/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/log/common/log","vs/base/common/uri","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/errors","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/types","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/resources","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/cancellation","vs/base/common/network","vs/platform/telemetry/common/telemetry","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/base/common/objects","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/map","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/request/common/request","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncProfilesStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/userDataSync/electron-sandbox/userDataSyncProfilesStorageService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],se=function(Q){for(var e=[],D=0,i=Q.length;D<i;D++)e[D]=re[Q[D]];return e};define(re[52],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(T){return T?T.replace(/\$\((.*?)\)/g,(I,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=D;class i{constructor(I,C,w){this.id=I,this.definition=C,this.description=w,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function R(T,I){const C=["codicon","codicon-"+T];return I&&C.push("codicon-modifier-"+I),C}e.getClassNamesArray=R;var k;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function C(b){if(b instanceof i)return["codicon","codicon-"+b.id];const S=I.exec(b.id);if(!S)return C(i.error);const[,m,f]=S,v=["codicon","codicon-"+m];return f&&v.push("codicon-modifier-"+f.substr(1)),v}T.asClassNameArray=C;function w(b){return C(b).join(" ")}T.asClassName=w;function E(b){return"."+C(b).join(".")}T.asCSSSelector=E})(k=e.CSSIcon||(e.CSSIcon={}))}),define(re[63],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function D(T){return(I,C,w)=>{let E=null,b=null;if(typeof w.value=="function"?(E="value",b=w.value):typeof w.get=="function"&&(E="get",b=w.get),!b)throw new Error("not supported");w[E]=T(b,C)}}function i(T,I,C){let w=null,E=null;if(typeof C.value=="function"?(w="value",E=C.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(w="get",E=C.get),!E)throw new Error("not supported");const b=`$memoize$${I}`;C[w]=function(...S){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,S)}),this[b]}}e.memoize=i;function R(T,I,C){return D((w,E)=>{const b=`$debounce$${E}`,S=`$debounce$result$${E}`;return function(...m){this[S]||(this[S]=C?C():void 0),clearTimeout(this[b]),I&&(this[S]=I(this[S],...m),m=[this[S]]),this[b]=setTimeout(()=>{w.apply(this,m),this[S]=C?C():void 0},T)}})}e.debounce=R;function k(T,I,C){return D((w,E)=>{const b=`$throttle$timer$${E}`,S=`$throttle$result$${E}`,m=`$throttle$lastRun$${E}`,f=`$throttle$pending$${E}`;return function(...v){if(this[S]||(this[S]=C?C():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),I&&(this[S]=I(this[S],...v)),this[f])return;const y=this[m]+T;y<=Date.now()?(this[m]=Date.now(),w.apply(this,[this[S]]),this[S]=C?C():void 0):(this[f]=!0,this[b]=setTimeout(()=>{this[f]=!1,this[m]=Date.now(),w.apply(this,[this[S]]),this[S]=C?C():void 0},y-Date.now()))}})}e.throttle=k}),define(re[11],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?c.isErrorNoTelemetry(n)?new c(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(o=>{o(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=D,e.errorHandler=new D;function i(d){e.errorHandler.setUnexpectedErrorHandler(d)}e.setUnexpectedErrorHandler=i;function R(d){C(d)||e.errorHandler.onUnexpectedError(d)}e.onUnexpectedError=R;function k(d){C(d)||e.errorHandler.onUnexpectedExternalError(d)}e.onUnexpectedExternalError=k;function T(d){if(d instanceof Error){const{name:n,message:o}=d,t=d.stacktrace||d.stack;return{$isError:!0,name:n,message:o,stack:t,noTelemetry:c.isErrorNoTelemetry(d)}}return d}e.transformErrorForSerialization=T;const I="Canceled";function C(d){return d instanceof w?!0:d instanceof Error&&d.name===I&&d.message===I}e.isCancellationError=C;class w extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=w;function E(){const d=new Error(I);return d.name=d.message,d}e.canceled=E;function b(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}e.illegalArgument=b;function S(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}e.illegalState=S;function m(d){return d?new Error(`readonly property '${d} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function f(d){const n=new Error(`${d} has been disposed`);return n.name="DISPOSED",n}e.disposed=f;function v(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}e.getErrorMessage=v;class y extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=y;class u extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=u;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class c extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof c)return n;const o=new c;return o.message=n.message,o.stack=n.stack,o}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=c;class h extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype);debugger}}e.BugIndicatingError=h}),define(re[19],se([0,1,11]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function i(X,ie=0){return X[X.length-(1+ie)]}e.tail=i;function R(X){if(X.length===0)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]}e.tail2=R;function k(X,ie,ne=(le,ue)=>le===ue){if(X===ie)return!0;if(!X||!ie||X.length!==ie.length)return!1;for(let le=0,ue=X.length;le<ue;le++)if(!ne(X[le],ie[le]))return!1;return!0}e.equals=k;function T(X,ie){const ne=X.length-1;ie<ne&&(X[ie]=X[ne]),X.pop()}e.removeFastWithoutKeepingOrder=T;function I(X,ie,ne){return C(X.length,le=>ne(X[le],ie))}e.binarySearch=I;function C(X,ie){let ne=0,le=X-1;for(;ne<=le;){const ue=(ne+le)/2|0,pe=ie(ue);if(pe<0)ne=ue+1;else if(pe>0)le=ue-1;else return ue}return-(ne+1)}e.binarySearch2=C;function w(X,ie){let ne=0,le=X.length;if(le===0)return 0;for(;ne<le;){const ue=Math.floor((ne+le)/2);ie(X[ue])?le=ue:ne=ue+1}return ne}e.findFirstInSorted=w;function E(X,ie,ne){if(X=X|0,X>=ie.length)throw new TypeError("invalid index");const le=ie[Math.floor(ie.length*Math.random())],ue=[],pe=[],we=[];for(const Ee of ie){const Ce=ne(Ee,le);Ce<0?ue.push(Ee):Ce>0?pe.push(Ee):we.push(Ee)}return X<ue.length?E(X,ue,ne):X<ue.length+we.length?we[0]:E(X-(ue.length+we.length),pe,ne)}e.quickSelect=E;function b(X,ie){const ne=[];let le;for(const ue of X.slice(0).sort(ie))!le||ie(le[0],ue)!==0?(le=[ue],ne.push(le)):le.push(ue);return ne}e.groupBy=b;function S(X,ie,ne){const le=[];function ue(Ee,Ce,Ae){if(Ce===0&&Ae.length===0)return;const Ne=le[le.length-1];Ne&&Ne.start+Ne.deleteCount===Ee?(Ne.deleteCount+=Ce,Ne.toInsert.push(...Ae)):le.push({start:Ee,deleteCount:Ce,toInsert:Ae})}let pe=0,we=0;for(;;){if(pe===X.length){ue(pe,0,ie.slice(we));break}if(we===ie.length){ue(pe,X.length-pe,[]);break}const Ee=X[pe],Ce=ie[we],Ae=ne(Ee,Ce);Ae===0?(pe+=1,we+=1):Ae<0?(ue(pe,1,[]),pe+=1):Ae>0&&(ue(pe,0,[Ce]),we+=1)}return le}e.sortedDiff=S;function m(X,ie,ne){const le=S(X,ie,ne),ue=[],pe=[];for(const we of le)ue.push(...X.slice(we.start,we.start+we.deleteCount)),pe.push(...we.toInsert);return{removed:ue,added:pe}}e.delta=m;function f(X,ie,ne){if(ne===0)return[];const le=X.slice(0,ne).sort(ie);return y(X,ie,le,ne,X.length),le}e.top=f;function v(X,ie,ne,le,ue){return ne===0?Promise.resolve([]):new Promise((pe,we)=>{(async()=>{const Ee=X.length,Ce=X.slice(0,ne).sort(ie);for(let Ae=ne,Ne=Math.min(ne+le,Ee);Ae<Ee;Ae=Ne,Ne=Math.min(Ne+le,Ee)){if(Ae>ne&&await new Promise(Ge=>setTimeout(Ge)),ue&&ue.isCancellationRequested)throw new D.CancellationError;y(X,ie,Ce,Ae,Ne)}return Ce})().then(pe,we)})}e.topAsync=v;function y(X,ie,ne,le,ue){for(const pe=ne.length;le<ue;le++){const we=X[le];if(ie(we,ne[pe-1])<0){ne.pop();const Ee=w(ne,Ce=>ie(we,Ce)<0);ne.splice(Ee,0,we)}}}function u(X){return X.filter(ie=>!!ie)}e.coalesce=u;function p(X){let ie=0;for(let ne=0;ne<X.length;ne++)X[ne]&&(X[ie]=X[ne],ie+=1);X.length=ie}e.coalesceInPlace=p;function c(X,ie,ne){X.splice(ne,0,X.splice(ie,1)[0])}e.move=c;function h(X){return!Array.isArray(X)||X.length===0}e.isFalsyOrEmpty=h;function d(X){return Array.isArray(X)&&X.length>0}e.isNonEmptyArray=d;function n(X,ie=ne=>ne){const ne=new Set;return X.filter(le=>{const ue=ie(le);return ne.has(ue)?!1:(ne.add(ue),!0)})}e.distinct=n;function o(X){const ie=new Set;return ne=>{const le=X(ne);return ie.has(le)?!1:(ie.add(le),!0)}}e.uniqueFilter=o;function t(X,ie){const ne=s(X,ie);if(ne!==-1)return X[ne]}e.findLast=t;function s(X,ie){for(let ne=X.length-1;ne>=0;ne--){const le=X[ne];if(ie(le))return ne}return-1}e.lastIndex=s;function r(X,ie){return X.length>0?X[0]:ie}e.firstOrDefault=r;function l(X,ie){return X.length>0?X[X.length-1]:ie}e.lastOrDefault=l;function a(X,ie,ne=(le,ue)=>le===ue){let le=0;for(let ue=0,pe=Math.min(X.length,ie.length);ue<pe&&ne(X[ue],ie[ue]);ue++)le++;return le}e.commonPrefixLength=a;function g(X){return[].concat(...X)}e.flatten=g;function P(X,ie){let ne=typeof ie=="number"?X:0;typeof ie=="number"?ne=X:(ne=0,ie=X);const le=[];if(ne<=ie)for(let ue=ne;ue<ie;ue++)le.push(ue);else for(let ue=ne;ue>ie;ue--)le.push(ue);return le}e.range=P;function A(X,ie,ne){return X.reduce((le,ue)=>(le[ie(ue)]=ne?ne(ue):ue,le),Object.create(null))}e.index=A;function V(X,ie){return X.push(ie),()=>O(X,ie)}e.insert=V;function O(X,ie){const ne=X.indexOf(ie);if(ne>-1)return X.splice(ne,1),ie}e.remove=O;function F(X,ie,ne){const le=X.slice(0,ie),ue=X.slice(ie);return le.concat(ne,ue)}e.arrayInsert=F;function N(X,ie){let ne;if(typeof ie=="number"){let le=ie;ne=()=>{const ue=Math.sin(le++)*179426549;return ue-Math.floor(ue)}}else ne=Math.random;for(let le=X.length-1;le>0;le-=1){const ue=Math.floor(ne()*(le+1)),pe=X[le];X[le]=X[ue],X[ue]=pe}}e.shuffle=N;function L(X,ie){const ne=X.indexOf(ie);ne>-1&&(X.splice(ne,1),X.unshift(ie))}e.pushToStart=L;function U(X,ie){const ne=X.indexOf(ie);ne>-1&&(X.splice(ne,1),X.push(ie))}e.pushToEnd=U;function $(X,ie){for(const ne of ie)X.push(ne)}e.pushMany=$;function x(X,ie){return Array.isArray(X)?X.map(ie):ie(X)}e.mapArrayOrNot=x;function j(X){return Array.isArray(X)?X:[X]}e.asArray=j;function B(X){return X[Math.floor(Math.random()*X.length)]}e.getRandomElement=B;function W(X,ie){for(const ne of X){const le=ie(ne);if(le!==void 0)return le}}e.mapFind=W;function q(X,ie,ne){const le=ee(X,ie),ue=X.length,pe=ne.length;X.length=ue+pe;for(let we=ue-1;we>=le;we--)X[we+pe]=X[we];for(let we=0;we<pe;we++)X[we+le]=ne[we]}e.insertInto=q;function Y(X,ie,ne,le){const ue=ee(X,ie),pe=X.splice(ue,ne);return q(X,ue,le),pe}e.splice=Y;function ee(X,ie){return ie<0?Math.max(ie+X.length,0):Math.min(ie,X.length)}var ce;(function(X){function ie(ue){return ue<0}X.isLessThan=ie;function ne(ue){return ue>0}X.isGreaterThan=ne;function le(ue){return ue===0}X.isNeitherLessOrGreaterThan=le,X.greaterThan=1,X.lessThan=-1,X.neitherLessOrGreaterThan=0})(ce=e.CompareResult||(e.CompareResult={}));function J(X,ie){return(ne,le)=>ie(X(ne),X(le))}e.compareBy=J;function z(...X){return(ie,ne)=>{for(const le of X){const ue=le(ie,ne);if(!ce.isNeitherLessOrGreaterThan(ue))return ue}return ce.neitherLessOrGreaterThan}}e.tieBreakComparators=z;const _=(X,ie)=>X-ie;e.numberComparator=_;function M(X,ie){if(X.length===0)return;let ne=X[0];for(let le=1;le<X.length;le++){const ue=X[le];ie(ue,ne)>0&&(ne=ue)}return ne}e.findMaxBy=M;function G(X,ie){if(X.length===0)return;let ne=X[0];for(let le=1;le<X.length;le++){const ue=X[le];ie(ue,ne)>=0&&(ne=ue)}return ne}e.findLastMaxBy=G;function H(X,ie){return M(X,(ne,le)=>-ie(ne,le))}e.findMinBy=H;class Z{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let ne=this.firstIdx;for(;ne<this.items.length&&ie(this.items[ne]);)ne++;const le=ne===this.firstIdx?null:this.items.slice(this.firstIdx,ne);return this.firstIdx=ne,le}takeFromEndWhile(ie){let ne=this.lastIdx;for(;ne>=0&&ie(this.items[ne]);)ne--;const le=ne===this.lastIdx?null:this.items.slice(ne+1,this.lastIdx+1);return this.lastIdx=ne,le}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const ne=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,ne}}e.ArrayQueue=Z;class oe{constructor(ie){this.iterate=ie}forEach(ie){this.iterate(ne=>(ie(ne),!0))}toArray(){const ie=[];return this.iterate(ne=>(ie.push(ne),!0)),ie}filter(ie){return new oe(ne=>this.iterate(le=>ie(le)?ne(le):!0))}map(ie){return new oe(ne=>this.iterate(le=>ne(ie(le))))}some(ie){let ne=!1;return this.iterate(le=>(ne=ie(le),!ne)),ne}findFirst(ie){let ne;return this.iterate(le=>ie(le)?(ne=le,!1):!0),ne}findLast(ie){let ne;return this.iterate(le=>(ie(le)&&(ne=le),!0)),ne}findLastMaxBy(ie){let ne,le=!0;return this.iterate(ue=>((le||ce.isGreaterThan(ie(ue,ne)))&&(le=!1,ne=ue),!0)),ne}}e.CallbackIterable=oe,oe.empty=new oe(X=>{})}),define(re[127],se([0,1,11]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function i(C,w){if(!C)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=i;function R(C,w="Unreachable"){throw new Error(w)}e.assertNever=R;function k(C){if(!C)throw new D.BugIndicatingError("Assertion Failed")}e.assert=k;function T(C){if(!C()){debugger;C(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function I(C,w){let E=0;for(;E<C.length-1;){const b=C[E],S=C[E+1];if(!w(b,S))return!1;E++}return!0}e.checkAdjacentItems=I}),define(re[80],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(i){const R=this;let k=!1,T;return function(){return k||(k=!0,T=i.apply(R,arguments)),T}}e.once=D}),define(re[64],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(i){function R(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}i.is=R;const k=Object.freeze([]);function T(){return k}i.empty=T;function*I(h){yield h}i.single=I;function C(h){return R(h)?h:I(h)}i.wrap=C;function w(h){return h||k}i.from=w;function E(h){return!h||h[Symbol.iterator]().next().done===!0}i.isEmpty=E;function b(h){return h[Symbol.iterator]().next().value}i.first=b;function S(h,d){for(const n of h)if(d(n))return!0;return!1}i.some=S;function m(h,d){for(const n of h)if(d(n))return n}i.find=m;function*f(h,d){for(const n of h)d(n)&&(yield n)}i.filter=f;function*v(h,d){let n=0;for(const o of h)yield d(o,n++)}i.map=v;function*y(...h){for(const d of h)for(const n of d)yield n}i.concat=y;function u(h,d,n){let o=n;for(const t of h)o=d(o,t);return o}i.reduce=u;function*p(h,d,n=h.length){for(d<0&&(d+=h.length),n<0?n+=h.length:n>h.length&&(n=h.length);d<n;d++)yield h[d]}i.slice=p;function c(h,d=Number.POSITIVE_INFINITY){const n=[];if(d===0)return[n,h];const o=h[Symbol.iterator]();for(let t=0;t<d;t++){const s=o.next();if(s.done)return[n,i.empty()];n.push(s.value)}return[n,{[Symbol.iterator](){return o}}]}i.consume=c})(D=e.Iterable||(e.Iterable={}))}),define(re[35],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var i;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(n){n.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function T(n,o=!1){let t=0;const s=n.length;let r="",l=0,a=16,g=0;function P(U){let $=0,x=0;for(;$<U;){const j=n.charCodeAt(t);if(j>=48&&j<=57)x=x*16+j-48;else if(j>=65&&j<=70)x=x*16+j-65+10;else if(j>=97&&j<=102)x=x*16+j-97+10;else break;t++,$++}return $<U&&(x=-1),x}function A(U){t=U,r="",l=0,a=16,g=0}function V(){const U=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&w(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&w(n.charCodeAt(t)))for(t++;t<n.length&&w(n.charCodeAt(t));)t++;else return g=3,n.substring(U,t);let $=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&w(n.charCodeAt(t))){for(t++;t<n.length&&w(n.charCodeAt(t));)t++;$=t}else g=3;return n.substring(U,$)}function O(){let U="",$=t;for(;;){if(t>=s){U+=n.substring($,t),g=2;break}const x=n.charCodeAt(t);if(x===34){U+=n.substring($,t),t++;break}if(x===92){if(U+=n.substring($,t),t++,t>=s){g=2;break}switch(n.charCodeAt(t++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const B=P(4);B>=0?U+=String.fromCharCode(B):g=4;break}default:g=5}$=t;continue}if(x>=0&&x<=31)if(C(x)){U+=n.substring($,t),g=2;break}else g=6;t++}return U}function F(){if(r="",g=0,l=t,t>=s)return l=s,a=17;let U=n.charCodeAt(t);if(I(U)){do t++,r+=String.fromCharCode(U),U=n.charCodeAt(t);while(I(U));return a=15}if(C(U))return t++,r+=String.fromCharCode(U),U===13&&n.charCodeAt(t)===10&&(t++,r+=`
`),a=14;switch(U){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,r=O(),a=10;case 47:{const $=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<s&&!C(n.charCodeAt(t));)t++;return r=n.substring($,t),a=12}if(n.charCodeAt(t+1)===42){t+=2;const x=s-1;let j=!1;for(;t<x;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,j=!0;break}t++}return j||(t++,g=1),r=n.substring($,t),a=13}return r+=String.fromCharCode(U),t++,a=16}case 45:if(r+=String.fromCharCode(U),t++,t===s||!w(n.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=V(),a=11;default:for(;t<s&&N(U);)t++,U=n.charCodeAt(t);if(l!==t){switch(r=n.substring(l,t),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode(U),t++,a=16}}function N(U){if(I(U)||C(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let U;do U=F();while(U>=12&&U<=15);return U}return{setPosition:A,getPosition:()=>t,scan:o?L:F,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>l,getTokenLength:()=>t-l,getTokenError:()=>g}}e.createScanner=T;function I(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function C(n){return n===10||n===13||n===8232||n===8233}function w(n){return n>=48&&n<=57}var E;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(E||(E={}));function b(n,o){const t=[],s=new Object;let r;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function g(P,A,V,O){l.value=P,l.offset=A,l.length=V,l.type=O,l.colonOffset=void 0,r=l}try{c(n,{onObjectBegin:(P,A)=>{if(o<=P)throw s;r=void 0,a=o>P,t.push("")},onObjectProperty:(P,A,V)=>{if(o<A||(g(P,A,V,"property"),t[t.length-1]=P,o<=A+V))throw s},onObjectEnd:(P,A)=>{if(o<=P)throw s;r=void 0,t.pop()},onArrayBegin:(P,A)=>{if(o<=P)throw s;r=void 0,t.push(0)},onArrayEnd:(P,A)=>{if(o<=P)throw s;r=void 0,t.pop()},onLiteralValue:(P,A,V)=>{if(o<A||(g(P,A,V,d(P)),o<=A+V))throw s},onSeparator:(P,A,V)=>{if(o<=A)throw s;if(P===":"&&r&&r.type==="property")r.colonOffset=A,a=!1,r=void 0;else if(P===","){const O=t[t.length-1];typeof O=="number"?t[t.length-1]=O+1:(a=!0,t[t.length-1]=""),r=void 0}}})}catch(P){if(P!==s)throw P}return{path:t,previousNode:r,isAtPropertyKey:a,matches:P=>{let A=0;for(let V=0;A<P.length&&V<t.length;V++)if(P[A]===t[V]||P[A]==="*")A++;else if(P[A]!=="**")return!1;return A===P.length}}}e.getLocation=b;function S(n,o=[],t=k.DEFAULT){let s=null,r=[];const l=[];function a(P){Array.isArray(r)?r.push(P):s!==null&&(r[s]=P)}return c(n,{onObjectBegin:()=>{const P={};a(P),l.push(r),r=P,s=null},onObjectProperty:P=>{s=P},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const P=[];a(P),l.push(r),r=P,s=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:a,onError:(P,A,V)=>{o.push({error:P,offset:A,length:V})}},t),r[0]}e.parse=S;function m(n,o=[],t=k.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(P){s.type==="property"&&(s.length=P-s.offset,s=s.parent)}function l(P){return s.children.push(P),P}c(n,{onObjectBegin:P=>{s=l({type:"object",offset:P,length:-1,parent:s,children:[]})},onObjectProperty:(P,A,V)=>{s=l({type:"property",offset:A,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:P,offset:A,length:V,parent:s})},onObjectEnd:(P,A)=>{s.length=P+A-s.offset,s=s.parent,r(P+A)},onArrayBegin:(P,A)=>{s=l({type:"array",offset:P,length:-1,parent:s,children:[]})},onArrayEnd:(P,A)=>{s.length=P+A-s.offset,s=s.parent,r(P+A)},onLiteralValue:(P,A,V)=>{l({type:d(P),offset:A,length:V,parent:s,value:P}),r(A+V)},onSeparator:(P,A,V)=>{s.type==="property"&&(P===":"?s.colonOffset=A:P===","&&r(A))},onError:(P,A,V)=>{o.push({error:P,offset:A,length:V})}},t);const g=s.children[0];return g&&delete g.parent,g}e.parseTree=m;function f(n,o){if(!n)return;let t=n;for(const s of o)if(typeof s=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let r=!1;for(const l of t.children)if(Array.isArray(l.children)&&l.children[0].value===s){t=l.children[1],r=!0;break}if(!r)return}else{const r=s;if(t.type!=="array"||r<0||!Array.isArray(t.children)||r>=t.children.length)return;t=t.children[r]}return t}e.findNodeAtLocation=f;function v(n){if(!n.parent||!n.parent.children)return[];const o=v(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;o.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&o.push(t)}return o}e.getNodePath=v;function y(n){switch(n.type){case"array":return n.children.map(y);case"object":{const o=Object.create(null);for(const t of n.children){const s=t.children[1];s&&(o[t.children[0].value]=y(s))}return o}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=y;function u(n,o,t=!1){return o>=n.offset&&o<n.offset+n.length||t&&o===n.offset+n.length}e.contains=u;function p(n,o,t=!1){if(u(n,o,t)){const s=n.children;if(Array.isArray(s))for(let r=0;r<s.length&&s[r].offset<=o;r++){const l=p(s[r],o,t);if(l)return l}return n}}e.findNodeAtOffset=p;function c(n,o,t=k.DEFAULT){const s=T(n,!1);function r(J){return J?()=>J(s.getTokenOffset(),s.getTokenLength()):()=>!0}function l(J){return J?z=>J(z,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=r(o.onObjectBegin),g=l(o.onObjectProperty),P=r(o.onObjectEnd),A=r(o.onArrayBegin),V=r(o.onArrayEnd),O=l(o.onLiteralValue),F=l(o.onSeparator),N=r(o.onComment),L=l(o.onError),U=t&&t.disallowComments,$=t&&t.allowTrailingComma;function x(){for(;;){const J=s.scan();switch(s.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:U||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(J){case 12:case 13:U?j(10):N();break;case 16:j(1);break;case 15:case 14:break;default:return J}}}function j(J,z=[],_=[]){if(L(J),z.length+_.length>0){let M=s.getToken();for(;M!==17;){if(z.indexOf(M)!==-1){x();break}else if(_.indexOf(M)!==-1)break;M=x()}}}function B(J){const z=s.getTokenValue();return J?O(z):g(z),x(),!0}function W(){switch(s.getToken()){case 11:{let J=0;try{J=JSON.parse(s.getTokenValue()),typeof J!="number"&&(j(2),J=0)}catch{j(2)}O(J);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return x(),!0}function q(){return s.getToken()!==10?(j(3,[],[2,5]),!1):(B(!1),s.getToken()===6?(F(":"),x(),ce()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function Y(){a(),x();let J=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(J||j(4,[],[]),F(","),x(),s.getToken()===2&&$)break}else J&&j(6,[],[]);q()||j(4,[],[2,5]),J=!0}return P(),s.getToken()!==2?j(7,[2],[]):x(),!0}function ee(){A(),x();let J=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(J||j(4,[],[]),F(","),x(),s.getToken()===4&&$)break}else J&&j(6,[],[]);ce()||j(4,[],[4,5]),J=!0}return V(),s.getToken()!==4?j(8,[4],[]):x(),!0}function ce(){switch(s.getToken()){case 3:return ee();case 1:return Y();case 10:return B(!0);default:return W()}}return x(),s.getToken()===17?t.allowEmptyContent?!0:(j(4,[],[]),!1):ce()?(s.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=c;function h(n,o){const t=T(n),s=[];let r,l=0,a;do switch(a=t.getPosition(),r=t.scan(),r){case 12:case 13:case 17:l!==a&&s.push(n.substring(l,a)),o!==void 0&&s.push(t.getTokenValue().replace(/[^\r\n]/g,o)),l=t.getPosition();break}while(r!==17);return s.join("")}e.stripComments=h;function d(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=d}),define(re[42],se([0,1,35]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(w,E,b){let S,m,f,v,y;if(E){for(v=E.offset,y=v+E.length,f=v;f>0&&!C(w,f-1);)f--;let a=y;for(;a<w.length&&!C(w,a);)a++;m=w.substring(f,a),S=T(m,b)}else m=w,S=0,f=0,v=0,y=w.length;const u=I(b,w);let p=!1,c=0,h;b.insertSpaces?h=k(" ",b.tabSize||4):h="	";const d=(0,D.createScanner)(m,!1);let n=!1;function o(){return u+k(h,S+c)}function t(){let a=d.scan();for(p=!1;a===15||a===14;)p=p||a===14,a=d.scan();return n=a===16||d.getTokenError()!==0,a}const s=[];function r(a,g,P){!n&&g<y&&P>v&&w.substring(g,P)!==a&&s.push({offset:g,length:P-g,content:a})}let l=t();if(l!==17){const a=d.getTokenOffset()+f,g=k(h,S);r(g,f,a)}for(;l!==17;){let a=d.getTokenOffset()+d.getTokenLength()+f,g=t(),P="";for(;!p&&(g===12||g===13);){const V=d.getTokenOffset()+f;r(" ",a,V),a=d.getTokenOffset()+d.getTokenLength()+f,P=g===12?o():"",g=t()}if(g===2)l!==1&&(c--,P=o());else if(g===4)l!==3&&(c--,P=o());else{switch(l){case 3:case 1:c++,P=o();break;case 5:case 12:P=o();break;case 13:p?P=o():P=" ";break;case 6:P=" ";break;case 10:if(g===6){P="";break}case 7:case 8:case 9:case 11:case 2:case 4:g===12||g===13?P=" ":g!==5&&g!==17&&(n=!0);break;case 16:n=!0;break}p&&(g===12||g===13)&&(P=o())}const A=d.getTokenOffset()+f;r(P,a,A),l=g}return s}e.format=i;function R(w,E){const b=JSON.stringify(w,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?b.replace(/\r\n|\r|\n/g,E.eol):b}e.toFormattedString=R;function k(w,E){let b="";for(let S=0;S<E;S++)b+=w;return b}function T(w,E){let b=0,S=0;const m=E.tabSize||4;for(;b<w.length;){const f=w.charAt(b);if(f===" ")S++;else if(f==="	")S+=m;else break;b++}return Math.floor(S/m)}function I(w,E){for(let b=0;b<E.length;b++){const S=E.charAt(b);if(S==="\r")return b+1<E.length&&E.charAt(b+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=I;function C(w,E){return`\r
`.indexOf(w.charAt(E))!==-1}e.isEOL=C}),define(re[81],se([0,1,35,42]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(w,E,b){return k(w,E,void 0,b)}e.removeProperty=R;function k(w,E,b,S,m){const f=E.slice(),v=[],y=(0,D.parseTree)(w,v);let u,p;for(;f.length>0&&(p=f.pop(),u=(0,D.findNodeAtLocation)(y,f),u===void 0&&b!==void 0);)typeof p=="string"?b={[p]:b}:b=[b];if(u)if(u.type==="object"&&typeof p=="string"&&Array.isArray(u.children)){const c=(0,D.findNodeAtLocation)(u,[p]);if(c!==void 0)if(b===void 0){if(!c.parent)throw new Error("Malformed AST");const h=u.children.indexOf(c.parent);let d,n=c.parent.offset+c.parent.length;if(h>0){const o=u.children[h-1];d=o.offset+o.length}else d=u.offset+1,u.children.length>1&&(n=u.children[1].offset);return T(w,{offset:d,length:n-d,content:""},S)}else return T(w,{offset:c.offset,length:c.length,content:JSON.stringify(b)},S);else{if(b===void 0)return[];const h=`${JSON.stringify(p)}: ${JSON.stringify(b)}`,d=m?m(u.children.map(o=>o.children[0].value)):u.children.length;let n;if(d>0){const o=u.children[d-1];n={offset:o.offset+o.length,length:0,content:","+h}}else u.children.length===0?n={offset:u.offset+1,length:0,content:h}:n={offset:u.offset+1,length:0,content:h+","};return T(w,n,S)}}else if(u.type==="array"&&typeof p=="number"&&Array.isArray(u.children))if(b!==void 0){const c=`${JSON.stringify(b)}`;let h;if(u.children.length===0||p===0)h={offset:u.offset+1,length:0,content:u.children.length===0?c:c+","};else{const d=p===-1||p>u.children.length?u.children.length:p,n=u.children[d-1];h={offset:n.offset+n.length,length:0,content:","+c}}return T(w,h,S)}else{const c=p,h=u.children[c];let d;if(u.children.length===1)d={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===c){const n=u.children[c-1],o=n.offset+n.length,t=u.offset+u.length;d={offset:o,length:t-2-o,content:""}}else d={offset:h.offset,length:u.children[c+1].offset-h.offset,content:""};return T(w,d,S)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${u.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return T(w,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(b)},S)}}e.setProperty=k;function T(w,E,b){let S=I(w,E),m=E.offset,f=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;m>0&&!(0,i.isEOL)(S,m-1);)m--;for(;f<S.length&&!(0,i.isEOL)(S,f);)f++}const v=(0,i.format)(S,{offset:m,length:f-m},b);for(let u=v.length-1;u>=0;u--){const p=v[u];S=I(S,p),m=Math.min(m,p.offset),f=Math.max(f,p.offset+p.length),f+=p.content.length-p.length}const y=w.length-(S.length-f)-m;return[{offset:m,length:y,content:S.substring(m,f)}]}e.withFormatting=T;function I(w,E){return w.substring(0,E.offset)+E.content+w.substring(E.offset+E.length)}e.applyEdit=I;function C(w,E){const b=E.slice(0).sort((m,f)=>{const v=m.offset-f.offset;return v===0?m.length-f.length:v});let S=w.length;for(let m=b.length-1;m>=0;m--){const f=b[m];if(f.offset+f.length<=S)w=I(w,f);else throw new Error("Overlapping edit");S=f.offset}return w}e.applyEdits=C}),define(re[128],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new D(()=>R(this.getValue()))}}e.Lazy=D}),define(re[2],se([0,1,80,64]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let k=null;function T(l){k=l}if(e.setDisposableTracker=T,R){const l="__is_disposable_tracked__";T(new class{trackDisposable(a){const g=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[l]||console.log(g)},3e3)}setParent(a,g){if(a&&a!==p.None)try{a[l]=!0}catch{}}markAsDisposed(a){if(a&&a!==p.None)try{a[l]=!0}catch{}}markAsSingleton(a){}})}function I(l){return k?.trackDisposable(l),l}function C(l){k?.markAsDisposed(l)}function w(l,a){k?.setParent(l,a)}function E(l,a){if(!!k)for(const g of l)k.setParent(g,a)}function b(l){return k?.markAsSingleton(l),l}e.markAsSingleton=b;function S(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=S;function m(l){if(i.Iterable.is(l)){const a=[];for(const g of l)if(g)try{g.dispose()}catch(P){a.push(P)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=m;function f(l){for(const a of l)S(a)&&a.dispose();return[]}e.disposeIfDisposable=f;function v(...l){const a=y(()=>m(l));return E(l,a),a}e.combinedDisposable=v;function y(l){const a=I({dispose:(0,D.once)(()=>{C(a),l()})});return a}e.toDisposable=y;class u{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{m(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return w(a,this),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new u,I(this),w(this._store,this)}dispose(){C(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&w(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,C(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&w(a,null),a}}e.MutableDisposable=c;class h{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=h;class d{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(a){let g=a;return this.unset=()=>g=void 0,this.isset=()=>g!==void 0,this.dispose=()=>{g&&(g(),g=void 0,C(this))},this}}e.SafeDisposable=d;class n{constructor(){this.references=new Map}acquire(a,...g){let P=this.references.get(a);P||(P={counter:0,object:this.createReferencedObject(a,...g)},this.references.set(a,P));const{object:A}=P,V=(0,D.once)(()=>{--P.counter===0&&(this.destroyReferencedObject(a,P.object),this.references.delete(a))});return P.counter++,{object:A,dispose:V}}}e.ReferenceCollection=n;class o{constructor(a){this.referenceCollection=a}async acquire(a,...g){const P=this.referenceCollection.acquire(a,...g);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(A){throw P.dispose(),A}}}e.AsyncReferenceCollection=o;class t{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=t;function s(l){const a=new u;try{l(a)}finally{a.dispose()}}e.disposeOnReturn=s;class r{constructor(){this._store=new Map,this._isDisposed=!1,I(this)}dispose(){C(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{m(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get(a){return this._store.get(a)}set(a,g,P=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),P||this._store.get(a)?.dispose(),this._store.set(a,g)}deleteAndDispose(a){this._store.get(a)?.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=r}),define(re[82],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(k){this.element=k,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class i{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let k=this._first;for(;k!==D.Undefined;){const T=k.next;k.prev=D.Undefined,k.next=D.Undefined,k=T}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,T){const I=new D(k);if(this._first===D.Undefined)this._first=I,this._last=I;else if(T){const w=this._last;this._last=I,I.prev=w,w.next=I}else{const w=this._first;this._first=I,I.next=w,w.prev=I}this._size+=1;let C=!1;return()=>{C||(C=!0,this._remove(I))}}shift(){if(this._first!==D.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==D.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==D.Undefined&&k.next!==D.Undefined){const T=k.prev;T.next=k.next,k.next.prev=T}else k.prev===D.Undefined&&k.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):k.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):k.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==D.Undefined;)yield k.element,k=k.next}}e.LinkedList=i}),define(re[41],se([0,1]),function(Q,e){"use strict";var D,i,R;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function k(f,v,y){let u=f.get(v);return u===void 0&&(u=y,f.set(v,u)),u}e.getOrSet=k;function T(f){const v=[];return f.forEach((y,u)=>{v.push(`${u} => ${y}`)}),`Map(${f.size}) {${v.join(", ")}}`}e.mapToString=T;function I(f){const v=[];return f.forEach(y=>{v.push(y)}),`Set(${f.size}) {${v.join(", ")}}`}e.setToString=I;class C{constructor(v,y){this.uri=v,this.value=y}}class w{constructor(v,y){this[D]="ResourceMap",v instanceof w?(this.map=new Map(v.map),this.toKey=y??w.defaultToKey):(this.map=new Map,this.toKey=v??w.defaultToKey)}set(v,y){return this.map.set(this.toKey(v),new C(v,y)),this}get(v){return this.map.get(this.toKey(v))?.value}has(v){return this.map.has(this.toKey(v))}get size(){return this.map.size}clear(){this.map.clear()}delete(v){return this.map.delete(this.toKey(v))}forEach(v,y){typeof y<"u"&&(v=v.bind(y));for(const[u,p]of this.map)v(p.value,p.uri,this)}*values(){for(const v of this.map.values())yield v.value}*keys(){for(const v of this.map.values())yield v.uri}*entries(){for(const v of this.map.values())yield[v.uri,v.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,v]of this.map)yield[v.uri,v.value]}}e.ResourceMap=w,w.defaultToKey=f=>f.toString();class E{constructor(v,y){this[i]="ResourceSet",!v||typeof v=="function"?this._map=new w(v):(this._map=new w(y),v.forEach(this.add,this))}get size(){return this._map.size}add(v){return this._map.set(v,v),this}clear(){this._map.clear()}delete(v){return this._map.delete(v)}forEach(v,y){this._map.forEach((u,p)=>v.call(y,p,p,this))}has(v){return this._map.has(v)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=E;var b;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class S{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(v){return this._map.has(v)}get(v,y=0){const u=this._map.get(v);if(!!u)return y!==0&&this.touch(u,y),u.value}set(v,y,u=0){let p=this._map.get(v);if(p)p.value=y,u!==0&&this.touch(p,u);else{switch(p={key:v,value:y,next:void 0,previous:void 0},u){case 0:this.addItemLast(p);break;case 1:this.addItemFirst(p);break;case 2:this.addItemLast(p);break;default:this.addItemLast(p);break}this._map.set(v,p),this._size++}return this}delete(v){return!!this.remove(v)}remove(v){const y=this._map.get(v);if(!!y)return this._map.delete(v),this.removeItem(y),this._size--,y.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const v=this._head;return this._map.delete(v.key),this.removeItem(v),this._size--,v.value}forEach(v,y){const u=this._state;let p=this._head;for(;p;){if(y?v.bind(y)(p.value,p.key,this):v(p.value,p.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const v=this,y=this._state;let u=this._head;const p={[Symbol.iterator](){return p},next(){if(v._state!==y)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:u.key,done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return p}values(){const v=this,y=this._state;let u=this._head;const p={[Symbol.iterator](){return p},next(){if(v._state!==y)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:u.value,done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return p}entries(){const v=this,y=this._state;let u=this._head;const p={[Symbol.iterator](){return p},next(){if(v._state!==y)throw new Error("LinkedMap got modified during iteration.");if(u){const c={value:[u.key,u.value],done:!1};return u=u.next,c}else return{value:void 0,done:!0}}};return p}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(v){if(v>=this.size)return;if(v===0){this.clear();return}let y=this._head,u=this.size;for(;y&&u>v;)this._map.delete(y.key),y=y.next,u--;this._head=y,this._size=u,y&&(y.previous=void 0),this._state++}addItemFirst(v){if(!this._head&&!this._tail)this._tail=v;else if(this._head)v.next=this._head,this._head.previous=v;else throw new Error("Invalid list");this._head=v,this._state++}addItemLast(v){if(!this._head&&!this._tail)this._head=v;else if(this._tail)v.previous=this._tail,this._tail.next=v;else throw new Error("Invalid list");this._tail=v,this._state++}removeItem(v){if(v===this._head&&v===this._tail)this._head=void 0,this._tail=void 0;else if(v===this._head){if(!v.next)throw new Error("Invalid list");v.next.previous=void 0,this._head=v.next}else if(v===this._tail){if(!v.previous)throw new Error("Invalid list");v.previous.next=void 0,this._tail=v.previous}else{const y=v.next,u=v.previous;if(!y||!u)throw new Error("Invalid list");y.previous=u,u.next=y}v.next=void 0,v.previous=void 0,this._state++}touch(v,y){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(y!==1&&y!==2)){if(y===1){if(v===this._head)return;const u=v.next,p=v.previous;v===this._tail?(p.next=void 0,this._tail=p):(u.previous=p,p.next=u),v.previous=void 0,v.next=this._head,this._head.previous=v,this._head=v,this._state++}else if(y===2){if(v===this._tail)return;const u=v.next,p=v.previous;v===this._head?(u.previous=void 0,this._head=u):(u.previous=p,p.next=u),v.next=void 0,v.previous=this._tail,this._tail.next=v,this._tail=v,this._state++}}}toJSON(){const v=[];return this.forEach((y,u)=>{v.push([u,y])}),v}fromJSON(v){this.clear();for(const[y,u]of v)this.set(y,u)}}e.LinkedMap=S;class m extends S{constructor(v,y=1){super(),this._limit=v,this._ratio=Math.min(Math.max(0,y),1)}get limit(){return this._limit}set limit(v){this._limit=v,this.checkTrim()}get ratio(){return this._ratio}set ratio(v){this._ratio=Math.min(Math.max(0,v),1),this.checkTrim()}get(v,y=2){return super.get(v,y)}peek(v){return super.get(v,0)}set(v,y){return super.set(v,y,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=m}),define(re[83],se([0,1,41]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new D.LRUCache(1e4);function R(w){return C(w,"NFC",i)}e.normalizeNFC=R;const k=new D.LRUCache(1e4);function T(w){return C(w,"NFD",k)}e.normalizeNFD=T;const I=/[^\u0000-\u0080]/;function C(w,E,b){if(!w)return w;const S=b.get(w);if(S)return S;let m;return I.test(w)?m=w.normalize(E):m=w,b.set(w,m),m}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(E){return T(E).replace(w,"")}}()}),function(){function Q(R){const k=[];typeof R=="number"&&k.push("code/timeOrigin",R);function T(C){k.push(C,Date.now())}function I(){const C=[];for(let w=0;w<k.length;w+=2)C.push({name:k[w],startTime:k[w+1]});return C}return{mark:T,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const T of performance.getEntriesByType("mark"))k.push({name:T.name,startTime:Math.round(R+T.startTime)});return k}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=D(i))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var i in D)(typeof exports=="object"?exports:Q)[i]=D[i]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function D(i){if(e[i])return e[i].exports;var R=e[i]={i,l:!1,exports:{}};return Q[i].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=Q,D.c=e,D.d=function(i,R,k){D.o(i,R)||Object.defineProperty(i,R,{enumerable:!0,get:k})},D.r=function(i){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},D.t=function(i,R){if(1&R&&(i=D(i)),8&R||4&R&&typeof i=="object"&&i&&i.__esModule)return i;var k=Object.create(null);if(D.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:i}),2&R&&typeof i!="string")for(var T in i)D.d(k,T,function(I){return i[I]}.bind(null,T));return k},D.n=function(i){var R=i&&i.__esModule?function(){return i.default}:function(){return i};return D.d(R,"a",R),R},D.o=function(i,R){return Object.prototype.hasOwnProperty.call(i,R)},D.p="",D(D.s=0)}([function(Q,e,D){(function(i){var R;e=Q.exports=_,R=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],C=e.src=[],w=0,E=w++;C[E]="0|[1-9]\\d*";var b=w++;C[b]="[0-9]+";var S=w++;C[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=w++;C[m]="("+C[E]+")\\.("+C[E]+")\\.("+C[E]+")";var f=w++;C[f]="("+C[b]+")\\.("+C[b]+")\\.("+C[b]+")";var v=w++;C[v]="(?:"+C[E]+"|"+C[S]+")";var y=w++;C[y]="(?:"+C[b]+"|"+C[S]+")";var u=w++;C[u]="(?:-("+C[v]+"(?:\\."+C[v]+")*))";var p=w++;C[p]="(?:-?("+C[y]+"(?:\\."+C[y]+")*))";var c=w++;C[c]="[0-9A-Za-z-]+";var h=w++;C[h]="(?:\\+("+C[c]+"(?:\\."+C[c]+")*))";var d=w++,n="v?"+C[m]+C[u]+"?"+C[h]+"?";C[d]="^"+n+"$";var o="[v=\\s]*"+C[f]+C[p]+"?"+C[h]+"?",t=w++;C[t]="^"+o+"$";var s=w++;C[s]="((?:<|>)?=?)";var r=w++;C[r]=C[b]+"|x|X|\\*";var l=w++;C[l]=C[E]+"|x|X|\\*";var a=w++;C[a]="[v=\\s]*("+C[l]+")(?:\\.("+C[l]+")(?:\\.("+C[l]+")(?:"+C[u]+")?"+C[h]+"?)?)?";var g=w++;C[g]="[v=\\s]*("+C[r]+")(?:\\.("+C[r]+")(?:\\.("+C[r]+")(?:"+C[p]+")?"+C[h]+"?)?)?";var P=w++;C[P]="^"+C[s]+"\\s*"+C[a]+"$";var A=w++;C[A]="^"+C[s]+"\\s*"+C[g]+"$";var V=w++;C[V]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=w++;C[O]="(?:~>?)";var F=w++;C[F]="(\\s*)"+C[O]+"\\s+",I[F]=new RegExp(C[F],"g");var N=w++;C[N]="^"+C[O]+C[a]+"$";var L=w++;C[L]="^"+C[O]+C[g]+"$";var U=w++;C[U]="(?:\\^)";var $=w++;C[$]="(\\s*)"+C[U]+"\\s+",I[$]=new RegExp(C[$],"g");var x=w++;C[x]="^"+C[U]+C[a]+"$";var j=w++;C[j]="^"+C[U]+C[g]+"$";var B=w++;C[B]="^"+C[s]+"\\s*("+o+")$|^$";var W=w++;C[W]="^"+C[s]+"\\s*("+n+")$|^$";var q=w++;C[q]="(\\s*)"+C[s]+"\\s*("+o+"|"+C[a]+")",I[q]=new RegExp(C[q],"g");var Y=w++;C[Y]="^\\s*("+C[a]+")\\s+-\\s+("+C[a]+")\\s*$";var ee=w++;C[ee]="^\\s*("+C[g]+")\\s+-\\s+("+C[g]+")\\s*$";var ce=w++;C[ce]="(<|>)?=?\\s*\\*";for(var J=0;J<35;J++)R(J,C[J]),I[J]||(I[J]=new RegExp(C[J]));function z(ae,fe){if(ae instanceof _)return ae;if(typeof ae!="string"||ae.length>k||!(fe?I[t]:I[d]).test(ae))return null;try{return new _(ae,fe)}catch{return null}}function _(ae,fe){if(ae instanceof _){if(ae.loose===fe)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof _))return new _(ae,fe);R("SemVer",ae,fe),this.loose=fe;var ge=ae.trim().match(fe?I[t]:I[d]);if(!ge)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ie=+be;if(Ie>=0&&Ie<T)return Ie}return be}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=z,e.valid=function(ae,fe){var ge=z(ae,fe);return ge?ge.version:null},e.clean=function(ae,fe){var ge=z(ae.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(ae){return R("SemVer.compare",this.version,this.loose,ae),ae instanceof _||(ae=new _(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},_.prototype.compareMain=function(ae){return ae instanceof _||(ae=new _(ae,this.loose)),G(this.major,ae.major)||G(this.minor,ae.minor)||G(this.patch,ae.patch)},_.prototype.comparePre=function(ae){if(ae instanceof _||(ae=new _(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],be=ae.prerelease[fe];if(R("prerelease compare",fe,ge,be),ge===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(ge===void 0)return-1;if(ge!==be)return G(ge,be)}while(++fe)},_.prototype.inc=function(ae,fe){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,fe,ge,be){typeof ge=="string"&&(be=ge,ge=void 0);try{return new _(ae,ge).inc(fe,be).version}catch{return null}},e.diff=function(ae,fe){if(X(ae,fe))return null;var ge=z(ae),be=z(fe);if(ge.prerelease.length||be.prerelease.length){for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==be[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==be[Ie])return Ie},e.compareIdentifiers=G;var M=/^[0-9]+$/;function G(ae,fe){var ge=M.test(ae),be=M.test(fe);return ge&&be&&(ae=+ae,fe=+fe),ge&&!be?-1:be&&!ge?1:ae<fe?-1:ae>fe?1:0}function H(ae,fe,ge){return new _(ae,ge).compare(new _(fe,ge))}function Z(ae,fe,ge){return H(ae,fe,ge)>0}function oe(ae,fe,ge){return H(ae,fe,ge)<0}function X(ae,fe,ge){return H(ae,fe,ge)===0}function ie(ae,fe,ge){return H(ae,fe,ge)!==0}function ne(ae,fe,ge){return H(ae,fe,ge)>=0}function le(ae,fe,ge){return H(ae,fe,ge)<=0}function ue(ae,fe,ge,be){var Ie;switch(fe){case"===":typeof ae=="object"&&(ae=ae.version),typeof ge=="object"&&(ge=ge.version),Ie=ae===ge;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof ge=="object"&&(ge=ge.version),Ie=ae!==ge;break;case"":case"=":case"==":Ie=X(ae,ge,be);break;case"!=":Ie=ie(ae,ge,be);break;case">":Ie=Z(ae,ge,be);break;case">=":Ie=ne(ae,ge,be);break;case"<":Ie=oe(ae,ge,be);break;case"<=":Ie=le(ae,ge,be);break;default:throw new TypeError("Invalid operator: "+fe)}return Ie}function pe(ae,fe){if(ae instanceof pe){if(ae.loose===fe)return ae;ae=ae.value}if(!(this instanceof pe))return new pe(ae,fe);R("comparator",ae,fe),this.loose=fe,this.parse(ae),this.semver===we?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(ae,fe){return G(fe,ae)},e.major=function(ae,fe){return new _(ae,fe).major},e.minor=function(ae,fe){return new _(ae,fe).minor},e.patch=function(ae,fe){return new _(ae,fe).patch},e.compare=H,e.compareLoose=function(ae,fe){return H(ae,fe,!0)},e.rcompare=function(ae,fe,ge){return H(fe,ae,ge)},e.sort=function(ae,fe){return ae.sort(function(ge,be){return e.compare(ge,be,fe)})},e.rsort=function(ae,fe){return ae.sort(function(ge,be){return e.rcompare(ge,be,fe)})},e.gt=Z,e.lt=oe,e.eq=X,e.neq=ie,e.gte=ne,e.lte=le,e.cmp=ue,e.Comparator=pe;var we={};function Ee(ae,fe){if(ae instanceof Ee)return ae.loose===fe?ae:new Ee(ae.raw,fe);if(ae instanceof pe)return new Ee(ae.value,fe);if(!(this instanceof Ee))return new Ee(ae,fe);if(this.loose=fe,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Ce(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function Ae(ae,fe,ge,be,Ie,Le,Re,Fe,_e,Me,ze,ke,Oe){return((fe=Ce(ge)?"":Ce(be)?">="+ge+".0.0":Ce(Ie)?">="+ge+"."+be+".0":">="+fe)+" "+(Fe=Ce(_e)?"":Ce(Me)?"<"+(+_e+1)+".0.0":Ce(ze)?"<"+_e+"."+(+Me+1)+".0":ke?"<="+_e+"."+Me+"."+ze+"-"+ke:"<="+Fe)).trim()}function Ne(ae,fe){for(var ge=0;ge<ae.length;ge++)if(!ae[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<ae.length;ge++)if(R(ae[ge].semver),ae[ge].semver!==we&&ae[ge].semver.prerelease.length>0){var be=ae[ge].semver;if(be.major===fe.major&&be.minor===fe.minor&&be.patch===fe.patch)return!0}return!1}return!0}function Ge(ae,fe,ge){try{fe=new Ee(fe,ge)}catch{return!1}return fe.test(ae)}function We(ae,fe,ge,be){var Ie,Le,Re,Fe,_e;switch(ae=new _(ae,be),fe=new Ee(fe,be),ge){case">":Ie=Z,Le=le,Re=oe,Fe=">",_e=">=";break;case"<":Ie=oe,Le=ne,Re=Z,Fe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ge(ae,fe,be))return!1;for(var Me=0;Me<fe.set.length;++Me){var ze=fe.set[Me],ke=null,Oe=null;if(ze.forEach(function(te){te.semver===we&&(te=new pe(">=0.0.0")),ke=ke||te,Oe=Oe||te,Ie(te.semver,ke.semver,be)?ke=te:Re(te.semver,Oe.semver,be)&&(Oe=te)}),ke.operator===Fe||ke.operator===_e||(!Oe.operator||Oe.operator===Fe)&&Le(ae,Oe.semver)||Oe.operator===_e&&Re(ae,Oe.semver))return!1}return!0}pe.prototype.parse=function(ae){var fe=this.loose?I[B]:I[W],ge=ae.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+ae);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new _(ge[2],this.loose):this.semver=we},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(ae){return R("Comparator.test",ae,this.loose),this.semver===we||(typeof ae=="string"&&(ae=new _(ae,this.loose)),ue(ae,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(ae,fe){if(!(ae instanceof pe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new Ee(ae.value,fe),Ge(this.value,ge,fe);if(ae.operator==="")return ge=new Ee(this.value,fe),Ge(ae.semver,ge,fe);var be=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Le=this.semver.version===ae.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),Fe=ue(this.semver,"<",ae.semver,fe)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),_e=ue(this.semver,">",ae.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return be||Ie||Le&&Re||Fe||_e},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ae){var fe=this.loose;ae=ae.trim(),R("range",ae,fe);var ge=fe?I[ee]:I[Y];ae=ae.replace(ge,Ae),R("hyphen replace",ae),ae=ae.replace(I[q],"$1$2$3"),R("comparator trim",ae,I[q]),ae=(ae=(ae=ae.replace(I[F],"$1~")).replace(I[$],"$1^")).split(/\s+/).join(" ");var be=fe?I[B]:I[W],Ie=ae.split(" ").map(function(Le){return function(Re,Fe){return R("comp",Re),Re=function(_e,Me){return _e.trim().split(/\s+/).map(function(ze){return function(ke,Oe){R("caret",ke,Oe);var te=Oe?I[j]:I[x];return ke.replace(te,function(he,de,me,Se,Pe){var De;return R("caret",ke,he,de,me,Se,Pe),Ce(de)?De="":Ce(me)?De=">="+de+".0.0 <"+(+de+1)+".0.0":Ce(Se)?De=de==="0"?">="+de+"."+me+".0 <"+de+"."+(+me+1)+".0":">="+de+"."+me+".0 <"+(+de+1)+".0.0":Pe?(R("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),De=de==="0"?me==="0"?">="+de+"."+me+"."+Se+Pe+" <"+de+"."+me+"."+(+Se+1):">="+de+"."+me+"."+Se+Pe+" <"+de+"."+(+me+1)+".0":">="+de+"."+me+"."+Se+Pe+" <"+(+de+1)+".0.0"):(R("no pr"),De=de==="0"?me==="0"?">="+de+"."+me+"."+Se+" <"+de+"."+me+"."+(+Se+1):">="+de+"."+me+"."+Se+" <"+de+"."+(+me+1)+".0":">="+de+"."+me+"."+Se+" <"+(+de+1)+".0.0"),R("caret return",De),De})}(ze,Me)}).join(" ")}(Re,Fe),R("caret",Re),Re=function(_e,Me){return _e.trim().split(/\s+/).map(function(ze){return function(ke,Oe){var te=Oe?I[L]:I[N];return ke.replace(te,function(he,de,me,Se,Pe){var De;return R("tilde",ke,he,de,me,Se,Pe),Ce(de)?De="":Ce(me)?De=">="+de+".0.0 <"+(+de+1)+".0.0":Ce(Se)?De=">="+de+"."+me+".0 <"+de+"."+(+me+1)+".0":Pe?(R("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),De=">="+de+"."+me+"."+Se+Pe+" <"+de+"."+(+me+1)+".0"):De=">="+de+"."+me+"."+Se+" <"+de+"."+(+me+1)+".0",R("tilde return",De),De})}(ze,Me)}).join(" ")}(Re,Fe),R("tildes",Re),Re=function(_e,Me){return R("replaceXRanges",_e,Me),_e.split(/\s+/).map(function(ze){return function(ke,Oe){ke=ke.trim();var te=Oe?I[A]:I[P];return ke.replace(te,function(he,de,me,Se,Pe,De){R("xRange",ke,he,de,me,Se,Pe,De);var Ve=Ce(me),$e=Ve||Ce(Se),Te=$e||Ce(Pe);return de==="="&&Te&&(de=""),Ve?he=de===">"||de==="<"?"<0.0.0":"*":de&&Te?($e&&(Se=0),Te&&(Pe=0),de===">"?(de=">=",$e?(me=+me+1,Se=0,Pe=0):Te&&(Se=+Se+1,Pe=0)):de==="<="&&(de="<",$e?me=+me+1:Se=+Se+1),he=de+me+"."+Se+"."+Pe):$e?he=">="+me+".0.0 <"+(+me+1)+".0.0":Te&&(he=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),R("xRange return",he),he})}(ze,Me)}).join(" ")}(Re,Fe),R("xrange",Re),Re=function(_e,Me){return R("replaceStars",_e,Me),_e.trim().replace(I[ce],"")}(Re,Fe),R("stars",Re),Re}(Le,fe)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Le){return!!Le.match(be)})),Ie=Ie.map(function(Le){return new pe(Le,fe)})},Ee.prototype.intersects=function(ae,fe){if(!(ae instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(be){return ae.set.some(function(Ie){return Ie.every(function(Le){return be.intersects(Le,fe)})})})})},e.toComparators=function(ae,fe){return new Ee(ae,fe).set.map(function(ge){return ge.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new _(ae,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Ne(this.set[fe],ae))return!0;return!1},e.satisfies=Ge,e.maxSatisfying=function(ae,fe,ge){var be=null,Ie=null;try{var Le=new Ee(fe,ge)}catch{return null}return ae.forEach(function(Re){Le.test(Re)&&(be&&Ie.compare(Re)!==-1||(Ie=new _(be=Re,ge)))}),be},e.minSatisfying=function(ae,fe,ge){var be=null,Ie=null;try{var Le=new Ee(fe,ge)}catch{return null}return ae.forEach(function(Re){Le.test(Re)&&(be&&Ie.compare(Re)!==1||(Ie=new _(be=Re,ge)))}),be},e.validRange=function(ae,fe){try{return new Ee(ae,fe).range||"*"}catch{return null}},e.ltr=function(ae,fe,ge){return We(ae,fe,"<",ge)},e.gtr=function(ae,fe,ge){return We(ae,fe,">",ge)},e.outside=We,e.prerelease=function(ae,fe){var ge=z(ae,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ae,fe,ge){return ae=new Ee(ae,ge),fe=new Ee(fe,ge),ae.intersects(fe)},e.coerce=function(ae){if(ae instanceof _)return ae;if(typeof ae!="string")return null;var fe=ae.match(I[V]);return fe==null?null:z((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,D(1))},function(Q,e){var D,i,R=Q.exports={};function k(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function I(y){if(D===setTimeout)return setTimeout(y,0);if((D===k||!D)&&setTimeout)return D=setTimeout,setTimeout(y,0);try{return D(y,0)}catch{try{return D.call(null,y,0)}catch{return D.call(this,y,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:k}catch{D=k}try{i=typeof clearTimeout=="function"?clearTimeout:T}catch{i=T}})();var C,w=[],E=!1,b=-1;function S(){E&&C&&(E=!1,C.length?w=C.concat(w):b=-1,w.length&&m())}function m(){if(!E){var y=I(S);E=!0;for(var u=w.length;u;){for(C=w,w=[];++b<u;)C&&C[b].run();b=-1,u=w.length}C=null,E=!1,function(p){if(i===clearTimeout)return clearTimeout(p);if((i===T||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(p);try{i(p)}catch{try{return i.call(null,p)}catch{return i.call(this,p)}}}(y)}}function f(y,u){this.fun=y,this.array=u}function v(){}R.nextTick=function(y){var u=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)u[p-1]=arguments[p];w.push(new f(y,u)),w.length!==1||E||I(m)},f.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=v,R.addListener=v,R.once=v,R.off=v,R.removeListener=v,R.removeAllListeners=v,R.emit=v,R.prependListener=v,R.prependOnceListener=v,R.listeners=function(y){return[]},R.binding=function(y){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(y){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(re[129],se([0,1]),function(Q,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class i{constructor(I,C,w){this.level=I,this.key=C,this.value=w,this.forward=[]}}const R=void 0;class k{constructor(I,C=2**16){this.comparator=I,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(C)|0),this._header=new i(this._maxLevel,R,R)}get size(){return this._size}clear(){this._header=new i(this._maxLevel,R,R)}has(I){return Boolean(k._search(this,I,this.comparator))}get(I){return k._search(this,I,this.comparator)?.value}set(I,C){return k._insert(this,I,C,this.comparator)&&(this._size+=1),this}delete(I){const C=k._delete(this,I,this.comparator);return C&&(this._size-=1),C}forEach(I,C){let w=this._header.forward[0];for(;w;)I.call(C,w.value,w.key,this),w=w.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",C=this._header.forward[0];for(;C;)I+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return I}static _search(I,C,w){let E=I._header;for(let b=I._level-1;b>=0;b--)for(;E.forward[b]&&w(E.forward[b].key,C)<0;)E=E.forward[b];if(E=E.forward[0],E&&w(E.key,C)===0)return E}static _insert(I,C,w,E){const b=[];let S=I._header;for(let m=I._level-1;m>=0;m--){for(;S.forward[m]&&E(S.forward[m].key,C)<0;)S=S.forward[m];b[m]=S}if(S=S.forward[0],S&&E(S.key,C)===0)return S.value=w,!1;{const m=k._randomLevel(I);if(m>I._level){for(let f=I._level;f<m;f++)b[f]=I._header;I._level=m}S=new i(m,C,w);for(let f=0;f<m;f++)S.forward[f]=b[f].forward[f],b[f].forward[f]=S;return!0}}static _randomLevel(I,C=.5){let w=1;for(;Math.random()<C&&w<I._maxLevel;)w+=1;return w}static _delete(I,C,w){const E=[];let b=I._header;for(let S=I._level-1;S>=0;S--){for(;b.forward[S]&&w(b.forward[S].key,C)<0;)b=b.forward[S];E[S]=b}if(b=b.forward[0],!b||w(b.key,C)!==0)return!1;for(let S=0;S<I._level&&E[S].forward[S]===b;S++)E[S].forward[S]=b.forward[S];for(;I._level>0&&I._header.forward[I._level-1]===R;)I._level-=1;return!0}}e.SkipList=k}),define(re[43],se([0,1,11,2]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(h){const d=h;return d?typeof d.read=="function":!1}e.isReadable=R;function k(h){const d=h;return d?[d.on,d.pause,d.resume,d.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=k;function T(h){const d=h;return d?k(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=T;function I(h,d){return new C(h,d)}e.newWriteableStream=I;class C{constructor(d,n){this.reducer=d,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d<"u"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(n=>n(d))}emitError(d){this.listeners.error.length===0?(0,D.onUnexpectedError)(d):this.listeners.error.slice(0).forEach(n=>n(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,n){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(d,n){if(this.state.destroyed)return;let o;switch(d){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const t=o.indexOf(n);t>=0&&o.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(h,d){const n=[];let o;for(;(o=h.read())!==null;)n.push(o);return d(n)}e.consumeReadable=w;function E(h,d,n){const o=[];let t;for(;(t=h.read())!==null&&o.length<n;)o.push(t);return t===null&&o.length>0?d(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const s=t;return t=void 0,s}return h.read()}}}e.peekReadable=E;function b(h,d){return new Promise((n,o)=>{const t=[];S(h,{onData:s=>{d&&t.push(s)},onError:s=>{d?o(s):n(void 0)},onEnd:()=>{n(d?d(t):void 0)}})})}e.consumeStream=b;function S(h,d){let n=!1;return h.on("error",o=>{n||d.onError(o)}),h.on("end",()=>{n||d.onEnd()}),h.on("data",o=>{n||d.onData(o)}),(0,i.toDisposable)(()=>n=!0)}e.listenStream=S;function m(h,d){return new Promise((n,o)=>{const t=new i.DisposableStore,s=[],r=g=>{if(s.push(g),s.length>d)return t.dispose(),h.pause(),n({stream:h,buffer:s,ended:!1})},l=g=>o(g),a=()=>n({stream:h,buffer:s,ended:!0});t.add((0,i.toDisposable)(()=>h.removeListener("error",l))),h.on("error",l),t.add((0,i.toDisposable)(()=>h.removeListener("end",a))),h.on("end",a),t.add((0,i.toDisposable)(()=>h.removeListener("data",r))),h.on("data",r)})}e.peekStream=m;function f(h,d){const n=I(d);return n.end(h),n}e.toStream=f;function v(){const h=I(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=v;function y(h){let d=!1;return{read:()=>d?null:(d=!0,h)}}e.toReadable=y;function u(h,d,n){const o=I(n);return S(h,{onData:t=>o.write(d.data(t)),onError:t=>o.error(d.error?d.error(t):t),onEnd:()=>o.end()}),o}e.transform=u;function p(h,d,n){let o=!1;return{read:()=>{const t=d.read();return o?t:(o=!0,t!==null?n([h,t]):h)}}}e.prefixedReadable=p;function c(h,d,n){let o=!1;const t=I(n);return S(d,{onData:s=>o?t.write(s):(o=!0,t.write(n([h,s]))),onError:s=>t.error(s),onEnd:()=>{o||(o=!0,t.write(h)),t.end()}}),t}e.prefixedStream=c}),define(re[17],se([0,1,43]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer<"u";let R,k;class T{static alloc(g){return i?new T(Buffer.allocUnsafe(g)):new T(new Uint8Array(g))}static wrap(g){return i&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new T(g)}static fromString(g,P){return!(P?.dontUseNodeBuffer||!1)&&i?new T(Buffer.from(g)):(R||(R=new TextEncoder),new T(R.encode(g)))}static fromByteArray(g){const P=T.alloc(g.length);for(let A=0,V=g.length;A<V;A++)P.buffer[A]=g[A];return P}static concat(g,P){if(typeof P>"u"){P=0;for(let O=0,F=g.length;O<F;O++)P+=g[O].byteLength}const A=T.alloc(P);let V=0;for(let O=0,F=g.length;O<F;O++){const N=g[O];A.set(N,V),V+=N.byteLength}return A}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=T.alloc(this.byteLength);return g.set(this),g}toString(){return i?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(g,P){return new T(this.buffer.subarray(g,P))}set(g,P){if(g instanceof T)this.buffer.set(g.buffer,P);else if(g instanceof Uint8Array)this.buffer.set(g,P);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),P);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return w(this.buffer,g)}writeUInt32BE(g,P){E(this.buffer,g,P)}readUInt32LE(g){return b(this.buffer,g)}writeUInt32LE(g,P){S(this.buffer,g,P)}readUInt8(g){return m(this.buffer,g)}writeUInt8(g,P){f(this.buffer,g,P)}}e.VSBuffer=T;function I(a,g){return a[g+0]<<0>>>0|a[g+1]<<8>>>0}e.readUInt16LE=I;function C(a,g,P){a[P+0]=g&255,g=g>>>8,a[P+1]=g&255}e.writeUInt16LE=C;function w(a,g){return a[g]*2**24+a[g+1]*2**16+a[g+2]*2**8+a[g+3]}e.readUInt32BE=w;function E(a,g,P){a[P+3]=g,g=g>>>8,a[P+2]=g,g=g>>>8,a[P+1]=g,g=g>>>8,a[P]=g}e.writeUInt32BE=E;function b(a,g){return a[g+0]<<0>>>0|a[g+1]<<8>>>0|a[g+2]<<16>>>0|a[g+3]<<24>>>0}e.readUInt32LE=b;function S(a,g,P){a[P+0]=g&255,g=g>>>8,a[P+1]=g&255,g=g>>>8,a[P+2]=g&255,g=g>>>8,a[P+3]=g&255}e.writeUInt32LE=S;function m(a,g){return a[g]}e.readUInt8=m;function f(a,g,P){a[P]=g}e.writeUInt8=f;function v(a){return D.consumeReadable(a,g=>T.concat(g))}e.readableToBuffer=v;function y(a){return D.toReadable(a)}e.bufferToReadable=y;function u(a){return D.consumeStream(a,g=>T.concat(g))}e.streamToBuffer=u;async function p(a){return a.ended?T.concat(a.buffer):T.concat([...a.buffer,await u(a.stream)])}e.bufferedStreamToBuffer=p;function c(a){return D.toStream(a,g=>T.concat(g))}e.bufferToStream=c;function h(a){return D.transform(a,{data:g=>typeof g=="string"?T.fromString(g):T.wrap(g)},g=>T.concat(g))}e.streamToBufferReadableStream=h;function d(a){return D.newWriteableStream(g=>T.concat(g),a)}e.newWriteableBufferStream=d;function n(a,g){return D.prefixedReadable(a,g,P=>T.concat(P))}e.prefixedBufferReadable=n;function o(a,g){return D.prefixedStream(a,g,P=>T.concat(P))}e.prefixedBufferStream=o;function t(a){let g=0,P=0,A=0;const V=new Uint8Array(Math.floor(a.length/4*3)),O=N=>{switch(P){case 3:V[A++]=g|N,P=0;break;case 2:V[A++]=g|N>>>2,g=N<<6,P=3;break;case 1:V[A++]=g|N>>>4,g=N<<4,P=2;break;default:g=N<<2,P=1}};for(let N=0;N<a.length;N++){const L=a.charCodeAt(N);if(L>=65&&L<=90)O(L-65);else if(L>=97&&L<=122)O(L-97+26);else if(L>=48&&L<=57)O(L-48+52);else if(L===43||L===45)O(62);else if(L===47||L===95)O(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${a[N]}`)}}const F=A;for(;P>0;)O(0);return T.wrap(V).slice(0,F)}e.decodeBase64=t;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:a},g=!0,P=!1){const A=P?r:s;let V="";const O=a.byteLength%3;let F=0;for(;F<a.byteLength-O;F+=3){const N=a[F+0],L=a[F+1],U=a[F+2];V+=A[N>>>2],V+=A[(N<<4|L>>>4)&63],V+=A[(L<<2|U>>>6)&63],V+=A[U&63]}if(O===1){const N=a[F+0];V+=A[N>>>2],V+=A[N<<4&63],g&&(V+="==")}else if(O===2){const N=a[F+0],L=a[F+1];V+=A[N>>>2],V+=A[(N<<4|L>>>4)&63],V+=A[L<<2&63],g&&(V+="=")}return V}e.encodeBase64=l}),define(re[15],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function D(o){return typeof o=="string"}e.isString=D;function i(o){return Array.isArray(o)&&o.every(t=>D(t))}e.isStringArray=i;function R(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=R;function k(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}e.isTypedArray=k;function T(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=T;function I(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=I;function C(o){return o===!0||o===!1}e.isBoolean=C;function w(o){return typeof o>"u"}e.isUndefined=w;function E(o){return!b(o)}e.isDefined=E;function b(o){return w(o)||o===null}e.isUndefinedOrNull=b;function S(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=S;function m(o){if(b(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=m;function f(...o){const t=[];for(let s=0;s<o.length;s++){const r=o[s];if(b(r))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(r)}return t}e.assertAllDefined=f;const v=Object.prototype.hasOwnProperty;function y(o){if(!R(o))return!1;for(const t in o)if(v.call(o,t))return!1;return!0}e.isEmptyObject=y;function u(o){return typeof o=="function"}e.isFunction=u;function p(...o){return o.length>0&&o.every(u)}e.areFunctions=p;function c(o,t){const s=Math.min(o.length,t.length);for(let r=0;r<s;r++)h(o[r],t[r])}e.validateConstraints=c;function h(o,t){if(D(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(o instanceof t)return}catch{}if(!b(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function d(o){return o===null?void 0:o}e.withNullAsUndefined=d;function n(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=n}),define(re[31],se([0,1,15]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const p=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([c,h])=>{p[c]=h&&typeof h=="object"?i(h):h}),p}e.deepClone=i;function R(u){if(!u||typeof u!="object")return u;const p=[u];for(;p.length>0;){const c=p.shift();Object.freeze(c);for(const h in c)if(k.call(c,h)){const d=c[h];typeof d=="object"&&!Object.isFrozen(d)&&!(0,D.isTypedArray)(d)&&p.push(d)}}return u}e.deepFreeze=R;const k=Object.prototype.hasOwnProperty;function T(u,p){return I(u,p,new Set)}e.cloneAndChange=T;function I(u,p,c){if((0,D.isUndefinedOrNull)(u))return u;const h=p(u);if(typeof h<"u")return h;if(Array.isArray(u)){const d=[];for(const n of u)d.push(I(n,p,c));return d}if((0,D.isObject)(u)){if(c.has(u))throw new Error("Cannot clone recursive data-structure");c.add(u);const d={};for(const n in u)k.call(u,n)&&(d[n]=I(u[n],p,c));return c.delete(u),d}return u}function C(u,p,c=!0){return(0,D.isObject)(u)?((0,D.isObject)(p)&&Object.keys(p).forEach(h=>{h in u?c&&((0,D.isObject)(u[h])&&(0,D.isObject)(p[h])?C(u[h],p[h],c):u[h]=p[h]):u[h]=p[h]}),u):p}e.mixin=C;function w(u,p){if(u===p)return!0;if(u==null||p===null||p===void 0||typeof u!=typeof p||typeof u!="object"||Array.isArray(u)!==Array.isArray(p))return!1;let c,h;if(Array.isArray(u)){if(u.length!==p.length)return!1;for(c=0;c<u.length;c++)if(!w(u[c],p[c]))return!1}else{const d=[];for(h in u)d.push(h);d.sort();const n=[];for(h in p)n.push(h);if(n.sort(),!w(d,n))return!1;for(c=0;c<d.length;c++)if(!w(u[d[c]],p[d[c]]))return!1}return!0}e.equals=w;function E(u){const p=new Set;return JSON.stringify(u,(c,h)=>{if((0,D.isObject)(h)||Array.isArray(h)){if(p.has(h))return"[Circular]";p.add(h)}return h})}e.safeStringify=E;function b(u,p){const c=Object.create(null);return!u||!p||Object.keys(p).forEach(d=>{const n=u[d],o=p[d];w(n,o)||(c[d]=o)}),c}e.distinct=b;function S(u,p){const c=p.toLowerCase(),h=Object.keys(u).find(d=>d.toLowerCase()===c);return h?u[h]:u[p]}e.getCaseInsensitive=S;function m(u,p){const c=Object.create(null);for(const[h,d]of Object.entries(u))p(h,d)&&(c[h]=d);return c}e.filter=m;function f(u){let p=[],c=Object.getPrototypeOf(u);for(;Object.prototype!==c;)p=p.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return p}e.getAllPropertyNames=f;function v(u){const p=[];for(const c of f(u))typeof u[c]=="function"&&p.push(c);return p}e.getAllMethodNames=v;function y(u,p){const c=d=>function(){const n=Array.prototype.slice.call(arguments,0);return p(d,n)},h={};for(const d of u)h[d]=c(d);return h}e.createProxyObject=y}),define(re[30],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(R){return D.test(R)}e.isUUID=i,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(I){for(let C=0;C<I.length;C++)I[C]=Math.floor(Math.random()*256);return I};const k=new Uint8Array(16),T=[];for(let I=0;I<256;I++)T.push(I.toString(16).padStart(2,"0"));return function(){R(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let C=0,w="";return w+=T[k[C++]],w+=T[k[C++]],w+=T[k[C++]],w+=T[k[C++]],w+="-",w+=T[k[C++]],w+=T[k[C++]],w+="-",w+=T[k[C++]],w+=T[k[C++]],w+="-",w+=T[k[C++]],w+=T[k[C++]],w+="-",w+=T[k[C++]],w+=T[k[C++]],w+=T[k[C++]],w+=T[k[C++]],w+=T[k[C++]],w+=T[k[C++]],w}}()}),define(re[130],se([0,1,34]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const i=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(T){const I=T.replace(/\-/g,":").toLowerCase();return!i.has(I)}function k(){const T=(0,D.networkInterfaces)();for(const I in T){const C=T[I];if(C){for(const{mac:w}of C)if(R(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=k}),define(re[131],se([0,1,84]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function i(I,C,w,E=1){let b=!1;return new Promise(S=>{const m=setTimeout(()=>{if(!b)return b=!0,S(0)},w);R(I,C,E,f=>{if(!b)return b=!0,clearTimeout(m),S(f)})})}e.findFreePort=i;function R(I,C,w,E){if(C===0)return E(0);const b=new D.Socket;b.once("connect",()=>(T(b),R(I+w,C-1,w,E))),b.once("data",()=>{}),b.once("error",S=>(T(b),S.code!=="ECONNREFUSED"?R(I+w,C-1,w,E):E(I))),b.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(I,C,w,E="127.0.0.1"){let b=!1,S,m=1;const f=D.createServer({pauseOnConnect:!0});function v(y,u){b||(b=!0,f.removeAllListeners(),f.close(),S&&clearTimeout(S),u(y))}return new Promise(y=>{S=setTimeout(()=>{v(0,y)},w),f.on("listening",()=>{v(I,y)}),f.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&m<C?(I++,m++,f.listen(I,E)):v(0,y)}),f.on("close",()=>{v(0,y)}),f.listen(I,E)})}e.findFreePortFaster=k;function T(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(C){console.error(C)}}}),define(re[132],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const D="Offline";function i(k){return k instanceof R?!0:k instanceof Error&&k.name===D&&k.message===D}e.isOfflineError=i;class R extends Error{constructor(){super(D),this.name=this.message}}e.OfflineError=R}),define(re[133],se([0,1,17,11,132]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function k(C,w){if(!navigator.onLine)throw new R.OfflineError;C.proxyAuthorization&&(C.headers={...C.headers||{},"Proxy-Authorization":C.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((b,S)=>{E.open(C.type||"GET",C.url||"",!0,C.user,C.password),T(E,C),E.responseType="arraybuffer",E.onerror=m=>S(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=m=>{b({res:{statusCode:E.status,headers:I(E)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=m=>S(new Error(`XHR timeout: ${C.timeout}ms`)),C.timeout&&(E.timeout=C.timeout),E.send(C.data),w.onCancellationRequested(()=>{E.abort(),S((0,i.canceled)())})})}e.request=k;function T(C,w){if(w.headers){e:for(const E in w.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}C.setRequestHeader(E,w.headers[E])}}}function I(C){const w=Object.create(null);for(const E of C.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const b=E.indexOf(":");w[E.substr(0,b).trim().toLowerCase()]=E.substr(b+1).trim()}return w}}),define(re[134],se([9,10]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(re[65],se([0,1,134]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,R=i*60,k=R*24,T=k*7,I=k*30,C=k*365;function w(b,S,m){typeof b!="number"&&(b=b.getTime());const f=Math.round((new Date().getTime()-b)/1e3);if(f<-30)return(0,D.localize)(0,null,w(new Date().getTime()+f*1e3,!1));if(f<30)return(0,D.localize)(1,null);let v;return f<i?(v=f,S?v===1?m?(0,D.localize)(2,null,v):(0,D.localize)(3,null,v):m?(0,D.localize)(4,null,v):(0,D.localize)(5,null,v):v===1?m?(0,D.localize)(6,null,v):(0,D.localize)(7,null,v):m?(0,D.localize)(8,null,v):(0,D.localize)(9,null,v)):f<R?(v=Math.floor(f/i),S?v===1?m?(0,D.localize)(10,null,v):(0,D.localize)(11,null,v):m?(0,D.localize)(12,null,v):(0,D.localize)(13,null,v):v===1?m?(0,D.localize)(14,null,v):(0,D.localize)(15,null,v):m?(0,D.localize)(16,null,v):(0,D.localize)(17,null,v)):f<k?(v=Math.floor(f/R),S?v===1?m?(0,D.localize)(18,null,v):(0,D.localize)(19,null,v):m?(0,D.localize)(20,null,v):(0,D.localize)(21,null,v):v===1?m?(0,D.localize)(22,null,v):(0,D.localize)(23,null,v):m?(0,D.localize)(24,null,v):(0,D.localize)(25,null,v)):f<T?(v=Math.floor(f/k),S?v===1?(0,D.localize)(26,null,v):(0,D.localize)(27,null,v):v===1?(0,D.localize)(28,null,v):(0,D.localize)(29,null,v)):f<I?(v=Math.floor(f/T),S?v===1?m?(0,D.localize)(30,null,v):(0,D.localize)(31,null,v):m?(0,D.localize)(32,null,v):(0,D.localize)(33,null,v):v===1?m?(0,D.localize)(34,null,v):(0,D.localize)(35,null,v):m?(0,D.localize)(36,null,v):(0,D.localize)(37,null,v)):f<C?(v=Math.floor(f/I),S?v===1?m?(0,D.localize)(38,null,v):(0,D.localize)(39,null,v):m?(0,D.localize)(40,null,v):(0,D.localize)(41,null,v):v===1?m?(0,D.localize)(42,null,v):(0,D.localize)(43,null,v):m?(0,D.localize)(44,null,v):(0,D.localize)(45,null,v)):(v=Math.floor(f/C),S?v===1?m?(0,D.localize)(46,null,v):(0,D.localize)(47,null,v):m?(0,D.localize)(48,null,v):(0,D.localize)(49,null,v):v===1?m?(0,D.localize)(50,null,v):(0,D.localize)(51,null,v):m?(0,D.localize)(52,null,v):(0,D.localize)(53,null,v))}e.fromNow=w;function E(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=E}),define(re[135],se([9,10]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(re[37],se([0,1,19,15,135]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function k(b,S){return S&&(b.stack||b.stacktrace)?R.localize(0,null,I(b),T(b.stack)||T(b.stacktrace)):I(b)}function T(b){return Array.isArray(b)?b.join(`
`):b}function I(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?R.localize(1,null,b.message):b.message||R.localize(2,null)}function C(b=null,S=!1){if(!b)return R.localize(3,null);if(Array.isArray(b)){const m=D.coalesce(b),f=C(m[0],S);return m.length>1?R.localize(4,null,f,m.length):f}if(i.isString(b))return b;if(b.detail){const m=b.detail;if(m.error)return k(m.error,S);if(m.exception)return k(m.exception,S)}return b.stack?k(b,S):b.message?b.message:R.localize(5,null)}e.toErrorMessage=C;function w(b){const S=b;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=w;function E(b,S){let m;return typeof b=="string"?m=new Error(b):m=b,m.actions=S,m}e.createErrorWithActions=E}),define(re[136],se([9,10]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(re[137],se([0,1,136]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function i(R){switch(R){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.getParseErrorMessage=i}),define(re[138],se([9,10]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(re[5],se([0,1,138]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let i=!1,R=!1,k=!1,T=!1,I=!1,C=!1,w=!1,E=!1,b=!1,S=!1,m,f=e.LANGUAGE_DEFAULT,v,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const p=typeof u?.versions?.electron=="string",c=p&&u?.type==="renderer";if(typeof navigator=="object"&&!c)y=navigator.userAgent,i=y.indexOf("Windows")>=0,R=y.indexOf("Macintosh")>=0,E=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=y.indexOf("Linux")>=0,S=y?.indexOf("Mobi")>=0,C=!0,m=D.getConfiguredDefaultLocale(D.localize(0,null))||e.LANGUAGE_DEFAULT,f=m;else if(typeof u=="object"){i=u.platform==="win32",R=u.platform==="darwin",k=u.platform==="linux",T=k&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,w=p,b=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const a=u.env.VSCODE_NLS_CONFIG;if(a)try{const g=JSON.parse(a),P=g.availableLanguages["*"];m=g.locale,f=P||e.LANGUAGE_DEFAULT,v=g._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var h;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function d(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=d;let n=0;R?n=1:i?n=3:k&&(n=2),e.isWindows=i,e.isMacintosh=R,e.isLinux=k,e.isLinuxSnap=T,e.isNative=I,e.isElectron=w,e.isWeb=C,e.isWebWorker=C&&typeof e.globals.importScripts=="function",e.isIOS=E,e.isMobile=S,e.isCI=b,e.platform=n,e.userAgent=y,e.language=f;var o;(function(a){function g(){return e.language}a.value=g;function P(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=P;function A(){return e.language==="en"}a.isDefault=A})(o=e.Language||(e.Language={})),e.locale=m,e.translationsConfigFile=v,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let A=0,V=a.length;A<V;A++){const O=a[A];if(O.id===P.data.vscodeScheduleAsyncWork){a.splice(A,1),O.callback();return}}});let g=0;return P=>{const A=++g;a.push({id:A,callback:P}),e.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return a=>setTimeout(a)})();var t;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||E?2:i?1:3;let s=!0,r=!1;function l(){if(!r){r=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,s=new Uint16Array(a.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(re[36],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.process<"u"){const R=D.globals.vscode.process;i={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(re[12],se([0,1,36]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,R=97,k=90,T=122,I=46,C=47,w=92,E=58,b=63;class S extends Error{constructor(h,d,n){let o;typeof d=="string"&&d.indexOf("not ")===0?(o="must not be",d=d.replace(/^not /,"")):o="must be";const t=h.indexOf(".")!==-1?"property":"argument";let s=`The "${h}" ${t} ${o} of type ${d}`;s+=`. Received type ${typeof n}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function m(c,h){if(typeof c!="string")throw new S(h,"string",c)}function f(c){return c===C||c===w}function v(c){return c===C}function y(c){return c>=i&&c<=k||c>=R&&c<=T}function u(c,h,d,n){let o="",t=0,s=-1,r=0,l=0;for(let a=0;a<=c.length;++a){if(a<c.length)l=c.charCodeAt(a);else{if(n(l))break;l=C}if(n(l)){if(!(s===a-1||r===1))if(r===2){if(o.length<2||t!==2||o.charCodeAt(o.length-1)!==I||o.charCodeAt(o.length-2)!==I){if(o.length>2){const g=o.lastIndexOf(d);g===-1?(o="",t=0):(o=o.slice(0,g),t=o.length-1-o.lastIndexOf(d)),s=a,r=0;continue}else if(o.length!==0){o="",t=0,s=a,r=0;continue}}h&&(o+=o.length>0?`${d}..`:"..",t=2)}else o.length>0?o+=`${d}${c.slice(s+1,a)}`:o=c.slice(s+1,a),t=a-s-1;s=a,r=0}else l===I&&r!==-1?++r:r=-1}return o}function p(c,h){if(h===null||typeof h!="object")throw new S("pathObject","Object",h);const d=h.dir||h.root,n=h.base||`${h.name||""}${h.ext||""}`;return d?d===h.root?`${d}${n}`:`${d}${c}${n}`:n}e.win32={resolve(...c){let h="",d="",n=!1;for(let o=c.length-1;o>=-1;o--){let t;if(o>=0){if(t=c[o],m(t,"path"),t.length===0)continue}else h.length===0?t=D.cwd():(t=D.env[`=${h}`]||D.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==h.toLowerCase()&&t.charCodeAt(2)===w)&&(t=`${h}\\`));const s=t.length;let r=0,l="",a=!1;const g=t.charCodeAt(0);if(s===1)f(g)&&(r=1,a=!0);else if(f(g))if(a=!0,f(t.charCodeAt(1))){let P=2,A=P;for(;P<s&&!f(t.charCodeAt(P));)P++;if(P<s&&P!==A){const V=t.slice(A,P);for(A=P;P<s&&f(t.charCodeAt(P));)P++;if(P<s&&P!==A){for(A=P;P<s&&!f(t.charCodeAt(P));)P++;(P===s||P!==A)&&(l=`\\\\${V}\\${t.slice(A,P)}`,r=P)}}}else r=1;else y(g)&&t.charCodeAt(1)===E&&(l=t.slice(0,2),r=2,s>2&&f(t.charCodeAt(2))&&(a=!0,r=3));if(l.length>0)if(h.length>0){if(l.toLowerCase()!==h.toLowerCase())continue}else h=l;if(n){if(h.length>0)break}else if(d=`${t.slice(r)}\\${d}`,n=a,a&&h.length>0)break}return d=u(d,!n,"\\",f),n?`${h}\\${d}`:`${h}${d}`||"."},normalize(c){m(c,"path");const h=c.length;if(h===0)return".";let d=0,n,o=!1;const t=c.charCodeAt(0);if(h===1)return v(t)?"\\":c;if(f(t))if(o=!0,f(c.charCodeAt(1))){let r=2,l=r;for(;r<h&&!f(c.charCodeAt(r));)r++;if(r<h&&r!==l){const a=c.slice(l,r);for(l=r;r<h&&f(c.charCodeAt(r));)r++;if(r<h&&r!==l){for(l=r;r<h&&!f(c.charCodeAt(r));)r++;if(r===h)return`\\\\${a}\\${c.slice(l)}\\`;r!==l&&(n=`\\\\${a}\\${c.slice(l,r)}`,d=r)}}}else d=1;else y(t)&&c.charCodeAt(1)===E&&(n=c.slice(0,2),d=2,h>2&&f(c.charCodeAt(2))&&(o=!0,d=3));let s=d<h?u(c.slice(d),!o,"\\",f):"";return s.length===0&&!o&&(s="."),s.length>0&&f(c.charCodeAt(h-1))&&(s+="\\"),n===void 0?o?`\\${s}`:s:o?`${n}\\${s}`:`${n}${s}`},isAbsolute(c){m(c,"path");const h=c.length;if(h===0)return!1;const d=c.charCodeAt(0);return f(d)||h>2&&y(d)&&c.charCodeAt(1)===E&&f(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let h,d;for(let t=0;t<c.length;++t){const s=c[t];m(s,"path"),s.length>0&&(h===void 0?h=d=s:h+=`\\${s}`)}if(h===void 0)return".";let n=!0,o=0;if(typeof d=="string"&&f(d.charCodeAt(0))){++o;const t=d.length;t>1&&f(d.charCodeAt(1))&&(++o,t>2&&(f(d.charCodeAt(2))?++o:n=!1))}if(n){for(;o<h.length&&f(h.charCodeAt(o));)o++;o>=2&&(h=`\\${h.slice(o)}`)}return e.win32.normalize(h)},relative(c,h){if(m(c,"from"),m(h,"to"),c===h)return"";const d=e.win32.resolve(c),n=e.win32.resolve(h);if(d===n||(c=d.toLowerCase(),h=n.toLowerCase(),c===h))return"";let o=0;for(;o<c.length&&c.charCodeAt(o)===w;)o++;let t=c.length;for(;t-1>o&&c.charCodeAt(t-1)===w;)t--;const s=t-o;let r=0;for(;r<h.length&&h.charCodeAt(r)===w;)r++;let l=h.length;for(;l-1>r&&h.charCodeAt(l-1)===w;)l--;const a=l-r,g=s<a?s:a;let P=-1,A=0;for(;A<g;A++){const O=c.charCodeAt(o+A);if(O!==h.charCodeAt(r+A))break;O===w&&(P=A)}if(A!==g){if(P===-1)return n}else{if(a>g){if(h.charCodeAt(r+A)===w)return n.slice(r+A+1);if(A===2)return n.slice(r+A)}s>g&&(c.charCodeAt(o+A)===w?P=A:A===2&&(P=3)),P===-1&&(P=0)}let V="";for(A=o+P+1;A<=t;++A)(A===t||c.charCodeAt(A)===w)&&(V+=V.length===0?"..":"\\..");return r+=P,V.length>0?`${V}${n.slice(r,l)}`:(n.charCodeAt(r)===w&&++r,n.slice(r,l))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const h=e.win32.resolve(c);if(h.length<=2)return c;if(h.charCodeAt(0)===w){if(h.charCodeAt(1)===w){const d=h.charCodeAt(2);if(d!==b&&d!==I)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(y(h.charCodeAt(0))&&h.charCodeAt(1)===E&&h.charCodeAt(2)===w)return`\\\\?\\${h}`;return c},dirname(c){m(c,"path");const h=c.length;if(h===0)return".";let d=-1,n=0;const o=c.charCodeAt(0);if(h===1)return f(o)?c:".";if(f(o)){if(d=n=1,f(c.charCodeAt(1))){let r=2,l=r;for(;r<h&&!f(c.charCodeAt(r));)r++;if(r<h&&r!==l){for(l=r;r<h&&f(c.charCodeAt(r));)r++;if(r<h&&r!==l){for(l=r;r<h&&!f(c.charCodeAt(r));)r++;if(r===h)return c;r!==l&&(d=n=r+1)}}}}else y(o)&&c.charCodeAt(1)===E&&(d=h>2&&f(c.charCodeAt(2))?3:2,n=d);let t=-1,s=!0;for(let r=h-1;r>=n;--r)if(f(c.charCodeAt(r))){if(!s){t=r;break}}else s=!1;if(t===-1){if(d===-1)return".";t=d}return c.slice(0,t)},basename(c,h){h!==void 0&&m(h,"ext"),m(c,"path");let d=0,n=-1,o=!0,t;if(c.length>=2&&y(c.charCodeAt(0))&&c.charCodeAt(1)===E&&(d=2),h!==void 0&&h.length>0&&h.length<=c.length){if(h===c)return"";let s=h.length-1,r=-1;for(t=c.length-1;t>=d;--t){const l=c.charCodeAt(t);if(f(l)){if(!o){d=t+1;break}}else r===-1&&(o=!1,r=t+1),s>=0&&(l===h.charCodeAt(s)?--s===-1&&(n=t):(s=-1,n=r))}return d===n?n=r:n===-1&&(n=c.length),c.slice(d,n)}for(t=c.length-1;t>=d;--t)if(f(c.charCodeAt(t))){if(!o){d=t+1;break}}else n===-1&&(o=!1,n=t+1);return n===-1?"":c.slice(d,n)},extname(c){m(c,"path");let h=0,d=-1,n=0,o=-1,t=!0,s=0;c.length>=2&&c.charCodeAt(1)===E&&y(c.charCodeAt(0))&&(h=n=2);for(let r=c.length-1;r>=h;--r){const l=c.charCodeAt(r);if(f(l)){if(!t){n=r+1;break}continue}o===-1&&(t=!1,o=r+1),l===I?d===-1?d=r:s!==1&&(s=1):d!==-1&&(s=-1)}return d===-1||o===-1||s===0||s===1&&d===o-1&&d===n+1?"":c.slice(d,o)},format:p.bind(null,"\\"),parse(c){m(c,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return h;const d=c.length;let n=0,o=c.charCodeAt(0);if(d===1)return f(o)?(h.root=h.dir=c,h):(h.base=h.name=c,h);if(f(o)){if(n=1,f(c.charCodeAt(1))){let P=2,A=P;for(;P<d&&!f(c.charCodeAt(P));)P++;if(P<d&&P!==A){for(A=P;P<d&&f(c.charCodeAt(P));)P++;if(P<d&&P!==A){for(A=P;P<d&&!f(c.charCodeAt(P));)P++;P===d?n=P:P!==A&&(n=P+1)}}}}else if(y(o)&&c.charCodeAt(1)===E){if(d<=2)return h.root=h.dir=c,h;if(n=2,f(c.charCodeAt(2))){if(d===3)return h.root=h.dir=c,h;n=3}}n>0&&(h.root=c.slice(0,n));let t=-1,s=n,r=-1,l=!0,a=c.length-1,g=0;for(;a>=n;--a){if(o=c.charCodeAt(a),f(o)){if(!l){s=a+1;break}continue}r===-1&&(l=!1,r=a+1),o===I?t===-1?t=a:g!==1&&(g=1):t!==-1&&(g=-1)}return r!==-1&&(t===-1||g===0||g===1&&t===r-1&&t===s+1?h.base=h.name=c.slice(s,r):(h.name=c.slice(s,t),h.base=c.slice(s,r),h.ext=c.slice(t,r))),s>0&&s!==n?h.dir=c.slice(0,s-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let h="",d=!1;for(let n=c.length-1;n>=-1&&!d;n--){const o=n>=0?c[n]:D.cwd();m(o,"path"),o.length!==0&&(h=`${o}/${h}`,d=o.charCodeAt(0)===C)}return h=u(h,!d,"/",v),d?`/${h}`:h.length>0?h:"."},normalize(c){if(m(c,"path"),c.length===0)return".";const h=c.charCodeAt(0)===C,d=c.charCodeAt(c.length-1)===C;return c=u(c,!h,"/",v),c.length===0?h?"/":d?"./":".":(d&&(c+="/"),h?`/${c}`:c)},isAbsolute(c){return m(c,"path"),c.length>0&&c.charCodeAt(0)===C},join(...c){if(c.length===0)return".";let h;for(let d=0;d<c.length;++d){const n=c[d];m(n,"path"),n.length>0&&(h===void 0?h=n:h+=`/${n}`)}return h===void 0?".":e.posix.normalize(h)},relative(c,h){if(m(c,"from"),m(h,"to"),c===h||(c=e.posix.resolve(c),h=e.posix.resolve(h),c===h))return"";const d=1,n=c.length,o=n-d,t=1,s=h.length-t,r=o<s?o:s;let l=-1,a=0;for(;a<r;a++){const P=c.charCodeAt(d+a);if(P!==h.charCodeAt(t+a))break;P===C&&(l=a)}if(a===r)if(s>r){if(h.charCodeAt(t+a)===C)return h.slice(t+a+1);if(a===0)return h.slice(t+a)}else o>r&&(c.charCodeAt(d+a)===C?l=a:a===0&&(l=0));let g="";for(a=d+l+1;a<=n;++a)(a===n||c.charCodeAt(a)===C)&&(g+=g.length===0?"..":"/..");return`${g}${h.slice(t+l)}`},toNamespacedPath(c){return c},dirname(c){if(m(c,"path"),c.length===0)return".";const h=c.charCodeAt(0)===C;let d=-1,n=!0;for(let o=c.length-1;o>=1;--o)if(c.charCodeAt(o)===C){if(!n){d=o;break}}else n=!1;return d===-1?h?"/":".":h&&d===1?"//":c.slice(0,d)},basename(c,h){h!==void 0&&m(h,"ext"),m(c,"path");let d=0,n=-1,o=!0,t;if(h!==void 0&&h.length>0&&h.length<=c.length){if(h===c)return"";let s=h.length-1,r=-1;for(t=c.length-1;t>=0;--t){const l=c.charCodeAt(t);if(l===C){if(!o){d=t+1;break}}else r===-1&&(o=!1,r=t+1),s>=0&&(l===h.charCodeAt(s)?--s===-1&&(n=t):(s=-1,n=r))}return d===n?n=r:n===-1&&(n=c.length),c.slice(d,n)}for(t=c.length-1;t>=0;--t)if(c.charCodeAt(t)===C){if(!o){d=t+1;break}}else n===-1&&(o=!1,n=t+1);return n===-1?"":c.slice(d,n)},extname(c){m(c,"path");let h=-1,d=0,n=-1,o=!0,t=0;for(let s=c.length-1;s>=0;--s){const r=c.charCodeAt(s);if(r===C){if(!o){d=s+1;break}continue}n===-1&&(o=!1,n=s+1),r===I?h===-1?h=s:t!==1&&(t=1):h!==-1&&(t=-1)}return h===-1||n===-1||t===0||t===1&&h===n-1&&h===d+1?"":c.slice(h,n)},format:p.bind(null,"/"),parse(c){m(c,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return h;const d=c.charCodeAt(0)===C;let n;d?(h.root="/",n=1):n=0;let o=-1,t=0,s=-1,r=!0,l=c.length-1,a=0;for(;l>=n;--l){const g=c.charCodeAt(l);if(g===C){if(!r){t=l+1;break}continue}s===-1&&(r=!1,s=l+1),g===I?o===-1?o=l:a!==1&&(a=1):o!==-1&&(a=-1)}if(s!==-1){const g=t===0&&d?1:t;o===-1||a===0||a===1&&o===s-1&&o===t+1?h.base=h.name=c.slice(g,s):(h.name=c.slice(g,o),h.base=c.slice(g,s),h.ext=c.slice(o,s))}return t>0?h.dir=c.slice(0,t-1):d&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(re[139],se([0,1,12]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(E){const b=(0,D.extname)(E),S=i[b.toLowerCase()];return S!==void 0?S:T(E)}e.getMediaOrTextMime=k;function T(E){const b=(0,D.extname)(E);return R[b.toLowerCase()]}e.getMediaMime=T;function I(E){for(const b in R)if(R[b]===E)return b}e.getExtensionForMimeType=I;const C=/^(.+)\/(.+?)(;.+)?$/;function w(E,b){const S=C.exec(E);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:b?void 0:E}e.normalizeMimeType=w}),define(re[85],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var i;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(i=e.Source||(e.Source={}));var R;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(I,...C){const w=C.reduce((S,m)=>(S[m]=!0,S),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(S=>!w[S]).forEach(S=>{for(let m=0;m<E.length;m++)if(S.search(E[m])!==-1){delete I[S];break}})}e.sanitizeProcessEnvironment=k;function T(I){!I||(delete I.DEBUG,D.isMacintosh&&delete I.DYLD_LIBRARY_PATH,D.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(re[140],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=D.globals.performance&&typeof D.globals.performance.now=="function";class R{static create(T=!0){return new R(T)}constructor(T){this._highResolution=i&&T,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(re[3],se([0,1,11,80,2,82,140]),function(Q,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,C=!1;var w;(function(l){l.None=()=>R.Disposable.None;function a(H){if(C){const{onDidAddListener:Z}=H,oe=f.create();let X=0;H.onDidAddListener=()=>{++X===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),oe.print()),Z?.()}}}function g(H,Z){return x(H,()=>{},0,void 0,void 0,Z)}l.defer=g;function P(H,Z=0,oe){return l.debounce(H,(X,ie)=>X?(X.push(ie),X):[ie],Z,void 0,void 0,oe)}l.accumulate=P;function A(H){return(Z,oe=null,X)=>{let ie=!1,ne;return ne=H(le=>{if(!ie)return ne?ne.dispose():ie=!0,Z.call(oe,le)},null,X),ie&&ne.dispose(),ne}}l.once=A;function V(H,Z,oe){return $((X,ie=null,ne)=>H(le=>X.call(ie,Z(le)),null,ne),oe)}l.map=V;function O(H,Z,oe){return $((X,ie=null,ne)=>H(le=>{Z(le),X.call(ie,le)},null,ne),oe)}l.forEach=O;function F(H,Z,oe){return $((X,ie=null,ne)=>H(le=>Z(le)&&X.call(ie,le),null,ne),oe)}l.filter=F;function N(H){return H}l.signal=N;function L(...H){return(Z,oe=null,X)=>(0,R.combinedDisposable)(...H.map(ie=>ie(ne=>Z.call(oe,ne),null,X)))}l.any=L;function U(H,Z,oe,X){let ie=oe;return V(H,ne=>(ie=Z(ie,ne),ie),X)}l.reduce=U;function $(H,Z){let oe;const X={onWillAddFirstListener(){oe=H(ie.fire,ie)},onDidRemoveLastListener(){oe?.dispose()}};Z||a(X);const ie=new y(X);return Z?.add(ie),ie.event}function x(H,Z,oe=100,X=!1,ie,ne){let le,ue,pe,we=0;const Ee={leakWarningThreshold:ie,onWillAddFirstListener(){le=H(Ae=>{we++,ue=Z(ue,Ae),X&&!pe&&(Ce.fire(ue),ue=void 0),clearTimeout(pe),pe=setTimeout(()=>{const Ne=ue;ue=void 0,pe=void 0,(!X||we>1)&&Ce.fire(Ne),we=0},oe)})},onDidRemoveLastListener(){le.dispose()}};ne||a(Ee);const Ce=new y(Ee);return ne?.add(Ce),Ce.event}l.debounce=x;function j(H,Z=(X,ie)=>X===ie,oe){let X=!0,ie;return F(H,ne=>{const le=X||!Z(ne,ie);return X=!1,ie=ne,le},oe)}l.latch=j;function B(H,Z,oe){return[l.filter(H,Z,oe),l.filter(H,X=>!Z(X),oe)]}l.split=B;function W(H,Z=!1,oe=[]){let X=oe.slice(),ie=H(ue=>{X?X.push(ue):le.fire(ue)});const ne=()=>{X?.forEach(ue=>le.fire(ue)),X=null},le=new y({onWillAddFirstListener(){ie||(ie=H(ue=>le.fire(ue)))},onDidAddFirstListener(){X&&(Z?setTimeout(ne):ne())},onDidRemoveLastListener(){ie&&ie.dispose(),ie=null}});return le.event}l.buffer=W;class q{constructor(Z){this.event=Z,this.disposables=new R.DisposableStore}map(Z){return new q(V(this.event,Z,this.disposables))}forEach(Z){return new q(O(this.event,Z,this.disposables))}filter(Z){return new q(F(this.event,Z,this.disposables))}reduce(Z,oe){return new q(U(this.event,Z,oe,this.disposables))}latch(){return new q(j(this.event,void 0,this.disposables))}debounce(Z,oe=100,X=!1,ie){return new q(x(this.event,Z,oe,X,ie,this.disposables))}on(Z,oe,X){return this.event(Z,oe,X)}once(Z,oe,X){return A(this.event)(Z,oe,X)}dispose(){this.disposables.dispose()}}function Y(H){return new q(H)}l.chain=Y;function ee(H,Z,oe=X=>X){const X=(...ue)=>le.fire(oe(...ue)),ie=()=>H.on(Z,X),ne=()=>H.removeListener(Z,X),le=new y({onWillAddFirstListener:ie,onDidRemoveLastListener:ne});return le.event}l.fromNodeEventEmitter=ee;function ce(H,Z,oe=X=>X){const X=(...ue)=>le.fire(oe(...ue)),ie=()=>H.addEventListener(Z,X),ne=()=>H.removeEventListener(Z,X),le=new y({onWillAddFirstListener:ie,onDidRemoveLastListener:ne});return le.event}l.fromDOMEventEmitter=ce;function J(H){return new Promise(Z=>A(H)(Z))}l.toPromise=J;function z(H,Z){return Z(void 0),H(oe=>Z(oe))}l.runAndSubscribe=z;function _(H,Z){let oe=null;function X(ne){oe?.dispose(),oe=new R.DisposableStore,Z(ne,oe)}X(void 0);const ie=H(ne=>X(ne));return(0,R.toDisposable)(()=>{ie.dispose(),oe?.dispose()})}l.runAndSubscribeWithStore=_;class M{constructor(Z,oe){this.obs=Z,this._counter=0,this._hasChanged=!1;const X={onWillAddFirstListener:()=>{Z.addObserver(this)},onDidRemoveLastListener:()=>{Z.removeObserver(this)}};oe||a(X),this.emitter=new y(X),oe&&oe.add(this.emitter)}beginUpdate(Z){this._counter++}handleChange(Z,oe){this._hasChanged=!0}endUpdate(Z){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function G(H,Z){return new M(H,Z).emitter.event}l.fromObservable=G})(w=e.Event||(e.Event={}));class E{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${E._idPool++}`,E.all.add(this)}start(a){this._stopWatch=new T.StopWatch(!0),this.listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=E,E.all=new Set,E._idPool=0;let b=-1;function S(l){const a=b;return b=l,{dispose(){b=a}}}e.setGlobalLeakWarningThreshold=S;class m{constructor(a,g=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=g,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(a,g){const P=this.threshold;if(P<=0||g<P)return;this._stacks||(this._stacks=new Map);const A=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,A+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=P*.5;let V,O=0;for(const[F,N]of this._stacks)(!V||O<N)&&(V=F,O=N);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${O}):`),console.warn(V)}return()=>{const V=this._stacks.get(a.value)||0;this._stacks.set(a.value,V-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(a,g,P){this.callback=a,this.callbackThis=g,this.stack=P,this.subscription=new R.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class y{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=b>0||this._options?.leakWarningThreshold?new m(this._options?.leakWarningThreshold??b):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(I){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const g of a)g.subscription.isset()&&(g.subscription.unset(),g.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,g,P)=>{if(this._listeners||(this._listeners=new k.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),R.Disposable.None;const A=this._listeners.isEmpty();A&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let V,O;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(O=f.create(),V=this._leakageMon.check(O,this._listeners.size+1)),I&&(O=O??f.create());const F=new v(a,g,O),N=this._listeners.push(F);A&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,a,g);const L=F.subscription.set(()=>{V?.(),this._disposed||(N(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return P instanceof R.DisposableStore?P.add(L):Array.isArray(P)&&P.push(L),L}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new p);for(const g of this._listeners)this._deliveryQueue.push(this,g,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=y;class u{constructor(){this._queue=new k.LinkedList}get size(){return this._queue.size}push(a,g,P){this._queue.push(new c(a,g,P))}clear(a){const g=new k.LinkedList;for(const P of this._queue)P.emitter!==a&&g.push(P);this._queue=g}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(g){(0,D.onUnexpectedError)(g)}}}}e.EventDeliveryQueue=u;class p extends u{clear(a){this._queue.clear()}}class c{constructor(a,g,P){this.emitter=a,this.listener=g,this.event=P}}class h extends y{async fireAsync(a,g,P){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const A of this._listeners)this._asyncDeliveryQueue.push([A,a]);for(;this._asyncDeliveryQueue.size>0&&!g.isCancellationRequested;){const[A,V]=this._asyncDeliveryQueue.shift(),O=[],F={...V,token:g,waitUntil:N=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");P&&(N=P(N,A.callback)),O.push(N)}};try{A.invoke(F)}catch(N){(0,D.onUnexpectedError)(N);continue}Object.freeze(O),await Promise.allSettled(O).then(N=>{for(const L of N)L.status==="rejected"&&(0,D.onUnexpectedError)(L.reason)})}}}}e.AsyncEmitter=h;class d extends y{constructor(a){super(a),this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=d;class n extends d{constructor(a){super(a),this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=n;class o extends y{constructor(a){super(a),this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){!this.hasListeners()||(this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(g=>super.fire(g)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const g={event:a,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const P=()=>{this.hasListeners&&this.unhook(g);const A=this.events.indexOf(g);this.events.splice(A,1)};return(0,R.toDisposable)((0,i.once)(P))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(g=>this.emitter.fire(g))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class s{constructor(){this.buffers=[]}wrapEvent(a){return(g,P,A)=>a(V=>{const O=this.buffers[this.buffers.length-1];O?O.push(()=>g.call(P,V)):g.call(P,V)},void 0,A)}bufferEvents(a){const g=[];this.buffers.push(g);const P=a();return this.buffers.pop(),g.forEach(A=>A()),P}}e.EventBufferer=s;class r{constructor(){this.listening=!1,this.inputEvent=w.None,this.inputEventListener=R.Disposable.None,this.emitter=new y({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=r}),define(re[22],se([0,1,3]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(I,C){const w=setTimeout(I.bind(C),0);return{dispose(){clearTimeout(w)}}});var R;(function(I){function C(w){return w===I.None||w===I.Cancelled||w instanceof k?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}I.isCancellationToken=C,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(R=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(C){this._token=void 0,this._parentListener=void 0,this._parentListener=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=R.Cancelled}dispose(C=!1){C&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=T}),define(re[141],se([0,1,22]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class i{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new D.CancellationTokenSource,C=this.task(I.token);return this.result={promise:C,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=i;class R{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const C=JSON.stringify(I);return this.lastArgKey!==C&&(this.lastArgKey=C,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=R;class k{get cachedValues(){return this._map}constructor(I){this.fn=I,this._map=new Map}get(I){if(this._map.has(I))return this._map.get(I);const C=this.fn(I);return this._map.set(I,C),C}}e.CachedFunction=k}),define(re[86],se([0,1,3,2]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const R=T=>({onDidChange:D.Event.None,value:T});e.staticObservableValue=R;class k extends i.Disposable{get value(){return this._value}set value(I){I!==this._value&&(this._value=I,this.changeEmitter.fire(I))}constructor(I){super(),this._value=I,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=k}),define(re[27],se([0,1,141,128]),function(Q,e,D,i){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function k(te){return!te||typeof te!="string"?!0:te.trim().length===0}e.isFalsyOrWhitespace=k;const T=/{(\d+)}/g;function I(te,...he){return he.length===0?te:te.replace(T,function(de,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=he.length?de:he[Se]})}e.format=I;const C=/{([^}]+)}/g;function w(te,he){return te.replace(C,(de,me)=>he[me]??de)}e.format2=w;function E(te){return te.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=E;function b(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function S(te,he){let de=0;const me=he.charCodeAt(0);for(let Se=te.length-1;Se>=0;Se--)te.charCodeAt(Se)===me&&de++;return de}e.count=S;function m(te,he,de="\u2026"){return te.length<=he?te:`${te.substr(0,he)}${de}`}e.truncate=m;function f(te,he=" "){const de=v(te,he);return y(de,he)}e.trim=f;function v(te,he){if(!te||!he)return te;const de=he.length;if(de===0||te.length===0)return te;let me=0;for(;te.indexOf(he,me)===me;)me=me+de;return te.substring(me)}e.ltrim=v;function y(te,he){if(!te||!he)return te;const de=he.length,me=te.length;if(de===0||me===0)return te;let Se=me,Pe=-1;for(;Pe=te.lastIndexOf(he,Se-1),!(Pe===-1||Pe+de!==Se);){if(Pe===0)return"";Se=Pe}return te.substring(0,Se)}e.rtrim=y;function u(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function p(te){return te.replace(/\*/g,"")}e.stripWildcards=p;function c(te,he,de={}){if(!te)throw new Error("Cannot create regex from empty string");he||(te=b(te)),de.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let me="";return de.global&&(me+="g"),de.matchCase||(me+="i"),de.multiline&&(me+="m"),de.unicode&&(me+="u"),new RegExp(te,me)}e.createRegExp=c;function h(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function d(te){return!!te.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=d;function n(te){return(te.global?"g":"")+(te.ignoreCase?"i":"")+(te.multiline?"m":"")+(te.unicode?"u":"")}e.regExpFlags=n;function o(te){return te.split(/\r\n|\r|\n/)}e.splitLines=o;function t(te){for(let he=0,de=te.length;he<de;he++){const me=te.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function s(te,he=0,de=te.length){for(let me=he;me<de;me++){const Se=te.charCodeAt(me);if(Se!==32&&Se!==9)return te.substring(he,me)}return te.substring(he,de)}e.getLeadingWhitespace=s;function r(te,he=te.length-1){for(let de=he;de>=0;de--){const me=te.charCodeAt(de);if(me!==32&&me!==9)return de}return-1}e.lastNonWhitespaceIndex=r;function l(te,he,de){const me=[];let Se=0;for(const Pe of te.matchAll(he)){if(me.push(te.slice(Se,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");Se=Pe.index+Pe[0].length,me.push(de(Pe[0],...Pe.slice(1),Pe.index,te,Pe.groups))}return me.push(te.slice(Se)),Promise.all(me).then(Pe=>Pe.join(""))}e.replaceAsync=l;function a(te,he){return te<he?-1:te>he?1:0}e.compare=a;function g(te,he,de=0,me=te.length,Se=0,Pe=he.length){for(;de<me&&Se<Pe;de++,Se++){const $e=te.charCodeAt(de),Te=he.charCodeAt(Se);if($e<Te)return-1;if($e>Te)return 1}const De=me-de,Ve=Pe-Se;return De<Ve?-1:De>Ve?1:0}e.compareSubstring=g;function P(te,he){return A(te,he,0,te.length,0,he.length)}e.compareIgnoreCase=P;function A(te,he,de=0,me=te.length,Se=0,Pe=he.length){for(;de<me&&Se<Pe;de++,Se++){let $e=te.charCodeAt(de),Te=he.charCodeAt(Se);if($e===Te)continue;if($e>=128||Te>=128)return g(te.toLowerCase(),he.toLowerCase(),de,me,Se,Pe);O($e)&&($e-=32),O(Te)&&(Te-=32);const je=$e-Te;if(je!==0)return je}const De=me-de,Ve=Pe-Se;return De<Ve?-1:De>Ve?1:0}e.compareSubstringIgnoreCase=A;function V(te){return te>=48&&te<=57}e.isAsciiDigit=V;function O(te){return te>=97&&te<=122}e.isLowerAsciiLetter=O;function F(te){return te>=65&&te<=90}e.isUpperAsciiLetter=F;function N(te,he){return te.length===he.length&&A(te,he)===0}e.equalsIgnoreCase=N;function L(te,he){const de=he.length;return he.length>te.length?!1:A(te,he,0,de)===0}e.startsWithIgnoreCase=L;function U(te,he){const de=Math.min(te.length,he.length);let me;for(me=0;me<de;me++)if(te.charCodeAt(me)!==he.charCodeAt(me))return me;return de}e.commonPrefixLength=U;function $(te,he){const de=Math.min(te.length,he.length);let me;const Se=te.length-1,Pe=he.length-1;for(me=0;me<de;me++)if(te.charCodeAt(Se-me)!==he.charCodeAt(Pe-me))return me;return de}e.commonSuffixLength=$;function x(te){return 55296<=te&&te<=56319}e.isHighSurrogate=x;function j(te){return 56320<=te&&te<=57343}e.isLowSurrogate=j;function B(te,he){return(te-55296<<10)+(he-56320)+65536}e.computeCodePoint=B;function W(te,he,de){const me=te.charCodeAt(de);if(x(me)&&de+1<he){const Se=te.charCodeAt(de+1);if(j(Se))return B(me,Se)}return me}e.getNextCodePoint=W;function q(te,he){const de=te.charCodeAt(he-1);if(j(de)&&he>1){const me=te.charCodeAt(he-2);if(x(me))return B(me,de)}return de}class Y{get offset(){return this._offset}constructor(he,de=0){this._str=he,this._len=he.length,this._offset=de}setOffset(he){this._offset=he}prevCodePoint(){const he=q(this._str,this._offset);return this._offset-=he>=65536?2:1,he}nextCodePoint(){const he=W(this._str,this._len,this._offset);return this._offset+=he>=65536?2:1,he}eol(){return this._offset>=this._len}}e.CodePointIterator=Y;class ee{get offset(){return this._iterator.offset}constructor(he,de=0){this._iterator=new Y(he,de)}nextGraphemeLength(){const he=Le.getInstance(),de=this._iterator,me=de.offset;let Se=he.getGraphemeBreakType(de.nextCodePoint());for(;!de.eol();){const Pe=de.offset,De=he.getGraphemeBreakType(de.nextCodePoint());if(be(Se,De)){de.setOffset(Pe);break}Se=De}return de.offset-me}prevGraphemeLength(){const he=Le.getInstance(),de=this._iterator,me=de.offset;let Se=he.getGraphemeBreakType(de.prevCodePoint());for(;de.offset>0;){const Pe=de.offset,De=he.getGraphemeBreakType(de.prevCodePoint());if(be(De,Se)){de.setOffset(Pe);break}Se=De}return me-de.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ee;function ce(te,he){return new ee(te,he).nextGraphemeLength()}e.nextCharLength=ce;function J(te,he){return new ee(te,he).prevGraphemeLength()}e.prevCharLength=J;function z(te,he){he>0&&j(te.charCodeAt(he))&&he--;const de=he+ce(te,he);return[de-J(te,de),de]}e.getCharContainingOffset=z;function _(te){const he=new ee(te);let de=0;for(;!he.eol();)de++,he.nextGraphemeLength();return de}e.charCount=_;let M;function G(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function H(te){return M||(M=G()),M.test(te)}e.containsRTL=H;const Z=/^[\t\n\r\x20-\x7E]*$/;function oe(te){return Z.test(te)}e.isBasicASCII=oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(te){return e.UNUSUAL_LINE_TERMINATORS.test(te)}e.containsUnusualLineTerminators=X;function ie(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}e.isFullWidthCharacter=ie;function ne(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}e.isEmojiImprecise=ne;function le(te,he){if(te.length<he)return te;const de=/\b/g;let me=0;for(;de.test(te)&&!(te.length-de.lastIndex<he);)me=de.lastIndex,de.lastIndex+=1;return te.substring(me).replace(/^\s/,"")}e.lcut=le;const ue=/\x1B\x5B[12]?K/g,pe=/\x1b\[\d+m/g,we=/\x1b\[0?m/g;function Ee(te){return te&&(te=te.replace(ue,""),te=te.replace(pe,""),te=te.replace(we,"")),te}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Ae(te){return Ce(te)?te.substr(1):te}e.stripUTF8BOM=Ae;function Ne(te,he){if(!te||!he||te.length<he.length)return!1;const de=he.length,me=te.toLowerCase();let Se=0,Pe=-1;for(;Se<de;){const De=me.indexOf(he[Se],Pe+1);if(De<0)return!1;Pe=De,Se++}return!0}e.fuzzyContains=Ne;function Ge(te,he=!1){return te?(he&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}e.containsUppercaseCharacter=Ge;function We(te){return te.charAt(0).toUpperCase()+te.slice(1)}e.uppercaseFirstLetter=We;function ae(te,he=1){if(he===0)return"";let de=-1;do de=te.indexOf(`
`,de+1),he--;while(he>0&&de>=0);return de===-1?te:(te[de-1]==="\r"&&de--,te.substr(0,de))}e.getNLines=ae;function fe(te){return te=te%(2*26),te<26?String.fromCharCode(97+te):String.fromCharCode(65+te-26)}e.singleLetterHash=fe;function ge(te){return Le.getInstance().getGraphemeBreakType(te)}e.getGraphemeBreakType=ge;function be(te,he){return te===0?he!==5&&he!==7:te===2&&he===3?!1:te===4||te===2||te===3||he===4||he===2||he===3?!0:!(te===8&&(he===8||he===9||he===11||he===12)||(te===11||te===9)&&(he===9||he===10)||(te===12||te===10)&&he===10||he===5||he===13||he===7||te===1||te===13&&he===14||te===6&&he===6)}var Ie;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Le{static getInstance(){return Le._INSTANCE||(Le._INSTANCE=new Le),Le._INSTANCE}constructor(){this._data=Re()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const de=this._data,me=de.length/3;let Se=1;for(;Se<=me;)if(he<de[3*Se])Se=2*Se;else if(he>de[3*Se+1])Se=2*Se+1;else return de[3*Se+2];return 0}}Le._INSTANCE=null;function Re(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Fe(te,he){if(te===0)return 0;const de=_e(te,he);if(de!==void 0)return de;const me=new Y(he,te);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=Fe;function _e(te,he){const de=new Y(he,te);let me=de.prevCodePoint();for(;Me(me)||me===65039||me===8419;){if(de.offset===0)return;me=de.prevCodePoint()}if(!ne(me))return;let Se=de.offset;return Se>0&&de.prevCodePoint()===8205&&(Se=de.offset),Se}function Me(te){return 127995<=te&&te<=127999}var ze;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(he){return ke.cache.get(Array.from(he))}static getLocales(){return ke._locales.getValue()}constructor(he){this.confusableDictionary=he}isAmbiguous(he){return this.confusableDictionary.has(he)}getPrimaryConfusable(he){return this.confusableDictionary.get(he)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ke,R=ke,ke.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.cache=new D.LRUCachedFunction(te=>{function he(Te){const je=new Map;for(let xe=0;xe<Te.length;xe+=2)je.set(Te[xe],Te[xe+1]);return je}function de(Te,je){const xe=new Map(Te);for(const[et,ot]of je)xe.set(et,ot);return xe}function me(Te,je){if(!Te)return je;const xe=new Map;for(const[et,ot]of Te)je.has(et)&&xe.set(et,ot);return xe}const Se=R.ambiguousCharacterData.getValue();let Pe=te.filter(Te=>!Te.startsWith("_")&&Te in Se);Pe.length===0&&(Pe=["_default"]);let De;for(const Te of Pe){const je=he(Se[Te]);De=me(De,je)}const Ve=he(Se._common),$e=de(Ve,De);return new ke($e)}),ke._locales=new i.Lazy(()=>Object.keys(ke.ambiguousCharacterData.getValue()).filter(te=>!te.startsWith("_")));class Oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Oe.getRawData())),this._data}static isInvisibleCharacter(he){return Oe.getData().has(he)}static get codePoints(){return Oe.getData()}}e.InvisibleCharacters=Oe,Oe._data=void 0}),define(re[48],se([0,1,12,5,27,15]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(r){return r===47||r===92}e.isPathSeparator=T;function I(r){return r.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=I;function C(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=C;function w(r,l=D.posix.sep){if(!r)return"";const a=r.length,g=r.charCodeAt(0);if(T(g)){if(T(r.charCodeAt(1))&&!T(r.charCodeAt(2))){let A=3;const V=A;for(;A<a&&!T(r.charCodeAt(A));A++);if(V!==A&&!T(r.charCodeAt(A+1))){for(A+=1;A<a;A++)if(T(r.charCodeAt(A)))return r.slice(0,A+1).replace(/[\\/]/g,l)}}return l}else if(u(g)&&r.charCodeAt(1)===58)return T(r.charCodeAt(2))?r.slice(0,2)+l:r.slice(0,2);let P=r.indexOf("://");if(P!==-1){for(P+=3;P<a;P++)if(T(r.charCodeAt(P)))return r.slice(0,P+1)}return""}e.getRoot=w;function E(r){if(!i.isWindows||!r||r.length<5)return!1;let l=r.charCodeAt(0);if(l!==92||(l=r.charCodeAt(1),l!==92))return!1;let a=2;const g=a;for(;a<r.length&&(l=r.charCodeAt(a),l!==92);a++);return!(g===a||(l=r.charCodeAt(a+1),isNaN(l)||l===92))}e.isUNC=E;const b=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,l=i.isWindows){const a=l?b:S;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||l&&m.test(r)||r==="."||r===".."||l&&r[r.length-1]==="."||l&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function v(r,l,a){const g=r===l;return!a||g?g:!r||!l?!1:(0,R.equalsIgnoreCase)(r,l)}e.isEqual=v;function y(r,l,a,g=D.sep){if(r===l)return!0;if(!r||!l||l.length>r.length)return!1;if(a){if(!(0,R.startsWithIgnoreCase)(r,l))return!1;if(l.length===r.length)return!0;let A=l.length;return l.charAt(l.length-1)===g&&A--,r.charAt(A)===g}return l.charAt(l.length-1)!==g&&(l+=g),r.indexOf(l)===0}e.isEqualOrParent=y;function u(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=u;function p(r,l){return i.isWindows&&r.endsWith(":")&&(r+=D.sep),(0,D.isAbsolute)(r)||(r=(0,D.join)(l,r)),r=(0,D.normalize)(r),i.isWindows?(r=(0,R.rtrim)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,R.rtrim)(r,D.sep),r||(r=D.sep)),r}e.sanitizeFilePath=p;function c(r){const l=(0,D.normalize)(r);return i.isWindows?r.length>3?!1:h(l)&&(r.length===2||l.charCodeAt(2)===92):l===D.posix.sep}e.isRootOrDriveLetter=c;function h(r,l=i.isWindows){return l?u(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function d(r){return h(r)?r[0]:void 0}e.getDriveLetter=d;function n(r,l,a){return l.length>r.length?-1:r===l?0:(a&&(r=r.toLowerCase(),l=l.toLowerCase()),r.indexOf(l))}e.indexOfPath=n;function o(r){const l=r.split(":");let a,g,P;for(const A of l){const V=Number(A);(0,k.isNumber)(V)?g===void 0?g=V:P===void 0&&(P=V):a=a?[a,A].join(":"):A}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:g!==void 0?g:void 0,column:P!==void 0?P:g!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(r,l,a=8){let g="";for(let A=0;A<a;A++)g+=t.charAt(Math.floor(Math.random()*t.length));let P;return l?P=`${l}-${g}`:P=g,r?(0,D.join)(r,P):P}e.randomPath=s}),define(re[66],se([0,1,27]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(u){return R(u,0)}e.hash=i;function R(u,p){switch(typeof u){case"object":return u===null?k(349,p):Array.isArray(u)?C(u,p):w(u,p);case"string":return I(u,p);case"boolean":return T(u,p);case"number":return k(u,p);case"undefined":return k(937,p);default:return k(617,p)}}e.doHash=R;function k(u,p){return(p<<5)-p+u|0}e.numberHash=k;function T(u,p){return k(u?433:863,p)}function I(u,p){p=k(149417,p);for(let c=0,h=u.length;c<h;c++)p=k(u.charCodeAt(c),p);return p}e.stringHash=I;function C(u,p){return p=k(104579,p),u.reduce((c,h)=>R(h,c),p)}function w(u,p){return p=k(181387,p),Object.keys(u).sort().reduce((c,h)=>(c=I(h,c),R(u[h],c)),p)}class E{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=R(p,this._value),this._value}}e.Hasher=E;var b;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function S(u,p,c=32){const h=c-p,d=~((1<<h)-1);return(u<<p|(d&u)>>>h)>>>0}function m(u,p=0,c=u.byteLength,h=0){for(let d=0;d<c;d++)u[p+d]=h}function f(u,p,c="0"){for(;u.length<p;)u=c+u;return u}function v(u,p=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(c=>c.toString(16).padStart(2,"0")).join(""):f((u>>>0).toString(16),p/4)}e.toHexString=v;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const c=p.length;if(c===0)return;const h=this._buff;let d=this._buffLen,n=this._leftoverHighSurrogate,o,t;for(n!==0?(o=n,t=-1,n=0):(o=p.charCodeAt(0),t=0);;){let s=o;if(D.isHighSurrogate(o))if(t+1<c){const r=p.charCodeAt(t+1);D.isLowSurrogate(r)?(t++,s=D.computeCodePoint(o,r)):s=65533}else{n=o;break}else D.isLowSurrogate(o)&&(s=65533);if(d=this._push(h,d,s),t++,t<c)o=p.charCodeAt(t);else break}this._buffLen=d,this._leftoverHighSurrogate=n}_push(p,c,h){return h<128?p[c++]=h:h<2048?(p[c++]=192|(h&1984)>>>6,p[c++]=128|(h&63)>>>0):h<65536?(p[c++]=224|(h&61440)>>>12,p[c++]=128|(h&4032)>>>6,p[c++]=128|(h&63)>>>0):(p[c++]=240|(h&1835008)>>>18,p[c++]=128|(h&258048)>>>12,p[c++]=128|(h&4032)>>>6,p[c++]=128|(h&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=y._bigBlock32,c=this._buffDV;for(let a=0;a<64;a+=4)p.setUint32(a,c.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)p.setUint32(a,S(p.getUint32(a-12,!1)^p.getUint32(a-32,!1)^p.getUint32(a-56,!1)^p.getUint32(a-64,!1),1),!1);let h=this._h0,d=this._h1,n=this._h2,o=this._h3,t=this._h4,s,r,l;for(let a=0;a<80;a++)a<20?(s=d&n|~d&o,r=1518500249):a<40?(s=d^n^o,r=1859775393):a<60?(s=d&n|d&o|n&o,r=2400959708):(s=d^n^o,r=3395469782),l=S(h,5)+s+t+r+p.getUint32(a*4,!1)&4294967295,t=o,o=n,n=S(d,30),d=h,h=l;this._h0=this._h0+h&4294967295,this._h1=this._h1+d&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(re[87],se([0,1,27]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(i||(i={})),function(R){const k="error",T="warning",I="warn",C="info",w="ignore";function E(S){return S?D.equalsIgnoreCase(k,S)?R.Error:D.equalsIgnoreCase(T,S)||D.equalsIgnoreCase(I,S)?R.Warning:D.equalsIgnoreCase(C,S)?R.Info:R.Ignore:R.Ignore}R.fromValue=E;function b(S){switch(S){case R.Error:return k;case R.Warning:return T;case R.Info:return C;default:return w}}R.toString=b}(i||(i={})),e.default=i}),define(re[49],se([0,1,19,27]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class R{constructor(){this._value="",this._pos=0}reset(m){return this._value=m,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(m){const f=m.charCodeAt(0),v=this._value.charCodeAt(this._pos);return f-v}value(){return this._value[this._pos]}}e.StringIterator=R;class k{constructor(m=!0){this._caseSensitive=m}reset(m){return this._value=m,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let m=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(m)this._from++;else break;else m=!1;return this}cmp(m){return this._caseSensitive?(0,i.compareSubstring)(m,this._value,0,m.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(m,this._value,0,m.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class T{constructor(m=!0,f=!0){this._splitOnBackslash=m,this._caseSensitive=f}reset(m){this._from=0,this._to=0,this._value=m,this._valueLen=m.length;for(let f=m.length-1;f>=0;f--,this._valueLen--){const v=this._value.charCodeAt(f);if(!(v===47||this._splitOnBackslash&&v===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let m=!0;for(;this._to<this._valueLen;this._to++){const f=this._value.charCodeAt(this._to);if(f===47||this._splitOnBackslash&&f===92)if(m)this._from++;else break;else m=!1}return this}cmp(m){return this._caseSensitive?(0,i.compareSubstring)(m,this._value,0,m.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(m,this._value,0,m.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var I;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(I||(I={}));class C{constructor(m,f){this._ignorePathCasing=m,this._ignoreQueryAndFragment=f,this._states=[],this._stateIdx=0}reset(m){return this._value=m,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(m)),this._pathIterator.reset(m.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(m)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(m){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(m,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(m,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(m);if(this._states[this._stateIdx]===4)return(0,i.compare)(m,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(m,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=C;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const m=this.right;return this.right=m.left,m.left=this,this.updateHeight(),m.updateHeight(),m}rotateRight(){const m=this.left;return this.left=m.right,m.right=this,this.updateHeight(),m.updateHeight(),m}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(E||(E={}));class b{static forUris(m=()=>!1,f=()=>!1){return new b(new C(m,f))}static forPaths(m=!1){return new b(new T(void 0,!m))}static forStrings(){return new b(new R)}static forConfigKeys(){return new b(new k)}constructor(m){this._iter=m}clear(){this._root=void 0}fill(m,f){if(f){const v=f.slice(0);(0,D.shuffle)(v);for(const y of v)this.set(y,m)}else{const v=m.slice(0);(0,D.shuffle)(v);for(const y of v)this.set(y[0],y[1])}}set(m,f){const v=this._iter.reset(m);let y;this._root||(this._root=new w,this._root.segment=v.value());const u=[];for(y=this._root;;){const c=v.cmp(y.segment);if(c>0)y.left||(y.left=new w,y.left.segment=v.value()),u.push([-1,y]),y=y.left;else if(c<0)y.right||(y.right=new w,y.right.segment=v.value()),u.push([1,y]),y=y.right;else if(v.hasNext())v.next(),y.mid||(y.mid=new w,y.mid.segment=v.value()),u.push([0,y]),y=y.mid;else break}const p=y.value;y.value=f,y.key=m;for(let c=u.length-1;c>=0;c--){const h=u[c][1];h.updateHeight();const d=h.balanceFactor();if(d<-1||d>1){const n=u[c][0],o=u[c+1][0];if(n===1&&o===1)u[c][1]=h.rotateLeft();else if(n===-1&&o===-1)u[c][1]=h.rotateRight();else if(n===1&&o===-1)h.right=u[c+1][1]=u[c+1][1].rotateRight(),u[c][1]=h.rotateLeft();else if(n===-1&&o===1)h.left=u[c+1][1]=u[c+1][1].rotateLeft(),u[c][1]=h.rotateRight();else throw new Error;if(c>0)switch(u[c-1][0]){case-1:u[c-1][1].left=u[c][1];break;case 1:u[c-1][1].right=u[c][1];break;case 0:u[c-1][1].mid=u[c][1];break}else this._root=u[0][1]}}return p}get(m){return this._getNode(m)?.value}_getNode(m){const f=this._iter.reset(m);let v=this._root;for(;v;){const y=f.cmp(v.segment);if(y>0)v=v.left;else if(y<0)v=v.right;else if(f.hasNext())f.next(),v=v.mid;else break}return v}has(m){const f=this._getNode(m);return!(f?.value===void 0&&f?.mid===void 0)}delete(m){return this._delete(m,!1)}deleteSuperstr(m){return this._delete(m,!0)}_delete(m,f){const v=this._iter.reset(m),y=[];let u=this._root;for(;u;){const p=v.cmp(u.segment);if(p>0)y.push([-1,u]),u=u.left;else if(p<0)y.push([1,u]),u=u.right;else if(v.hasNext())v.next(),y.push([0,u]),u=u.mid;else break}if(!!u){if(f?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const p=this._min(u.right);if(p.key){const{key:c,value:h,segment:d}=p;this._delete(p.key,!1),u.key=c,u.value=h,u.segment=d}}else{const p=u.left??u.right;if(y.length>0){const[c,h]=y[y.length-1];switch(c){case-1:h.left=p;break;case 0:h.mid=p;break;case 1:h.right=p;break}}else this._root=p}for(let p=y.length-1;p>=0;p--){const c=y[p][1];c.updateHeight();const h=c.balanceFactor();if(h>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),y[p][1]=c.rotateLeft()):h<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),y[p][1]=c.rotateRight()),p>0)switch(y[p-1][0]){case-1:y[p-1][1].left=y[p][1];break;case 1:y[p-1][1].right=y[p][1];break;case 0:y[p-1][1].mid=y[p][1];break}else this._root=y[0][1]}}}_min(m){for(;m.left;)m=m.left;return m}findSubstr(m){const f=this._iter.reset(m);let v=this._root,y;for(;v;){const u=f.cmp(v.segment);if(u>0)v=v.left;else if(u<0)v=v.right;else if(f.hasNext())f.next(),y=v.value||y,v=v.mid;else break}return v&&v.value||y}findSuperstr(m){const f=this._iter.reset(m);let v=this._root;for(;v;){const y=f.cmp(v.segment);if(y>0)v=v.left;else if(y<0)v=v.right;else if(f.hasNext())f.next(),v=v.mid;else return v.mid?this._entries(v.mid):void 0}}forEach(m){for(const[f,v]of this)m(v,f)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(m){const f=[];return this._dfsEntries(m,f),f[Symbol.iterator]()}_dfsEntries(m,f){!m||(m.left&&this._dfsEntries(m.left,f),m.value&&f.push([m.key,m.value]),m.mid&&this._dfsEntries(m.mid,f),m.right&&this._dfsEntries(m.right,f))}_isBalanced(){const m=f=>{if(!f)return!0;const v=f.balanceFactor();return v<-1||v>1?!1:m(f.left)&&m(f.right)};return m(this._root)}}e.TernarySearchTree=b}),define(re[8],se([0,1,12,5]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,k=/^\//,T=/^\/\//;function I(t,s){if(!t.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!R.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!k.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(t,s){return!t&&!s?"file":t}function w(t,s){switch(t){case"https":case"http":case"file":s?s[0]!==b&&(s=b+s):s=b;break}return s}const E="",b="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(s){return s instanceof m?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,r,l,a,g,P=!1){typeof s=="object"?(this.scheme=s.scheme||E,this.authority=s.authority||E,this.path=s.path||E,this.query=s.query||E,this.fragment=s.fragment||E):(this.scheme=C(s,P),this.authority=r||E,this.path=w(this.scheme,l||E),this.query=a||E,this.fragment=g||E,I(this,P))}get fsPath(){return c(this,!1)}with(s){if(!s)return this;let{scheme:r,authority:l,path:a,query:g,fragment:P}=s;return r===void 0?r=this.scheme:r===null&&(r=E),l===void 0?l=this.authority:l===null&&(l=E),a===void 0?a=this.path:a===null&&(a=E),g===void 0?g=this.query:g===null&&(g=E),P===void 0?P=this.fragment:P===null&&(P=E),r===this.scheme&&l===this.authority&&a===this.path&&g===this.query&&P===this.fragment?this:new v(r,l,a,g,P)}static parse(s,r=!1){const l=S.exec(s);return l?new v(l[2]||E,o(l[4]||E),o(l[5]||E),o(l[7]||E),o(l[9]||E),r):new v(E,E,E,E,E)}static file(s){let r=E;if(i.isWindows&&(s=s.replace(/\\/g,b)),s[0]===b&&s[1]===b){const l=s.indexOf(b,2);l===-1?(r=s.substring(2),s=b):(r=s.substring(2,l),s=s.substring(l)||b)}return new v("file",r,s,E,E)}static from(s){const r=new v(s.scheme,s.authority,s.path,s.query,s.fragment);return I(r,!0),r}static joinPath(s,...r){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return i.isWindows&&s.scheme==="file"?l=m.file(D.win32.join(c(s,!0),...r)).path:l=D.posix.join(s.path,...r),s.with({path:l})}toString(s=!1){return h(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof m)return s;{const r=new v(s);return r._formatted=s.external,r._fsPath=s._sep===f?s.fsPath:null,r}}else return s}}e.URI=m;const f=i.isWindows?1:void 0;class v extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(s=!1){return s?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=f),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(t,s){let r,l=-1;for(let a=0;a<t.length;a++){const g=t.charCodeAt(a);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||s&&g===47)l!==-1&&(r+=encodeURIComponent(t.substring(l,a)),l=-1),r!==void 0&&(r+=t.charAt(a));else{r===void 0&&(r=t.substr(0,a));const P=y[g];P!==void 0?(l!==-1&&(r+=encodeURIComponent(t.substring(l,a)),l=-1),r+=P):l===-1&&(l=a)}}return l!==-1&&(r+=encodeURIComponent(t.substring(l))),r!==void 0?r:t}function p(t){let s;for(let r=0;r<t.length;r++){const l=t.charCodeAt(r);l===35||l===63?(s===void 0&&(s=t.substr(0,r)),s+=y[l]):s!==void 0&&(s+=t[r])}return s!==void 0?s:t}function c(t,s){let r;return t.authority&&t.path.length>1&&t.scheme==="file"?r=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?s?r=t.path.substr(1):r=t.path[1].toLowerCase()+t.path.substr(2):r=t.path,i.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=c;function h(t,s){const r=s?p:u;let l="",{scheme:a,authority:g,path:P,query:A,fragment:V}=t;if(a&&(l+=a,l+=":"),(g||a==="file")&&(l+=b,l+=b),g){let O=g.indexOf("@");if(O!==-1){const F=g.substr(0,O);g=g.substr(O+1),O=F.indexOf(":"),O===-1?l+=r(F,!1):(l+=r(F.substr(0,O),!1),l+=":",l+=r(F.substr(O+1),!1)),l+="@"}g=g.toLowerCase(),O=g.indexOf(":"),O===-1?l+=r(g,!1):(l+=r(g.substr(0,O),!1),l+=g.substr(O))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const O=P.charCodeAt(1);O>=65&&O<=90&&(P=`/${String.fromCharCode(O+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const O=P.charCodeAt(0);O>=65&&O<=90&&(P=`${String.fromCharCode(O+32)}:${P.substr(2)}`)}l+=r(P,!0)}return A&&(l+="?",l+=r(A,!1)),V&&(l+="#",l+=s?V:u(V,!1)),l}function d(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+d(t.substr(3)):t}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(t){return t.match(n)?t.replace(n,s=>d(s)):t}}),define(re[142],se([0,1,8]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function i(w){const E=w;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.isRemoteConsoleLog=i;function R(w){const E=[];let b;try{const S=JSON.parse(w.arguments),m=S[S.length-1];m&&m.__$stack&&(S.pop(),b=m.__$stack),E.push(...S)}catch{E.push("Unable to log remote console arguments",w.arguments)}return{args:E,stack:b}}e.parse=R;function k(w){if(typeof w!="string")return k(R(w).stack);const E=w;if(E){const b=T(E),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(S&&S.length===4)return{uri:D.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=k;function T(w){if(!w)return w;const E=w.indexOf(`
`);return E===-1?w:w.substring(0,E)}function I(w,E){const{args:b,stack:S}=R(w),m=typeof b[0]=="string"&&b.length===1;let f=T(S);f&&(f=`(${f.trim()})`);let v=[];if(typeof b[0]=="string"?f&&m?v=[`%c[${E}] %c${b[0]} %c${f}`,C("blue"),C(""),C("grey")]:v=[`%c[${E}] %c${b[0]}`,C("blue"),C(""),...b.slice(1)]:v=[`%c[${E}]%`,C("blue"),...b],f&&!m&&v.push(f),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,v)}e.log=I;function C(w){return`color: ${w}`}}),define(re[67],se([0,1,17,27,8]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(w){return JSON.stringify(w,I)}e.stringify=k;function T(w){let E=JSON.parse(w);return E=C(E),E}e.parse=T;function I(w,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,i.regExpFlags)(E)}:E}function C(w,E=0){if(!w||E>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return R.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 15:return new Date(w.source)}if(w instanceof D.VSBuffer||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let b=0;b<w.length;++b)w[b]=C(w[b],E+1);else for(const b in w)Object.hasOwnProperty.call(w,b)&&(w[b]=C(w[b],E+1))}return w}e.revive=C}),define(re[23],se([0,1,5,8]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.vscodeUserData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp",C.vsls="vsls",C.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}setServerRootPath(w){this._remoteResourcesPath=`${w}/${R.vscodeRemoteResource}`}set(w,E,b){this._hosts[w]=E,this._ports[w]=b}setConnectionToken(w,E){this._connectionTokens[w]=E}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(w){if(this._delegate)return this._delegate(w);const E=w.authority;let b=this._hosts[E];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const S=this._ports[E],m=this._connectionTokens[E];let f=`path=${encodeURIComponent(w.path)}`;return typeof m=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),i.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${b}:${S}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new k;class T{asBrowserUri(w,E){const b=this.toUri(w,E);return b.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===R.file&&(D.isNative||D.isWebWorker&&D.globals.origin===`${R.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?b.with({scheme:R.vscodeFileResource,authority:b.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(w,E){const b=this.toUri(w,E);return b.scheme===R.vscodeFileResource?b.with({scheme:R.file,authority:b.authority!==T.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(w,E){return i.URI.isUri(w)?w:i.URI.parse(E.toUrl(w))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T;var I;(function(C){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);C.CoopAndCoep=Object.freeze(w.get("3"));const E="vscode-coi";function b(m){let f;typeof m=="string"?f=new URL(m).searchParams:m instanceof URL?f=m.searchParams:i.URI.isUri(m)&&(f=new URL(m.toString(!0)).searchParams);const v=f?.get(E);if(!!v)return w.get(v)}C.getHeadersFromQuery=b;function S(m,f,v){if(!globalThis.crossOriginIsolated)return;const y=f&&v?"3":v?"2":"1";m instanceof URLSearchParams?m.set(E,y):m[E]=y}C.addSearchParam=S})(I=e.COI||(e.COI={}))}),define(re[20],se([0,1,48,23,12,5,27,8]),function(Q,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(m){return(0,I.uriToFsPath)(m,!0)}e.originalFSPath=C;class w{constructor(f){this._ignorePathCasing=f}compare(f,v,y=!1){return f===v?0:(0,T.compare)(this.getComparisonKey(f,y),this.getComparisonKey(v,y))}isEqual(f,v,y=!1){return f===v?!0:!f||!v?!1:this.getComparisonKey(f,y)===this.getComparisonKey(v,y)}getComparisonKey(f,v=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,v,y=!1){if(f.scheme===v.scheme){if(f.scheme===i.Schemas.file)return D.isEqualOrParent(C(f),C(v),this._ignorePathCasing(f))&&f.query===v.query&&(y||f.fragment===v.fragment);if((0,e.isEqualAuthority)(f.authority,v.authority))return D.isEqualOrParent(f.path,v.path,this._ignorePathCasing(f),"/")&&f.query===v.query&&(y||f.fragment===v.fragment)}return!1}joinPath(f,...v){return I.URI.joinPath(f,...v)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return R.posix.basename(f.path)}extname(f){return R.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let v;return f.scheme===i.Schemas.file?v=I.URI.file(R.dirname(C(f))).path:(v=R.posix.dirname(f.path),f.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),v="/")),f.with({path:v})}normalizePath(f){if(!f.path.length)return f;let v;return f.scheme===i.Schemas.file?v=I.URI.file(R.normalize(C(f))).path:v=R.posix.normalize(f.path),f.with({path:v})}relativePath(f,v){if(f.scheme!==v.scheme||!(0,e.isEqualAuthority)(f.authority,v.authority))return;if(f.scheme===i.Schemas.file){const p=R.relative(C(f),C(v));return k.isWindows?D.toSlashes(p):p}let y=f.path||"/";const u=v.path||"/";if(this._ignorePathCasing(f)){let p=0;for(const c=Math.min(y.length,u.length);p<c&&!(y.charCodeAt(p)!==u.charCodeAt(p)&&y.charAt(p).toLowerCase()!==u.charAt(p).toLowerCase());p++);y=u.substr(0,p)+y.substr(p)}return R.posix.relative(y,u)}resolvePath(f,v){if(f.scheme===i.Schemas.file){const y=I.URI.file(R.resolve(C(f),v));return f.with({authority:y.authority,path:y.path})}return v=D.toPosixPath(v),f.with({path:R.posix.resolve(f.path,v)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,v){return f===v||f!==void 0&&v!==void 0&&(0,T.equalsIgnoreCase)(f,v)}hasTrailingPathSeparator(f,v=R.sep){if(f.scheme===i.Schemas.file){const y=C(f);return y.length>D.getRoot(y).length&&y[y.length-1]===v}else{const y=f.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,v=R.sep){return(0,e.hasTrailingPathSeparator)(f,v)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,v=R.sep){let y=!1;if(f.scheme===i.Schemas.file){const u=C(f);y=u!==void 0&&u.length===D.getRoot(u).length&&u[u.length-1]===v}else{v="/";const u=f.path;y=u.length===1&&u.charCodeAt(u.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(f,v)?f.with({path:f.path+"/"}):f}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(m=>m.scheme===i.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new w(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function E(m,f){const v=[];for(let y=0;y<m.length;y++){const u=f(m[y]);m.some((p,c)=>c===y?!1:(0,e.isEqualOrParent)(u,f(p)))||v.push(m[y])}return v}e.distinctParents=E;var b;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function f(v){const y=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(c=>{const[h,d]=c.split(":");h&&d&&y.set(h,d)});const p=v.path.substring(0,v.path.indexOf(";"));return p&&y.set(m.META_DATA_MIME,p),y}m.parseMetaData=f})(b=e.DataUri||(e.DataUri={}));function S(m,f,v){if(f){let y=m.path;return y&&y[0]!==R.posix.sep&&(y=R.posix.sep+y),m.with({scheme:v,authority:f,path:y})}return m.with({scheme:v})}e.toLocalResource=S}),define(re[6],se([0,1,22,11,3,2,20,5]),function(Q,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(z){return!!z&&typeof z.then=="function"}e.isThenable=C;function w(z){const _=new D.CancellationTokenSource,M=z(_.token),G=new Promise((H,Z)=>{const oe=_.token.onCancellationRequested(()=>{oe.dispose(),_.dispose(),Z(new i.CancellationError)});Promise.resolve(M).then(X=>{oe.dispose(),_.dispose(),H(X)},X=>{oe.dispose(),_.dispose(),Z(X)})});return new class{cancel(){_.cancel()}then(H,Z){return G.then(H,Z)}catch(H){return this.then(void 0,H)}finally(H){return G.finally(H)}}}e.createCancelablePromise=w;function E(z,_,M){return new Promise((G,H)=>{const Z=_.onCancellationRequested(()=>{Z.dispose(),G(M)});z.then(G,H).finally(()=>Z.dispose())})}e.raceCancellation=E;function b(z,_){return new Promise((M,G)=>{const H=_.onCancellationRequested(()=>{H.dispose(),G(new i.CancellationError)});z.then(M,G).finally(()=>H.dispose())})}e.raceCancellationError=b;async function S(z){let _=-1;const M=z.map((H,Z)=>H.then(oe=>(_=Z,oe))),G=await Promise.race(M);return z.forEach((H,Z)=>{Z!==_&&H.cancel()}),G}e.raceCancellablePromises=S;function m(z,_,M){let G;const H=setTimeout(()=>{G?.(void 0),M?.()},_);return Promise.race([z.finally(()=>clearTimeout(H)),new Promise(Z=>G=Z)])}e.raceTimeout=m;function f(z){return new Promise((_,M)=>{const G=z();C(G)?G.then(_,M):_(G)})}e.asPromise=f;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(_){if(this.activePromise){if(this.queuedPromiseFactory=_,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(M,M).then(G)})}return new Promise((M,G)=>{this.queuedPromise.then(M,G)})}return this.activePromise=_(),new Promise((M,G)=>{this.activePromise.then(H=>{this.activePromise=null,M(H)},H=>{this.activePromise=null,G(H)})})}}e.Throttler=v;class y{constructor(){this.current=Promise.resolve(null)}queue(_){return this.current=this.current.then(()=>_(),()=>_())}}e.Sequencer=y;class u{constructor(){this.promiseMap=new Map}queue(_,M){const H=(this.promiseMap.get(_)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(_)===H&&this.promiseMap.delete(_)});return this.promiseMap.set(_,H),H}}e.SequencerByKey=u;const p=(z,_)=>{let M=!0;const G=setTimeout(()=>{M=!1,_()},z);return{isTriggered:()=>M,dispose:()=>{clearTimeout(G),M=!1}}},c=z=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,z())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(_){this.defaultDelay=_,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(_,M=this.defaultDelay){this.task=_,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((H,Z)=>{this.doResolve=H,this.doReject=Z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const H=this.task;return this.task=null,H()}}));const G=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=M===e.MicrotaskDelay?c(G):p(M,G),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=h;class d{constructor(_){this.delayer=new h(_),this.throttler=new v}trigger(_,M){return this.delayer.trigger(()=>this.throttler.queue(_),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=d;class n{constructor(){this._isOpen=!1,this._promise=new Promise((_,M)=>{this._completePromise=_})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class o extends n{constructor(_){super(),this._timeout=setTimeout(()=>this.open(),_)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function t(z,_){return _?new Promise((M,G)=>{const H=setTimeout(()=>{Z.dispose(),M()},z),Z=_.onCancellationRequested(()=>{clearTimeout(H),Z.dispose(),G(new i.CancellationError)})}):w(M=>t(z,M))}e.timeout=t;function s(z,_=0){const M=setTimeout(z,_);return(0,k.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=s;function r(z){const _=[];let M=0;const G=z.length;function H(){return M<G?z[M++]():null}function Z(oe){oe!=null&&_.push(oe);const X=H();return X?X.then(Z):Promise.resolve(_)}return Promise.resolve(null).then(Z)}e.sequence=r;function l(z,_=G=>!!G,M=null){let G=0;const H=z.length,Z=()=>{if(G>=H)return Promise.resolve(M);const oe=z[G++];return Promise.resolve(oe()).then(ie=>_(ie)?Promise.resolve(ie):Z())};return Z()}e.first=l;function a(z,_=G=>!!G,M=null){if(z.length===0)return Promise.resolve(M);let G=z.length;const H=()=>{G=-1;for(const Z of z)Z.cancel?.()};return new Promise((Z,oe)=>{for(const X of z)X.then(ie=>{--G>=0&&_(ie)?(H(),Z(ie)):G===0&&Z(M)}).catch(ie=>{--G>=0&&(H(),oe(ie))})})}e.firstParallel=a;class g{constructor(_){this._size=0,this.maxDegreeOfParalellism=_,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new R.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(_){return this._size++,new Promise((M,G)=>{this.outstandingPromises.push({factory:_,c:M,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const _=this.outstandingPromises.shift();this.runningPromises++;const M=_.factory();M.then(_.c,_.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=g;class P extends g{constructor(){super(1)}}e.Queue=P;class A{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const _=new W;return this.drainers.add(_),_.p}isDrained(){for(const[,_]of this.queues)if(_.size>0)return!1;return!0}queueFor(_,M=T.extUri){const G=M.getComparisonKey(_);let H=this.queues.get(G);return H||(H=new P,R.Event.once(H.onDrained)(()=>{H?.dispose(),this.queues.delete(G),this.onDidQueueDrain()}),this.queues.set(G,H)),H}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const _ of this.drainers)_.complete();this.drainers.clear()}dispose(){for(const[,_]of this.queues)_.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=A;class V{constructor(_,M){this._token=-1,typeof _=="function"&&typeof M=="number"&&this.setIfNotSet(_,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(_,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,_()},M)}setIfNotSet(_,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,_()},M))}}e.TimeoutTimer=V;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(_,M){this.cancel(),this._token=setInterval(()=>{_()},M)}}e.IntervalTimer=O;class F{constructor(_,M){this.timeoutToken=-1,this.runner=_,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(_=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,_)}get delay(){return this.timeout}set delay(_){this.timeout=_}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=F;class N{constructor(_,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.runner=_,this.timeout=M,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(_=this.timeout){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(_/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=N;class L extends F{constructor(_,M){super(_,M),this.units=[]}work(_){this.units.push(_),this.isScheduled()||this.schedule()}doRun(){const _=this.units;this.units=[],this.runner?.(_)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L;class U extends k.Disposable{constructor(_,M){super(),this.options=_,this.handler=M,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(_){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+_.length>this.options.maxBufferedWork)return!1}else if(this.pending+_.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(..._),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=z=>{(0,I.setTimeout0)(()=>{if(_)return;const M=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.runWhenIdle=(z,_)=>{const M=requestIdleCallback(z,typeof _=="number"?{timeout:_}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(M))}}}}();class ${constructor(_){this._didRun=!1,this._executor=()=>{try{this._value=_()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=$;async function x(z,_,M){let G;for(let H=0;H<M;H++)try{return await z()}catch(Z){G=Z,await t(_)}throw G}e.retry=x;class j{hasPending(_){return this._pending?typeof _=="number"?this._pending.taskId===_:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(_,M,G){return this._pending={taskId:_,cancel:()=>G?.(),promise:M},M.then(()=>this.donePending(_),()=>this.donePending(_)),M}donePending(_){this._pending&&_===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const _=this._next;this._next=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this._next)this._next.run=_;else{let M,G;const H=new Promise((Z,oe)=>{M=Z,G=oe});this._next={run:_,promise:H,promiseResolve:M,promiseReject:G}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=j;class B{constructor(_,M=()=>Date.now()){this.interval=_,this.nowFn=M,this.lastIncrementTime=0,this.value=0}increment(){const _=this.nowFn();return _-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=_,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class W{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((_,M)=>{this.completeCallback=_,this.errorCallback=M})}complete(_){return new Promise(M=>{this.completeCallback(_),this.resolved=!0,M()})}error(_){return new Promise(M=>{this.errorCallback(_),this.rejected=!0,M()})}cancel(){new Promise(_=>{this.errorCallback(new i.CancellationError),this.rejected=!0,_()})}}e.DeferredPromise=W;var q;(function(z){async function _(G){let H;const Z=await Promise.all(G.map(oe=>oe.then(X=>X,X=>{H||(H=X)})));if(typeof H<"u")throw H;return Z}z.settled=_;function M(G){return new Promise(async(H,Z)=>{try{await G(H,Z)}catch(oe){Z(oe)}})}z.withAsyncBody=M})(q=e.Promises||(e.Promises={}));var Y;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(Y||(Y={}));class ee{static fromArray(_){return new ee(M=>{M.emitMany(_)})}static fromPromise(_){return new ee(async M=>{M.emitMany(await _)})}static fromPromises(_){return new ee(async M=>{await Promise.all(_.map(async G=>M.emitOne(await G)))})}static merge(_){return new ee(async M=>{await Promise.all(_.map(async G=>{for await(const H of G)M.emitOne(H)}))})}constructor(_){this._state=0,this._results=[],this._error=null,this._onStateChanged=new R.Emitter,queueMicrotask(async()=>{const M={emitOne:G=>this.emitOne(G),emitMany:G=>this.emitMany(G),reject:G=>this.reject(G)};try{await Promise.resolve(_(M)),this.resolve()}catch(G){this.reject(G)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(_<this._results.length)return{done:!1,value:this._results[_++]};if(this._state===1)return{done:!0,value:void 0};await R.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(_,M){return new ee(async G=>{for await(const H of _)G.emitOne(M(H))})}map(_){return ee.map(this,_)}static filter(_,M){return new ee(async G=>{for await(const H of _)M(H)&&G.emitOne(H)})}filter(_){return ee.filter(this,_)}static coalesce(_){return ee.filter(_,M=>!!M)}coalesce(){return ee.coalesce(this)}static async toPromise(_){const M=[];for await(const G of _)M.push(G);return M}toPromise(){return ee.toPromise(this)}emitOne(_){this._state===0&&(this._results.push(_),this._onStateChanged.fire())}emitMany(_){this._state===0&&(this._results=this._results.concat(_),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(_){this._state===0&&(this._state=2,this._error=_,this._onStateChanged.fire())}}e.AsyncIterableObject=ee,ee.EMPTY=ee.fromArray([]);class ce extends ee{constructor(_,M){super(M),this._source=_}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function J(z){const _=new D.CancellationTokenSource,M=z(_.token);return new ce(_,async G=>{const H=_.token.onCancellationRequested(()=>{H.dispose(),_.dispose(),G.reject(new i.CancellationError)});try{for await(const Z of M){if(_.token.isCancellationRequested)return;G.emitOne(Z)}H.dispose(),_.dispose()}catch(Z){H.dispose(),_.dispose(),G.reject(Z)}})}e.createCancelableAsyncIterable=J}),define(re[88],se([0,1,19,6,48,41,12,5,27]),function(Q,e,D,i,R,k,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function w(){return Object.create(null)}e.getEmptyExpression=w,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",b="[^/\\\\]",S=/\//g;function m(W,q){switch(W){case 0:return"";case 1:return`${b}*?`;default:return`(?:${E}|${b}+${E}${q?`|${E}${b}+`:""})*?`}}function f(W,q){if(!W)return[];const Y=[];let ee=!1,ce=!1,J="";for(const z of W){switch(z){case q:if(!ee&&!ce){Y.push(J),J="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}J+=z}return J&&Y.push(J),Y}e.splitGlobAware=f;function v(W){if(!W)return"";let q="";const Y=f(W,e.GLOB_SPLIT);if(Y.every(ee=>ee===e.GLOBSTAR))q=".*";else{let ee=!1;Y.forEach((ce,J)=>{if(ce===e.GLOBSTAR){if(ee)return;q+=m(2,J===Y.length-1)}else{let z=!1,_="",M=!1,G="";for(const H of ce){if(H!=="}"&&z){_+=H;continue}if(M&&(H!=="]"||!G)){let Z;H==="-"?Z=H:(H==="^"||H==="!")&&!G?Z="^":H===e.GLOB_SPLIT?Z="":Z=(0,C.escapeRegExpCharacters)(H),G+=Z;continue}switch(H){case"{":z=!0;continue;case"[":M=!0;continue;case"}":{q+=`(?:${f(_,",").map(X=>v(X)).join("|")})`,z=!1,_="";break}case"]":{q+="["+G+"]",M=!1,G="";break}case"?":q+=b;continue;case"*":q+=m(1);continue;default:q+=(0,C.escapeRegExpCharacters)(H)}}J<Y.length-1&&(Y[J+1]!==e.GLOBSTAR||J+2<Y.length)&&(q+=E)}ee=ce===e.GLOBSTAR})}return q}const y=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new k.LRUCache(1e4),o=function(){return!1},t=function(){return null};function s(W,q){if(!W)return t;let Y;typeof W!="string"?Y=W.pattern:Y=W,Y=Y.trim();const ee=`${Y}_${!!q.trimForExclusions}`;let ce=n.get(ee);if(ce)return r(ce,W);let J;return y.test(Y)?ce=a(Y.substr(4),Y):(J=u.exec(l(Y,q)))?ce=g(J[1],Y):(q.trimForExclusions?c:p).test(Y)?ce=P(Y,q):(J=h.exec(l(Y,q)))?ce=A(J[1].substr(1),Y,!0):(J=d.exec(l(Y,q)))?ce=A(J[1],Y,!1):ce=V(Y),n.set(ee,ce),r(ce,W)}function r(W,q){if(typeof q=="string")return W;const Y=function(ee,ce){return(0,R.isEqualOrParent)(ee,q.base,!I.isLinux)?W(ee.substr(q.base.length+1),ce):null};return Y.allBasenames=W.allBasenames,Y.allPaths=W.allPaths,Y.basenames=W.basenames,Y.patterns=W.patterns,Y}function l(W,q){return q.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function a(W,q){return function(Y,ee){return typeof Y=="string"&&Y.endsWith(W)?q:null}}function g(W,q){const Y=`/${W}`,ee=`\\${W}`,ce=function(z,_){return typeof z!="string"?null:_?_===W?q:null:z===W||z.endsWith(Y)||z.endsWith(ee)?q:null},J=[W];return ce.basenames=J,ce.patterns=[q],ce.allBasenames=J,ce}function P(W,q){const Y=j(W.slice(1,-1).split(",").map(_=>s(_,q)).filter(_=>_!==t),W),ee=Y.length;if(!ee)return t;if(ee===1)return Y[0];const ce=function(_,M){for(let G=0,H=Y.length;G<H;G++)if(Y[G](_,M))return W;return null},J=Y.find(_=>!!_.allBasenames);J&&(ce.allBasenames=J.allBasenames);const z=Y.reduce((_,M)=>M.allPaths?_.concat(M.allPaths):_,[]);return z.length&&(ce.allPaths=z),ce}function A(W,q,Y){const ee=T.sep===T.posix.sep,ce=ee?W:W.replace(S,T.sep),J=T.sep+ce,z=T.posix.sep+W;let _;return Y?_=function(M,G){return typeof M=="string"&&(M===ce||M.endsWith(J)||!ee&&(M===W||M.endsWith(z)))?q:null}:_=function(M,G){return typeof M=="string"&&(M===ce||!ee&&M===W)?q:null},_.allPaths=[(Y?"*/":"./")+W],_}function V(W){try{const q=new RegExp(`^${v(W)}$`);return function(Y){return q.lastIndex=0,typeof Y=="string"&&q.test(Y)?W:null}}catch{return t}}function O(W,q,Y){return!W||typeof q!="string"?!1:F(W)(q,void 0,Y)}e.match=O;function F(W,q={}){if(!W)return o;if(typeof W=="string"||N(W)){const Y=s(W,q);if(Y===t)return o;const ee=function(ce,J){return!!Y(ce,J)};return Y.allBasenames&&(ee.allBasenames=Y.allBasenames),Y.allPaths&&(ee.allPaths=Y.allPaths),ee}return $(W,q)}e.parse=F;function N(W){const q=W;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.isRelativePattern=N;function L(W){return W.allBasenames||[]}e.getBasenameTerms=L;function U(W){return W.allPaths||[]}e.getPathTerms=U;function $(W,q){const Y=j(Object.getOwnPropertyNames(W).map(_=>x(_,W[_],q)).filter(_=>_!==t)),ee=Y.length;if(!ee)return t;if(!Y.some(_=>!!_.requiresSiblings)){if(ee===1)return Y[0];const _=function(H,Z){let oe;for(let X=0,ie=Y.length;X<ie;X++){const ne=Y[X](H,Z);if(typeof ne=="string")return ne;(0,i.isThenable)(ne)&&(oe||(oe=[]),oe.push(ne))}return oe?(async()=>{for(const X of oe){const ie=await X;if(typeof ie=="string")return ie}return null})():null},M=Y.find(H=>!!H.allBasenames);M&&(_.allBasenames=M.allBasenames);const G=Y.reduce((H,Z)=>Z.allPaths?H.concat(Z.allPaths):H,[]);return G.length&&(_.allPaths=G),_}const ce=function(_,M,G){let H,Z;for(let oe=0,X=Y.length;oe<X;oe++){const ie=Y[oe];ie.requiresSiblings&&G&&(M||(M=(0,T.basename)(_)),H||(H=M.substr(0,M.length-(0,T.extname)(_).length)));const ne=ie(_,M,H,G);if(typeof ne=="string")return ne;(0,i.isThenable)(ne)&&(Z||(Z=[]),Z.push(ne))}return Z?(async()=>{for(const oe of Z){const X=await oe;if(typeof X=="string")return X}return null})():null},J=Y.find(_=>!!_.allBasenames);J&&(ce.allBasenames=J.allBasenames);const z=Y.reduce((_,M)=>M.allPaths?_.concat(M.allPaths):_,[]);return z.length&&(ce.allPaths=z),ce}function x(W,q,Y){if(q===!1)return t;const ee=s(W,Y);if(ee===t)return t;if(typeof q=="boolean")return ee;if(q){const ce=q.when;if(typeof ce=="string"){const J=(z,_,M,G)=>{if(!G||!ee(z,_))return null;const H=ce.replace("$(basename)",M),Z=G(H);return(0,i.isThenable)(Z)?Z.then(oe=>oe?W:null):Z?W:null};return J.requiresSiblings=!0,J}}return ee}function j(W,q){const Y=W.filter(_=>!!_.basenames);if(Y.length<2)return W;const ee=Y.reduce((_,M)=>{const G=M.basenames;return G?_.concat(G):_},[]);let ce;if(q){ce=[];for(let _=0,M=ee.length;_<M;_++)ce.push(q)}else ce=Y.reduce((_,M)=>{const G=M.patterns;return G?_.concat(G):_},[]);const J=function(_,M){if(typeof _!="string")return null;if(!M){let H;for(H=_.length;H>0;H--){const Z=_.charCodeAt(H-1);if(Z===47||Z===92)break}M=_.substr(H)}const G=ee.indexOf(M);return G!==-1?ce[G]:null};J.basenames=ee,J.patterns=ce,J.allBasenames=ee;const z=W.filter(_=>!_.basenames);return z.push(J),z}function B(W,q){return(0,D.equals)(W,q,(Y,ee)=>typeof Y=="string"&&typeof ee=="string"?Y===ee:typeof Y!="string"&&typeof ee!="string"?Y.base===ee.base&&Y.pattern===ee.pattern:!1)}e.patternsEquals=B}),define(re[143],se([0,1,8]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(E){return E.toJSON()}class R{constructor(b){this._uriTransformer=b}transformIncoming(b){const S=this._uriTransformer.transformIncoming(b);return S===b?b:i(D.URI.from(S))}transformOutgoing(b){const S=this._uriTransformer.transformOutgoing(b);return S===b?b:i(D.URI.from(S))}transformOutgoingURI(b){const S=this._uriTransformer.transformOutgoing(b);return S===b?b:D.URI.from(S)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function k(E,b,S){if(!E||S>200)return null;if(typeof E=="object"){if(E instanceof D.URI)return b.transformOutgoing(E);for(const m in E)if(Object.hasOwnProperty.call(E,m)){const f=k(E[m],b,S+1);f!==null&&(E[m]=f)}}return null}function T(E,b){const S=k(E,b,0);return S===null?E:S}e.transformOutgoingURIs=T;function I(E,b,S,m){if(!E||m>200)return null;if(typeof E=="object"){if(E.$mid===1)return S?D.URI.revive(b.transformIncoming(E)):b.transformIncoming(E);for(const f in E)if(Object.hasOwnProperty.call(E,f)){const v=I(E[f],b,S,m+1);v!==null&&(E[f]=v)}}return null}function C(E,b){const S=I(E,b,!1,0);return S===null?E:S}e.transformIncomingURIs=C;function w(E,b){const S=I(E,b,!0,0);return S===null?E:S}e.transformAndReviveIncomingURIs=w}),define(re[144],se([0,1,34,11,49,30,130]),function(Q,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(E){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(E)}value(){if(this._value===void 0){let E=0,b=0;const S=(0,D.networkInterfaces)();for(const m in S){const f=S[m];if(f)for(const{mac:v,internal:y}of f)y||(b+=1,this._isVirtualMachineMacAddress(v.toUpperCase())&&(E+=1))}this._value=b>0?E/b:0}return this._value}};let I;async function C(){return I||(I=(async()=>await w()||k.generateUuid())()),I}e.getMachineId=C;async function w(){try{const E=await new Promise((S,m)=>{Q(["crypto"],S,m)}),b=(0,T.getMac)();return E.createHash("sha256").update(b,"utf8").digest("hex")}catch(E){i.onUnexpectedError(E);return}}}),define(re[28],se([0,1,53,34,282,6,48,83,12,5,20,8]),function(Q,e,D,i,R,k,T,I,C,w,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function m($,x=S.UNLINK){if((0,T.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return x===S.UNLINK?v($):f($)}async function f($){try{const x=(0,T.randomPath)((0,i.tmpdir)());try{await D.promises.rename($,x)}catch(j){return j.code==="ENOENT"?void 0:v($)}v(x).catch(j=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function v($){return(0,R.promisify)(D.rm)($,{recursive:!0,force:!0,maxRetries:3})}function y($){if((0,T.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync($,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=y;async function u($,x){return h(await(x?p($):(0,R.promisify)(D.readdir)($)))}async function p($){try{return await(0,R.promisify)(D.readdir)($,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const x=[],j=await u($);for(const B of j){let W=!1,q=!1,Y=!1;try{const ee=await e.Promises.lstat((0,C.join)($,B));W=ee.isFile(),q=ee.isDirectory(),Y=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}x.push({name:B,isFile:()=>W,isDirectory:()=>q,isSymbolicLink:()=>Y})}return x}function c($){return h(D.readdirSync($))}e.readdirSync=c;function h($){return $.map(x=>typeof x=="string"?w.isMacintosh?(0,I.normalizeNFC)(x):x:(x.name=w.isMacintosh?(0,I.normalizeNFC)(x.name):x.name,x))}async function d($){const x=await u($),j=[];for(const B of x)await o.existsDirectory((0,C.join)($,B))&&j.push(B);return j}function n($,x=1e3){return new Promise(j=>{let B=!1;const W=setInterval(()=>{B||(B=!0,D.access($,q=>{B=!1,q&&(clearInterval(W),j(void 0))}))},x)})}e.whenDeleted=n;var o;(function($){async function x(W){let q;try{if(q=await e.Promises.lstat(W),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(w.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw ee}throw Y}}$.stat=x;async function j(W){try{const{stat:q,symbolicLink:Y}=await $.stat(W);return q.isFile()&&Y?.dangling!==!0}catch{}return!1}$.existsFile=j;async function B(W){try{const{stat:q,symbolicLink:Y}=await $.stat(W);return q.isDirectory()&&Y?.dangling!==!0}catch{}return!1}$.existsDirectory=B})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new k.ResourceQueue;function s($,x,j){return t.queueFor(b.URI.file($),E.extUriBiasedIgnorePathCase).queue(()=>{const B=P(j);return new Promise((W,q)=>a($,x,B,Y=>Y?q(Y):W()))})}let r=!0;function l($){r=$}e.configureFlushOnWrite=l;function a($,x,j,B){if(!r)return D.writeFile($,x,{mode:j.mode,flag:j.flag},B);D.open($,j.flag,j.mode,(W,q)=>{if(W)return B(W);D.writeFile(q,x,Y=>{if(Y)return D.close(q,()=>B(Y));D.fdatasync(q,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),l(!1)),D.close(q,ce=>B(ce))))})})}function g($,x,j){const B=P(j);if(!r)return D.writeFileSync($,x,{mode:B.mode,flag:B.flag});const W=D.openSync($,B.flag,B.mode);try{D.writeFileSync(W,x);try{D.fdatasyncSync(W)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),l(!1)}}finally{D.closeSync(W)}}e.writeFileSync=g;function P($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function A($,x){if($!==x)try{await e.Promises.rename($,x)}catch(j){if($.toLowerCase()!==x.toLowerCase()&&j.code==="EXDEV"||$.endsWith("."))await V($,x,{preserveSymlinks:!1}),await m($,S.MOVE);else throw j}}async function V($,x,j){return F($,x,{root:{source:$,target:x},options:j,handledSourcePaths:new Set})}const O=511;async function F($,x,j){if(j.handledSourcePaths.has($))return;j.handledSourcePaths.add($);const{stat:B,symbolicLink:W}=await o.stat($);if(W){if(j.options.preserveSymlinks)try{return await U($,x,j)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(W.dangling)return}return B.isDirectory()?N($,x,B.mode&O,j):L($,x,B.mode&O)}async function N($,x,j,B){await e.Promises.mkdir(x,{recursive:!0,mode:j});const W=await u($);for(const q of W)await F((0,C.join)($,q),(0,C.join)(x,q),B)}async function L($,x,j){await e.Promises.copyFile($,x),await e.Promises.chmod(x,j)}async function U($,x,j){let B=await e.Promises.readlink($);(0,T.isEqualOrParent)(B,j.root.source,!w.isLinux)&&(B=(0,C.join)(j.root.target,B.substr(j.root.source.length+1))),await e.Promises.symlink(B,x)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return($,x,j,B,W)=>new Promise((q,Y)=>{D.read($,x,j,B,W,(ee,ce,J)=>ee?Y(ee):q({bytesRead:ce,buffer:J}))})}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return($,x,j,B,W)=>new Promise((q,Y)=>{D.write($,x,j,B,W,(ee,ce,J)=>ee?Y(ee):q({bytesWritten:ce,buffer:J}))})}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists($){try{return await e.Promises.access($),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return d}get writeFile(){return s}get rm(){return m}get move(){return A}get copy(){return V}}}),define(re[145],se([0,1,53,12,5,27,28]),function(Q,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(S){if(R.isLinux)return S;const m=(0,i.dirname)(S);if(S===m)return S;const f=((0,i.basename)(S)||S).toLowerCase();try{const y=(0,T.readdirSync)(m).filter(u=>u.toLowerCase()===f);if(y.length===1){const u=I(m);if(u)return(0,i.join)(u,y[0])}else if(y.length>1){const u=y.indexOf(f);if(u>=0){const p=I(m);if(p)return(0,i.join)(p,y[u])}}}catch{}return null}e.realcaseSync=I;async function C(S){if(R.isLinux)return S;const m=(0,i.dirname)(S);if(S===m)return S;const f=((0,i.basename)(S)||S).toLowerCase();try{const y=(await T.Promises.readdir(m)).filter(u=>u.toLowerCase()===f);if(y.length===1){const u=await C(m);if(u)return(0,i.join)(u,y[0])}else if(y.length>1){const u=y.indexOf(f);if(u>=0){const p=await C(m);if(p)return(0,i.join)(p,y[u])}}}catch{}return null}e.realcase=C;async function w(S){try{return await T.Promises.realpath(S)}catch{const f=b(S);return await T.Promises.access(f,D.constants.R_OK),f}}e.realpath=w;function E(S){try{return D.realpathSync(S)}catch{const f=b(S);return D.accessSync(f,D.constants.R_OK),f}}e.realpathSync=E;function b(S){return(0,k.rtrim)((0,i.normalize)(S),i.sep)}}),define(re[89],se([0,1,34,12,28]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,T=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var C;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(C||(C={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class b{constructor(d,n,o){this.exePath=d,this.displayName=n,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:h=!1}={}){return h?w===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:h=!1,findPreview:d=!1}={}){const n=S({useAlternateBitness:h});if(!n)return null;const o=i.join(n,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(o))return null;let t=-1,s=null;for(const a of await R.Promises.readdir(o)){let g=-1;if(d){const A=a.indexOf("-");if(A<0)continue;const V=a.substring(0,A);if(!k.test(V)||a.substring(A+1)!=="preview")continue;g=parseInt(V,10)}else{if(!k.test(a))continue;g=parseInt(a,10)}if(g<=t)continue;const P=i.join(o,a,"pwsh.exe");!await R.SymlinkSupport.existsFile(P)||(s=P,t=g)}if(!s)return null;const r=n.includes("x86")?" (x86)":"",l=d?" Preview":"";return new b(s,`PowerShell${l}${r}`,!0)}async function f({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const d=i.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(d))return null;const{pwshMsixDirRegex:n,pwshMsixName:o}=h?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(d))if(n.test(t)){const s=i.join(d,t,"pwsh.exe");return new b(s,o)}return null}function v(){const h=i.join(D.homedir(),".dotnet","tools","pwsh.exe");return new b(h,".NET Core PowerShell Global Tool")}function y(){const h=i.join(process.env.windir,w===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(h,"Windows PowerShell",!0)}async function*u(){let h=await m();h&&(yield h),h=await m({useAlternateBitness:!0}),h&&(yield h),h=await f(),h&&(yield h),h=v(),h&&(yield h),h=await m({findPreview:!0}),h&&(yield h),h=await f({findPreview:!0}),h&&(yield h),h=await m({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=y(),h&&(yield h)}async function*p(){for await(const h of u())await h.exists()&&(yield h)}e.enumeratePowerShellInstallations=p;async function c(){for await(const h of p())return h;return null}e.getFirstAvailablePowerShellInstallation=c}),define(re[90],se([0,1,12,5,36,85,15,28]),function(Q,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function C(b=R.env){return b.comspec||"cmd.exe"}e.getWindowsShell=C;function w(b){let S=[],m=!1;const f=function(v){if(m){S.push(v);return}(!b.send(v,u=>{if(u&&console.error(u),m=!1,S.length>0){const p=S.slice(0);S=[],p.forEach(c=>f(c))}})||i.isWindows)&&(m=!0)};return{send:f}}e.createQueuedSender=w;var E;(function(b){async function S(m,f,v){if(D.isAbsolute(m))return m;if(f===void 0&&(f=R.cwd()),D.dirname(m)!=="."||(v===void 0&&T.isString(R.env.PATH)&&(v=R.env.PATH.split(D.delimiter)),v===void 0||v.length===0))return D.join(f,m);async function u(p){if(await I.Promises.exists(p)){let c;try{c=await I.Promises.stat(p)}catch(h){h.message.startsWith("EACCES")&&(c=await I.Promises.lstat(p))}return c?!c.isDirectory():!1}return!1}for(const p of v){let c;if(D.isAbsolute(p)?c=D.join(p,m):c=D.join(f,p,m),await u(c))return c;let h=c+".com";if(await u(h)||(h=c+".exe",await u(h)))return h}return D.join(f,m)}b.findExecutable=S})(E=e.win32||(e.win32={}))}),define(re[146],se([0,1,50,23]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(T){return new Promise((I,C)=>{let w;const E=new Map;function b(m,f,v,y,u){const p=E.get(f);if(m===T||p){const c={name:S(v),cmd:v,pid:m,ppid:f,load:y,mem:u};E.set(m,c),m===T&&(w=c),p&&(p.children||(p.children=[]),p.children.push(c),p.children.length>1&&(p.children=p.children.sort((h,d)=>h.pid-d.pid)))}}function S(m){const f=/--vscode-window-kind=shared-process/,v=/--vscode-window-kind=issue-reporter/,y=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,p=/--utility-sub-type=node.mojom.NodeService/,c=/--crashes-directory/,h=/\\pipe\\winpty-control/,d=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(c.exec(m))return"electron-crash-reporter";if(h.exec(m))return"winpty-process";if(d.exec(m))return"console-window-host (Windows internal process)";let o=n.exec(m);if(o&&o.length===2){if(o[1]==="renderer")return f.exec(m)?"shared-process":v.exec(m)?"issue-reporter":y.exec(m)?"process-explorer":"window";if(o[1]==="utility"){if(u.exec(m))return"utility-network-service";if(p.exec(m))return"extension-host"}return o[1]}const t=/[a-zA-Z-]+\.js/g;let s="";do o=t.exec(m),o&&(s+=o+" ");while(o);return s&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron_node ${s}`:m}if(process.platform==="win32"){const m=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,v)=>{Q(["windows-process-tree"],f,v)}).then(f=>{f.getProcessList(T,v=>{if(!v){C(new Error(`Root process ${T} not found`));return}f.getProcessCpuUsage(v,y=>{const u=new Map;y.forEach(p=>{const c=m(p.commandLine||"");u.set(p.pid,{name:S(c),cmd:c,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),w=u.get(T),w?(u.forEach(p=>{const c=u.get(p.ppid);c&&(c.children||(c.children=[]),c.children.push(p))}),u.forEach(p=>{p.children&&(p.children=p.children.sort((c,h)=>c.pid-h.pid))}),I(w)):C(new Error(`Root process ${T} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let m=function(){let f=[w];const v=[];for(;f.length;){const u=f.shift();u&&(v.push(u.pid),u.children&&(f=f.concat(u.children)))}let y=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);y+=" "+v.join(" "),(0,D.exec)(y,{},(u,p,c)=>{if(u||c)C(u||new Error(c.toString()));else{const h=p.toString().split(`
`);for(let d=0;d<v.length;d++){const n=E.get(v[d]);n.load=parseFloat(h[d])}if(!w){C(new Error(`Root process ${T} not found`));return}I(w)}})};(0,D.exec)("which ps",{},(f,v,y)=>{if(f||y)if(process.platform!=="linux")C(f||new Error(y.toString()));else{const u=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);(0,D.exec)(u,{},(p,c,h)=>{p||h?C(p||new Error(h.toString())):(k(c,b),m())})}else{const u=v.toString().trim(),p="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${u} ${p}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,h,d)=>{c||d&&!d.includes("screen size is bogus")?C(c||new Error(d.toString())):(k(h,b),process.platform==="linux"?m():w?I(w):C(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=R;function k(T,I){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=T.toString().split(`
`);for(const E of w){const b=C.exec(E.trim());b&&b.length===6&&I(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(re[147],se([0,1,34,5,89,90]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(m,f){return m===1?i.isWindows?b():k.getWindowsShell(f):w(m,f)}e.getSystemShell=T;function I(m,f){return m===1?i.isWindows?S(f):k.getWindowsShell(f):w(m,f)}e.getSystemShellSync=I;let C=null;function w(m,f){if(i.isLinux&&m===2||i.isMacintosh&&m===3)return"/bin/bash";if(!C){let v;if(i.isWindows)v="/bin/bash";else{if(v=f.SHELL,!v)try{v=(0,D.userInfo)().shell}catch{}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}C=v}return C}let E=null;async function b(){return E||(E=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),E}function S(m){if(E)return E;const f=i.isWindows&&parseFloat((0,D.release)())>=10,v=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${m.windir}\\${v?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?y:k.getWindowsShell(m)}});var ve=this&&this.__decorate||function(Q,e,D,i){var R=arguments.length,k=R<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,D):i,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(Q,e,D,i);else for(var I=Q.length-1;I>=0;I--)(T=Q[I])&&(k=(R<3?T(k):R>3?T(e,D,k):T(e,D))||k);return R>3&&k&&Object.defineProperty(e,D,k),k};define(re[38],se([0,1,19,6,17,22,63,11,3,2,67,27,15]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var m;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(m||(m={}));function f(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(v||(v={}));function y(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(u||(u={}));class p{constructor(q){this.buffer=q,this.pos=0}read(q){const Y=this.buffer.slice(this.pos,this.pos+q);return this.pos+=Y.byteLength,Y}}class c{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}var h;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(h||(h={}));function d(W){const q=R.VSBuffer.alloc(4);return q.writeUInt32BE(W,0),q}function n(W){return W.read(4).readUInt32BE(0)}function o(W){const q=R.VSBuffer.alloc(1);return q.writeUInt8(W,0),q}const t={Undefined:o(h.Undefined),String:o(h.String),Buffer:o(h.Buffer),VSBuffer:o(h.VSBuffer),Array:o(h.Array),Object:o(h.Object)},s=typeof Buffer<"u";function r(W,q){if(typeof q>"u")W.write(t.Undefined);else if(typeof q=="string"){const Y=R.VSBuffer.fromString(q);W.write(t.String),W.write(d(Y.byteLength)),W.write(Y)}else if(s&&Buffer.isBuffer(q)){const Y=R.VSBuffer.wrap(q);W.write(t.Buffer),W.write(d(Y.byteLength)),W.write(Y)}else if(q instanceof R.VSBuffer)W.write(t.VSBuffer),W.write(d(q.byteLength)),W.write(q);else if(Array.isArray(q)){W.write(t.Array),W.write(d(q.length));for(const Y of q)r(W,Y)}else{const Y=R.VSBuffer.fromString(JSON.stringify(q));W.write(t.Object),W.write(d(Y.byteLength)),W.write(Y)}}function l(W){switch(W.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return W.read(n(W)).toString();case h.Buffer:return W.read(n(W)).buffer;case h.VSBuffer:return W.read(n(W));case h.Array:{const Y=n(W),ee=[];for(let ce=0;ce<Y;ce++)ee.push(l(W));return ee}case h.Object:return JSON.parse(W.read(n(W)).toString())}}class a{constructor(q,Y,ee=null,ce=1e3){this.protocol=q,this.ctx=Y,this.logger=ee,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(J=>this.onRawMessage(J)),this.sendResponse({type:200})}registerChannel(q,Y){this.channels.set(q,Y),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const Y=this.send([q.type]);this.logger?.logOutgoing(Y,0,1,y(q.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([q.type,q.id],q.data);this.logger?.logOutgoing(Y,q.id,1,y(q.type),q.data);return}}}send(q,Y=void 0){const ee=new c;return r(ee,q),r(ee,Y),this.sendBuffer(ee.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const Y=new p(q),ee=l(Y),ce=l(Y),J=ee[0];switch(J){case 100:return this.logger?.logIncoming(q.byteLength,ee[1],1,`${f(J)}: ${ee[2]}.${ee[3]}`,ce),this.onPromise({type:J,id:ee[1],channelName:ee[2],name:ee[3],arg:ce});case 102:return this.logger?.logIncoming(q.byteLength,ee[1],1,`${f(J)}: ${ee[2]}.${ee[3]}`,ce),this.onEventListen({type:J,id:ee[1],channelName:ee[2],name:ee[3],arg:ce});case 101:return this.logger?.logIncoming(q.byteLength,ee[1],1,`${f(J)}`),this.disposeActiveRequest({type:J,id:ee[1]});case 103:return this.logger?.logIncoming(q.byteLength,ee[1],1,`${f(J)}`),this.disposeActiveRequest({type:J,id:ee[1]})}}onPromise(q){const Y=this.channels.get(q.channelName);if(!Y){this.collectPendingRequest(q);return}const ee=new k.CancellationTokenSource;let ce;try{ce=Y.call(this.ctx,q.name,q.arg,ee.token)}catch(_){ce=Promise.reject(_)}const J=q.id;ce.then(_=>{this.sendResponse({id:J,data:_,type:201}),this.activeRequests.delete(q.id)},_=>{_ instanceof Error?this.sendResponse({id:J,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:J,data:_,type:203}),this.activeRequests.delete(q.id)});const z=(0,w.toDisposable)(()=>ee.cancel());this.activeRequests.set(q.id,z)}onEventListen(q){const Y=this.channels.get(q.channelName);if(!Y){this.collectPendingRequest(q);return}const ee=q.id,J=Y.listen(this.ctx,q.name,q.arg)(z=>this.sendResponse({id:ee,data:z,type:204}));this.activeRequests.set(q.id,J)}disposeActiveRequest(q){const Y=this.activeRequests.get(q.id);Y&&(Y.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let Y=this.pendingRequests.get(q.channelName);Y||(Y=[],this.pendingRequests.set(q.channelName,Y));const ee=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:q,timeoutTimer:ee})}flushPendingRequests(q){const Y=this.pendingRequests.get(q);if(Y){for(const ee of Y)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.onPromise(ee.request);break;case 102:this.onEventListen(ee.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var g;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class P{constructor(q,Y=null){this.protocol=q,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new C.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ee=>this.onBuffer(ee)),this.logger=Y}getChannel(q){const Y=this;return{call(ee,ce,J){return Y.isDisposed?Promise.reject(new I.CancellationError):Y.requestPromise(q,ee,ce,J)},listen(ee,ce){return Y.isDisposed?C.Event.None:Y.requestEvent(q,ee,ce)}}}requestPromise(q,Y,ee,ce=k.CancellationToken.None){const J=this.lastRequestId++,_={id:J,type:100,channelName:q,name:Y,arg:ee};if(ce.isCancellationRequested)return Promise.reject(new I.CancellationError);let M;return new Promise((H,Z)=>{if(ce.isCancellationRequested)return Z(new I.CancellationError);const oe=()=>{const le=ue=>{switch(ue.type){case 201:this.handlers.delete(J),H(ue.data);break;case 202:{this.handlers.delete(J);const pe=new Error(ue.data.message);pe.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,pe.name=ue.data.name,Z(pe);break}case 203:this.handlers.delete(J),Z(ue.data);break}};this.handlers.set(J,le),this.sendRequest(_)};let X=null;this.state===u.Idle?oe():(X=(0,i.createCancelablePromise)(le=>this.whenInitialized()),X.then(()=>{X=null,oe()}));const ie=()=>{X?(X.cancel(),X=null):this.sendRequest({id:J,type:101}),Z(new I.CancellationError)},ne=ce.onCancellationRequested(ie);M=(0,w.combinedDisposable)((0,w.toDisposable)(ie),ne),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(q,Y,ee){const ce=this.lastRequestId++,z={id:ce,type:102,channelName:q,name:Y,arg:ee};let _=null;const M=new C.Emitter({onWillAddFirstListener:()=>{_=(0,i.createCancelablePromise)(H=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(M),this.sendRequest(z)})},onDidRemoveLastListener:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(M),this.sendRequest({id:ce,type:103}))}}),G=H=>M.fire(H.data);return this.handlers.set(ce,G),M.event}sendRequest(q){switch(q.type){case 100:case 102:{const Y=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger?.logOutgoing(Y,q.id,0,`${f(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const Y=this.send([q.type,q.id]);this.logger?.logOutgoing(Y,q.id,0,f(q.type));return}}}send(q,Y=void 0){const ee=new c;return r(ee,q),r(ee,Y),this.sendBuffer(ee.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const Y=new p(q),ee=l(Y),ce=l(Y),J=ee[0];switch(J){case 200:return this.logger?.logIncoming(q.byteLength,0,0,y(J)),this.onResponse({type:ee[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(q.byteLength,ee[1],0,y(J),ce),this.onResponse({type:ee[0],id:ee[1],data:ce})}}onResponse(q){if(q.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(q.id)?.(q)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ve([T.memoize],P.prototype,"onDidInitializePromise",null),e.ChannelClient=P;class A{get connections(){const q=[];return this._connections.forEach(Y=>q.push(Y)),q}constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new C.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new C.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,q(({protocol:Y,onDidClientDisconnect:ee})=>{C.Event.once(Y.onMessage)(J=>{const z=new p(J),_=l(z),M=new a(Y,_),G=new P(Y);this.channels.forEach((Z,oe)=>M.registerChannel(oe,Z));const H={channelServer:M,channelClient:G,ctx:_};this._connections.add(H),this._onDidAddConnection.fire(H),ee(()=>{M.dispose(),G.dispose(),this._connections.delete(H),this._onDidRemoveConnection.fire(H)})})})}getChannel(q,Y){const ee=this;return{call(ce,J,z){let _;if((0,S.isFunction)(Y)){const G=(0,D.getRandomElement)(ee.connections.filter(Y));_=G?Promise.resolve(G):C.Event.toPromise(C.Event.filter(ee.onDidAddConnection,Y))}else _=Y.routeCall(ee,ce,J);const M=_.then(G=>G.channelClient.getChannel(q));return O(M).call(ce,J,z)},listen(ce,J){if((0,S.isFunction)(Y))return ee.getMulticastEvent(q,Y,ce,J);const z=Y.routeEvent(ee,ce,J).then(_=>_.channelClient.getChannel(q));return O(z).listen(ce,J)}}}getMulticastEvent(q,Y,ee,ce){const J=this;let z=new w.DisposableStore;const _=new C.Emitter({onWillAddFirstListener:()=>{z=new w.DisposableStore;const M=new C.EventMultiplexer,G=new Map,H=oe=>{const ie=oe.channelClient.getChannel(q).listen(ee,ce),ne=M.add(ie);G.set(oe,ne)},Z=oe=>{const X=G.get(oe);!X||(X.dispose(),G.delete(oe))};J.connections.filter(Y).forEach(H),C.Event.filter(J.onDidAddConnection,Y)(H,void 0,z),J.onDidRemoveConnection(Z,void 0,z),M.event(_.fire,_,z),z.add(M)},onDidRemoveLastListener:()=>{z.dispose()}});return _.event}registerChannel(q,Y){this.channels.set(q,Y),this._connections.forEach(ee=>{ee.channelServer.registerChannel(q,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class V{constructor(q,Y,ee=null){const ce=new c;r(ce,Y),q.send(ce.buffer),this.channelClient=new P(q,ee),this.channelServer=new a(q,Y,ee)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,Y){this.channelServer.registerChannel(q,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=V;function O(W){return{call(q,Y,ee){return W.then(ce=>ce.call(q,Y,ee))},listen(q,Y){const ee=new C.Relay;return W.then(ce=>ee.input=ce.listen(q,Y)),ee.event}}}e.getDelayedChannel=O;function F(W){let q=!1;return{call(Y,ee,ce){return q?W.call(Y,ee,ce):(0,i.timeout)(0).then(()=>q=!0).then(()=>W.call(Y,ee,ce))},listen(Y,ee){if(q)return W.listen(Y,ee);const ce=new C.Relay;return(0,i.timeout)(0).then(()=>q=!0).then(()=>ce.input=W.listen(Y,ee)),ce.event}}}e.getNextTickChannel=F;class N{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const Y of q.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await C.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=N;var L;(function(W){function q(J,z){const _=J,M=z&&z.disableMarshalling,G=new Map;for(const H in _)ee(H)&&G.set(H,C.Event.buffer(_[H],!0));return new class{listen(H,Z,oe){const X=G.get(Z);if(X)return X;if(ce(Z)){const ie=_[Z];if(typeof ie=="function")return ie.call(_,oe)}throw new Error(`Event not found: ${Z}`)}call(H,Z,oe){const X=_[Z];if(typeof X=="function"){if(!M&&Array.isArray(oe))for(let ie=0;ie<oe.length;ie++)oe[ie]=(0,E.revive)(oe[ie]);return X.apply(_,oe)}throw new Error(`Method not found: ${Z}`)}}}W.fromService=q;function Y(J,z){const _=z&&z.disableMarshalling;return new Proxy({},{get(M,G){if(typeof G=="string")return z?.properties?.has(G)?z.properties.get(G):ce(G)?function(H){return J.listen(G,H)}:ee(G)?J.listen(G):async function(...H){let Z;z&&!(0,S.isUndefinedOrNull)(z.context)?Z=[z.context,...H]:Z=H;const oe=await J.call(G,Z);return _?oe:(0,E.revive)(oe)};throw new Error(`Property not found: ${String(G)}`)}})}W.toService=Y;function ee(J){return J[0]==="o"&&J[1]==="n"&&b.isUpperAsciiLetter(J.charCodeAt(2))}function ce(J){return/^onDynamic/.test(J)&&b.isUpperAsciiLetter(J.charCodeAt(9))}})(L=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const q=W.toString();if(q!=="[object Object]")return q}return W}function x(W){return Array.isArray(W)?W.map($):$(W)}function j(W,q,Y,ee,ce,J,z){z=x(z);const _=U[ce],M=_[ee%_.length];let G=[`%c[${W}]%c[${String(q).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(J)?(G=G.concat(z),G.push(")")):G.push(z),console.log.apply(console,G)}class B{constructor(q,Y){this._outgoingPrefix=q,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,Y,ee,ce,J){this._totalOutgoing+=q,j(this._outgoingPrefix,this._totalOutgoing,q,Y,ee,ce,J)}logIncoming(q,Y,ee,ce,J){this._totalIncoming+=q,j(this._incomingPrefix,this._totalIncoming,q,Y,ee,ce,J)}}e.IPCLogger=B}),define(re[148],se([0,1,17,3,38]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(C){this.port=C,this.onMessage=i.Event.fromDOMEventEmitter(this.port,"message",w=>D.VSBuffer.wrap(w.data)),C.start()}send(C){this.port.postMessage(C.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class T extends R.IPCClient{constructor(C,w){const E=new k(C);super(E,w),this.protocol=E}dispose(){this.protocol.disconnect()}}e.Client=T}),define(re[91],se([0,1,17,3,2,38]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const r=new WeakMap;let l=0;function a(P,A){if(!r.has(P)){const V=String(++l);r.set(P,V)}return r.get(P)}function g(P,A,V,O){if(!s.enableDiagnostics)return;const F=a(P,A);if(O instanceof D.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const N=D.VSBuffer.alloc(O.byteLength);N.set(O),s.records.push({timestamp:Date.now(),id:F,label:A,type:V,buff:N})}else s.records.push({timestamp:Date.now(),id:F,label:A,type:V,data:O})}s.traceSocketEvent=g})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var C;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function E(){return w||(w=D.VSBuffer.alloc(0)),w}class b{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,l){if(r===0)return E();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const A=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=r),A}if(this._chunks[0].byteLength>r){const A=this._chunks[0].slice(0,r);return l&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),A}const a=D.VSBuffer.alloc(r);let g=0,P=0;for(;r>0;){const A=this._chunks[P];if(A.byteLength>r){const V=A.slice(0,r);a.set(V,g),g+=r,l&&(this._chunks[P]=A.slice(r),this._totalLength-=r),r-=r}else a.set(A,g),g+=A.byteLength,l?(this._chunks.shift(),this._totalLength-=A.byteLength):P++,r-=A.byteLength}return a}}e.ChunkStream=b;var S;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(S||(S={}));function m(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class v{constructor(r,l,a,g){this.type=r,this.id=l,this.ack=a,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends R.Disposable{constructor(r){super(),this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:m(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,g=this._state.id,P=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",l),this._onMessage.fire(new v(a,g,P,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=D.VSBuffer.alloc(13);l.writeUInt8(r.type,0),l.writeUInt32BE(r.id,1),l.writeUInt32BE(r.ack,5),l.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:m(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(l,r.data)}_bufferAdd(r,l){const a=this._totalLength===0;return this._data.push(r,l),this._totalLength+=r.byteLength+l.byteLength,a}_bufferTake(){const r=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,l){this._bufferAdd(r,l)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class p extends R.Disposable{constructor(r){super(),this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new y(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new v(1,0,0,r))}}e.Protocol=p;class c extends k.IPCClient{static fromSocket(r,l){return new c(new p(r),l)}get onDidDispose(){return this.protocol.onDidDispose}constructor(r,l,a=null){super(r,l,a),this.protocol=r}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=c;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class d{constructor(r){this.data=r,this.next=null}}class n{constructor(){this._first=null,this._last=null}length(){let r=0,l=this._first;for(;l;)l=l.next,r++;return r}peek(){return this._first?this._first.data:null}toArray(){const r=[];let l=0,a=this._first;for(;a;)r[l++]=a.data,a=a.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const l=new d(r);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class o{static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const r=Date.now();for(let l=0;l<o._HISTORY_LENGTH;l++)this.lastRuns[l]=r-1e3*l;setInterval(()=>{for(let l=o._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}load(){const r=Date.now(),l=(1+o._HISTORY_LENGTH)*1e3;let a=0;for(let g=0;g<o._HISTORY_LENGTH;g++)r-this.lastRuns[g]<=l&&a++;return 1-a/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class t{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(r,l=null,a=o.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(g=>this._receiveMessage(g))),this._socketDisposables.push(this._socket.onClose(g=>this._onSocketClose.fire(g))),l&&this._socketReader.acceptChunk(l),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new v(5,0,0,E());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new v(7,0,0,E());this._socketWriter.write(r)}sendResume(){const r=new v(8,0,0,E());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,l){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new v(3,0,this._incomingAckId,E());this._socketWriter.write(r);const l=this._outgoingUnackMsg.toArray();for(let a=0,g=l.length;a<g;a++)this._socketWriter.write(l[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new v(6,0,0,E())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const l=this._outgoingUnackMsg.toArray();for(let a=0,g=l.length;a<g;a++)this._socketWriter.write(l[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new v(1,l,this._incomingAckId,r);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(r){const l=new v(2,0,0,r);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),l=Date.now()-r.writtenTime,a=Date.now()-this._socketReader.lastReadTime,g=Date.now()-this._lastSocketTimeoutTime;if(l>=2e4&&a>=2e4&&g>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:a});return}const P=Math.max(2e4-l,2e4-a,2e4-g,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},P)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new v(3,0,this._incomingAckId,E());this._socketWriter.write(r)}_sendKeepAlive(){const r=new v(9,0,0,E());this._socketWriter.write(r)}}e.PersistentProtocol=t}),define(re[149],se([0,1,92,3,38,148]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends R.IPCServer{static getOnDidClientConnect(){const C=i.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(w,E)=>E);return i.Event.map(C,w=>{const{port1:E,port2:b}=new MessageChannel,m={protocol:new k.Protocol(E),onDidClientDisconnect:i.Event.fromDOMEventEmitter(E,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",w,[b]),m})}constructor(){super(T.getOnDidClientConnect())}}e.Server=T}),define(re[68],se([0,1,50,6,17,22,142,11,3,2,31,90,85,38]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends m.ChannelServer{constructor(u){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",p=>R.VSBuffer.wrap(Buffer.from(p,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=f;class v{constructor(u,p){this.modulePath=u,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new C.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new i.Delayer(c),this.child=null,this._client=null}getChannel(u){const p=this;return{call(c,h,d){return p.requestPromise(u,c,h,d)},listen(c,h){return p.requestEvent(u,c,h)}}}requestPromise(u,p,c,h=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const d=this.getCachedChannel(u),n=(0,i.createCancelablePromise)(s=>d.call(p,c,s)),o=h.onCancellationRequested(()=>n.cancel()),t=(0,w.toDisposable)(()=>n.cancel());return this.activeRequests.add(t),n.finally(()=>{o.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(u,p,c){if(!this.disposeDelayer)return C.Event.None;this.disposeDelayer.cancel();let h;const d=new C.Emitter({onWillAddFirstListener:()=>{h=this.getCachedChannel(u).listen(p,c)(d.fire,d),this.activeRequests.add(h)},onDidRemoveLastListener:()=>{this.activeRequests.delete(h),h.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return d.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,S.removeDangerousEnvVariables)(p.env),this.child=(0,D.fork)(this.modulePath,u,p);const c=new C.Emitter;C.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,T.isRemoteConsoleLog)(r)){(0,T.log)(r,`IPC Library: ${this.options.serverName}`);return}c.fire(R.VSBuffer.wrap(Buffer.from(r,"base64")))});const d=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,n=r=>this.child&&this.child.connected&&d.send(r.buffer.toString("base64")),o=c.event,t={send:n,onMessage:o};this._client=new m.ChannelClient(t);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,l)=>{process.removeListener("exit",s),this.activeRequests.forEach(a=>(0,w.dispose)(a)),this.activeRequests.clear(),r!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+l),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:l})})}return this._client}getCachedChannel(u){let p=this.channels.get(u);return p||(p=this.client.getChannel(u),this.channels.set(u,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=v}),define(re[150],se([0,1,17,11,3,2,12,5,30,38,91]),function(Q,e,D,i,R,k,T,I,C,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function b(){return{crypto:Q.__$__nodeRequire("crypto"),zlib:Q.__$__nodeRequire("zlib"),net:Q.__$__nodeRequire("net"),os:Q.__$__nodeRequire("os")}}class S{traceSocketEvent(a,g){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,g)}constructor(a,g=""){this._canWrite=!0,this.debugLabel=g,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,i.onUnexpectedError)(P)}},this.socket.on("error",this._errorListener),this._closeListener=P=>{this.traceSocketEvent("close",{hadError:P}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(a){const g=P=>{this.traceSocketEvent("read",P),a(D.VSBuffer.wrap(P))};return this.socket.on("data",g),{dispose:()=>this.socket.off("data",g)}}onClose(a){const g=P=>{a({type:0,hadError:P,error:void 0})};return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(a){const g=()=>{a()};return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(a){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,g=>{if(g){if(g.code==="EPIPE")return;(0,i.onUnexpectedError)(g)}})}catch(g){if(g.code==="EPIPE")return;(0,i.onUnexpectedError)(g)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,g)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.NodeSocket=S;var m;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(m||(m={}));var f;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(f||(f={}));class v extends k.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(a,g){this.socket.traceSocketEvent(a,g)}constructor(a,g,P,A){super(),this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:g,inflateBytesLength:P?.byteLength||0,recordInflateBytes:A}),this._flowManager=this._register(new y(this,g,P,A,this._onData,(V,O)=>this._write(V,O))),this._register(this._flowManager.onError(V=>{console.error(V),(0,i.onUnexpectedError)(V),this._onClose.fire({type:0,hadError:!0,error:V})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(V=>this._acceptChunk(V))),this._register(this.socket.onClose(V=>this._onClose.fire(V)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this._onData.event(a)}onClose(a){return this._onClose.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this._flowManager.writeMessage(a)}_write(a,g){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let P=2;a.byteLength<126?P+=0:a.byteLength<2**16?P+=2:P+=8;const A=D.VSBuffer.alloc(P);if(g?A.writeUInt8(194,0):A.writeUInt8(130,0),a.byteLength<126)A.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){A.writeUInt8(126,1);let V=1;A.writeUInt8(a.byteLength>>>8&255,++V),A.writeUInt8(a.byteLength>>>0&255,++V)}else{A.writeUInt8(127,1);let V=1;A.writeUInt8(0,++V),A.writeUInt8(0,++V),A.writeUInt8(0,++V),A.writeUInt8(0,++V),A.writeUInt8(a.byteLength>>>24&255,++V),A.writeUInt8(a.byteLength>>>16&255,++V),A.writeUInt8(a.byteLength>>>8&255,++V),A.writeUInt8(a.byteLength>>>0&255,++V)}this.socket.write(D.VSBuffer.concat([A,a]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(a){if(a.byteLength!==0){for(this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const g=this._incomingData.peek(this._state.readLen),P=g.readUInt8(0),A=(P&128)>>>7,V=(P&64)>>>6,O=g.readUInt8(1),F=(O&128)>>>7,N=O&127;this._state.state=2,this._state.readLen=2+(F?4:0)+(N===126?2:0)+(N===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(V)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const g=this._incomingData.read(this._state.readLen),P=g.readUInt8(1),A=(P&128)>>>7;let V=P&127,O=1;V===126?V=g.readUInt8(++O)*2**8+g.readUInt8(++O):V===127&&(V=g.readUInt8(++O)*0+g.readUInt8(++O)*0+g.readUInt8(++O)*0+g.readUInt8(++O)*0+g.readUInt8(++O)*2**24+g.readUInt8(++O)*2**16+g.readUInt8(++O)*2**8+g.readUInt8(++O));let F=0;A&&(F=g.readUInt8(++O)*2**24+g.readUInt8(++O)*2**16+g.readUInt8(++O)*2**8+g.readUInt8(++O)),this._state.state=3,this._state.readLen=V,this._state.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const g=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",g),c(g,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",g),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(g,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=v;class y extends k.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}constructor(a,g,P,A,V,O){super(),this._tracer=a,this._onData=V,this._writeFn=O,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,g?(this._zlibInflateStream=this._register(new u(this._tracer,A,P,{windowBits:15})),this._zlibDeflateStream=this._register(new p(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(F=>this._onError.fire(F))),this._register(this._zlibDeflateStream.onError(F=>this._onError.fire(F)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(a){this._writeQueue.push(a),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const a=this._writeQueue.shift();if(this._zlibDeflateStream){const g=await this._deflateMessage(this._zlibDeflateStream,a);this._writeFn(g,!0)}else this._writeFn(a,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(a,g){return new Promise((P,A)=>{a.write(g),a.flush(V=>P(V))})}acceptFrame(a,g,P){this._readQueue.push({data:a,isCompressed:g,isLastFrameOfMessage:P}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const a=this._readQueue.shift();if(this._zlibInflateStream&&a.isCompressed){const g=await this._inflateFrame(this._zlibInflateStream,a.data,a.isLastFrameOfMessage);this._onData.fire(g)}else this._onData.fire(a.data)}this._isProcessingReadQueue=!1}}_inflateFrame(a,g,P){return new Promise((A,V)=>{a.write(g),P&&a.write(D.VSBuffer.fromByteArray([0,0,255,255])),a.flush(O=>A(O))})}}class u extends k.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}constructor(a,g,P,A){super(),this._tracer=a,this._recordInflateBytes=g,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=b().zlib.createInflateRaw(A),this._zlibInflate.on("error",V=>{this._tracer.traceSocketEvent("zlibInflateError",{message:V?.message,code:V?.code}),this._onError.fire(V)}),this._zlibInflate.on("data",V=>{this._tracer.traceSocketEvent("zlibInflateData",V),this._pendingInflateData.push(D.VSBuffer.wrap(V))}),P&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this._zlibInflate.write(P.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(a){this._recordInflateBytes&&this._recordedInflateBytes.push(a.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",a),this._zlibInflate.write(a.buffer)}flush(a){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const g=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,a(g)})}}class p extends k.Disposable{constructor(a,g){super(),this._tracer=a,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=b().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",P=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this._onError.fire(P)}),this._zlibDeflate.on("data",P=>{this._tracer.traceSocketEvent("zlibDeflateData",P),this._pendingDeflateData.push(D.VSBuffer.wrap(P))})}write(a){this._tracer.traceSocketEvent("zlibDeflateWrite",a.buffer),this._zlibDeflate.write(a.buffer)}flush(a){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let g=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,g=g.slice(0,g.byteLength-4),a(g)})}}function c(l,a){if(a===0)return;const g=l.byteLength>>>2;for(let N=0;N<g;N++){const L=l.readUInt32BE(N*4);l.writeUInt32BE(L^a,N*4)}const P=g*4,A=l.byteLength-P,V=a>>>24&255,O=a>>>16&255,F=a>>>8&255;A>=1&&l.writeUInt8(l.readUInt8(P)^V,P),A>=2&&l.writeUInt8(l.readUInt8(P+1)^O,P+1),A>=3&&l.writeUInt8(l.readUInt8(P+2)^F,P+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const h={[2]:107,[1]:103};function d(){const l=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):a=(0,T.join)(b().os.tmpdir(),`vscode-ipc-${l}.sock`),o(a),a}e.createRandomIPCHandle=d;function n(l,a,g){const P=b().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${g}-${a}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${P.substr(0,8)}-${g}-${a}.sock`):A=(0,T.join)(l,`${g}-${a}.sock`),o(A),A}e.createStaticIPCHandle=n;function o(l){const a=h[I.platform];typeof a=="number"&&l.length>=a&&console.warn(`WARNING: IPC handle "${l}" is longer than ${a} chars, try a shorter --user-data-dir`)}class t extends w.IPCServer{static toClientConnectionEvent(a){const g=R.Event.fromNodeEventEmitter(a,"connection");return R.Event.map(g,P=>({protocol:new E.Protocol(new S(P,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(P,"close"))}))}constructor(a){super(t.toClientConnectionEvent(a)),this.server=a}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function s(l){return new Promise((a,g)=>{const P=b().net.createServer();P.on("error",g),P.listen(l,()=>{P.removeListener("error",g),a(new t(P))})})}e.serve=s;function r(l,a){return new Promise((g,P)=>{const A=b().net.createConnection(l,()=>{A.removeListener("error",P),g(E.Client.fromSocket(new S(A,`ipc-client${a}`),a))});A.once("error",P)})}e.connect=r}),define(re[69],se([0,1,6,3,2,15]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function I(b){const S=b;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var C;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(C=e.StorageState||(e.StorageState={}));class w extends R.Disposable{constructor(S,m=Object.create(null)){super(),this.database=S,this.options=m,this._onDidChangeStorage=this._register(new i.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=C.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((m,f)=>this.accept(f,m)),S.deleted?.forEach(m=>this.accept(m,void 0))}accept(S,m){if(this.state===C.Closed)return;let f=!1;(0,k.isUndefinedOrNull)(m)?f=this.cache.delete(S):this.cache.get(S)!==m&&(this.cache.set(S,m),f=!0),f&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===C.None&&(this.state=C.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,m){const f=this.cache.get(S);return(0,k.isUndefinedOrNull)(f)?m:f}getBoolean(S,m){const f=this.get(S);return(0,k.isUndefinedOrNull)(f)?m:f==="true"}getNumber(S,m){const f=this.get(S);return(0,k.isUndefinedOrNull)(f)?m:parseInt(f,10)}async set(S,m){if(this.state===C.Closed)return;if((0,k.isUndefinedOrNull)(m))return this.delete(S);const f=String(m);if(this.cache.get(S)!==f)return this.cache.set(S,f),this.pendingInserts.set(S,f),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async delete(S){if(!(this.state===C.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=C.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!!this.hasPending)return this.doFlush(S)}async doFlush(S){return this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=i.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((m,f)=>this.items.set(f,m)),S.delete?.forEach(m=>this.items.delete(m))}async close(){}}e.InMemoryStorageDatabase=E}),define(re[151],se([9,10]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(re[152],se([9,10]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[153],se([9,10]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(re[154],se([9,10]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(re[155],se([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[156],se([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[157],se([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[158],se([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[159],se([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(re[160],se([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[161],se([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[162],se([9,10]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[163],se([9,10]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(re[164],se([9,10]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(re[165],se([9,10]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(re[166],se([9,10]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[167],se([9,10]),function(Q,e){return Q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[168],se([9,10]),function(Q,e){return Q.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(re[169],se([9,10]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(re[170],se([9,10]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(re[171],se([9,10]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[172],se([9,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[173],se([9,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[174],se([9,10]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[175],se([9,10]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[176],se([9,10]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[177],se([9,10]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[178],se([9,10]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[179],se([9,10]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[180],se([9,10]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[181],se([9,10]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(re[182],se([9,10]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(re[93],se([0,1,65,63,23,12,36,20,8]),function(Q,e,D,i,R,k,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class w{get appRoot(){return(0,k.dirname)(R.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return C.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return C.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.paths.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const v=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",v)}return this.args.logsPath}get userDataSyncLogResource(){return C.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return C.URI.file((0,k.join)(this.logsPath,"editSessions.log"))}get remoteTunnelLogResource(){return C.URI.file((0,k.join)(this.logsPath,"remoteTunnel.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(C.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=T.env.VSCODE_PORTABLE;return v?C.URI.file((0,k.join)(v,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,k.resolve)(v):(0,k.normalize)((0,k.join)(R.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadLocation(){const v=this.args["extensions-download-dir"];return v?C.URI.file((0,k.resolve)(v)):C.URI.file((0,k.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,k.resolve)(v);const y=T.env.VSCODE_EXTENSIONS;if(y)return y;const u=T.env.VSCODE_PORTABLE;return u?(0,k.join)(u,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(y=>/^[^:/?#]+?:\/\//.test(y)?C.URI.parse(y):C.URI.file((0,k.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?C.URI.parse(v):C.URI.file((0,k.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(v=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(v))}get extensionLogLevel(){const v=[];for(const y of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);u&&u[1]&&u[2]&&v.push([u[1],u[2]])}return v.length?v:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return C.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const v=T.env.VSCODE_PORTABLE;return v?C.URI.file((0,k.join)(v,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(v){this.args.continueOn=v}get args(){return this._args}constructor(v,y,u){this._args=v,this.paths=y,this.productService=u,this.editSessionId=this.args.editSessionId}}ve([i.memoize],w.prototype,"appRoot",null),ve([i.memoize],w.prototype,"userHome",null),ve([i.memoize],w.prototype,"userDataPath",null),ve([i.memoize],w.prototype,"appSettingsHome",null),ve([i.memoize],w.prototype,"tmpDir",null),ve([i.memoize],w.prototype,"cacheHome",null),ve([i.memoize],w.prototype,"stateResource",null),ve([i.memoize],w.prototype,"userRoamingDataHome",null),ve([i.memoize],w.prototype,"userDataSyncHome",null),ve([i.memoize],w.prototype,"userDataSyncLogResource",null),ve([i.memoize],w.prototype,"editSessionsLogResource",null),ve([i.memoize],w.prototype,"remoteTunnelLogResource",null),ve([i.memoize],w.prototype,"sync",null),ve([i.memoize],w.prototype,"machineSettingsResource",null),ve([i.memoize],w.prototype,"workspaceStorageHome",null),ve([i.memoize],w.prototype,"localHistoryHome",null),ve([i.memoize],w.prototype,"keyboardLayoutResource",null),ve([i.memoize],w.prototype,"argvResource",null),ve([i.memoize],w.prototype,"isExtensionDevelopment",null),ve([i.memoize],w.prototype,"untitledWorkspacesHome",null),ve([i.memoize],w.prototype,"installSourcePath",null),ve([i.memoize],w.prototype,"builtinExtensionsPath",null),ve([i.memoize],w.prototype,"extensionsPath",null),ve([i.memoize],w.prototype,"extensionDevelopmentLocationURI",null),ve([i.memoize],w.prototype,"extensionDevelopmentKind",null),ve([i.memoize],w.prototype,"extensionTestsLocationURI",null),ve([i.memoize],w.prototype,"debugExtensionHost",null),ve([i.memoize],w.prototype,"logLevel",null),ve([i.memoize],w.prototype,"extensionLogLevel",null),ve([i.memoize],w.prototype,"serviceMachineIdResource",null),ve([i.memoize],w.prototype,"telemetryLogResource",null),ve([i.memoize],w.prototype,"disableWorkspaceTrust",null),ve([i.memoize],w.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=w;function E(f,v){return m(f["inspect-extensions"],f["inspect-brk-extensions"],5870,v,f.debugId,f.extensionEnvironment)}e.parseExtensionHostPort=E;function b(f,v){return m(f["inspect-search"],f["inspect-brk-search"],5876,v,f.extensionEnvironment)}e.parseSearchPort=b;function S(f,v){return m(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,v,f.extensionEnvironment)}e.parsePtyHostPort=S;function m(f,v,y,u,p,c){const d=Number(v||f)||(u?null:y),n=d?Boolean(!!v):!1;let o;if(c)try{o=JSON.parse(c)}catch{}return{port:d,break:n,debugId:p,env:o}}}),define(re[183],se([0,1,283,5,153]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,R.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,R.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(12,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,R.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,R.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(17,null)},category:{type:"string",cat:"e",description:(0,R.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,R.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,R.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,R.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,R.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,R.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,R.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,R.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,R.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,R.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(v,y,u=T){const p=v.find(l=>l.length>0&&l[0]!=="-"),c={},h=["_"],d=[],n={};let o;for(const l in y){const a=y[l];a.type==="subcommand"?l===p&&(o=a):(a.alias&&(c[l]=a.alias),a.type==="string"||a.type==="string[]"?(h.push(l),a.deprecates&&h.push(...a.deprecates)):a.type==="boolean"&&(d.push(l),a.deprecates&&d.push(...a.deprecates)),a.global&&(n[l]=a))}if(o&&p){const l=n;for(const A in o.options)l[A]=o.options[A];const a=v.filter(A=>A!==p),g=u.getSubcommandReporter?u.getSubcommandReporter(p):void 0,P=I(a,l,g);return{[p]:P,_:[]}}const t=D(v,{string:h,boolean:d,alias:c}),s={},r=t;s._=t._.map(l=>String(l)).filter(l=>l.length>0),delete r._;for(const l in y){const a=y[l];if(a.type==="subcommand")continue;a.alias&&delete r[a.alias];let g=r[l];if(a.deprecates)for(const P of a.deprecates)r.hasOwnProperty(P)&&(g||(g=r[P],g&&u.onDeprecatedOption(P,a.deprecationMessage||(0,R.localize)(36,null,l))),delete r[P]);if(typeof g<"u"){if(a.type==="string[]"){if(Array.isArray(g)||(g=[g]),!a.allowEmptyValue){const P=g.filter(A=>A.length>0);P.length!==g.length&&(u.onEmptyValue(l),g=P.length>0?P:void 0)}}else a.type==="string"&&(Array.isArray(g)?(g=g.pop(),u.onMultipleValues(l,g)):!g&&!a.allowEmptyValue&&(u.onEmptyValue(l),g=void 0));s[l]=g,a.deprecationMessage&&u.onDeprecatedOption(l,a.deprecationMessage)}delete r[l]}for(const l in r)u.onUnknownOption(l);return s}e.parseArgs=I;function C(v,y){let u="";return y.args&&(Array.isArray(y.args)?u=` <${y.args.join("> <")}>`:u=` <${y.args}>`),y.alias?`-${y.alias} --${v}${u}`:`--${v}${u}`}function w(v,y){const u=[];for(const p in v){const c=v[p],h=C(p,c);u.push([h,c.description])}return E(u,y)}e.formatOptions=w;function E(v,y){const p=v.reduce((d,n)=>Math.max(d,n[0].length),12)+2+1;if(y-p<25)return v.reduce((d,n)=>d.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const c=y-p-1,h=[];for(const d of v){const n=d[0],o=S(d[1],c),t=b(p-n.length-2);h.push("  "+n+t+o[0]);for(let s=1;s<o.length;s++)h.push(b(p)+o[s])}return h}function b(v){return" ".repeat(v)}function S(v,y){const u=[];for(;v.length;){const p=v.length<y?v.length:v.lastIndexOf(" ",y),c=v.slice(0,p).trim();v=v.slice(p),u.push(c)}return u}function m(v,y,u,p,c){const h=process.stdout.isTTY&&process.stdout.columns||80,d=c?.noInputFiles!==!0?`[${(0,R.localize)(37,null)}...]`:"",n=[`${v} ${u}`];n.push(""),n.push(`${(0,R.localize)(38,null)}: ${y} [${(0,R.localize)(39,null)}]${d}`),n.push(""),c?.noPipe!==!0&&(i.isWindows?n.push((0,R.localize)(40,null,y)):n.push((0,R.localize)(41,null,y)),n.push(""));const o={},t=[];for(const s in p){const r=p[s];if(r.type==="subcommand")r.description&&t.push({command:s,description:r.description});else if(r.description&&r.cat){let l=o[r.cat];l||(o[r.cat]=l={}),l[s]=r}}for(const s in o){const r=s,l=o[r];l&&(n.push(k[r]),n.push(...w(l,h)),n.push(""))}return t.length&&(n.push((0,R.localize)(42,null)),n.push(...E(t.map(s=>[s.command,s.description]),h)),n.push("")),n.join(`
`)}e.buildHelpMessage=m;function f(v,y){return`${v||(0,R.localize)(43,null)}
${y||(0,R.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=f}),define(re[184],se([0,1,284,154,183]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const k=2048;function T(S,m){const f=(h,d)=>{console.warn((0,i.localize)(0,null,h,d))},v=h=>{console.warn((0,i.localize)(1,null,h))},y=(h,d)=>{console.warn((0,i.localize)(2,null,h,d))},u=h=>({onUnknownOption:d=>{h!=="tunnel"&&console.warn((0,i.localize)(3,null,d,h))},onMultipleValues:f,onEmptyValue:v,onDeprecatedOption:y,getSubcommandReporter:h!=="tunnel"?u:void 0}),p={onUnknownOption:h=>{console.warn((0,i.localize)(4,null,h))},onMultipleValues:f,onEmptyValue:v,onDeprecatedOption:y,getSubcommandReporter:u},c=(0,R.parseArgs)(S,R.OPTIONS,m?p:void 0);return c.goto&&c._.forEach(h=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(h),(0,i.localize)(5,null))),c["max-memory"]&&D(parseInt(c["max-memory"])>=k,`The max-memory argument cannot be specified lower than ${k} MB.`),c}function I(S){const m=S.findIndex(f=>!/^-/.test(f));if(m>-1)return[...S.slice(0,m),...S.slice(m+1)]}function C(S){let[,...m]=S;process.env.VSCODE_DEV&&(m=I(m)||[]);const f=!b(process.env);return T(m,f)}e.parseMainProcessArgv=C;function w(S){let[,,...m]=S;return process.env.VSCODE_DEV&&(m=I(m)||[]),T(m,!0)}e.parseCLIProcessArgv=w;function E(S,...m){const f=S.indexOf("--");return f===-1?S.push(...m):S.splice(f,0,...m),S}e.addArg=E;function b(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),function(){"use strict";function Q(e,D,i){function R(T,I){const C=k(T,I),w=[C];return e.isAbsolute(C)||w.unshift(i),e.resolve(...w)}function k(T,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,I);const E=T["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(b,"AppData","Roaming")}break;case"darwin":w=e.join(D.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,I)}return{getUserDataPath:R}}if(typeof define=="function")define(re[185],se([285,34,36]),function(e,D,i){return Q(e,D,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=Q(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[186],se([0,1,34,93,185]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends i.AbstractNativeEnvironmentService{constructor(I,C){super(I,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(I,C.nameShort)},C)}}e.NativeEnvironmentService=k}),define(re[187],se([0,1,8]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const i=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,I=/^\s*url\s*=\s*(.+\S)\s*$/mg,C=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function w(y){const u=y.match(T);return u?u[1]:null}function E(y){if(y.indexOf("://")===-1){const u=y.match(i);return u?w(u[2]):null}try{const u=D.URI.parse(y);if(u.authority)return w(u.authority)}catch{}return null}function b(y,u){const p=new Set;let c;for(;c=I.exec(y);){const d=E(c[1]);d&&p.add(d)}const h=new Set(u);return Array.from(p).map(d=>h.has(d)?d:d.replace(C,"a"))}e.getDomainsOfRemotes=b;function S(y){const u=y.match(k);return u?u[2]:null}function m(y,u,p){return y&&u?(p&&u.endsWith(".git")&&(u=u.substr(0,u.length-4)),u.indexOf("/")===0?`${y}${u}`:`${y}/${u}`):null}function f(y,u){if(y.indexOf("://")===-1){const p=y.match(R);if(p)return m(p[2],p[3],u)}try{const p=D.URI.parse(y);if(p.authority)return m(S(p.authority),p.path,u)}catch{}return null}function v(y,u=!1){const p=[];let c;for(;c=I.exec(y);){const h=f(c[1],u);h&&p.push(h)}return p}e.getRemotes=v}),define(re[188],se([0,1,15,157]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function R(T,I,C){try{k(T,I,C)}catch(w){console.error(w?.message??w)}return T}e.localizeManifest=R;function k(T,I,C){const w=(E,b,S)=>{const m=E[b];if((0,D.isString)(m)){const f=m,v=f.length;if(v>1&&f[0]==="%"&&f[v-1]==="%"){const y=f.substr(1,v-2);let u=I[y];u===void 0&&C&&(u=C[y]);const p=typeof u=="string"?u:u?.message,c=C?.[y],h=typeof c=="string"?c:c?.message;if(!p){h||console.warn(`[${T.name}]: ${(0,i.localize)(0,null,y)}`);return}if(S&&(b==="title"||b==="category")&&h&&h!==p){const d={value:p,original:h};E[b]=d}else E[b]=p}}else if((0,D.isObject)(m))for(const f in m)m.hasOwnProperty(f)&&(f==="commands"?w(m,f,!0):w(m,f,S));else if(Array.isArray(m))for(let f=0;f<m.length;f++)w(m,f,S)};for(const E in T)T.hasOwnProperty(E)&&w(T,E)}}),define(re[189],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(k){this.channel=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,T,I,C){return this.channel.call("promptImportantExtensionsInstallNotification",[k,T,I,C])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class i{constructor(k){this.service=k}listen(k,T){throw new Error(`Event not found: ${T}`)}call(k,T,I){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(I[0],I[1],I[2],I[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=i}),define(re[70],se([0,1,20,87,162,54]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function C(u){return u=u.trim(),u==="*"||T.test(u)}e.isValidVersionStr=C;function w(u){if(!C(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=u.match(T);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=w;function E(u){if(!u)return null;const p=u.majorBase,c=u.majorMustEqual,h=u.minorBase;let d=u.minorMustEqual;const n=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&(p===0||(d=!1),o=!1);let t=0;if(u.preRelease){const s=I.exec(u.preRelease);if(s){const[,r,l,a]=s;t=Date.UTC(Number(r),Number(l)-1,Number(a))}}return{majorBase:p,majorMustEqual:c,minorBase:h,minorMustEqual:d,patchBase:n,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:t}}e.normalizeVersion=E;function b(u,p,c){let h;typeof u=="string"?h=E(w(u)):h=u;let d;p instanceof Date?d=p.getTime():typeof p=="string"&&(d=new Date(p).getTime());let n;if(typeof c=="string"?n=E(w(c)):n=c,!h||!n)return!1;const o=h.majorBase,t=h.minorBase,s=h.patchBase;let r=n.majorBase,l=n.minorBase,a=n.patchBase;const g=n.notBefore;let P=n.majorMustEqual,A=n.minorMustEqual,V=n.patchMustEqual;return n.isMinimum?o>r?!0:o<r?!1:t>l?!0:t<l||d&&d<g?!1:s>=a:(o===1&&r===0&&(!P||!A||!V)&&(r=1,l=0,a=0,P=!0,A=!1,V=!1),o<r?!1:o>r?!P:t<l?!1:t>l?!A:s<a?!1:s>a?!V:!(d&&d<g))}e.isValidVersion=b;function S(u,p,c,h,d){const n=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return n.push([i.default.Error,R.localize(0,null)]),n;if(typeof h.name!="string")return n.push([i.default.Error,R.localize(1,null,"name")]),n;if(typeof h.version!="string")return n.push([i.default.Error,R.localize(2,null,"version")]),n;if(!h.engines)return n.push([i.default.Error,R.localize(3,null,"engines")]),n;if(typeof h.engines.vscode!="string")return n.push([i.default.Error,R.localize(4,null,"engines.vscode")]),n;if(typeof h.extensionDependencies<"u"&&!y(h.extensionDependencies))return n.push([i.default.Error,R.localize(5,null,"extensionDependencies")]),n;if(typeof h.activationEvents<"u"){if(!y(h.activationEvents))return n.push([i.default.Error,R.localize(6,null,"activationEvents")]),n;if(typeof h.main>"u"&&typeof h.browser>"u")return n.push([i.default.Error,R.localize(7,null,"activationEvents","main")]),n}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&n.push([i.default.Warning,R.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return n.push([i.default.Error,R.localize(9,null,"main")]),n;{const s=(0,D.joinPath)(c,h.main);(0,D.isEqualOrParent)(s,c)||n.push([i.default.Warning,R.localize(10,null,s.path,c.path)])}if(typeof h.activationEvents>"u")return n.push([i.default.Error,R.localize(11,null,"activationEvents","main")]),n}if(typeof h.browser<"u"){if(typeof h.browser!="string")return n.push([i.default.Error,R.localize(12,null,"browser")]),n;{const s=(0,D.joinPath)(c,h.browser);(0,D.isEqualOrParent)(s,c)||n.push([i.default.Warning,R.localize(13,null,s.path,c.path)])}if(typeof h.activationEvents>"u")return n.push([i.default.Error,R.localize(14,null,"activationEvents","browser")]),n}if(!k.valid(h.version))return n.push([i.default.Error,R.localize(15,null)]),n;const o=[];if(!m(u,p,h,d,o))for(const s of o)n.push([i.default.Error,s]);return n}e.validateExtensionManifest=S;function m(u,p,c,h,d){return h||typeof c.main>"u"&&typeof c.browser>"u"?!0:v(u,p,c.engines.vscode,d)}e.isValidExtensionVersion=m;function f(u,p,c){return u==="*"||v(p,c,u)}e.isEngineValid=f;function v(u,p,c,h=[]){const d=E(w(c));if(!d)return h.push(R.localize(16,null,c)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return h.push(R.localize(17,null,c)),!1}else if(!d.majorMustEqual)return h.push(R.localize(18,null,c)),!1;return b(u,p,d)?!0:(h.push(R.localize(19,null,u,c)),!1)}function y(u){if(!Array.isArray(u))return!1;for(let p=0,c=u.length;p<c;p++)if(typeof u[p]!="string")return!1;return!0}}),define(re[44],se([0,1,17,30]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(k,T,I){let C=I&&I.get("storage.serviceMachineId",-1)||null;if(C)return C;try{const E=(await T.readFile(k.serviceMachineIdResource)).value.toString();C=(0,i.isUUID)(E)?E:null}catch{C=null}if(!C){C=(0,i.generateUuid)();try{await T.writeFile(k.serviceMachineIdResource,D.VSBuffer.fromString(C))}catch{}}return I?.store("storage.serviceMachineId",C,-1,1),C}e.getServiceMachineId=R}),define(re[55],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,k=[],T=!1){this.ctor=R,this.staticArguments=k,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=D}),define(re[94],se([0,1,55]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const i=[];var R;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(R=e.InstantiationType||(e.InstantiationType={}));function k(I,C,w){C instanceof D.SyncDescriptor||(C=new D.SyncDescriptor(C,[],Boolean(w))),i.push([I,C])}e.registerSingleton=k;function T(){return i}e.getSingletonServiceDescriptors=T}),define(re[190],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(k,T){this.key=k,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=D;class i{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(const T of this._nodes.values())T.outgoing.size===0&&k.push(T);return k}insertEdge(k,T){const I=this.lookupOrInsertNode(k),C=this.lookupOrInsertNode(T);I.outgoing.set(C.key,C),C.incoming.set(I.key,I)}removeNode(k){const T=this._hashFn(k);this._nodes.delete(T);for(const I of this._nodes.values())I.outgoing.delete(T),I.incoming.delete(T)}lookupOrInsertNode(k){const T=this._hashFn(k);let I=this._nodes.get(T);return I||(I=new D(T,k),this._nodes.set(T,I)),I}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){const k=[];for(const[T,I]of this._nodes)k.push(`${T}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,T]of this._nodes){const I=new Set([k]),C=this._findCycle(T,I);if(C)return C}}_findCycle(k,T){for(const[I,C]of k.outgoing){if(T.has(I))return[...T,I].join(" -> ");T.add(I);const w=this._findCycle(C,T);if(w)return w;T.delete(I)}}}e.Graph=i}),define(re[4],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function I(C){return C[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=I})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function i(T,I,C){I[D.DI_TARGET]===I?I[D.DI_DEPENDENCIES].push({id:T,index:C}):(I[D.DI_DEPENDENCIES]=[{id:T,index:C}],I[D.DI_TARGET]=I)}function R(T){if(D.serviceIds.has(T))return D.serviceIds.get(T);const I=function(C,w,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(I,C,E)};return I.toString=()=>T,D.serviceIds.set(T,I),I}e.createDecorator=R;function k(T){return T}e.refineServiceDecorator=k}),define(re[191],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(re[16],se([0,1,15,8,4]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function k(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof i.URI)}e.isConfigurationOverrides=k;function T(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=T;var I;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=C;function w(u,p){const c=Object.create(null);for(const h in u)E(c,h,u[h],p);return c}e.toValuesTree=w;function E(u,p,c,h){const d=p.split("."),n=d.pop();let o=u;for(let t=0;t<d.length;t++){const s=d[t];let r=o[s];switch(typeof r){case"undefined":r=o[s]=Object.create(null);break;case"object":break;default:h(`Ignoring ${p} as ${d.slice(0,t+1).join(".")} is ${JSON.stringify(r)}`);return}o=r}if(typeof o=="object"&&o!==null)try{o[n]=c}catch{h(`Ignoring ${p} as ${d.join(".")} is ${JSON.stringify(o)}`)}else h(`Ignoring ${p} as ${d.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=E;function b(u,p){const c=p.split(".");S(u,c)}e.removeFromValueTree=b;function S(u,p){const c=p.shift();if(p.length===0){delete u[c];return}if(Object.keys(u).indexOf(c)!==-1){const h=u[c];typeof h=="object"&&!Array.isArray(h)&&(S(h,p),Object.keys(h).length===0&&delete u[c])}}function m(u,p,c){function h(o,t){let s=o;for(const r of t){if(typeof s!="object"||s===null)return;s=s[r]}return s}const d=p.split("."),n=h(u,d);return typeof n>"u"?c:n}e.getConfigurationValue=m;function f(u,p,c){Object.keys(p).forEach(h=>{h!=="__proto__"&&(h in u?D.isObject(u[h])&&D.isObject(p[h])?f(u[h],p[h],c):c&&(u[h]=p[h]):u[h]=p[h])})}e.merge=f;function v(u,p,c){const h=u.inspect(p),d=u.inspect(c);return typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:typeof d.userValue<"u"||typeof d.workspaceValue<"u"||typeof d.workspaceFolderValue<"u"?d.value:h.defaultValue}e.getMigratedSettingValue=v;function y(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=y}),define(re[192],se([0,1,5,27,4]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",D.isMacintosh),k.set("isLinux",D.isLinux),k.set("isWindows",D.isWindows),k.set("isWeb",D.isWeb),k.set("isMacNative",D.isMacintosh&&!D.isWeb),k.set("isEdge",D.isEdge),k.set("isFirefox",D.isFirefox),k.set("isChrome",D.isChrome),k.set("isSafari",D.isSafari);const T=Object.prototype.hasOwnProperty;var I;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return b.INSTANCE}static true(){return S.INSTANCE}static has(L){return m.create(L)}static equals(L,U){return f.create(L,U)}static notEquals(L,U){return u.create(L,U)}static regex(L,U){return t.create(L,U)}static in(L,U){return v.create(L,U)}static notIn(L,U){return y.create(L,U)}static not(L){return p.create(L)}static and(...L){return l.create(L,null,!0)}static or(...L){return a.create(L,null,!0)}static greater(L,U){return h.create(L,U)}static greaterEquals(L,U){return d.create(L,U)}static smaller(L,U){return n.create(L,U)}static smallerEquals(L,U){return o.create(L,U)}static deserialize(L,U=!1){if(!!L)return this._deserializeOrExpression(L,U)}static _deserializeOrExpression(L,U){const $=L.split("||");return a.create($.map(x=>this._deserializeAndExpression(x,U)),null,!0)}static _deserializeAndExpression(L,U){const $=L.split("&&");return l.create($.map(x=>this._deserializeOne(x,U)),null,!0)}static _deserializeOne(L,U){if(L=L.trim(),L.indexOf("!=")>=0){const $=L.split("!=");return u.create($[0].trim(),this._deserializeValue($[1],U))}if(L.indexOf("==")>=0){const $=L.split("==");return f.create($[0].trim(),this._deserializeValue($[1],U))}if(L.indexOf("=~")>=0){const $=L.split("=~");return t.create($[0].trim(),this._deserializeRegexValue($[1],U))}if(L.indexOf(" not in ")>=0){const $=L.split(" not in ");return y.create($[0].trim(),this._deserializeValue($[1],U))}if(L.indexOf(" in ")>=0){const $=L.split(" in ");return v.create($[0].trim(),this._deserializeValue($[1],U))}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const $=L.split(">=");return d.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const $=L.split(">");return h.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const $=L.split("<=");return o.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const $=L.split("<");return n.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(L)?p.create(L.substr(1).trim()):m.create(L)}static _deserializeValue(L,U){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const $=/^'([^']*)'$/.exec(L);return $?$[1].trim():L}static _deserializeRegexValue(L,U){if((0,i.isFalsyOrWhitespace)(L)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=L.indexOf("/"),x=L.lastIndexOf("/");if($===x||$<0){if(U)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const j=L.slice($+1,x),B=L[x+1]==="i"?"i":"";try{return new RegExp(j,B)}catch(W){if(U)throw new Error(`bad regexp-value '${L}', parse error: ${W}`);return console.warn(`bad regexp-value '${L}', parse error: ${W}`),null}}}e.ContextKeyExpr=C;function w(N,L){const U=N?N.substituteConstants():void 0,$=L?L.substituteConstants():void 0;return!U&&!$?!0:!U||!$?!1:U.equals($)}e.expressionsAreEqualWithConstantSubstitution=w;function E(N,L){return N.cmp(L)}class b{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class S{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=S,S.INSTANCE=new S;class m{static create(L,U=null){const $=k.get(L);return typeof $=="boolean"?$?S.INSTANCE:b.INSTANCE:new m(L,U)}constructor(L,U){this.key=L,this.negated=U,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:P(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=k.get(this.key);return typeof L=="boolean"?L?S.INSTANCE:b.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=m;class f{static create(L,U,$=null){if(typeof U=="boolean")return U?m.create(L,$):p.create(L,$);const x=k.get(L);return typeof x=="boolean"?U===(x?"true":"false")?S.INSTANCE:b.INSTANCE:new f(L,U,$)}constructor(L,U,$){this.key=L,this.value=U,this.negated=$,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=k.get(this.key);if(typeof L=="boolean"){const U=L?"true":"false";return this.value===U?S.INSTANCE:b.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class v{static create(L,U){return new v(L,U)}constructor(L,U){this.key=L,this.valueKey=U,this.type=10,this.negated=null}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const U=L.getValue(this.valueKey),$=L.getValue(this.key);return Array.isArray(U)?U.includes($):typeof $=="string"&&typeof U=="object"&&U!==null?T.call(U,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=y.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=v;class y{static create(L,U){return new y(L,U)}constructor(L,U){this.key=L,this.valueKey=U,this.type=11,this._negated=v.create(L,U)}cmp(L){return L.type!==this.type?this.type-L.type:this._negated.cmp(L._negated)}equals(L){return L.type===this.type?this._negated.equals(L._negated):!1}substituteConstants(){return this}evaluate(L){return!this._negated.evaluate(L)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(L){return L.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=y;class u{static create(L,U,$=null){if(typeof U=="boolean")return U?p.create(L,$):m.create(L,$);const x=k.get(L);return typeof x=="boolean"?U===(x?"true":"false")?b.INSTANCE:S.INSTANCE:new u(L,U,$)}constructor(L,U,$){this.key=L,this.value=U,this.negated=$,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=k.get(this.key);if(typeof L=="boolean"){const U=L?"true":"false";return this.value===U?b.INSTANCE:S.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=u;class p{static create(L,U=null){const $=k.get(L);return typeof $=="boolean"?$?b.INSTANCE:S.INSTANCE:new p(L,U)}constructor(L,U){this.key=L,this.negated=U,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:P(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=k.get(this.key);return typeof L=="boolean"?L?b.INSTANCE:S.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=p;function c(N,L){if(typeof N=="string"){const U=parseFloat(N);isNaN(U)||(N=U)}return typeof N=="string"||typeof N=="number"?L(N):b.INSTANCE}class h{static create(L,U,$=null){return c(U,x=>new h(L,x,$))}constructor(L,U,$){this.key=L,this.value=U,this.negated=$,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=h;class d{static create(L,U,$=null){return c(U,x=>new d(L,x,$))}constructor(L,U,$){this.key=L,this.value=U,this.negated=$,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=d;class n{static create(L,U,$=null){return c(U,x=>new n(L,x,$))}constructor(L,U,$){this.key=L,this.value=U,this.negated=$,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class o{static create(L,U,$=null){return c(U,x=>new o(L,x,$))}constructor(L,U,$){this.key=L,this.value=U,this.negated=$,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=o;class t{static create(L,U){return new t(L,U)}constructor(L,U){this.key=L,this.regexp=U,this.type=7,this.negated=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const U=this.regexp?this.regexp.source:"",$=L.regexp?L.regexp.source:"";return U<$?-1:U>$?1:0}equals(L){if(L.type===this.type){const U=this.regexp?this.regexp.source:"",$=L.regexp?L.regexp.source:"";return this.key===L.key&&U===$}return!1}substituteConstants(){return this}evaluate(L){const U=L.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class s{static create(L){return new s(L)}constructor(L){this._actual=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new s(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function r(N){let L=null;for(let U=0,$=N.length;U<$;U++){const x=N[U].substituteConstants();if(N[U]!==x&&L===null){L=[];for(let j=0;j<U;j++)L[j]=N[j]}L!==null&&(L[U]=x)}return L===null?N:L}class l{static create(L,U,$){return l._normalizeArr(L,U,$)}constructor(L,U){this.expr=L,this.negated=U,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let U=0,$=this.expr.length;U<$;U++){const x=E(this.expr[U],L.expr[U]);if(x!==0)return x}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let U=0,$=this.expr.length;U<$;U++)if(!this.expr[U].equals(L.expr[U]))return!1;return!0}return!1}substituteConstants(){const L=r(this.expr);return L===this.expr?this:l.create(L,this.negated,!1)}evaluate(L){for(let U=0,$=this.expr.length;U<$;U++)if(!this.expr[U].evaluate(L))return!1;return!0}static _normalizeArr(L,U,$){const x=[];let j=!1;for(const B of L)if(!!B){if(B.type===1){j=!0;continue}if(B.type===0)return b.INSTANCE;if(B.type===6){x.push(...B.expr);continue}x.push(B)}if(x.length===0&&j)return S.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(E);for(let B=1;B<x.length;B++)x[B-1].equals(x[B])&&(x.splice(B,1),B--);if(x.length===1)return x[0];for(;x.length>1;){const B=x[x.length-1];if(B.type!==9)break;x.pop();const W=x.pop(),q=x.length===0,Y=a.create(B.expr.map(ee=>l.create([ee,W],null,$)),null,q);Y&&(x.push(Y),x.sort(E))}if(x.length===1)return x[0];if($){for(let B=0;B<x.length;B++)for(let W=B+1;W<x.length;W++)if(x[B].negate().equals(x[W]))return b.INSTANCE;if(x.length===1)return x[0]}return new l(x,U)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const U of this.expr)L.push(...U.keys());return L}map(L){return new l(this.expr.map(U=>U.map(L)),null)}negate(){if(!this.negated){const L=[];for(const U of this.expr)L.push(U.negate());this.negated=a.create(L,this,!0)}return this.negated}}class a{static create(L,U,$){return a._normalizeArr(L,U,$)}constructor(L,U){this.expr=L,this.negated=U,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let U=0,$=this.expr.length;U<$;U++){const x=E(this.expr[U],L.expr[U]);if(x!==0)return x}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let U=0,$=this.expr.length;U<$;U++)if(!this.expr[U].equals(L.expr[U]))return!1;return!0}return!1}substituteConstants(){const L=r(this.expr);return L===this.expr?this:a.create(L,this.negated,!1)}evaluate(L){for(let U=0,$=this.expr.length;U<$;U++)if(this.expr[U].evaluate(L))return!0;return!1}static _normalizeArr(L,U,$){let x=[],j=!1;if(L){for(let B=0,W=L.length;B<W;B++){const q=L[B];if(!!q){if(q.type===0){j=!0;continue}if(q.type===1)return S.INSTANCE;if(q.type===9){x=x.concat(q.expr);continue}x.push(q)}}if(x.length===0&&j)return b.INSTANCE;x.sort(E)}if(x.length!==0){if(x.length===1)return x[0];for(let B=1;B<x.length;B++)x[B-1].equals(x[B])&&(x.splice(B,1),B--);if(x.length===1)return x[0];if($){for(let B=0;B<x.length;B++)for(let W=B+1;W<x.length;W++)if(x[B].negate().equals(x[W]))return S.INSTANCE;if(x.length===1)return x[0]}return new a(x,U)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const U of this.expr)L.push(...U.keys());return L}map(L){return new a(this.expr.map(U=>U.map(L)),null)}negate(){if(!this.negated){const L=[];for(const U of this.expr)L.push(U.negate());for(;L.length>1;){const U=L.shift(),$=L.shift(),x=[];for(const j of F(U))for(const B of F($))x.push(l.create([j,B],null,!1));L.unshift(a.create(x,null,!1))}this.negated=a.create(L,this,!0)}return this.negated}}class g extends m{static all(){return g._info.values()}constructor(L,U,$){super(L,null),this._defaultValue=U,typeof $=="object"?g._info.push({...$,key:L}):$!==!0&&g._info.push({key:L,description:$,type:U!=null?typeof U:void 0})}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return f.create(this.key,L)}notEqualsTo(L){return u.create(this.key,L)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function P(N,L){return N<L?-1:N>L?1:0}function A(N,L,U,$){return N<U?-1:N>U?1:L<$?-1:L>$?1:0}function V(N,L){if(N.type===0||L.type===1)return!0;if(N.type===9)return L.type===9?O(N.expr,L.expr):!1;if(L.type===9){for(const U of L.expr)if(V(N,U))return!0;return!1}if(N.type===6){if(L.type===6)return O(L.expr,N.expr);for(const U of N.expr)if(V(U,L))return!0;return!1}return N.equals(L)}e.implies=V;function O(N,L){let U=0,$=0;for(;U<N.length&&$<L.length;){const x=N[U].cmp(L[$]);if(x<0)return!1;x===0&&U++,$++}return U===N.length}function F(N){return N.type===9?N.expr:[N]}}),define(re[95],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function i(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=i;class R{async getPerformanceInfo(T,I){return{}}async getSystemInfo(T,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,I){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=R}),define(re[96],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(re[13],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(re[29],se([0,1,156,4]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY="DEFAULT_PROFILE_EXTENSIONS_MIGRATION";function R(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function k(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function T(u,p){switch(u){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function I(u,p){return p==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function C(u,p,c){return I(p,c)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===c?!0:w(c).includes(u)}e.isTargetPlatformCompatible=C;function w(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=w;function E(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=E;var b;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var S;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var m;(function(u){u.Install="install",u.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,i.createDecorator)("extensionGalleryService");var v;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class y extends Error{constructor(p,c){super(p),this.code=c,this.name=c}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,i.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,i.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,i.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(re[193],se([0,1,3,2,67,31,8,143,29]),function(Q,e,D,i,R,k,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function w(y,u){return T.URI.revive(u?u.transformIncoming(y):y)}function E(y,u){return u?u.transformOutgoingURI(y):y}function b(y,u){u=u||I.DefaultURITransformer;const p=y.manifest;return{...(0,I.transformAndReviveIncomingURIs)({...y,manifest:void 0},u),manifest:p}}function S(y,u){return u?(0,k.cloneAndChange)(y,p=>p instanceof T.URI?u.transformOutgoingURI(p):void 0):y}class m{constructor(u,p){this.service=u,this.getUriTransformer=p,this.onInstallExtension=D.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(u.onDidUninstallExtension,!0)}listen(u,p){const c=this.getUriTransformer(u);switch(p){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,h=>h.map(d=>({...d,local:d.local?S(d.local,c):d.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(u,p,c){const h=this.getUriTransformer(u);switch(p){case"zip":return this.service.zip(b(c[0],h)).then(d=>E(d,h));case"unzip":return this.service.unzip(w(c[0],h));case"install":return this.service.install(w(c[0],h),(0,R.revive)(c[1]));case"getManifest":return this.service.getManifest(w(c[0],h));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(c[0]);case"installFromGallery":return this.service.installFromGallery(c[0],(0,R.revive)(c[1]));case"uninstall":return this.service.uninstall(b(c[0],h),(0,R.revive)(c[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(b(c[0],h));case"getInstalled":return this.service.getInstalled(c[0],T.URI.revive(c[1])).then(d=>d.map(n=>S(n,h)));case"getMetadata":return this.service.getMetadata(b(c[0],h));case"updateMetadata":return this.service.updateMetadata(b(c[0],h),c[1]).then(d=>S(d,h));case"updateExtensionScope":return this.service.updateExtensionScope(b(c[0],h),c[1]).then(d=>S(d,h));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(c[0],c[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class f extends i.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(u){super(),this.channel=u,this._onInstallExtension=this._register(new D.Emitter),this._onDidInstallExtensions=this._register(new D.Emitter),this._onUninstallExtension=this._register(new D.Emitter),this._onDidUninstallExtension=this._register(new D.Emitter),this._register(this.channel.listen("onInstallExtension")(p=>this._onInstallExtension.fire({identifier:p.identifier,source:this.isUriComponents(p.source)?T.URI.revive(p.source):p.source,profileLocation:T.URI.revive(p.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(p=>this._onDidInstallExtensions.fire(p.map(c=>({...c,local:c.local?b(c.local,null):c.local,source:this.isUriComponents(c.source)?T.URI.revive(c.source):c.source,profileLocation:T.URI.revive(c.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(p=>this._onUninstallExtension.fire({identifier:p.identifier,profileLocation:T.URI.revive(p.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(p=>this._onDidUninstallExtension.fire({...p,profileLocation:T.URI.revive(p.profileLocation)})))}isUriComponents(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(u){const p=await this.getTargetPlatform();return u.allTargetPlatforms.some(c=>(0,C.isTargetPlatformCompatible)(c,u.allTargetPlatforms,p))}zip(u){return Promise.resolve(this.channel.call("zip",[u]).then(p=>T.URI.revive(p)))}unzip(u){return Promise.resolve(this.channel.call("unzip",[u]))}install(u,p){return Promise.resolve(this.channel.call("install",[u,p])).then(c=>b(c,null))}getManifest(u){return Promise.resolve(this.channel.call("getManifest",[u]))}installFromGallery(u,p){return Promise.resolve(this.channel.call("installFromGallery",[u,p])).then(c=>b(c,null))}uninstall(u,p){return Promise.resolve(this.channel.call("uninstall",[u,p]))}reinstallFromGallery(u){return Promise.resolve(this.channel.call("reinstallFromGallery",[u]))}getInstalled(u=null,p){return Promise.resolve(this.channel.call("getInstalled",[u,p])).then(c=>c.map(h=>b(h,null)))}getMetadata(u){return Promise.resolve(this.channel.call("getMetadata",[u]))}updateMetadata(u,p){return Promise.resolve(this.channel.call("updateMetadata",[u,p])).then(c=>b(c,null))}updateExtensionScope(u,p){return Promise.resolve(this.channel.call("updateExtensionScope",[u,p])).then(c=>b(c,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(u,p){const c=await this.channel.call("download",[u,p]);return T.URI.revive(c)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=f;class v{constructor(u){this.service=u}listen(u,p){throw new Error("Invalid listen")}call(u,p,c){switch(p){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(c[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=v}),define(re[97],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,D.createDecorator)("IExtensionSignatureVerificationService");class i{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((k,T)=>Q(["node-vsce-sign"],async I=>k(I),T))),this.moduleLoadingPromise}async verify(k,T){let I;try{I=await this.vsceSign()}catch{return!1}return I.verify(k,T)}}e.ExtensionSignatureVerificationService=i}),define(re[98],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var i;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(i=e.RecommendationSource||(e.RecommendationSource={}));function R(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var k;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(re[14],se([0,1,49,12,27,15,8,164,4]),function(Q,e,D,i,R,k,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function w(j){return j.create===!0}e.isFileOpenForWriteOptions=w;var E;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var b;(function(j){j[j.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var S;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead",j[j.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=m;function f(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=f;function v(j){return!!(j.capabilities&32768)}e.hasFileCloneCapability=v;function y(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function u(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=u;function p(j){return m(j)?!!(j.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var c;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(c=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(B,W){super(B),this.code=W}}e.FileSystemProviderError=h;function d(j,B){const W=new h(j.toString(),B);return o(W,B),W}e.createFileSystemProviderError=d;function n(j){return j||d((0,I.localize)(0,null),c.Unknown)}e.ensureFileSystemProviderError=n;function o(j,B){return j.name=B?`${B} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=o;function t(j){if(!j)return c.Unknown;if(j instanceof h)return j.code;const B=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!B)return c.Unknown;switch(B[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileExceedsMemoryLimit:return c.FileExceedsMemoryLimit;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.toFileSystemProviderErrorCode=t;function s(j){if(j instanceof A)return j.fileOperationResult;switch(t(j)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 10;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileExceedsMemoryLimit:return 9;case c.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class l{constructor(B,W,q){this.resource=B,this.operation=W,this.target=q}isOperation(B){return this.operation===B}}e.FileOperationEvent=l;var a;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class g{constructor(B,W){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=B;const q=new Map;for(const Y of B){const ee=q.get(Y.type);switch(ee?ee.push([Y.resource,Y]):q.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,ee]of q)switch(Y){case 1:this.added=D.TernarySearchTree.forUris(()=>W),this.added.fill(ee);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>W),this.updated.fill(ee);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>W),this.deleted.fill(ee);break}}contains(B,...W){return this.doContains(B,{includeChildren:!1},...W)}affects(B,...W){return this.doContains(B,{includeChildren:!0},...W)}doContains(B,W,...q){if(!B)return!1;const Y=q.length>0;return!!((!Y||q.includes(1))&&(this.added?.get(B)||W.includeChildren&&this.added?.findSuperstr(B))||(!Y||q.includes(0))&&(this.updated?.get(B)||W.includeChildren&&this.updated?.findSuperstr(B))||(!Y||q.includes(2))&&(this.deleted?.findSubstr(B)||W.includeChildren&&this.deleted?.findSuperstr(B)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=g;function P(j,B,W){return!j||!B||j===B||B.length>j.length?!1:(B.charAt(B.length-1)!==i.sep&&(B+=i.sep),W?(0,R.startsWithIgnoreCase)(j,B):j.indexOf(B)===0)}e.isParent=P;class A extends Error{constructor(B,W,q){super(B),this.fileOperationResult=W,this.options=q}}e.FileOperationError=A;class V extends A{constructor(B,W,q){super(B,2,q),this.stat=W}}e.NotModifiedSinceFileOperationError=V;var O;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(O=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=N;async function L(j,B){if(!B.hasProvider(T.URI.from({scheme:j.scheme})))return new Promise(W=>{const q=B.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===j.scheme&&Y.added&&(q.dispose(),W())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(B){return(0,k.isNumber)(B)||(B=0),B<U.KB?(0,I.localize)(1,null,B.toFixed(0)):B<U.MB?(0,I.localize)(2,null,(B/U.KB).toFixed(2)):B<U.GB?(0,I.localize)(3,null,(B/U.MB).toFixed(2)):B<U.TB?(0,I.localize)(4,null,(B/U.GB).toFixed(2)):(0,I.localize)(5,null,(B/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var $;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function x(j){return{maxFileSize:j===0?300*U.MB:16*U.GB,maxHeapSize:j===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=x});var K=this&&this.__param||function(Q,e){return function(D,i){e(D,i,Q)}};define(re[194],se([0,1,99,43,14]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(I){this.fileService=I}async checksum(I){const C=(await this.fileService.readFileStream(I)).value;return new Promise((w,E)=>{const b=(0,D.createHash)("md5");(0,i.listenStream)(C,{onData:S=>b.update(S.buffer),onError:S=>E(S),onEnd:()=>w(b.digest("base64").replace(/=+$/,""))})})}};k=ve([K(0,R.IFileService)],k),e.ChecksumService=k}),define(re[195],se([0,1,17,37,11,3,2,43,8,30,14]),function(Q,e,D,i,R,k,T,I,C,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends T.Disposable{constructor(m,f){super(),this.channel=m,this.extraCapabilities=f,this.onDidChangeCapabilities=k.Event.None,this._onDidChange=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,w.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(m){return this.channel.call("stat",[m])}readdir(m){return this.channel.call("readdir",[m])}async readFile(m,f){const{buffer:v}=await this.channel.call("readFile",[m,f]);return v}readFileStream(m,f,v){const y=(0,I.newWriteableStream)(p=>D.VSBuffer.concat(p.map(c=>D.VSBuffer.wrap(c))).buffer),u=this.channel.listen("readFileStream",[m,f])(p=>{if(p instanceof D.VSBuffer)y.write(p.buffer);else{if(p==="end")y.end();else{let c=p;c instanceof Error||(c=(0,E.createFileSystemProviderError)((0,i.toErrorMessage)(c),E.FileSystemProviderErrorCode.Unknown)),y.error(c),y.end()}u.dispose()}});return v.onCancellationRequested(()=>{y.error((0,R.canceled)()),y.end(),u.dispose()}),y}writeFile(m,f,v){return this.channel.call("writeFile",[m,D.VSBuffer.wrap(f),v])}open(m,f){return this.channel.call("open",[m,f])}close(m){return this.channel.call("close",[m])}async read(m,f,v,y,u){const[p,c]=await this.channel.call("read",[m,f,u]);return v.set(p.buffer.slice(0,c),y),c}write(m,f,v,y,u){return this.channel.call("write",[m,f,D.VSBuffer.wrap(v),y,u])}mkdir(m){return this.channel.call("mkdir",[m])}delete(m,f){return this.channel.call("delete",[m,f])}rename(m,f,v){return this.channel.call("rename",[m,f,v])}copy(m,f,v){return this.channel.call("copy",[m,f,v])}cloneFile(m,f){return this.channel.call("cloneFile",[m,f])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(m=>{if(Array.isArray(m)){const f=m;this._onDidChange.fire(f.map(v=>({resource:C.URI.revive(v.resource),type:v.type})))}else{const f=m;this._onDidWatchError.fire(f)}}))}watch(m,f){const v=(0,w.generateUuid)();return this.channel.call("watch",[this.sessionId,v,m,f]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,v]))}}e.DiskFileSystemProviderClient=b}),define(re[100],se([0,1,17,11,165,14]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(E,b,S,m,f,v){let y;try{await I(E,b,S,m,f,v)}catch(u){y=u}finally{y&&f.errorTransformer&&(y=f.errorTransformer(y)),typeof y<"u"&&S.error(y),S.end()}}e.readFileIntoStream=T;async function I(E,b,S,m,f,v){C(v);const y=await E.open(b,{create:!1});try{C(v);let u=0,p=0,c=f&&typeof f.length=="number"?f.length:void 0,h=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof c=="number"?c:f.bufferSize)),d=f&&typeof f.position=="number"?f.position:0,n=0;do p=await E.read(y,d,h.buffer,n,h.byteLength-n),d+=p,n+=p,u+=p,typeof c=="number"&&(c-=p),n===h.byteLength&&(await S.write(m(h)),h=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof c=="number"?c:f.bufferSize)),n=0);while(p>0&&(typeof c!="number"||c>0)&&C(v)&&w(u,f));if(n>0){let o=n;typeof c=="number"&&(o=Math.min(n,c)),S.write(m(h.slice(0,o)))}}catch(u){throw(0,k.ensureFileSystemProviderError)(u)}finally{await E.close(y)}}function C(E){if(E.isCancellationRequested)throw(0,i.canceled)();return!0}function w(E,b){if(b?.limits){if(typeof b.limits.memory=="number"&&E>b.limits.memory)throw(0,k.createFileSystemProviderError)((0,R.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&E>b.limits.size)throw(0,k.createFileSystemProviderError)((0,R.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(re[56],se([0,1,88,2,12,5,8,14]),function(Q,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function C(u){return u.recursive===!0}e.isRecursiveWatchRequest=C;class w extends i.Disposable{constructor(p,c,h,d){super(),this.onFileChanges=p,this.onLogMessage=c,this.verboseLogging=h,this.options=d,this.watcherDisposables=this._register(new i.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const p=new i.DisposableStore;this.watcherDisposables.value=p,this.watcher=this.createWatcher(p),this.watcher.setVerboseLogging(this.verboseLogging),p.add(this.watcher.onDidChangeFile(c=>this.onFileChanges(c))),p.add(this.watcher.onDidLogMessage(c=>this.onLogMessage(c))),p.add(this.watcher.onDidError(c=>this.onError(c)))}onError(p){this.options.restartOnError?this.restartCounter<w.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${p}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${p}`):this.error(p)}restart(p){this.restartCounter++,this.init(),this.watch(p)}async watch(p){this.requests=p,await this.watcher?.watch(p)}async setVerboseLogging(p){this.verboseLogging=p,await this.watcher?.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${p}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=w,w.MAX_RESTARTS=5;class E extends w{constructor(p,c,h){super(p,c,h,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=E;class b extends w{constructor(p,c,h){super(p,c,h,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function S(u){return u.map(p=>({type:p.type,resource:T.URI.file(p.path)}))}e.toFileChanges=S;function m(u){const p=new y;for(const c of u)p.processEvent(c);return p.coalesce()}e.coalesceEvents=m;function f(u,p){return typeof p=="string"&&!p.startsWith(D.GLOBSTAR)&&!(0,R.isAbsolute)(p)?{base:u,pattern:p}:p}e.normalizeWatcherPattern=f;function v(u,p){const c=[];for(const h of p)c.push((0,D.parse)(f(u,h)));return c}e.parseWatcherPatterns=v;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(p){return k.isLinux?p.path:p.path.toLowerCase()}processEvent(p){const c=this.mapPathToChange.get(this.toKey(p));let h=!1;if(c){const d=c.type,n=p.type;c.path!==p.path&&(p.type===2||p.type===1)?h=!0:d===1&&n===2?(this.mapPathToChange.delete(this.toKey(p)),this.coalesced.delete(c)):d===2&&n===1?c.type=0:d===1&&n===0||(c.type=n)}else h=!0;h&&(this.coalesced.add(p),this.mapPathToChange.set(this.toKey(p),p))}coalesce(){const p=[],c=[];return Array.from(this.coalesced).filter(h=>h.type!==2?(p.push(h),!1):!0).sort((h,d)=>h.path.length-d.path.length).filter(h=>c.some(d=>(0,I.isParent)(h.path,d,!k.isLinux))?!1:(c.push(h.path),!0)).concat(p)}}}),define(re[196],se([0,1,53,6,22,48,2,83,12,5,145,28,56]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class m extends T.Disposable{constructor(y,u,p,c){super(),this.request=y,this.onDidFilesChange=u,this.onLogMessage=p,this.verboseLogging=c,this.throttledFileChangesWorker=new i.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},h=>this.onDidFilesChange(h)),this.fileChangesDelayer=this._register(new i.ThrottledDelayer(m.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new R.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const y=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const u=await b.Promises.stat(y);this._register(await this.doWatch(y,u.isDirectory()))}catch(y){y.code!=="ENOENT"?this.error(y):this.trace(y)}}async normalizePath(y){let u=y.path;try{u=await b.Promises.realpath(y.path),y.path===u&&(u=await(0,E.realcase)(y.path)??y.path),y.path!==u&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${y.path}, real: ${u})`)}catch{}return u}async doWatch(y,u){if(w.isMacintosh&&(0,k.isEqualOrParent)(y,"/Volumes/",!0))return this.error(`Refusing to watch ${y} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const p=new R.CancellationTokenSource(this.cts.token),c=new T.DisposableStore;try{const h=(0,C.basename)(y),d=(0,D.watch)(y);c.add((0,T.toDisposable)(()=>{d.removeAllListeners(),d.close()})),this.trace(`Started watching: '${y}'`);const n=new Set;if(u)try{for(const t of await b.Promises.readdir(y))n.add(t)}catch(t){this.error(t)}const o=new Map;c.add((0,T.toDisposable)(()=>{for(const[,t]of o)t.dispose();o.clear()})),d.on("error",(t,s)=>{this.error(`Failed to watch ${y} for changes using fs.watch() (${t}, ${s})`),this.dispose()}),d.on("change",(t,s)=>{if(p.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${s}`);let r="";if(s&&(r=s.toString(),w.isMacintosh&&(r=(0,I.normalizeNFC)(r))),!(!r||t!=="change"&&t!=="rename"))if(u)if(t==="rename"){o.get(r)?.dispose();const l=setTimeout(async()=>{if(o.delete(r),r===h&&!await b.Promises.exists(y)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,C.join)(y,r));if(p.token.isCancellationRequested)return;let g;a?n.has(r)?g=0:(g=1,n.add(r)):(n.delete(r),g=2),this.onFileChange({path:(0,C.join)(this.request.path,r),type:g})},m.FILE_DELETE_HANDLER_DELAY);o.set(r,(0,T.toDisposable)(()=>clearTimeout(l)))}else{let l;n.has(r)?l=0:(l=1,n.add(r)),this.onFileChange({path:(0,C.join)(this.request.path,r),type:l})}else if(t==="rename"||r!==h){const l=setTimeout(async()=>{const a=await b.Promises.exists(y);p.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),c.add(await this.doWatch(y,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},m.FILE_DELETE_HANDLER_DELAY);c.clear(),c.add((0,T.toDisposable)(()=>clearTimeout(l)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(h){await b.Promises.exists(y)&&!p.token.isCancellationRequested&&this.error(`Failed to watch ${y} for changes using fs.watch() (${h.toString()})`)}return(0,T.toDisposable)(()=>{p.dispose(!0),c.dispose()})}async onFileChange(y,u=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),!u&&this.excludes.some(p=>p(y.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${y.path}`):!u&&this.includes&&this.includes.length>0&&!this.includes.some(p=>p(y.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${y.path}`):this.fileChangesBuffer.push(y);try{await this.fileChangesDelayer.trigger(async()=>{const p=this.fileChangesBuffer;this.fileChangesBuffer=[];const c=(0,S.coalesceEvents)(p);if(c.length>0){if(this.verboseLogging)for(const d of c)this.trace(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);this.throttledFileChangesWorker.work(c)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(y){if(w.isLinux)return b.Promises.exists(y);try{const u=(0,C.basename)(y);return(await b.Promises.readdir((0,C.dirname)(y))).some(c=>c===u)}catch(u){return this.trace(u),!1}}setVerboseLogging(y){this.verboseLogging=y}error(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${y}`})}warn(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${y}`})}trace(y){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=m,m.FILE_DELETE_HANDLER_DELAY=100,m.FILE_CHANGES_HANDLER_DELAY=50;async function f(v,y,u,p,c=512){const h=await b.Promises.open(v,"r"),d=Buffer.allocUnsafe(c),n=new R.CancellationTokenSource(p);let o,t=!1;const s={path:v,excludes:[],recursive:!1},r=new m(s,l=>{(async()=>{for(const{type:a}of l)if(a===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:g}=await b.Promises.read(h,d,0,c,null);if(!g||n.token.isCancellationRequested)break;y(d.slice(0,g))}}catch(g){o=new Error(g),n.dispose(!0)}finally{t=!1}}})()});return await r.ready,u(),new Promise((l,a)=>{n.token.onCancellationRequested(async()=>{r.dispose();try{await b.Promises.close(h)}catch(g){o=new Error(g)}o?a(o):l()})})}e.watchFileContents=f}),define(re[197],se([0,1,3,88,2,5,196]),function(Q,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends R.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(w){const E=this.normalizeRequests(w),b=E.filter(m=>{const f=this.watchers.get(m.path);return f?!(0,i.patternsEquals)(f.request.excludes,m.excludes)||!(0,i.patternsEquals)(f.request.includes,m.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:m})=>!E.find(f=>f.path===m.path&&(0,i.patternsEquals)(f.excludes,m.excludes)&&(0,i.patternsEquals)(f.includes,m.includes))).map(({request:m})=>m.path);b.length&&this.trace(`Request to start watching: ${b.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const m of S)this.stopWatching(m);for(const m of b)this.startWatching(m)}startWatching(w){const E=new T.NodeJSFileWatcherLibrary(w,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),b={request:w,instance:E};this.watchers.set(w.path,b)}async stop(){for(const[w]of this.watchers)this.stopWatching(w);this.watchers.clear()}stopWatching(w){const E=this.watchers.get(w);E&&(this.watchers.delete(w),E.instance.dispose())}normalizeRequests(w){const E=new Map;for(const b of w){const S=k.isLinux?b.path:b.path.toLowerCase();E.set(S,b)}return Array.from(E.values())}async setVerboseLogging(w){this.verboseLogging=w;for(const[,E]of this.watchers)E.instance.setVerboseLogging(w)}trace(w){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(w)})}toMessage(w,E){return E?`[File Watcher (node.js)] ${w} (path: ${E.request.path})`:`[File Watcher (node.js)] ${w}`}}e.NodeJSWatcher=I}),define(re[198],se([0,1,56,197]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends D.AbstractNonRecursiveWatcherClient{constructor(T,I,C){super(T,I,C),this.init()}createWatcher(){return new i.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(re[199],se([0,1,23,38,68,56]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends k.AbstractUniversalWatcherClient{constructor(C,w,E){super(C,w,E),this.init()}createWatcher(C){const w=C.add(new R.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(w.onDidProcessExit(({code:E,signal:b})=>this.onError(`terminated by itself with code ${E}, signal: ${b}`))),i.ProxyChannel.toService((0,i.getNextTickChannel)(w.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(re[71],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(const[k,T]of R)this.set(k,T)}set(R,k){const T=this._entries.get(R);return this._entries.set(R,k),T}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(re[200],se([0,1,6,11,2,55,190,4,71,82]),function(Q,e,D,i,R,k,T,I,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class b extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class S{constructor(y=new C.ServiceCollection,u=!1,p,c=E){this._services=y,this._strict=u,this._parent=p,this._enableTracing=c,this._activeInstantiations=new Set,this._services.set(I.IInstantiationService,this),this._globalGraph=c?p?._globalGraph??new T.Graph(h=>h):void 0}createChild(y){return new S(y,this._strict,this,this._enableTracing)}invokeFunction(y,...u){const p=f.traceInvocation(this._enableTracing,y);let c=!1;try{return y({get:d=>{if(c)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(d,p);if(!n)throw new Error(`[invokeFunction] unknown service '${d}'`);return n}},...u)}finally{c=!0,p.stop()}}createInstance(y,...u){let p,c;return y instanceof k.SyncDescriptor?(p=f.traceCreation(this._enableTracing,y.ctor),c=this._createInstance(y.ctor,y.staticArguments.concat(u),p)):(p=f.traceCreation(this._enableTracing,y),c=this._createInstance(y,u,p)),p.stop(),c}_createInstance(y,u=[],p){const c=I._util.getServiceDependencies(y).sort((n,o)=>n.index-o.index),h=[];for(const n of c){const o=this._getOrCreateServiceInstance(n.id,p);o||this._throwIfStrict(`[createInstance] ${y.name} depends on UNKNOWN service ${n.id}.`,!1),h.push(o)}const d=c.length>0?c[0].index:u.length;if(u.length!==d){console.trace(`[createInstance] First service dependency of ${y.name} at position ${d+1} conflicts with ${u.length} static arguments`);const n=d-u.length;n>0?u=u.concat(new Array(n)):u=u.slice(0,d)}return Reflect.construct(y,u.concat(h))}_setServiceInstance(y,u){if(this._services.get(y)instanceof k.SyncDescriptor)this._services.set(y,u);else if(this._parent)this._parent._setServiceInstance(y,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(y){const u=this._services.get(y);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(y):u}_getOrCreateServiceInstance(y,u){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(y));const p=this._getServiceInstanceOrDescriptor(y);return p instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(y,p,u.branch(y,!0)):(u.branch(y,!1),p)}_safeCreateAndCacheServiceInstance(y,u,p){if(this._activeInstantiations.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this._activeInstantiations.add(y);try{return this._createAndCacheServiceInstance(y,u,p)}finally{this._activeInstantiations.delete(y)}}_createAndCacheServiceInstance(y,u,p){const c=new T.Graph(n=>n.id.toString());let h=0;const d=[{id:y,desc:u,_trace:p}];for(;d.length;){const n=d.pop();if(c.lookupOrInsertNode(n),h++>1e3)throw new b(c);for(const o of I._util.getServiceDependencies(n.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(o.id);if(t||this._throwIfStrict(`[createInstance] ${y} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(o.id)),t instanceof k.SyncDescriptor){const s={id:o.id,desc:t,_trace:n._trace.branch(o.id,!0)};c.insertEdge(n,s),d.push(s)}}}for(;;){const n=c.roots();if(n.length===0){if(!c.isEmpty())throw new b(c);break}for(const{data:o}of n){if(this._getServiceInstanceOrDescriptor(o.id)instanceof k.SyncDescriptor){const s=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,s)}c.removeNode(o)}}return this._getServiceInstanceOrDescriptor(y)}_createServiceInstanceWithOwner(y,u,p=[],c,h){if(this._services.get(y)instanceof k.SyncDescriptor)return this._createServiceInstance(y,u,p,c,h);if(this._parent)return this._parent._createServiceInstanceWithOwner(y,u,p,c,h);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(y,u,p=[],c,h){if(c){const d=new S(void 0,this._strict,this,this._enableTracing);d._globalGraphImplicitDependency=String(y);const n=new Map,o=new D.IdleValue(()=>{const t=d._createInstance(u,p,h);for(const[s,r]of n){const l=t[s];if(typeof l=="function")for(const a of r)l.apply(t,a)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=n.get(s);return a||(a=new w.LinkedList,n.set(s,a)),(P,A,V)=>{const O=a.push([P,A,V]);return(0,R.toDisposable)(O)}}if(s in t)return t[s];const r=o.value;let l=r[s];return typeof l!="function"||(l=l.bind(r),t[s]=l),l},set(t,s,r){return o.value[s]=r,!0}})}else return this._createInstance(u,p,h)}_throwIfStrict(y,u){if(u&&console.warn(y),this._strict)throw new Error(y)}}e.InstantiationService=S;var m;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(m||(m={}));class f{static traceInvocation(y,u){return y?new f(1,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f._None}static traceCreation(y,u){return y?new f(0,u.name):f._None}constructor(y,u){this.type=y,this.name=u,this._start=Date.now(),this._dep=[]}branch(y,u){const p=new f(2,y.toString());return this._dep.push([y,u,p]),p}stop(){const y=Date.now()-this._start;f._totals+=y;let u=!1;function p(h,d){const n=[],o=new Array(h+1).join("	");for(const[t,s,r]of d._dep)if(s&&r){u=!0,n.push(`${o}CREATES -> ${t}`);const l=p(h+1,r);l&&n.push(l)}else n.push(`${o}uses -> ${t}`);return n.join(`
`)}const c=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(y>2||u)&&f.all.add(c.join(`
`))}}e.Trace=f,f.all=new Set,f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(re[201],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,k){this.server=R,this.router=k}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,k){this.server.registerChannel(R,k)}}e.MessagePortMainProcessService=D}),define(re[57],se([0,1,38,55,94,4]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(m,f,v,y){const u=v.getChannel(m);return I(f)?y.createInstance(new i.SyncDescriptor(f.channelClientCtor,[u])):D.ProxyChannel.toService(u,f?.proxyOptions)}}function I(S){return!!S?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let C=class extends T{constructor(m,f,v,y){super(m,f,v,y)}};C=ve([K(2,e.IMainProcessService),K(3,k.IInstantiationService)],C);function w(S,m,f){(0,R.registerSingleton)(S,new i.SyncDescriptor(C,[m,f],!0))}e.registerMainProcessRemoteService=w,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let E=class extends T{constructor(m,f,v,y){super(m,f,v,y)}};E=ve([K(2,e.ISharedProcessService),K(3,k.IInstantiationService)],E);function b(S,m,f){(0,R.registerSingleton)(S,new i.SyncDescriptor(E,[m,f],!0))}e.registerSharedProcessRemoteService=b}),define(re[72],se([0,1,22,2,5,167,29,4]),function(Q,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,I.createDecorator)("languagePackService");let C=class extends i.Disposable{constructor(E){super(),this.extensionGalleryService=E}async getAvailableLanguages(){const E=new D.CancellationTokenSource;setTimeout(()=>E.cancel(),1e3);let b;try{b=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const m=b.firstPage.filter(f=>f.properties.localizedLanguages?.length&&f.tags.some(v=>v.startsWith("lp-"))).map(f=>{const v=f.properties.localizedLanguages?.[0],y=this.getLocale(f);return{...this.createQuickPickItem(y,v,f),extensionId:f.identifier.id,galleryExtension:f}});return m.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),m}getLocale(E){return E.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(E,b,S){const m=b??E;let f;if(m!==E&&(f=`(${E})`),E.toLowerCase()===R.language.toLowerCase()&&(f??="",f+=(0,k.localize)(0,null)),S?.installCount){f??="";const v=S.installCount;let y;v>1e6?y=`${Math.floor(v/1e5)/10}M`:v>1e3?y=`${Math.floor(v/1e3)}K`:y=String(v),f+=` $(cloud-download) ${y}`}return{id:E,label:m,description:f}}};C=ve([K(0,T.IExtensionGalleryService)],C),e.LanguagePackBaseService=C}),define(re[202],se([0,1,2,72]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(T){super(),this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=ve([K(0,i.ILanguagePackService)],R),e.LocalizationsUpdater=R}),define(re[7],se([0,1,37,3,2,41,5,8,4]),function(Q,e,D,i,R,k,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,C.createDecorator)("logService"),e.ILoggerService=(0,C.createDecorator)("loggerService");function w(){return new Date().toISOString()}var E;(function(l){l[l.Off=0]="Off",l[l.Trace=1]="Trace",l[l.Debug=2]="Debug",l[l.Info=3]="Info",l[l.Warning=4]="Warning",l[l.Error=5]="Error"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function b(l,a,g){switch(a){case E.Trace:l.trace(g);break;case E.Debug:l.debug(g);break;case E.Info:l.info(g);break;case E.Warning:l.warn(g);break;case E.Error:l.error(g);break;default:throw new Error("Invalid log level")}}e.log=b;function S(l){let a="";for(let g=0;g<l.length;g++){let P=l[g];if(typeof P=="object")try{P=JSON.stringify(P)}catch{}a+=(g>0?" ":"")+P}return a}e.format=S;class m extends R.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=m;class f extends m{constructor(a){super(),this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...g){this.checkLogLevel(E.Trace)&&this.log(E.Trace,S([a,...g]))}debug(a,...g){this.checkLogLevel(E.Debug)&&this.log(E.Debug,S([a,...g]))}info(a,...g){this.checkLogLevel(E.Info)&&this.log(E.Info,S([a,...g]))}warn(a,...g){this.checkLogLevel(E.Warning)&&this.log(E.Warning,S([a,...g]))}error(a,...g){if(this.checkLogLevel(E.Error))if(a instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=a.stack,this.log(E.Error,S(P))}else this.log(E.Error,S([a,...g]))}flush(){}}e.AbstractMessageLogger=f;class v extends m{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.useColors=!T.isWindows}trace(a,...g){this.getLevel()<=E.Trace&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,a,...g):console.log(`[main ${w()}]`,a,...g))}debug(a,...g){this.getLevel()<=E.Debug&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,a,...g):console.log(`[main ${w()}]`,a,...g))}info(a,...g){this.getLevel()<=E.Info&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,a,...g):console.log(`[main ${w()}]`,a,...g))}warn(a,...g){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,a,...g):console.warn(`[main ${w()}]`,a,...g))}error(a,...g){this.getLevel()<=E.Error&&(this.useColors?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,a,...g):console.error(`[main ${w()}]`,a,...g))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class y extends m{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...g){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",a,...g)}debug(a,...g){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...g)}info(a,...g){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",a,...g)}warn(a,...g){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",a,...g)}error(a,...g){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",a,...g)}dispose(){}flush(){}}e.ConsoleLogger=y;class u extends m{constructor(a,g=e.DEFAULT_LOG_LEVEL){super(),this.adapter=a,this.setLevel(g)}trace(a,...g){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(a),...g])}debug(a,...g){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(a),...g])}info(a,...g){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(a),...g])}warn(a,...g){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(a),...g])}error(a,...g){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(a),...g])}extractMessage(a){return typeof a=="string"?a:(0,D.toErrorMessage)(a,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=u;class p extends m{constructor(a){super(),this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const g of this.logServices)g.setLevel(a);super.setLevel(a)}trace(a,...g){for(const P of this.logServices)P.trace(a,...g)}debug(a,...g){for(const P of this.logServices)P.debug(a,...g)}info(a,...g){for(const P of this.logServices)P.info(a,...g)}warn(a,...g){for(const P of this.logServices)P.warn(a,...g)}error(a,...g){for(const P of this.logServices)P.error(a,...g)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=p;class c extends R.Disposable{constructor(a){super(),this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...g){this.logger.trace(a,...g)}debug(a,...g){this.logger.debug(a,...g)}info(a,...g){this.logger.info(a,...g)}warn(a,...g){this.logger.warn(a,...g)}error(a,...g){this.logger.error(a,...g)}flush(){this.logger.flush()}}e.LogService=c;class h extends R.Disposable{constructor(a,g){super(),this.logLevel=a,this.loggerItems=new k.ResourceMap,this._register(g(P=>this.setLevel(P)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:a})=>a)}getLogger(a){return this.loggerItems.get(a)?.logger}createLogger(a,g,P){let A=this.loggerItems.get(a)?.logger;return A||(P=g?.always?E.Trace:P,A=this.doCreateLogger(a,P??this.logLevel,g),this.loggerItems.set(a,{logger:A,logLevel:P})),A}setLevel(a,g){const P=I.URI.isUri(a)?a:void 0,A=P?g:a;if(P){const V=this.loggerItems.get(P);V&&V.logLevel!==A&&(V.logLevel=A,V.logger.setLevel(A))}else this.logLevel=A,this.loggerItems.forEach(({logLevel:V,logger:O})=>{V===void 0&&O.setLevel(this.logLevel)})}getLogLevel(a){return this.loggerItems.get(a)?.logLevel}dispose(){this.loggerItems.forEach(({logger:a})=>a.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=h;class d{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(a){}getLevel(){return E.Info}trace(a,...g){}debug(a,...g){}info(a,...g){}warn(a,...g){}error(a,...g){}critical(a,...g){}dispose(){}flush(){}}e.NullLogger=d;class n extends d{}e.NullLogService=n;class o extends h{constructor(){super(E.Info,i.Event.None)}doCreateLogger(a,g,P){return new d}}e.NullLoggerService=o;function t(l){if(l.verbose)return E.Trace;if(typeof l.logLevel=="string"){const a=r(l.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function s(l){switch(l){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.LogLevelToString=s;function r(l){switch(l){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.parseLogLevel=r}),define(re[203],se([0,1,6,11,2,12,28,13,7]),function(Q,e,D,i,R,k,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let w=class extends R.Disposable{constructor(b,S){super(),this.environmentService=b,this.logService=S,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const b=(0,k.basename)(this.environmentService.logsPath),S=(0,k.dirname)(this.environmentService.logsPath),v=(await T.Promises.readdir(S)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==b),y=v.slice(0,Math.max(0,v.length-9));y.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${y.join(", ")}'`),await Promise.all(y.map(u=>T.Promises.rm((0,k.join)(S,u)))))}catch(b){(0,i.onUnexpectedError)(b)}}};w=ve([K(0,I.IEnvironmentService),K(1,C.ILogService)],w),e.LogsDataCleaner=w}),define(re[204],se([0,1,19,6,11,3,2,12,56,7]),function(Q,e,D,i,R,k,T,I,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class E extends T.Disposable{constructor(S,m){super(),this.logService=S,this.options=m,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new i.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new i.ThrottledDelayer(0))}watch(S,m){return m.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,m):this.watchNonRecursive(S,m)}watchUniversal(S,m){const f={path:this.toFilePath(S),excludes:m.excludes,includes:m.includes,recursive:m.recursive},v=(0,D.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{v(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,R.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(m=>this._onDidChangeFile.fire((0,C.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const m of this.universalPathsToWatch)(0,C.isRecursiveWatchRequest)(m)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const m of this.universalPathsToWatch)(0,C.isRecursiveWatchRequest)(m)&&S.includes(m.path)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,m){const f={path:this.toFilePath(S),excludes:m.excludes,includes:m.includes,recursive:!1},v=(0,D.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{v(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,R.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,C.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,I.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=E}),define(re[205],se([0,1,19,6,17,22,3,66,64,2,49,23,206,20,43,163,14,100,7]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class extends w.Disposable{constructor(d){super(),this.logService=d,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new i.ResourceQueue)}registerProvider(d,n){if(this.provider.has(d))throw new Error(`A filesystem provider for the scheme '${d}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${d}`);const o=new w.DisposableStore;return this.provider.set(d,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:d,provider:n}),o.add(n.onDidChangeFile(t=>this._onDidFilesChange.fire(new y.FileChangesEvent(t,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&o.add(n.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),o.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:d}))),(0,w.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:d,provider:n}),this.provider.delete(d),(0,w.dispose)(o)})}getProvider(d){return this.provider.get(d)}async activateProvider(d){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:d,join(o){n.push(o)}}),!this.provider.has(d)&&await i.Promises.settled(n)}async canHandleResource(d){return await this.activateProvider(d.scheme),this.hasProvider(d)}hasProvider(d){return this.provider.has(d.scheme)}hasCapability(d,n){const o=this.provider.get(d.scheme);return!!(o&&o.capabilities&n)}listCapabilities(){return C.Iterable.map(this.provider,([d,n])=>({scheme:d,capabilities:n.capabilities}))}async withProvider(d){if(!(0,m.isAbsolutePath)(d))throw new y.FileOperationError((0,v.localize)(0,null,this.resourceForError(d)),8);await this.activateProvider(d.scheme);const n=this.provider.get(d.scheme);if(!n){const o=new Error;throw o.name="ENOPRO",o.message=(0,v.localize)(1,null,d.toString()),o}return n}async withReadProvider(d){const n=await this.withProvider(d);if((0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n)||(0,y.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${d.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(d){const n=await this.withProvider(d);if((0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${d.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(d,n){try{return await this.doResolveFile(d,n)}catch(o){throw(0,y.toFileSystemProviderErrorCode)(o)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,v.localize)(2,null,this.resourceForError(d)),1):(0,y.ensureFileSystemProviderError)(o)}}async doResolveFile(d,n){const o=await this.withProvider(d),t=this.isPathCaseSensitive(o),s=n?.resolveTo,r=n?.resolveSingleChildDescendants,l=n?.resolveMetadata,a=await o.stat(d);let g;return this.toFileStat(o,d,a,void 0,!!l,(P,A)=>(g||(g=E.TernarySearchTree.forUris(()=>!t),g.set(d,!0),s&&g.fill(!0,s)),g.get(P.resource)||g.findSuperstr(P.resource.with({query:null,fragment:null}))?!0:P.isDirectory&&r?A===1:!1))}async toFileStat(d,n,o,t,s,r){const{providerExtUri:l}=this.getExtUri(d),a={resource:n,name:l.basename(n),isFile:(o.type&y.FileType.File)!==0,isDirectory:(o.type&y.FileType.Directory)!==0,isSymbolicLink:(o.type&y.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&y.FilePermission.Readonly)||Boolean(d.capabilities&2048),etag:(0,y.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(a.isDirectory&&r(a,t)){try{const g=await d.readdir(n),P=await i.Promises.settled(g.map(async([A,V])=>{try{const O=l.joinPath(n,A),F=s?await d.stat(O):{type:V};return await this.toFileStat(d,O,F,g.length,s,r)}catch(O){return this.logService.trace(O),null}}));a.children=(0,D.coalesce)(P)}catch(g){this.logService.trace(g),a.children=[]}return a}return a}async resolveAll(d){return i.Promises.settled(d.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(d){const n=await this.withProvider(d),o=await n.stat(d);return this.toFileStat(n,d,o,void 0,!0,()=>!1)}async exists(d){const n=await this.withProvider(d);try{return!!await n.stat(d)}catch{return!1}}async canCreateFile(d,n){try{await this.doValidateCreateFile(d,n)}catch(o){return o}return!0}async doValidateCreateFile(d,n){if(!n?.overwrite&&await this.exists(d))throw new y.FileOperationError((0,v.localize)(3,null,this.resourceForError(d)),3,n)}async createFile(d,n=R.VSBuffer.fromString(""),o){await this.doValidateCreateFile(d,o);const t=await this.writeFile(d,n);return this._onDidRunOperation.fire(new y.FileOperationEvent(d,0,t)),t}async writeFile(d,n,o){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(d),d),{providerExtUri:s}=this.getExtUri(t);try{await this.validateWriteFile(t,d,o)||await this.mkdirp(t,s.dirname(d));let l;if((0,y.hasReadWriteCapability)(t)&&!(n instanceof R.VSBuffer))if((0,f.isReadableStream)(n)){const a=await(0,f.peekStream)(n,3);a.ended?l=R.VSBuffer.concat(a.buffer):l=a}else l=(0,f.peekReadable)(n,a=>R.VSBuffer.concat(a),3);else l=n;!(0,y.hasOpenReadWriteCloseCapability)(t)||(0,y.hasReadWriteCapability)(t)&&l instanceof R.VSBuffer?await this.doWriteUnbuffered(t,d,o,l):await this.doWriteBuffered(t,d,o,l instanceof R.VSBuffer?(0,R.bufferToReadable)(l):l),this._onDidRunOperation.fire(new y.FileOperationEvent(d,4))}catch(r){throw new y.FileOperationError((0,v.localize)(4,null,this.resourceForError(d),(0,y.ensureFileSystemProviderError)(r).toString()),(0,y.toFileOperationResult)(r),o)}return this.resolve(d,{resolveMetadata:!0})}async validateWriteFile(d,n,o){if(!!o?.unlock&&!(d.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(n)));let s;try{s=await d.stat(n)}catch{return}if((s.type&y.FileType.Directory)!==0)throw new y.FileOperationError((0,v.localize)(6,null,this.resourceForError(n)),0,o);if(this.throwIfFileIsReadonly(n,s),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==y.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&o.mtime<s.mtime&&o.etag!==(0,y.etag)({mtime:o.mtime,size:s.size}))throw new y.FileOperationError((0,v.localize)(7,null),3,o);return s}async readFile(d,n,o){const t=await this.withReadProvider(d);return n?.atomic?this.doReadFileAtomic(t,d,n,o):this.doReadFile(t,d,n,o)}async doReadFileAtomic(d,n,o,t){return new Promise((s,r)=>{this.writeQueue.queueFor(n,this.getExtUri(d).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(d,n,o,t);s(l)}catch(l){r(l)}})})}async doReadFile(d,n,o,t){const s=await this.doReadFileStream(d,n,{...o,preferUnbuffered:!0},t);return{...s,value:await(0,R.streamToBuffer)(s.value)}}async readFileStream(d,n,o){const t=await this.withReadProvider(d);return this.doReadFileStream(t,d,n,o)}async doReadFileStream(d,n,o,t){const s=new k.CancellationTokenSource(t),r=this.validateReadFile(n,o).then(a=>a,a=>{throw s.cancel(),a});let l;try{return typeof o?.etag=="string"&&o.etag!==y.ETAG_DISABLED&&await r,o?.atomic&&(0,y.hasFileAtomicReadCapability)(d)||!((0,y.hasOpenReadWriteCloseCapability)(d)||(0,y.hasFileReadStreamCapability)(d))||(0,y.hasReadWriteCapability)(d)&&o?.preferUnbuffered?l=this.readFileUnbuffered(d,n,o):(0,y.hasFileReadStreamCapability)(d)?l=this.readFileStreamed(d,n,s.token,o):l=this.readFileBuffered(d,n,s.token,o),{...await r,value:l}}catch(a){l&&await(0,f.consumeStream)(l);const g=(0,v.localize)(8,null,this.resourceForError(n),(0,y.ensureFileSystemProviderError)(a).toString());throw a instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(g,a.stat,o):new y.FileOperationError(g,(0,y.toFileOperationResult)(a),o)}}readFileStreamed(d,n,o,t=Object.create(null)){const s=d.readFileStream(n,t,o);return(0,f.transform)(s,{data:r=>r instanceof R.VSBuffer?r:R.VSBuffer.wrap(r),error:r=>new y.FileOperationError((0,v.localize)(9,null,this.resourceForError(n),(0,y.ensureFileSystemProviderError)(r).toString()),(0,y.toFileOperationResult)(r),t)},r=>R.VSBuffer.concat(r))}readFileBuffered(d,n,o,t=Object.create(null)){const s=(0,R.newWriteableBufferStream)();return(0,u.readFileIntoStream)(d,n,s,r=>r,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new y.FileOperationError((0,v.localize)(10,null,this.resourceForError(n),(0,y.ensureFileSystemProviderError)(r).toString()),(0,y.toFileOperationResult)(r),t)},o),s}readFileUnbuffered(d,n,o){const t=(0,f.newWriteableStream)(s=>R.VSBuffer.concat(s));return(async()=>{try{let s;o?.atomic&&(0,y.hasFileAtomicReadCapability)(d)?s=await d.readFile(n,{atomic:!0}):s=await d.readFile(n),typeof o?.position=="number"&&(s=s.slice(o.position)),typeof o?.length=="number"&&(s=s.slice(0,o.length)),this.validateReadFileLimits(n,s.byteLength,o),t.end(R.VSBuffer.wrap(s))}catch(s){t.error(s),t.end()}})(),t}async validateReadFile(d,n){const o=await this.resolve(d,{resolveMetadata:!0});if(o.isDirectory)throw new y.FileOperationError((0,v.localize)(11,null,this.resourceForError(d)),0,n);if(typeof n?.etag=="string"&&n.etag!==y.ETAG_DISABLED&&n.etag===o.etag)throw new y.NotModifiedSinceFileOperationError((0,v.localize)(12,null),o,n);return this.validateReadFileLimits(d,o.size,n),o}validateReadFileLimits(d,n,o){if(o?.limits){let t;if(typeof o.limits.memory=="number"&&n>o.limits.memory&&(t=9),typeof o.limits.size=="number"&&n>o.limits.size&&(t=7),typeof t=="number")throw new y.FileOperationError((0,v.localize)(13,null,this.resourceForError(d)),t)}}async canMove(d,n,o){return this.doCanMoveCopy(d,n,"move",o)}async canCopy(d,n,o){return this.doCanMoveCopy(d,n,"copy",o)}async doCanMoveCopy(d,n,o,t){if(d.toString()!==n.toString())try{const s=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(d),d):await this.withReadProvider(d),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(s,d,r,n,o,t)}catch(s){return s}return!0}async move(d,n,o){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(d),d),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),r=await this.doMoveCopy(t,d,s,n,"move",!!o),l=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(d,r==="move"?2:3,l)),l}async copy(d,n,o){const t=await this.withReadProvider(d),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),r=await this.doMoveCopy(t,d,s,n,"copy",!!o),l=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(d,r==="copy"?3:2,l)),l}async doMoveCopy(d,n,o,t,s,r){if(n.toString()===t.toString())return s;const{exists:l,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(d,n,o,t,s,r);if(l&&!a&&r&&await this.del(t,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(t)),s==="copy"){if(d===o&&(0,y.hasFileFolderCopyCapability)(d))await d.copy(n,t,{overwrite:r});else{const g=await this.resolve(n);g.isDirectory?await this.doCopyFolder(d,g,o,t):await this.doCopyFile(d,n,o,t)}return s}else return d===o?(await d.rename(n,t,{overwrite:r}),s):(await this.doMoveCopy(d,n,o,t,"copy",r),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(d,n,o,t){if((0,y.hasOpenReadWriteCloseCapability)(d)&&(0,y.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(d,n,o,t);if((0,y.hasOpenReadWriteCloseCapability)(d)&&(0,y.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(d,n,o,t);if((0,y.hasReadWriteCapability)(d)&&(0,y.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(d,n,o,t);if((0,y.hasReadWriteCapability)(d)&&(0,y.hasReadWriteCapability)(o))return this.doPipeUnbuffered(d,n,o,t)}async doCopyFolder(d,n,o,t){await o.mkdir(t),Array.isArray(n.children)&&await i.Promises.settled(n.children.map(async s=>{const r=this.getExtUri(o).providerExtUri.joinPath(t,s.name);return s.isDirectory?this.doCopyFolder(d,await this.resolve(s.resource),o,r):this.doCopyFile(d,s.resource,o,r)}))}async doValidateMoveCopy(d,n,o,t,s,r){let l=!1;if(d===o){const{providerExtUri:g,isPathCaseSensitive:P}=this.getExtUri(d);if(P||(l=g.isEqual(n,t)),l&&s==="copy")throw new Error((0,v.localize)(14,null,this.resourceForError(n),this.resourceForError(t)));if(!l&&g.isEqualOrParent(t,n))throw new Error((0,v.localize)(15,null,this.resourceForError(n),this.resourceForError(t)))}const a=await this.exists(t);if(a&&!l){if(!r)throw new y.FileOperationError((0,v.localize)(16,null,this.resourceForError(n),this.resourceForError(t)),4);if(d===o){const{providerExtUri:g}=this.getExtUri(d);if(g.isEqualOrParent(n,t))throw new Error((0,v.localize)(17,null,this.resourceForError(n),this.resourceForError(t)))}}return{exists:a,isSameResourceWithDifferentPathCase:l}}getExtUri(d){const n=this.isPathCaseSensitive(d);return{providerExtUri:n?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(d){return!!(d.capabilities&1024)}async createFolder(d){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(d),d);await this.mkdirp(n,d);const o=await this.resolve(d,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(d,0,o)),o}async mkdirp(d,n){const o=[],{providerExtUri:t}=this.getExtUri(d);for(;!t.isEqual(n,t.dirname(n));)try{if(((await d.stat(n)).type&y.FileType.Directory)===0)throw new Error((0,v.localize)(18,null,this.resourceForError(n)));break}catch(s){if((0,y.toFileSystemProviderErrorCode)(s)!==y.FileSystemProviderErrorCode.FileNotFound)throw s;o.push(t.basename(n)),n=t.dirname(n)}for(let s=o.length-1;s>=0;s--){n=t.joinPath(n,o[s]);try{await d.mkdir(n)}catch(r){if((0,y.toFileSystemProviderErrorCode)(r)!==y.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(d,n){try{await this.doValidateDelete(d,n)}catch(o){return o}return!0}async doValidateDelete(d,n){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(d),d);if(!!n?.useTrash&&!(o.capabilities&4096))throw new Error((0,v.localize)(19,null,this.resourceForError(d)));let s;try{s=await o.stat(d)}catch{}if(s)this.throwIfFileIsReadonly(d,s);else throw new y.FileOperationError((0,v.localize)(20,null,this.resourceForError(d)),1);if(!!!n?.recursive){const l=await this.resolve(d);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,v.localize)(21,null,this.resourceForError(d)))}return o}async del(d,n){const o=await this.doValidateDelete(d,n),t=!!n?.useTrash,s=!!n?.recursive;await o.delete(d,{recursive:s,useTrash:t}),this._onDidRunOperation.fire(new y.FileOperationEvent(d,1))}async cloneFile(d,n){const o=await this.withProvider(d),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(o===t&&this.getExtUri(o).providerExtUri.isEqual(d,n))return;if(o===t&&(0,y.hasFileCloneCapability)(o))return o.cloneFile(d,n);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n));const s=this.writeQueue.queueFor(d,this.getExtUri(o).providerExtUri);return o===t&&(0,y.hasFileFolderCopyCapability)(o)?s.queue(()=>o.copy(d,n,{overwrite:!0})):s.queue(()=>this.doCopyFile(o,d,t,n))}watch(d,n={recursive:!1,excludes:[]}){const o=new w.DisposableStore;let t=!1,s=()=>{t=!0};return o.add((0,w.toDisposable)(()=>s())),(async()=>{try{const r=await this.doWatch(d,n);t?(0,w.dispose)(r):s=()=>(0,w.dispose)(r)}catch(r){this.logService.error(r)}})(),o}async doWatch(d,n){const o=await this.withProvider(d),t=(0,I.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(d),n]);let s=this.activeWatchers.get(t);return s||(s={count:0,disposable:o.watch(d,n)},this.activeWatchers.set(t,s)),s.count+=1,(0,w.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,w.dispose)(s.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,d]of this.activeWatchers)(0,w.dispose)(d.disposable);this.activeWatchers.clear()}async doWriteBuffered(d,n,o,t){return this.writeQueue.queueFor(n,this.getExtUri(d).providerExtUri).queue(async()=>{const s=await d.open(n,{create:!0,unlock:o?.unlock??!1});try{(0,f.isReadableStream)(t)||(0,f.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(d,s,t):await this.doWriteReadableBufferedQueued(d,s,t)}catch(r){throw(0,y.ensureFileSystemProviderError)(r)}finally{await d.close(s)}})}async doWriteStreamBufferedQueued(d,n,o){let t=0,s;if((0,f.isReadableBufferedStream)(o)){if(o.buffer.length>0){const r=R.VSBuffer.concat(o.buffer);await this.doWriteBuffer(d,n,r,r.byteLength,t,0),t+=r.byteLength}if(o.ended)return;s=o.stream}else s=o;return new Promise((r,l)=>{(0,f.listenStream)(s,{onData:async a=>{s.pause();try{await this.doWriteBuffer(d,n,a,a.byteLength,t,0)}catch(g){return l(g)}t+=a.byteLength,setTimeout(()=>s.resume())},onError:a=>l(a),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(d,n,o){let t=0,s;for(;(s=o.read())!==null;)await this.doWriteBuffer(d,n,s,s.byteLength,t,0),t+=s.byteLength}async doWriteBuffer(d,n,o,t,s,r){let l=0;for(;l<t;)l+=await d.write(n,s+l,o.buffer,r+l,t-l)}async doWriteUnbuffered(d,n,o,t){return this.writeQueue.queueFor(n,this.getExtUri(d).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(d,n,o,t))}async doWriteUnbufferedQueued(d,n,o,t){let s;t instanceof R.VSBuffer?s=t:(0,f.isReadableStream)(t)?s=await(0,R.streamToBuffer)(t):(0,f.isReadableBufferedStream)(t)?s=await(0,R.bufferedStreamToBuffer)(t):s=(0,R.readableToBuffer)(t),await d.writeFile(n,s.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(d,n,o,t){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(d,n,o,t))}async doPipeBufferedQueued(d,n,o,t){let s,r;try{s=await d.open(n,{create:!1}),r=await o.open(t,{create:!0,unlock:!1});const l=R.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,g=0,P=0;do P=await d.read(s,a,l.buffer,g,l.byteLength-g),await this.doWriteBuffer(o,r,l,P,a,g),a+=P,g+=P,g===l.byteLength&&(g=0);while(P>0)}catch(l){throw(0,y.ensureFileSystemProviderError)(l)}finally{await i.Promises.settled([typeof s=="number"?d.close(s):Promise.resolve(),typeof r=="number"?o.close(r):Promise.resolve()])}}async doPipeUnbuffered(d,n,o,t){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(d,n,o,t))}async doPipeUnbufferedQueued(d,n,o,t){return o.writeFile(t,await d.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(d,n,o,t){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(d,n,o,t))}async doPipeUnbufferedToBufferedQueued(d,n,o,t){const s=await o.open(t,{create:!0,unlock:!1});try{const r=await d.readFile(n);await this.doWriteBuffer(o,s,R.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,y.ensureFileSystemProviderError)(r)}finally{await o.close(s)}}async doPipeBufferedToUnbuffered(d,n,o,t){const s=await(0,R.streamToBuffer)(this.readFileBuffered(d,n,k.CancellationToken.None));await this.doWriteUnbuffered(o,t,void 0,s)}throwIfFileSystemIsReadonly(d,n){if(d.capabilities&2048)throw new y.FileOperationError((0,v.localize)(22,null,this.resourceForError(n)),6);return d}throwIfFileIsReadonly(d,n){if((n.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,v.localize)(23,null,this.resourceForError(d)),6)}resourceForError(d){return d.scheme===b.Schemas.file?d.fsPath:d.toString(!0)}};c=ve([K(0,p.ILogService)],c),e.FileService=c}),define(re[207],se([0,1,53,286,6,41,17,3,48,2,12,5,20,43,28,166,14,100,204,37,199,198]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u,p,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,i.gracefulify)(D)}catch(o){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(o)}`)}})();class n extends p.AbstractDiskFileSystemProvider{constructor(t,s){super(t,s),this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new k.ResourceMap(r=>S.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:s,symbolicLink:r}=await f.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(s,r),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(t){try{const s=await f.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),r=[];return await Promise.all(s.map(async l=>{try{let a;l.isSymbolicLink()?a=(await this.stat((0,S.joinPath)(t,l.name))).type:a=this.toType(l),r.push([l.name,a])}catch(a){this.logService.trace(a)}})),r}catch(s){throw this.toFileSystemProviderError(s)}}toType(t,s){let r;return s?.dangling?r=y.FileType.Unknown:t.isFile()?r=y.FileType.File:t.isDirectory()?r=y.FileType.Directory:r=y.FileType.Unknown,s&&(r|=y.FileType.SymbolicLink),r}async createResourceLock(t){const s=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let r;for(;r=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await r.wait();const l=new R.Barrier;return this.resourceLocks.set(t,l),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,w.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.resourceLocks.get(t)===l&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),l.open()})}async readFile(t,s){let r;try{s?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),r=await this.createResourceLock(t));const l=this.toFilePath(t);return await f.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{r?.dispose()}}traceLock(t){n.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,s,r){const l=(0,m.newWriteableStream)(a=>T.VSBuffer.concat(a.map(g=>T.VSBuffer.wrap(g))).buffer);return(0,u.readFileIntoStream)(this,t,l,a=>a.buffer,{...s,bufferSize:256*1024},r),l}async writeFile(t,s,r){let l;try{const a=this.toFilePath(t);if(!r.create||!r.overwrite){if(await f.Promises.exists(a)){if(!r.overwrite)throw(0,y.createFileSystemProviderError)((0,v.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,y.createFileSystemProviderError)((0,v.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:r.unlock}),await this.write(l,0,s,0,s.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(t,a)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(t){n.canFlush=t}async open(t,s){const r=this.toFilePath(t);let l;(0,y.isFileOpenForWriteOptions)(s)&&(l=await this.createResourceLock(t));let a;try{if((0,y.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:P}=await f.SymlinkSupport.stat(r);P.mode&128||await f.Promises.chmod(r,P.mode|128)}catch(P){this.logService.trace(P)}let g;if((0,y.isFileOpenForWriteOptions)(s)){if(b.isWindows)try{await f.Promises.truncate(r,0),g="r+"}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}g||(g="w")}else g="r";a=await f.Promises.open(r,g)}catch(g){throw l?.dispose(),(0,y.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(t,g):this.toFileSystemProviderError(g)}if(this.mapHandleToPos.set(a,0),(0,y.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(a,t),l){const g=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${r})`),this.mapHandleToLock.set(a,l),g&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${r})`),g.dispose())}return a}async close(t){const s=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&n.canFlush)try{await f.Promises.fdatasync(t)}catch(r){n.configureFlushOnWrite(!1),this.logService.error(r)}return await f.Promises.close(t)}catch(r){throw this.toFileSystemProviderError(r)}finally{s&&(this.mapHandleToLock.get(t)===s&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),s.dispose())}}async read(t,s,r,l,a){const g=this.normalizePos(t,s);let P=null;try{P=(await f.Promises.read(t,r,l,a,g)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(t,g,P)}return P}normalizePos(t,s){return s===this.mapHandleToPos.get(t)?null:s}updatePos(t,s,r){const l=this.mapHandleToPos.get(t);typeof l=="number"&&(typeof s=="number"||(typeof r=="number"?this.mapHandleToPos.set(t,l+r):this.mapHandleToPos.delete(t)))}async write(t,s,r,l,a){return(0,R.retry)(()=>this.doWrite(t,s,r,l,a),100,3)}async doWrite(t,s,r,l,a){const g=this.normalizePos(t,s);let P=null;try{P=(await f.Promises.write(t,r,l,a,g)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),A)}finally{this.updatePos(t,g,P)}return P}async mkdir(t){try{await f.Promises.mkdir(this.toFilePath(t))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(t,s){try{const r=this.toFilePath(t);s.recursive?await f.Promises.rm(r,f.RimRafMode.MOVE):await f.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(t,s,r){const l=this.toFilePath(t),a=this.toFilePath(s);if(l!==a)try{await this.validateTargetDeleted(t,s,"move",r.overwrite),await f.Promises.move(l,a)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,v.localize)(2,null,(0,E.basename)(l),(0,E.basename)((0,E.dirname)(a)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(t,s,r){const l=this.toFilePath(t),a=this.toFilePath(s);if(l!==a)try{await this.validateTargetDeleted(t,s,"copy",r.overwrite),await f.Promises.copy(l,a,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,v.localize)(3,null,(0,E.basename)(l),(0,E.basename)((0,E.dirname)(a)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(t,s,r,l){const a=this.toFilePath(t),g=this.toFilePath(s);let P=!1;if(!!(this.capabilities&1024)||(P=(0,C.isEqual)(a,g,!0)),P&&r==="copy")throw(0,y.createFileSystemProviderError)((0,v.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!P&&await f.Promises.exists(g)){if(!l)throw(0,y.createFileSystemProviderError)((0,v.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}async cloneFile(t,s){return this.doCloneFile(t,s,!1)}async doCloneFile(t,s,r){const l=this.toFilePath(t),a=this.toFilePath(s),g=!!(this.capabilities&1024);if((0,C.isEqual)(l,a,!g))return;const P=new w.DisposableStore;try{const[A,V]=await Promise.all([this.createResourceLock(t),this.createResourceLock(s)]);P.add(A),P.add(V),r&&await f.Promises.mkdir((0,E.dirname)(a),{recursive:!0}),await f.Promises.copyFile(l,a)}catch(A){if(A.code==="ENOENT"&&!r)return this.doCloneFile(t,s,!0);throw this.toFileSystemProviderError(A)}finally{P.dispose()}}createUniversalWatcher(t,s,r){return new h.UniversalWatcherClient(l=>t(l),l=>s(l),r)}createNonRecursiveWatcher(t,s,r){return new d.NodeJSWatcherClient(l=>t(l),l=>s(l),r)}toFileSystemProviderError(t){if(t instanceof y.FileSystemProviderError)return t;let s;switch(t.code){case"ENOENT":s=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=y.FileSystemProviderErrorCode.NoPermissions;break;default:s=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(t,s)}async toFileSystemProviderWriteError(t,s){let r=this.toFileSystemProviderError(s);if(t&&r.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await f.SymlinkSupport.stat(this.toFilePath(t));l.mode&128||(r=(0,y.createFileSystemProviderError)(s,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return r}}e.DiskFileSystemProvider=n,n.TRACE_LOG_RESOURCE_LOCKS=!1,n.canFlush=!0}),define(re[101],se([0,1,6,3,2,4,7]),function(Q,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,k.createDecorator)("lifecycleSharedProcessService");let I=class extends R.Disposable{constructor(w){super(),this.logService=w,this.pendingWillShutdownPromise=void 0,this._onWillShutdown=this._register(new i.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const w=[];return this._onWillShutdown.fire({join(E){w.push(E)}}),this.pendingWillShutdownPromise=(async()=>{try{await D.Promises.settled(w)}catch(E){this.logService.error(E)}})(),this.pendingWillShutdownPromise}};I=ve([K(0,T.ILogService)],I),e.SharedProcessLifecycleService=I}),define(re[102],se([0,1,3,8,7]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(S,m){this.logService=S,this.loggerService=m,this.onDidChangeLogLevel=D.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,m){switch(m){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${m}`)}async call(S,m,f){switch(m){case"setLevel":return f[1]?this.loggerService.setLevel(i.URI.revive(f[1]),f[0]):this.logService.setLevel(f[0])}throw new Error(`Call not found: ${m}`)}}e.LogLevelChannel=k;class T{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S,m){T.setLevel(this.channel,S,m)}static setLevel(S,m,f){return S.call("setLevel",[m,f])}}e.LogLevelChannelClient=T;class I{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,m){throw new Error(`Event not found: ${m}`)}async call(S,m,f){switch(m){case"createLogger":this.createLogger(i.URI.revive(f[0]),f[1]);return;case"log":return this.log(i.URI.revive(f[0]),f[1]);case"consoleLog":return this.consoleLog(f[0],f[1])}throw new Error(`Call not found: ${m}`)}createLogger(S,m){this.loggers.set(S.toString(),this.loggerService.createLogger(S,m))}consoleLog(S,m){let f=console.log;switch(S){case R.LogLevel.Error:f=console.error;break;case R.LogLevel.Warning:f=console.warn;break;case R.LogLevel.Info:f=console.info;break}f.call(console,...m)}log(S,m){const f=this.loggers.get(S.toString());if(!f)throw new Error("Create the logger before logging");for(const[v,y]of m)(0,R.log)(f,v,y)}}e.LoggerChannel=I;class C extends R.AbstractLoggerService{constructor(S,m,f){super(S,m),this.channel=f}createConsoleMainLogger(){return new R.AdapterLogger({log:(S,m)=>{this.channel.call("consoleLog",[S,m])}})}doCreateLogger(S,m,f){return new w(this.channel,S,m,f)}}e.LoggerChannelClient=C;class w extends R.AbstractMessageLogger{constructor(S,m,f,v){super(v?.always),this.channel=S,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[m,v]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,m){const f=[[S,m]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(S){this.channel.call("log",[this.file,S])}}class E extends R.LogService{constructor(S,m){super(m),this.parent=S,this._register(S.onDidChangeLogLevel(f=>m.setLevel(f)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=E}),define(re[58],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(re[59],se([0,1,3,64,2,4]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,k.createDecorator)("policy");class T extends R.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(w){const E=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...w,...this.policyDefinitions},E!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(w),i.Iterable.reduce(this.policies.entries(),(b,[S,m])=>({...b,[S]:m}),{})}getPolicyValue(w){return this.policies.get(w)}serialize(){return i.Iterable.reduce(Object.entries(this.policyDefinitions),(w,[E,b])=>({...w,[E]:{definition:b,value:this.policies.get(E)}}),{})}}e.AbstractPolicyService=T;class I{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(re[208],se([0,1,3,2,59]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class k{constructor(C){this.service=C,this.disposables=new i.DisposableStore}listen(C,w){switch(w){case"onDidChange":return D.Event.map(this.service.onDidChange,E=>E.reduce((b,S)=>({...b,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${w}`)}call(C,w,E){switch(w){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(E)}throw new Error(`Call not found: ${w}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=k;class T extends R.AbstractPolicyService{constructor(C,w){super(),this.channel=w;for(const E in C){const{definition:b,value:S}=C[E];this.policyDefinitions[E]=b,S!==void 0&&this.policies.set(E,S)}this.channel.listen("onDidChange")(E=>{for(const b in E){const S=E[b];S===null?this.policies.delete(b):this.policies.set(b,S)}this._onDidChange.fire(Object.keys(E))})}async initializePolicies(C){const w=await this.channel.call("registerPolicyDefinitions",C);for(const E in w)this.policies.set(E,w[E])}}e.PolicyChannelClient=T}),define(re[103],se([0,1,23,5,36,20]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof i.globals.vscode<"u"&&typeof i.globals.vscode.context<"u"){const I=i.globals.vscode.context.configuration();if(I)T=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const I=(0,k.dirname)(D.FileAccess.asFileUri("",Q));if(T=Q.__$__nodeRequire((0,k.joinPath)(I,"product.json").fsPath),R.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const C=Q.__$__nodeRequire((0,k.joinPath)(I,"package.json").fsPath);Object.assign(T,{version:C.version})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(re[25],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(re[209],se([0,1,6,11,2,12,28,7,25]),function(Q,e,D,i,R,k,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let w=class extends R.Disposable{constructor(b,S,m){super(),this.productService=S,this.logService=m,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(b)},3e4)).schedule()}async cleanUpCodeCaches(b){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const S=Date.now(),m=(0,k.dirname)(b),f=(0,k.basename)(b),v=await T.Promises.readdir(m);await Promise.all(v.map(async y=>{if(y===f)return;const u=(0,k.join)(m,y),p=await T.Promises.stat(u);if(p.isDirectory()&&S-p.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${y}.`),T.Promises.rm(u)}))}catch(S){(0,i.onUnexpectedError)(S)}}};w=ve([K(1,C.IProductService),K(2,I.ILogService)],w),e.CodeCacheCleaner=w}),define(re[210],se([0,1,6,11,2,12,28,13,7,25]),function(Q,e,D,i,R,k,T,I,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let E=class extends R.Disposable{constructor(S,m,f){super(),this.environmentService=S,this.logService=m,this.productService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const S=Object.create(null),m=JSON.parse(await T.Promises.readFile((0,k.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const p of Object.keys(m)){const c=m[p];S[`${c.hash}.${p}`]=!0}const f=(0,k.join)(this.environmentService.userDataPath,"clp");if(!await T.Promises.exists(f))return;const y=await T.Promises.readdir(f);for(const p of y){if(S[p]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${p}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${p}`),await T.Promises.rm((0,k.join)(f,p))}const u=Date.now();for(const p of Object.keys(S)){const c=(0,k.join)(f,p),h=await T.Promises.readdir(c);for(const d of h){if(d==="tcf.json")continue;const n=(0,k.join)(c,d),o=await T.Promises.stat(n);o.isDirectory()&&u-o.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,k.join)(p,d)}`),await T.Promises.rm(n))}}}catch(S){(0,i.onUnexpectedError)(S)}}};E=ve([K(0,I.INativeEnvironmentService),K(1,C.ILogService),K(2,w.IProductService)],E),e.LanguagePackCachedDataCleaner=E}),define(re[211],se([0,1,12,4]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,i.createDecorator)("IV8InspectProfilingService");var R;(function(k){function T(C){return Boolean(C.samples&&C.timeDeltas)}k.isValidProfile=T;function I(C,w="noAbsolutePaths"){for(const E of C.nodes)E.callFrame&&E.callFrame.url&&((0,D.isAbsolute)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(E.callFrame.url))&&(E.callFrame.url=(0,D.join)(w,(0,D.basename)(E.callFrame.url)));return C}k.rewriteAbsolutePaths=I})(R=e.Utils||(e.Utils={}))}),define(re[212],se([0,1,30]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class i{constructor(){this._sessions=new Map}async startProfiling(k){const I=await(await new Promise((w,E)=>{Q(["v8-inspect-profiler"],w,E)})).startProfiling({port:k.port,checkForPaused:!0}),C=(0,D.generateUuid)();return this._sessions.set(C,I),C}async stopProfiling(k){const T=this._sessions.get(k);if(!T)throw new Error(`UNKNOWN session '${k}'`);const I=await T.stop();return this._sessions.delete(k),I.profile}}e.InspectProfilingService=i}),define(re[39],se([0,1,127,15]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(T,I){D.ok(i.isString(T)),D.ok(i.isObject(I)),D.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,I)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new R}),define(re[104],se([0,1,3,39]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class k{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,w){this.schemasById[R(C)]=w,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new k;i.Registry.add(e.Extensions.JSONContribution,T)}),define(re[45],se([0,1,19,3,15,152,16,104,39]),function(Q,e,D,i,R,k,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=C.Registry.as(I.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,o=!0){this.registerConfigurations([n],o)}registerConfigurations(n,o=!0){const t=this.doRegisterConfigurations(n,o);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(n){const o=this.doDeregisterConfigurations(n);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:n,remove:o}){const t=[];t.push(...this.doDeregisterConfigurations(o)),t.push(...this.doRegisterConfigurations(n,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(t)})}registerDefaultConfigurations(n){const o=[],t=[];for(const{overrides:s,source:r}of n)for(const l in s)if(o.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const a=this.configurationDefaultsOverrides.get(l),g=a?.valuesSources??new Map;if(r)for(const O of Object.keys(s[l]))g.set(O,r);const P={...a?.value||{},...s[l]};this.configurationDefaultsOverrides.set(l,{source:r,value:P,valuesSources:g});const A=(0,T.getLanguageTagSettingPlainKey)(l),V={type:"object",default:P,description:k.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:P,source:R.isString(r)?void 0:r,defaultValueSource:r};t.push(...v(l)),this.configurationProperties[l]=V,this.defaultLanguageConfigurationOverridesNode.properties[l]=V}else{this.configurationDefaultsOverrides.set(l,{value:s[l],source:r});const a=this.configurationProperties[l];a&&(this.updatePropertyDefaultValue(l,a),this.updateSchema(l,a))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const o=[];for(const{overrides:t,source:s}of n)for(const r in t){const l=this.configurationDefaultsOverrides.get(r),a=R.isString(s)?s:s?.id,g=R.isString(l?.source)?l?.source:l?.source?.id;if(a===g)if(o.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const P=this.configurationProperties[r];P&&(this.updatePropertyDefaultValue(r,P),this.updateSchema(r,P))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const o of n)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,o){const t=[];return n.forEach(s=>{t.push(...this.validateAndRegisterProperties(s,o,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),t}doDeregisterConfigurations(n){const o=[],t=s=>{if(s.properties)for(const r in s.properties){o.push(r);const l=this.configurationProperties[r];l?.policy?.name&&this.policyConfigurations.delete(l.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,s.properties[r])}s.allOf?.forEach(r=>t(r))};for(const s of n){t(s);const r=this.configurationContributors.indexOf(s);r!==-1&&this.configurationContributors.splice(r,1)}return o}validateAndRegisterProperties(n,o=!0,t,s,r=3){r=R.isUndefinedOrNull(n.scope)?r:n.scope;const l=[],a=n.properties;if(a)for(const P in a){const A=a[P];if(o&&c(P,A)){delete a[P];continue}if(A.source=t,A.defaultDefaultValue=a[P].default,this.updatePropertyDefaultValue(P,A),e.OVERRIDE_PROPERTY_REGEX.test(P)?A.scope=void 0:(A.scope=R.isUndefinedOrNull(A.scope)?r:A.scope,A.restricted=R.isUndefinedOrNull(A.restricted)?!!s?.includes(P):A.restricted),a[P].hasOwnProperty("included")&&!a[P].included){this.excludedConfigurationProperties[P]=a[P],delete a[P];continue}else this.configurationProperties[P]=a[P],a[P].policy?.name&&this.policyConfigurations.set(a[P].policy.name,P);!a[P].deprecationMessage&&a[P].markdownDeprecationMessage&&(a[P].deprecationMessage=a[P].markdownDeprecationMessage),l.push(P)}const g=n.allOf;if(g)for(const P of g)l.push(...this.validateAndRegisterProperties(P,o,t,s,r));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const o=t=>{const s=t.properties;if(s)for(const l in s)this.updateSchema(l,s[l]);t.allOf?.forEach(o)};o(n)}updateSchema(n,o){switch(e.allSettings.properties[n]=o,o.scope){case 1:e.applicationSettings.properties[n]=o;break;case 2:e.machineSettings.properties[n]=o;break;case 6:e.machineOverridableSettings.properties[n]=o;break;case 3:e.windowSettings.properties[n]=o;break;case 4:e.resourceSettings.properties[n]=o;break;case 5:e.resourceSettings.properties[n]=o,this.resourceLanguageSettingsSchema.properties[n]=o;break}}removeFromSchema(n,o){switch(delete e.allSettings.properties[n],o.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const o=`[${n}]`,t={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,t),e.allSettings.properties[o]=t,e.applicationSettings.properties[o]=t,e.machineSettings.properties[o]=t,e.machineOverridableSettings.properties[o]=t,e.windowSettings.properties[o]=t,e.resourceSettings.properties[o]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,o){const t=this.configurationDefaultsOverrides.get(n);let s=t?.value,r=t?.source;R.isUndefined(s)&&(s=o.defaultDefaultValue,r=void 0),R.isUndefined(s)&&(s=u(o.type)),o.default=s,o.defaultValueSource=r}}const m="\\[([^\\]]+)\\]",f=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(d){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(d)){let o=f.exec(d);for(;o?.length;){const t=o[1].trim();t&&n.push(t),o=f.exec(d)}}return(0,D.distinct)(n)}e.overrideIdentifiersFromKey=v;function y(d){return d.reduce((n,o)=>`${n}[${o}]`,"")}e.keyFromOverrideIdentifiers=y;function u(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const p=new S;C.Registry.add(e.Extensions.Configuration,p);function c(d,n){return d.trim()?e.OVERRIDE_PROPERTY_REGEX.test(d)?k.localize(7,null,d):p.getConfigurationProperties()[d]!==void 0?k.localize(8,null,d):n.policy?.name&&p.getPolicyConfigurations().get(n.policy?.name)!==void 0?k.localize(9,null,d,n.policy?.name,p.getPolicyConfigurations().get(n.policy?.name)):null:k.localize(6,null)}e.validateProperty=c;function h(){const d=[],n=p.getConfigurationProperties();for(const o of Object.keys(n))d.push([o,n[o].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.getScopes=h}),define(re[73],se([0,1,19,3,35,2,41,31,15,8,16,45,39]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class m{constructor(o={},t=[],s=[],r){this._contents=o,this._keys=t,this._overrides=s,this.raw=r,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const o=this.raw.map(t=>{if(t instanceof m)return t;const s=new f("");return s.parseRaw(t),s.configurationModel});this._rawConfiguration=o.reduce((t,s)=>s===t?s:t.merge(s),o[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(o){return o?(0,E.getConfigurationValue)(this.contents,o):this.contents}inspect(o,t){const s=this.rawConfiguration.getValue(o),r=t?this.rawConfiguration.getOverrideValue(o,t):void 0,l=t?this.rawConfiguration.override(t).getValue(o):s;return{value:s,override:r,merged:l}}getOverrideValue(o,t){const s=this.getContentsForOverrideIdentifer(t);return s?o?(0,E.getConfigurationValue)(s,o):s:void 0}getKeysForOverrideIdentifier(o){const t=[];for(const s of this.overrides)s.identifiers.includes(o)&&t.push(...s.keys);return D.distinct(t)}getAllOverrideIdentifiers(){const o=[];for(const t of this.overrides)o.push(...t.identifiers);return D.distinct(o)}override(o){let t=this.overrideConfigurations.get(o);return t||(t=this.createOverrideConfigurationModel(o),this.overrideConfigurations.set(o,t)),t}merge(...o){const t=I.deepClone(this.contents),s=I.deepClone(this.overrides),r=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const a of o)if(l.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.mergeContents(t,a.contents);for(const g of a.overrides){const[P]=s.filter(A=>D.equals(A.identifiers,g.identifiers));P?(this.mergeContents(P.contents,g.contents),P.keys.push(...g.keys),P.keys=D.distinct(P.keys)):s.push(I.deepClone(g))}for(const g of a.keys)r.indexOf(g)===-1&&r.push(g)}return new m(t,r,s,l.every(a=>a instanceof m)?void 0:l)}freeze(){return this.frozen=!0,this}clone(){return new m(I.deepClone(this.contents),[...this.keys],I.deepClone(this.overrides))}createOverrideConfigurationModel(o){const t=this.getContentsForOverrideIdentifer(o);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const s={};for(const r of D.distinct([...Object.keys(this.contents),...Object.keys(t)])){let l=this.contents[r];const a=t[r];a&&(typeof l=="object"&&typeof a=="object"?(l=I.deepClone(l),this.mergeContents(l,a)):l=a),s[r]=l}return new m(s,this.keys,this.overrides)}mergeContents(o,t){for(const s of Object.keys(t)){if(s in o&&C.isObject(o[s])&&C.isObject(t[s])){this.mergeContents(o[s],t[s]);continue}o[s]=I.deepClone(t[s])}}checkAndFreeze(o){return this.frozen&&!Object.isFrozen(o)?I.deepFreeze(o):o}getContentsForOverrideIdentifer(o){let t=null,s=null;const r=l=>{l&&(s?this.mergeContents(s,l):s=I.deepClone(l))};for(const l of this.overrides)D.equals(l.identifiers,[o])?t=l.contents:l.identifiers.includes(o)&&r(l.contents);return r(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,t){this.addKey(o),(0,E.addToValueTree)(this.contents,o,t,s=>{throw new Error(s)})}removeValue(o){this.removeKey(o)&&(0,E.removeFromValueTree)(this.contents,o)}addKey(o){let t=this.keys.length;for(let s=0;s<t;s++)o.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,o)}removeKey(o){const t=this.keys.indexOf(o);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=m;class f{constructor(o){this._name=o,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(o,t){if(!C.isUndefinedOrNull(o)){const s=this.doParseContent(o);this.parseRaw(s,t)}}reparse(o){this._raw&&this.parseRaw(this._raw,o)}parseRaw(o,t){this._raw=o;const{contents:s,keys:r,overrides:l,restricted:a,hasExcludedProperties:g}=this.doParseRaw(o,t);this._configurationModel=new m(s,r,l,g?[o]:void 0),this._restrictedConfigurations=a||[]}doParseContent(o){let t={},s=null,r=[];const l=[],a=[];function g(A){Array.isArray(r)?r.push(A):s!==null&&(r[s]=A)}const P={onObjectBegin:()=>{const A={};g(A),l.push(r),r=A,s=null},onObjectProperty:A=>{s=A},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const A=[];g(A),l.push(r),r=A,s=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:g,onError:(A,V,O)=>{a.push({error:A,offset:V,length:O})}};if(o)try{R.visit(o,P),t=r[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return t}doParseRaw(o,t){const s=S.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),r=this.filter(o,s,!0,t);o=r.raw;const l=(0,E.toValuesTree)(o,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),a=Object.keys(o),g=this.toOverrides(o,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:l,keys:a,overrides:g,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}filter(o,t,s,r){let l=!1;if(!r?.scopes&&!r?.skipRestricted)return{raw:o,restricted:[],hasExcludedProperties:l};const a={},g=[];for(const P in o)if(b.OVERRIDE_PROPERTY_REGEX.test(P)&&s){const A=this.filter(o[P],t,!1,r);a[P]=A.raw,l=l||A.hasExcludedProperties,g.push(...A.restricted)}else{const A=t[P],V=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&g.push(P),(V===void 0||r.scopes===void 0||r.scopes.includes(V))&&!(r.skipRestricted&&A?.restricted)?a[P]=o[P]:l=!0}return{raw:a,restricted:g,hasExcludedProperties:l}}toOverrides(o,t){const s=[];for(const r of Object.keys(o))if(b.OVERRIDE_PROPERTY_REGEX.test(r)){const l={};for(const a in o[r])l[a]=o[r][a];s.push({identifiers:(0,b.overrideIdentifiersFromKey)(r),keys:Object.keys(l),contents:(0,E.toValuesTree)(l,t)})}return s}}e.ConfigurationModelParser=f;class v extends k.Disposable{constructor(o,t,s,r){super(),this.userSettingsResource=o,this.scopes=t,this.fileService=r,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.any(i.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource)),i.Event.filter(this.fileService.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,o)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const o=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(o.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class y{constructor(o,t,s,r,l,a,g,P,A,V,O,F,N){this.key=o,this.overrides=t,this.value=s,this.overrideIdentifiers=r,this.defaultConfiguration=l,this.policyConfiguration=a,this.applicationConfiguration=g,this.userConfiguration=P,this.localUserConfiguration=A,this.remoteUserConfiguration=V,this.workspaceConfiguration=O,this.folderConfigurationModel=F,this.memoryInspectValue=N}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class u{constructor(o,t,s,r,l=new m,a=new m,g=new T.ResourceMap,P=new m,A=new T.ResourceMap,V=!0){this._defaultConfiguration=o,this._policyConfiguration=t,this._applicationConfiguration=s,this._localUserConfiguration=r,this._remoteUserConfiguration=l,this._workspaceConfiguration=a,this._folderConfigurations=g,this._memoryConfiguration=P,this._memoryConfigurationByResource=A,this._freeze=V,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(o,t,s){return this.getConsolidatedConfigurationModel(o,t,s).getValue(o)}updateValue(o,t,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new m,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,t===void 0?r.removeValue(o):r.setValue(o,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(o,t,s){const r=this.getConsolidatedConfigurationModel(o,t,s),l=D.distinct(r.overrides.map(P=>P.identifiers).flat()).filter(P=>r.getOverrideValue(o,P)!==void 0),a=this.getFolderConfigurationModelForResource(t.resource,s),g=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration;return new y(o,t,r.getValue(o),l.length?l:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),s?this._workspaceConfiguration.freeze():void 0,a?a.freeze():void 0,g.inspect(o,t.overrideIdentifier))}keys(o){const t=this.getFolderConfigurationModelForResource(void 0,o);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(o){this._defaultConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(o){this._policyConfiguration=o}updateApplicationConfiguration(o){this._applicationConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(o){this._localUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(o){this._remoteUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(o){this._workspaceConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(o,t){this._folderConfigurations.set(o,t),this._foldersConsolidatedConfigurations.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this._foldersConsolidatedConfigurations.delete(o)}compareAndUpdateDefaultConfiguration(o,t){const s=[];if(!t){const{added:r,updated:l,removed:a}=h(this._defaultConfiguration,o);t=[...r,...l,...a]}for(const r of t)for(const l of(0,b.overrideIdentifiersFromKey)(r)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(l),g=o.getKeysForOverrideIdentifier(l),P=[...g.filter(A=>a.indexOf(A)===-1),...a.filter(A=>g.indexOf(A)===-1),...a.filter(A=>!I.equals(this._defaultConfiguration.override(l).getValue(A),o.override(l).getValue(A)))];s.push([l,P])}return this.updateDefaultConfiguration(o),{keys:t,overrides:s}}compareAndUpdatePolicyConfiguration(o){const{added:t,updated:s,removed:r}=h(this._policyConfiguration,o),l=[...t,...s,...r];return l.length&&this.updatePolicyConfiguration(o),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:t,updated:s,removed:r,overrides:l}=h(this.applicationConfiguration,o),a=[...t,...s,...r];return a.length&&this.updateApplicationConfiguration(o),{keys:a,overrides:l}}compareAndUpdateLocalUserConfiguration(o){const{added:t,updated:s,removed:r,overrides:l}=h(this.localUserConfiguration,o),a=[...t,...s,...r];return a.length&&this.updateLocalUserConfiguration(o),{keys:a,overrides:l}}compareAndUpdateRemoteUserConfiguration(o){const{added:t,updated:s,removed:r,overrides:l}=h(this.remoteUserConfiguration,o),a=[...t,...s,...r];return a.length&&this.updateRemoteUserConfiguration(o),{keys:a,overrides:l}}compareAndUpdateWorkspaceConfiguration(o){const{added:t,updated:s,removed:r,overrides:l}=h(this.workspaceConfiguration,o),a=[...t,...s,...r];return a.length&&this.updateWorkspaceConfiguration(o),{keys:a,overrides:l}}compareAndUpdateFolderConfiguration(o,t){const s=this.folderConfigurations.get(o),{added:r,updated:l,removed:a,overrides:g}=h(s,t),P=[...r,...l,...a];return(P.length||!s)&&this.updateFolderConfiguration(o,t),{keys:P,overrides:g}}compareAndDeleteFolderConfiguration(o){const t=this.folderConfigurations.get(o);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:s,updated:r,removed:l,overrides:a}=h(t,void 0);return{keys:[...s,...r,...l],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(o,t,s){let r=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier&&(r=r.override(t.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(o)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:o},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&o){const r=t.getFolder(o);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const l=this._memoryConfigurationByResource.get(o);l&&(s=s.merge(l))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(o){let t=this._foldersConsolidatedConfigurations.get(o);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(o);r?(t=s.merge(r),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(o,t)):t=s}return t}getFolderConfigurationModelForResource(o,t){if(t&&o){const s=t.getFolder(o);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((o,t)=>{const{contents:s,overrides:r,keys:l}=this._folderConfigurations.get(t);return o.push([t,{contents:s,overrides:r,keys:l}]),o},[])}}allKeys(){const o=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>o.add(t)),this.userConfiguration.freeze().keys.forEach(t=>o.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>o.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>o.add(s))),[...o.values()]}allOverrideIdentifiers(){const o=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>o.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>o.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>o.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>o.add(s))),[...o.values()]}getAllKeysForOverrideIdentifier(o){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(o).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(o).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(o).forEach(r=>t.add(r))),[...t.values()]}static parse(o){const t=this.parseConfigurationModel(o.defaults),s=this.parseConfigurationModel(o.policy),r=this.parseConfigurationModel(o.application),l=this.parseConfigurationModel(o.user),a=this.parseConfigurationModel(o.workspace),g=o.folders.reduce((P,A)=>(P.set(w.URI.revive(A[0]),this.parseConfigurationModel(A[1])),P),new T.ResourceMap);return new u(t,s,r,l,new m,a,g,new m,new T.ResourceMap,!1)}static parseConfigurationModel(o){return new m(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=u;function p(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const o=new Set,t=new Map;for(const r of n)r.keys.forEach(l=>o.add(l)),r.overrides.forEach(([l,a])=>{const g=(0,T.getOrSet)(t,l,new Set);a.forEach(P=>g.add(P))});const s=[];return t.forEach((r,l)=>s.push([l,[...r.values()]])),{keys:[...o.values()],overrides:s}}e.mergeChanges=p;class c{constructor(o,t,s,r){this.change=o,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;o.keys.forEach(g=>l.add(g)),o.overrides.forEach(([,g])=>g.forEach(P=>l.add(P))),this.affectedKeys=[...l.values()];const a=new m;this.affectedKeys.forEach(g=>a.setValue(g,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=u.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(o,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,o)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(o,t,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(o,t,this.currentWorkspace);return!I.equals(s,r)}return!0}return!1}doesAffectedKeysTreeContains(o,t){let s=(0,E.toValuesTree)({[t]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(o=o[r],!o)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=c;function h(n,o){const{added:t,removed:s,updated:r}=d(o?.rawConfiguration,n?.rawConfiguration),l=[],a=n?.getAllOverrideIdentifiers()||[],g=o?.getAllOverrideIdentifiers()||[];if(o){const P=g.filter(A=>!a.includes(A));for(const A of P)l.push([A,o.getKeysForOverrideIdentifier(A)])}if(n){const P=a.filter(A=>!g.includes(A));for(const A of P)l.push([A,n.getKeysForOverrideIdentifier(A)])}if(o&&n){for(const P of a)if(g.includes(P)){const A=d({contents:n.getOverrideValue(void 0,P)||{},keys:n.getKeysForOverrideIdentifier(P)},{contents:o.getOverrideValue(void 0,P)||{},keys:o.getKeysForOverrideIdentifier(P)});l.push([P,[...A.added,...A.removed,...A.updated]])}}return{added:t,removed:s,updated:r,overrides:l}}function d(n,o){const t=n?o?n.keys.filter(l=>o.keys.indexOf(l)===-1):[...n.keys]:[],s=o?n?o.keys.filter(l=>n.keys.indexOf(l)===-1):[...o.keys]:[],r=[];if(n&&o){for(const l of o.keys)if(n.keys.indexOf(l)!==-1){const a=(0,E.getConfigurationValue)(o.contents,l),g=(0,E.getConfigurationValue)(n.contents,l);I.equals(a,g)||r.push(l)}}return{added:t,removed:s,updated:r}}}),define(re[213],se([0,1,19,3,2,31,15,16,73,45,7,59,39]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class m extends R.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new f(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(S.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:c})=>this.onDidUpdateConfiguration(p,c))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(p,c){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:p})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=m;class f extends C.ConfigurationModel{constructor(p={}){const c=S.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(c),d=Object.create(null),n=[];for(const o in c){const t=p[o],s=t!==void 0?t:c[o].default;(0,I.addToValueTree)(d,o,s,r=>console.error(`Conflict in default settings: ${r}`))}for(const o of Object.keys(d))w.OVERRIDE_PROPERTY_REGEX.test(o)&&n.push({identifiers:(0,w.overrideIdentifiersFromKey)(o),keys:Object.keys(d[o]),contents:(0,I.toValuesTree)(d[o],t=>console.error(`Conflict in default settings file: ${t}`))});super(d,h,n)}}e.DefaultConfigurationModel=f;class v{constructor(){this.onDidChangeConfiguration=i.Event.None,this.configurationModel=new C.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=v;let y=class extends R.Disposable{get configurationModel(){return this._configurationModel}constructor(p,c,h){super(),this.defaultConfiguration=p,this.policyService=c,this.logService=h,this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new C.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(p=>this.onDidChangePolicies(p))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:p})=>this.update(await this.registerPolicyDefinitions(p),!0))),this._configurationModel}async registerPolicyDefinitions(p){const c={},h=[],d=S.Registry.as(w.Extensions.Configuration).getConfigurationProperties();for(const n of p){const o=d[n];if(!o){h.push(n);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}h.push(n),c[o.policy.name]={type:o.type}}}return(0,T.isEmptyObject)(c)||await this.policyService.registerPolicyDefinitions(c),h}onDidChangePolicies(p){const c=S.Registry.as(w.Extensions.Configuration).getPolicyConfigurations(),h=(0,D.coalesce)(p.map(d=>c.get(d)));this.update(h,!0)}update(p,c){const h=S.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),d=[],n=this._configurationModel.isEmpty();for(const o of p){const t=h[o]?.policy?.name;if(t){const s=this.policyService.getPolicyValue(t);(n?s!==void 0:!(0,k.equals)(this._configurationModel.getValue(o),s))&&d.push([o,s])}else this._configurationModel.getValue(o)!==void 0&&d.push([o,void 0])}if(d.length){const o=this._configurationModel;this._configurationModel=new C.ConfigurationModel;for(const t of o.keys)this._configurationModel.setValue(t,o.getValue(t));for(const[t,s]of d)s===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,s);c&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};y=ve([K(1,b.IPolicyService),K(2,E.ILogService)],y),e.PolicyConfiguration=y}),define(re[214],se([0,1,6,3,2,20,16,73,213,59]),function(Q,e,D,i,R,k,T,I,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class E extends R.Disposable{constructor(S,m,f,v){super(),this.settingsResource=S,this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new C.DefaultConfiguration),this.policyConfiguration=f instanceof w.NullPolicyService?new C.NullPolicyConfiguration:this._register(new C.PolicyConfiguration(this.defaultConfiguration,f,v)),this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,m)),this.configuration=new I.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:y,properties:u})=>this.onDidDefaultConfigurationChange(y,u))),this._register(this.policyConfiguration.onDidChangeConfiguration(y=>this.onDidPolicyConfigurationChange(y))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,m,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new I.Configuration(S,m,new I.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(S,m){const f=typeof S=="string"?S:void 0,v=(0,T.isConfigurationOverrides)(S)?S:(0,T.isConfigurationOverrides)(m)?m:{};return this.configuration.getValue(f,v,void 0)}updateValue(S,m,f,v){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const m=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(f,m,2)}onDidDefaultConfigurationChange(S,m){const f=this.configuration.toData(),v=this.configuration.compareAndUpdateDefaultConfiguration(S,m);this.trigger(v,f,7)}onDidPolicyConfigurationChange(S){const m=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(f,m,7)}trigger(S,m,f){const v=new I.ConfigurationChangeEvent(S,{data:m},this.configuration);v.source=f,v.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=E}),define(re[215],se([0,1,11,4]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,i.createDecorator)("remoteAuthorityResolverService");var R;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends D.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof k&&I._code===R.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof k&&I._code===R.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof k&&I._code===R.NoResolverFound}static isHandled(I){return I instanceof k&&I.isHandled}constructor(I,C=R.Unknown,w){super(I),this._message=I,this._code=C,this._detail=w,this.isHandled=C===R.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}}e.RemoteAuthorityResolverError=k}),define(re[105],se([0,1,23]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function i(w){return w.scheme===D.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=i;function R(w){if(!w)return;const E=w.indexOf("+");return E<0?w:w.substr(0,E)}e.getRemoteName=R;function k(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.getRemoteServerRootPath=k;function T(w){const{host:E,port:b}=C(w);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:E,port:b}}e.parseAuthorityWithPort=T;function I(w,E){let{host:b,port:S}=C(w);return typeof S>"u"&&(S=E),{host:b,port:S}}e.parseAuthorityWithOptionalPort=I;function C(w){const E=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const b=w.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const S=w.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:w,port:void 0}}}),define(re[46],se([0,1,27,4,105]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=k;function T(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var C;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));class w{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,y){if(typeof v>"u"||v===null)return typeof y>"u"||y===null;if(typeof y>"u"||y===null)return!1;if(typeof v=="string"||typeof y=="string"){const u=typeof v=="string"?v:v.value,p=typeof y=="string"?y:y.value;return D.equalsIgnoreCase(u,p)}return v._lower===y._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=w;function E(f){return b(f)}e.isApplicationScopedExtension=E;function b(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function S(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function m(f,v){if(v){const y=`onResolveRemoteAuthority:${(0,R.getRemoteName)(v)}`;return f.activationEvents?.indexOf(y)!==-1}return!1}e.isResolverExtension=m,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(re[33],se([0,1,27,29,46,5,8,11,36]),function(Q,e,D,i,R,k,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function w(o,t){return o.uuid&&t.uuid?o.uuid===t.uuid:o.id===t.id?!0:(0,D.compareIgnoreCase)(o.id,t.id)===0}e.areSameExtensions=w;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(t){const s=t.manifest?t.manifest.version:t.version,r=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new b(t.identifier,s,r)}static parse(t){const s=E.exec(t);return s&&s[1]&&s[2]?new b({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,r="undefined"){this.version=s,this.targetPlatform=r,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof b?w(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=b;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(o){const t=S.exec(o);return t&&t[1]?[v(t[1]),t[2]]:[v(o),void 0]}e.getIdAndVersion=m;function f(o,t){return`${o}.${t}`}e.getExtensionId=f;function v(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=v;function y(o,t){return v(f(o,t))}e.getGalleryExtensionId=y;function u(o,t){const s=[],r=l=>{for(const a of s)if(a.some(g=>w(t(g),t(l))))return a;return null};for(const l of o){const a=r(l);a?a.push(l):s.push([l])}return s}e.groupByExtension=u;function p(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function c(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.getGalleryExtensionTelemetryData=c,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function h(o,t){const s=[],r=t.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const l=r.shift();if(l&&s.every(a=>!w(a.identifier,{id:l}))){const a=o.filter(g=>w(g.identifier,{id:l}));a.length===1&&(s.push(a[0]),r.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=h;async function d(o,t){if(!k.isLinux)return!1;let s;try{s=(await o.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await o.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){t.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=d;async function n(o,t){const s=await d(o,t),r=(0,i.getTargetPlatform)(s?"alpine":k.platform,C.arch);return t.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=n}),define(re[60],se([0,1,6,17,2,41,8,33,14,4,7]),function(Q,e,D,i,R,k,T,I,C,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let b=class extends R.Disposable{constructor(m,f){super(),this.fileService=m,this.logService=f,this.resourcesAccessQueueMap=new k.ResourceMap}scanProfileExtensions(m){return this.withProfileExtensions(m)}addExtensionsToProfile(m,f){return this.withProfileExtensions(f,v=>(v=v.filter(y=>m.some(([u])=>!(0,I.areSameExtensions)(y.identifier,u.identifier))),v.push(...m.map(([y,u])=>({identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:u}))),v))}removeExtensionFromProfile(m,f){return this.withProfileExtensions(f,v=>v.filter(y=>!(0,I.areSameExtensions)(y.identifier,m)))}async withProfileExtensions(m,f){return this.getResourceAccessQueue(m).queue(async()=>{let v=[];try{const y=await this.fileService.readFile(m),u=JSON.parse(y.value.toString());for(const p of u){if(!p.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",p);continue}if(!p.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",p);continue}if(!p.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",p);continue}v.push({identifier:p.identifier,location:T.URI.revive(p.location),version:p.version,metadata:p.metadata})}}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}if(f){v=f(v);const y=v.map(u=>({identifier:u.identifier,version:u.version,location:u.location.toJSON(),metadata:u.metadata}));await this.fileService.writeFile(m,i.VSBuffer.fromString(JSON.stringify(y)))}return v})}getResourceAccessQueue(m){let f=this.resourcesAccessQueueMap.get(m);return f||(f=new D.Queue,this.resourcesAccessQueueMap.set(m,f)),f}};b=ve([K(0,C.IFileService),K(1,E.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(re[216],se([0,1,22,33]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function R(k,T,I,C,w){try{const E=await k.getExtensionsControlManifest();if(!E.deprecated)return;const b=await k.getInstalled(1);for(const[S,m]of Object.entries(E.deprecated)){if(!m?.extension)continue;const{id:f,autoMigrate:v,preRelease:y}=m.extension;if(!v)continue;const u=b.find(c=>(0,i.areSameExtensions)(c.identifier,{id:S}));if(!u)continue;const p=(await T.getExtensions([{id:f,preRelease:y}],{targetPlatform:await k.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!p){w.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{w.info(`Migrating '${u.identifier.id}' extension to '${f}' extension...`);const c=!C.getDisabledExtensions().some(d=>(0,i.areSameExtensions)(d,u.identifier));await k.uninstall(u),w.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let h=b.find(d=>(0,i.areSameExtensions)(d.identifier,{id:f}));(!h||!h.isPreReleaseVersion&&c)&&(h=await k.installFromGallery(p,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),w.info(`Installed the pre-release extension '${h.identifier.id}'`),c||(await C.disableExtension(h.identifier),w.info(`Disabled the pre-release extension '${h.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),v.storage&&(I.addToMigrationList((0,i.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,i.getExtensionId)(h.manifest.publisher,h.manifest.name)),w.info("Added pre-release extension to the storage migration list"))),w.info(`Migrated '${u.identifier.id}' extension to '${f}' extension.`)}catch(c){w.error(c)}}}catch(E){w.error(E)}}e.migrateUnsupportedExtensions=R}),define(re[217],se([0,1,6,11,2,23,5,20,54,30,28,16,13,29,33,97,14,7]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let p=class pt extends R.Disposable{constructor(h,d,n,o,t,s){super(),this.fileService=d,this.extensionGalleryService=n,this.configurationService=o,this.extensionSignatureVerificationService=t,this.logService=s,this.extensionsDownloadDir=h.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(h,d){await this.cleanUpPromise;const n=(0,I.joinPath)(this.extensionsDownloadDir,this.getName(h));try{await this.downloadFile(h,n,t=>this.extensionGalleryService.download(h,t,d))}catch(t){throw new m.ExtensionManagementError(t.message,m.ExtensionManagementErrorCode.Download)}let o=!1;if(h.isSigned&&this.configurationService.getValue("extensions.verifySignature")===!0){const t=await this.downloadSignatureArchive(h);try{o=await this.extensionSignatureVerificationService.verify(n.fsPath,t.fsPath),this.logService.info(`Verified extension: ${h.identifier.id}`,o)}catch(s){throw await this.delete(t),await this.delete(n),new m.ExtensionManagementError(s.code,m.ExtensionManagementErrorCode.Signature)}}return{location:n,verified:o}}async downloadSignatureArchive(h){await this.cleanUpPromise;const d=(0,I.joinPath)(this.extensionsDownloadDir,`${this.getName(h)}${pt.SignatureArchiveExtension}`);return await this.downloadFile(h,d,n=>this.extensionGalleryService.downloadSignatureArchive(h,n)),d}async downloadFile(h,d,n){if(await this.fileService.exists(d))return;if(d.scheme!==k.Schemas.file){await n(d);return}const o=(0,I.joinPath)(this.extensionsDownloadDir,`.${(0,w.generateUuid)()}`);await this.fileService.exists(o)||await n(o);try{await this.rename(o,d,Date.now()+2*60*1e3)}catch(t){try{await this.fileService.del(o)}catch{}if(t.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",h.identifier.id,d.path);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(t)}. Deleted the file from downloaded location`,o.path),t}}async delete(h){await this.cleanUpPromise,await this.fileService.del(h)}async rename(h,d,n){try{await E.Promises.rename(h.fsPath,d.fsPath)}catch(o){if(T.isWindows&&o&&o.code==="EPERM"&&Date.now()<n)return this.logService.info(`Failed renaming ${h} to ${d} with 'EPERM' error. Trying again...`),this.rename(h,d,n);throw o}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const h=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const d=[],n=[],o=[];for(const r of h.children)if(r.name.endsWith(pt.SignatureArchiveExtension))o.push(r.resource);else{const l=f.ExtensionKey.parse(r.name);l&&n.push([l,r])}const t=(0,f.groupByExtension)(n,([r])=>r),s=[];for(const r of t)r.sort((l,a)=>C.rcompare(l[0].version,a[0].version)),d.push(...r.slice(1).map(l=>l[1].resource)),s.push(r[0][1]);s.sort((r,l)=>r.mtime-l.mtime),d.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(r=>r.resource)),d.push(...o),await D.Promises.settled(d.map(r=>(this.logService.trace("Deleting from cache",r.path),this.fileService.del(r))))}}catch(h){this.logService.error(h)}}getName(h){return this.cache?f.ExtensionKey.create(h).toString().toLowerCase():(0,w.generateUuid)()}};p.SignatureArchiveExtension=".sigzip",p=ve([K(0,S.INativeEnvironmentService),K(1,y.IFileService),K(2,m.IExtensionGalleryService),K(3,b.IConfigurationService),K(4,v.IExtensionSignatureVerificationService),K(5,u.ILogService)],p),e.ExtensionsDownloader=p}),define(re[218],se([0,1,2,12,28,46]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends D.Disposable{constructor(C,w){super(),this.environmentService=C,this.extensionsManifestCache=(0,i.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(w.onDidInstallExtensions(E=>this.onDidInstallExtensions(E))),this._register(w.onDidUninstallExtension(E=>this.onDidUnInstallExtension(E)))}onDidInstallExtensions(C){C.some(w=>!!w.local)&&this.invalidate()}onDidUnInstallExtension(C){C.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(re[219],se([0,1,3,2,33,46]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class T extends i.Disposable{constructor(C,w,E,b,S,m,f){super(),this.extensionManagementService=C,this.userDataProfilesService=w,this.extensionsProfileScannerService=E,this.extensionsScannerService=b,this.uriIdentityService=S,this.fileService=m,this.logService=f,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.profileExtensionsLocations=new Map,this.initialize().then(()=>this.registerListeners(),v=>f.error(v))}async initialize(){await this.extensionManagementService.migrateDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles,[]),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(C=>this.onDidChangeProfiles(C.added,C.removed))),this._register(this.extensionManagementService.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(this.extensionManagementService.onDidUninstallExtension(C=>this.onDidUninstallExtension(C))),this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(D.Event.filter(this.fileService.onDidFilesChange,C=>C.rawChanges.some(w=>this.doesChangeAffects(w,this.extensionsScannerService.userExtensionsLocation)))(()=>this.onDidChange()))}doesChangeAffects(C,w){return C.type!==1&&C.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(C.resource),w)?!1:this.uriIdentityService.extUri.isEqual(C.resource,this.uriIdentityService.extUri.joinPath(w,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(C.resource).startsWith(".")}async onDidChange(){const w=(await this.extensionManagementService.getAllUserInstalled()).filter(E=>E.installedTimestamp!==void 0||this.profileExtensionsLocations.has(this.getKey(E.identifier,E.manifest.version))?!1:(this.logService.info("Detected extension installed from another source",E.identifier.id),!0));w.length&&(await this.extensionsProfileScannerService.addExtensionsToProfile(w.map(E=>[E,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this._onDidChangeExtensionsByAnotherSource.fire({added:w.map(E=>({identifier:E.identifier,operation:1,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,local:E})),removed:[]}))}async onDidChangeProfiles(C,w){try{await Promise.all(w.map(E=>this.removeExtensionsFromProfile(E.extensionsResource)))}catch(E){this.logService.error(E)}try{C.length&&await Promise.all(C.map(E=>this.populateExtensionsFromProfile(E.extensionsResource)))}catch(E){this.logService.error(E)}}async uninstallExtensionsNotInProfiles(){const w=(await this.extensionManagementService.getAllUserInstalled()).filter(E=>!this.profileExtensionsLocations.has(this.getKey(E.identifier,E.manifest.version)));w.length&&await this.extensionManagementService.markAsUninstalled(...w)}async onDidInstallExtensions(C){for(const{local:w,profileLocation:E}of C)!w||!E||this.addExtensionWithKey(this.getKey(w.identifier,w.manifest.version),E)}async onDidUninstallExtension(C){!C.profileLocation||!C.version||this.removeExtensionWithKey(this.getKey(C.identifier,C.version),C.profileLocation)&&await this.uninstallExtensions([{identifier:C.identifier,version:C.version}])}async populateExtensionsFromProfile(C){const w=await this.extensionsProfileScannerService.scanProfileExtensions(C);for(const E of w)this.addExtensionWithKey(this.getKey(E.identifier,E.version),C)}async removeExtensionsFromProfile(C){const w=[];for(const E of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(E,C))continue;const b=this.fromKey(E);b&&w.push(b)}w.length&&await this.uninstallExtensions(w)}addExtensionWithKey(C,w){let E=this.profileExtensionsLocations.get(C);E||(E=[],this.profileExtensionsLocations.set(C,E)),E.push(w)}removeExtensionWithKey(C,w){const E=this.profileExtensionsLocations.get(C);if(E){const b=E.findIndex(S=>this.uriIdentityService.extUri.isEqual(S,w));b>-1&&E.splice(b,1)}return E?.length?!1:(this.profileExtensionsLocations.delete(C),!0)}async uninstallExtensions(C){const E=(await this.extensionManagementService.getAllUserInstalled()).filter(b=>C.some(S=>this.getKey(b.identifier,b.manifest.version)===this.getKey(S.identifier,S.version)));E.length&&await this.extensionManagementService.markAsUninstalled(...E)}getKey(C,w){return`${k.ExtensionIdentifier.toKey(C.id)}@${w}`}fromKey(C){const[w,E]=(0,R.getIdAndVersion)(C);return E?{identifier:{id:w},version:E}:void 0}}e.ExtensionsWatcher=T}),define(re[220],se([0,1,99,19,6,2,23,12,28,13,29,33,7,72,5,8]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let y=class extends m.LanguagePackBaseService{constructor(h,d,n,o){super(n),this.extensionManagementService=h,this.logService=o,this.cache=this._register(new u(d,o)),this.extensionManagementService.registerParticipant({postInstall:async t=>this.postInstallExtension(t),postUninstall:async t=>this.postUninstallExtension(t)})}async getBuiltInExtensionTranslationsUri(h){const n=(await this.cache.getLanguagePacks())[f.Language.value()];if(!n){this.logService.warn(`No language pack found for ${f.Language.value()}`);return}const o=n.translations[h];return o?v.URI.file(o):void 0}async getInstalledLanguages(){const h=await this.cache.getLanguagePacks(),d=Object.keys(h).map(n=>{const o=h[n];return{...this.createQuickPickItem(n,o.label),extensionId:o.extensions[0].extensionIdentifier.id}});return d.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),d.sort((n,o)=>n.label.localeCompare(o.label)),d}async postInstallExtension(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",h.identifier.id),await this.update())}async postUninstallExtension(h){const d=await this.cache.getLanguagePacks();Object.keys(d).some(n=>d[n]&&d[n].extensions.some(o=>(0,b.areSameExtensions)(o.extensionIdentifier,h.identifier)))&&(this.logService.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,d]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),n=await this.cache.update(d);return!(0,i.equals)(Object.keys(h),Object.keys(n))}};y=ve([K(0,E.IExtensionManagementService),K(1,w.INativeEnvironmentService),K(2,E.IExtensionGalleryService),K(3,S.ILogService)],y),e.NativeLanguagePackService=y;let u=class extends k.Disposable{constructor(h,d){super(),this.logService=d,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(h.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(h){return this.withLanguagePacks(d=>{Object.keys(d).forEach(n=>delete d[n]),this.createLanguagePacksFromExtensions(d,...h)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(h,...d){for(const n of d)n&&n.manifest&&n.manifest.contributes&&n.manifest.contributes.localizations&&n.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(h,n);Object.keys(h).forEach(n=>this.updateHash(h[n]))}createLanguagePacksFromExtension(h,d){const n=d.identifier,o=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const t of o)if(d.location.scheme===T.Schemas.file&&p(t)){let s=h[t.languageId];s||(s={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},h[t.languageId]=s);const r=s.extensions.filter(l=>(0,b.areSameExtensions)(l.extensionIdentifier,n))[0];r?r.version=d.manifest.version:s.extensions.push({extensionIdentifier:n,version:d.manifest.version});for(const l of t.translations)s.translations[l.id]=(0,I.join)(d.location.fsPath,l.path)}}updateHash(h){if(h){const d=(0,D.createHash)("md5");for(const n of h.extensions)d.update(n.extensionIdentifier.uuid||n.extensionIdentifier.id).update(n.version);h.hash=d.digest("hex")}}withLanguagePacks(h=()=>null){return this.languagePacksFileLimiter.queue(()=>{let d=null;return C.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,n=>n.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(n)).then(n=>{try{return JSON.parse(n)}catch{return{}}}).then(n=>(d=h(n),n)).then(n=>{for(const t of Object.keys(n))n[t]||delete n[t];this.languagePacks=n,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),C.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>d,n=>this.logService.error(n))})}};u=ve([K(0,w.INativeEnvironmentService),K(1,S.ILogService)],u);function p(c){if(typeof c.languageId!="string"||!Array.isArray(c.translations)||c.translations.length===0)return!1;for(const h of c.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(c.languageName&&typeof c.languageName!="string"||c.localizedLanguageName&&typeof c.localizedLanguageName!="string")}}),define(re[221],se([0,1,6,17,22,11,3,2,30,91,215,105]),function(Q,e,D,i,R,k,T,I,C,w,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const S=30*1e3;var m;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(m=e.ConnectionType||(e.ConnectionType={}));function f(J){switch(J){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function v(J){const z=new R.CancellationTokenSource;return setTimeout(()=>z.cancel(),J),z.token}function y(J,z){if(J.isCancellationRequested||z.isCancellationRequested)return R.CancellationToken.Cancelled;const _=new R.CancellationTokenSource;return J.onCancellationRequested(()=>_.cancel()),z.onCancellationRequested(()=>_.cancel()),_.token}class u{get didTimeout(){return this._state==="timedout"}constructor(z){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((_,M)=>{this._resolvePromise=_,this._rejectPromise=M}),z.isCancellationRequested?this._timeout():this._disposables.add(z.onCancellationRequested(()=>this._timeout()))}registerDisposable(z){this._state==="pending"?this._disposables.add(z):z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const z=new Error("Time limit reached");return z.code="ETIMEDOUT",z.syscall="connect",z}resolve(z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(z))}reject(z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(z))}}function p(J,z){const _=new u(z);return _.registerDisposable(J.onControlMessage(M=>{const G=JSON.parse(M.toString()),H=W(G);H?_.reject(H):_.resolve(G)})),_.promise}function c(J,z,_,M,G,H,Z,oe){const X=new u(oe);return z.connect(_,M,G,H,Z,(ie,ne)=>{X.didTimeout?(ie&&J.error(ie),ne?.dispose()):ie||!ne?X.reject(ie):X.resolve(ne)}),X.promise}function h(J,z){const _=new u(z);return J.then(M=>{_.didTimeout||_.resolve(M)},M=>{_.didTimeout||_.reject(M)}),_.promise}async function d(J,z,_,M){const G=ee(J,z);J.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let H;try{H=await c(J.logService,J.socketFactory,J.host,J.port,(0,b.getRemoteServerRootPath)(J),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,`renderer-${f(z)}-${J.reconnectionToken}`,M)}catch(ne){throw J.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),J.logService.error(ne),ne}J.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let Z,oe;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(H,null),Z=J.reconnectionProtocol,oe=!1):(Z=new w.PersistentProtocol(H,null),oe=!0),J.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const X=await h(J.signService.createNewMessage((0,C.generateUuid)()),M),ie={type:"auth",auth:J.connectionToken||"00000000000000000000",data:X.data};Z.sendControl(i.VSBuffer.fromString(JSON.stringify(ie)));try{const ne=await p(Z,y(M,v(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(J.logService.trace(`${G} 4/6. received SignRequest control message.`),!await h(J.signService.validate(X,ne.signedData),M)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const ue=await h(J.signService.sign(ne.data),M),pe={type:"connectionType",commit:J.commit,signedData:ue,desiredConnectionType:z};return _&&(pe.args=_),J.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(i.VSBuffer.fromString(JSON.stringify(pe))),{protocol:Z,ownsProtocol:oe}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(J.logService.error(`${G} the handshake timed out. Error:`),J.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${G} received error control message when negotiating connection. Error:`),J.logService.error(ne)),oe&&B(Z),ne}}async function n(J,z,_,M){const G=Date.now(),H=ee(J,z),{protocol:Z,ownsProtocol:oe}=await d(J,z,_,M),X=new u(M);return X.registerDisposable(Z.onControlMessage(ie=>{const ne=JSON.parse(ie.toString()),le=W(ne);le?(J.logService.error(`${H} received error control message when negotiating connection. Error:`),J.logService.error(le),oe&&B(Z),X.reject(le)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${ce(G)}!`),X.resolve({protocol:Z,firstMessage:ne}))})),X.promise}async function o(J,z){const{protocol:_}=await n(J,1,void 0,z);return{protocol:_}}async function t(J,z,_){const{protocol:M,firstMessage:G}=await n(J,2,z,_),H=G&&G.debugPort;return{protocol:M,debugPort:H}}async function s(J,z,_){const M=Date.now(),G=ee(J,3),{protocol:H}=await d(J,3,z,_);return J.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${ce(M)}!`),H}async function r(J,z,_){const{host:M,port:G,connectionToken:H}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,host:M,port:G,connectionToken:H,reconnectionToken:z,reconnectionProtocol:_,socketFactory:J.socketFactory,signService:J.signService,logService:J.logService}}async function l(J,z,_){return g(J,async M=>{const{protocol:G}=await o(M,R.CancellationToken.None);return new x(J,z,_,M.reconnectionToken,G)})}e.connectRemoteAgentManagement=l;async function a(J,z){return g(J,async _=>{const{protocol:M,debugPort:G}=await t(_,z,R.CancellationToken.None);return new j(J,z,_.reconnectionToken,M,G)})}e.connectRemoteAgentExtensionHost=a;async function g(J,z){for(let M=1;;M++)try{const G=(0,C.generateUuid)(),H=await r(J,G,null);return await z(H)}catch(G){if(M<5)J.logService.error(`[remote-connection][attempt ${M}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(G);else throw J.logService.error(`[remote-connection][attempt ${M}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(G),$.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled(G)),G}}async function P(J,z,_){const M=await r(J,(0,C.generateUuid)(),null);return await s(M,{host:z,port:_},R.CancellationToken.None)}e.connectRemoteAgentTunnel=P;function A(J){return(0,D.createCancelablePromise)(z=>new Promise((_,M)=>{const G=setTimeout(_,J*1e3);z.onCancellationRequested(()=>{clearTimeout(G),_()})}))}var V;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(V=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class O{constructor(z,_){this.reconnectionToken=z,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=O;class F{constructor(z,_,M,G){this.reconnectionToken=z,this.millisSinceLastIncomingData=_,this.durationSeconds=M,this.cancellableTimer=G,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class N{constructor(z,_,M){this.reconnectionToken=z,this.millisSinceLastIncomingData=_,this.attempt=M,this.type=2}}e.ReconnectionRunningEvent=N;class L{constructor(z,_,M){this.reconnectionToken=z,this.millisSinceLastIncomingData=_,this.attempt=M,this.type=4}}e.ConnectionGainEvent=L;class U{constructor(z,_,M,G){this.reconnectionToken=z,this.millisSinceLastIncomingData=_,this.attempt=M,this.handled=G,this.type=3}}e.ReconnectionPermanentFailureEvent=U;class $ extends I.Disposable{static triggerPermanentFailure(z,_,M){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=z,this._permanentFailureAttempt=_,this._permanentFailureHandled=M,this._instances.forEach(G=>G._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(z=>z._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(z=>z._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||$._permanentFailure}constructor(z,_,M,G,H){super(),this._connectionType=z,this._options=_,this.reconnectionToken=M,this.protocol=G,this._reconnectionFailureIsFatal=H,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new L(this.reconnectionToken,0,0)),this._register(G.onSocketClose(Z=>{const oe=Y(this._connectionType,this.reconnectionToken,!0);Z?Z.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this._options.logService.error(Z.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this._options.logService.error(Z.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(G.onSocketTimeout(Z=>{const oe=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),$._instances.push(this),this._register((0,I.toDisposable)(()=>{const Z=$._instances.indexOf(this);Z>=0&&$._instances.splice(Z,1)})),this._isPermanentFailure&&this._gotoPermanentFailure($._permanentFailureMillisSinceLastIncomingData,$._permanentFailureAttempt,$._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const z=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let M=-1;do{M++;const G=M<_.length?_[M]:_[_.length-1];try{if(G>0){const Z=A(G);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G,Z)),this._options.logService.info(`${z} waiting for ${G} seconds before reconnecting...`);try{await Z}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1)),this._options.logService.info(`${z} resolving connection...`);const H=await r(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${z} connecting to ${H.host}:${H.port}...`),await this._reconnect(H,v(S)),this._options.logService.info(`${z} reconnected!`),this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(M>360){this._options.logService.error(`${z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(E.RemoteAuthorityResolverError.isTemporarilyNotAvailable(H)){this._options.logService.info(`${z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this._options.logService.info(`${z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((0,k.isCancellationError)(H)){this._options.logService.info(`${z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if(H instanceof E.RemoteAuthorityResolverError){this._options.logService.error(`${z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,E.RemoteAuthorityResolverError.isHandled(H));break}this._options.logService.error(`${z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(z,_,M){this._reconnectionFailureIsFatal?$.triggerPermanentFailure(z,_,M):this._gotoPermanentFailure(z,_,M)}_gotoPermanentFailure(z,_,M){this._onDidStateChange.fire(new U(this.reconnectionToken,z,_,M)),B(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=$,$._permanentFailure=!1,$._permanentFailureMillisSinceLastIncomingData=0,$._permanentFailureAttempt=0,$._permanentFailureHandled=!1,$._instances=[];class x extends ${constructor(z,_,M,G,H){super(1,z,G,H,!0),this.client=this._register(new w.Client(H,{remoteAuthority:_,clientId:M},z.ipcLogger))}async _reconnect(z,_){await o(z,_)}}e.ManagementPersistentConnection=x;class j extends ${constructor(z,_,M,G,H){super(2,z,M,G,!1),this._startArguments=_,this.debugPort=H}async _reconnect(z,_){await t(z,this._startArguments,_)}}e.ExtensionHostPersistentConnection=j;function B(J){try{J.acceptDisconnect();const z=J.getSocket();J.dispose(),z.dispose()}catch(z){(0,k.onUnexpectedError)(z)}}function W(J){if(J&&J.type==="error"){const z=new Error(`Connection error: ${J.reason}`);return z.code="VSCODE_CONNECTION_ERROR",z}return null}function q(J,z){for(;J.length<z;)J+=" ";return J}function Y(J,z,_){return`[remote-connection][${q(f(J),13)}][${z.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function ee(J,z){return`${Y(z,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.host}:${J.port}]`}function ce(J){return`${Date.now()-J} ms`}}),define(re[222],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(re[223],se([0,1,84,150]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,k,T,I,C,w){const E=S=>w(S,void 0),b=D.createConnection({host:R,port:k},()=>{b.removeListener("error",E);const S=Buffer.alloc(16);for(let y=0;y<16;y++)S[y]=Math.round(Math.random()*256);const m=S.toString("base64"),f=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${k}${T}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${m}`];b.write(f.join(`\r
`)+`\r
\r
`);const v=y=>{y.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",v),w(void 0,new i.NodeSocket(b,C)))};b.on("data",v)});b.setNoDelay(!0),b.once("error",E)}}}),define(re[106],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,D.createDecorator)("IRemoteTunnelService");var i;(function(R){R.disconnected={type:"disconnected"},R.uninitialized={type:"uninitialized"},R.connected=k=>({type:"connected",info:k}),R.connecting=k=>({type:"connecting",progress:k})})(i=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride"}),define(re[224],se([0,1,133,16,7]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(I,C){this.configurationService=I,this.logService=C}async request(I,C){this.logService.trace("RequestService#request (browser) - begin",I.url),I.proxyAuthorization||(I.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const w=await(0,D.request)(I,C);return this.logService.trace("RequestService#request (browser) - success",I.url),w}catch(w){throw this.logService.error("RequestService#request (browser) - error",I.url,w),w}}async resolveProxy(I){}};k=ve([K(0,i.IConfigurationService),K(1,R.ILogService)],k),e.RequestService=k}),define(re[47],se([0,1,17,169,45,4,39]),function(Q,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function I(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.isSuccess=I;function C(v){return v.res.statusCode===204}async function w(v){return C(v)?null:(await(0,D.streamToBuffer)(v.stream)).toString()}e.asText=w;async function E(v){if(!I(v))throw new Error("Server returned "+v.res.statusCode);return w(v)}e.asTextOrError=E;async function b(v){if(!I(v))throw new Error("Server returned "+v.res.statusCode);if(C(v))return null;const u=(await(0,D.streamToBuffer)(v.stream)).toString();try{return JSON.parse(u)}catch(p){throw p.message+=`:
`+u,p}}e.asJson=b;function S(v){f(v)}e.updateProxyConfigurationsScope=S;let m;function f(v){const y=T.Registry.as(R.Extensions.Configuration),u=m;m={id:"http",order:15,title:(0,i.localize)(0,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,i.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,i.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,i.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,i.localize)(4,null),(0,i.localize)(5,null),(0,i.localize)(6,null),(0,i.localize)(7,null)],default:"override",description:(0,i.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,i.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[m],remove:u?[u]:[]})}f(2)}),define(re[225],se([0,1,22,23,14,47]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(C,w){this.requestService=C,this.fileService=w}async download(C,w,E=D.CancellationToken.None){if(C.scheme===i.Schemas.file||C.scheme===i.Schemas.vscodeRemote){await this.fileService.copy(C,w);return}const b={type:"GET",url:C.toString(!0)},S=await this.requestService.request(b,E);if(S.res.statusCode===200)await this.fileService.writeFile(w,S.stream);else{const m=await(0,k.asTextOrError)(S);throw new Error(`Expected 200, got back ${S.res.statusCode} instead.

${m}`)}}};T=ve([K(0,k.IRequestService),K(1,R.IFileService)],T),e.DownloadService=T}),define(re[226],se([0,1,19,22,2,20,187,14,7,25,47]),function(Q,e,D,i,R,k,T,I,C,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let b=class extends R.Disposable{constructor(m,f,v,y){super(),this.fileService=m,this.productService=f,this.requestService=v,this.logService=y,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,u])=>this.allConfigBasedTips.set(u.configPath,u))}getConfigBasedTips(m){return this.getValidConfigBasedTips(m)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(m){const f=[];for(const[v,y]of this.allConfigBasedTips)if(!(y.configScheme&&y.configScheme!==m.scheme))try{const u=await this.fileService.readFile((0,k.joinPath)(m,v)),p=new Map;Object.entries(y.recommendations).forEach(([h,d])=>{if((0,D.isNonEmptyArray)(d.remotes))for(const n of d.remotes)p.set(n,{extensionId:h,extensionName:d.name,configName:y.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled});else f.push({extensionId:h,extensionName:d.name,configName:y.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled})});const c=(0,T.getDomainsOfRemotes)(u.value.toString(),[...p.keys()]);for(const h of c){const d=p.get(h);d&&f.push(d)}}catch{}return f}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const m=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},i.CancellationToken.None);if(m.res.statusCode!==200)return[];const f=await(0,E.asJson)(m);return f?f.workspaceRecommendations||[]:[]}catch(m){return this.logService.error(m),[]}}};b=ve([K(0,I.IFileService),K(1,w.IProductService),K(2,E.IRequestService),K(3,C.ILogService)],b),e.ExtensionTipsService=b}),define(re[227],se([0,1,17,22]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class R{constructor(I){this.service=I}listen(I,C){throw new Error("Invalid listen")}call(I,C,w,E=i.CancellationToken.None){switch(C){case"request":return this.service.request(w[0],E).then(async({res:b,stream:S})=>{const m=await(0,D.streamToBuffer)(S);return[{statusCode:b.statusCode,headers:b.headers},m]});case"resolveProxy":return this.service.resolveProxy(w[0])}throw new Error("Invalid call")}}e.RequestChannel=R;class k{constructor(I){this.channel=I}async request(I,C){const[w,E]=await this.channel.call("request",[I],C);return{res:w,stream:(0,D.bufferToStream)(E)}}async resolveProxy(I){return this.channel.call("resolveProxy",[I])}}e.RequestChannelClient=k}),define(re[228],se([0,1,224,227]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class R{constructor(T,I,C){this.configurationService=I,this.logService=C,this.browserRequestService=new D.RequestService(I,C),this.mainRequestService=new i.RequestChannelClient(T.getChannel("request"))}request(T,I){return this.getRequestService().request(T,I)}async resolveProxy(T){return this.getRequestService().resolveProxy(T)}getRequestService(){return this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}}e.SharedProcessRequestService=R}),define(re[107],se([0,1,66,4]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function R(k){return(0,D.hash)({moduleId:k.process.moduleId,windowId:k.reply.windowId})}e.hash=R,e.ISharedProcessWorkerService=(0,i.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(re[229],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(i){i.Spawn="vscode:shared-process->shared-process-worker=spawn",i.Terminate="vscode:shared-process->shared-process-worker=terminate",i.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",i.Ready="vscode:shared-process-worker->shared-process=ready",i.Ack="vscode:shared-process-worker->shared-process=ack",i.Trace="vscode:shared-process-worker->shared-process=trace",i.Info="vscode:shared-process-worker->shared-process=info",i.Warn="vscode:shared-process-worker->shared-process=warn",i.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(re[230],se([0,1,92,6,22,3,2,23,30,7,107,229]),function(Q,e,D,i,R,k,T,I,C,w,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let S=class{constructor(v){this.logService=v,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(v){const y=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${y})`);const u=(0,E.hash)(v);this.processeDisposables.has(u)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${y})`),this.doDisposeWorker(v));const p=new R.CancellationTokenSource;let c,h,d;this.processeDisposables.set(u,s=>{p.dispose(!0),c?.terminate(v,R.CancellationToken.None),h?.close(),d?.close(),this.processeDisposables.delete(u);const r=this.processResolvers.get(u);r&&(this.processResolvers.delete(u),r({reason:s}))}),c=await this.getOrCreateWebWorker(v);const n=new Promise(s=>{this.processResolvers.set(u,s)});if(p.token.isCancellationRequested)return n;const{port1:o,port2:t}=new MessageChannel;return h=o,d=t,await c.spawn(v,d,p.token),p.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${y})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",v,[h])),n}getOrCreateWebWorker(v){let y=this.workers.get(v.process.moduleId);if(!y){this.logService.trace(`SharedProcess: creating new web worker (${v.process.moduleId})`);const u=new m(v.process.type,this.logService);y=u.init(),u.onDidProcessSelfTerminate(({configuration:p,reason:c})=>{this.doDisposeWorker(p,c)}),this.workers.set(v.process.moduleId,y)}return y}async disposeWorker(v){return this.doDisposeWorker(v)}doDisposeWorker(v,y){const u=this.processeDisposables.get((0,E.hash)(v));u&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),u(y))}};S=ve([K(0,w.ILogService)],S),e.SharedProcessWorkerService=S;class m extends T.Disposable{constructor(v,y){super(),this.type=v,this.logService=y,this._onDidProcessSelfTerminate=this._register(new k.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const v=new i.DeferredPromise,y=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return y.onerror=u=>{this.logService.error(`SharedProcess: worker error (${this.type})`,u.message)},y.onmessageerror=u=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,u)},y.onmessage=u=>{const{id:p,message:c,configuration:h,nonce:d}=u.data;switch(p){case b.SharedProcessWorkerMessages.Ready:v.complete(y);break;case b.SharedProcessWorkerMessages.Ack:if(d){const n=this.mapMessageNonceToPendingMessageResolve.get(d);n&&(this.mapMessageNonceToPendingMessageResolve.delete(d),n())}break;case b.SharedProcessWorkerMessages.SelfTerminated:h&&c&&this._onDidProcessSelfTerminate.fire({configuration:h,reason:JSON.parse(c)});break;case b.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,c);break;case b.SharedProcessWorkerMessages.Info:c&&this.logService.info(c);break;case b.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,c);break;case b.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,c);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,u)}},y.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),v.p}async send(v,y,u){const p=await this.workerReady;if(!y.isCancellationRequested)return new Promise(c=>{const h=(0,C.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(h,c);const d={...v,nonce:h};u?p.postMessage(d,[u]):p.postMessage(d),y.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(h)&&c()})})}spawn(v,y,u){const p={id:b.SharedProcessWorkerMessages.Spawn,configuration:v,environment:{bootstrapPath:I.FileAccess.asFileUri("bootstrap-fork",Q).fsPath}};return this.send(p,u,y)}terminate(v,y){const u={id:b.SharedProcessWorkerMessages.Terminate,configuration:v};return this.send(u,y)}}}),define(re[231],se([0,1,63,23,186]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class k extends R.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:i.Schemas.vscodeUserData})}}ve([D.memoize],k.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=k}),define(re[232],se([0,1,50,12,170,22,37,11,5,30,147,184,6]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const m=1e4;let f;async function v(u,p,c){return p["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):C.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(c)&&!p["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(c)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=S.Promises.withAsyncBody(async(h,d)=>{const n=new k.CancellationTokenSource,o=setTimeout(()=>{n.dispose(!0),d(new Error((0,R.localize)(0,null)))},m);try{h(await y(u,n.token))}catch(t){!(0,I.isCancellationError)(t)&&!n.token.isCancellationRequested?d(new Error((0,R.localize)(1,null,(0,T.toErrorMessage)(t)))):h({})}finally{clearTimeout(o),n.dispose()}})),f)}e.getResolvedShellEnv=v;async function y(u,p){const c=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",c);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",h);const d=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(d+"(.*)"+d),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",o);const t=await(0,E.getSystemShell)(C.OS,o);return u.trace("getUnixShellEnvironment#shell",t),new Promise((s,r)=>{if(p.isCancellationRequested)return r((0,I.canceled)());const l=(0,i.basename)(t);let a,g;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(a=`& '${process.execPath}' ${P} -p '''${d}'' + JSON.stringify(process.env) + ''${d}'''`,g=["-Login","-Command"]):(a=`'${process.execPath}' ${P} -p '"${d}" + JSON.stringify(process.env) + "${d}"'`,l==="tcsh"?g=["-ic"]:g=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),a);const A=(0,D.spawn)(t,[...g,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});p.onCancellationRequested(()=>(A.kill(),r((0,I.canceled)()))),A.on("error",F=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(F)),r(F)});const V=[];A.stdout.on("data",F=>V.push(F));const O=[];A.stderr.on("data",F=>O.push(F)),A.on("close",(F,N)=>{const L=Buffer.concat(V).toString("utf8");u.trace("getUnixShellEnvironment#raw",L);const U=Buffer.concat(O).toString("utf8");if(U.trim()&&u.trace("getUnixShellEnvironment#stderr",U),F||N)return r(new Error((0,R.localize)(2,null,F,N)));const $=n.exec(L),x=$?$[1]:"{}";try{const j=JSON.parse(x);c?j.ELECTRON_RUN_AS_NODE=c:delete j.ELECTRON_RUN_AS_NODE,h?j.ELECTRON_NO_ATTACH_CONSOLE=h:delete j.ELECTRON_NO_ATTACH_CONSOLE,delete j.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",j),s(j)}catch(j){u.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(j)),r(j)}})})}}),define(re[108],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(re[233],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((R,k)=>Q(["vsda"],R,k))}async createNewMessage(R){try{const k=await this.vsda(),T=new k.validator;if(T){const I=String(D._nextId++);return this.validators.set(I,T),{id:I,data:T.createNewMessage(R)}}}catch{}return{id:"",data:R}}async validate(R,k){if(!R.id)return!0;const T=this.validators.get(R.id);if(!T)return!1;this.validators.delete(R.id);try{return T.validate(k)==="ok"}catch{return!1}}async sign(R){try{const k=await this.vsda(),T=new k.signer;if(T)return T.sign(R)}catch{}return R}}e.SignService=D,D._nextId=1}),define(re[74],se([0,1,3,2]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class R extends i.Disposable{constructor(b,S,m){super(),this.channel=b,this.profile=S,this.workspace=m}async getItems(){const b={profile:this.profile,workspace:this.workspace},S=await this.channel.call("getItems",b);return new Map(S)}updateItems(b){const S={profile:this.profile,workspace:this.workspace};return b.insert&&(S.insert=Array.from(b.insert.entries())),b.delete&&(S.delete=Array.from(b.delete.values())),this.channel.call("updateItems",S)}}class k extends R{constructor(b,S){super(b,S,void 0),this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(b=>this.onDidChangeStorage(b)))}onDidChangeStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}}class T extends k{constructor(b){super(b,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=T;class I extends k{constructor(b,S){super(b,S)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=I;class C extends R{constructor(b,S){super(b,void 0,S),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=C;class w{constructor(b){this.channel=b}isUsed(b){const S={payload:b,profile:void 0,workspace:void 0};return this.channel.call("isUsed",S)}}e.StorageClient=w}),define(re[109],se([0,1,5,36,8,30]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(w){if(D.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function I(w,E,b,S,m,f,v,y,u,p){const c=Object.create(null);c["common.machineId"]=v,c.sessionID=(0,k.generateUuid)()+Date.now(),c.commitHash=m,c.version=f,c["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,D.PlatformToString)(D.platform),c["common.nodePlatform"]=i.platform,c["common.nodeArch"]=S,c["common.product"]=p||"desktop",y&&(c["common.msftInternal"]=y);let h=0;const d=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),D.isLinuxSnap&&(c["common.snap"]="true");const n=T(b);n&&(c["common.platformDetail"]=n);try{const o=await w.readFile(R.URI.file(u));c["common.source"]=o.value.toString().slice(0,30)}catch{}return c}e.resolveCommonProperties=I;function C(w){const E=i.env.USERDNSDOMAIN;if(!E)return!1;const b=E.toLowerCase();return w.some(S=>b===S)}e.verifyMicrosoftInternalDomain=C}),define(re[24],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var i;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(i=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(re[234],se([0,1,34,6,35,23,12,5,8,144,28,146,95,14,25,24]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const y=new Map;async function u(n,o){const t=`${n}::${o.join(":")}`,s=y.get(t);if(s)return s;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,a=new Map,g=2e4;function P(V,O,F,N){const L=O.substring(V.length+1);return i.Promises.withAsyncBody(async U=>{let $;try{$=await E.Promises.readdir(O,{withFileTypes:!0})}catch{U();return}if(N.count>=g){N.count+=$.length,N.maxReached=!0,U();return}let x=$.length;if(x===0){U();return}let j=$;N.count+$.length>g&&(N.maxReached=!0,x=g-N.count,j=$.slice(0,x)),N.count+=$.length;for(const B of j)if(B.isDirectory()){if(F.includes(B.name)||await P(V,(0,T.join)(O,B.name),F,N),--x===0){U();return}}else{const W=B.name.lastIndexOf(".");if(W>=0){const q=B.name.substring(W+1);q&&l.set(q,(l.get(q)??0)+1)}for(const q of r)q.relativePathPattern?.test(L)!==!1&&q.filePattern.test(B.name)&&a.set(q.tag,(a.get(q.tag)??0)+1);if(--x===0){U();return}}})}const A=i.Promises.withAsyncBody(async V=>{const O={count:0,maxReached:!1};await P(n,n,o,O);const F=await h(n);V({configFiles:p(a),fileTypes:p(l),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:F})});return y.set(t,A),A}e.collectWorkspaceStats=u;function p(n){return Array.from(n.entries(),([o,t])=>({name:o,count:t})).sort((o,t)=>t.count-o.count)}function c(){const n={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},o=D.cpus();return o&&o.length>0&&(n.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),n}e.getMachineInfo=c;async function h(n){try{const o=new Map,t=(0,T.join)(n,".vscode","launch.json"),s=await E.Promises.readFile(t),r=[],l=(0,R.parse)(s.toString(),r);if(r.length)return console.log(`Unable to parse ${t}`),[];if((0,R.getNodeType)(l)==="object"&&l.configurations)for(const a of l.configurations){const g=a.type;g&&(o.has(g)?o.set(g,o.get(g)+1):o.set(g,1))}return p(o)}catch{return[]}}e.collectLaunchConfigs=h;let d=class{constructor(o,t){this.telemetryService=o,this.productService=t}formatMachineInfo(o){const t=[];return t.push(`OS Version:       ${o.os}`),t.push(`CPUs:             ${o.cpus}`),t.push(`Memory (System):  ${o.memory}`),t.push(`VM:               ${o.vmHint}`),t.join(`
`)}formatEnvironment(o){const t=[];t.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),t.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const s=D.cpus();return s&&s.length>0&&t.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),t.push(`Memory (System):  ${(D.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`),I.isWindows||t.push(`Load (avg):       ${D.loadavg().map(r=>Math.round(r)).join(", ")}`),t.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${o.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(o,t){return Promise.all([(0,b.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async s=>{let[r,l]=s,a=this.formatProcessList(o,r);return t.forEach(g=>{if((0,S.isRemoteDiagnosticError)(g))a+=`
${g.errorMessage}`,l+=`
${g.errorMessage}`;else if(a+=`

Remote: ${g.hostName}`,g.processes&&(a+=`
${this.formatProcessList(o,g.processes)}`),g.workspaceMetadata){l+=`
|  Remote: ${g.hostName}`;for(const P of Object.keys(g.workspaceMetadata)){const A=g.workspaceMetadata[P];let V=`${A.fileCount} files`;A.maxFilesReached&&(V=`more than ${V}`),l+=`|    Folder (${P}): ${V}`,l+=this.formatWorkspaceStats(A)}}}),{processInfo:a,workspaceInfo:l}})}async getSystemInfo(o,t){const{memory:s,vmHint:r,os:l,cpus:a}=c(),g={os:l,memory:s,cpus:a,vmHint:r,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:t};return I.isWindows||(g.load=`${D.loadavg().map(P=>Math.round(P)).join(", ")}`),I.isLinux&&(g.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(g)}async getDiagnostics(o,t){const s=[];return(0,b.listProcesses)(o.mainPID).then(async r=>(s.push(""),s.push(this.formatEnvironment(o)),s.push(""),s.push(this.formatProcessList(o,r)),o.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(o))),t.forEach(l=>{if((0,S.isRemoteDiagnosticError)(l))s.push(`
${l.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${l.hostName}`),s.push(this.formatMachineInfo(l.machineInfo)),l.processes&&s.push(this.formatProcessList(o,l.processes)),l.workspaceMetadata)for(const a of Object.keys(l.workspaceMetadata)){const g=l.workspaceMetadata[a];let P=`${g.fileCount} files`;g.maxFilesReached&&(P=`more than ${P}`),s.push(`Folder (${a}): ${P}`),s.push(this.formatWorkspaceStats(g))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(o){const t=[];let r=0;const l=(A,V)=>{const O=` ${A}(${V})`;r+O.length>60?(t.push(a),a="|                 ",r=a.length):r+=O.length,a+=O};let a="|      File types:";const g=10,P=o.fileTypes.length>g?g:o.fileTypes.length;for(let A=0;A<P;A++){const V=o.fileTypes[A];l(V.name,V.count)}if(t.push(a),o.configFiles.length>=0&&(a="|      Conf files:",r=0,o.configFiles.forEach(A=>{l(A.name,A.count)}),t.push(a)),o.launchConfigFiles.length>0){let A="|      Launch Configs:";o.launchConfigFiles.forEach(V=>{A+=V.count>1?` ${V.name}(${V.count})`:` ${V.name}`}),t.push(A)}return t.join(`
`)}expandGPUFeatures(o){const t=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(t-s.length)}  ${o[s]}`).join(`
                  `)}formatWorkspaceMetadata(o){const t=[],s=[];return o.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(t.push(`|  Window (${r.title})`),r.folderURIs.forEach(l=>{const a=C.URI.revive(l);if(a.scheme===k.Schemas.file){const g=a.fsPath;s.push(u(g,["node_modules",".git"]).then(P=>{let A=`${P.fileCount} files`;P.maxFilesReached&&(A=`more than ${A}`),t.push(`|    Folder (${(0,T.basename)(g)}): ${A}`),t.push(this.formatWorkspaceStats(P))}).catch(P=>{t.push(`|      Error: Unable to collect workspace stats for folder ${g} (${P.toString()})`)}))}else t.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(r=>t.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(o,t){const s=new Map;o.windows.forEach(l=>s.set(l.pid,l.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),t&&this.formatProcessItem(o.mainPID,s,r,t,0),r.join(`
`)}formatProcessItem(o,t,s,r,l){const a=l===0;let g;a?g=r.pid===o?`${this.productService.applicationName} main`:"remote agent":(g=`${"  ".repeat(l)} ${r.name}`,r.name==="window"&&(g=`${g} (${t.get(r.pid)})`));const P=process.platform==="win32"?r.mem:D.totalmem()*(r.mem/100);s.push(`${r.load.toFixed(0).padStart(5," ")}	${(P/m.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${g}`),Array.isArray(r.children)&&r.children.forEach(A=>this.formatProcessItem(o,t,s,A,l+1))}async getWorkspaceFileExtensions(o){const t=new Set;for(const{uri:s}of o.folders){const r=C.URI.revive(s);if(r.scheme!==k.Schemas.file)continue;const l=r.fsPath;try{(await u(l,["node_modules",".git"])).fileTypes.forEach(g=>t.add(g.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(o){for(const{uri:t}of o.folders){const s=C.URI.revive(t);if(s.scheme!==k.Schemas.file)continue;const r=s.fsPath;try{const l=await u(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),l.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),l.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),l.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};d=ve([K(0,v.ITelemetryService),K(1,f.IProductService)],d),e.DiagnosticsService=d}),define(re[235],se([0,1,106,3,24,13,2,7,12,50,25,5,6,101,16,168,34]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;let u=class extends T.Disposable{constructor(c,h,d,n,o,t){super(),this.telemetryService=c,this.productService=h,this.environmentService=d,this.configurationService=t,this._onDidTokenFailedEmitter=new i.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new i.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeAccountEmitter=new i.Emitter,this.onDidChangeAccount=this._onDidChangeAccountEmitter.event,this._tunnelStatus=D.TunnelStates.disconnected,this._logger=this._register(n.createLogger(d.remoteTunnelLogResource,{name:"remoteTunnel"})),this._startTunnelProcessDelayer=new S.Delayer(100),this._register(o.onWillShutdown(s=>{this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),this.dispose()})),this._register(t.onDidChangeConfiguration(s=>{s.affectsConfiguration(D.CONFIGURATION_KEY_HOST_NAME)&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}))}async getAccount(){return this._account}async updateAccount(c){if(c&&this._account?c.token!==this._account.token||c.authenticationProviderId!==this._account.authenticationProviderId:c!==this._account){this._account=c,this._onDidChangeAccountEmitter.fire(c),this._logger.info(`Account updated: ${c?c.authenticationProviderId:"undefined"}`),this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:!!c});try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(h){this._logger.error(h)}}}getTunnelCommandLocation(){if(!this._tunnelCommand){let c;b.isMacintosh?c=this.environmentService.appRoot:c=(0,C.dirname)((0,C.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,C.join)(c,"bin",`${this.productService.tunnelApplicationName}${b.isWindows?".exe":""}`)}return this._tunnelCommand}async updateTunnelProcess(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),!this._account){this.setTunnelStatus(D.TunnelStates.disconnected);return}const{token:c,authenticationProviderId:h}=this._account;this.setTunnelStatus(D.TunnelStates.connecting((0,v.localize)(0,null)));const d=(r,l)=>{r=r.replaceAll(c,"*".repeat(4)),l?this._logger.error(r):this._logger.info(r)},n=this.runCodeTunneCommand("login",["user","login","--provider",h,"--access-token",c],d);this._tunnelProcess=n;try{if(await n,this._tunnelProcess!==n)return}catch(r){this._logger.error(r),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(!0),this.setTunnelStatus(D.TunnelStates.disconnected);return}const o=["--parent-process-id",String(process.pid),"--accept-server-license-terms"],t=this.getHostName();t?o.push("--name",t):o.push("--random-name");const s=this.runCodeTunneCommand("tunnel",o,(r,l)=>{l?this._logger.error(r):this._logger.info(r);const a=r.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(a){const g={link:a[1],domain:a[2],extensionId:"ms-vscode.remote-server",hostName:a[4]};this.setTunnelStatus(D.TunnelStates.connected(g))}else r.match(/error refreshing token/)&&(s.cancel(),this._onDidTokenFailedEmitter.fire(!0),this.setTunnelStatus(D.TunnelStates.disconnected))});this._tunnelProcess=s,s.finally(()=>{s===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._account=void 0,this.setTunnelStatus(D.TunnelStates.disconnected))})}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(c){c!==this._tunnelStatus&&(this._tunnelStatus=c,this._onDidChangeTunnelStatusEmitter.fire(c))}runCodeTunneCommand(c,h,d=()=>{}){return(0,S.createCancelablePromise)(n=>new Promise((o,t)=>{n.isCancellationRequested&&o();let s;if(n.onCancellationRequested(()=>{s&&(this._logger.info(`${c} terminating (${s.pid})`),s.kill())}),process.env.VSCODE_DEV)d("Compiling tunnel CLI from sources and run",!1),d(`${c} Spawning: cargo run -- tunnel ${h.join(" ")}`,!1),s=(0,w.spawn)("cargo",["run","--","tunnel",...h],{cwd:(0,C.join)(this.environmentService.appRoot,"cli")});else{d("Running tunnel CLI",!1);const r=this.getTunnelCommandLocation();d(`${c} Spawning: ${r} tunnel ${h.join(" ")}`,!1),s=(0,w.spawn)(r,["tunnel",...h],{cwd:(0,y.homedir)()})}s.stdout.on("data",r=>{if(s){const l=r.toString();d(l,!1)}}),s.stderr.on("data",r=>{if(s){const l=r.toString();d(l,!0)}}),s.on("exit",r=>{s&&(d(`${c} exit (${s.pid}):  + ${r}`,!1),s=void 0,r===0?o():t())}),s.on("error",r=>{s&&(d(`${c} error (${s.pid}):  + ${r}`,!0),s=void 0,t())})}))}getHostName(){const c=this.configurationService.getValue(D.CONFIGURATION_KEY_HOST_NAME);if(c&&c.match(/^([\w-]+)$/)&&c.length<=20)return c;const h=(0,y.hostname)();if(h&&h.match(/^([\w-]+)$/))return h.substring(0,20)}};u=ve([K(0,R.ITelemetryService),K(1,E.IProductService),K(2,k.INativeEnvironmentService),K(3,I.ILoggerService),K(4,m.ISharedProcessLifecycleService),K(5,f.IConfigurationService)],u),e.RemoteTunnelService=u}),define(re[110],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(k){this.appenders=k}listen(k,T){throw new Error(`Event not found: ${T}`)}call(k,T,{eventName:I,data:C}){return this.appenders.forEach(w=>w.log(I,C)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class i{constructor(k){this.channel=k}log(k,T){return this.channel.call("log",{eventName:k,data:T}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=i}),define(re[51],se([0,1,31,86,15,16,109,24]),function(Q,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class C{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,i.staticObservableValue)(0)}publicLog(s,r){return Promise.resolve(void 0)}publicLog2(s,r){return this.publicLog(s,r)}publicLogError(s,r){return Promise.resolve(void 0)}publicLogError2(s,r){return this.publicLogError(s,r)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=C,e.NullTelemetryService=new C;class w{async publicLog(s,r,l){}async publicLogError(s,r,l){}}e.NullEndpointTelemetryService=w,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(t,s){return s.onDidChangeConfiguration(r=>{r.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(r.source),configurationKeys:u(r.sourceConfig)})})}e.configurationTelemetry=E;function b(t,s){return!(s.disableTelemetry||!t.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=b;function S(t){const s=t.getValue(I.TELEMETRY_SETTING_ID),r=t.getValue("telemetry.enableCrashReporter");if(t.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function m(t){const s={},r={},l={};y(t,l);for(let a in l){a=a.length>150?a.substr(a.length-149):a;const g=l[a];typeof g=="number"?r[a]=g:typeof g=="boolean"?r[a]=g?1:0:typeof g=="string"?(g.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${g.length}`),s[a]=g.substring(0,8191)):typeof g<"u"&&g!==null&&(s[a]=g)}return{properties:s,measurements:r}}e.validateTelemetryData=m;const f=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function v(t){if(!t)return"none";for(const s of f)if(t.startsWith(`${s}+`))return s;return"other"}e.cleanRemoteAuthority=v;function y(t,s,r=0,l){if(!!t)for(const a of Object.getOwnPropertyNames(t)){const g=t[a],P=l?l+a:a;Array.isArray(g)?s[P]=(0,D.safeStringify)(g):g instanceof Date?s[P]=g.toISOString():(0,R.isObject)(g)?r<2?y(g,s,r+1,P+"."):s[P]=(0,D.safeStringify)(g):s[P]=g}}function u(t){if(!t)return[];const s=[];return p(s,"",t),s}function p(t,s,r){r&&typeof r=="object"&&!Array.isArray(r)?Object.keys(r).forEach(l=>p(t,s?`${s}.${l}`:l,r[l])):t.push(s)}function c(t,s){const r=t.msftInternalDomains||[],l=s.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(r)||l}e.isInternalTelemetry=c;function h(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.getPiiPathsFromEnvironment=h;function d(t,s){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const l=[];for(const A of s)for(;;){const V=A.exec(t);if(!V)break;l.push([V.index,A.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let P=0;for(r="";;){const A=g.exec(t);if(!A)break;const V=l.some(([O,F])=>A.index<F&&O<g.lastIndex);!a.test(A[0])&&!V&&(r+=t.substring(P,A.index)+"<REDACTED: user-file-path>",P=g.lastIndex)}return P<t.length&&(r+=t.substr(P)),r}function n(t){if(!t)return t;const s=t.toLowerCase(),r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of r)if(l.regex.test(s))return`<REDACTED: ${l.label}>`;return t}function o(t,s){return(0,D.cloneAndChange)(t,r=>{if(typeof r=="string"){let l=r;l=d(l,s);for(const a of s)l=l.replace(a,"");return l=n(l),l}})}e.cleanData=o}),define(re[236],se([0,1,44,51]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(k,T,I,C,w,E,b){const S={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${T.nameShort})`};if((0,i.supportsTelemetry)(T,I)&&(0,i.getTelemetryLevel)(C)===3){const m=await(0,D.getServiceMachineId)(I,w,E),{sessionId:f}=await b.getTelemetryInfo();S["X-Market-User-Id"]=m,S["VSCode-SessionId"]=f}return S}e.resolveMarketplaceHeaders=R}),define(re[237],se([0,1,11,31,51]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const k="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function T(C,w,E){const b=await new Promise((y,u)=>{Q(["@microsoft/1ds-core-js"],y,u)}),S=await new Promise((y,u)=>{Q(["@microsoft/1ds-post-js"],y,u)}),m=new b.AppInsightsCore,f=new S.PostChannel,v={instrumentationKey:C,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(E){v.extensionConfig={};const y={alwaysUseXhrOverride:!0,httpXHROverride:E};v.extensionConfig[f.identifier]=y}return m.initialize(v,[]),m.addTelemetryInitializer(y=>{w&&(y.ext=y.ext??{},y.ext.utc=y.ext.utc??{},y.ext.utc.flags=8462029)}),m}class I{constructor(w,E,b,S,m){this._isInternalTelemetry=w,this._eventPrefix=E,this._defaultData=b,this._xhrOverride=m,this.endPointUrl=k,this._defaultData||(this._defaultData={}),typeof S=="function"?this._aiCoreOrKey=S():this._aiCoreOrKey=S,this._asyncAiCore=null}_withAIClient(w){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){w(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=T(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(E=>{w(E)},E=>{(0,D.onUnexpectedError)(E),console.error(E)})}}log(w,E){if(!this._aiCoreOrKey)return;E=(0,i.mixin)(E,this._defaultData),E=(0,R.validateTelemetryData)(E);const b=this._eventPrefix+"/"+w;try{this._withAIClient(S=>{S.pluginVersionString=E?.properties.version??"Unknown",S.track({name:b,baseData:{name:b,properties:E?.properties,measurements:E?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(w=>{this._withAIClient(E=>{E.unload(!0,()=>{this._aiCoreOrKey=void 0,w(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(re[111],se([0,1,2,13,7,51]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends D.Disposable{constructor(C,w,E=""){super(),this.prefix=E;const b=C.getLogger(w.telemetryLogResource);b?this.logger=this._register(b):(this.logger=this._register(C.createLogger(w.telemetryLogResource)),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(C,w){this.logger.trace(`${this.prefix}telemetry/${C}`,(0,k.validateTelemetryData)(w))}};T=ve([K(0,R.ILoggerService),K(1,i.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(re[112],se([0,1,2,31,86,5,27,171,16,45,103,25,39,24,51]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let v=class{constructor(p,c,h){this._configurationService=c,this._productService=h,this._experimentProperties={},this.telemetryLevel=new R.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=p.appenders,this._commonProperties=p.commonProperties||Promise.resolve({}),this._piiPaths=p.piiPaths||[],this._sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(d),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(p,c){this._experimentProperties[p]=c}_updateTelemetryLevel(){let p=(0,f.getTelemetryLevel)(this._configurationService);const c=this._productService.enabledTelemetryLevels;if(c){this._sendErrorTelemetry=this.sendErrorTelemetry?c.error:!1;const h=c.usage?3:c.error?2:0;p=Math.min(p,h)}this.telemetryLevel.value=p}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const p=await this._commonProperties,c=p.sessionID,h=p["common.machineId"],d=p["common.firstSessionDate"],n=p["common.msftInternal"];return{sessionId:c,machineId:h,firstSessionDate:d,msftInternal:n}}dispose(){this._disposables.dispose()}_log(p,c,h,d){return this.telemetryLevel.value<c?Promise.resolve(void 0):this._commonProperties.then(n=>{h=(0,i.mixin)(h,this._experimentProperties),h=(0,f.cleanData)(h,this._cleanupPatterns),h=(0,i.mixin)(h,n),this._appenders.forEach(o=>o.log(p,h))},n=>{console.error(n)})}publicLog(p,c,h){return this._log(p,3,c,h)}publicLog2(p,c,h){return this.publicLog(p,c,h)}publicLogError(p,c){return this._sendErrorTelemetry?this._log(p,2,c,!0):Promise.resolve(void 0)}publicLogError2(p,c){return this.publicLogError(p,c)}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=ve([K(1,C.IConfigurationService),K(2,b.IProductService)],v),e.TelemetryService=v;function y(){const u=(0,I.localize)(0,null,E.default.nameLong),p=E.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=k.isWeb?"":(0,I.localize)(3,null),h=(0,I.localize)(4,null),d=(0,I.localize)(5,null),n=(0,I.localize)(6,null),o=(0,I.localize)(7,null),t=`
|       | ${h} | ${d} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,I.localize)(8,null);return`
${u} ${p} ${c}

&nbsp;

${o}
${t}

&nbsp;

${s}
`}S.Registry.as(w.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(w.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,I.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,I.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[238],se([0,1,287,237]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class R extends i.AbstractOneDataSystemAppender{constructor(T,I,C,w){const E={sendPOST:(b,S)=>{const m={method:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data)}};try{const f=D.request(b.urlString,m,v=>{v.on("data",function(y){S(v.statusCode??200,v.headers,y.toString())}),v.on("error",function(y){S(0,{})})});f.write(b.data),f.end()}catch{S(0,{})}}};super(T,I,C,w,E)}}e.OneDataSystemAppender=R}),define(re[239],se([0,1,23,68,16,13,7,25,24,110,111,112]),function(Q,e,D,i,R,k,T,I,C,w,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let S=class{constructor(f,v,y,u,p){this.configurationService=f,this.telemetryService=v,this.loggerService=y,this.environmentService=u,this.productService=p,this.customTelemetryServices=new Map}async getCustomTelemetryService(f){if(!this.customTelemetryServices.has(f.id)){const{machineId:v,sessionId:y}=await this.telemetryService.getTelemetryInfo(),u=Object.create(null);u["common.vscodemachineid"]=v,u["common.vscodesessionid"]=y;const p=[f.id,JSON.stringify(u),f.aiKey],h=new i.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:p,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),d=[new w.TelemetryAppenderClient(h),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${f.id}] `)];this.customTelemetryServices.set(f.id,new b.TelemetryService({appenders:d,sendErrorTelemetry:f.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(f.id)}async publicLog(f,v,y){await(await this.getCustomTelemetryService(f)).publicLog(v,y)}async publicLogError(f,v,y){await(await this.getCustomTelemetryService(f)).publicLogError(v,y)}};S=ve([K(0,R.IConfigurationService),K(1,C.ITelemetryService),K(2,T.ILoggerService),K(3,k.IEnvironmentService),K(4,I.IProductService)],S),e.CustomEndpointTelemetryService=S}),define(re[240],se([0,1,6,22,3,2,7]),function(Q,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let I=class extends k.Disposable{constructor(w,E){super(),this._logService=E,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=w===void 0?15e3:w}createRequest(w){return new Promise((E,b)=>{const S=++this._lastRequestId;this._pendingRequests.set(S,E),this._onCreateRequest.fire({requestId:S,...w});const m=new i.CancellationTokenSource;(0,D.timeout)(this._timeout,m.token).then(()=>b(`Request ${S} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(S,[(0,k.toDisposable)(()=>m.cancel())])})}acceptReply(w,E){const b=this._pendingRequests.get(w);b?(this._pendingRequests.delete(w),(0,k.dispose)(this._pendingRequestDisposables.get(w)||[]),this._pendingRequestDisposables.delete(w),b(E)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${w}`)}};I=ve([K(1,T.ILogService)],I),e.RequestStore=I}),define(re[113],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var i;(function(c){c.Shell="terminal.integrated.shell.",c.ShellArgs="terminal.integrated.shellArgs.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(i=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(c){c.ShellLinux="terminal.integrated.shell.linux",c.ShellMacOs="terminal.integrated.shell.osx",c.ShellWindows="terminal.integrated.shell.windows",c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationShellLinux="terminal.integrated.automationShell.linux",c.AutomationShellMacOs="terminal.integrated.automationShell.osx",c.AutomationShellWindows="terminal.integrated.automationShell.windows",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ShellArgsLinux="terminal.integrated.shellArgs.linux",c.ShellArgsMacOs="terminal.integrated.shellArgs.osx",c.ShellArgsWindows="terminal.integrated.shellArgs.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.SmoothScrolling="terminal.integrated.smoothScrolling"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(c){c.FileName="ptyhost"})(k=e.TerminalLogConstants||(e.TerminalLogConstants={}));var T;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(T=e.PosixShellType||(e.PosixShellType={}));var I;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(I=e.WindowsShellType||(e.WindowsShellType={}));var C;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(C=e.TitleEventSource||(e.TitleEventSource={}));var w;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.Log="log",c.Heartbeat="heartbeat"})(w=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var E;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var S;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(S=e.TerminalLocation||(e.TerminalLocation={}));var m;(function(c){c.TerminalView="view",c.Editor="editor"})(m=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(f=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var v;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(v=e.FlowControlConstants||(e.FlowControlConstants={}));var y;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(y=e.ProfileSource||(e.ProfileSource={}));var u;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(u=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var p;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(p=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(re[241],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(re[242],se([0,1,34,23,31,12,5,36,27,15,28]),function(Q,e,D,i,R,k,T,I,C,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let d=0;return h&&h.length===4&&(d=parseInt(h[3])),d}e.getWindowsBuildNumber=b;async function S(h,d,n,o=I.env,t=E.Promises.exists){if(k.isAbsolute(h))return await t(h)?h:void 0;if(d===void 0&&(d=I.cwd()),k.dirname(h)!=="."){const a=k.join(d,h);return await t(a)?a:void 0}const r=(0,R.getCaseInsensitive)(o,"PATH");if(n===void 0&&(0,w.isString)(r)&&(n=r.split(k.delimiter)),n===void 0||n.length===0){const a=k.join(d,h);return await t(a)?a:void 0}for(const a of n){let g;if(k.isAbsolute(a)?g=k.join(a,h):g=k.join(d,a,h),await t(g))return g;if(T.isWindows){let P=g+".com";if(await t(P)||(P=g+".exe",await t(P)))return P}}const l=k.join(d,h);return await t(l)?l:void 0}e.findExecutable=S;function m(h,d,n,o,t){if(!d.shellIntegration.enabled||!h.executable||h.isFeatureTerminal||h.hideFromUser||h.ignoreShellIntegration||T.isWindows&&!d.windowsEnableConpty)return;const s=h.args,r=I.platform==="win32"?k.basename(h.executable).toLowerCase():k.basename(h.executable),l=k.dirname(i.FileAccess.asFileUri("",Q).fsPath);let a;const g={VSCODE_INJECTION:"1"};if(T.isWindows){if(r==="pwsh.exe")return!s||p(s)?a=e.shellIntegrationArgs.get(f.WindowsPwsh):u(s)&&(a=e.shellIntegrationArgs.get(f.WindowsPwshLogin)),a?(a=[...a],a[a.length-1]=(0,C.format)(a[a.length-1],l,""),{newArgs:a,envMixin:g}):void 0;o.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args);return}switch(r){case"bash":return!s||s.length===0?a=e.shellIntegrationArgs.get(f.Bash):c(s)&&(g.VSCODE_SHELL_LOGIN="1",a=e.shellIntegrationArgs.get(f.Bash)),a?(a=[...a],a[a.length-1]=(0,C.format)(a[a.length-1],l),{newArgs:a,envMixin:g}):void 0;case"pwsh":return!s||p(s)?a=e.shellIntegrationArgs.get(f.Pwsh):u(s)&&(a=e.shellIntegrationArgs.get(f.PwshLogin)),a?(a=[...a],a[a.length-1]=(0,C.format)(a[a.length-1],l,""),{newArgs:a,envMixin:g}):void 0;case"zsh":{if(!s||s.length===0?a=e.shellIntegrationArgs.get(f.Zsh):c(s)?a=e.shellIntegrationArgs.get(f.ZshLogin):(s===e.shellIntegrationArgs.get(f.Zsh)||s===e.shellIntegrationArgs.get(f.ZshLogin))&&(a=s),!a)return;a=[...a],a[a.length-1]=(0,C.format)(a[a.length-1],l);const P=k.join(D.tmpdir(),`${D.userInfo().username}-${t.applicationName}-zsh`);g.ZDOTDIR=P;const A=n?.ZDOTDIR??D.homedir()??"~";g.USER_ZDOTDIR=A;const V=[];return V.push({source:k.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:k.join(P,".zshrc")}),V.push({source:k.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:k.join(P,".zprofile")}),V.push({source:k.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:k.join(P,".zshenv")}),V.push({source:k.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:k.join(P,".zlogin")}),{newArgs:a,envMixin:g,filesToCopy:V}}}o.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args)}e.getShellIntegrationInjection=m;var f;(function(h){h.WindowsPwsh="windows-pwsh",h.WindowsPwshLogin="windows-pwsh-login",h.Pwsh="pwsh",h.PwshLogin="pwsh-login",h.Zsh="zsh",h.ZshLogin="zsh-login",h.Bash="bash"})(f=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(f.Zsh,["-i"]),e.shellIntegrationArgs.set(f.ZshLogin,["-il"]),e.shellIntegrationArgs.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const v=["-login","-l"],y=["-nol","-nologo"];function u(h){return typeof h=="string"?v.includes(h.toLowerCase()):h.length===1&&v.includes(h[0].toLowerCase())||h.length===2&&(v.includes(h[0].toLowerCase())||v.includes(h[1].toLowerCase()))&&(y.includes(h[0].toLowerCase())||y.includes(h[1].toLowerCase()))}function p(h){return typeof h=="string"?y.includes(h.toLowerCase()):h.length===0||h?.length===1&&y.includes(h[0].toLowerCase())}function c(h){return h==="string"&&v.includes(h.toLowerCase())||typeof h!="string"&&h.length===1&&v.includes(h[0].toLowerCase())}}),define(re[243],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var D;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST_DARK="hcDark",k.HIGH_CONTRAST_LIGHT="hcLight"})(D=e.ColorScheme||(e.ColorScheme={}));function i(k){return k===D.HIGH_CONTRAST_DARK||k===D.HIGH_CONTRAST_LIGHT}e.isHighContrast=i;function R(k){return k===D.DARK||k===D.HIGH_CONTRAST_DARK}e.isDark=R}),define(re[114],se([0,1,52,3,2,4,39,243]),function(Q,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var C;(function(y){function u(p){return p&&typeof p=="object"&&typeof p.id=="string"}y.isThemeColor=u})(C=e.ThemeColor||(e.ThemeColor={}));function w(y){return{id:y}}e.themeColorFromId=w;var E;(function(y){function u(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||C.isThemeColor(s.color))}y.isThemeIcon=u;const p=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function c(s){const r=p.exec(s);if(!r)return;const[,l]=r;return{id:l}}y.fromString=c;function h(s){return{id:s}}y.fromId=h;function d(s,r){let l=s.id;const a=l.lastIndexOf("~");return a!==-1&&(l=l.substring(0,a)),r&&(l=`${l}~${r}`),{id:l}}y.modify=d;function n(s){const r=s.id.lastIndexOf("~");if(r!==-1)return s.id.substring(r+1)}y.getModifier=n;function o(s,r){return s.id===r.id&&s.color?.id===r.color?.id}y.isEqual=o;function t(s,r){return{id:s.id,color:r?w(r):void 0}}y.asThemeIcon=t,y.asClassNameArray=D.CSSIcon.asClassNameArray,y.asClassName=D.CSSIcon.asClassName,y.asCSSSelector=D.CSSIcon.asCSSSelector})(E=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function b(y){switch(y){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(u){return this.themingParticipants.push(u),this.onThemingParticipantAddedEmitter.fire(u),(0,R.toDisposable)(()=>{const p=this.themingParticipants.indexOf(u);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const m=new S;T.Registry.add(e.Extensions.ThemingContribution,m);function f(y){return m.onColorThemeChange(y)}e.registerThemingParticipant=f;class v extends R.Disposable{constructor(u){super(),this.themeService=u,this.theme=u.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(u){this.theme=u,this.updateStyles()}updateStyles(){}getColor(u,p){let c=this.theme.getColor(u);return c&&p&&(c=p(c,this.theme)),c?c.toString():null}}e.Themable=v}),define(re[244],se([0,1,52,8,173,114]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(S,m){const f=[{name:null,description:(0,R.localize)(0,null)}];return f.push(...S.map(v=>({name:v.profileName,description:I(v)}))),m&&f.push(...m.map(v=>({name:v.title,description:C(v)}))),{values:f.map(v=>v.name),markdownDescriptions:f.map(v=>v.description)}}e.createProfileSchemaEnums=T;function I(S){let m=`$(${k.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:D.Codicon.terminal.id}) ${S.profileName}
- path: ${S.path}`;return S.args&&(typeof S.args=="string"?m+=`
- args: "${S.args}"`:m+=`
- args: [${S.args.length===0?"":`'${S.args.join("','")}'`}]`),S.overrideName!==void 0&&(m+=`
- overrideName: ${S.overrideName}`),S.color&&(m+=`
- color: ${S.color}`),S.env&&(m+=`
- env: ${JSON.stringify(S.env)}`),m}function C(S){return`$(${k.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:D.Codicon.terminal.id}) ${S.title}
- extensionIdentifier: ${S.extensionIdentifier}`}function w(S,m){if(!S&&!m)return!0;if(typeof S=="string"&&typeof m=="string")return S===m;if(Array.isArray(S)&&Array.isArray(m)){if(S.length!==m.length)return!1;for(let f=0;f<S.length;f++)if(S[f]!==m[f])return!1;return!0}return!1}e.terminalProfileArgsMatch=w;function E(S,m){if(!S&&!m)return!0;if(!S||!m)return!1;if(k.ThemeIcon.isThemeIcon(S)&&k.ThemeIcon.isThemeIcon(m))return S.id===m.id&&S.color===m.color;if(typeof S=="object"&&"light"in S&&"dark"in S&&typeof m=="object"&&"light"in m&&"dark"in m){const f=S,v=m;if((i.URI.isUri(f.light)||b(f.light))&&(i.URI.isUri(f.dark)||b(f.dark))&&(i.URI.isUri(v.light)||b(v.light))&&(i.URI.isUri(v.dark)||b(v.dark)))return f.light.path===v.light.path&&f.dark.path===v.dark.path}if(i.URI.isUri(S)&&i.URI.isUri(m)||b(S)||b(m)){const f=S,v=m;return f.path===v.path&&f.scheme===v.scheme}return!1}e.terminalIconsEqual=E;function b(S){return S?typeof S.path=="string"&&typeof S.scheme=="string":!1}e.isUriComponents=b}),define(re[245],se([0,1,52,172,45,39,244]),function(Q,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(D.Codicon.getAll(),h=>h.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),h=>`$(${h.id})`)};const I={args:{description:(0,i.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,i.localize)(1,null),type:"boolean"},icon:{description:(0,i.localize)(2,null),...e.terminalIconSchema},color:{description:(0,i.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,i.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},C={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(5,null),type:["string","array"],items:{type:"string"}},...I}},w={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(6,null),type:["string"],items:{type:"string"}},...I}},E=(0,i.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),b=(0,i.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),S=(0,i.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),m=(0,i.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),f=(0,i.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),v=(0,i.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),y={id:"terminal",order:100,title:(0,i.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,i.localize)(26,null)}},{type:"string",markdownDescription:(0,i.localize)(27,null)}],default:[],markdownDeprecationMessage:S},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,i.localize)(29,null),enum:["PowerShell","Git Bash"]},...I}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(30,null),type:"string"},id:{description:(0,i.localize)(31,null),type:"string"},title:{description:(0,i.localize)(32,null),type:"string"},...I}},{type:"null"},C]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(34,null),type:"string"},id:{description:(0,i.localize)(35,null),type:"string"},title:{description:(0,i.localize)(36,null),type:"string"},...I}},{type:"null"},C]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(38,null),type:"string"},id:{description:(0,i.localize)(39,null),type:"string"},title:{description:(0,i.localize)(40,null),type:"string"},...I}},{type:"null"},C]}},["terminal.integrated.useWslProfiles"]:{description:(0,i.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,i.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,i.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,i.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,i.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){k.Registry.as(R.Extensions.Configuration).registerConfiguration(y),c()}e.registerTerminalPlatformConfiguration=u;let p;function c(h,d){const n=k.Registry.as(R.Extensions.Configuration);let o;h&&(o=(0,T.createProfileSchemaEnums)(h?.profiles,d));const t=p;p={id:"terminal",order:100,title:(0,i.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:h?.os===3?o?.values:void 0,markdownEnumDescriptions:h?.os===3?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:h?.os===2?o?.values:void 0,markdownEnumDescriptions:h?.os===2?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:h?.os===1?o?.values:void 0,markdownEnumDescriptions:h?.os===1?o?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[p],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=c}),define(re[246],se([0,1,50,52,12,5,28,89,242,114]),function(Q,e,D,i,R,k,T,I,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let E,b=!0;function S(o,t,s,r,l=process.env,a,g,P,A){return a=a||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},k.isWindows?m(s,a,l,g,r.getValue("terminal.integrated.useWslProfiles")!==!1,o&&typeof o=="object"?{...o}:r.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:r.getValue("terminal.integrated.defaultProfile.windows"),A,P):h(a,g,s,o&&typeof o=="object"?{...o}:r.getValue(k.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:r.getValue(k.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),A,P,l)}e.detectAvailableProfiles=S;async function m(o,t,s,r,l,a,g,P,A){const V=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${V?"Sysnative":"System32"}`;let F=!1;(0,C.getWindowsBuildNumber)()>=16299&&(F=!0),await y(P);const N=new Map;o&&(N.set("PowerShell",{source:"PowerShell",icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),N.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:i.Codicon.terminalCmd,isAutoDetected:!0})),d(a,N);const L=await f(N.entries(),g,t,s,r,A);if(o||l)try{const U=await p(`${O}\\${F?"wsl":"bash"}.exe`,g);for(const $ of U)(!a||!($.profileName in a))&&L.push($)}catch{b&&(r?.info("WSL is not installed, so could not detect WSL profiles"),b=!1)}return L}async function f(o,t,s,r=process.env,l,a){const g=[];for(const[P,A]of o){if(A===null)continue;let V,O,F;if("source"in A){const U=E?.get(A.source);if(!U)continue;V=U.paths,O=A.args||U.args,A.icon?F=v(A.icon):U.icon&&(F=U.icon)}else V=Array.isArray(A.path)?A.path:[A.path],O=k.isWindows||Array.isArray(A.args)?A.args:void 0,F=v(A.icon);const N=await a?.(V)||V.slice(),L=await n(P,t,N,s,r,O,A.env,A.overrideName,A.isAutoDetected,l);L?(L.isAutoDetected=A.isAutoDetected,L.icon=F,L.color=A.color,g.push(L)):l?.debug("Terminal profile not validated",P,V)}return l?.debug("Validated terminal profiles",g),g}function v(o){return typeof o=="string"?{id:o}:o}async function y(o){E&&!o||(E=new Map,E.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),E.set("PowerShell",{profileName:"PowerShell",paths:o||await u(),icon:w.ThemeIcon.asThemeIcon(i.Codicon.terminalPowershell)}))}async function u(){const o=[];for await(const t of(0,I.enumeratePowerShellInstallations)())o.push(t.exePath);return o}async function p(o,t){const s=[],r=await new Promise((g,P)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(A,V)=>{if(A)return P("Problem occurred when getting wsl distros");g(V)})});if(!r)return[];const l=new RegExp(/[\r?\n]/),a=r.split(l).filter(g=>g.trim().length>0&&g!=="");for(const g of a){if(g===""||g.startsWith("docker-desktop"))continue;const P=`${g} (WSL)`,A={profileName:P,path:o,args:["-d",`${g}`],isDefault:P===t,icon:c(g),isAutoDetected:!1};s.push(A)}return s}function c(o){return o.includes("Ubuntu")?w.ThemeIcon.asThemeIcon(i.Codicon.terminalUbuntu):o.includes("Debian")?w.ThemeIcon.asThemeIcon(i.Codicon.terminalDebian):w.ThemeIcon.asThemeIcon(i.Codicon.terminalLinux)}async function h(o,t,s,r,l,a,g,P){const A=new Map;if(s){const V=(await o.readFile("/etc/shells")).toString(),O=a||V.split(`
`).filter(N=>N.trim().indexOf("#")!==0&&N.trim().length>0),F=new Map;for(const N of O){let L=(0,R.basename)(N),U=F.get(L)||0;U++,U>1&&(L=`${L} (${U})`),F.set(L,U),A.set(L,{path:N,isAutoDetected:!0})}}return d(r,A),await f(A.entries(),l,o,P,t,g)}function d(o,t){if(!!o)for(const[s,r]of Object.entries(o))r===null||!("path"in r)&&!("source"in r)?t.delete(s):(r.icon=r.icon||t.get(s)?.icon,t.set(s,r))}async function n(o,t,s,r,l,a,g,P,A,V){if(s.length===0)return Promise.resolve(void 0);const O=s.shift();if(O==="")return n(o,t,s,r,l,a,g,P,A);const F={profileName:o,path:O,args:a,env:g,overrideName:P,isAutoDetected:A,isDefault:o===t};if((0,R.basename)(O)===O){const L=l.PATH?l.PATH.split(R.delimiter):void 0,U=await(0,C.findExecutable)(O,void 0,L,void 0,r.existsFile);return U?(F.path=U,F.isFromPath=!0,F):n(o,t,s,r,l,a)}return await r.existsFile((0,R.normalize)(O))?F:n(o,t,s,r,l,a,g,P,A)}}),define(re[247],se([0,1,3,2,23,5,38,68,16,13,93,232,7,102,240,113,245,246]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var p;(function(d){d[d.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let c=0,h=class extends i.Disposable{constructor(n,o,t,s){super(),this._reconnectConstants=n,this._configurationService=o,this._environmentService=t,this._logService=s,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,y.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,i.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new f.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(k.isWindows)return process.env;try{return await(0,b.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(n){return this._logService.error("ptyHost was unable to resolve shell environment",n),{}}}_startPtyHost(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},o=(0,E.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);o&&(o.break&&o.port?n.debugBrk=o.port:!o.break&&o.port&&(n.debug=o.port));const t=new I.Client(R.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,n);this._onPtyHostStart.fire(),T.ProxyChannel.toService(t.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=p.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const r=t.getChannel(v.TerminalIpcChannels.Log);m.LogLevelChannelClient.setLevel(r,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{m.LogLevelChannelClient.setLevel(r,this._logService.getLevel())}));const l=T.ProxyChannel.toService(t.getChannel(v.TerminalIpcChannels.PtyHost));return this._register(l.onProcessData(a=>this._onProcessData.fire(a))),this._register(l.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(l.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(l.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(l.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(l.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(l.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[t,l]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(n,o,t,s,r,l,a,g,P,A,V){const O=setTimeout(()=>this._handleUnresponsiveCreateProcess(),v.HeartbeatConstants.CreateProcessTimeout),F=await this._proxy.createProcess(n,o,t,s,r,l,a,g,P,A,V);return clearTimeout(O),c=Math.max(c,F),F}updateTitle(n,o,t){return this._proxy.updateTitle(n,o,t)}updateIcon(n,o,t,s){return this._proxy.updateIcon(n,o,t,s)}attachToProcess(n){return this._proxy.attachToProcess(n)}detachFromProcess(n,o){return this._proxy.detachFromProcess(n,o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(n){return this._proxy.start(n)}shutdown(n,o){return this._proxy.shutdown(n,o)}input(n,o){return this._proxy.input(n,o)}processBinary(n,o){return this._proxy.processBinary(n,o)}resize(n,o,t){return this._proxy.resize(n,o,t)}acknowledgeDataEvent(n,o){return this._proxy.acknowledgeDataEvent(n,o)}setUnicodeVersion(n,o){return this._proxy.setUnicodeVersion(n,o)}getInitialCwd(n){return this._proxy.getInitialCwd(n)}getCwd(n){return this._proxy.getCwd(n)}getLatency(n){return this._proxy.getLatency(n)}orphanQuestionReply(n){return this._proxy.orphanQuestionReply(n)}installAutoReply(n,o){return this._proxy.installAutoReply(n,o)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(n){return this._proxy.uninstallAutoReply(n)}getDefaultSystemShell(n){return this._proxy.getDefaultSystemShell(n)}async getProfiles(n,o,t,s=!1){const r=await this._shellEnv;return(0,u.detectAvailableProfiles)(o,t,s,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,n))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(n){return this._proxy.getWslPath(n)}getRevivedPtyNewId(n){return this._proxy.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this._proxy.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this._proxy.getTerminalLayoutInfo(n)}async requestDetachInstance(n,o){return this._proxy.requestDetachInstance(n,o)}async acceptDetachInstanceReply(n,o){return this._proxy.acceptDetachInstanceReply(n,o)}async freePortKillProcess(n){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(n)}async serializeTerminalState(n){return this._proxy.serializeTerminalState(n)}async reviveTerminalProcesses(n,o){return this._proxy.reviveTerminalProcesses(n,o)}async refreshProperty(n,o){return this._proxy.refreshProperty(n,o)}async updateProperty(n,o,t){return this._proxy.updateProperty(n,o,t)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(n,o){return this._resolveVariablesRequestStore.createRequest({workspaceId:n,originalText:o})}async acceptPtyHostResolvedVariables(n,o){this._resolveVariablesRequestStore.acceptReply(n,o)}};h=ve([K(1,C.IConfigurationService),K(2,w.IEnvironmentService),K(3,S.ILogService)],h),e.PtyHostService=h}),define(re[75],se([0,1,3,16,4,7]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var T;(function(v){v.Http="http",v.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const y=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!y)return{address:y[1],port:+y[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=E,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=b;function S(v,y,u,p){if(u===1)return!1;if(u===2&&b(y)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(c?.length===4&&parseInt(c[1])>=18)return!1}return v<1024}e.isPortPrivileged=S;class m{constructor(y,u,p){this.remoteAddress=y,this.localAddress=u,this._dispose=p,this._onDispose=new D.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=m;let f=class{constructor(y,u){this.logService=y,this.configurationService=u,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const y=this.configurationService.getValue("remote.localPortHost");return!y||y==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(y){return this._tunnelProvider=y,y?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(y){this._canElevate=y.elevation,this._privacyOptions=y.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const y=[],u=Array.from(this._tunnels.values());for(const p of u){const c=Array.from(p.values());for(const h of c){const d=await h.value;d&&y.push(d)}}return y}async dispose(){for(const y of this._tunnels.values()){for(const{value:u}of y.values())await u.then(p=>p?.dispose());y.clear()}this._tunnels.clear()}setEnvironmentTunnel(y,u,p,c,h){this.addTunnelToMap(y,u,Promise.resolve({tunnelRemoteHost:y,tunnelRemotePort:u,localAddress:p,privacy:c,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(y,u){(b(y)||E(y))&&(y=e.LOCALHOST_ADDRESSES[0]);const p=this.getTunnelFromMap(y,u);if(p)return++p.refcount,p.value}openTunnel(y,u,p,c,h=!1,d,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${p} on local port ${c}.`),!y)return;if(u||(u="localhost"),this._tunnelProvider&&this._factoryInProgress.has(p)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(y,u,p,c,h,d,n);return o?o.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(u,p);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(t);return(t.tunnelRemoteHost!==u||t.tunnelRemotePort!==p)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(y){return{tunnelRemotePort:y.tunnelRemotePort,tunnelRemoteHost:y.tunnelRemoteHost,tunnelLocalPort:y.tunnelLocalPort,localAddress:y.localAddress,privacy:y.privacy,protocol:y.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${y.tunnelRemoteHost}:${y.tunnelRemotePort} `);const u=this._tunnels.get(y.tunnelRemoteHost);if(u){const p=u.get(y.tunnelRemotePort);p&&(p.refcount--,await this.tryDisposeTunnel(y.tunnelRemoteHost,y.tunnelRemotePort,p))}}}}async tryDisposeTunnel(y,u,p){if(p.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${y}:${u}.`);const c=p.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(y)&&this._tunnels.get(y).delete(u),c}}async closeTunnel(y,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${y}:${u} `);const p=this._tunnels.get(y);if(p&&p.has(u)){const c=p.get(u);c.refcount=0,await this.tryDisposeTunnel(y,u,c)}}addTunnelToMap(y,u,p){this._tunnels.has(y)||this._tunnels.set(y,new Map),this._tunnels.get(y).set(u,{refcount:1,value:p})}async removeEmptyTunnelFromMap(y,u){const p=this._tunnels.get(y);p&&(await p.get(u)||p.delete(u),p.size===0&&this._tunnels.delete(y))}getTunnelFromMap(y,u){const p=[y];E(y)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):b(y)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const c=p.map(h=>this._tunnels.get(h));for(const h of c){const d=h?.get(u);if(d)return d}}canTunnel(y){return!!w(y)}createWithProvider(y,u,p,c,h,d,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${p} on local port ${c}.`);const o=p;this._factoryInProgress.add(o);const t=c===void 0?p:c,s={elevationRequired:h?this.isPortPrivileged(t):!1},r={remoteAddress:{host:u,port:p},localAddressPort:c,privacy:d,public:d?d!==I.Private:void 0,protocol:n},l=y.forwardPort(r,s);return l?(this.addTunnelToMap(u,p,l),l.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),l}};f=ve([K(0,k.ILogService),K(1,i.IConfigurationService)],f),e.AbstractTunnelService=f}),define(re[248],se([0,1,7,75,2,11,6]),function(Q,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class I extends R.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new T.DeferredPromise),this._addressPromise.p)}setAddress(E){this._address=E,this._addressPromise&&(this._addressPromise.complete(E),this._addressPromise=null)}setTunnel(E){this._register(E)}}let C=class kt extends R.Disposable{constructor(E,b){super(),this._tunnelService=E,this._logService=b,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++kt._lastId)}}async startTunnel(E,b,S,m,f,v){const y=new I,u=await Promise.resolve(this._tunnelService.openTunnel(E,y,S,m,f,v));if(!u)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${S}:${m} (remote).`),y.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(b))throw this._disposedTunnels.delete(b),y.dispose(),await u.dispose(),(0,k.canceled)();return y.setTunnel(u),this._tunnels.set(b,y),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${u.localAddress} (local) to ${S}:${m} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(E,b){const S=this._tunnels.get(E);!S||S.setAddress(b)}async destroyTunnel(E){const b=this._tunnels.get(E);if(b){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this._tunnels.delete(E),await b.dispose();return}this._disposedTunnels.add(E)}};C._lastId=0,C=ve([K(0,i.ISharedTunnelsService),K(1,D.ILogService)],C),e.SharedProcessTunnelService=C}),define(re[249],se([0,1,84,34,131,223,6,2,16,7,25,221,75,108,5]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(h,d,n,o,t){let s;for(let r=3;r&&(s?.dispose(),s=await new y(h,d,n,o,t).waitForReady(),!(t&&R.BROWSER_RESTRICTED_PORTS[t]||!R.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));r--);return s}class y extends I.Disposable{constructor(d,n,o,t,s){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=s,this.privacy=S.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=d,this._server=D.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=t,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){const d=this.suggestedLocalPort??this.tunnelRemotePort,n=(0,S.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let o=await(0,R.findFreePortFaster)(d,2,1e3,n),t=null;return this._server.listen(o,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address(),t||(o=0,this._server.listen(o,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async _onConnection(d){d.pause();const n=(0,S.isLocalhost)(this.tunnelRemoteHost)||(0,S.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,b.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),t=o.getSocket().socket,s=o.readEntireBuffer();o.dispose(),s.byteLength>0&&d.write(s.buffer),d.on("end",()=>{d.localAddress&&this._socketsDispose.delete(d.localAddress),t.end()}),d.on("close",()=>t.end()),d.on("error",()=>{d.localAddress&&this._socketsDispose.delete(d.localAddress),t.destroy()}),t.on("end",()=>d.end()),t.on("close",()=>d.end()),t.on("error",()=>{d.destroy()}),d.pipe(t),t.pipe(d),d.localAddress&&this._socketsDispose.set(d.localAddress,()=>{d.end(),t.end()})}}let u=class extends S.AbstractTunnelService{constructor(d,n,o,t,s){super(n,s),this.socketFactory=d,this.signService=o,this.productService=t}isPortPrivileged(d){return(0,S.isPortPrivileged)(d,this.defaultTunnelHost,f.OS,i.release())}retainOrCreateTunnel(d,n,o,t,s,r,l){const a=this.getTunnelFromMap(n,o);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,n,o,t,s,r,l);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${o} on local port ${t}.`);const g={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:d,signService:this.signService,logService:this.logService,ipcLogger:null},P=v(g,this.defaultTunnelHost,n,o,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,o,P),P}}};u=ve([K(1,w.ILogService),K(2,m.ISignService),K(3,E.IProductService),K(4,C.IConfigurationService)],u),e.BaseTunnelService=u;let p=class extends u{constructor(d,n,o,t){super(k.nodeSocketFactory,d,n,o,t)}};p=ve([K(0,w.ILogService),K(1,m.ISignService),K(2,E.IProductService),K(3,C.IConfigurationService)],p),e.TunnelService=p;let c=class extends I.Disposable{constructor(d,n,o,t){super(),this.logService=d,this.productService=n,this.signService=o,this.configurationService=t,this._tunnelServices=new Map}async openTunnel(d,n,o,t,s,r,l,a){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${t} on local port ${s}.`),!this._tunnelServices.has(d)){const g=new p(this.logService,this.signService,this.productService,this.configurationService);this._register(g),this._tunnelServices.set(d,g),g.onTunnelClosed(async()=>{(await g.tunnels).length===0&&(g.dispose(),this._tunnelServices.delete(d))})}return this._tunnelServices.get(d).openTunnel(n,o,t,s,r,l,a)}};c=ve([K(0,w.ILogService),K(1,E.IProductService),K(2,m.ISignService),K(3,C.IConfigurationService)],c),e.SharedTunnelsService=c}),define(re[32],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(re[250],se([0,1,32,94,14,20,129,3,2]),function(Q,e,D,i,R,k,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class w{constructor(S){this.uri=S,this.time=w._clock++}touch(){return this.time=w._clock++,this}}w._clock=0;let E=class{constructor(S){this._fileService=S,this._dispooables=new C.DisposableStore,this._limit=2**16;const m=new Map,f=v=>{let y=m.get(v.scheme);return y===void 0&&(y=S.hasProvider(v)&&!this._fileService.hasCapability(v,1024),m.set(v.scheme,y)),y};this._dispooables.add(I.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(v=>{m.delete(v.scheme)})),this.extUri=new k.ExtUri(f),this._canonicalUris=new T.SkipList((v,y)=>this.extUri.compare(v,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,k.normalizePath)(S));const m=this._canonicalUris.get(S);return m?m.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new w(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((f,v)=>f[1].touch<v[1].touch?1:f[1].touch>v[1].touch?-1:0);w._clock=0,this._canonicalUris.clear();const m=this._limit*.5;for(let f=0;f<m;f++)this._canonicalUris.set(S[f][0],S[f][1].touch())}};E=ve([K(0,R.IFileService)],E),e.UriIdentityService=E,(0,i.registerSingleton)(D.IUriIdentityService,E,1)}),define(re[251],se([0,1,3,2,14,43,49,17]),function(Q,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class C extends i.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(E,b,S,m){super(),this.fileSystemScheme=E,this.fileSystemProvider=b,this.userDataScheme=S,this.logService=m,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(f=>this.handleFileChanges(f)))}watch(E,b){this.watchResources.set(E,E);const S=this.fileSystemProvider.watch(this.toFileSystemResource(E),b);return(0,i.toDisposable)(()=>{this.watchResources.delete(E),S.dispose()})}stat(E){return this.fileSystemProvider.stat(this.toFileSystemResource(E))}mkdir(E){return this.fileSystemProvider.mkdir(this.toFileSystemResource(E))}rename(E,b,S){return this.fileSystemProvider.rename(this.toFileSystemResource(E),this.toFileSystemResource(b),S)}readFile(E){return this.fileSystemProvider.readFile(this.toFileSystemResource(E),{atomic:!0})}readFileStream(E,b,S){const m=(0,k.newWriteableStream)(f=>I.VSBuffer.concat(f.map(v=>I.VSBuffer.wrap(v))).buffer);return(async()=>{try{const f=await this.readFile(E);m.end(f)}catch(f){m.error(f),m.end()}})(),m}readdir(E){return this.fileSystemProvider.readdir(this.toFileSystemResource(E))}writeFile(E,b,S){return this.fileSystemProvider.writeFile(this.toFileSystemResource(E),b,S)}delete(E,b){return this.fileSystemProvider.delete(this.toFileSystemResource(E),b)}copy(E,b,S){if((0,R.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(E),this.toFileSystemResource(b),S);throw new Error("copy not supported")}handleFileChanges(E){const b=[];for(const S of E){if(S.resource.scheme!==this.fileSystemScheme)continue;const m=this.toUserDataResource(S.resource);this.watchResources.findSubstr(m)&&b.push({resource:m,type:S.type})}b.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(b))}toFileSystemResource(E){return E.with({scheme:this.fileSystemScheme})}toUserDataResource(E){return E.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=C}),define(re[61],se([0,1,81]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function i(T,I,C,w){const E=(0,D.setProperty)(T,I,C,w)[0];return E&&(T=T.substring(0,E.offset)+E.content+T.substring(E.offset+E.length)),T}e.edit=i;function R(T,I,C){let w=C;for(;w>=0;){if(T.charAt(w)===I.charAt(I.length-1)&&I.length===1)return w+1;if(w--,I.length===2&&w>=0&&T.charAt(w)===I.charAt(0))return w+2}return 0}e.getLineStartOffset=R;function k(T,I,C){let w=C;for(;w>=0;)if(T.charAt(w)===I.charAt(I.length-1)&&I.length===1||(w++,I.length===2&&w>=0&&T.charAt(w)===I.charAt(1)))return w;return T.length-1}e.getLineEndOffset=k}),define(re[252],se([0,1,31,54,15]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(m,f,v,y,u,p){const c=[],h=[],d=[];if(!f){const U=m.filter(({identifier:$})=>u.every(x=>x.toLowerCase()!==$.id.toLowerCase()));return{local:{added:c,removed:h,updated:d},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}m=m.map(b),f=f.map(b),v=v?v.map(b):null;const n=new Map,o=U=>{U.uuid&&n.set(U.id.toLowerCase(),U.uuid)};m.forEach(({identifier:U})=>o(U)),f.forEach(({identifier:U})=>o(U)),v?.forEach(({identifier:U})=>o(U));const t=U=>{const $=U.identifier.uuid||n.get(U.identifier.id.toLowerCase());return $?`uuid:${$}`:`id:${U.identifier.id.toLowerCase()}`},s=(U,$)=>(U.set(t($),$),U),r=m.reduce(s,new Map),l=f.reduce(s,new Map),a=f.reduce((U,$)=>s(U,(0,D.deepClone)($)),new Map),g=v?v.reduce(s,new Map):null,P=y.reduce(s,new Map),A=u.reduce((U,$)=>{const x=n.get($.toLowerCase());return U.add(x?`uuid:${x}`:`id:${$.toLowerCase()}`)},new Set),V=p.reduce((U,{id:$,uuid:x})=>(x=x??n.get($.toLowerCase()),U.add(x?`uuid:${x}`:`id:${$.toLowerCase()}`)),new Set),O=T(r,l,A,!1);if(O.added.size>0||O.removed.size>0||O.updated.size>0){const U=T(g,r,A,!1),$=T(g,l,A,!0),x=(j,B,W,q)=>({...q,installed:B.installed||W.installed,version:W.version&&(!B.installed||i.gt(W.version,B.version))?W.version:B.version,state:C(B,W,g?.get(j)),preRelease:(B.installed?q.preRelease:W.preRelease)??B.preRelease});for(const j of $.removed.values()){const B=r.get(j);if(!B)continue;const W=(0,R.assertIsDefined)(g?.get(j)),q=!V.has(j)&&W.installed;B.installed&&q?h.push(B.identifier):a.set(j,B)}for(const j of $.added.values()){const B=(0,R.assertIsDefined)(l.get(j)),W=r.get(j);if(W){if(O.updated.has(j)){const q=x(j,W,B,B);I(W,B,!1,!1)||d.push(S(q,j)),a.set(j,q)}}else B.installed&&c.push(S(B,j))}for(const j of $.updated.values()){const B=(0,R.assertIsDefined)(l.get(j)),W=(0,R.assertIsDefined)(g?.get(j)),q=r.get(j);if(q)if(!V.has(j)&&W.installed&&q.installed&&!B.installed)h.push(q.identifier);else{const ee=x(j,q,B,B);d.push(S(ee,j)),a.set(j,ee)}else B.installed&&c.push(S(B,j))}for(const j of U.added.values())$.added.has(j)||a.set(j,(0,R.assertIsDefined)(r.get(j)));for(const j of U.updated.values()){if($.removed.has(j)||$.updated.has(j))continue;const B=(0,R.assertIsDefined)(r.get(j)),W=(0,R.assertIsDefined)(l.get(j));a.set(j,x(j,B,W,B))}for(const j of U.removed.values())$.updated.has(j)||$.removed.has(j)||P.has(j)||!(0,R.assertIsDefined)(l.get(j)).installed||V.has(j)||!(0,R.assertIsDefined)(g?.get(j)).installed||a.delete(j)}const F=[],N=T(l,a,new Set,!0),L=N.added.size>0||N.updated.size>0||N.removed.size>0;return L&&a.forEach((U,$)=>F.push(S(U,$))),{local:{added:c,removed:h,updated:d},remote:L?{added:[...N.added].map(U=>a.get(U)),updated:[...N.updated].map(U=>a.get(U)),removed:[...N.removed].map(U=>l.get(U)),all:F}:null}}e.merge=k;function T(m,f,v,y){const u=m?[...m.keys()].filter(n=>!v.has(n)):[],p=[...f.keys()].filter(n=>!v.has(n)),c=p.filter(n=>u.indexOf(n)===-1).reduce((n,o)=>(n.add(o),n),new Set),h=u.filter(n=>p.indexOf(n)===-1).reduce((n,o)=>(n.add(o),n),new Set),d=new Set;for(const n of u){if(h.has(n))continue;const o=m.get(n),t=f.get(n);(!t||!I(o,t,y,!0))&&d.add(n)}return{added:c,removed:h,updated:d}}function I(m,f,v,y){return!(m.disabled!==f.disabled||y&&m.installed!==f.installed||m.installed&&f.installed&&m.preRelease!==f.preRelease||!E(m.state,f.state)||v&&m.version!==f.version)}function C(m,f,v){const y=m.state,u=f.state,p=v?.state;if(!f.version||y&&i.gt(m.version,f.version))return y;if(u&&i.gt(f.version,m.version)||!y)return u;if(!u)return y;const c=(0,D.deepClone)(y),h=p?w(p,u):{added:Object.keys(u).reduce((n,o)=>(n.add(o),n),new Set),removed:new Set,updated:new Set},d=p?w(p,y):{added:Object.keys(y).reduce((n,o)=>(n.add(o),n),new Set),removed:new Set,updated:new Set};for(const n of[...h.added.values(),...h.updated.values()])c[n]=u[n];for(const n of h.removed.values())d.updated.has(n)||delete c[n];return c}function w(m,f){const v=Object.keys(m),y=Object.keys(f),u=y.filter(h=>v.indexOf(h)===-1).reduce((h,d)=>(h.add(d),h),new Set),p=v.filter(h=>y.indexOf(h)===-1).reduce((h,d)=>(h.add(d),h),new Set),c=new Set;for(const h of v){if(p.has(h))continue;const d=m[h],n=f[h];(0,D.equals)(d,n)||c.add(h)}return{added:u,removed:p,updated:c}}function E(m={},f={}){const{added:v,removed:y,updated:u}=w(m,f);return v.size===0&&y.size===0&&u.size===0}function b(m){return{...m,disabled:!!m.disabled,installed:!!m.installed}}function S(m,f){const v={identifier:{id:m.identifier.id,uuid:f.startsWith("uuid:")?f.substring(5):void 0},preRelease:!!m.preRelease};return m.version&&(v.version=m.version),m.disabled&&(v.disabled=!0),m.installed&&(v.installed=!0),m.state&&(v.state=m.state),v}}),define(re[115],se([0,1,19,16,4]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(I){this.configurationService=I}hasToNeverSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,C){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return w=w.filter(E=>E!==I&&E!==`-${I}`),C&&w.push(I.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,2)}updateSynchronizedExtensions(I,C){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return w=w.filter(E=>E!==I&&E!==`-${I}`),C&&w.push(`-${I.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,2)}getIgnoredExtensions(I){const C=I.filter(S=>S.isMachineScoped).map(S=>S.identifier.id.toLowerCase()),w=this.getConfiguredIgnoredExtensions().map(S=>S.toLowerCase()),E=[],b=[];if(Array.isArray(w))for(const S of w)S.startsWith("-")?b.push(S.substring(1)):E.push(S);return(0,D.distinct)([...C,...E].filter(S=>b.indexOf(S)===-1))}getConfiguredIgnoredExtensions(){let I=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.configurationService.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};k=ve([K(0,i.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(re[253],se([0,1,19,35,31,192,61]),function(Q,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function I(h){return(0,i.parse)(h)||[]}e.parseKeybindings=I;async function C(h,d,n,o,t){const s=I(h),r=I(d),l=n?I(n):null,a=[...s,...r,...l||[]].map(x=>x.key),g=await t.resolveUserBindings(a),P=E(s,r,l,g);if(!P.hasLocalForwarded&&!P.hasRemoteForwarded)return{mergeContent:h,hasChanges:!1,hasConflicts:!1};if(!P.hasLocalForwarded&&P.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};if(P.hasLocalForwarded&&!P.hasRemoteForwarded)return{mergeContent:h,hasChanges:!0,hasConflicts:!1};const A=S(s),V=S(r),O=l?S(l):null,F=f(A,V,g),N=O?f(O,A,g):{added:[...A.keys()].reduce((x,j)=>(x.add(j),x),new Set),removed:new Set,updated:new Set},L=O?f(O,V,g):{added:[...V.keys()].reduce((x,j)=>(x.add(j),x),new Set),removed:new Set,updated:new Set},U=w(F,N,L);let $=h;for(const x of U.removed.values())U.conflicts.has(x)||($=p($,x,o));for(const x of U.added.values()){if(U.conflicts.has(x))continue;const j=V.get(x);if(j.some(B=>B.command!==`-${x}`&&P.conflicts.has(g[B.key]))){U.conflicts.add(x);continue}$=u($,j,o)}for(const x of U.updated.values()){if(U.conflicts.has(x))continue;const j=V.get(x);if(j.some(B=>B.command!==`-${x}`&&P.conflicts.has(g[B.key]))){U.conflicts.add(x);continue}$=c($,x,j,o)}return{mergeContent:$,hasChanges:!0,hasConflicts:U.conflicts.size>0}}e.merge=C;function w(h,d,n){const o=new Set,t=new Set,s=new Set,r=new Set;for(const l of d.removed.values())n.updated.has(l)&&r.add(l);for(const l of n.removed.values())r.has(l)||(d.updated.has(l)?r.add(l):t.add(l));for(const l of d.added.values())r.has(l)||n.added.has(l)&&h.updated.has(l)&&r.add(l);for(const l of n.added.values())r.has(l)||(d.added.has(l)?h.updated.has(l)&&r.add(l):o.add(l));for(const l of d.updated.values())r.has(l)||n.updated.has(l)&&h.updated.has(l)&&r.add(l);for(const l of n.updated.values())r.has(l)||(d.updated.has(l)?h.updated.has(l)&&r.add(l):s.add(l));return{added:o,removed:t,updated:s,conflicts:r}}function E(h,d,n,o){const t=new Set,s=b(h,o),r=b(d,o),l=n?b(n,o):null,a=m(s,r);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const g=l?m(l,s):{added:[...s.keys()].reduce((N,L)=>(N.add(L),N),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const P=l?m(l,r):{added:[...r.keys()].reduce((N,L)=>(N.add(L),N),new Set),removed:new Set,updated:new Set};if(P.added.size===0&&P.removed.size===0&&P.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:A,removed:V,updated:O,conflicts:F}=w(a,g,P);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:V,updated:O,conflicts:F}}function b(h,d){const n=new Map;for(const o of h){const t=d[o.key];let s=n.get(t);s||(s=[],n.set(t,s)),s.push(o)}return n}function S(h){const d=new Map;for(const n of h){const o=n.command[0]==="-"?n.command.substring(1):n.command;let t=d.get(o);t||(t=[],d.set(o,t)),t.push(n)}return d}function m(h,d){const n=[...h.keys()],o=[...d.keys()],t=o.filter(l=>n.indexOf(l)===-1).reduce((l,a)=>(l.add(a),l),new Set),s=n.filter(l=>o.indexOf(l)===-1).reduce((l,a)=>(l.add(a),l),new Set),r=new Set;for(const l of n){if(s.has(l))continue;const a=h.get(l).map(P=>({...P,key:l})),g=d.get(l).map(P=>({...P,key:l}));(0,D.equals)(a,g,(P,A)=>y(P,A))||r.add(l)}return{added:t,removed:s,updated:r}}function f(h,d,n){const o=[...h.keys()],t=[...d.keys()],s=t.filter(a=>o.indexOf(a)===-1).reduce((a,g)=>(a.add(g),a),new Set),r=o.filter(a=>t.indexOf(a)===-1).reduce((a,g)=>(a.add(g),a),new Set),l=new Set;for(const a of o){if(r.has(a))continue;const g=h.get(a).map(A=>({...A,key:n[A.key]})),P=d.get(a).map(A=>({...A,key:n[A.key]}));v(g,P)||l.add(a)}return{added:s,removed:r,updated:l}}function v(h,d){return!(!(0,D.equals)(h.filter(({command:n})=>n[0]!=="-"),d.filter(({command:n})=>n[0]!=="-"),(n,o)=>y(n,o))||!(0,D.equals)(h.filter(({command:n})=>n[0]==="-"),d.filter(({command:n})=>n[0]==="-"),(n,o)=>y(n,o)))}function y(h,d){if(h.command!==d.command||h.key!==d.key)return!1;const n=k.ContextKeyExpr.deserialize(h.when),o=k.ContextKeyExpr.deserialize(d.when);return!(n&&!o||!n&&o||n&&o&&!n.equals(o)||!R.equals(h.args,d.args))}function u(h,d,n){for(const o of d)h=T.edit(h,[-1],o,n);return h}function p(h,d,n){const o=I(h);for(let t=o.length-1;t>=0;t--)(o[t].command===d||o[t].command===`-${d}`)&&(h=T.edit(h,[t],void 0,n));return h}function c(h,d,n,o){const t=I(h),s=t.findIndex(r=>r.command===d||r.command===`-${d}`);for(let r=t.length-1;r>=0;r--)(t[r].command===d||t[r].command===`-${d}`)&&(h=T.edit(h,[r],void 0,o));for(let r=n.length-1;r>=0;r--)h=T.edit(h,[s],n[r],o);return h}}),define(re[254],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(k,T,I){const C={},w={},E=new Set;if(!T)return{local:{added:C,updated:w,removed:[...E.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const b=i(k,T);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:C,updated:w,removed:[...E.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const S=i(I,k),m=i(I,T),f={},v={},y=new Set,u=new Set;for(const p of S.removed.values())m.updated.has(p)?C[p]=T[p]:y.add(p);for(const p of m.removed.values())u.has(p)||(S.updated.has(p)?u.add(p):E.add(p));for(const p of S.updated.values())u.has(p)||(m.updated.has(p)?b.updated.has(p)&&u.add(p):v[p]=k[p]);for(const p of m.updated.values())u.has(p)||(S.updated.has(p)?b.updated.has(p)&&u.add(p):k[p]!==void 0&&(w[p]=T[p]));for(const p of S.added.values())u.has(p)||(m.added.has(p)?b.updated.has(p)&&u.add(p):f[p]=k[p]);for(const p of m.added.values())u.has(p)||(S.added.has(p)?b.updated.has(p)&&u.add(p):C[p]=T[p]);return{local:{added:C,removed:[...E.values()],updated:w},remote:{added:f,removed:[...y.values()],updated:v},conflicts:[...u.values()]}}e.merge=D;function i(k,T){const I=k?Object.keys(k):[],C=T?Object.keys(T):[],w=C.filter(S=>I.indexOf(S)===-1).reduce((S,m)=>(S.add(m),S),new Set),E=I.filter(S=>C.indexOf(S)===-1).reduce((S,m)=>(S.add(m),S),new Set),b=new Set;for(const S of I){if(E.has(S))continue;const m=k[S],f=T[S];m!==f&&b.add(S)}return{added:w,removed:E,updated:b}}function R(k,T){const{added:I,removed:C,updated:w}=i(k,T);return I.size===0&&C.size===0&&w.size===0}e.areSame=R}),define(re[255],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(R,k,T,I){const C={local:{added:[],removed:[],updated:[]},remote:{added:[],removed:[],updated:[]}};if(!k){const E=R.filter(({id:b})=>!I.includes(b));return E.length?C.remote.added=E:C.remote=null,C}const w=i(R,k,I);if(w.added.length>0||w.removed.length>0||w.updated.length>0){const E=i(T,R,I),b=i(T,k,I);for(const S of b.removed){const m=R.find(f=>f.id===S);m&&C.local.removed.push(m)}for(const S of b.added){const m=k.find(f=>f.id===S);E.added.includes(S)?w.updated.includes(S)&&C.local.updated.push(m):C.local.added.push(m)}for(const S of b.updated)C.local.updated.push(k.find(m=>m.id===S));for(const S of E.added)b.added.includes(S)||C.remote.added.push(R.find(m=>m.id===S));for(const S of E.updated)b.removed.includes(S)||b.updated.includes(S)||C.remote.updated.push(R.find(m=>m.id===S));for(const S of E.removed)C.remote.removed.push(k.find(m=>m.id===S))}return C.remote.added.length===0&&C.remote.removed.length===0&&C.remote.updated.length===0&&(C.remote=null),C}e.merge=D;function i(R,k,T){R=R?R.filter(({id:S})=>!T.includes(S)):[],k=k.filter(({id:S})=>!T.includes(S));const I=R.map(({id:S})=>S),C=k.map(({id:S})=>S),w=C.filter(S=>I.indexOf(S)===-1),E=I.filter(S=>C.indexOf(S)===-1),b=[];for(const{id:S,name:m,shortName:f}of R){if(E.includes(S))continue;const v=k.find(y=>y.id===S);(!v||v.name!==m||v.shortName!==f)&&b.push(S)}return{added:w,removed:E,updated:b}}}),define(re[26],se([0,1,19,15,179,45,29,4,104,39]),function(Q,e,D,i,R,k,T,I,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const r=w.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(r).filter(l=>!!r[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function b(){const r=w.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(r).filter(P=>!!r[P].ignoreSync),a=Object.keys(r).filter(P=>r[P].scope===2||r[P].scope===6),g=E();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...a,...g])}e.getDefaultIgnoredSettings=b,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function S(){const r="vscode://schemas/ignoredSettings",l=w.Registry.as(k.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,R.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,R.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,R.localize)(2,null),items:[{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,R.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,R.localize)(4,null),default:[],scope:1,$ref:r,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=w.Registry.as(C.Extensions.JSONContribution),g=()=>{const P=E(),A=b().filter(N=>N!==e.CONFIGURATION_SYNC_STORE_KEY),V=Object.keys(k.allSettings.properties).filter(N=>A.indexOf(N)===-1),O=A.filter(N=>P.indexOf(N)===-1),F={items:{type:"string",enum:[...V,...O.map(N=>`-${N}`)]}};a.registerSchema(r,F)};return l.onDidUpdateConfiguration(()=>g())}e.registerConfiguration=S;function m(r){return r&&(0,i.isObject)(r)&&(0,i.isString)(r.id)&&Array.isArray(r.scopes)}e.isAuthenticationProvider=m;var f;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState",r.Profiles="profiles"})(f=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function v(r,...l){return r?[r,...l]:l}e.getPathSegments=v;function y(r,l,a,g){return g.joinPath(a.userDataSyncHome,...v(r,l,`lastSync${l}.json`))}e.getLastSyncResourceUri=y,e.IUserDataSyncStoreManagementService=(0,I.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,I.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,I.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(r){const l={};return l[e.HEADER_EXECUTION_ID]=r,l}e.createSyncHeaders=u;var p;(function(r){r.Unauthorized="Unauthorized",r.Conflict="Conflict",r.Gone="Gone",r.PreconditionFailed="PreconditionFailed",r.TooLarge="TooLarge",r.UpgradeRequired="UpgradeRequired",r.PreconditionRequired="PreconditionRequired",r.TooManyRequests="RemoteTooManyRequests",r.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",r.RequestFailed="RequestFailed",r.RequestCanceled="RequestCanceled",r.RequestTimeout="RequestTimeout",r.RequestProtocolNotSupported="RequestProtocolNotSupported",r.RequestPathNotEscaped="RequestPathNotEscaped",r.RequestHeadersNotObject="RequestHeadersNotObject",r.NoCollection="NoCollection",r.NoRef="NoRef",r.EmptyResponse="EmptyResponse",r.TurnedOff="TurnedOff",r.SessionExpired="SessionExpired",r.ServiceChanged="ServiceChanged",r.DefaultServiceChanged="DefaultServiceChanged",r.LocalTooManyRequests="LocalTooManyRequests",r.LocalPreconditionFailed="LocalPreconditionFailed",r.LocalInvalidContent="LocalInvalidContent",r.LocalError="LocalError",r.IncompatibleLocalContent="IncompatibleLocalContent",r.IncompatibleRemoteContent="IncompatibleRemoteContent",r.UnresolvedConflicts="UnresolvedConflicts",r.Unknown="Unknown"})(p=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class c extends Error{constructor(l,a,g,P){super(l),this.code=a,this.resource=g,this.operationId=P,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=c;class h extends c{constructor(l,a,g,P,A){super(l,g,void 0,A),this.url=a,this.serverCode=P}}e.UserDataSyncStoreError=h;class d extends c{constructor(l,a){super(l,a)}}e.UserDataAutoSyncError=d,function(r){function l(a){if(a instanceof r)return a;const g=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(g&&g[1]){const P=g[2]==="unknown"?void 0:g[2],A=g[3]==="unknown"?void 0:g[3];return new r(a.message,g[1],P,A)}return new r(a.message,"Unknown")}r.toUserDataSyncError=l}(c=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(r){r.Uninitialized="uninitialized",r.Idle="idle",r.Syncing="syncing",r.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var o;(function(r){r[r.None=0]="None",r[r.Added=1]="Added",r[r.Modified=2]="Modified",r[r.Deleted=3]="Deleted"})(o=e.Change||(e.Change={}));var t;(function(r){r.Preview="preview",r.Conflict="conflict",r.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(r){return`sync.enable.${r}`}e.getEnablementKey=s,e.IUserDataSyncEnablementService=(0,I.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,I.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,I.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,I.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,I.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,I.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(re[256],se([0,1,31,26]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(T,I,C,w,E){if(!I)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const b=k(T,I);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const S=C?k(C,I):{added:Object.keys(I).reduce((p,c)=>(p.add(c),p),new Set),removed:new Set,updated:new Set},m=C?k(C,T):{added:Object.keys(T).reduce((p,c)=>(p.add(c),p),new Set),removed:new Set,updated:new Set},f={added:{},removed:[],updated:{}},v=D.deepClone(I),y=!C;for(const p of m.added.values())p!==i.SYNC_SERVICE_URL_TYPE&&y&&S.added.has(p)||(v[p]=T[p]);for(const p of m.updated.values())v[p]=T[p];for(const p of m.removed.values())w.unregistered.includes(p)||delete v[p];for(const p of S.added.values()){const c=I[p];if(w.machine.includes(p)){E.info(`GlobalState: Skipped adding ${p} in local storage because it is declared as machine scoped.`);continue}if(C&&m.added.has(p))continue;const h=T[p];h&&h.value===c.value||p===i.SYNC_SERVICE_URL_TYPE&&y&&m.added.has(p)||(h?f.updated[p]=c:f.added[p]=c)}for(const p of S.updated.values()){const c=I[p];if(w.machine.includes(p)){E.info(`GlobalState: Skipped updating ${p} in local storage because it is declared as machine scoped.`);continue}if(m.updated.has(p)||m.removed.has(p))continue;const h=T[p];h&&h.value===c.value||(f.updated[p]=c)}for(const p of S.removed.values()){if(w.machine.includes(p)){E.trace(`GlobalState: Skipped removing ${p} in local storage because it is declared as machine scoped.`);continue}m.updated.has(p)||m.removed.has(p)||f.removed.push(p)}const u=k(I,v);return{local:f,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:v}}}e.merge=R;function k(T,I){const C=Object.keys(T),w=Object.keys(I),E=w.filter(m=>C.indexOf(m)===-1).reduce((m,f)=>(m.add(f),m),new Set),b=C.filter(m=>w.indexOf(m)===-1).reduce((m,f)=>(m.add(f),m),new Set),S=new Set;for(const m of C){if(b.has(m))continue;const f=T[m],v=I[m];D.equals(f,v)||S.add(m)}return{added:E,removed:b,updated:S}}}),define(re[257],se([0,1,19,35,81,42,31,61,26]),function(Q,e,D,i,R,k,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function w(a,g,P){let A=[];P?A=b(P):A=E(g);const V=[],O=[...(0,C.getDisallowedIgnoredSettings)()];if(Array.isArray(A))for(const F of A)F.startsWith("-")?O.push(F.substring(1)):V.push(F);return(0,D.distinct)([...a,...V].filter(F=>O.indexOf(F)===-1))}e.getIgnoredSettings=w;function E(a){let g=a.inspect("settingsSync.ignoredSettings").userValue;return g!==void 0||(g=a.inspect("sync.ignoredSettings").userValue,g!==void 0)?g:a.getValue("settingsSync.ignoredSettings")||[]}function b(a){const g=(0,i.parse)(a);return g?g["settingsSync.ignoredSettings"]||g["sync.ignoredSettings"]||[]:[]}function S(a,g){const P=(0,i.parse)(a)||{};let A="{}";for(const V of Object.keys(P)){const O=(0,R.setProperty)(A,[V],P[V],g);A=(0,R.applyEdits)(A,O)}return A}e.removeComments=S;function m(a,g,P,A){if(P.length){const V=l(g),O=(0,i.parse)(g)||{},F=(0,i.parse)(a);if(!F)return a;const N=[];for(const L of P){const U=O[L],$=F[L];U===void 0?a=I.edit(a,[L],void 0,A):$!==void 0?a=I.edit(a,[L],U,A):N.push(n(L,V))}N.sort((L,U)=>L.startOffset-U.startOffset),N.forEach(L=>a=p(L.setting.key,g,a,A))}return a}e.updateIgnoredSettings=m;function f(a,g,P,A,V,O){const F=m(a,g,A,O),N=P!==F,L=P!==g;if(!N&&!L)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!L)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(L&&!N)return{conflictsSettings:[],localContent:m(g,a,A,O),remoteContent:null,hasConflicts:!1};if(P===null&&y(a)){const H=v(a,g,A)?null:m(g,a,A,O);return{conflictsSettings:[],localContent:H,remoteContent:null,hasConflicts:!1}}let U=a,$=g;const x=(0,i.parse)(a),j=(0,i.parse)(g),B=P?(0,i.parse)(P):null,W=A.reduce((H,Z)=>(H.add(Z),H),new Set),q=u(x,j,W),Y=u(B,x,W),ee=u(B,j,W),ce=new Map,J=new Set,z=H=>{J.add(H);const Z=V.filter(({key:oe})=>oe===H)[0];Z?(U=I.edit(U,[H],Z.value,O),$=I.edit($,[H],Z.value,O)):ce.set(H,{key:H,localValue:x[H],remoteValue:j[H]})};for(const H of Y.removed.values())ee.updated.has(H)?z(H):$=I.edit($,[H],void 0,O);for(const H of ee.removed.values())J.has(H)||(Y.updated.has(H)?z(H):U=I.edit(U,[H],void 0,O));for(const H of Y.updated.values())J.has(H)||(ee.updated.has(H)?q.updated.has(H)&&z(H):$=I.edit($,[H],x[H],O));for(const H of ee.updated.values())J.has(H)||(Y.updated.has(H)?q.updated.has(H)&&z(H):U=I.edit(U,[H],j[H],O));for(const H of Y.added.values())J.has(H)||(ee.added.has(H)?q.updated.has(H)&&z(H):$=p(H,U,$,O));for(const H of ee.added.values())J.has(H)||(Y.added.has(H)?q.updated.has(H)&&z(H):U=p(H,$,U,O));const _=ce.size>0||!v(U,$,A),M=_||!v(U,a,[]),G=_||!v($,g,[]);return{localContent:M?U:null,remoteContent:G?$:null,conflictsSettings:[...ce.values()],hasConflicts:_}}e.merge=f;function v(a,g,P){if(a===g)return!0;const A=(0,i.parse)(a),V=(0,i.parse)(g),O=P.reduce((L,U)=>(L.add(U),L),new Set),F=l(a).filter(L=>!(L.setting&&O.has(L.setting.key))),N=l(g).filter(L=>!(L.setting&&O.has(L.setting.key)));if(F.length!==N.length)return!1;for(let L=0;L<F.length;L++){const U=F[L],$=N[L];if(U.setting&&$.setting){if(U.setting.key!==$.setting.key||!T.equals(A[U.setting.key],V[U.setting.key]))return!1}else if(!U.setting&&!$.setting){if(U.value!==$.value)return!1}else return!1}return!0}e.areSame=v;function y(a){return a?l(a).length===0:!0}e.isEmpty=y;function u(a,g,P){const A=a?Object.keys(a).filter(L=>!P.has(L)):[],V=Object.keys(g).filter(L=>!P.has(L)),O=V.filter(L=>A.indexOf(L)===-1).reduce((L,U)=>(L.add(U),L),new Set),F=A.filter(L=>V.indexOf(L)===-1).reduce((L,U)=>(L.add(U),L),new Set),N=new Set;if(a)for(const L of A){if(F.has(L))continue;const U=a[L],$=g[L];T.equals(U,$)||N.add(L)}return{added:O,removed:F,updated:N}}function p(a,g,P,A){const V=(0,i.parse)(g),O=l(g),F=l(P),N=c(a,O,F);return h(P,a,V[a],N,F,A)}e.addSetting=p;function c(a,g,P){const A=g.findIndex(O=>O.setting?.key===a),V=g[A-1];if(V){if(V.setting){const F=n(V.setting.key,P);if(F)return{index:P.indexOf(F),insertAfter:!0}}else{const F=o(A,g);if(F){const N=n(F.setting.key,P);if(N){const L=t(P.indexOf(N),P),U=s(g,F,g[A]);if(L){const $=s(P,N,L),x=r(U,$);return x?{index:P.indexOf(x),insertAfter:!0}:{index:P.indexOf(L),insertAfter:!1}}else{const $=s(P,N,P[P.length-1]),x=r(U,$);return x?{index:P.indexOf(x),insertAfter:!0}:{index:P.length-1,insertAfter:!0}}}}}const O=g[A+1];if(O)if(O.setting){const F=n(O.setting.key,P);if(F)return{index:P.indexOf(F),insertAfter:!1}}else{const F=t(A,g);if(F){const N=n(F.setting.key,P);if(N){const L=o(P.indexOf(N),P),U=s(g,g[A],F);if(L){const $=s(P,L,N),x=r(U.reverse(),$.reverse());return x?{index:P.indexOf(x),insertAfter:!1}:{index:P.indexOf(L),insertAfter:!0}}else{const $=s(P,P[0],N),x=r(U.reverse(),$.reverse());return x?{index:P.indexOf(x),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:P.length-1,insertAfter:!0}}function h(a,g,P,A,V,O){let F;return A.index===-1?F=(0,R.setProperty)(a,[g],P,O):F=d(a,g,P,A,V,O).map(N=>(0,R.withFormatting)(a,N,O)[0]),(0,R.applyEdits)(a,F)}function d(a,g,P,A,V,O){const F=`${JSON.stringify(g)}: ${JSON.stringify(P)}`,N=(0,k.getEOL)(O,a),L=V[A.index];if(A.insertAfter){const U=[];if(L.setting)U.push({offset:L.endOffset,length:0,content:","+F});else{const $=t(A.index,V),x=o(A.index,V),j=x?.setting?.commaOffset;x&&j===void 0&&U.push({offset:x.endOffset,length:0,content:","});const B=j!==void 0&&j>L.endOffset;U.push({offset:B?j+1:L.endOffset,length:0,content:$?N+F+",":N+F})}return U}else{if(L.setting)return[{offset:L.startOffset,length:0,content:F+","}];const U=(V[A.index-1]&&!V[A.index-1].setting?N:"")+F+(t(A.index,V)?",":"")+N;return[{offset:L.startOffset,length:0,content:U}]}}function n(a,g){return g.filter(P=>P.setting?.key===a)[0]}function o(a,g){for(let P=a-1;P>=0;P--)if(g[P].setting)return g[P]}function t(a,g){for(let P=a+1;P<g.length;P++)if(g[P].setting)return g[P]}function s(a,g,P){const A=a.indexOf(g),V=a.indexOf(P);return a.filter((O,F)=>A<F&&F<V)}function r(a,g){if(a.length&&g.length){let P=0;for(;P<g.length&&P<a.length;P++)if(a[P].value!==g[P].value)return g[P-1];return g[P-1]}}function l(a){const g=[];let P=-1,A,V;const O={onObjectBegin:F=>{P++},onObjectProperty:(F,N,L)=>{P===0&&(A=N,V=F)},onObjectEnd:(F,N)=>{P--,P===0&&g.push({startOffset:A,endOffset:F+N,value:a.substring(A,F+N),setting:{key:V,commaOffset:void 0}})},onArrayBegin:(F,N)=>{P++},onArrayEnd:(F,N)=>{P--,P===0&&g.push({startOffset:A,endOffset:F+N,value:a.substring(A,F+N),setting:{key:V,commaOffset:void 0}})},onLiteralValue:(F,N,L)=>{P===0&&g.push({startOffset:A,endOffset:N+L,value:a.substring(A,N+L),setting:{key:V,commaOffset:void 0}})},onSeparator:(F,N,L)=>{if(P===0&&F===","){let U=g.length-1;for(;U>=0&&!g[U].setting;U--);const $=g[U];$&&g.splice(U,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:N}})}},onComment:(F,N)=>{P===0&&g.push({startOffset:F,endOffset:F+N,value:a.substring(F,F+N)})}};return(0,i.visit)(a,O),g}}),define(re[76],se([0,1,3,2,4,26]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let T=class extends i.Disposable{get account(){return this._account}constructor(C,w){super(),this.userDataSyncStoreService=C,this.logService=w,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(C.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(C.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(C){(C&&this._account?C.token!==this._account.token||C.authenticationProviderId!==this._account.authenticationProviderId:C!==this._account)&&(this._account=C,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(C))}};T=ve([K(0,k.IUserDataSyncStoreService),K(1,k.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(re[258],se([0,1,2,8]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(S){this.service=S}listen(S,m){switch(m){case"onError":return this.service.onError}throw new Error(`Event not found: ${m}`)}call(S,m,f){switch(m){case"triggerSync":return this.service.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(f[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class k{constructor(S){this.service=S}listen(S,m){throw new Error(`Event not found: ${m}`)}call(S,m,f){switch(m){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(i.URI.revive(f[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class T{constructor(S){this.channel=S}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(S){return this.channel.call("resolveUserKeybindings",[S])}async resolveFormattingOptions(S){return this.channel.call("resolveFormattingOptions",[S])}}e.UserDataSyncUtilServiceClient=T;class I{constructor(S){this.service=S}listen(S,m){switch(m){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${m}`)}async call(S,m,f){switch(m){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(f[0],f[1]);case"setEnablements":return this.service.setEnablements(f)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=I;class C{constructor(S){this.service=S}listen(S,m){switch(m){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${m}`)}call(S,m,f){switch(m){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=C;class w{constructor(S){this.service=S}listen(S,m){switch(m){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${m}`)}call(S,m,f){switch(m){case"switch":return this.service.switch(f[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=w;class E extends D.Disposable{constructor(S){super(),this.channel=S,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(S){return this.channel.call("switch",[S])}async getPreviousUserDataSyncStore(){const S=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(S)}revive(S){return{url:i.URI.revive(S.url),type:S.type,defaultUrl:i.URI.revive(S.defaultUrl),insidersUrl:i.URI.revive(S.insidersUrl),stableUrl:i.URI.revive(S.stableUrl),canSwitch:S.canSwitch,authenticationProviders:S.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=E}),define(re[259],se([0,1,13,7]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends i.AbstractLogger{constructor(T,I){super(),this.logger=this._register(T.createLogger(I.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...I){this.logger.trace(T,...I)}debug(T,...I){this.logger.debug(T,...I)}info(T,...I){this.logger.info(T,...I)}warn(T,...I){this.logger.warn(T,...I)}error(T,...I){this.logger.error(T,...I)}flush(){this.logger.flush()}};R=ve([K(0,i.ILoggerService),K(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(re[260],se([0,1,6,3,2]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends R.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:C,getActiveWindowId:w}){super(),this.disposables=this._register(new R.DisposableStore),i.Event.latch(i.Event.any(I,C))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>w()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(re[116],se([0,1,182,12,49,20,8,4,23]),function(Q,e,D,i,R,k,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function w(o){const t=o;return typeof t?.id=="string"&&T.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=w,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function E(o,t){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,i.basename)(o)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const s=o;if(s.configuration)return{id:s.id,configPath:s.configuration};if(s.folders.length===1)return{id:s.id,uri:s.folders[0].uri}}e.toWorkspaceIdentifier=E;function b(o){const t=o;return typeof t?.id=="string"&&T.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=b;function S(o){const t=o;if(t?.uri)return{id:t.id,uri:T.URI.revive(t.uri)};const s=o;if(s?.configPath)return{id:s.id,configPath:T.URI.revive(s.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=S;var m;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function f(o){const t=o;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=f;function v(o){const t=o;return!!(t&&typeof t=="object"&&T.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=v;class y{constructor(t,s,r,l,a){this._id=t,this._transient=r,this._configuration=l,this._ignorePathCasing=a,this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=s}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class u{constructor(t,s){this.raw=s,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,k.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function p(o){return new u({uri:o,index:0,name:(0,k.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(o,t){return k.extUriBiasedIgnorePathCase.isEqualOrParent(o,t.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function h(o){let t;return T.URI.isUri(o)?t=o:t=o.configuration,t?.scheme===C.Schemas.tmp}e.isTemporaryWorkspace=h;function d(o,t){return!c(o,t)&&!h(o)}e.isSavedWorkspace=d;function n(o){return(typeof o=="string"?(0,i.extname)(o):(0,k.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(re[21],se([0,1,66,3,2,20,8,174,13,14,4,7,116,41,32,6,30,27]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function p(o){const t=o;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&T.URI.isUri(t.location)&&T.URI.isUri(t.globalStorageHome)&&T.URI.isUri(t.settingsResource)&&T.URI.isUri(t.keybindingsResource)&&T.URI.isUri(t.tasksResource)&&T.URI.isUri(t.snippetsHome)&&T.URI.isUri(t.extensionsResource))}e.isUserDataProfile=p,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,E.createDecorator)("IUserDataProfilesService");function c(o,t){return{id:o.id,isDefault:o.isDefault,name:o.name,shortName:o.shortName,location:T.URI.revive(o.location).with({scheme:t}),globalStorageHome:T.URI.revive(o.globalStorageHome).with({scheme:t}),settingsResource:T.URI.revive(o.settingsResource).with({scheme:t}),keybindingsResource:T.URI.revive(o.keybindingsResource).with({scheme:t}),tasksResource:T.URI.revive(o.tasksResource).with({scheme:t}),snippetsHome:T.URI.revive(o.snippetsHome).with({scheme:t}),extensionsResource:T.URI.revive(o.extensionsResource)?.with({scheme:t}),useDefaultFlags:o.useDefaultFlags,isTransient:o.isTransient}}e.reviveProfile=c;function h(o,t,s,r){return{id:o,name:t,location:s,isDefault:!1,shortName:r?.shortName,globalStorageHome:(0,k.joinPath)(s,"globalStorage"),settingsResource:(0,k.joinPath)(s,"settings.json"),keybindingsResource:(0,k.joinPath)(s,"keybindings.json"),tasksResource:(0,k.joinPath)(s,"tasks.json"),snippetsHome:(0,k.joinPath)(s,"snippets"),extensionsResource:(0,k.joinPath)(s,"extensions.json"),useDefaultFlags:r?.useDefaultFlags,isTransient:r?.transient}}e.toUserDataProfile=h;let d=class extends R.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(t,s,r,l){super(),this.environmentService=t,this.fileService=s,this.uriIdentityService=r,this.logService=l,this.enabled=!1,this._onDidChangeProfiles=this._register(new i.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new i.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new i.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new i.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new m.ResourceMap},this.profilesHome=(0,k.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(t){this.enabled!==t&&(this._profilesObject=void 0,this.enabled=t)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const t=this.enabled?this.getStoredProfiles().map(a=>h((0,k.basename)(a.location),a.name,a.location,{shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})):[];let s;const r=new m.ResourceMap,l=h((0,D.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,I.localize)(0,null),this.environmentService.userRoamingDataHome);if(t.unshift({...l,isDefault:!0}),t.length){const a=this.getStoredProfileAssociations();if(a.workspaces)for(const[g,P]of Object.entries(a.workspaces)){const A=T.URI.parse(g),V=T.URI.parse(P),O=t.find(F=>this.uriIdentityService.extUri.isEqual(F.location,V));O&&r.set(A,O)}if(a.emptyWindow){const g=T.URI.parse(a.emptyWindow);s=t.find(P=>this.uriIdentityService.extUri.isEqual(P.location,g))}}this._profilesObject={profiles:t,workspaces:r,emptyWindow:s}}return this._profilesObject}async createTransientProfile(t){const s="Temp",r=new RegExp(`${(0,u.escapeRegExpCharacters)(s)}\\s(\\d+)`);let l=0;for(const g of this.profiles){const P=r.exec(g.name),A=P?parseInt(P[1]):0;l=A>l?A:l}const a=`${s} ${l+1}`;return this.createProfile((0,D.hash)((0,y.generateUuid)()).toString(16),a,{transient:!0},t)}async createNamedProfile(t,s,r){return this.createProfile((0,D.hash)((0,y.generateUuid)()).toString(16),t,s,r)}async createProfile(t,s,r,l){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=await this.doCreateProfile(t,s,r);return l&&await this.setProfileForWorkspace(l,a),a}async doCreateProfile(t,s,r){let l=this.profileCreationPromises.get(s);return l||(l=(async()=>{try{const a=this.profiles.find(A=>A.name===s||A.id===t);if(a)return a;const g=h(t,s,(0,k.joinPath)(this.profilesHome,t),r);await this.fileService.createFolder(g.location);const P=[];return this._onWillCreateProfile.fire({profile:g,join(A){P.push(A)}}),await v.Promises.settled(P),this.updateProfiles([g],[],[]),g}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,l)),l}async updateProfile(t,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let r=this.profiles.find(l=>l.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);return r=h(r.id,s.name??r.name,r.location,{shortName:s.shortName??r.shortName,transient:s.transient??r.isTransient,useDefaultFlags:s.useDefaultFlags??r.useDefaultFlags}),this.updateProfiles([],[],[r]),r}async removeProfile(t){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(t.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(l=>l.id===t.id);if(!s)throw new Error(`Profile '${t.name}' does not exist`);const r=[];this._onWillRemoveProfile.fire({profile:s,join(l){r.push(l)}});try{await Promise.allSettled(r)}catch(l){this.logService.error(l)}s.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const l of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(l)?.id&&this.profilesObject.workspaces.delete(l);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(s.location,{recursive:!0})}catch(l){this.logService.error(l)}}getOrSetProfileForWorkspace(t,s=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let r=this.getProfileForWorkspace(t);return r||(r=s,this.profiles.length>1&&this.setProfileForWorkspaceSync(t,r)),r}async setProfileForWorkspace(t,s){this.setProfileForWorkspaceSync(t,s)}setProfileForWorkspaceSync(t,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const r=this.profiles.find(l=>l.id===s.id);if(!r)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(t,r)}unsetWorkspace(t,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(t,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const t=await this.fileService.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(s=>s.isDirectory&&this.profiles.every(r=>!this.uriIdentityService.extUri.isEqual(r.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const t=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(t.map(s=>this.removeProfile(s)))}getProfileForWorkspace(t){const s=this.getWorkspace(t);return T.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(t){return(0,S.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,S.isWorkspaceIdentifier)(t)?t.configPath:"empty-window"}isProfileAssociatedToWorkspace(t){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,t.location)||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,t.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,t.location)||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,t.location)))}updateProfiles(t,s,r){const l=[...this.profiles,...t],a=[];this.transientProfilesObject.profiles=[];for(let g of l)g.isDefault||s.some(P=>g.id===P.id)||(g=r.find(P=>g.id===P.id)??g,g.isTransient?this.transientProfilesObject.profiles.push(g):a.push({location:g.location,name:g.name,shortName:g.shortName,useDefaultFlags:g.useDefaultFlags}));this.saveStoredProfiles(a),this._profilesObject=void 0,this.triggerProfilesChanges(t,s,r)}triggerProfilesChanges(t,s,r){this._onDidChangeProfiles.fire({added:t,removed:s,updated:r,all:this.profiles})}updateWorkspaceAssociation(t,s,r){r=s?.isTransient?!0:r,r||this.updateWorkspaceAssociation(t,void 0,!0);const l=this.getWorkspace(t),a=r?this.transientProfilesObject:this.profilesObject;T.URI.isUri(l)?(a.workspaces.delete(l),s&&a.workspaces.set(l,s)):a.emptyWindow=s,r||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const t={};for(const[r,l]of this.profilesObject.workspaces.entries())t[r.toString()]=l.location.toString();const s=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:t,emptyWindow:s}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(t){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(t){throw new Error("not implemented")}};d.PROFILES_KEY="userDataProfiles",d.PROFILE_ASSOCIATIONS_KEY="profileAssociations",d=ve([K(0,C.IEnvironmentService),K(1,w.IFileService),K(2,f.IUriIdentityService),K(3,b.ILogService)],d),e.UserDataProfilesService=d;class n extends d{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(t){this.storedProfiles=t}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(t){this.storedProfileAssociations=t}}e.InMemoryUserDataProfilesService=n}),define(re[261],se([0,1,6,2,21]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let k=class extends i.Disposable{constructor(I){super(),this._register(new D.RunOnceScheduler(()=>{I.cleanUp()},10*1e3)).schedule()}};k=ve([K(0,R.IUserDataProfilesService)],k),e.UserDataProfilesCleaner=k}),define(re[262],se([0,1,19,6,22,11,3,2,5,8,155,29,33,46,7,25,24,21]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let p=class extends I.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(t,s,r,l,a){super(),this.galleryService=t,this.telemetryService=s,this.logService=r,this.productService=l,this.userDataProfilesService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this._onDidInstallExtensions=this._register(new T.Emitter),this._onUninstallExtension=this._register(new T.Emitter),this._onDidUninstallExtension=this._register(new T.Emitter),this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(({task:g})=>g.cancel()),this.uninstallingExtensions.forEach(g=>g.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const s=await this.getTargetPlatform();return t.allTargetPlatforms.some(r=>(0,b.isTargetPlatformCompatible)(r,t.allTargetPlatforms,s))}async installFromGallery(t,s={}){try{if(!this.galleryService.isEnabled())throw new b.ExtensionManagementError(E.localize(0,null),b.ExtensionManagementErrorCode.Internal);const r=await this.checkAndGetCompatibleVersion(t,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.installExtension(r.manifest,r.extension,s)}catch(r){throw d(this.telemetryService,"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(t),error:r}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(r),h(r)}}async uninstall(t,s={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,s)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,s,r){const l={...r,installOnlyNewlyAddedFromExtensionPack:w.URI.isUri(s)?r.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:!r.profileLocation||(0,m.isApplicationScopedExtension)(t)?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation},a=F=>`${S.ExtensionKey.create(F).toString()}${l.profileLocation?`-${l.profileLocation.toString()}`:""}`;if(!w.URI.isUri(s)){const F=this.installingExtensions.get(a(s));if(F){this.logService.info("Extensions is already requested to install",s.identifier.id);const{local:N}=await F.task.waitUntilTaskIsFinished();return N}}const g=[],P=[],A=[],V=this.createInstallExtensionTask(t,s,l);w.URI.isUri(s)||this.installingExtensions.set(a(s),{task:V,waitingTasks:[]}),this._onInstallExtension.fire({identifier:V.identifier,source:s,profileLocation:l.profileLocation}),this.logService.info("Installing extension:",V.identifier.id),g.push({task:V,manifest:t});let O=!1;try{if(l.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",V.identifier.id);else try{const N=await this.getAllDepsAndPackExtensions(V.identifier,t,!!l.installOnlyNewlyAddedFromExtensionPack,!!l.installPreReleaseVersion,l.profileLocation),L=await this.getInstalled(void 0,l.profileLocation);for(const{gallery:U,manifest:$}of N){O=O||!!$.extensionDependencies?.some(B=>(0,S.areSameExtensions)({id:B},V.identifier));const x=a(U),j=this.installingExtensions.get(x);if(j){if(this.canWaitForTask(V,j.task)){this.logService.info("Waiting for already requested installing extension",U.identifier.id,V.identifier.id),j.waitingTasks.push(V);const B=j.task.identifier;P.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,W=>W.some(q=>(0,S.areSameExtensions)(q.identifier,B)))).then(W=>{if(!W.find(Y=>(0,S.areSameExtensions)(Y.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!L.some(({identifier:B})=>(0,S.areSameExtensions)(B,U.identifier))){const B=this.createInstallExtensionTask($,U,{...l,donotIncludePackAndDependencies:!0});this.installingExtensions.set(x,{task:B,waitingTasks:[V]}),this._onInstallExtension.fire({identifier:B.identifier,source:U,profileLocation:l.profileLocation}),this.logService.info("Installing extension:",B.identifier.id,V.identifier.id),g.push({task:B,manifest:$})}}}catch(N){if(w.URI.isUri(V.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",V.identifier.id,N.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",V.identifier.id,N.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",V.identifier.id),N}const F=g.reduce((N,{task:L,manifest:U})=>(N.set(L.identifier.id.toLowerCase(),{task:L,manifest:U}),N),new Map);for(;F.size;){let N;const L=[...F.values()].filter(({manifest:U})=>!U.extensionDependencies?.some($=>F.has($.toLowerCase())));L.length?N=F.size===1?L:L.filter(({task:U})=>!(U===V&&!O)):(this.logService.info("Found extensions with circular dependencies",L.map(({task:U})=>U.identifier.id)),N=[...F.values()]),await this.joinAllSettled(N.map(async({task:U})=>{const $=new Date().getTime();try{const{local:x}=await U.run();if(await this.joinAllSettled(this.participants.map(j=>j.postInstall(x,U.source,l,R.CancellationToken.None))),!w.URI.isUri(U.source)){const j=U.operation===3,B=j?void 0:(new Date().getTime()-U.source.lastUpdated)/1e3;if(d(this.telemetryService,j?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(U.source),wasVerified:U.wasVerified,duration:new Date().getTime()-$,durationSinceUpdate:B}),C.isWeb&&U.operation!==3)try{await this.galleryService.reportStatistic(x.manifest.publisher,x.manifest.name,x.manifest.version,"install")}catch{}}A.push({local:x,identifier:U.identifier,operation:U.operation,source:U.source,context:l.context,profileLocation:l.profileLocation,applicationScoped:x.isApplicationScoped})}catch(x){throw w.URI.isUri(U.source)||d(this.telemetryService,U.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(U.source),wasVerified:U.wasVerified,duration:new Date().getTime()-$,error:x}),this.logService.error("Error while installing the extension:",U.identifier.id),x}finally{F.delete(U.identifier.id.toLowerCase())}}))}return P.length&&await this.joinAllSettled(P),A.forEach(({identifier:N})=>this.logService.info("Extension installed successfully:",N.id)),this._onDidInstallExtensions.fire(A),A.filter(({identifier:N})=>(0,S.areSameExtensions)(N,V.identifier))[0].local}catch(F){if(g.forEach(({task:N})=>N.cancel()),A.length)try{const N=await Promise.allSettled(A.map(({local:L})=>this.createUninstallExtensionTask(L,{versionOnly:!0,profileLocation:l.profileLocation}).run()));for(let L=0;L<N.length;L++){const U=N[L],{identifier:$}=A[L];U.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",$.id):this.logService.warn("Rollback: Error while uninstalling extension",$.id,(0,k.getErrorMessage)(U.reason))}}catch(N){this.logService.warn("Error while rolling back extensions",(0,k.getErrorMessage)(N),A.map(({identifier:L})=>L.id))}throw this._onDidInstallExtensions.fire(g.map(({task:N})=>({identifier:N.identifier,operation:2,source:N.source,context:l.context,profileLocation:l.profileLocation}))),F}finally{for(const[F,{task:N,waitingTasks:L}]of this.installingExtensions.entries()){const U=L.indexOf(V);U!==-1&&L.splice(U,1),L.length===0&&(N===V||U!==-1)&&this.installingExtensions.delete(F)}}}canWaitForTask(t,s){for(const[,{task:r,waitingTasks:l}]of this.installingExtensions.entries())if(r===t&&(l.includes(s)||l.some(a=>this.canWaitForTask(a,s)))||r===s&&l[0]&&!this.canWaitForTask(t,l[0]))return!1;return!0}async joinAllSettled(t){const s=[],r=[],l=await Promise.allSettled(t);for(const a of l)a.status==="fulfilled"?s.push(a.value):r.push(a.reason);if(r.length)throw c(r);return s}async getAllDepsAndPackExtensions(t,s,r,l,a){if(!this.galleryService.isEnabled())return[];const g=await this.getInstalled(void 0,a),P=[t],A=[],V=async(O,F)=>{const N=F.extensionDependencies||[],L=[...N];if(F.extensionPack){const U=r?g.find($=>(0,S.areSameExtensions)($.identifier,O)):void 0;for(const $ of F.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(x=>(0,S.areSameExtensions)({id:x},{id:$}))||L.every(x=>!(0,S.areSameExtensions)({id:x},{id:$}))&&L.push($)}if(L.length){const U=[...P,...A.map(x=>x.gallery.identifier)],$=L.filter(x=>U.every(j=>!(0,S.areSameExtensions)(j,{id:x})));if($.length){const x=await this.galleryService.getExtensions($.map(j=>({id:j,preRelease:l})),R.CancellationToken.None);for(const j of x){if(U.find(q=>(0,S.areSameExtensions)(q,j.identifier)))continue;const B=N.some(q=>(0,S.areSameExtensions)({id:q},j.identifier));let W;try{W=await this.checkAndGetCompatibleVersion(j,!1,l)}catch(q){if(q instanceof b.ExtensionManagementError&&q.code===b.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!B){this.logService.info("Skipping the packed extension as it cannot be installed",j.identifier.id);continue}else throw q}A.push({gallery:W.extension,manifest:W.manifest}),await V(W.extension.identifier,W.manifest)}}}};return await V(t,s),A}async checkAndGetCompatibleVersion(t,s,r){if((await this.getExtensionsControlManifest()).malicious.some(P=>(0,S.areSameExtensions)(t.identifier,P)))throw new b.ExtensionManagementError(E.localize(1,null,t.identifier.id),b.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const P=await this.getTargetPlatform();throw new b.ExtensionManagementError(E.localize(2,null,t.identifier.id,this.productService.nameLong,(0,b.TargetPlatformToString)(P)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(t,s,r);if(a){if(r&&!s&&t.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new b.ExtensionManagementError(E.localize(3,null,t.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!r&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],R.CancellationToken.None))[0]?new b.ExtensionManagementError(E.localize(4,null,t.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.ExtensionManagementError(E.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const g=await this.galleryService.getManifest(a,R.CancellationToken.None);if(g===null)throw new b.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(g.version!==a.version)throw new b.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:g}}async getCompatibleVersion(t,s,r){const l=await this.getTargetPlatform();let a=null;return!s&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==r&&(a=(await this.galleryService.getExtensions([{...t.identifier,preRelease:r}],{targetPlatform:l,compatible:!0},R.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(t,r,l)&&(a=t),a||(s?a=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:l,compatible:!0},R.CancellationToken.None))[0]||null:a=await this.galleryService.getCompatibleExtension(t,r,l)),a}async uninstallExtension(t,s){const r={...s,profileLocation:!s.profileLocation||t.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:s.profileLocation},l=O=>`${O.id.toLowerCase()}${r.versionOnly?`-${t.manifest.version}`:""}${r.profileLocation?`@${r.profileLocation.toString()}`:""}`,a=this.uninstallingExtensions.get(l(t.identifier));if(a)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),a.waitUntilTaskIsFinished();const g=O=>{const F=this.createUninstallExtensionTask(O,r);return this.uninstallingExtensions.set(l(F.extension.identifier),F),r.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${O.identifier.id}@${O.manifest.version}`,r.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${O.identifier.id}@${O.manifest.version}`),this._onUninstallExtension.fire({identifier:O.identifier,profileLocation:r.profileLocation,applicationScoped:O.isApplicationScoped}),F},P=(O,F)=>{F?r.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${O.identifier.id}@${O.manifest.version}`,r.profileLocation.toString(),F.message):this.logService.error("Failed to uninstall extension:",`${O.identifier.id}@${O.manifest.version}`,F.message):r.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${O.identifier.id}@${O.manifest.version}`,r.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${O.identifier.id}@${O.manifest.version}`),d(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,S.getLocalExtensionTelemetryData)(O),error:F}),this._onDidUninstallExtension.fire({identifier:O.identifier,version:O.manifest.version,error:F?.code,profileLocation:r.profileLocation,applicationScoped:O.isApplicationScoped})},A=[],V=[];try{A.push(g(t));const O=await this.getInstalled(1,r.profileLocation);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const F=this.getAllPackExtensionsToUninstall(t,O);for(const N of F)this.uninstallingExtensions.has(l(N.identifier))?this.logService.info("Extensions is already requested to uninstall",N.identifier.id):A.push(g(N))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(A.map(F=>F.extension),O,t),await this.joinAllSettled(A.map(async F=>{try{if(await F.run(),await this.joinAllSettled(this.participants.map(N=>N.postUninstall(F.extension,r,R.CancellationToken.None))),F.extension.identifier.uuid)try{await this.galleryService.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}P(F.extension)}catch(N){const L=N instanceof b.ExtensionManagementError?N:new b.ExtensionManagementError((0,k.getErrorMessage)(N),b.ExtensionManagementErrorCode.Internal);throw P(F.extension,L),L}finally{V.push(F)}}))}catch(O){const F=O instanceof b.ExtensionManagementError?O:new b.ExtensionManagementError((0,k.getErrorMessage)(O),b.ExtensionManagementErrorCode.Internal);for(const N of A){try{N.cancel()}catch{}V.includes(N)||P(N.extension,F)}throw F}finally{for(const O of A)this.uninstallingExtensions.delete(l(O.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",O.extension.identifier.id)}}checkForDependents(t,s,r){for(const l of t){const a=this.getDependents(l,s);if(a.length){const g=a.filter(P=>!t.some(A=>(0,S.areSameExtensions)(A.identifier,P.identifier)));if(g.length)throw new Error(this.getDependentsErrorMessage(l,g,r))}}}getDependentsErrorMessage(t,s,r){return r===t?s.length===1?E.localize(6,null,r.manifest.displayName||r.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?E.localize(7,null,r.manifest.displayName||r.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):E.localize(8,null,r.manifest.displayName||r.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?E.localize(9,null,r.manifest.displayName||r.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?E.localize(10,null,r.manifest.displayName||r.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):E.localize(11,null,r.manifest.displayName||r.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(t,s,r=[]){if(r.indexOf(t)!==-1)return[];r.push(t);const l=t.manifest.extensionPack?t.manifest.extensionPack:[];if(l.length){const a=s.filter(P=>!P.isBuiltin&&l.some(A=>(0,S.areSameExtensions)({id:A},P.identifier))),g=[];for(const P of a)g.push(...this.getAllPackExtensionsToUninstall(P,s,r));return[...a,...g]}return[]}getDependents(t,s){return s.filter(r=>r.manifest.extensionDependencies&&r.manifest.extensionDependencies.some(l=>(0,S.areSameExtensions)({id:l},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};p=ve([K(0,b.IExtensionGalleryService),K(1,y.ITelemetryService),K(2,f.ILogService),K(3,v.IProductService),K(4,u.IUserDataProfilesService)],p),e.AbstractExtensionManagementService=p;function c(o){const t=Array.isArray(o)?o:[o];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((s,r)=>new Error(`${s.message}${s.message?",":""}${r instanceof Error?r.message:r}`),new Error(""))}e.joinErrors=c;function h(o){if(o instanceof b.ExtensionManagementError)return o;const t=new b.ExtensionManagementError(o.message,b.ExtensionManagementErrorCode.Internal);return t.stack=o.stack,t}function d(o,t,{extensionData:s,wasVerified:r,duration:l,error:a,durationSinceUpdate:g}){let P,A;a&&(a instanceof b.ExtensionManagementError?(P=a.code,a.code===b.ExtensionManagementErrorCode.Signature&&(A=a.message)):P=b.ExtensionManagementErrorCode.Internal),o.publicLog(t,{...s,wasVerified:r,success:!a,duration:l,errorcode:P,errorcodeDetail:A,durationSinceUpdate:g})}e.reportTelemetry=d;class n{constructor(){this.barrier=new i.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,i.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,i.createCancelablePromise)(t=>new Promise((s,r)=>{const l=t.onCancellationRequested(()=>{l.dispose(),r(new k.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=n}),define(re[77],se([0,1,19,6,31,17,11,35,137,2,23,12,5,20,54,87,15,8,158,13,33,46,70,14,4,7,25,3,67,60,21,32,188]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u,p,c,h,d,n,o,t,s,r,l,a,g,P,A,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var O;(function(j){function B(W,q){if(W===q)return!0;const Y=Object.keys(W),ee=new Set;for(const ce of Object.keys(q))ee.add(ce);if(Y.length!==ee.size)return!1;for(const ce of Y){if(W[ce]!==q[ce])return!1;ee.delete(ce)}return ee.size===0}j.equals=B})(O=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let F=class extends w.Disposable{constructor(B,W,q,Y,ee,ce,J,z,_,M,G){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=W,this.extensionsControlLocation=q,this.cacheLocation=Y,this.userDataProfilesService=ee,this.extensionsProfileScannerService=ce,this.fileService=J,this.logService=z,this.environmentService=_,this.productService=M,this.instantiationService=G,this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,m.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(U,(0,m.joinPath)(this.cacheLocation,d.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(U,(0,m.joinPath)(this.cacheLocation,d.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(L,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,h.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(B,W,q){const[Y,ee]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(W)]),ce=q?await this.scanExtensionsUnderDevelopment(B,[...Y,...ee]):[];return this.dedupExtensions(Y,ee,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const W=[];W.push(this.scanDefaultSystemExtensions(!!B.useCache,B.language)),W.push(this.scanDevSystemExtensions(B.language,!!B.checkControlFile));const[q,Y]=await Promise.all(W);return this.applyScanOptions([...q,...Y],0,B,!1)}async scanUserExtensions(B){const W=B.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",W);const q=await this.createExtensionScannerInput(W,!!B.profileLocation,1,!B.includeUninstalled,B.language);let ee=await(B.useCache&&!q.devMode&&q.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(q);return ee=await this.applyScanOptions(ee,1,B,!0),this.logService.trace("Scanned user extensions:",ee.length),ee}async scanExtensionsUnderDevelopment(B,W){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const q=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(Y=>Y.scheme===E.Schemas.file).map(async Y=>{const ee=await this.createExtensionScannerInput(Y,!1,1,!0,B.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(ee)).map(J=>(J.type=W.find(z=>(0,h.areSameExtensions)(z.identifier,J.identifier))?.type??J.type,this.extensionsScanner.validate(J,ee)))}))).flat();return this.applyScanOptions(q,"development",B,!0)}return[]}async scanExistingExtension(B,W,q){const Y=await this.createExtensionScannerInput(B,!1,W,!0,q.language),ee=await this.extensionsScanner.scanExtension(Y);return!ee||!q.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(B,W,q){const Y=await this.createExtensionScannerInput(B,!1,W,!0,q.language),ee=await this.extensionsScanner.scanOneOrMultipleExtensions(Y);return this.applyScanOptions(ee,W,q,!0)}async scanMetadata(B){const W=(0,m.joinPath)(B,"package.json"),q=(await this.fileService.readFile(W)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(B,W){const q=(0,m.joinPath)(B,"package.json"),Y=(await this.fileService.readFile(q)).value.toString(),ee=JSON.parse(Y);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.installedTimestamp=W.installedTimestamp||void 0,ee.__metadata={...ee.__metadata,...W},await this.fileService.writeFile((0,m.joinPath)(B,"package.json"),k.VSBuffer.fromString(JSON.stringify(ee,null,"	")))}async applyScanOptions(B,W,q,Y){return q.includeAllVersions||(B=this.dedupExtensions(W===0?B:void 0,W===1?B:void 0,W==="development"?B:void 0,await this.getTargetPlatform(),Y)),q.includeInvalid||(B=B.filter(ee=>ee.isValid)),B.sort((ee,ce)=>{const J=b.basename(ee.location.fsPath),z=b.basename(ce.location.fsPath);return J<z?-1:J>z?1:0})}dedupExtensions(B,W,q,Y,ee){const ce=(z,_,M)=>{if(z.isValid&&!_.isValid)return!1;if(z.isValid===_.isValid){if(ee&&f.gt(z.manifest.version,_.manifest.version))return this.logService.debug(`Skipping extension ${_.location.path} with lower version ${_.manifest.version} in favour of ${z.location.path} with version ${z.manifest.version}`),!1;if(f.eq(z.manifest.version,_.manifest.version)){if(z.type===0)return this.logService.debug(`Skipping extension ${_.location.path} in favour of system extension ${z.location.path} with same version`),!1;if(z.targetPlatform===Y)return this.logService.debug(`Skipping extension ${_.location.path} from different target platform ${_.targetPlatform}`),!1}}return M?this.logService.warn(`Overwriting user extension ${z.location.path} with ${_.location.path}.`):this.logService.debug(`Overwriting user extension ${z.location.path} with ${_.location.path}.`),!0},J=new Map;return B?.forEach(z=>{const _=d.ExtensionIdentifier.toKey(z.identifier.id),M=J.get(_);(!M||ce(M,z,!1))&&J.set(_,z)}),W?.forEach(z=>{const _=d.ExtensionIdentifier.toKey(z.identifier.id),M=J.get(_);if(!M&&B&&z.type===0){this.logService.debug(`Skipping obsolete system extension ${z.location.path}.`);return}(!M||ce(M,z,!1))&&J.set(_,z)}),q?.forEach(z=>{const _=d.ExtensionIdentifier.toKey(z.identifier.id),M=J.get(_);(!M||ce(M,z,!0))&&J.set(_,z),J.set(_,z)}),[...J.values()]}async scanDefaultSystemExtensions(B,W){this.logService.trace("Started scanning system extensions");const q=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,W),ee=await(B&&!q.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(q);return this.logService.trace("Scanned system extensions:",ee.length),ee}async scanDevSystemExtensions(B,W){const q=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!q?.length)return[];this.logService.trace("Started scanning dev system extensions");const Y=W?await this.getBuiltInExtensionControl():{},ee=[],ce=u.URI.file(b.normalize(b.join(E.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions")));for(const z of q){const _=Y[z.name]||"marketplace";switch(_){case"disabled":break;case"marketplace":ee.push((0,m.joinPath)(ce,z.name));break;default:ee.push(u.URI.file(_));break}}const J=await Promise.all(ee.map(async z=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(z,!1,0,!0,B))));return this.logService.trace("Scanned dev system extensions:",J.length),(0,D.coalesce)(J)}async getBuiltInExtensionControl(){try{const B=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(B.value.toString())}catch{return{}}}async createExtensionScannerInput(B,W,q,Y,ee,ce=!0){const J=await this.getTranslations(ee??S.language),z=await this.getMtime(B),_=W?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,M=_?await this.getMtime(_):void 0;return new N(B,z,_,M,W,q,Y,ce,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,ee,J)}async getMtime(B){try{const W=await this.fileService.stat(B);if(typeof W.mtime=="number")return W.mtime}catch{}}};F=ve([K(4,P.IUserDataProfilesService),K(5,g.IExtensionsProfileScannerService),K(6,o.IFileService),K(7,s.ILogService),K(8,c.IEnvironmentService),K(9,r.IProductService),K(10,t.IInstantiationService)],F),e.AbstractExtensionsScannerService=F;class N{constructor(B,W,q,Y,ee,ce,J,z,_,M,G,H,Z,oe){this.location=B,this.mtime=W,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=Y,this.profile=ee,this.type=ce,this.excludeObsolete=J,this.validate=z,this.productVersion=_,this.productDate=M,this.productCommit=G,this.devMode=H,this.language=Z,this.translations=oe}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,W){return(0,m.isEqual)(B.location,W.location)&&B.mtime===W.mtime&&(0,m.isEqual)(B.applicationExtensionslocation,W.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&B.profile===W.profile&&B.type===W.type&&B.excludeObsolete===W.excludeObsolete&&B.validate===W.validate&&B.productVersion===W.productVersion&&B.productDate===W.productDate&&B.productCommit===W.productCommit&&B.devMode===W.devMode&&B.language===W.language&&O.equals(B.translations,W.translations)}}let L=class extends w.Disposable{constructor(B,W,q,Y,ee){super(),this.obsoleteFile=B,this.extensionsProfileScannerService=W,this.uriIdentityService=q,this.fileService=Y,this.logService=ee}async scanExtensions(B){const W=B.profile?await this.scanExtensionsFromProfile(B):await this.scanExtensionsFromLocation(B);let q={};if(B.excludeObsolete&&B.type===1)try{const Y=(await this.fileService.readFile(this.obsoleteFile)).value.toString();q=JSON.parse(Y)}catch{}return(0,y.isEmptyObject)(q)?W:W.filter(Y=>!q[h.ExtensionKey.create(Y).toString()])}async scanExtensionsFromLocation(B){const W=await this.fileService.resolve(B.location);if(!W.children?.length)return[];const q=await Promise.all(W.children.map(async Y=>{if(!Y.isDirectory||B.type===1&&(0,m.basename)(Y.resource).indexOf(".")===0)return null;const ee=new N(Y.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(ee)}));return(0,D.coalesce)(q).sort((Y,ee)=>Y.location.path<ee.location.path?-1:1)}async scanExtensionsFromProfile(B){let W=await this.scanExtensionsFromProfileResource(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(B.location,B.applicationExtensionslocation)){W=W.filter(Y=>!Y.metadata?.isApplicationScoped);const q=await this.scanExtensionsFromProfileResource(B.applicationExtensionslocation,Y=>!!Y.metadata?.isApplicationScoped,B);W.push(...q)}return W}async scanExtensionsFromProfileResource(B,W,q){const Y=await this.extensionsProfileScannerService.scanProfileExtensions(B);if(!Y.length)return[];const ee=await Promise.all(Y.map(async ce=>{if(W(ce)){const J=new N(ce.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(J,ce.metadata)}return null}));return(0,D.coalesce)(ee)}async scanOneOrMultipleExtensions(B){try{if(await this.fileService.exists((0,m.joinPath)(B.location,"package.json"))){const W=await this.scanExtension(B);return W?[W]:[]}else return await this.scanExtensions(B)}catch(W){return this.logService.error(`Error scanning extensions at ${B.location.path}:`,(0,T.getErrorMessage)(W)),[]}}async scanExtension(B,W){try{let q=await this.scanExtensionManifest(B.location);if(q){q.publisher||(q.publisher=d.UNDEFINED_PUBLISHER),W=W??q.__metadata,delete q.__metadata;const Y=(0,h.getGalleryExtensionId)(q.publisher,q.name),ee=W?.id?{id:Y,uuid:W.id}:{id:Y},ce=W?.isSystem?0:B.type,J=ce===0||!!W?.isBuiltin;q=await this.translateManifest(B.location,q,N.createNlsConfiguration(B));const z={type:ce,identifier:ee,manifest:q,location:B.location,isBuiltin:J,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return B.validate?this.validate(z,B):z}}catch(q){B.type!==0&&this.logService.error(q)}return null}validate(B,W){let q=!0;const Y=(0,n.validateExtensionManifest)(W.productVersion,W.productDate,W.location,B.manifest,B.isBuiltin);for(const[ee,ce]of Y)ee===v.default.Error&&(q=!1,this.logService.error(this.formatMessage(W.location,ce)));return B.isValid=q,B.validations=Y,B}async scanExtensionManifest(B){const W=(0,m.joinPath)(B,"package.json");let q;try{q=(await this.fileService.readFile(W)).value.toString()}catch(ee){return(0,o.toFileOperationResult)(ee)!==1&&this.logService.error(this.formatMessage(B,(0,p.localize)(0,null,W.path,ee.message))),null}let Y;try{Y=JSON.parse(q)}catch{const ce=[];(0,I.parse)(q,ce);for(const J of ce)this.logService.error(this.formatMessage(B,(0,p.localize)(1,null,W.path,J.offset,J.length,(0,C.getParseErrorMessage)(J.error))));return null}return(0,I.getNodeType)(Y)!=="object"?(this.logService.error(this.formatMessage(B,(0,p.localize)(2,null,W.path))),null):Y}async translateManifest(B,W,q){const Y=await this.getLocalizedMessages(B,W,q);if(Y)try{const ee=[],ce=await this.resolveOriginalMessageBundle(Y.default,ee);if(ee.length>0)return ee.forEach(z=>{this.logService.error(this.formatMessage(B,(0,p.localize)(3,null,Y.default?.path,(0,C.getParseErrorMessage)(z.error))))}),W;if((0,I.getNodeType)(Y)!=="object")return this.logService.error(this.formatMessage(B,(0,p.localize)(4,null,Y.default?.path))),W;const J=Y.values||Object.create(null);return(0,V.localizeManifest)(W,J,ce)}catch{}return W}async getLocalizedMessages(B,W,q){const Y=(0,m.joinPath)(B,"package.nls.json"),ee=(_,M)=>{M.forEach(G=>{this.logService.error(this.formatMessage(B,(0,p.localize)(5,null,_?.path,(0,C.getParseErrorMessage)(G.error))))})},ce=_=>{this.logService.error(this.formatMessage(B,(0,p.localize)(6,null,_?.path)))},J=`${W.publisher}.${W.name}`,z=q.translations[J];if(z)try{const _=u.URI.file(z),M=(await this.fileService.readFile(_)).value.toString(),G=[],H=(0,I.parse)(M,G);return G.length>0?(ee(_,G),{values:void 0,default:Y}):(0,I.getNodeType)(H)!=="object"?(ce(_),{values:void 0,default:Y}):{values:H.contents?H.contents.package:void 0,default:Y}}catch{return{values:void 0,default:Y}}else{if(!await this.fileService.exists(Y))return;let M;try{M=await this.findMessageBundles(B,q)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const G=(await this.fileService.readFile(M.localized)).value.toString(),H=[],Z=(0,I.parse)(G,H);return H.length>0?(ee(M.localized,H),{values:void 0,default:M.original}):(0,I.getNodeType)(Z)!=="object"?(ce(M.localized),{values:void 0,default:M.original}):{values:Z,default:M.original}}catch{return{values:void 0,default:M.original}}}}async resolveOriginalMessageBundle(B,W){if(B)try{const q=(await this.fileService.readFile(B)).value.toString();return(0,I.parse)(q,W)}catch{}}findMessageBundles(B,W){return new Promise((q,Y)=>{const ee=ce=>{const J=(0,m.joinPath)(B,`package.nls.${ce}.json`);this.fileService.exists(J).then(z=>{z&&q({localized:J,original:(0,m.joinPath)(B,"package.nls.json")});const _=ce.lastIndexOf("-");_===-1?q({localized:(0,m.joinPath)(B,"package.nls.json"),original:null}):(ce=ce.substring(0,_),ee(ce))})};if(W.devMode||W.pseudo||!W.language)return q({localized:(0,m.joinPath)(B,"package.nls.json"),original:null});ee(W.language)})}formatMessage(B,W){return`[${B.path}]: ${W}`}};L=ve([K(1,g.IExtensionsProfileScannerService),K(2,A.IUriIdentityService),K(3,o.IFileService),K(4,s.ILogService)],L);let U=class extends L{constructor(B,W,q,Y,ee,ce){super(W,q,Y,ee,ce),this.cacheFile=B,this.cacheValidatorThrottler=this._register(new i.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(B){const W=await this.readExtensionCache();if(this.input=B,W&&W.input&&N.equals(W.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),W.result.map(Y=>(Y.location=u.URI.revive(Y.location),Y));const q=await super.scanExtensions(B);return await this.writeExtensionCache({input:B,result:q}),q}async readExtensionCache(){try{const B=await this.fileService.readFile(this.cacheFile),W=JSON.parse(B.value.toString());return{result:W.result,input:(0,a.revive)(W.input)}}catch(B){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(B))}return null}async writeExtensionCache(B){try{await this.fileService.writeFile(this.cacheFile,k.VSBuffer.fromString(JSON.stringify(B)))}catch(W){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(W))}}async validateCache(){if(!this.input)return;const B=await this.readExtensionCache();if(!B)return;const W=B.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!R.equals(q,W))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(Y){this.logService.error(Y)}}};U=ve([K(2,g.IExtensionsProfileScannerService),K(3,A.IUriIdentityService),K(4,o.IFileService),K(5,s.ILogService)],U);function $(j,B){const W=(0,h.getExtensionId)(j.manifest.publisher,j.manifest.name);return{id:W,identifier:new d.ExtensionIdentifier(W),isBuiltin:j.type===0,isUserBuiltin:j.type===1&&j.isBuiltin,isUnderDevelopment:B,extensionLocation:j.location,uuid:j.identifier.uuid,targetPlatform:j.targetPlatform,...j.manifest}}e.toExtensionDescription=$;class x extends F{constructor(B,W,q,Y,ee,ce,J,z,_,M,G){super(B,W,(0,m.joinPath)(q,".vscode-oss-dev","extensions","control.json"),(0,m.joinPath)(Y,d.MANIFEST_CACHE_FOLDER),ee,ce,J,z,_,M,G),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const H=await this.fileService.readFile(u.URI.file(S.translationsConfigFile));return JSON.parse(H.value.toString())}catch{}return Object.create(null)})()}getTranslations(B){return this.translationsPromise}}e.NativeExtensionsScannerService=x}),define(re[263],se([0,1,50,6,37,3,2,23,12,28,7,21]),function(Q,e,D,i,R,k,T,I,C,w,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let S=class extends T.Disposable{constructor(f,v){super(),this.userDataProfilesService=f,this.logService=v,this.processesLimiter=new i.Limiter(5)}async postUninstall(f){const v=this.parseScript(f,"uninstall");return v&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(v.script,"uninstall",v.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${y}`)))),w.Promises.rm(this.getExtensionStoragePath(f)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(f,v){const y=`vscode:${v}`;if(f.location.scheme===I.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[y]=="string"){const u=f.manifest.scripts[y].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${y} should be a node script`),null):{script:(0,C.join)(f.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}runLifecycleHook(f,v,y,u,p){return new Promise((c,h)=>{const d=this.start(f,v,y,p);let n;const o=t=>{n&&(clearTimeout(n),n=null),t?h(t):c(void 0)};d.on("error",t=>{o((0,R.toErrorMessage)(t)||"Unknown")}),d.on("exit",(t,s)=>{o(t?`post-${v} process exited with code ${t}`:void 0)}),u&&(n=setTimeout(()=>{n=null,d.kill(),h("timed out")},5e3))})}start(f,v,y,u){const p={silent:!0,execArgv:void 0},c=(0,D.fork)(f,[`--type=extension-post-${v}`,...y],p);c.stdout.setEncoding("utf8"),c.stderr.setEncoding("utf8");const h=k.Event.fromNodeEventEmitter(c.stdout,"data"),d=k.Event.fromNodeEventEmitter(c.stderr,"data");h(t=>this.logService.info(u.identifier.id,u.manifest.version,`post-${v}`,t)),d(t=>this.logService.error(u.identifier.id,u.manifest.version,`post-${v}`,t));const n=k.Event.any(k.Event.map(h,t=>({data:`%c${t}`,format:[""]})),k.Event.map(d,t=>({data:`%c${t}`,format:["color: red"]})));return k.Event.debounce(n,(t,s)=>t?{data:t.data+s.data,format:[...t.format,...s.format]}:{data:s.data,format:s.format},100)(t=>{console.group(u.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),c}getExtensionStoragePath(f){return(0,C.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};S=ve([K(0,b.IUserDataProfilesService),K(1,E.ILogService)],S),e.ExtensionsLifecycle=S}),define(re[264],se([0,1,8,13,60,77,14,4,7,25,21]),function(Q,e,D,i,R,k,T,I,C,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends k.NativeExtensionsScannerService{constructor(m,f,v,y,u,p,c){super(D.URI.file(u.builtinExtensionsPath),D.URI.file(u.extensionsPath),u.userHome,D.URI.file(u.userDataPath),m,f,v,y,u,p,c)}};b=ve([K(0,E.IUserDataProfilesService),K(1,R.IExtensionsProfileScannerService),K(2,T.IFileService),K(3,C.ILogService),K(4,i.INativeEnvironmentService),K(5,w.IProductService),K(6,I.IInstantiationService)],b),e.ExtensionsScannerService=b}),define(re[18],se([0,1,6,3,2,206,15,69,4,21]),function(Q,e,D,i,R,k,T,I,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,C.createDecorator)("storageService");var E;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var S;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(S=e.StorageTarget||(e.StorageTarget={}));function m(p){const c=p.get(e.TARGET_KEY);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.loadKeyTargets=m;class f extends R.Disposable{constructor(c={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super(),this.options=c,this._onDidChangeValue=this._register(new i.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new i.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new i.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(c,h){if(h===e.TARGET_KEY){switch(c){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:c})}else this._onDidChangeValue.fire({scope:c,key:h,target:this.getKeyTargets(c)[h]})}emitWillSaveState(c){this._onWillSaveState.fire({reason:c})}get(c,h,d){return this.getStorage(h)?.get(c,d)}getBoolean(c,h,d){return this.getStorage(h)?.getBoolean(c,d)}getNumber(c,h,d){return this.getStorage(h)?.getNumber(c,d)}store(c,h,d,n){if((0,T.isUndefinedOrNull)(h)){this.remove(c,d);return}this.withPausedEmitters(()=>{this.updateKeyTarget(c,d,n),this.getStorage(d)?.set(c,h)})}remove(c,h){this.withPausedEmitters(()=>{this.updateKeyTarget(c,h,void 0),this.getStorage(h)?.delete(c)})}withPausedEmitters(c){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{c()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(c,h){const d=[],n=this.getKeyTargets(c);for(const o of Object.keys(n))n[o]===h&&d.push(o);return d}updateKeyTarget(c,h,d){const n=this.getKeyTargets(h);typeof d=="number"?n[c]!==d&&(n[c]=d,this.getStorage(h)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[c]=="number"&&(delete n[c],this.getStorage(h)?.set(e.TARGET_KEY,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(c){switch(c){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(c){const h=this.getStorage(c);return h?m(h):Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}async flush(c=E.NONE){this._onWillSaveState.fire({reason:c});const h=this.getStorage(-1),d=this.getStorage(0),n=this.getStorage(1);switch(c){case E.NONE:await D.Promises.settled([h?.whenFlushed()??Promise.resolve(),d?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await D.Promises.settled([h?.flush(0)??Promise.resolve(),d?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.getStorage(-1)?.items??new Map,h=this.getStorage(0)?.items??new Map,d=this.getStorage(1)?.items??new Map;return u(c,h,d,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(c,h){return this.emitWillSaveState(E.NONE),(0,w.isUserDataProfile)(c)?this.switchToProfile(c,h):this.switchToWorkspace(c,h)}canSwitchProfile(c,h){return!(c.id===h.id||v(h)&&v(c))}switchData(c,h,d,n){this.withPausedEmitters(()=>{if(n)for(const[o,t]of c)h.set(o,t);else{const o=new Set;for(const[t,s]of c)o.add(t),h.get(t)!==s&&this.emitDidChangeValue(d,t);for(const[t]of h.items)o.has(t)||this.emitDidChangeValue(d,t)}})}}e.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;function v(p){return p.isDefault||!!p.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=v;class y extends f{constructor(){super(),this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(c=>this.emitDidChangeValue(1,c))),this._register(this.profileStorage.onDidChangeStorage(c=>this.emitDidChangeValue(0,c))),this._register(this.applicationStorage.onDidChangeStorage(c=>this.emitDidChangeValue(-1,c)))}getStorage(c){switch(c){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(c){return!1}}e.InMemoryStorageService=y;async function u(p,c,h,d,n,o){const t=O=>{try{return JSON.parse(O)}catch{return O}},s=new Map,r=new Map;p.forEach((O,F)=>{s.set(F,O),r.set(F,t(O))});const l=new Map,a=new Map;c.forEach((O,F)=>{l.set(F,O),a.set(F,t(O))});const g=new Map,P=new Map;h.forEach((O,F)=>{g.set(F,O),P.set(F,t(O))}),console.group(d!==n?`Storage: Application (path: ${d})`:`Storage: Application & Profile (path: ${d}, default profile)`);const A=[];if(s.forEach((O,F)=>{A.push({key:F,value:O})}),console.table(A),console.groupEnd(),console.log(r),d!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const O=[];l.forEach((F,N)=>{O.push({key:N,value:F})}),console.table(O),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const V=[];g.forEach((O,F)=>{V.push({key:F,value:O})}),console.table(V),console.groupEnd(),console.log(P)}e.logStorage=u}),define(re[117],se([0,1,3,2,15,29,33,18]),function(Q,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let C=class extends i.Disposable{constructor(b,S){super(),this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new w(b)),this._register(this.storageManger.onDidChange(m=>this._onDidChangeEnablement.fire({extensions:m,source:"storage"}))),this._register(S.onDidInstallExtensions(m=>m.forEach(({local:f,operation:v})=>{f&&v===4&&this._removeFromDisabledExtensions(f.identifier)})))}async enableExtension(b,S){return this._removeFromDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:S}),!0):!1}async disableExtension(b,S){return this._addToDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:S}),!0):!1}getDisabledExtensions(){return this._getExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(b){const S=this.getDisabledExtensions();return S.every(m=>!(0,T.areSameExtensions)(m,b))?(S.push(b),this._setDisabledExtensions(S),!0):!1}_removeFromDisabledExtensions(b){const S=this.getDisabledExtensions();for(let m=0;m<S.length;m++){const f=S[m];if((0,T.areSameExtensions)(f,b))return S.splice(m,1),this._setDisabledExtensions(S),!0}return!1}_setDisabledExtensions(b){this._setExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH,b)}_getExtensions(b){return this.storageManger.get(b,0)}_setExtensions(b,S){this.storageManger.set(b,S,0)}};C=ve([K(0,I.IStorageService),K(1,k.IExtensionManagementService)],C),e.GlobalExtensionEnablementService=C;class w extends i.Disposable{constructor(b){super(),this.storageService=b,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(b.onDidChangeValue(S=>this.onDidStorageChange(S)))}get(b,S){let m;return S===0?((0,R.isUndefinedOrNull)(this.storage[b])&&(this.storage[b]=this._get(b,S)),m=this.storage[b]):m=this._get(b,S),JSON.parse(m)}set(b,S,m){const f=JSON.stringify(S.map(({id:y,uuid:u})=>({id:y,uuid:u})));this._get(b,m)!==f&&(m===0&&(S.length?this.storage[b]=f:delete this.storage[b]),this._set(b,S.length?f:void 0,m))}onDidStorageChange(b){if(b.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[b.key])&&this._get(b.key,b.scope)!==this.storage[b.key]){const m=this.get(b.key,b.scope);delete this.storage[b.key];const f=this.get(b.key,b.scope),v=m.filter(u=>!f.some(p=>(0,T.areSameExtensions)(u,p))),y=f.filter(u=>!m.some(p=>(0,T.areSameExtensions)(p,u)));(v.length||y.length)&&this._onDidChange.fire([...v,...y])}}_get(b,S){return this.storageService.get(b,S,"[]")}_set(b,S,m){S?this.storageService.store(b,S,m,1):this.storageService.remove(b,m)}}e.StorageManager=w}),define(re[265],se([0,1,19,22,11,5,36,15,8,16,13,29,33,70,14,7,25,47,236,18,24]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u,p,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const d=k.isWeb?"web":(0,b.getTargetPlatform)(k.platform,T.arch);var n;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished",_[_.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function o(..._){return String(_.reduce((M,G)=>M|G,0))}var t;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class g{constructor(M=a){this.state=M}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(M,G=this.state.pageSize){return new g({...this.state,pageNumber:M,pageSize:G})}withFilter(M,...G){const H=[...this.state.criteria,...G.length?G.map(Z=>({filterType:M,value:Z})):[{filterType:M}]];return new g({...this.state,criteria:H})}withSortBy(M){return new g({...this.state,sortBy:M})}withSortOrder(M){return new g({...this.state,sortOrder:M})}withFlags(...M){return new g({...this.state,flags:M.reduce((G,H)=>G|H,0)})}withAssetTypes(...M){return new g({...this.state,assetTypes:M})}withSource(M){return new g({...this.state,source:M})}get raw(){const{criteria:M,pageNumber:G,pageSize:H,sortBy:Z,sortOrder:oe,flags:X,assetTypes:ie}=this.state;return{filters:[{criteria:M,pageNumber:G,pageSize:H,sortBy:Z,sortOrder:oe}],assetTypes:ie,flags:X}}get searchText(){const M=this.state.criteria.filter(G=>G.filterType===t.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(M=>String(M.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function P(_,M){const G=(_||[]).filter(H=>H.statisticName===M)[0];return G?G.value:0}function A(_){const M="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(H=>H.assetType.indexOf(M)===0).reduce((H,Z)=>{const oe=F(_,Z.assetType);return oe&&H.push([Z.assetType.substring(M.length),oe]),H},[])}function V(_){if(_.properties){const M=_.properties.filter(Z=>Z.key===s.Repository),G=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),H=M.filter(Z=>G.test(Z.value))[0];return H?{uri:H.value,fallbackUri:H.value}:null}return F(_,s.Repository)}function O(_){return{uri:`${_.fallbackAssetUri}/${s.VSIX}?redirect=true${_.targetPlatform?`&targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${s.VSIX}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}}function F(_,M){return _.files.filter(H=>H.assetType===M)[0]?{uri:`${_.assetUri}/${M}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${M}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}:null}function N(_,M){const G=_.properties?_.properties.filter(Z=>Z.key===M):[],H=G.length>0&&G[0].value;return H?H.split(",").map(Z=>(0,S.adoptToGalleryExtensionId)(Z)):[]}function L(_){const M=_.properties?_.properties.filter(G=>G.key===r.Engine):[];return M.length>0&&M[0].value||""}function U(_){const M=_.properties?_.properties.filter(G=>G.key===r.PreRelease):[];return M.length>0&&M[0].value==="true"}function $(_){const M=_.properties?_.properties.filter(H=>H.key===r.LocalizedLanguages):[],G=M.length>0&&M[0].value||"";return G?G.split(","):[]}function x(_){return _.properties?.find(M=>M.key===r.SponsorLink)?.value}function j(_){return _.indexOf("preview")!==-1}function B(_){return _.targetPlatform?(0,b.toTargetPlatform)(_.targetPlatform):"undefined"}function W(_){const M=(0,D.distinct)(_.versions.map(B)),G=!!_.tags?.includes(b.WEB_EXTENSION_TAG),H=M.indexOf("web");return G?H===-1&&M.push("web"):H!==-1&&M.splice(H,1),M}function q(_,M){const G=(0,b.getFallbackTargetPlarforms)(M);for(let H=0;H<_.length;H++){const Z=_[H];if(Z.version===_[H-1]?.version){let oe=H;const X=B(Z);if(X===M)for(;oe>0&&_[oe-1].version===Z.version;)oe--;else if(G.includes(X))for(;oe>0&&_[oe-1].version===Z.version&&B(_[oe-1])!==M;)oe--;oe!==H&&(_.splice(H,1),_.splice(oe,0,Z))}}return _}e.sortExtensionVersions=q;function Y(_,M,G){_.telemetryData={index:M,querySource:G}}function ee(_,M,G){const H=_.versions[0],Z={manifest:F(M,s.Manifest),readme:F(M,s.Details),changelog:F(M,s.Changelog),license:F(M,s.License),repository:V(M),download:O(M),icon:F(M,s.Icon),signature:F(M,s.Signature),coreTranslations:A(M)};return{identifier:{id:(0,S.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:M.version,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,publisherDomain:_.publisher.domain?{link:_.publisher.domain,verified:!!_.publisher.isDomainVerified}:void 0,publisherSponsorLink:x(H),description:_.shortDescription||"",installCount:P(_.statistics,"install"),rating:P(_.statistics,"averagerating"),ratingCount:P(_.statistics,"ratingcount"),categories:_.categories||[],tags:_.tags||[],releaseDate:Date.parse(_.releaseDate),lastUpdated:Date.parse(_.lastUpdated),allTargetPlatforms:G,assets:Z,properties:{dependencies:N(M,r.Dependency),extensionPack:N(M,r.ExtensionPack),engine:L(M),localizedLanguages:$(M),targetPlatform:B(M),isPreReleaseVersion:U(M)},hasPreReleaseVersion:U(H),hasReleaseVersion:!0,preview:j(_.flags),isSigned:!!Z.signature}}let ce=class{constructor(M,G,H,Z,oe,X,ie,ne){this.requestService=G,this.logService=H,this.environmentService=Z,this.telemetryService=oe,this.fileService=X,this.productService=ie,this.configurationService=ne;const le=ie.extensionsGallery,ue=le?.servicePPEUrl&&ne.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=ue?le.servicePPEUrl:le?.serviceUrl,this.extensionsGallerySearchUrl=ue?void 0:le?.searchUrl,this.extensionsControlUrl=le?.controlUrl,this.commonHeadersPromise=(0,p.resolveMarketplaceHeaders)(ie.version,ie,this.environmentService,this.configurationService,this.fileService,M,this.telemetryService)}api(M=""){return`${this.extensionsGalleryUrl}${M}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(M,G,H){const Z=i.CancellationToken.isCancellationToken(G)?{}:G,oe=i.CancellationToken.isCancellationToken(G)?G:H,X=[],ie=[],ne=[],le=[];let ue=!0;for(const Ee of M){Ee.uuid?ie.push(Ee.uuid):X.push(Ee.id);const Ce=!!(Ee.version||Ee.preRelease);ne.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ce}),Ee.version&&le.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),ue=ue&&!!Ee.hasPreRelease&&!Ce}if(!ie.length&&!X.length)return[];let pe=new g().withPage(1,M.length);ie.length&&(pe=pe.withFilter(t.ExtensionId,...ie)),X.length&&(pe=pe.withFilter(t.ExtensionName,...X)),(Z.queryAllVersions||ue)&&(pe=pe.withFlags(pe.flags,n.IncludeVersions)),Z.source&&(pe=pe.withSource(Z.source));const{extensions:we}=await this.queryGalleryExtensions(pe,{targetPlatform:Z.targetPlatform??d,includePreRelease:ne,versions:le,compatible:!!Z.compatible},oe);return Z.source&&we.forEach((Ee,Ce)=>Y(Ee,Ce,Z.source)),we}async getCompatibleExtension(M,G,H){if((0,b.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,H))return null;if(await this.isExtensionCompatible(M,G,H))return M;const Z=new g().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,M.identifier.uuid),{extensions:oe}=await this.queryGalleryExtensions(Z,{targetPlatform:H,compatible:!0,includePreRelease:G},i.CancellationToken.None);return oe[0]||null}async isExtensionCompatible(M,G,H){if(!(0,b.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,H)||!G&&M.properties.isPreReleaseVersion)return!1;let Z=M.properties.engine;if(!Z){const oe=await this.getManifest(M,i.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");Z=oe.engines.vscode}return(0,m.isEngineValid)(Z,this.productService.version,this.productService.date)}async isValidVersion(M,G,H,Z,oe){if(!(0,b.isTargetPlatformCompatible)(B(M),Z,oe)||G!=="any"&&U(M)!==(G==="prerelease"))return!1;if(H)try{const X=await this.getEngine(M);if(!(0,m.isEngineValid)(X,this.productService.version,this.productService.date))return!1}catch(X){return this.logService.error(`Error while getting the engine for the version ${M.version}.`,(0,R.getErrorMessage)(X)),!1}return!0}async query(M,G){let H=M.text||"";const Z=M.pageSize??50;let oe=new g().withPage(1,Z);H?(H=H.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,pe,we)=>(oe=oe.withFilter(t.Category,we||pe),"")),H=H.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,pe,we)=>(oe=oe.withFilter(t.Tag,we||pe),"")),H=H.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(t.Featured),"")),H=H.trim(),H&&(H=H.length<200?H:H.substring(0,200),oe=oe.withFilter(t.SearchText,H)),oe=oe.withSortBy(0)):M.ids?oe=oe.withFilter(t.ExtensionId,...M.ids):M.names?oe=oe.withFilter(t.ExtensionName,...M.names):oe=oe.withSortBy(4),typeof M.sortBy=="number"&&(oe=oe.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(oe=oe.withSortOrder(M.sortOrder)),M.source&&(oe=oe.withSource(M.source));const X=async(ue,pe)=>{const{extensions:we,total:Ee}=await this.queryGalleryExtensions(ue,{targetPlatform:d,compatible:!1,includePreRelease:!!M.includePreRelease},pe);return we.forEach((Ce,Ae)=>Y(Ce,(ue.pageNumber-1)*ue.pageSize+Ae,M.source)),{extensions:we,total:Ee}},{extensions:ie,total:ne}=await X(oe,G),le=async(ue,pe)=>{if(pe.isCancellationRequested)throw new R.CancellationError;const{extensions:we}=await X(oe.withPage(ue+1),pe);return we};return{firstPage:ie,total:ne,pageSize:oe.pageSize,getPage:le}}async queryGalleryExtensions(M,G,H){const Z=M.flags;!!(M.flags&n.IncludeLatestVersionOnly)&&!!(M.flags&n.IncludeVersions)&&(M=M.withFlags(M.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(M.flags&n.IncludeLatestVersionOnly)&&!(M.flags&n.IncludeVersions)&&(M=M.withFlags(M.flags,n.IncludeLatestVersionOnly)),G.versions?.length&&(M=M.withFlags(M.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),M=M.withFlags(M.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:oe,total:X}=await this.queryRawGalleryExtensions(M,H);if(!(M.flags&n.IncludeLatestVersionOnly)){const ue=[];for(const pe of oe){const we=await this.toGalleryExtensionWithCriteria(pe,G);we&&ue.push(we)}return{extensions:ue,total:X}}const ne=[],le=new Map;for(let ue=0;ue<oe.length;ue++){const pe=oe[ue],we={id:(0,S.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},Ee=(0,I.isBoolean)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(Ae=>(0,S.areSameExtensions)(Ae,we))?.includePreRelease;if(G.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(W(pe),G.targetPlatform))continue;const Ce=await this.toGalleryExtensionWithCriteria(pe,G);!Ce||Ce.properties.isPreReleaseVersion&&(!Ee||!Ce.hasReleaseVersion)||!Ce.properties.isPreReleaseVersion&&Ce.properties.targetPlatform!==G.targetPlatform&&Ce.hasPreReleaseVersion?le.set(pe.extensionId,ue):ne.push([ue,Ce])}if(le.size){const ue=new Date().getTime(),pe=new g().withFlags(Z&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,le.size).withFilter(t.ExtensionId,...le.keys()),{extensions:we}=await this.queryGalleryExtensions(pe,G,H);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ue,count:le.size});for(const Ee of we){const Ce=le.get(Ee.identifier.uuid);ne.push([Ce,Ee])}}return{extensions:ne.sort((ue,pe)=>ue[0]-pe[0]).map(([,ue])=>ue),total:X}}async toGalleryExtensionWithCriteria(M,G){const H={id:(0,S.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},Z=G.versions?.find(ne=>(0,S.areSameExtensions)(ne,H))?.version,oe=(0,I.isBoolean)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(ne=>(0,S.areSameExtensions)(ne,H))?.includePreRelease,X=W(M),ie=q(M.versions,G.targetPlatform);if(G.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(X,G.targetPlatform))return null;for(let ne=0;ne<ie.length;ne++){const le=ie[ne];if(!(Z&&le.version!==Z)){if(await this.isValidVersion(le,oe?"any":"release",G.compatible,X,G.targetPlatform))return ee(M,le,X);if(Z&&le.version===Z)return null}}return Z||G.compatible?null:ee(M,M.versions[0],X)}async queryRawGalleryExtensions(M,G){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,o(n.Unpublished));const H=await this.commonHeadersPromise,Z=JSON.stringify(M.raw),oe={...H,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},X=new Date().getTime();let ie,ne,le=0;try{if(ie=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&M.criteria.some(pe=>pe.filterType===t.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:Z,headers:oe},G),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:le};const ue=await(0,u.asJson)(ie);if(ue){const pe=ue.results[0],we=pe.extensions,Ee=pe.resultMetadata&&pe.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return le=Ee&&Ee.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:le}}return{galleryExtensions:[],total:le}}catch(ue){throw ne=ue,ue}finally{this.telemetryService.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(Z.length),duration:new Date().getTime()-X,success:!!ie&&(0,u.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:ne?(0,R.isCancellationError)(ne)?"canceled":(0,R.getErrorMessage)(ne).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic(M,G,H,Z){if(!this.isEnabled())return;const oe=k.isWeb?this.api(`/itemName/${M}.${G}/version/${H}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${M}/extensions/${G}/${H}/stats?statType=${Z}`),X=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ne={...await this.commonHeadersPromise,Accept:X};try{await this.requestService.request({type:"POST",url:oe,headers:ne},i.CancellationToken.None)}catch{}}async download(M,G,H){this.logService.trace("ExtensionGalleryService#download",M.identifier.id);const Z=(0,S.getGalleryExtensionTelemetryData)(M),oe=new Date().getTime(),X=ue=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Z,duration:ue}),ie=H===2?"install":H===3?"update":"",ne=ie?{uri:`${M.assets.download.uri}${C.URI.parse(M.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${M.assets.download.fallbackUri}${C.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:M.assets.download,le=await this.getAsset(ne);await this.fileService.writeFile(G,le.stream),X(new Date().getTime()-oe)}async downloadSignatureArchive(M,G){if(!M.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const H=await this.getAsset(M.assets.signature);await this.fileService.writeFile(G,H.stream)}async getReadme(M,G){if(M.assets.readme){const H=await this.getAsset(M.assets.readme,{},G);return await(0,u.asTextOrError)(H)||""}return""}async getManifest(M,G){if(M.assets.manifest){const H=await this.getAsset(M.assets.manifest,{},G),Z=await(0,u.asTextOrError)(H);return Z?JSON.parse(Z):null}return null}async getManifestFromRawExtensionVersion(M,G){const H=F(M,s.Manifest);if(!H)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},oe=await this.getAsset(H,{headers:Z});return await(0,u.asJson)(oe)}async getCoreTranslation(M,G){const H=M.assets.coreTranslations.filter(Z=>Z[0]===G.toUpperCase())[0];if(H){const Z=await this.getAsset(H[1]),oe=await(0,u.asTextOrError)(Z);return oe?JSON.parse(oe):null}return null}async getChangelog(M,G){if(M.assets.changelog){const H=await this.getAsset(M.assets.changelog,{},G);return await(0,u.asTextOrError)(H)||""}return""}async getAllCompatibleVersions(M,G,H){let Z=new g().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?Z=Z.withFilter(t.ExtensionId,M.identifier.uuid):Z=Z.withFilter(t.ExtensionName,M.identifier.id);const{galleryExtensions:oe}=await this.queryRawGalleryExtensions(Z,i.CancellationToken.None);if(!oe.length)return[];const X=W(oe[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(X,H))return[];const ie=[];await Promise.all(oe[0].versions.map(async ue=>{try{await this.isValidVersion(ue,G?"any":"release",!0,X,H)&&ie.push(ue)}catch{}}));const ne=[],le=new Set;for(const ue of q(ie,H))le.has(ue.version)||(le.add(ue.version),ne.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:U(ue)}));return ne}async getAsset(M,G={},H=i.CancellationToken.None){const Z=await this.commonHeadersPromise,oe={type:"GET"},X={...Z,...G.headers||{}};G={...G,...oe,headers:X};const ie=M.uri,ne=M.fallbackUri,le={...G,url:ie};try{const ue=await this.requestService.request(le,H);if(ue.res.statusCode===200)return ue;const pe=await(0,u.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${pe}`)}catch(ue){if((0,R.isCancellationError)(ue))throw ue;const pe=(0,R.getErrorMessage)(ue);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:pe});const we={...G,url:ne};return this.requestService.request(we,H)}}async getEngine(M){let G=L(M);if(!G){const H=await this.getManifestFromRawExtensionVersion(M,i.CancellationToken.None);if(!H)throw new Error("Manifest was not found");G=H.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const M=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const G=await(0,u.asJson)(M),H=[],Z={};if(G){for(const oe of G.malicious)H.push({id:oe});if(G.migrateToPreRelease)for(const[oe,X]of Object.entries(G.migrateToPreRelease))(!X.engine||(0,m.isEngineValid)(X.engine,this.productService.version,this.productService.date))&&(Z[oe.toLowerCase()]={disallowInstall:!0,extension:{id:X.id,displayName:X.displayName,autoMigrate:{storage:!!X.migrateStorage},preRelease:!0}});if(G.deprecated)for(const[oe,X]of Object.entries(G.deprecated))X&&(Z[oe.toLowerCase()]=(0,I.isBoolean)(X)?{}:X)}return{malicious:H,deprecated:Z}}};ce=ve([K(1,u.IRequestService),K(2,v.ILogService),K(3,E.IEnvironmentService),K(4,h.ITelemetryService),K(5,f.IFileService),K(6,y.IProductService),K(7,w.IConfigurationService)],ce);let J=class extends ce{constructor(M,G,H,Z,oe,X,ie,ne){super(M,G,H,Z,oe,X,ie,ne)}};J=ve([K(0,c.IStorageService),K(1,u.IRequestService),K(2,v.ILogService),K(3,E.IEnvironmentService),K(4,h.ITelemetryService),K(5,f.IFileService),K(6,y.IProductService),K(7,w.IConfigurationService)],J),e.ExtensionGalleryService=J;let z=class extends ce{constructor(M,G,H,Z,oe,X,ie){super(void 0,M,G,H,Z,oe,X,ie)}};z=ve([K(0,u.IRequestService),K(1,v.ILogService),K(2,E.IEnvironmentService),K(3,h.ITelemetryService),K(4,f.IFileService),K(5,y.IProductService),K(6,w.IConfigurationService)],z),e.ExtensionGalleryServiceWithNoStorageService=z}),define(re[78],se([0,1,4,3,2,18,33,25,19,7,15]),function(Q,e,D,i,R,k,T,I,C,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let S=class Ze extends R.Disposable{static toKey(f){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static fromKey(f){const v=b.exec(f);if(v&&v[1])return{id:v[1],version:v[2]}}static async removeOutdatedExtensionVersions(f,v){const y=await f.getInstalled(),u=[];for(const[p,c]of Ze.readAllExtensionsWithKeysForSync(v)){const h=y.find(d=>(0,T.areSameExtensions)(d.identifier,{id:p}))?.manifest.version;for(const d of c)h!==d&&u.push(Ze.toKey({id:p,version:d}))}for(const p of u)v.remove(p,0)}static readAllExtensionsWithKeysForSync(f){const v=new Map,y=f.keys(0,1);for(const u of y){const p=Ze.fromKey(u);if(p){let c=v.get(p.id.toLowerCase());c||v.set(p.id.toLowerCase(),c=[]),c.push(p.version)}}return v}constructor(f,v,y){super(),this.storageService=f,this.productService=v,this.logService=y,this._onDidChangeExtensionStorageToSync=this._register(new i.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Ze.readAllExtensionsWithKeysForSync(f),this._register(this.storageService.onDidChangeValue(u=>this.onDidChangeStorageValue(u)))}onDidChangeStorageValue(f){if(f.scope!==0)return;if(this.extensionsWithKeysForSync.has(f.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const v=Ze.fromKey(f.key);if(v){if(this.storageService.get(f.key,0)===void 0)this.extensionsWithKeysForSync.delete(v.id.toLowerCase());else{let y=this.extensionsWithKeysForSync.get(v.id.toLowerCase());y||this.extensionsWithKeysForSync.set(v.id.toLowerCase(),y=[]),y.push(v.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(f){if((0,E.isString)(f))return f;const v=f.manifest?f.manifest.publisher:f.publisher,y=f.manifest?f.manifest.name:f.name;return(0,T.getExtensionId)(v,y)}getExtensionState(f,v){const y=this.getExtensionId(f),u=this.storageService.get(y,v?0:1);if(u)try{return JSON.parse(u)}catch(p){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${v}): ${p}`)}}setExtensionState(f,v,y){const u=this.getExtensionId(f);v===void 0?this.storageService.remove(u,y?0:1):this.storageService.store(u,JSON.stringify(v),y?0:1,1)}setKeysForSync(f,v){this.storageService.store(Ze.toKey(f),JSON.stringify(v),0,1)}getKeysForSync(f){const v=this.productService.extensionSyncedKeys?.[f.id.toLowerCase()],y=this.storageService.get(Ze.toKey(f),0),u=y?JSON.parse(y):void 0;return u&&v?(0,C.distinct)([...u,...v]):u||v}addToMigrationList(f,v){if(f!==v){const y=this.migrationList.filter(u=>!u.includes(f)&&!u.includes(v));y.push([f,v]),this.migrationList=y}}getSourceExtensionToMigrate(f){const v=this.migrationList.find(([,y])=>f===y);return v?v[0]:void 0}get migrationList(){const f=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const v=JSON.parse(f);if(Array.isArray(v))return v}catch{}return[]}set migrationList(f){f.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(f),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};S=ve([K(0,k.IStorageService),K(1,I.IProductService),K(2,w.ILogService)],S),e.ExtensionStorageService=S}),define(re[266],se([0,1,19,6,3,12,5,36,8,159,13,29,33,226,98,14,7,58,25,47,18,24]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u,p,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const n="extensionTips/promptedExecutableTips",o="extensionTips/lastPromptedMediumImpExeTime";let t=class extends m.ExtensionTipsService{constructor(r,l,a,g,P,A,V,O,F,N){super(V,O,F,N),this.environmentService=r,this.telemetryService=l,this.extensionManagementService=a,this.storageService=g,this.nativeHostService=P,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&Object.entries(O.exeBasedExtensionTips).forEach(([L,U])=>{const $=[],x=[],j=[];Object.entries(U.recommendations).forEach(([B,W])=>{W.important?U.important?$.push({extensionId:B,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):x.push({extensionId:B,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):j.push({extensionId:B,extensionName:W.name,isExtensionPack:!!W.isExtensionPack})}),$.length&&this.highImportanceExecutableTips.set(L,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:$}),x.length&&this.mediumImportanceExecutableTips.set(L,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:x}),j.length&&this.allOtherExecutableTips.set(L,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:j})}),(0,i.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const r=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...r,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const r=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),a=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(r,a),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,a)}groupImportantTipsByExe(r,l){const a=new Map;r.forEach(O=>a.set(O.extensionId.toLowerCase(),O));const{installed:g,uninstalled:P}=this.groupByInstalled([...a.keys()],l);for(const O of g){const F=a.get(O);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:F.exeName})}for(const O of P){const F=a.get(O);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:F.exeName})}const A=this.getPromptedExecutableTips(),V=new Map;for(const O of P){const F=a.get(O);if(F&&(!A[F.exeName]||!A[F.exeName].includes(F.extensionId))){let N=V.get(F.exeName);N||(N=[],V.set(F.exeName,N)),N.push(F)}}return V}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[r,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(a=>{switch(a){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(r);break;case"incompatibleWindow":{const g=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const g=this._register((0,i.disposableTimeout)(()=>{g.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const r=this.getLastPromptedMediumExeTime(),l=Date.now()-r,a=7*24*60*60*1e3;if(l<a){const A=this._register((0,i.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},a-l));return}const[g,P]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(P).then(A=>{switch(A){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(P[0].exeName,P);const V=this._register((0,i.disposableTimeout)(()=>{V.dispose(),this.promptMediumImportanceExeBasedTip()},a));break}case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const V=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(V(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const V=this._register((0,i.disposableTimeout)(()=>{V.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(r){const l=await this.extensionManagementService.getInstalled(1),a=r.filter(P=>!P.whenNotInstalled||P.whenNotInstalled.every(A=>l.every(V=>!(0,S.areSameExtensions)(V.identifier,{id:A})))).map(({extensionId:P})=>P.toLowerCase()),g=(0,w.localize)(0,null,r[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(a,g,`@exe:"${r[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let r=this.storageService.getNumber(o,-1);return r||(r=Date.now(),this.updateLastPromptedMediumExeTime(r)),r}updateLastPromptedMediumExeTime(r){this.storageService.store(o,r,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(n,-1,"{}"))}addToRecommendedExecutables(r,l){const a=this.getPromptedExecutableTips();a[r]=l.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(n,JSON.stringify(a),-1,0)}groupByInstalled(r,l){const a=[],g=[],P=l.reduce((A,V)=>(A.add(V.identifier.id.toLowerCase()),A),new Set);return r.forEach(A=>{P.has(A.toLowerCase())?a.push(A):g.push(A)}),{installed:a,uninstalled:g}}async getValidExecutableBasedExtensionTips(r){const l=[],a=new Map;for(const g of r.keys()){const P=r.get(g);if(!P||!(0,D.isNonEmptyArray)(P.recommendations))continue;const A=[];T.isWindows?P.windowsPath&&A.push(P.windowsPath.replace("%USERPROFILE%",I.env.USERPROFILE).replace("%ProgramFiles(x86)%",I.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",I.env.ProgramFiles).replace("%APPDATA%",I.env.APPDATA).replace("%WINDIR%",I.env.WINDIR)):(A.push((0,k.join)("/usr/local/bin",g)),A.push((0,k.join)("/usr/bin",g)),A.push((0,k.join)(this.environmentService.userHome.fsPath,g)));for(const V of A){let O=a.get(V);if(O===void 0&&(O=await this.fileService.exists(C.URI.file(V)),a.set(V,O)),O)for(const{extensionId:F,extensionName:N,isExtensionPack:L,whenNotInstalled:U}of P.recommendations)l.push({extensionId:F,extensionName:N,isExtensionPack:L,exeName:g,exeFriendlyName:P.exeFriendlyName,windowsPath:P.windowsPath,whenNotInstalled:U})}}return l}};t=ve([K(0,E.INativeEnvironmentService),K(1,d.ITelemetryService),K(2,b.IExtensionManagementService),K(3,h.IStorageService),K(4,u.INativeHostService),K(5,f.IExtensionRecommendationNotificationService),K(6,v.IFileService),K(7,p.IProductService),K(8,c.IRequestService),K(9,y.ILogService)],t),e.ExtensionTipsService=t}),define(re[267],se([0,1,6,2,20,69,18,74,21]),function(Q,e,D,i,R,k,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class w extends T.AbstractStorageService{constructor(b,S,m,f){super(),this.initialWorkspace=b,this.initialProfiles=S,this.mainProcessService=m,this.environmentService=f,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new i.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new i.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const b=this._register(new I.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),S=this._register(new k.Storage(b));return this._register(S.onDidChangeStorage(m=>this.emitDidChangeValue(-1,m))),S}createProfileStorage(b){this.profileStorageDisposables.clear(),this.profileStorageProfile=b;let S;if((0,T.isProfileUsingDefaultStorage)(b))S=this.applicationStorage;else{const m=this.profileStorageDisposables.add(new I.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),b));S=this.profileStorageDisposables.add(new k.Storage(m))}return this.profileStorageDisposables.add(S.onDidChangeStorage(m=>this.emitDidChangeValue(0,m))),S}createWorkspaceStorage(b){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=b?.id;let S;if(b){const m=this.workspaceStorageDisposables.add(new I.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),b));S=this.workspaceStorageDisposables.add(new k.Storage(m)),this.workspaceStorageDisposables.add(S.onDidChangeStorage(f=>this.emitDidChangeValue(1,f)))}return S}async doInitialize(){await D.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(b){switch(b){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(b){switch(b){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,R.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(T.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(b,S){if(!this.canSwitchProfile(this.profileStorageProfile,b))return;const m=this.profileStorage,f=m.items;m!==this.applicationStorage&&await m.close(),this.profileStorage=this.createProfileStorage(b),await this.profileStorage.init(),this.switchData(f,this.profileStorage,0,S)}async switchToWorkspace(b,S){const m=this.workspaceStorage,f=m?.items??new Map;await m?.close(),this.workspaceStorage=this.createWorkspaceStorage(b),await this.workspaceStorage.init(),this.switchData(f,this.workspaceStorage,1,S)}hasScope(b){return(0,C.isUserDataProfile)(b)?this.profileStorageProfile.id===b.id:this.workspaceStorageId===b.id}}e.NativeStorageService=w}),define(re[268],se([0,1,3,2,20,13,57,21]),function(Q,e,D,i,R,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let C=class extends i.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(E,b,S){super(),this._profiles=[],this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this.channel=b.getChannel("userDataProfiles"),this.profilesHome=(0,R.joinPath)(S.userRoamingDataHome,"profiles"),this._profiles=E.map(m=>(0,I.reviveProfile)(m,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(m=>{const f=m.added.map(u=>(0,I.reviveProfile)(u,this.profilesHome.scheme)),v=m.removed.map(u=>(0,I.reviveProfile)(u,this.profilesHome.scheme)),y=m.updated.map(u=>(0,I.reviveProfile)(u,this.profilesHome.scheme));this._profiles=m.all.map(u=>(0,I.reviveProfile)(u,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:f,removed:v,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(E){this.enabled=E}isEnabled(){return this.enabled}async createNamedProfile(E,b,S){const m=await this.channel.call("createNamedProfile",[E,b,S]);return(0,I.reviveProfile)(m,this.profilesHome.scheme)}async createProfile(E,b,S,m){const f=await this.channel.call("createProfile",[E,b,S,m]);return(0,I.reviveProfile)(f,this.profilesHome.scheme)}async createTransientProfile(E){const b=await this.channel.call("createTransientProfile",[E]);return(0,I.reviveProfile)(b,this.profilesHome.scheme)}async setProfileForWorkspace(E,b){await this.channel.call("setProfileForWorkspace",[E,b])}removeProfile(E){return this.channel.call("removeProfile",[E])}async updateProfile(E,b){const S=await this.channel.call("updateProfile",[E,b]);return(0,I.reviveProfile)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}};C=ve([K(1,T.IMainProcessService),K(2,k.IEnvironmentService)],C),e.UserDataProfilesNativeService=C}),define(re[40],se([0,1,19,6,17,22,3,35,2,27,15,175,16,13,14,7,44,18,24,32,26,21]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u,p,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=void 0;function n(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=n;function o(a,g){return`${(0,w.uppercaseFirstLetter)(a)}${g.isDefault?"":` (${g.name})`}`}e.getSyncResourceLogLabel=o;let t=class extends C.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(g,P,A,V,O,F,N,L,U,$,x,j){super(),this.syncResource=g,this.collection=P,this.fileService=A,this.environmentService=V,this.userDataSyncStoreService=F,this.userDataSyncBackupStoreService=N,this.userDataSyncEnablementService=L,this.telemetryService=U,this.logService=$,this.configurationService=x,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new i.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=o(g.syncResource,g.profile),this.extUri=j.extUri,this.syncFolder=this.extUri.joinPath(V.userDataSyncHome,...(0,h.getPathSegments)(g.profile.isDefault?void 0:g.profile.id,g.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,h.PREVIEW_DIR_NAME),this.lastSyncResource=(0,h.getLastSyncResourceUri)(g.profile.isDefault?void 0:g.profile.id,g.syncResource,V,this.extUri),this.currentMachineIdPromise=(0,y.getServiceMachineId)(V,A,O)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const g=await this.syncPreviewPromise;this.syncPreviewPromise=null;const P=await this.performSync(g.remoteUserData,g.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(P)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const g=await this.getLastSyncUserData();(g?await this.hasRemoteChanged(g):!0)&&this._onDidChangeLocal.fire()}}setStatus(g){this._status!==g&&(this._status=g,this._onDidChangStatus.fire(g))}async sync(g,P={}){await this._sync(g,!0,this.getUserDataSyncConfiguration(),P)}async preview(g,P,A={}){return this._sync(g,!1,P,A)}async apply(g,P={}){try{this.syncHeaders={...P};const A=await this.doApply(g);return this.setStatus(A),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(g,P,A,V){try{if(this.syncHeaders={...V},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let O="idle";try{const F=await this.getLastSyncUserData(),N=await this.getLatestRemoteUserData(g,F);return O=await this.performSync(N,F,P,A),O==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(O)}}finally{this.syncHeaders={}}}async replace(g){const P=this.parseSyncData(g);if(!P)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const A=await this.getLastSyncUserData(),V=await this.getLatestRemoteUserData(null,A),O=await this.isRemoteDataFromCurrentMachine(V),F=await this.generateSyncPreview({ref:V.ref,syncData:P},A,O,this.getUserDataSyncConfiguration(),k.CancellationToken.None),N=[];for(const L of F){const U=await this.getAcceptResult(L,L.remoteResource,void 0,k.CancellationToken.None),{remoteChange:$}=await this.getAcceptResult(L,L.previewResource,L.remoteContent,k.CancellationToken.None);N.push([L,{...U,remoteChange:$!==0?$:2}])}await this.applyResult(V,A,N,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(g){const P=await this.currentMachineIdPromise;return!!g.syncData?.machineId&&g.syncData.machineId===P}async getLatestRemoteUserData(g,P){if(P){const A=g?g[this.resource]:void 0;if(P.ref===A||A===void 0&&P.syncData===null)return P}return this.getRemoteUserData(P)}async performSync(g,P,A,V){if(g.syncData&&g.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new h.UserDataSyncError((0,b.localize)(0,null,this.resource,this.version,g.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(g,P,A,V)}catch(O){if(O instanceof h.UserDataSyncError)switch(O.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(g,P,A,V);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),g=await this.getRemoteUserData(null),P=await this.getLastSyncUserData(),this.performSync(g,P,A,V)}throw O}}async doSync(g,P,A,V){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,i.createCancelablePromise)(F=>this.doGenerateSyncResourcePreview(g,P,A,V,F)));const O=await this.syncPreviewPromise;return this.updateConflicts(O.resourcePreviews),O.resourcePreviews.some(({mergeState:F})=>F==="conflict")?"hasConflicts":A?await this.doApply(!1):"syncing"}catch(O){throw this.syncPreviewPromise=null,O}}async merge(g){return await this.updateSyncResourcePreview(g,async P=>{const A=await this.getMergeResult(P,k.CancellationToken.None);await this.fileService.writeFile(P.previewResource,R.VSBuffer.fromString(A?.content||""));const V=A&&!A.hasConflicts?await this.getAcceptResult(P,P.previewResource,void 0,k.CancellationToken.None):void 0;return P.acceptResult=V,P.mergeState=A.hasConflicts?"conflict":V?"accepted":"preview",P.localChange=V?V.localChange:A.localChange,P.remoteChange=V?V.remoteChange:A.remoteChange,P}),this.syncPreviewPromise}async accept(g,P){return await this.updateSyncResourcePreview(g,async A=>{const V=await this.getAcceptResult(A,g,P,k.CancellationToken.None);return A.acceptResult=V,A.mergeState="accepted",A.localChange=V.localChange,A.remoteChange=V.remoteChange,A}),this.syncPreviewPromise}async discard(g){return await this.updateSyncResourcePreview(g,async P=>{const A=await this.getMergeResult(P,k.CancellationToken.None);return await this.fileService.writeFile(P.previewResource,R.VSBuffer.fromString(A.content||"")),P.acceptResult=void 0,P.mergeState="preview",P.localChange=A.localChange,P.remoteChange=A.remoteChange,P}),this.syncPreviewPromise}async updateSyncResourcePreview(g,P){if(!this.syncPreviewPromise)return;let A=await this.syncPreviewPromise;const V=A.resourcePreviews.findIndex(({localResource:O,remoteResource:F,previewResource:N})=>this.extUri.isEqual(O,g)||this.extUri.isEqual(F,g)||this.extUri.isEqual(N,g));V!==-1&&(this.syncPreviewPromise=(0,i.createCancelablePromise)(async O=>{const F=[...A.resourcePreviews];return F[V]=await P(F[V]),{...A,resourcePreviews:F}}),A=await this.syncPreviewPromise,this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(g){if(!this.syncPreviewPromise)return"idle";const P=await this.syncPreviewPromise;return P.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":P.resourcePreviews.some(({mergeState:A})=>A!=="accepted")?"syncing":(await this.applyResult(P.remoteUserData,P.lastSyncUserData,P.resourcePreviews.map(A=>[A,A.acceptResult]),g),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(g){const P=g.filter(({mergeState:A})=>A==="conflict");(0,D.equals)(this._conflicts,P,(A,V)=>this.extUri.isEqual(A.previewResource,V.previewResource))||(this._conflicts=P,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const g=await this.getLastSyncUserData();return!!g&&g.syncData!==null}async resolvePreviewContent(g){const P=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(P)for(const A of P.resourcePreviews){if(this.extUri.isEqual(A.acceptedResource,g))return A.acceptResult?A.acceptResult.content:null;if(this.extUri.isEqual(A.remoteResource,g))return A.remoteContent;if(this.extUri.isEqual(A.localResource,g))return A.localContent;if(this.extUri.isEqual(A.baseResource,g))return A.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(g,P,A,V,O){const F=await this.isRemoteDataFromCurrentMachine(g),N=await this.generateSyncPreview(g,P,F,V,O),L=[];for(const U of N){const $=U.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(U.localChange===0&&U.remoteChange===0)L.push({...U,acceptedResource:$,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=A?await this.getMergeResult(U,O):void 0;if(O.isCancellationRequested)break;await this.fileService.writeFile(U.previewResource,R.VSBuffer.fromString(x?.content||""));const j=x&&!x.hasConflicts?await this.getAcceptResult(U,U.previewResource,void 0,O):void 0;L.push({...U,acceptResult:j,mergeState:x?.hasConflicts?"conflict":j?"accepted":"preview",localChange:j?j.localChange:x?x.localChange:U.localChange,remoteChange:j?j.remoteChange:x?x.remoteChange:U.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:g,lastSyncUserData:P,resourcePreviews:L,isLastSyncFromCurrentMachine:F}}async getLastSyncUserData(){try{const g=await this.fileService.readFile(this.lastSyncResource),P=JSON.parse(g.value.toString()),A=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=P.version&&A&&P.version!==A,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${P.version} is not compatible with current sync state version ${A}.`),await this.resetLocal(),null;const V=P;if(V.content===null)return{ref:P.ref,syncData:null};const O=JSON.parse(V.content);if(n(O))return{...P,syncData:O,content:void 0}}catch(g){g instanceof f.FileOperationError&&g.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Not synced yet. Last sync resource does not exist.`):this.logService.error(g)}return null}async updateLastSyncUserData(g,P={}){if(P.ref||P.content||P.version)throw new Error("Cannot have core properties as additional");const A=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),V={ref:g.ref,content:g.syncData?JSON.stringify(g.syncData):null,version:A,...P};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(V)))}async getRemoteUserData(g){const{ref:P,content:A}=await this.getUserData(g);let V=null;return A!==null&&(V=this.parseSyncData(A)),{ref:P,syncData:V}}parseSyncData(g){try{const P=JSON.parse(g);if(n(P))return P}catch(P){this.logService.error(P)}throw new h.UserDataSyncError((0,b.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(g){const P=g?{ref:g.ref,content:g.syncData?JSON.stringify(g.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,P,this.collection,this.syncHeaders)}async updateRemoteUserData(g,P){const A=await this.currentMachineIdPromise,V={version:this.version,machineId:A,content:g};try{return P=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(V),P,this.collection,this.syncHeaders),{ref:P,syncData:V}}catch(O){throw O instanceof h.UserDataSyncError&&O.code==="TooLarge"&&(O=new h.UserDataSyncError(O.message,O.code,this.resource)),O}}async backupLocal(g){const P={version:this.version,content:g};return this.userDataSyncBackupStoreService.backup(this.syncResource.profile,this.resource,JSON.stringify(P))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(h.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=ve([K(2,f.IFileService),K(3,m.IEnvironmentService),K(4,u.IStorageService),K(5,h.IUserDataSyncStoreService),K(6,h.IUserDataSyncBackupStoreService),K(7,h.IUserDataSyncEnablementService),K(8,p.ITelemetryService),K(9,h.IUserDataSyncLogService),K(10,S.IConfigurationService),K(11,c.IUriIdentityService)],t),e.AbstractSynchroniser=t;let s=class extends t{constructor(g,P,A,V,O,F,N,L,U,$,x,j,B){super(P,A,V,O,F,N,L,U,$,x,j,B),this.file=g,this._register(this.fileService.watch(this.extUri.dirname(g))),this._register(this.fileService.onDidFilesChange(W=>this.onFileChanges(W)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(g,P,A){try{P?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(g),A?void 0:P):await this.fileService.createFile(this.file,R.VSBuffer.fromString(g),{overwrite:A})}catch(V){throw V instanceof f.FileOperationError&&V.fileOperationResult===1||V instanceof f.FileOperationError&&V.fileOperationResult===3?new h.UserDataSyncError(V.message,"LocalPreconditionFailed"):V}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(g){if(!(g instanceof f.FileOperationError&&g.fileOperationResult===1))throw g}}onFileChanges(g){!g.contains(this.file)||this.triggerLocalChange()}};s=ve([K(3,f.IFileService),K(4,m.IEnvironmentService),K(5,u.IStorageService),K(6,h.IUserDataSyncStoreService),K(7,h.IUserDataSyncBackupStoreService),K(8,h.IUserDataSyncEnablementService),K(9,p.ITelemetryService),K(10,h.IUserDataSyncLogService),K(11,S.IConfigurationService),K(12,c.IUriIdentityService)],s),e.AbstractFileSynchroniser=s;let r=class extends s{constructor(g,P,A,V,O,F,N,L,U,$,x,j,B,W){super(g,P,A,V,O,F,N,L,U,$,x,B,W),this.userDataSyncUtilService=j,this._formattingOptions=void 0}hasErrors(g,P){const A=[],V=(0,I.parse)(g,A,{allowEmptyContent:!0,allowTrailingComma:!0});return A.length>0||!(0,E.isUndefined)(V)&&P!==Array.isArray(V)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};r=ve([K(3,f.IFileService),K(4,m.IEnvironmentService),K(5,u.IStorageService),K(6,h.IUserDataSyncStoreService),K(7,h.IUserDataSyncBackupStoreService),K(8,h.IUserDataSyncEnablementService),K(9,p.ITelemetryService),K(10,h.IUserDataSyncLogService),K(11,h.IUserDataSyncUtilService),K(12,S.IConfigurationService),K(13,c.IUriIdentityService)],r),e.AbstractJsonFileSynchroniser=r;let l=class{constructor(g,P,A,V,O,F){this.resource=g,this.userDataProfilesService=P,this.environmentService=A,this.logService=V,this.fileService=O,this.extUri=F.extUri,this.lastSyncResource=(0,h.getLastSyncResourceUri)(void 0,this.resource,A,this.extUri)}async initialize({ref:g,content:P}){if(!P){this.logService.info("Remote content does not exist.",this.resource);return}const A=this.parseSyncData(P);if(!!A)try{await this.doInitialize({ref:g,syncData:A})}catch(V){this.logService.error(V)}}parseSyncData(g){try{const P=JSON.parse(g);if(n(P))return P}catch(P){this.logService.error(P)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(g,P={}){const A={ref:g.ref,content:g.syncData?JSON.stringify(g.syncData):null,...P};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(A)))}};l=ve([K(1,d.IUserDataProfilesService),K(2,m.IEnvironmentService),K(3,v.ILogService),K(4,f.IFileService),K(5,c.IUriIdentityService)],l),e.AbstractInitializer=l}),define(re[118],se([0,1,19,17,3,35,5,15,176,16,13,14,18,24,32,21,40,253,26]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function c(n,o,t){try{const s=JSON.parse(n);if(!o)return(0,I.isUndefined)(s.all)?null:s.all;switch(T.OS){case 2:return(0,I.isUndefined)(s.mac)?null:s.mac;case 3:return(0,I.isUndefined)(s.linux)?null:s.linux;case 1:return(0,I.isUndefined)(s.windows)?null:s.windows}}catch(s){return t.error(s),null}}e.getKeybindingsContentFromSyncContent=c;let h=class extends y.AbstractJsonFileSynchroniser{constructor(o,t,s,r,l,a,g,P,A,V,O,F,N){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},t,P,A,V,s,r,g,F,l,O,a,N),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(a.onDidChangeConfiguration,L=>L.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,t,s,r){const l=o.syncData?c(o.syncData.content,r.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&s?o:t;const a=t?this.getKeybindingsContentFromLastSyncUserData(t):null,g=await this.getLocalFileContent(),P=await this.getFormattingOptions();let A=null,V=!1,O=!1,F=!1;if(l){let U=g?g.value.toString():"[]";if(U=U||"[]",this.hasErrors(U,!0))throw new p.UserDataSyncError((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==U||a!==l){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const $=await(0,u.merge)(U,l,a,P,this.userDataSyncUtilService);$.hasChanges&&(A=$.mergeContent,F=$.hasConflicts,V=F||$.mergeContent!==U,O=F||$.mergeContent!==l)}}else g&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),A=g.value.toString(),O=!0);const N={content:F?a:A,localChange:V?g?2:1:0,remoteChange:O?2:0,hasConflicts:F},L=g?g.value.toString():null;return[{fileContent:g,baseResource:this.baseResource,baseContent:a,localResource:this.localResource,localContent:L,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:l,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const t=this.getKeybindingsContentFromLastSyncUserData(o);if(t===null)return!0;const s=await this.getLocalFileContent(),r=s?s.value.toString():"",l=await this.getFormattingOptions(),a=await(0,u.merge)(r||"[]",t,t,l,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==t}async getMergeResult(o,t){return o.previewResult}async getAcceptResult(o,t,s,r){if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,s,r){const{fileContent:l}=s[0][0];let{content:a,localChange:g,remoteChange:P}=s[0][1];if(g===0&&P===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new p.UserDataSyncError((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(g!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),l&&await this.backupLocal(this.toSyncContent(l.value.toString())),await this.updateLocalFileContent(a||"[]",l,r),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),P!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const A=this.toSyncContent(a||"[]",o.syncData?.content);o=await this.updateRemoteUserData(A,r?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=(0,k.parse)(o.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.baseResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)?this.resolvePreviewContent(o):null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:c(o.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(o,t){let s={};try{s=JSON.parse(t||"{}")}catch(r){this.logService.error(r)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=o,T.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(p.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};h=ve([K(2,p.IUserDataSyncStoreService),K(3,p.IUserDataSyncBackupStoreService),K(4,p.IUserDataSyncLogService),K(5,w.IConfigurationService),K(6,p.IUserDataSyncEnablementService),K(7,b.IFileService),K(8,E.IEnvironmentService),K(9,S.IStorageService),K(10,p.IUserDataSyncUtilService),K(11,m.ITelemetryService),K(12,f.IUriIdentityService)],h),e.KeybindingsSynchroniser=h;let d=class extends y.AbstractInitializer{constructor(o,t,s,r,l){super("keybindings",t,s,r,o,l)}async doInitialize(o){const t=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,i.VSBuffer.fromString(t)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,k.parse)(o.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return c(o,!0,this.logService)}catch(t){return this.logService.error(t),null}}};d=ve([K(0,b.IFileService),K(1,v.IUserDataProfilesService),K(2,E.IEnvironmentService),K(3,p.IUserDataSyncLogService),K(4,f.IUriIdentityService)],d),e.KeybindingsInitializer=d}),define(re[119],se([0,1,17,3,177,16,73,13,29,14,18,24,32,21,40,61,257,26]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function p(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function c(n){const o=JSON.parse(n);return p(o)?o:{settings:n}}e.parseSettingsSyncContent=c;let h=class extends f.AbstractJsonFileSynchroniser{constructor(o,t,s,r,l,a,g,P,A,V,O,F,N,L){super(o.settingsResource,{syncResource:"settings",profile:o},t,s,r,l,a,g,O,F,P,A,V,L),this.extensionManagementService=N,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(o){const t=await this.getLastSyncUserData(),s=await this.getLatestRemoteUserData(o,t),r=this.getSettingsSyncContent(s),l=new T.ConfigurationModelParser(u.USER_DATA_SYNC_CONFIGURATION_SCOPE);return r?.settings&&l.parse(r.settings),l.configurationModel.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(o,t,s){const r=await this.getLocalFileContent(),l=await this.getFormattingOptions(),a=this.getSettingsSyncContent(o);t=t===null&&s?o:t;const g=t?this.getSettingsSyncContent(t):null,P=await this.getIgnoredSettings();let A=null,V=!1,O=!1,F=!1;if(a){let $=r?r.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const x=(0,y.merge)($,a.settings,g?g.settings:null,P,[],l);A=x.localContent||x.remoteContent,V=x.localContent!==null,O=x.remoteContent!==null,F=x.hasConflicts}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),A=r.value.toString().trim()||"{}",this.validateContent(A),O=!0);const N=r?r.value.toString():null,L=g?.settings??null,U={content:F?L:A,localChange:V?2:0,remoteChange:O?2:0,hasConflicts:F};return[{fileContent:r,baseResource:this.baseResource,baseContent:L,localResource:this.localResource,localContent:N,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const t=this.getSettingsSyncContent(o);if(t===null)return!0;const s=await this.getLocalFileContent(),r=s?s.value.toString().trim():"",l=await this.getIgnoredSettings(),a=await this.getFormattingOptions();return(0,y.merge)(r||"{}",t.settings,t.settings,l,[],a).remoteContent!==null}async getMergeResult(o,t){const s=await this.getFormattingOptions(),r=await this.getIgnoredSettings();return{...o.previewResult,content:o.previewResult.content?(0,y.updateIgnoredSettings)(o.previewResult.content,"{}",r,s):null}}async getAcceptResult(o,t,s,r){const l=await this.getFormattingOptions(),a=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?(0,y.updateIgnoredSettings)(o.fileContent.value.toString(),"{}",a,l):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent!==null?(0,y.updateIgnoredSettings)(o.remoteContent,o.fileContent?o.fileContent.value.toString():"{}",a,l):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s!==null?(0,y.updateIgnoredSettings)(s,o.fileContent?o.fileContent.value.toString():"{}",a,l):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,s,r){const{fileContent:l}=s[0][0];let{content:a,localChange:g,remoteChange:P}=s[0][1];if(g===0&&P===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.validateContent(a),g!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),l&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(l.value.toString()))),await this.updateLocalFileContent(a,l,r),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),P!==0){const A=await this.getFormattingOptions(),V=this.getSettingsSyncContent(o),O=await this.getIgnoredSettings(a);a=(0,y.updateIgnoredSettings)(a,V?V.settings:"{}",O,A),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),o=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(a)),r?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(o),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=await this.getFormattingOptions(),s=(0,v.edit)(o.value.toString(),[u.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,y.isEmpty)(s)}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)||this.extUri.isEqual(this.baseResource,o)?this.resolvePreviewContent(o):null}async resolvePreviewContent(o){let t=await super.resolvePreviewContent(o);if(t){const s=await this.getFormattingOptions(),r=await this.getIgnoredSettings();t=(0,y.updateIgnoredSettings)(t,"{}",r,s)}return t}getSettingsSyncContent(o){return o.syncData?this.parseSettingsSyncContent(o.syncData.content):null}parseSettingsSyncContent(o){try{return c(o)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(o){return{settings:o}}async getIgnoredSettings(o){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const s=i.Event.any(i.Event.filter(this.extensionManagementService.onDidInstallExtensions,r=>r.some(({local:l})=>!!l)),i.Event.filter(this.extensionManagementService.onDidUninstallExtension,r=>!r.error))(()=>{s.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,y.getIgnoredSettings)(t,this.configurationService,o)}validateContent(o){if(this.hasErrors(o,!1))throw new u.UserDataSyncError((0,R.localize)(0,null),"LocalInvalidContent",this.resource)}};h=ve([K(2,w.IFileService),K(3,I.IEnvironmentService),K(4,E.IStorageService),K(5,u.IUserDataSyncStoreService),K(6,u.IUserDataSyncBackupStoreService),K(7,u.IUserDataSyncLogService),K(8,u.IUserDataSyncUtilService),K(9,k.IConfigurationService),K(10,u.IUserDataSyncEnablementService),K(11,b.ITelemetryService),K(12,C.IExtensionManagementService),K(13,S.IUriIdentityService)],h),e.SettingsSynchroniser=h;let d=class extends f.AbstractInitializer{constructor(o,t,s,r,l){super("settings",t,s,r,o,l)}async doInitialize(o){const t=o.syncData?this.parseSettingsSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,D.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,y.isEmpty)(o.value.toString().trim())}catch(o){return o.fileOperationResult===1}}parseSettingsSyncContent(o){try{return c(o)}catch(t){this.logService.error(t)}return null}};d=ve([K(0,w.IFileService),K(1,m.IUserDataProfilesService),K(2,I.IEnvironmentService),K(3,u.IUserDataSyncLogService),K(4,S.IUriIdentityService)],d),e.SettingsInitializer=d}),define(re[120],se([0,1,17,3,31,16,13,14,18,24,32,21,40,254,26]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function v(p){return JSON.parse(p.content)}e.parseSnippets=v;let y=class extends S.AbstractSynchroniser{constructor(c,h,d,n,o,t,s,r,l,a,g,P){super({syncResource:"snippets",profile:c},h,n,d,o,t,s,a,g,r,l,P),this.version=1,this.snippetsFolder=c.snippetsHome,this._register(this.fileService.watch(d.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(i.Event.filter(this.fileService.onDidFilesChange,A=>A.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(c,h,d){const n=await this.getSnippetsFileContents(),o=this.toSnippetsContents(n),t=c.syncData?this.parseSnippets(c.syncData):null;h=h===null&&d?c:h;const s=h&&h.syncData?this.parseSnippets(h.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const r=(0,m.merge)(o,t,s);return this.getResourcePreviews(r,n,t||{},s||{})}async hasRemoteChanged(c){const h=c.syncData?this.parseSnippets(c.syncData):null;if(h===null)return!0;const d=await this.getSnippetsFileContents(),n=this.toSnippetsContents(d),o=(0,m.merge)(n,h,h);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async getMergeResult(c,h){return c.previewResult}async getAcceptResult(c,h,d,n){if(this.extUri.isEqualOrParent(h,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:c.fileContent?c.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(h,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:c.remoteContent,localChange:c.remoteContent!==null?c.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(h,this.syncPreviewFolder))return d===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:d,localChange:d===null?c.fileContent!==null?3:0:2,remoteChange:d===null?c.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${h.toString()}`)}async applyResult(c,h,d,n){const o=d.map(([t,s])=>({...t,acceptResult:s}));o.every(({localChange:t,remoteChange:s})=>t===0&&s===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:t})=>t!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,n)),o.some(({remoteChange:t})=>t!==0)&&(c=await this.updateRemoteSnippets(o,c,n)),h?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(c),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:t}of o)try{await this.fileService.del(t)}catch{}}getResourcePreviews(c,h,d,n){const o=new Map;for(const t of Object.keys(c.local.added)){const s={content:c.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(c.local.updated)){const s={content:c.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},r=h[t]?h[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of c.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},r=h[t]?h[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(c.remote.added)){const s={content:c.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},r=h[t]?h[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(c.remote.updated)){const s={content:c.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},r=h[t]?h[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of c.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of c.conflicts){const s={content:n[t]??null,hasConflicts:!0,localChange:h[t]?2:1,remoteChange:d[t]?2:1},r=h[t]?h[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t]||null,localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(h))if(!o.has(t)){const s={content:h[t]?h[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},r=h[t]?h[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t]||null,localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...o.values()]}async resolveContent(c){return this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(c):null}async hasLocalData(){try{const c=await this.getSnippetsFileContents();if(Object.keys(c).length)return!0}catch{}return!1}async updateLocalBackup(c){const h={};for(const d of c)d.fileContent&&(h[this.extUri.basename(d.localResource)]=d.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(h)))}async updateLocalSnippets(c,h){for(const{fileContent:d,acceptResult:n,localResource:o,remoteResource:t,localChange:s}of c)if(s!==0){const r=t?this.extUri.basename(t):this.extUri.basename(o),l=this.extUri.joinPath(this.snippetsFolder,r);s===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(l)),await this.fileService.del(l),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(l))):s===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(l)),await this.fileService.createFile(l,D.VSBuffer.fromString(n.content),{overwrite:h}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(l))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(l)),await this.fileService.writeFile(l,D.VSBuffer.fromString(n.content),h?void 0:d),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(l)))}}async updateRemoteSnippets(c,h,d){const n=h.syncData?this.parseSnippets(h.syncData):{},o=(0,R.deepClone)(n);for(const{acceptResult:t,localResource:s,remoteResource:r,remoteChange:l}of c)if(l!==0){const a=s?this.extUri.basename(s):this.extUri.basename(r);l===3?delete o[a]:o[a]=t.content}return(0,m.areSame)(n,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),h=await this.updateRemoteUserData(JSON.stringify(o),d?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),h}parseSnippets(c){return v(c)}toSnippetsContents(c){const h={};for(const d of Object.keys(c))h[d]=c[d].value.toString();return h}async getSnippetsFileContents(){const c={};let h;try{h=await this.fileService.resolve(this.snippetsFolder)}catch(d){if(d instanceof I.FileOperationError&&d.fileOperationResult===1)return c;throw d}for(const d of h.children||[]){const n=d.resource,o=this.extUri.extname(n);if(o===".json"||o===".code-snippets"){const t=this.extUri.relativePath(this.snippetsFolder,n),s=await this.fileService.readFile(n);c[t]=s}}return c}};y=ve([K(2,T.IEnvironmentService),K(3,I.IFileService),K(4,C.IStorageService),K(5,f.IUserDataSyncStoreService),K(6,f.IUserDataSyncBackupStoreService),K(7,f.IUserDataSyncLogService),K(8,k.IConfigurationService),K(9,f.IUserDataSyncEnablementService),K(10,w.ITelemetryService),K(11,E.IUriIdentityService)],y),e.SnippetsSynchroniser=y;let u=class extends S.AbstractInitializer{constructor(c,h,d,n,o){super("snippets",h,d,n,c,o)}async doInitialize(c){const h=c.syncData?JSON.parse(c.syncData.content):null;if(!h){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(h)){const o=h[n];if(o){const t=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,n);await this.fileService.createFile(t,D.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(t))}}await this.updateLastSyncUserData(c)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(c){return c.fileOperationResult===1}}};u=ve([K(0,I.IFileService),K(1,b.IUserDataProfilesService),K(2,T.IEnvironmentService),K(3,f.IUserDataSyncLogService),K(4,E.IUriIdentityService)],u),e.SnippetsInitializer=u}),define(re[121],se([0,1,17,16,13,14,18,24,32,21,40,26]),function(Q,e,D,i,R,k,T,I,C,w,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function S(y,u){try{return JSON.parse(y).tasks??null}catch(p){return u.error(p),null}}e.getTasksContentFromSyncContent=S;let m=class extends E.AbstractFileSynchroniser{constructor(u,p,c,h,d,n,o,t,s,r,l,a){super(u.tasksResource,{syncResource:"tasks",profile:u},p,t,s,r,c,h,o,l,d,n,a),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(u,p,c,h){const d=u.syncData?S(u.syncData.content,this.logService):null;p=p===null&&c?u:p;const n=p?.syncData?S(p.syncData.content,this.logService):null,o=await this.getLocalFileContent();let t=null,s=!1,r=!1,l=!1;if(u.syncData){const P=o?o.value.toString():null;if(!n||n!==P||n!==d){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const A=v(P,d,n);t=A.content,l=A.hasConflicts,s=A.hasLocalChanged,r=A.hasRemoteChanged}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=o.value.toString(),r=!0);const a={content:l?n:t,localChange:s?o?2:1:0,remoteChange:r?2:0,hasConflicts:l},g=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:n,localResource:this.localResource,localContent:g,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:d,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const p=u?.syncData?S(u.syncData.content,this.logService):null;if(p===null)return!0;const c=await this.getLocalFileContent(),h=c?c.value.toString():null,d=v(h,p,p);return d.hasLocalChanged||d.hasRemoteChanged}async getMergeResult(u,p){return u.previewResult}async getAcceptResult(u,p,c,h){if(this.extUri.isEqual(p,this.localResource))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(p,this.remoteResource))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(p,this.previewResource))return c===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:c,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${p.toString()}`)}async applyResult(u,p,c,h){const{fileContent:d}=c[0][0],{content:n,localChange:o,remoteChange:t}=c[0][1];if(o===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),d&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(d.value.toString()))),n?await this.updateLocalFileContent(n,d,h):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const s=JSON.stringify(this.toTasksSyncContent(n));u=await this.updateRemoteUserData(s,h?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}p?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(u){return this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)?this.resolvePreviewContent(u):null}toTasksSyncContent(u){return u?{tasks:u}:{}}};m=ve([K(2,b.IUserDataSyncStoreService),K(3,b.IUserDataSyncBackupStoreService),K(4,b.IUserDataSyncLogService),K(5,i.IConfigurationService),K(6,b.IUserDataSyncEnablementService),K(7,k.IFileService),K(8,R.IEnvironmentService),K(9,T.IStorageService),K(10,I.ITelemetryService),K(11,C.IUriIdentityService)],m),e.TasksSynchroniser=m;let f=class extends E.AbstractInitializer{constructor(u,p,c,h,d){super("tasks",p,c,h,u,d),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(u){const p=u.syncData?S(u.syncData.content,this.logService):null;if(!p){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,D.VSBuffer.fromString(p)),await this.updateLastSyncUserData(u)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};f=ve([K(0,k.IFileService),K(1,w.IUserDataProfilesService),K(2,R.IEnvironmentService),K(3,b.IUserDataSyncLogService),K(4,C.IUriIdentityService)],f),e.TasksInitializer=f;function v(y,u,p){if(y===null&&u===null&&p===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(y===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const c=p!==y,h=p!==u;return!c&&!h?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:c&&!h?{content:y,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:h&&!c?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:y,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[122],se([0,1,42,16,13,14,18,24,32,21,40,255,26]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let m=class extends E.AbstractSynchroniser{constructor(u,p,c,h,d,n,o,t,s,r,l,a,g){super({syncResource:"profiles",profile:u},p,h,d,n,o,t,l,a,s,r,g),this.userDataProfilesService=c,this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?v(u.syncData):null}async getRemoteSyncedProfiles(u){const p=await this.getLastSyncUserData(),c=await this.getLatestRemoteUserData(u,p);return c?.syncData?v(c.syncData):null}async generateSyncPreview(u,p,c){const h=u.syncData?v(u.syncData):null,d=p?.syncData?v(p.syncData):null,n=this.getLocalUserDataProfiles(),{local:o,remote:t}=(0,b.merge)(n,h,d,[]),s={local:o,remote:t,content:d?this.stringifyRemoteProfiles(d):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:t!==null?2:0},r=f(n,!1);return[{baseResource:this.baseResource,baseContent:d?this.stringifyRemoteProfiles(d):null,localResource:this.localResource,localContent:r,remoteResource:this.remoteResource,remoteContent:h?this.stringifyRemoteProfiles(h):null,remoteProfiles:h,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const p=u?.syncData?v(u.syncData):null,c=this.getLocalUserDataProfiles(),{remote:h}=(0,b.merge)(c,p,p,[]);return!!h?.added.length||!!h?.removed.length||!!h?.updated.length}async getMergeResult(u,p){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,p,c,h){if(this.extUri.isEqual(p,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(p,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(p,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${p.toString()}`)}async acceptLocal(u){const p=this.getLocalUserDataProfiles(),c=(0,b.merge)(p,null,null,[]),{local:h,remote:d}=c;return{content:u.localContent,local:h,remote:d,localChange:h.added.length>0||h.removed.length>0||h.updated.length>0?2:0,remoteChange:d!==null?2:0}}async acceptRemote(u){const p=u.remoteContent?JSON.parse(u.remoteContent):null,c=[],h=[];for(const d of this.getLocalUserDataProfiles()){const n=p?.find(o=>o.id===d.id);n&&(c.push({id:d.id,name:d.name,collection:n.collection}),h.push(d))}if(p!==null){const d=(0,b.merge)(h,p,c,[]),{local:n,remote:o}=d;return{content:u.remoteContent,local:n,remote:o,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,p,c,h){const{local:d,remote:n,localChange:o,remoteChange:t}=c[0][1];if(o===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`),o!==0){await this.backupLocal(f(this.getLocalUserDataProfiles(),!1));const s=[];for(const r of d.added)s.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${r.name}' profile...`),await this.userDataProfilesService.createProfile(r.id,r.name,{shortName:r.shortName}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${r.name}'.`)})());for(const r of d.removed)s.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${r.name}' profile...`),await this.userDataProfilesService.removeProfile(r),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${r.name}'.`)})());for(const r of d.updated){const l=this.userDataProfilesService.profiles.find(a=>a.id===r.id);l?s.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Updating '${r.name}' profile...`),await this.userDataProfilesService.updateProfile(l,{name:r.name,shortName:r.shortName}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${r.name}'.`)})()):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(s)}if(t!==0){const s=c[0][0].remoteProfiles||[];this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);for(const r of n?.added||[]){const l=await this.userDataSyncStoreService.createCollection(this.syncHeaders);s.push({id:r.id,name:r.name,collection:l,shortName:r.shortName})}for(const r of n?.removed||[])s.splice(s.findIndex(({id:l})=>r.id===l),1);for(const r of n?.updated||[]){const l=s.find(({id:a})=>r.id===a);l&&s.splice(s.indexOf(l),1,{id:r.id,name:r.name,collection:l.collection,shortName:r.shortName})}u=await this.updateRemoteUserData(this.stringifyRemoteProfiles(s),h?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${n?.added.length?` Added: ${JSON.stringify(n.added.map(r=>r.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(r=>r.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(r=>r.name))}.`:""}`);for(const r of n?.removed||[])await this.userDataSyncStoreService.deleteCollection(r.collection,this.syncHeaders)}p?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(u){if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)){const p=await this.resolvePreviewContent(u);return p&&(0,D.toFormattedString)(JSON.parse(p),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(u=>!u.isDefault&&!u.isTransient)}stringifyRemoteProfiles(u){return JSON.stringify([...u].sort((p,c)=>p.name.localeCompare(c.name)))}};m=ve([K(2,w.IUserDataProfilesService),K(3,k.IFileService),K(4,R.IEnvironmentService),K(5,T.IStorageService),K(6,S.IUserDataSyncStoreService),K(7,S.IUserDataSyncBackupStoreService),K(8,S.IUserDataSyncLogService),K(9,i.IConfigurationService),K(10,S.IUserDataSyncEnablementService),K(11,I.ITelemetryService),K(12,C.IUriIdentityService)],m),e.UserDataProfilesManifestSynchroniser=m;function f(y,u){const p=[...y].sort((c,h)=>c.name.localeCompare(h.name)).map(c=>({id:c.id,name:c.name}));return u?(0,D.toFormattedString)(p,{}):JSON.stringify(p)}e.stringifyLocalProfiles=f;function v(y){return JSON.parse(y.content)}e.parseUserDataProfilesManifest=v}),define(re[269],se([0,1,6,17,65,2,20,16,13,14,21,26]),function(Q,e,D,i,R,k,T,I,C,w,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let S=class extends k.Disposable{constructor(f,v,y,u,p){super(),this.environmentService=f,this.fileService=v,this.configurationService=y,this.logService=u,this.userDataProfilesService=p;for(const c of this.userDataProfilesService.profiles)for(const h of b.ALL_SYNC_RESOURCES)this.cleanUpBackup(this.getResourceBackupHome(c,h))}async getAllRefs(f,v){const y=this.getResourceBackupHome(f,v),u=await this.fileService.resolve(y);return u.children?u.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort().reverse().map(c=>({ref:c.name,created:this.getCreationTime(c)})):[]}async resolveContent(f,v,y){const u=this.getResourceBackupHome(f,v),p=(0,T.joinPath)(u,y);try{return(await this.fileService.readFile(p)).value.toString()}catch(c){return this.logService.error(c),null}}async backup(f,v,y){const u=this.getResourceBackupHome(f,v),p=(0,T.joinPath)(u,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(p,i.VSBuffer.fromString(y))}catch(c){this.logService.error(c)}try{this.cleanUpBackup(u)}catch{}}getResourceBackupHome(f,v){return(0,T.joinPath)(this.environmentService.userDataSyncHome,...f.isDefault?[v]:[f.id,v])}async cleanUpBackup(f){try{try{if(!await this.fileService.exists(f))return}catch{return}const v=await this.fileService.resolve(f);if(v.children){const y=v.children.filter(h=>h.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(h.name)).sort(),u=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let p=y.filter(h=>Date.now()-this.getCreationTime(h)>u);const c=y.length-p.length;c<10&&(p=p.slice(10-c)),await D.Promises.settled(p.map(async h=>{this.logService.info("Deleting from backup",h.resource.path),await this.fileService.del(h.resource)}))}}catch(v){this.logService.error(v)}}getCreationTime(f){return f.ctime||new Date(parseInt(f.name.substring(0,4)),parseInt(f.name.substring(4,6))-1,parseInt(f.name.substring(6,8)),parseInt(f.name.substring(9,11)),parseInt(f.name.substring(11,13)),parseInt(f.name.substring(13,15))).getTime()}};S=ve([K(0,C.IEnvironmentService),K(1,w.IFileService),K(2,I.IConfigurationService),K(3,b.IUserDataSyncLogService),K(4,E.IUserDataProfilesService)],S),e.UserDataSyncBackupStoreService=S}),define(re[270],se([0,1,3,2,5,13,18,24,26]),function(Q,e,D,i,R,k,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const w="sync.enable";let E=class extends i.Disposable{constructor(S,m,f,v){super(),this.storageService=S,this.telemetryService=m,this.environmentService=f,this.userDataSyncStoreManagementService=v,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(S.onDidChangeValue(y=>this.onDidStorageChange(y)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(w,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(S){S&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(w,{enabled:S}),this.storageService.store(w,S,-1,1))}isResourceEnabled(S){return this.storageService.getBoolean((0,C.getEnablementKey)(S),-1,!0)}setResourceEnablement(S,m){if(this.isResourceEnabled(S)!==m){const f=(0,C.getEnablementKey)(S);this.storeResourceEnablement(f,m)}}getResourceSyncStateVersion(S){}storeResourceEnablement(S,m){this.storageService.store(S,m,-1,R.isWeb?0:1)}onDidStorageChange(S){if(S.scope!==-1)return;if(w===S.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const m=C.ALL_SYNC_RESOURCES.filter(f=>(0,C.getEnablementKey)(f)===S.key)[0];if(m){this._onDidChangeResourceEnablement.fire([m,this.isResourceEnabled(m)]);return}}};E=ve([K(0,T.IStorageService),K(1,I.ITelemetryService),K(2,k.IEnvironmentService),K(3,C.IUserDataSyncStoreManagementService)],E),e.UserDataSyncEnablementService=E}),define(re[79],se([0,1,3,2,5,27,180,13,14,4,25,44,18,26]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,w.createDecorator)("IUserDataSyncMachinesService");const f="sync.currentMachineName",v="Safari",y="Chrome",u="Edge",p="Firefox",c="Android";function h(o){switch(o){case v:case y:case u:case p:case c:case(0,R.PlatformToString)(0):return!0}return!1}e.isWebPlatform=h;function d(){return R.isSafari?v:R.isChrome?y:R.isEdge?u:R.isFirefox?p:R.isAndroid?c:(0,R.PlatformToString)(R.isWeb?0:R.platform)}let n=class st extends i.Disposable{constructor(t,s,r,l,a,g){super(),this.storageService=r,this.userDataSyncStoreService=l,this.logService=a,this.productService=g,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,b.getServiceMachineId)(t,s,r)}async getMachines(t){const s=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(l=>({...l,isCurrent:l.id===s}))}async addCurrentMachine(t){const s=await this.currentMachineIdPromise,r=await this.readMachinesData(t);r.machines.some(({id:l})=>l===s)||(r.machines.push({id:s,name:this.computeCurrentMachineName(r.machines),platform:d()}),await this.writeMachinesData(r))}async removeCurrentMachine(t){const s=await this.currentMachineIdPromise,r=await this.readMachinesData(t),l=r.machines.filter(({id:a})=>a!==s);l.length!==r.machines.length&&(r.machines=l,await this.writeMachinesData(r))}async renameMachine(t,s,r){const l=await this.readMachinesData(r),a=l.machines.find(({id:g})=>g===t);if(a){a.name=s,await this.writeMachinesData(l);const g=await this.currentMachineIdPromise;t===g&&this.storageService.store(f,s,-1,1)}}async setEnablements(t){const s=await this.readMachinesData();for(const[r,l]of t){const a=s.machines.find(g=>g.id===r);a&&(a.disabled=l?void 0:!0)}await this.writeMachinesData(s)}computeCurrentMachineName(t){const s=this.storageService.get(f,-1);if(s)return s;const r=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${d()} (${this.productService.nameShort})`,l=new RegExp(`${(0,k.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let a=0;for(const g of t){const P=l.exec(g.name),A=P?parseInt(P[1]):0;a=A>a?A:a}return`${r} #${a+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const s=this.parse(this.userData);if(s.version!==st.VERSION)throw new Error((0,T.localize)(0,null,this.productService.nameLong));return s}async writeMachinesData(t){const s=JSON.stringify(t),r=await this.userDataSyncStoreService.writeResource(st.RESOURCE,s,this.userData?.ref||null);this.userData={ref:r,content:s},this._onDidChange.fire()}async readUserData(t){if(this.userData){const s=t&&t.latest?t.latest[st.RESOURCE]:void 0;if(this.userData.ref===s)return this.userData;if(s===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(st.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(s){this.logService.error(s)}return{version:st.VERSION,machines:[]}}};n.VERSION=1,n.RESOURCE="machines",n=ve([K(0,I.IEnvironmentService),K(1,C.IFileService),K(2,S.IStorageService),K(3,m.IUserDataSyncStoreService),K(4,m.IUserDataSyncLogService),K(5,E.IProductService)],n),e.UserDataSyncMachinesService=n}),define(re[271],se([0,1,6,65,37,11,3,2,5,20,8,178,25,18,24,26,76,79]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const p="sync.disableMachineEventually",c="sync.sessionId",h="sync.storeUrl",d="sync.productQuality";let n=class extends I.Disposable{get syncUrl(){const s=this.storageService.get(h,-1);return s?E.URI.parse(s):void 0}set syncUrl(s){s?this.storageService.store(h,s.toString(),-1,1):this.storageService.remove(h,-1)}get productQuality(){return this.storageService.get(d,-1)}set productQuality(s){s?this.storageService.store(d,s,-1,1):this.storageService.remove(d,-1)}constructor(s,r,l,a,g,P,A,V,O,F){super(),this.userDataSyncStoreManagementService=r,this.userDataSyncStoreService=l,this.userDataSyncEnablementService=a,this.userDataSyncService=g,this.logService=P,this.userDataSyncAccountService=A,this.telemetryService=V,this.userDataSyncMachinesService=O,this.storageService=F,this.autoSync=this._register(new I.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=r.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=s.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(r.onDidChangeUserDataSyncStore(()=>{(0,w.isEqual)(this.syncUrl,r.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=r.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(A.onDidChangeAccount(()=>this.updateAutoSync())),this._register(l.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(g.onDidChangeLocal(N=>this.triggerSync([N],!1,!1))),this._register(T.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,N])=>N)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:s,message:r}=this.isAutoSyncEnabled();s?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(l=>this.onDidFinishSync(l))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(r&&this.logService.info(r),this.autoSync.clear()):r&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(r))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,i.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(s,r,l){try{this.userDataSyncAccountService.account&&!l&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(c,-1),s?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(this.logService.error(a),r)this.updateEnablement(!1);else throw a}}updateEnablement(s){this.userDataSyncEnablementService.isEnabled()!==s&&(this.userDataSyncEnablementService.setEnablement(s),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(s){if(!s){this.successiveFailures=0;return}const r=v.UserDataSyncError.toUserDataSyncError(s);r instanceof v.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:r.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),r.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):r.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):r.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):r.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):r.code==="UpgradeRequired"||r.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):r.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${r.resource} content with newer version than of client. Requires client upgrade.`)):r.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${r.resource} content with older version than of client. Requires server reset.`)):r.code==="ServiceChanged"||r.code==="DefaultServiceChanged"?C.isWeb&&r.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(r),this.successiveFailures++),this._onError.fire(r)}async disableMachineEventually(){this.storageService.store(p,!0,-1,1),await(0,D.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(p,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(p,-1)}async triggerSync(s,r,l){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(r&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...s),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",l)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};n=ve([K(0,S.IProductService),K(1,v.IUserDataSyncStoreManagementService),K(2,v.IUserDataSyncStoreService),K(3,v.IUserDataSyncEnablementService),K(4,v.IUserDataSyncService),K(5,v.IUserDataSyncLogService),K(6,y.IUserDataSyncAccountService),K(7,f.ITelemetryService),K(8,u.IUserDataSyncMachinesService),K(9,m.IStorageService)],n),e.UserDataAutoSyncService=n;class o extends I.Disposable{constructor(s,r,l,a,g,P,A,V){super(),this.lastSyncUrl=s,this.interval=r,this.userDataSyncStoreManagementService=l,this.userDataSyncStoreService=a,this.userDataSyncService=g,this.userDataSyncMachinesService=P,this.logService=A,this.storageService=V,this.intervalHandler=this._register(new I.MutableDisposable),this._onDidStartSync=this._register(new T.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new T.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,I.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(s,r){const l=(0,D.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(g){if((0,k.isCancellationError)(g))return}return this.doSync(s,r,a)});return this.syncPromise=l,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,w.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const s=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),r=this.userDataSyncStoreManagementService.userDataSyncStore;return!!r&&!!s&&(!(0,w.isEqual)(r.defaultUrl,s.defaultUrl)||!(0,w.isEqual)(r.insidersUrl,s.insidersUrl)||!(0,w.isEqual)(r.stableUrl,s.stableUrl))}async doSync(s,r,l){this.logService.info(`Auto Sync: Triggered by ${s}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,r),l.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const g=this.storageService.get(c,-1);if(g&&this.manifest&&g!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const P=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(l.isCancellationRequested)return;const A=P.find(V=>V.isCurrent);if(A?.disabled)throw new v.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(V){throw new v.UserDataAutoSyncError((0,R.toErrorMessage)(V),V instanceof v.UserDataSyncError?V.code:"Unknown")}if(this.manifest&&this.manifest.session!==g&&this.storageService.store(c,this.manifest.session,-1,1),l.isCancellationRequested)return;A||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(g){this.logService.error(g),a=g}this._onDidFinishSync.fire(a)}register(s){return super._register(s)}}o.INTERVAL_SYNCING="Interval"}),define(re[62],se([0,1,2,69,4,18]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataSyncProfilesStorageService=e.IUserDataSyncProfilesStorageService=void 0,e.IUserDataSyncProfilesStorageService=(0,R.createDecorator)("IUserDataSyncProfilesStorageService");let T=class extends D.Disposable{constructor(w){super(),this.storageService=w}async readStorageData(w){return this.withProfileScopedStorageService(w,async E=>this.getItems(E))}async updateStorageData(w,E,b){return this.withProfileScopedStorageService(w,async S=>this.writeItems(S,E,b))}async withProfileScopedStorageService(w,E){if(this.storageService.hasScope(w))return E(this.storageService);const b=await this.createStorageDatabase(w),S=new I(b);try{await S.initialize();const m=await E(S);return await S.flush(),m}finally{S.dispose(),await this.closeAndDispose(b)}}getItems(w){const E=new Map,b=S=>{for(const m of w.keys(0,S))E.set(m,{value:w.get(m,0),target:S})};return b(0),b(1),E}writeItems(w,E,b){for(const[S,m]of E)w.store(S,m,0,b)}async closeAndDispose(w){try{await w.close()}finally{(0,D.isDisposable)(w)&&w.dispose()}}};T=ve([K(0,k.IStorageService)],T),e.AbstractUserDataSyncProfilesStorageService=T;class I extends k.AbstractStorageService{constructor(w){super({flushInterval:100}),this.profileStorage=this._register(new i.Storage(w))}doInitialize(){return this.profileStorage.init()}getStorage(w){return w===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(re[123],se([0,1,6,22,11,3,42,2,27,16,13,117,29,33,78,14,4,71,7,18,24,32,21,40,252,115,26,62]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u,p,c,h,d,n,o,t,s,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function a(F,N){const L=JSON.parse(F.content);if(F.version===1||F.version===2){const U=(await N.getInstalled(0)).filter($=>$.isBuiltin);for(const $ of L)F.version===1&&($.enabled===!1&&($.disabled=!0),delete $.enabled),F.version===2&&U.every(x=>!(0,m.areSameExtensions)(x.identifier,$.identifier))&&($.installed=!0)}return L}function g(F){return JSON.parse(F.content)}e.parseExtensions=g;function P(F,N){return F.sort((L,U)=>!L.identifier.uuid&&U.identifier.uuid?-1:L.identifier.uuid&&!U.identifier.uuid?1:(0,C.compare)(L.identifier.id,U.identifier.id)),N?(0,T.toFormattedString)(F,{}):JSON.stringify(F)}e.stringify=P;let A=class extends o.AbstractSynchroniser{constructor(N,L,U,$,x,j,B,W,q,Y,ee,ce,J,z,_,M,G){super({syncResource:"extensions",profile:N},L,$,U,x,j,B,ce,J,Y,ee,_),this.extensionManagementService=W,this.ignoredExtensionsManagementService=q,this.instantiationService=G,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(V),this._register(k.Event.any(k.Event.filter(this.extensionManagementService.onDidInstallExtensions,H=>H.some(({local:Z})=>!!Z)),k.Event.filter(this.extensionManagementService.onDidUninstallExtension,H=>!H.error),k.Event.filter(M.onDidChange,H=>H.valueChanges.some(({profile:Z,changes:oe})=>this.syncResource.profile.id===Z.id&&oe.some(X=>X.key===S.DISABLED_EXTENSIONS_STORAGE_PATH))),z.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(N,L){const U=N.syncData?await a(N.syncData,this.extensionManagementService):null,$=L?.skippedExtensions||[],x=L?.builtinExtensions||[],j=L?.syncData?await a(L.syncData,this.extensionManagementService):null,{localExtensions:B,ignoredExtensions:W}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);U?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:q,remote:Y}=(0,t.merge)(B,U,j,$,W,x),ee={local:q,remote:Y,content:this.getPreviewContent(B,q.added,q.updated,q.removed),localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:Y!==null?2:0},ce=this.stringify(B,!1);return[{skippedExtensions:$,builtinExtensions:x,baseResource:this.baseResource,baseContent:j?this.stringify(j,!1):ce,localResource:this.localResource,localContent:ce,localExtensions:B,remoteResource:this.remoteResource,remoteExtensions:U,remoteContent:U?this.stringify(U,!1):null,previewResource:this.previewResource,previewResult:ee,localChange:ee.localChange,remoteChange:ee.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(N){const L=N.syncData?await a(N.syncData,this.extensionManagementService):null,{localExtensions:U,ignoredExtensions:$}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,t.merge)(U,L,L,N.skippedExtensions||[],$,N.builtinExtensions||[]);return x!==null}getPreviewContent(N,L,U,$){const x=[...L,...U],j=new Set,B=W=>{j.add(W.id.toLowerCase()),W.uuid&&j.add(W.uuid)};x.forEach(({identifier:W})=>B(W)),$.forEach(B);for(const W of N)j.has(W.identifier.id.toLowerCase())||W.identifier.uuid&&j.has(W.identifier.uuid)||x.push(W);return this.stringify(x,!1)}async getMergeResult(N,L){return{...N.previewResult,hasConflicts:!1}}async getAcceptResult(N,L,U,$){if(this.extUri.isEqual(L,this.localResource))return this.acceptLocal(N);if(this.extUri.isEqual(L,this.remoteResource))return this.acceptRemote(N);if(this.extUri.isEqual(L,this.previewResource))return N.previewResult;throw new Error(`Invalid Resource: ${L.toString()}`)}async acceptLocal(N){const L=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(L),$=(0,t.merge)(N.localExtensions,null,null,N.skippedExtensions,U,N.builtinExtensions),{local:x,remote:j}=$;return{content:N.localContent,local:x,remote:j,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:j!==null?2:0}}async acceptRemote(N){const L=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(L),$=N.remoteContent?JSON.parse(N.remoteContent):null;if($!==null){const x=(0,t.merge)(N.localExtensions,$,N.localExtensions,[],U,N.builtinExtensions),{local:j,remote:B}=x;return{content:N.remoteContent,local:j,remote:B,localChange:j.added.length>0||j.removed.length>0||j.updated.length>0?2:0,remoteChange:B!==null?2:0}}else return{content:N.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(N,L,U,$){let{skippedExtensions:x,localExtensions:j}=U[0][0];const{local:B,remote:W,localChange:q,remoteChange:Y}=U[0][1];if(q===0&&Y===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),q!==0&&(await this.backupLocal(JSON.stringify(j)),x=await this.localExtensionsProvider.updateLocalExtensions(B.added,B.removed,B.updated,x,this.syncResource.profile)),W){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const ee=JSON.stringify(W.all);N=await this.updateRemoteUserData(ee,$?null:N.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${W.added.length?` Added: ${JSON.stringify(W.added.map(ce=>ce.identifier.id))}.`:""}${W.updated.length?` Updated: ${JSON.stringify(W.updated.map(ce=>ce.identifier.id))}.`:""}${W.removed.length?` Removed: ${JSON.stringify(W.removed.map(ce=>ce.identifier.id))}.`:""}`)}if(L?.ref!==N.ref){this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`);const ee=j.filter(ce=>!ce.installed).map(ce=>ce.identifier);await this.updateLastSyncUserData(N,{skippedExtensions:x,builtinExtensions:ee}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(ce=>ce.identifier.id))}.`:""}`)}}async resolveContent(N){if(this.extUri.isEqual(this.remoteResource,N)||this.extUri.isEqual(this.baseResource,N)||this.extUri.isEqual(this.localResource,N)||this.extUri.isEqual(this.acceptedResource,N)){const L=await this.resolvePreviewContent(N);return L&&this.stringify(JSON.parse(L),!0)}return null}stringify(N,L){return P(N,L)}async hasLocalData(){try{const{localExtensions:N}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(N.some(L=>L.installed||L.disabled))return!0}catch{}return!1}};A=ve([K(2,E.IEnvironmentService),K(3,v.IFileService),K(4,c.IStorageService),K(5,r.IUserDataSyncStoreService),K(6,r.IUserDataSyncBackupStoreService),K(7,S.IExtensionManagementService),K(8,s.IIgnoredExtensionsManagementService),K(9,r.IUserDataSyncLogService),K(10,w.IConfigurationService),K(11,r.IUserDataSyncEnablementService),K(12,h.ITelemetryService),K(13,f.IExtensionStorageService),K(14,d.IUriIdentityService),K(15,l.IUserDataSyncProfilesStorageService),K(16,y.IInstantiationService)],A),e.ExtensionsSynchroniser=A;let V=class{constructor(N,L,U,$,x,j){this.extensionManagementService=N,this.userDataSyncProfilesStorageService=L,this.extensionGalleryService=U,this.ignoredExtensionsManagementService=$,this.instantiationService=x,this.logService=j}async getLocalExtensions(N){const L=await this.extensionManagementService.getInstalled(void 0,N.extensionsResource),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(L);return{localExtensions:await this.withProfileScopedServices(N,async(x,j)=>{const B=x.getDisabledExtensions();return L.map(W=>{const{identifier:q,isBuiltin:Y,manifest:ee,preRelease:ce}=W,J={identifier:q,preRelease:ce,version:ee.version};B.some(z=>(0,m.areSameExtensions)(z,q))&&(J.disabled=!0),Y||(J.installed=!0);try{const z=j.getKeysForSync({id:q.id,version:ee.version});if(z){const _=j.getExtensionState(W,!0)||{};J.state=Object.keys(_).reduce((M,G)=>(z.includes(G)&&(M[G]=_[G]),M),{})}}catch(z){this.logService.info(`${(0,o.getSyncResourceLogLabel)("extensions",N)}: Error while parsing extension state`,(0,R.getErrorMessage)(z))}return J})}),ignoredExtensions:U}}async updateLocalExtensions(N,L,U,$,x){const j=(0,o.getSyncResourceLogLabel)("extensions",x);return this.withProfileScopedServices(x,async(B,W)=>{const q=[],Y=[],ee=await this.extensionManagementService.getInstalled(void 0,x.extensionsResource);if(L.length){const J=ee.filter(({identifier:z,isBuiltin:_})=>!_&&L.some(M=>(0,m.areSameExtensions)(z,M)));await D.Promises.settled(J.map(async z=>{this.logService.trace(`${j}: Uninstalling local extension...`,z.identifier.id),await this.extensionManagementService.uninstall(z,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.logService.info(`${j}: Uninstalled local extension.`,z.identifier.id),q.push(z.identifier)}))}(N.length||U.length)&&await D.Promises.settled([...N,...U].map(async J=>{const z=ee.find(M=>(0,m.areSameExtensions)(M.identifier,J.identifier));if(z&&z.isBuiltin){J.state&&z.manifest.version===J.version&&this.updateExtensionState(J.state,z,z.manifest.version,W),B.getDisabledExtensions().some(G=>(0,m.areSameExtensions)(G,J.identifier))!==!!J.disabled&&(J.disabled?(this.logService.trace(`${j}: Disabling extension...`,J.identifier.id),await B.disableExtension(J.identifier),this.logService.info(`${j}: Disabled extension`,J.identifier.id)):(this.logService.trace(`${j}: Enabling extension...`,J.identifier.id),await B.enableExtension(J.identifier),this.logService.info(`${j}: Enabled extension`,J.identifier.id))),q.push(J.identifier);return}const _=(await this.extensionGalleryService.getExtensions([{...J.identifier,preRelease:J.preRelease}],i.CancellationToken.None))[0];if(J.state&&(z?z.manifest.version===J.version:!!_)&&this.updateExtensionState(J.state,z||_,z?.manifest.version,W),_)try{B.getDisabledExtensions().some(G=>(0,m.areSameExtensions)(G,J.identifier))!==!!J.disabled&&(J.disabled?(this.logService.trace(`${j}: Disabling extension...`,J.identifier.id,_.version),await B.disableExtension(_.identifier),this.logService.info(`${j}: Disabled extension`,J.identifier.id,_.version)):(this.logService.trace(`${j}: Enabling extension...`,J.identifier.id,_.version),await B.enableExtension(_.identifier),this.logService.info(`${j}: Enabled extension`,J.identifier.id,_.version))),(!z||z.preRelease!==J.preRelease)&&(await this.extensionManagementService.canInstall(_)?(this.logService.trace(`${j}: Installing extension...`,J.identifier.id,_.version),await this.extensionManagementService.installFromGallery(_,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:J.preRelease,profileLocation:x.extensionsResource}),this.logService.info(`${j}: Installed extension.`,J.identifier.id,_.version),q.push(_.identifier)):(this.logService.info(`${j}: Skipped synchronizing extension because it cannot be installed.`,_.displayName||_.identifier.id),Y.push(J)))}catch(M){Y.push(J),M instanceof S.ExtensionManagementError&&[S.ExtensionManagementErrorCode.Incompatible,S.ExtensionManagementErrorCode.IncompatiblePreRelease,S.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(M.code)?this.logService.info(`${j}: Skipped synchronizing extension because the compatible extension is not found.`,_.displayName||_.identifier.id):(this.logService.error(M),this.logService.info(`${j}: Skipped synchronizing extension`,_.displayName||_.identifier.id))}else Y.push(J),this.logService.info(`${j}: Skipped synchronizing extension because the extension is not found.`,J.identifier.id)}));const ce=[];for(const J of $)q.some(z=>(0,m.areSameExtensions)(z,J.identifier))||ce.push(J);for(const J of Y)ce.some(z=>(0,m.areSameExtensions)(z.identifier,J.identifier))||ce.push(J);return ce})}updateExtensionState(N,L,U,$){const x=$.getExtensionState(L,!0)||{},j=U?$.getKeysForSync({id:L.identifier.id,version:U}):void 0;j?j.forEach(B=>{x[B]=N[B]}):Object.keys(N).forEach(B=>x[B]=N[B]),$.setExtensionState(L,x,!0)}async withProfileScopedServices(N,L){return this.userDataSyncProfilesStorageService.withProfileScopedStorageService(N,async U=>{const $=new I.DisposableStore,x=this.instantiationService.createChild(new u.ServiceCollection([c.IStorageService,U])),j=$.add(x.createInstance(b.GlobalExtensionEnablementService)),B=$.add(x.createInstance(f.ExtensionStorageService));try{return await L(j,B)}finally{$.dispose()}})}};V=ve([K(0,S.IExtensionManagementService),K(1,l.IUserDataSyncProfilesStorageService),K(2,S.IExtensionGalleryService),K(3,s.IIgnoredExtensionsManagementService),K(4,y.IInstantiationService),K(5,r.IUserDataSyncLogService)],V),e.LocalExtensionsProvider=V;let O=class extends o.AbstractInitializer{constructor(N,L,U,$,x,j,B){super("extensions",$,x,j,U,B),this.extensionManagementService=N,this.ignoredExtensionsManagementService=L}async parseExtensions(N){return N.syncData?await a(N.syncData,this.extensionManagementService):null}generatePreview(N,L){const U=[],$=[],x=[];for(const j of N){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(j.identifier.id))continue;const B=L.find(W=>(0,m.areSameExtensions)(W.identifier,j.identifier));B?(U.push(B),j.disabled&&x.push(j.identifier)):j.installed&&($.push({...j.identifier,preRelease:!!j.preRelease}),j.disabled&&x.push(j.identifier))}return{installedExtensions:U,newExtensions:$,disabledExtensions:x,remoteExtensions:N}}};O=ve([K(0,S.IExtensionManagementService),K(1,s.IIgnoredExtensionsManagementService),K(2,v.IFileService),K(3,n.IUserDataProfilesService),K(4,E.IEnvironmentService),K(5,p.ILogService),K(6,d.IUriIdentityService)],O),e.AbstractExtensionsInitializer=O}),define(re[124],se([0,1,17,11,3,35,42,5,30,16,13,14,7,44,18,24,32,40,61,256,26,21,62,4]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u,p,c,h,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",s=["locale"];function r(V,O){const F=V.storage?Object.keys(V.storage).sort():[],N={};return F.forEach(L=>N[L]=V.storage[L]),V.storage=N,O?(0,T.toFormattedString)(V,{}):JSON.stringify(V)}e.stringify=r;const l=1;let a=class extends u.AbstractSynchroniser{constructor(O,F,N,L,U,$,x,j,B,W,q,Y,ee,ce){super({syncResource:"globalState",profile:O},F,L,j,Y,U,$,B,W,x,q,ee),this.userDataSyncProfilesStorageService=N,this.version=l,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=ce.createInstance(g),this._register(L.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(R.Event.any(R.Event.filter(L.onDidFilesChange,J=>J.contains(this.environmentService.argvResource)),R.Event.filter(N.onDidChange,J=>!!(J.targetChanges.some(z=>this.syncResource.profile.id===z.id)||J.valueChanges.some(({profile:z,changes:_})=>this.syncResource.profile.id===z.id&&_.some(M=>M.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(O,F,N){const L=O.syncData?JSON.parse(O.syncData.content):null;F=F===null&&N?O:F;const U=F&&F.syncData?JSON.parse(F.syncData.content):null,$=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);L?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const x=await this.getStorageKeys(U),{local:j,remote:B}=(0,c.merge)($.storage,L?L.storage:null,U?U.storage:null,x,this.logService),W={content:null,local:j,remote:B,localChange:Object.keys(j.added).length>0||Object.keys(j.updated).length>0||j.removed.length>0?2:0,remoteChange:B.all!==null?2:0},q=r($,!1);return[{baseResource:this.baseResource,baseContent:U?r(U,!1):q,localResource:this.localResource,localContent:q,localUserData:$,remoteResource:this.remoteResource,remoteContent:L?r(L,!1):null,previewResource:this.previewResource,previewResult:W,localChange:W.localChange,remoteChange:W.remoteChange,acceptedResource:this.acceptedResource,storageKeys:x}]}async hasRemoteChanged(O){const F=O.syncData?JSON.parse(O.syncData.content):null;if(F===null)return!0;const N=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),L=await this.getStorageKeys(F),{remote:U}=(0,c.merge)(N.storage,F.storage,F.storage,L,this.logService);return U.all!==null}async getMergeResult(O,F){return{...O.previewResult,hasConflicts:!1}}async getAcceptResult(O,F,N,L){if(this.extUri.isEqual(F,this.localResource))return this.acceptLocal(O);if(this.extUri.isEqual(F,this.remoteResource))return this.acceptRemote(O);if(this.extUri.isEqual(F,this.previewResource))return O.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async acceptLocal(O){return{content:O.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(O.localUserData.storage),removed:[],updated:[],all:O.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(O){if(O.remoteContent!==null){const F=JSON.parse(O.remoteContent),{local:N,remote:L}=(0,c.merge)(O.localUserData.storage,F.storage,null,O.storageKeys,this.logService);return{content:O.remoteContent,local:N,remote:L,localChange:Object.keys(N.added).length>0||Object.keys(N.updated).length>0||N.removed.length>0?2:0,remoteChange:L!==null?2:0}}else return{content:O.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(O,F,N,L){const{localUserData:U}=N[0][0],{local:$,remote:x,localChange:j,remoteChange:B}=N[0][1];if(j===0&&B===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),j!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(U)),await this.localGlobalStateProvider.writeLocalGlobalState($,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),B!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const W=JSON.stringify({storage:x.all});O=await this.updateRemoteUserData(W,L?null:O.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${x.added.length?` Added: ${x.added}.`:""}${x.updated.length?` Updated: ${x.updated}.`:""}${x.removed.length?` Removed: ${x.removed}.`:""}`)}F?.ref!==O.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(O),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(O){if(this.extUri.isEqual(this.remoteResource,O)||this.extUri.isEqual(this.baseResource,O)||this.extUri.isEqual(this.localResource,O)||this.extUri.isEqual(this.acceptedResource,O)){const F=await this.resolvePreviewContent(O);return F&&r(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:O}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(O).length>1||O[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(O){const F=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile),N=[],L=[];for(const[x,j]of F)j.target===0?N.push(x):j.target===1&&L.push(x);const U=[...N,...L],$=O?.storage?Object.keys(O.storage).filter(x=>!x.startsWith(t)&&!U.includes(x)&&F.get(x)!==void 0):[];if(!I.isWeb){const x=[...h.ALL_SYNC_RESOURCES.map(j=>(0,h.getEnablementKey)(j)),h.SYNC_SERVICE_URL_TYPE];$.push(...x),L.push(...x)}return{user:N,machine:L,unregistered:$}}};a=ve([K(2,n.IUserDataSyncProfilesStorageService),K(3,b.IFileService),K(4,h.IUserDataSyncStoreService),K(5,h.IUserDataSyncBackupStoreService),K(6,h.IUserDataSyncLogService),K(7,E.IEnvironmentService),K(8,h.IUserDataSyncEnablementService),K(9,v.ITelemetryService),K(10,w.IConfigurationService),K(11,f.IStorageService),K(12,y.IUriIdentityService),K(13,o.IInstantiationService)],a),e.GlobalStateSynchroniser=a;let g=class{constructor(O,F,N,L){this.fileService=O,this.environmentService=F,this.userDataSyncProfilesStorageService=N,this.logService=L}async getLocalGlobalState(O){const F={};if(O.isDefault){const L=await this.getLocalArgvContent(),U=(0,k.parse)(L);for(const $ of s)U[$]!==void 0&&(F[`${t}${$}`]={version:1,value:U[$]})}const N=await this.userDataSyncProfilesStorageService.readStorageData(O);for(const[L,U]of N)U.value&&U.target===0&&(F[L]={version:1,value:U.value});return{storage:F}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const O=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),O.value.toString()}catch(O){this.logService.debug((0,i.getErrorMessage)(O))}return"{}"}async writeLocalGlobalState({added:O,removed:F,updated:N},L){const U=(0,u.getSyncResourceLogLabel)("globalState",L),$={},x=new Map,j=await this.userDataSyncProfilesStorageService.readStorageData(L),B=(W,q)=>{for(const Y of W){if(Y.startsWith(t)){$[Y.substring(t.length)]=q?q[Y].value:void 0;continue}if(q){const ee=q[Y];ee.value!==j.get(Y)?.value&&x.set(Y,ee.value)}else j.get(Y)!==void 0&&x.set(Y,void 0)}};if(B(Object.keys(O),O),B(Object.keys(N),N),B(F),Object.keys($).length){this.logService.trace(`${U}: Updating locale...`);const W=await this.getLocalArgvContent();let q=W;for(const Y of Object.keys($))q=(0,p.edit)(q,[Y],$[Y],{});W!==q&&(this.logService.trace(`${U}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(q)),this.logService.info(`${U}: Updated locale.`)),this.logService.info(`${U}: Updated locale`)}x.size&&(this.logService.trace(`${U}: Updating global state...`),await this.userDataSyncProfilesStorageService.updateStorageData(L,x,0),this.logService.info(`${U}: Updated global state`,[...x.keys()]))}};g=ve([K(0,b.IFileService),K(1,E.IEnvironmentService),K(2,n.IUserDataSyncProfilesStorageService),K(3,h.IUserDataSyncLogService)],g),e.LocalGlobalStateProvider=g;let P=class extends u.AbstractInitializer{constructor(O,F,N,L,U,$){super("globalState",N,L,U,F,$),this.storageService=O}async doInitialize(O){const F=O.syncData?JSON.parse(O.syncData.content):null;if(!F){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const N={},L={};for(const U of Object.keys(F.storage))U.startsWith(t)?N[U.substring(t.length)]=F.storage[U].value:this.storageService.get(U,0)===void 0&&(L[U]=F.storage[U].value);if(Object.keys(N).length){let U="{}";try{U=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const $ of Object.keys(N))U=(0,p.edit)(U,[$],N[$],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(U))}if(Object.keys(L).length)for(const U of Object.keys(L))this.storageService.store(U,L[U],0,0)}};P=ve([K(0,f.IStorageService),K(1,b.IFileService),K(2,d.IUserDataProfilesService),K(3,E.IEnvironmentService),K(4,h.IUserDataSyncLogService),K(5,y.IUriIdentityService)],P),e.GlobalStateInitializer=P;let A=class{constructor(O,F,N,L,U){this.userDataSyncStoreClient=O,this.storageService=F,this.environmentService=N,this.fileService=L,this.logService=U}getSyncStoreType(O){return this.parseGlobalState(O)?.storage[h.SYNC_SERVICE_URL_TYPE]?.value}async sync(O){const F=(0,h.createSyncHeaders)((0,C.generateUuid)());try{return await this.doSync(O,F)}catch(N){if(N instanceof h.UserDataSyncError)switch(N.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(O,F)}throw N}}async doSync(O,F){const N=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,F),L=this.parseGlobalState(N)||{storage:{}};L.storage[h.SYNC_SERVICE_URL_TYPE]={value:O,version:l};const U=await(0,m.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:l,machineId:U,content:r(L,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify($),N.ref,void 0,F)}parseGlobalState({content:O}){if(!O)return null;const F=JSON.parse(O);if((0,u.isSyncData)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};A=ve([K(1,f.IStorageService),K(2,E.IEnvironmentService),K(3,b.IFileService),K(4,S.ILogService)],A),e.UserDataSyncStoreTypeSynchronizer=A}),define(re[272],se([0,1,8,181,13,14,44,18,32,26,21,40,120,119,118,16,121,123,124,4,122,42]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u,p,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class Be{constructor(t,s,r,l,a,g,P,A,V,O){this.userDataSyncStoreService=t,this.userDataSyncBackupStoreService=s,this.logService=r,this.environmentService=a,this.storageService=g,this.fileService=P,this.userDataProfilesService=A,this.configurationService=V,this.instantiationService=O,this.extUri=l.extUri}async getRemoteSyncedProfiles(){const t=await this.userDataSyncStoreService.readResource("profiles",null,void 0);if(t.content){const s=this.parseSyncData(t.content,"profiles");return(0,h.parseUserDataProfilesManifest)(s)}return[]}async getRemoteSyncResourceHandles(t,s){return(await this.userDataSyncStoreService.getAllResourceRefs(t,s?.collection)).map(({created:l,ref:a})=>({created:l,uri:this.toUri({remote:!0,syncResource:t,profile:s?.id??this.userDataProfilesService.defaultProfile.id,collection:s?.collection,ref:a,node:void 0})}))}async getLocalSyncResourceHandles(t,s){return(await this.userDataSyncBackupStoreService.getAllRefs(s,t)).map(({created:l,ref:a})=>({created:l,uri:this.toUri({remote:!1,syncResource:t,profile:s.id,collection:void 0,ref:a,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const s=this.resolveUri(t),r=s?this.userDataProfilesService.profiles.find(l=>l.id===s.profile):void 0;return s&&r?{profile:r,syncResource:s?.syncResource}:void 0}async getAssociatedResources({uri:t}){const s=this.resolveUri(t);if(!s)return[];const r=this.userDataProfilesService.profiles.find(l=>l.id===s.profile);switch(s.syncResource){case"settings":return this.getSettingsAssociatedResources(t,r);case"keybindings":return this.getKeybindingsAssociatedResources(t,r);case"tasks":return this.getTasksAssociatedResources(t,r);case"snippets":return this.getSnippetsAssociatedResources(t,r);case"globalState":return this.getGlobalStateAssociatedResources(t,r);case"extensions":return this.getExtensionsAssociatedResources(t,r);case"profiles":return this.getProfilesAssociatedResources(t,r)}}async getMachineId({uri:t}){const s=this.resolveUri(t);if(!!s){if(s.remote){if(s.ref){const{content:r}=await this.getUserData(s.syncResource,s.ref,s.collection);if(r)return this.parseSyncData(r,s.syncResource)?.machineId}return}return(0,T.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(t){const s=this.resolveUri(t);if(!s||s.node===Be.NOT_EXISTING_RESOURCE)return null;if(s.ref){const r=await this.getContentFromStore(s.remote,s.syncResource,s.profile,s.collection,s.ref);return s.node&&r?this.resolveNodeContent(s.syncResource,r,s.node):r}return!s.remote&&!s.node?this.resolveLatestContent(s.syncResource,s.profile):null}async getContentFromStore(t,s,r,l,a){if(t){const{content:P}=await this.getUserData(s,a,l);return P}const g=this.userDataProfilesService.profiles.find(P=>P.id===r);return g?this.userDataSyncBackupStoreService.resolveContent(g,s,a):null}resolveNodeContent(t,s,r){const l=this.parseSyncData(s,t);switch(t){case"settings":return this.resolveSettingsNodeContent(l,r);case"keybindings":return this.resolveKeybindingsNodeContent(l,r);case"tasks":return this.resolveTasksNodeContent(l,r);case"snippets":return this.resolveSnippetsNodeContent(l,r);case"globalState":return this.resolveGlobalStateNodeContent(l,r);case"extensions":return this.resolveExtensionsNodeContent(l,r);case"profiles":return this.resolveProfileNodeContent(l,r)}}async resolveLatestContent(t,s){const r=this.userDataProfilesService.profiles.find(l=>l.id===s);if(!r)return null;switch(t){case"globalState":return this.resolveLatestGlobalStateContent(r);case"extensions":return this.resolveLatestExtensionsContent(r);case"profiles":return this.resolveLatestProfilesContent(r);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}getSettingsAssociatedResources(t,s){const r=this.extUri.joinPath(t,"settings.json"),l=s?s.settingsResource:this.extUri.joinPath(t,Be.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:l}]}resolveSettingsNodeContent(t,s){switch(s){case"settings.json":return(0,m.parseSettingsSyncContent)(t.content).settings}return null}getKeybindingsAssociatedResources(t,s){const r=this.extUri.joinPath(t,"keybindings.json"),l=s?s.keybindingsResource:this.extUri.joinPath(t,Be.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:l}]}resolveKeybindingsNodeContent(t,s){switch(s){case"keybindings.json":return(0,f.getKeybindingsContentFromSyncContent)(t.content,!!this.configurationService.getValue(w.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(t,s){const r=this.extUri.joinPath(t,"tasks.json"),l=s?s.tasksResource:this.extUri.joinPath(t,Be.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:l}]}resolveTasksNodeContent(t,s){switch(s){case"tasks.json":return(0,y.getTasksContentFromSyncContent)(t.content,this.logService)}return null}async getSnippetsAssociatedResources(t,s){const r=await this.resolveContent(t);if(r){const l=this.parseSyncData(r,"snippets");if(l){const a=(0,S.parseSnippets)(l),g=[];for(const P of Object.keys(a)){const A=this.extUri.joinPath(t,P),V=s?this.extUri.joinPath(s.snippetsHome,P):this.extUri.joinPath(t,Be.NOT_EXISTING_RESOURCE);g.push({resource:A,comparableResource:V})}return g}}return[]}resolveSnippetsNodeContent(t,s){return(0,S.parseSnippets)(t)[s]||null}getExtensionsAssociatedResources(t,s){const r=this.extUri.joinPath(t,"extensions.json"),l=s?this.toUri({remote:!1,syncResource:"extensions",profile:s.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,Be.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:l}]}resolveExtensionsNodeContent(t,s){switch(s){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(t),!0)}return null}async resolveLatestExtensionsContent(t){const{localExtensions:s}=await this.instantiationService.createInstance(u.LocalExtensionsProvider).getLocalExtensions(t);return(0,u.stringify)(s,!0)}getGlobalStateAssociatedResources(t,s){const r=this.extUri.joinPath(t,"globalState.json"),l=s?this.toUri({remote:!1,syncResource:"globalState",profile:s.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,Be.NOT_EXISTING_RESOURCE);return[{resource:r,comparableResource:l}]}resolveGlobalStateNodeContent(t,s){switch(s){case"globalState.json":return(0,p.stringify)(JSON.parse(t.content),!0)}return null}async resolveLatestGlobalStateContent(t){const s=await this.instantiationService.createInstance(p.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,p.stringify)(s,!0)}getProfilesAssociatedResources(t,s){const r=this.extUri.joinPath(t,"profiles.json"),l=this.toUri({remote:!1,syncResource:"profiles",profile:this.userDataProfilesService.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:r,comparableResource:l}]}resolveProfileNodeContent(t,s){switch(s){case"profiles.json":return(0,d.toFormattedString)(JSON.parse(t.content),{})}return null}async resolveLatestProfilesContent(t){return(0,h.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(s=>!s.isDefault&&!s.isTransient),!0)}toUri(t){const s=t.remote?Be.REMOTE_BACKUP_AUTHORITY:Be.LOCAL_BACKUP_AUTHORITY,r=[t.syncResource,t.profile];return t.collection&&r.push(`collection:${t.collection}`),t.ref&&r.push(`ref:${t.ref}`),t.node&&r.push(t.node),this.extUri.joinPath(D.URI.from({scheme:w.USER_DATA_SYNC_SCHEME,authority:s,path:"/"}),...r)}resolveUri(t){if(t.scheme!==w.USER_DATA_SYNC_SCHEME||t.authority!==Be.LOCAL_BACKUP_AUTHORITY&&t.authority!==Be.REMOTE_BACKUP_AUTHORITY)return;const s=[];for(;t.path!=="/";)s.unshift(this.extUri.basename(t)),t=this.extUri.dirname(t);if(s.length<2)return;const r=t.authority===Be.REMOTE_BACKUP_AUTHORITY,l=s.shift(),a=s.shift();let g,P,A;for(;s.length;){const V=s.shift();V.startsWith("collection:")?g=V.substring(11):V.startsWith("ref:")?P=V.substring(4):A=V}return{remote:r,syncResource:l,profile:a,collection:g,ref:P,node:A}}parseSyncData(t,s){try{const r=JSON.parse(t);if((0,b.isSyncData)(r))return r}catch(r){this.logService.error(r)}throw new w.UserDataSyncError((0,i.localize)(0,null),"IncompatibleRemoteContent",s)}async getUserData(t,s,r){const l=await this.userDataSyncStoreService.resolveResourceContent(t,s,r);return{ref:s,content:l}}};n.NOT_EXISTING_RESOURCE="not-existing-resource",n.REMOTE_BACKUP_AUTHORITY="remote-backup",n.LOCAL_BACKUP_AUTHORITY="local-backup",n=ve([K(0,w.IUserDataSyncStoreService),K(1,w.IUserDataSyncBackupStoreService),K(2,w.IUserDataSyncLogService),K(3,C.IUriIdentityService),K(4,R.IEnvironmentService),K(5,I.IStorageService),K(6,k.IFileService),K(7,E.IUserDataProfilesService),K(8,v.IConfigurationService),K(9,c.IInstantiationService)],n),e.UserDataSyncResourceProviderService=n}),define(re[273],se([0,1,19,6,22,37,3,2,20,15,30,16,13,29,4,25,18,24,21,123,124,118,119,120,121,122,26]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u,p,c,h,d,n,o,t,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const l="sync.lastSyncTime";let a=class extends I.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(O,F,N,L,U,$,x,j,B,W,q){super(),this.userDataSyncStoreService=O,this.userDataSyncStoreManagementService=F,this.instantiationService=N,this.logService=L,this.telemetryService=U,this.storageService=$,this.userDataSyncEnablementService=x,this.userDataProfilesService=j,this.productService=B,this.environmentService=W,this.userDataSyncResourceProviderService=q,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=F.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(l,-1,void 0),this._register((0,I.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(O,F){this.checkEnablement(),this.logService.info("Sync started.");const N=new Date().getTime(),L=(0,E.generateUuid)();try{const j=(0,r.createSyncHeaders)(L);F&&(j["Cache-Control"]="no-cache"),O=await this.userDataSyncStoreService.manifest(O,j)}catch(j){const B=r.UserDataSyncError.toUserDataSyncError(j);throw A(B,L,this.userDataSyncStoreManagementService,this.telemetryService),B}const U=!1,$=this;let x;return{manifest:O,async run(){if(U)throw new Error("Can run a task only once");x=(0,i.createCancelablePromise)(j=>$.sync(O,!1,L,j)),await x.finally(()=>x=void 0),$.logService.info(`Sync done. Took ${new Date().getTime()-N}ms`),$.updateLastSyncTime()},stop(){return x?.cancel(),$.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new r.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const O=new Date().getTime(),F=(0,E.generateUuid)(),N=(0,r.createSyncHeaders)(F);let L;try{L=await this.userDataSyncStoreService.manifest(null,N)}catch(x){const j=r.UserDataSyncError.toUserDataSyncError(x);throw A(j,F,this.userDataSyncStoreManagementService,this.telemetryService),j}await this.resetLocal();const U=this,$=new R.CancellationTokenSource;return{id:F,async merge(){return U.sync(L,!0,F,$.token)},async apply(){await U.applyManualSync(L,F,$.token),U.logService.info(`Sync done. Took ${new Date().getTime()-O}ms`),U.updateLastSyncTime()},stop(){return $.cancel(),U.stop()},dispose(){$.cancel(),U.stop()}}}async sync(O,F,N,L){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const U=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(U,O,F,N,L));const $=U.enabled.find(x=>x.resource==="profiles");if($){const x=await $.getLastSyncedProfiles()||[];if(L.isCancellationRequested)return;await this.syncRemoteProfiles(x,O,F,N,L)}}finally{this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(O,F,N,L,U){for(const $ of O){if(U.isCancellationRequested)return;const x=this.userDataProfilesService.profiles.find(B=>B.id===$.id);if(!x){this.logService.error(`Settings Profile with id:${$.id} and name: ${$.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",$.name);const j=this.getOrCreateActiveProfileSynchronizer(x,$);this._syncErrors.push(...await this.syncProfile(j,F,N,L,U))}}async applyManualSync(O,F,N){const L=this.getActiveProfileSynchronizers();for(const B of L){if(N.isCancellationRequested)return;await B.apply(F,N)}const U=L.find(B=>B.profile.isDefault);if(!U)return;const $=U.enabled.find(B=>B.resource==="profiles");if(!$)return;const j=(await $.getRemoteSyncedProfiles(O?.latest??null)||[]).filter(B=>L.every(W=>W.profile.id!==B.id));j.length&&await this.syncRemoteProfiles(j,O,!1,F,N)}async syncProfile(O,F,N,L,U){return(await O.sync(F,N,L,U)).map(([x,j])=>({profile:O.profile,syncResource:x,error:j}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(O=>O.stop()))}async resolveContent(O){const F=await this.userDataSyncResourceProviderService.resolveContent(O);if(F)return F;for(const N of this.getActiveProfileSynchronizers())for(const L of N.enabled){const U=await L.resolveContent(O);if(U)return U}return null}async replace(O){this.checkEnablement();const F=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(O);if(!F)return;const N=await this.resolveContent(O.uri);!N||await this.performAction(F.profile,async L=>{if(F.syncResource===L.resource)return await L.replace(N),!0})}async accept(O,F,N,L){this.checkEnablement(),await this.performAction(O.profile,async U=>{if(O.syncResource===U.resource)return await U.accept(F,N),L&&await U.apply((0,w.isBoolean)(L)?!1:L.force,(0,r.createSyncHeaders)((0,E.generateUuid)())),!0})}getRemoteProfiles(){return this.userDataSyncResourceProviderService.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(O,F){return this.userDataSyncResourceProviderService.getRemoteSyncResourceHandles(O,F)}async getLocalSyncResourceHandles(O,F){return this.userDataSyncResourceProviderService.getLocalSyncResourceHandles(O,F??this.userDataProfilesService.defaultProfile)}async getAssociatedResources(O){return this.userDataSyncResourceProviderService.getAssociatedResources(O)}async getMachineId(O){return this.userDataSyncResourceProviderService.getMachineId(O)}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async F=>{if(F.resource!=="globalState"&&await F.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async F=>{if(await F.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(O){this.logService.error(O)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this.storageService.remove(l,-1);for(const[O]of this.activeProfileSynchronizers.values())try{await O.resetLocal()}catch(F){this.logService.error(F)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performAction(O,F){const N=new I.DisposableStore;try{const L=this.activeProfileSynchronizers.get(O.id);if(L){const B=await this.performActionWithProfileSynchronizer(L[0],F,N);return(0,w.isUndefined)(B)?null:B}if(O.isDefault){const B=N.add(this.instantiationService.createInstance(g,O,void 0)),W=await this.performActionWithProfileSynchronizer(B,F,N);return(0,w.isUndefined)(W)?null:W}if(this.userDataProfilesService.isEnabled()||this.environmentService.isBuilt&&(!this.productService.enableSyncingProfiles||(0,C.isEqual)(this.userDataSyncStoreManagementService.userDataSyncStore?.url,this.userDataSyncStoreManagementService.userDataSyncStore?.stableUrl)))return null;const U=N.add(this.instantiationService.createInstance(s.UserDataProfilesManifestSynchroniser,O,void 0)),$=await this.userDataSyncStoreService.manifest(null),j=(await U.getRemoteSyncedProfiles($?.latest??null)||[]).find(B=>B.id===O.id);if(j){const B=N.add(this.instantiationService.createInstance(g,O,j.collection)),W=await this.performActionWithProfileSynchronizer(B,F,N);return(0,w.isUndefined)(W)?null:W}return null}finally{N.dispose()}}async performActionWithProfileSynchronizer(O,F,N){const L=[...O.enabled,...O.disabled.map(U=>N.add(O.createSynchronizer(U)))];for(const U of L){const $=await F(U);if(!(0,w.isUndefined)($))return $}}setStatus(O){const F=this._status;this._status!==O&&(this._status=O,this._onDidChangeStatus.fire(O),F==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const O=this.getActiveProfileSynchronizers().map(F=>F.conflicts).flat();(0,D.equals)(this._conflicts,O,(F,N)=>F.profile.id===N.profile.id&&F.syncResource===N.syncResource&&(0,D.equals)(F.conflicts,N.conflicts,(L,U)=>(0,C.isEqual)(L.previewResource,U.previewResource)))||(this._conflicts=O,this._onDidChangeConflicts.fire(O))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(l,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(O,F){let N=this.activeProfileSynchronizers.get(O.id);if(!N){const L=new I.DisposableStore,U=L.add(this.instantiationService.createInstance(g,O,F?.collection));L.add(U.onDidChangeStatus($=>this.setStatus($))),L.add(U.onDidChangeConflicts($=>this.updateConflicts())),L.add(U.onDidChangeLocal($=>this._onDidChangeLocal.fire($))),this.activeProfileSynchronizers.set(O.id,N=[U,L])}return N[0]}getActiveProfileSynchronizers(){const O=[];for(const[F]of this.activeProfileSynchronizers.values())O.push(F);return O}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,O])=>O.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};a=ve([K(0,r.IUserDataSyncStoreService),K(1,r.IUserDataSyncStoreManagementService),K(2,f.IInstantiationService),K(3,r.IUserDataSyncLogService),K(4,u.ITelemetryService),K(5,y.IStorageService),K(6,r.IUserDataSyncEnablementService),K(7,p.IUserDataProfilesService),K(8,v.IProductService),K(9,S.IEnvironmentService),K(10,r.IUserDataSyncResourceProviderService)],a),e.UserDataSyncService=a;let g=class extends I.Disposable{get enabled(){return this._enabled.sort((O,F)=>O[1]-F[1]).map(([O])=>O)}get disabled(){return r.ALL_SYNC_RESOURCES.filter(O=>!this.userDataSyncEnablementService.isResourceEnabled(O))}get status(){return this._status}get conflicts(){return this._conflicts}get profile(){return this._profile}constructor(O,F,N,L,U,$,x,j,B,W,q,Y){super(),this._profile=O,this.collection=F,this.userDataSyncEnablementService=N,this.instantiationService=L,this.extensionGalleryService=U,this.userDataSyncStoreManagementService=$,this.telemetryService=x,this.logService=j,this.productService=B,this.userDataProfilesService=W,this.configurationService=q,this.environmentService=Y,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(N.onDidChangeResourceEnablement(([ee,ce])=>this.onDidChangeResourceEnablement(ee,ce))),this._register((0,I.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,ee])=>ee.dispose())));for(const ee of r.ALL_SYNC_RESOURCES)N.isResourceEnabled(ee)&&this.registerSynchronizer(ee)}onDidChangeResourceEnablement(O,F){F?this.registerSynchronizer(O):this.deRegisterSynchronizer(O)}registerSynchronizer(O){if(this._enabled.some(([U])=>U.resource===O))return;if(O==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(O==="profiles"){if(!this._profile.isDefault||!this.userDataProfilesService.isEnabled())return;if(this.environmentService.isBuilt&&(!this.productService.enableSyncingProfiles||(0,C.isEqual)(this.userDataSyncStoreManagementService.userDataSyncStore?.url,this.userDataSyncStoreManagementService.userDataSyncStore?.stableUrl))){this.logService.debug("Skipping profiles sync");return}}const F=new I.DisposableStore,N=F.add(this.createSynchronizer(O));F.add(N.onDidChangeStatus(()=>this.updateStatus())),F.add(N.onDidChangeConflicts(()=>this.updateConflicts())),F.add(N.onDidChangeLocal(()=>this._onDidChangeLocal.fire(O)));const L=this.getOrder(O);this._enabled.push([N,L,F])}deRegisterSynchronizer(O){const F=this._enabled.findIndex(([N])=>N.resource===O);if(F!==-1){const N=this._enabled.splice(F,1);for(const[L,,U]of N){if(L.status!=="idle"){const $=L.conflicts.conflicts.length>0;L.stop(),$&&this.updateConflicts(),this.updateStatus()}U.dispose()}}}createSynchronizer(O){switch(O){case"settings":return this.instantiationService.createInstance(n.SettingsSynchroniser,this._profile,this.collection);case"keybindings":return this.instantiationService.createInstance(d.KeybindingsSynchroniser,this._profile,this.collection);case"snippets":return this.instantiationService.createInstance(o.SnippetsSynchroniser,this._profile,this.collection);case"tasks":return this.instantiationService.createInstance(t.TasksSynchroniser,this._profile,this.collection);case"globalState":return this.instantiationService.createInstance(h.GlobalStateSynchroniser,this._profile,this.collection);case"extensions":return this.instantiationService.createInstance(c.ExtensionsSynchroniser,this._profile,this.collection);case"profiles":return this.instantiationService.createInstance(s.UserDataProfilesManifestSynchroniser,this._profile,this.collection)}}async sync(O,F,N,L){if(L.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const $=[],x=(0,r.createSyncHeaders)(N),j=(this.collection?O?.collections?.[this.collection]?.latest:O?.latest)??null,B=F?await this.getUserDataSyncConfiguration(j):{};for(const W of U){if(L.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(W.resource))return[];try{if(F){const q=await W.preview(j,B,x);if(q)for(const Y of q.resourcePreviews)(Y.localChange!==0||Y.remoteChange!==0)&&Y.mergeState==="preview"&&await W.merge(Y.previewResource)}else await W.sync(j,x)}catch(q){const Y=r.UserDataSyncError.toUserDataSyncError(q);if(A(Y,N,this.userDataSyncStoreManagementService,this.telemetryService),P(q))throw Y;this.logService.error(q),this.logService.error(`${W.resource}: ${(0,k.toErrorMessage)(q)}`),$.push([W.resource,Y])}}return $}finally{this.updateStatus()}}async apply(O,F){const N=(0,r.createSyncHeaders)(O);for(const L of this.enabled){if(F.isCancellationRequested)return;try{await L.apply(!1,N)}catch(U){const $=r.UserDataSyncError.toUserDataSyncError(U);if(A($,O,this.userDataSyncStoreManagementService,this.telemetryService),P(U))throw $;this.logService.error(U),this.logService.error(`${L.resource}: ${(0,k.toErrorMessage)(U)}`)}}}async stop(){for(const O of this.enabled)try{O.status!=="idle"&&await O.stop()}catch(F){this.logService.error(F)}}async resetLocal(){for(const O of this.enabled)try{await O.resetLocal()}catch(F){this.logService.error(`${O.resource}: ${(0,k.toErrorMessage)(F)}`),this.logService.error(F)}}async getUserDataSyncConfiguration(O){if(!this.profile.isDefault)return{};const F=this.configurationService.getValue(r.USER_DATA_SYNC_CONFIGURATION_SCOPE),N=this.enabled.find(L=>L instanceof n.SettingsSynchroniser);if(N){const L=await N.getRemoteUserDataSyncConfiguration(O);return{...F,...L}}return F}setStatus(O){this._status!==O&&(this._status=O,this._onDidChangeStatus.fire(O))}updateStatus(){return this.updateConflicts(),this.enabled.some(O=>O.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(O=>O.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const O=this.enabled.filter(F=>F.status==="hasConflicts").filter(F=>F.conflicts.conflicts.length>0).map(F=>F.conflicts);(0,D.equals)(this._conflicts,O,(F,N)=>F.syncResource===N.syncResource&&(0,D.equals)(F.conflicts,N.conflicts,(L,U)=>(0,C.isEqual)(L.previewResource,U.previewResource)))||(this._conflicts=O,this._onDidChangeConflicts.fire(O))}getOrder(O){switch(O){case"profiles":return 0;case"settings":return 1;case"keybindings":return 2;case"snippets":return 3;case"tasks":return 4;case"globalState":return 5;case"extensions":return 6}}};g=ve([K(2,r.IUserDataSyncEnablementService),K(3,f.IInstantiationService),K(4,m.IExtensionGalleryService),K(5,r.IUserDataSyncStoreManagementService),K(6,u.ITelemetryService),K(7,r.IUserDataSyncLogService),K(8,v.IProductService),K(9,p.IUserDataProfilesService),K(10,b.IConfigurationService),K(11,S.IEnvironmentService)],g);function P(V){if(V instanceof r.UserDataSyncError)switch(V.code){case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function A(V,O,F,N){N.publicLog2("sync/error",{code:V.code,serverCode:V instanceof r.UserDataSyncStoreError?String(V.serverCode):void 0,url:V instanceof r.UserDataSyncStoreError?V.url:void 0,resource:V.resource,executionId:O,service:F.userDataSyncStore.url.toString()})}}),define(re[274],se([0,1,3,2,8,21,26]),function(Q,e,D,i,R,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function I(S,m){return{...S,profile:(0,k.reviveProfile)(S.profile,m.profilesHome.scheme)}}function C(S){return{created:S.created,uri:R.URI.revive(S.uri)}}class w{constructor(m,f,v){this.service=m,this.userDataProfilesService=f,this.logService=v,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(m,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(m,f,v){try{return await this._call(m,f,v)}catch(y){throw this.logService.error(y),y}}async _call(m,f,v){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(R.URI.revive(v[0]));case"accept":return this.service.accept(I(v[0],this.userDataProfilesService),R.URI.revive(v[1]),v[2],v[3]);case"getRemoteProfiles":return this.service.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(v[0],(0,k.reviveProfile)(v[1],this.userDataProfilesService.profilesHome.scheme));case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(v[0],v[1]);case"replace":return this.service.replace(C(v[0]));case"getAssociatedResources":return this.service.getAssociatedResources(C(v[0]));case"getMachineId":return this.service.getMachineId(C(v[0]));case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const y=f.substring(11),u=v[0],p=this.getManualSyncTask(u);switch(v=v.slice(1),y){case"merge":return p.merge();case"apply":return p.apply();case"stop":return p.stop();case"dispose":return this.disposeManualSyncTask(p)}}throw new Error("Invalid call")}getManualSyncTask(m){const f=this.manualSyncTasks.get(this.createKey(m));if(!f)throw new Error(`Manual sync taks not found: ${m}`);return f.manualSyncTask}async createManualSyncTask(){const m=new i.DisposableStore,f=m.add(await this.service.createManualSyncTask());return this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:m}),f.id}disposeManualSyncTask(m){m.dispose();const f=this.createKey(m.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(m){return`manualSyncTask-${m}`}}e.UserDataSyncChannel=w;let E=class extends i.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(m,f){super(),this.userDataProfilesService=f,this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(v,y,u){return m.call(v,y,u).then(null,p=>{throw T.UserDataSyncError.toUserDataSyncError(p)})},listen(v,y){return m.listen(v,y)}},this.channel.call("_getInitialData").then(([v,y,u])=>{this.updateStatus(v),this.updateConflicts(y),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(p=>this.updateStatus(p))),this._register(this.channel.listen("onDidChangeLastSyncTime")(p=>this.updateLastSyncTime(p)))}),this._register(this.channel.listen("onDidChangeConflicts")(v=>this.updateConflicts(v))),this._register(this.channel.listen("onSyncErrors")(v=>this._onSyncErrors.fire(v.map(y=>({...y,error:T.UserDataSyncError.toUserDataSyncError(y.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const m=await this.channel.call("createManualSyncTask"),f=this;return new b(m,{async call(y,u,p){return f.channel.call(`manualSync/${y}`,[m,...Array.isArray(u)?u:[u]],p)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(m,f,v,y){return this.channel.call("accept",[m,f,v,y])}resolveContent(m){return this.channel.call("resolveContent",[m])}getRemoteProfiles(){return this.channel.call("getRemoteProfiles")}async getLocalSyncResourceHandles(m,f){return(await this.channel.call("getLocalSyncResourceHandles",[m,f])).map(({created:y,uri:u})=>({created:y,uri:R.URI.revive(u)}))}async getRemoteSyncResourceHandles(m,f){return(await this.channel.call("getRemoteSyncResourceHandles",[m,f])).map(({created:y,uri:u})=>({created:y,uri:R.URI.revive(u)}))}async getAssociatedResources(m){return(await this.channel.call("getAssociatedResources",[m])).map(({resource:v,comparableResource:y})=>({resource:R.URI.revive(v),comparableResource:R.URI.revive(y)}))}getMachineId(m){return this.channel.call("getMachineId",[m])}replace(m){return this.channel.call("replace",[m])}async updateStatus(m){this._status=m,this._onDidChangeStatus.fire(m)}async updateConflicts(m){this._conflicts=m.map(f=>({syncResource:f.syncResource,profile:(0,k.reviveProfile)(f.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:f.conflicts.map(v=>({...v,baseResource:R.URI.revive(v.baseResource),localResource:R.URI.revive(v.localResource),remoteResource:R.URI.revive(v.remoteResource),previewResource:R.URI.revive(v.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(m){this._lastSyncTime!==m&&(this._lastSyncTime=m,this._onDidChangeLastSyncTime.fire(m))}};E=ve([K(1,k.IUserDataProfilesService)],E),e.UserDataSyncChannelClient=E;class b extends i.Disposable{constructor(m,f){super(),this.id=m,this.channel=f}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(re[275],se([0,1,6,22,11,3,2,139,5,20,15,8,30,16,13,14,25,47,44,18,26]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u,p,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const d="sync.previous.store",n="sync.donot-make-requests-until",o="sync.user-session-id",t="sync.machine-session-id",s=100,r=1e3*60*5;let l=class extends T.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(h.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(O){this.storageService.store(h.SYNC_SERVICE_URL_TYPE,O,-1,C.isWeb?0:1)}constructor(O,F,N){super(),this.productService=O,this.configurationService=F,this.storageService=N,this._onDidChangeUserDataSyncStore=this._register(new k.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(k.Event.filter(N.onDidChangeValue,L=>L.key===h.SYNC_SERVICE_URL_TYPE&&L.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[h.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(h.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,F){O=C.isWeb&&O?.web?{...O,...O.web}:O;const N={...O||{},...F||{}};if(N&&(0,E.isString)(N.url)&&(0,E.isObject)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(L=>Array.isArray(N.authenticationProviders[L].scopes))){const L=N,U=!!L.canSwitch&&!F?.url,$=L.url===L.insidersUrl?"insiders":"stable",x=(U?this.userDataSyncStoreType:void 0)||$,j=F?.url||(x==="insiders"?L.insidersUrl:x==="stable"?L.stableUrl:L.url);return{url:b.URI.parse(j),type:x,defaultType:$,defaultUrl:b.URI.parse(L.url),stableUrl:b.URI.parse(L.stableUrl),insidersUrl:b.URI.parse(L.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(L.authenticationProviders).reduce((B,W)=>(B.push({id:W,scopes:L.authenticationProviders[W].scopes}),B),[])}}}};l=ve([K(0,y.IProductService),K(1,m.IConfigurationService),K(2,c.IStorageService)],l),e.AbstractUserDataSyncStoreManagementService=l;let a=class extends l{constructor(O,F,N){super(O,F,N);const L=this.storageService.get(d,-1);L&&(this.previousConfigurationSyncStore=JSON.parse(L));const U=this.productService[h.CONFIGURATION_SYNC_STORE_KEY];U?this.storageService.store(d,JSON.stringify(U),-1,1):this.storageService.remove(d,-1)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};a=ve([K(0,y.IProductService),K(1,m.IConfigurationService),K(2,c.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let g=class extends T.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(O,F,N,L,U,$,x){super(),this.requestService=N,this.logService=L,this.storageService=x,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new k.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new k.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,p.getServiceMachineId)(U,$,x).then(j=>{const B={"X-Client-Name":`${F.applicationName}${C.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(B["X-Client-Commit"]=F.commit),B}),this.session=new A(s,r,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,T.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(O,F){this.authToken={token:O,type:F}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,w.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(n,-1);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(n,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(F=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(n,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,w.joinPath)(this.userDataSyncStoreUrl,"collection").toString();O={...O},O["Content-Type"]="application/json";const N=await this.request(F,{type:"GET",headers:O},[],i.CancellationToken.None);return await(0,u.asJson)(N)||[]}async createCollection(O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,w.joinPath)(this.userDataSyncStoreUrl,"collection").toString();O={...O},O["Content-Type"]=I.Mimes.text;const N=await this.request(F,{type:"POST",headers:O},[],i.CancellationToken.None),L=await(0,u.asTextOrError)(N);if(!L)throw new h.UserDataSyncStoreError("Server did not return the collection id",F,"NoCollection",N.res.statusCode,N.res.headers[h.HEADER_OPERATION_ID]);return L}async deleteCollection(O,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=O?(0,w.joinPath)(this.userDataSyncStoreUrl,"collection",O).toString():(0,w.joinPath)(this.userDataSyncStoreUrl,"collection").toString();F={...F},await this.request(N,{type:"DELETE",headers:F},[],i.CancellationToken.None)}async getAllResourceRefs(O,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=this.getResourceUrl(this.userDataSyncStoreUrl,F,O),L={},U=await this.request(N.toString(),{type:"GET",headers:L},[],i.CancellationToken.None);return(await(0,u.asJson)(U)||[]).map(({url:x,created:j})=>({ref:(0,w.relativePath)(N,N.with({path:x})),created:j*1e3}))}async resolveResourceContent(O,F,N,L={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,w.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,N,O),F).toString();L={...L},L["Cache-Control"]="no-cache";const $=await this.request(U,{type:"GET",headers:L},[],i.CancellationToken.None);return await(0,u.asTextOrError)($)}async deleteResource(O,F,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const L=F!==null?(0,w.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,N,O),F).toString():this.getResourceUrl(this.userDataSyncStoreUrl,N,O).toString(),U={};await this.request(L,{type:"DELETE",headers:U},[],i.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,w.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":I.Mimes.text};await this.request(O,{type:"DELETE",headers:F},[],i.CancellationToken.None)}async readResource(O,F,N,L={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,w.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,N,O),"latest").toString();L={...L},L["Cache-Control"]="no-cache",F&&(L["If-None-Match"]=F.ref);const $=await this.request(U,{type:"GET",headers:L},[304],i.CancellationToken.None);let x=null;if($.res.statusCode===304&&(x=F),x===null){const j=$.res.headers.etag;if(!j)throw new h.UserDataSyncStoreError("Server did not return the ref",U,"NoRef",$.res.statusCode,$.res.headers[h.HEADER_OPERATION_ID]);const B=await(0,u.asTextOrError)($);if(!B&&$.res.statusCode===304)throw new h.UserDataSyncStoreError("Empty response",U,"EmptyResponse",$.res.statusCode,$.res.headers[h.HEADER_OPERATION_ID]);x={ref:j,content:B}}return x}async writeResource(O,F,N,L,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=this.getResourceUrl(this.userDataSyncStoreUrl,L,O).toString();U={...U},U["Content-Type"]=I.Mimes.text,N&&(U["If-Match"]=N);const x=await this.request($,{type:"POST",data:F,headers:U},[],i.CancellationToken.None),j=x.res.headers.etag;if(!j)throw new h.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",x.res.statusCode,x.res.headers[h.HEADER_OPERATION_ID]);return j}async manifest(O,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,w.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",O&&(F["If-None-Match"]=O.ref);const L=await this.request(N,{type:"GET",headers:F},[304],i.CancellationToken.None);let U=null;if(L.res.statusCode===304&&(U=O),!U){const x=L.res.headers.etag;if(!x)throw new h.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",L.res.statusCode,L.res.headers[h.HEADER_OPERATION_ID]);const j=await(0,u.asTextOrError)(L);if(!j&&L.res.statusCode===304)throw new h.UserDataSyncStoreError("Empty response",N,"EmptyResponse",L.res.statusCode,L.res.headers[h.HEADER_OPERATION_ID]);j&&(U={...JSON.parse(j),ref:x})}const $=this.storageService.get(o,-1);return $&&U&&$!==U.session&&this.clearSession(),U===null&&$&&this.clearSession(),U&&this.storageService.store(o,U.session,-1,1),U}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteResources(),await this.deleteCollection(),this.clearSession()}getResourceUrl(O,F,N){return F?(0,w.joinPath)(O,"collection",F,"resource",N):(0,w.joinPath)(O,"resource",N)}clearSession(){this.storageService.remove(o,-1),this.storageService.remove(t,-1)}async request(O,F,N,L){if(!this.authToken)throw new h.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new h.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const U=await this.commonHeadersPromise;F.headers={...F.headers||{},...U,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:O,type:F.type,headers:{...F.headers,authorization:void 0}});let $;try{$=await this.session.request(O,F,L)}catch(W){if(!(W instanceof h.UserDataSyncStoreError)){let q="RequestFailed";const Y=(0,R.getErrorMessage)(W).toLowerCase();Y.includes("xhr timeout")?q="RequestTimeout":Y.includes("protocol")&&Y.includes("not supported")?q="RequestProtocolNotSupported":Y.includes("request path contains unescaped characters")?q="RequestPathNotEscaped":Y.includes("headers must be an object")?q="RequestHeadersNotObject":(0,R.isCancellationError)(W)&&(q="RequestCanceled"),W=new h.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,q,void 0,void 0)}throw this.logService.info("Request failed",O),W}const x=$.res.headers[h.HEADER_OPERATION_ID],j={url:O,status:$.res.statusCode,"execution-id":F.headers[h.HEADER_EXECUTION_ID],"operation-id":x},B=(0,u.isSuccess)($)||$.res.statusCode&&N.indexOf($.res.statusCode)!==-1;if(B?this.logService.trace("Request succeeded",j):this.logService.info("Request failed",j),$.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new h.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",$.res.statusCode,x);if(this._onTokenSucceed.fire(),$.res.statusCode===409)throw new h.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",$.res.statusCode,x);if($.res.statusCode===410)throw new h.UserDataSyncStoreError(`${F.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",$.res.statusCode,x);if($.res.statusCode===412)throw new h.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",$.res.statusCode,x);if($.res.statusCode===413)throw new h.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",$.res.statusCode,x);if($.res.statusCode===426)throw new h.UserDataSyncStoreError(`${F.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",$.res.statusCode,x);if($.res.statusCode===429){const W=$.res.headers["retry-after"];throw W?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(W)*1e3)),new h.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",$.res.statusCode,x)):new h.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",$.res.statusCode,x)}if(!B)throw new h.UserDataSyncStoreError("Server returned "+$.res.statusCode,O,"Unknown",$.res.statusCode,x);return $}addSessionHeaders(O){let F=this.storageService.get(t,-1);F===void 0&&(F=(0,S.generateUuid)(),this.storageService.store(t,F,-1,1)),O["X-Machine-Session-Id"]=F;const N=this.storageService.get(o,-1);N!==void 0&&(O["X-User-Session-Id"]=N)}};g=ve([K(1,y.IProductService),K(2,u.IRequestService),K(3,h.IUserDataSyncLogService),K(4,f.IEnvironmentService),K(5,v.IFileService),K(6,c.IStorageService)],g),e.UserDataSyncStoreClient=g;let P=class extends g{constructor(O,F,N,L,U,$,x){super(O.userDataSyncStore?.url,F,N,L,U,$,x),this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};P=ve([K(0,h.IUserDataSyncStoreManagementService),K(1,y.IProductService),K(2,u.IRequestService),K(3,h.IUserDataSyncLogService),K(4,f.IEnvironmentService),K(5,v.IFileService),K(6,c.IStorageService)],P),e.UserDataSyncStoreService=P;class A{constructor(O,F,N,L){this.limit=O,this.interval=F,this.requestService=N,this.logService=L,this.requests=[],this.startTime=void 0}request(O,F,N){if(this.isExpired()&&this.reset(),F.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new h.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(F,N)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(re[276],se([0,1,3,58,25,18,24,271,26,76,79]),function(Q,e,D,i,R,k,T,I,C,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends I.UserDataAutoSyncService{constructor(m,f,v,y,u,p,c,h,d,n,o){super(m,f,v,y,u,c,h,d,n,o),this._register(D.Event.debounce(D.Event.any(D.Event.map(p.onDidFocusWindow,()=>"windowFocus"),D.Event.map(p.onDidOpenWindow,()=>"windowOpen")),(t,s)=>t?[...t,s]:[s],1e3)(t=>this.triggerSync(t,!0,!1)))}};b=ve([K(0,R.IProductService),K(1,C.IUserDataSyncStoreManagementService),K(2,C.IUserDataSyncStoreService),K(3,C.IUserDataSyncEnablementService),K(4,C.IUserDataSyncService),K(5,i.INativeHostService),K(6,C.IUserDataSyncLogService),K(7,w.IUserDataSyncAccountService),K(8,T.ITelemetryService),K(9,E.IUserDataSyncMachinesService),K(10,k.IStorageService)],b),e.UserDataAutoSyncService=b}),define(re[277],se([0,1,3,2,57,7,62,18,74,21]),function(Q,e,D,i,R,k,T,I,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncProfilesStorageService=void 0;let E=class extends T.AbstractUserDataSyncProfilesStorageService{constructor(S,m,f,v){super(f),this.mainProcessService=S;const y=S.getChannel("profileStorageListener"),u=this._register(new i.MutableDisposable);this._onDidChange=this._register(new D.Emitter({onWillAddFirstListener:()=>{u.value=y.listen("onDidChange")(p=>{v.trace("profile storage changes",p),this._onDidChange.fire({targetChanges:p.targetChanges.map(c=>(0,w.reviveProfile)(c,m.profilesHome.scheme)),valueChanges:p.valueChanges.map(c=>({...c,profile:(0,w.reviveProfile)(c.profile,m.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(S){const m=this.mainProcessService.getChannel("storage");return(0,I.isProfileUsingDefaultStorage)(S)?new C.ApplicationStorageDatabaseClient(m):new C.ProfileStorageDatabaseClient(m,S)}};E=ve([K(0,R.IMainProcessService),K(1,w.IUserDataProfilesService),K(2,I.IStorageService),K(3,k.ILogService)],E),e.UserDataSyncProfilesStorageService=E}),define(re[278],se([0,1,99,23,5,20]),function(Q,e,D,i,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function T(w){function E(){let b=w.scheme===i.Schemas.file?(0,k.originalFSPath)(w):w.toString();return R.isLinux||(b=b.toLowerCase()),(0,D.createHash)("md5").update(b).digest("hex")}return{id:E(),configPath:w}}e.getWorkspaceIdentifier=T;function I(w,E){function b(){if(w.scheme!==i.Schemas.file)return(0,D.createHash)("md5").update(w.toString()).digest("hex");if(!E)return;let m;return R.isLinux?m=E.ino:R.isMacintosh?m=E.birthtime.getTime():R.isWindows&&(typeof E.birthtimeMs=="number"?m=Math.floor(E.birthtimeMs):m=E.birthtime.getTime()),(0,D.createHash)("md5").update(w.fsPath).update(m?String(m):"").digest("hex")}const S=b();if(typeof S=="string")return{id:S,uri:w}}e.getSingleFolderWorkspaceIdentifier=I;function C(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=C}),define(re[279],se([0,1,6,11,2,12,28,13,57,7,58,74,116,278]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let f=class extends R.Disposable{constructor(y,u,p,c){super(),this.environmentService=y,this.logService=u,this.nativeHostService=p,this.mainProcessService=c,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const y=await T.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),u=new b.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(y.map(async p=>{const c=(0,k.join)(this.environmentService.workspaceStorageHome.fsPath,p);p.length===m.NON_EMPTY_WORKSPACE_ID_LENGTH||p===S.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(n=>n.workspace?.id===p)||await u.isUsed(c)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${p} as it seems to be an unused empty workspace.`),await T.Promises.rm(c))}))}catch(y){(0,i.onUnexpectedError)(y)}}};f=ve([K(0,I.INativeEnvironmentService),K(1,w.ILogService),K(2,E.INativeHostService),K(3,C.IMainProcessService)],f),e.UnusedWorkspaceStorageDataCleaner=f}),define(re[125],se([0,1,53,6,12,15,28,151,288,289]),function(Q,e,D,i,R,k,T,I,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class E extends Error{constructor(n,o){let t=o.message;switch(n){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=n,this.cause=o}}e.ExtractError=E;function b(d){const n=d.externalFileAttributes>>16||33188;return[448,56,7].map(o=>n&o).reduce((o,t)=>o+t,n&61440)}function S(d){if(d instanceof E)return d;let n;return/end of central directory record signature not found/.test(d.message)&&(n="CorruptZip"),new E(n,d)}function m(d,n,o,t,s,r){const l=R.dirname(n),a=R.join(t,l);if(!a.startsWith(t))return Promise.reject(new Error(I.localize(0,null,n)));const g=R.join(t,n);let P;return r.onCancellationRequested(()=>{P?.destroy()}),Promise.resolve(T.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((A,V)=>{if(!r.isCancellationRequested)try{P=(0,D.createWriteStream)(g,{mode:o}),P.once("close",()=>A()),P.once("error",V),d.once("error",V),d.pipe(P)}catch(O){V(O)}}))}function f(d,n,o,t){let s=(0,i.createCancelablePromise)(()=>Promise.resolve()),r=0;return t.onCancellationRequested(()=>{s.cancel(),d.close()}),new Promise((l,a)=>{const g=new i.Sequencer,P=A=>{A.isCancellationRequested||(r++,d.readEntry())};d.once("error",a),d.once("close",()=>s.then(()=>{t.isCancellationRequested||d.entryCount===r?l():a(new E("Incomplete",new Error(I.localize(1,null,r,d.entryCount))))},a)),d.readEntry(),d.on("entry",A=>{if(t.isCancellationRequested)return;if(!o.sourcePathRegex.test(A.fileName)){P(t);return}const V=A.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(V)){const N=R.join(n,V);s=(0,i.createCancelablePromise)(L=>T.Promises.mkdir(N,{recursive:!0}).then(()=>P(L)).then(void 0,a));return}const O=y(d,A),F=b(A);s=(0,i.createCancelablePromise)(N=>g.queue(()=>O.then(L=>m(L,V,F,n,o,N).then(()=>P(N)))).then(null,a))})})}function v(d,n=!1){return new Promise((o,t)=>{(0,C.open)(d,n?{lazyEntries:!0}:void 0,(s,r)=>{s?t(S(s)):o((0,k.assertIsDefined)(r))})})}function y(d,n){return new Promise((o,t)=>{d.openReadStream(n,(s,r)=>{s?t(S(s)):o((0,k.assertIsDefined)(r))})})}function u(d,n){return new Promise((o,t)=>{const s=new w.ZipFile;n.forEach(l=>{l.contents?s.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&s.addFile(l.localPath,l.path)}),s.end();const r=(0,D.createWriteStream)(d);s.outputStream.pipe(r),s.outputStream.once("error",t),r.once("error",t),r.once("finish",()=>o(d))})}e.zip=u;function p(d,n,o={},t){const s=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let r=v(d,!0);return o.overwrite&&(r=r.then(l=>T.Promises.rm(n).then(()=>l))),r.then(l=>f(l,n,{sourcePathRegex:s},t))}e.extract=p;function c(d,n){return v(d).then(o=>new Promise((t,s)=>{o.on("entry",r=>{r.fileName===n&&y(o,r).then(l=>t(l),l=>s(l))}),o.once("close",()=>s(new Error(I.localize(2,null,n))))}))}function h(d,n){return c(d,n).then(o=>new Promise((t,s)=>{const r=[];o.once("error",s),o.on("data",l=>r.push(l)),o.on("end",()=>t(Buffer.concat(r)))}))}e.buffer=h}),define(re[280],se([0,1,125,161]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(k){return(0,D.buffer)(k,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,i.localize)(0,null))}})}e.getManifest=R}),define(re[126],se([0,1,6,17,22,37,11,2,23,12,5,20,54,15,8,30,28,125,160,96,13,262,29,33,60,77,217,263,280,218,219,46,70,14,4,7,25,24,32,21]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u,p,c,h,d,n,o,t,s,r,l,a,g,P,A,V,O,F,N,L,U,$,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,F.refineServiceDecorator)(n.IExtensionManagementService);let j=class extends d.AbstractExtensionManagementService{constructor(z,_,M,G,H,Z,oe,X,ie,ne,le,ue){super(z,_,M,ne,ue),this.extensionsScannerService=H,this.extensionsProfileScannerService=Z,this.downloadService=oe,this.fileService=ie,this.installGalleryExtensionsTasks=new Map;const pe=this._register(X.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(X.createInstance(B,Ee=>pe.postUninstall(Ee))),this.manifestCache=this._register(new g.ExtensionsManifestCache(G,this)),this.extensionsDownloader=this._register(X.createInstance(r.ExtensionsDownloader));const we=this._register(new P.ExtensionsWatcher(this,ue,Z,H,le,ie,M));this._register(we.onDidChangeExtensionsByAnotherSource(({added:Ee,removed:Ce})=>{Ee.length&&this._onDidInstallExtensions.fire(Ee),Ce.forEach(Ae=>this._onDidUninstallExtension.fire(Ae))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,o.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(z){this.logService.trace("ExtensionManagementService#zip",z.identifier.id);const _=await this.collectFiles(z),M=await(0,u.zip)((0,b.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,_);return f.URI.file(M)}async unzip(z){return this.logService.trace("ExtensionManagementService#unzip",z.toString()),(await this.install(z)).identifier}async getManifest(z){const{location:_,cleanup:M}=await this.downloadVsix(z),G=w.resolve(_.fsPath);try{return await(0,a.getManifest)(G)}finally{await M()}}getInstalled(z,_){return this.extensionsScanner.scanExtensions(z??null,_)}getAllUserInstalled(){return this.extensionsScanner.scanAllUserExtensions(!1)}async install(z,_={}){this.logService.trace("ExtensionManagementService#install",z.toString());const{location:M,cleanup:G}=await this.downloadVsix(z);try{const H=await(0,a.getManifest)(w.resolve(M.fsPath));if(H.engines&&H.engines.vscode&&!(0,V.isEngineValid)(H.engines.vscode,this.productService.version,this.productService.date))throw new Error(p.localize(0,null,(0,o.getGalleryExtensionId)(H.publisher,H.name),this.productService.version));return await this.installExtension(H,M,_)}finally{await G()}}getMetadata(z){return this.extensionsScannerService.scanMetadata(z.location)}async updateMetadata(z,_){this.logService.trace("ExtensionManagementService#updateMetadata",z.identifier.id);const M={..._};return _.isPreReleaseVersion&&(M.preRelease=!0),z=await this.extensionsScanner.updateMetadata(z,M),this.manifestCache.invalidate(),z}async updateExtensionScope(z,_){return this.logService.trace("ExtensionManagementService#updateExtensionScope",z.identifier.id),z=await this.extensionsScanner.updateMetadata(z,{isMachineScoped:_}),this.manifestCache.invalidate(),z}async reinstallFromGallery(z){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",z.identifier.id),!this.galleryService.isEnabled())throw new Error(p.localize(1,null));const _=await this.getTargetPlatform(),[M]=await this.galleryService.getExtensions([{...z.identifier,preRelease:z.preRelease}],{targetPlatform:_,compatible:!0},R.CancellationToken.None);if(!M)throw new Error(p.localize(2,null));await this.extensionsScanner.setUninstalled(z);try{await this.extensionsScanner.removeUninstalledExtension(z)}catch(G){throw new Error(p.localize(3,null,(0,k.toErrorMessage)(G)))}await this.installFromGallery(M)}markAsUninstalled(...z){return this.extensionsScanner.setUninstalled(...z)}removeUninstalledExtensions(){return this.extensionsScanner.cleanUp()}migrateDefaultProfileExtensions(){return this.extensionsScanner.migrateDefaultProfileExtensions()}async download(z,_){const{location:M}=await this.extensionsDownloader.download(z,_);return M}async downloadVsix(z){if(z.scheme===C.Schemas.file)return{location:z,async cleanup(){}};this.logService.trace("Downloading extension from",z.toString());const _=(0,b.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)());return await this.downloadService.download(z,_),this.logService.info("Downloaded extension to",_.toString()),{location:_,cleanup:async()=>{try{await this.fileService.del(_)}catch(G){this.logService.error(G)}}}}createInstallExtensionTask(z,_,M){let G;if(f.URI.isUri(_))G=new Y(z,_,M,this.galleryService,this.extensionsScanner,this.logService);else{const H=o.ExtensionKey.create(_).toString();G=this.installGalleryExtensionsTasks.get(H),G||(this.installGalleryExtensionsTasks.set(H,G=new q(z,_,M,this.extensionsDownloader,this.extensionsScanner,this.logService)),G.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(H)))}return new ee(G,M.profileLocation,this.extensionsProfileScannerService)}createUninstallExtensionTask(z,_){return new ce(z,_.profileLocation,this.extensionsProfileScannerService)}async collectFiles(z){const _=async G=>{let H=await y.Promises.readdir(G);H=H.map(X=>w.join(G,X));const Z=await Promise.all(H.map(X=>y.Promises.stat(X)));let oe=Promise.resolve([]);return Z.forEach((X,ie)=>{const ne=H[ie];X.isFile()&&(oe=oe.then(le=>[...le,ne])),X.isDirectory()&&(oe=oe.then(le=>_(ne).then(ue=>[...le,...ue])))}),oe};return(await _(z.location.fsPath)).map(G=>({path:`extension/${w.relative(z.location.fsPath,G)}`,localPath:G}))}};j=ve([K(0,n.IExtensionGalleryService),K(1,U.ITelemetryService),K(2,N.ILogService),K(3,h.INativeEnvironmentService),K(4,s.IExtensionsScannerService),K(5,t.IExtensionsProfileScannerService),K(6,c.IDownloadService),K(7,F.IInstantiationService),K(8,O.IFileService),K(9,L.IProductService),K(10,$.IUriIdentityService),K(11,x.IUserDataProfilesService)],j),e.ExtensionManagementService=j;let B=class extends I.Disposable{constructor(z,_,M,G,H,Z){super(),this.beforeRemovingExtension=z,this.fileService=_,this.extensionsScannerService=M,this.userDataProfilesService=G,this.extensionsProfileScannerService=H,this.logService=Z,this._migrateDefaultProfileExtensionsPromise=void 0,this.uninstalledPath=(0,b.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(){await this.removeUninstalledExtensions()}async scanExtensions(z,_){await this.migrateDefaultProfileExtensions();const M={includeInvalid:!0,profileLocation:_};let G=[];return z===null||z===0?G.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},M,!1)):z===1&&G.push(...await this.extensionsScannerService.scanUserExtensions(M)),G=z!==null?G.filter(H=>H.type===z):G,Promise.all(G.map(H=>this.toLocalExtension(H)))}async scanAllUserExtensions(z){const _=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!z,includeInvalid:!0});return Promise.all(_.map(M=>this.toLocalExtension(M)))}async extractUserExtension(z,_,M,G){await this.migrateDefaultProfileExtensions();const H=z.toString(),Z=w.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),oe=w.join(this.extensionsScannerService.userExtensionsLocation.fsPath,H);try{await y.Promises.rm(oe)}catch{throw new n.ExtensionManagementError(p.localize(4,null,oe,z.id),n.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(z,_,Z,G),await this.extensionsScannerService.updateMetadata(f.URI.file(Z),M);try{await this.rename(z,Z,oe,Date.now()+2*60*1e3),this.logService.info("Renamed to",oe)}catch(X){try{await y.Promises.rm(Z)}catch{}if(X.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",z.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(X)}. Deleted from extracted location`,Z),X}return this.scanLocalExtension(f.URI.file(oe),1)}async updateMetadata(z,_){return await this.extensionsScannerService.updateMetadata(z.location,_),this.scanLocalExtension(z.location,z.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...z){const _=z.map(M=>o.ExtensionKey.create(M));await this.withUninstalledExtensions(M=>_.forEach(G=>{M[G.toString()]=!0,this.logService.info("Marked extension as uninstalled",G.toString())}))}async setInstalled(z){await this.withUninstalledExtensions(G=>delete G[z.toString()]);const M=(await this.scanAllUserExtensions(!0)).find(G=>o.ExtensionKey.create(G).equals(z))||null;return M?this.updateMetadata(M,{installedTimestamp:Date.now()}):null}async removeExtension(z,_){this.logService.trace(`Deleting ${_} extension from disk`,z.identifier.id,z.location.fsPath),await y.Promises.rm(z.location.fsPath),this.logService.info("Deleted from disk",z.identifier.id,z.location.fsPath)}async removeUninstalledExtension(z){await this.removeExtension(z,"uninstalled"),await this.withUninstalledExtensions(_=>delete _[o.ExtensionKey.create(z).toString()])}async withUninstalledExtensions(z){return this.uninstalledFileLimiter.queue(async()=>{let _;try{_=await y.Promises.readFile(this.uninstalledPath,"utf8")}catch(G){if(G.code!=="ENOENT")throw G}let M={};if(_)try{M=JSON.parse(_)}catch{}return z&&(z(M),Object.keys(M).length?await y.Promises.writeFile(this.uninstalledPath,JSON.stringify(M)):await y.Promises.rm(this.uninstalledPath)),M})}async extractAtLocation(z,_,M,G){this.logService.trace(`Started extracting the extension from ${_} to ${M}`);try{await y.Promises.rm(M)}catch(H){throw new n.ExtensionManagementError(this.joinErrors(H).message,n.ExtensionManagementErrorCode.Delete)}try{await(0,u.extract)(_,M,{sourcePath:"extension",overwrite:!0},G),this.logService.info(`Extracted extension to ${M}:`,z.id)}catch(H){try{await y.Promises.rm(M)}catch{}let Z=n.ExtensionManagementErrorCode.Extract;throw H instanceof u.ExtractError&&(H.type==="CorruptZip"?Z=n.ExtensionManagementErrorCode.CorruptZip:H.type==="Incomplete"&&(Z=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(H.message,Z)}}async rename(z,_,M,G){try{await y.Promises.rename(_,M)}catch(H){if(E.isWindows&&H&&H.code==="EPERM"&&Date.now()<G)return this.logService.info(`Failed renaming ${_} to ${M} with 'EPERM' error. Trying again...`,z.id),this.rename(z,_,M,G);throw new n.ExtensionManagementError(H.message||p.localize(5,null,_,M),H.code||n.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(z,_){const M=await this.extensionsScannerService.scanExistingExtension(z,_,{includeInvalid:!0});if(M)return this.toLocalExtension(M);throw new Error(p.localize(6,null,z.path))}async toLocalExtension(z){const _=await this.fileService.resolve(z.location);let M,G;return _.children&&(M=_.children.find(({name:H})=>/^readme(\.txt|\.md|)$/i.test(H))?.resource,G=_.children.find(({name:H})=>/^changelog(\.txt|\.md|)$/i.test(H))?.resource),{identifier:z.identifier,type:z.type,isBuiltin:z.isBuiltin||!!z.metadata?.isBuiltin,location:z.location,manifest:z.manifest,targetPlatform:z.targetPlatform,validations:z.validations,isValid:z.isValid,readmeUrl:M,changelogUrl:G,publisherDisplayName:z.metadata?.publisherDisplayName||null,publisherId:z.metadata?.publisherId||null,isApplicationScoped:!!z.metadata?.isApplicationScoped,isMachineScoped:!!z.metadata?.isMachineScoped,isPreReleaseVersion:!!z.metadata?.isPreReleaseVersion,preRelease:!!z.metadata?.preRelease,installedTimestamp:z.metadata?.installedTimestamp,updated:!!z.metadata?.updated}}async removeUninstalledExtensions(){const z=await this.getUninstalledExtensions(),_=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),M=new Set;for(const Z of _)z[o.ExtensionKey.create(Z).toString()]||M.add(Z.identifier.id.toLowerCase());const G=(0,o.groupByExtension)(_,Z=>Z.identifier);await D.Promises.settled(G.map(async Z=>{const oe=Z.sort((X,ie)=>S.rcompare(X.manifest.version,ie.manifest.version))[0];M.has(oe.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(oe))}));const H=_.filter(Z=>z[o.ExtensionKey.create(Z).toString()]);await D.Promises.settled(H.map(Z=>this.removeUninstalledExtension(Z)))}migrateDefaultProfileExtensions(){return this._migrateDefaultProfileExtensionsPromise||(this._migrateDefaultProfileExtensionsPromise=(async()=>{try{const z=(0,b.joinPath)(this.userDataProfilesService.defaultProfile.location,".migrated-default-profile");if(await this.fileService.exists(z))return;if(!await this.fileService.exists(this.userDataProfilesService.defaultProfile.extensionsResource)){this.logService.info("Started migrating default profile extensions from extensions installation folder to extensions manifest.");const _=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(_.map(M=>[M,M.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Completed migrating default profile extensions from extensions installation folder to extensions manifest.")}try{await this.fileService.createFile(z,i.VSBuffer.fromString(""))}catch(_){this.logService.warn("Failed to create migration marker file for default profile extensions migration.",(0,T.getErrorMessage)(_))}}catch(z){throw this.logService.error(z),z}})()),this._migrateDefaultProfileExtensionsPromise}joinErrors(z){const _=Array.isArray(z)?z:[z];return _.length===1?_[0]instanceof Error?_[0]:new Error(_[0]):_.reduce((M,G)=>new Error(`${M.message}${M.message?",":""}${G instanceof Error?G.message:G}`),new Error(""))}};B=ve([K(1,O.IFileService),K(2,s.IExtensionsScannerService),K(3,x.IUserDataProfilesService),K(4,t.IExtensionsProfileScannerService),K(5,N.ILogService)],B),e.ExtensionsScanner=B;class W extends d.AbstractExtensionTask{get operation(){return(0,m.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(z,_,M,G,H){super(),this.identifier=z,this.source=_,this.options=M,this.extensionsScanner=G,this.logService=H,this.wasVerified=!1,this._operation=2}async installExtension(z,_){try{const M=await this.unsetUninstalledAndGetLocal(z.key);if(M)return this.extensionsScanner.updateMetadata(M,z.metadata)}catch{throw E.isMacintosh?new n.ExtensionManagementError(p.localize(7,null),n.ExtensionManagementErrorCode.Internal):new n.ExtensionManagementError(p.localize(8,null),n.ExtensionManagementErrorCode.Internal)}return this.extract(z,_)}async unsetUninstalledAndGetLocal(z){if(!await this.isUninstalled(z))return null;this.logService.trace("Removing the extension from uninstalled list:",z.id);const M=await this.extensionsScanner.setInstalled(z);return this.logService.info("Removed the extension from uninstalled list:",z.id),M}async isUninstalled(z){return!!(await this.extensionsScanner.getUninstalledExtensions())[z.toString()]}async extract({zipPath:z,key:_,metadata:M},G){const H=await this.extensionsScanner.extractUserExtension(_,z,M,G);return this.logService.info("Extracting completed.",_.id),H}}class q extends W{constructor(z,_,M,G,H,Z){super(_.identifier,_,M,H,Z),this.manifest=z,this.gallery=_,this.extensionsDownloader=G}async doRun(z){const M=(await this.extensionsScanner.scanExtensions(null,void 0)).find(oe=>(0,o.areSameExtensions)(oe.identifier,this.gallery.identifier));M&&(this._operation=3);const G={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,A.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||M?.isMachineScoped,isBuiltin:this.options.isBuiltin||M?.isBuiltin,isSystem:M?.type===0?!0:void 0,updated:!!M,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,m.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:M?.preRelease)};if(M?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(M,G),metadata:G};const{location:H,verified:Z}=await this.extensionsDownloader.download(this.gallery,this._operation);try{this.wasVerified=!!Z,this.validateManifest(H.fsPath);const oe=await this.installExtension({zipPath:H.fsPath,key:o.ExtensionKey.create(this.gallery),metadata:G},z);return M&&!this.options.profileLocation&&(M.targetPlatform!==oe.targetPlatform||S.neq(M.manifest.version,oe.manifest.version))&&await this.extensionsScanner.setUninstalled(M),{local:oe,metadata:G}}catch(oe){try{await this.extensionsDownloader.delete(H)}catch(X){this.logService.warn("Error while deleting the downloaded file",H.toString(),(0,T.getErrorMessage)(X))}throw oe}}async validateManifest(z){try{await(0,a.getManifest)(z)}catch(_){throw new n.ExtensionManagementError((0,d.joinErrors)(_).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=q;class Y extends W{constructor(z,_,M,G,H,Z){super({id:(0,o.getGalleryExtensionId)(z.publisher,z.name)},_,M,H,Z),this.manifest=z,this.location=_,this.galleryService=G}async doRun(z){const _=new o.ExtensionKey(this.identifier,this.manifest.version),G=(await this.extensionsScanner.scanExtensions(1,void 0)).find(oe=>(0,o.areSameExtensions)(this.identifier,oe.identifier)),H=await this.getMetadata(this.identifier.id,this.manifest.version,z);if(H.isApplicationScoped=(0,A.isApplicationScopedExtension)(this.manifest),H.isMachineScoped=this.options.isMachineScoped||G?.isMachineScoped,H.isBuiltin=this.options.isBuiltin||G?.isBuiltin,H.installedTimestamp=Date.now(),G)if(this._operation=3,_.equals(new o.ExtensionKey(G.identifier,G.manifest.version)))try{await this.extensionsScanner.removeExtension(G,"existing")}catch{throw new Error(p.localize(9,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&S.gt(G.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(G);else{const oe=await this.unsetUninstalledAndGetLocal(_);if(oe)try{await this.extensionsScanner.removeExtension(oe,"existing")}catch{throw new Error(p.localize(10,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:w.resolve(this.location.fsPath),key:_,metadata:H},z),metadata:H}}async getMetadata(z,_,M){try{let[G]=await this.galleryService.getExtensions([{id:z,version:_}],M);if(G||([G]=await this.galleryService.getExtensions([{id:z}],M)),G)return{id:G.identifier.uuid,publisherDisplayName:G.publisherDisplayName,publisherId:G.publisherId,isPreReleaseVersion:G.properties.isPreReleaseVersion,preRelease:G.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class ee{constructor(z,_,M){this.task=z,this.profileLocation=_,this.extensionsProfileScannerService=M,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const z=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[z.local,z.metadata]],this.profileLocation),z}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class ce extends d.AbstractExtensionTask{constructor(z,_,M){super(),this.extension=z,this.profileLocation=_,this.extensionsProfileScannerService=M}async doRun(z){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(re[281],se([0,1,2,29,78,216,126,7,18]),function(Q,e,D,i,R,k,T,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let w=class extends D.Disposable{constructor(b,S,m,f,v,y){super(),b.migrateDefaultProfileExtensions().then(()=>v.store(i.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY,!0,-1,1),u=>null),b.removeUninstalledExtensions(),(0,k.migrateUnsupportedExtensions)(b,S,m,f,y),R.ExtensionStorageService.removeOutdatedExtensionVersions(b,v)}};w=ve([K(0,T.INativeServerExtensionManagementService),K(1,i.IExtensionGalleryService),K(2,R.IExtensionStorageService),K(3,i.IGlobalExtensionEnablementService),K(4,C.IStorageService),K(5,I.ILogService)],w),e.ExtensionsContributions=w}),define(re[290],se([0,1,92,34,37,11,2,23,20,8,38,149,209,210,202,203,279,191,194,16,214,95,234,96,225,13,231,117,265,29,97,193,266,126,98,189,14,205,207,55,4,200,71,201,57,72,220,7,102,58,103,25,47,18,267,109,24,110,111,112,51,239,113,241,247,78,115,26,76,269,258,259,79,270,273,274,275,276,277,62,260,108,233,75,249,222,248,107,230,32,250,5,251,195,212,211,77,264,21,60,208,59,268,228,238,261,235,106,101,272,281]),function(Q,e,D,i,R,k,T,I,C,w,E,b,S,m,f,v,y,u,p,c,h,d,n,o,t,s,r,l,a,g,P,A,V,O,F,N,L,U,$,x,j,B,W,q,Y,ee,ce,J,z,_,M,G,H,Z,oe,X,ie,ne,le,ue,pe,we,Ee,Ce,Ae,Ne,Ge,We,ae,fe,ge,be,Ie,Le,Re,Fe,_e,Me,ze,ke,Oe,te,he,de,me,Se,Pe,De,Ve,$e,Te,je,xe,et,ot,St,Lt,Tt,yt,wt,At,Et,_t,Ot,Ut,Mt,Nt,bt,Ct,Ft,$t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Wt extends T.Disposable{constructor(ye){super(),this.configuration=ye,this.server=this._register(new b.Server),this.sharedProcessWorkerService=void 0,this.lifecycleService=void 0,this.registerListeners()}registerListeners(){const ye=async()=>{this.lifecycleService&&(await this.lifecycleService.fireOnWillShutdown(),this.lifecycleService.dispose(),this.lifecycleService=void 0),this.dispose()};process.once("exit",ye),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Ue="vscode:electron-main->shared-process=disposeWorker",qe=(Ke,tt)=>{this.onDisposeWorker(tt)};D.ipcRenderer.on(Ue,qe),this._register((0,T.toDisposable)(()=>D.ipcRenderer.removeListener(Ue,qe)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,We.registerConfiguration)(),ye.invokeFunction(Ue=>{const qe=Ue.get(J.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(qe)}),this._register((0,T.combinedDisposable)(ye.createInstance(S.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(m.LanguagePackCachedDataCleaner),ye.createInstance(y.UnusedWorkspaceStorageDataCleaner),ye.createInstance(v.LogsDataCleaner),ye.createInstance(f.LocalizationsUpdater),ye.createInstance($t.ExtensionsContributions),ye.createInstance(Mt.UserDataProfilesCleaner)))}async initServices(){const ye=new W.ServiceCollection,Ue={_serviceBrand:void 0,...M.default};ye.set(G.IProductService,Ue);const qe=new E.StaticRouter(Xe=>Xe==="main"),Ke=new q.MessagePortMainProcessService(this.server,qe);ye.set(Y.IMainProcessService,Ke);const tt=this.configuration.policiesData?new At.PolicyChannelClient(this.configuration.policiesData,Ke.getChannel("policy")):new Et.NullPolicyService;ye.set(Et.IPolicyService,tt);const He=new r.SharedProcessEnvironmentService(this.configuration.args,Ue);ye.set(s.INativeEnvironmentService,He);const lt=new z.LogLevelChannelClient(this.server.getChannel("logLevel",qe)),it=new z.LoggerChannelClient(this.configuration.logLevel,lt.onDidChangeLogLevel,Ke.getChannel("logger"));ye.set(J.ILoggerService,it);const ht=this._register(new J.MultiplexLogService([this._register(new J.ConsoleLogger(this.configuration.logLevel)),this._register(it.createLogger((0,C.joinPath)(w.URI.file(He.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ye=this._register(new z.FollowerLogService(lt,ht));ye.set(J.ILogService,Ye),this.lifecycleService=new Ct.SharedProcessLifecycleService(Ye),ye.set(Ct.ISharedProcessLifecycleService,this.lifecycleService),this.sharedProcessWorkerService=new Ve.SharedProcessWorkerService(Ye),ye.set(De.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Qe=this._register(new U.FileService(Ye));ye.set(L.IFileService,Qe);const dt=this._register(new $.DiskFileSystemProvider(Ye));Qe.registerProvider(I.Schemas.file,dt);const ft=this._register(new xe.FileUserDataProvider(I.Schemas.file,this._register(new et.DiskFileSystemProviderClient(Ke.getChannel(et.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:je.isLinux})),I.Schemas.vscodeUserData,Ye));Qe.registerProvider(I.Schemas.vscodeUserData,ft);const nt=this._register(new _t.UserDataProfilesNativeService(this.configuration.profiles,Ke,He));ye.set(yt.IUserDataProfilesService,nt);const Je=this._register(new h.ConfigurationService(nt.defaultProfile.settingsResource,Qe,tt,Ye));ye.set(c.IConfigurationService,Je);const at=new oe.NativeStorageService(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},Ke,He);ye.set(Z.IStorageService,at),this._register((0,T.toDisposable)(()=>at.flush())),await Promise.all([Je.initialize(),at.initialize()]),ye.set($e.IUriIdentityService,new Te.UriIdentityService(Qe)),ye.set(H.IRequestService,new Ot.SharedProcessRequestService(Ke,Je,Ye)),ye.set(u.IChecksumService,new x.SyncDescriptor(p.ChecksumService,void 0,!1)),ye.set(St.IV8InspectProfilingService,new x.SyncDescriptor(ot.InspectProfilingService,void 0,!1));const ut=E.ProxyChannel.toService(Ke.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(_.INativeHostService,ut),ye.set(o.IDownloadService,new x.SyncDescriptor(t.DownloadService,void 0,!0));const gt=this._register(new Oe.ActiveWindowManager(ut)),mt=new E.StaticRouter(Xe=>gt.getActiveClientId().then(vt=>Xe===vt));ye.set(F.IExtensionRecommendationNotificationService,new N.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",mt)));let rt;const ct=[],It=(0,pe.isInternalTelemetry)(Ue,Je);if((0,pe.supportsTelemetry)(Ue,He)){const Xe=new le.TelemetryLogAppender(it,He);ct.push(Xe);const{installSourcePath:vt}=He;if(Ue.aiConfig?.ariaKey){const Rt=new Ut.OneDataSystemAppender(It,"monacoworkbench",null,Ue.aiConfig.ariaKey);this._register((0,T.toDisposable)(()=>Rt.flush())),ct.push(Rt)}rt=new ue.TelemetryService({appenders:ct,commonProperties:(0,X.resolveCommonProperties)(Qe,(0,i.release)(),(0,i.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,It,vt),sendErrorTelemetry:!0,piiPaths:(0,pe.getPiiPathsFromEnvironment)(He)},Je,Ue)}else{rt=pe.NullTelemetryService;const Xe=pe.NullAppender;ct.push(Xe)}this.server.registerChannel("telemetryAppender",new ne.TelemetryAppenderChannel(ct)),ye.set(ie.ITelemetryService,rt);const jt=new we.CustomEndpointTelemetryService(Je,rt,it,He,Ue);ye.set(ie.ICustomEndpointTelemetryService,jt),ye.set(wt.IExtensionsProfileScannerService,new x.SyncDescriptor(wt.ExtensionsProfileScannerService,void 0,!0)),ye.set(Lt.IExtensionsScannerService,new x.SyncDescriptor(Tt.ExtensionsScannerService,void 0,!0)),ye.set(P.IExtensionSignatureVerificationService,new x.SyncDescriptor(P.ExtensionSignatureVerificationService,void 0,!0)),ye.set(O.INativeServerExtensionManagementService,new x.SyncDescriptor(O.ExtensionManagementService,void 0,!0)),ye.set(g.IExtensionGalleryService,new x.SyncDescriptor(a.ExtensionGalleryService,void 0,!0)),ye.set(g.IExtensionTipsService,new x.SyncDescriptor(V.ExtensionTipsService,void 0,!1)),ye.set(ee.ILanguagePackService,new x.SyncDescriptor(ce.NativeLanguagePackService,void 0,!1)),ye.set(d.IDiagnosticsService,new x.SyncDescriptor(n.DiagnosticsService,void 0,!1)),ye.set(ae.IUserDataSyncAccountService,new x.SyncDescriptor(ae.UserDataSyncAccountService,void 0,!0)),ye.set(We.IUserDataSyncLogService,new x.SyncDescriptor(be.UserDataSyncLogService,void 0,!0)),ye.set(We.IUserDataSyncUtilService,new ge.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Xe=>Xe.ctx!=="main"))),ye.set(g.IGlobalExtensionEnablementService,new x.SyncDescriptor(l.GlobalExtensionEnablementService,void 0,!1)),ye.set(Ge.IIgnoredExtensionsManagementService,new x.SyncDescriptor(Ge.IgnoredExtensionsManagementService,void 0,!0)),ye.set(Ne.IExtensionStorageService,new x.SyncDescriptor(Ne.ExtensionStorageService)),ye.set(We.IUserDataSyncStoreManagementService,new x.SyncDescriptor(_e.UserDataSyncStoreManagementService,void 0,!0)),ye.set(We.IUserDataSyncStoreService,new x.SyncDescriptor(_e.UserDataSyncStoreService,void 0,!0)),ye.set(Ie.IUserDataSyncMachinesService,new x.SyncDescriptor(Ie.UserDataSyncMachinesService,void 0,!0)),ye.set(We.IUserDataSyncBackupStoreService,new x.SyncDescriptor(fe.UserDataSyncBackupStoreService,void 0,!1)),ye.set(We.IUserDataSyncEnablementService,new x.SyncDescriptor(Le.UserDataSyncEnablementService,void 0,!0)),ye.set(We.IUserDataSyncService,new x.SyncDescriptor(Re.UserDataSyncService,void 0,!1)),ye.set(ke.IUserDataSyncProfilesStorageService,new x.SyncDescriptor(ze.UserDataSyncProfilesStorageService,void 0,!0)),ye.set(We.IUserDataSyncResourceProviderService,new x.SyncDescriptor(Ft.UserDataSyncResourceProviderService,void 0,!0));const Dt=new Ae.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Je.getValue("terminal.integrated.persistentSessionScrollback")??100},Je,He,Ye);return Dt.initialize(),ye.set(Ce.ILocalPtyService,this._register(Dt)),ye.set(te.ISignService,new x.SyncDescriptor(he.SignService,void 0,!1)),ye.set(de.ISharedTunnelsService,new x.SyncDescriptor(me.SharedTunnelsService)),ye.set(Se.ISharedProcessTunnelService,new x.SyncDescriptor(Pe.SharedProcessTunnelService)),ye.set(bt.IRemoteTunnelService,new x.SyncDescriptor(Nt.RemoteTunnelService)),new B.InstantiationService(ye)}initChannels(ye){const Ue=new z.LogLevelChannel(ye.get(J.ILogService),ye.get(J.ILoggerService));this.server.registerChannel("logLevel",Ue);const qe=new A.ExtensionManagementChannel(ye.get(g.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",qe);const Ke=E.ProxyChannel.fromService(ye.get(ee.ILanguagePackService));this.server.registerChannel("languagePacks",Ke);const tt=E.ProxyChannel.fromService(ye.get(d.IDiagnosticsService));this.server.registerChannel("diagnostics",tt);const He=new A.ExtensionTipsChannel(ye.get(g.IExtensionTipsService));this.server.registerChannel("extensionTipsService",He);const lt=E.ProxyChannel.fromService(ye.get(u.IChecksumService));this.server.registerChannel("checksum",lt);const it=E.ProxyChannel.fromService(ye.get(St.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",it);const ht=new ge.UserDataSyncMachinesServiceChannel(ye.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ht);const Ye=E.ProxyChannel.fromService(ye.get(ie.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Ye);const Qe=new ge.UserDataSyncAccountServiceChannel(ye.get(ae.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Qe);const dt=new ge.UserDataSyncStoreManagementServiceChannel(ye.get(We.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",dt);const ft=new Fe.UserDataSyncChannel(ye.get(We.IUserDataSyncService),ye.get(yt.IUserDataProfilesService),ye.get(J.ILogService));this.server.registerChannel("userDataSync",ft);const nt=this._register(ye.get(j.IInstantiationService).createInstance(Me.UserDataAutoSyncService)),Je=new ge.UserDataAutoSyncChannel(nt);this.server.registerChannel("userDataAutoSync",Je);const at=ye.get(Ce.ILocalPtyService),ut=E.ProxyChannel.fromService(at);this.server.registerChannel(Ee.TerminalIpcChannels.LocalPty,ut);const gt=E.ProxyChannel.fromService(ye.get(Se.ISharedProcessTunnelService));this.server.registerChannel(Se.ipcSharedProcessTunnelChannelName,gt);const mt=E.ProxyChannel.fromService(ye.get(De.ISharedProcessWorkerService));this.server.registerChannel(De.ipcSharedProcessWorkerChannelName,mt);const rt=E.ProxyChannel.fromService(ye.get(bt.IRemoteTunnelService));this.server.registerChannel("remoteTunnel",rt)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Ue=>{(0,k.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,k.setUnexpectedErrorHandler)(Ue=>{const qe=(0,R.toErrorMessage)(Ue,!0);!qe||ye.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function zt(Pt){const ye=new Wt(Pt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=zt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e8eb39bac26ddc87f27ed69fa06c54cd230d18f9/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
