/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","os","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","vs/platform/state/electron-main/state","vs/base/common/map","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/userDataProfile/electron-main/userDataProfile","vs/base/common/functional","vs/base/common/objects","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/userDataSync/electron-main/userDataSyncProfilesStorageIpc","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],te=function(z){for(var e=[],E=0,t=z.length;E<t;E++)e[E]=ee[z[E]];return e};define(ee[119],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function E(D){return D?D.replace(/\$\((.*?)\)/g,(P,p)=>` ${p} `).trim():""}e.getCodiconAriaLabel=E;class t{constructor(P,p,v){this.id=P,this.definition=p,this.description=v,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(D,P){const p=["codicon","codicon-"+D];return P&&p.push("codicon-modifier-"+P),p}e.getClassNamesArray=k;var R;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function p(C){if(C instanceof t)return["codicon","codicon-"+C.id];const I=P.exec(C.id);if(!I)return p(t.error);const[,u,w]=I,g=["codicon","codicon-"+u];return w&&g.push("codicon-modifier-"+w.substr(1)),g}D.asClassNameArray=p;function v(C){return p(C).join(" ")}D.asClassName=v;function b(C){return"."+p(C).join(".")}D.asCSSSelector=b})(R=e.CSSIcon||(e.CSSIcon={}))}),define(ee[120],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(P,p){const v=Math.pow(10,p);return Math.round(P*v)/v}class t{constructor(p,v,b,C=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,p))|0,this.g=Math.min(255,Math.max(0,v))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=E(Math.max(Math.min(1,C),0),3)}static equals(p,v){return p.r===v.r&&p.g===v.g&&p.b===v.b&&p.a===v.a}}e.RGBA=t;class k{constructor(p,v,b,C){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,p),0)|0,this.s=E(Math.max(Math.min(1,v),0),3),this.l=E(Math.max(Math.min(1,b),0),3),this.a=E(Math.max(Math.min(1,C),0),3)}static equals(p,v){return p.h===v.h&&p.s===v.s&&p.l===v.l&&p.a===v.a}static fromRGBA(p){const v=p.r/255,b=p.g/255,C=p.b/255,I=p.a,u=Math.max(v,b,C),w=Math.min(v,b,C);let g=0,f=0;const d=(w+u)/2,S=u-w;if(S>0){switch(f=Math.min(d<=.5?S/(2*d):S/(2-2*d),1),u){case v:g=(b-C)/S+(b<C?6:0);break;case b:g=(C-v)/S+2;break;case C:g=(v-b)/S+4;break}g*=60,g=Math.round(g)}return new k(g,f,d,I)}static _hue2rgb(p,v,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?p+(v-p)*6*b:b<1/2?v:b<2/3?p+(v-p)*(2/3-b)*6:p}static toRGBA(p){const v=p.h/360,{s:b,l:C,a:I}=p;let u,w,g;if(b===0)u=w=g=C;else{const f=C<.5?C*(1+b):C+b-C*b,d=2*C-f;u=k._hue2rgb(d,f,v+1/3),w=k._hue2rgb(d,f,v),g=k._hue2rgb(d,f,v-1/3)}return new t(Math.round(u*255),Math.round(w*255),Math.round(g*255),I)}}e.HSLA=k;class R{constructor(p,v,b,C){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,p),0)|0,this.s=E(Math.max(Math.min(1,v),0),3),this.v=E(Math.max(Math.min(1,b),0),3),this.a=E(Math.max(Math.min(1,C),0),3)}static equals(p,v){return p.h===v.h&&p.s===v.s&&p.v===v.v&&p.a===v.a}static fromRGBA(p){const v=p.r/255,b=p.g/255,C=p.b/255,I=Math.max(v,b,C),u=Math.min(v,b,C),w=I-u,g=I===0?0:w/I;let f;return w===0?f=0:I===v?f=((b-C)/w%6+6)%6:I===b?f=(C-v)/w+2:f=(v-b)/w+4,new R(Math.round(f*60),g,I,p.a)}static toRGBA(p){const{h:v,s:b,v:C,a:I}=p,u=C*b,w=u*(1-Math.abs(v/60%2-1)),g=C-u;let[f,d,S]=[0,0,0];return v<60?(f=u,d=w):v<120?(f=w,d=u):v<180?(d=u,S=w):v<240?(d=w,S=u):v<300?(f=w,S=u):v<=360&&(f=u,S=w),f=Math.round((f+g)*255),d=Math.round((d+g)*255),S=Math.round((S+g)*255),new t(f,d,S,I)}}e.HSVA=R;class D{static fromHex(p){return D.Format.CSS.parseHex(p)||D.red}static equals(p,v){return!p&&!v?!0:!p||!v?!1:p.equals(v)}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}constructor(p){if(p)if(p instanceof t)this.rgba=p;else if(p instanceof k)this._hsla=p,this.rgba=k.toRGBA(p);else if(p instanceof R)this._hsva=p,this.rgba=R.toRGBA(p);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(p){return!!p&&t.equals(this.rgba,p.rgba)&&k.equals(this.hsla,p.hsla)&&R.equals(this.hsva,p.hsva)}getRelativeLuminance(){const p=D._relativeLuminanceForComponent(this.rgba.r),v=D._relativeLuminanceForComponent(this.rgba.g),b=D._relativeLuminanceForComponent(this.rgba.b),C=.2126*p+.7152*v+.0722*b;return E(C,4)}static _relativeLuminanceForComponent(p){const v=p/255;return v<=.03928?v/12.92:Math.pow((v+.055)/1.055,2.4)}getContrastRatio(p){const v=this.getRelativeLuminance(),b=p.getRelativeLuminance();return v>b?(v+.05)/(b+.05):(b+.05)/(v+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(p){const v=this.getRelativeLuminance(),b=p.getRelativeLuminance();return v>b}isDarkerThan(p){const v=this.getRelativeLuminance(),b=p.getRelativeLuminance();return v<b}lighten(p){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*p,this.hsla.a))}darken(p){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*p,this.hsla.a))}transparent(p){const{r:v,g:b,b:C,a:I}=this.rgba;return new D(new t(v,b,C,I*p))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(p){const v=p.rgba,b=this.rgba.a,C=v.a,I=b+C*(1-b);if(I<1e-6)return D.transparent;const u=this.rgba.r*b/I+v.r*C*(1-b)/I,w=this.rgba.g*b/I+v.g*C*(1-b)/I,g=this.rgba.b*b/I+v.b*C*(1-b)/I;return new D(new t(u,w,g,I))}makeOpaque(p){if(this.isOpaque()||p.rgba.a!==1)return this;const{r:v,g:b,b:C,a:I}=this.rgba;return new D(new t(p.rgba.r-I*(p.rgba.r-v),p.rgba.g-I*(p.rgba.g-b),p.rgba.b-I*(p.rgba.b-C),1))}flatten(...p){const v=p.reduceRight((b,C)=>D._flatten(C,b));return D._flatten(this,v)}static _flatten(p,v){const b=1-p.rgba.a;return new D(new t(b*v.rgba.r+p.rgba.a*p.rgba.r,b*v.rgba.g+p.rgba.a*p.rgba.g,b*v.rgba.b+p.rgba.a*p.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(p,v,b){if(p.isLighterThan(v))return p;b=b||.5;const C=p.getRelativeLuminance(),I=v.getRelativeLuminance();return b=b*(I-C)/I,p.lighten(b)}static getDarkerColor(p,v,b){if(p.isDarkerThan(v))return p;b=b||.5;const C=p.getRelativeLuminance(),I=v.getRelativeLuminance();return b=b*(C-I)/C,p.darken(b)}}e.Color=D,D.white=new D(new t(255,255,255,1)),D.black=new D(new t(0,0,0,1)),D.red=new D(new t(255,0,0,1)),D.blue=new D(new t(0,0,255,1)),D.green=new D(new t(0,255,0,1)),D.cyan=new D(new t(0,255,255,1)),D.lightgrey=new D(new t(211,211,211,1)),D.transparent=new D(new t(0,0,0,0)),function(P){let p;(function(v){let b;(function(C){function I(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:P.Format.CSS.formatRGBA(n)}C.formatRGB=I;function u(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}C.formatRGBA=u;function w(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(n)}C.formatHSL=w;function g(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}C.formatHSLA=g;function f(n){const r=n.toString(16);return r.length!==2?"0"+r:r}function d(n){return`#${f(n.rgba.r)}${f(n.rgba.g)}${f(n.rgba.b)}`}C.formatHex=d;function S(n,r=!1){return r&&n.rgba.a===1?P.Format.CSS.formatHex(n):`#${f(n.rgba.r)}${f(n.rgba.g)}${f(n.rgba.b)}${f(Math.round(n.rgba.a*255))}`}C.formatHexA=S;function m(n){return n.isOpaque()?P.Format.CSS.formatHex(n):P.Format.CSS.formatRGBA(n)}C.format=m;function h(n){const r=n.length;if(r===0||n.charCodeAt(0)!==35)return null;if(r===7){const i=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),o=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),s=16*l(n.charCodeAt(5))+l(n.charCodeAt(6));return new P(new t(i,o,s,1))}if(r===9){const i=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),o=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),s=16*l(n.charCodeAt(5))+l(n.charCodeAt(6)),c=16*l(n.charCodeAt(7))+l(n.charCodeAt(8));return new P(new t(i,o,s,c/255))}if(r===4){const i=l(n.charCodeAt(1)),o=l(n.charCodeAt(2)),s=l(n.charCodeAt(3));return new P(new t(16*i+i,16*o+o,16*s+s))}if(r===5){const i=l(n.charCodeAt(1)),o=l(n.charCodeAt(2)),s=l(n.charCodeAt(3)),c=l(n.charCodeAt(4));return new P(new t(16*i+i,16*o+o,16*s+s,(16*c+c)/255))}return null}C.parseHex=h;function l(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=v.CSS||(v.CSS={}))})(p=P.Format||(P.Format={}))}(D=e.Color||(e.Color={}))}),define(ee[53],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(D){return(P,p,v)=>{let b=null,C=null;if(typeof v.value=="function"?(b="value",C=v.value):typeof v.get=="function"&&(b="get",C=v.get),!C)throw new Error("not supported");v[b]=D(C,p)}}function t(D,P,p){let v=null,b=null;if(typeof p.value=="function"?(v="value",b=p.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(v="get",b=p.get),!b)throw new Error("not supported");const C=`$memoize$${P}`;p[v]=function(...I){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,I)}),this[C]}}e.memoize=t;function k(D,P,p){return E((v,b)=>{const C=`$debounce$${b}`,I=`$debounce$result$${b}`;return function(...u){this[I]||(this[I]=p?p():void 0),clearTimeout(this[C]),P&&(this[I]=P(this[I],...u),u=[this[I]]),this[C]=setTimeout(()=>{v.apply(this,u),this[I]=p?p():void 0},D)}})}e.debounce=k;function R(D,P,p){return E((v,b)=>{const C=`$throttle$timer$${b}`,I=`$throttle$result$${b}`,u=`$throttle$lastRun$${b}`,w=`$throttle$pending$${b}`;return function(...g){if(this[I]||(this[I]=p?p():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),P&&(this[I]=P(this[I],...g)),this[w])return;const f=this[u]+D;f<=Date.now()?(this[u]=Date.now(),v.apply(this,[this[I]]),this[I]=p?p():void 0):(this[w]=!0,this[C]=setTimeout(()=>{this[w]=!1,this[u]=Date.now(),v.apply(this,[this[I]]),this[I]=p?p():void 0},f-Date.now()))}})}e.throttle=R}),define(ee[16],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?m.isErrorNoTelemetry(n)?new m(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(r=>{r(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=E,e.errorHandler=new E;function t(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=t;function k(l){p(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=k;function R(l){p(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=R;function D(l){if(l instanceof Error){const{name:n,message:r}=l,i=l.stacktrace||l.stack;return{$isError:!0,name:n,message:r,stack:i,noTelemetry:m.isErrorNoTelemetry(l)}}return l}e.transformErrorForSerialization=D;const P="Canceled";function p(l){return l instanceof v?!0:l instanceof Error&&l.name===P&&l.message===P}e.isCancellationError=p;class v extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=v;function b(){const l=new Error(P);return l.name=l.message,l}e.canceled=b;function C(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=C;function I(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=I;function u(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=u;function w(l){const n=new Error(`${l} has been disposed`);return n.name="DISPOSED",n}e.disposed=w;function g(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=g;class f extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=f;class d extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=d;class S extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=S;class m extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof m)return n;const r=new m;return r.message=n.message,r.stack=n.stack,r}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=m;class h extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype);debugger}}e.BugIndicatingError=h}),define(ee[24],te([0,1,16]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(B,J=0){return B[B.length-(1+J)]}e.tail=t;function k(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=k;function R(B,J,Z=(ce,ge)=>ce===ge){if(B===J)return!0;if(!B||!J||B.length!==J.length)return!1;for(let ce=0,ge=B.length;ce<ge;ce++)if(!Z(B[ce],J[ce]))return!1;return!0}e.equals=R;function D(B,J){const Z=B.length-1;J<Z&&(B[J]=B[Z]),B.pop()}e.removeFastWithoutKeepingOrder=D;function P(B,J,Z){return p(B.length,ce=>Z(B[ce],J))}e.binarySearch=P;function p(B,J){let Z=0,ce=B-1;for(;Z<=ce;){const ge=(Z+ce)/2|0,De=J(ge);if(De<0)Z=ge+1;else if(De>0)ce=ge-1;else return ge}return-(Z+1)}e.binarySearch2=p;function v(B,J){let Z=0,ce=B.length;if(ce===0)return 0;for(;Z<ce;){const ge=Math.floor((Z+ce)/2);J(B[ge])?ce=ge:Z=ge+1}return Z}e.findFirstInSorted=v;function b(B,J,Z){if(B=B|0,B>=J.length)throw new TypeError("invalid index");const ce=J[Math.floor(J.length*Math.random())],ge=[],De=[],Te=[];for(const Me of J){const Le=Z(Me,ce);Le<0?ge.push(Me):Le>0?De.push(Me):Te.push(Me)}return B<ge.length?b(B,ge,Z):B<ge.length+Te.length?Te[0]:b(B-(ge.length+Te.length),De,Z)}e.quickSelect=b;function C(B,J){const Z=[];let ce;for(const ge of B.slice(0).sort(J))!ce||J(ce[0],ge)!==0?(ce=[ge],Z.push(ce)):ce.push(ge);return Z}e.groupBy=C;function I(B,J,Z){const ce=[];function ge(Me,Le,we){if(Le===0&&we.length===0)return;const pe=ce[ce.length-1];pe&&pe.start+pe.deleteCount===Me?(pe.deleteCount+=Le,pe.toInsert.push(...we)):ce.push({start:Me,deleteCount:Le,toInsert:we})}let De=0,Te=0;for(;;){if(De===B.length){ge(De,0,J.slice(Te));break}if(Te===J.length){ge(De,B.length-De,[]);break}const Me=B[De],Le=J[Te],we=Z(Me,Le);we===0?(De+=1,Te+=1):we<0?(ge(De,1,[]),De+=1):we>0&&(ge(De,0,[Le]),Te+=1)}return ce}e.sortedDiff=I;function u(B,J,Z){const ce=I(B,J,Z),ge=[],De=[];for(const Te of ce)ge.push(...B.slice(Te.start,Te.start+Te.deleteCount)),De.push(...Te.toInsert);return{removed:ge,added:De}}e.delta=u;function w(B,J,Z){if(Z===0)return[];const ce=B.slice(0,Z).sort(J);return f(B,J,ce,Z,B.length),ce}e.top=w;function g(B,J,Z,ce,ge){return Z===0?Promise.resolve([]):new Promise((De,Te)=>{(async()=>{const Me=B.length,Le=B.slice(0,Z).sort(J);for(let we=Z,pe=Math.min(Z+ce,Me);we<Me;we=pe,pe=Math.min(pe+ce,Me)){if(we>Z&&await new Promise(Se=>setTimeout(Se)),ge&&ge.isCancellationRequested)throw new E.CancellationError;f(B,J,Le,we,pe)}return Le})().then(De,Te)})}e.topAsync=g;function f(B,J,Z,ce,ge){for(const De=Z.length;ce<ge;ce++){const Te=B[ce];if(J(Te,Z[De-1])<0){Z.pop();const Me=v(Z,Le=>J(Te,Le)<0);Z.splice(Me,0,Te)}}}function d(B){return B.filter(J=>!!J)}e.coalesce=d;function S(B){let J=0;for(let Z=0;Z<B.length;Z++)B[Z]&&(B[J]=B[Z],J+=1);B.length=J}e.coalesceInPlace=S;function m(B,J,Z){B.splice(Z,0,B.splice(J,1)[0])}e.move=m;function h(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=h;function l(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=l;function n(B,J=Z=>Z){const Z=new Set;return B.filter(ce=>{const ge=J(ce);return Z.has(ge)?!1:(Z.add(ge),!0)})}e.distinct=n;function r(B){const J=new Set;return Z=>{const ce=B(Z);return J.has(ce)?!1:(J.add(ce),!0)}}e.uniqueFilter=r;function i(B,J){const Z=o(B,J);if(Z!==-1)return B[Z]}e.findLast=i;function o(B,J){for(let Z=B.length-1;Z>=0;Z--){const ce=B[Z];if(J(ce))return Z}return-1}e.lastIndex=o;function s(B,J){return B.length>0?B[0]:J}e.firstOrDefault=s;function c(B,J){return B.length>0?B[B.length-1]:J}e.lastOrDefault=c;function a(B,J,Z=(ce,ge)=>ce===ge){let ce=0;for(let ge=0,De=Math.min(B.length,J.length);ge<De&&Z(B[ge],J[ge]);ge++)ce++;return ce}e.commonPrefixLength=a;function y(B){return[].concat(...B)}e.flatten=y;function M(B,J){let Z=typeof J=="number"?B:0;typeof J=="number"?Z=B:(Z=0,J=B);const ce=[];if(Z<=J)for(let ge=Z;ge<J;ge++)ce.push(ge);else for(let ge=Z;ge>J;ge--)ce.push(ge);return ce}e.range=M;function T(B,J,Z){return B.reduce((ce,ge)=>(ce[J(ge)]=Z?Z(ge):ge,ce),Object.create(null))}e.index=T;function U(B,J){return B.push(J),()=>Y(B,J)}e.insert=U;function Y(B,J){const Z=B.indexOf(J);if(Z>-1)return B.splice(Z,1),J}e.remove=Y;function G(B,J,Z){const ce=B.slice(0,J),ge=B.slice(J);return ce.concat(Z,ge)}e.arrayInsert=G;function V(B,J){let Z;if(typeof J=="number"){let ce=J;Z=()=>{const ge=Math.sin(ce++)*179426549;return ge-Math.floor(ge)}}else Z=Math.random;for(let ce=B.length-1;ce>0;ce-=1){const ge=Math.floor(Z()*(ce+1)),De=B[ce];B[ce]=B[ge],B[ge]=De}}e.shuffle=V;function oe(B,J){const Z=B.indexOf(J);Z>-1&&(B.splice(Z,1),B.unshift(J))}e.pushToStart=oe;function ae(B,J){const Z=B.indexOf(J);Z>-1&&(B.splice(Z,1),B.push(J))}e.pushToEnd=ae;function se(B,J){for(const Z of J)B.push(Z)}e.pushMany=se;function fe(B,J){return Array.isArray(B)?B.map(J):J(B)}e.mapArrayOrNot=fe;function K(B){return Array.isArray(B)?B:[B]}e.asArray=K;function H(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=H;function F(B,J){for(const Z of B){const ce=J(Z);if(ce!==void 0)return ce}}e.mapFind=F;function A(B,J,Z){const ce=_(B,J),ge=B.length,De=Z.length;B.length=ge+De;for(let Te=ge-1;Te>=ce;Te--)B[Te+De]=B[Te];for(let Te=0;Te<De;Te++)B[Te+ce]=Z[Te]}e.insertInto=A;function O(B,J,Z,ce){const ge=_(B,J),De=B.splice(ge,Z);return A(B,ge,ce),De}e.splice=O;function _(B,J){return J<0?Math.max(J+B.length,0):Math.min(J,B.length)}var ne;(function(B){function J(ge){return ge<0}B.isLessThan=J;function Z(ge){return ge>0}B.isGreaterThan=Z;function ce(ge){return ge===0}B.isNeitherLessOrGreaterThan=ce,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(ne=e.CompareResult||(e.CompareResult={}));function N(B,J){return(Z,ce)=>J(B(Z),B(ce))}e.compareBy=N;function $(...B){return(J,Z)=>{for(const ce of B){const ge=ce(J,Z);if(!ne.isNeitherLessOrGreaterThan(ge))return ge}return ne.neitherLessOrGreaterThan}}e.tieBreakComparators=$;const L=(B,J)=>B-J;e.numberComparator=L;function W(B,J){if(B.length===0)return;let Z=B[0];for(let ce=1;ce<B.length;ce++){const ge=B[ce];J(ge,Z)>0&&(Z=ge)}return Z}e.findMaxBy=W;function j(B,J){if(B.length===0)return;let Z=B[0];for(let ce=1;ce<B.length;ce++){const ge=B[ce];J(ge,Z)>=0&&(Z=ge)}return Z}e.findLastMaxBy=j;function q(B,J){return W(B,(Z,ce)=>-J(Z,ce))}e.findMinBy=q;class X{constructor(J){this.items=J,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(J){let Z=this.firstIdx;for(;Z<this.items.length&&J(this.items[Z]);)Z++;const ce=Z===this.firstIdx?null:this.items.slice(this.firstIdx,Z);return this.firstIdx=Z,ce}takeFromEndWhile(J){let Z=this.lastIdx;for(;Z>=0&&J(this.items[Z]);)Z--;const ce=Z===this.lastIdx?null:this.items.slice(Z+1,this.lastIdx+1);return this.lastIdx=Z,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const J=this.items[this.firstIdx];return this.firstIdx++,J}removeLast(){const J=this.items[this.lastIdx];return this.lastIdx--,J}takeCount(J){const Z=this.items.slice(this.firstIdx,this.firstIdx+J);return this.firstIdx+=J,Z}}e.ArrayQueue=X;class re{constructor(J){this.iterate=J}forEach(J){this.iterate(Z=>(J(Z),!0))}toArray(){const J=[];return this.iterate(Z=>(J.push(Z),!0)),J}filter(J){return new re(Z=>this.iterate(ce=>J(ce)?Z(ce):!0))}map(J){return new re(Z=>this.iterate(ce=>Z(J(ce))))}some(J){let Z=!1;return this.iterate(ce=>(Z=J(ce),!Z)),Z}findFirst(J){let Z;return this.iterate(ce=>J(ce)?(Z=ce,!1):!0),Z}findLast(J){let Z;return this.iterate(ce=>(J(ce)&&(Z=ce),!0)),Z}findLastMaxBy(J){let Z,ce=!0;return this.iterate(ge=>((ce||ne.isGreaterThan(J(ge,Z)))&&(ce=!1,Z=ge),!0)),Z}}e.CallbackIterable=re,re.empty=new re(B=>{})}),define(ee[121],te([0,1,16]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(p,v){if(!p)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=t;function k(p,v="Unreachable"){throw new Error(v)}e.assertNever=k;function R(p){if(!p)throw new E.BugIndicatingError("Assertion Failed")}e.assert=R;function D(p){if(!p()){debugger;p(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function P(p,v){let b=0;for(;b<p.length-1;){const C=p[b],I=p[b+1];if(!v(C,I))return!1;b++}return!0}e.checkAdjacentItems=P}),define(ee[49],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(t){const k=this;let R=!1,D;return function(){return R||(R=!0,D=t.apply(k,arguments)),D}}e.once=E}),define(ee[66],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(t){function k(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function D(){return R}t.empty=D;function*P(h){yield h}t.single=P;function p(h){return k(h)?h:P(h)}t.wrap=p;function v(h){return h||R}t.from=v;function b(h){return!h||h[Symbol.iterator]().next().done===!0}t.isEmpty=b;function C(h){return h[Symbol.iterator]().next().value}t.first=C;function I(h,l){for(const n of h)if(l(n))return!0;return!1}t.some=I;function u(h,l){for(const n of h)if(l(n))return n}t.find=u;function*w(h,l){for(const n of h)l(n)&&(yield n)}t.filter=w;function*g(h,l){let n=0;for(const r of h)yield l(r,n++)}t.map=g;function*f(...h){for(const l of h)for(const n of l)yield n}t.concat=f;function d(h,l,n){let r=n;for(const i of h)r=l(r,i);return r}t.reduce=d;function*S(h,l,n=h.length){for(l<0&&(l+=h.length),n<0?n+=h.length:n>h.length&&(n=h.length);l<n;l++)yield h[l]}t.slice=S;function m(h,l=Number.POSITIVE_INFINITY){const n=[];if(l===0)return[n,h];const r=h[Symbol.iterator]();for(let i=0;i<l;i++){const o=r.next();if(o.done)return[n,t.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return r}}]}t.consume=m})(E=e.Iterable||(e.Iterable={}))}),define(ee[42],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(n){n.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(n,r=!1){let i=0;const o=n.length;let s="",c=0,a=16,y=0;function M(ae){let se=0,fe=0;for(;se<ae;){const K=n.charCodeAt(i);if(K>=48&&K<=57)fe=fe*16+K-48;else if(K>=65&&K<=70)fe=fe*16+K-65+10;else if(K>=97&&K<=102)fe=fe*16+K-97+10;else break;i++,se++}return se<ae&&(fe=-1),fe}function T(ae){i=ae,s="",c=0,a=16,y=0}function U(){const ae=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&v(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&v(n.charCodeAt(i)))for(i++;i<n.length&&v(n.charCodeAt(i));)i++;else return y=3,n.substring(ae,i);let se=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&v(n.charCodeAt(i))){for(i++;i<n.length&&v(n.charCodeAt(i));)i++;se=i}else y=3;return n.substring(ae,se)}function Y(){let ae="",se=i;for(;;){if(i>=o){ae+=n.substring(se,i),y=2;break}const fe=n.charCodeAt(i);if(fe===34){ae+=n.substring(se,i),i++;break}if(fe===92){if(ae+=n.substring(se,i),i++,i>=o){y=2;break}switch(n.charCodeAt(i++)){case 34:ae+='"';break;case 92:ae+="\\";break;case 47:ae+="/";break;case 98:ae+="\b";break;case 102:ae+="\f";break;case 110:ae+=`
`;break;case 114:ae+="\r";break;case 116:ae+="	";break;case 117:{const H=M(4);H>=0?ae+=String.fromCharCode(H):y=4;break}default:y=5}se=i;continue}if(fe>=0&&fe<=31)if(p(fe)){ae+=n.substring(se,i),y=2;break}else y=6;i++}return ae}function G(){if(s="",y=0,c=i,i>=o)return c=o,a=17;let ae=n.charCodeAt(i);if(P(ae)){do i++,s+=String.fromCharCode(ae),ae=n.charCodeAt(i);while(P(ae));return a=15}if(p(ae))return i++,s+=String.fromCharCode(ae),ae===13&&n.charCodeAt(i)===10&&(i++,s+=`
`),a=14;switch(ae){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,s=Y(),a=10;case 47:{const se=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<o&&!p(n.charCodeAt(i));)i++;return s=n.substring(se,i),a=12}if(n.charCodeAt(i+1)===42){i+=2;const fe=o-1;let K=!1;for(;i<fe;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,K=!0;break}i++}return K||(i++,y=1),s=n.substring(se,i),a=13}return s+=String.fromCharCode(ae),i++,a=16}case 45:if(s+=String.fromCharCode(ae),i++,i===o||!v(n.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=U(),a=11;default:for(;i<o&&V(ae);)i++,ae=n.charCodeAt(i);if(c!==i){switch(s=n.substring(c,i),s){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return s+=String.fromCharCode(ae),i++,a=16}}function V(ae){if(P(ae)||p(ae))return!1;switch(ae){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let ae;do ae=G();while(ae>=12&&ae<=15);return ae}return{setPosition:T,getPosition:()=>i,scan:r?oe:G,getToken:()=>a,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>y}}e.createScanner=D;function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function p(n){return n===10||n===13||n===8232||n===8233}function v(n){return n>=48&&n<=57}var b;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(b||(b={}));function C(n,r){const i=[],o=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function y(M,T,U,Y){c.value=M,c.offset=T,c.length=U,c.type=Y,c.colonOffset=void 0,s=c}try{m(n,{onObjectBegin:(M,T)=>{if(r<=M)throw o;s=void 0,a=r>M,i.push("")},onObjectProperty:(M,T,U)=>{if(r<T||(y(M,T,U,"property"),i[i.length-1]=M,r<=T+U))throw o},onObjectEnd:(M,T)=>{if(r<=M)throw o;s=void 0,i.pop()},onArrayBegin:(M,T)=>{if(r<=M)throw o;s=void 0,i.push(0)},onArrayEnd:(M,T)=>{if(r<=M)throw o;s=void 0,i.pop()},onLiteralValue:(M,T,U)=>{if(r<T||(y(M,T,U,l(M)),r<=T+U))throw o},onSeparator:(M,T,U)=>{if(r<=T)throw o;if(M===":"&&s&&s.type==="property")s.colonOffset=T,a=!1,s=void 0;else if(M===","){const Y=i[i.length-1];typeof Y=="number"?i[i.length-1]=Y+1:(a=!0,i[i.length-1]=""),s=void 0}}})}catch(M){if(M!==o)throw M}return{path:i,previousNode:s,isAtPropertyKey:a,matches:M=>{let T=0;for(let U=0;T<M.length&&U<i.length;U++)if(M[T]===i[U]||M[T]==="*")T++;else if(M[T]!=="**")return!1;return T===M.length}}}e.getLocation=C;function I(n,r=[],i=R.DEFAULT){let o=null,s=[];const c=[];function a(M){Array.isArray(s)?s.push(M):o!==null&&(s[o]=M)}return m(n,{onObjectBegin:()=>{const M={};a(M),c.push(s),s=M,o=null},onObjectProperty:M=>{o=M},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const M=[];a(M),c.push(s),s=M,o=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:a,onError:(M,T,U)=>{r.push({error:M,offset:T,length:U})}},i),s[0]}e.parse=I;function u(n,r=[],i=R.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(M){o.type==="property"&&(o.length=M-o.offset,o=o.parent)}function c(M){return o.children.push(M),M}m(n,{onObjectBegin:M=>{o=c({type:"object",offset:M,length:-1,parent:o,children:[]})},onObjectProperty:(M,T,U)=>{o=c({type:"property",offset:T,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:M,offset:T,length:U,parent:o})},onObjectEnd:(M,T)=>{o.length=M+T-o.offset,o=o.parent,s(M+T)},onArrayBegin:(M,T)=>{o=c({type:"array",offset:M,length:-1,parent:o,children:[]})},onArrayEnd:(M,T)=>{o.length=M+T-o.offset,o=o.parent,s(M+T)},onLiteralValue:(M,T,U)=>{c({type:l(M),offset:T,length:U,parent:o,value:M}),s(T+U)},onSeparator:(M,T,U)=>{o.type==="property"&&(M===":"?o.colonOffset=T:M===","&&s(T))},onError:(M,T,U)=>{r.push({error:M,offset:T,length:U})}},i);const y=o.children[0];return y&&delete y.parent,y}e.parseTree=u;function w(n,r){if(!n)return;let i=n;for(const o of r)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===o){i=c.children[1],s=!0;break}if(!s)return}else{const s=o;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=w;function g(n){if(!n.parent||!n.parent.children)return[];const r=g(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;r.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&r.push(i)}return r}e.getNodePath=g;function f(n){switch(n.type){case"array":return n.children.map(f);case"object":{const r=Object.create(null);for(const i of n.children){const o=i.children[1];o&&(r[i.children[0].value]=f(o))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=f;function d(n,r,i=!1){return r>=n.offset&&r<n.offset+n.length||i&&r===n.offset+n.length}e.contains=d;function S(n,r,i=!1){if(d(n,r,i)){const o=n.children;if(Array.isArray(o))for(let s=0;s<o.length&&o[s].offset<=r;s++){const c=S(o[s],r,i);if(c)return c}return n}}e.findNodeAtOffset=S;function m(n,r,i=R.DEFAULT){const o=D(n,!1);function s(N){return N?()=>N(o.getTokenOffset(),o.getTokenLength()):()=>!0}function c(N){return N?$=>N($,o.getTokenOffset(),o.getTokenLength()):()=>!0}const a=s(r.onObjectBegin),y=c(r.onObjectProperty),M=s(r.onObjectEnd),T=s(r.onArrayBegin),U=s(r.onArrayEnd),Y=c(r.onLiteralValue),G=c(r.onSeparator),V=s(r.onComment),oe=c(r.onError),ae=i&&i.disallowComments,se=i&&i.allowTrailingComma;function fe(){for(;;){const N=o.scan();switch(o.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:ae||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(N){case 12:case 13:ae?K(10):V();break;case 16:K(1);break;case 15:case 14:break;default:return N}}}function K(N,$=[],L=[]){if(oe(N),$.length+L.length>0){let W=o.getToken();for(;W!==17;){if($.indexOf(W)!==-1){fe();break}else if(L.indexOf(W)!==-1)break;W=fe()}}}function H(N){const $=o.getTokenValue();return N?Y($):y($),fe(),!0}function F(){switch(o.getToken()){case 11:{let N=0;try{N=JSON.parse(o.getTokenValue()),typeof N!="number"&&(K(2),N=0)}catch{K(2)}Y(N);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return fe(),!0}function A(){return o.getToken()!==10?(K(3,[],[2,5]),!1):(H(!1),o.getToken()===6?(G(":"),fe(),ne()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function O(){a(),fe();let N=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(N||K(4,[],[]),G(","),fe(),o.getToken()===2&&se)break}else N&&K(6,[],[]);A()||K(4,[],[2,5]),N=!0}return M(),o.getToken()!==2?K(7,[2],[]):fe(),!0}function _(){T(),fe();let N=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(N||K(4,[],[]),G(","),fe(),o.getToken()===4&&se)break}else N&&K(6,[],[]);ne()||K(4,[],[4,5]),N=!0}return U(),o.getToken()!==4?K(8,[4],[]):fe(),!0}function ne(){switch(o.getToken()){case 3:return _();case 1:return O();case 10:return H(!0);default:return F()}}return fe(),o.getToken()===17?i.allowEmptyContent?!0:(K(4,[],[]),!1):ne()?(o.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=m;function h(n,r){const i=D(n),o=[];let s,c=0,a;do switch(a=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:c!==a&&o.push(n.substring(c,a)),r!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,r)),c=i.getPosition();break}while(s!==17);return o.join("")}e.stripComments=h;function l(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ee[122],te([0,1,42]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(v,b,C){let I,u,w,g,f;if(b){for(g=b.offset,f=g+b.length,w=g;w>0&&!p(v,w-1);)w--;let a=f;for(;a<v.length&&!p(v,a);)a++;u=v.substring(w,a),I=D(u,C)}else u=v,I=0,w=0,g=0,f=v.length;const d=P(C,v);let S=!1,m=0,h;C.insertSpaces?h=R(" ",C.tabSize||4):h="	";const l=(0,E.createScanner)(u,!1);let n=!1;function r(){return d+R(h,I+m)}function i(){let a=l.scan();for(S=!1;a===15||a===14;)S=S||a===14,a=l.scan();return n=a===16||l.getTokenError()!==0,a}const o=[];function s(a,y,M){!n&&y<f&&M>g&&v.substring(y,M)!==a&&o.push({offset:y,length:M-y,content:a})}let c=i();if(c!==17){const a=l.getTokenOffset()+w,y=R(h,I);s(y,w,a)}for(;c!==17;){let a=l.getTokenOffset()+l.getTokenLength()+w,y=i(),M="";for(;!S&&(y===12||y===13);){const U=l.getTokenOffset()+w;s(" ",a,U),a=l.getTokenOffset()+l.getTokenLength()+w,M=y===12?r():"",y=i()}if(y===2)c!==1&&(m--,M=r());else if(y===4)c!==3&&(m--,M=r());else{switch(c){case 3:case 1:m++,M=r();break;case 5:case 12:M=r();break;case 13:S?M=r():M=" ";break;case 6:M=" ";break;case 10:if(y===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?M=" ":y!==5&&y!==17&&(n=!0);break;case 16:n=!0;break}S&&(y===12||y===13)&&(M=r())}const T=l.getTokenOffset()+w;s(M,a,T),c=y}return o}e.format=t;function k(v,b){const C=JSON.stringify(v,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?C.replace(/\r\n|\r|\n/g,b.eol):C}e.toFormattedString=k;function R(v,b){let C="";for(let I=0;I<b;I++)C+=v;return C}function D(v,b){let C=0,I=0;const u=b.tabSize||4;for(;C<v.length;){const w=v.charAt(C);if(w===" ")I++;else if(w==="	")I+=u;else break;C++}return Math.floor(I/u)}function P(v,b){for(let C=0;C<b.length;C++){const I=b.charAt(C);if(I==="\r")return C+1<b.length&&b.charAt(C+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return v&&v.eol||`
`}e.getEOL=P;function p(v,b){return`\r
`.indexOf(v.charAt(b))!==-1}e.isEOL=p}),define(ee[123],te([0,1,42,122]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(v,b,C){return R(v,b,void 0,C)}e.removeProperty=k;function R(v,b,C,I,u){const w=b.slice(),g=[],f=(0,E.parseTree)(v,g);let d,S;for(;w.length>0&&(S=w.pop(),d=(0,E.findNodeAtLocation)(f,w),d===void 0&&C!==void 0);)typeof S=="string"?C={[S]:C}:C=[C];if(d)if(d.type==="object"&&typeof S=="string"&&Array.isArray(d.children)){const m=(0,E.findNodeAtLocation)(d,[S]);if(m!==void 0)if(C===void 0){if(!m.parent)throw new Error("Malformed AST");const h=d.children.indexOf(m.parent);let l,n=m.parent.offset+m.parent.length;if(h>0){const r=d.children[h-1];l=r.offset+r.length}else l=d.offset+1,d.children.length>1&&(n=d.children[1].offset);return D(v,{offset:l,length:n-l,content:""},I)}else return D(v,{offset:m.offset,length:m.length,content:JSON.stringify(C)},I);else{if(C===void 0)return[];const h=`${JSON.stringify(S)}: ${JSON.stringify(C)}`,l=u?u(d.children.map(r=>r.children[0].value)):d.children.length;let n;if(l>0){const r=d.children[l-1];n={offset:r.offset+r.length,length:0,content:","+h}}else d.children.length===0?n={offset:d.offset+1,length:0,content:h}:n={offset:d.offset+1,length:0,content:h+","};return D(v,n,I)}}else if(d.type==="array"&&typeof S=="number"&&Array.isArray(d.children))if(C!==void 0){const m=`${JSON.stringify(C)}`;let h;if(d.children.length===0||S===0)h={offset:d.offset+1,length:0,content:d.children.length===0?m:m+","};else{const l=S===-1||S>d.children.length?d.children.length:S,n=d.children[l-1];h={offset:n.offset+n.length,length:0,content:","+m}}return D(v,h,I)}else{const m=S,h=d.children[m];let l;if(d.children.length===1)l={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===m){const n=d.children[m-1],r=n.offset+n.length,i=d.offset+d.length;l={offset:r,length:i-2-r,content:""}}else l={offset:h.offset,length:d.children[m+1].offset-h.offset,content:""};return D(v,l,I)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${d.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return D(v,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(C)},I)}}e.setProperty=R;function D(v,b,C){let I=P(v,b),u=b.offset,w=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;u>0&&!(0,t.isEOL)(I,u-1);)u--;for(;w<I.length&&!(0,t.isEOL)(I,w);)w++}const g=(0,t.format)(I,{offset:u,length:w-u},C);for(let d=g.length-1;d>=0;d--){const S=g[d];I=P(I,S),u=Math.min(u,S.offset),w=Math.max(w,S.offset+S.length),w+=S.content.length-S.length}const f=v.length-(I.length-w)-u;return[{offset:u,length:f,content:I.substring(u,w)}]}e.withFormatting=D;function P(v,b){return v.substring(0,b.offset)+b.content+v.substring(b.offset+b.length)}e.applyEdit=P;function p(v,b){const C=b.slice(0).sort((u,w)=>{const g=u.offset-w.offset;return g===0?u.length-w.length:g});let I=v.length;for(let u=C.length-1;u>=0;u--){const w=C[u];if(w.offset+w.length<=I)v=P(v,w);else throw new Error("Overlapping edit");I=w.offset}return v}e.applyEdits=p}),define(ee[124],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new E(()=>k(this.getValue()))}}e.Lazy=E}),define(ee[2],te([0,1,49,66]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function D(c){R=c}if(e.setDisposableTracker=D,k){const c="__is_disposable_tracked__";D(new class{trackDisposable(a){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[c]||console.log(y)},3e3)}setParent(a,y){if(a&&a!==S.None)try{a[c]=!0}catch{}}markAsDisposed(a){if(a&&a!==S.None)try{a[c]=!0}catch{}}markAsSingleton(a){}})}function P(c){return R?.trackDisposable(c),c}function p(c){R?.markAsDisposed(c)}function v(c,a){R?.setParent(c,a)}function b(c,a){if(!!R)for(const y of c)R.setParent(y,a)}function C(c){return R?.markAsSingleton(c),c}e.markAsSingleton=C;function I(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=I;function u(c){if(t.Iterable.is(c)){const a=[];for(const y of c)if(y)try{y.dispose()}catch(M){a.push(M)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=u;function w(c){for(const a of c)I(a)&&a.dispose();return[]}e.disposeIfDisposable=w;function g(...c){const a=f(()=>u(c));return b(c,a),a}e.combinedDisposable=g;function f(c){const a=P({dispose:(0,E.once)(()=>{p(a),c()})});return a}e.toDisposable=f;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(p(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{u(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return v(a,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new d,P(this),v(this._store,this)}dispose(){p(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=S,S.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&v(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,p(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&v(a,null),a}}e.MutableDisposable=m;class h{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=h;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(a){let y=a;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,p(this))},this}}e.SafeDisposable=l;class n{constructor(){this.references=new Map}acquire(a,...y){let M=this.references.get(a);M||(M={counter:0,object:this.createReferencedObject(a,...y)},this.references.set(a,M));const{object:T}=M,U=(0,E.once)(()=>{--M.counter===0&&(this.destroyReferencedObject(a,M.object),this.references.delete(a))});return M.counter++,{object:T,dispose:U}}}e.ReferenceCollection=n;class r{constructor(a){this.referenceCollection=a}async acquire(a,...y){const M=this.referenceCollection.acquire(a,...y);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(T){throw M.dispose(),T}}}e.AsyncReferenceCollection=r;class i{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=i;function o(c){const a=new d;try{c(a)}finally{a.dispose()}}e.disposeOnReturn=o;class s{constructor(){this._store=new Map,this._isDisposed=!1,P(this)}dispose(){p(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{u(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get(a){return this._store.get(a)}set(a,y,M=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this._store.get(a)?.dispose(),this._store.set(a,y)}deleteAndDispose(a){this._store.get(a)?.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=s}),define(ee[94],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(R){this.element=R,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class t{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let R=this._first;for(;R!==E.Undefined;){const D=R.next;R.prev=E.Undefined,R.next=E.Undefined,R=D}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const P=new E(R);if(this._first===E.Undefined)this._first=P,this._last=P;else if(D){const v=this._last;this._last=P,P.prev=v,v.next=P}else{const v=this._first;this._first=P,P.next=v,v.prev=P}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(P))}}shift(){if(this._first!==E.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==E.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==E.Undefined&&R.next!==E.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===E.Undefined&&R.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):R.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):R.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==E.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),define(ee[38],te([0,1]),function(z,e){"use strict";var E,t,k;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(w,g,f){let d=w.get(g);return d===void 0&&(d=f,w.set(g,d)),d}e.getOrSet=R;function D(w){const g=[];return w.forEach((f,d)=>{g.push(`${d} => ${f}`)}),`Map(${w.size}) {${g.join(", ")}}`}e.mapToString=D;function P(w){const g=[];return w.forEach(f=>{g.push(f)}),`Set(${w.size}) {${g.join(", ")}}`}e.setToString=P;class p{constructor(g,f){this.uri=g,this.value=f}}class v{constructor(g,f){this[E]="ResourceMap",g instanceof v?(this.map=new Map(g.map),this.toKey=f??v.defaultToKey):(this.map=new Map,this.toKey=g??v.defaultToKey)}set(g,f){return this.map.set(this.toKey(g),new p(g,f)),this}get(g){return this.map.get(this.toKey(g))?.value}has(g){return this.map.has(this.toKey(g))}get size(){return this.map.size}clear(){this.map.clear()}delete(g){return this.map.delete(this.toKey(g))}forEach(g,f){typeof f<"u"&&(g=g.bind(f));for(const[d,S]of this.map)g(S.value,S.uri,this)}*values(){for(const g of this.map.values())yield g.value}*keys(){for(const g of this.map.values())yield g.uri}*entries(){for(const g of this.map.values())yield[g.uri,g.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,g]of this.map)yield[g.uri,g.value]}}e.ResourceMap=v,v.defaultToKey=w=>w.toString();class b{constructor(g,f){this[t]="ResourceSet",!g||typeof g=="function"?this._map=new v(g):(this._map=new v(f),g.forEach(this.add,this))}get size(){return this._map.size}add(g){return this._map.set(g,g),this}clear(){this._map.clear()}delete(g){return this._map.delete(g)}forEach(g,f){this._map.forEach((d,S)=>g.call(f,S,S,this))}has(g){return this._map.has(g)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=b;var C;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(C=e.Touch||(e.Touch={}));class I{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(g){return this._map.has(g)}get(g,f=0){const d=this._map.get(g);if(!!d)return f!==0&&this.touch(d,f),d.value}set(g,f,d=0){let S=this._map.get(g);if(S)S.value=f,d!==0&&this.touch(S,d);else{switch(S={key:g,value:f,next:void 0,previous:void 0},d){case 0:this.addItemLast(S);break;case 1:this.addItemFirst(S);break;case 2:this.addItemLast(S);break;default:this.addItemLast(S);break}this._map.set(g,S),this._size++}return this}delete(g){return!!this.remove(g)}remove(g){const f=this._map.get(g);if(!!f)return this._map.delete(g),this.removeItem(f),this._size--,f.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const g=this._head;return this._map.delete(g.key),this.removeItem(g),this._size--,g.value}forEach(g,f){const d=this._state;let S=this._head;for(;S;){if(f?g.bind(f)(S.value,S.key,this):g(S.value,S.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");S=S.next}}keys(){const g=this,f=this._state;let d=this._head;const S={[Symbol.iterator](){return S},next(){if(g._state!==f)throw new Error("LinkedMap got modified during iteration.");if(d){const m={value:d.key,done:!1};return d=d.next,m}else return{value:void 0,done:!0}}};return S}values(){const g=this,f=this._state;let d=this._head;const S={[Symbol.iterator](){return S},next(){if(g._state!==f)throw new Error("LinkedMap got modified during iteration.");if(d){const m={value:d.value,done:!1};return d=d.next,m}else return{value:void 0,done:!0}}};return S}entries(){const g=this,f=this._state;let d=this._head;const S={[Symbol.iterator](){return S},next(){if(g._state!==f)throw new Error("LinkedMap got modified during iteration.");if(d){const m={value:[d.key,d.value],done:!1};return d=d.next,m}else return{value:void 0,done:!0}}};return S}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(g){if(g>=this.size)return;if(g===0){this.clear();return}let f=this._head,d=this.size;for(;f&&d>g;)this._map.delete(f.key),f=f.next,d--;this._head=f,this._size=d,f&&(f.previous=void 0),this._state++}addItemFirst(g){if(!this._head&&!this._tail)this._tail=g;else if(this._head)g.next=this._head,this._head.previous=g;else throw new Error("Invalid list");this._head=g,this._state++}addItemLast(g){if(!this._head&&!this._tail)this._head=g;else if(this._tail)g.previous=this._tail,this._tail.next=g;else throw new Error("Invalid list");this._tail=g,this._state++}removeItem(g){if(g===this._head&&g===this._tail)this._head=void 0,this._tail=void 0;else if(g===this._head){if(!g.next)throw new Error("Invalid list");g.next.previous=void 0,this._head=g.next}else if(g===this._tail){if(!g.previous)throw new Error("Invalid list");g.previous.next=void 0,this._tail=g.previous}else{const f=g.next,d=g.previous;if(!f||!d)throw new Error("Invalid list");f.previous=d,d.next=f}g.next=void 0,g.previous=void 0,this._state++}touch(g,f){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(g===this._head)return;const d=g.next,S=g.previous;g===this._tail?(S.next=void 0,this._tail=S):(d.previous=S,S.next=d),g.previous=void 0,g.next=this._head,this._head.previous=g,this._head=g,this._state++}else if(f===2){if(g===this._tail)return;const d=g.next,S=g.previous;g===this._head?(d.previous=void 0,this._head=d):(d.previous=S,S.next=d),g.next=void 0,g.previous=this._tail,this._tail.next=g,this._tail=g,this._state++}}}toJSON(){const g=[];return this.forEach((f,d)=>{g.push([d,f])}),g}fromJSON(g){this.clear();for(const[f,d]of g)this.set(f,d)}}e.LinkedMap=I;class u extends I{constructor(g,f=1){super(),this._limit=g,this._ratio=Math.min(Math.max(0,f),1)}get limit(){return this._limit}set limit(g){this._limit=g,this.checkTrim()}get ratio(){return this._ratio}set ratio(g){this._ratio=Math.min(Math.max(0,g),1),this.checkTrim()}get(g,f=2){return super.get(g,f)}peek(g){return super.get(g,0)}set(g,f){return super.set(g,f,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u}),define(ee[76],te([0,1,38]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new E.LRUCache(1e4);function k(v){return p(v,"NFC",t)}e.normalizeNFC=k;const R=new E.LRUCache(1e4);function D(v){return p(v,"NFD",R)}e.normalizeNFD=D;const P=/[^\u0000-\u0080]/;function p(v,b,C){if(!v)return v;const I=C.get(v);if(I)return I;let u;return P.test(v)?u=v.normalize(b):u=v,C.set(v,u),u}e.removeAccents=function(){const v=/[\u0300-\u036f]/g;return function(b){return D(b).replace(v,"")}}()}),function(){function z(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function D(p){R.push(p,Date.now())}function P(){const p=[];for(let v=0;v<R.length;v+=2)p.push({name:R[v],startTime:R[v+1]});return p}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(k+D.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function E(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=E(t))}(),function(z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var t in E)(typeof exports=="object"?exports:z)[t]=E[t]}}(typeof self<"u"?self:this,function(){return function(z){var e={};function E(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return z[t].call(k.exports,k,k.exports,E),k.l=!0,k.exports}return E.m=z,E.c=e,E.d=function(t,k,R){E.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},E.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},E.t=function(t,k){if(1&k&&(t=E(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(E.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var D in t)E.d(R,D,function(P){return t[P]}.bind(null,D));return R},E.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return E.d(k,"a",k),k},E.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},E.p="",E(E.s=0)}([function(z,e,E){(function(t){var k;e=z.exports=L,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],p=e.src=[],v=0,b=v++;p[b]="0|[1-9]\\d*";var C=v++;p[C]="[0-9]+";var I=v++;p[I]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=v++;p[u]="("+p[b]+")\\.("+p[b]+")\\.("+p[b]+")";var w=v++;p[w]="("+p[C]+")\\.("+p[C]+")\\.("+p[C]+")";var g=v++;p[g]="(?:"+p[b]+"|"+p[I]+")";var f=v++;p[f]="(?:"+p[C]+"|"+p[I]+")";var d=v++;p[d]="(?:-("+p[g]+"(?:\\."+p[g]+")*))";var S=v++;p[S]="(?:-?("+p[f]+"(?:\\."+p[f]+")*))";var m=v++;p[m]="[0-9A-Za-z-]+";var h=v++;p[h]="(?:\\+("+p[m]+"(?:\\."+p[m]+")*))";var l=v++,n="v?"+p[u]+p[d]+"?"+p[h]+"?";p[l]="^"+n+"$";var r="[v=\\s]*"+p[w]+p[S]+"?"+p[h]+"?",i=v++;p[i]="^"+r+"$";var o=v++;p[o]="((?:<|>)?=?)";var s=v++;p[s]=p[C]+"|x|X|\\*";var c=v++;p[c]=p[b]+"|x|X|\\*";var a=v++;p[a]="[v=\\s]*("+p[c]+")(?:\\.("+p[c]+")(?:\\.("+p[c]+")(?:"+p[d]+")?"+p[h]+"?)?)?";var y=v++;p[y]="[v=\\s]*("+p[s]+")(?:\\.("+p[s]+")(?:\\.("+p[s]+")(?:"+p[S]+")?"+p[h]+"?)?)?";var M=v++;p[M]="^"+p[o]+"\\s*"+p[a]+"$";var T=v++;p[T]="^"+p[o]+"\\s*"+p[y]+"$";var U=v++;p[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=v++;p[Y]="(?:~>?)";var G=v++;p[G]="(\\s*)"+p[Y]+"\\s+",P[G]=new RegExp(p[G],"g");var V=v++;p[V]="^"+p[Y]+p[a]+"$";var oe=v++;p[oe]="^"+p[Y]+p[y]+"$";var ae=v++;p[ae]="(?:\\^)";var se=v++;p[se]="(\\s*)"+p[ae]+"\\s+",P[se]=new RegExp(p[se],"g");var fe=v++;p[fe]="^"+p[ae]+p[a]+"$";var K=v++;p[K]="^"+p[ae]+p[y]+"$";var H=v++;p[H]="^"+p[o]+"\\s*("+r+")$|^$";var F=v++;p[F]="^"+p[o]+"\\s*("+n+")$|^$";var A=v++;p[A]="(\\s*)"+p[o]+"\\s*("+r+"|"+p[a]+")",P[A]=new RegExp(p[A],"g");var O=v++;p[O]="^\\s*("+p[a]+")\\s+-\\s+("+p[a]+")\\s*$";var _=v++;p[_]="^\\s*("+p[y]+")\\s+-\\s+("+p[y]+")\\s*$";var ne=v++;p[ne]="(<|>)?=?\\s*\\*";for(var N=0;N<35;N++)k(N,p[N]),P[N]||(P[N]=new RegExp(p[N]));function $(x,ue){if(x instanceof L)return x;if(typeof x!="string"||x.length>R||!(ue?P[i]:P[l]).test(x))return null;try{return new L(x,ue)}catch{return null}}function L(x,ue){if(x instanceof L){if(x.loose===ue)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(x,ue);k("SemVer",x,ue),this.loose=ue;var de=x.trim().match(ue?P[i]:P[l]);if(!de)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Ce=+ye;if(Ce>=0&&Ce<D)return Ce}return ye}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=$,e.valid=function(x,ue){var de=$(x,ue);return de?de.version:null},e.clean=function(x,ue){var de=$(x.trim().replace(/^[=v]+/,""),ue);return de?de.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(x){return k("SemVer.compare",this.version,this.loose,x),x instanceof L||(x=new L(x,this.loose)),this.compareMain(x)||this.comparePre(x)},L.prototype.compareMain=function(x){return x instanceof L||(x=new L(x,this.loose)),j(this.major,x.major)||j(this.minor,x.minor)||j(this.patch,x.patch)},L.prototype.comparePre=function(x){if(x instanceof L||(x=new L(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var ue=0;do{var de=this.prerelease[ue],ye=x.prerelease[ue];if(k("prerelease compare",ue,de,ye),de===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(de===void 0)return-1;if(de!==ye)return j(de,ye)}while(++ue)},L.prototype.inc=function(x,ue){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,ue,de,ye){typeof de=="string"&&(ye=de,de=void 0);try{return new L(x,de).inc(ue,ye).version}catch{return null}},e.diff=function(x,ue){if(B(x,ue))return null;var de=$(x),ye=$(ue);if(de.prerelease.length||ye.prerelease.length){for(var Ce in de)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&de[Ce]!==ye[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in de)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&de[Ce]!==ye[Ce])return Ce},e.compareIdentifiers=j;var W=/^[0-9]+$/;function j(x,ue){var de=W.test(x),ye=W.test(ue);return de&&ye&&(x=+x,ue=+ue),de&&!ye?-1:ye&&!de?1:x<ue?-1:x>ue?1:0}function q(x,ue,de){return new L(x,de).compare(new L(ue,de))}function X(x,ue,de){return q(x,ue,de)>0}function re(x,ue,de){return q(x,ue,de)<0}function B(x,ue,de){return q(x,ue,de)===0}function J(x,ue,de){return q(x,ue,de)!==0}function Z(x,ue,de){return q(x,ue,de)>=0}function ce(x,ue,de){return q(x,ue,de)<=0}function ge(x,ue,de,ye){var Ce;switch(ue){case"===":typeof x=="object"&&(x=x.version),typeof de=="object"&&(de=de.version),Ce=x===de;break;case"!==":typeof x=="object"&&(x=x.version),typeof de=="object"&&(de=de.version),Ce=x!==de;break;case"":case"=":case"==":Ce=B(x,de,ye);break;case"!=":Ce=J(x,de,ye);break;case">":Ce=X(x,de,ye);break;case">=":Ce=Z(x,de,ye);break;case"<":Ce=re(x,de,ye);break;case"<=":Ce=ce(x,de,ye);break;default:throw new TypeError("Invalid operator: "+ue)}return Ce}function De(x,ue){if(x instanceof De){if(x.loose===ue)return x;x=x.value}if(!(this instanceof De))return new De(x,ue);k("comparator",x,ue),this.loose=ue,this.parse(x),this.semver===Te?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(x,ue){return j(ue,x)},e.major=function(x,ue){return new L(x,ue).major},e.minor=function(x,ue){return new L(x,ue).minor},e.patch=function(x,ue){return new L(x,ue).patch},e.compare=q,e.compareLoose=function(x,ue){return q(x,ue,!0)},e.rcompare=function(x,ue,de){return q(ue,x,de)},e.sort=function(x,ue){return x.sort(function(de,ye){return e.compare(de,ye,ue)})},e.rsort=function(x,ue){return x.sort(function(de,ye){return e.rcompare(de,ye,ue)})},e.gt=X,e.lt=re,e.eq=B,e.neq=J,e.gte=Z,e.lte=ce,e.cmp=ge,e.Comparator=De;var Te={};function Me(x,ue){if(x instanceof Me)return x.loose===ue?x:new Me(x.raw,ue);if(x instanceof De)return new Me(x.value,ue);if(!(this instanceof Me))return new Me(x,ue);if(this.loose=ue,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function Le(x){return!x||x.toLowerCase()==="x"||x==="*"}function we(x,ue,de,ye,Ce,Fe,Oe,$e,Ne,je,Qe,Be,Ge){return((ue=Le(de)?"":Le(ye)?">="+de+".0.0":Le(Ce)?">="+de+"."+ye+".0":">="+ue)+" "+($e=Le(Ne)?"":Le(je)?"<"+(+Ne+1)+".0.0":Le(Qe)?"<"+Ne+"."+(+je+1)+".0":Be?"<="+Ne+"."+je+"."+Qe+"-"+Be:"<="+$e)).trim()}function pe(x,ue){for(var de=0;de<x.length;de++)if(!x[de].test(ue))return!1;if(ue.prerelease.length){for(de=0;de<x.length;de++)if(k(x[de].semver),x[de].semver!==Te&&x[de].semver.prerelease.length>0){var ye=x[de].semver;if(ye.major===ue.major&&ye.minor===ue.minor&&ye.patch===ue.patch)return!0}return!1}return!0}function Se(x,ue,de){try{ue=new Me(ue,de)}catch{return!1}return ue.test(x)}function ke(x,ue,de,ye){var Ce,Fe,Oe,$e,Ne;switch(x=new L(x,ye),ue=new Me(ue,ye),de){case">":Ce=X,Fe=ce,Oe=re,$e=">",Ne=">=";break;case"<":Ce=re,Fe=Z,Oe=X,$e="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(x,ue,ye))return!1;for(var je=0;je<ue.set.length;++je){var Qe=ue.set[je],Be=null,Ge=null;if(Qe.forEach(function(Q){Q.semver===Te&&(Q=new De(">=0.0.0")),Be=Be||Q,Ge=Ge||Q,Ce(Q.semver,Be.semver,ye)?Be=Q:Oe(Q.semver,Ge.semver,ye)&&(Ge=Q)}),Be.operator===$e||Be.operator===Ne||(!Ge.operator||Ge.operator===$e)&&Fe(x,Ge.semver)||Ge.operator===Ne&&Oe(x,Ge.semver))return!1}return!0}De.prototype.parse=function(x){var ue=this.loose?P[H]:P[F],de=x.match(ue);if(!de)throw new TypeError("Invalid comparator: "+x);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new L(de[2],this.loose):this.semver=Te},De.prototype.toString=function(){return this.value},De.prototype.test=function(x){return k("Comparator.test",x,this.loose),this.semver===Te||(typeof x=="string"&&(x=new L(x,this.loose)),ge(x,this.operator,this.semver,this.loose))},De.prototype.intersects=function(x,ue){if(!(x instanceof De))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Me(x.value,ue),Se(this.value,de,ue);if(x.operator==="")return de=new Me(this.value,ue),Se(x.semver,de,ue);var ye=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Fe=this.semver.version===x.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),$e=ge(this.semver,"<",x.semver,ue)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Ne=ge(this.semver,">",x.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ye||Ce||Fe&&Oe||$e||Ne},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(x){var ue=this.loose;x=x.trim(),k("range",x,ue);var de=ue?P[_]:P[O];x=x.replace(de,we),k("hyphen replace",x),x=x.replace(P[A],"$1$2$3"),k("comparator trim",x,P[A]),x=(x=(x=x.replace(P[G],"$1~")).replace(P[se],"$1^")).split(/\s+/).join(" ");var ye=ue?P[H]:P[F],Ce=x.split(" ").map(function(Fe){return function(Oe,$e){return k("comp",Oe),Oe=function(Ne,je){return Ne.trim().split(/\s+/).map(function(Qe){return function(Be,Ge){k("caret",Be,Ge);var Q=Ge?P[K]:P[fe];return Be.replace(Q,function(le,he,me,be,Ae){var Ue;return k("caret",Be,le,he,me,be,Ae),Le(he)?Ue="":Le(me)?Ue=">="+he+".0.0 <"+(+he+1)+".0.0":Le(be)?Ue=he==="0"?">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":">="+he+"."+me+".0 <"+(+he+1)+".0.0":Ae?(k("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Ue=he==="0"?me==="0"?">="+he+"."+me+"."+be+Ae+" <"+he+"."+me+"."+(+be+1):">="+he+"."+me+"."+be+Ae+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+be+Ae+" <"+(+he+1)+".0.0"):(k("no pr"),Ue=he==="0"?me==="0"?">="+he+"."+me+"."+be+" <"+he+"."+me+"."+(+be+1):">="+he+"."+me+"."+be+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+be+" <"+(+he+1)+".0.0"),k("caret return",Ue),Ue})}(Qe,je)}).join(" ")}(Oe,$e),k("caret",Oe),Oe=function(Ne,je){return Ne.trim().split(/\s+/).map(function(Qe){return function(Be,Ge){var Q=Ge?P[oe]:P[V];return Be.replace(Q,function(le,he,me,be,Ae){var Ue;return k("tilde",Be,le,he,me,be,Ae),Le(he)?Ue="":Le(me)?Ue=">="+he+".0.0 <"+(+he+1)+".0.0":Le(be)?Ue=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":Ae?(k("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Ue=">="+he+"."+me+"."+be+Ae+" <"+he+"."+(+me+1)+".0"):Ue=">="+he+"."+me+"."+be+" <"+he+"."+(+me+1)+".0",k("tilde return",Ue),Ue})}(Qe,je)}).join(" ")}(Oe,$e),k("tildes",Oe),Oe=function(Ne,je){return k("replaceXRanges",Ne,je),Ne.split(/\s+/).map(function(Qe){return function(Be,Ge){Be=Be.trim();var Q=Ge?P[T]:P[M];return Be.replace(Q,function(le,he,me,be,Ae,Ue){k("xRange",Be,le,he,me,be,Ae,Ue);var it=Le(me),Je=it||Le(be),He=Je||Le(Ae);return he==="="&&He&&(he=""),it?le=he===">"||he==="<"?"<0.0.0":"*":he&&He?(Je&&(be=0),He&&(Ae=0),he===">"?(he=">=",Je?(me=+me+1,be=0,Ae=0):He&&(be=+be+1,Ae=0)):he==="<="&&(he="<",Je?me=+me+1:be=+be+1),le=he+me+"."+be+"."+Ae):Je?le=">="+me+".0.0 <"+(+me+1)+".0.0":He&&(le=">="+me+"."+be+".0 <"+me+"."+(+be+1)+".0"),k("xRange return",le),le})}(Qe,je)}).join(" ")}(Oe,$e),k("xrange",Oe),Oe=function(Ne,je){return k("replaceStars",Ne,je),Ne.trim().replace(P[ne],"")}(Oe,$e),k("stars",Oe),Oe}(Fe,ue)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Fe){return!!Fe.match(ye)})),Ce=Ce.map(function(Fe){return new De(Fe,ue)})},Me.prototype.intersects=function(x,ue){if(!(x instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(ye){return x.set.some(function(Ce){return Ce.every(function(Fe){return ye.intersects(Fe,ue)})})})})},e.toComparators=function(x,ue){return new Me(x,ue).set.map(function(de){return de.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new L(x,this.loose));for(var ue=0;ue<this.set.length;ue++)if(pe(this.set[ue],x))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(x,ue,de){var ye=null,Ce=null;try{var Fe=new Me(ue,de)}catch{return null}return x.forEach(function(Oe){Fe.test(Oe)&&(ye&&Ce.compare(Oe)!==-1||(Ce=new L(ye=Oe,de)))}),ye},e.minSatisfying=function(x,ue,de){var ye=null,Ce=null;try{var Fe=new Me(ue,de)}catch{return null}return x.forEach(function(Oe){Fe.test(Oe)&&(ye&&Ce.compare(Oe)!==1||(Ce=new L(ye=Oe,de)))}),ye},e.validRange=function(x,ue){try{return new Me(x,ue).range||"*"}catch{return null}},e.ltr=function(x,ue,de){return ke(x,ue,"<",de)},e.gtr=function(x,ue,de){return ke(x,ue,">",de)},e.outside=ke,e.prerelease=function(x,ue){var de=$(x,ue);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(x,ue,de){return x=new Me(x,de),ue=new Me(ue,de),x.intersects(ue)},e.coerce=function(x){if(x instanceof L)return x;if(typeof x!="string")return null;var ue=x.match(P[U]);return ue==null?null:$((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,E(1))},function(z,e){var E,t,k=z.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function P(f){if(E===setTimeout)return setTimeout(f,0);if((E===R||!E)&&setTimeout)return E=setTimeout,setTimeout(f,0);try{return E(f,0)}catch{try{return E.call(null,f,0)}catch{return E.call(this,f,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:R}catch{E=R}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var p,v=[],b=!1,C=-1;function I(){b&&p&&(b=!1,p.length?v=p.concat(v):C=-1,v.length&&u())}function u(){if(!b){var f=P(I);b=!0;for(var d=v.length;d;){for(p=v,v=[];++C<d;)p&&p[C].run();C=-1,d=v.length}p=null,b=!1,function(S){if(t===clearTimeout)return clearTimeout(S);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(S);try{t(S)}catch{try{return t.call(null,S)}catch{return t.call(this,S)}}}(f)}}function w(f,d){this.fun=f,this.array=d}function g(){}k.nextTick=function(f){var d=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)d[S-1]=arguments[S];v.push(new w(f,d)),v.length!==1||b||P(u)},w.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=g,k.addListener=g,k.once=g,k.off=g,k.removeListener=g,k.removeAllListeners=g,k.emit=g,k.prependListener=g,k.prependOnceListener=g,k.listeners=function(f){return[]},k.binding=function(f){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(f){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ee[125],te([0,1]),function(z,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(P,p,v){this.level=P,this.key=p,this.value=v,this.forward=[]}}const k=void 0;class R{constructor(P,p=2**16){this.comparator=P,this[E]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(p)|0),this._header=new t(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,k,k)}has(P){return Boolean(R._search(this,P,this.comparator))}get(P){return R._search(this,P,this.comparator)?.value}set(P,p){return R._insert(this,P,p,this.comparator)&&(this._size+=1),this}delete(P){const p=R._delete(this,P,this.comparator);return p&&(this._size-=1),p}forEach(P,p){let v=this._header.forward[0];for(;v;)P.call(p,v.value,v.key,this),v=v.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",p=this._header.forward[0];for(;p;)P+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return P}static _search(P,p,v){let b=P._header;for(let C=P._level-1;C>=0;C--)for(;b.forward[C]&&v(b.forward[C].key,p)<0;)b=b.forward[C];if(b=b.forward[0],b&&v(b.key,p)===0)return b}static _insert(P,p,v,b){const C=[];let I=P._header;for(let u=P._level-1;u>=0;u--){for(;I.forward[u]&&b(I.forward[u].key,p)<0;)I=I.forward[u];C[u]=I}if(I=I.forward[0],I&&b(I.key,p)===0)return I.value=v,!1;{const u=R._randomLevel(P);if(u>P._level){for(let w=P._level;w<u;w++)C[w]=P._header;P._level=u}I=new t(u,p,v);for(let w=0;w<u;w++)I.forward[w]=C[w].forward[w],C[w].forward[w]=I;return!0}}static _randomLevel(P,p=.5){let v=1;for(;Math.random()<p&&v<P._maxLevel;)v+=1;return v}static _delete(P,p,v){const b=[];let C=P._header;for(let I=P._level-1;I>=0;I--){for(;C.forward[I]&&v(C.forward[I].key,p)<0;)C=C.forward[I];b[I]=C}if(C=C.forward[0],!C||v(C.key,p)!==0)return!1;for(let I=0;I<P._level&&b[I].forward[I]===C;I++)b[I].forward[I]=C.forward[I];for(;P._level>0&&P._header.forward[P._level-1]===k;)P._level-=1;return!0}}e.SkipList=R}),define(ee[57],te([0,1,16,2]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(h){const l=h;return l?typeof l.read=="function":!1}e.isReadable=k;function R(h){const l=h;return l?[l.on,l.pause,l.resume,l.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=R;function D(h){const l=h;return l?R(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=D;function P(h,l){return new p(h,l)}e.newWriteableStream=P;class p{constructor(l,n){this.reducer=l,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l<"u"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(n=>n(l))}emitError(l){this.listeners.error.length===0?(0,E.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(n=>n(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,n){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(l,n){if(this.state.destroyed)return;let r;switch(l){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const i=r.indexOf(n);i>=0&&r.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function v(h,l){const n=[];let r;for(;(r=h.read())!==null;)n.push(r);return l(n)}e.consumeReadable=v;function b(h,l,n){const r=[];let i;for(;(i=h.read())!==null&&r.length<n;)r.push(i);return i===null&&r.length>0?l(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i<"u"){const o=i;return i=void 0,o}return h.read()}}}e.peekReadable=b;function C(h,l){return new Promise((n,r)=>{const i=[];I(h,{onData:o=>{l&&i.push(o)},onError:o=>{l?r(o):n(void 0)},onEnd:()=>{n(l?l(i):void 0)}})})}e.consumeStream=C;function I(h,l){let n=!1;return h.on("error",r=>{n||l.onError(r)}),h.on("end",()=>{n||l.onEnd()}),h.on("data",r=>{n||l.onData(r)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=I;function u(h,l){return new Promise((n,r)=>{const i=new t.DisposableStore,o=[],s=y=>{if(o.push(y),o.length>l)return i.dispose(),h.pause(),n({stream:h,buffer:o,ended:!1})},c=y=>r(y),a=()=>n({stream:h,buffer:o,ended:!0});i.add((0,t.toDisposable)(()=>h.removeListener("error",c))),h.on("error",c),i.add((0,t.toDisposable)(()=>h.removeListener("end",a))),h.on("end",a),i.add((0,t.toDisposable)(()=>h.removeListener("data",s))),h.on("data",s)})}e.peekStream=u;function w(h,l){const n=P(l);return n.end(h),n}e.toStream=w;function g(){const h=P(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=g;function f(h){let l=!1;return{read:()=>l?null:(l=!0,h)}}e.toReadable=f;function d(h,l,n){const r=P(n);return I(h,{onData:i=>r.write(l.data(i)),onError:i=>r.error(l.error?l.error(i):i),onEnd:()=>r.end()}),r}e.transform=d;function S(h,l,n){let r=!1;return{read:()=>{const i=l.read();return r?i:(r=!0,i!==null?n([h,i]):h)}}}e.prefixedReadable=S;function m(h,l,n){let r=!1;const i=P(n);return I(l,{onData:o=>r?i.write(o):(r=!0,i.write(n([h,o]))),onError:o=>i.error(o),onEnd:()=>{r||(r=!0,i.write(h)),i.end()}}),i}e.prefixedStream=m}),define(ee[17],te([0,1,57]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,R;class D{static alloc(y){return t?new D(Buffer.allocUnsafe(y)):new D(new Uint8Array(y))}static wrap(y){return t&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new D(y)}static fromString(y,M){return!(M?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(y)):(k||(k=new TextEncoder),new D(k.encode(y)))}static fromByteArray(y){const M=D.alloc(y.length);for(let T=0,U=y.length;T<U;T++)M.buffer[T]=y[T];return M}static concat(y,M){if(typeof M>"u"){M=0;for(let Y=0,G=y.length;Y<G;Y++)M+=y[Y].byteLength}const T=D.alloc(M);let U=0;for(let Y=0,G=y.length;Y<G;Y++){const V=y[Y];T.set(V,U),U+=V.byteLength}return T}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=D.alloc(this.byteLength);return y.set(this),y}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(y,M){return new D(this.buffer.subarray(y,M))}set(y,M){if(y instanceof D)this.buffer.set(y.buffer,M);else if(y instanceof Uint8Array)this.buffer.set(y,M);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),M);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return v(this.buffer,y)}writeUInt32BE(y,M){b(this.buffer,y,M)}readUInt32LE(y){return C(this.buffer,y)}writeUInt32LE(y,M){I(this.buffer,y,M)}readUInt8(y){return u(this.buffer,y)}writeUInt8(y,M){w(this.buffer,y,M)}}e.VSBuffer=D;function P(a,y){return a[y+0]<<0>>>0|a[y+1]<<8>>>0}e.readUInt16LE=P;function p(a,y,M){a[M+0]=y&255,y=y>>>8,a[M+1]=y&255}e.writeUInt16LE=p;function v(a,y){return a[y]*2**24+a[y+1]*2**16+a[y+2]*2**8+a[y+3]}e.readUInt32BE=v;function b(a,y,M){a[M+3]=y,y=y>>>8,a[M+2]=y,y=y>>>8,a[M+1]=y,y=y>>>8,a[M]=y}e.writeUInt32BE=b;function C(a,y){return a[y+0]<<0>>>0|a[y+1]<<8>>>0|a[y+2]<<16>>>0|a[y+3]<<24>>>0}e.readUInt32LE=C;function I(a,y,M){a[M+0]=y&255,y=y>>>8,a[M+1]=y&255,y=y>>>8,a[M+2]=y&255,y=y>>>8,a[M+3]=y&255}e.writeUInt32LE=I;function u(a,y){return a[y]}e.readUInt8=u;function w(a,y,M){a[M]=y}e.writeUInt8=w;function g(a){return E.consumeReadable(a,y=>D.concat(y))}e.readableToBuffer=g;function f(a){return E.toReadable(a)}e.bufferToReadable=f;function d(a){return E.consumeStream(a,y=>D.concat(y))}e.streamToBuffer=d;async function S(a){return a.ended?D.concat(a.buffer):D.concat([...a.buffer,await d(a.stream)])}e.bufferedStreamToBuffer=S;function m(a){return E.toStream(a,y=>D.concat(y))}e.bufferToStream=m;function h(a){return E.transform(a,{data:y=>typeof y=="string"?D.fromString(y):D.wrap(y)},y=>D.concat(y))}e.streamToBufferReadableStream=h;function l(a){return E.newWriteableStream(y=>D.concat(y),a)}e.newWriteableBufferStream=l;function n(a,y){return E.prefixedReadable(a,y,M=>D.concat(M))}e.prefixedBufferReadable=n;function r(a,y){return E.prefixedStream(a,y,M=>D.concat(M))}e.prefixedBufferStream=r;function i(a){let y=0,M=0,T=0;const U=new Uint8Array(Math.floor(a.length/4*3)),Y=V=>{switch(M){case 3:U[T++]=y|V,M=0;break;case 2:U[T++]=y|V>>>2,y=V<<6,M=3;break;case 1:U[T++]=y|V>>>4,y=V<<4,M=2;break;default:y=V<<2,M=1}};for(let V=0;V<a.length;V++){const oe=a.charCodeAt(V);if(oe>=65&&oe<=90)Y(oe-65);else if(oe>=97&&oe<=122)Y(oe-97+26);else if(oe>=48&&oe<=57)Y(oe-48+52);else if(oe===43||oe===45)Y(62);else if(oe===47||oe===95)Y(63);else{if(oe===61)break;throw new SyntaxError(`Unexpected base64 character ${a[V]}`)}}const G=T;for(;M>0;)Y(0);return D.wrap(U).slice(0,G)}e.decodeBase64=i;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:a},y=!0,M=!1){const T=M?s:o;let U="";const Y=a.byteLength%3;let G=0;for(;G<a.byteLength-Y;G+=3){const V=a[G+0],oe=a[G+1],ae=a[G+2];U+=T[V>>>2],U+=T[(V<<4|oe>>>4)&63],U+=T[(oe<<2|ae>>>6)&63],U+=T[ae&63]}if(Y===1){const V=a[G+0];U+=T[V>>>2],U+=T[V<<4&63],y&&(U+="==")}else if(Y===2){const V=a[G+0],oe=a[G+1];U+=T[V>>>2],U+=T[(V<<4|oe>>>4)&63],U+=T[oe<<2&63],y&&(U+="=")}return U}e.encodeBase64=c}),define(ee[12],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(r){return typeof r=="string"}e.isString=E;function t(r){return Array.isArray(r)&&r.every(i=>E(i))}e.isStringArray=t;function k(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=k;function R(r){const i=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof i}e.isTypedArray=R;function D(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=D;function P(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=P;function p(r){return r===!0||r===!1}e.isBoolean=p;function v(r){return typeof r>"u"}e.isUndefined=v;function b(r){return!C(r)}e.isDefined=b;function C(r){return v(r)||r===null}e.isUndefinedOrNull=C;function I(r,i){if(!r)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=I;function u(r){if(C(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=u;function w(...r){const i=[];for(let o=0;o<r.length;o++){const s=r[o];if(C(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(s)}return i}e.assertAllDefined=w;const g=Object.prototype.hasOwnProperty;function f(r){if(!k(r))return!1;for(const i in r)if(g.call(r,i))return!1;return!0}e.isEmptyObject=f;function d(r){return typeof r=="function"}e.isFunction=d;function S(...r){return r.length>0&&r.every(d)}e.areFunctions=S;function m(r,i){const o=Math.min(r.length,i.length);for(let s=0;s<o;s++)h(r[s],i[s])}e.validateConstraints=m;function h(r,i){if(E(i)){if(typeof r!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(d(i)){try{if(r instanceof i)return}catch{}if(!C(r)&&r.constructor===i||i.length===1&&i.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function l(r){return r===null?void 0:r}e.withNullAsUndefined=l;function n(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=n}),define(ee[50],te([0,1,12]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const S=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([m,h])=>{S[m]=h&&typeof h=="object"?t(h):h}),S}e.deepClone=t;function k(d){if(!d||typeof d!="object")return d;const S=[d];for(;S.length>0;){const m=S.shift();Object.freeze(m);for(const h in m)if(R.call(m,h)){const l=m[h];typeof l=="object"&&!Object.isFrozen(l)&&!(0,E.isTypedArray)(l)&&S.push(l)}}return d}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function D(d,S){return P(d,S,new Set)}e.cloneAndChange=D;function P(d,S,m){if((0,E.isUndefinedOrNull)(d))return d;const h=S(d);if(typeof h<"u")return h;if(Array.isArray(d)){const l=[];for(const n of d)l.push(P(n,S,m));return l}if((0,E.isObject)(d)){if(m.has(d))throw new Error("Cannot clone recursive data-structure");m.add(d);const l={};for(const n in d)R.call(d,n)&&(l[n]=P(d[n],S,m));return m.delete(d),l}return d}function p(d,S,m=!0){return(0,E.isObject)(d)?((0,E.isObject)(S)&&Object.keys(S).forEach(h=>{h in d?m&&((0,E.isObject)(d[h])&&(0,E.isObject)(S[h])?p(d[h],S[h],m):d[h]=S[h]):d[h]=S[h]}),d):S}e.mixin=p;function v(d,S){if(d===S)return!0;if(d==null||S===null||S===void 0||typeof d!=typeof S||typeof d!="object"||Array.isArray(d)!==Array.isArray(S))return!1;let m,h;if(Array.isArray(d)){if(d.length!==S.length)return!1;for(m=0;m<d.length;m++)if(!v(d[m],S[m]))return!1}else{const l=[];for(h in d)l.push(h);l.sort();const n=[];for(h in S)n.push(h);if(n.sort(),!v(l,n))return!1;for(m=0;m<l.length;m++)if(!v(d[l[m]],S[l[m]]))return!1}return!0}e.equals=v;function b(d){const S=new Set;return JSON.stringify(d,(m,h)=>{if((0,E.isObject)(h)||Array.isArray(h)){if(S.has(h))return"[Circular]";S.add(h)}return h})}e.safeStringify=b;function C(d,S){const m=Object.create(null);return!d||!S||Object.keys(S).forEach(l=>{const n=d[l],r=S[l];v(n,r)||(m[l]=r)}),m}e.distinct=C;function I(d,S){const m=S.toLowerCase(),h=Object.keys(d).find(l=>l.toLowerCase()===m);return h?d[h]:d[S]}e.getCaseInsensitive=I;function u(d,S){const m=Object.create(null);for(const[h,l]of Object.entries(d))S(h,l)&&(m[h]=l);return m}e.filter=u;function w(d){let S=[],m=Object.getPrototypeOf(d);for(;Object.prototype!==m;)S=S.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return S}e.getAllPropertyNames=w;function g(d){const S=[];for(const m of w(d))typeof d[m]=="function"&&S.push(m);return S}e.getAllMethodNames=g;function f(d,S){const m=l=>function(){const n=Array.prototype.slice.call(arguments,0);return S(l,n)},h={};for(const l of d)h[l]=m(l);return h}e.createProxyObject=f}),define(ee[29],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return E.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(P){for(let p=0;p<P.length;p++)P[p]=Math.floor(Math.random()*256);return P};const R=new Uint8Array(16),D=[];for(let P=0;P<256;P++)D.push(P.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let p=0,v="";return v+=D[R[p++]],v+=D[R[p++]],v+=D[R[p++]],v+=D[R[p++]],v+="-",v+=D[R[p++]],v+=D[R[p++]],v+="-",v+=D[R[p++]],v+=D[R[p++]],v+="-",v+=D[R[p++]],v+=D[R[p++]],v+="-",v+=D[R[p++]],v+=D[R[p++]],v+=D[R[p++]],v+=D[R[p++]],v+=D[R[p++]],v+=D[R[p++]],v}}()}),define(ee[126],te([0,1,77,39,49]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(D,P){if(await new Promise((b,C)=>{const I=t.createReadStream(D),u=E.createHash("sha1");I.pipe(u);const w=(0,k.once)((g,f)=>{I.removeAllListeners(),u.removeAllListeners(),g?C(g):b(f)});I.once("error",w),I.once("end",w),u.once("error",w),u.once("data",g=>w(void 0,g.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.checksum=R}),define(ee[127],te([0,1,27]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(D){const P=D.replace(/\-/g,":").toLowerCase();return!t.has(P)}function R(){const D=(0,E.networkInterfaces)();for(const P in D){const p=D[P];if(p){for(const{mac:v}of p)if(k(v))return v}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(ee[95],te([0,1,78]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(P,p,v,b=1){let C=!1;return new Promise(I=>{const u=setTimeout(()=>{if(!C)return C=!0,I(0)},v);k(P,p,b,w=>{if(!C)return C=!0,clearTimeout(u),I(w)})})}e.findFreePort=t;function k(P,p,v,b){if(p===0)return b(0);const C=new E.Socket;C.once("connect",()=>(D(C),k(P+v,p-1,v,b))),C.once("data",()=>{}),C.once("error",I=>(D(C),I.code!=="ECONNREFUSED"?k(P+v,p-1,v,b):b(P))),C.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(P,p,v,b="127.0.0.1"){let C=!1,I,u=1;const w=E.createServer({pauseOnConnect:!0});function g(f,d){C||(C=!0,w.removeAllListeners(),w.close(),I&&clearTimeout(I),d(f))}return new Promise(f=>{I=setTimeout(()=>{g(0,f)},v),w.on("listening",()=>{g(P,f)}),w.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&u<p?(P++,u++,w.listen(P,b)):g(0,f)}),w.on("close",()=>{g(0,f)}),w.listen(P,b)})}e.findFreePortFaster=R;function D(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(p){console.error(p)}}}),define(ee[128],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[129],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(k,R){this.sender=k,this.onMessage=R}send(k){try{this.sender.send("vscode:message",k.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=E}),define(ee[40],te([0,1,13,16]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,P){const p=(v,...b)=>{this.validateEvent(D,v)&&P(v,...b)};return this.mapListenerToWrapper.set(P,p),E.ipcMain.on(D,p),this}once(D,P){return E.ipcMain.once(D,(p,...v)=>{this.validateEvent(D,p)&&P(p,...v)}),this}handle(D,P){return E.ipcMain.handle(D,(p,...v)=>this.validateEvent(D,p)?P(p,...v):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return E.ipcMain.removeHandler(D),this}removeListener(D,P){const p=this.mapListenerToWrapper.get(P);return p&&(E.ipcMain.removeListener(D,p),this.mapListenerToWrapper.delete(P)),this}validateEvent(D,P){if(!D||!D.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const p=P.senderFrame,v=p.url;if(!v)return!0;let b="unknown";try{b=new URL(v).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${v}'.`),!1}return b!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${b}'.`),!1):p.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(ee[130],te([0,1,13,40,12,128]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(p,v,b,C,I)=>{const u=P(p,C,b);u.popup({window:(0,k.withNullAsUndefined)(E.BrowserWindow.fromWebContents(p.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{u&&p.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,v)}})})}e.registerContextMenuListener=D;function P(p,v,b){const C=new E.Menu;return b.forEach(I=>{let u;I.type==="separator"?u=new E.MenuItem({type:I.type}):Array.isArray(I.submenu)?u=new E.MenuItem({submenu:P(p,v,I.submenu),label:I.label}):u=new E.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(w,g,f)=>p.sender.send(v,I.id,f)}),C.append(u)}),C}}),define(ee[131],te([11,10]),function(z,e){return z.create("vs/base/common/date",e)}),define(ee[132],te([0,1,131]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,D=R*7,P=R*30,p=R*365;function v(C,I,u){typeof C!="number"&&(C=C.getTime());const w=Math.round((new Date().getTime()-C)/1e3);if(w<-30)return(0,E.localize)(0,null,v(new Date().getTime()+w*1e3,!1));if(w<30)return(0,E.localize)(1,null);let g;return w<t?(g=w,I?g===1?u?(0,E.localize)(2,null,g):(0,E.localize)(3,null,g):u?(0,E.localize)(4,null,g):(0,E.localize)(5,null,g):g===1?u?(0,E.localize)(6,null,g):(0,E.localize)(7,null,g):u?(0,E.localize)(8,null,g):(0,E.localize)(9,null,g)):w<k?(g=Math.floor(w/t),I?g===1?u?(0,E.localize)(10,null,g):(0,E.localize)(11,null,g):u?(0,E.localize)(12,null,g):(0,E.localize)(13,null,g):g===1?u?(0,E.localize)(14,null,g):(0,E.localize)(15,null,g):u?(0,E.localize)(16,null,g):(0,E.localize)(17,null,g)):w<R?(g=Math.floor(w/k),I?g===1?u?(0,E.localize)(18,null,g):(0,E.localize)(19,null,g):u?(0,E.localize)(20,null,g):(0,E.localize)(21,null,g):g===1?u?(0,E.localize)(22,null,g):(0,E.localize)(23,null,g):u?(0,E.localize)(24,null,g):(0,E.localize)(25,null,g)):w<D?(g=Math.floor(w/R),I?g===1?(0,E.localize)(26,null,g):(0,E.localize)(27,null,g):g===1?(0,E.localize)(28,null,g):(0,E.localize)(29,null,g)):w<P?(g=Math.floor(w/D),I?g===1?u?(0,E.localize)(30,null,g):(0,E.localize)(31,null,g):u?(0,E.localize)(32,null,g):(0,E.localize)(33,null,g):g===1?u?(0,E.localize)(34,null,g):(0,E.localize)(35,null,g):u?(0,E.localize)(36,null,g):(0,E.localize)(37,null,g)):w<p?(g=Math.floor(w/P),I?g===1?u?(0,E.localize)(38,null,g):(0,E.localize)(39,null,g):u?(0,E.localize)(40,null,g):(0,E.localize)(41,null,g):g===1?u?(0,E.localize)(42,null,g):(0,E.localize)(43,null,g):u?(0,E.localize)(44,null,g):(0,E.localize)(45,null,g)):(g=Math.floor(w/p),I?g===1?u?(0,E.localize)(46,null,g):(0,E.localize)(47,null,g):u?(0,E.localize)(48,null,g):(0,E.localize)(49,null,g):g===1?u?(0,E.localize)(50,null,g):(0,E.localize)(51,null,g):u?(0,E.localize)(52,null,g):(0,E.localize)(53,null,g))}e.fromNow=v;function b(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(ee[133],te([11,10]),function(z,e){return z.create("vs/base/common/errorMessage",e)}),define(ee[43],te([0,1,24,12,133]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(C,I){return I&&(C.stack||C.stacktrace)?k.localize(0,null,P(C),D(C.stack)||D(C.stacktrace)):P(C)}function D(C){return Array.isArray(C)?C.join(`
`):C}function P(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?k.localize(1,null,C.message):C.message||k.localize(2,null)}function p(C=null,I=!1){if(!C)return k.localize(3,null);if(Array.isArray(C)){const u=E.coalesce(C),w=p(u[0],I);return u.length>1?k.localize(4,null,w,u.length):w}if(t.isString(C))return C;if(C.detail){const u=C.detail;if(u.error)return R(u.error,I);if(u.exception)return R(u.exception,I)}return C.stack?R(C,I):C.message?C.message:k.localize(5,null)}e.toErrorMessage=p;function v(C){const I=C;return I instanceof Error&&Array.isArray(I.actions)}e.isErrorWithActions=v;function b(C,I){let u;return typeof C=="string"?u=new Error(C):u=C,u.actions=I,u}e.createErrorWithActions=b}),define(ee[134],te([11,10]),function(z,e){return z.create("vs/base/common/jsonErrorMessages",e)}),define(ee[135],te([0,1,134]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ee[136],te([11,10]),function(z,e){return z.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,136]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,k=!1,R=!1,D=!1,P=!1,p=!1,v=!1,b=!1,C=!1,I=!1,u,w=e.LANGUAGE_DEFAULT,g,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const S=typeof d?.versions?.electron=="string",m=S&&d?.type==="renderer";if(typeof navigator=="object"&&!m)f=navigator.userAgent,t=f.indexOf("Windows")>=0,k=f.indexOf("Macintosh")>=0,b=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=f.indexOf("Linux")>=0,I=f?.indexOf("Mobi")>=0,p=!0,u=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,w=u;else if(typeof d=="object"){t=d.platform==="win32",k=d.platform==="darwin",R=d.platform==="linux",D=R&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,v=S,C=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT;const a=d.env.VSCODE_NLS_CONFIG;if(a)try{const y=JSON.parse(a),M=y.availableLanguages["*"];u=y.locale,w=M||e.LANGUAGE_DEFAULT,g=y._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var h;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function l(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let n=0;k?n=1:t?n=3:R&&(n=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=R,e.isLinuxSnap=D,e.isNative=P,e.isElectron=v,e.isWeb=p,e.isWebWorker=p&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isMobile=I,e.isCI=C,e.platform=n,e.userAgent=f,e.language=w;var r;(function(a){function y(){return e.language}a.value=y;function M(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=M;function T(){return e.language==="en"}a.isDefault=T})(r=e.Language||(e.Language={})),e.locale=u,e.translationsConfigFile=g,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let T=0,U=a.length;T<U;T++){const Y=a[T];if(Y.id===M.data.vscodeScheduleAsyncWork){a.splice(T,1),Y.callback();return}}});let y=0;return M=>{const T=++y;a.push({id:T,callback:M}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return a=>setTimeout(a)})();var i;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||b?2:t?1:3;let o=!0,s=!1;function c(){if(!s){s=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,o=new Uint16Array(a.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[32],te([0,1,4]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const k=E.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ee[9],te([0,1,32]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,D=122,P=46,p=47,v=92,b=58,C=63;class I extends Error{constructor(h,l,n){let r;typeof l=="string"&&l.indexOf("not ")===0?(r="must not be",l=l.replace(/^not /,"")):r="must be";const i=h.indexOf(".")!==-1?"property":"argument";let o=`The "${h}" ${i} ${r} of type ${l}`;o+=`. Received type ${typeof n}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function u(m,h){if(typeof m!="string")throw new I(h,"string",m)}function w(m){return m===p||m===v}function g(m){return m===p}function f(m){return m>=t&&m<=R||m>=k&&m<=D}function d(m,h,l,n){let r="",i=0,o=-1,s=0,c=0;for(let a=0;a<=m.length;++a){if(a<m.length)c=m.charCodeAt(a);else{if(n(c))break;c=p}if(n(c)){if(!(o===a-1||s===1))if(s===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const y=r.lastIndexOf(l);y===-1?(r="",i=0):(r=r.slice(0,y),i=r.length-1-r.lastIndexOf(l)),o=a,s=0;continue}else if(r.length!==0){r="",i=0,o=a,s=0;continue}}h&&(r+=r.length>0?`${l}..`:"..",i=2)}else r.length>0?r+=`${l}${m.slice(o+1,a)}`:r=m.slice(o+1,a),i=a-o-1;o=a,s=0}else c===P&&s!==-1?++s:s=-1}return r}function S(m,h){if(h===null||typeof h!="object")throw new I("pathObject","Object",h);const l=h.dir||h.root,n=h.base||`${h.name||""}${h.ext||""}`;return l?l===h.root?`${l}${n}`:`${l}${m}${n}`:n}e.win32={resolve(...m){let h="",l="",n=!1;for(let r=m.length-1;r>=-1;r--){let i;if(r>=0){if(i=m[r],u(i,"path"),i.length===0)continue}else h.length===0?i=E.cwd():(i=E.env[`=${h}`]||E.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==h.toLowerCase()&&i.charCodeAt(2)===v)&&(i=`${h}\\`));const o=i.length;let s=0,c="",a=!1;const y=i.charCodeAt(0);if(o===1)w(y)&&(s=1,a=!0);else if(w(y))if(a=!0,w(i.charCodeAt(1))){let M=2,T=M;for(;M<o&&!w(i.charCodeAt(M));)M++;if(M<o&&M!==T){const U=i.slice(T,M);for(T=M;M<o&&w(i.charCodeAt(M));)M++;if(M<o&&M!==T){for(T=M;M<o&&!w(i.charCodeAt(M));)M++;(M===o||M!==T)&&(c=`\\\\${U}\\${i.slice(T,M)}`,s=M)}}}else s=1;else f(y)&&i.charCodeAt(1)===b&&(c=i.slice(0,2),s=2,o>2&&w(i.charCodeAt(2))&&(a=!0,s=3));if(c.length>0)if(h.length>0){if(c.toLowerCase()!==h.toLowerCase())continue}else h=c;if(n){if(h.length>0)break}else if(l=`${i.slice(s)}\\${l}`,n=a,a&&h.length>0)break}return l=d(l,!n,"\\",w),n?`${h}\\${l}`:`${h}${l}`||"."},normalize(m){u(m,"path");const h=m.length;if(h===0)return".";let l=0,n,r=!1;const i=m.charCodeAt(0);if(h===1)return g(i)?"\\":m;if(w(i))if(r=!0,w(m.charCodeAt(1))){let s=2,c=s;for(;s<h&&!w(m.charCodeAt(s));)s++;if(s<h&&s!==c){const a=m.slice(c,s);for(c=s;s<h&&w(m.charCodeAt(s));)s++;if(s<h&&s!==c){for(c=s;s<h&&!w(m.charCodeAt(s));)s++;if(s===h)return`\\\\${a}\\${m.slice(c)}\\`;s!==c&&(n=`\\\\${a}\\${m.slice(c,s)}`,l=s)}}}else l=1;else f(i)&&m.charCodeAt(1)===b&&(n=m.slice(0,2),l=2,h>2&&w(m.charCodeAt(2))&&(r=!0,l=3));let o=l<h?d(m.slice(l),!r,"\\",w):"";return o.length===0&&!r&&(o="."),o.length>0&&w(m.charCodeAt(h-1))&&(o+="\\"),n===void 0?r?`\\${o}`:o:r?`${n}\\${o}`:`${n}${o}`},isAbsolute(m){u(m,"path");const h=m.length;if(h===0)return!1;const l=m.charCodeAt(0);return w(l)||h>2&&f(l)&&m.charCodeAt(1)===b&&w(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let h,l;for(let i=0;i<m.length;++i){const o=m[i];u(o,"path"),o.length>0&&(h===void 0?h=l=o:h+=`\\${o}`)}if(h===void 0)return".";let n=!0,r=0;if(typeof l=="string"&&w(l.charCodeAt(0))){++r;const i=l.length;i>1&&w(l.charCodeAt(1))&&(++r,i>2&&(w(l.charCodeAt(2))?++r:n=!1))}if(n){for(;r<h.length&&w(h.charCodeAt(r));)r++;r>=2&&(h=`\\${h.slice(r)}`)}return e.win32.normalize(h)},relative(m,h){if(u(m,"from"),u(h,"to"),m===h)return"";const l=e.win32.resolve(m),n=e.win32.resolve(h);if(l===n||(m=l.toLowerCase(),h=n.toLowerCase(),m===h))return"";let r=0;for(;r<m.length&&m.charCodeAt(r)===v;)r++;let i=m.length;for(;i-1>r&&m.charCodeAt(i-1)===v;)i--;const o=i-r;let s=0;for(;s<h.length&&h.charCodeAt(s)===v;)s++;let c=h.length;for(;c-1>s&&h.charCodeAt(c-1)===v;)c--;const a=c-s,y=o<a?o:a;let M=-1,T=0;for(;T<y;T++){const Y=m.charCodeAt(r+T);if(Y!==h.charCodeAt(s+T))break;Y===v&&(M=T)}if(T!==y){if(M===-1)return n}else{if(a>y){if(h.charCodeAt(s+T)===v)return n.slice(s+T+1);if(T===2)return n.slice(s+T)}o>y&&(m.charCodeAt(r+T)===v?M=T:T===2&&(M=3)),M===-1&&(M=0)}let U="";for(T=r+M+1;T<=i;++T)(T===i||m.charCodeAt(T)===v)&&(U+=U.length===0?"..":"\\..");return s+=M,U.length>0?`${U}${n.slice(s,c)}`:(n.charCodeAt(s)===v&&++s,n.slice(s,c))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const h=e.win32.resolve(m);if(h.length<=2)return m;if(h.charCodeAt(0)===v){if(h.charCodeAt(1)===v){const l=h.charCodeAt(2);if(l!==C&&l!==P)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(f(h.charCodeAt(0))&&h.charCodeAt(1)===b&&h.charCodeAt(2)===v)return`\\\\?\\${h}`;return m},dirname(m){u(m,"path");const h=m.length;if(h===0)return".";let l=-1,n=0;const r=m.charCodeAt(0);if(h===1)return w(r)?m:".";if(w(r)){if(l=n=1,w(m.charCodeAt(1))){let s=2,c=s;for(;s<h&&!w(m.charCodeAt(s));)s++;if(s<h&&s!==c){for(c=s;s<h&&w(m.charCodeAt(s));)s++;if(s<h&&s!==c){for(c=s;s<h&&!w(m.charCodeAt(s));)s++;if(s===h)return m;s!==c&&(l=n=s+1)}}}}else f(r)&&m.charCodeAt(1)===b&&(l=h>2&&w(m.charCodeAt(2))?3:2,n=l);let i=-1,o=!0;for(let s=h-1;s>=n;--s)if(w(m.charCodeAt(s))){if(!o){i=s;break}}else o=!1;if(i===-1){if(l===-1)return".";i=l}return m.slice(0,i)},basename(m,h){h!==void 0&&u(h,"ext"),u(m,"path");let l=0,n=-1,r=!0,i;if(m.length>=2&&f(m.charCodeAt(0))&&m.charCodeAt(1)===b&&(l=2),h!==void 0&&h.length>0&&h.length<=m.length){if(h===m)return"";let o=h.length-1,s=-1;for(i=m.length-1;i>=l;--i){const c=m.charCodeAt(i);if(w(c)){if(!r){l=i+1;break}}else s===-1&&(r=!1,s=i+1),o>=0&&(c===h.charCodeAt(o)?--o===-1&&(n=i):(o=-1,n=s))}return l===n?n=s:n===-1&&(n=m.length),m.slice(l,n)}for(i=m.length-1;i>=l;--i)if(w(m.charCodeAt(i))){if(!r){l=i+1;break}}else n===-1&&(r=!1,n=i+1);return n===-1?"":m.slice(l,n)},extname(m){u(m,"path");let h=0,l=-1,n=0,r=-1,i=!0,o=0;m.length>=2&&m.charCodeAt(1)===b&&f(m.charCodeAt(0))&&(h=n=2);for(let s=m.length-1;s>=h;--s){const c=m.charCodeAt(s);if(w(c)){if(!i){n=s+1;break}continue}r===-1&&(i=!1,r=s+1),c===P?l===-1?l=s:o!==1&&(o=1):l!==-1&&(o=-1)}return l===-1||r===-1||o===0||o===1&&l===r-1&&l===n+1?"":m.slice(l,r)},format:S.bind(null,"\\"),parse(m){u(m,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return h;const l=m.length;let n=0,r=m.charCodeAt(0);if(l===1)return w(r)?(h.root=h.dir=m,h):(h.base=h.name=m,h);if(w(r)){if(n=1,w(m.charCodeAt(1))){let M=2,T=M;for(;M<l&&!w(m.charCodeAt(M));)M++;if(M<l&&M!==T){for(T=M;M<l&&w(m.charCodeAt(M));)M++;if(M<l&&M!==T){for(T=M;M<l&&!w(m.charCodeAt(M));)M++;M===l?n=M:M!==T&&(n=M+1)}}}}else if(f(r)&&m.charCodeAt(1)===b){if(l<=2)return h.root=h.dir=m,h;if(n=2,w(m.charCodeAt(2))){if(l===3)return h.root=h.dir=m,h;n=3}}n>0&&(h.root=m.slice(0,n));let i=-1,o=n,s=-1,c=!0,a=m.length-1,y=0;for(;a>=n;--a){if(r=m.charCodeAt(a),w(r)){if(!c){o=a+1;break}continue}s===-1&&(c=!1,s=a+1),r===P?i===-1?i=a:y!==1&&(y=1):i!==-1&&(y=-1)}return s!==-1&&(i===-1||y===0||y===1&&i===s-1&&i===o+1?h.base=h.name=m.slice(o,s):(h.name=m.slice(o,i),h.base=m.slice(o,s),h.ext=m.slice(i,s))),o>0&&o!==n?h.dir=m.slice(0,o-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let h="",l=!1;for(let n=m.length-1;n>=-1&&!l;n--){const r=n>=0?m[n]:E.cwd();u(r,"path"),r.length!==0&&(h=`${r}/${h}`,l=r.charCodeAt(0)===p)}return h=d(h,!l,"/",g),l?`/${h}`:h.length>0?h:"."},normalize(m){if(u(m,"path"),m.length===0)return".";const h=m.charCodeAt(0)===p,l=m.charCodeAt(m.length-1)===p;return m=d(m,!h,"/",g),m.length===0?h?"/":l?"./":".":(l&&(m+="/"),h?`/${m}`:m)},isAbsolute(m){return u(m,"path"),m.length>0&&m.charCodeAt(0)===p},join(...m){if(m.length===0)return".";let h;for(let l=0;l<m.length;++l){const n=m[l];u(n,"path"),n.length>0&&(h===void 0?h=n:h+=`/${n}`)}return h===void 0?".":e.posix.normalize(h)},relative(m,h){if(u(m,"from"),u(h,"to"),m===h||(m=e.posix.resolve(m),h=e.posix.resolve(h),m===h))return"";const l=1,n=m.length,r=n-l,i=1,o=h.length-i,s=r<o?r:o;let c=-1,a=0;for(;a<s;a++){const M=m.charCodeAt(l+a);if(M!==h.charCodeAt(i+a))break;M===p&&(c=a)}if(a===s)if(o>s){if(h.charCodeAt(i+a)===p)return h.slice(i+a+1);if(a===0)return h.slice(i+a)}else r>s&&(m.charCodeAt(l+a)===p?c=a:a===0&&(c=0));let y="";for(a=l+c+1;a<=n;++a)(a===n||m.charCodeAt(a)===p)&&(y+=y.length===0?"..":"/..");return`${y}${h.slice(i+c)}`},toNamespacedPath(m){return m},dirname(m){if(u(m,"path"),m.length===0)return".";const h=m.charCodeAt(0)===p;let l=-1,n=!0;for(let r=m.length-1;r>=1;--r)if(m.charCodeAt(r)===p){if(!n){l=r;break}}else n=!1;return l===-1?h?"/":".":h&&l===1?"//":m.slice(0,l)},basename(m,h){h!==void 0&&u(h,"ext"),u(m,"path");let l=0,n=-1,r=!0,i;if(h!==void 0&&h.length>0&&h.length<=m.length){if(h===m)return"";let o=h.length-1,s=-1;for(i=m.length-1;i>=0;--i){const c=m.charCodeAt(i);if(c===p){if(!r){l=i+1;break}}else s===-1&&(r=!1,s=i+1),o>=0&&(c===h.charCodeAt(o)?--o===-1&&(n=i):(o=-1,n=s))}return l===n?n=s:n===-1&&(n=m.length),m.slice(l,n)}for(i=m.length-1;i>=0;--i)if(m.charCodeAt(i)===p){if(!r){l=i+1;break}}else n===-1&&(r=!1,n=i+1);return n===-1?"":m.slice(l,n)},extname(m){u(m,"path");let h=-1,l=0,n=-1,r=!0,i=0;for(let o=m.length-1;o>=0;--o){const s=m.charCodeAt(o);if(s===p){if(!r){l=o+1;break}continue}n===-1&&(r=!1,n=o+1),s===P?h===-1?h=o:i!==1&&(i=1):h!==-1&&(i=-1)}return h===-1||n===-1||i===0||i===1&&h===n-1&&h===l+1?"":m.slice(h,n)},format:S.bind(null,"/"),parse(m){u(m,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return h;const l=m.charCodeAt(0)===p;let n;l?(h.root="/",n=1):n=0;let r=-1,i=0,o=-1,s=!0,c=m.length-1,a=0;for(;c>=n;--c){const y=m.charCodeAt(c);if(y===p){if(!s){i=c+1;break}continue}o===-1&&(s=!1,o=c+1),y===P?r===-1?r=c:a!==1&&(a=1):r!==-1&&(a=-1)}if(o!==-1){const y=i===0&&l?1:i;r===-1||a===0||a===1&&r===o-1&&r===i+1?h.base=h.name=m.slice(y,o):(h.name=m.slice(y,r),h.base=m.slice(y,o),h.ext=m.slice(r,o))}return i>0?h.dir=m.slice(0,i-1):l&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=E.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E.platform==="win32"?e.win32.join:e.posix.join,e.resolve=E.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=E.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=E.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=E.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=E.platform==="win32"?e.win32.extname:e.posix.extname,e.format=E.platform==="win32"?e.win32.format:e.posix.format,e.parse=E.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=E.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=E.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ee[79],te([0,1,4]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(P,...p){const v=p.reduce((I,u)=>(I[u]=!0,I),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(I=>!v[I]).forEach(I=>{for(let u=0;u<b.length;u++)if(I.search(b[u])!==-1){delete P[I];break}})}e.sanitizeProcessEnvironment=R;function D(P){!P||(delete P.DEBUG,E.isMacintosh&&delete P.DYLD_LIBRARY_PATH,E.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(ee[80],te([0,1,4]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=E.globals.performance&&typeof E.globals.performance.now=="function";class k{static create(D=!0){return new k(D)}constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ee[3],te([0,1,16,49,2,94,80]),function(z,e,E,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,p=!1;var v;(function(c){c.None=()=>k.Disposable.None;function a(q){if(p){const{onDidAddListener:X}=q,re=w.create();let B=0;q.onDidAddListener=()=>{++B===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),re.print()),X?.()}}}function y(q,X){return fe(q,()=>{},0,void 0,void 0,X)}c.defer=y;function M(q,X=0,re){return c.debounce(q,(B,J)=>B?(B.push(J),B):[J],X,void 0,void 0,re)}c.accumulate=M;function T(q){return(X,re=null,B)=>{let J=!1,Z;return Z=q(ce=>{if(!J)return Z?Z.dispose():J=!0,X.call(re,ce)},null,B),J&&Z.dispose(),Z}}c.once=T;function U(q,X,re){return se((B,J=null,Z)=>q(ce=>B.call(J,X(ce)),null,Z),re)}c.map=U;function Y(q,X,re){return se((B,J=null,Z)=>q(ce=>{X(ce),B.call(J,ce)},null,Z),re)}c.forEach=Y;function G(q,X,re){return se((B,J=null,Z)=>q(ce=>X(ce)&&B.call(J,ce),null,Z),re)}c.filter=G;function V(q){return q}c.signal=V;function oe(...q){return(X,re=null,B)=>(0,k.combinedDisposable)(...q.map(J=>J(Z=>X.call(re,Z),null,B)))}c.any=oe;function ae(q,X,re,B){let J=re;return U(q,Z=>(J=X(J,Z),J),B)}c.reduce=ae;function se(q,X){let re;const B={onWillAddFirstListener(){re=q(J.fire,J)},onDidRemoveLastListener(){re?.dispose()}};X||a(B);const J=new f(B);return X?.add(J),J.event}function fe(q,X,re=100,B=!1,J,Z){let ce,ge,De,Te=0;const Me={leakWarningThreshold:J,onWillAddFirstListener(){ce=q(we=>{Te++,ge=X(ge,we),B&&!De&&(Le.fire(ge),ge=void 0),clearTimeout(De),De=setTimeout(()=>{const pe=ge;ge=void 0,De=void 0,(!B||Te>1)&&Le.fire(pe),Te=0},re)})},onDidRemoveLastListener(){ce.dispose()}};Z||a(Me);const Le=new f(Me);return Z?.add(Le),Le.event}c.debounce=fe;function K(q,X=(B,J)=>B===J,re){let B=!0,J;return G(q,Z=>{const ce=B||!X(Z,J);return B=!1,J=Z,ce},re)}c.latch=K;function H(q,X,re){return[c.filter(q,X,re),c.filter(q,B=>!X(B),re)]}c.split=H;function F(q,X=!1,re=[]){let B=re.slice(),J=q(ge=>{B?B.push(ge):ce.fire(ge)});const Z=()=>{B?.forEach(ge=>ce.fire(ge)),B=null},ce=new f({onWillAddFirstListener(){J||(J=q(ge=>ce.fire(ge)))},onDidAddFirstListener(){B&&(X?setTimeout(Z):Z())},onDidRemoveLastListener(){J&&J.dispose(),J=null}});return ce.event}c.buffer=F;class A{constructor(X){this.event=X,this.disposables=new k.DisposableStore}map(X){return new A(U(this.event,X,this.disposables))}forEach(X){return new A(Y(this.event,X,this.disposables))}filter(X){return new A(G(this.event,X,this.disposables))}reduce(X,re){return new A(ae(this.event,X,re,this.disposables))}latch(){return new A(K(this.event,void 0,this.disposables))}debounce(X,re=100,B=!1,J){return new A(fe(this.event,X,re,B,J,this.disposables))}on(X,re,B){return this.event(X,re,B)}once(X,re,B){return T(this.event)(X,re,B)}dispose(){this.disposables.dispose()}}function O(q){return new A(q)}c.chain=O;function _(q,X,re=B=>B){const B=(...ge)=>ce.fire(re(...ge)),J=()=>q.on(X,B),Z=()=>q.removeListener(X,B),ce=new f({onWillAddFirstListener:J,onDidRemoveLastListener:Z});return ce.event}c.fromNodeEventEmitter=_;function ne(q,X,re=B=>B){const B=(...ge)=>ce.fire(re(...ge)),J=()=>q.addEventListener(X,B),Z=()=>q.removeEventListener(X,B),ce=new f({onWillAddFirstListener:J,onDidRemoveLastListener:Z});return ce.event}c.fromDOMEventEmitter=ne;function N(q){return new Promise(X=>T(q)(X))}c.toPromise=N;function $(q,X){return X(void 0),q(re=>X(re))}c.runAndSubscribe=$;function L(q,X){let re=null;function B(Z){re?.dispose(),re=new k.DisposableStore,X(Z,re)}B(void 0);const J=q(Z=>B(Z));return(0,k.toDisposable)(()=>{J.dispose(),re?.dispose()})}c.runAndSubscribeWithStore=L;class W{constructor(X,re){this.obs=X,this._counter=0,this._hasChanged=!1;const B={onWillAddFirstListener:()=>{X.addObserver(this)},onDidRemoveLastListener:()=>{X.removeObserver(this)}};re||a(B),this.emitter=new f(B),re&&re.add(this.emitter)}beginUpdate(X){this._counter++}handleChange(X,re){this._hasChanged=!0}endUpdate(X){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function j(q,X){return new W(q,X).emitter.event}c.fromObservable=j})(v=e.Event||(e.Event={}));class b{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${b._idPool++}`,b.all.add(this)}start(a){this._stopWatch=new D.StopWatch(!0),this.listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=b,b.all=new Set,b._idPool=0;let C=-1;function I(c){const a=C;return C=c,{dispose(){C=a}}}e.setGlobalLeakWarningThreshold=I;class u{constructor(a,y=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=y,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(a,y){const M=this.threshold;if(M<=0||y<M)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let U,Y=0;for(const[G,V]of this._stacks)(!U||Y<V)&&(U=G,Y=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${Y}):`),console.warn(U)}return()=>{const U=this._stacks.get(a.value)||0;this._stacks.set(a.value,U-1)}}}class w{static create(){return new w(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g{constructor(a,y,M){this.callback=a,this.callbackThis=y,this.stack=M,this.subscription=new k.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class f{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=C>0||this._options?.leakWarningThreshold?new u(this._options?.leakWarningThreshold??C):void 0,this._perfMon=this._options?._profName?new b(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const y of a)y.subscription.isset()&&(y.subscription.unset(),y.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,y,M)=>{if(this._listeners||(this._listeners=new R.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),k.Disposable.None;const T=this._listeners.isEmpty();T&&this._options?.onWillAddFirstListener&&this._options.onWillAddFirstListener(this);let U,Y;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(Y=w.create(),U=this._leakageMon.check(Y,this._listeners.size+1)),P&&(Y=Y??w.create());const G=new g(a,y,Y),V=this._listeners.push(G);T&&this._options?.onDidAddFirstListener&&this._options.onDidAddFirstListener(this),this._options?.onDidAddListener&&this._options.onDidAddListener(this,a,y);const oe=G.subscription.set(()=>{U?.(),this._disposed||(V(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return M instanceof k.DisposableStore?M.add(oe):Array.isArray(M)&&M.push(oe),oe}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S);for(const y of this._listeners)this._deliveryQueue.push(this,y,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=f;class d{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(a,y,M){this._queue.push(new m(a,y,M))}clear(a){const y=new R.LinkedList;for(const M of this._queue)M.emitter!==a&&y.push(M);this._queue=y}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(y){(0,E.onUnexpectedError)(y)}}}}e.EventDeliveryQueue=d;class S extends d{clear(a){this._queue.clear()}}class m{constructor(a,y,M){this.emitter=a,this.listener=y,this.event=M}}class h extends f{async fireAsync(a,y,M){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,a]);for(;this._asyncDeliveryQueue.size>0&&!y.isCancellationRequested;){const[T,U]=this._asyncDeliveryQueue.shift(),Y=[],G={...U,token:y,waitUntil:V=>{if(Object.isFrozen(Y))throw new Error("waitUntil can NOT be called asynchronous");M&&(V=M(V,T.callback)),Y.push(V)}};try{T.invoke(G)}catch(V){(0,E.onUnexpectedError)(V);continue}Object.freeze(Y),await Promise.allSettled(Y).then(V=>{for(const oe of V)oe.status==="rejected"&&(0,E.onUnexpectedError)(oe.reason)})}}}}e.AsyncEmitter=h;class l extends f{constructor(a){super(a),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=l;class n extends l{constructor(a){super(a),this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=n;class r extends f{constructor(a){super(a),this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){!this.hasListeners()||(this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(y=>super.fire(y)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=r;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const y={event:a,listener:null};this.events.push(y),this.hasListeners&&this.hook(y);const M=()=>{this.hasListeners&&this.unhook(y);const T=this.events.indexOf(y);this.events.splice(T,1)};return(0,k.toDisposable)((0,t.once)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(y=>this.emitter.fire(y))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class o{constructor(){this.buffers=[]}wrapEvent(a){return(y,M,T)=>a(U=>{const Y=this.buffers[this.buffers.length-1];Y?Y.push(()=>y.call(M,U)):y.call(M,U)},void 0,T)}bufferEvents(a){const y=[];this.buffers.push(y);const M=a();return this.buffers.pop(),y.forEach(T=>T()),M}}e.EventBufferer=o;class s{constructor(){this.listening=!1,this.inputEvent=v.None,this.inputEventListener=k.Disposable.None,this.emitter=new f({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(ee[22],te([0,1,3]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(P,p){const v=setTimeout(P.bind(p),0);return{dispose(){clearTimeout(v)}}});var k;(function(P){function p(v){return v===P.None||v===P.Cancelled||v instanceof R?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}P.isCancellationToken=p,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=D}),define(ee[137],te([0,1,22]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new E.CancellationTokenSource,p=this.task(P.token);return this.result={promise:p,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=t;class k{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const p=JSON.stringify(P);return this.lastArgKey!==p&&(this.lastArgKey=p,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=k;class R{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const p=this.fn(P);return this._map.set(P,p),p}}e.CachedFunction=R}),define(ee[96],te([0,1,3,2]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=D=>({onDidChange:E.Event.None,value:D});e.staticObservableValue=k;class R extends t.Disposable{get value(){return this._value}set value(P){P!==this._value&&(this._value=P,this.changeEmitter.fire(P))}constructor(P){super(),this._value=P,this.changeEmitter=this._register(new E.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=R}),define(ee[25],te([0,1,137,124]),function(z,e,E,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function P(Q,...le){return le.length===0?Q:Q.replace(D,function(he,me){const be=parseInt(me,10);return isNaN(be)||be<0||be>=le.length?he:le[be]})}e.format=P;const p=/{([^}]+)}/g;function v(Q,le){return Q.replace(p,(he,me)=>le[me]??he)}e.format2=v;function b(Q){return Q.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=b;function C(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function I(Q,le){let he=0;const me=le.charCodeAt(0);for(let be=Q.length-1;be>=0;be--)Q.charCodeAt(be)===me&&he++;return he}e.count=I;function u(Q,le,he="\u2026"){return Q.length<=le?Q:`${Q.substr(0,le)}${he}`}e.truncate=u;function w(Q,le=" "){const he=g(Q,le);return f(he,le)}e.trim=w;function g(Q,le){if(!Q||!le)return Q;const he=le.length;if(he===0||Q.length===0)return Q;let me=0;for(;Q.indexOf(le,me)===me;)me=me+he;return Q.substring(me)}e.ltrim=g;function f(Q,le){if(!Q||!le)return Q;const he=le.length,me=Q.length;if(he===0||me===0)return Q;let be=me,Ae=-1;for(;Ae=Q.lastIndexOf(le,be-1),!(Ae===-1||Ae+he!==be);){if(Ae===0)return"";be=Ae}return Q.substring(0,be)}e.rtrim=f;function d(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function S(Q){return Q.replace(/\*/g,"")}e.stripWildcards=S;function m(Q,le,he={}){if(!Q)throw new Error("Cannot create regex from empty string");le||(Q=C(Q)),he.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let me="";return he.global&&(me+="g"),he.matchCase||(me+="i"),he.multiline&&(me+="m"),he.unicode&&(me+="u"),new RegExp(Q,me)}e.createRegExp=m;function h(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function l(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function n(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=n;function r(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=r;function i(Q){for(let le=0,he=Q.length;le<he;le++){const me=Q.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=i;function o(Q,le=0,he=Q.length){for(let me=le;me<he;me++){const be=Q.charCodeAt(me);if(be!==32&&be!==9)return Q.substring(le,me)}return Q.substring(le,he)}e.getLeadingWhitespace=o;function s(Q,le=Q.length-1){for(let he=le;he>=0;he--){const me=Q.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.lastNonWhitespaceIndex=s;function c(Q,le,he){const me=[];let be=0;for(const Ae of Q.matchAll(le)){if(me.push(Q.slice(be,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");be=Ae.index+Ae[0].length,me.push(he(Ae[0],...Ae.slice(1),Ae.index,Q,Ae.groups))}return me.push(Q.slice(be)),Promise.all(me).then(Ae=>Ae.join(""))}e.replaceAsync=c;function a(Q,le){return Q<le?-1:Q>le?1:0}e.compare=a;function y(Q,le,he=0,me=Q.length,be=0,Ae=le.length){for(;he<me&&be<Ae;he++,be++){const Je=Q.charCodeAt(he),He=le.charCodeAt(be);if(Je<He)return-1;if(Je>He)return 1}const Ue=me-he,it=Ae-be;return Ue<it?-1:Ue>it?1:0}e.compareSubstring=y;function M(Q,le){return T(Q,le,0,Q.length,0,le.length)}e.compareIgnoreCase=M;function T(Q,le,he=0,me=Q.length,be=0,Ae=le.length){for(;he<me&&be<Ae;he++,be++){let Je=Q.charCodeAt(he),He=le.charCodeAt(be);if(Je===He)continue;if(Je>=128||He>=128)return y(Q.toLowerCase(),le.toLowerCase(),he,me,be,Ae);Y(Je)&&(Je-=32),Y(He)&&(He-=32);const et=Je-He;if(et!==0)return et}const Ue=me-he,it=Ae-be;return Ue<it?-1:Ue>it?1:0}e.compareSubstringIgnoreCase=T;function U(Q){return Q>=48&&Q<=57}e.isAsciiDigit=U;function Y(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=Y;function G(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=G;function V(Q,le){return Q.length===le.length&&T(Q,le)===0}e.equalsIgnoreCase=V;function oe(Q,le){const he=le.length;return le.length>Q.length?!1:T(Q,le,0,he)===0}e.startsWithIgnoreCase=oe;function ae(Q,le){const he=Math.min(Q.length,le.length);let me;for(me=0;me<he;me++)if(Q.charCodeAt(me)!==le.charCodeAt(me))return me;return he}e.commonPrefixLength=ae;function se(Q,le){const he=Math.min(Q.length,le.length);let me;const be=Q.length-1,Ae=le.length-1;for(me=0;me<he;me++)if(Q.charCodeAt(be-me)!==le.charCodeAt(Ae-me))return me;return he}e.commonSuffixLength=se;function fe(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=fe;function K(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=K;function H(Q,le){return(Q-55296<<10)+(le-56320)+65536}e.computeCodePoint=H;function F(Q,le,he){const me=Q.charCodeAt(he);if(fe(me)&&he+1<le){const be=Q.charCodeAt(he+1);if(K(be))return H(me,be)}return me}e.getNextCodePoint=F;function A(Q,le){const he=Q.charCodeAt(le-1);if(K(he)&&le>1){const me=Q.charCodeAt(le-2);if(fe(me))return H(me,he)}return he}class O{get offset(){return this._offset}constructor(le,he=0){this._str=le,this._len=le.length,this._offset=he}setOffset(le){this._offset=le}prevCodePoint(){const le=A(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=F(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=O;class _{get offset(){return this._iterator.offset}constructor(le,he=0){this._iterator=new O(le,he)}nextGraphemeLength(){const le=Fe.getInstance(),he=this._iterator,me=he.offset;let be=le.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const Ae=he.offset,Ue=le.getGraphemeBreakType(he.nextCodePoint());if(ye(be,Ue)){he.setOffset(Ae);break}be=Ue}return he.offset-me}prevGraphemeLength(){const le=Fe.getInstance(),he=this._iterator,me=he.offset;let be=le.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const Ae=he.offset,Ue=le.getGraphemeBreakType(he.prevCodePoint());if(ye(Ue,be)){he.setOffset(Ae);break}be=Ue}return me-he.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=_;function ne(Q,le){return new _(Q,le).nextGraphemeLength()}e.nextCharLength=ne;function N(Q,le){return new _(Q,le).prevGraphemeLength()}e.prevCharLength=N;function $(Q,le){le>0&&K(Q.charCodeAt(le))&&le--;const he=le+ne(Q,le);return[he-N(Q,he),he]}e.getCharContainingOffset=$;function L(Q){const le=new _(Q);let he=0;for(;!le.eol();)he++,le.nextGraphemeLength();return he}e.charCount=L;let W;function j(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q(Q){return W||(W=j()),W.test(Q)}e.containsRTL=q;const X=/^[\t\n\r\x20-\x7E]*$/;function re(Q){return X.test(Q)}e.isBasicASCII=re,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=B;function J(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=J;function Z(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=Z;function ce(Q,le){if(Q.length<le)return Q;const he=/\b/g;let me=0;for(;he.test(Q)&&!(Q.length-he.lastIndex<le);)me=he.lastIndex,he.lastIndex+=1;return Q.substring(me).replace(/^\s/,"")}e.lcut=ce;const ge=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Te=/\x1b\[0?m/g;function Me(Q){return Q&&(Q=Q.replace(ge,""),Q=Q.replace(De,""),Q=Q.replace(Te,"")),Q}e.removeAnsiEscapeCodes=Me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function we(Q){return Le(Q)?Q.substr(1):Q}e.stripUTF8BOM=we;function pe(Q,le){if(!Q||!le||Q.length<le.length)return!1;const he=le.length,me=Q.toLowerCase();let be=0,Ae=-1;for(;be<he;){const Ue=me.indexOf(le[be],Ae+1);if(Ue<0)return!1;Ae=Ue,be++}return!0}e.fuzzyContains=pe;function Se(Q,le=!1){return Q?(le&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=Se;function ke(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=ke;function x(Q,le=1){if(le===0)return"";let he=-1;do he=Q.indexOf(`
`,he+1),le--;while(le>0&&he>=0);return he===-1?Q:(Q[he-1]==="\r"&&he--,Q.substr(0,he))}e.getNLines=x;function ue(Q){return Q=Q%(2*26),Q<26?String.fromCharCode(97+Q):String.fromCharCode(65+Q-26)}e.singleLetterHash=ue;function de(Q){return Fe.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=de;function ye(Q,le){return Q===0?le!==5&&le!==7:Q===2&&le===3?!1:Q===4||Q===2||Q===3||le===4||le===2||le===3?!0:!(Q===8&&(le===8||le===9||le===11||le===12)||(Q===11||Q===9)&&(le===9||le===10)||(Q===12||Q===10)&&le===10||le===5||le===13||le===7||Q===1||Q===13&&le===14||Q===6&&le===6)}var Ce;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(Ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Fe{static getInstance(){return Fe._INSTANCE||(Fe._INSTANCE=new Fe),Fe._INSTANCE}constructor(){this._data=Oe()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const he=this._data,me=he.length/3;let be=1;for(;be<=me;)if(le<he[3*be])be=2*be;else if(le>he[3*be+1])be=2*be+1;else return he[3*be+2];return 0}}Fe._INSTANCE=null;function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function $e(Q,le){if(Q===0)return 0;const he=Ne(Q,le);if(he!==void 0)return he;const me=new O(le,Q);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=$e;function Ne(Q,le){const he=new O(le,Q);let me=he.prevCodePoint();for(;je(me)||me===65039||me===8419;){if(he.offset===0)return;me=he.prevCodePoint()}if(!Z(me))return;let be=he.offset;return be>0&&he.prevCodePoint()===8205&&(be=he.offset),be}function je(Q){return 127995<=Q&&Q<=127999}var Qe;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.noBreakWhitespace="\xA0";class Be{static getInstance(le){return Be.cache.get(Array.from(le))}static getLocales(){return Be._locales.getValue()}constructor(le){this.confusableDictionary=le}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Be,k=Be,Be.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Be.cache=new E.LRUCachedFunction(Q=>{function le(He){const et=new Map;for(let nt=0;nt<He.length;nt+=2)et.set(He[nt],He[nt+1]);return et}function he(He,et){const nt=new Map(He);for(const[lt,gt]of et)nt.set(lt,gt);return nt}function me(He,et){if(!He)return et;const nt=new Map;for(const[lt,gt]of He)et.has(lt)&&nt.set(lt,gt);return nt}const be=k.ambiguousCharacterData.getValue();let Ae=Q.filter(He=>!He.startsWith("_")&&He in be);Ae.length===0&&(Ae=["_default"]);let Ue;for(const He of Ae){const et=le(be[He]);Ue=me(Ue,et)}const it=le(be._common),Je=he(it,Ue);return new Be(Je)}),Be._locales=new t.Lazy(()=>Object.keys(Be.ambiguousCharacterData.getValue()).filter(Q=>!Q.startsWith("_")));class Ge{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ge.getRawData())),this._data}static isInvisibleCharacter(le){return Ge.getData().has(le)}static get codePoints(){return Ge.getData()}}e.InvisibleCharacters=Ge,Ge._data=void 0}),define(ee[30],te([0,1,9,4,25,12]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(s){return s===47||s===92}e.isPathSeparator=D;function P(s){return s.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=P;function p(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=p;function v(s,c=E.posix.sep){if(!s)return"";const a=s.length,y=s.charCodeAt(0);if(D(y)){if(D(s.charCodeAt(1))&&!D(s.charCodeAt(2))){let T=3;const U=T;for(;T<a&&!D(s.charCodeAt(T));T++);if(U!==T&&!D(s.charCodeAt(T+1))){for(T+=1;T<a;T++)if(D(s.charCodeAt(T)))return s.slice(0,T+1).replace(/[\\/]/g,c)}}return c}else if(d(y)&&s.charCodeAt(1)===58)return D(s.charCodeAt(2))?s.slice(0,2)+c:s.slice(0,2);let M=s.indexOf("://");if(M!==-1){for(M+=3;M<a;M++)if(D(s.charCodeAt(M)))return s.slice(0,M+1)}return""}e.getRoot=v;function b(s){if(!t.isWindows||!s||s.length<5)return!1;let c=s.charCodeAt(0);if(c!==92||(c=s.charCodeAt(1),c!==92))return!1;let a=2;const y=a;for(;a<s.length&&(c=s.charCodeAt(a),c!==92);a++);return!(y===a||(c=s.charCodeAt(a+1),isNaN(c)||c===92))}e.isUNC=b;const C=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(s,c=t.isWindows){const a=c?C:I;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||c&&u.test(s)||s==="."||s===".."||c&&s[s.length-1]==="."||c&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=w;function g(s,c,a){const y=s===c;return!a||y?y:!s||!c?!1:(0,k.equalsIgnoreCase)(s,c)}e.isEqual=g;function f(s,c,a,y=E.sep){if(s===c)return!0;if(!s||!c||c.length>s.length)return!1;if(a){if(!(0,k.startsWithIgnoreCase)(s,c))return!1;if(c.length===s.length)return!0;let T=c.length;return c.charAt(c.length-1)===y&&T--,s.charAt(T)===y}return c.charAt(c.length-1)!==y&&(c+=y),s.indexOf(c)===0}e.isEqualOrParent=f;function d(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=d;function S(s,c){return t.isWindows&&s.endsWith(":")&&(s+=E.sep),(0,E.isAbsolute)(s)||(s=(0,E.join)(c,s)),s=(0,E.normalize)(s),t.isWindows?(s=(0,k.rtrim)(s,E.sep),s.endsWith(":")&&(s+=E.sep)):(s=(0,k.rtrim)(s,E.sep),s||(s=E.sep)),s}e.sanitizeFilePath=S;function m(s){const c=(0,E.normalize)(s);return t.isWindows?s.length>3?!1:h(c)&&(s.length===2||c.charCodeAt(2)===92):c===E.posix.sep}e.isRootOrDriveLetter=m;function h(s,c=t.isWindows){return c?d(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function l(s){return h(s)?s[0]:void 0}e.getDriveLetter=l;function n(s,c,a){return c.length>s.length?-1:s===c?0:(a&&(s=s.toLowerCase(),c=c.toLowerCase()),s.indexOf(c))}e.indexOfPath=n;function r(s){const c=s.split(":");let a,y,M;for(const T of c){const U=Number(T);(0,R.isNumber)(U)?y===void 0?y=U:M===void 0&&(M=U):a=a?[a,T].join(":"):T}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:y!==void 0?y:void 0,column:M!==void 0?M:y!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(s,c,a=8){let y="";for(let T=0;T<a;T++)y+=i.charAt(Math.floor(Math.random()*i.length));let M;return c?M=`${c}-${y}`:M=y,s?(0,E.join)(s,M):M}e.randomPath=o}),define(ee[67],te([0,1,25]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(d){return k(d,0)}e.hash=t;function k(d,S){switch(typeof d){case"object":return d===null?R(349,S):Array.isArray(d)?p(d,S):v(d,S);case"string":return P(d,S);case"boolean":return D(d,S);case"number":return R(d,S);case"undefined":return R(937,S);default:return R(617,S)}}e.doHash=k;function R(d,S){return(S<<5)-S+d|0}e.numberHash=R;function D(d,S){return R(d?433:863,S)}function P(d,S){S=R(149417,S);for(let m=0,h=d.length;m<h;m++)S=R(d.charCodeAt(m),S);return S}e.stringHash=P;function p(d,S){return S=R(104579,S),d.reduce((m,h)=>k(h,m),S)}function v(d,S){return S=R(181387,S),Object.keys(d).sort().reduce((m,h)=>(m=P(h,m),k(d[h],m)),S)}class b{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=k(S,this._value),this._value}}e.Hasher=b;var C;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function I(d,S,m=32){const h=m-S,l=~((1<<h)-1);return(d<<S|(l&d)>>>h)>>>0}function u(d,S=0,m=d.byteLength,h=0){for(let l=0;l<m;l++)d[S+l]=h}function w(d,S,m="0"){for(;d.length<S;)d=m+d;return d}function g(d,S=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(m=>m.toString(16).padStart(2,"0")).join(""):w((d>>>0).toString(16),S/4)}e.toHexString=g;class f{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const m=S.length;if(m===0)return;const h=this._buff;let l=this._buffLen,n=this._leftoverHighSurrogate,r,i;for(n!==0?(r=n,i=-1,n=0):(r=S.charCodeAt(0),i=0);;){let o=r;if(E.isHighSurrogate(r))if(i+1<m){const s=S.charCodeAt(i+1);E.isLowSurrogate(s)?(i++,o=E.computeCodePoint(r,s)):o=65533}else{n=r;break}else E.isLowSurrogate(r)&&(o=65533);if(l=this._push(h,l,o),i++,i<m)r=S.charCodeAt(i);else break}this._buffLen=l,this._leftoverHighSurrogate=n}_push(S,m,h){return h<128?S[m++]=h:h<2048?(S[m++]=192|(h&1984)>>>6,S[m++]=128|(h&63)>>>0):h<65536?(S[m++]=224|(h&61440)>>>12,S[m++]=128|(h&4032)>>>6,S[m++]=128|(h&63)>>>0):(S[m++]=240|(h&1835008)>>>18,S[m++]=128|(h&258048)>>>12,S[m++]=128|(h&4032)>>>6,S[m++]=128|(h&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,u(this._buff,this._buffLen),this._buffLen>56&&(this._step(),u(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=f._bigBlock32,m=this._buffDV;for(let a=0;a<64;a+=4)S.setUint32(a,m.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)S.setUint32(a,I(S.getUint32(a-12,!1)^S.getUint32(a-32,!1)^S.getUint32(a-56,!1)^S.getUint32(a-64,!1),1),!1);let h=this._h0,l=this._h1,n=this._h2,r=this._h3,i=this._h4,o,s,c;for(let a=0;a<80;a++)a<20?(o=l&n|~l&r,s=1518500249):a<40?(o=l^n^r,s=1859775393):a<60?(o=l&n|l&r|n&r,s=2400959708):(o=l^n^r,s=3395469782),c=I(h,5)+o+i+s+S.getUint32(a*4,!1)&4294967295,i=r,r=n,n=I(l,30),l=h,h=c;this._h0=this._h0+h&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=f,f._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ee[97],te([0,1,25]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",D="warning",P="warn",p="info",v="ignore";function b(I){return I?E.equalsIgnoreCase(R,I)?k.Error:E.equalsIgnoreCase(D,I)||E.equalsIgnoreCase(P,I)?k.Warning:E.equalsIgnoreCase(p,I)?k.Info:k.Ignore:k.Ignore}k.fromValue=b;function C(I){switch(I){case k.Error:return R;case k.Warning:return D;case k.Info:return p;default:return v}}k.toString=C}(t||(t={})),e.default=t}),define(ee[58],te([0,1,24,25]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this._value="",this._pos=0}reset(u){return this._value=u,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(u){const w=u.charCodeAt(0),g=this._value.charCodeAt(this._pos);return w-g}value(){return this._value[this._pos]}}e.StringIterator=k;class R{constructor(u=!0){this._caseSensitive=u}reset(u){return this._value=u,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(u)this._from++;else break;else u=!1;return this}cmp(u){return this._caseSensitive?(0,t.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class D{constructor(u=!0,w=!0){this._splitOnBackslash=u,this._caseSensitive=w}reset(u){this._from=0,this._to=0,this._value=u,this._valueLen=u.length;for(let w=u.length-1;w>=0;w--,this._valueLen--){const g=this._value.charCodeAt(w);if(!(g===47||this._splitOnBackslash&&g===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let u=!0;for(;this._to<this._valueLen;this._to++){const w=this._value.charCodeAt(this._to);if(w===47||this._splitOnBackslash&&w===92)if(u)this._from++;else break;else u=!1}return this}cmp(u){return this._caseSensitive?(0,t.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=D;var P;(function(I){I[I.Scheme=1]="Scheme",I[I.Authority=2]="Authority",I[I.Path=3]="Path",I[I.Query=4]="Query",I[I.Fragment=5]="Fragment"})(P||(P={}));class p{constructor(u,w){this._ignorePathCasing=u,this._ignoreQueryAndFragment=w,this._states=[],this._stateIdx=0}reset(u){return this._value=u,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new D(!1,!this._ignorePathCasing(u)),this._pathIterator.reset(u.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(u)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(u){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(u,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(u,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(u);if(this._states[this._stateIdx]===4)return(0,t.compare)(u,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(u,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(I){I[I.Left=-1]="Left",I[I.Mid=0]="Mid",I[I.Right=1]="Right"})(b||(b={}));class C{static forUris(u=()=>!1,w=()=>!1){return new C(new p(u,w))}static forPaths(u=!1){return new C(new D(void 0,!u))}static forStrings(){return new C(new k)}static forConfigKeys(){return new C(new R)}constructor(u){this._iter=u}clear(){this._root=void 0}fill(u,w){if(w){const g=w.slice(0);(0,E.shuffle)(g);for(const f of g)this.set(f,u)}else{const g=u.slice(0);(0,E.shuffle)(g);for(const f of g)this.set(f[0],f[1])}}set(u,w){const g=this._iter.reset(u);let f;this._root||(this._root=new v,this._root.segment=g.value());const d=[];for(f=this._root;;){const m=g.cmp(f.segment);if(m>0)f.left||(f.left=new v,f.left.segment=g.value()),d.push([-1,f]),f=f.left;else if(m<0)f.right||(f.right=new v,f.right.segment=g.value()),d.push([1,f]),f=f.right;else if(g.hasNext())g.next(),f.mid||(f.mid=new v,f.mid.segment=g.value()),d.push([0,f]),f=f.mid;else break}const S=f.value;f.value=w,f.key=u;for(let m=d.length-1;m>=0;m--){const h=d[m][1];h.updateHeight();const l=h.balanceFactor();if(l<-1||l>1){const n=d[m][0],r=d[m+1][0];if(n===1&&r===1)d[m][1]=h.rotateLeft();else if(n===-1&&r===-1)d[m][1]=h.rotateRight();else if(n===1&&r===-1)h.right=d[m+1][1]=d[m+1][1].rotateRight(),d[m][1]=h.rotateLeft();else if(n===-1&&r===1)h.left=d[m+1][1]=d[m+1][1].rotateLeft(),d[m][1]=h.rotateRight();else throw new Error;if(m>0)switch(d[m-1][0]){case-1:d[m-1][1].left=d[m][1];break;case 1:d[m-1][1].right=d[m][1];break;case 0:d[m-1][1].mid=d[m][1];break}else this._root=d[0][1]}}return S}get(u){return this._getNode(u)?.value}_getNode(u){const w=this._iter.reset(u);let g=this._root;for(;g;){const f=w.cmp(g.segment);if(f>0)g=g.left;else if(f<0)g=g.right;else if(w.hasNext())w.next(),g=g.mid;else break}return g}has(u){const w=this._getNode(u);return!(w?.value===void 0&&w?.mid===void 0)}delete(u){return this._delete(u,!1)}deleteSuperstr(u){return this._delete(u,!0)}_delete(u,w){const g=this._iter.reset(u),f=[];let d=this._root;for(;d;){const S=g.cmp(d.segment);if(S>0)f.push([-1,d]),d=d.left;else if(S<0)f.push([1,d]),d=d.right;else if(g.hasNext())g.next(),f.push([0,d]),d=d.mid;else break}if(!!d){if(w?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const S=this._min(d.right);if(S.key){const{key:m,value:h,segment:l}=S;this._delete(S.key,!1),d.key=m,d.value=h,d.segment=l}}else{const S=d.left??d.right;if(f.length>0){const[m,h]=f[f.length-1];switch(m){case-1:h.left=S;break;case 0:h.mid=S;break;case 1:h.right=S;break}}else this._root=S}for(let S=f.length-1;S>=0;S--){const m=f[S][1];m.updateHeight();const h=m.balanceFactor();if(h>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),f[S][1]=m.rotateLeft()):h<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),f[S][1]=m.rotateRight()),S>0)switch(f[S-1][0]){case-1:f[S-1][1].left=f[S][1];break;case 1:f[S-1][1].right=f[S][1];break;case 0:f[S-1][1].mid=f[S][1];break}else this._root=f[0][1]}}}_min(u){for(;u.left;)u=u.left;return u}findSubstr(u){const w=this._iter.reset(u);let g=this._root,f;for(;g;){const d=w.cmp(g.segment);if(d>0)g=g.left;else if(d<0)g=g.right;else if(w.hasNext())w.next(),f=g.value||f,g=g.mid;else break}return g&&g.value||f}findSuperstr(u){const w=this._iter.reset(u);let g=this._root;for(;g;){const f=w.cmp(g.segment);if(f>0)g=g.left;else if(f<0)g=g.right;else if(w.hasNext())w.next(),g=g.mid;else return g.mid?this._entries(g.mid):void 0}}forEach(u){for(const[w,g]of this)u(g,w)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(u){const w=[];return this._dfsEntries(u,w),w[Symbol.iterator]()}_dfsEntries(u,w){!u||(u.left&&this._dfsEntries(u.left,w),u.value&&w.push([u.key,u.value]),u.mid&&this._dfsEntries(u.mid,w),u.right&&this._dfsEntries(u.right,w))}_isBalanced(){const u=w=>{if(!w)return!0;const g=w.balanceFactor();return g<-1||g>1?!1:u(w.left)&&u(w.right)};return u(this._root)}}e.TernarySearchTree=C}),define(ee[7],te([0,1,9,4]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function P(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(i,o){return!i&&!o?"file":i}function v(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==C&&(o=C+o):o=C;break}return o}const b="",C="/",I=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(o){return o instanceof u?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,s,c,a,y,M=!1){typeof o=="object"?(this.scheme=o.scheme||b,this.authority=o.authority||b,this.path=o.path||b,this.query=o.query||b,this.fragment=o.fragment||b):(this.scheme=p(o,M),this.authority=s||b,this.path=v(this.scheme,c||b),this.query=a||b,this.fragment=y||b,P(this,M))}get fsPath(){return m(this,!1)}with(o){if(!o)return this;let{scheme:s,authority:c,path:a,query:y,fragment:M}=o;return s===void 0?s=this.scheme:s===null&&(s=b),c===void 0?c=this.authority:c===null&&(c=b),a===void 0?a=this.path:a===null&&(a=b),y===void 0?y=this.query:y===null&&(y=b),M===void 0?M=this.fragment:M===null&&(M=b),s===this.scheme&&c===this.authority&&a===this.path&&y===this.query&&M===this.fragment?this:new g(s,c,a,y,M)}static parse(o,s=!1){const c=I.exec(o);return c?new g(c[2]||b,r(c[4]||b),r(c[5]||b),r(c[7]||b),r(c[9]||b),s):new g(b,b,b,b,b)}static file(o){let s=b;if(t.isWindows&&(o=o.replace(/\\/g,C)),o[0]===C&&o[1]===C){const c=o.indexOf(C,2);c===-1?(s=o.substring(2),o=C):(s=o.substring(2,c),o=o.substring(c)||C)}return new g("file",s,o,b,b)}static from(o){const s=new g(o.scheme,o.authority,o.path,o.query,o.fragment);return P(s,!0),s}static joinPath(o,...s){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&o.scheme==="file"?c=u.file(E.win32.join(m(o,!0),...s)).path:c=E.posix.join(o.path,...s),o.with({path:c})}toString(o=!1){return h(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof u)return o;{const s=new g(o);return s._formatted=o.external,s._fsPath=o._sep===w?o.fsPath:null,s}}else return o}}e.URI=u;const w=t.isWindows?1:void 0;class g extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(o=!1){return o?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=w),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(i,o){let s,c=-1;for(let a=0;a<i.length;a++){const y=i.charCodeAt(a);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||o&&y===47)c!==-1&&(s+=encodeURIComponent(i.substring(c,a)),c=-1),s!==void 0&&(s+=i.charAt(a));else{s===void 0&&(s=i.substr(0,a));const M=f[y];M!==void 0?(c!==-1&&(s+=encodeURIComponent(i.substring(c,a)),c=-1),s+=M):c===-1&&(c=a)}}return c!==-1&&(s+=encodeURIComponent(i.substring(c))),s!==void 0?s:i}function S(i){let o;for(let s=0;s<i.length;s++){const c=i.charCodeAt(s);c===35||c===63?(o===void 0&&(o=i.substr(0,s)),o+=f[c]):o!==void 0&&(o+=i[s])}return o!==void 0?o:i}function m(i,o){let s;return i.authority&&i.path.length>1&&i.scheme==="file"?s=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?s=i.path.substr(1):s=i.path[1].toLowerCase()+i.path.substr(2):s=i.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=m;function h(i,o){const s=o?S:d;let c="",{scheme:a,authority:y,path:M,query:T,fragment:U}=i;if(a&&(c+=a,c+=":"),(y||a==="file")&&(c+=C,c+=C),y){let Y=y.indexOf("@");if(Y!==-1){const G=y.substr(0,Y);y=y.substr(Y+1),Y=G.indexOf(":"),Y===-1?c+=s(G,!1):(c+=s(G.substr(0,Y),!1),c+=":",c+=s(G.substr(Y+1),!1)),c+="@"}y=y.toLowerCase(),Y=y.indexOf(":"),Y===-1?c+=s(y,!1):(c+=s(y.substr(0,Y),!1),c+=y.substr(Y))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const Y=M.charCodeAt(1);Y>=65&&Y<=90&&(M=`/${String.fromCharCode(Y+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const Y=M.charCodeAt(0);Y>=65&&Y<=90&&(M=`${String.fromCharCode(Y+32)}:${M.substr(2)}`)}c+=s(M,!0)}return T&&(c+="?",c+=s(T,!1)),U&&(c+="#",c+=o?U:d(U,!1)),c}function l(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+l(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(n)?i.replace(n,o=>l(o)):i}}),define(ee[138],te([0,1,7]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(v){const b=v;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=t;function k(v){const b=[];let C;try{const I=JSON.parse(v.arguments),u=I[I.length-1];u&&u.__$stack&&(I.pop(),C=u.__$stack),b.push(...I)}catch{b.push("Unable to log remote console arguments",v.arguments)}return{args:b,stack:C}}e.parse=k;function R(v){if(typeof v!="string")return R(k(v).stack);const b=v;if(b){const C=D(b),I=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(I&&I.length===4)return{uri:E.URI.file(I[1]),line:Number(I[2]),column:Number(I[3])}}}e.getFirstFrame=R;function D(v){if(!v)return v;const b=v.indexOf(`
`);return b===-1?v:v.substring(0,b)}function P(v,b){const{args:C,stack:I}=k(v),u=typeof C[0]=="string"&&C.length===1;let w=D(I);w&&(w=`(${w.trim()})`);let g=[];if(typeof C[0]=="string"?w&&u?g=[`%c[${b}] %c${C[0]} %c${w}`,p("blue"),p(""),p("grey")]:g=[`%c[${b}] %c${C[0]}`,p("blue"),p(""),...C.slice(1)]:g=[`%c[${b}]%`,p("blue"),...C],w&&!u&&g.push(w),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,g)}e.log=P;function p(v){return`color: ${v}`}}),define(ee[68],te([0,1,17,25,7]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(v){return JSON.stringify(v,P)}e.stringify=R;function D(v){let b=JSON.parse(v);return b=p(b),b}e.parse=D;function P(v,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,t.regExpFlags)(b)}:b}function p(v,b=0){if(!v||b>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return k.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 15:return new Date(v.source)}if(v instanceof E.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let C=0;C<v.length;++C)v[C]=p(v[C],b+1);else for(const C in v)Object.hasOwnProperty.call(v,C)&&(v[C]=p(v[C],b+1))}return v}e.revive=p}),define(ee[14],te([0,1,4,7]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebook="vscode-notebook",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractive="vscode-interactive",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(v){this._preferredWebSchema=v}setDelegate(v){this._delegate=v}setServerRootPath(v){this._remoteResourcesPath=`${v}/${k.vscodeRemoteResource}`}set(v,b,C){this._hosts[v]=b,this._ports[v]=C}setConnectionToken(v,b){this._connectionTokens[v]=b}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(v){if(this._delegate)return this._delegate(v);const b=v.authority;let C=this._hosts[b];C&&C.indexOf(":")!==-1&&C.indexOf("[")===-1&&(C=`[${C}]`);const I=this._ports[b],u=this._connectionTokens[b];let w=`path=${encodeURIComponent(v.path)}`;return typeof u=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(u)}`),t.URI.from({scheme:E.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${C}:${I}`,path:this._remoteResourcesPath,query:w})}}e.RemoteAuthorities=new R;class D{asBrowserUri(v,b){const C=this.toUri(v,b);return C.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===k.file&&(E.isNative||E.isWebWorker&&E.globals.origin===`${k.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?C.with({scheme:k.vscodeFileResource,authority:C.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(v,b){const C=this.toUri(v,b);return C.scheme===k.vscodeFileResource?C.with({scheme:k.file,authority:C.authority!==D.FALLBACK_AUTHORITY?C.authority:null,query:null,fragment:null}):C}toUri(v,b){return t.URI.isUri(v)?v:t.URI.parse(b.toUrl(v))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D;var P;(function(p){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(v.get("3"));const b="vscode-coi";function C(u){let w;typeof u=="string"?w=new URL(u).searchParams:u instanceof URL?w=u.searchParams:t.URI.isUri(u)&&(w=new URL(u.toString(!0)).searchParams);const g=w?.get(b);if(!!g)return v.get(g)}p.getHeadersFromQuery=C;function I(u,w,g){if(!globalThis.crossOriginIsolated)return;const f=w&&g?"3":g?"2":"1";u instanceof URLSearchParams?u.set(b,f):u[b]=f}p.addSearchParam=I})(P=e.COI||(e.COI={}))}),define(ee[19],te([0,1,30,14,9,4,25,7]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(u){return(0,P.uriToFsPath)(u,!0)}e.originalFSPath=p;class v{constructor(w){this._ignorePathCasing=w}compare(w,g,f=!1){return w===g?0:(0,D.compare)(this.getComparisonKey(w,f),this.getComparisonKey(g,f))}isEqual(w,g,f=!1){return w===g?!0:!w||!g?!1:this.getComparisonKey(w,f)===this.getComparisonKey(g,f)}getComparisonKey(w,g=!1){return w.with({path:this._ignorePathCasing(w)?w.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(w){return this._ignorePathCasing(w)}isEqualOrParent(w,g,f=!1){if(w.scheme===g.scheme){if(w.scheme===t.Schemas.file)return E.isEqualOrParent(p(w),p(g),this._ignorePathCasing(w))&&w.query===g.query&&(f||w.fragment===g.fragment);if((0,e.isEqualAuthority)(w.authority,g.authority))return E.isEqualOrParent(w.path,g.path,this._ignorePathCasing(w),"/")&&w.query===g.query&&(f||w.fragment===g.fragment)}return!1}joinPath(w,...g){return P.URI.joinPath(w,...g)}basenameOrAuthority(w){return(0,e.basename)(w)||w.authority}basename(w){return k.posix.basename(w.path)}extname(w){return k.posix.extname(w.path)}dirname(w){if(w.path.length===0)return w;let g;return w.scheme===t.Schemas.file?g=P.URI.file(k.dirname(p(w))).path:(g=k.posix.dirname(w.path),w.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),g="/")),w.with({path:g})}normalizePath(w){if(!w.path.length)return w;let g;return w.scheme===t.Schemas.file?g=P.URI.file(k.normalize(p(w))).path:g=k.posix.normalize(w.path),w.with({path:g})}relativePath(w,g){if(w.scheme!==g.scheme||!(0,e.isEqualAuthority)(w.authority,g.authority))return;if(w.scheme===t.Schemas.file){const S=k.relative(p(w),p(g));return R.isWindows?E.toSlashes(S):S}let f=w.path||"/";const d=g.path||"/";if(this._ignorePathCasing(w)){let S=0;for(const m=Math.min(f.length,d.length);S<m&&!(f.charCodeAt(S)!==d.charCodeAt(S)&&f.charAt(S).toLowerCase()!==d.charAt(S).toLowerCase());S++);f=d.substr(0,S)+f.substr(S)}return k.posix.relative(f,d)}resolvePath(w,g){if(w.scheme===t.Schemas.file){const f=P.URI.file(k.resolve(p(w),g));return w.with({authority:f.authority,path:f.path})}return g=E.toPosixPath(g),w.with({path:k.posix.resolve(w.path,g)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,g){return w===g||w!==void 0&&g!==void 0&&(0,D.equalsIgnoreCase)(w,g)}hasTrailingPathSeparator(w,g=k.sep){if(w.scheme===t.Schemas.file){const f=p(w);return f.length>E.getRoot(f).length&&f[f.length-1]===g}else{const f=w.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,g=k.sep){return(0,e.hasTrailingPathSeparator)(w,g)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,g=k.sep){let f=!1;if(w.scheme===t.Schemas.file){const d=p(w);f=d!==void 0&&d.length===E.getRoot(d).length&&d[d.length-1]===g}else{g="/";const d=w.path;f=d.length===1&&d.charCodeAt(d.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(w,g)?w.with({path:w.path+"/"}):w}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(u=>u.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new v(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(u,w){const g=[];for(let f=0;f<u.length;f++){const d=w(u[f]);u.some((S,m)=>m===f?!1:(0,e.isEqualOrParent)(d,w(S)))||g.push(u[f])}return g}e.distinctParents=b;var C;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function w(g){const f=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(m=>{const[h,l]=m.split(":");h&&l&&f.set(h,l)});const S=g.path.substring(0,g.path.indexOf(";"));return S&&f.set(u.META_DATA_MIME,S),f}u.parseMetaData=w})(C=e.DataUri||(e.DataUri={}));function I(u,w,g){if(w){let f=u.path;return f&&f[0]!==k.posix.sep&&(f=k.posix.sep+f),u.with({scheme:g,authority:w,path:f})}return u.with({scheme:g})}e.toLocalResource=I}),define(ee[8],te([0,1,22,16,3,2,19,4]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function p($){return!!$&&typeof $.then=="function"}e.isThenable=p;function v($){const L=new E.CancellationTokenSource,W=$(L.token),j=new Promise((q,X)=>{const re=L.token.onCancellationRequested(()=>{re.dispose(),L.dispose(),X(new t.CancellationError)});Promise.resolve(W).then(B=>{re.dispose(),L.dispose(),q(B)},B=>{re.dispose(),L.dispose(),X(B)})});return new class{cancel(){L.cancel()}then(q,X){return j.then(q,X)}catch(q){return this.then(void 0,q)}finally(q){return j.finally(q)}}}e.createCancelablePromise=v;function b($,L,W){return new Promise((j,q)=>{const X=L.onCancellationRequested(()=>{X.dispose(),j(W)});$.then(j,q).finally(()=>X.dispose())})}e.raceCancellation=b;function C($,L){return new Promise((W,j)=>{const q=L.onCancellationRequested(()=>{q.dispose(),j(new t.CancellationError)});$.then(W,j).finally(()=>q.dispose())})}e.raceCancellationError=C;async function I($){let L=-1;const W=$.map((q,X)=>q.then(re=>(L=X,re))),j=await Promise.race(W);return $.forEach((q,X)=>{X!==L&&q.cancel()}),j}e.raceCancellablePromises=I;function u($,L,W){let j;const q=setTimeout(()=>{j?.(void 0),W?.()},L);return Promise.race([$.finally(()=>clearTimeout(q)),new Promise(X=>j=X)])}e.raceTimeout=u;function w($){return new Promise((L,W)=>{const j=$();p(j)?j.then(L,W):L(j)})}e.asPromise=w;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const W=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(W,W).then(j)})}return new Promise((W,j)=>{this.queuedPromise.then(W,j)})}return this.activePromise=L(),new Promise((W,j)=>{this.activePromise.then(q=>{this.activePromise=null,W(q)},q=>{this.activePromise=null,j(q)})})}}e.Throttler=g;class f{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=f;class d{constructor(){this.promiseMap=new Map}queue(L,W){const q=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(L)===q&&this.promiseMap.delete(L)});return this.promiseMap.set(L,q),q}}e.SequencerByKey=d;const S=($,L)=>{let W=!0;const j=setTimeout(()=>{W=!1,L()},$);return{isTriggered:()=>W,dispose:()=>{clearTimeout(j),W=!1}}},m=$=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,$())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,W=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((q,X)=>{this.doResolve=q,this.doReject=X}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const q=this.task;return this.task=null,q()}}));const j=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=W===e.MicrotaskDelay?m(j):S(W,j),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=h;class l{constructor(L){this.delayer=new h(L),this.throttler=new g}trigger(L,W){return this.delayer.trigger(()=>this.throttler.queue(L),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class n{constructor(){this._isOpen=!1,this._promise=new Promise((L,W)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class r extends n{constructor(L){super(),this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function i($,L){return L?new Promise((W,j)=>{const q=setTimeout(()=>{X.dispose(),W()},$),X=L.onCancellationRequested(()=>{clearTimeout(q),X.dispose(),j(new t.CancellationError)})}):v(W=>i($,W))}e.timeout=i;function o($,L=0){const W=setTimeout($,L);return(0,R.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=o;function s($){const L=[];let W=0;const j=$.length;function q(){return W<j?$[W++]():null}function X(re){re!=null&&L.push(re);const B=q();return B?B.then(X):Promise.resolve(L)}return Promise.resolve(null).then(X)}e.sequence=s;function c($,L=j=>!!j,W=null){let j=0;const q=$.length,X=()=>{if(j>=q)return Promise.resolve(W);const re=$[j++];return Promise.resolve(re()).then(J=>L(J)?Promise.resolve(J):X())};return X()}e.first=c;function a($,L=j=>!!j,W=null){if($.length===0)return Promise.resolve(W);let j=$.length;const q=()=>{j=-1;for(const X of $)X.cancel?.()};return new Promise((X,re)=>{for(const B of $)B.then(J=>{--j>=0&&L(J)?(q(),X(J)):j===0&&X(W)}).catch(J=>{--j>=0&&(q(),re(J))})})}e.firstParallel=a;class y{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((W,j)=>{this.outstandingPromises.push({factory:L,c:W,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const W=L.factory();W.then(L.c,L.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=y;class M extends y{constructor(){super(1)}}e.Queue=M;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new F;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,W=D.extUri){const j=W.getComparisonKey(L);let q=this.queues.get(j);return q||(q=new M,k.Event.once(q.onDrained)(()=>{q?.dispose(),this.queues.delete(j),this.onDidQueueDrain()}),this.queues.set(j,q)),q}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class U{constructor(L,W){this._token=-1,typeof L=="function"&&typeof W=="number"&&this.setIfNotSet(L,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},W)}setIfNotSet(L,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},W))}}e.TimeoutTimer=U;class Y{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,W){this.cancel(),this._token=setInterval(()=>{L()},W)}}e.IntervalTimer=Y;class G{constructor(L,W){this.timeoutToken=-1,this.runner=L,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=G;class V{constructor(L,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=W,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=V;class oe extends G{constructor(L,W){super(L,W),this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=oe;class ae extends R.Disposable{constructor(L,W){super(),this.options=L,this.handler=W,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new G(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ae,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=$=>{(0,P.setTimeout0)(()=>{if(L)return;const W=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=($,L)=>{const W=requestIdleCallback($,typeof L=="number"?{timeout:L}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(W))}}}}();class se{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function fe($,L,W){let j;for(let q=0;q<W;q++)try{return await $()}catch(X){j=X,await i(L)}throw j}e.retry=fe;class K{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(L,W,j){return this._pending={taskId:L,cancel:()=>j?.(),promise:W},W.then(()=>this.donePending(L),()=>this.donePending(L)),W}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let W,j;const q=new Promise((X,re)=>{W=X,j=re});this._next={run:L,promise:q,promiseResolve:W,promiseReject:j}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=K;class H{constructor(L,W=()=>Date.now()){this.interval=L,this.nowFn=W,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class F{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,W)=>{this.completeCallback=L,this.errorCallback=W})}complete(L){return new Promise(W=>{this.completeCallback(L),this.resolved=!0,W()})}error(L){return new Promise(W=>{this.errorCallback(L),this.rejected=!0,W()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=F;var A;(function($){async function L(j){let q;const X=await Promise.all(j.map(re=>re.then(B=>B,B=>{q||(q=B)})));if(typeof q<"u")throw q;return X}$.settled=L;function W(j){return new Promise(async(q,X)=>{try{await j(q,X)}catch(re){X(re)}})}$.withAsyncBody=W})(A=e.Promises||(e.Promises={}));var O;(function($){$[$.Initial=0]="Initial",$[$.DoneOK=1]="DoneOK",$[$.DoneError=2]="DoneError"})(O||(O={}));class _{static fromArray(L){return new _(W=>{W.emitMany(L)})}static fromPromise(L){return new _(async W=>{W.emitMany(await L)})}static fromPromises(L){return new _(async W=>{await Promise.all(L.map(async j=>W.emitOne(await j)))})}static merge(L){return new _(async W=>{await Promise.all(L.map(async j=>{for await(const q of j)W.emitOne(q)}))})}constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const W={emitOne:j=>this.emitOne(j),emitMany:j=>this.emitMany(j),reject:j=>this.reject(j)};try{await Promise.resolve(L(W)),this.resolve()}catch(j){this.reject(j)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,W){return new _(async j=>{for await(const q of L)j.emitOne(W(q))})}map(L){return _.map(this,L)}static filter(L,W){return new _(async j=>{for await(const q of L)W(q)&&j.emitOne(q)})}filter(L){return _.filter(this,L)}static coalesce(L){return _.filter(L,W=>!!W)}coalesce(){return _.coalesce(this)}static async toPromise(L){const W=[];for await(const j of L)W.push(j);return W}toPromise(){return _.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=_,_.EMPTY=_.fromArray([]);class ne extends _{constructor(L,W){super(W),this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ne;function N($){const L=new E.CancellationTokenSource,W=$(L.token);return new ne(L,async j=>{const q=L.token.onCancellationRequested(()=>{q.dispose(),L.dispose(),j.reject(new t.CancellationError)});try{for await(const X of W){if(L.token.isCancellationRequested)return;j.emitOne(X)}q.dispose(),L.dispose()}catch(X){q.dispose(),L.dispose(),j.reject(X)}})}e.createCancelableAsyncIterable=N}),define(ee[98],te([0,1,24,8,30,38,9,4,25]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function v(){return Object.create(null)}e.getEmptyExpression=v,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",C="[^/\\\\]",I=/\//g;function u(F,A){switch(F){case 0:return"";case 1:return`${C}*?`;default:return`(?:${b}|${C}+${b}${A?`|${b}${C}+`:""})*?`}}function w(F,A){if(!F)return[];const O=[];let _=!1,ne=!1,N="";for(const $ of F){switch($){case A:if(!_&&!ne){O.push(N),N="";continue}break;case"{":_=!0;break;case"}":_=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}N+=$}return N&&O.push(N),O}e.splitGlobAware=w;function g(F){if(!F)return"";let A="";const O=w(F,e.GLOB_SPLIT);if(O.every(_=>_===e.GLOBSTAR))A=".*";else{let _=!1;O.forEach((ne,N)=>{if(ne===e.GLOBSTAR){if(_)return;A+=u(2,N===O.length-1)}else{let $=!1,L="",W=!1,j="";for(const q of ne){if(q!=="}"&&$){L+=q;continue}if(W&&(q!=="]"||!j)){let X;q==="-"?X=q:(q==="^"||q==="!")&&!j?X="^":q===e.GLOB_SPLIT?X="":X=(0,p.escapeRegExpCharacters)(q),j+=X;continue}switch(q){case"{":$=!0;continue;case"[":W=!0;continue;case"}":{A+=`(?:${w(L,",").map(B=>g(B)).join("|")})`,$=!1,L="";break}case"]":{A+="["+j+"]",W=!1,j="";break}case"?":A+=C;continue;case"*":A+=u(1);continue;default:A+=(0,p.escapeRegExpCharacters)(q)}}N<O.length-1&&(O[N+1]!==e.GLOBSTAR||N+2<O.length)&&(A+=b)}_=ne===e.GLOBSTAR})}return A}const f=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new R.LRUCache(1e4),r=function(){return!1},i=function(){return null};function o(F,A){if(!F)return i;let O;typeof F!="string"?O=F.pattern:O=F,O=O.trim();const _=`${O}_${!!A.trimForExclusions}`;let ne=n.get(_);if(ne)return s(ne,F);let N;return f.test(O)?ne=a(O.substr(4),O):(N=d.exec(c(O,A)))?ne=y(N[1],O):(A.trimForExclusions?m:S).test(O)?ne=M(O,A):(N=h.exec(c(O,A)))?ne=T(N[1].substr(1),O,!0):(N=l.exec(c(O,A)))?ne=T(N[1],O,!1):ne=U(O),n.set(_,ne),s(ne,F)}function s(F,A){if(typeof A=="string")return F;const O=function(_,ne){return(0,k.isEqualOrParent)(_,A.base,!P.isLinux)?F(_.substr(A.base.length+1),ne):null};return O.allBasenames=F.allBasenames,O.allPaths=F.allPaths,O.basenames=F.basenames,O.patterns=F.patterns,O}function c(F,A){return A.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function a(F,A){return function(O,_){return typeof O=="string"&&O.endsWith(F)?A:null}}function y(F,A){const O=`/${F}`,_=`\\${F}`,ne=function($,L){return typeof $!="string"?null:L?L===F?A:null:$===F||$.endsWith(O)||$.endsWith(_)?A:null},N=[F];return ne.basenames=N,ne.patterns=[A],ne.allBasenames=N,ne}function M(F,A){const O=K(F.slice(1,-1).split(",").map(L=>o(L,A)).filter(L=>L!==i),F),_=O.length;if(!_)return i;if(_===1)return O[0];const ne=function(L,W){for(let j=0,q=O.length;j<q;j++)if(O[j](L,W))return F;return null},N=O.find(L=>!!L.allBasenames);N&&(ne.allBasenames=N.allBasenames);const $=O.reduce((L,W)=>W.allPaths?L.concat(W.allPaths):L,[]);return $.length&&(ne.allPaths=$),ne}function T(F,A,O){const _=D.sep===D.posix.sep,ne=_?F:F.replace(I,D.sep),N=D.sep+ne,$=D.posix.sep+F;let L;return O?L=function(W,j){return typeof W=="string"&&(W===ne||W.endsWith(N)||!_&&(W===F||W.endsWith($)))?A:null}:L=function(W,j){return typeof W=="string"&&(W===ne||!_&&W===F)?A:null},L.allPaths=[(O?"*/":"./")+F],L}function U(F){try{const A=new RegExp(`^${g(F)}$`);return function(O){return A.lastIndex=0,typeof O=="string"&&A.test(O)?F:null}}catch{return i}}function Y(F,A,O){return!F||typeof A!="string"?!1:G(F)(A,void 0,O)}e.match=Y;function G(F,A={}){if(!F)return r;if(typeof F=="string"||V(F)){const O=o(F,A);if(O===i)return r;const _=function(ne,N){return!!O(ne,N)};return O.allBasenames&&(_.allBasenames=O.allBasenames),O.allPaths&&(_.allPaths=O.allPaths),_}return se(F,A)}e.parse=G;function V(F){const A=F;return A?typeof A.base=="string"&&typeof A.pattern=="string":!1}e.isRelativePattern=V;function oe(F){return F.allBasenames||[]}e.getBasenameTerms=oe;function ae(F){return F.allPaths||[]}e.getPathTerms=ae;function se(F,A){const O=K(Object.getOwnPropertyNames(F).map(L=>fe(L,F[L],A)).filter(L=>L!==i)),_=O.length;if(!_)return i;if(!O.some(L=>!!L.requiresSiblings)){if(_===1)return O[0];const L=function(q,X){let re;for(let B=0,J=O.length;B<J;B++){const Z=O[B](q,X);if(typeof Z=="string")return Z;(0,t.isThenable)(Z)&&(re||(re=[]),re.push(Z))}return re?(async()=>{for(const B of re){const J=await B;if(typeof J=="string")return J}return null})():null},W=O.find(q=>!!q.allBasenames);W&&(L.allBasenames=W.allBasenames);const j=O.reduce((q,X)=>X.allPaths?q.concat(X.allPaths):q,[]);return j.length&&(L.allPaths=j),L}const ne=function(L,W,j){let q,X;for(let re=0,B=O.length;re<B;re++){const J=O[re];J.requiresSiblings&&j&&(W||(W=(0,D.basename)(L)),q||(q=W.substr(0,W.length-(0,D.extname)(L).length)));const Z=J(L,W,q,j);if(typeof Z=="string")return Z;(0,t.isThenable)(Z)&&(X||(X=[]),X.push(Z))}return X?(async()=>{for(const re of X){const B=await re;if(typeof B=="string")return B}return null})():null},N=O.find(L=>!!L.allBasenames);N&&(ne.allBasenames=N.allBasenames);const $=O.reduce((L,W)=>W.allPaths?L.concat(W.allPaths):L,[]);return $.length&&(ne.allPaths=$),ne}function fe(F,A,O){if(A===!1)return i;const _=o(F,O);if(_===i)return i;if(typeof A=="boolean")return _;if(A){const ne=A.when;if(typeof ne=="string"){const N=($,L,W,j)=>{if(!j||!_($,L))return null;const q=ne.replace("$(basename)",W),X=j(q);return(0,t.isThenable)(X)?X.then(re=>re?F:null):X?F:null};return N.requiresSiblings=!0,N}}return _}function K(F,A){const O=F.filter(L=>!!L.basenames);if(O.length<2)return F;const _=O.reduce((L,W)=>{const j=W.basenames;return j?L.concat(j):L},[]);let ne;if(A){ne=[];for(let L=0,W=_.length;L<W;L++)ne.push(A)}else ne=O.reduce((L,W)=>{const j=W.patterns;return j?L.concat(j):L},[]);const N=function(L,W){if(typeof L!="string")return null;if(!W){let q;for(q=L.length;q>0;q--){const X=L.charCodeAt(q-1);if(X===47||X===92)break}W=L.substr(q)}const j=_.indexOf(W);return j!==-1?ne[j]:null};N.basenames=_,N.patterns=ne,N.allBasenames=_;const $=F.filter(L=>!L.basenames);return $.push(N),$}function H(F,A){return(0,E.equals)(F,A,(O,_)=>typeof O=="string"&&typeof _=="string"?O===_:typeof O!="string"&&typeof _!="string"?O.base===_.base&&O.pattern===_.pattern:!1)}e.patternsEquals=H}),define(ee[33],te([0,1,24,30,9,4,19,25]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function p(i,o){const{os:s,tildify:c,relative:a}=o;if(a){const T=v(i,a,s);if(typeof T=="string")return T}let y=i.fsPath;if(s===1&&!R.isWindows?y=y.replace(/\//g,"\\"):s!==1&&R.isWindows&&(y=y.replace(/\\/g,"/")),s!==1&&c?.userHome){const T=c.userHome.fsPath;let U;i.scheme!==c.userHome.scheme&&i.path.startsWith(k.posix.sep)?U=c.userHome.with({path:i.path}).fsPath:U=i.fsPath,y=I(U,T,s)}return(s===1?k.win32:k.posix).normalize(b(y,s===1))}e.getPathLabel=p;function v(i,o,s){const c=s===1?k.win32:k.posix,a=s===3?D.extUri:D.extUriIgnorePathCase,y=o.getWorkspace(),M=(0,E.firstOrDefault)(y.folders);if(!M)return;i.scheme!==M.uri.scheme&&i.path.startsWith(k.posix.sep)&&(i=M.uri.with({path:i.path}));const T=o.getWorkspaceFolder(i);if(!T)return;let U;if(a.isEqual(T.uri,i)?U="":U=a.relativePath(T.uri,i)??"",U&&(U=c.normalize(U)),y.folders.length>1&&!o.noPrefix){const Y=T.name?T.name:a.basenameOrAuthority(T.uri);U=U?`${Y} \u2022 ${U}`:Y}return U}function b(i,o=R.isWindows){return(0,t.hasDriveLetter)(i,o)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=b;let C=Object.create(null);function I(i,o,s=R.OS){if(s===1||!i||!o)return i;let c=C.original===o?C.normalized:void 0;c||(c=o,R.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,P.rtrim)(c,k.posix.sep)}${k.posix.sep}`,C={original:o,normalized:c});let a=i;return R.isWindows&&(a=(0,t.toSlashes)(a)),(s===3?a.startsWith(c):(0,P.startsWithIgnoreCase)(a,c))?`~/${a.substr(c.length)}`:i}e.tildify=I;function u(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=u;const w="\u2026",g="\\\\",f="~";function d(i,o=k.sep){const s=new Array(i.length);let c=!1;for(let a=0;a<i.length;a++){const y=i[a];if(y===""){s[a]=`.${o}`;continue}if(!y){s[a]=y;continue}c=!0;let M="",T=y;T.indexOf(g)===0?(M=T.substr(0,T.indexOf(g)+g.length),T=T.substr(T.indexOf(g)+g.length)):T.indexOf(o)===0?(M=T.substr(0,T.indexOf(o)+o.length),T=T.substr(T.indexOf(o)+o.length)):T.indexOf(f)===0&&(M=T.substr(0,T.indexOf(f)+f.length),T=T.substr(T.indexOf(f)+f.length));const U=T.split(o);for(let Y=1;c&&Y<=U.length;Y++)for(let G=U.length-Y;c&&G>=0;G--){c=!1;let V=U.slice(G,G+Y).join(o);for(let oe=0;!c&&oe<i.length;oe++)if(oe!==a&&i[oe]&&i[oe].indexOf(V)>-1){const ae=G+Y===U.length,se=G>0&&i[oe].indexOf(o)>-1?o+V:V,fe=i[oe].endsWith(se);c=!ae||fe}if(!c){let oe="";(U[0].endsWith(":")||M!=="")&&(G===1&&(G=0,Y++,V=U[0]+o+V),G>0&&(oe=U[0]+o),oe=M+oe),G>0&&(oe=oe+w+o),oe=oe+V,G+Y<U.length&&(oe=oe+o+w),s[a]=oe}}c&&(s[a]=y)}return s}e.shorten=d;var S;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(S||(S={}));function m(i,o=Object.create(null)){const s=[];let c=!1,a="";for(const y of i)if(y==="$"||c&&y==="{")a&&s.push({value:a,type:S.TEXT}),a="",c=!0;else if(y==="}"&&c){const M=o[a];if(typeof M=="string")M.length&&s.push({value:M,type:S.VARIABLE});else if(M){const T=s[s.length-1];(!T||T.type!==S.SEPARATOR)&&s.push({value:M.label,type:S.SEPARATOR})}a="",c=!1}else a+=y;return a&&!c&&s.push({value:a,type:S.TEXT}),s.filter((y,M)=>{if(y.type===S.SEPARATOR){const T=s[M-1],U=s[M+1];return[T,U].every(Y=>Y&&(Y.type===S.VARIABLE||Y.type===S.TEXT)&&Y.value.length>0)}return!0}).map(y=>y.value).join("")}e.template=m;function h(i,o){return R.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function l(i,o){return R.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,s=>s==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function n(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=n;function r(i){const o=i.indexOf("/")!==-1?k.posix:k.win32,s=o.basename(i),c=o.dirname(i);return s.length?{name:s,parentPath:c}:{name:c,parentPath:""}}e.splitName=r}),define(ee[139],te([0,1,7]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(b){return b.toJSON()}class k{constructor(C){this._uriTransformer=C}transformIncoming(C){const I=this._uriTransformer.transformIncoming(C);return I===C?C:t(E.URI.from(I))}transformOutgoing(C){const I=this._uriTransformer.transformOutgoing(C);return I===C?C:t(E.URI.from(I))}transformOutgoingURI(C){const I=this._uriTransformer.transformOutgoing(C);return I===C?C:E.URI.from(I)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function R(b,C,I){if(!b||I>200)return null;if(typeof b=="object"){if(b instanceof E.URI)return C.transformOutgoing(b);for(const u in b)if(Object.hasOwnProperty.call(b,u)){const w=R(b[u],C,I+1);w!==null&&(b[u]=w)}}return null}function D(b,C){const I=R(b,C,0);return I===null?b:I}e.transformOutgoingURIs=D;function P(b,C,I,u){if(!b||u>200)return null;if(typeof b=="object"){if(b.$mid===1)return I?E.URI.revive(C.transformIncoming(b)):C.transformIncoming(b);for(const w in b)if(Object.hasOwnProperty.call(b,w)){const g=P(b[w],C,I,u+1);g!==null&&(b[w]=g)}}return null}function p(b,C){const I=P(b,C,!1,0);return I===null?b:I}e.transformIncomingURIs=p;function v(b,C){const I=P(b,C,!0,0);return I===null?b:I}e.transformAndReviveIncomingURIs=v}),define(ee[81],te([0,1,27,16,58,29,127]),function(z,e,E,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(b){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(b)}value(){if(this._value===void 0){let b=0,C=0;const I=(0,E.networkInterfaces)();for(const u in I){const w=I[u];if(w)for(const{mac:g,internal:f}of w)f||(C+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(b+=1))}this._value=C>0?b/C:0}return this._value}};let P;async function p(){return P||(P=(async()=>await v()||R.generateUuid())()),P}e.getMachineId=p;async function v(){try{const b=await new Promise((I,u)=>{z(["crypto"],I,u)}),C=(0,D.getMac)();return b.createHash("sha256").update(C,"utf8").digest("hex")}catch(b){t.onUnexpectedError(b);return}}}),define(ee[23],te([0,1,39,27,140,8,30,76,9,4,19,7]),function(z,e,E,t,k,R,D,P,p,v,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var I;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(I=e.RimRafMode||(e.RimRafMode={}));async function u(se,fe=I.UNLINK){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return fe===I.UNLINK?g(se):w(se)}async function w(se){try{const fe=(0,D.randomPath)((0,t.tmpdir)());try{await E.promises.rename(se,fe)}catch(K){return K.code==="ENOENT"?void 0:g(se)}g(fe).catch(K=>{})}catch(fe){if(fe.code!=="ENOENT")throw fe}}async function g(se){return(0,k.promisify)(E.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function f(se){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function d(se,fe){return h(await(fe?S(se):(0,k.promisify)(E.readdir)(se)))}async function S(se){try{return await(0,k.promisify)(E.readdir)(se,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const fe=[],K=await d(se);for(const H of K){let F=!1,A=!1,O=!1;try{const _=await e.Promises.lstat((0,p.join)(se,H));F=_.isFile(),A=_.isDirectory(),O=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}fe.push({name:H,isFile:()=>F,isDirectory:()=>A,isSymbolicLink:()=>O})}return fe}function m(se){return h(E.readdirSync(se))}e.readdirSync=m;function h(se){return se.map(fe=>typeof fe=="string"?v.isMacintosh?(0,P.normalizeNFC)(fe):fe:(fe.name=v.isMacintosh?(0,P.normalizeNFC)(fe.name):fe.name,fe))}async function l(se){const fe=await d(se),K=[];for(const H of fe)await r.existsDirectory((0,p.join)(se,H))&&K.push(H);return K}function n(se,fe=1e3){return new Promise(K=>{let H=!1;const F=setInterval(()=>{H||(H=!0,E.access(se,A=>{H=!1,A&&(clearInterval(F),K(void 0))}))},fe)})}e.whenDeleted=n;var r;(function(se){async function fe(F){let A;try{if(A=await e.Promises.lstat(F),!A.isSymbolicLink())return{stat:A}}catch{}try{return{stat:await e.Promises.stat(F),symbolicLink:A?.isSymbolicLink()?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(v.isWindows&&O.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw _}throw O}}se.stat=fe;async function K(F){try{const{stat:A,symbolicLink:O}=await se.stat(F);return A.isFile()&&O?.dangling!==!0}catch{}return!1}se.existsFile=K;async function H(F){try{const{stat:A,symbolicLink:O}=await se.stat(F);return A.isDirectory()&&O?.dangling!==!0}catch{}return!1}se.existsDirectory=H})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function o(se,fe,K){return i.queueFor(C.URI.file(se),b.extUriBiasedIgnorePathCase).queue(()=>{const H=M(K);return new Promise((F,A)=>a(se,fe,H,O=>O?A(O):F()))})}let s=!0;function c(se){s=se}e.configureFlushOnWrite=c;function a(se,fe,K,H){if(!s)return E.writeFile(se,fe,{mode:K.mode,flag:K.flag},H);E.open(se,K.flag,K.mode,(F,A)=>{if(F)return H(F);E.writeFile(A,fe,O=>{if(O)return E.close(A,()=>H(O));E.fdatasync(A,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),c(!1)),E.close(A,ne=>H(ne))))})})}function y(se,fe,K){const H=M(K);if(!s)return E.writeFileSync(se,fe,{mode:H.mode,flag:H.flag});const F=E.openSync(se,H.flag,H.mode);try{E.writeFileSync(F,fe);try{E.fdatasyncSync(F)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),c(!1)}}finally{E.closeSync(F)}}e.writeFileSync=y;function M(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function T(se,fe){if(se!==fe)try{await e.Promises.rename(se,fe)}catch(K){if(se.toLowerCase()!==fe.toLowerCase()&&K.code==="EXDEV"||se.endsWith("."))await U(se,fe,{preserveSymlinks:!1}),await u(se,I.MOVE);else throw K}}async function U(se,fe,K){return G(se,fe,{root:{source:se,target:fe},options:K,handledSourcePaths:new Set})}const Y=511;async function G(se,fe,K){if(K.handledSourcePaths.has(se))return;K.handledSourcePaths.add(se);const{stat:H,symbolicLink:F}=await r.stat(se);if(F){if(K.options.preserveSymlinks)try{return await ae(se,fe,K)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(F.dangling)return}return H.isDirectory()?V(se,fe,H.mode&Y,K):oe(se,fe,H.mode&Y)}async function V(se,fe,K,H){await e.Promises.mkdir(fe,{recursive:!0,mode:K});const F=await d(se);for(const A of F)await G((0,p.join)(se,A),(0,p.join)(fe,A),H)}async function oe(se,fe,K){await e.Promises.copyFile(se,fe),await e.Promises.chmod(fe,K)}async function ae(se,fe,K){let H=await e.Promises.readlink(se);(0,D.isEqualOrParent)(H,K.root.source,!v.isLinux)&&(H=(0,p.join)(K.root.target,H.substr(K.root.source.length+1))),await e.Promises.symlink(H,fe)}e.Promises=new class{get access(){return(0,k.promisify)(E.access)}get stat(){return(0,k.promisify)(E.stat)}get lstat(){return(0,k.promisify)(E.lstat)}get utimes(){return(0,k.promisify)(E.utimes)}get read(){return(se,fe,K,H,F)=>new Promise((A,O)=>{E.read(se,fe,K,H,F,(_,ne,N)=>_?O(_):A({bytesRead:ne,buffer:N}))})}get readFile(){return(0,k.promisify)(E.readFile)}get write(){return(se,fe,K,H,F)=>new Promise((A,O)=>{E.write(se,fe,K,H,F,(_,ne,N)=>_?O(_):A({bytesWritten:ne,buffer:N}))})}get appendFile(){return(0,k.promisify)(E.appendFile)}get fdatasync(){return(0,k.promisify)(E.fdatasync)}get truncate(){return(0,k.promisify)(E.truncate)}get rename(){return(0,k.promisify)(E.rename)}get copyFile(){return(0,k.promisify)(E.copyFile)}get open(){return(0,k.promisify)(E.open)}get close(){return(0,k.promisify)(E.close)}get symlink(){return(0,k.promisify)(E.symlink)}get readlink(){return(0,k.promisify)(E.readlink)}get chmod(){return(0,k.promisify)(E.chmod)}get mkdir(){return(0,k.promisify)(E.mkdir)}get unlink(){return(0,k.promisify)(E.unlink)}get rmdir(){return(0,k.promisify)(E.rmdir)}get realpath(){return(0,k.promisify)(E.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return l}get writeFile(){return o}get rm(){return u}get move(){return T}get copy(){return U}}}),define(ee[99],te([0,1,39,9,4,25,23]),function(z,e,E,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(I){if(k.isLinux)return I;const u=(0,t.dirname)(I);if(I===u)return I;const w=((0,t.basename)(I)||I).toLowerCase();try{const f=(0,D.readdirSync)(u).filter(d=>d.toLowerCase()===w);if(f.length===1){const d=P(u);if(d)return(0,t.join)(d,f[0])}else if(f.length>1){const d=f.indexOf(w);if(d>=0){const S=P(u);if(S)return(0,t.join)(S,f[d])}}}catch{}return null}e.realcaseSync=P;async function p(I){if(k.isLinux)return I;const u=(0,t.dirname)(I);if(I===u)return I;const w=((0,t.basename)(I)||I).toLowerCase();try{const f=(await D.Promises.readdir(u)).filter(d=>d.toLowerCase()===w);if(f.length===1){const d=await p(u);if(d)return(0,t.join)(d,f[0])}else if(f.length>1){const d=f.indexOf(w);if(d>=0){const S=await p(u);if(S)return(0,t.join)(S,f[d])}}}catch{}return null}e.realcase=p;async function v(I){try{return await D.Promises.realpath(I)}catch{const w=C(I);return await D.Promises.access(w,E.constants.R_OK),w}}e.realpath=v;function b(I){try{return E.realpathSync(I)}catch{const w=C(I);return E.accessSync(w,E.constants.R_OK),w}}e.realpathSync=b;function C(I){return(0,R.rtrim)((0,t.normalize)(I),t.sep)}}),define(ee[141],te([0,1,27,9,23]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var p;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(p||(p={}));let v;switch(process.arch){case"ia32":case"x32":v=1;break;case"arm":case"arm64":v=2;break;default:v=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class C{constructor(l,n,r){this.exePath=l,this.displayName=n,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function I({useAlternateBitness:h=!1}={}){return h?v===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:h=!1,findPreview:l=!1}={}){const n=I({useAlternateBitness:h});if(!n)return null;const r=t.join(n,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let i=-1,o=null;for(const a of await k.Promises.readdir(r)){let y=-1;if(l){const T=a.indexOf("-");if(T<0)continue;const U=a.substring(0,T);if(!R.test(U)||a.substring(T+1)!=="preview")continue;y=parseInt(U,10)}else{if(!R.test(a))continue;y=parseInt(a,10)}if(y<=i)continue;const M=t.join(r,a,"pwsh.exe");!await k.SymlinkSupport.existsFile(M)||(o=M,i=y)}if(!o)return null;const s=n.includes("x86")?" (x86)":"",c=l?" Preview":"";return new C(o,`PowerShell${c}${s}`,!0)}async function w({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const l=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=h?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(l))if(n.test(i)){const o=t.join(l,i,"pwsh.exe");return new C(o,r)}return null}function g(){const h=t.join(E.homedir(),".dotnet","tools","pwsh.exe");return new C(h,".NET Core PowerShell Global Tool")}function f(){const h=t.join(process.env.windir,v===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(h,"Windows PowerShell",!0)}async function*d(){let h=await u();h&&(yield h),h=await u({useAlternateBitness:!0}),h&&(yield h),h=await w(),h&&(yield h),h=g(),h&&(yield h),h=await u({findPreview:!0}),h&&(yield h),h=await w({findPreview:!0}),h&&(yield h),h=await u({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=f(),h&&(yield h)}async function*S(){for await(const h of d())await h.exists()&&(yield h)}e.enumeratePowerShellInstallations=S;async function m(){for await(const h of S())return h;return null}e.getFirstAvailablePowerShellInstallation=m}),define(ee[82],te([0,1,9,4,32,79,12,23]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function p(C=k.env){return C.comspec||"cmd.exe"}e.getWindowsShell=p;function v(C){let I=[],u=!1;const w=function(g){if(u){I.push(g);return}(!C.send(g,d=>{if(d&&console.error(d),u=!1,I.length>0){const S=I.slice(0);I=[],S.forEach(m=>w(m))}})||t.isWindows)&&(u=!0)};return{send:w}}e.createQueuedSender=v;var b;(function(C){async function I(u,w,g){if(E.isAbsolute(u))return u;if(w===void 0&&(w=k.cwd()),E.dirname(u)!=="."||(g===void 0&&D.isString(k.env.PATH)&&(g=k.env.PATH.split(E.delimiter)),g===void 0||g.length===0))return E.join(w,u);async function d(S){if(await P.Promises.exists(S)){let m;try{m=await P.Promises.stat(S)}catch(h){h.message.startsWith("EACCES")&&(m=await P.Promises.lstat(S))}return m?!m.isDirectory():!1}return!1}for(const S of g){let m;if(E.isAbsolute(S)?m=E.join(S,u):m=E.join(w,S,u),await d(m))return m;let h=m+".com";if(await d(h)||(h=m+".exe",await d(h)))return h}return E.join(w,u)}C.findExecutable=I})(b=e.win32||(e.win32={}))}),define(ee[100],te([0,1,44,14]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(D){return new Promise((P,p)=>{let v;const b=new Map;function C(u,w,g,f,d){const S=b.get(w);if(u===D||S){const m={name:I(g),cmd:g,pid:u,ppid:w,load:f,mem:d};b.set(u,m),u===D&&(v=m),S&&(S.children||(S.children=[]),S.children.push(m),S.children.length>1&&(S.children=S.children.sort((h,l)=>h.pid-l.pid)))}}function I(u){const w=/--vscode-window-kind=shared-process/,g=/--vscode-window-kind=issue-reporter/,f=/--vscode-window-kind=process-explorer/,d=/--utility-sub-type=network/,S=/--utility-sub-type=node.mojom.NodeService/,m=/--crashes-directory/,h=/\\pipe\\winpty-control/,l=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(m.exec(u))return"electron-crash-reporter";if(h.exec(u))return"winpty-process";if(l.exec(u))return"console-window-host (Windows internal process)";let r=n.exec(u);if(r&&r.length===2){if(r[1]==="renderer")return w.exec(u)?"shared-process":g.exec(u)?"issue-reporter":f.exec(u)?"process-explorer":"window";if(r[1]==="utility"){if(d.exec(u))return"utility-network-service";if(S.exec(u))return"extension-host"}return r[1]}const i=/[a-zA-Z-]+\.js/g;let o="";do r=i.exec(u),r&&(o+=r+" ");while(r);return o&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron_node ${o}`:u}if(process.platform==="win32"){const u=w=>w.indexOf("\\\\?\\")===0||w.indexOf("\\??\\")===0?w.substr(4):w.indexOf('"\\\\?\\')===0||w.indexOf('"\\??\\')===0?'"'+w.substr(5):w;new Promise((w,g)=>{z(["windows-process-tree"],w,g)}).then(w=>{w.getProcessList(D,g=>{if(!g){p(new Error(`Root process ${D} not found`));return}w.getProcessCpuUsage(g,f=>{const d=new Map;f.forEach(S=>{const m=u(S.commandLine||"");d.set(S.pid,{name:I(m),cmd:m,pid:S.pid,ppid:S.ppid,load:S.cpu||0,mem:S.memory||0})}),v=d.get(D),v?(d.forEach(S=>{const m=d.get(S.ppid);m&&(m.children||(m.children=[]),m.children.push(S))}),d.forEach(S=>{S.children&&(S.children=S.children.sort((m,h)=>m.pid-h.pid))}),P(v)):p(new Error(`Root process ${D} not found`))})},w.ProcessDataFlag.CommandLine|w.ProcessDataFlag.Memory)})}else{let u=function(){let w=[v];const g=[];for(;w.length;){const d=w.shift();d&&(g.push(d.pid),d.children&&(w=w.concat(d.children)))}let f=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",z).fsPath);f+=" "+g.join(" "),(0,E.exec)(f,{},(d,S,m)=>{if(d||m)p(d||new Error(m.toString()));else{const h=S.toString().split(`
`);for(let l=0;l<g.length;l++){const n=b.get(g[l]);n.load=parseFloat(h[l])}if(!v){p(new Error(`Root process ${D} not found`));return}P(v)}})};(0,E.exec)("which ps",{},(w,g,f)=>{if(w||f)if(process.platform!=="linux")p(w||new Error(f.toString()));else{const d=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",z).fsPath);(0,E.exec)(d,{},(S,m,h)=>{S||h?p(S||new Error(h.toString())):(R(m,C),u())})}else{const d=g.toString().trim(),S="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${d} ${S}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,h,l)=>{m||l&&!l.includes("screen size is bogus")?p(m||new Error(l.toString())):(R(h,C),process.platform==="linux"?u():v?P(v):p(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=k;function R(D,P){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,v=D.toString().split(`
`);for(const b of v){const C=p.exec(b.trim());C&&C.length===6&&P(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(ee[142],te([0,1,27,4,141,82]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(u,w){return u===1?t.isWindows?C():R.getWindowsShell(w):v(u,w)}e.getSystemShell=D;function P(u,w){return u===1?t.isWindows?I(w):R.getWindowsShell(w):v(u,w)}e.getSystemShellSync=P;let p=null;function v(u,w){if(t.isLinux&&u===2||t.isMacintosh&&u===3)return"/bin/bash";if(!p){let g;if(t.isWindows)g="/bin/bash";else{if(g=w.SHELL,!g)try{g=(0,E.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}p=g}return p}let b=null;async function C(){return b||(b=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),b}function I(u){if(b)return b;const w=t.isWindows&&parseFloat((0,E.release)())>=10,g=u.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${u.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return w?f:R.getWindowsShell(u)}});var ve=this&&this.__decorate||function(z,e,E,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,E):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(z,e,E,t);else for(var P=z.length-1;P>=0;P--)(D=z[P])&&(R=(k<3?D(R):k>3?D(e,E,R):D(e,E))||R);return k>3&&R&&Object.defineProperty(e,E,R),R};define(ee[45],te([0,1,24,8,17,22,53,16,3,2,68,25,12]),function(z,e,E,t,k,R,D,P,p,v,b,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var u;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(u||(u={}));function w(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(g||(g={}));function f(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(d||(d={}));class S{constructor(A){this.buffer=A,this.pos=0}read(A){const O=this.buffer.slice(this.pos,this.pos+A);return this.pos+=O.byteLength,O}}class m{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var h;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(h||(h={}));function l(F){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(F,0),A}function n(F){return F.read(4).readUInt32BE(0)}function r(F){const A=k.VSBuffer.alloc(1);return A.writeUInt8(F,0),A}const i={Undefined:r(h.Undefined),String:r(h.String),Buffer:r(h.Buffer),VSBuffer:r(h.VSBuffer),Array:r(h.Array),Object:r(h.Object)},o=typeof Buffer<"u";function s(F,A){if(typeof A>"u")F.write(i.Undefined);else if(typeof A=="string"){const O=k.VSBuffer.fromString(A);F.write(i.String),F.write(l(O.byteLength)),F.write(O)}else if(o&&Buffer.isBuffer(A)){const O=k.VSBuffer.wrap(A);F.write(i.Buffer),F.write(l(O.byteLength)),F.write(O)}else if(A instanceof k.VSBuffer)F.write(i.VSBuffer),F.write(l(A.byteLength)),F.write(A);else if(Array.isArray(A)){F.write(i.Array),F.write(l(A.length));for(const O of A)s(F,O)}else{const O=k.VSBuffer.fromString(JSON.stringify(A));F.write(i.Object),F.write(l(O.byteLength)),F.write(O)}}function c(F){switch(F.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return F.read(n(F)).toString();case h.Buffer:return F.read(n(F)).buffer;case h.VSBuffer:return F.read(n(F));case h.Array:{const O=n(F),_=[];for(let ne=0;ne<O;ne++)_.push(c(F));return _}case h.Object:return JSON.parse(F.read(n(F)).toString())}}class a{constructor(A,O,_=null,ne=1e3){this.protocol=A,this.ctx=O,this.logger=_,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(N=>this.onRawMessage(N)),this.sendResponse({type:200})}registerChannel(A,O){this.channels.set(A,O),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const O=this.send([A.type]);this.logger?.logOutgoing(O,0,1,f(A.type));return}case 201:case 202:case 204:case 203:{const O=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(O,A.id,1,f(A.type),A.data);return}}}send(A,O=void 0){const _=new m;return s(_,A),s(_,O),this.sendBuffer(_.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const O=new S(A),_=c(O),ne=c(O),N=_[0];switch(N){case 100:return this.logger?.logIncoming(A.byteLength,_[1],1,`${w(N)}: ${_[2]}.${_[3]}`,ne),this.onPromise({type:N,id:_[1],channelName:_[2],name:_[3],arg:ne});case 102:return this.logger?.logIncoming(A.byteLength,_[1],1,`${w(N)}: ${_[2]}.${_[3]}`,ne),this.onEventListen({type:N,id:_[1],channelName:_[2],name:_[3],arg:ne});case 101:return this.logger?.logIncoming(A.byteLength,_[1],1,`${w(N)}`),this.disposeActiveRequest({type:N,id:_[1]});case 103:return this.logger?.logIncoming(A.byteLength,_[1],1,`${w(N)}`),this.disposeActiveRequest({type:N,id:_[1]})}}onPromise(A){const O=this.channels.get(A.channelName);if(!O){this.collectPendingRequest(A);return}const _=new R.CancellationTokenSource;let ne;try{ne=O.call(this.ctx,A.name,A.arg,_.token)}catch(L){ne=Promise.reject(L)}const N=A.id;ne.then(L=>{this.sendResponse({id:N,data:L,type:201}),this.activeRequests.delete(A.id)},L=>{L instanceof Error?this.sendResponse({id:N,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:N,data:L,type:203}),this.activeRequests.delete(A.id)});const $=(0,v.toDisposable)(()=>_.cancel());this.activeRequests.set(A.id,$)}onEventListen(A){const O=this.channels.get(A.channelName);if(!O){this.collectPendingRequest(A);return}const _=A.id,N=O.listen(this.ctx,A.name,A.arg)($=>this.sendResponse({id:_,data:$,type:204}));this.activeRequests.set(A.id,N)}disposeActiveRequest(A){const O=this.activeRequests.get(A.id);O&&(O.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let O=this.pendingRequests.get(A.channelName);O||(O=[],this.pendingRequests.set(A.channelName,O));const _=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:A,timeoutTimer:_})}flushPendingRequests(A){const O=this.pendingRequests.get(A);if(O){for(const _ of O)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.onPromise(_.request);break;case 102:this.onEventListen(_.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,v.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var y;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(A,O=null){this.protocol=A,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(_=>this.onBuffer(_)),this.logger=O}getChannel(A){const O=this;return{call(_,ne,N){return O.isDisposed?Promise.reject(new P.CancellationError):O.requestPromise(A,_,ne,N)},listen(_,ne){return O.isDisposed?p.Event.None:O.requestEvent(A,_,ne)}}}requestPromise(A,O,_,ne=R.CancellationToken.None){const N=this.lastRequestId++,L={id:N,type:100,channelName:A,name:O,arg:_};if(ne.isCancellationRequested)return Promise.reject(new P.CancellationError);let W;return new Promise((q,X)=>{if(ne.isCancellationRequested)return X(new P.CancellationError);const re=()=>{const ce=ge=>{switch(ge.type){case 201:this.handlers.delete(N),q(ge.data);break;case 202:{this.handlers.delete(N);const De=new Error(ge.data.message);De.stack=Array.isArray(ge.data.stack)?ge.data.stack.join(`
`):ge.data.stack,De.name=ge.data.name,X(De);break}case 203:this.handlers.delete(N),X(ge.data);break}};this.handlers.set(N,ce),this.sendRequest(L)};let B=null;this.state===d.Idle?re():(B=(0,t.createCancelablePromise)(ce=>this.whenInitialized()),B.then(()=>{B=null,re()}));const J=()=>{B?(B.cancel(),B=null):this.sendRequest({id:N,type:101}),X(new P.CancellationError)},Z=ne.onCancellationRequested(J);W=(0,v.combinedDisposable)((0,v.toDisposable)(J),Z),this.activeRequests.add(W)}).finally(()=>{this.activeRequests.delete(W)})}requestEvent(A,O,_){const ne=this.lastRequestId++,$={id:ne,type:102,channelName:A,name:O,arg:_};let L=null;const W=new p.Emitter({onWillAddFirstListener:()=>{L=(0,t.createCancelablePromise)(q=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(W),this.sendRequest($)})},onDidRemoveLastListener:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(W),this.sendRequest({id:ne,type:103}))}}),j=q=>W.fire(q.data);return this.handlers.set(ne,j),W.event}sendRequest(A){switch(A.type){case 100:case 102:{const O=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(O,A.id,0,`${w(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const O=this.send([A.type,A.id]);this.logger?.logOutgoing(O,A.id,0,w(A.type));return}}}send(A,O=void 0){const _=new m;return s(_,A),s(_,O),this.sendBuffer(_.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const O=new S(A),_=c(O),ne=c(O),N=_[0];switch(N){case 200:return this.logger?.logIncoming(A.byteLength,0,0,f(N)),this.onResponse({type:_[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,_[1],0,f(N),ne),this.onResponse({type:_[0],id:_[1],data:ne})}}onResponse(A){if(A.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,v.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ve([D.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class T{get connections(){const A=[];return this._connections.forEach(O=>A.push(O)),A}constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:O,onDidClientDisconnect:_})=>{p.Event.once(O.onMessage)(N=>{const $=new S(N),L=c($),W=new a(O,L),j=new M(O);this.channels.forEach((X,re)=>W.registerChannel(re,X));const q={channelServer:W,channelClient:j,ctx:L};this._connections.add(q),this._onDidAddConnection.fire(q),_(()=>{W.dispose(),j.dispose(),this._connections.delete(q),this._onDidRemoveConnection.fire(q)})})})}getChannel(A,O){const _=this;return{call(ne,N,$){let L;if((0,I.isFunction)(O)){const j=(0,E.getRandomElement)(_.connections.filter(O));L=j?Promise.resolve(j):p.Event.toPromise(p.Event.filter(_.onDidAddConnection,O))}else L=O.routeCall(_,ne,N);const W=L.then(j=>j.channelClient.getChannel(A));return Y(W).call(ne,N,$)},listen(ne,N){if((0,I.isFunction)(O))return _.getMulticastEvent(A,O,ne,N);const $=O.routeEvent(_,ne,N).then(L=>L.channelClient.getChannel(A));return Y($).listen(ne,N)}}}getMulticastEvent(A,O,_,ne){const N=this;let $=new v.DisposableStore;const L=new p.Emitter({onWillAddFirstListener:()=>{$=new v.DisposableStore;const W=new p.EventMultiplexer,j=new Map,q=re=>{const J=re.channelClient.getChannel(A).listen(_,ne),Z=W.add(J);j.set(re,Z)},X=re=>{const B=j.get(re);!B||(B.dispose(),j.delete(re))};N.connections.filter(O).forEach(q),p.Event.filter(N.onDidAddConnection,O)(q,void 0,$),N.onDidRemoveConnection(X,void 0,$),W.event(L.fire,L,$),$.add(W)},onDidRemoveLastListener:()=>{$.dispose()}});return L.event}registerChannel(A,O){this.channels.set(A,O),this._connections.forEach(_=>{_.channelServer.registerChannel(A,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class U{constructor(A,O,_=null){const ne=new m;s(ne,O),A.send(ne.buffer),this.channelClient=new M(A,_),this.channelServer=new a(A,O,_)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,O){this.channelServer.registerChannel(A,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function Y(F){return{call(A,O,_){return F.then(ne=>ne.call(A,O,_))},listen(A,O){const _=new p.Relay;return F.then(ne=>_.input=ne.listen(A,O)),_.event}}}e.getDelayedChannel=Y;function G(F){let A=!1;return{call(O,_,ne){return A?F.call(O,_,ne):(0,t.timeout)(0).then(()=>A=!0).then(()=>F.call(O,_,ne))},listen(O,_){if(A)return F.listen(O,_);const ne=new p.Relay;return(0,t.timeout)(0).then(()=>A=!0).then(()=>ne.input=F.listen(O,_)),ne.event}}}e.getNextTickChannel=G;class V{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const O of A.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await p.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=V;var oe;(function(F){function A(N,$){const L=N,W=$&&$.disableMarshalling,j=new Map;for(const q in L)_(q)&&j.set(q,p.Event.buffer(L[q],!0));return new class{listen(q,X,re){const B=j.get(X);if(B)return B;if(ne(X)){const J=L[X];if(typeof J=="function")return J.call(L,re)}throw new Error(`Event not found: ${X}`)}call(q,X,re){const B=L[X];if(typeof B=="function"){if(!W&&Array.isArray(re))for(let J=0;J<re.length;J++)re[J]=(0,b.revive)(re[J]);return B.apply(L,re)}throw new Error(`Method not found: ${X}`)}}}F.fromService=A;function O(N,$){const L=$&&$.disableMarshalling;return new Proxy({},{get(W,j){if(typeof j=="string")return $?.properties?.has(j)?$.properties.get(j):ne(j)?function(q){return N.listen(j,q)}:_(j)?N.listen(j):async function(...q){let X;$&&!(0,I.isUndefinedOrNull)($.context)?X=[$.context,...q]:X=q;const re=await N.call(j,X);return L?re:(0,b.revive)(re)};throw new Error(`Property not found: ${String(j)}`)}})}F.toService=O;function _(N){return N[0]==="o"&&N[1]==="n"&&C.isUpperAsciiLetter(N.charCodeAt(2))}function ne(N){return/^onDynamic/.test(N)&&C.isUpperAsciiLetter(N.charCodeAt(9))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const A=F.toString();if(A!=="[object Object]")return A}return F}function fe(F){return Array.isArray(F)?F.map(se):se(F)}function K(F,A,O,_,ne,N,$){$=fe($);const L=ae[ne],W=L[_%L.length];let j=[`%c[${F}]%c[${String(A).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${N}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(N)?(j=j.concat($),j.push(")")):j.push($),console.log.apply(console,j)}class H{constructor(A,O){this._outgoingPrefix=A,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,O,_,ne,N){this._totalOutgoing+=A,K(this._outgoingPrefix,this._totalOutgoing,A,O,_,ne,N)}logIncoming(A,O,_,ne,N){this._totalIncoming+=A,K(this._incomingPrefix,this._totalIncoming,A,O,_,ne,N)}}e.IPCLogger=H}),define(ee[143],te([0,1,17,3,45]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(p){this.port=p,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",v=>E.VSBuffer.wrap(v.data)),p.start()}send(p){this.port.postMessage(p.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends k.IPCClient{constructor(p,v){const b=new R(p);super(b,v),this.protocol=b}dispose(){this.protocol.disconnect()}}e.Client=D}),define(ee[101],te([0,1,17,3,2,45]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(o){o.enableDiagnostics=!1,o.records=[];const s=new WeakMap;let c=0;function a(M,T){if(!s.has(M)){const U=String(++c);s.set(M,U)}return s.get(M)}function y(M,T,U,Y){if(!o.enableDiagnostics)return;const G=a(M,T);if(Y instanceof E.VSBuffer||Y instanceof Uint8Array||Y instanceof ArrayBuffer||ArrayBuffer.isView(Y)){const V=E.VSBuffer.alloc(Y.byteLength);V.set(Y),o.records.push({timestamp:Date.now(),id:G,label:T,type:U,buff:V})}else o.records.push({timestamp:Date.now(),id:G,label:T,type:U,data:Y})}o.traceSocketEvent=y})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var p;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p=e.SocketCloseEventType||(e.SocketCloseEventType={}));let v=null;function b(){return v||(v=E.VSBuffer.alloc(0)),v}class C{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,c){if(s===0)return b();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const T=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=s),T}if(this._chunks[0].byteLength>s){const T=this._chunks[0].slice(0,s);return c&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),T}const a=E.VSBuffer.alloc(s);let y=0,M=0;for(;s>0;){const T=this._chunks[M];if(T.byteLength>s){const U=T.slice(0,s);a.set(U,y),y+=s,c&&(this._chunks[M]=T.slice(s),this._totalLength-=s),s-=s}else a.set(T,y),y+=T.byteLength,c?(this._chunks.shift(),this._totalLength-=T.byteLength):M++,s-=T.byteLength}return a}}e.ChunkStream=C;var I;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume",o[o.KeepAlive=9]="KeepAlive"})(I||(I={}));function u(o){switch(o){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var w;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(s,c,a,y){this.type=s,this.id=c,this.ack=a,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends k.Disposable{constructor(s){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:u(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,y=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new g(a,y,M,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=E.VSBuffer.alloc(13);c.writeUInt8(s.type,0),c.writeUInt32BE(s.id,1),c.writeUInt32BE(s.ack,5),c.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:u(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(c,s.data)}_bufferAdd(s,c){const a=this._totalLength===0;return this._data.push(s,c),this._totalLength+=s.byteLength+c.byteLength,a}_bufferTake(){const s=E.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,c){this._bufferAdd(s,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class S extends k.Disposable{constructor(s){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new g(1,0,0,s))}}e.Protocol=S;class m extends R.IPCClient{static fromSocket(s,c){return new m(new S(s),c)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,c,a=null){super(s,c,a),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=m;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class l{constructor(s){this.data=s,this.next=null}}class n{constructor(){this._first=null,this._last=null}length(){let s=0,c=this._first;for(;c;)c=c.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let c=0,a=this._first;for(;a;)s[c++]=a.data,a=a.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const c=new l(s);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class r{static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let c=0;c<r._HISTORY_LENGTH;c++)this.lastRuns[c]=s-1e3*c;setInterval(()=>{for(let c=r._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),c=(1+r._HISTORY_LENGTH)*1e3;let a=0;for(let y=0;y<r._HISTORY_LENGTH;y++)s-this.lastRuns[y]<=c&&a++;return 1-a/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class i{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s,c=null,a=r.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(y=>this._receiveMessage(y))),this._socketDisposables.push(this._socket.onClose(y=>this._onSocketClose.fire(y))),c&&this._socketReader.acceptChunk(c),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new g(5,0,0,b());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new g(7,0,0,b());this._socketWriter.write(s)}sendResume(){const s=new g(8,0,0,b());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,c){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new g(3,0,this._incomingAckId,b());this._socketWriter.write(s);const c=this._outgoingUnackMsg.toArray();for(let a=0,y=c.length;a<y;a++)this._socketWriter.write(c[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new g(6,0,0,b())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let a=0,y=c.length;a<y;a++)this._socketWriter.write(c[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new g(1,c,this._incomingAckId,s);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(s){const c=new g(2,0,0,s);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),c=Date.now()-s.writtenTime,a=Date.now()-this._socketReader.lastReadTime,y=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&a>=2e4&&y>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:a});return}const M=Math.max(2e4-c,2e4-a,2e4-y,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new g(3,0,this._incomingAckId,b());this._socketWriter.write(s)}_sendKeepAlive(){const s=new g(9,0,0,b());this._socketWriter.write(s)}}e.PersistentProtocol=i}),define(ee[144],te([0,1,40,17,3,2,45,129]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function p(b,C){const I=k.Event.fromNodeEventEmitter(E.validatedIpcMain,C,(w,g)=>({event:w,message:g})),u=k.Event.filter(I,({event:w})=>w.sender.id===b);return k.Event.map(u,({message:w})=>w&&t.VSBuffer.wrap(w))}class v extends D.IPCServer{static getOnDidClientConnect(){const C=k.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:I})=>I);return k.Event.map(C,I=>{const u=I.id;v.Clients.get(u)?.dispose();const g=new k.Emitter;v.Clients.set(u,(0,R.toDisposable)(()=>g.fire()));const f=p(u,"vscode:message"),d=k.Event.any(k.Event.signal(p(u,"vscode:disconnect")),g.event);return{protocol:new P.Protocol(I,f),onDidClientDisconnect:d}})}constructor(){super(v.getOnDidClientConnect())}}e.Server=v,v.Clients=new Map}),define(ee[102],te([0,1,40,3,29,143]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends R.Client{constructor(v,b){super({addEventListener:(C,I)=>v.addListener(C,I),removeEventListener:(C,I)=>v.removeListener(C,I),postMessage:C=>v.postMessage(C),start:()=>v.start(),close:()=>v.close()},b)}}e.Client=D;async function P(p){if(p.isDestroyed()||p.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const v=(0,k.generateUuid)();p.webContents.send("vscode:createMessageChannel",v);const b=t.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(I,u)=>({nonce:u,port:I.ports[0]})),{port:C}=await t.Event.toPromise(t.Event.once(t.Event.filter(b,I=>I.nonce===v)));return C}e.connect=P}),define(ee[145],te([0,1,44,8,17,22,138,16,3,2,50,82,79,45]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class w extends u.ChannelServer{constructor(d){super({send:S=>{try{process.send?.(S.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",S=>k.VSBuffer.wrap(Buffer.from(S,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.Server=w;class g{constructor(d,S){this.modulePath=d,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new p.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new t.Delayer(m),this.child=null,this._client=null}getChannel(d){const S=this;return{call(m,h,l){return S.requestPromise(d,m,h,l)},listen(m,h){return S.requestEvent(d,m,h)}}}requestPromise(d,S,m,h=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(d),n=(0,t.createCancelablePromise)(o=>l.call(S,m,o)),r=h.onCancellationRequested(()=>n.cancel()),i=(0,v.toDisposable)(()=>n.cancel());return this.activeRequests.add(i),n.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(d,S,m){if(!this.disposeDelayer)return p.Event.None;this.disposeDelayer.cancel();let h;const l=new p.Emitter({onWillAddFirstListener:()=>{h=this.getCachedChannel(d).listen(S,m)(l.fire,l),this.activeRequests.add(h)},onDidRemoveLastListener:()=>{this.activeRequests.delete(h),h.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(S.env={...S.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,I.removeDangerousEnvVariables)(S.env),this.child=(0,E.fork)(this.modulePath,d,S);const m=new p.Emitter;p.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,D.isRemoteConsoleLog)(s)){(0,D.log)(s,`IPC Library: ${this.options.serverName}`);return}m.fire(k.VSBuffer.wrap(Buffer.from(s,"base64")))});const l=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,n=s=>this.child&&this.child.connected&&l.send(s.buffer.toString("base64")),r=m.event,i={send:n,onMessage:r};this._client=new u.ChannelClient(i);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,c)=>{process.removeListener("exit",o),this.activeRequests.forEach(a=>(0,v.dispose)(a)),this.activeRequests.clear(),s!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:c})})}return this._client}getCachedChannel(d){let S=this.channels.get(d);return S||(S=this.client.getChannel(d),this.channels.set(d,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(ee[83],te([0,1,17,16,3,2,9,4,29,45,101]),function(z,e,E,t,k,R,D,P,p,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function C(){return{crypto:z.__$__nodeRequire("crypto"),zlib:z.__$__nodeRequire("zlib"),net:z.__$__nodeRequire("net"),os:z.__$__nodeRequire("os")}}class I{traceSocketEvent(a,y){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,y)}constructor(a,y=""){this._canWrite=!0,this.debugLabel=y,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,t.onUnexpectedError)(M)}},this.socket.on("error",this._errorListener),this._closeListener=M=>{this.traceSocketEvent("close",{hadError:M}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(a){const y=M=>{this.traceSocketEvent("read",M),a(E.VSBuffer.wrap(M))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(a){const y=M=>{a({type:0,hadError:M,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(a){const y=()=>{a()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(a){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,t.onUnexpectedError)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,t.onUnexpectedError)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.NodeSocket=I;var u;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(u||(u={}));var w;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(w||(w={}));class g extends R.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(a,y){this.socket.traceSocketEvent(a,y)}constructor(a,y,M,T){super(),this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:M?.byteLength||0,recordInflateBytes:T}),this._flowManager=this._register(new f(this,y,M,T,this._onData,(U,Y)=>this._write(U,Y))),this._register(this._flowManager.onError(U=>{console.error(U),(0,t.onUnexpectedError)(U),this._onClose.fire({type:0,hadError:!0,error:U})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(U=>this._acceptChunk(U))),this._register(this.socket.onClose(U=>this._onClose.fire(U)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this._onData.event(a)}onClose(a){return this._onClose.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this._flowManager.writeMessage(a)}_write(a,y){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let M=2;a.byteLength<126?M+=0:a.byteLength<2**16?M+=2:M+=8;const T=E.VSBuffer.alloc(M);if(y?T.writeUInt8(194,0):T.writeUInt8(130,0),a.byteLength<126)T.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){T.writeUInt8(126,1);let U=1;T.writeUInt8(a.byteLength>>>8&255,++U),T.writeUInt8(a.byteLength>>>0&255,++U)}else{T.writeUInt8(127,1);let U=1;T.writeUInt8(0,++U),T.writeUInt8(0,++U),T.writeUInt8(0,++U),T.writeUInt8(0,++U),T.writeUInt8(a.byteLength>>>24&255,++U),T.writeUInt8(a.byteLength>>>16&255,++U),T.writeUInt8(a.byteLength>>>8&255,++U),T.writeUInt8(a.byteLength>>>0&255,++U)}this.socket.write(E.VSBuffer.concat([T,a]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(a){if(a.byteLength!==0){for(this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const y=this._incomingData.peek(this._state.readLen),M=y.readUInt8(0),T=(M&128)>>>7,U=(M&64)>>>6,Y=y.readUInt8(1),G=(Y&128)>>>7,V=Y&127;this._state.state=2,this._state.readLen=2+(G?4:0)+(V===126?2:0)+(V===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(U)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const y=this._incomingData.read(this._state.readLen),M=y.readUInt8(1),T=(M&128)>>>7;let U=M&127,Y=1;U===126?U=y.readUInt8(++Y)*2**8+y.readUInt8(++Y):U===127&&(U=y.readUInt8(++Y)*0+y.readUInt8(++Y)*0+y.readUInt8(++Y)*0+y.readUInt8(++Y)*0+y.readUInt8(++Y)*2**24+y.readUInt8(++Y)*2**16+y.readUInt8(++Y)*2**8+y.readUInt8(++Y));let G=0;T&&(G=y.readUInt8(++Y)*2**24+y.readUInt8(++Y)*2**16+y.readUInt8(++Y)*2**8+y.readUInt8(++Y)),this._state.state=3,this._state.readLen=U,this._state.mask=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const y=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),m(y,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(y,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=g;class f extends R.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:E.VSBuffer.alloc(0)}constructor(a,y,M,T,U,Y){super(),this._tracer=a,this._onData=U,this._writeFn=Y,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,y?(this._zlibInflateStream=this._register(new d(this._tracer,T,M,{windowBits:15})),this._zlibDeflateStream=this._register(new S(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(G=>this._onError.fire(G))),this._register(this._zlibDeflateStream.onError(G=>this._onError.fire(G)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(a){this._writeQueue.push(a),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const a=this._writeQueue.shift();if(this._zlibDeflateStream){const y=await this._deflateMessage(this._zlibDeflateStream,a);this._writeFn(y,!0)}else this._writeFn(a,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(a,y){return new Promise((M,T)=>{a.write(y),a.flush(U=>M(U))})}acceptFrame(a,y,M){this._readQueue.push({data:a,isCompressed:y,isLastFrameOfMessage:M}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const a=this._readQueue.shift();if(this._zlibInflateStream&&a.isCompressed){const y=await this._inflateFrame(this._zlibInflateStream,a.data,a.isLastFrameOfMessage);this._onData.fire(y)}else this._onData.fire(a.data)}this._isProcessingReadQueue=!1}}_inflateFrame(a,y,M){return new Promise((T,U)=>{a.write(y),M&&a.write(E.VSBuffer.fromByteArray([0,0,255,255])),a.flush(Y=>T(Y))})}}class d extends R.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?E.VSBuffer.concat(this._recordedInflateBytes):E.VSBuffer.alloc(0)}constructor(a,y,M,T){super(),this._tracer=a,this._recordInflateBytes=y,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=C().zlib.createInflateRaw(T),this._zlibInflate.on("error",U=>{this._tracer.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibInflate.on("data",U=>{this._tracer.traceSocketEvent("zlibInflateData",U),this._pendingInflateData.push(E.VSBuffer.wrap(U))}),M&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this._zlibInflate.write(M.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(a){this._recordInflateBytes&&this._recordedInflateBytes.push(a.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",a),this._zlibInflate.write(a.buffer)}flush(a){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const y=E.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,a(y)})}}class S extends R.Disposable{constructor(a,y){super(),this._tracer=a,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=C().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",M=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibDeflate.on("data",M=>{this._tracer.traceSocketEvent("zlibDeflateData",M),this._pendingDeflateData.push(E.VSBuffer.wrap(M))})}write(a){this._tracer.traceSocketEvent("zlibDeflateWrite",a.buffer),this._zlibDeflate.write(a.buffer)}flush(a){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let y=E.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,y=y.slice(0,y.byteLength-4),a(y)})}}function m(c,a){if(a===0)return;const y=c.byteLength>>>2;for(let V=0;V<y;V++){const oe=c.readUInt32BE(V*4);c.writeUInt32BE(oe^a,V*4)}const M=y*4,T=c.byteLength-M,U=a>>>24&255,Y=a>>>16&255,G=a>>>8&255;T>=1&&c.writeUInt8(c.readUInt8(M)^U,M),T>=2&&c.writeUInt8(c.readUInt8(M+1)^Y,M+1),T>=3&&c.writeUInt8(c.readUInt8(M+2)^G,M+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const h={[2]:107,[1]:103};function l(){const c=(0,p.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):a=(0,D.join)(C().os.tmpdir(),`vscode-ipc-${c}.sock`),r(a),a}e.createRandomIPCHandle=l;function n(c,a,y){const M=C().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${y}-${a}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${M.substr(0,8)}-${y}-${a}.sock`):T=(0,D.join)(c,`${y}-${a}.sock`),r(T),T}e.createStaticIPCHandle=n;function r(c){const a=h[P.platform];typeof a=="number"&&c.length>=a&&console.warn(`WARNING: IPC handle "${c}" is longer than ${a} chars, try a shorter --user-data-dir`)}class i extends v.IPCServer{static toClientConnectionEvent(a){const y=k.Event.fromNodeEventEmitter(a,"connection");return k.Event.map(y,M=>({protocol:new b.Protocol(new I(M,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(M,"close"))}))}constructor(a){super(i.toClientConnectionEvent(a)),this.server=a}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function o(c){return new Promise((a,y)=>{const M=C().net.createServer();M.on("error",y),M.listen(c,()=>{M.removeListener("error",y),a(new i(M))})})}e.serve=o;function s(c,a){return new Promise((y,M)=>{const T=C().net.createConnection(c,()=>{T.removeListener("error",M),y(b.Client.fromSocket(new I(T,`ipc-client${a}`),a))});T.once("error",M)})}e.connect=s}),define(ee[103],te([0,1,8,3,2,12]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function P(C){const I=C;return I?.changed instanceof Map||I?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var p;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(p=e.StorageState||(e.StorageState={}));class v extends k.Disposable{constructor(I,u=Object.create(null)){super(),this.database=I,this.options=u,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=p.None,this.cache=new Map,this.flushDelayer=new E.ThrottledDelayer(v.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(I=>this.onDidChangeItemsExternal(I)))}onDidChangeItemsExternal(I){I.changed?.forEach((u,w)=>this.accept(w,u)),I.deleted?.forEach(u=>this.accept(u,void 0))}accept(I,u){if(this.state===p.Closed)return;let w=!1;(0,R.isUndefinedOrNull)(u)?w=this.cache.delete(I):this.cache.get(I)!==u&&(this.cache.set(I,u),w=!0),w&&this._onDidChangeStorage.fire(I)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===p.None&&(this.state=p.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(I,u){const w=this.cache.get(I);return(0,R.isUndefinedOrNull)(w)?u:w}getBoolean(I,u){const w=this.get(I);return(0,R.isUndefinedOrNull)(w)?u:w==="true"}getNumber(I,u){const w=this.get(I);return(0,R.isUndefinedOrNull)(w)?u:parseInt(w,10)}async set(I,u){if(this.state===p.Closed)return;if((0,R.isUndefinedOrNull)(u))return this.delete(I);const w=String(u);if(this.cache.get(I)!==w)return this.cache.set(I,w),this.pendingInserts.set(I,w),this.pendingDeletes.delete(I),this._onDidChangeStorage.fire(I),this.doFlush()}async delete(I){if(!(this.state===p.Closed||!this.cache.delete(I)))return this.pendingDeletes.has(I)||this.pendingDeletes.add(I),this.pendingInserts.delete(I),this._onDidChangeStorage.fire(I),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=p.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const I={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(I).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(I){if(!!this.hasPending)return this.doFlush(I)}async doFlush(I){return this.flushDelayer.trigger(()=>this.flushPending(),I)}async whenFlushed(){if(!!this.hasPending)return new Promise(I=>this.whenFlushedCallbacks.push(I))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=v,v.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(I){I.insert?.forEach((u,w)=>this.items.set(w,u)),I.delete?.forEach(u=>this.items.delete(u))}async close(){}}e.InMemoryStorageDatabase=b}),define(ee[146],te([0,1,8,3,38,9,23]),function(z,e,E,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{get onDidChangeItemsExternal(){return t.Event.None}constructor(b,C=Object.create(null)){this.path=b,this.options=C,this.name=(0,R.basename)(this.path),this.logger=new p(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const b=await this.whenConnected,C=new Map;return(await this.all(b,"SELECT * FROM ItemTable")).forEach(u=>C.set(u.key,u.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${C.size} rows`),C}async updateItems(b){const C=await this.whenConnected;return this.doUpdateItems(C,b)}doUpdateItems(b,C){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${C.insert?(0,k.mapToString)(C.insert):"0"}), delete(${C.delete?(0,k.setToString)(C.delete):"0"})`),this.transaction(b,()=>{const I=C.insert,u=C.delete;if(I&&I.size>0){const w=[];w.push([]);let g=0;I.forEach((f,d)=>{let S=w[g];S.length>P.MAX_HOST_PARAMETERS&&(g++,S=[],w.push(S)),S.push(d,f)}),w.forEach(f=>{this.prepare(b,`INSERT INTO ItemTable VALUES ${new Array(f.length/2).fill("(?,?)").join(",")}`,d=>d.run(f),()=>{const d=[];let S=0;return I.forEach((m,h)=>{d.push(h),S+=m.length}),`Keys: ${d.join(", ")} Length: ${S}`})})}if(u&&u.size){const w=[];w.push([]);let g=0;u.forEach(f=>{let d=w[g];d.length>P.MAX_HOST_PARAMETERS&&(g++,d=[],w.push(d)),d.push(f)}),w.forEach(f=>{this.prepare(b,`DELETE FROM ItemTable WHERE key IN (${new Array(f.length).fill("?").join(",")})`,d=>d.run(f),()=>{const d=[];return u.forEach(S=>{d.push(S)}),`Keys: ${d.join(", ")}`})})}})}async close(b){this.logger.trace(`[storage ${this.name}] close()`);const C=await this.whenConnected;return this.doClose(C,b)}doClose(b,C){return new Promise((I,u)=>{b.db.close(w=>(w&&this.handleSQLiteError(b,`[storage ${this.name}] close(): ${w}`),this.path===P.IN_MEMORY_PATH?I():!b.isErroneous&&!b.isInMemory?this.backup().then(I,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),I())):typeof C=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const f=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:C()}).then(()=>f(),d=>(f(),Promise.reject(d)))})).then(I,u):u(w||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const b=this.toBackupPath(this.path);return D.Promises.copy(this.path,b,{preserveSymlinks:!1})}toBackupPath(b){return`${b}.backup`}async checkIntegrity(b){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${b})`);const C=await this.whenConnected,I=await this.get(C,b?"PRAGMA integrity_check":"PRAGMA quick_check"),u=b?I.integrity_check:I.quick_check;return C.isErroneous?`${u} (last error: ${C.lastError})`:C.isInMemory?`${u} (in-memory!)`:u}async connect(b,C=!0){this.logger.trace(`[storage ${this.name}] open(${b}, retryOnBusy: ${C})`);try{return await this.doConnect(b)}catch(I){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${I}`),I.code==="SQLITE_BUSY"&&C)return await(0,E.timeout)(P.BUSY_OPEN_TIMEOUT),this.connect(b,!1);try{await D.Promises.unlink(b);try{await D.Promises.rename(this.toBackupPath(b),b)}catch{}return await this.doConnect(b)}catch(u){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${u}`),this.doConnect(P.IN_MEMORY_PATH)}}}handleSQLiteError(b,C){b.isErroneous=!0,b.lastError=C,this.logger.error(C)}doConnect(b){return new Promise((C,I)=>{new Promise((u,w)=>{z(["@vscode/sqlite3"],u,w)}).then(u=>{const w={db:new(this.logger.isTracing?u.verbose().Database:u.Database)(b,g=>g?w.db&&g.code!=="SQLITE_CANTOPEN"?w.db.close(()=>I(g)):I(g):this.exec(w,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>C(w),f=>w.db.close(()=>I(f)))),isInMemory:b===P.IN_MEMORY_PATH};w.db.on("error",g=>this.handleSQLiteError(w,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&w.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},I)})}exec(b,C){return new Promise((I,u)=>{b.db.exec(C,w=>w?(this.handleSQLiteError(b,`[storage ${this.name}] exec(): ${w}`),u(w)):I())})}get(b,C){return new Promise((I,u)=>{b.db.get(C,(w,g)=>w?(this.handleSQLiteError(b,`[storage ${this.name}] get(): ${w}`),u(w)):I(g))})}all(b,C){return new Promise((I,u)=>{b.db.all(C,(w,g)=>w?(this.handleSQLiteError(b,`[storage ${this.name}] all(): ${w}`),u(w)):I(g))})}transaction(b,C){return new Promise((I,u)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),C(),b.db.run("END TRANSACTION",w=>w?(this.handleSQLiteError(b,`[storage ${this.name}] transaction(): ${w}`),u(w)):I())})})}prepare(b,C,I,u){const w=b.db.prepare(C),g=f=>{this.handleSQLiteError(b,`[storage ${this.name}] prepare(): ${f} (${C}). Details: ${u()}`)};w.on("error",g),I(w),w.finalize(f=>{f&&g(f),w.removeListener("error",g)})}}e.SQLiteStorageDatabase=P,P.IN_MEMORY_PATH=":memory:",P.BUSY_OPEN_TIMEOUT=2e3,P.MAX_HOST_PARAMETERS=256;class p{constructor(b){b&&typeof b.logTrace=="function"&&process.env[p.VSCODE_TRACE_STORAGE]&&(this.logTrace=b.logTrace),b&&typeof b.logError=="function"&&(this.logError=b.logError)}get isTracing(){return!!this.logTrace}trace(b){this.logTrace?.(b)}error(b){this.logError?.(b)}}p.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[147],te([11,10]),function(z,e){return z.create("vs/code/electron-main/app",e)}),define(ee[148],te([11,10]),function(z,e){return z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[149],te([11,10]),function(z,e){return z.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[150],te([11,10]),function(z,e){return z.create("vs/platform/environment/node/argv",e)}),define(ee[151],te([11,10]),function(z,e){return z.create("vs/platform/environment/node/argvHelper",e)}),define(ee[152],te([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[153],te([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[154],te([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[155],te([11,10]),function(z,e){return z.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[156],te([11,10]),function(z,e){return z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[157],te([11,10]),function(z,e){return z.create("vs/platform/files/common/fileService",e)}),define(ee[158],te([11,10]),function(z,e){return z.create("vs/platform/files/common/files",e)}),define(ee[159],te([11,10]),function(z,e){return z.create("vs/platform/files/common/io",e)}),define(ee[160],te([11,10]),function(z,e){return z.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[161],te([11,10]),function(z,e){return z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[162],te([11,10]),function(z,e){return z.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[163],te([11,10]),function(z,e){return z.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[164],te([11,10]),function(z,e){return z.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[165],te([11,10]),function(z,e){return z.create("vs/platform/request/common/request",e)}),define(ee[166],te([11,10]),function(z,e){return z.create("vs/platform/shell/node/shellEnv",e)}),define(ee[167],te([11,10]),function(z,e){return z.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[168],te([11,10]),function(z,e){return z.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[169],te([11,10]),function(z,e){return z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[170],te([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[171],te([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[172],te([11,10]),function(z,e){return z.create("vs/platform/workspace/common/workspace",e)}),define(ee[173],te([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[174],te([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[175],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(ee[176],te([0,1,7]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(D){return typeof D?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function k(D){let P=[];try{Array.isArray(D.workspaces)&&(P=D.workspaces.map(p=>({workspace:{id:p.id,configPath:E.URI.parse(p.configURIPath)},remoteAuthority:p.remoteAuthority})))}catch{}return P}e.deserializeWorkspaceInfos=k;function R(D){let P=[];try{Array.isArray(D.folders)&&(P=D.folders.map(p=>({folderUri:E.URI.parse(p.folderUri),remoteAuthority:p.remoteAuthority})))}catch{}return P}e.deserializeFolderInfos=R}),define(ee[177],te([0,1,3,2]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new E.Emitter,this._onReloadEmitter=new E.Emitter,this._onTerminateEmitter=new E.Emitter,this._onAttachEmitter=new E.Emitter}call(P,p,v){switch(p){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:v[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:v[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:v[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:v[0],port:v[1],subId:v[2]}))}throw new Error("Method not implemented.")}listen(P,p,v){switch(p){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(P){super(),this.channel=P}reload(P){this.channel.call("reload",[P])}get onReload(){return this.channel.listen("reload")}close(P){this.channel.call("close",[P])}get onClose(){return this.channel.listen("close")}attachSession(P,p,v){this.channel.call("attach",[P,p,v])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(P,p){this.channel.call("terminate",[P,p])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(P,p){return this.channel.call("openExtensionDevelopmentHostWindow",[P,p])}}e.ExtensionHostDebugChannelClient=R}),define(ee[178],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class E{constructor(k){this.machineId=k}encryption(){return new Promise((k,R)=>z(["vscode-encrypt"],k,R))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch{return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch{return k}}}e.EncryptionMainService=E}),define(ee[179],te([0,1,132,53,14,9,32,19,7]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class v{get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("",z).fsPath)}get userHome(){return p.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return p.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.paths.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return p.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return p.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get remoteTunnelLogResource(){return p.URI.file((0,R.join)(this.logsPath,"remoteTunnel.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(p.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=D.env.VSCODE_PORTABLE;return g?p.URI.file((0,R.join)(g,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,R.resolve)(g):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?p.URI.file((0,R.resolve)(g)):p.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,R.resolve)(g);const f=D.env.VSCODE_EXTENSIONS;if(f)return f;const d=D.env.VSCODE_PORTABLE;return d?(0,R.join)(d,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(f=>/^[^:/?#]+?:\/\//.test(f)?p.URI.parse(f):p.URI.file((0,R.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?p.URI.parse(g):p.URI.file((0,R.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(g))}get extensionLogLevel(){const g=[];for(const f of this.args.log||[]){const d=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(f);d&&d[1]&&d[2]&&g.push([d[1],d[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return p.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=D.env.VSCODE_PORTABLE;return g?p.URI.file((0,R.join)(g,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this._args}constructor(g,f,d){this._args=g,this.paths=f,this.productService=d,this.editSessionId=this.args.editSessionId}}ve([t.memoize],v.prototype,"appRoot",null),ve([t.memoize],v.prototype,"userHome",null),ve([t.memoize],v.prototype,"userDataPath",null),ve([t.memoize],v.prototype,"appSettingsHome",null),ve([t.memoize],v.prototype,"tmpDir",null),ve([t.memoize],v.prototype,"cacheHome",null),ve([t.memoize],v.prototype,"stateResource",null),ve([t.memoize],v.prototype,"userRoamingDataHome",null),ve([t.memoize],v.prototype,"userDataSyncHome",null),ve([t.memoize],v.prototype,"userDataSyncLogResource",null),ve([t.memoize],v.prototype,"editSessionsLogResource",null),ve([t.memoize],v.prototype,"remoteTunnelLogResource",null),ve([t.memoize],v.prototype,"sync",null),ve([t.memoize],v.prototype,"machineSettingsResource",null),ve([t.memoize],v.prototype,"workspaceStorageHome",null),ve([t.memoize],v.prototype,"localHistoryHome",null),ve([t.memoize],v.prototype,"keyboardLayoutResource",null),ve([t.memoize],v.prototype,"argvResource",null),ve([t.memoize],v.prototype,"isExtensionDevelopment",null),ve([t.memoize],v.prototype,"untitledWorkspacesHome",null),ve([t.memoize],v.prototype,"installSourcePath",null),ve([t.memoize],v.prototype,"builtinExtensionsPath",null),ve([t.memoize],v.prototype,"extensionsPath",null),ve([t.memoize],v.prototype,"extensionDevelopmentLocationURI",null),ve([t.memoize],v.prototype,"extensionDevelopmentKind",null),ve([t.memoize],v.prototype,"extensionTestsLocationURI",null),ve([t.memoize],v.prototype,"debugExtensionHost",null),ve([t.memoize],v.prototype,"logLevel",null),ve([t.memoize],v.prototype,"extensionLogLevel",null),ve([t.memoize],v.prototype,"serviceMachineIdResource",null),ve([t.memoize],v.prototype,"telemetryLogResource",null),ve([t.memoize],v.prototype,"disableWorkspaceTrust",null),ve([t.memoize],v.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=v;function b(w,g){return u(w["inspect-extensions"],w["inspect-brk-extensions"],5870,g,w.debugId,w.extensionEnvironment)}e.parseExtensionHostPort=b;function C(w,g){return u(w["inspect-search"],w["inspect-brk-search"],5876,g,w.extensionEnvironment)}e.parseSearchPort=C;function I(w,g){return u(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,g,w.extensionEnvironment)}e.parsePtyHostPort=I;function u(w,g,f,d,S,m){const l=Number(g||w)||(d?null:f),n=l?Boolean(!!g):!1;let r;if(m)try{r=JSON.parse(m)}catch{}return{port:l,break:n,debugId:S,env:r}}}),define(ee[104],te([0,1,275,4,150]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(12,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},category:{type:"string",cat:"e",description:(0,k.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,k.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,k.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(g,f,d=D){const S=g.find(c=>c.length>0&&c[0]!=="-"),m={},h=["_"],l=[],n={};let r;for(const c in f){const a=f[c];a.type==="subcommand"?c===S&&(r=a):(a.alias&&(m[c]=a.alias),a.type==="string"||a.type==="string[]"?(h.push(c),a.deprecates&&h.push(...a.deprecates)):a.type==="boolean"&&(l.push(c),a.deprecates&&l.push(...a.deprecates)),a.global&&(n[c]=a))}if(r&&S){const c=n;for(const T in r.options)c[T]=r.options[T];const a=g.filter(T=>T!==S),y=d.getSubcommandReporter?d.getSubcommandReporter(S):void 0,M=P(a,c,y);return{[S]:M,_:[]}}const i=E(g,{string:h,boolean:l,alias:m}),o={},s=i;o._=i._.map(c=>String(c)).filter(c=>c.length>0),delete s._;for(const c in f){const a=f[c];if(a.type==="subcommand")continue;a.alias&&delete s[a.alias];let y=s[c];if(a.deprecates)for(const M of a.deprecates)s.hasOwnProperty(M)&&(y||(y=s[M],y&&d.onDeprecatedOption(M,a.deprecationMessage||(0,k.localize)(36,null,c))),delete s[M]);if(typeof y<"u"){if(a.type==="string[]"){if(Array.isArray(y)||(y=[y]),!a.allowEmptyValue){const M=y.filter(T=>T.length>0);M.length!==y.length&&(d.onEmptyValue(c),y=M.length>0?M:void 0)}}else a.type==="string"&&(Array.isArray(y)?(y=y.pop(),d.onMultipleValues(c,y)):!y&&!a.allowEmptyValue&&(d.onEmptyValue(c),y=void 0));o[c]=y,a.deprecationMessage&&d.onDeprecatedOption(c,a.deprecationMessage)}delete s[c]}for(const c in s)d.onUnknownOption(c);return o}e.parseArgs=P;function p(g,f){let d="";return f.args&&(Array.isArray(f.args)?d=` <${f.args.join("> <")}>`:d=` <${f.args}>`),f.alias?`-${f.alias} --${g}${d}`:`--${g}${d}`}function v(g,f){const d=[];for(const S in g){const m=g[S],h=p(S,m);d.push([h,m.description])}return b(d,f)}e.formatOptions=v;function b(g,f){const S=g.reduce((l,n)=>Math.max(l,n[0].length),12)+2+1;if(f-S<25)return g.reduce((l,n)=>l.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const m=f-S-1,h=[];for(const l of g){const n=l[0],r=I(l[1],m),i=C(S-n.length-2);h.push("  "+n+i+r[0]);for(let o=1;o<r.length;o++)h.push(C(S)+r[o])}return h}function C(g){return" ".repeat(g)}function I(g,f){const d=[];for(;g.length;){const S=g.length<f?g.length:g.lastIndexOf(" ",f),m=g.slice(0,S).trim();g=g.slice(S),d.push(m)}return d}function u(g,f,d,S,m){const h=process.stdout.isTTY&&process.stdout.columns||80,l=m?.noInputFiles!==!0?`[${(0,k.localize)(37,null)}...]`:"",n=[`${g} ${d}`];n.push(""),n.push(`${(0,k.localize)(38,null)}: ${f} [${(0,k.localize)(39,null)}]${l}`),n.push(""),m?.noPipe!==!0&&(t.isWindows?n.push((0,k.localize)(40,null,f)):n.push((0,k.localize)(41,null,f)),n.push(""));const r={},i=[];for(const o in S){const s=S[o];if(s.type==="subcommand")s.description&&i.push({command:o,description:s.description});else if(s.description&&s.cat){let c=r[s.cat];c||(r[s.cat]=c={}),c[o]=s}}for(const o in r){const s=o,c=r[s];c&&(n.push(R[s]),n.push(...v(c,h)),n.push(""))}return i.length&&(n.push((0,k.localize)(42,null)),n.push(...b(i.map(o=>[o.command,o.description]),h)),n.push("")),n.join(`
`)}e.buildHelpMessage=u;function w(g,f){return`${g||(0,k.localize)(43,null)}
${f||(0,k.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=w}),define(ee[180],te([0,1,78,177,104]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(P,p){super(),this.windowsMainService=P,this.userDataProfilesMainService=p}call(P,p,v){return p==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(v[0],v[1]):super.call(P,p,v)}async openExtensionDevelopmentHostWindow(P,p){const v=(0,k.parseArgs)(P,k.OPTIONS);v.debugRenderer=p;const b=v.extensionDevelopmentPath;if(!b)return{success:!1};const[C]=await this.windowsMainService.openExtensionDevelopmentHostWindow(b,{context:5,cli:v,profile:await this.userDataProfilesMainService.checkAndCreateProfileFromCli(v)});if(!p)return{success:!0};const I=C.win;if(!I)return{success:!0};const u=I.webContents.debugger;let w=u.isAttached()?1/0:0;const g=(0,E.createServer)(f=>{w++===0&&u.attach();let d=!1;const S=l=>{d||f.write(JSON.stringify(l)+"\0")},m=(l,n,r,i)=>S({method:n,params:r,sessionId:i});I.on("close",()=>{u.removeListener("message",m),f.end(),d=!0}),u.addListener("message",m);let h=Buffer.alloc(0);f.on("data",l=>{h=Buffer.concat([h,l]);for(let n=h.indexOf(0);n!==-1;n=h.indexOf(0)){let r;try{const i=h.slice(0,n).toString("utf8");h=h.slice(n+1),r=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}u.sendCommand(r.method,r.params,r.sessionId).then(i=>S({id:r.id,sessionId:r.sessionId,result:i})).catch(i=>S({id:r.id,sessionId:r.sessionId,error:{code:0,message:i.message}}))}}),f.on("error",l=>{console.error("error on cdp pipe:",l)}),f.on("close",()=>{d=!0,--w===0&&u.detach()})});return await new Promise(f=>g.listen(0,f)),I.on("close",()=>g.close()),{rendererDebugPort:g.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(ee[59],te([0,1,276,151,104]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function D(I,u){const w=(h,l)=>{console.warn((0,t.localize)(0,null,h,l))},g=h=>{console.warn((0,t.localize)(1,null,h))},f=(h,l)=>{console.warn((0,t.localize)(2,null,h,l))},d=h=>({onUnknownOption:l=>{h!=="tunnel"&&console.warn((0,t.localize)(3,null,l,h))},onMultipleValues:w,onEmptyValue:g,onDeprecatedOption:f,getSubcommandReporter:h!=="tunnel"?d:void 0}),S={onUnknownOption:h=>{console.warn((0,t.localize)(4,null,h))},onMultipleValues:w,onEmptyValue:g,onDeprecatedOption:f,getSubcommandReporter:d},m=(0,k.parseArgs)(I,k.OPTIONS,u?S:void 0);return m.goto&&m._.forEach(h=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(h),(0,t.localize)(5,null))),m["max-memory"]&&E(parseInt(m["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),m}function P(I){const u=I.findIndex(w=>!/^-/.test(w));if(u>-1)return[...I.slice(0,u),...I.slice(u+1)]}function p(I){let[,...u]=I;process.env.VSCODE_DEV&&(u=P(u)||[]);const w=!C(process.env);return D(u,w)}e.parseMainProcessArgv=p;function v(I){let[,,...u]=I;return process.env.VSCODE_DEV&&(u=P(u)||[]),D(u,!0)}e.parseCLIProcessArgv=v;function b(I,...u){const w=I.indexOf("--");return w===-1?I.push(...u):I.splice(w,0,...u),I}e.addArg=b;function C(I){return I.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),function(){"use strict";function z(e,E,t){function k(D,P){const p=R(D,P),v=[p];return e.isAbsolute(p)||v.unshift(t),e.resolve(...v)}function R(D,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let v=process.env.VSCODE_APPDATA;if(v)return e.join(v,P);const b=D["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(v=process.env.APPDATA,!v){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");v=e.join(C,"AppData","Roaming")}break;case"darwin":v=e.join(E.homedir(),"Library","Application Support");break;case"linux":v=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(v,P)}return{getUserDataPath:k}}if(typeof define=="function")define(ee[181],te([182,27,32]),function(e,E,t){return z(e,E,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=z(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[183],te([0,1,27,179,181]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(P,p){super(P,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,k.getUserDataPath)(P,p.nameShort)},p)}}e.NativeEnvironmentService=R}),define(ee[184],te([0,1,39,27,30]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(D){const P=(0,k.randomPath)((0,t.tmpdir)());try{return(0,E.writeFileSync)(P,""),D&&console.log(`Marker file for --wait created: ${P}`),P}catch(p){D&&console.error(`Failed to create marker file for --wait: ${p}`);return}}e.createWaitMarkerFileSync=R}),define(ee[185],te([0,1,12,153]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(D,P,p){try{R(D,P,p)}catch(v){console.error(v?.message??v)}return D}e.localizeManifest=k;function R(D,P,p){const v=(b,C,I)=>{const u=b[C];if((0,E.isString)(u)){const w=u,g=w.length;if(g>1&&w[0]==="%"&&w[g-1]==="%"){const f=w.substr(1,g-2);let d=P[f];d===void 0&&p&&(d=p[f]);const S=typeof d=="string"?d:d?.message,m=p?.[f],h=typeof m=="string"?m:m?.message;if(!S){h||console.warn(`[${D.name}]: ${(0,t.localize)(0,null,f)}`);return}if(I&&(C==="title"||C==="category")&&h&&h!==S){const l={value:S,original:h};b[C]=l}else b[C]=S}}else if((0,E.isObject)(u))for(const w in u)u.hasOwnProperty(w)&&(w==="commands"?v(u,w,!0):v(u,w,I));else if(Array.isArray(u))for(let w=0;w<u.length;w++)v(u,w,I)};for(const b in D)D.hasOwnProperty(b)&&v(D,b)}}),define(ee[186],te([0,1,19,97,155,187]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function p(d){return d=d.trim(),d==="*"||D.test(d)}e.isValidVersionStr=p;function v(d){if(!p(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const S=d.match(D);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=v;function b(d){if(!d)return null;const S=d.majorBase,m=d.majorMustEqual,h=d.minorBase;let l=d.minorMustEqual;const n=d.patchBase;let r=d.patchMustEqual;d.hasCaret&&(S===0||(l=!1),r=!1);let i=0;if(d.preRelease){const o=P.exec(d.preRelease);if(o){const[,s,c,a]=o;i=Date.UTC(Number(s),Number(c)-1,Number(a))}}return{majorBase:S,majorMustEqual:m,minorBase:h,minorMustEqual:l,patchBase:n,patchMustEqual:r,isMinimum:d.hasGreaterEquals,notBefore:i}}e.normalizeVersion=b;function C(d,S,m){let h;typeof d=="string"?h=b(v(d)):h=d;let l;S instanceof Date?l=S.getTime():typeof S=="string"&&(l=new Date(S).getTime());let n;if(typeof m=="string"?n=b(v(m)):n=m,!h||!n)return!1;const r=h.majorBase,i=h.minorBase,o=h.patchBase;let s=n.majorBase,c=n.minorBase,a=n.patchBase;const y=n.notBefore;let M=n.majorMustEqual,T=n.minorMustEqual,U=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:i>c?!0:i<c||l&&l<y?!1:o>=a:(r===1&&s===0&&(!M||!T||!U)&&(s=1,c=0,a=0,M=!0,T=!1,U=!1),r<s?!1:r>s?!M:i<c?!1:i>c?!T:o<a?!1:o>a?!U:!(l&&l<y))}e.isValidVersion=C;function I(d,S,m,h,l){const n=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return n.push([t.default.Error,k.localize(0,null)]),n;if(typeof h.name!="string")return n.push([t.default.Error,k.localize(1,null,"name")]),n;if(typeof h.version!="string")return n.push([t.default.Error,k.localize(2,null,"version")]),n;if(!h.engines)return n.push([t.default.Error,k.localize(3,null,"engines")]),n;if(typeof h.engines.vscode!="string")return n.push([t.default.Error,k.localize(4,null,"engines.vscode")]),n;if(typeof h.extensionDependencies<"u"&&!f(h.extensionDependencies))return n.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),n;if(typeof h.activationEvents<"u"){if(!f(h.activationEvents))return n.push([t.default.Error,k.localize(6,null,"activationEvents")]),n;if(typeof h.main>"u"&&typeof h.browser>"u")return n.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),n}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&n.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return n.push([t.default.Error,k.localize(9,null,"main")]),n;{const o=(0,E.joinPath)(m,h.main);(0,E.isEqualOrParent)(o,m)||n.push([t.default.Warning,k.localize(10,null,o.path,m.path)])}if(typeof h.activationEvents>"u")return n.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),n}if(typeof h.browser<"u"){if(typeof h.browser!="string")return n.push([t.default.Error,k.localize(12,null,"browser")]),n;{const o=(0,E.joinPath)(m,h.browser);(0,E.isEqualOrParent)(o,m)||n.push([t.default.Warning,k.localize(13,null,o.path,m.path)])}if(typeof h.activationEvents>"u")return n.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),n}if(!R.valid(h.version))return n.push([t.default.Error,k.localize(15,null)]),n;const r=[];if(!u(d,S,h,l,r))for(const o of r)n.push([t.default.Error,o]);return n}e.validateExtensionManifest=I;function u(d,S,m,h,l){return h||typeof m.main>"u"&&typeof m.browser>"u"?!0:g(d,S,m.engines.vscode,l)}e.isValidExtensionVersion=u;function w(d,S,m){return d==="*"||g(S,m,d)}e.isEngineValid=w;function g(d,S,m,h=[]){const l=b(v(m));if(!l)return h.push(k.localize(16,null,m)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return h.push(k.localize(17,null,m)),!1}else if(!l.majorMustEqual)return h.push(k.localize(18,null,m)),!1;return C(d,S,l)?!0:(h.push(k.localize(19,null,d,m)),!1)}function f(d){if(!Array.isArray(d))return!1;for(let S=0,m=d.length;S<m;S++)if(typeof d[S]!="string")return!1;return!0}}),define(ee[188],te([0,1,17,29]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,D,P){let p=P&&P.get("storage.serviceMachineId",-1)||null;if(p)return p;try{const b=(await D.readFile(R.serviceMachineIdResource)).value.toString();p=(0,t.isUUID)(b)?b:null}catch{p=null}if(!p){p=(0,t.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,E.VSBuffer.fromString(p))}catch{}}return P?.store("storage.serviceMachineId",p,-1,1),p}e.getServiceMachineId=k}),define(ee[69],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(k,R=[],D=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=E}),define(ee[189],te([0,1,69]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function R(P,p,v){p instanceof E.SyncDescriptor||(p=new E.SyncDescriptor(p,[],Boolean(v))),t.push([P,p])}e.registerSingleton=R;function D(){return t}e.getSingletonServiceDescriptors=D}),define(ee[190],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(R,D){this.key=R,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const P=this.lookupOrInsertNode(R),p=this.lookupOrInsertNode(D);P.outgoing.set(p.key,p),p.incoming.set(P.key,P)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(const P of this._nodes.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let P=this._nodes.get(D);return P||(P=new E(D,R),this._nodes.set(D,P)),P}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[D,P]of this._nodes)R.push(`${D}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this._nodes){const P=new Set([R]),p=this._findCycle(D,P);if(p)return p}}_findCycle(R,D){for(const[P,p]of R.outgoing){if(D.has(P))return[...D,P].join(" -> ");D.add(P);const v=this._findCycle(p,D);if(v)return v;D.delete(P)}}}e.Graph=t}),define(ee[5],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function P(p){return p[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=P})(E=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(D,P,p){P[E.DI_TARGET]===P?P[E.DI_DEPENDENCIES].push({id:D,index:p}):(P[E.DI_DEPENDENCIES]=[{id:D,index:p}],P[E.DI_TARGET]=P)}function k(D){if(E.serviceIds.has(D))return E.serviceIds.get(D);const P=function(p,v,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,p,b)};return P.toString=()=>D,E.serviceIds.set(D,P),P}e.createDecorator=k;function R(D){return D}e.refineServiceDecorator=R}),define(ee[60],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(ee[18],te([0,1,12,7,5]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationOverrides=R;function D(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var P;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function p(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=p;function v(d,S){const m=Object.create(null);for(const h in d)b(m,h,d[h],S);return m}e.toValuesTree=v;function b(d,S,m,h){const l=S.split("."),n=l.pop();let r=d;for(let i=0;i<l.length;i++){const o=l[i];let s=r[o];switch(typeof s){case"undefined":s=r[o]=Object.create(null);break;case"object":break;default:h(`Ignoring ${S} as ${l.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[n]=m}catch{h(`Ignoring ${S} as ${l.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${S} as ${l.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=b;function C(d,S){const m=S.split(".");I(d,m)}e.removeFromValueTree=C;function I(d,S){const m=S.shift();if(S.length===0){delete d[m];return}if(Object.keys(d).indexOf(m)!==-1){const h=d[m];typeof h=="object"&&!Array.isArray(h)&&(I(h,S),Object.keys(h).length===0&&delete d[m])}}function u(d,S,m){function h(r,i){let o=r;for(const s of i){if(typeof o!="object"||o===null)return;o=o[s]}return o}const l=S.split("."),n=h(d,l);return typeof n>"u"?m:n}e.getConfigurationValue=u;function w(d,S,m){Object.keys(S).forEach(h=>{h!=="__proto__"&&(h in d?E.isObject(d[h])&&E.isObject(S[h])?w(d[h],S[h],m):m&&(d[h]=S[h]):d[h]=S[h])})}e.merge=w;function g(d,S,m){const h=d.inspect(S),l=d.inspect(m);return typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:h.defaultValue}e.getMigratedSettingValue=g;function f(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(ee[70],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,D){return this.secretVault[R]?.[D]??null}async setPassword(R,D,P){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][D]=P}async deletePassword(R,D){return this.secretVault[R]?.[D]?(delete this.secretVault[R][D],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const D=[];for(const P of Object.keys(this.secretVault[R]||{}))D.push({account:P,password:this.secretVault[R][P]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(ee[84],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(D,P){return{}}async getSystemInfo(D,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,P){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=k}),define(ee[105],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(ee[34],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[26],te([0,1,53,9,83,34,183,5]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,P.refineServiceDecorator)(R.IEnvironmentService);class p extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([E.memoize],p.prototype,"cachedLanguagesPath",null),ve([E.memoize],p.prototype,"backupHome",null),ve([E.memoize],p.prototype,"mainIPCHandle",null),ve([E.memoize],p.prototype,"mainLockfile",null),ve([E.memoize],p.prototype,"disableUpdates",null),ve([E.memoize],p.prototype,"disableKeytar",null),ve([E.memoize],p.prototype,"crossOriginIsolated",null),ve([E.memoize],p.prototype,"codeCachePath",null),ve([E.memoize],p.prototype,"useCodeCache",null),e.EnvironmentMainService=p}),define(ee[191],te([0,1,152,5]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY="DEFAULT_PROFILE_EXTENSIONS_MIGRATION";function k(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(d,S){switch(d){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function P(d,S){return S==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function p(d,S,m){return P(S,m)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===m?!0:v(m).includes(d)}e.isTargetPlatformCompatible=p;function v(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=v;function b(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=b;var C;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(C=e.SortBy||(e.SortBy={}));var I;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(I=e.SortOrder||(e.SortOrder={}));var u;(function(d){d.Install="install",d.Uninstall="uninstall"})(u=e.StatisticType||(e.StatisticType={}));var w;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var g;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal",d.Signature="Signature"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class f extends Error{constructor(S,m){super(S),this.code=m,this.name=m}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ee[192],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(ee[193],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[106],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(ee[194],te([0,1,44,14,9,4,79,23,82,156,106]),function(z,e,E,t,k,R,D,P,p,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const C=v.localize(0,null);class I{async getDefaultTerminalForPlatforms(){return{windows:u.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class u extends I{openTerminal(h,l){return this.spawnTerminal(E,h,p.getWindowsShell(),l)}spawnTerminal(h,l,n,r){const i=l.windowsExec||u.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const o=k.basename(i).toLowerCase();if(o==="cmder"||o==="cmder.exe")return h.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return i.indexOf(" ")>=0&&s.push('""'),s.push(i),(o==="wt"||o==="wt.exe")&&s.push("-d ."),new Promise((c,a)=>{const y=f(process),M=h.spawn(n,s,{cwd:r,env:y});M.on("error",a),M.on("exit",()=>c())})}runInTerminal(h,l,n,r,i){const o="windowsExec"in i&&i.windowsExec?i.windowsExec:u.getDefaultTerminalWindows();return new Promise((s,c)=>{const a=`"${l} - ${C}"`,y=`""${n.join('" "')}" & pause"`,M=["/c","start",a,"/wait",o,"/c",y],T=Object.assign({},f(process),r);Object.keys(T).filter(G=>T[G]===null).forEach(G=>delete T[G]);const U={cwd:l,env:T,windowsVerbatimArguments:!0};E.spawn(u.CMD,M,U).on("error",G=>{c(d(G))}),s(void 0)})}static getDefaultTerminalWindows(){if(!u._DEFAULT_TERMINAL_WINDOWS){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");u._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return u._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=u,u.CMD="cmd.exe";class w extends I{openTerminal(h,l){return this.spawnTerminal(E,h,l)}runInTerminal(h,l,n,r,i){const o=i.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((s,c)=>{if(o===b.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const a=o===b.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`,z).fsPath,"-t",h||C,"-w",l];for(const Y of n)M.push("-a"),M.push(Y);if(r){const Y=Object.assign({},f(process),r);for(const G in Y){const V=Y[G];V===null?(M.push("-u"),M.push(G)):(M.push("-e"),M.push(`${G}=${V}`))}}let T="";const U=E.spawn(w.OSASCRIPT,M);U.on("error",Y=>{c(d(Y))}),U.stderr.on("data",Y=>{T+=Y.toString()}),U.on("exit",Y=>{if(Y===0)s(void 0);else if(T){const G=T.split(`
`,1);c(new Error(G[0]))}else c(new Error(v.localize(1,null,a,Y)))})}else c(new Error(v.localize(2,null,o)))})}spawnTerminal(h,l,n){const r=l.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((i,o)=>{const s=["-a",r];n&&s.push(n);const c=f(process),a=h.spawn("/usr/bin/open",s,{cwd:n,env:c});a.on("error",o),a.on("exit",()=>i())})}}e.MacExternalTerminalService=w,w.OSASCRIPT="/usr/bin/osascript";class g extends I{openTerminal(h,l){return this.spawnTerminal(E,h,l)}runInTerminal(h,l,n,r,i){const o=i.linuxExec?Promise.resolve(i.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((s,c)=>{const a=[];o.then(y=>{y.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const M=`${S(n)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;a.push(`''${M}''`);const T=Object.assign({},f(process),r);Object.keys(T).filter(V=>T[V]===null).forEach(V=>delete T[V]);const U={cwd:l,env:T};let Y="";const G=E.spawn(y,a,U);G.on("error",V=>{c(d(V))}),G.stderr.on("data",V=>{Y+=V.toString()}),G.on("exit",V=>{if(V===0)s(void 0);else if(Y){const oe=Y.split(`
`,1);c(new Error(oe[0]))}else c(new Error(v.localize(4,null,y,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!g._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)g._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const h=await P.Promises.exists("/etc/debian_version");g._DEFAULT_TERMINAL_LINUX_READY=new Promise(l=>{h?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(h,l,n){const r=l.linuxExec?Promise.resolve(l.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((i,o)=>{r.then(s=>{const c=f(process),a=h.spawn(s,[],{cwd:n,env:c});a.on("error",o),a.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=v.localize(3,null);function f(m){const h={...m.env};return(0,D.sanitizeProcessEnvironment)(h),h}function d(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(v.localize(5,null,m.path)):m}function S(m){let h="";for(const l of m)l.indexOf(" ")>=0?h+='"'+l+'"':h+=l,h+=" ";return h}}),define(ee[15],te([0,1,58,9,25,12,7,158,5]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,p.createDecorator)("fileService");function v(K){return K.create===!0}e.isFileOpenForWriteOptions=v;var b;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var C;(function(K){K[K.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var I;(function(K){K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock",K[K.FileAtomicRead=16384]="FileAtomicRead",K[K.FileClone=32768]="FileClone"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function u(K){return!!(K.capabilities&2)}e.hasReadWriteCapability=u;function w(K){return!!(K.capabilities&8)}e.hasFileFolderCopyCapability=w;function g(K){return!!(K.capabilities&32768)}e.hasFileCloneCapability=g;function f(K){return!!(K.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function d(K){return!!(K.capabilities&16)}e.hasFileReadStreamCapability=d;function S(K){return u(K)?!!(K.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var m;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(H,F){super(H),this.code=F}}e.FileSystemProviderError=h;function l(K,H){const F=new h(K.toString(),H);return r(F,H),F}e.createFileSystemProviderError=l;function n(K){return K||l((0,P.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=n;function r(K,H){return K.name=H?`${H} (FileSystemError)`:"FileSystemError",K}e.markAsFileSystemProviderError=r;function i(K){if(!K)return m.Unknown;if(K instanceof h)return K.code;const H=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!H)return m.Unknown;switch(H[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=i;function o(K){if(K instanceof T)return K.fileOperationResult;switch(i(K)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var s;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY",K[K.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class c{constructor(H,F,A){this.resource=H,this.operation=F,this.target=A}isOperation(H){return this.operation===H}}e.FileOperationEvent=c;var a;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class y{constructor(H,F){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=H;const A=new Map;for(const O of H){const _=A.get(O.type);switch(_?_.push([O.resource,O]):A.set(O.type,[[O.resource,O]]),O.type){case 1:this.rawAdded.push(O.resource);break;case 0:this.rawUpdated.push(O.resource);break;case 2:this.rawDeleted.push(O.resource);break}}for(const[O,_]of A)switch(O){case 1:this.added=E.TernarySearchTree.forUris(()=>F),this.added.fill(_);break;case 0:this.updated=E.TernarySearchTree.forUris(()=>F),this.updated.fill(_);break;case 2:this.deleted=E.TernarySearchTree.forUris(()=>F),this.deleted.fill(_);break}}contains(H,...F){return this.doContains(H,{includeChildren:!1},...F)}affects(H,...F){return this.doContains(H,{includeChildren:!0},...F)}doContains(H,F,...A){if(!H)return!1;const O=A.length>0;return!!((!O||A.includes(1))&&(this.added?.get(H)||F.includeChildren&&this.added?.findSuperstr(H))||(!O||A.includes(0))&&(this.updated?.get(H)||F.includeChildren&&this.updated?.findSuperstr(H))||(!O||A.includes(2))&&(this.deleted?.findSubstr(H)||F.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=y;function M(K,H,F){return!K||!H||K===H||H.length>K.length?!1:(H.charAt(H.length-1)!==t.sep&&(H+=t.sep),F?(0,k.startsWithIgnoreCase)(K,H):K.indexOf(H)===0)}e.isParent=M;class T extends Error{constructor(H,F,A){super(H),this.fileOperationResult=F,this.options=A}}e.FileOperationError=T;class U extends T{constructor(H,F,A){super(H,2,A),this.stat=F}}e.NotModifiedSinceFileOperationError=U;var Y;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",K[K.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var G;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(G=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function V(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}e.etag=V;async function oe(K,H){if(!H.hasProvider(D.URI.from({scheme:K.scheme})))return new Promise(F=>{const A=H.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===K.scheme&&O.added&&(A.dispose(),F())})})}e.whenProviderRegistered=oe,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ae{static formatSize(H){return(0,R.isNumber)(H)||(H=0),H<ae.KB?(0,P.localize)(1,null,H.toFixed(0)):H<ae.MB?(0,P.localize)(2,null,(H/ae.KB).toFixed(2)):H<ae.GB?(0,P.localize)(3,null,(H/ae.MB).toFixed(2)):H<ae.TB?(0,P.localize)(4,null,(H/ae.GB).toFixed(2)):(0,P.localize)(5,null,(H/ae.TB).toFixed(2))}}e.ByteSize=ae,ae.KB=1024,ae.MB=ae.KB*ae.KB,ae.GB=ae.MB*ae.KB,ae.TB=ae.GB*ae.KB;var se;(function(K){K[K.IA32=0]="IA32",K[K.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function fe(K){return{maxFileSize:K===0?300*ae.MB:16*ae.GB,maxHeapSize:K===0?700*ae.MB:2*700*ae.MB}}e.getPlatformLimits=fe}),define(ee[195],te([0,1,17,43,16,3,2,57,7,29,15]),function(z,e,E,t,k,R,D,P,p,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends D.Disposable{constructor(u,w){super(),this.channel=u,this.extraCapabilities=w,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,v.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(u){return this.channel.call("stat",[u])}readdir(u){return this.channel.call("readdir",[u])}async readFile(u,w){const{buffer:g}=await this.channel.call("readFile",[u,w]);return g}readFileStream(u,w,g){const f=(0,P.newWriteableStream)(S=>E.VSBuffer.concat(S.map(m=>E.VSBuffer.wrap(m))).buffer),d=this.channel.listen("readFileStream",[u,w])(S=>{if(S instanceof E.VSBuffer)f.write(S.buffer);else{if(S==="end")f.end();else{let m=S;m instanceof Error||(m=(0,b.createFileSystemProviderError)((0,t.toErrorMessage)(m),b.FileSystemProviderErrorCode.Unknown)),f.error(m),f.end()}d.dispose()}});return g.onCancellationRequested(()=>{f.error((0,k.canceled)()),f.end(),d.dispose()}),f}writeFile(u,w,g){return this.channel.call("writeFile",[u,E.VSBuffer.wrap(w),g])}open(u,w){return this.channel.call("open",[u,w])}close(u){return this.channel.call("close",[u])}async read(u,w,g,f,d){const[S,m]=await this.channel.call("read",[u,w,d]);return g.set(S.buffer.slice(0,m),f),m}write(u,w,g,f,d){return this.channel.call("write",[u,w,E.VSBuffer.wrap(g),f,d])}mkdir(u){return this.channel.call("mkdir",[u])}delete(u,w){return this.channel.call("delete",[u,w])}rename(u,w,g){return this.channel.call("rename",[u,w,g])}copy(u,w,g){return this.channel.call("copy",[u,w,g])}cloneFile(u,w){return this.channel.call("cloneFile",[u,w])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(u=>{if(Array.isArray(u)){const w=u;this._onDidChange.fire(w.map(g=>({resource:p.URI.revive(g.resource),type:g.type})))}else{const w=u;this._onDidWatchError.fire(w)}}))}watch(u,w){const g=(0,v.generateUuid)();return this.channel.call("watch",[this.sessionId,g,u,w]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,g]))}}e.DiskFileSystemProviderClient=C}),define(ee[107],te([0,1,17,16,159,15]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(b,C,I,u,w,g){let f;try{await P(b,C,I,u,w,g)}catch(d){f=d}finally{f&&w.errorTransformer&&(f=w.errorTransformer(f)),typeof f<"u"&&I.error(f),I.end()}}e.readFileIntoStream=D;async function P(b,C,I,u,w,g){p(g);const f=await b.open(C,{create:!1});try{p(g);let d=0,S=0,m=w&&typeof w.length=="number"?w.length:void 0,h=E.VSBuffer.alloc(Math.min(w.bufferSize,typeof m=="number"?m:w.bufferSize)),l=w&&typeof w.position=="number"?w.position:0,n=0;do S=await b.read(f,l,h.buffer,n,h.byteLength-n),l+=S,n+=S,d+=S,typeof m=="number"&&(m-=S),n===h.byteLength&&(await I.write(u(h)),h=E.VSBuffer.alloc(Math.min(w.bufferSize,typeof m=="number"?m:w.bufferSize)),n=0);while(S>0&&(typeof m!="number"||m>0)&&p(g)&&v(d,w));if(n>0){let r=n;typeof m=="number"&&(r=Math.min(n,m)),I.write(u(h.slice(0,r)))}}catch(d){throw(0,R.ensureFileSystemProviderError)(d)}finally{await b.close(f)}}function p(b){if(b.isCancellationRequested)throw(0,t.canceled)();return!0}function v(b,C){if(C?.limits){if(typeof C.limits.memory=="number"&&b>C.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&b>C.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[71],te([0,1,98,2,9,4,7,15]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function p(d){return d.recursive===!0}e.isRecursiveWatchRequest=p;class v extends t.Disposable{constructor(S,m,h,l){super(),this.onFileChanges=S,this.onLogMessage=m,this.verboseLogging=h,this.options=l,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const S=new t.DisposableStore;this.watcherDisposables.value=S,this.watcher=this.createWatcher(S),this.watcher.setVerboseLogging(this.verboseLogging),S.add(this.watcher.onDidChangeFile(m=>this.onFileChanges(m))),S.add(this.watcher.onDidLogMessage(m=>this.onLogMessage(m))),S.add(this.watcher.onDidError(m=>this.onError(m)))}onError(S){this.options.restartOnError?this.restartCounter<v.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${S}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${S}`):this.error(S)}restart(S){this.restartCounter++,this.init(),this.watch(S)}async watch(S){this.requests=S,await this.watcher?.watch(S)}async setVerboseLogging(S){this.verboseLogging=S,await this.watcher?.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${S}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=v,v.MAX_RESTARTS=5;class b extends v{constructor(S,m,h){super(S,m,h,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class C extends v{constructor(S,m,h){super(S,m,h,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=C;function I(d){return d.map(S=>({type:S.type,resource:D.URI.file(S.path)}))}e.toFileChanges=I;function u(d){const S=new f;for(const m of d)S.processEvent(m);return S.coalesce()}e.coalesceEvents=u;function w(d,S){return typeof S=="string"&&!S.startsWith(E.GLOBSTAR)&&!(0,k.isAbsolute)(S)?{base:d,pattern:S}:S}e.normalizeWatcherPattern=w;function g(d,S){const m=[];for(const h of S)m.push((0,E.parse)(w(d,h)));return m}e.parseWatcherPatterns=g;class f{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(S){return R.isLinux?S.path:S.path.toLowerCase()}processEvent(S){const m=this.mapPathToChange.get(this.toKey(S));let h=!1;if(m){const l=m.type,n=S.type;m.path!==S.path&&(S.type===2||S.type===1)?h=!0:l===1&&n===2?(this.mapPathToChange.delete(this.toKey(S)),this.coalesced.delete(m)):l===2&&n===1?m.type=0:l===1&&n===0||(m.type=n)}else h=!0;h&&(this.coalesced.add(S),this.mapPathToChange.set(this.toKey(S),S))}coalesce(){const S=[],m=[];return Array.from(this.coalesced).filter(h=>h.type!==2?(S.push(h),!1):!0).sort((h,l)=>h.path.length-l.path.length).filter(h=>m.some(l=>(0,P.isParent)(h.path,l,!R.isLinux))?!1:(m.push(h.path),!0)).concat(S)}}}),define(ee[196],te([0,1,39,8,22,30,2,76,9,4,99,23,71]),function(z,e,E,t,k,R,D,P,p,v,b,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class u extends D.Disposable{constructor(f,d,S,m){super(),this.request=f,this.onDidFilesChange=d,this.onLogMessage=S,this.verboseLogging=m,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},h=>this.onDidFilesChange(h)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(u.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,I.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,I.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const f=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const d=await C.Promises.stat(f);this._register(await this.doWatch(f,d.isDirectory()))}catch(f){f.code!=="ENOENT"?this.error(f):this.trace(f)}}async normalizePath(f){let d=f.path;try{d=await C.Promises.realpath(f.path),f.path===d&&(d=await(0,b.realcase)(f.path)??f.path),f.path!==d&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${d})`)}catch{}return d}async doWatch(f,d){if(v.isMacintosh&&(0,R.isEqualOrParent)(f,"/Volumes/",!0))return this.error(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const S=new k.CancellationTokenSource(this.cts.token),m=new D.DisposableStore;try{const h=(0,p.basename)(f),l=(0,E.watch)(f);m.add((0,D.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.trace(`Started watching: '${f}'`);const n=new Set;if(d)try{for(const i of await C.Promises.readdir(f))n.add(i)}catch(i){this.error(i)}const r=new Map;m.add((0,D.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),l.on("error",(i,o)=>{this.error(`Failed to watch ${f} for changes using fs.watch() (${i}, ${o})`),this.dispose()}),l.on("change",(i,o)=>{if(S.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${o}`);let s="";if(o&&(s=o.toString(),v.isMacintosh&&(s=(0,P.normalizeNFC)(s))),!(!s||i!=="change"&&i!=="rename"))if(d)if(i==="rename"){r.get(s)?.dispose();const c=setTimeout(async()=>{if(r.delete(s),s===h&&!await C.Promises.exists(f)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,p.join)(f,s));if(S.token.isCancellationRequested)return;let y;a?n.has(s)?y=0:(y=1,n.add(s)):(n.delete(s),y=2),this.onFileChange({path:(0,p.join)(this.request.path,s),type:y})},u.FILE_DELETE_HANDLER_DELAY);r.set(s,(0,D.toDisposable)(()=>clearTimeout(c)))}else{let c;n.has(s)?c=0:(c=1,n.add(s)),this.onFileChange({path:(0,p.join)(this.request.path,s),type:c})}else if(i==="rename"||s!==h){const c=setTimeout(async()=>{const a=await C.Promises.exists(f);S.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),m.add(await this.doWatch(f,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},u.FILE_DELETE_HANDLER_DELAY);m.clear(),m.add((0,D.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(h){await C.Promises.exists(f)&&!S.token.isCancellationRequested&&this.error(`Failed to watch ${f} for changes using fs.watch() (${h.toString()})`)}return(0,D.toDisposable)(()=>{S.dispose(!0),m.dispose()})}async onFileChange(f,d=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),!d&&this.excludes.some(S=>S(f.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${f.path}`):!d&&this.includes&&this.includes.length>0&&!this.includes.some(S=>S(f.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${f.path}`):this.fileChangesBuffer.push(f);try{await this.fileChangesDelayer.trigger(async()=>{const S=this.fileChangesBuffer;this.fileChangesBuffer=[];const m=(0,I.coalesceEvents)(S);if(m.length>0){if(this.verboseLogging)for(const l of m)this.trace(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.throttledFileChangesWorker.work(m)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${m.length}, most recent change: ${m[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(f){if(v.isLinux)return C.Promises.exists(f);try{const d=(0,p.basename)(f);return(await C.Promises.readdir((0,p.dirname)(f))).some(m=>m===d)}catch(d){return this.trace(d),!1}}setVerboseLogging(f){this.verboseLogging=f}error(f){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}warn(f){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}trace(f){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=u,u.FILE_DELETE_HANDLER_DELAY=100,u.FILE_CHANGES_HANDLER_DELAY=50;async function w(g,f,d,S,m=512){const h=await C.Promises.open(g,"r"),l=Buffer.allocUnsafe(m),n=new k.CancellationTokenSource(S);let r,i=!1;const o={path:g,excludes:[],recursive:!1},s=new u(o,c=>{(async()=>{for(const{type:a}of c)if(a===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:y}=await C.Promises.read(h,l,0,m,null);if(!y||n.token.isCancellationRequested)break;f(l.slice(0,y))}}catch(y){r=new Error(y),n.dispose(!0)}finally{i=!1}}})()});return await s.ready,d(),new Promise((c,a)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await C.Promises.close(h)}catch(y){r=new Error(y)}r?a(r):c()})})}e.watchFileContents=w}),define(ee[197],te([0,1,3,98,2,4,196]),function(z,e,E,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new E.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new E.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=E.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(v){const b=this.normalizeRequests(v),C=b.filter(u=>{const w=this.watchers.get(u.path);return w?!(0,t.patternsEquals)(w.request.excludes,u.excludes)||!(0,t.patternsEquals)(w.request.includes,u.includes):!0}),I=Array.from(this.watchers.values()).filter(({request:u})=>!b.find(w=>w.path===u.path&&(0,t.patternsEquals)(w.excludes,u.excludes)&&(0,t.patternsEquals)(w.includes,u.includes))).map(({request:u})=>u.path);C.length&&this.trace(`Request to start watching: ${C.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"})`).join(",")}`),I.length&&this.trace(`Request to stop watching: ${I.join(",")}`);for(const u of I)this.stopWatching(u);for(const u of C)this.startWatching(u)}startWatching(v){const b=new D.NodeJSFileWatcherLibrary(v,I=>this._onDidChangeFile.fire(I),I=>this._onDidLogMessage.fire(I),this.verboseLogging),C={request:v,instance:b};this.watchers.set(v.path,C)}async stop(){for(const[v]of this.watchers)this.stopWatching(v);this.watchers.clear()}stopWatching(v){const b=this.watchers.get(v);b&&(this.watchers.delete(v),b.instance.dispose())}normalizeRequests(v){const b=new Map;for(const C of v){const I=R.isLinux?C.path:C.path.toLowerCase();b.set(I,C)}return Array.from(b.values())}async setVerboseLogging(v){this.verboseLogging=v;for(const[,b]of this.watchers)b.instance.setVerboseLogging(v)}trace(v){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(v)})}toMessage(v,b){return b?`[File Watcher (node.js)] ${v} (path: ${b.request.path})`:`[File Watcher (node.js)] ${v}`}}e.NodeJSWatcher=P}),define(ee[198],te([0,1,71,197]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends E.AbstractNonRecursiveWatcherClient{constructor(D,P,p){super(D,P,p),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(ee[199],te([0,1,14,45,145,71]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends R.AbstractUniversalWatcherClient{constructor(p,v,b){super(p,v,b),this.init()}createWatcher(p){const v=p.add(new k.Client(E.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(v.onDidProcessExit(({code:b,signal:C})=>this.onError(`terminated by itself with code ${b}, signal: ${C}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(v.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(ee[85],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...k){this._entries=new Map;for(const[R,D]of k)this.set(R,D)}set(k,R){const D=this._entries.get(k);return this._entries.set(k,R),D}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=E}),define(ee[200],te([0,1,8,16,2,69,190,5,85,94]),function(z,e,E,t,k,R,D,P,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class C extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class I{constructor(f=new p.ServiceCollection,d=!1,S,m=b){this._services=f,this._strict=d,this._parent=S,this._enableTracing=m,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=m?S?._globalGraph??new D.Graph(h=>h):void 0}createChild(f){return new I(f,this._strict,this,this._enableTracing)}invokeFunction(f,...d){const S=w.traceInvocation(this._enableTracing,f);let m=!1;try{return f({get:l=>{if(m)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(l,S);if(!n)throw new Error(`[invokeFunction] unknown service '${l}'`);return n}},...d)}finally{m=!0,S.stop()}}createInstance(f,...d){let S,m;return f instanceof R.SyncDescriptor?(S=w.traceCreation(this._enableTracing,f.ctor),m=this._createInstance(f.ctor,f.staticArguments.concat(d),S)):(S=w.traceCreation(this._enableTracing,f),m=this._createInstance(f,d,S)),S.stop(),m}_createInstance(f,d=[],S){const m=P._util.getServiceDependencies(f).sort((n,r)=>n.index-r.index),h=[];for(const n of m){const r=this._getOrCreateServiceInstance(n.id,S);r||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${n.id}.`,!1),h.push(r)}const l=m.length>0?m[0].index:d.length;if(d.length!==l){console.trace(`[createInstance] First service dependency of ${f.name} at position ${l+1} conflicts with ${d.length} static arguments`);const n=l-d.length;n>0?d=d.concat(new Array(n)):d=d.slice(0,l)}return Reflect.construct(f,d.concat(h))}_setServiceInstance(f,d){if(this._services.get(f)instanceof R.SyncDescriptor)this._services.set(f,d);else if(this._parent)this._parent._setServiceInstance(f,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const d=this._services.get(f);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):d}_getOrCreateServiceInstance(f,d){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(f));const S=this._getServiceInstanceOrDescriptor(f);return S instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,S,d.branch(f,!0)):(d.branch(f,!1),S)}_safeCreateAndCacheServiceInstance(f,d,S){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,d,S)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,d,S){const m=new D.Graph(n=>n.id.toString());let h=0;const l=[{id:f,desc:d,_trace:S}];for(;l.length;){const n=l.pop();if(m.lookupOrInsertNode(n),h++>1e3)throw new C(m);for(const r of P._util.getServiceDependencies(n.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(r.id);if(i||this._throwIfStrict(`[createInstance] ${f} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),i instanceof R.SyncDescriptor){const o={id:r.id,desc:i,_trace:n._trace.branch(r.id,!0)};m.insertEdge(n,o),l.push(o)}}}for(;;){const n=m.roots();if(n.length===0){if(!m.isEmpty())throw new C(m);break}for(const{data:r}of n){if(this._getServiceInstanceOrDescriptor(r.id)instanceof R.SyncDescriptor){const o=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,o)}m.removeNode(r)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,d,S=[],m,h){if(this._services.get(f)instanceof R.SyncDescriptor)return this._createServiceInstance(f,d,S,m,h);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,d,S,m,h);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(f,d,S=[],m,h){if(m){const l=new I(void 0,this._strict,this,this._enableTracing);l._globalGraphImplicitDependency=String(f);const n=new Map,r=new E.IdleValue(()=>{const i=l._createInstance(d,S,h);for(const[o,s]of n){const c=i[o];if(typeof c=="function")for(const a of s)c.apply(i,a)}return n.clear(),i});return new Proxy(Object.create(null),{get(i,o){if(!r.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let a=n.get(o);return a||(a=new v.LinkedList,n.set(o,a)),(M,T,U)=>{const Y=a.push([M,T,U]);return(0,k.toDisposable)(Y)}}if(o in i)return i[o];const s=r.value;let c=s[o];return typeof c!="function"||(c=c.bind(s),i[o]=c),c},set(i,o,s){return r.value[o]=s,!0}})}else return this._createInstance(d,S,h)}_throwIfStrict(f,d){if(d&&console.warn(f),this._strict)throw new Error(f)}}e.InstantiationService=I;var u;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(u||(u={}));class w{static traceInvocation(f,d){return f?new w(1,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w._None}static traceCreation(f,d){return f?new w(0,d.name):w._None}constructor(f,d){this.type=f,this.name=d,this._start=Date.now(),this._dep=[]}branch(f,d){const S=new w(2,f.toString());return this._dep.push([f,d,S]),S}stop(){const f=Date.now()-this._start;w._totals+=f;let d=!1;function S(h,l){const n=[],r=new Array(h+1).join("	");for(const[i,o,s]of l._dep)if(o&&s){d=!0,n.push(`${r}CREATES -> ${i}`);const c=S(h+1,s);c&&n.push(c)}else n.push(`${r}uses -> ${i}`);return n.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(f>2||d)&&w.all.add(m.join(`
`))}}e.Trace=w,w.all=new Set,w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(ee[6],te([0,1,43,3,2,38,4,7,5]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function v(){return new Date().toISOString()}var b;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function C(c,a,y){switch(a){case b.Trace:c.trace(y);break;case b.Debug:c.debug(y);break;case b.Info:c.info(y);break;case b.Warning:c.warn(y);break;case b.Error:c.error(y);break;default:throw new Error("Invalid log level")}}e.log=C;function I(c){let a="";for(let y=0;y<c.length;y++){let M=c[y];if(typeof M=="object")try{M=JSON.stringify(M)}catch{}a+=(y>0?" ":"")+M}return a}e.format=I;class u extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=u;class w extends u{constructor(a){super(),this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...y){this.checkLogLevel(b.Trace)&&this.log(b.Trace,I([a,...y]))}debug(a,...y){this.checkLogLevel(b.Debug)&&this.log(b.Debug,I([a,...y]))}info(a,...y){this.checkLogLevel(b.Info)&&this.log(b.Info,I([a,...y]))}warn(a,...y){this.checkLogLevel(b.Warning)&&this.log(b.Warning,I([a,...y]))}error(a,...y){if(this.checkLogLevel(b.Error))if(a instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=a.stack,this.log(b.Error,I(M))}else this.log(b.Error,I([a,...y]))}flush(){}}e.AbstractMessageLogger=w;class g extends u{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.useColors=!D.isWindows}trace(a,...y){this.getLevel()<=b.Trace&&(this.useColors?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,a,...y):console.log(`[main ${v()}]`,a,...y))}debug(a,...y){this.getLevel()<=b.Debug&&(this.useColors?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,a,...y):console.log(`[main ${v()}]`,a,...y))}info(a,...y){this.getLevel()<=b.Info&&(this.useColors?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,a,...y):console.log(`[main ${v()}]`,a,...y))}warn(a,...y){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,a,...y):console.warn(`[main ${v()}]`,a,...y))}error(a,...y){this.getLevel()<=b.Error&&(this.useColors?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,a,...y):console.error(`[main ${v()}]`,a,...y))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class f extends u{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...y){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",a,...y)}debug(a,...y){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...y)}info(a,...y){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",a,...y)}warn(a,...y){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",a,...y)}error(a,...y){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",a,...y)}dispose(){}flush(){}}e.ConsoleLogger=f;class d extends u{constructor(a,y=e.DEFAULT_LOG_LEVEL){super(),this.adapter=a,this.setLevel(y)}trace(a,...y){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(a),...y])}debug(a,...y){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(a),...y])}info(a,...y){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(a),...y])}warn(a,...y){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(a),...y])}error(a,...y){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(a),...y])}extractMessage(a){return typeof a=="string"?a:(0,E.toErrorMessage)(a,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class S extends u{constructor(a){super(),this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const y of this.logServices)y.setLevel(a);super.setLevel(a)}trace(a,...y){for(const M of this.logServices)M.trace(a,...y)}debug(a,...y){for(const M of this.logServices)M.debug(a,...y)}info(a,...y){for(const M of this.logServices)M.info(a,...y)}warn(a,...y){for(const M of this.logServices)M.warn(a,...y)}error(a,...y){for(const M of this.logServices)M.error(a,...y)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=S;class m extends k.Disposable{constructor(a){super(),this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...y){this.logger.trace(a,...y)}debug(a,...y){this.logger.debug(a,...y)}info(a,...y){this.logger.info(a,...y)}warn(a,...y){this.logger.warn(a,...y)}error(a,...y){this.logger.error(a,...y)}flush(){this.logger.flush()}}e.LogService=m;class h extends k.Disposable{constructor(a,y){super(),this.logLevel=a,this.loggerItems=new R.ResourceMap,this._register(y(M=>this.setLevel(M)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:a})=>a)}getLogger(a){return this.loggerItems.get(a)?.logger}createLogger(a,y,M){let T=this.loggerItems.get(a)?.logger;return T||(M=y?.always?b.Trace:M,T=this.doCreateLogger(a,M??this.logLevel,y),this.loggerItems.set(a,{logger:T,logLevel:M})),T}setLevel(a,y){const M=P.URI.isUri(a)?a:void 0,T=M?y:a;if(M){const U=this.loggerItems.get(M);U&&U.logLevel!==T&&(U.logLevel=T,U.logger.setLevel(T))}else this.logLevel=T,this.loggerItems.forEach(({logLevel:U,logger:Y})=>{U===void 0&&Y.setLevel(this.logLevel)})}getLogLevel(a){return this.loggerItems.get(a)?.logLevel}dispose(){this.loggerItems.forEach(({logger:a})=>a.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=h;class l{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(a){}getLevel(){return b.Info}trace(a,...y){}debug(a,...y){}info(a,...y){}warn(a,...y){}error(a,...y){}critical(a,...y){}dispose(){}flush(){}}e.NullLogger=l;class n extends l{}e.NullLogService=n;class r extends h{constructor(){super(b.Info,t.Event.None)}doCreateLogger(a,y,M){return new l}}e.NullLoggerService=r;function i(c){if(c.verbose)return b.Trace;if(typeof c.logLevel=="string"){const a=s(c.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function o(c){switch(c){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=o;function s(c){switch(c){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=s});var ie=this&&this.__param||function(z,e){return function(E,t){e(E,t,z)}};define(ee[201],te([0,1,70,3,2,6,4,8]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let p=class Et extends k.Disposable{constructor(b){super(),this.logService=b,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(b,C){this.logService.trace("Getting password from keytar:",b,C);let I;try{I=await this.withKeytar()}catch{return null}const u=await(0,P.retry)(()=>I.getPassword(b,C),50,3);if(!u)return this.logService.trace("Did not get a password from keytar for account:",C),u;let w,g;try{const f=JSON.parse(u);w=f.content,g=f.hasNextChunk}catch{}if(!w||!g)return this.logService.trace("Got password from keytar for account:",C),u;try{let f=1;for(;g;){const d=await(0,P.retry)(()=>I.getPassword(b,`${C}-${f}`),50,3),S=JSON.parse(d);w+=S.content,g=S.hasNextChunk,f++}return this.logService.trace(`Got ${f}-chunked password from keytar for account:`,C),w}catch(f){return this.logService.error(f),u}}async setPassword(b,C,I){this.logService.trace("Setting password using keytar:",b,C);let u;try{u=await this.withKeytar()}catch(w){throw this.surfaceKeytarLoadError?.(w),w}if(D.isWindows&&I.length>Et.MAX_PASSWORD_LENGTH){let w=0,g=0,f=!0;for(;f;){const d=I.substring(w,w+Et.PASSWORD_CHUNK_SIZE);w+=Et.PASSWORD_CHUNK_SIZE,f=I.length-w>0;const S={content:d,hasNextChunk:f};await(0,P.retry)(()=>u.setPassword(b,g?`${C}-${g}`:C,JSON.stringify(S)),50,3),g++}this.logService.trace(`Got${g?` ${g}-chunked`:""} password from keytar for account:`,C)}else await(0,P.retry)(()=>u.setPassword(b,C,I),50,3),this.logService.trace("Got password from keytar for account:",C);this._onDidChangePassword.fire({service:b,account:C})}async deletePassword(b,C){this.logService.trace("Deleting password using keytar:",b,C);let I;try{I=await this.withKeytar()}catch(d){throw this.surfaceKeytarLoadError?.(d),d}const u=await I.getPassword(b,C);if(!u)return this.logService.trace("Did not get a password to delete from keytar for account:",C),!1;let w,g;try{const d=JSON.parse(u);w=d.content,g=d.hasNextChunk}catch{}let f=0;if(w&&g)try{for(f++;g;){const d=`${C}-${f}`,S=await I.getPassword(b,d);await I.deletePassword(b,d),g=JSON.parse(S).hasNextChunk,f++}}catch(d){this.logService.error(d)}return await I.deletePassword(b,C)?(this._onDidChangePassword.fire({service:b,account:C}),this.logService.trace(`Deleted${f?` ${f}-chunked`:""} password from keytar for account:`,C),!0):(this.logService.trace(`Keytar failed to delete${f?` ${f}-chunked`:""} password for account:`,C),!1)}async findPassword(b){let C;try{C=await this.withKeytar()}catch{return null}return await C.findPassword(b)}async findCredentials(b){let C;try{C=await this.withKeytar()}catch{return[]}return await C.findCredentials(b)}clear(){return this._keytarCache instanceof E.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};p.MAX_PASSWORD_LENGTH=2500,p.PASSWORD_CHUNK_SIZE=p.MAX_PASSWORD_LENGTH-100,p=ve([ie(0,R.ILogService)],p),e.BaseCredentialsMainService=p}),define(ee[202],te([0,1,24,8,16,3,2,9,71,6]),function(z,e,E,t,k,R,D,P,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends D.Disposable{constructor(I,u){super(),this.logService=I,this.options=u,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(I,u){return u.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(I,u):this.watchNonRecursive(I,u)}watchUniversal(I,u){const w={path:this.toFilePath(I),excludes:u.excludes,includes:u.includes,recursive:u.recursive},g=(0,E.insert)(this.universalPathsToWatch,w);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{g(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(I=>(0,k.onUnexpectedError)(I))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(u=>this._onDidChangeFile.fire((0,p.toFileChanges)(u)),u=>this.onWatcherLogMessage(u),this.logService.getLevel()===v.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)})));const I=this.options?.watcher?.recursive?.usePolling;if(I===!0)for(const u of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(u)&&(u.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(I))for(const u of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(u)&&I.includes(u.path)&&(u.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(I,u){const w={path:this.toFilePath(I),excludes:u.excludes,includes:u.includes,recursive:!1},g=(0,E.insert)(this.nonRecursivePathsToWatch,w);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{g(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(I=>(0,k.onUnexpectedError)(I))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(I=>this._onDidChangeFile.fire((0,p.toFileChanges)(I)),I=>this.onWatcherLogMessage(I),this.logService.getLevel()===v.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(I){I.type==="error"&&this._onDidWatchError.fire(I.message),this.logService[I.type](I.message)}toFilePath(I){return(0,P.normalize)(I.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(ee[203],te([0,1,24,8,17,22,3,67,66,2,58,14,72,19,57,157,15,107,6]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g,f,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let m=class extends v.Disposable{constructor(l){super(),this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(l,n){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${l}`);const r=new v.DisposableStore;return this.provider.set(l,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:n}),r.add(n.onDidChangeFile(i=>this._onDidFilesChange.fire(new f.FileChangesEvent(i,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),r.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:l}))),(0,v.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:n}),this.provider.delete(l),(0,v.dispose)(r)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(r){n.push(r)}}),!this.provider.has(l)&&await t.Promises.settled(n)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,n){const r=this.provider.get(l.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return p.Iterable.map(this.provider,([l,n])=>({scheme:l,capabilities:n.capabilities}))}async withProvider(l){if(!(0,u.isAbsolutePath)(l))throw new f.FileOperationError((0,g.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const n=this.provider.get(l.scheme);if(!n){const r=new Error;throw r.name="ENOPRO",r.message=(0,g.localize)(1,null,l.toString()),r}return n}async withReadProvider(l){const n=await this.withProvider(l);if((0,f.hasOpenReadWriteCloseCapability)(n)||(0,f.hasReadWriteCapability)(n)||(0,f.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const n=await this.withProvider(l);if((0,f.hasOpenReadWriteCloseCapability)(n)||(0,f.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,n){try{return await this.doResolveFile(l,n)}catch(r){throw(0,f.toFileSystemProviderErrorCode)(r)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,g.localize)(2,null,this.resourceForError(l)),1):(0,f.ensureFileSystemProviderError)(r)}}async doResolveFile(l,n){const r=await this.withProvider(l),i=this.isPathCaseSensitive(r),o=n?.resolveTo,s=n?.resolveSingleChildDescendants,c=n?.resolveMetadata,a=await r.stat(l);let y;return this.toFileStat(r,l,a,void 0,!!c,(M,T)=>(y||(y=b.TernarySearchTree.forUris(()=>!i),y.set(l,!0),o&&y.fill(!0,o)),y.get(M.resource)||y.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&s?T===1:!1))}async toFileStat(l,n,r,i,o,s){const{providerExtUri:c}=this.getExtUri(l),a={resource:n,name:c.basename(n),isFile:(r.type&f.FileType.File)!==0,isDirectory:(r.type&f.FileType.Directory)!==0,isSymbolicLink:(r.type&f.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&f.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,f.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(a.isDirectory&&s(a,i)){try{const y=await l.readdir(n),M=await t.Promises.settled(y.map(async([T,U])=>{try{const Y=c.joinPath(n,T),G=o?await l.stat(Y):{type:U};return await this.toFileStat(l,Y,G,y.length,o,s)}catch(Y){return this.logService.trace(Y),null}}));a.children=(0,E.coalesce)(M)}catch(y){this.logService.trace(y),a.children=[]}return a}return a}async resolveAll(l){return t.Promises.settled(l.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(l){const n=await this.withProvider(l),r=await n.stat(l);return this.toFileStat(n,l,r,void 0,!0,()=>!1)}async exists(l){const n=await this.withProvider(l);try{return!!await n.stat(l)}catch{return!1}}async canCreateFile(l,n){try{await this.doValidateCreateFile(l,n)}catch(r){return r}return!0}async doValidateCreateFile(l,n){if(!n?.overwrite&&await this.exists(l))throw new f.FileOperationError((0,g.localize)(3,null,this.resourceForError(l)),3,n)}async createFile(l,n=k.VSBuffer.fromString(""),r){await this.doValidateCreateFile(l,r);const i=await this.writeFile(l,n);return this._onDidRunOperation.fire(new f.FileOperationEvent(l,0,i)),i}async writeFile(l,n,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:o}=this.getExtUri(i);try{await this.validateWriteFile(i,l,r)||await this.mkdirp(i,o.dirname(l));let c;if((0,f.hasReadWriteCapability)(i)&&!(n instanceof k.VSBuffer))if((0,w.isReadableStream)(n)){const a=await(0,w.peekStream)(n,3);a.ended?c=k.VSBuffer.concat(a.buffer):c=a}else c=(0,w.peekReadable)(n,a=>k.VSBuffer.concat(a),3);else c=n;!(0,f.hasOpenReadWriteCloseCapability)(i)||(0,f.hasReadWriteCapability)(i)&&c instanceof k.VSBuffer?await this.doWriteUnbuffered(i,l,r,c):await this.doWriteBuffered(i,l,r,c instanceof k.VSBuffer?(0,k.bufferToReadable)(c):c),this._onDidRunOperation.fire(new f.FileOperationEvent(l,4))}catch(s){throw new f.FileOperationError((0,g.localize)(4,null,this.resourceForError(l),(0,f.ensureFileSystemProviderError)(s).toString()),(0,f.toFileOperationResult)(s),r)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,n,r){if(!!r?.unlock&&!(l.capabilities&8192))throw new Error((0,g.localize)(5,null,this.resourceForError(n)));let o;try{o=await l.stat(n)}catch{return}if((o.type&f.FileType.Directory)!==0)throw new f.FileOperationError((0,g.localize)(6,null,this.resourceForError(n)),0,r);if(this.throwIfFileIsReadonly(n,o),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==f.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&r.mtime<o.mtime&&r.etag!==(0,f.etag)({mtime:r.mtime,size:o.size}))throw new f.FileOperationError((0,g.localize)(7,null),3,r);return o}async readFile(l,n,r){const i=await this.withReadProvider(l);return n?.atomic?this.doReadFileAtomic(i,l,n,r):this.doReadFile(i,l,n,r)}async doReadFileAtomic(l,n,r,i){return new Promise((o,s)=>{this.writeQueue.queueFor(n,this.getExtUri(l).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(l,n,r,i);o(c)}catch(c){s(c)}})})}async doReadFile(l,n,r,i){const o=await this.doReadFileStream(l,n,{...r,preferUnbuffered:!0},i);return{...o,value:await(0,k.streamToBuffer)(o.value)}}async readFileStream(l,n,r){const i=await this.withReadProvider(l);return this.doReadFileStream(i,l,n,r)}async doReadFileStream(l,n,r,i){const o=new R.CancellationTokenSource(i),s=this.validateReadFile(n,r).then(a=>a,a=>{throw o.cancel(),a});let c;try{return typeof r?.etag=="string"&&r.etag!==f.ETAG_DISABLED&&await s,r?.atomic&&(0,f.hasFileAtomicReadCapability)(l)||!((0,f.hasOpenReadWriteCloseCapability)(l)||(0,f.hasFileReadStreamCapability)(l))||(0,f.hasReadWriteCapability)(l)&&r?.preferUnbuffered?c=this.readFileUnbuffered(l,n,r):(0,f.hasFileReadStreamCapability)(l)?c=this.readFileStreamed(l,n,o.token,r):c=this.readFileBuffered(l,n,o.token,r),{...await s,value:c}}catch(a){c&&await(0,w.consumeStream)(c);const y=(0,g.localize)(8,null,this.resourceForError(n),(0,f.ensureFileSystemProviderError)(a).toString());throw a instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(y,a.stat,r):new f.FileOperationError(y,(0,f.toFileOperationResult)(a),r)}}readFileStreamed(l,n,r,i=Object.create(null)){const o=l.readFileStream(n,i,r);return(0,w.transform)(o,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new f.FileOperationError((0,g.localize)(9,null,this.resourceForError(n),(0,f.ensureFileSystemProviderError)(s).toString()),(0,f.toFileOperationResult)(s),i)},s=>k.VSBuffer.concat(s))}readFileBuffered(l,n,r,i=Object.create(null)){const o=(0,k.newWriteableBufferStream)();return(0,d.readFileIntoStream)(l,n,o,s=>s,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new f.FileOperationError((0,g.localize)(10,null,this.resourceForError(n),(0,f.ensureFileSystemProviderError)(s).toString()),(0,f.toFileOperationResult)(s),i)},r),o}readFileUnbuffered(l,n,r){const i=(0,w.newWriteableStream)(o=>k.VSBuffer.concat(o));return(async()=>{try{let o;r?.atomic&&(0,f.hasFileAtomicReadCapability)(l)?o=await l.readFile(n,{atomic:!0}):o=await l.readFile(n),typeof r?.position=="number"&&(o=o.slice(r.position)),typeof r?.length=="number"&&(o=o.slice(0,r.length)),this.validateReadFileLimits(n,o.byteLength,r),i.end(k.VSBuffer.wrap(o))}catch(o){i.error(o),i.end()}})(),i}async validateReadFile(l,n){const r=await this.resolve(l,{resolveMetadata:!0});if(r.isDirectory)throw new f.FileOperationError((0,g.localize)(11,null,this.resourceForError(l)),0,n);if(typeof n?.etag=="string"&&n.etag!==f.ETAG_DISABLED&&n.etag===r.etag)throw new f.NotModifiedSinceFileOperationError((0,g.localize)(12,null),r,n);return this.validateReadFileLimits(l,r.size,n),r}validateReadFileLimits(l,n,r){if(r?.limits){let i;if(typeof r.limits.memory=="number"&&n>r.limits.memory&&(i=9),typeof r.limits.size=="number"&&n>r.limits.size&&(i=7),typeof i=="number")throw new f.FileOperationError((0,g.localize)(13,null,this.resourceForError(l)),i)}}async canMove(l,n,r){return this.doCanMoveCopy(l,n,"move",r)}async canCopy(l,n,r){return this.doCanMoveCopy(l,n,"copy",r)}async doCanMoveCopy(l,n,r,i){if(l.toString()!==n.toString())try{const o=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(o,l,s,n,r,i)}catch(o){return o}return!0}async move(l,n,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(i,l,o,n,"move",!!r),c=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(l,s==="move"?2:3,c)),c}async copy(l,n,r){const i=await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(i,l,o,n,"copy",!!r),c=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(l,s==="copy"?3:2,c)),c}async doMoveCopy(l,n,r,i,o,s){if(n.toString()===i.toString())return o;const{exists:c,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(l,n,r,i,o,s);if(c&&!a&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(i)),o==="copy"){if(l===r&&(0,f.hasFileFolderCopyCapability)(l))await l.copy(n,i,{overwrite:s});else{const y=await this.resolve(n);y.isDirectory?await this.doCopyFolder(l,y,r,i):await this.doCopyFile(l,n,r,i)}return o}else return l===r?(await l.rename(n,i,{overwrite:s}),o):(await this.doMoveCopy(l,n,r,i,"copy",s),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(l,n,r,i){if((0,f.hasOpenReadWriteCloseCapability)(l)&&(0,f.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(l,n,r,i);if((0,f.hasOpenReadWriteCloseCapability)(l)&&(0,f.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(l,n,r,i);if((0,f.hasReadWriteCapability)(l)&&(0,f.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(l,n,r,i);if((0,f.hasReadWriteCapability)(l)&&(0,f.hasReadWriteCapability)(r))return this.doPipeUnbuffered(l,n,r,i)}async doCopyFolder(l,n,r,i){await r.mkdir(i),Array.isArray(n.children)&&await t.Promises.settled(n.children.map(async o=>{const s=this.getExtUri(r).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.doCopyFolder(l,await this.resolve(o.resource),r,s):this.doCopyFile(l,o.resource,r,s)}))}async doValidateMoveCopy(l,n,r,i,o,s){let c=!1;if(l===r){const{providerExtUri:y,isPathCaseSensitive:M}=this.getExtUri(l);if(M||(c=y.isEqual(n,i)),c&&o==="copy")throw new Error((0,g.localize)(14,null,this.resourceForError(n),this.resourceForError(i)));if(!c&&y.isEqualOrParent(i,n))throw new Error((0,g.localize)(15,null,this.resourceForError(n),this.resourceForError(i)))}const a=await this.exists(i);if(a&&!c){if(!s)throw new f.FileOperationError((0,g.localize)(16,null,this.resourceForError(n),this.resourceForError(i)),4);if(l===r){const{providerExtUri:y}=this.getExtUri(l);if(y.isEqualOrParent(n,i))throw new Error((0,g.localize)(17,null,this.resourceForError(n),this.resourceForError(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:c}}getExtUri(l){const n=this.isPathCaseSensitive(l);return{providerExtUri:n?u.extUri:u.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(n,l);const r=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(l,0,r)),r}async mkdirp(l,n){const r=[],{providerExtUri:i}=this.getExtUri(l);for(;!i.isEqual(n,i.dirname(n));)try{if(((await l.stat(n)).type&f.FileType.Directory)===0)throw new Error((0,g.localize)(18,null,this.resourceForError(n)));break}catch(o){if((0,f.toFileSystemProviderErrorCode)(o)!==f.FileSystemProviderErrorCode.FileNotFound)throw o;r.push(i.basename(n)),n=i.dirname(n)}for(let o=r.length-1;o>=0;o--){n=i.joinPath(n,r[o]);try{await l.mkdir(n)}catch(s){if((0,f.toFileSystemProviderErrorCode)(s)!==f.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(l,n){try{await this.doValidateDelete(l,n)}catch(r){return r}return!0}async doValidateDelete(l,n){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!n?.useTrash&&!(r.capabilities&4096))throw new Error((0,g.localize)(19,null,this.resourceForError(l)));let o;try{o=await r.stat(l)}catch{}if(o)this.throwIfFileIsReadonly(l,o);else throw new f.FileOperationError((0,g.localize)(20,null,this.resourceForError(l)),1);if(!!!n?.recursive){const c=await this.resolve(l);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,g.localize)(21,null,this.resourceForError(l)))}return r}async del(l,n){const r=await this.doValidateDelete(l,n),i=!!n?.useTrash,o=!!n?.recursive;await r.delete(l,{recursive:o,useTrash:i}),this._onDidRunOperation.fire(new f.FileOperationEvent(l,1))}async cloneFile(l,n){const r=await this.withProvider(l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(r===i&&this.getExtUri(r).providerExtUri.isEqual(l,n))return;if(r===i&&(0,f.hasFileCloneCapability)(r))return r.cloneFile(l,n);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n));const o=this.writeQueue.queueFor(l,this.getExtUri(r).providerExtUri);return r===i&&(0,f.hasFileFolderCopyCapability)(r)?o.queue(()=>r.copy(l,n,{overwrite:!0})):o.queue(()=>this.doCopyFile(r,l,i,n))}watch(l,n={recursive:!1,excludes:[]}){const r=new v.DisposableStore;let i=!1,o=()=>{i=!0};return r.add((0,v.toDisposable)(()=>o())),(async()=>{try{const s=await this.doWatch(l,n);i?(0,v.dispose)(s):o=()=>(0,v.dispose)(s)}catch(s){this.logService.error(s)}})(),r}async doWatch(l,n){const r=await this.withProvider(l),i=(0,P.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(l),n]);let o=this.activeWatchers.get(i);return o||(o={count:0,disposable:r.watch(l,n)},this.activeWatchers.set(i,o)),o.count+=1,(0,v.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,v.dispose)(o.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,v.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,n,r,i){return this.writeQueue.queueFor(n,this.getExtUri(l).providerExtUri).queue(async()=>{const o=await l.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,w.isReadableStream)(i)||(0,w.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(l,o,i):await this.doWriteReadableBufferedQueued(l,o,i)}catch(s){throw(0,f.ensureFileSystemProviderError)(s)}finally{await l.close(o)}})}async doWriteStreamBufferedQueued(l,n,r){let i=0,o;if((0,w.isReadableBufferedStream)(r)){if(r.buffer.length>0){const s=k.VSBuffer.concat(r.buffer);await this.doWriteBuffer(l,n,s,s.byteLength,i,0),i+=s.byteLength}if(r.ended)return;o=r.stream}else o=r;return new Promise((s,c)=>{(0,w.listenStream)(o,{onData:async a=>{o.pause();try{await this.doWriteBuffer(l,n,a,a.byteLength,i,0)}catch(y){return c(y)}i+=a.byteLength,setTimeout(()=>o.resume())},onError:a=>c(a),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(l,n,r){let i=0,o;for(;(o=r.read())!==null;)await this.doWriteBuffer(l,n,o,o.byteLength,i,0),i+=o.byteLength}async doWriteBuffer(l,n,r,i,o,s){let c=0;for(;c<i;)c+=await l.write(n,o+c,r.buffer,s+c,i-c)}async doWriteUnbuffered(l,n,r,i){return this.writeQueue.queueFor(n,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,n,r,i))}async doWriteUnbufferedQueued(l,n,r,i){let o;i instanceof k.VSBuffer?o=i:(0,w.isReadableStream)(i)?o=await(0,k.streamToBuffer)(i):(0,w.isReadableBufferedStream)(i)?o=await(0,k.bufferedStreamToBuffer)(i):o=(0,k.readableToBuffer)(i),await l.writeFile(n,o.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(l,n,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,n,r,i))}async doPipeBufferedQueued(l,n,r,i){let o,s;try{o=await l.open(n,{create:!1}),s=await r.open(i,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,y=0,M=0;do M=await l.read(o,a,c.buffer,y,c.byteLength-y),await this.doWriteBuffer(r,s,c,M,a,y),a+=M,y+=M,y===c.byteLength&&(y=0);while(M>0)}catch(c){throw(0,f.ensureFileSystemProviderError)(c)}finally{await t.Promises.settled([typeof o=="number"?l.close(o):Promise.resolve(),typeof s=="number"?r.close(s):Promise.resolve()])}}async doPipeUnbuffered(l,n,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,n,r,i))}async doPipeUnbufferedQueued(l,n,r,i){return r.writeFile(i,await l.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,n,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,n,r,i))}async doPipeUnbufferedToBufferedQueued(l,n,r,i){const o=await r.open(i,{create:!0,unlock:!1});try{const s=await l.readFile(n);await this.doWriteBuffer(r,o,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,f.ensureFileSystemProviderError)(s)}finally{await r.close(o)}}async doPipeBufferedToUnbuffered(l,n,r,i){const o=await(0,k.streamToBuffer)(this.readFileBuffered(l,n,R.CancellationToken.None));await this.doWriteUnbuffered(r,i,void 0,o)}throwIfFileSystemIsReadonly(l,n){if(l.capabilities&2048)throw new f.FileOperationError((0,g.localize)(22,null,this.resourceForError(n)),6);return l}throwIfFileIsReadonly(l,n){if((n.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,g.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===C.Schemas.file?l.fsPath:l.toString(!0)}};m=ve([ie(0,S.ILogService)],m),e.FileService=m}),define(ee[86],te([0,1,39,277,8,38,17,3,30,2,9,4,19,57,23,161,15,107,202,43,199,198]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g,f,d,S,m,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(E)}catch(r){console.error(`Error enabling graceful-fs: ${(0,m.toErrorMessage)(r)}`)}})();class n extends S.AbstractDiskFileSystemProvider{constructor(i,o){super(i,o),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new R.ResourceMap(s=>I.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:o,symbolicLink:s}=await w.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(o,s),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(i){try{const o=await w.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),s=[];return await Promise.all(o.map(async c=>{try{let a;c.isSymbolicLink()?a=(await this.stat((0,I.joinPath)(i,c.name))).type:a=this.toType(c),s.push([c.name,a])}catch(a){this.logService.trace(a)}})),s}catch(o){throw this.toFileSystemProviderError(o)}}toType(i,o){let s;return o?.dangling?s=f.FileType.Unknown:i.isFile()?s=f.FileType.File:i.isDirectory()?s=f.FileType.Directory:s=f.FileType.Unknown,o&&(s|=f.FileType.SymbolicLink),s}async createResourceLock(i){const o=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let s;for(;s=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await s.wait();const c=new k.Barrier;return this.resourceLocks.set(i,c),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,v.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.resourceLocks.get(i)===c&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),c.open()})}async readFile(i,o){let s;try{o?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),s=await this.createResourceLock(i));const c=this.toFilePath(i);return await w.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{s?.dispose()}}traceLock(i){n.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,o,s){const c=(0,u.newWriteableStream)(a=>D.VSBuffer.concat(a.map(y=>D.VSBuffer.wrap(y))).buffer);return(0,d.readFileIntoStream)(this,i,c,a=>a.buffer,{...o,bufferSize:256*1024},s),c}async writeFile(i,o,s){let c;try{const a=this.toFilePath(i);if(!s.create||!s.overwrite){if(await w.Promises.exists(a)){if(!s.overwrite)throw(0,f.createFileSystemProviderError)((0,g.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,f.createFileSystemProviderError)((0,g.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(c,0,o,0,o.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(i,a)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(i){n.canFlush=i}async open(i,o){const s=this.toFilePath(i);let c;(0,f.isFileOpenForWriteOptions)(o)&&(c=await this.createResourceLock(i));let a;try{if((0,f.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:M}=await w.SymlinkSupport.stat(s);M.mode&128||await w.Promises.chmod(s,M.mode|128)}catch(M){this.logService.trace(M)}let y;if((0,f.isFileOpenForWriteOptions)(o)){if(C.isWindows)try{await w.Promises.truncate(s,0),y="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}y||(y="w")}else y="r";a=await w.Promises.open(s,y)}catch(y){throw c?.dispose(),(0,f.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(i,y):this.toFileSystemProviderError(y)}if(this.mapHandleToPos.set(a,0),(0,f.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(a,i),c){const y=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${s})`),this.mapHandleToLock.set(a,c),y&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${s})`),y.dispose())}return a}async close(i){const o=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&n.canFlush)try{await w.Promises.fdatasync(i)}catch(s){n.configureFlushOnWrite(!1),this.logService.error(s)}return await w.Promises.close(i)}catch(s){throw this.toFileSystemProviderError(s)}finally{o&&(this.mapHandleToLock.get(i)===o&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),o.dispose())}}async read(i,o,s,c,a){const y=this.normalizePos(i,o);let M=null;try{M=(await w.Promises.read(i,s,c,a,y)).bytesRead}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(i,y,M)}return M}normalizePos(i,o){return o===this.mapHandleToPos.get(i)?null:o}updatePos(i,o,s){const c=this.mapHandleToPos.get(i);typeof c=="number"&&(typeof o=="number"||(typeof s=="number"?this.mapHandleToPos.set(i,c+s):this.mapHandleToPos.delete(i)))}async write(i,o,s,c,a){return(0,k.retry)(()=>this.doWrite(i,o,s,c,a),100,3)}async doWrite(i,o,s,c,a){const y=this.normalizePos(i,o);let M=null;try{M=(await w.Promises.write(i,s,c,a,y)).bytesWritten}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),T)}finally{this.updatePos(i,y,M)}return M}async mkdir(i){try{await w.Promises.mkdir(this.toFilePath(i))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(i,o){try{const s=this.toFilePath(i);o.recursive?await w.Promises.rm(s,w.RimRafMode.MOVE):await w.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(i,o,s){const c=this.toFilePath(i),a=this.toFilePath(o);if(c!==a)try{await this.validateTargetDeleted(i,o,"move",s.overwrite),await w.Promises.move(c,a)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,g.localize)(2,null,(0,b.basename)(c),(0,b.basename)((0,b.dirname)(a)),y.toString()))),this.toFileSystemProviderError(y)}}async copy(i,o,s){const c=this.toFilePath(i),a=this.toFilePath(o);if(c!==a)try{await this.validateTargetDeleted(i,o,"copy",s.overwrite),await w.Promises.copy(c,a,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,g.localize)(3,null,(0,b.basename)(c),(0,b.basename)((0,b.dirname)(a)),y.toString()))),this.toFileSystemProviderError(y)}}async validateTargetDeleted(i,o,s,c){const a=this.toFilePath(i),y=this.toFilePath(o);let M=!1;if(!!(this.capabilities&1024)||(M=(0,p.isEqual)(a,y,!0)),M&&s==="copy")throw(0,f.createFileSystemProviderError)((0,g.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!M&&await w.Promises.exists(y)){if(!c)throw(0,f.createFileSystemProviderError)((0,g.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}async cloneFile(i,o){return this.doCloneFile(i,o,!1)}async doCloneFile(i,o,s){const c=this.toFilePath(i),a=this.toFilePath(o),y=!!(this.capabilities&1024);if((0,p.isEqual)(c,a,!y))return;const M=new v.DisposableStore;try{const[T,U]=await Promise.all([this.createResourceLock(i),this.createResourceLock(o)]);M.add(T),M.add(U),s&&await w.Promises.mkdir((0,b.dirname)(a),{recursive:!0}),await w.Promises.copyFile(c,a)}catch(T){if(T.code==="ENOENT"&&!s)return this.doCloneFile(i,o,!0);throw this.toFileSystemProviderError(T)}finally{M.dispose()}}createUniversalWatcher(i,o,s){return new h.UniversalWatcherClient(c=>i(c),c=>o(c),s)}createNonRecursiveWatcher(i,o,s){return new l.NodeJSWatcherClient(c=>i(c),c=>o(c),s)}toFileSystemProviderError(i){if(i instanceof f.FileSystemProviderError)return i;let o;switch(i.code){case"ENOENT":o=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=f.FileSystemProviderErrorCode.NoPermissions;break;default:o=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(i,o)}async toFileSystemProviderWriteError(i,o){let s=this.toFileSystemProviderError(o);if(i&&s.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await w.SymlinkSupport.stat(this.toFilePath(i));c.mode&128||(s=(0,f.createFileSystemProviderError)(o,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return s}}e.DiskFileSystemProvider=n,n.TRACE_LOG_RESOURCE_LOCKS=!1,n.canFlush=!0}),define(ee[204],te([0,1,3,86,2,17,57,22]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class p extends k.Disposable{constructor(C,I){super(),this.provider=C,this.logService=I,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(C,I,u){const w=this.getUriTransformer(C);switch(I){case"stat":return this.stat(w,u[0]);case"readdir":return this.readdir(w,u[0]);case"open":return this.open(w,u[0],u[1]);case"close":return this.close(u[0]);case"read":return this.read(u[0],u[1],u[2]);case"readFile":return this.readFile(w,u[0],u[1]);case"write":return this.write(u[0],u[1],u[2],u[3],u[4]);case"writeFile":return this.writeFile(w,u[0],u[1],u[2]);case"rename":return this.rename(w,u[0],u[1],u[2]);case"copy":return this.copy(w,u[0],u[1],u[2]);case"cloneFile":return this.cloneFile(w,u[0],u[1]);case"mkdir":return this.mkdir(w,u[0]);case"delete":return this.delete(w,u[0],u[1]);case"watch":return this.watch(w,u[0],u[1],u[2],u[3]);case"unwatch":return this.unwatch(u[0],u[1])}throw new Error(`IPC Command ${I} not found`)}listen(C,I,u){const w=this.getUriTransformer(C);switch(I){case"fileChange":return this.onFileChange(w,u[0]);case"readFileStream":return this.onReadFileStream(w,u[0],u[1])}throw new Error(`Unknown event ${I}`)}stat(C,I){const u=this.transformIncoming(C,I,!0);return this.provider.stat(u)}readdir(C,I){const u=this.transformIncoming(C,I);return this.provider.readdir(u)}async readFile(C,I,u){const w=this.transformIncoming(C,I,!0),g=await this.provider.readFile(w,u);return R.VSBuffer.wrap(g)}onReadFileStream(C,I,u){const w=this.transformIncoming(C,I,!0),g=new P.CancellationTokenSource,f=new E.Emitter({onDidRemoveLastListener:()=>{g.cancel()}}),d=this.provider.readFileStream(w,u,g.token);return(0,D.listenStream)(d,{onData:S=>f.fire(R.VSBuffer.wrap(S)),onError:S=>f.fire(S),onEnd:()=>{f.fire("end"),f.dispose(),g.dispose()}}),f.event}writeFile(C,I,u,w){const g=this.transformIncoming(C,I);return this.provider.writeFile(g,u.buffer,w)}open(C,I,u){const w=this.transformIncoming(C,I,!0);return this.provider.open(w,u)}close(C){return this.provider.close(C)}async read(C,I,u){const w=R.VSBuffer.alloc(u),g=0,f=await this.provider.read(C,I,w.buffer,g,u);return[w,f]}write(C,I,u,w,g){return this.provider.write(C,I,u.buffer,w,g)}mkdir(C,I){const u=this.transformIncoming(C,I);return this.provider.mkdir(u)}delete(C,I,u){const w=this.transformIncoming(C,I);return this.provider.delete(w,u)}rename(C,I,u,w){const g=this.transformIncoming(C,I),f=this.transformIncoming(C,u);return this.provider.rename(g,f,w)}copy(C,I,u,w){const g=this.transformIncoming(C,I),f=this.transformIncoming(C,u);return this.provider.copy(g,f,w)}cloneFile(C,I,u){const w=this.transformIncoming(C,I),g=this.transformIncoming(C,u);return this.provider.cloneFile(w,g)}onFileChange(C,I){const u=new E.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(I,this.createSessionFileWatcher(C,u))},onDidRemoveLastListener:()=>{(0,k.dispose)(this.sessionToWatcher.get(I)),this.sessionToWatcher.delete(I)}});return u.event}async watch(C,I,u,w,g){const f=this.sessionToWatcher.get(I);if(f){const d=this.transformIncoming(C,w),S=f.watch(u,d,g);this.watchRequests.set(I+u,S)}}async unwatch(C,I){const u=C+I,w=this.watchRequests.get(u);w&&((0,k.dispose)(w),this.watchRequests.delete(u))}dispose(){super.dispose();for(const[,C]of this.watchRequests)C.dispose();this.watchRequests.clear();for(const[,C]of this.sessionToWatcher)C.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=p;class v extends k.Disposable{constructor(C,I,u,w){super(),this.uriTransformer=C,this.logService=u,this.environmentService=w,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(I)}registerListeners(C){const I=this._register(new E.Emitter);this._register(I.event(u=>{C.fire(u.map(w=>({resource:this.uriTransformer.transformOutgoingURI(w.resource),type:w.type})))})),this._register(this.fileWatcher.onDidChangeFile(u=>I.fire(u))),this._register(this.fileWatcher.onDidWatchError(u=>C.fire(u)))}getRecursiveWatcherOptions(C){}getExtraExcludes(C){}watch(C,I,u){const w=this.getExtraExcludes(this.environmentService);return Array.isArray(w)&&(u.excludes=[...u.excludes,...w]),this.watcherRequests.set(C,this.fileWatcher.watch(I,u)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.watcherRequests.get(C)),this.watcherRequests.delete(C)})}dispose(){super.dispose();for(const[,C]of this.watcherRequests)C.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=v}),define(ee[205],te([0,1,13,160,4,7,15,9,204,139]),function(z,e,E,t,k,R,D,P,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class b extends p.AbstractDiskFileSystemProviderChannel{constructor(u,w,g){super(u,w),this.environmentService=g}getUriTransformer(u){return v.DefaultURITransformer}transformIncoming(u,w){return R.URI.revive(w)}async delete(u,w,g){if(!g.useTrash)return super.delete(u,w,g);const f=this.transformIncoming(u,w),d=(0,P.normalize)(f.fsPath);try{await E.shell.trashItem(d)}catch{throw(0,D.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,P.basename)(d)):(0,t.localize)(1,null,(0,P.basename)(d)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(u,w){return new C(u,w,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=b;class C extends p.AbstractSessionFileWatcher{watch(u,w,g){if(g.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(u,w,g)}}}),define(ee[206],te([0,1,6]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,D){switch(D){case E.LogLevel.Trace:return R.trace;case E.LogLevel.Debug:return R.debug;case E.LogLevel.Info:return R.info;case E.LogLevel.Warning:return R.warn;case E.LogLevel.Error:return R.error;default:throw new Error("Invalid log level")}}class k extends E.AbstractLogger{constructor(D=E.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(D),this._register(this.onDidChangeLogLevel(P=>{this._logger?.setLevel(P)}))}set logger(D){this._logger=D;for(const{level:P,args:p}of this.buffer)t(D,P).apply(D,p);this.buffer=[]}_log(D,...P){this._logger?t(this._logger,D).apply(this._logger,P):this.getLevel()<=D&&this.buffer.push({level:D,args:P})}trace(D,...P){this._log(E.LogLevel.Trace,D,...P)}debug(D,...P){this._log(E.LogLevel.Debug,D,...P)}info(D,...P){this._log(E.LogLevel.Info,D,...P)}warn(D,...P){this._log(E.LogLevel.Warning,D,...P)}error(D,...P){this._log(E.LogLevel.Error,D,...P)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=k}),define(ee[207],te([0,1,3,7,6]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(I,u){this.logService=I,this.loggerService=u,this.onDidChangeLogLevel=E.Event.buffer(I.onDidChangeLogLevel,!0)}listen(I,u){switch(u){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${u}`)}async call(I,u,w){switch(u){case"setLevel":return w[1]?this.loggerService.setLevel(t.URI.revive(w[1]),w[0]):this.logService.setLevel(w[0])}throw new Error(`Call not found: ${u}`)}}e.LogLevelChannel=R;class D{constructor(I){this.channel=I}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(I,u){D.setLevel(this.channel,I,u)}static setLevel(I,u,w){return I.call("setLevel",[u,w])}}e.LogLevelChannelClient=D;class P{constructor(I){this.loggerService=I,this.loggers=new Map}listen(I,u){throw new Error(`Event not found: ${u}`)}async call(I,u,w){switch(u){case"createLogger":this.createLogger(t.URI.revive(w[0]),w[1]);return;case"log":return this.log(t.URI.revive(w[0]),w[1]);case"consoleLog":return this.consoleLog(w[0],w[1])}throw new Error(`Call not found: ${u}`)}createLogger(I,u){this.loggers.set(I.toString(),this.loggerService.createLogger(I,u))}consoleLog(I,u){let w=console.log;switch(I){case k.LogLevel.Error:w=console.error;break;case k.LogLevel.Warning:w=console.warn;break;case k.LogLevel.Info:w=console.info;break}w.call(console,...u)}log(I,u){const w=this.loggers.get(I.toString());if(!w)throw new Error("Create the logger before logging");for(const[g,f]of u)(0,k.log)(w,g,f)}}e.LoggerChannel=P;class p extends k.AbstractLoggerService{constructor(I,u,w){super(I,u),this.channel=w}createConsoleMainLogger(){return new k.AdapterLogger({log:(I,u)=>{this.channel.call("consoleLog",[I,u])}})}doCreateLogger(I,u,w){return new v(this.channel,I,u,w)}}e.LoggerChannelClient=p;class v extends k.AbstractMessageLogger{constructor(I,u,w,g){super(g?.always),this.channel=I,this.file=u,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(w),this.channel.call("createLogger",[u,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,u){const w=[[I,u]];this.isLoggerCreated?this.doLog(w):this.buffer.push(...w)}doLog(I){this.channel.call("log",[this.file,I])}}class b extends k.LogService{constructor(I,u){super(u),this.parent=I,this._register(I.onDidChangeLogLevel(w=>u.setLevel(w)))}setLevel(I){super.setLevel(I),this.parent.setLevel(I)}}e.FollowerLogService=b}),define(ee[208],te([0,1,15,6]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(k||(k={}));async function R(v,b,C,I,u){try{const w=await new Promise((f,d)=>{z(["spdlog"],f,d)});w.setFlushOn(t.LogLevel.Trace);const g=await w.createAsyncRotatingLogger(v,b,C,I);return u?g.clearFormatters():g.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),g}catch(w){console.error(w)}return null}function D(v,b,C){switch(b){case t.LogLevel.Trace:v.trace(C);break;case t.LogLevel.Debug:v.debug(C);break;case t.LogLevel.Info:v.info(C);break;case t.LogLevel.Warning:v.warn(C);break;case t.LogLevel.Error:v.error(C);break;default:throw new Error("Invalid log level")}}function P(v,b){switch(b){case t.LogLevel.Trace:v.setLevel(k.Trace);break;case t.LogLevel.Debug:v.setLevel(k.Debug);break;case t.LogLevel.Info:v.setLevel(k.Info);break;case t.LogLevel.Warning:v.setLevel(k.Warning);break;case t.LogLevel.Error:v.setLevel(k.Error);break;case t.LogLevel.Off:v.setLevel(k.Off);break;default:throw new Error("Invalid log level")}}class p extends t.AbstractMessageLogger{constructor(b,C,I,u,w){super(),this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(b,C,I,u),this._register(this.onDidChangeLogLevel(g=>{this._logger&&P(this._logger,g)}))}async _createSpdLogLogger(b,C,I,u){const w=I?6:1,g=30/w*E.ByteSize.MB,f=await R(b,C,g,w,u);if(f){this._logger=f,P(this._logger,this.getLevel());for(const{level:d,message:S}of this.buffer)D(this._logger,d,S);this.buffer=[]}}log(b,C){this._logger?D(this._logger,b,C):this.getLevel()<=b&&this.buffer.push({level:b,message:C})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=p}),define(ee[209],te([0,1,29,6,208]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let R=class extends t.AbstractLoggerService{constructor(P){super(P.getLevel(),P.onDidChangeLogLevel)}doCreateLogger(P,p,v){return new k.SpdLogLogger(v?.name||(0,E.generateUuid)(),P.fsPath,!v?.donotRotate,!!v?.donotUseFormatters,p)}};R=ve([ie(0,t.ILogService)],R),e.LoggerService=R}),define(ee[210],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function t(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(D){return!E(D)&&!t(D)&&!k(D)}e.isMenubarMenuItemAction=R}),define(ee[36],te([0,1,3,66,2,5]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class D extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(v){const b=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...v,...this.policyDefinitions},b!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(v),t.Iterable.reduce(this.policies.entries(),(C,[I,u])=>({...C,[I]:u}),{})}getPolicyValue(v){return this.policies.get(v)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(v,[b,C])=>({...v,[b]:{definition:C,value:this.policies.get(b)}}),{})}}e.AbstractPolicyService=D;class P{constructor(){this.onDidChange=E.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ee[211],te([0,1,8,3,66,12,15,6,36]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function v(C,I){const u=[];for(const w of k.Iterable.concat(C.keys(),I.keys()))C.get(w)!==I.get(w)&&u.push(w);return u}let b=class extends p.AbstractPolicyService{constructor(I,u,w){super(),this.file=I,this.fileService=u,this.logService=w,this.throttledDelayer=this._register(new E.ThrottledDelayer(500));const g=t.Event.filter(u.onDidFilesChange,f=>f.affects(I));this._register(u.watch(I)),this._register(g(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(I){await this.refresh()}async read(){const I=new Map;try{const u=await this.fileService.readFile(this.file),w=JSON.parse(u.value.toString());if(!(0,R.isObject)(w))throw new Error("Policy file isn't a JSON object");for(const g of Object.keys(w))this.policyDefinitions[g]&&I.set(g,w[g])}catch(u){u.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",u)}return I}async refresh(){const I=await this.read(),u=v(this.policies,I);this.policies=I,u.length>0&&this._onDidChange.fire(u)}};b=ve([ie(1,D.IFileService),ie(2,P.ILogService)],b),e.FilePolicyService=b}),define(ee[212],te([0,1,3,2,36]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(p){this.service=p,this.disposables=new t.DisposableStore}listen(p,v){switch(v){case"onDidChange":return E.Event.map(this.service.onDidChange,b=>b.reduce((C,I)=>({...C,[I]:this.service.getPolicyValue(I)??null}),{}),this.disposables)}throw new Error(`Event not found: ${v}`)}call(p,v,b){switch(v){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(b)}throw new Error(`Call not found: ${v}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class D extends k.AbstractPolicyService{constructor(p,v){super(),this.channel=v;for(const b in p){const{definition:C,value:I}=p[b];this.policyDefinitions[b]=C,I!==void 0&&this.policies.set(b,I)}this.channel.listen("onDidChange")(b=>{for(const C in b){const I=b[C];I===null?this.policies.delete(C):this.policies.set(C,I)}this._onDidChange.fire(Object.keys(b))})}async initializePolicies(p){const v=await this.channel.call("registerPolicyDefinitions",p);for(const b in v)this.policies.set(b,v[b])}}e.PolicyChannelClient=D}),define(ee[54],te([0,1,14,4,32,19]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const P=t.globals.vscode.context.configuration();if(P)D=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof z?.__$__nodeRequire=="function"){const P=(0,R.dirname)(E.FileAccess.asFileUri("",z));if(D=z.__$__nodeRequire((0,R.joinPath)(P,"product.json").fsPath),k.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const p=z.__$__nodeRequire((0,R.joinPath)(P,"package.json").fsPath);Object.assign(D,{version:p.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(ee[20],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[213],te([0,1,77,6,20]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(P,p){this.productService=P,this.logService=p,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(P,p){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const v=/^(.*)#([^#]+)$/.exec(p);if(!v)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",p),!1;const[,b,C]=v;let I=this.trustedExtensionUrlPublicKeys.get(P);if(!I){if(I=this.productService.trustedExtensionUrlPublicKeys[P],!I||I.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.trustedExtensionUrlPublicKeys.set(P,[...I])}const u=Buffer.from(decodeURIComponent(C),"base64");if(u.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",p),!1;const w=u.slice(0,6),g=u.readUIntBE(0,6),f=Date.now()-g;if(f<0||f>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",p),!1;const d=u.slice(6),S=E.createVerify("SHA256");S.write(w),S.write(Buffer.from(b)),S.end();for(let m=0;m<I.length;m++){let h=I[m];if(h!==null){if(typeof h=="string")try{h=E.createPublicKey({key:Buffer.from(h,"base64"),format:"der",type:"spki"}),I[m]=h}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${m+1} for ${P}:`,l),I[m]=null;continue}if(S.verify(h,d))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",p),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",p),!1}};R=ve([ie(0,k.IProductService),ie(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(ee[214],te([0,1,8,6]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let k=class{constructor(D,P,p){this._window=D,this._sessionId=P,this._logService=p}async inspect(D){await this._connect();const P=this._window.webContents.debugger;await P.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,E.timeout)(D);const p=await P.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),p.profile}async _connect(){const D=this._window.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async _disconnect(){const D=this._window.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};k=ve([ie(2,t.ILogService)],k),e.WindowProfiler=k}),define(ee[61],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(ee[46],te([0,1,121,12]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(D,P){E.ok(t.isString(D)),E.ok(t.isObject(P)),E.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,P)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new k}),define(ee[215],te([0,1,3,46]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class R{constructor(){this._onDidChangeSchema=new E.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,v){this.schemasById[k(p)]=v,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;t.Registry.add(e.Extensions.JSONContribution,D)}),define(ee[62],te([0,1,24,3,12,148,18,215,46]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var v;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(v=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=p.Registry.as(P.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const i=this.doRegisterConfigurations(n,r);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(n){const r=this.doDeregisterConfigurations(n);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:n,remove:r}){const i=[];i.push(...this.doDeregisterConfigurations(r)),i.push(...this.doRegisterConfigurations(n,!1)),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,E.distinct)(i)})}registerDefaultConfigurations(n){const r=[],i=[];for(const{overrides:o,source:s}of n)for(const c in o)if(r.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const a=this.configurationDefaultsOverrides.get(c),y=a?.valuesSources??new Map;if(s)for(const Y of Object.keys(o[c]))y.set(Y,s);const M={...a?.value||{},...o[c]};this.configurationDefaultsOverrides.set(c,{source:s,value:M,valuesSources:y});const T=(0,D.getLanguageTagSettingPlainKey)(c),U={type:"object",default:M,description:R.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:k.isString(s)?void 0:s,defaultValueSource:s};i.push(...g(c)),this.configurationProperties[c]=U,this.defaultLanguageConfigurationOverridesNode.properties[c]=U}else{this.configurationDefaultsOverrides.set(c,{value:o[c],source:s});const a=this.configurationProperties[c];a&&(this.updatePropertyDefaultValue(c,a),this.updateSchema(c,a))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const r=[];for(const{overrides:i,source:o}of n)for(const s in i){const c=this.configurationDefaultsOverrides.get(s),a=k.isString(o)?o:o?.id,y=k.isString(c?.source)?c?.source:c?.source?.id;if(a===y)if(r.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const M=this.configurationProperties[s];M&&(this.updatePropertyDefaultValue(s,M),this.updateSchema(s,M))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const r of n)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,r){const i=[];return n.forEach(o=>{i.push(...this.validateAndRegisterProperties(o,r,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),i}doDeregisterConfigurations(n){const r=[],i=o=>{if(o.properties)for(const s in o.properties){r.push(s);const c=this.configurationProperties[s];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,o.properties[s])}o.allOf?.forEach(s=>i(s))};for(const o of n){i(o);const s=this.configurationContributors.indexOf(o);s!==-1&&this.configurationContributors.splice(s,1)}return r}validateAndRegisterProperties(n,r=!0,i,o,s=3){s=k.isUndefinedOrNull(n.scope)?s:n.scope;const c=[],a=n.properties;if(a)for(const M in a){const T=a[M];if(r&&m(M,T)){delete a[M];continue}if(T.source=i,T.defaultDefaultValue=a[M].default,this.updatePropertyDefaultValue(M,T),e.OVERRIDE_PROPERTY_REGEX.test(M)?T.scope=void 0:(T.scope=k.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=k.isUndefinedOrNull(T.restricted)?!!o?.includes(M):T.restricted),a[M].hasOwnProperty("included")&&!a[M].included){this.excludedConfigurationProperties[M]=a[M],delete a[M];continue}else this.configurationProperties[M]=a[M],a[M].policy?.name&&this.policyConfigurations.set(a[M].policy.name,M);!a[M].deprecationMessage&&a[M].markdownDeprecationMessage&&(a[M].deprecationMessage=a[M].markdownDeprecationMessage),c.push(M)}const y=n.allOf;if(y)for(const M of y)c.push(...this.validateAndRegisterProperties(M,r,i,o,s));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const r=i=>{const o=i.properties;if(o)for(const c in o)this.updateSchema(c,o[c]);i.allOf?.forEach(r)};r(n)}updateSchema(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.resourceLanguageSettingsSchema.properties[n]=r;break}}removeFromSchema(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const r=`[${n}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,i),e.allSettings.properties[r]=i,e.applicationSettings.properties[r]=i,e.machineSettings.properties[r]=i,e.machineOverridableSettings.properties[r]=i,e.windowSettings.properties[r]=i,e.resourceSettings.properties[r]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,r){const i=this.configurationDefaultsOverrides.get(n);let o=i?.value,s=i?.source;k.isUndefined(o)&&(o=r.defaultDefaultValue,s=void 0),k.isUndefined(o)&&(o=d(r.type)),r.default=o,r.defaultValueSource=s}}const u="\\[([^\\]]+)\\]",w=new RegExp(u,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${u})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(l){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let r=w.exec(l);for(;r?.length;){const i=r[1].trim();i&&n.push(i),r=w.exec(l)}}return(0,E.distinct)(n)}e.overrideIdentifiersFromKey=g;function f(l){return l.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=f;function d(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const S=new I;p.Registry.add(e.Extensions.Configuration,S);function m(l,n){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?R.localize(7,null,l):S.getConfigurationProperties()[l]!==void 0?R.localize(8,null,l):n.policy?.name&&S.getPolicyConfigurations().get(n.policy?.name)!==void 0?R.localize(9,null,l,n.policy?.name,S.getPolicyConfigurations().get(n.policy?.name)):null:R.localize(6,null)}e.validateProperty=m;function h(){const l=[],n=S.getConfigurationProperties();for(const r of Object.keys(n))l.push([r,n[r].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=h}),define(ee[108],te([0,1,24,3,42,2,38,50,12,7,18,62,46]),function(z,e,E,t,k,R,D,P,p,v,b,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class u{constructor(r={},i=[],o=[],s){this._contents=r,this._keys=i,this._overrides=o,this.raw=s,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof u)return i;const o=new w("");return o.parseRaw(i),o.configurationModel});this._rawConfiguration=r.reduce((i,o)=>o===i?o:i.merge(o),r[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,b.getConfigurationValue)(this.contents,r):this.contents}inspect(r,i){const o=this.rawConfiguration.getValue(r),s=i?this.rawConfiguration.getOverrideValue(r,i):void 0,c=i?this.rawConfiguration.override(i).getValue(r):o;return{value:o,override:s,merged:c}}getOverrideValue(r,i){const o=this.getContentsForOverrideIdentifer(i);return o?r?(0,b.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const o of this.overrides)o.identifiers.includes(r)&&i.push(...o.keys);return E.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return E.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=P.deepClone(this.contents),o=P.deepClone(this.overrides),s=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const a of r)if(c.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.mergeContents(i,a.contents);for(const y of a.overrides){const[M]=o.filter(T=>E.equals(T.identifiers,y.identifiers));M?(this.mergeContents(M.contents,y.contents),M.keys.push(...y.keys),M.keys=E.distinct(M.keys)):o.push(P.deepClone(y))}for(const y of a.keys)s.indexOf(y)===-1&&s.push(y)}return new u(i,s,o,c.every(a=>a instanceof u)?void 0:c)}freeze(){return this.frozen=!0,this}clone(){return new u(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const o={};for(const s of E.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[s];const a=i[s];a&&(typeof c=="object"&&typeof a=="object"?(c=P.deepClone(c),this.mergeContents(c,a)):c=a),o[s]=c}return new u(o,this.keys,this.overrides)}mergeContents(r,i){for(const o of Object.keys(i)){if(o in r&&p.isObject(r[o])&&p.isObject(i[o])){this.mergeContents(r[o],i[o]);continue}r[o]=P.deepClone(i[o])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?P.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,o=null;const s=c=>{c&&(o?this.mergeContents(o,c):o=P.deepClone(c))};for(const c of this.overrides)E.equals(c.identifiers,[r])?i=c.contents:c.identifiers.includes(r)&&s(c.contents);return s(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,b.addToValueTree)(this.contents,r,i,o=>{throw new Error(o)})}removeValue(r){this.removeKey(r)&&(0,b.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let o=0;o<i;o++)r.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,r)}removeKey(r){const i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=u;class w{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new u}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!p.isUndefinedOrNull(r)){const o=this.doParseContent(r);this.parseRaw(o,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:o,keys:s,overrides:c,restricted:a,hasExcludedProperties:y}=this.doParseRaw(r,i);this._configurationModel=new u(o,s,c,y?[r]:void 0),this._restrictedConfigurations=a||[]}doParseContent(r){let i={},o=null,s=[];const c=[],a=[];function y(T){Array.isArray(s)?s.push(T):o!==null&&(s[o]=T)}const M={onObjectBegin:()=>{const T={};y(T),c.push(s),s=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const T=[];y(T),c.push(s),s=T,o=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:y,onError:(T,U,Y)=>{a.push({error:T,offset:U,length:Y})}};if(r)try{k.visit(r,M),i=s[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(r,i){const o=I.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),s=this.filter(r,o,!0,i);r=s.raw;const c=(0,b.toValuesTree)(r,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),a=Object.keys(r),y=this.toOverrides(r,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:c,keys:a,overrides:y,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}filter(r,i,o,s){let c=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const a={},y=[];for(const M in r)if(C.OVERRIDE_PROPERTY_REGEX.test(M)&&o){const T=this.filter(r[M],i,!1,s);a[M]=T.raw,c=c||T.hasExcludedProperties,y.push(...T.restricted)}else{const T=i[M],U=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&y.push(M),(U===void 0||s.scopes===void 0||s.scopes.includes(U))&&!(s.skipRestricted&&T?.restricted)?a[M]=r[M]:c=!0}return{raw:a,restricted:y,hasExcludedProperties:c}}toOverrides(r,i){const o=[];for(const s of Object.keys(r))if(C.OVERRIDE_PROPERTY_REGEX.test(s)){const c={};for(const a in r[s])c[a]=r[s][a];o.push({identifiers:(0,C.overrideIdentifiersFromKey)(s),keys:Object.keys(c),contents:(0,b.toValuesTree)(c,i)})}return o}}e.ConfigurationModelParser=w;class g extends R.Disposable{constructor(r,i,o,s){super(),this.userSettingsResource=r,this.scopes=i,this.fileService=s,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&o.isEqual(c.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new u}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class f{constructor(r,i,o,s,c,a,y,M,T,U,Y,G,V){this.key=r,this.overrides=i,this.value=o,this.overrideIdentifiers=s,this.defaultConfiguration=c,this.policyConfiguration=a,this.applicationConfiguration=y,this.userConfiguration=M,this.localUserConfiguration=T,this.remoteUserConfiguration=U,this.workspaceConfiguration=Y,this.folderConfigurationModel=G,this.memoryInspectValue=V}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class d{constructor(r,i,o,s,c=new u,a=new u,y=new D.ResourceMap,M=new u,T=new D.ResourceMap,U=!0){this._defaultConfiguration=r,this._policyConfiguration=i,this._applicationConfiguration=o,this._localUserConfiguration=s,this._remoteUserConfiguration=c,this._workspaceConfiguration=a,this._folderConfigurations=y,this._memoryConfiguration=M,this._memoryConfigurationByResource=T,this._freeze=U,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(r,i,o){return this.getConsolidatedConfigurationModel(r,i,o).getValue(r)}updateValue(r,i,o={}){let s;o.resource?(s=this._memoryConfigurationByResource.get(o.resource),s||(s=new u,this._memoryConfigurationByResource.set(o.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(r):s.setValue(r,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,o){const s=this.getConsolidatedConfigurationModel(r,i,o),c=E.distinct(s.overrides.map(M=>M.identifiers).flat()).filter(M=>s.getOverrideValue(r,M)!==void 0),a=this.getFolderConfigurationModelForResource(i.resource,o),y=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration;return new f(r,i,s.getValue(r),c.length?c:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),o?this._workspaceConfiguration.freeze():void 0,a?a.freeze():void 0,y.inspect(r,i.overrideIdentifier))}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const o=[];if(!i){const{added:s,updated:c,removed:a}=h(this._defaultConfiguration,r);i=[...s,...c,...a]}for(const s of i)for(const c of(0,C.overrideIdentifiersFromKey)(s)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(c),y=r.getKeysForOverrideIdentifier(c),M=[...y.filter(T=>a.indexOf(T)===-1),...a.filter(T=>y.indexOf(T)===-1),...a.filter(T=>!P.equals(this._defaultConfiguration.override(c).getValue(T),r.override(c).getValue(T)))];o.push([c,M])}return this.updateDefaultConfiguration(r),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:o,removed:s}=h(this._policyConfiguration,r),c=[...i,...o,...s];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:o,removed:s,overrides:c}=h(this.applicationConfiguration,r),a=[...i,...o,...s];return a.length&&this.updateApplicationConfiguration(r),{keys:a,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:o,removed:s,overrides:c}=h(this.localUserConfiguration,r),a=[...i,...o,...s];return a.length&&this.updateLocalUserConfiguration(r),{keys:a,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:o,removed:s,overrides:c}=h(this.remoteUserConfiguration,r),a=[...i,...o,...s];return a.length&&this.updateRemoteUserConfiguration(r),{keys:a,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:o,removed:s,overrides:c}=h(this.workspaceConfiguration,r),a=[...i,...o,...s];return a.length&&this.updateWorkspaceConfiguration(r),{keys:a,overrides:c}}compareAndUpdateFolderConfiguration(r,i){const o=this.folderConfigurations.get(r),{added:s,updated:c,removed:a,overrides:y}=h(o,i),M=[...s,...c,...a];return(M.length||!o)&&this.updateFolderConfiguration(r,i),{keys:M,overrides:y}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:s,removed:c,overrides:a}=h(i,void 0);return{keys:[...o,...s,...c],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,i,o){let s=this.getConsolidatedConfigurationModelForResource(i,o);return i.overrideIdentifier&&(s=s.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(s=s.merge(this._policyConfiguration)),s}getConsolidatedConfigurationModelForResource({resource:r},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const s=i.getFolder(r);s&&(o=this.getFolderConsolidatedConfiguration(s.uri)||o);const c=this._memoryConfigurationByResource.get(r);c&&(o=o.merge(c))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(r);s?(i=o.merge(s),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=o}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const o=i.getFolder(r);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:o,overrides:s,keys:c}=this._folderConfigurations.get(i);return r.push([i,{contents:o,overrides:s,keys:c}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>r.add(o))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),o=this.parseConfigurationModel(r.policy),s=this.parseConfigurationModel(r.application),c=this.parseConfigurationModel(r.user),a=this.parseConfigurationModel(r.workspace),y=r.folders.reduce((M,T)=>(M.set(v.URI.revive(T[0]),this.parseConfigurationModel(T[1])),M),new D.ResourceMap);return new d(i,o,s,c,new u,a,y,new u,new D.ResourceMap,!1)}static parseConfigurationModel(r){return new u(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=d;function S(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,i=new Map;for(const s of n)s.keys.forEach(c=>r.add(c)),s.overrides.forEach(([c,a])=>{const y=(0,D.getOrSet)(i,c,new Set);a.forEach(M=>y.add(M))});const o=[];return i.forEach((s,c)=>o.push([c,[...s.values()]])),{keys:[...r.values()],overrides:o}}e.mergeChanges=S;class m{constructor(r,i,o,s){this.change=r,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=s,this._previousConfiguration=void 0;const c=new Set;r.keys.forEach(y=>c.add(y)),r.overrides.forEach(([,y])=>y.forEach(M=>c.add(M))),this.affectedKeys=[...c.values()];const a=new u;this.affectedKeys.forEach(y=>a.setValue(y,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!P.equals(o,s)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let o=(0,b.toValuesTree)({[i]:!0},()=>{}),s;for(;typeof o=="object"&&(s=Object.keys(o)[0]);){if(r=r[s],!r)return!1;o=o[s]}return!0}}e.ConfigurationChangeEvent=m;function h(n,r){const{added:i,removed:o,updated:s}=l(r?.rawConfiguration,n?.rawConfiguration),c=[],a=n?.getAllOverrideIdentifiers()||[],y=r?.getAllOverrideIdentifiers()||[];if(r){const M=y.filter(T=>!a.includes(T));for(const T of M)c.push([T,r.getKeysForOverrideIdentifier(T)])}if(n){const M=a.filter(T=>!y.includes(T));for(const T of M)c.push([T,n.getKeysForOverrideIdentifier(T)])}if(r&&n){for(const M of a)if(y.includes(M)){const T=l({contents:n.getOverrideValue(void 0,M)||{},keys:n.getKeysForOverrideIdentifier(M)},{contents:r.getOverrideValue(void 0,M)||{},keys:r.getKeysForOverrideIdentifier(M)});c.push([M,[...T.added,...T.removed,...T.updated]])}}return{added:i,removed:o,updated:s,overrides:c}}function l(n,r){const i=n?r?n.keys.filter(c=>r.keys.indexOf(c)===-1):[...n.keys]:[],o=r?n?r.keys.filter(c=>n.keys.indexOf(c)===-1):[...r.keys]:[],s=[];if(n&&r){for(const c of r.keys)if(n.keys.indexOf(c)!==-1){const a=(0,b.getConfigurationValue)(r.contents,c),y=(0,b.getConfigurationValue)(n.contents,c);P.equals(a,y)||s.push(c)}}return{added:i,removed:o,updated:s}}}),define(ee[216],te([0,1,24,3,2,50,12,18,108,62,6,36,46]),function(z,e,E,t,k,R,D,P,p,v,b,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class u extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new w(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(I.Registry.as(v.Extensions.Configuration).onDidUpdateConfiguration(({properties:S,defaultsOverrides:m})=>this.onDidUpdateConfiguration(S,m))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(S,m){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:S})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=u;class w extends p.ConfigurationModel{constructor(S={}){const m=I.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(m),l=Object.create(null),n=[];for(const r in m){const i=S[r],o=i!==void 0?i:m[r].default;(0,P.addToValueTree)(l,r,o,s=>console.error(`Conflict in default settings: ${s}`))}for(const r of Object.keys(l))v.OVERRIDE_PROPERTY_REGEX.test(r)&&n.push({identifiers:(0,v.overrideIdentifiersFromKey)(r),keys:Object.keys(l[r]),contents:(0,P.toValuesTree)(l[r],i=>console.error(`Conflict in default settings file: ${i}`))});super(l,h,n)}}e.DefaultConfigurationModel=w;class g{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new p.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let f=class extends k.Disposable{get configurationModel(){return this._configurationModel}constructor(S,m,h){super(),this.defaultConfiguration=S,this.policyService=m,this.logService=h,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new p.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(S=>this.onDidChangePolicies(S))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:S})=>this.update(await this.registerPolicyDefinitions(S),!0))),this._configurationModel}async registerPolicyDefinitions(S){const m={},h=[],l=I.Registry.as(v.Extensions.Configuration).getConfigurationProperties();for(const n of S){const r=l[n];if(!r){h.push(n);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}h.push(n),m[r.policy.name]={type:r.type}}}return(0,D.isEmptyObject)(m)||await this.policyService.registerPolicyDefinitions(m),h}onDidChangePolicies(S){const m=I.Registry.as(v.Extensions.Configuration).getPolicyConfigurations(),h=(0,E.coalesce)(S.map(l=>m.get(l)));this.update(h,!0)}update(S,m){const h=I.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),l=[],n=this._configurationModel.isEmpty();for(const r of S){const i=h[r]?.policy?.name;if(i){const o=this.policyService.getPolicyValue(i);(n?o!==void 0:!(0,R.equals)(this._configurationModel.getValue(r),o))&&l.push([r,o])}else this._configurationModel.getValue(r)!==void 0&&l.push([r,void 0])}if(l.length){const r=this._configurationModel;this._configurationModel=new p.ConfigurationModel;for(const i of r.keys)this._configurationModel.setValue(i,r.getValue(i));for(const[i,o]of l)o===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,o);m&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};f=ve([ie(1,C.IPolicyService),ie(2,b.ILogService)],f),e.PolicyConfiguration=f}),define(ee[217],te([0,1,8,3,2,19,18,108,216,36]),function(z,e,E,t,k,R,D,P,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends k.Disposable{constructor(I,u,w,g){super(),this.settingsResource=I,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new p.DefaultConfiguration),this.policyConfiguration=w instanceof v.NullPolicyService?new p.NullPolicyConfiguration:this._register(new p.PolicyConfiguration(this.defaultConfiguration,w,g)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,u)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:f,properties:d})=>this.onDidDefaultConfigurationChange(f,d))),this._register(this.policyConfiguration.onDidChangeConfiguration(f=>this.onDidPolicyConfigurationChange(f))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[I,u,w]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(I,u,new P.ConfigurationModel,w)}getConfigurationData(){return this.configuration.toData()}getValue(I,u){const w=typeof I=="string"?I:void 0,g=(0,D.isConfigurationOverrides)(I)?I:(0,D.isConfigurationOverrides)(u)?u:{};return this.configuration.getValue(w,g,void 0)}updateValue(I,u,w,g){return Promise.reject(new Error("not supported"))}inspect(I){return this.configuration.inspect(I,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const I=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(I)}onDidChangeUserConfiguration(I){const u=this.configuration.toData(),w=this.configuration.compareAndUpdateLocalUserConfiguration(I);this.trigger(w,u,2)}onDidDefaultConfigurationChange(I,u){const w=this.configuration.toData(),g=this.configuration.compareAndUpdateDefaultConfiguration(I,u);this.trigger(g,w,7)}onDidPolicyConfigurationChange(I){const u=this.configuration.toData(),w=this.configuration.compareAndUpdatePolicyConfiguration(I);this.trigger(w,u,7)}trigger(I,u,w){const g=new P.ConfigurationChangeEvent(I,{data:u},this.configuration);g.source=w,g.sourceConfig=this.getTargetConfiguration(w),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(I){switch(I){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(ee[218],te([0,1,16,5]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends E.ErrorNoTelemetry{static isNotAvailable(P){return P instanceof R&&P._code===k.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof R&&P._code===k.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof R&&P._code===k.NoResolverFound}static isHandled(P){return P instanceof R&&P.isHandled}constructor(P,p=k.Unknown,v){super(P),this._message=P,this._code=p,this._detail=v,this.isHandled=p===k.NotAvailable&&v===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R}),define(ee[63],te([0,1,14]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(v){return v.scheme===E.Schemas.vscodeRemote?v.authority:void 0}e.getRemoteAuthority=t;function k(v){if(!v)return;const b=v.indexOf("+");return b<0?v:v.substr(0,b)}e.getRemoteName=k;function R(v){return`/${v.quality??"oss"}-${v.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(v){const{host:b,port:C}=p(v);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:C}}e.parseAuthorityWithPort=D;function P(v,b){let{host:C,port:I}=p(v);return typeof I>"u"&&(I=b),{host:C,port:I}}e.parseAuthorityWithOptionalPort=P;function p(v){const b=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const C=v.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const I=v.match(/(.*):(\d+)$/);return I?{host:I[1],port:parseInt(I[2],10)}:{host:v,port:void 0}}}),define(ee[109],te([0,1,25,5,63]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=R;function D(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var p;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(p=e.TargetPlatform||(e.TargetPlatform={}));class v{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,f){if(typeof g>"u"||g===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof g=="string"||typeof f=="string"){const d=typeof g=="string"?g:g.value,S=typeof f=="string"?f:f.value;return E.equalsIgnoreCase(d,S)}return g._lower===f._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=v;function b(w){return C(w)}e.isApplicationScopedExtension=b;function C(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function I(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function u(w,g){if(g){const f=`onResolveRemoteAuthority:${(0,k.getRemoteName)(g)}`;return w.activationEvents?.indexOf(f)!==-1}return!1}e.isResolverExtension=u,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[110],te([0,1,25,191,109,4,7,16,32]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function v(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,E.compareIgnoreCase)(r.id,i.id)===0}e.areSameExtensions=v;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class C{static create(i){const o=i.manifest?i.manifest.version:i.version,s=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new C(i.identifier,o,s)}static parse(i){const o=b.exec(i);return o&&o[1]&&o[2]?new C({id:o[1]},o[2],o[4]||void 0):null}constructor(i,o,s="undefined"){this.version=o,this.targetPlatform=s,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof C?v(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=C;const I=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function u(r){const i=I.exec(r);return i&&i[1]?[g(i[1]),i[2]]:[g(r),void 0]}e.getIdAndVersion=u;function w(r,i){return`${r}.${i}`}e.getExtensionId=w;function g(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=g;function f(r,i){return g(w(r,i))}e.getGalleryExtensionId=f;function d(r,i){const o=[],s=c=>{for(const a of o)if(a.some(y=>v(i(y),i(c))))return a;return null};for(const c of r){const a=s(c);a?a.push(c):o.push([c])}return o}e.groupByExtension=d;function S(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function m(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function h(r,i){const o=[],s=i.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const c=s.shift();if(c&&o.every(a=>!v(a.identifier,{id:c}))){const a=r.filter(y=>v(y.identifier,{id:c}));a.length===1&&(o.push(a[0]),s.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=h;async function l(r,i){if(!R.isLinux)return!1;let o;try{o=(await r.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await r.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(c))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=l;async function n(r,i){const o=await l(r,i),s=(0,t.getTargetPlatform)(o?"alpine":R.platform,p.arch);return i.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=n}),define(ee[87],te([0,1,8,17,2,38,7,110,15,5,6]),function(z,e,E,t,k,R,D,P,p,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,v.createDecorator)("IExtensionsProfileScannerService");let C=class extends k.Disposable{constructor(u,w){super(),this.fileService=u,this.logService=w,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(u){return this.withProfileExtensions(u)}addExtensionsToProfile(u,w){return this.withProfileExtensions(w,g=>(g=g.filter(f=>u.some(([d])=>!(0,P.areSameExtensions)(f.identifier,d.identifier))),g.push(...u.map(([f,d])=>({identifier:f.identifier,version:f.manifest.version,location:f.location,metadata:d}))),g))}removeExtensionFromProfile(u,w){return this.withProfileExtensions(w,g=>g.filter(f=>!(0,P.areSameExtensions)(f.identifier,u)))}async withProfileExtensions(u,w){return this.getResourceAccessQueue(u).queue(async()=>{let g=[];try{const f=await this.fileService.readFile(u),d=JSON.parse(f.value.toString());for(const S of d){if(!S.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",S);continue}if(!S.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",S);continue}if(!S.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",S);continue}g.push({identifier:S.identifier,location:D.URI.revive(S.location),version:S.version,metadata:S.metadata})}}catch(f){f.fileOperationResult!==1&&this.logService.error(f)}if(w){g=w(g);const f=g.map(d=>({identifier:d.identifier,version:d.version,location:d.location.toJSON(),metadata:d.metadata}));await this.fileService.writeFile(u,t.VSBuffer.fromString(JSON.stringify(f)))}return g})}getResourceAccessQueue(u){let w=this.resourcesAccessQueueMap.get(u);return w||(w=new E.Queue,this.resourcesAccessQueueMap.set(u,w)),w}};C=ve([ie(0,p.IFileService),ie(1,b.ILogService)],C),e.ExtensionsProfileScannerService=C}),define(ee[219],te([0,1,8,17,22,16,3,2,29,101,218,63]),function(z,e,E,t,k,R,D,P,p,v,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var u;(function(N){N[N.Management=1]="Management",N[N.ExtensionHost=2]="ExtensionHost",N[N.Tunnel=3]="Tunnel"})(u=e.ConnectionType||(e.ConnectionType={}));function w(N){switch(N){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(N){const $=new k.CancellationTokenSource;return setTimeout(()=>$.cancel(),N),$.token}function f(N,$){if(N.isCancellationRequested||$.isCancellationRequested)return k.CancellationToken.Cancelled;const L=new k.CancellationTokenSource;return N.onCancellationRequested(()=>L.cancel()),$.onCancellationRequested(()=>L.cancel()),L.token}class d{get didTimeout(){return this._state==="timedout"}constructor($){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((L,W)=>{this._resolvePromise=L,this._rejectPromise=W}),$.isCancellationRequested?this._timeout():this._disposables.add($.onCancellationRequested(()=>this._timeout()))}registerDisposable($){this._state==="pending"?this._disposables.add($):$.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const $=new Error("Time limit reached");return $.code="ETIMEDOUT",$.syscall="connect",$}resolve($){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise($))}reject($){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise($))}}function S(N,$){const L=new d($);return L.registerDisposable(N.onControlMessage(W=>{const j=JSON.parse(W.toString()),q=F(j);q?L.reject(q):L.resolve(j)})),L.promise}function m(N,$,L,W,j,q,X,re){const B=new d(re);return $.connect(L,W,j,q,X,(J,Z)=>{B.didTimeout?(J&&N.error(J),Z?.dispose()):J||!Z?B.reject(J):B.resolve(Z)}),B.promise}function h(N,$){const L=new d($);return N.then(W=>{L.didTimeout||L.resolve(W)},W=>{L.didTimeout||L.reject(W)}),L.promise}async function l(N,$,L,W){const j=_(N,$);N.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let q;try{q=await m(N.logService,N.socketFactory,N.host,N.port,(0,C.getRemoteServerRootPath)(N),`reconnectionToken=${N.reconnectionToken}&reconnection=${N.reconnectionProtocol?"true":"false"}`,`renderer-${w($)}-${N.reconnectionToken}`,W)}catch(Z){throw N.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),N.logService.error(Z),Z}N.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let X,re;N.reconnectionProtocol?(N.reconnectionProtocol.beginAcceptReconnection(q,null),X=N.reconnectionProtocol,re=!1):(X=new v.PersistentProtocol(q,null),re=!0),N.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const B=await h(N.signService.createNewMessage((0,p.generateUuid)()),W),J={type:"auth",auth:N.connectionToken||"00000000000000000000",data:B.data};X.sendControl(t.VSBuffer.fromString(JSON.stringify(J)));try{const Z=await S(X,f(W,g(1e4)));if(Z.type!=="sign"||typeof Z.data!="string"){const Te=new Error("Unexpected handshake message");throw Te.code="VSCODE_CONNECTION_ERROR",Te}if(N.logService.trace(`${j} 4/6. received SignRequest control message.`),!await h(N.signService.validate(B,Z.signedData),W)){const Te=new Error("Refused to connect to unsupported server");throw Te.code="VSCODE_CONNECTION_ERROR",Te}const ge=await h(N.signService.sign(Z.data),W),De={type:"connectionType",commit:N.commit,signedData:ge,desiredConnectionType:$};return L&&(De.args=L),N.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),X.sendControl(t.VSBuffer.fromString(JSON.stringify(De))),{protocol:X,ownsProtocol:re}}catch(Z){throw Z&&Z.code==="ETIMEDOUT"&&(N.logService.error(`${j} the handshake timed out. Error:`),N.logService.error(Z)),Z&&Z.code==="VSCODE_CONNECTION_ERROR"&&(N.logService.error(`${j} received error control message when negotiating connection. Error:`),N.logService.error(Z)),re&&H(X),Z}}async function n(N,$,L,W){const j=Date.now(),q=_(N,$),{protocol:X,ownsProtocol:re}=await l(N,$,L,W),B=new d(W);return B.registerDisposable(X.onControlMessage(J=>{const Z=JSON.parse(J.toString()),ce=F(Z);ce?(N.logService.error(`${q} received error control message when negotiating connection. Error:`),N.logService.error(ce),re&&H(X),B.reject(ce)):(N.reconnectionProtocol?.endAcceptReconnection(),N.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${ne(j)}!`),B.resolve({protocol:X,firstMessage:Z}))})),B.promise}async function r(N,$){const{protocol:L}=await n(N,1,void 0,$);return{protocol:L}}async function i(N,$,L){const{protocol:W,firstMessage:j}=await n(N,2,$,L),q=j&&j.debugPort;return{protocol:W,debugPort:q}}async function o(N,$,L){const W=Date.now(),j=_(N,3),{protocol:q}=await l(N,3,$,L);return N.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${ne(W)}!`),q}async function s(N,$,L){const{host:W,port:j,connectionToken:q}=await N.addressProvider.getAddress();return{commit:N.commit,quality:N.quality,host:W,port:j,connectionToken:q,reconnectionToken:$,reconnectionProtocol:L,socketFactory:N.socketFactory,signService:N.signService,logService:N.logService}}async function c(N,$,L){return y(N,async W=>{const{protocol:j}=await r(W,k.CancellationToken.None);return new fe(N,$,L,W.reconnectionToken,j)})}e.connectRemoteAgentManagement=c;async function a(N,$){return y(N,async L=>{const{protocol:W,debugPort:j}=await i(L,$,k.CancellationToken.None);return new K(N,$,L.reconnectionToken,W,j)})}e.connectRemoteAgentExtensionHost=a;async function y(N,$){for(let W=1;;W++)try{const j=(0,p.generateUuid)(),q=await s(N,j,null);return await $(q)}catch(j){if(W<5)N.logService.error(`[remote-connection][attempt ${W}] An error occurred in initial connection! Will retry... Error:`),N.logService.error(j);else throw N.logService.error(`[remote-connection][attempt ${W}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),N.logService.error(j),se.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(j)),j}}async function M(N,$,L){const W=await s(N,(0,p.generateUuid)(),null);return await o(W,{host:$,port:L},k.CancellationToken.None)}e.connectRemoteAgentTunnel=M;function T(N){return(0,E.createCancelablePromise)($=>new Promise((L,W)=>{const j=setTimeout(L,N*1e3);$.onCancellationRequested(()=>{clearTimeout(j),L()})}))}var U;(function(N){N[N.ConnectionLost=0]="ConnectionLost",N[N.ReconnectionWait=1]="ReconnectionWait",N[N.ReconnectionRunning=2]="ReconnectionRunning",N[N.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",N[N.ConnectionGain=4]="ConnectionGain"})(U=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class Y{constructor($,L){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=Y;class G{constructor($,L,W,j){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.durationSeconds=W,this.cancellableTimer=j,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=G;class V{constructor($,L,W){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=W,this.type=2}}e.ReconnectionRunningEvent=V;class oe{constructor($,L,W){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=W,this.type=4}}e.ConnectionGainEvent=oe;class ae{constructor($,L,W,j){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=W,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=ae;class se extends P.Disposable{static triggerPermanentFailure($,L,W){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=$,this._permanentFailureAttempt=L,this._permanentFailureHandled=W,this._instances.forEach(j=>j._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach($=>$._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach($=>$._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||se._permanentFailure}constructor($,L,W,j,q){super(),this._connectionType=$,this._options=L,this.reconnectionToken=W,this.protocol=j,this._reconnectionFailureIsFatal=q,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new oe(this.reconnectionToken,0,0)),this._register(j.onSocketClose(X=>{const re=O(this._connectionType,this.reconnectionToken,!0);X?X.type===0?(this._options.logService.info(`${re} received socket close event (hadError: ${X.hadError}).`),X.error&&this._options.logService.error(X.error)):(this._options.logService.info(`${re} received socket close event (wasClean: ${X.wasClean}, code: ${X.code}, reason: ${X.reason}).`),X.event&&this._options.logService.error(X.event)):this._options.logService.info(`${re} received socket close event.`),this._beginReconnecting()})),this._register(j.onSocketTimeout(X=>{const re=O(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${X.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${X.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${X.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),se._instances.push(this),this._register((0,P.toDisposable)(()=>{const X=se._instances.indexOf(this);X>=0&&se._instances.splice(X,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(se._permanentFailureMillisSinceLastIncomingData,se._permanentFailureAttempt,se._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const $=O(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${$} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const j=W<L.length?L[W]:L[L.length-1];try{if(j>0){const X=T(j);this._onDidStateChange.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,X)),this._options.logService.info(`${$} waiting for ${j} seconds before reconnecting...`);try{await X}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${$} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this._options.logService.info(`${$} resolving connection...`);const q=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${$} connecting to ${q.host}:${q.port}...`),await this._reconnect(q,g(I)),this._options.logService.info(`${$} reconnected!`),this._onDidStateChange.fire(new oe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${$} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this._options.logService.error(`${$} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(q)){this._options.logService.info(`${$} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this._options.logService.info(`${$} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if((0,R.isCancellationError)(q)){this._options.logService.info(`${$} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(q);continue}if(q instanceof b.RemoteAuthorityResolverError){this._options.logService.error(`${$} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,b.RemoteAuthorityResolverError.isHandled(q));break}this._options.logService.error(`${$} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(q),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure($,L,W){this._reconnectionFailureIsFatal?se.triggerPermanentFailure($,L,W):this._gotoPermanentFailure($,L,W)}_gotoPermanentFailure($,L,W){this._onDidStateChange.fire(new ae(this.reconnectionToken,$,L,W)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=se,se._permanentFailure=!1,se._permanentFailureMillisSinceLastIncomingData=0,se._permanentFailureAttempt=0,se._permanentFailureHandled=!1,se._instances=[];class fe extends se{constructor($,L,W,j,q){super(1,$,j,q,!0),this.client=this._register(new v.Client(q,{remoteAuthority:L,clientId:W},$.ipcLogger))}async _reconnect($,L){await r($,L)}}e.ManagementPersistentConnection=fe;class K extends se{constructor($,L,W,j,q){super(2,$,W,j,!1),this._startArguments=L,this.debugPort=q}async _reconnect($,L){await i($,this._startArguments,L)}}e.ExtensionHostPersistentConnection=K;function H(N){try{N.acceptDisconnect();const $=N.getSocket();N.dispose(),$.dispose()}catch($){(0,R.onUnexpectedError)($)}}function F(N){if(N&&N.type==="error"){const $=new Error(`Connection error: ${N.reason}`);return $.code="VSCODE_CONNECTION_ERROR",$}return null}function A(N,$){for(;N.length<$;)N+=" ";return N}function O(N,$,L){return`[remote-connection][${A(w(N),13)}][${$.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function _(N,$){return`${O($,N.reconnectionToken,!!N.reconnectionProtocol)}[${N.host}:${N.port}]`}function ne(N){return`${Date.now()-N} ms`}}),define(ee[220],te([0,1,78,83]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,D,P,p,v){const b=I=>v(I,void 0),C=E.createConnection({host:k,port:R},()=>{C.removeListener("error",b);const I=Buffer.alloc(16);for(let f=0;f<16;f++)I[f]=Math.round(Math.random()*256);const u=I.toString("base64"),w=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${D}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${u}`];C.write(w.join(`\r
`)+`\r
\r
`);const g=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(C.off("data",g),v(void 0,new t.NodeSocket(C,p)))};C.on("data",g)});C.setNoDelay(!0),C.once("error",b)}}}),define(ee[221],te([0,1,27,44,39,182]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let D;async function P(u=!1){return(D===void 0||u)&&(D=p()),D}e.hasWSLFeatureInstalled=P;async function p(){const u=v();if(u===void 0)return!1;if(u>=22e3){const w=C();if(w)return new Promise(g=>{t.execFile(w,["--status"],f=>g(!f))})}else{const w=I();if(w)try{if((await k.promises.stat(w)).isFile())return!0}catch{}}return!1}function v(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(u)return parseInt(u[3])}function b(u){const w=process.env.SystemRoot;if(w){const g=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(w,g?"Sysnative":"System32",u)}}function C(){return b("wsl.exe")}function I(){return b("lxss\\LxssManager.dll")}}),define(ee[55],te([0,1,17,165,62,5,46]),function(z,e,E,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function P(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=P;function p(g){return g.res.statusCode===204}async function v(g){return p(g)?null:(await(0,E.streamToBuffer)(g.stream)).toString()}e.asText=v;async function b(g){if(!P(g))throw new Error("Server returned "+g.res.statusCode);return v(g)}e.asTextOrError=b;async function C(g){if(!P(g))throw new Error("Server returned "+g.res.statusCode);if(p(g))return null;const d=(await(0,E.streamToBuffer)(g.stream)).toString();try{return JSON.parse(d)}catch(S){throw S.message+=`:
`+d,S}}e.asJson=C;function I(g){w(g)}e.updateProxyConfigurationsScope=I;let u;function w(g){const f=D.Registry.as(k.Extensions.Configuration),d=u;u={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},f.updateConfigurations({add:[u],remove:d?[d]:[]})}w(2)}),define(ee[222],te([0,1,17,22]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(P){this.service=P}listen(P,p){throw new Error("Invalid listen")}call(P,p,v,b=t.CancellationToken.None){switch(p){case"request":return this.service.request(v[0],b).then(async({res:C,stream:I})=>{const u=await(0,E.streamToBuffer)(I);return[{statusCode:C.statusCode,headers:C.headers},u]});case"resolveProxy":return this.service.resolveProxy(v[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(P){this.channel=P}async request(P,p){const[v,b]=await this.channel.call("request",[P],p);return{res:v,stream:(0,E.bufferToStream)(b)}}async resolveProxy(P){return this.channel.call("resolveProxy",[P])}}e.RequestChannelClient=R}),define(ee[223],te([0,1,224,12]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(D,P){return D.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:D.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function R(D,P,p={}){const v=(0,E.parse)(D),b=p.proxyUrl||k(v,P);if(!b)return null;const C=(0,E.parse)(b);if(!/^https?:$/.test(C.protocol||""))return null;const I={host:C.hostname||"",port:C.port||(C.protocol==="https"?"443":"80"),auth:C.auth,rejectUnauthorized:(0,t.isBoolean)(p.strictSSL)?p.strictSSL:!0};return v.protocol==="http:"?new(await new Promise((u,w)=>{z(["http-proxy-agent"],u,w)}))(I):new(await new Promise((u,w)=>{z(["https-proxy-agent"],u,w)}))(I)}e.getProxyAgent=R}),define(ee[111],te([0,1,44,9,166,22,43,16,4,29,142,59,8]),function(z,e,E,t,k,R,D,P,p,v,b,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const u=1e4;let w;async function g(d,S,m){return S["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(m)&&!S["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(m)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=I.Promises.withAsyncBody(async(h,l)=>{const n=new R.CancellationTokenSource,r=setTimeout(()=>{n.dispose(!0),l(new Error((0,k.localize)(0,null)))},u);try{h(await f(d,n.token))}catch(i){!(0,P.isCancellationError)(i)&&!n.token.isCancellationRequested?l(new Error((0,k.localize)(1,null,(0,D.toErrorMessage)(i)))):h({})}finally{clearTimeout(r),n.dispose()}})),w)}e.getResolvedShellEnv=g;async function f(d,S){const m=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",m);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",h);const l=(0,v.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(l+"(.*)"+l),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",r);const i=await(0,b.getSystemShell)(p.OS,r);return d.trace("getUnixShellEnvironment#shell",i),new Promise((o,s)=>{if(S.isCancellationRequested)return s((0,P.canceled)());const c=(0,t.basename)(i);let a,y;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(a=`& '${process.execPath}' ${M} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,y=["-Login","-Command"]):(a=`'${process.execPath}' ${M} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,c==="tcsh"?y=["-ic"]:y=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),a);const T=(0,E.spawn)(i,[...y,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});S.onCancellationRequested(()=>(T.kill(),s((0,P.canceled)()))),T.on("error",G=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(G)),s(G)});const U=[];T.stdout.on("data",G=>U.push(G));const Y=[];T.stderr.on("data",G=>Y.push(G)),T.on("close",(G,V)=>{const oe=Buffer.concat(U).toString("utf8");d.trace("getUnixShellEnvironment#raw",oe);const ae=Buffer.concat(Y).toString("utf8");if(ae.trim()&&d.trace("getUnixShellEnvironment#stderr",ae),G||V)return s(new Error((0,k.localize)(2,null,G,V)));const se=n.exec(oe),fe=se?se[1]:"{}";try{const K=JSON.parse(fe);m?K.ELECTRON_RUN_AS_NODE=m:delete K.ELECTRON_RUN_AS_NODE,h?K.ELECTRON_NO_ATTACH_CONSOLE=h:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",K),o(K)}catch(K){d.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(K)),s(K)}})})}}),define(ee[88],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[225],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{constructor(){this.validators=new Map}vsda(){return new Promise((k,R)=>z(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.vsda(),D=new R.validator;if(D){const P=String(E._nextId++);return this.validators.set(P,D),{id:P,data:D.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const D=this.validators.get(k.id);if(!D)return!1;this.validators.delete(k.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(k)}catch{}return k}}e.SignService=E,E._nextId=1}),define(ee[37],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,E.createDecorator)("stateMainService")}),define(ee[21],te([0,1,13,40,8,3,2,4,32,12,5,6,37,26]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,b.createDecorator)("lifecycleMainService");var w;(function(d){d[d.QUIT=1]="QUIT",d[d.KILL=2]="KILL"})(w=e.ShutdownReason||(e.ShutdownReason={}));var g;(function(d){d[d.Starting=1]="Starting",d[d.Ready=2]="Ready",d[d.AfterWindowOpen=3]="AfterWindowOpen",d[d.Eventually=4]="Eventually"})(g=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let f=class Ct extends D.Disposable{get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(S,m,h){super(),this.logService=S,this.stateMainService=m,this.environmentMainService=h,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(Ct.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(Ct.QUIT_AND_RESTART_KEY)}registerListeners(){const S=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),P.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};E.app.addListener("before-quit",S);const m=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!P.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",m),E.app.once("will-quit",h=>{this.trace("Lifecycle#app.on(will-quit)"),h.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),E.app.removeListener("before-quit",S),E.app.removeListener("window-all-closed",m),E.app.quit()})})}fireOnWillShutdown(S){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.trace("Lifecycle#onWillShutdown.fire()");const m=[];return this._onWillShutdown.fire({reason:S,join(h){m.push(h)}}),this.pendingWillShutdownPromise=(async()=>{try{await k.Promises.settled(m)}catch(h){this.logService.error(h)}try{await this.stateMainService.close()}catch(h){this.logService.error(h)}})(),this.pendingWillShutdownPromise}set phase(S){if(S<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===S)return;this.trace(`lifecycle (main): phase changed (value: ${S})`),this._phase=S;const m=this.phaseWhen.get(this._phase);m&&(m.open(),this.phaseWhen.delete(this._phase))}async when(S){if(S<=this._phase)return;let m=this.phaseWhen.get(S);m||(m=new k.Barrier,this.phaseWhen.set(S,m)),await m.wait()}registerWindow(S){const m=new D.DisposableStore;this.windowCounter++,m.add(S.onWillLoad(l=>this._onWillLoadWindow.fire({window:S,workspace:l.workspace,reason:l.reason})));const h=(0,v.assertIsDefined)(S.win);h.on("close",l=>{const n=S.id;if(this.windowToCloseRequest.has(n)){this.windowToCloseRequest.delete(n);return}this.trace(`Lifecycle#window.on('close') - window ID ${S.id}`),l.preventDefault(),this.unload(S,1).then(r=>{if(r){this.windowToCloseRequest.delete(n);return}this.windowToCloseRequest.add(n),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${n}`),this._onBeforeCloseWindow.fire(S),S.close()})}),h.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${S.id}`),this.windowCounter--,m.dispose(),this.windowCounter===0&&(!P.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(S,m){await this.unload(S,3)||S.reload(m)}unload(S,m){const h=this.mapWindowIdToPendingUnload.get(S.id);if(h)return h;const l=this.doUnload(S,m).finally(()=>{this.mapWindowIdToPendingUnload.delete(S.id)});return this.mapWindowIdToPendingUnload.set(S.id,l),l}async doUnload(S,m){if(!S.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${S.id}`);const h=this._quitRequested?2:m,l=await this.onBeforeUnloadWindowInRenderer(S,h);return l?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${S.id})`),this.handleWindowUnloadVeto(l)):(await this.onWillUnloadWindowInRenderer(S,h),!1)}handleWindowUnloadVeto(S){return S?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(S){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(S),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(S,m){return new Promise(h=>{const l=this.oneTimeListenerTokenGenerator++,n=`vscode:ok${l}`,r=`vscode:cancel${l}`;t.validatedIpcMain.once(n,()=>{h(!1)}),t.validatedIpcMain.once(r,()=>{h(!0)}),S.send("vscode:onBeforeUnload",{okChannel:n,cancelChannel:r,reason:m})})}onWillUnloadWindowInRenderer(S,m){return new Promise(h=>{const n=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(n,()=>h()),S.send("vscode:onWillUnload",{replyChannel:n,reason:m})})}quit(S){return this.trace(`Lifecycle#quit() - begin (willRestart: ${S})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(S&&this.stateMainService.setItem(Ct.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(m=>{this.pendingQuitPromiseResolve=m,this.trace("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.pendingQuitPromise)}trace(S){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(S):this.logService.trace(S)}async relaunch(S){this.trace("Lifecycle#relaunch()");const m=process.argv.slice(1);if(S?.addArgs&&m.push(...S.addArgs),S?.removeArgs)for(const n of S.removeArgs){const r=m.indexOf(n);r>=0&&m.splice(r,1)}const h=()=>{try{if(P.isWindows){const n=(0,p.cwd)();n!==process.cwd()&&process.chdir(n)}}catch(n){this.logService.error(n)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:m})};E.app.once("quit",h),await this.quit(!0)&&E.app.removeListener("quit",h)}async kill(S){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const m of E.BrowserWindow.getAllWindows())if(m&&!m.isDestroyed()){let h;m.webContents&&!m.webContents.isDestroyed()?h=new Promise(l=>m.once("closed",l)):h=Promise.resolve(),m.destroy(),await h}})()]),E.app.exit(S)}};f.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",f=ve([ie(0,C.ILogService),ie(1,I.IStateMainService),ie(2,u.IEnvironmentMainService)],f),e.LifecycleMainService=f}),define(ee[226],te([0,1,4,3,2,5,21]),function(z,e,E,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let P=class extends k.Disposable{constructor(b){super(),this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,b.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const b=await new Promise((C,I)=>{z(["native-keymap"],C,I)});this._keyboardLayoutData=p(b),E.isCI||b.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=p(b),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};P=ve([ie(0,D.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function p(v){const b=v.getKeyMap(),C=v.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:C}}}),define(ee[227],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,E.createDecorator)("stateService")}),define(ee[228],te([0,1,8,17,12,34,15,6]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class p{constructor(C,I,u){this.storagePath=C,this.logService=I,this.fileService=u,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new E.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(C){C.fileOperationResult!==1&&this.logService.error(C)}}getItem(C,I){const u=this.storage[C];return(0,k.isUndefinedOrNull)(u)?I:u}setItem(C,I){this.setItems([{key:C,data:I}])}setItems(C){let I=!1;for(const{key:u,data:w}of C)this.storage[u]!==w&&((0,k.isUndefinedOrNull)(w)?(0,k.isUndefined)(this.storage[u])||(this.storage[u]=void 0,I=!0):(this.storage[u]=w,I=!0));I&&this.save()}removeItem(C){(0,k.isUndefined)(this.storage[C])||(this.storage[C]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const C=JSON.stringify(this.storage,null,4);if(C!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(C)),this.lastSavedStorageContents=C}catch(I){this.logService.error(I)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=p;let v=class{constructor(C,I,u){this.fileStorage=new p(C.stateResource,I,u)}async init(){await this.fileStorage.init()}getItem(C,I){return this.fileStorage.getItem(C,I)}};v=ve([ie(0,R.IEnvironmentService),ie(1,P.ILogService),ie(2,D.IFileService)],v),e.StateService=v}),define(ee[229],te([0,1,228]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends E.StateService{setItem(R,D){this.fileStorage.setItem(R,D)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(ee[112],te([0,1,4,32,7,29]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(v){if(E.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}async function P(v,b,C,I,u,w,g,f,d,S){const m=Object.create(null);m["common.machineId"]=g,m.sessionID=(0,R.generateUuid)()+Date.now(),m.commitHash=u,m.version=w,m["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,E.PlatformToString)(E.platform),m["common.nodePlatform"]=t.platform,m["common.nodeArch"]=I,m["common.product"]=S||"desktop",f&&(m["common.msftInternal"]=f);let h=0;const l=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),E.isLinuxSnap&&(m["common.snap"]="true");const n=D(C);n&&(m["common.platformDetail"]=n);try{const r=await v.readFile(k.URI.file(d));m["common.source"]=r.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=P;function p(v){const b=t.env.USERDNSDOMAIN;if(!b)return!1;const C=b.toLowerCase();return v.some(I=>C===I)}e.verifyMicrosoftInternalDomain=p}),define(ee[35],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[230],te([0,1,27,8,42,14,9,4,7,81,23,100,84,15,20,35]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const f=new Map;async function d(n,r){const i=`${n}::${r.join(":")}`,o=f.get(i);if(o)return o;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,a=new Map,y=2e4;function M(U,Y,G,V){const oe=Y.substring(U.length+1);return t.Promises.withAsyncBody(async ae=>{let se;try{se=await b.Promises.readdir(Y,{withFileTypes:!0})}catch{ae();return}if(V.count>=y){V.count+=se.length,V.maxReached=!0,ae();return}let fe=se.length;if(fe===0){ae();return}let K=se;V.count+se.length>y&&(V.maxReached=!0,fe=y-V.count,K=se.slice(0,fe)),V.count+=se.length;for(const H of K)if(H.isDirectory()){if(G.includes(H.name)||await M(U,(0,D.join)(Y,H.name),G,V),--fe===0){ae();return}}else{const F=H.name.lastIndexOf(".");if(F>=0){const A=H.name.substring(F+1);A&&c.set(A,(c.get(A)??0)+1)}for(const A of s)A.relativePathPattern?.test(oe)!==!1&&A.filePattern.test(H.name)&&a.set(A.tag,(a.get(A.tag)??0)+1);if(--fe===0){ae();return}}})}const T=t.Promises.withAsyncBody(async U=>{const Y={count:0,maxReached:!1};await M(n,n,r,Y);const G=await h(n);U({configFiles:S(a),fileTypes:S(c),fileCount:Y.count,maxFilesReached:Y.maxReached,launchConfigFiles:G})});return f.set(i,T),T}e.collectWorkspaceStats=d;function S(n){return Array.from(n.entries(),([r,i])=>({name:r,count:i})).sort((r,i)=>i.count-r.count)}function m(){const n={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(v.virtualMachineHint.value()*100)}%`},r=E.cpus();return r&&r.length>0&&(n.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),n}e.getMachineInfo=m;async function h(n){try{const r=new Map,i=(0,D.join)(n,".vscode","launch.json"),o=await b.Promises.readFile(i),s=[],c=(0,k.parse)(o.toString(),s);if(s.length)return console.log(`Unable to parse ${i}`),[];if((0,k.getNodeType)(c)==="object"&&c.configurations)for(const a of c.configurations){const y=a.type;y&&(r.has(y)?r.set(y,r.get(y)+1):r.set(y,1))}return S(r)}catch{return[]}}e.collectLaunchConfigs=h;let l=class{constructor(r,i){this.telemetryService=r,this.productService=i}formatMachineInfo(r){const i=[];return i.push(`OS Version:       ${r.os}`),i.push(`CPUs:             ${r.cpus}`),i.push(`Memory (System):  ${r.memory}`),i.push(`VM:               ${r.vmHint}`),i.join(`
`)}formatEnvironment(r){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const o=E.cpus();return o&&o.length>0&&i.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),i.push(`Memory (System):  ${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||i.push(`Load (avg):       ${E.loadavg().map(s=>Math.round(s)).join(", ")}`),i.push(`VM:               ${Math.round(v.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${r.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(r,i){return Promise.all([(0,C.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async o=>{let[s,c]=o,a=this.formatProcessList(r,s);return i.forEach(y=>{if((0,I.isRemoteDiagnosticError)(y))a+=`
${y.errorMessage}`,c+=`
${y.errorMessage}`;else if(a+=`

Remote: ${y.hostName}`,y.processes&&(a+=`
${this.formatProcessList(r,y.processes)}`),y.workspaceMetadata){c+=`
|  Remote: ${y.hostName}`;for(const M of Object.keys(y.workspaceMetadata)){const T=y.workspaceMetadata[M];let U=`${T.fileCount} files`;T.maxFilesReached&&(U=`more than ${U}`),c+=`|    Folder (${M}): ${U}`,c+=this.formatWorkspaceStats(T)}}}),{processInfo:a,workspaceInfo:c}})}async getSystemInfo(r,i){const{memory:o,vmHint:s,os:c,cpus:a}=m(),y={os:c,memory:o,cpus:a,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:i};return P.isWindows||(y.load=`${E.loadavg().map(M=>Math.round(M)).join(", ")}`),P.isLinux&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(r,i){const o=[];return(0,C.listProcesses)(r.mainPID).then(async s=>(o.push(""),o.push(this.formatEnvironment(r)),o.push(""),o.push(this.formatProcessList(r,s)),r.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(r))),i.forEach(c=>{if((0,I.isRemoteDiagnosticError)(c))o.push(`
${c.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${c.hostName}`),o.push(this.formatMachineInfo(c.machineInfo)),c.processes&&o.push(this.formatProcessList(r,c.processes)),c.workspaceMetadata)for(const a of Object.keys(c.workspaceMetadata)){const y=c.workspaceMetadata[a];let M=`${y.fileCount} files`;y.maxFilesReached&&(M=`more than ${M}`),o.push(`Folder (${a}): ${M}`),o.push(this.formatWorkspaceStats(y))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(r){const i=[];let s=0;const c=(T,U)=>{const Y=` ${T}(${U})`;s+Y.length>60?(i.push(a),a="|                 ",s=a.length):s+=Y.length,a+=Y};let a="|      File types:";const y=10,M=r.fileTypes.length>y?y:r.fileTypes.length;for(let T=0;T<M;T++){const U=r.fileTypes[T];c(U.name,U.count)}if(i.push(a),r.configFiles.length>=0&&(a="|      Conf files:",s=0,r.configFiles.forEach(T=>{c(T.name,T.count)}),i.push(a)),r.launchConfigFiles.length>0){let T="|      Launch Configs:";r.launchConfigFiles.forEach(U=>{T+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),i.push(T)}return i.join(`
`)}expandGPUFeatures(r){const i=Math.max(...Object.keys(r).map(o=>o.length));return Object.keys(r).map(o=>`${o}:  ${" ".repeat(i-o.length)}  ${r[o]}`).join(`
                  `)}formatWorkspaceMetadata(r){const i=[],o=[];return r.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(i.push(`|  Window (${s.title})`),s.folderURIs.forEach(c=>{const a=p.URI.revive(c);if(a.scheme===R.Schemas.file){const y=a.fsPath;o.push(d(y,["node_modules",".git"]).then(M=>{let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),i.push(`|    Folder (${(0,D.basename)(y)}): ${T}`),i.push(this.formatWorkspaceStats(M))}).catch(M=>{i.push(`|      Error: Unable to collect workspace stats for folder ${y} (${M.toString()})`)}))}else i.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(s=>i.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(r,i){const o=new Map;r.windows.forEach(c=>o.set(c.pid,c.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(r.mainPID,o,s,i,0),s.join(`
`)}formatProcessItem(r,i,o,s,c){const a=c===0;let y;a?y=s.pid===r?`${this.productService.applicationName} main`:"remote agent":(y=`${"  ".repeat(c)} ${s.name}`,s.name==="window"&&(y=`${y} (${i.get(s.pid)})`));const M=process.platform==="win32"?s.mem:E.totalmem()*(s.mem/100);o.push(`${s.load.toFixed(0).padStart(5," ")}	${(M/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(s.children)&&s.children.forEach(T=>this.formatProcessItem(r,i,o,T,c+1))}async getWorkspaceFileExtensions(r){const i=new Set;for(const{uri:o}of r.folders){const s=p.URI.revive(o);if(s.scheme!==R.Schemas.file)continue;const c=s.fsPath;try{(await d(c,["node_modules",".git"])).fileTypes.forEach(y=>i.add(y.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(r){for(const{uri:i}of r.folders){const o=p.URI.revive(i);if(o.scheme!==R.Schemas.file)continue;const s=o.fsPath;try{const c=await d(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),c.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),c.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),c.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};l=ve([ie(0,g.ITelemetryService),ie(1,w.IProductService)],l),e.DiagnosticsService=l}),define(ee[231],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:P,data:p}){return this.appenders.forEach(v=>v.log(P,p)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class t{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(ee[73],te([0,1,50,96,12,18,112,35]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class p{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(o,s){return Promise.resolve(void 0)}publicLog2(o,s){return this.publicLog(o,s)}publicLogError(o,s){return Promise.resolve(void 0)}publicLogError2(o,s){return this.publicLogError(o,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class v{async publicLog(o,s,c){}async publicLogError(o,s,c){}}e.NullEndpointTelemetryService=v,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(i,o){return o.onDidChangeConfiguration(s=>{s.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(s.source),configurationKeys:d(s.sourceConfig)})})}e.configurationTelemetry=b;function C(i,o){return!(o.disableTelemetry||!i.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=C;function I(i){const o=i.getValue(P.TELEMETRY_SETTING_ID),s=i.getValue("telemetry.enableCrashReporter");if(i.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=I;function u(i){const o={},s={},c={};f(i,c);for(let a in c){a=a.length>150?a.substr(a.length-149):a;const y=c[a];typeof y=="number"?s[a]=y:typeof y=="boolean"?s[a]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${y.length}`),o[a]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(o[a]=y)}return{properties:o,measurements:s}}e.validateTelemetryData=u;const w=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function g(i){if(!i)return"none";for(const o of w)if(i.startsWith(`${o}+`))return o;return"other"}e.cleanRemoteAuthority=g;function f(i,o,s=0,c){if(!!i)for(const a of Object.getOwnPropertyNames(i)){const y=i[a],M=c?c+a:a;Array.isArray(y)?o[M]=(0,E.safeStringify)(y):y instanceof Date?o[M]=y.toISOString():(0,k.isObject)(y)?s<2?f(y,o,s+1,M+"."):o[M]=(0,E.safeStringify)(y):o[M]=y}}function d(i){if(!i)return[];const o=[];return S(o,"",i),o}function S(i,o,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(c=>S(i,o?`${o}.${c}`:c,s[c])):i.push(o)}function m(i,o){const s=i.msftInternalDomains||[],c=o.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(s)||c}e.isInternalTelemetry=m;function h(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=h;function l(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let s=i;const c=[];for(const T of o)for(;;){const U=T.exec(i);if(!U)break;c.push([U.index,T.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let M=0;for(s="";;){const T=y.exec(i);if(!T)break;const U=c.some(([Y,G])=>T.index<G&&Y<y.lastIndex);!a.test(T[0])&&!U&&(s+=i.substring(M,T.index)+"<REDACTED: user-file-path>",M=y.lastIndex)}return M<i.length&&(s+=i.substr(M)),s}function n(i){if(!i)return i;const o=i.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of s)if(c.regex.test(o))return`<REDACTED: ${c.label}>`;return i}function r(i,o){return(0,E.cloneAndChange)(i,s=>{if(typeof s=="string"){let c=s;c=l(c,o);for(const a of o)c=c.replace(a,"");return c=n(c),c}})}e.cleanData=r}),define(ee[232],te([0,1,188,73]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,D,P,p,v,b,C){const I={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${D.nameShort})`};if((0,t.supportsTelemetry)(D,P)&&(0,t.getTelemetryLevel)(p)===3){const u=await(0,E.getServiceMachineId)(P,v,b),{sessionId:w}=await C.getTelemetryInfo();I["X-Market-User-Id"]=u,I["VSCode-SessionId"]=w}return I}e.resolveMarketplaceHeaders=k}),define(ee[233],te([0,1,2,50,96,4,25,167,18,62,54,20,46,35,73]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{constructor(S,m,h){this._configurationService=m,this._productService=h,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new E.DisposableStore,this._cleanupPatterns=[],this._appenders=S.appenders,this._commonProperties=S.commonProperties||Promise.resolve({}),this._piiPaths=S.piiPaths||[],this._sendErrorTelemetry=!!S.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const l of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(l),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(S,m){this._experimentProperties[S]=m}_updateTelemetryLevel(){let S=(0,w.getTelemetryLevel)(this._configurationService);const m=this._productService.enabledTelemetryLevels;if(m){this._sendErrorTelemetry=this.sendErrorTelemetry?m.error:!1;const h=m.usage?3:m.error?2:0;S=Math.min(S,h)}this.telemetryLevel.value=S}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const S=await this._commonProperties,m=S.sessionID,h=S["common.machineId"],l=S["common.firstSessionDate"],n=S["common.msftInternal"];return{sessionId:m,machineId:h,firstSessionDate:l,msftInternal:n}}dispose(){this._disposables.dispose()}_log(S,m,h,l){return this.telemetryLevel.value<m?Promise.resolve(void 0):this._commonProperties.then(n=>{h=(0,t.mixin)(h,this._experimentProperties),h=(0,w.cleanData)(h,this._cleanupPatterns),h=(0,t.mixin)(h,n),this._appenders.forEach(r=>r.log(S,h))},n=>{console.error(n)})}publicLog(S,m,h){return this._log(S,3,m,h)}publicLog2(S,m,h){return this.publicLog(S,m,h)}publicLogError(S,m){return this._sendErrorTelemetry?this._log(S,2,m,!0):Promise.resolve(void 0)}publicLogError2(S,m){return this.publicLogError(S,m)}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=ve([ie(1,p.IConfigurationService),ie(2,C.IProductService)],g),e.TelemetryService=g;function f(){const d=(0,P.localize)(0,null,b.default.nameLong),S=b.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=R.isWeb?"":(0,P.localize)(3,null),h=(0,P.localize)(4,null),l=(0,P.localize)(5,null),n=(0,P.localize)(6,null),r=(0,P.localize)(7,null),i=`
|       | ${h} | ${l} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,P.localize)(8,null);return`
${d} ${S} ${m}

&nbsp;

${r}
${i}

&nbsp;

${o}
`}I.Registry.as(v.Extensions.Configuration).registerConfiguration({id:u.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[u.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:f(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(v.Extensions.Configuration).registerConfiguration({id:u.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[u.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,P.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,P.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${u.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[234],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var E;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(E=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===E.HIGH_CONTRAST_DARK||R===E.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===E.DARK||R===E.HIGH_CONTRAST_DARK}e.isDark=k}),define(ee[235],te([0,1,119,3,2,5,46,234]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var p;(function(f){function d(S){return S&&typeof S=="object"&&typeof S.id=="string"}f.isThemeColor=d})(p=e.ThemeColor||(e.ThemeColor={}));function v(f){return{id:f}}e.themeColorFromId=v;var b;(function(f){function d(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||p.isThemeColor(o.color))}f.isThemeIcon=d;const S=new RegExp(`^\\$\\((${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?)\\)$`);function m(o){const s=S.exec(o);if(!s)return;const[,c]=s;return{id:c}}f.fromString=m;function h(o){return{id:o}}f.fromId=h;function l(o,s){let c=o.id;const a=c.lastIndexOf("~");return a!==-1&&(c=c.substring(0,a)),s&&(c=`${c}~${s}`),{id:c}}f.modify=l;function n(o){const s=o.id.lastIndexOf("~");if(s!==-1)return o.id.substring(s+1)}f.getModifier=n;function r(o,s){return o.id===s.id&&o.color?.id===s.color?.id}f.isEqual=r;function i(o,s){return{id:o.id,color:s?v(s):void 0}}f.asThemeIcon=i,f.asClassNameArray=E.CSSIcon.asClassNameArray,f.asClassName=E.CSSIcon.asClassName,f.asCSSSelector=E.CSSIcon.asCSSSelector})(b=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=E.Codicon.file,e.FolderThemeIcon=E.Codicon.folder;function C(f){switch(f){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class I{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,k.toDisposable)(()=>{const S=this.themingParticipants.indexOf(d);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const u=new I;D.Registry.add(e.Extensions.ThemingContribution,u);function w(f){return u.onColorThemeChange(f)}e.registerThemingParticipant=w;class g extends k.Disposable{constructor(d){super(),this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,S){let m=this.theme.getColor(d);return m&&S&&(m=S(m,this.theme)),m?m.toString():null}}e.Themable=g}),define(ee[64],te([0,1,13,3,2,4,18,5,37]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const v="#FFFFFF",b="#1E1E1E",C="#000000",I="#FFFFFF",u="theme",w="themeBackground",g="windowSplash";e.IThemeMainService=(0,P.createDecorator)("themeMainService");let f=class extends k.Disposable{constructor(S,m){super(),this.stateMainService=S,this.configurationService=m,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,E.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const S=this.getColorScheme();if(S.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return S.dark?C:I;let m=this.stateMainService.getItem(w,null);if(!m)switch(this.stateMainService.getItem(u,"vs-dark").split(" ")[0]){case"vs":m=v;break;case"hc-black":m=C;break;case"hc-light":m=I;break;default:m=b}return R.isMacintosh&&m.toUpperCase()===b&&(m="#171717"),m}saveWindowSplash(S,m){this.stateMainService.setItems([{key:u,data:m.baseTheme},{key:w,data:m.colorInfo.background},{key:g,data:m}]),typeof S=="number"&&this.updateBackgroundColor(S,m)}updateBackgroundColor(S,m){for(const h of E.BrowserWindow.getAllWindows())if(h.id===S){h.setBackgroundColor(m.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(g)}};f=ve([ie(0,p.IStateMainService),ie(1,D.IConfigurationService)],f),e.ThemeMainService=f}),define(ee[113],te([0,1,3,18,5,6]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var D;(function(g){g.Http="http",g.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var p;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(p=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function v(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const f=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(!!f)return{address:f[1],port:+f[2]}}e.extractLocalHostUriMetaDataForPortMapping=v,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}e.isAllInterfaces=C;function I(g,f,d,S){if(d===1)return!1;if(d===2&&C(f)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(S);if(m?.length===4&&parseInt(m[1])>=18)return!1}return g<1024}e.isPortPrivileged=I;class u{constructor(f,d,S){this.remoteAddress=f,this.localAddress=d,this._dispose=S,this._onDispose=new E.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=u;let w=class{constructor(f,d){this.logService=f,this.configurationService=d,this._onTunnelOpened=new E.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new E.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new E.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const f=this.configurationService.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(f){return this._tunnelProvider=f,f?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(f){this._canElevate=f.elevation,this._privacyOptions=f.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const f=[],d=Array.from(this._tunnels.values());for(const S of d){const m=Array.from(S.values());for(const h of m){const l=await h.value;l&&f.push(l)}}return f}async dispose(){for(const f of this._tunnels.values()){for(const{value:d}of f.values())await d.then(S=>S?.dispose());f.clear()}this._tunnels.clear()}setEnvironmentTunnel(f,d,S,m,h){this.addTunnelToMap(f,d,Promise.resolve({tunnelRemoteHost:f,tunnelRemotePort:d,localAddress:S,privacy:m,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(f,d){(C(f)||b(f))&&(f=e.LOCALHOST_ADDRESSES[0]);const S=this.getTunnelFromMap(f,d);if(S)return++S.refcount,S.value}openTunnel(f,d,S,m,h=!1,l,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${S} on local port ${m}.`),!f)return;if(d||(d="localhost"),this._tunnelProvider&&this._factoryInProgress.has(S)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(f,d,S,m,h,l,n);return r?r.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(i);return(i.tunnelRemoteHost!==d||i.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(f){return{tunnelRemotePort:f.tunnelRemotePort,tunnelRemoteHost:f.tunnelRemoteHost,tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress,privacy:f.privacy,protocol:f.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${f.tunnelRemoteHost}:${f.tunnelRemotePort} `);const d=this._tunnels.get(f.tunnelRemoteHost);if(d){const S=d.get(f.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(f.tunnelRemoteHost,f.tunnelRemotePort,S))}}}}async tryDisposeTunnel(f,d,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${f}:${d}.`);const m=S.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(f)&&this._tunnels.get(f).delete(d),m}}async closeTunnel(f,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${f}:${d} `);const S=this._tunnels.get(f);if(S&&S.has(d)){const m=S.get(d);m.refcount=0,await this.tryDisposeTunnel(f,d,m)}}addTunnelToMap(f,d,S){this._tunnels.has(f)||this._tunnels.set(f,new Map),this._tunnels.get(f).set(d,{refcount:1,value:S})}async removeEmptyTunnelFromMap(f,d){const S=this._tunnels.get(f);S&&(await S.get(d)||S.delete(d),S.size===0&&this._tunnels.delete(f))}getTunnelFromMap(f,d){const S=[f];b(f)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):C(f)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const m=S.map(h=>this._tunnels.get(h));for(const h of m){const l=h?.get(d);if(l)return l}}canTunnel(f){return!!v(f)}createWithProvider(f,d,S,m,h,l,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${S} on local port ${m}.`);const r=S;this._factoryInProgress.add(r);const i=m===void 0?S:m,o={elevationRequired:h?this.isPortPrivileged(i):!1},s={remoteAddress:{host:d,port:S},localAddressPort:m,privacy:l,public:l?l!==P.Private:void 0,protocol:n},c=f.forwardPort(s,o);return c?(this.addTunnelToMap(d,S,c),c.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),c}};w=ve([ie(0,R.ILogService),ie(1,t.IConfigurationService)],w),e.AbstractTunnelService=w}),define(ee[236],te([0,1,78,27,95,220,8,2,18,6,20,219,113,88,4]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function g(h,l,n,r,i){let o;for(let s=3;s&&(o?.dispose(),o=await new f(h,l,n,r,i).waitForReady(),!(i&&k.BROWSER_RESTRICTED_PORTS[i]||!k.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));s--);return o}class f extends P.Disposable{constructor(l,n,r,i,o){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=o,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=l,this._server=E.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){const l=this.suggestedLocalPort??this.tunnelRemotePort,n=(0,I.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let r=await(0,k.findFreePortFaster)(l,2,1e3,n),i=null;return this._server.listen(r,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address(),i||(r=0,this._server.listen(r,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async _onConnection(l){l.pause();const n=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,C.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),i=r.getSocket().socket,o=r.readEntireBuffer();r.dispose(),o.byteLength>0&&l.write(o.buffer),l.on("end",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),i.end()}),l.on("close",()=>i.end()),l.on("error",()=>{l.localAddress&&this._socketsDispose.delete(l.localAddress),i.destroy()}),i.on("end",()=>l.end()),i.on("close",()=>l.end()),i.on("error",()=>{l.destroy()}),l.pipe(i),i.pipe(l),l.localAddress&&this._socketsDispose.set(l.localAddress,()=>{l.end(),i.end()})}}let d=class extends I.AbstractTunnelService{constructor(l,n,r,i,o){super(n,o),this.socketFactory=l,this.signService=r,this.productService=i}isPortPrivileged(l){return(0,I.isPortPrivileged)(l,this.defaultTunnelHost,w.OS,t.release())}retainOrCreateTunnel(l,n,r,i,o,s,c){const a=this.getTunnelFromMap(n,r);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,n,r,i,o,s,c);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${r} on local port ${i}.`);const y={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:l,signService:this.signService,logService:this.logService,ipcLogger:null},M=g(y,this.defaultTunnelHost,n,r,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,r,M),M}}};d=ve([ie(1,v.ILogService),ie(2,u.ISignService),ie(3,b.IProductService),ie(4,p.IConfigurationService)],d),e.BaseTunnelService=d;let S=class extends d{constructor(l,n,r,i){super(R.nodeSocketFactory,l,n,r,i)}};S=ve([ie(0,v.ILogService),ie(1,u.ISignService),ie(2,b.IProductService),ie(3,p.IConfigurationService)],S),e.TunnelService=S;let m=class extends P.Disposable{constructor(l,n,r,i){super(),this.logService=l,this.productService=n,this.signService=r,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(l,n,r,i,o,s,c,a){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${i} on local port ${o}.`),!this._tunnelServices.has(l)){const y=new S(this.logService,this.signService,this.productService,this.configurationService);this._register(y),this._tunnelServices.set(l,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this._tunnelServices.delete(l))})}return this._tunnelServices.get(l).openTunnel(n,r,i,o,s,c,a)}};m=ve([ie(0,v.ILogService),ie(1,b.IProductService),ie(2,u.ISignService),ie(3,p.IConfigurationService)],m),e.SharedTunnelsService=m}),define(ee[47],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,D)=>({type:"idle",updateType:R,error:D}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(ee[237],te([0,1,4,168,62,46]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[238],te([0,1,3,47]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(P){this.service=P}listen(P,p){switch(p){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${p}`)}call(P,p,v){switch(p){case"checkForUpdates":return this.service.checkForUpdates(v);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(v)}throw new Error(`Call not found: ${p}`)}}e.UpdateChannel=k;class R{get state(){return this._state}set state(P){this._state=P,this._onStateChange.fire(P)}constructor(P){this.channel=P,this._onStateChange=new E.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(p=>this.state=p),this.channel.call("_getInitialState").then(p=>this.state=p)}checkForUpdates(P){return this.channel.call("checkForUpdates",P)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(P){return this.channel.call("_applySpecificUpdate",P)}}e.UpdateChannelClient=R}),define(ee[89],te([0,1,8,22,3,18,26,21,6,20,55,47]),function(z,e,E,t,k,R,D,P,p,v,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function I(w,g,f){return`${f.updateUrl}/api/update/${w}/${g}/${f.commit}`}e.createUpdateURL=I;let u=class{get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}constructor(g,f,d,S,m,h){this.lifecycleMainService=g,this.configurationService=f,this.environmentMainService=d,this.requestService=S,this.logService=m,this.productService=h,this._state=C.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=this.getUpdateMode(),f=this.getProductQuality(g);if(!f){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(f),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(C.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,d=>this.logService.error(d))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,E.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(g){}getUpdateType(){return 1}doQuitAndInstall(){}};u=ve([ie(0,P.ILifecycleMainService),ie(1,R.IConfigurationService),ie(2,D.IEnvironmentMainService),ie(3,b.IRequestService),ie(4,p.ILogService),ie(5,v.IProductService)],u),e.AbstractUpdateService=u}),define(ee[239],te([0,1,13,53,3,2,18,26,21,6,20,55,35,47,89]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends w.AbstractUpdateService{get onRawError(){return k.Event.fromNodeEventEmitter(E.autoUpdater,"error",(d,S)=>S)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(d,S,m)=>({url:S,version:m,productVersion:m}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(d,S,m,h)=>({releaseNotes:S,version:m,productVersion:m,date:h}))}constructor(d,S,m,h,l,n,r){super(d,S,h,l,n,r),this.telemetryService=m,this.disposables=new R.DisposableStore}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(d){this.logService.error("UpdateService error:",d);const m=(this.state.type==="checking for updates"?this.state.explicit:!0)?d:void 0;this.setState(u.State.Idle(1,m))}buildUpdateFeedUrl(d){let S;this.productService.darwinUniversalAssetId?S=this.productService.darwinUniversalAssetId:S=process.arch==="x64"?"darwin":"darwin-arm64";const m=(0,w.createUpdateURL)(S,d,this.productService);try{E.autoUpdater.setFeedURL({url:m})}catch(h){this.logService.error("Failed to set update feed URL",h);return}return m}doCheckForUpdates(d){this.setState(u.State.CheckingForUpdates(d)),E.autoUpdater.checkForUpdates()}onUpdateAvailable(d){this.state.type==="checking for updates"&&this.setState(u.State.Downloading(d))}onUpdateDownloaded(d){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:d.version}),this.setState(u.State.Ready(d)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(u.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ve([t.memoize],g.prototype,"onRawError",null),ve([t.memoize],g.prototype,"onRawUpdateNotAvailable",null),ve([t.memoize],g.prototype,"onRawUpdateAvailable",null),ve([t.memoize],g.prototype,"onRawUpdateDownloaded",null),g=ve([ie(0,p.ILifecycleMainService),ie(1,D.IConfigurationService),ie(2,I.ITelemetryService),ie(3,P.IEnvironmentMainService),ie(4,C.IRequestService),ie(5,v.ILogService),ie(6,b.IProductService)],g),e.DarwinUpdateService=g}),define(ee[240],te([0,1,44,39,8,3,9,26,21,6,35,47]),function(z,e,E,t,k,R,D,P,p,v,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let I=class{get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}constructor(g,f,d){if(this.lifecycleMainService=g,this.logService=d,this._state=C.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,f.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(C.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,S=>this.logService.error(S))}scheduleCheckForUpdates(g=60*60*1e3){return(0,k.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(g){}};I=ve([ie(0,p.ILifecycleMainService),ie(1,P.IEnvironmentMainService),ie(2,v.ILogService)],I);let u=class extends I{constructor(g,f,d,S,m,h){super(d,S,m),this.snap=g,this.snapRevision=f,this.telemetryService=h;const l=(0,t.watch)(D.dirname(this.snap)),n=R.Event.fromNodeEventEmitter(l,"change",(s,c)=>c),r=R.Event.filter(n,s=>s==="current"),o=R.Event.debounce(r,(s,c)=>c,2e3)(()=>this.checkForUpdates(!1));d.onWillShutdown(()=>{o.dispose(),l.close()})}doCheckForUpdates(){this.setState(C.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(C.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(C.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(C.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((d,S)=>(0,t.realpath)(`${D.dirname(this.snap)}/current`,(m,h)=>m?S(m):d(h))),f=D.basename(g);return this.snapRevision!==f}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};u=ve([ie(2,p.ILifecycleMainService),ie(3,P.IEnvironmentMainService),ie(4,v.ILogService),ie(5,b.ITelemetryService)],u),e.SnapUpdateService=u}),define(ee[51],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(ee[241],te([0,1,51,189,15,19,125,3,2]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class v{constructor(I){this.uri=I,this.time=v._clock++}touch(){return this.time=v._clock++,this}}v._clock=0;let b=class{constructor(I){this._fileService=I,this._dispooables=new p.DisposableStore,this._limit=2**16;const u=new Map,w=g=>{let f=u.get(g.scheme);return f===void 0&&(f=I.hasProvider(g)&&!this._fileService.hasCapability(g,1024),u.set(g.scheme,f)),f};this._dispooables.add(P.Event.any(I.onDidChangeFileSystemProviderRegistrations,I.onDidChangeFileSystemProviderCapabilities)(g=>{u.delete(g.scheme)})),this.extUri=new R.ExtUri(w),this._canonicalUris=new D.SkipList((g,f)=>this.extUri.compare(g,f,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(I){this._fileService.hasProvider(I)&&(I=(0,R.normalizePath)(I));const u=this._canonicalUris.get(I);return u?u.touch().uri.with({fragment:I.fragment}):(this._canonicalUris.set(I,new v(I)),this._checkTrim(),I)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const I=[...this._canonicalUris.entries()].sort((w,g)=>w[1].touch<g[1].touch?1:w[1].touch>g[1].touch?-1:0);v._clock=0,this._canonicalUris.clear();const u=this._limit*.5;for(let w=0;w<u;w++)this._canonicalUris.set(I[w][0],I[w][1].touch())}};b=ve([ie(0,k.IFileService)],b),e.UriIdentityService=b,(0,t.registerSingleton)(E.IUriIdentityService,b,1)}),define(ee[114],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(ee[242],te([0,1,7]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(P){this.handler=P}listen(P,p){throw new Error(`Event not found: ${p}`)}call(P,p,v){switch(p){case"handleURL":return this.handler.handleURL(E.URI.revive(v[0]),v[1])}throw new Error(`Call not found: ${p}`)}}e.URLHandlerChannel=t;class k{constructor(P){this.channel=P}handleURL(P,p){return this.channel.call("handleURL",[P.toJSON(),p])}}e.URLHandlerChannelClient=k;class R{constructor(P){this.next=P}async routeCall(P,p,v,b){if(p!=="handleURL")throw new Error(`Call not found: ${p}`);if(v){const C=E.URI.revive(v);if(C&&C.query){const I=/\bwindowId=(\d+)/.exec(C.query);if(I){const u=I[1],w=new RegExp(`window:${u}`),g=P.connections.find(f=>w.test(f.ctx));if(g)return g}}}return this.next.routeCall(P,p,v,b)}routeEvent(P,p){throw new Error(`Event not found: ${p}`)}}e.URLHandlerRouter=R}),define(ee[243],te([0,1,8,2,7,20]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends t.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(v,b){const C=[...this.handlers.values()];return(0,E.first)(C.map(I=>()=>I.handleURL(v,b)),void 0,!1).then(I=>I||!1)}registerHandler(v){return this.handlers.add(v),(0,t.toDisposable)(()=>this.handlers.delete(v))}}e.AbstractURLService=D;let P=class extends D{constructor(v){super(),this.productService=v}create(v){let{authority:b,path:C,query:I,fragment:u}=v||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&C&&C.indexOf("/")!==0&&(C=`/${C}`),k.URI.from({scheme:this.productService.urlProtocol,authority:b,path:C,query:I,fragment:u})}};P=ve([ie(0,R.IProductService)],P),e.NativeURLService=P}),define(ee[244],te([0,1,13,8,3,2,4,7]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function p(b){try{return P.URI.parse(b)}catch{return null}}class v{constructor(C,I,u,w,g){if(this.urlService=I,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=C,D.isWindows){const S=w.isBuilt?[]:[`"${w.appRoot}"`];S.push("--open-url","--"),E.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,S)}const f=k.Event.map(k.Event.fromNodeEventEmitter(E.app,"open-url",(S,m)=>({event:S,url:m})),({event:S,url:m})=>(S.preventDefault(),m));this.disposables.add(f(S=>{const m=p(S);!m||this.urlService.open(m,{originalUrl:S})})),u.getWindows().filter(S=>S.isReady).length>0?this.flush():k.Event.once(u.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const C=[];for(const I of this.uris)await this.urlService.open(I.uri,{originalUrl:I.url})||C.push(I);C.length!==0&&(this.uris=C,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=v}),define(ee[245],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(ee[246],te([0,1,13,2,14,7]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends t.Disposable{constructor(){super();const p=this.handleWebviewRequest.bind(this);E.protocol.registerFileProtocol(k.Schemas.vscodeWebview,p)}handleWebviewRequest(p,v){try{const b=R.URI.parse(p.url),C=D.validWebviewFilePaths.get(b.path);if(typeof C=="string"){const I=`vs/workbench/contrib/webview/browser/pre/${C}`,u=k.FileAccess.asFileUri(I,z);return v({path:decodeURIComponent(u.fsPath),headers:{...k.COI.getHeadersFromQuery(p.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return v({error:-10})}catch{}return v({error:-2})}}e.WebviewProtocolProvider=D,D.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(ee[74],te([0,1,4]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(b){return!!b.workspaceUri}e.isWorkspaceToOpen=t;function k(b){return!!b.folderUri}e.isFolderToOpen=k;function R(b){return!!b.fileUri}e.isFileToOpen=R;function D(b){const C=P(b),I=b.getValue("window.menuBarVisibility");return I==="default"||C==="native"&&I==="compact"||E.isMacintosh&&E.isNative?"classic":I}e.getMenuBarVisibility=D;function P(b){if(E.isWeb)return"custom";const C=b.getValue("window");if(C){if(E.isMacintosh&&C.nativeTabs===!0||E.isMacintosh&&C.nativeFullScreen===!1)return"native";const w=C.titleBarStyle;if(w==="native"||w==="custom")return w}return E.isLinux?"native":"custom"}e.getTitleBarStyle=P;function p(b){if(!E.isWindows||E.isWeb||P(b)==="native")return!1;const C=b.getValue("window.experimental.windowControlsOverlay.enabled");return typeof C=="boolean"?C:!1}e.useWindowControlsOverlay=p;function v(b=0){return Math.pow(1.2,b)}e.zoomLevelToZoomFactor=v}),define(ee[115],te([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(E=e.LoadReason||(e.LoadReason={}));var t;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(P=1){return{width:1024,height:768,mode:P}};e.defaultWindowState=k;var R;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var D;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(ee[31],te([0,1,5]),function(z,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(ee[247],te([0,1,13,22,3,67,2,29,70,105,6,20,31]),function(z,e,E,t,k,R,D,P,p,v,b,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var u;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(u||(u={}));let w=class extends D.Disposable{constructor(f,d,S,m,h){super(),this.logService=f,this.windowsMainService=d,this.credentialsService=S,this.encryptionMainService=m,this.productService=h,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=u.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const f=k.Event.fromNodeEventEmitter(E.app,"login",(d,S,m,h,l)=>({event:d,webContents:S,req:m,authInfo:h,callback:l}));this._register(f(this.onLogin,this))}async onLogin({event:f,authInfo:d,req:S,callback:m}){if(!d.isProxy)return;if(!this.pendingProxyResolve&&this.state===u.LoginDialogShown&&S.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}f.preventDefault();let h;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),h=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(d);try{h=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}m(h?.username,h?.password)}async resolveProxyCredentials(f){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const d=await this.doResolveProxyCredentials(f);if(d)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),d;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(f){this.logService.trace("auth#doResolveProxyCredentials - enter",f);const d=String((0,R.hash)({scheme:f.scheme,host:f.host,port:f.port}));let S,m;try{const r=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,d);if(r){const i=JSON.parse(await this.encryptionMainService.decrypt(r));S=i.username,m=i.password}}catch(r){this.logService.error(r)}if(this.state!==u.StoredCredentialsUsed&&typeof S=="string"&&typeof m=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=u.StoredCredentialsUsed,{username:S,password:m};const h=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!h){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${h.id} to handle proxy login`);const l={authInfo:f,username:this.sessionCredentials?.username??S,password:this.sessionCredentials?.password??m,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};h.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,l),this.state=u.LoginDialogShown;const n=await new Promise(r=>{const i=async(o,s,c)=>{if(s===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${h.id}`),h.win?.webContents.off("ipc-message",i),c){const a={username:c.username,password:c.password};try{if(c.remember){const y=await this.encryptionMainService.encrypt(JSON.stringify(a));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,d,y)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,d)}catch(y){this.logService.error(y)}r({username:a.username,password:a.password})}else r(void 0)};h.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=n,n}};w=ve([ie(0,b.ILogService),ie(1,I.IWindowsMainService),ie(2,p.ICredentialsMainService),ie(3,v.IEncryptionMainService),ie(4,C.IProductService)],w),e.ProxyAuthHandler=w}),define(ee[248],te([0,1,70,6,34,20,31,201]),function(z,e,E,t,k,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let p=class extends P.BaseCredentialsMainService{constructor(b,C,I,u){super(b),this.environmentMainService=C,this.productService=I,this.windowsMainService=u,this.surfaceKeytarLoadError=w=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",w.message??w)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new E.InMemoryCredentialsProvider,this._keytarCache;const b=await new Promise((C,I)=>{z(["keytar"],C,I)});return await b.findCredentials("test-keytar-loads"),this._keytarCache=b,this._keytarCache}};p=ve([ie(0,t.ILogService),ie(1,k.INativeEnvironmentService),ie(2,R.IProductService),ie(3,D.IWindowsMainService)],p),e.CredentialsNativeMainService=p}),define(ee[249],te([0,1,16,2,3,6,21,80,44,278,8,14,50,4,32,13,31]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const d=g.utilityProcess,S=typeof d<"u";let m=class Ut{constructor(r,i,o){this._logService=r,this._windowsMainService=o,this._shutdown=!1,this._extHosts=new Map,i.onWillShutdown(s=>{this._shutdown=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(r){const i=this._extHosts.get(r);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(r){return this._getExtHost(r).onStdout}onDynamicStderr(r){return this._getExtHost(r).onStderr}onDynamicMessage(r){return this._getExtHost(r).onMessage}onDynamicError(r){return this._getExtHost(r).onError}onDynamicExit(r){return this._getExtHost(r).onExit}async canUseUtilityProcess(){return S}async createExtensionHost(r){if(this._shutdown)throw(0,E.canceled)();const i=String(++Ut._lastId);let o;if(r){if(!S)throw new Error("Cannot use UtilityProcess!");o=new l(i,this._logService,this._windowsMainService)}else o=new h(i,this._logService);return this._extHosts.set(i,o),o.onExit(({pid:s,code:c,signal:a})=>{this._logService.info(`Extension host with pid ${s} exited with code: ${c}, signal: ${a}.`),setTimeout(()=>{o.dispose(),this._extHosts.delete(i)})}),{id:i}}async start(r,i){if(this._shutdown)throw(0,E.canceled)();return this._getExtHost(r).start(i)}async enableInspectPort(r){if(this._shutdown)throw(0,E.canceled)();const i=this._extHosts.get(r);return i?i.enableInspectPort():!1}async kill(r){if(this._shutdown)throw(0,E.canceled)();const i=this._extHosts.get(r);!i||i.kill()}async _killAllNow(){for(const[,r]of this._extHosts)r.kill()}async _waitForAllExit(r){const i=[];for(const[,o]of this._extHosts)i.push(o.waitForExit(r));return b.Promises.settled(i).then(()=>{})}};m._lastId=0,m=ve([ie(0,R.ILogService),ie(1,D.ILifecycleMainService),ie(2,f.IWindowsMainService)],m),e.ExtensionHostStarter=m;let h=class extends t.Disposable{constructor(r,i){super(),this.id=r,this._logService=i,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(r){u.isCI&&this._logService.info("Calling fork to start extension host...");const i=P.StopWatch.create(!1);this._process=(0,p.fork)(C.FileAccess.asFileUri("bootstrap-fork",z).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,I.mixin)({cwd:(0,w.cwd)()},r));const o=i.elapsed(),s=this._process.pid;this._logService.info(`Starting extension host with pid ${s} (fork() took ${o} ms).`);const c=new v.StringDecoder("utf-8");this._process.stdout?.on("data",y=>{const M=typeof y=="string"?y:c.write(y);this._onStdout.fire(M)});const a=new v.StringDecoder("utf-8");this._process.stderr?.on("data",y=>{const M=typeof y=="string"?y:a.write(y);this._onStderr.fire(M)}),this._process.on("message",y=>{this._onMessage.fire(y)}),this._process.on("error",y=>{this._onError.fire({error:(0,E.transformErrorForSerialization)(y)})}),this._process.on("exit",(y,M)=>{this._hasExited=!0,this._onExit.fire({pid:s,code:y,signal:M})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):u.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(r){if(!this._process)return;const i=this._process.pid;this._logService.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,b.timeout)(r)]),this._hasExited||(this._logService.info(`Extension host with pid ${i} did not exit within ${r}ms.`),this._process.kill())}};h=ve([ie(1,R.ILogService)],h);let l=class extends t.Disposable{constructor(r,i,o){super(),this.id=r,this._logService=i,this._windowsMainService=o,this.onError=k.Event.None,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(r){const i=this._windowsMainService.getWindowById(r.responseWindowId);if(!i){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const o=i.win;if(!o||o.isDestroyed()||o.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=`extensionHost${this.id}`,c=C.FileAccess.asFileUri("bootstrap-fork.js",z).fsPath,a=["--type=extensionHost","--skipWorkspaceStorageLock"],y=r.execArgv||[],M={...r.env},T=!0,U="pipe";for(const se of Object.keys(M))M[se]=String(M[se]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=d.fork(c,a,{serviceName:s,env:M,execArgv:y,allowLoadingUnsignedLibraries:T,stdio:U});const Y=new v.StringDecoder("utf-8");this._process.stdout?.on("data",se=>{const fe=typeof se=="string"?se:Y.write(se);this._onStdout.fire(fe)});const G=new v.StringDecoder("utf-8");this._process.stderr?.on("data",se=>{const fe=typeof se=="string"?se:G.write(se);this._onStderr.fire(fe)}),this._process.on("message",se=>{this._onMessage.fire(se)}),this._register(k.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const V=k.Event.fromNodeEventEmitter(this._process,"exit",se=>se);this._register(V(se=>{this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${se}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:se,signal:""})}));const{port1:oe,port2:ae}=new g.MessageChannelMain;this._process.postMessage("null",[ae]),o.webContents.postMessage(r.responseChannel,r.responseNonce,[oe])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):!1):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(r){if(!this._process)return;const i=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,b.timeout)(r)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${i} did not exit within ${r}ms, will kill it now.`),this._process.kill())}};l=ve([ie(1,R.ILogService),ie(2,f.IWindowsMainService)],l)}),define(ee[250],te([0,1,13,3,2,246,31]),function(z,e,E,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends k.Disposable{constructor(v){super(),this.windowsMainService=v,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(v,b){let C;if(typeof v.windowId=="number"){const{windowId:I}=v,u=this.windowsMainService.getWindowById(I);if(!u?.win)throw new Error(`Invalid windowId: ${I}`);C=u.win.webContents}else{const{webContentsId:I}=v;if(C=E.webContents.fromId(I),!C)throw new Error(`Invalid webContentsId: ${I}`)}C.isDestroyed()||C.setIgnoreMenuShortcuts(b)}async findInFrame(v,b,C,I){const w=this.getFrameByName(v,b);if(typeof w.findInFrame=="function"){w.findInFrame(C,{findNext:I.findNext,forward:I.forward});const g=(f,d)=>{d.finalUpdate&&(this._onFoundInFrame.fire(d),w.removeListener("found-in-frame",g))};w.on("found-in-frame",g)}}async stopFindInFrame(v,b,C){const u=this.getFrameByName(v,b);typeof u.stopFindInFrame=="function"&&u.stopFindInFrame(C.keepSelection?"keepSelection":"clearSelection")}getFrameByName(v,b){const C=this.windowsMainService.getWindowById(v.windowId);if(!C?.win)throw new Error(`Invalid windowId: ${v}`);const I=C.win.webContents.mainFrame.framesInSubtree.find(u=>u.name===b);if(!I)throw new Error(`Unknown frame: ${b}`);return I}};P=ve([ie(0,D.IWindowsMainService)],P),e.WebviewMainService=P}),define(ee[251],te([0,1,8,3,2]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:p,getActiveWindowId:v}){super(),this.disposables=this._register(new k.DisposableStore),t.Event.latch(t.Event.any(P,p))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,E.createCancelablePromise)(()=>v()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(ee[28],te([0,1,172,9,58,19,7,5,14]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function v(r){const i=r;return typeof i?.id=="string"&&D.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=v,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function b(r,i){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,t.basename)(r)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const o=r;if(o.configuration)return{id:o.id,configPath:o.configuration};if(o.folders.length===1)return{id:o.id,uri:o.folders[0].uri}}e.toWorkspaceIdentifier=b;function C(r){const i=r;return typeof i?.id=="string"&&D.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=C;function I(r){const i=r;if(i?.uri)return{id:i.id,uri:D.URI.revive(i.uri)};const o=r;if(o?.configPath)return{id:o.id,configPath:D.URI.revive(o.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=I;var u;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(u=e.WorkbenchState||(e.WorkbenchState={}));function w(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=w;function g(r){const i=r;return!!(i&&typeof i=="object"&&D.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=g;class f{constructor(i,o,s,c,a){this._id=i,this._transient=s,this._configuration=c,this._ignorePathCasing=a,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class d{constructor(i,o){this.raw=o,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,R.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function S(r){return new d({uri:r,index:0,name:(0,R.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function m(r,i){return R.extUriBiasedIgnorePathCase.isEqualOrParent(r,i.untitledWorkspacesHome)}e.isUntitledWorkspace=m;function h(r){let i;return D.URI.isUri(r)?i=r:i=r.configuration,i?.scheme===p.Schemas.tmp}e.isTemporaryWorkspace=h;function l(r,i){return!m(r,i)&&!h(r)}e.isSavedWorkspace=l;function n(r){return(typeof r=="string"?(0,t.extname)(r):(0,R.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(ee[56],te([0,1,13,8,67,33,2,76,4,12,23,149,5,6,28]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,I.createDecorator)("dialogMainService");let g=class{constructor(d){this.logService=d,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(d,S){return this.doPick({...d,pickFolders:!0,pickFiles:!0,title:(0,C.localize)(0,null)},S)}pickFolder(d,S){return this.doPick({...d,pickFolders:!0,title:(0,C.localize)(1,null)},S)}pickFile(d,S){return this.doPick({...d,pickFiles:!0,title:(0,C.localize)(2,null)},S)}pickWorkspace(d,S){const m=(0,C.localize)(3,null),h=(0,R.mnemonicButtonLabel)((0,C.localize)(4,null)),l=w.WORKSPACE_FILTER;return this.doPick({...d,pickFiles:!0,title:m,filters:l,buttonLabel:h},S)}async doPick(d,S){const m={title:d.title,buttonLabel:d.buttonLabel,filters:d.filters,defaultPath:d.defaultPath};(typeof d.pickFiles=="boolean"||typeof d.pickFolders=="boolean")&&(m.properties=void 0,d.pickFiles&&d.pickFolders&&(m.properties=["multiSelections","openDirectory","openFile","createDirectory"])),m.properties||(m.properties=["multiSelections",d.pickFolders?"openDirectory":"openFile","createDirectory"]),p.isMacintosh&&m.properties.push("treatPackageAsDirectory");const h=await this.showOpenDialog(m,(0,v.withNullAsUndefined)(S||E.BrowserWindow.getFocusedWindow()));if(h&&h.filePaths&&h.filePaths.length>0)return h.filePaths}getWindowDialogQueue(d){if(d){let S=this.windowDialogQueues.get(d.id);return S||(S=new t.Queue,this.windowDialogQueues.set(d.id,S)),S}else return this.noWindowDialogueQueue}showMessageBox(d,S){return this.getWindowDialogQueue(S).queue(async()=>S?E.dialog.showMessageBox(S,d):E.dialog.showMessageBox(d))}async showSaveDialog(d,S){const m=this.acquireFileDialogLock(d,S);if(!m)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(S).queue(async()=>{let h;return S?h=await E.dialog.showSaveDialog(S,d):h=await E.dialog.showSaveDialog(d),h.filePath=this.normalizePath(h.filePath),h})}finally{(0,D.dispose)(m)}}normalizePath(d){return d&&p.isMacintosh&&(d=(0,P.normalizeNFC)(d)),d}normalizePaths(d){return d.map(S=>this.normalizePath(S))}async showOpenDialog(d,S){d.defaultPath&&(await b.Promises.exists(d.defaultPath)||(d.defaultPath=void 0));const m=this.acquireFileDialogLock(d,S);if(!m)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(S).queue(async()=>{let h;return S?h=await E.dialog.showOpenDialog(S,d):h=await E.dialog.showOpenDialog(d),h.filePaths=this.normalizePaths(h.filePaths),h})}finally{(0,D.dispose)(m)}}acquireFileDialogLock(d,S){if(!S)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",d);let m=this.windowFileDialogLocks.get(S.id);m||(m=new Set,this.windowFileDialogLocks.set(S.id,m));const h=(0,k.hash)(d);if(!m.has(h))return this.logService.trace("[DialogMainService]: new file dialog lock created",d),m.add(h),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",d),m?.delete(h),m?.size===0&&this.windowFileDialogLocks.delete(S.id)})}};g=ve([ie(0,u.ILogService)],g),e.DialogMainService=g}),define(ee[252],te([0,1,3,2,68,28]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends t.Disposable{constructor(p,v){super(),this.logService=p,this.storageMainService=v,this.onDidChangeApplicationStorageEmitter=this._register(new E.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(v.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(p,v){this._register(E.Event.debounce(p.onDidChangeStorage,(b,C)=>(b?b.push(C):b=[C],b),D.STORAGE_CHANGE_DEBOUNCE_TIME)(b=>{b.length&&v.fire(this.serializeStorageChangeEvents(b,p))}))}serializeStorageChangeEvents(p,v){const b=new Map,C=new Set;return p.forEach(I=>{const u=v.get(I.key);typeof u=="string"?b.set(I.key,u):C.add(I.key)}),{changed:Array.from(b.entries()),deleted:Array.from(C.values())}}listen(p,v,b){switch(v){case"onDidChangeStorage":{const C=b.profile?(0,k.revive)(b.profile):void 0;if(!C)return this.onDidChangeApplicationStorageEmitter.event;let I=this.mapProfileToOnDidChangeProfileStorageEmitter.get(C.id);return I||(I=this._register(new E.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(C),I),this.mapProfileToOnDidChangeProfileStorageEmitter.set(C.id,I)),I.event}}throw new Error(`Event not found: ${v}`)}async call(p,v,b){const C=b.profile?(0,k.revive)(b.profile):void 0,I=(0,R.reviveIdentifier)(b.workspace),u=await this.withStorageInitialized(C,I);switch(v){case"getItems":return Array.from(u.items.entries());case"updateItems":{const w=b;if(w.insert)for(const[g,f]of w.insert)u.set(g,f);w.delete?.forEach(g=>u.delete(g));break}case"isUsed":{const w=b.payload;if(typeof w=="string")return this.storageMainService.isUsed(w)}default:throw new Error(`Call not found: ${v}`)}}async withStorageInitialized(p,v){let b;v?b=this.storageMainService.workspaceStorage(v):p?b=this.storageMainService.profileStorage(p):b=this.storageMainService.applicationStorage;try{await b.init()}catch(C){this.logService.error(`StorageIPC#init: Unable to init ${v?"workspace":p?"profile":"application"} storage due to ${C}`)}return b}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(ee[41],te([0,1,67,3,2,19,7,169,34,15,5,6,28,38,51,8,29,25]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function S(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&D.URI.isUri(i.location)&&D.URI.isUri(i.globalStorageHome)&&D.URI.isUri(i.settingsResource)&&D.URI.isUri(i.keybindingsResource)&&D.URI.isUri(i.tasksResource)&&D.URI.isUri(i.snippetsHome)&&D.URI.isUri(i.extensionsResource))}e.isUserDataProfile=S,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function m(r,i){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,location:D.URI.revive(r.location).with({scheme:i}),globalStorageHome:D.URI.revive(r.globalStorageHome).with({scheme:i}),settingsResource:D.URI.revive(r.settingsResource).with({scheme:i}),keybindingsResource:D.URI.revive(r.keybindingsResource).with({scheme:i}),tasksResource:D.URI.revive(r.tasksResource).with({scheme:i}),snippetsHome:D.URI.revive(r.snippetsHome).with({scheme:i}),extensionsResource:D.URI.revive(r.extensionsResource)?.with({scheme:i}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.reviveProfile=m;function h(r,i,o,s){return{id:r,name:i,location:o,isDefault:!1,shortName:s?.shortName,globalStorageHome:(0,R.joinPath)(o,"globalStorage"),settingsResource:(0,R.joinPath)(o,"settings.json"),keybindingsResource:(0,R.joinPath)(o,"keybindings.json"),tasksResource:(0,R.joinPath)(o,"tasks.json"),snippetsHome:(0,R.joinPath)(o,"snippets"),extensionsResource:(0,R.joinPath)(o,"extensions.json"),useDefaultFlags:s?.useDefaultFlags,isTransient:s?.transient}}e.toUserDataProfile=h;let l=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,o,s,c){super(),this.environmentService=i,this.fileService=o,this.uriIdentityService=s,this.logService=c,this.enabled=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new u.ResourceMap},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const i=this.enabled?this.getStoredProfiles().map(a=>h((0,R.basename)(a.location),a.name,a.location,{shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})):[];let o;const s=new u.ResourceMap,c=h((0,E.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.environmentService.userRoamingDataHome);if(i.unshift({...c,isDefault:!0}),i.length){const a=this.getStoredProfileAssociations();if(a.workspaces)for(const[y,M]of Object.entries(a.workspaces)){const T=D.URI.parse(y),U=D.URI.parse(M),Y=i.find(G=>this.uriIdentityService.extUri.isEqual(G.location,U));Y&&s.set(T,Y)}if(a.emptyWindow){const y=D.URI.parse(a.emptyWindow);o=i.find(M=>this.uriIdentityService.extUri.isEqual(M.location,y))}}this._profilesObject={profiles:i,workspaces:s,emptyWindow:o}}return this._profilesObject}async createTransientProfile(i){const o="Temp",s=new RegExp(`${(0,d.escapeRegExpCharacters)(o)}\\s(\\d+)`);let c=0;for(const y of this.profiles){const M=s.exec(y.name),T=M?parseInt(M[1]):0;c=T>c?T:c}const a=`${o} ${c+1}`;return this.createProfile((0,E.hash)((0,f.generateUuid)()).toString(16),a,{transient:!0},i)}async createNamedProfile(i,o,s){return this.createProfile((0,E.hash)((0,f.generateUuid)()).toString(16),i,o,s)}async createProfile(i,o,s,c){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=await this.doCreateProfile(i,o,s);return c&&await this.setProfileForWorkspace(c,a),a}async doCreateProfile(i,o,s){let c=this.profileCreationPromises.get(o);return c||(c=(async()=>{try{const a=this.profiles.find(T=>T.name===o||T.id===i);if(a)return a;const y=h(i,o,(0,R.joinPath)(this.profilesHome,i),s);await this.fileService.createFolder(y.location);const M=[];return this._onWillCreateProfile.fire({profile:y,join(T){M.push(T)}}),await g.Promises.settled(M),this.updateProfiles([y],[],[]),y}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,c)),c}async updateProfile(i,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let s=this.profiles.find(c=>c.id===i.id);if(!s)throw new Error(`Profile '${i.name}' does not exist`);return s=h(s.id,o.name??s.name,s.location,{shortName:o.shortName??s.shortName,transient:o.transient??s.isTransient,useDefaultFlags:o.useDefaultFlags??s.useDefaultFlags}),this.updateProfiles([],[],[s]),s}async removeProfile(i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(i.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(c=>c.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);const s=[];this._onWillRemoveProfile.fire({profile:o,join(c){s.push(c)}});try{await Promise.allSettled(s)}catch(c){this.logService.error(c)}o.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const c of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(c)?.id&&this.profilesObject.workspaces.delete(c);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(o.location,{recursive:!0})}catch(c){this.logService.error(c)}}getOrSetProfileForWorkspace(i,o=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let s=this.getProfileForWorkspace(i);return s||(s=o,this.profiles.length>1&&this.setProfileForWorkspaceSync(i,s)),s}async setProfileForWorkspace(i,o){this.setProfileForWorkspaceSync(i,o)}setProfileForWorkspaceSync(i,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const s=this.profiles.find(c=>c.id===o.id);if(!s)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(i,s)}unsetWorkspace(i,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(i,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(o=>o.isDirectory&&this.profiles.every(s=>!this.uriIdentityService.extUri.isEqual(s.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(i.map(o=>this.removeProfile(o)))}getProfileForWorkspace(i){const o=this.getWorkspace(i);return D.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(i){return(0,I.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,I.isWorkspaceIdentifier)(i)?i.configPath:"empty-window"}isProfileAssociatedToWorkspace(i){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,i.location)||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,i.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,i.location)||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,i.location)))}updateProfiles(i,o,s){const c=[...this.profiles,...i],a=[];this.transientProfilesObject.profiles=[];for(let y of c)y.isDefault||o.some(M=>y.id===M.id)||(y=s.find(M=>y.id===M.id)??y,y.isTransient?this.transientProfilesObject.profiles.push(y):a.push({location:y.location,name:y.name,shortName:y.shortName,useDefaultFlags:y.useDefaultFlags}));this.saveStoredProfiles(a),this._profilesObject=void 0,this.triggerProfilesChanges(i,o,s)}triggerProfilesChanges(i,o,s){this._onDidChangeProfiles.fire({added:i,removed:o,updated:s,all:this.profiles})}updateWorkspaceAssociation(i,o,s){s=o?.isTransient?!0:s,s||this.updateWorkspaceAssociation(i,void 0,!0);const c=this.getWorkspace(i),a=s?this.transientProfilesObject:this.profilesObject;D.URI.isUri(c)?(a.workspaces.delete(c),o&&a.workspaces.set(c,o)):a.emptyWindow=o,s||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[s,c]of this.profilesObject.workspaces.entries())i[s.toString()]=c.location.toString();const o=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:i,emptyWindow:o}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}};l.PROFILES_KEY="userDataProfiles",l.PROFILE_ASSOCIATIONS_KEY="profileAssociations",l=ve([ie(0,p.IEnvironmentService),ie(1,v.IFileService),ie(2,w.IUriIdentityService),ie(3,C.ILogService)],l),e.UserDataProfilesService=l;class n extends l{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=n}),define(ee[116],te([0,1,24,8,50,17,16,42,135,2,14,9,4,19,187,97,12,7,154,34,110,109,186,15,5,6,20,3,68,87,41,51,185]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g,f,d,S,m,h,l,n,r,i,o,s,c,a,y,M,T,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var Y;(function(K){function H(F,A){if(F===A)return!0;const O=Object.keys(F),_=new Set;for(const ne of Object.keys(A))_.add(ne);if(O.length!==_.size)return!1;for(const ne of O){if(F[ne]!==A[ne])return!1;_.delete(ne)}return _.size===0}K.equals=H})(Y=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let G=class extends v.Disposable{constructor(H,F,A,O,_,ne,N,$,L,W,j){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=F,this.extensionsControlLocation=A,this.cacheLocation=O,this.userDataProfilesService=_,this.extensionsProfileScannerService=ne,this.fileService=N,this.logService=$,this.environmentService=L,this.productService=W,this.instantiationService=j,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,u.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ae,(0,u.joinPath)(this.cacheLocation,l.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ae,(0,u.joinPath)(this.cacheLocation,l.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(oe,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,h.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(H,F,A){const[O,_]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(F)]),ne=A?await this.scanExtensionsUnderDevelopment(H,[...O,..._]):[];return this.dedupExtensions(O,_,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const F=[];F.push(this.scanDefaultSystemExtensions(!!H.useCache,H.language)),F.push(this.scanDevSystemExtensions(H.language,!!H.checkControlFile));const[A,O]=await Promise.all(F);return this.applyScanOptions([...A,...O],0,H,!1)}async scanUserExtensions(H){const F=H.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",F);const A=await this.createExtensionScannerInput(F,!!H.profileLocation,1,!H.includeUninstalled,H.language);let _=await(H.useCache&&!A.devMode&&A.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(A);return _=await this.applyScanOptions(_,1,H,!0),this.logService.trace("Scanned user extensions:",_.length),_}async scanExtensionsUnderDevelopment(H,F){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const A=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(O=>O.scheme===b.Schemas.file).map(async O=>{const _=await this.createExtensionScannerInput(O,!1,1,!0,H.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(_)).map(N=>(N.type=F.find($=>(0,h.areSameExtensions)($.identifier,N.identifier))?.type??N.type,this.extensionsScanner.validate(N,_)))}))).flat();return this.applyScanOptions(A,"development",H,!0)}return[]}async scanExistingExtension(H,F,A){const O=await this.createExtensionScannerInput(H,!1,F,!0,A.language),_=await this.extensionsScanner.scanExtension(O);return!_||!A.includeInvalid&&!_.isValid?null:_}async scanOneOrMultipleExtensions(H,F,A){const O=await this.createExtensionScannerInput(H,!1,F,!0,A.language),_=await this.extensionsScanner.scanOneOrMultipleExtensions(O);return this.applyScanOptions(_,F,A,!0)}async scanMetadata(H){const F=(0,u.joinPath)(H,"package.json"),A=(await this.fileService.readFile(F)).value.toString();return JSON.parse(A).__metadata}async updateMetadata(H,F){const A=(0,u.joinPath)(H,"package.json"),O=(await this.fileService.readFile(A)).value.toString(),_=JSON.parse(O);F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0,_.__metadata={..._.__metadata,...F},await this.fileService.writeFile((0,u.joinPath)(H,"package.json"),R.VSBuffer.fromString(JSON.stringify(_,null,"	")))}async applyScanOptions(H,F,A,O){return A.includeAllVersions||(H=this.dedupExtensions(F===0?H:void 0,F===1?H:void 0,F==="development"?H:void 0,await this.getTargetPlatform(),O)),A.includeInvalid||(H=H.filter(_=>_.isValid)),H.sort((_,ne)=>{const N=C.basename(_.location.fsPath),$=C.basename(ne.location.fsPath);return N<$?-1:N>$?1:0})}dedupExtensions(H,F,A,O,_){const ne=($,L,W)=>{if($.isValid&&!L.isValid)return!1;if($.isValid===L.isValid){if(_&&w.gt($.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${$.location.path} with version ${$.manifest.version}`),!1;if(w.eq($.manifest.version,L.manifest.version)){if($.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${$.location.path} with same version`),!1;if($.targetPlatform===O)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return W?this.logService.warn(`Overwriting user extension ${$.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${$.location.path} with ${L.location.path}.`),!0},N=new Map;return H?.forEach($=>{const L=l.ExtensionIdentifier.toKey($.identifier.id),W=N.get(L);(!W||ne(W,$,!1))&&N.set(L,$)}),F?.forEach($=>{const L=l.ExtensionIdentifier.toKey($.identifier.id),W=N.get(L);if(!W&&H&&$.type===0){this.logService.debug(`Skipping obsolete system extension ${$.location.path}.`);return}(!W||ne(W,$,!1))&&N.set(L,$)}),A?.forEach($=>{const L=l.ExtensionIdentifier.toKey($.identifier.id),W=N.get(L);(!W||ne(W,$,!0))&&N.set(L,$),N.set(L,$)}),[...N.values()]}async scanDefaultSystemExtensions(H,F){this.logService.trace("Started scanning system extensions");const A=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,F),_=await(H&&!A.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(A);return this.logService.trace("Scanned system extensions:",_.length),_}async scanDevSystemExtensions(H,F){const A=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!A?.length)return[];this.logService.trace("Started scanning dev system extensions");const O=F?await this.getBuiltInExtensionControl():{},_=[],ne=d.URI.file(C.normalize(C.join(b.FileAccess.asFileUri("",z).fsPath,"..",".build","builtInExtensions")));for(const $ of A){const L=O[$.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":_.push((0,u.joinPath)(ne,$.name));break;default:_.push(d.URI.file(L));break}}const N=await Promise.all(_.map(async $=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput($,!1,0,!0,H))));return this.logService.trace("Scanned dev system extensions:",N.length),(0,E.coalesce)(N)}async getBuiltInExtensionControl(){try{const H=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(H.value.toString())}catch{return{}}}async createExtensionScannerInput(H,F,A,O,_,ne=!0){const N=await this.getTranslations(_??I.language),$=await this.getMtime(H),L=F?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,W=L?await this.getMtime(L):void 0;return new V(H,$,L,W,F,A,O,ne,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,_,N)}async getMtime(H){try{const F=await this.fileService.stat(H);if(typeof F.mtime=="number")return F.mtime}catch{}}};G=ve([ie(4,M.IUserDataProfilesService),ie(5,y.IExtensionsProfileScannerService),ie(6,r.IFileService),ie(7,o.ILogService),ie(8,m.IEnvironmentService),ie(9,s.IProductService),ie(10,i.IInstantiationService)],G),e.AbstractExtensionsScannerService=G;class V{constructor(H,F,A,O,_,ne,N,$,L,W,j,q,X,re){this.location=H,this.mtime=F,this.applicationExtensionslocation=A,this.applicationExtensionslocationMtime=O,this.profile=_,this.type=ne,this.excludeObsolete=N,this.validate=$,this.productVersion=L,this.productDate=W,this.productCommit=j,this.devMode=q,this.language=X,this.translations=re}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,F){return(0,u.isEqual)(H.location,F.location)&&H.mtime===F.mtime&&(0,u.isEqual)(H.applicationExtensionslocation,F.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===F.applicationExtensionslocationMtime&&H.profile===F.profile&&H.type===F.type&&H.excludeObsolete===F.excludeObsolete&&H.validate===F.validate&&H.productVersion===F.productVersion&&H.productDate===F.productDate&&H.productCommit===F.productCommit&&H.devMode===F.devMode&&H.language===F.language&&Y.equals(H.translations,F.translations)}}let oe=class extends v.Disposable{constructor(H,F,A,O,_){super(),this.obsoleteFile=H,this.extensionsProfileScannerService=F,this.uriIdentityService=A,this.fileService=O,this.logService=_}async scanExtensions(H){const F=H.profile?await this.scanExtensionsFromProfile(H):await this.scanExtensionsFromLocation(H);let A={};if(H.excludeObsolete&&H.type===1)try{const O=(await this.fileService.readFile(this.obsoleteFile)).value.toString();A=JSON.parse(O)}catch{}return(0,f.isEmptyObject)(A)?F:F.filter(O=>!A[h.ExtensionKey.create(O).toString()])}async scanExtensionsFromLocation(H){const F=await this.fileService.resolve(H.location);if(!F.children?.length)return[];const A=await Promise.all(F.children.map(async O=>{if(!O.isDirectory||H.type===1&&(0,u.basename)(O.resource).indexOf(".")===0)return null;const _=new V(O.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(_)}));return(0,E.coalesce)(A).sort((O,_)=>O.location.path<_.location.path?-1:1)}async scanExtensionsFromProfile(H){let F=await this.scanExtensionsFromProfileResource(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(H.location,H.applicationExtensionslocation)){F=F.filter(O=>!O.metadata?.isApplicationScoped);const A=await this.scanExtensionsFromProfileResource(H.applicationExtensionslocation,O=>!!O.metadata?.isApplicationScoped,H);F.push(...A)}return F}async scanExtensionsFromProfileResource(H,F,A){const O=await this.extensionsProfileScannerService.scanProfileExtensions(H);if(!O.length)return[];const _=await Promise.all(O.map(async ne=>{if(F(ne)){const N=new V(ne.location,A.mtime,A.applicationExtensionslocation,A.applicationExtensionslocationMtime,A.profile,A.type,A.excludeObsolete,A.validate,A.productVersion,A.productDate,A.productCommit,A.devMode,A.language,A.translations);return this.scanExtension(N,ne.metadata)}return null}));return(0,E.coalesce)(_)}async scanOneOrMultipleExtensions(H){try{if(await this.fileService.exists((0,u.joinPath)(H.location,"package.json"))){const F=await this.scanExtension(H);return F?[F]:[]}else return await this.scanExtensions(H)}catch(F){return this.logService.error(`Error scanning extensions at ${H.location.path}:`,(0,D.getErrorMessage)(F)),[]}}async scanExtension(H,F){try{let A=await this.scanExtensionManifest(H.location);if(A){A.publisher||(A.publisher=l.UNDEFINED_PUBLISHER),F=F??A.__metadata,delete A.__metadata;const O=(0,h.getGalleryExtensionId)(A.publisher,A.name),_=F?.id?{id:O,uuid:F.id}:{id:O},ne=F?.isSystem?0:H.type,N=ne===0||!!F?.isBuiltin;A=await this.translateManifest(H.location,A,V.createNlsConfiguration(H));const $={type:ne,identifier:_,manifest:A,location:H.location,isBuiltin:N,targetPlatform:F?.targetPlatform??"undefined",metadata:F,isValid:!0,validations:[]};return H.validate?this.validate($,H):$}}catch(A){H.type!==0&&this.logService.error(A)}return null}validate(H,F){let A=!0;const O=(0,n.validateExtensionManifest)(F.productVersion,F.productDate,F.location,H.manifest,H.isBuiltin);for(const[_,ne]of O)_===g.default.Error&&(A=!1,this.logService.error(this.formatMessage(F.location,ne)));return H.isValid=A,H.validations=O,H}async scanExtensionManifest(H){const F=(0,u.joinPath)(H,"package.json");let A;try{A=(await this.fileService.readFile(F)).value.toString()}catch(_){return(0,r.toFileOperationResult)(_)!==1&&this.logService.error(this.formatMessage(H,(0,S.localize)(0,null,F.path,_.message))),null}let O;try{O=JSON.parse(A)}catch{const ne=[];(0,P.parse)(A,ne);for(const N of ne)this.logService.error(this.formatMessage(H,(0,S.localize)(1,null,F.path,N.offset,N.length,(0,p.getParseErrorMessage)(N.error))));return null}return(0,P.getNodeType)(O)!=="object"?(this.logService.error(this.formatMessage(H,(0,S.localize)(2,null,F.path))),null):O}async translateManifest(H,F,A){const O=await this.getLocalizedMessages(H,F,A);if(O)try{const _=[],ne=await this.resolveOriginalMessageBundle(O.default,_);if(_.length>0)return _.forEach($=>{this.logService.error(this.formatMessage(H,(0,S.localize)(3,null,O.default?.path,(0,p.getParseErrorMessage)($.error))))}),F;if((0,P.getNodeType)(O)!=="object")return this.logService.error(this.formatMessage(H,(0,S.localize)(4,null,O.default?.path))),F;const N=O.values||Object.create(null);return(0,U.localizeManifest)(F,N,ne)}catch{}return F}async getLocalizedMessages(H,F,A){const O=(0,u.joinPath)(H,"package.nls.json"),_=(L,W)=>{W.forEach(j=>{this.logService.error(this.formatMessage(H,(0,S.localize)(5,null,L?.path,(0,p.getParseErrorMessage)(j.error))))})},ne=L=>{this.logService.error(this.formatMessage(H,(0,S.localize)(6,null,L?.path)))},N=`${F.publisher}.${F.name}`,$=A.translations[N];if($)try{const L=d.URI.file($),W=(await this.fileService.readFile(L)).value.toString(),j=[],q=(0,P.parse)(W,j);return j.length>0?(_(L,j),{values:void 0,default:O}):(0,P.getNodeType)(q)!=="object"?(ne(L),{values:void 0,default:O}):{values:q.contents?q.contents.package:void 0,default:O}}catch{return{values:void 0,default:O}}else{if(!await this.fileService.exists(O))return;let W;try{W=await this.findMessageBundles(H,A)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const j=(await this.fileService.readFile(W.localized)).value.toString(),q=[],X=(0,P.parse)(j,q);return q.length>0?(_(W.localized,q),{values:void 0,default:W.original}):(0,P.getNodeType)(X)!=="object"?(ne(W.localized),{values:void 0,default:W.original}):{values:X,default:W.original}}catch{return{values:void 0,default:W.original}}}}async resolveOriginalMessageBundle(H,F){if(H)try{const A=(await this.fileService.readFile(H)).value.toString();return(0,P.parse)(A,F)}catch{}}findMessageBundles(H,F){return new Promise((A,O)=>{const _=ne=>{const N=(0,u.joinPath)(H,`package.nls.${ne}.json`);this.fileService.exists(N).then($=>{$&&A({localized:N,original:(0,u.joinPath)(H,"package.nls.json")});const L=ne.lastIndexOf("-");L===-1?A({localized:(0,u.joinPath)(H,"package.nls.json"),original:null}):(ne=ne.substring(0,L),_(ne))})};if(F.devMode||F.pseudo||!F.language)return A({localized:(0,u.joinPath)(H,"package.nls.json"),original:null});_(F.language)})}formatMessage(H,F){return`[${H.path}]: ${F}`}};oe=ve([ie(1,y.IExtensionsProfileScannerService),ie(2,T.IUriIdentityService),ie(3,r.IFileService),ie(4,o.ILogService)],oe);let ae=class extends oe{constructor(H,F,A,O,_,ne){super(F,A,O,_,ne),this.cacheFile=H,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(H){const F=await this.readExtensionCache();if(this.input=H,F&&F.input&&V.equals(F.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),F.result.map(O=>(O.location=d.URI.revive(O.location),O));const A=await super.scanExtensions(H);return await this.writeExtensionCache({input:H,result:A}),A}async readExtensionCache(){try{const H=await this.fileService.readFile(this.cacheFile),F=JSON.parse(H.value.toString());return{result:F.result,input:(0,a.revive)(F.input)}}catch(H){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(H))}return null}async writeExtensionCache(H){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(H)))}catch(F){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(F))}}async validateCache(){if(!this.input)return;const H=await this.readExtensionCache();if(!H)return;const F=H.result,A=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(A,F))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(O){this.logService.error(O)}}};ae=ve([ie(2,y.IExtensionsProfileScannerService),ie(3,T.IUriIdentityService),ie(4,r.IFileService),ie(5,o.ILogService)],ae);function se(K,H){const F=(0,h.getExtensionId)(K.manifest.publisher,K.manifest.name);return{id:F,identifier:new l.ExtensionIdentifier(F),isBuiltin:K.type===0,isUserBuiltin:K.type===1&&K.isBuiltin,isUnderDevelopment:H,extensionLocation:K.location,uuid:K.identifier.uuid,targetPlatform:K.targetPlatform,...K.manifest}}e.toExtensionDescription=se;class fe extends G{constructor(H,F,A,O,_,ne,N,$,L,W,j){super(H,F,(0,u.joinPath)(A,".vscode-oss-dev","extensions","control.json"),(0,u.joinPath)(O,l.MANIFEST_CACHE_FOLDER),_,ne,N,$,L,W,j),this.translationsPromise=(async()=>{if(I.translationsConfigFile)try{const q=await this.fileService.readFile(d.URI.file(I.translationsConfigFile));return JSON.parse(q.value.toString())}catch{}return Object.create(null)})()}getTranslations(H){return this.translationsPromise}}e.NativeExtensionsScannerService=fe}),define(ee[253],te([0,1,7,34,87,116,15,5,6,20,41]),function(z,e,E,t,k,R,D,P,p,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let C=class extends R.NativeExtensionsScannerService{constructor(u,w,g,f,d,S,m){super(E.URI.file(d.builtinExtensionsPath),E.URI.file(d.extensionsPath),d.userHome,E.URI.file(d.userDataPath),u,w,g,f,d,S,m)}};C=ve([ie(0,b.IUserDataProfilesService),ie(1,k.IExtensionsProfileScannerService),ie(2,D.IFileService),ie(3,p.ILogService),ie(4,t.INativeEnvironmentService),ie(5,v.IProductService),ie(6,P.IInstantiationService)],C),e.ExtensionsScannerService=C}),define(ee[254],te([0,1,13,2,14,9,4,58,7,29,40,34,6,41]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let w=class extends t.Disposable{constructor(f,d,S){super(),this.environmentService=f,this.logService=S,this.validRoots=P.TernarySearchTree.forPaths(!D.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(f.appRoot),this.addValidFileRoot(f.extensionsPath),this.addValidFileRoot(d.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(f.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:f}=E.session;f.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,(d,S)=>this.handleResourceRequest(d,S)),f.protocol.interceptFileProtocol(k.Schemas.file,(d,S)=>this.handleFileRequest(d,S)),this._register((0,t.toDisposable)(()=>{f.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),f.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(f){const d=(0,R.normalize)(f);return this.validRoots.get(d)?t.Disposable.None:(this.validRoots.set(d,!0),(0,t.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(f,d){const S=p.URI.parse(f.url);return this.logService.error(`Refused to load resource ${S.fsPath} from ${k.Schemas.file}: protocol (original URL: ${f.url})`),d({error:-3})}handleResourceRequest(f,d){const S=this.requestToNormalizedFilePath(f);let m;return this.environmentService.crossOriginIsolated&&((0,R.basename)(S)==="workbench.html"||(0,R.basename)(S)==="workbench-dev.html"?m=k.COI.CoopAndCoep:m=k.COI.getHeadersFromQuery(f.url)),this.validRoots.findSubstr(S)?d({path:S,headers:m}):this.validExtensions.has((0,R.extname)(S).toLowerCase())?d({path:S}):(this.logService.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${S} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${f.url})`),d({error:-3}))}requestToNormalizedFilePath(f){const d=p.URI.parse(f.url),S=k.FileAccess.asFileUri(d);return(0,R.normalize)(S.fsPath)}createIPCObjectUrl(){let f;const d=p.URI.from({scheme:"vscode",path:(0,v.generateUuid)()}),S=d.toString(),m=async()=>f;return b.validatedIpcMain.handle(S,m),this.logService.trace(`IPC Object URL: Registered new channel ${S}.`),{resource:d,update:h=>f=h,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${S}.`),b.validatedIpcMain.removeHandler(S)}}}};w=ve([ie(0,C.INativeEnvironmentService),ie(1,u.IUserDataProfilesService),ie(2,I.ILogService)],w),e.ProtocolMainService=w}),define(ee[255],te([0,1,13,40,8,3,2,14,12,102,26,21,6,54,61,64,43,41,36]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g,f,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let m=class extends D.Disposable{constructor(l,n,r,i,o,s,c,a,y){super(),this.machineId=l,this.userEnv=n,this.environmentMainService=r,this.userDataProfilesService=i,this.lifecycleMainService=o,this.logService=s,this.policyService=c,this.themeMainService=a,this.protocolMainService=y,this.firstWindowConnectionBarrier=new k.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(l,n)=>this.onWindowConnection(l,n)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(l,n)=>this.onWorkerConnection(l,n)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(l,n){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const r=await this.connect();if(l.sender.isDestroyed())return r.close();l.sender.postMessage("vscode:createSharedProcessMessageChannelResult",n,[r])}onWorkerConnection(l,n){this.logService.trace("SharedProcess: onWorkerConnection",n);const r=new D.DisposableStore,i=s=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${s}')`,n),r.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",n))},o=E.BrowserWindow.fromId(n.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!n.reply.channel){i("unavailable");return}r.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===o)(()=>i("load"))),r.add(R.Event.fromNodeEventEmitter(o,"closed")(()=>i("closed"))),o.webContents.postMessage(n.reply.channel,n.reply.nonce,l.ports)}onWillShutdown(){const l=this.window;!l||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(l.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{l.close()}catch{}this.window=void 0},0))}send(l,...n){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${l}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(l,...n)}catch(r){this.logService.warn(`Error sending IPC message to channel '${l}' of shared process: ${(0,f.toErrorMessage)(r)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),l()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),l()}))})()),this._whenIpcReady}createWindow(){const l=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new E.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),l.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:u.default,policiesData:this.policyService.serialize()}),this.window.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=l=>{this.logService.trace("SharedProcess#close prevented"),l.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(l,n)=>this._onDidError.fire({type:2,details:n})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(l,n,r)=>this._onDidError.fire({type:3,details:{reason:r,exitCode:n}})))}async connect(){await this.whenIpcReady;const l=(0,p.assertIsDefined)(this.window);return(0,v.connect)(l)}async toggle(){await this.whenIpcReady,this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const l=this.window;return l?!l.isDestroyed()&&!l.webContents.isDestroyed():!1}};m=ve([ie(2,b.IEnvironmentMainService),ie(3,d.IUserDataProfilesService),ie(4,C.ILifecycleMainService),ie(5,I.ILogService),ie(6,S.IPolicyService),ie(7,g.IThemeMainService),ie(8,w.IProtocolMainService)],m),e.SharedProcess=m}),define(ee[90],te([0,1,8,3,2,72,12,103,5,41]),function(z,e,E,t,k,R,D,P,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,p.createDecorator)("storageService");var b;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var C;(function(S){S[S.APPLICATION=-1]="APPLICATION",S[S.PROFILE=0]="PROFILE",S[S.WORKSPACE=1]="WORKSPACE"})(C=e.StorageScope||(e.StorageScope={}));var I;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));function u(S){const m=S.get(e.TARGET_KEY);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}e.loadKeyTargets=u;class w extends k.Disposable{constructor(m={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super(),this.options=m,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new E.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,E.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,h){if(h===e.TARGET_KEY){switch(m){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:m})}else this._onDidChangeValue.fire({scope:m,key:h,target:this.getKeyTargets(m)[h]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,h,l){return this.getStorage(h)?.get(m,l)}getBoolean(m,h,l){return this.getStorage(h)?.getBoolean(m,l)}getNumber(m,h,l){return this.getStorage(h)?.getNumber(m,l)}store(m,h,l,n){if((0,D.isUndefinedOrNull)(h)){this.remove(m,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,l,n),this.getStorage(l)?.set(m,h)})}remove(m,h){this.withPausedEmitters(()=>{this.updateKeyTarget(m,h,void 0),this.getStorage(h)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,h){const l=[],n=this.getKeyTargets(m);for(const r of Object.keys(n))n[r]===h&&l.push(r);return l}updateKeyTarget(m,h,l){const n=this.getKeyTargets(h);typeof l=="number"?n[m]!==l&&(n[m]=l,this.getStorage(h)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[m]=="number"&&(delete n[m],this.getStorage(h)?.set(e.TARGET_KEY,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(m){switch(m){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(m){const h=this.getStorage(m);return h?u(h):Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=b.NONE){this._onWillSaveState.fire({reason:m});const h=this.getStorage(-1),l=this.getStorage(0),n=this.getStorage(1);switch(m){case b.NONE:await E.Promises.settled([h?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await E.Promises.settled([h?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.getStorage(-1)?.items??new Map,h=this.getStorage(0)?.items??new Map,l=this.getStorage(1)?.items??new Map;return d(m,h,l,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(m,h){return this.emitWillSaveState(b.NONE),(0,v.isUserDataProfile)(m)?this.switchToProfile(m,h):this.switchToWorkspace(m,h)}canSwitchProfile(m,h){return!(m.id===h.id||g(h)&&g(m))}switchData(m,h,l,n){this.withPausedEmitters(()=>{if(n)for(const[r,i]of m)h.set(r,i);else{const r=new Set;for(const[i,o]of m)r.add(i),h.get(i)!==o&&this.emitDidChangeValue(l,i);for(const[i]of h.items)r.has(i)||this.emitDidChangeValue(l,i)}})}}e.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;function g(S){return S.isDefault||!!S.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=g;class f extends w{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.profileStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m))),this._register(this.applicationStorage.onDidChangeStorage(m=>this.emitDidChangeValue(-1,m)))}getStorage(m){switch(m){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(m){return!1}}e.InMemoryStorageService=f;async function d(S,m,h,l,n,r){const i=Y=>{try{return JSON.parse(Y)}catch{return Y}},o=new Map,s=new Map;S.forEach((Y,G)=>{o.set(G,Y),s.set(G,i(Y))});const c=new Map,a=new Map;m.forEach((Y,G)=>{c.set(G,Y),a.set(G,i(Y))});const y=new Map,M=new Map;h.forEach((Y,G)=>{y.set(G,Y),M.set(G,i(Y))}),console.group(l!==n?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const T=[];if(o.forEach((Y,G)=>{T.push({key:G,value:Y})}),console.table(T),console.groupEnd(),console.log(s),l!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const Y=[];c.forEach((G,V)=>{Y.push({key:V,value:G})}),console.table(Y),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const U=[];y.forEach((Y,G)=>{U.push({key:G,value:Y})}),console.table(U),console.groupEnd(),console.log(M)}e.logStorage=d}),define(ee[256],te([0,1,24,8,3,2,9,80,7,23,103,146,6,90,35,28]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class f extends R.Disposable{get storage(){return this._storage}constructor(r,i){super(),this.logService=r,this.fileService=i,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new b.Storage(new b.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=b.StorageState.None}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===b.StorageState.None)try{const r=await this.doCreate();this._storage.dispose(),this._storage=r,this._register(r.onDidChangeStorage(o=>this._onDidChangeStorage.fire({key:o}))),await this.doInit(r);const i=r.getBoolean(u.IS_NEW_KEY);i===void 0?r.set(u.IS_NEW_KEY,!0):i&&r.set(u.IS_NEW_KEY,!1)}catch(r){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.state=b.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===I.LogLevel.Trace?r=>this.logService.trace(r):void 0,logError:r=>this.logService.error(r)}}doInit(r){return r.init()}get items(){return this._storage.items}get(r,i){return this._storage.get(r,i)}set(r,i){return this._storage.set(r,i)}delete(r){return this._storage.delete(r)}async close(){const r=new P.StopWatch(!1);await this.doClose(),r.stop(),r.elapsed()>f.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(r),this._onDidCloseStorage.fire()}async logSlowClose(r){if(!!this.path)try{const i=(0,E.top)(Array.from(this._storage.items.entries()).map(([s,c])=>({key:s,length:c.length})),(s,c)=>c.length-s.length,5).map(s=>`${s.key}:${s.length}`).join(", "),o=(await this.fileService.stat(p.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${o}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=b.StorageState.Closed,await this._storage.close()}}f.LOG_SLOW_CLOSE_THRESHOLD=2e3;class d extends f{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,d.STORAGE_NAME)}constructor(r,i,o,s){super(o,s),this.profile=r,this.options=i}async doCreate(){return new b.Storage(new C.SQLiteStorageDatabase(this.path??C.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}d.STORAGE_NAME="state.vscdb";class S extends d{constructor(r,i,o,s){super(r,i,o,s)}}e.ProfileStorageMain=S;class m extends d{constructor(r,i,o,s){super(i.defaultProfile,r,o,s)}async doInit(r){await super.doInit(r),this.updateTelemetryState(r)}updateTelemetryState(r){r.get(w.firstSessionDateStorageKey,void 0)===void 0&&r.set(w.firstSessionDateStorageKey,new Date().toUTCString());const o=r.get(w.currentSessionDateStorageKey,void 0),s=new Date().toUTCString();r.set(w.lastSessionDateStorageKey,typeof o>"u"?null:o),r.set(w.currentSessionDateStorageKey,s)}}e.ApplicationStorageMain=m;class h extends f{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,h.WORKSPACE_STORAGE_NAME)}constructor(r,i,o,s,c){super(o,c),this.workspace=r,this.options=i,this.environmentService=s}async doCreate(){const{storageFilePath:r,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new b.Storage(new C.SQLiteStorageDatabase(r,{logging:this.createLoggingOptions()}),{hint:i?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:C.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const r=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,D.join)(r,h.WORKSPACE_STORAGE_NAME);return await v.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await v.Promises.mkdir(r,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(r),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(r){let i;if((0,g.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,g.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const o=(0,D.join)(r,h.WORKSPACE_META_NAME);await v.Promises.exists(o)||await v.Promises.writeFile(o,JSON.stringify(i,void 0,2))}catch(o){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${o}`)}}}e.WorkspaceStorageMain=h,h.WORKSPACE_STORAGE_NAME="state.vscdb",h.WORKSPACE_META_NAME="workspace.json";class l extends f{get path(){}async doCreate(){return new b.Storage(new b.InMemoryStorageDatabase)}}e.InMemoryStorageMain=l}),define(ee[257],te([0,1,68,34,15,6,227,51,41]),function(z,e,E,t,k,R,D,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let v=class At extends p.UserDataProfilesService{constructor(C,I,u,w,g){super(u,w,I,g),this.stateService=C}getStoredProfiles(){return(0,E.revive)(this.stateService.getItem(At.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,E.revive)(this.stateService.getItem(At.PROFILE_ASSOCIATIONS_KEY,{}))}};v=ve([ie(0,D.IStateService),ie(1,P.IUriIdentityService),ie(2,t.IEnvironmentService),ie(3,k.IFileService),ie(4,R.ILogService)],v),e.UserDataProfilesService=v}),define(ee[48],te([0,1,7,34,15,5,6,37,51,41,257]),function(z,e,E,t,k,R,D,P,p,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(v.IUserDataProfilesService);let C=class ht extends b.UserDataProfilesService{constructor(u,w,g,f,d){super(u,w,g,f,d),this.stateMainService=u}setEnablement(u){super.setEnablement(u),this.enabled||(this.saveStoredProfiles([]),this.saveStoredProfileAssociations({}))}checkAndCreateProfileFromCli(u){if(!!this.isEnabled()){if(u.profile){const w=this.profiles.find(g=>g.name===u.profile);return w?Promise.resolve(w):this.createNamedProfile(u.profile)}if(u["profile-temp"])return this.createTransientProfile()}}saveStoredProfiles(u){u.length?this.stateMainService.setItem(ht.PROFILES_KEY,u):this.stateMainService.removeItem(ht.PROFILES_KEY)}saveStoredProfileAssociations(u){u.emptyWindow||u.workspaces?this.stateMainService.setItem(ht.PROFILE_ASSOCIATIONS_KEY,u):this.stateMainService.removeItem(ht.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const u="workspaceAndProfileInfo",w=this.stateMainService.getItem(u,void 0);if(w){this.stateMainService.removeItem(u);const g=w.reduce((f,{workspace:d,profile:S})=>(f[E.URI.revive(d).toString()]=E.URI.revive(S).toString(),f),{});this.stateMainService.setItem(ht.PROFILE_ASSOCIATIONS_KEY,{workspaces:g})}return super.getStoredProfileAssociations()}};C=ve([ie(0,P.IStateMainService),ie(1,p.IUriIdentityService),ie(2,t.IEnvironmentService),ie(3,k.IFileService),ie(4,D.ILogService)],C),e.UserDataProfilesMainService=C}),define(ee[258],te([0,1,13,24,4,7,23,18,59,5,6,114,31,48]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,v.createDecorator)(e.ID);let w=class{constructor(f,d,S,m,h){this.logService=f,this.windowsMainService=d,this.urlService=S,this.configurationService=m,this.userDataProfilesMainService=h}async start(f,d){this.logService.trace("Received data from other instance: ",f,d),k.isMacintosh&&E.app.focus({steal:!0});const S=this.parseOpenUrl(f);if(S.length){let m=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const h=(0,t.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));h&&(m=h.ready())}m.then(()=>{for(const{uri:h,url:l}of S)this.urlService.open(h,{originalUrl:l})})}else return this.startOpenWindow(f,d)}parseOpenUrl(f){return f["open-url"]&&f._urls&&f._urls.length>0?(0,t.coalesce)(f._urls.map(d=>{try{return{uri:R.URI.parse(d),url:d}}catch{return null}})):[]}async startOpenWindow(f,d){const S=(0,p.isLaunchedFromCli)(d)?0:4;let m=[];const h=f.wait&&f.waitMarkerFilePath?R.URI.file(f.waitMarkerFilePath):void 0,l=f.remote||void 0,n=await this.userDataProfilesMainService.checkAndCreateProfileFromCli(f),r={context:S,cli:f,userEnv:d,waitMarkerFileURI:h,remoteAuthority:l,profile:n};if(f.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(f.extensionDevelopmentPath,r);else if(!f._.length&&!f["folder-uri"]&&!f["file-uri"]){let i=!1;if(f["new-window"]||f["unity-launch"]||n)i=!0;else if(f["reuse-window"])i=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!k.isMacintosh}if(i)m=await this.windowsMainService.open({...r,forceNewWindow:!0,forceEmpty:!0});else{const o=this.windowsMainService.getLastActiveWindow();o?(this.windowsMainService.openExistingWindow(o,r),m=[o]):m=await this.windowsMainService.open({...r,forceEmpty:!0})}}else m=await this.windowsMainService.open({...r,forceNewWindow:f["new-window"],preferNewWindow:!f["reuse-window"]&&!f.wait,forceReuseWindow:f["reuse-window"],diffMode:f.diff,mergeMode:f.merge,addMode:f.add,noRecentEntry:!!f["skip-add-to-recently-opened"],gotoLineMode:f.goto});if(h&&m.length===1&&m[0])return Promise.race([m[0].whenClosedOrLoaded,(0,D.whenDeleted)(h.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};w=ve([ie(0,b.ILogService),ie(1,I.IWindowsMainService),ie(2,C.IURLService),ie(3,P.IConfigurationService),ie(4,u.IUserDataProfilesMainService)],w),e.LaunchMainService=w}),define(ee[91],te([0,1,7,49,3,2,34,15,5,21,6,90,256,41,48,51]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,p.createDecorator)("storageMainService");let f=class extends R.Disposable{constructor(m,h,l,n,r,i){super(),this.logService=m,this.environmentService=h,this.userDataProfilesService=l,this.lifecycleMainService=n,this.fileService=r,this.uriIdentityService=i,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new k.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(m=>{m.window.profile&&this.profileStorage(m.window.profile).init(),m.workspace&&this.workspaceStorage(m.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(m=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=m.reason,m.join(this.applicationStorage.close());for(const[,h]of this.mapProfileToStorage)m.join(h.close());for(const[,h]of this.mapWorkspaceToStorage)m.join(h.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(m=>{m.join((async()=>{await this.fileService.exists(m.profile.globalStorageHome)||await this.fileService.createFolder(m.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(m=>{const h=this.mapProfileToStorage.get(m.profile.id);h&&m.join(h.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const m=new I.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,t.once)(m.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),m}profileStorage(m){if((0,C.isProfileUsingDefaultStorage)(m))return this.applicationStorage;let h=this.mapProfileToStorage.get(m.id);if(!h){this.logService.trace(`StorageMainService: creating profile storage (${m.name})`),h=this.createProfileStorage(m),this.mapProfileToStorage.set(m.id,h);const l=this._register(h.onDidChangeStorage(n=>this._onDidChangeProfileStorage.fire({...n,storage:h,profile:m})));(0,t.once)(h.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${m.name})`),this.mapProfileToStorage.delete(m.id),l.dispose()})}return h}createProfileStorage(m){return this.shutdownReason===2?new I.InMemoryStorageMain(this.logService,this.fileService):new I.ProfileStorageMain(m,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(m){let h=this.mapWorkspaceToStorage.get(m.id);return h||(this.logService.trace(`StorageMainService: creating workspace storage (${m.id})`),h=this.createWorkspaceStorage(m),this.mapWorkspaceToStorage.set(m.id,h),(0,t.once)(h.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${m.id})`),this.mapWorkspaceToStorage.delete(m.id)})),h}createWorkspaceStorage(m){return this.shutdownReason===2?new I.InMemoryStorageMain(this.logService,this.fileService):new I.WorkspaceStorageMain(m,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(m){const h=E.URI.file(m);for(const l of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(!!l.path&&this.uriIdentityService.extUri.isEqualOrParent(E.URI.file(l.path),h))return!0;return!1}};f=ve([ie(0,b.ILogService),ie(1,D.IEnvironmentService),ie(2,w.IUserDataProfilesMainService),ie(3,v.ILifecycleMainService),ie(4,P.IFileService),ie(5,g.IUriIdentityService)],f),e.StorageMainService=f,e.IApplicationStorageMainService=(0,p.createDecorator)("applicationStorageMainService");let d=class extends C.AbstractStorageService{constructor(m,h){super(),this.userDataProfilesService=m,this.storageMainService=h,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(m){if(m===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(m){if(m===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};d=ve([ie(0,u.IUserDataProfilesService),ie(1,e.IStorageMainService)],d),e.ApplicationStorageMainService=d}),define(ee[259],te([0,1,2,21,48]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let R=class extends E.Disposable{constructor(P,p){super(),this.userDataProfilesService=p,this._register(P.onWillLoadWindow(v=>{v.reason===2&&this.unsetTransientProfileForWorkspace(v.window.openedWorkspace??"empty-window")})),this._register(P.onBeforeCloseWindow(v=>this.unsetTransientProfileForWorkspace(v.openedWorkspace??"empty-window")))}async unsetTransientProfileForWorkspace(P){this.userDataProfilesService.getOrSetProfileForWorkspace(P).isTransient&&(this.userDataProfilesService.unsetWorkspace(P,!0),await this.userDataProfilesService.cleanUpTransientProfiles())}};R=ve([ie(0,t.ILifecycleMainService),ie(1,k.IUserDataProfilesMainService)],R),e.UserDataTransientProfilesHandler=R}),define(ee[260],te([0,1,3,2,90]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends t.Disposable{constructor(P,p,v){super(),this.storageMainService=P,this.userDataProfilesService=p,this.logService=v;const b=this._register(new t.MutableDisposable);this._onDidChange=this._register(new E.Emitter({onWillAddFirstListener:()=>b.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>b.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new t.DisposableStore;return P.add(E.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(p,v)=>(p?p.push(v.key):p=[v.key],p),100)(p=>this.onDidChangeApplicationStorage(p))),P.add(E.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(p,v)=>{p||(p=new Map);let b=p.get(v.profile.id);return b||p.set(v.profile.id,b={profile:v.profile,keys:[],storage:v.storage}),b.keys.push(v.key),p},100)(p=>this.onDidChangeProfileStorage(p))),P}onDidChangeApplicationStorage(P){const p=P.includes(k.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],v=[];if(P=P.filter(b=>b!==k.TARGET_KEY),P.length){const b=(0,k.loadKeyTargets)(this.storageMainService.applicationStorage.storage);v.push({profile:this.userDataProfilesService.defaultProfile,changes:P.map(C=>({key:C,scope:0,target:b[C]}))})}this.triggerEvents(p,v)}onDidChangeProfileStorage(P){const p=[],v=new Map;for(const[b,C]of P.entries()){C.keys.includes(k.TARGET_KEY)&&p.push(C.profile);const I=C.keys.filter(u=>u!==k.TARGET_KEY);if(I.length){const u=(0,k.loadKeyTargets)(C.storage.storage);v.set(b,{profile:C.profile,changes:I.map(w=>({key:w,scope:0,target:u[w]}))})}}this.triggerEvents(p,[...v.values()])}triggerEvents(P,p){(P.length||p.length)&&this._onDidChange.fire({valueChanges:p,targetChanges:P})}listen(P,p,v){switch(p){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${p}`)}async call(P,p){throw new Error(`Call not found: ${p}`)}}e.ProfileStorageChangesListenerChannel=R}),define(ee[117],te([0,1,19,7,28]),function(z,e,E,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(p,v,b){for(const I of p){const u=I.openedWorkspace;if((0,k.isWorkspaceIdentifier)(u)){const w=await b(u);if(w){if(w.folders.some(g=>E.extUriBiasedIgnorePathCase.isEqualOrParent(v,g.uri)))return I}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(v,u.configPath))return I}}const C=p.filter(I=>(0,k.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(v,I.openedWorkspace.uri));if(C.length)return C.sort((I,u)=>-(I.openedWorkspace.uri.path.length-u.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function D(p,v){for(const b of p)if((0,k.isWorkspaceIdentifier)(b.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.configPath,v)||(0,k.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.uri,v))return b}e.findWindowOnWorkspaceOrFolder=D;function P(p,v){const b=C=>v.some(I=>E.extUriBiasedIgnorePathCase.isEqual(t.URI.file(I),t.URI.file(C)));for(const C of p)if(C.config?.extensionDevelopmentPath?.some(I=>b(I)))return C}e.findWindowOnExtensionDevelopmentPath=P}),define(ee[261],te([0,1,13,2,4,19,7,18,21,6,37,31,115,28]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let w=class Tt extends t.Disposable{get state(){return this._state}constructor(h,l,n,r,i){super(),this.windowsMainService=h,this.stateMainService=l,this.lifecycleMainService=n,this.logService=r,this.configurationService=i,this._state=g(this.stateMainService.getItem(Tt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){E.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h=new Set,l={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!l.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(o=>!o.isExtensionDevelopmentHost)),i&&(l.lastActiveWindow=this.toWindowState(i),l.lastActiveWindow.uiState.mode===3&&h.add(l.lastActiveWindow.uiState.display))}const n=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);n&&(l.lastPluginDevelopmentHostWindow=this.toWindowState(n),l.lastPluginDevelopmentHostWindow.uiState.mode===3&&(h.has(l.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!n.win?.isSimpleFullScreen()&&(l.lastPluginDevelopmentHostWindow.uiState.mode=1):h.add(l.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(l.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const o=this.toWindowState(i);return o.uiState.mode===3&&(h.has(o.uiState.display)?k.isMacintosh&&o.windowId!==l.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(o.uiState.mode=1):h.add(o.uiState.display)),o}));const r=d(l);this.stateMainService.setItem(Tt.windowsStateStorageKey,r),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",r)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const l=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=l:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(n=>{const r=(0,u.isWorkspaceIdentifier)(h.openedWorkspace)&&n.workspace?.id===h.openedWorkspace.id,i=(0,u.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&n.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(n.folderUri,h.openedWorkspace.uri);(r||i)&&(n.uiState=l.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=l)}toWindowState(h){return{windowId:h.id,workspace:(0,u.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,u.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const l=this.doGetNewWindowState(h),n=this.configurationService.getValue("window");if(l.mode===3){let r;l.hasDefaultState?r=!!(n?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(n.newWindowDimensions)>=0):r=!!(this.lifecycleMainService.wasRestarted||n?.restoreFullscreen),r||(l.mode=1)}return l}doGetNewWindowState(h){const l=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=h.workspace;if((0,u.isWorkspaceIdentifier)(c)){const y=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===c.id).map(M=>M.uiState);if(y.length)return y[0]}if((0,u.isSingleFolderWorkspaceIdentifier)(c)){const y=this.state.openedWindows.filter(M=>M.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(M.folderUri,c.uri)).map(M=>M.uiState);if(y.length)return y[0]}else if(h.backupPath){const y=this.state.openedWindows.filter(M=>M.backupPath===h.backupPath).map(M=>M.uiState);if(y.length)return y[0]}const a=this.lastClosedState||this.state.lastActiveWindow;if(!l&&a)return a.uiState}let n;const r=E.screen.getAllDisplays();if(r.length===1)n=r[0];else{if(k.isMacintosh){const c=E.screen.getCursorScreenPoint();n=E.screen.getDisplayNearestPoint(c)}!n&&l&&(n=E.screen.getDisplayMatching(l.getBounds())),n||(n=E.screen.getPrimaryDisplay()||r[0])}let i=(0,I.defaultWindowState)();i.x=Math.round(n.bounds.x+n.bounds.width/2-i.width/2),i.y=Math.round(n.bounds.y+n.bounds.height/2-i.height/2);const o=this.configurationService.getValue("window");let s=!0;if(o?.newWindowDimensions){if(o.newWindowDimensions==="maximized")i.mode=0,s=!1;else if(o.newWindowDimensions==="fullscreen")i.mode=3,s=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&l){const c=l.serializeWindowState();c.mode===3?i.mode=3:i=c,s=i.mode!==3&&o.newWindowDimensions==="offset"}}return s&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const l=this.windowsMainService.getWindows().map(n=>n.getBounds());for(;l.some(n=>n.x===h.x||n.y===h.y);)h.x+=30,h.y+=30;return h}};w.windowsStateStorageKey="windowsState",w=ve([ie(0,C.IWindowsMainService),ie(1,b.IStateMainService),ie(2,p.ILifecycleMainService),ie(3,v.ILogService),ie(4,P.IConfigurationService)],w),e.WindowsStateHandler=w;function g(m){const h={openedWindows:[]},l=m||{openedWindows:[]};return l.lastActiveWindow&&(h.lastActiveWindow=f(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=f(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(h.openedWindows=l.openedWindows.map(n=>f(n))),h}e.restoreWindowsState=g;function f(m){const h={uiState:m.uiState};return m.backupPath&&(h.backupPath=m.backupPath),m.remoteAuthority&&(h.remoteAuthority=m.remoteAuthority),m.folder&&(h.folderUri=D.URI.parse(m.folder)),m.workspaceIdentifier&&(h.workspace={id:m.workspaceIdentifier.id,configPath:D.URI.parse(m.workspaceIdentifier.configURIPath)}),h}function d(m){return{lastActiveWindow:m.lastActiveWindow&&S(m.lastActiveWindow),lastPluginDevelopmentHostWindow:m.lastPluginDevelopmentHostWindow&&S(m.lastPluginDevelopmentHostWindow),openedWindows:m.openedWindows.map(h=>S(h))}}e.getWindowsStateStoreData=d;function S(m){return{workspaceIdentifier:m.workspace&&{id:m.workspace.id,configURIPath:m.workspace.configPath.toString()},folder:m.folderUri&&m.folderUri.toString(),backupPath:m.backupPath,remoteAuthority:m.remoteAuthority,uiState:m.uiState}}}),define(ee[92],te([0,1,30,42,123,33,14,9,4,19,7,5,63,28]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,C.createDecorator)("workspacesService");function w(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function g(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=g;function f(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=f;function d(M){return S(M)||m(M)}e.isStoredWorkspaceFolder=d;function S(M){const T=M;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function m(M){const T=M;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function h(M,T,U,Y,G){if(M.scheme!==Y.scheme)return{name:U,uri:M.toString(!0)};let V=T?void 0:G.relativePath(Y,M);if(V!==void 0)V.length===0?V=".":p.isWindows&&(V=l(V));else if(M.scheme===D.Schemas.file)V=M.fsPath,p.isWindows&&(V=l(V));else if(G.isEqualAuthority(M.authority,Y.authority))V=M.path;else return{name:U,uri:M.toString(!0)};return{name:U,path:V}}e.getStoredWorkspaceFolder=h;function l(M){return M=(0,R.normalizeDriveLetter)(M),(0,E.isUNC)(M)||(M=(0,E.toSlashes)(M)),M}function n(M,T,U){const Y=[],G=new Set,V=U.dirname(T);for(const oe of M){let ae;if(S(oe))oe.path&&(ae=U.resolvePath(V,oe.path));else if(m(oe))try{ae=b.URI.parse(oe.uri),ae.path[0]!==P.posix.sep&&(ae=ae.with({path:P.posix.sep+ae.path}))}catch(se){console.warn(se)}if(ae){const se=U.getComparisonKey(ae);if(!G.has(se)){G.add(se);const fe=oe.name||U.basenameOrAuthority(ae);Y.push(new u.WorkspaceFolder({uri:ae,name:fe,index:Y.length},oe))}}}return Y}e.toWorkspaceFolders=n;function r(M,T,U,Y,G){const V=i(T,M),oe=G.dirname(T),ae=G.dirname(Y),se=[];for(const F of V.folders){const A=S(F)?G.resolvePath(oe,F.path):b.URI.parse(F.uri);let O;U?O=!1:O=!S(F)||(0,P.isAbsolute)(F.path),se.push(h(A,O,F.name,ae,G))}const fe={insertSpaces:!1,tabSize:4,eol:p.isLinux||p.isMacintosh?`
`:`\r
`},K=k.setProperty(M,["folders"],se,fe);let H=k.applyEdits(M,K);return(0,v.isEqualAuthority)(V.remoteAuthority,(0,I.getRemoteAuthority)(Y))&&(H=k.applyEdits(H,k.removeProperty(H,["remoteAuthority"],fe))),H}e.rewriteWorkspaceFileForNewLocation=r;function i(M,T){const U=t.parse(T);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(Y=>d(Y));else throw new Error(`${M} looks like an invalid workspace file.`);return U}function o(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function s(M){return typeof M.folderUri=="string"}function c(M){return typeof M.fileUri=="string"}function a(M,T){const U={workspaces:[],files:[]};if(M){const Y=function(V,oe){for(let ae=0;ae<V.length;ae++)try{oe(V[ae],ae)}catch(se){T.warn(`Error restoring recent entry ${JSON.stringify(V[ae])}: ${se.toString()}. Skip entry.`)}},G=M;Array.isArray(G.entries)&&Y(G.entries,V=>{const oe=V.label,ae=V.remoteAuthority;o(V)?U.workspaces.push({label:oe,remoteAuthority:ae,workspace:{id:V.workspace.id,configPath:b.URI.parse(V.workspace.configPath)}}):s(V)?U.workspaces.push({label:oe,remoteAuthority:ae,folderUri:b.URI.parse(V.folderUri)}):c(V)&&U.files.push({label:oe,remoteAuthority:ae,fileUri:b.URI.parse(V.fileUri)})})}return U}e.restoreRecentlyOpened=a;function y(M){const T={entries:[]};for(const U of M.workspaces)g(U)?T.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):T.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of M.files)T.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return T}e.toStoreData=y}),define(ee[93],te([0,1,77,14,4,19]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function D(v){function b(){let C=v.scheme===t.Schemas.file?(0,R.originalFSPath)(v):v.toString();return k.isLinux||(C=C.toLowerCase()),(0,E.createHash)("md5").update(C).digest("hex")}return{id:b(),configPath:v}}e.getWorkspaceIdentifier=D;function P(v,b){function C(){if(v.scheme!==t.Schemas.file)return(0,E.createHash)("md5").update(v.toString()).digest("hex");if(!b)return;let u;return k.isLinux?u=b.ino:k.isMacintosh?u=b.birthtime.getTime():k.isWindows&&(typeof b.birthtimeMs=="number"?u=Math.floor(b.birthtimeMs):u=b.birthtime.getTime()),(0,E.createHash)("md5").update(v.fsPath).update(u?String(u):"").digest("hex")}const I=C();if(typeof I=="string")return{id:I,uri:v}}e.getSingleFolderWorkspaceIdentifier=P;function p(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=p}),define(ee[262],te([0,1,77,30,14,9,4,19,23,176,18,26,37,15,6,175,28,93]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let S=class Ot{constructor(h,l,n,r){this.environmentMainService=h,this.configurationService=l,this.logService=n,this.stateMainService=r,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=P.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,o)=>(0,t.isEqual)(i,o,!D.isLinux)}}async initialize(){const h=await this.initializeAndMigrateBackupWorkspacesMetadata();this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWindows),this.workspaces=await this.validateWorkspaces((0,v.deserializeWorkspaceInfos)(h)),this.folders=await this.validateFolders((0,v.deserializeFolderInfos)(h)),this.storeWorkspacesMetadata()}async initializeAndMigrateBackupWorkspacesMetadata(){let h=this.stateMainService.getItem(Ot.backupWorkspacesMetadataStorageKey);if(!h)try{const l=(0,R.join)(this.backupHome,"workspaces.json"),n=await p.Promises.readFile(l,"utf8");try{await p.Promises.unlink(l)}catch{}const r=JSON.parse(n);h={workspaces:Array.isArray(r.rootURIWorkspaces)?r.rootURIWorkspaces:[],folders:Array.isArray(r.folderWorkspaceInfos)?r.folderWorkspaceInfos:[],emptyWindows:Array.isArray(r.emptyWorkspaceInfos)?r.emptyWorkspaceInfos:[]}}catch(l){l.code!=="ENOENT"&&this.logService.error(`Backup: Could not migrate legacy backup workspaces metadata: ${l.toString()}`)}return h??{workspaces:[],folders:[],emptyWindows:[]}}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==u.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===u.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||u.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(h,l){this.workspaces.some(r=>h.workspace.id===r.workspace.id)||(this.workspaces.push(h),this.storeWorkspacesMetadata());const n=(0,R.join)(this.backupHome,h.workspace.id);return l?this.moveBackupFolder(n,l).then(()=>n):n}async moveBackupFolder(h,l){if(await p.Promises.exists(h)&&await this.convertToEmptyWindowBackup(h),await p.Promises.exists(l))try{await p.Promises.rename(l,h)}catch(n){this.logService.error(`Backup: Could not move backup folder to new location: ${n.toString()}`)}}registerFolderBackup(h){return this.folders.some(l=>this.backupUriComparer.isEqual(h.folderUri,l.folderUri))||(this.folders.push(h),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,this.getFolderHash(h))}registerEmptyWindowBackup(h){return this.emptyWindows.some(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,h.backupFolder))||(this.emptyWindows.push(h),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,h.backupFolder)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const l=new Set,n=[];for(const r of h){const i=r.workspace;if(!(0,f.isWorkspaceIdentifier)(i))return[];if(!l.has(i.id)){l.add(i.id);const o=(0,R.join)(this.backupHome,i.id);await this.doHasBackups(o)?i.configPath.scheme!==k.Schemas.file||await p.Promises.exists(i.configPath.fsPath)?n.push(r):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return n}async validateFolders(h){if(!Array.isArray(h))return[];const l=[],n=new Set;for(const r of h){const i=r.folderUri,o=this.backupUriComparer.getComparisonKey(i);if(!n.has(o)){n.add(o);const s=(0,R.join)(this.backupHome,this.getFolderHash(r));await this.doHasBackups(s)?i.scheme!==k.Schemas.file||await p.Promises.exists(i.fsPath)?l.push(r):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return l}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const l=[],n=new Set;for(const r of h){const i=r.backupFolder;if(typeof i!="string")return[];if(!n.has(i)){n.add(i);const o=(0,R.join)(this.backupHome,i);await this.doHasBackups(o)?l.push(r):await this.deleteStaleBackup(o)}}return l}async deleteStaleBackup(h){try{await p.Promises.rm(h,p.RimRafMode.MOVE)}catch(l){this.logService.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}prepareNewEmptyWindowBackup(){let h=(0,d.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,h.id));)h=(0,d.createEmptyWorkspaceIdentifier)();return{backupFolder:h.id}}async convertToEmptyWindowBackup(h){const l=this.prepareNewEmptyWindowBackup(),n=(0,R.join)(this.backupHome,l.backupFolder);try{await p.Promises.rename(h,n)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push(l),!0}async getDirtyWorkspaces(){const h=[];for(const l of this.workspaces)await this.hasBackups(l)&&h.push(l);for(const l of this.folders)await this.hasBackups(l)&&h.push(l);return h}hasBackups(h){let l;return(0,v.isEmptyWindowBackupInfo)(h)?l=(0,R.join)(this.backupHome,h.backupFolder):(0,g.isFolderBackupInfo)(h)?l=(0,R.join)(this.backupHome,this.getFolderHash(h)):l=(0,R.join)(this.backupHome,h.workspace.id),this.doHasBackups(l)}async doHasBackups(h){try{const l=await p.Promises.readdir(h);for(const n of l)try{if((await p.Promises.readdir((0,R.join)(h,n))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const h={workspaces:this.workspaces.map(({workspace:l,remoteAuthority:n})=>{const r={id:l.id,configURIPath:l.configPath.toString()};return n&&(r.remoteAuthority=n),r}),folders:this.folders.map(({folderUri:l,remoteAuthority:n})=>{const r={folderUri:l.toString()};return n&&(r.remoteAuthority=n),r}),emptyWindows:this.emptyWindows.map(({backupFolder:l,remoteAuthority:n})=>{const r={backupFolder:l};return n&&(r.remoteAuthority=n),r})};this.stateMainService.setItem(Ot.backupWorkspacesMetadataStorageKey,h)}getFolderHash(h){const l=h.folderUri;let n;return l.scheme===k.Schemas.file?n=D.isLinux?l.fsPath:l.fsPath.toLowerCase():n=l.toString().toLowerCase(),(0,E.createHash)("md5").update(n).digest("hex")}};S.backupWorkspacesMetadataStorageKey="backupWorkspaces",S=ve([ie(0,C.IEnvironmentMainService),ie(1,b.IConfigurationService),ie(2,w.ILogService),ie(3,I.IStateMainService)],S),e.BackupMainService=S}),define(ee[52],te([0,1,13,3,42,33,2,14,9,19,12,23,174,60,56,26,5,6,20,48,117,28,92,93]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g,f,d,S,m,h,l,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,f.createDecorator)("workspacesManagementMainService");let i=class extends D.Disposable{constructor(s,c,a,y,M,T){super(),this.environmentMainService=s,this.logService=c,this.userDataProfilesMainService=a,this.backupMainService=y,this.dialogMainService=M,this.productService=T,this._onDidDeleteUntitledWorkspace=this._register(new t.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new t.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const s=(await C.Promises.readdir(this.untitledWorkspacesHome.fsPath)).map(c=>(0,v.joinPath)(this.untitledWorkspacesHome,c,l.UNTITLED_WORKSPACE_NAME));for(const c of s){const a=(0,r.getWorkspaceIdentifier)(c),y=await this.resolveLocalWorkspace(c);y?this.untitledWorkspaces.push({workspace:a,remoteAuthority:y.remoteAuthority}):await this.deleteUntitledWorkspace(a)}}catch(s){s.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${s}).`)}}resolveLocalWorkspace(s){return this.doResolveLocalWorkspace(s,c=>C.Promises.readFile(c,"utf8"))}doResolveLocalWorkspace(s,c){if(!!this.isWorkspacePath(s)&&s.scheme===P.Schemas.file)try{const a=c(s.fsPath);return a instanceof Promise?a.then(y=>this.doResolveWorkspace(s,y),y=>{}):this.doResolveWorkspace(s,a)}catch{return}}isWorkspacePath(s){return(0,l.isUntitledWorkspace)(s,this.environmentMainService)||(0,l.hasWorkspaceFileExtension)(s)}doResolveWorkspace(s,c){try{const a=this.doParseStoredWorkspace(s,c),y=(0,r.getWorkspaceIdentifier)(s);return{id:y.id,configPath:y.configPath,folders:(0,n.toWorkspaceFolders)(a.folders,y.configPath,v.extUriBiasedIgnorePathCase),remoteAuthority:a.remoteAuthority,transient:a.transient}}catch(a){this.logService.warn(a.toString())}}doParseStoredWorkspace(s,c){const a=(0,k.parse)(c);if(a&&Array.isArray(a.folders))a.folders=a.folders.filter(y=>(0,n.isStoredWorkspaceFolder)(y));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return a}async createUntitledWorkspace(s,c){const{workspace:a,storedWorkspace:y}=this.newUntitledWorkspace(s,c),M=a.configPath.fsPath;return await C.Promises.mkdir((0,p.dirname)(M),{recursive:!0}),await C.Promises.writeFile(M,JSON.stringify(y,null,"	")),this.untitledWorkspaces.push({workspace:a,remoteAuthority:c}),a}newUntitledWorkspace(s=[],c){const a=(Date.now()+Math.round(Math.random()*1e3)).toString(),y=(0,v.joinPath)(this.untitledWorkspacesHome,a),M=(0,v.joinPath)(y,l.UNTITLED_WORKSPACE_NAME),T=[];for(const U of s)T.push((0,n.getStoredWorkspaceFolder)(U.uri,!0,U.name,y,v.extUriBiasedIgnorePathCase));return{workspace:(0,r.getWorkspaceIdentifier)(M),storedWorkspace:{folders:T,remoteAuthority:c}}}async getWorkspaceIdentifier(s){return(0,r.getWorkspaceIdentifier)(s)}isUntitledWorkspace(s){return(0,l.isUntitledWorkspace)(s.configPath,this.environmentMainService)}async deleteUntitledWorkspace(s){!this.isUntitledWorkspace(s)||(await this.doDeleteUntitledWorkspace(s),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(s),this._onDidDeleteUntitledWorkspace.fire(s))}async doDeleteUntitledWorkspace(s){const c=(0,v.originalFSPath)(s.configPath);try{await C.Promises.rm((0,p.dirname)(c));const a=(0,p.join)(this.environmentMainService.workspaceStorageHome.fsPath,s.id);await C.Promises.exists(a)&&await C.Promises.writeFile((0,p.join)(a,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(y=>y.workspace.id!==s.id)}catch(a){this.logService.warn(`Unable to delete untitled workspace ${c} (${a}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(s,c,a){if(!s||!s.win||!s.isReady||!await this.isValidTargetWorkspacePath(s,c,a))return;const M=await this.doEnterWorkspace(s,(0,r.getWorkspaceIdentifier)(a));if(!!M)return this._onDidEnterWorkspace.fire({window:s,workspace:M.workspace}),M}async isValidTargetWorkspacePath(s,c,a){if(!a)return!0;if((0,l.isWorkspaceIdentifier)(s.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(s.openedWorkspace.configPath,a))return!1;if((0,h.findWindowOnWorkspaceOrFolder)(c,a)){const y={title:this.productService.nameLong,type:"info",buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(0,null))],message:(0,I.localize)(1,null,(0,v.basename)(a)),detail:(0,I.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(y,(0,b.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),!1}return!0}async doEnterWorkspace(s,c){if(!s.config)return;s.focus();let a;return s.config.extensionDevelopmentPath||(s.config.backupPath?a=await this.backupMainService.registerWorkspaceBackup({workspace:c,remoteAuthority:s.remoteAuthority},s.config.backupPath):a=this.backupMainService.registerWorkspaceBackup({workspace:c,remoteAuthority:s.remoteAuthority})),(0,l.isWorkspaceIdentifier)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&await this.deleteUntitledWorkspace(s.openedWorkspace),s.config.workspace=c,s.config.backupPath=a,{workspace:c,backupPath:a}}};i=ve([ie(0,g.IEnvironmentMainService),ie(1,d.ILogService),ie(2,m.IUserDataProfilesMainService),ie(3,u.IBackupMainService),ie(4,w.IDialogMainService),ie(5,S.IProductService)],i),e.WorkspacesManagementMainService=i}),define(ee[118],te([0,1,13,40,22,5,31,28,52,12,6]),function(z,e,E,t,k,R,D,P,p,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let C=class{constructor(u,w,g){this.windowsMainService=u,this.workspacesManagementMainService=w,this.logService=g}async getRemoteDiagnostics(u){const w=this.windowsMainService.getWindows();return(await Promise.all(w.map(async f=>{const d=f.remoteAuthority;if(!d)return;const S=`vscode:getDiagnosticInfoResponse${f.id}`,m={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?await this.getFolderURIs(f):void 0};return new Promise(h=>{f.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:S,args:m}),t.validatedIpcMain.once(S,(l,n)=>{n||h({hostName:d,errorMessage:`Unable to resolve connection to '${d}'.`}),h(n)}),setTimeout(()=>{h({hostName:d,errorMessage:`Connection to '${d}' could not be established`})},5e3)})}))).filter(f=>!!f)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const u=[];for(const w of E.BrowserWindow.getAllWindows()){const g=this.windowsMainService.getWindowById(w.id);g?u.push(await this.codeWindowToInfo(g)):u.push(this.browserWindowToInfo(w))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async codeWindowToInfo(u){const w=await this.getFolderURIs(u),g=(0,v.assertIsDefined)(u.win);return this.browserWindowToInfo(g,w,u.remoteAuthority)}browserWindowToInfo(u,w=[],g){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:w,remoteAuthority:g}}async getFolderURIs(u){const w=[],g=u.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(g))w.push(g.uri);else if((0,P.isWorkspaceIdentifier)(g)){const f=await this.workspacesManagementMainService.resolveLocalWorkspace(g.configPath);f&&f.folders.forEach(S=>{w.push(S.uri)})}return w}};C=ve([ie(0,D.IWindowsMainService),ie(1,p.IWorkspacesManagementMainService),ie(2,b.ILogService)],C),e.DiagnosticsMainService=C}),define(ee[65],te([0,1,44,13,27,140,53,3,33,2,14,9,4,7,99,81,23,95,164,56,26,5,21,6,20,64,31,28,52,17,221,214]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g,f,d,S,m,h,l,n,r,i,o,s,c,a,y,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,l.createDecorator)("nativeHostMainService");let U=class extends v.Disposable{constructor(G,V,oe,ae,se,fe,K,H,F){super(),this.sharedProcess=G,this.windowsMainService=V,this.dialogMainService=oe,this.lifecycleMainService=ae,this.environmentMainService=se,this.logService=fe,this.productService=K,this.themeMainService=H,this.workspacesManagementMainService=F,this.onDidOpenWindow=P.Event.map(this.windowsMainService.onDidOpenWindow,A=>A.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:A,x:O,y:_})=>({windowId:A.id,x:O,y:_})),({windowId:A})=>!!this.windowsMainService.getWindowById(A)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(A,O)=>O.id),A=>!!this.windowsMainService.getWindowById(A)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(A,O)=>O.id),A=>!!this.windowsMainService.getWindowById(A)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(A,O)=>O.id),A=>!!this.windowsMainService.getWindowById(A)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),A=>!!A),A=>A.id),P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(A,O)=>O.id),A=>!!this.windowsMainService.getWindowById(A))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new P.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(A,O,_)=>_),A=>!(Array.isArray(A)&&A.length===1&&A[0]==="workArea")),P.Event.fromNodeEventEmitter(t.screen,"display-added"),P.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(V=>({id:V.id,workspace:V.openedWorkspace??(0,c.toWorkspaceIdentifier)(V.backupPath,V.isExtensionDevelopmentHost),title:V.win?.getTitle()??"",filename:V.getRepresentedFilename(),dirty:V.isDocumentEdited()}))}async getWindowCount(G){return this.windowsMainService.getWindowCount()}async getActiveWindowId(G){const V=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(V)return V.id}openWindow(G,V,oe){return Array.isArray(V)?this.doOpenWindow(G,V,oe):this.doOpenEmptyWindow(G,V)}async doOpenWindow(G,V,oe=Object.create(null)){V.length>0&&await this.windowsMainService.open({context:5,contextWindowId:G,urisToOpen:V,cli:this.environmentMainService.args,forceNewWindow:oe.forceNewWindow,forceReuseWindow:oe.forceReuseWindow,preferNewWindow:oe.preferNewWindow,diffMode:oe.diffMode,mergeMode:oe.mergeMode,addMode:oe.addMode,gotoLineMode:oe.gotoLineMode,noRecentEntry:oe.noRecentEntry,waitMarkerFileURI:oe.waitMarkerFileURI,remoteAuthority:oe.remoteAuthority||void 0})}async doOpenEmptyWindow(G,V){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:G},V)}async toggleFullScreen(G){this.windowById(G)?.toggleFullScreen()}async handleTitleDoubleClick(G){this.windowById(G)?.handleTitleDoubleClick()}async isMaximized(G){const V=this.windowById(G);return V?.win?V.win.isMaximized():!1}async maximizeWindow(G){const V=this.windowById(G);V?.win&&V.win.maximize()}async unmaximizeWindow(G){const V=this.windowById(G);V?.win&&V.win.unmaximize()}async minimizeWindow(G){const V=this.windowById(G);V?.win&&V.win.minimize()}async updateWindowControls(G,V){const oe=this.windowById(G);oe&&oe.updateWindowControls(V)}async focusWindow(G,V){V&&typeof V.windowId=="number"&&(G=V.windowId),this.windowById(G)?.focus({force:V?.force??!1})}async setMinimumSize(G,V,oe){const ae=this.windowById(G);if(ae?.win){const[se,fe]=ae.win.getSize(),[K,H]=ae.win.getMinimumSize(),[F,A]=[V??K,oe??H],[O,_]=[Math.max(se,F),Math.max(fe,A)];(K!==F||H!==A)&&ae.win.setMinimumSize(F,A),(se!==O||fe!==_)&&ae.win.setSize(O,_)}}async saveWindowSplash(G,V){this.themeMainService.saveWindowSplash(G,V)}async installShellCommand(G){const{source:V,target:oe}=await this.getShellCommandLink();try{const{symbolicLink:ae}=await f.SymlinkSupport.stat(V);if(ae&&!ae.dangling){const se=await(0,w.realpath)(V);if(oe===se)return}await f.Promises.unlink(V)}catch(ae){if(ae.code!=="ENOENT")throw ae}try{await f.Promises.symlink(oe,V)}catch(ae){if(ae.code!=="EACCES"&&ae.code!=="ENOENT")throw ae;const{response:se}=await this.showMessageBox(G,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(0,null,this.productService.nameShort),buttons:[(0,p.mnemonicButtonLabel)((0,S.localize)(1,null)),(0,p.mnemonicButtonLabel)((0,S.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const fe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${oe}' '${V}'\\" with administrator privileges"`;await(0,R.promisify)(E.exec)(fe)}catch{throw new Error((0,S.localize)(3,null,V))}}}async uninstallShellCommand(G){const{source:V}=await this.getShellCommandLink();try{await f.Promises.unlink(V)}catch(oe){switch(oe.code){case"EACCES":{const{response:ae}=await this.showMessageBox(G,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(4,null,this.productService.nameShort),buttons:[(0,p.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,p.mnemonicButtonLabel)((0,S.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ae===0)try{const se=`osascript -e "do shell script \\"rm '${V}'\\" with administrator privileges"`;await(0,R.promisify)(E.exec)(se)}catch{throw new Error((0,S.localize)(7,null,V))}break}case"ENOENT":break;default:throw oe}}}async getShellCommandLink(){const G=(0,C.resolve)(this.environmentMainService.appRoot,"bin","code"),V=`/usr/local/bin/${this.productService.applicationName}`;if(!await f.Promises.exists(G))throw new Error((0,S.localize)(8,null,G));return{source:V,target:G}}async showMessageBox(G,V){return this.dialogMainService.showMessageBox(V,this.toBrowserWindow(G))}async showSaveDialog(G,V){return this.dialogMainService.showSaveDialog(V,this.toBrowserWindow(G))}async showOpenDialog(G,V){return this.dialogMainService.showOpenDialog(V,this.toBrowserWindow(G))}toBrowserWindow(G){const V=this.windowById(G);if(V?.win)return V.win}async pickFileFolderAndOpen(G,V){const oe=await this.dialogMainService.pickFileFolder(V);oe&&await this.doOpenPicked(await Promise.all(oe.map(async ae=>await f.SymlinkSupport.existsDirectory(ae)?{folderUri:u.URI.file(ae)}:{fileUri:u.URI.file(ae)})),V,G)}async pickFolderAndOpen(G,V){const oe=await this.dialogMainService.pickFolder(V);oe&&await this.doOpenPicked(oe.map(ae=>({folderUri:u.URI.file(ae)})),V,G)}async pickFileAndOpen(G,V){const oe=await this.dialogMainService.pickFile(V);oe&&await this.doOpenPicked(oe.map(ae=>({fileUri:u.URI.file(ae)})),V,G)}async pickWorkspaceAndOpen(G,V){const oe=await this.dialogMainService.pickWorkspace(V);oe&&await this.doOpenPicked(oe.map(ae=>({workspaceUri:u.URI.file(ae)})),V,G)}async doOpenPicked(G,V,oe){await this.windowsMainService.open({context:3,contextWindowId:oe,cli:this.environmentMainService.args,urisToOpen:G,forceNewWindow:V.forceNewWindow})}async showItemInFolder(G,V){t.shell.showItemInFolder(V)}async setRepresentedFilename(G,V){this.windowById(G)?.setRepresentedFilename(V)}async setDocumentEdited(G,V){this.windowById(G)?.setDocumentEdited(V)}async openExternal(G,V){return I.isLinuxSnap?this.safeSnapOpenExternal(V):t.shell.openExternal(V),!0}safeSnapOpenExternal(G){const V=process.env.GDK_PIXBUF_MODULE_FILE,oe=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(G),process.env.GDK_PIXBUF_MODULE_FILE=V,process.env.GDK_PIXBUF_MODULEDIR=oe}moveItemToTrash(G,V){return t.shell.trashItem(V)}async isAdmin(){let G;return I.isWindows?G=(await new Promise((V,oe)=>{z(["native-is-elevated"],V,oe)}))():G=process.getuid()===0,G}async writeElevated(G,V,oe,ae){const se=await new Promise((fe,K)=>{z(["@vscode/sudo-prompt"],fe,K)});return new Promise((fe,K)=>{const H=[`"${this.cliPath}"`];ae?.unlock&&H.push("--file-chmod"),H.push("--file-write",`"${V.fsPath}"`,`"${oe.fsPath}"`);const F={name:this.productService.nameLong.replace("-",""),icns:I.isMacintosh&&this.environmentMainService.isBuilt?(0,C.join)((0,C.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};se.exec(H.join(" "),F,(A,O,_)=>{O&&this.logService.trace(`[sudo-prompt] received stdout: ${O}`),_&&this.logService.trace(`[sudo-prompt] received stderr: ${_}`),A?K(A):fe(void 0)})})}get cliPath(){return I.isWindows?this.environmentMainService.isBuilt?(0,C.join)((0,C.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,C.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):I.isLinux?this.environmentMainService.isBuilt?(0,C.join)((0,C.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,C.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,C.join)(this.environmentMainService.appRoot,"bin","code"):(0,C.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return I.isWindows&&(0,M.hasWSLFeatureInstalled)()}async killProcess(G,V,oe){process.kill(V,oe)}async readClipboardText(G,V){return t.clipboard.readText(V)}async writeClipboardText(G,V,oe){return t.clipboard.writeText(V,oe)}async readClipboardFindText(G){return t.clipboard.readFindText()}async writeClipboardFindText(G,V){return t.clipboard.writeFindText(V)}async writeClipboardBuffer(G,V,oe,ae){return t.clipboard.writeBuffer(V,Buffer.from(oe.buffer),ae)}async readClipboardBuffer(G,V){return y.VSBuffer.wrap(t.clipboard.readBuffer(V))}async hasClipboard(G,V,oe){return t.clipboard.has(V,oe)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(G,V){this.windowById(G)?.updateTouchBar(V)}async notifyReady(G){this.windowById(G)?.setReady()}async relaunch(G,V){return this.lifecycleMainService.relaunch(V)}async reload(G,V){const oe=this.windowById(G);if(oe){if((0,c.isWorkspaceIdentifier)(oe.openedWorkspace)){const ae=oe.openedWorkspace.configPath;if(ae.scheme===b.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ae))?.transient)return this.openWindow(oe.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(oe,V?.disableExtensions!==void 0?{_:[],"disable-extensions":V.disableExtensions}:void 0)}}async closeWindow(G){this.closeWindowById(G,G)}async closeWindowById(G,V){const oe=this.windowById(V);if(oe?.win)return oe.win.close()}async quit(G){const V=this.windowsMainService.getLastActiveWindow();V?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&V.win?V.win.close():this.lifecycleMainService.quit()}async exit(G,V){await this.lifecycleMainService.kill(V)}async resolveProxy(G,V){const ae=this.windowById(G)?.win?.webContents?.session;if(ae)return ae.resolveProxy(V)}findFreePort(G,V,oe,ae,se=1){return(0,d.findFreePort)(V,oe,ae,se)}async openDevTools(G,V){const oe=this.windowById(G);oe?.win&&oe.win.webContents.openDevTools(V)}async toggleDevTools(G){const V=this.windowById(G);V?.win&&V.win.webContents.toggleDevTools()}async sendInputEvent(G,V){const oe=this.windowById(G);oe?.win&&(V.type==="mouseDown"||V.type==="mouseUp")&&oe.win.webContents.sendInputEvent(V)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async profileRenderer(G,V,oe){const ae=this.windowById(G);if(!ae||!ae.win)throw new Error;return await new T.WindowProfiler(ae.win,V,this.logService).inspect(oe)}async windowsGetStringRegKey(G,V,oe,ae){if(!I.isWindows)return;const se=await new Promise((fe,K)=>{z(["@vscode/windows-registry"],fe,K)});try{return se.GetStringRegKey(V,oe,ae)}catch{return}}windowById(G){if(typeof G=="number")return this.windowsMainService.getWindowById(G)}};ve([D.memoize],U.prototype,"cliPath",null),U=ve([ie(1,s.IWindowsMainService),ie(2,m.IDialogMainService),ie(3,n.ILifecycleMainService),ie(4,h.IEnvironmentMainService),ie(5,r.ILogService),ie(6,i.IProductService),ie(7,o.IThemeMainService),ie(8,a.IWorkspacesManagementMainService)],U),e.NativeHostMainService=U}),define(ee[263],te([0,1,13,40,27,33,2,14,4,100,162,84,118,56,26,5,6,65,54,20,61,74,30,12]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g,f,d,S,m,h,l,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,g.createDecorator)("issueMainService");let i=class Nt{constructor(s,c,a,y,M,T,U,Y,G){this.userEnv=s,this.environmentMainService=c,this.logService=a,this.diagnosticsService=y,this.diagnosticsMainService=M,this.dialogMainService=T,this.nativeHostMainService=U,this.protocolMainService=Y,this.productService=G,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async s=>{const[c,a]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),y=await this.diagnosticsService.getSystemInfo(c,a);this.safeSend(s,"vscode:issueSystemInfoResponse",y)}),t.validatedIpcMain.on("vscode:listProcesses",async s=>{const c=[];try{c.push({name:(0,b.localize)(0,null),rootProcess:await(0,v.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(y=>{(0,C.isRemoteDiagnosticError)(y)?c.push({name:y.hostName,rootProcess:y}):y.processes&&c.push({name:y.hostName,rootProcess:y.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(s,"vscode:listProcessesResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async s=>{const c={title:this.productService.nameLong,message:(0,b.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,b.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,b.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(c,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",a.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const c=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,b.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,b.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,b.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(s,c)=>{const{id:a,from:y,args:M}=c;let T;switch(y){case"issueReporter":T=this.issueReporterParentWindow;break;case"processExplorer":T=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${y}`)}T?.webContents.send("vscode:runAction",{id:a,from:y,args:M})}),t.validatedIpcMain.on("vscode:openExternal",(s,c)=>{this.nativeHostMainService.openExternal(void 0,c)}),t.validatedIpcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async s=>{const c=await this.diagnosticsMainService.getMainDiagnostics();this.safeSend(s,"vscode:windowsInfoResponse",c.windows)})}safeSend(s,c,...a){s.sender.isDestroyed()||s.sender.send(c,...a)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=E.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const c=new D.DisposableStore,a=c.add(this.protocolMainService.createIPCObjectUrl()),y=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(y,a,{backgroundColor:s.styles.backgroundColor,title:(0,b.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:S.default}),this.issueReporterWindow.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,c.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,c.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=E.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const c=new D.DisposableStore,a=c.add(this.protocolMainService.createIPCObjectUrl()),y=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(y,a,{backgroundColor:s.styles.backgroundColor,title:(0,b.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:S.default}),this.processExplorerWindow.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,c.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,c.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,c,a,y){const M=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:a.title,backgroundColor:a.backgroundColor||Nt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,`--vscode-window-kind=${y}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,l.zoomLevelToZoomFactor)(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop,experimentalDarkMode:!0});return M.setMenuBarVisibility(!1),M}async getSystemStatus(){const[s,c]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,c)}getWindowPosition(s,c,a){let y;const M=E.screen.getAllDisplays();if(M.length===1)y=M[0];else{if(p.isMacintosh){const Y=E.screen.getCursorScreenPoint();y=E.screen.getDisplayNearestPoint(Y)}!y&&s&&(y=E.screen.getDisplayMatching(s.getBounds())),y||(y=E.screen.getPrimaryDisplay()||M[0])}const T={width:c,height:a},U=y.bounds;return T.x=U.x+U.width/2-T.width/2,T.y=U.y+U.height/2-T.height/2,U.width>0&&U.height>0&&(T.x<U.x&&(T.x=U.x),T.y<U.y&&(T.y=U.y),T.x>U.x+U.width&&(T.x=U.x),T.y>U.y+U.height&&(T.y=U.y),T.width>U.width&&(T.width=U.width),T.height>U.height&&(T.height=U.height)),T}async getPerformanceInfo(){try{const[s,c]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,c)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}async stopTracing(){if(!this.environmentMainService.args.trace)return;const s=await E.contentTracing.stopRecording(`${(0,n.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,b.localize)(9,null),detail:(0,b.localize)(10,null,s),buttons:[(0,R.mnemonicButtonLabel)((0,b.localize)(11,null))],defaultId:0,noLink:!0},(0,r.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),this.nativeHostMainService.showItemInFolder(void 0,s)}};i.DEFAULT_BACKGROUND_COLOR="#1E1E1E",i=ve([ie(1,w.IEnvironmentMainService),ie(2,f.ILogService),ie(3,C.IDiagnosticsService),ie(4,I.IDiagnosticsMainService),ie(5,u.IDialogMainService),ie(6,d.INativeHostMainService),ie(7,h.IProtocolMainService),ie(8,m.IProductService)],i),e.IssueMainService=i}),define(ee[264],te([0,1,22,18,26,21,6,65,20,55,35,47,89]),function(z,e,E,t,k,R,D,P,p,v,b,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let u=class extends I.AbstractUpdateService{constructor(g,f,d,S,m,h,l,n){super(g,f,S,m,h,n),this.telemetryService=d,this.nativeHostMainService=l}buildUpdateFeedUrl(g){return(0,I.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(C.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},E.CancellationToken.None).then(v.asJson).then(f=>{!f||!f.url||!f.version||!f.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(C.State.Idle(1))):this.setState(C.State.AvailableForDownload(f))}).then(void 0,f=>{this.logService.error(f),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const d=g?f.message||f:void 0;this.setState(C.State.Idle(1,d))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(C.State.Idle(1))}};u=ve([ie(0,R.ILifecycleMainService),ie(1,t.IConfigurationService),ie(2,b.ITelemetryService),ie(3,k.IEnvironmentMainService),ie(4,v.IRequestService),ie(5,D.ILogService),ie(6,P.INativeHostMainService),ie(7,p.IProductService)],u),e.LinuxUpdateService=u}),define(ee[265],te([0,1,44,39,27,8,22,53,9,7,126,23,18,26,15,21,6,65,20,55,35,47,89]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g,f,d,S,m,h,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(c,a=1e3){for(;!c();)await(0,R.timeout)(a)}let i;function o(){return typeof i>"u"&&(i=t.existsSync(p.join(p.dirname(process.execPath),"unins000.exe"))?0:1),i}let s=class extends n.AbstractUpdateService{get cachePath(){const a=p.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return C.Promises.mkdir(a,{recursive:!0}).then(()=>a)}constructor(a,y,M,T,U,Y,G,V,oe){super(a,y,T,U,Y,oe),this.telemetryService=M,this.fileService=G,this.nativeHostMainService=V}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(a){let y="win32";return process.arch!=="ia32"&&(y+=`-${process.arch}`),o()===1?y+="-archive":this.productService.target==="user"&&(y+="-user"),(0,n.createUpdateURL)(y,a,this.productService)}doCheckForUpdates(a){!this.url||(this.setState(l.State.CheckingForUpdates(a)),this.requestService.request({url:this.url},D.CancellationToken.None).then(m.asJson).then(y=>{const M=o();return!y||!y.url||!y.version||!y.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!a}),this.setState(l.State.Idle(M)),Promise.resolve(null)):M===1?(this.setState(l.State.AvailableForDownload(y)),Promise.resolve(null)):(this.setState(l.State.Downloading(y)),this.cleanup(y.version).then(()=>this.getUpdatePackagePath(y.version).then(T=>C.Promises.exists(T).then(U=>{if(U)return Promise.resolve(T);const Y=y.url,G=y.hash,V=`${T}.tmp`;return this.requestService.request({url:Y},D.CancellationToken.None).then(oe=>this.fileService.writeFile(v.URI.file(V),oe.stream)).then(G?()=>(0,b.checksum)(V,y.hash):()=>{}).then(()=>C.Promises.rename(V,T)).then(()=>T)})).then(T=>{const U=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},U&&y.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(y)):this.setState(l.State.Ready(y))})))}).then(void 0,y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!a});const M=a?y.message||y:void 0;this.setState(l.State.Idle(o(),M))}))}async doDownloadUpdate(a){a.update.url&&this.nativeHostMainService.openExternal(void 0,a.update.url),this.setState(l.State.Idle(o()))}async getUpdatePackagePath(a){const y=await this.cachePath;return p.join(y,`CodeSetup-${this.productService.quality}-${a}.exe`)}async cleanup(a=null){const y=a?Y=>!new RegExp(`${this.productService.quality}-${a}\\.exe$`).test(Y):()=>!0,M=await this.cachePath,U=(await C.Promises.readdir(M)).filter(y).map(async Y=>{try{await C.Promises.unlink(p.join(M,Y))}catch{}});await Promise.all(U)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const a=this.state.update;this.setState(l.State.Updating(a));const y=await this.cachePath;this.availableUpdate.updateFilePath=p.join(y,`CodeSetup-${this.productService.quality}-${a.version}.flag`),await C.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,E.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(l.State.Idle(o()))});const T=`${this.productService.win32MutexName}-ready`,U=await new Promise((Y,G)=>{z(["windows-mutex"],Y,G)});r(()=>U.isActive(T)).then(()=>this.setState(l.State.Ready(a)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,E.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return o()}async _applySpecificUpdate(a){if(this.state.type!=="idle")return;const y=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!y};this.setState(l.State.Downloading(M)),this.availableUpdate={packagePath:a},y?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(M)):this.setState(l.State.Ready(M))}};ve([P.memoize],s.prototype,"cachePath",null),s=ve([ie(0,g.ILifecycleMainService),ie(1,I.IConfigurationService),ie(2,h.ITelemetryService),ie(3,u.IEnvironmentMainService),ie(4,m.IRequestService),ie(5,f.ILogService),ie(6,w.IFileService),ie(7,d.INativeHostMainService),ie(8,S.IProductService)],s),e.Win32UpdateService=s}),define(ee[266],te([0,1,13,8,22,43,3,33,2,14,9,72,4,7,170,60,18,56,26,59,15,21,6,20,61,232,91,35,235,64,74,31,28,52,115,120,36,37,54,48]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g,f,d,S,m,h,l,n,r,i,o,s,c,a,y,M,T,U,Y,G,V,oe,ae,se,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var K;(function(F){F[F.NONE=0]="NONE",F[F.NAVIGATING=1]="NAVIGATING",F[F.READY=2]="READY"})(K||(K={}));let H=class Wt extends p.Disposable{get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",this.userDataProfilesService.profiles.find(A=>A.id===this.config?.profiles.profile.id)??this.userDataProfilesService.defaultProfile):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(A,O,_,ne,N,$,L,W,j,q,X,re,B,J,Z,ce,ge,De,Te){super(),this.logService=O,this.environmentMainService=_,this.policyService=ne,this.userDataProfilesService=N,this.fileService=$,this.applicationStorageMainService=L,this.storageMainService=W,this.configurationService=j,this.themeMainService=q,this.workspacesManagementMainService=X,this.backupMainService=re,this.telemetryService=B,this.dialogMainService=J,this.lifecycleMainService=Z,this.productService=ce,this.protocolMainService=ge,this.windowsMainService=De,this.stateMainService=Te,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Me,Le]=this.restoreWindowState(A.state);this.windowState=Me,this.logService.trace("window#ctor: using window state",Me);const we=this.windowState.mode===0||this.windowState.mode===3,pe=this.configurationService.getValue("window");let Se=!1;typeof pe?.experimental?.useSandbox=="boolean"?Se=pe.experimental.useSandbox:Se=typeof se.default.quality=="string"&&se.default.quality!=="stable";const ke={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!we,title:this.productService.nameLong,webPreferences:{preload:v.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.zoomLevelToZoomFactor)(pe?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...Se?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};I.isLinux?ke.icon=(0,b.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):I.isWindows&&!this.environmentMainService.isBuilt&&(ke.icon=(0,b.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),I.isMacintosh&&!this.useNativeFullScreen()&&(ke.fullscreenable=!1),I.isMacintosh&&(ke.acceptFirstMouse=!0,pe?.clickThroughInactive===!1&&(ke.acceptFirstMouse=!1));const x=I.isMacintosh&&pe?.nativeTabs===!0;x&&(ke.tabbingIdentifier=this.productService.nameShort);const ue=(0,M.getTitleBarStyle)(this.configurationService)==="custom";if(ue&&(ke.titleBarStyle="hidden",I.isMacintosh||(ke.frame=!1),(0,M.useWindowControlsOverlay)(this.configurationService))){const de=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),ye=V.Color.fromHex(de).isDarker()?"#FFFFFF":"#000000";ke.titleBarOverlay={height:29,color:de,symbolColor:ye},this.hasWindowControlOverlay=!0}if((0,C.mark)("code/willCreateCodeBrowserWindow"),this._win=new E.BrowserWindow(ke),(0,C.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,I.isMacintosh&&ue&&this._win.setSheetOffset(22),ue&&(I.isWindows&&(0,M.useWindowControlsOverlay)(this.configurationService)||I.isMacintosh)){const de=this.stateMainService.getItem(Wt.windowControlHeightStateStorageKey);de&&this.updateWindowControls({height:de})}I.isWindows&&ue&&this._win.hookWindowMessage(278,()=>{const[ye,Ce]=this._win.getPosition(),Fe=E.screen.getCursorScreenPoint(),Oe=Fe.x-ye,$e=Fe.y-Ce;return(()=>!(Oe>30&&$e>=0&&$e<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Oe,y:$e})),0}),(I.isMacintosh||I.isWindows)&&Le&&(!x||E.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(de=>typeof de=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),we&&((0,C.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,C.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setRepresentedFilename(A){I.isMacintosh?this._win.setRepresentedFilename(A):this.representedFilename=A}getRepresentedFilename(){return I.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(A){I.isMacintosh&&this._win.setDocumentEdited(A),this.documentEdited=A}isDocumentEdited(){return I.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(A){I.isMacintosh&&A?.force&&E.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.whenReadyCallbacks.push(A)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(A=>{function O(){_.dispose(),ne.dispose(),A()}const _=this.onDidClose(()=>O()),ne=this.onWillLoad(()=>O())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(O,_)=>this.onWindowError(2,_)),this._win.webContents.on("did-fail-load",(O,_,ne)=>this.onWindowError(3,{reason:ne,exitCode:_})),this._win.webContents.on("will-prevent-unload",O=>{O.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",O=>{this._config&&(this._config.maximized=!0),E.app.emit("browser-window-maximize",O,this._win)}),this._win.on("unmaximize",O=>{this._config&&(this._config.maximized=!1),E.app.emit("browser-window-unmaximize",O,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(O=>this.onConfigurationUpdated(O))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(O=>this.onDidDeleteUntitledWorkspace(O)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(O,_)=>{const ne=await this.getMarketplaceHeaders();_({cancel:!1,requestHeaders:Object.assign(O.requestHeaders,ne)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,o.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(A,O){switch(A){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:A,reason:O?.reason,code:O?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const _=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,w.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,w.localize)(1,null)),(0,P.mnemonicButtonLabel)((0,w.localize)(2,null))],message:(0,w.localize)(3,null),detail:(0,w.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,w.localize)(5,null):void 0},this._win);if(_.response!==1){const ne=_.response===0;await this.destroyWindow(ne,_.checkboxChecked)}}else if(A===2){let _;O?_=(0,w.localize)(7,null,O.reason,O.exitCode??"<unknown>"):_=(0,w.localize)(6,null);const ne=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,w.localize)(8,null)),(0,P.mnemonicButtonLabel)((0,w.localize)(9,null))],message:_,detail:(0,w.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,w.localize)(11,null):void 0},this._win),N=ne.response===0;await this.destroyWindow(N,ne.checkboxChecked)}break}}async destroyWindow(A,O){const _=this._config?.workspace;if(O&&_)try{const ne=this.storageMainService.workspaceStorage(_);await ne.init(),ne.delete("memento/workbench.parts.editor"),await ne.close()}catch(ne){this.logService.error(ne)}if(this._onDidDestroy.fire(),this._win?.destroy(),A&&this._config){let ne,N;(0,U.isSingleFolderWorkspaceIdentifier)(_)?ne={folderUri:_.uri}:(0,U.isWorkspaceIdentifier)(_)?ne={workspaceUri:_.configPath}:N=!0;const[$]=await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:ne?[ne]:void 0,forceEmpty:N,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});$.focus()}}onDidDeleteUntitledWorkspace(A){this._config?.workspace?.id===A.id&&(this._config.workspace=void 0)}onConfigurationUpdated(A){const O=this.getMenuBarVisibility();O!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=O,this.setMenuBarVisibility(O));let _=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;_?.endsWith("/")&&(_=_.substr(0,_.length-1));const ne=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((_||"").indexOf("@")===-1&&(_!==this.currentHttpProxy||ne!==this.currentNoProxy)){this.currentHttpProxy=_,this.currentNoProxy=ne;const N=_||"",$=ne?`${ne},<local>`:"<local>";this.logService.trace(`Setting proxy to '${N}', bypassing '${$}'`),this._win.webContents.session.setProxy({proxyRules:N,proxyBypassRules:$,pacScript:""})}}addTabbedWindow(A){I.isMacintosh&&A.win&&this._win.addTabbedWindow(A.win)}load(A,O=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!O.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),O.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(A,O),this.readyState===0?this._config=A:this.pendingLoadConfig=A,this.readyState=1,this._win.loadURL(v.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0));const _=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:A.workspace,reason:O.isReload?3:_?2:1})}updateConfiguration(A,O){const _=(this._config??this.pendingLoadConfig)?.userEnv;if(_){const ne=(0,m.isLaunchedFromCli)(_)&&!(0,m.isLaunchedFromCli)(A.userEnv),N=this.isExtensionDevelopmentHost;(ne||N)&&(A.userEnv={..._,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),O.disableExtensions!==void 0&&(A["disable-extensions"]=O.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this._win.isMaximized(),A.partsSplash=this.themeMainService.getWindowSplash(),(0,C.mark)("code/willOpenNewWindow"),A.perfMarks=(0,C.getMarks)(),this.configObjectUrl.update(A)}async reload(A){const O=Object.assign({},this._config);O.workspace=await this.validateWorkspaceBeforeReload(O),delete O.filesToOpenOrCreate,delete O.filesToDiff,delete O.filesToMerge,delete O.filesToWait,this.isExtensionDevelopmentHost&&A&&(O.verbose=A.verbose,O.debugId=A.debugId,O.extensionEnvironment=A.extensionEnvironment,O["inspect-extensions"]=A["inspect-extensions"],O["inspect-brk-extensions"]=A["inspect-brk-extensions"],O["extensions-dir"]=A["extensions-dir"]),O.isInitialStartup=!1,O.policiesData=this.policyService.serialize(),O.continueOn=this.environmentMainService.continueOn,O.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile},this.load(O,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async validateWorkspaceBeforeReload(A){if((0,U.isWorkspaceIdentifier)(A.workspace)){const O=A.workspace.configPath;if(O.scheme===v.Schemas.file&&!await this.fileService.exists(O))return}else if((0,U.isSingleFolderWorkspaceIdentifier)(A.workspace)){const O=A.workspace.uri;if(O.scheme===v.Schemas.file&&!await this.fileService.exists(O))return}return A.workspace}serializeWindowState(){if(!this._win)return(0,G.defaultWindowState)();if(this.isFullScreen){let _;try{_=E.screen.getDisplayMatching(this.getBounds())}catch{}const ne=(0,G.defaultWindowState)();return{mode:3,display:_?_.id:void 0,width:this.windowState.width||ne.width,height:this.windowState.height||ne.height,x:this.windowState.x||0,y:this.windowState.y||0}}const A=Object.create(null);let O;if(!I.isMacintosh&&this._win.isMaximized()?O=0:O=1,O===0?A.mode=0:A.mode=1,O===1||O===0){let _;O===1?_=this.getBounds():_=this._win.getNormalBounds(),A.x=_.x,A.y=_.y,A.width=_.width,A.height=_.height}return A}updateWindowControls(A){if(A.height&&this.stateMainService.setItem(Wt.windowControlHeightStateStorageKey,A.height),I.isWindows&&this.hasWindowControlOverlay)this._win.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0});else if(I.isMacintosh&&A.height!==void 0){const O=(A.height-15)/2;this._win.setTrafficLightPosition({x:O,y:O})}}restoreWindowState(A){(0,C.mark)("code/willRestoreCodeWindowState");let O=!1;if(A)try{const _=E.screen.getAllDisplays();O=_.length>1,A=this.validateWindowState(A,_)}catch(_){this.logService.warn(`Unexpected error validating window state: ${_}
${_.stack}`)}return(0,C.mark)("code/didRestoreCodeWindowState"),[A||(0,G.defaultWindowState)(),O]}validateWindowState(A,O){if(this.logService.trace(`window#validateWindowState: validating window state on ${O.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(O.length===1){const N=this.getWorkingArea(O[0]);if(N){let $=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!N||(A.x<N.x&&(A.x=N.x),A.y<N.y&&(A.y=N.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",N),$(),A.width>N.width&&(A.width=N.width),A.height>N.height&&(A.height=N.height),A.x>N.x+N.width-128&&(A.x=N.x+N.width-A.width),A.y>N.y+N.height-128&&(A.y=N.y+N.height-A.height),$()}return A}if(A.display&&A.mode===3){const N=O.find($=>$.id===A.display);if(N&&typeof N.bounds?.x=="number"&&typeof N.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const $=(0,G.defaultWindowState)(3);return $.x=N.bounds.x,$.y=N.bounds.y,$}}let _,ne;try{_=E.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),ne=this.getWorkingArea(_)}catch{}if(_&&ne&&A.x+A.width>ne.x&&A.y+A.height>ne.y&&A.x<ne.x+ne.width&&A.y<ne.y+ne.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",ne),A}getWorkingArea(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,O]=this._win.getPosition(),[_,ne]=this._win.getSize();return{x:A,y:O,width:_,height:ne}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(A){this.useNativeFullScreen()?this.setNativeFullScreen(A):this.setSimpleFullScreen(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return I.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(A){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(A)}doSetNativeFullScreen(A){I.isMacintosh&&(this.transientIsNativeFullScreen=A,this.joinNativeFullScreenTransition=new t.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,t.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(A)}setSimpleFullScreen(A){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(A),this._win.webContents.focus()}useNativeFullScreen(){const A=this.configurationService.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let A=(0,M.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}setMenuBarVisibility(A,O=!0){I.isMacintosh||(A==="toggle"&&O&&this.send("vscode:showInfoMessage",(0,w.localize)(12,null)),A==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(A)}):this.doSetMenuBarVisibility(A))}doSetMenuBarVisibility(A){const O=this.isFullScreen;switch(A){case"classic":this._win.setMenuBarVisibility(!O),this._win.autoHideMenuBar=O;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(I.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(A,O,..._){this.isReady?this.send(A,..._):this.ready().then(()=>{O.isCancellationRequested||this.send(A,..._)})}send(A,...O){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this._win.webContents.send(A,...O)}catch(_){this.logService.warn(`Error sending IPC message to channel '${A}' of window ${this._id}: ${(0,R.toErrorMessage)(_)}`)}}}updateTouchBar(A){!I.isMacintosh||this.touchBarGroups.forEach((O,_)=>{const ne=A[_];O.segments=this.createTouchBarGroupSegments(ne)})}createTouchBar(){if(!!I.isMacintosh){for(let A=0;A<10;A++){const O=this.createTouchBarGroup();this.touchBarGroups.push(O)}this._win.setTouchBar(new E.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(A=[]){const O=this.createTouchBarGroupSegments(A),_=new E.TouchBar.TouchBarSegmentedControl({segments:O,mode:"buttons",segmentStyle:"automatic",change:ne=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:_.segments[ne].id,from:"touchbar"})}});return _}createTouchBarGroupSegments(A=[]){return A.map(_=>{let ne;_.icon&&!a.ThemeIcon.isThemeIcon(_.icon)&&_.icon?.dark?.scheme===v.Schemas.file&&(ne=E.nativeImage.createFromPath(u.URI.revive(_.icon.dark).fsPath),ne.isEmpty()&&(ne=void 0));let N;return typeof _.title=="string"?N=_.title:N=_.title.value,{id:_.id,label:ne?void 0:N,icon:ne}})}dispose(){super.dispose(),this._win=null}};H.windowControlHeightStateStorageKey="windowControlHeight",H=ve([ie(1,n.ILogService),ie(2,S.IEnvironmentMainService),ie(3,oe.IPolicyService),ie(4,fe.IUserDataProfilesMainService),ie(5,h.IFileService),ie(6,s.IApplicationStorageMainService),ie(7,s.IStorageMainService),ie(8,f.IConfigurationService),ie(9,y.IThemeMainService),ie(10,Y.IWorkspacesManagementMainService),ie(11,g.IBackupMainService),ie(12,c.ITelemetryService),ie(13,d.IDialogMainService),ie(14,l.ILifecycleMainService),ie(15,r.IProductService),ie(16,i.IProtocolMainService),ie(17,T.IWindowsMainService),ie(18,ae.IStateMainService)],H),e.CodeWindow=H}),define(ee[75],te([0,1,13,24,8,3,33,2,14,4,19,7,23,173,5,21,6,91,92,28,52,38]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g,f,d,S,m,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,w.createDecorator)("workspacesHistoryMainService");let n=class rt extends P.Disposable{constructor(i,o,s,c){super(),this.logService=i,this.workspacesManagementMainService=o,this.lifecycleMainService=s,this.applicationStorageMainService=c,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let o=[],s=[];for(const a of i)if((0,S.isRecentWorkspace)(a))!this.workspacesManagementMainService.isUntitledWorkspace(a.workspace)&&!this.containsWorkspace(o,a.workspace)&&o.push(a);else if((0,S.isRecentFolder)(a))this.containsFolder(o,a.folderUri)||o.push(a);else{const y=this.containsFile(s,a.fileUri),M=a.fileUri.scheme===p.Schemas.file&&rt.COMMON_FILES_FILTER.indexOf((0,b.basename)(a.fileUri))>=0;!y&&!M&&(s.push(a),v.isWindows&&a.fileUri.scheme===p.Schemas.file&&E.app.addRecentDocument(a.fileUri.fsPath))}const c=await this.mergeEntriesFromStorage({workspaces:o,files:s});o=c.workspaces,s=c.files,o.length>rt.MAX_TOTAL_RECENT_ENTRIES&&(o.length=rt.MAX_TOTAL_RECENT_ENTRIES),s.length>rt.MAX_TOTAL_RECENT_ENTRIES&&(s.length=rt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:o,files:s}),this._onDidChangeRecentlyOpened.fire(),v.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(i){const o=y=>{const M=this.location(y);for(const T of i)if(b.extUriBiasedIgnorePathCase.isEqual(T,M))return!1;return!0},s=await this.getRecentlyOpened(),c=s.workspaces.filter(o),a=s.files.filter(o);(c.length!==s.workspaces.length||a.length!==s.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:c}),this._onDidChangeRecentlyOpened.fire(),v.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(i){const o=new l.ResourceMap(a=>b.extUriBiasedIgnorePathCase.getComparisonKey(a));if(i?.workspaces)for(const a of i.workspaces)o.set(this.location(a),a);const s=new l.ResourceMap(a=>b.extUriBiasedIgnorePathCase.getComparisonKey(a));if(i?.files)for(const a of i.files)s.set(this.location(a),a);const c=await this.getRecentlyOpenedFromStorage();for(const a of c.workspaces){const y=o.get(this.location(a));y?y.label=y.label??a.label:o.set(this.location(a),a)}for(const a of c.files){const y=s.get(this.location(a));y?y.label=y.label??a.label:s.set(this.location(a),a)}return{workspaces:[...o.values()],files:[...s.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let i;const o=this.applicationStorageMainService.get(rt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof o=="string")try{i=JSON.parse(o)}catch(s){this.logService.error("Unexpected error parsing opened paths list",s)}return(0,S.restoreRecentlyOpened)(i,this.logService)}async saveRecentlyOpened(i){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(rt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,S.toStoreData)(i)),-1,1)}location(i){return(0,S.isRecentFolder)(i)?i.folderUri:(0,S.isRecentFile)(i)?i.fileUri:i.workspace.configPath}containsWorkspace(i,o){return!!i.find(s=>(0,S.isRecentWorkspace)(s)&&s.workspace.id===o.id)}containsFolder(i,o){return!!i.find(s=>(0,S.isRecentFolder)(s)&&b.extUriBiasedIgnorePathCase.isEqual(s.folderUri,o))}containsFile(i,o){return!!i.find(s=>b.extUriBiasedIgnorePathCase.isEqual(s.fileUri,o))}async handleWindowsJumpList(){!v.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!v.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,u.localize)(0,null),description:(0,u.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const o=[];for(const a of E.app.getJumpListSettings().removedItems){const y=a.args;if(y){const M=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(y);M&&o.push(C.URI.parse(M[2]))}}await this.removeRecentlyOpened(o);let s=!1;const c=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const y=(0,S.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:M,description:T}=this.getWindowsJumpListLabel(y,a.label);let U;return C.URI.isUri(y)?U=`--folder-uri "${y.toString()}"`:(s=!0,U=`--file-uri "${y.configPath.toString()}"`),{type:"task",title:M.substr(0,255),description:T.substr(0,255),program:process.execPath,args:U,iconPath:"explorer.exe",iconIndex:0}}));c.length>0&&i.push({type:"custom",name:s?(0,u.localize)(2,null):(0,u.localize)(3,null),items:c})}i.push({type:"recent"});try{const o=E.app.setJumpList(i);o&&o!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${o}`)}catch(o){this.logService.warn("updateWindowsJumpList#setJumpList",o)}}getWindowsJumpListLabel(i,o){if(o)return{title:(0,D.splitName)(o).name,description:o};if(C.URI.isUri(i))return{title:(0,b.basename)(i),description:this.renderJumpListPathDescription(i)};if(this.workspacesManagementMainService.isUntitledWorkspace(i))return{title:(0,u.localize)(4,null),description:""};let s=(0,b.basename)(i.configPath);return s.endsWith(m.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-m.WORKSPACE_EXTENSION.length-1)),{title:(0,u.localize)(5,null,s),description:this.renderJumpListPathDescription(i.configPath)}}renderJumpListPathDescription(i){return i.scheme==="file"?(0,D.normalizeDriveLetter)(i.fsPath):i.toString()}async updateMacOSRecentDocuments(){if(!v.isMacintosh)return;E.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),o=[];let s=0;for(let a=0;a<i.workspaces.length&&s<rt.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const y=this.location(i.workspaces[a]);if(y.scheme===p.Schemas.file){const M=(0,b.originalFSPath)(y);await I.Promises.exists(M)&&(o.push(M),s++)}}const c=[];for(let a=0;a<i.files.length&&s<rt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const y=this.location(i.files[a]);if(y.scheme===p.Schemas.file){const M=(0,b.originalFSPath)(y);if(rt.COMMON_FILES_FILTER.includes((0,b.basename)(y))||o.includes(M))continue;await I.Promises.exists(M)&&(c.push(M),s++)}}c.reverse().forEach(a=>E.app.addRecentDocument(a)),o.reverse().forEach(a=>E.app.addRecentDocument(a))}};n.MAX_TOTAL_RECENT_ENTRIES=500,n.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",n.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,n.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,n.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,n.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],n=ve([ie(0,f.ILogService),ie(1,h.IWorkspacesManagementMainService),ie(2,g.ILifecycleMainService),ie(3,d.IApplicationStorageMainService)],n),e.WorkspacesHistoryMainService=n}),define(ee[267],te([0,1,13,8,22,33,4,7,163,18,26,21,6,210,65,20,37,35,47,74,31,75]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g,f,d,S,m,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const n="menu";let r=class Ft{constructor(s,c,a,y,M,T,U,Y,G,V,oe){this.updateService=s,this.configurationService=c,this.windowsMainService=a,this.environmentMainService=y,this.telemetryService=M,this.workspacesHistoryMainService=T,this.stateMainService=U,this.lifecycleMainService=Y,this.logService=G,this.nativeHostMainService=V,this.productService=oe,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,m.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(Ft.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,U,Y)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:U?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,U,Y)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:U?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,U,Y)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(Y),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(T,U,Y)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(Y),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,U,Y)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(Y),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const c=this.productService.requestFeatureUrl;c&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(c,"openUserVoiceUrl"));const a=this.productService.reportIssueUrl;a&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(a,"openReportIssues"));const y=this.productService.licenseUrl;y&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const T=y.indexOf("?")>0?"&":"?";this.openUrl(`${y}${T}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(y,"openLicenseUrl")});const M=this.productService.privacyStatementUrl;M&&y&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(M,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,c){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(Ft.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!D.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!D.isMacintosh||(this.noActiveWindow=!E.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=E.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){E.Menu.setApplicationMenu(D.isMacintosh?new E.Menu:null);return}const c=new E.Menu;let a;if(D.isMacintosh){const M=new E.Menu;a=new E.MenuItem({label:this.productService.nameShort,submenu:M}),this.setMacApplicationMenu(M),c.append(a)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const M=new E.Menu;M.append(new E.MenuItem({label:this.mnemonicLabel(p.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),E.app.dock.setMenu(M)}if(this.shouldDrawMenu("File")){const M=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(p.localize(1,null)),submenu:M});this.setMenuById(M,"File"),c.append(T)}if(this.shouldDrawMenu("Edit")){const M=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(p.localize(2,null)),submenu:M});this.setMenuById(M,"Edit"),c.append(T)}if(this.shouldDrawMenu("Selection")){const M=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(p.localize(3,null)),submenu:M});this.setMenuById(M,"Selection"),c.append(T)}if(this.shouldDrawMenu("View")){const M=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(p.localize(4,null)),submenu:M});this.setMenuById(M,"View"),c.append(T)}if(this.shouldDrawMenu("Go")){const M=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(p.localize(5,null)),submenu:M});this.setMenuById(M,"Go"),c.append(T)}if(this.shouldDrawMenu("Run")){const M=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(p.localize(6,null)),submenu:M});this.setMenuById(M,"Run"),c.append(T)}if(this.shouldDrawMenu("Terminal")){const M=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(p.localize(7,null)),submenu:M});this.setMenuById(M,"Terminal"),c.append(T)}let y;if(this.shouldDrawMenu("Window")){const M=new E.Menu;y=new E.MenuItem({label:this.mnemonicLabel(p.localize(8,null)),submenu:M,role:"window"}),this.setMacWindowMenu(M)}if(y&&c.append(y),this.shouldDrawMenu("Help")){const M=new E.Menu,T=new E.MenuItem({label:this.mnemonicLabel(p.localize(9,null)),submenu:M,role:"help"});this.setMenuById(M,"Help"),c.append(T)}c.items&&c.items.length>0?E.Menu.setApplicationMenu(c):E.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const c=this.createMenuItem(p.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),a=this.getUpdateMenuItems();let y;if(this.shouldDrawMenu("Preferences")){const ae=new E.Menu;this.setMenuById(ae,"Preferences"),y=new E.MenuItem({label:this.mnemonicLabel(p.localize(11,null)),submenu:ae})}const M=new E.Menu,T=new E.MenuItem({label:p.localize(12,null),role:"services",submenu:M}),U=new E.MenuItem({label:p.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),Y=new E.MenuItem({label:p.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),G=new E.MenuItem({label:p.localize(15,null),role:"unhide"}),V=new E.MenuItem(this.likeAction("workbench.action.quit",{label:p.localize(16,null,this.productService.nameLong),click:async(ae,se,fe)=>{const K=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!E.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&await this.confirmBeforeQuit(fe)&&this.nativeHostMainService.quit(void 0)}})),oe=[c];oe.push(...a),y&&oe.push(i(),y),oe.push(i(),T,i(),U,Y,G,i(),V),oe.forEach(ae=>s.append(ae))}async confirmBeforeQuit(s){if(this.windowsMainService.getWindowCount()===0)return!0;const c=this.configurationService.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.isKeyboardEvent(s)){const a={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(p.localize(17,null)),(0,R.mnemonicButtonLabel)(p.localize(18,null))],message:p.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:y}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,a);return y===0}return!0}shouldDrawMenu(s){if(!D.isMacintosh&&(0,m.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,c){c.forEach(a=>{if((0,u.isMenubarMenuItemSeparator)(a))s.append(i());else if((0,u.isMenubarMenuItemSubmenu)(a)){const y=new E.Menu,M=new E.MenuItem({label:this.mnemonicLabel(a.label),submenu:y});this.setMenu(y,a.submenu.items),s.append(M)}else(0,u.isMenubarMenuItemRecentAction)(a)?s.append(this.createOpenRecentMenuItem(a)):(0,u.isMenubarMenuItemAction)(a)&&(a.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[a.id]?s.append(new E.MenuItem(this.likeAction(a.id,{label:this.mnemonicLabel(a.label),click:this.fallbackMenuHandlers[a.id]}))):s.append(this.createMenuItem(a.label,a.id,!1,a.checked)):s.append(this.createMenuItem(a.label,a.id,a.enabled!==!1,!!a.checked)):s.append(this.createMenuItem(a.label,a.id,a.enabled!==!1,!!a.checked)))})}setMenuById(s,c){this.menubarMenus&&this.menubarMenus[c]&&this.setMenu(s,this.menubarMenus[c].items)}insertCheckForUpdatesItems(s){const c=this.getUpdateMenuItems();c.length&&(c.forEach(a=>s.append(a)),s.append(i()))}createOpenRecentMenuItem(s){const c=P.URI.revive(s.uri),a=s.id,y=a==="openRecentFile"?{fileUri:c}:a==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new E.MenuItem(this.likeAction(a,{label:s.label,click:async(M,T,U)=>{const Y=this.isOptionClick(U);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[y],forceNewWindow:Y,gotoLineMode:!1,remoteAuthority:s.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([c])}},!1))}isOptionClick(s){return!!(s&&(!D.isMacintosh&&(s.ctrlKey||s.shiftKey)||D.isMacintosh&&(s.metaKey||s.altKey)))}isKeyboardEvent(s){return!!(s.triggeredByAccelerator||s.altKey||s.ctrlKey||s.metaKey||s.shiftKey)}createRoleMenuItem(s,c,a){const y={label:this.mnemonicLabel(s),role:a,enabled:!0};return new E.MenuItem(this.withKeybinding(c,y))}setMacWindowMenu(s){const c=new E.MenuItem({label:p.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),a=new E.MenuItem({label:p.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),y=new E.MenuItem({label:p.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),M=this.createMenuItem(p.localize(23,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(i()),T.push(this.createMenuItem(p.localize(24,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(p.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(p.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(p.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(p.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,a,i(),M,...T,i(),y].forEach(U=>s.append(U))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.mnemonicLabel(p.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:p.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.mnemonicLabel(p.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:p.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.mnemonicLabel(p.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new E.MenuItem({label:p.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.mnemonicLabel(p.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,c,a,y){const M=this.mnemonicLabel(s),T=typeof c=="function"?c:(oe,ae,se)=>{const fe=oe?oe.userSettingsLabel:null;let K=c;Array.isArray(c)&&(K=this.isOptionClick(se)?c[1]:c[0]),fe&&se.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:fe}):this.runActionInRenderer({type:"commandId",commandId:K})},U=typeof a=="boolean"?a:this.windowsMainService.getWindowCount()>0,Y=typeof y=="boolean"?y:!1,G={label:M,click:T,enabled:U};Y&&(G.type="checkbox",G.checked=Y);let V;return typeof c=="string"?V=c:Array.isArray(c)&&(V=c[0]),D.isMacintosh&&(V==="editor.action.clipboardCutAction"?G.role="cut":V==="editor.action.clipboardCopyAction"?G.role="copy":V==="editor.action.clipboardPasteAction"&&(G.role="paste"),V==="undo"?G.click=this.makeContextAwareClickHandler(T,{inDevTools:oe=>oe.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):V==="redo"?G.click=this.makeContextAwareClickHandler(T,{inDevTools:oe=>oe.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):V==="editor.action.selectAll"&&(G.click=this.makeContextAwareClickHandler(T,{inDevTools:oe=>oe.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.withKeybinding(V,G))}makeContextAwareClickHandler(s,c){return(a,y,M)=>{const T=E.BrowserWindow.getFocusedWindow();if(!T)return c.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return c.inDevTools(T.webContents.devToolsWebContents);s(a,y||T,M)}}runActionInRenderer(s){let c=E.BrowserWindow.getFocusedWindow();if(!c){const y=this.windowsMainService.getLastActiveWindow();y?.isMinimized()&&(c=y.win)}const a=c?this.windowsMainService.getWindowById(c.id):void 0;if(a){if(this.logService.trace("menubar#runActionInRenderer",s),D.isMacintosh&&!this.environmentMainService.isBuilt&&!a.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const y={id:s.commandId,from:"menu"};a.sendWhenReady("vscode:runAction",k.CancellationToken.None,y)}else{const y={userSettingsLabel:s.userSettingsLabel};a.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,y)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,c){const a=typeof s=="string"?this.keybindings[s]:void 0;if(a?.label){if(a.isNative!==!1)c.accelerator=a.label,c.userSettingsLabel=a.userSettingsLabel;else if(typeof c.label=="string"){const y=c.label.indexOf("[");y>=0?c.label=`${c.label.substr(0,y)} [${a.label}]`:c.label=`${c.label} [${a.label}]`}}else c.accelerator=void 0;return c}likeAction(s,c,a=!c.accelerator){a&&(c=this.withKeybinding(s,c));const y=c.click;return c.click=(M,T,U)=>{this.reportMenuActionTelemetry(s),y?.(M,T,U)},c}openUrl(s,c){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(c)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:n})}mnemonicLabel(s){return(0,R.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=ve([ie(0,S.IUpdateService),ie(1,v.IConfigurationService),ie(2,h.IWindowsMainService),ie(3,b.IEnvironmentMainService),ie(4,d.ITelemetryService),ie(5,l.IWorkspacesHistoryMainService),ie(6,f.IStateMainService),ie(7,C.ILifecycleMainService),ie(8,I.ILogService),ie(9,w.INativeHostMainService),ie(10,g.IProductService)],r),e.Menubar=r;function i(){return new E.MenuItem({type:"separator"})}}),define(ee[268],te([0,1,5,21,6,267]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let D=class{constructor(p,v,b){this.instantiationService=p,this.lifecycleMainService=v,this.logService=b,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(p,v){this.logService.trace("menubarService#updateMenubar",p),(await this.menubar).updateMenu(v,p)}};D=ve([ie(0,E.IInstantiationService),ie(1,t.ILifecycleMainService),ie(2,k.ILogService)],D),e.MenubarMainService=D}),define(ee[269],te([0,1,13,23,27,24,22,3,30,49,33,2,14,9,72,4,32,19,12,7,171,60,18,56,26,15,5,21,6,54,20,61,63,37,74,266,117,261,28,93,75,52,64,36,48]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g,f,d,S,m,h,l,n,r,i,o,s,c,a,y,M,T,U,Y,G,V,oe,ae,se,fe,K,H,F,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function _($){return(0,se.isWorkspaceIdentifier)($?.workspace)}function ne($){return(0,se.isSingleFolderWorkspaceIdentifier)($?.workspace)}let N=class ft extends C.Disposable{constructor(L,W,j,q,X,re,B,J,Z,ce,ge,De,Te,Me,Le,we,pe,Se){super(),this.machineId=L,this.initialUserEnv=W,this.logService=j,this.stateMainService=q,this.policyService=X,this.environmentMainService=re,this.userDataProfilesMainService=B,this.lifecycleMainService=J,this.backupMainService=Z,this.configurationService=ce,this.workspacesHistoryMainService=ge,this.workspacesManagementMainService=De,this.instantiationService=Te,this.dialogMainService=Me,this.fileService=Le,this.productService=we,this.protocolMainService=pe,this.themeMainService=Se,this._onDidOpenWindow=this._register(new P.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new P.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new P.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new P.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new P.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ae.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const W=new C.DisposableStore;if(W.add(P.Event.any(L.onDidClose,L.onDidDestroy)(()=>W.dispose())),L.config.extensionDevelopmentPath)for(const j of L.config.extensionDevelopmentPath)W.add(this.protocolMainService.addValidFileRoot(j));L.config.extensionTestsPath&&W.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,W){const j=this.environmentMainService.args,q=W?.remoteAuthority||void 0,X=!0,re=W?.forceReuseWindow,B=!re;return this.open({...L,cli:j,forceEmpty:X,forceNewWindow:B,forceReuseWindow:re,remoteAuthority:q})}openExistingWindow(L,W){L.focus(),this.handleWaitMarkerFile(W,[L])}async open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const W=[],j=[],q=[],X=[],re=[];let B,J=0;const Z=await this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",Z);for(const Me of Z)ne(Me)?L.addMode?W.push(Me):j.push(Me):_(Me)?q.push(Me):Me.fileUri?(B||(B={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Me.remoteAuthority}),B.filesToOpenOrCreate.push(Me)):Me.backupPath?re.push({backupFolder:(0,u.basename)(Me.backupPath),remoteAuthority:Me.remoteAuthority}):J++;L.diffMode&&B&&B.filesToOpenOrCreate.length>=2&&(B.filesToDiff=B.filesToOpenOrCreate.slice(0,2),B.filesToOpenOrCreate=[]),L.mergeMode&&B&&B.filesToOpenOrCreate.length===4&&(B.filesToMerge=B.filesToOpenOrCreate.slice(0,4),B.filesToOpenOrCreate=[],B.filesToDiff=[]),B&&L.waitMarkerFileURI&&(B.filesToWait={paths:(0,R.coalesce)([...B.filesToDiff,B.filesToMerge[3],...B.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(X.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),q.push(...X),re.push(...this.backupMainService.getEmptyWindowBackups())):re.length=0;const{windows:ce,filesOpenedInWindow:ge}=await this.doOpen(L,q,j,re,J,B,W);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${q.length}, foldersToOpen: ${j.length}, emptyToRestore: ${re.length}, emptyToOpen: ${J})`),ce.length>1)if(ge)ge.focus();else{const Me=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Le=!0,we=!0;if(Me){const pe=ce.filter(Se=>this.windowsStateHandler.state.lastActiveWindow&&Se.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Le=!1,we=!1)}if(Le)for(let pe=ce.length-1;pe>=0;pe--){const Se=ce[pe];if(!(Se.openedWorkspace&&X.some(ke=>Se.openedWorkspace&&ke.workspace.id===Se.openedWorkspace.id)||Se.backupPath&&re.some(ke=>Se.backupPath&&ke.backupFolder===(0,u.basename)(Se.backupPath)))){Se.focus(),we=!1;break}}we&&ce[ce.length-1].focus()}const De=B&&B.filesToDiff.length>0,Te=B&&B.filesToMerge.length>0;if(!ce.some(Me=>Me.isExtensionDevelopmentHost)&&!De&&!Te&&!L.noRecentEntry){const Me=[];for(const Le of Z)_(Le)&&!Le.transient?Me.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):ne(Le)?Me.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&Me.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Me)}return this.handleWaitMarkerFile(L,ce),ce}handleWaitMarkerFile(L,W){const j=L.waitMarkerFileURI;L.context===0&&j&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.fileService.del(j)}catch{}})()}async doOpen(L,W,j,q,X,re,B){const J=[];let Z;function ce(pe,Se){J.push(pe),Se&&(Z=pe,re=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:De}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&B.length>0){const pe=B[0].remoteAuthority,Se=this.getLastActiveWindowForAuthority(pe);Se&&ce(this.doAddFoldersToExistingWindow(Se,B.map(ke=>ke.workspace.uri)))}const Te=j.length+W.length+q.length;if(re&&Te===0){const pe=re.filesToOpenOrCreate[0]||re.filesToDiff[0]||re.filesToMerge[3],Se=this.getWindows().filter(x=>re&&(0,d.isEqualAuthority)(x.remoteAuthority,re.remoteAuthority));let ke;pe?.fileUri&&!De&&((L.context===4||L.context===0||L.context===1)&&(ke=await(0,oe.findWindowOnFile)(Se,pe.fileUri,async x=>x.configPath.scheme===I.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(x.configPath):void 0)),ke||(ke=this.doGetLastActiveWindow(Se))),ke?(0,se.isWorkspaceIdentifier)(ke.openedWorkspace)?W.push({workspace:ke.openedWorkspace,remoteAuthority:ke.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(ke.openedWorkspace)?j.push({workspace:ke.openedWorkspace,remoteAuthority:ke.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(L,ke,re),!0):ce(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:re,forceNewWindow:!0,remoteAuthority:re.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,profile:L.profile}),!0)}const Me=(0,R.distinct)(W,pe=>pe.workspace.id);if(Me.length>0){const pe=(0,R.coalesce)(Me.map(Se=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),Se.workspace.configPath)));if(pe.length>0){const Se=pe[0],ke=(0,d.isEqualAuthority)(re?.remoteAuthority,Se.remoteAuthority)?re:void 0;ce(this.doOpenFilesInExistingWindow(L,Se,ke),!!ke),ge=!0}for(const Se of Me){if(pe.some(ue=>ue.openedWorkspace&&ue.openedWorkspace.id===Se.workspace.id))continue;const ke=Se.remoteAuthority,x=(0,d.isEqualAuthority)(re?.remoteAuthority,ke)?re:void 0;ce(this.doOpenFolderOrWorkspace(L,Se,ge,x),!!x),ge=!0}}const Le=(0,R.distinct)(j,pe=>d.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(Le.length>0){const pe=(0,R.coalesce)(Le.map(Se=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),Se.workspace.uri)));if(pe.length>0){const Se=pe[0],ke=(0,d.isEqualAuthority)(re?.remoteAuthority,Se.remoteAuthority)?re:void 0;ce(this.doOpenFilesInExistingWindow(L,Se,ke),!!ke),ge=!0}for(const Se of Le){if(pe.some(ue=>(0,se.isSingleFolderWorkspaceIdentifier)(ue.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(ue.openedWorkspace.uri,Se.workspace.uri)))continue;const ke=Se.remoteAuthority,x=(0,d.isEqualAuthority)(re?.remoteAuthority,ke)?re:void 0;ce(this.doOpenFolderOrWorkspace(L,Se,ge,x),!!x),ge=!0}}const we=(0,R.distinct)(q,pe=>pe.backupFolder);if(we.length>0)for(const pe of we){const Se=pe.remoteAuthority,ke=(0,d.isEqualAuthority)(re?.remoteAuthority,Se)?re:void 0;ce(this.doOpenEmpty(L,!0,Se,ke,pe),!!ke),ge=!0}if(J.length===0||re){re&&!X&&X++;const pe=re?re.remoteAuthority:L.remoteAuthority;for(let Se=0;Se<X;Se++)ce(this.doOpenEmpty(L,ge,pe,re),!!re),ge=!0}return{windows:(0,R.distinct)(J),filesOpenedInWindow:Z}}doOpenFilesInExistingWindow(L,W,j){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:j}),W.focus();const q={filesToOpenOrCreate:j?.filesToOpenOrCreate,filesToDiff:j?.filesToDiff,filesToMerge:j?.filesToMerge,filesToWait:j?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",D.CancellationToken.None,q),W}doAddFoldersToExistingWindow(L,W){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),L.focus();const j={foldersToAdd:W};return L.sendWhenReady("vscode:addFolders",D.CancellationToken.None,j),L}doOpenEmpty(L,W,j,q,X){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!X,remoteAuthority:j,filesToOpen:q,forceNewWindow:W});let re;return!W&&typeof L.contextWindowId=="number"&&(re=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:j,forceNewWindow:W,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:q,windowToUse:re,emptyWindowBackupInfo:X,profile:L.profile})}doOpenFolderOrWorkspace(L,W,j,q,X){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:q}),!j&&!X&&typeof L.contextWindowId=="number"&&(X=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:W.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:j,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:q,windowToUse:X,profile:L.profile})}async getPathsToOpen(L){let W,j=!1,q=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(W=await this.doExtractPathsFromAPI(L),j=!0):L.forceEmpty?W=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(W=await this.doExtractPathsFromCLI(L.cli),W.length===0&&W.push(Object.create(null)),j=!0):(W=await this.doGetPathsFromLastSession(),W.length===0&&W.push(Object.create(null)),q=!0),!L.addMode&&j){const X=W.filter(re=>ne(re));if(X.length>1){const re=X[0].remoteAuthority;if(X.every(B=>(0,d.isEqualAuthority)(B.remoteAuthority,re))){const B=await this.workspacesManagementMainService.createUntitledWorkspace(X.map(J=>({uri:J.workspace.uri})));W.push({workspace:B,remoteAuthority:re}),W=W.filter(J=>!ne(J))}}}if(L.initialStartup&&!q&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const X=await this.doGetPathsFromLastSession();W.unshift(...X.filter(re=>_(re)||ne(re)||re.backupPath))}return W}async doExtractPathsFromAPI(L){const W={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},j=await Promise.all((0,R.coalesce)(L.urisToOpen||[]).map(async q=>{const X=await this.resolveOpenable(q,W);if(X)return X.label=q.label,X;const re=this.resourceFromOpenable(q),B={title:this.productService.nameLong,type:"info",buttons:[(0,b.mnemonicButtonLabel)((0,h.localize)(0,null))],defaultId:0,message:re.scheme===I.Schemas.file?(0,h.localize)(1,null):(0,h.localize)(2,null),detail:re.scheme===I.Schemas.file?(0,h.localize)(3,null,(0,b.getPathLabel)(re,{os:g.OS,tildify:this.environmentMainService})):(0,h.localize)(4,null,re.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(B,(0,S.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(j)}async doExtractPathsFromCLI(L){const W=[],j={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},q=L["folder-uri"];if(q){const B=await Promise.all(q.map(J=>{const Z=this.cliArgToUri(J);if(!!Z)return this.resolveOpenable({folderUri:Z},j)}));W.push(...(0,R.coalesce)(B))}const X=L["file-uri"];if(X){const B=await Promise.all(X.map(J=>{const Z=this.cliArgToUri(J);if(!!Z)return this.resolveOpenable((0,se.hasWorkspaceFileExtension)(J)?{workspaceUri:Z}:{fileUri:Z},j)}));W.push(...(0,R.coalesce)(B))}const re=await Promise.all(L._.map(B=>j.remoteAuthority?this.doResolveRemotePath(B,j):this.doResolveFilePath(B,j)));return W.push(...(0,R.coalesce)(re)),W}cliArgToUri(L){try{const W=m.URI.parse(L);if(!W.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return W}catch(W){this.logService.error(`Invalid URI input string: ${L}, ${W.message}`)}}async doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const W=[];L!=="one"&&W.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&W.push(this.windowsStateHandler.state.lastActiveWindow);const j=await Promise.all(W.map(async q=>{if(q.workspace){const X=await this.resolveOpenable({workspaceUri:q.workspace.configPath},{remoteAuthority:q.remoteAuthority,rejectTransientWorkspaces:!0});if(_(X))return X}else if(q.folderUri){const X=await this.resolveOpenable({folderUri:q.folderUri},{remoteAuthority:q.remoteAuthority});if(ne(X))return X}else if(L!=="folders"&&q.backupPath)return{backupPath:q.backupPath,remoteAuthority:q.remoteAuthority}}));return(0,R.coalesce)(j)}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async resolveOpenable(L,W=Object.create(null)){const j=this.resourceFromOpenable(L);return j.scheme===I.Schemas.file?((0,G.isFileToOpen)(L)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(j.fsPath,W)):this.doResolveRemoteOpenable(L,W)}doResolveRemoteOpenable(L,W){let j=this.resourceFromOpenable(L);const q=(0,U.getRemoteAuthority)(j)||W.remoteAuthority;if(j=(0,d.removeTrailingPathSeparator)((0,d.normalizePath)(j)),(0,G.isFileToOpen)(L)){if(W.gotoLineMode){const{path:X,line:re,column:B}=(0,p.parseLineAndColumnAware)(j.path);return{fileUri:j.with({path:X}),options:{selection:re?{startLineNumber:re,startColumn:B||1}:void 0},remoteAuthority:q}}return{fileUri:j,remoteAuthority:q}}else if((0,G.isWorkspaceToOpen)(L))return{workspace:(0,fe.getWorkspaceIdentifier)(j),remoteAuthority:q};return{workspace:(0,fe.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:q}}resourceFromOpenable(L){return(0,G.isWorkspaceToOpen)(L)?L.workspaceUri:(0,G.isFolderToOpen)(L)?L.folderUri:L.fileUri}async doResolveFilePath(L,W){let j,q;W.gotoLineMode&&({path:L,line:j,column:q}=(0,p.parseLineAndColumnAware)(L)),L=(0,p.sanitizeFilePath)((0,u.normalize)(L),(0,f.cwd)());try{const X=await t.Promises.stat(L);if(X.isFile()){if(!W.forceOpenWorkspaceAsFile){const re=await this.workspacesManagementMainService.resolveLocalWorkspace(m.URI.file(L));if(re)return re.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:re.id,configPath:re.configPath},type:o.FileType.File,exists:!0,remoteAuthority:re.remoteAuthority,transient:re.transient}}return{fileUri:m.URI.file(L),type:o.FileType.File,exists:!0,options:{selection:j?{startLineNumber:j,startColumn:q||1}:void 0}}}else{if(X.isDirectory())return{workspace:(0,fe.getSingleFolderWorkspaceIdentifier)(m.URI.file(L),X),type:o.FileType.Directory,exists:!0};if(!g.isWindows&&L==="/dev/null")return{fileUri:m.URI.file(L),type:o.FileType.File,exists:!0}}}catch{const re=m.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([re]),W.ignoreFileNotFound)return{fileUri:re,type:o.FileType.File,exists:!1}}}doResolveRemotePath(L,W){const j=L.charCodeAt(0),q=W.remoteAuthority;let X,re;W.gotoLineMode&&({path:L,line:X,column:re}=(0,p.parseLineAndColumnAware)(L)),j!==47&&((0,p.isWindowsDriveLetter)(j)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,p.toSlashes)(L)),L=`/${L}`);const B=m.URI.from({scheme:I.Schemas.vscodeRemote,authority:q,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return W.forceOpenWorkspaceAsFile?{fileUri:B,options:{selection:X?{startLineNumber:X,startColumn:re||1}:void 0},remoteAuthority:W.remoteAuthority}:{workspace:(0,fe.getWorkspaceIdentifier)(B),remoteAuthority:q};if(W.gotoLineMode||u.posix.basename(L).indexOf(".")!==-1)return{fileUri:B,options:{selection:X?{startLineNumber:X,startColumn:re||1}:void 0},remoteAuthority:q}}return{workspace:(0,fe.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:q}}shouldOpenNewWindow(L){const W=this.configurationService.getValue("window"),j=W?.openFoldersInNewWindow||"default",q=W?.openFilesInNewWindow||"off";let X=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(j==="on"||j==="off")&&(X=j==="on");let re=!1;return L.forceNewWindow||L.forceReuseWindow?re=!!L.forceNewWindow&&!L.forceReuseWindow:(g.isMacintosh?L.context===1&&(re=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(re=!0),!L.cli.extensionDevelopmentPath&&(q==="on"||q==="off")&&(re=q==="on")),{openFolderInNewWindow:!!X,openFilesInNewWindow:re}}async openExtensionDevelopmentHostWindow(L,W){const j=(0,oe.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(j)return this.lifecycleMainService.reload(j,W.cli),j.focus(),[j];let q=W.cli["folder-uri"]||[],X=W.cli["file-uri"]||[],re=W.cli._;if(!re.length&&!q.length&&!X.length&&!W.cli.extensionTestsPath){const Z=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ce=Z?.workspace??Z?.folderUri;ce&&(m.URI.isUri(ce)?ce.scheme===I.Schemas.file?re=[ce.fsPath]:q=[ce.toString()]:ce.configPath.scheme===I.Schemas.file?re=[(0,d.originalFSPath)(ce.configPath)]:X=[ce.configPath.toString()])}let B=W.remoteAuthority;for(const Z of L)if(Z.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ce=m.URI.parse(Z),ge=(0,U.getRemoteAuthority)(ce);ge&&(B?(0,d.isEqualAuthority)(ge,B)||this.logService.error("more than one extension development path authority"):B=ge)}re=re.filter(Z=>{const ce=m.URI.file(Z);return(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:(0,d.isEqualAuthority)((0,U.getRemoteAuthority)(ce),B)}),q=q.filter(Z=>{const ce=this.cliArgToUri(Z);return ce&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,d.isEqualAuthority)((0,U.getRemoteAuthority)(ce),B):!1}),X=X.filter(Z=>{const ce=this.cliArgToUri(Z);return ce&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,d.isEqualAuthority)((0,U.getRemoteAuthority)(ce),B):!1}),W.cli._=re,W.cli["folder-uri"]=q,W.cli["file-uri"]=X;const J={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:!re.length&&!q.length&&!X.length,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:B,profile:W.profile};return this.open(J)}openInBrowserWindow(L){const W=this.configurationService.getValue("window"),j={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,u.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesMainService.profiles,profile:this.resolveProfileForBrowserWindow(L)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:y.default,isInitialStartup:L.initialStartup,perfMarks:(0,w.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof W?.zoomLevel=="number"?W.zoomLevel:void 0,autoDetectHighContrast:W?.autoDetectHighContrast??!0,autoDetectColorScheme:W?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};let q;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(q=L.windowToUse||this.getLastActiveWindow(),q&&q.focus()),q){const X=q.config;!j.extensionDevelopmentPath&&X?.extensionDevelopmentPath&&(j.extensionDevelopmentPath=X.extensionDevelopmentPath,j.extensionDevelopmentKind=X.extensionDevelopmentKind,j["enable-proposed-api"]=X["enable-proposed-api"],j.verbose=X.verbose,j["inspect-extensions"]=X["inspect-extensions"],j["inspect-brk-extensions"]=X["inspect-brk-extensions"],j.debugId=X.debugId,j.extensionEnvironment=X.extensionEnvironment,j["extensions-dir"]=X["extensions-dir"],j["disable-extensions"]=X["disable-extensions"])}else{const X=this.windowsStateHandler.getNewWindowState(j);(0,w.mark)("code/willCreateCodeWindow");const re=q=this.instantiationService.createInstance(V.CodeWindow,{state:X,extensionDevelopmentPath:j.extensionDevelopmentPath,isExtensionTestHost:!!j.extensionTestsPath});(0,w.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(re),ft.WINDOWS.push(re),this._onDidOpenWindow.fire(re),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,v.once)(re.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(re)),(0,v.once)(re.onDidClose)(()=>this.onWindowClosed(re)),(0,v.once)(re.onDidDestroy)(()=>this._onDidDestroyWindow.fire(re)),re.onDidTriggerSystemContextMenu(({x:J,y:Z})=>this._onDidTriggerSystemContextMenu.fire({window:re,x:J,y:Z}));const B=(0,S.assertIsDefined)(re.win?.webContents);B.removeAllListeners("devtools-reload-page"),B.on("devtools-reload-page",()=>this.lifecycleMainService.reload(re)),this.lifecycleMainService.registerWindow(re)}return j.windowId=q.id,q.isReady?this.lifecycleMainService.unload(q,4).then(X=>{X||this.doOpenInBrowserWindow(q,j,L)}):this.doOpenInBrowserWindow(q,j,L),q}doOpenInBrowserWindow(L,W,j){W.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(W.workspace)?W.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:W.workspace,remoteAuthority:W.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(W.workspace)?W.backupPath=this.backupMainService.registerFolderBackup({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority}):W.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:j.emptyWindowBackupInfo?.backupFolder??(0,fe.createEmptyWorkspaceIdentifier)().id,remoteAuthority:W.remoteAuthority})),L.load(W)}resolveProfileForBrowserWindow(L){let W=L.profile;return W&&this.userDataProfilesMainService.setProfileForWorkspaceSync(L.workspace??"empty-window",W),W||(W=this.userDataProfilesMainService.getOrSetProfileForWorkspace(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesMainService.defaultProfile)),W}onWindowClosed(L){const W=ft.WINDOWS.indexOf(L);ft.WINDOWS.splice(W,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=E.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(W=>(0,d.isEqualAuthority)(W.remoteAuthority,L)))}doGetLastActiveWindow(L){const W=Math.max.apply(Math,L.map(j=>j.lastFocusTime));return L.find(j=>j.lastFocusTime===W)}sendToFocused(L,...W){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,D.CancellationToken.None,...W)}sendToAll(L,W,j){for(const q of this.getWindows())j&&j.indexOf(q.id)>=0||q.sendWhenReady(L,D.CancellationToken.None,W)}getWindows(){return ft.WINDOWS}getWindowCount(){return ft.WINDOWS.length}getWindowById(L){const W=this.getWindows().filter(j=>j.id===L);return(0,R.firstOrDefault)(W)}getWindowByWebContents(L){const W=E.BrowserWindow.fromWebContents(L);if(!!W)return this.getWindowById(W.id)}};N.WINDOWS=[],N=ve([ie(2,a.ILogService),ie(3,Y.IStateMainService),ie(4,A.IPolicyService),ie(5,i.IEnvironmentMainService),ie(6,O.IUserDataProfilesMainService),ie(7,c.ILifecycleMainService),ie(8,l.IBackupMainService),ie(9,n.IConfigurationService),ie(10,K.IWorkspacesHistoryMainService),ie(11,H.IWorkspacesManagementMainService),ie(12,s.IInstantiationService),ie(13,r.IDialogMainService),ie(14,o.IFileService),ie(15,M.IProductService),ie(16,T.IProtocolMainService),ie(17,F.IThemeMainService)],N),e.WindowsMainService=N}),define(ee[270],te([0,1,60,31,75,52]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(p,v,b,C){this.workspacesManagementMainService=p,this.windowsMainService=v,this.workspacesHistoryMainService=b,this.backupMainService=C,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(p,v){const b=this.windowsMainService.getWindowById(p);if(b)return this.workspacesManagementMainService.enterWorkspace(b,this.windowsMainService.getWindows(),v)}createUntitledWorkspace(p,v,b){return this.workspacesManagementMainService.createUntitledWorkspace(v,b)}deleteUntitledWorkspace(p,v){return this.workspacesManagementMainService.deleteUntitledWorkspace(v)}getWorkspaceIdentifier(p,v){return this.workspacesManagementMainService.getWorkspaceIdentifier(v)}getRecentlyOpened(p){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(p,v){return this.workspacesHistoryMainService.addRecentlyOpened(v)}removeRecentlyOpened(p,v){return this.workspacesHistoryMainService.removeRecentlyOpened(v)}clearRecentlyOpened(p){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};D=ve([ie(0,R.IWorkspacesManagementMainService),ie(1,t.IWindowsMainService),ie(2,k.IWorkspacesHistoryMainService),ie(3,E.IBackupMainService)],D),e.WorkspacesMainService=D}),define(ee[271],te([0,1,13,40,27,17,43,16,30,49,42,33,2,14,9,4,12,7,29,81,130,45,144,102,247,147,60,262,18,70,180,84,118,56,105,178,26,59,111,192,213,193,249,106,194,195,15,205,86,69,5,85,263,226,258,21,6,207,268,65,20,63,255,88,37,252,91,112,35,231,233,73,47,238,239,264,240,265,114,242,243,244,245,250,31,269,251,28,92,75,270,52,248,36,212,48,222,55,87,116,253,259,260,8]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g,f,d,S,m,h,l,n,r,i,o,s,c,a,y,M,T,U,Y,G,V,oe,ae,se,fe,K,H,F,A,O,_,ne,N,$,L,W,j,q,X,re,B,J,Z,ce,ge,De,Te,Me,Le,we,pe,Se,ke,x,ue,de,ye,Ce,Fe,Oe,$e,Ne,je,Qe,Be,Ge,Q,le,he,me,be,Ae,Ue,it,Je,He,et,nt,lt,gt,St,Bt,zt,_t,$t,jt,qt,Ht,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Pt=class extends I.Disposable{constructor(Ee,Pe,Re,Ie,We,ze,Ze,tt,_e,Ve,Ke){super(),this.mainProcessNodeIpcServer=Ee,this.userEnv=Pe,this.mainInstantiationService=Re,this.logService=Ie,this.environmentMainService=We,this.lifecycleMainService=ze,this.configurationService=Ze,this.stateMainService=tt,this.fileService=_e,this.productService=Ve,this.userDataProfilesMainService=Ke,this.configureSession(),this.registerListeners()}configureSession(){const Ee=_e=>_e?.startsWith(`${u.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((_e,Ve,Ke,xe)=>Ee(xe.requestingUrl)?Ke(Pe.has(Ve)):Ke(!1)),E.session.defaultSession.setPermissionCheckHandler((_e,Ve,Ke,xe)=>Ee(xe.requestingUrl)?Pe.has(Ve):!1);const Re=new Set([u.Schemas.file,u.Schemas.vscodeFileResource,u.Schemas.vscodeRemoteResource,"devtools"]),Ie=_e=>{for(let Ve=_e;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${u.Schemas.vscodeWebview}://`))return!0;return!1},We=_e=>_e.resourceType==="xhr"||Ie(_e.frame),ze=_e=>{const Ve=_e.frame;if(!Ve||!this.windowsMainService)return!1;const Ke=E.BrowserWindow.getAllWindows();for(const xe of Ke)if(Ve.processId===xe.webContents.mainFrame.processId)return!0;return!1},Ze=(_e,Ve)=>{if(_e.path!=="/index.html")return!0;const Ke=Ve.frame;if(!Ke||!this.windowsMainService)return!1;for(const xe of this.windowsMainService.getWindows())if(xe.win&&Ke.processId===xe.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((_e,Ve)=>{const Ke=d.URI.parse(_e.url);return Ke.scheme===u.Schemas.vscodeWebview&&!Ze(Ke,_e)?(this.logService.error("Blocked vscode-webview request",_e.url),Ve({cancel:!0})):Ke.scheme===u.Schemas.vscodeFileResource&&!ze(_e)?(this.logService.error("Blocked vscode-file request",_e.url),Ve({cancel:!0})):Ke.path.endsWith(".svg")&&!Re.has(Ke.scheme)?Ve({cancel:!We(_e)}):Ve({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((_e,Ve)=>{const Ke=_e.responseHeaders,xe=Ke["content-type"]||Ke["Content-Type"];if(xe&&Array.isArray(xe)){const ot=d.URI.parse(_e.url);if(ot.path.endsWith(".svg")&&Re.has(ot.scheme))return Ke["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Ke});if(!ot.path.endsWith(u.Schemas.vscodeRemoteResource)&&xe.some(ct=>ct.toLowerCase().includes("image/svg")))return Ve({cancel:!We(_e)})}return Ve({cancel:!1})});const tt=E.session.defaultSession;typeof tt.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&tt.setCodeCachePath((0,w.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,P.setUnexpectedErrorHandler)(Re=>this.onUnexpectedError(Re)),process.on("uncaughtException",Re=>(0,P.onUnexpectedError)(Re)),process.on("unhandledRejection",Re=>(0,P.onUnexpectedError)(Re)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,h.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(Re,Ie)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),E.app.on("activate",async(Re,Ie)=>{this.logService.trace("app#activate"),Ie||await this.windowsMainService?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(Re,Ie)=>{Ie.on("will-navigate",We=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),We.preventDefault()}),Ie.setWindowOpenHandler(({url:We})=>(this.nativeHostMainService?.openExternal(void 0,We),{action:"deny"}))});let Ee=[],Pe;E.app.on("open-file",(Re,Ie)=>{this.logService.trace("app#open-file: ",Ie),Re.preventDefault(),Ee.push((0,Ue.hasWorkspaceFileExtension)(Ie)?{workspaceUri:d.URI.file(Ie)}:{fileUri:d.URI.file(Ie)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:Ee,gotoLineMode:!1,preferNewWindow:!0}),Ee=[],Pe=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Re=>{const Ie=this.windowsMainService?.getWindowByWebContents(Re.sender);let We,ze;return Ie?.config?(We=Ie.config,ze={...process.env,...Ie.config.userEnv}):(We=this.environmentMainService.args,ze=process.env),this.resolveShellEnvironment(We,ze,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Re,Ie,We)=>{const ze=this.validateNlsPath([Ie]);if(!ze||typeof We!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(ze,R.VSBuffer.fromString(We))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Re,...Ie)=>{const We=this.validateNlsPath(Ie);if(!We)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(We)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Re=>Re.sender.reload())}validateNlsPath(Ee){let Pe;for(const Re of Ee)typeof Re=="string"&&(typeof Pe!="string"?Pe=Re:Pe=(0,w.join)(Pe,Re));if(!(typeof Pe!="string"||!(0,w.isAbsolute)(Pe)||!(0,p.isEqualOrParent)(Pe,this.environmentMainService.cachedLanguagesPath,!g.isLinux)))return d.URI.file(Pe)}onUnexpectedError(Ee){if(Ee){const Pe={message:`[uncaught exception in main]: ${Ee.message}`,stack:Ee.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.logService.error(`[uncaught exception in main]: ${Ee}`),Ee.stack&&this.logService.error(Ee.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const Ee=this.productService.win32AppUserModelId;g.isWindows&&Ee&&E.app.setAppUserModelId(Ee);try{g.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(_e){this.logService.error(_e)}const Pe=new n.Server;this.lifecycleMainService.onWillShutdown(_e=>{_e.reason===2&&Pe.dispose()}),this.logService.trace("Resolving machine identifier...");const Re=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Re}`);const{sharedProcess:Ie,sharedProcessReady:We,sharedProcessClient:ze}=this.setupSharedProcess(Re),Ze=await this.initServices(Re,Ie,We);this.setUpHandlers(Ze),Ze.invokeFunction(_e=>this.initChannels(_e,Pe,ze)),await Ze.invokeFunction(_e=>this.openFirstWindow(_e,Pe)),Ze.invokeFunction(_e=>this.afterWindowOpen(_e,Ie)),this._register(new It.RunOnceScheduler(()=>{this._register((0,It.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setUpHandlers(Ee){this._register(Ee.createInstance(i.ProxyAuthHandler)),this._register(Ee.createInstance(qt.UserDataTransientProfilesHandler))}async resolveMachineId(){let Ee=this.stateMainService.getItem(x.machineIdKey);return(!Ee||g.isMacintosh&&Ee==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(Ee=await(0,m.getMachineId)(),this.stateMainService.setItem(x.machineIdKey,Ee)),Ee}setupSharedProcess(Ee){const Pe=this._register(this.mainInstantiationService.createInstance(Me.SharedProcess,Ee,this.userEnv)),Re=(async()=>{this.logService.trace("Main->SharedProcess#connect");const We=await Pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new r.Client(We,"main")})(),Ie=(async()=>(await Pe.whenReady(),Re))();return{sharedProcess:Pe,sharedProcessReady:Ie,sharedProcessClient:Re}}async initServices(Ee,Pe,Re){const Ie=new j.ServiceCollection;switch(process.platform){case"win32":Ie.set(Ce.IUpdateService,new L.SyncDescriptor(je.Win32UpdateService));break;case"linux":g.isLinuxSnap?Ie.set(Ce.IUpdateService,new L.SyncDescriptor(Ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(Ce.IUpdateService,new L.SyncDescriptor($e.LinuxUpdateService));break;case"darwin":Ie.set(Ce.IUpdateService,new L.SyncDescriptor(Oe.DarwinUpdateService));break}Ie.set(me.IWindowsMainService,new L.SyncDescriptor(be.WindowsMainService,[Ee,this.userEnv],!1));const We=new Y.DialogMainService(this.logService);Ie.set(Y.IDialogMainService,We),Ie.set(re.ILaunchMainService,new L.SyncDescriptor(re.LaunchMainService,void 0,!1)),Ie.set(U.IDiagnosticsMainService,new L.SyncDescriptor(U.DiagnosticsMainService,void 0,!1)),Ie.set(T.IDiagnosticsService,l.ProxyChannel.toService((0,l.getDelayedChannel)(Re.then(tt=>tt.getChannel("diagnostics"))))),Ie.set(q.IIssueMainService,new L.SyncDescriptor(q.IssueMainService,[this.userEnv])),Ie.set(G.IEncryptionMainService,new L.SyncDescriptor(V.EncryptionMainService,[Ee])),Ie.set(X.IKeyboardLayoutMainService,new L.SyncDescriptor(X.KeyboardLayoutMainService)),Ie.set(ge.INativeHostMainService,new L.SyncDescriptor(ge.NativeHostMainService,[Pe],!1)),Ie.set(y.ICredentialsMainService,new L.SyncDescriptor(nt.CredentialsNativeMainService)),Ie.set(le.IWebviewManagerService,new L.SyncDescriptor(he.WebviewMainService)),Ie.set(ce.IMenubarMainService,new L.SyncDescriptor(ce.MenubarMainService)),Ie.set(fe.IExtensionUrlTrustService,new L.SyncDescriptor(K.ExtensionUrlTrustService)),Ie.set(H.IExtensionHostStarter,new L.SyncDescriptor(F.ExtensionHostStarter)),Ie.set(Se.IStorageMainService,new L.SyncDescriptor(Se.StorageMainService)),Ie.set(Se.IApplicationStorageMainService,new L.SyncDescriptor(Se.ApplicationStorageMainService)),g.isWindows?Ie.set(A.IExternalTerminalMainService,new L.SyncDescriptor(O.WindowsExternalTerminalService)):g.isMacintosh?Ie.set(A.IExternalTerminalMainService,new L.SyncDescriptor(O.MacExternalTerminalService)):g.isLinux&&Ie.set(A.IExternalTerminalMainService,new L.SyncDescriptor(O.LinuxExternalTerminalService));const ze=new c.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateMainService);Ie.set(s.IBackupMainService,ze);const Ze=new et.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,ze,We,this.productService);if(Ie.set(et.IWorkspacesManagementMainService,Ze),Ie.set(it.IWorkspacesService,new L.SyncDescriptor(He.WorkspacesMainService,void 0,!1)),Ie.set(Je.IWorkspacesHistoryMainService,new L.SyncDescriptor(Je.WorkspacesHistoryMainService,void 0,!1)),Ie.set(Qe.IURLService,new L.SyncDescriptor(Ge.NativeURLService,void 0,!1)),(0,ye.supportsTelemetry)(this.productService,this.environmentMainService)){const tt=(0,ye.isInternalTelemetry)(this.productService,this.configurationService),_e=(0,l.getDelayedChannel)(Re.then(ct=>ct.getChannel("telemetryAppender"))),Ve=new ue.TelemetryAppenderClient(_e),Ke=(0,ke.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,Ee,tt,this.environmentMainService.installSourcePath),xe=(0,ye.getPiiPathsFromEnvironment)(this.environmentMainService),ot={appenders:[Ve],commonProperties:Ke,piiPaths:xe,sendErrorTelemetry:!0};Ie.set(x.ITelemetryService,new L.SyncDescriptor(de.TelemetryService,[ot],!1))}else Ie.set(x.ITelemetryService,ye.NullTelemetryService);return Ie.set(_t.IExtensionsProfileScannerService,new L.SyncDescriptor(_t.ExtensionsProfileScannerService,void 0,!0)),Ie.set($t.IExtensionsScannerService,new L.SyncDescriptor(jt.ExtensionsScannerService,void 0,!0)),await It.Promises.settled([ze.initialize(),Ze.initialize()]),this.mainInstantiationService.createChild(Ie)}initChannels(Ee,Pe,Re){const Ie=l.ProxyChannel.fromService(Ee.get(re.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Ie);const We=l.ProxyChannel.fromService(Ee.get(U.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",We);const ze=new gt.PolicyChannel(Ee.get(lt.IPolicyService));Pe.registerChannel("policy",ze),Re.then(Ye=>Ye.registerChannel("policy",ze));const Ze=this.fileService.getProvider(u.Schemas.file);(0,f.assertType)(Ze instanceof $.DiskFileSystemProvider);const tt=new N.DiskFileSystemProviderChannel(Ze,this.logService,this.environmentMainService);Pe.registerChannel(_.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt),Re.then(Ye=>Ye.registerChannel(_.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt));const _e=l.ProxyChannel.fromService(Ee.get(St.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",_e),Re.then(Ye=>Ye.registerChannel("userDataProfiles",_e));const Ve=new Bt.RequestChannel(Ee.get(zt.IRequestService));Re.then(Ye=>Ye.registerChannel("request",Ve));const Ke=new Fe.UpdateChannel(Ee.get(Ce.IUpdateService));Pe.registerChannel("update",Ke);const xe=l.ProxyChannel.fromService(Ee.get(q.IIssueMainService));Pe.registerChannel("issue",xe);const ot=l.ProxyChannel.fromService(Ee.get(G.IEncryptionMainService));Pe.registerChannel("encryption",ot);const ct=l.ProxyChannel.fromService(Ee.get(y.ICredentialsMainService));Pe.registerChannel("credentials",ct);const kt=l.ProxyChannel.fromService(Ee.get(Le.ISignService));Pe.registerChannel("sign",kt);const Xe=l.ProxyChannel.fromService(Ee.get(X.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",Xe),this.nativeHostMainService=Ee.get(ge.INativeHostMainService);const mt=l.ProxyChannel.fromService(this.nativeHostMainService);Pe.registerChannel("nativeHost",mt),Re.then(Ye=>Ye.registerChannel("nativeHost",mt));const pt=l.ProxyChannel.fromService(Ee.get(it.IWorkspacesService));Pe.registerChannel("workspaces",pt);const yt=l.ProxyChannel.fromService(Ee.get(ce.IMenubarMainService));Pe.registerChannel("menubar",yt);const Mt=l.ProxyChannel.fromService(Ee.get(Qe.IURLService));Pe.registerChannel("url",Mt);const Dt=l.ProxyChannel.fromService(Ee.get(fe.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",Dt);const wt=l.ProxyChannel.fromService(Ee.get(le.IWebviewManagerService));Pe.registerChannel("webview",wt);const ut=this._register(new pe.StorageDatabaseChannel(this.logService,Ee.get(Se.IStorageMainService)));Pe.registerChannel("storage",ut),Re.then(Ye=>Ye.registerChannel("storage",ut));const bt=this._register(new Ht.ProfileStorageChangesListenerChannel(Ee.get(Se.IStorageMainService),Ee.get(St.IUserDataProfilesMainService),this.logService));Re.then(Ye=>Ye.registerChannel("profileStorageListener",bt));const vt=l.ProxyChannel.fromService(Ee.get(A.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",vt);const qe=new Z.LogLevelChannel(Ee.get(J.ILogService),Ee.get(J.ILoggerService));Pe.registerChannel("logLevel",qe),Re.then(Ye=>Ye.registerChannel("logLevel",qe));const st=new Z.LoggerChannel(Ee.get(J.ILoggerService));Pe.registerChannel("logger",st),Re.then(Ye=>Ye.registerChannel("logger",st));const dt=new M.ElectronExtensionHostDebugBroadcastChannel(Ee.get(me.IWindowsMainService),Ee.get(St.IUserDataProfilesMainService));Pe.registerChannel("extensionhostdebugservice",dt);const at=l.ProxyChannel.fromService(Ee.get(H.IExtensionHostStarter));Pe.registerChannel(H.ipcExtensionHostStarterChannelName,at)}async openFirstWindow(Ee,Pe){const Re=this.windowsMainService=Ee.get(me.IWindowsMainService),Ie=Ee.get(Qe.IURLService),We=Ee.get(ge.INativeHostMainService);this.lifecycleMainService.phase=2;const ze=[],Ze=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(qe=>{try{return{uri:d.URI.parse(qe),url:qe}}catch{return}}).filter(qe=>{if(!qe||this.shouldBlockURI(qe.uri))return!1;const st=this.getWindowOpenableFromProtocolLink(qe.uri);return st?(ze.push(st),!1):!0}),tt=this,_e=this.environmentMainService,Ve=this.productService,Ke=this.logService;Ie.registerHandler({async handleURL(qe,st){if(Ke.trace("app#handleURL: ",qe.toString(!0),st),qe.scheme===Ve.urlProtocol&&qe.path==="workspace"&&(qe=qe.with({authority:"file",path:d.URI.parse(qe.query).path,query:""})),tt.shouldBlockURI(qe))return!0;let dt=!1;const at=new URLSearchParams(qe.query);at.get("windowId")==="_blank"&&(at.delete("windowId"),qe=qe.with({query:at.toString()}),dt=!0),dt||=g.isMacintosh&&Re.getWindowCount()===0;const Ye=at.get("continueOn");Ye!==null&&(_e.continueOn=Ye??void 0,at.delete("continueOn"),qe=qe.with({query:at.toString()}));const Rt=tt.getWindowOpenableFromProtocolLink(qe);if(Ke.trace("app#handleURL: windowOpenableFromProtocolLink = ",Rt),Rt){const[Lt]=await Re.open({context:5,cli:{..._e.args},urisToOpen:[Rt],forceNewWindow:dt,gotoLineMode:!0});return Lt.focus(),!0}if(dt){const[Lt]=await Re.open({context:5,cli:{..._e.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Te.getRemoteAuthority)(qe)});return await Lt.ready(),Ie.open(qe,st)}return!1}});const xe=this._register(new Ae.ActiveWindowManager({onDidOpenWindow:We.onDidOpenWindow,onDidFocusWindow:We.onDidFocusWindow,getActiveWindowId:()=>We.getActiveWindowId(-1)})),ot=new l.StaticRouter(qe=>xe.getActiveClientId().then(st=>qe===st)),ct=new Be.URLHandlerRouter(ot),kt=Pe.getChannel("urlHandler",ct);Ie.registerHandler(new Be.URLHandlerChannelClient(kt)),this._register(new Q.ElectronURLListener(Ze,Ie,Re,this.environmentMainService,this.productService));const Xe=this.environmentMainService.args,mt=global.macOpenFiles,pt=(0,ae.isLaunchedFromCli)(process.env)?0:4,yt=Xe._.length,Mt=!!Xe["folder-uri"],Dt=!!Xe["file-uri"],wt=Xe["skip-add-to-recently-opened"]===!0,ut=Xe.wait&&Xe.waitMarkerFilePath?d.URI.file(Xe.waitMarkerFilePath):void 0,bt=Xe.remote||void 0;if(ze.length>0)return Re.open({context:pt,cli:Xe,urisToOpen:ze,gotoLineMode:!0,initialStartup:!0});const vt=await this.userDataProfilesMainService.checkAndCreateProfileFromCli(this.environmentMainService.args);if(!yt&&!Mt&&!Dt){if(Xe["new-window"]||vt)return Re.open({context:pt,cli:Xe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:wt,waitMarkerFileURI:ut,initialStartup:!0,remoteAuthority:bt,profile:vt});if(mt.length)return Re.open({context:1,cli:Xe,urisToOpen:mt.map(qe=>(0,Ue.hasWorkspaceFileExtension)(qe)?{workspaceUri:d.URI.file(qe)}:{fileUri:d.URI.file(qe)}),noRecentEntry:wt,waitMarkerFileURI:ut,initialStartup:!0})}return Re.open({context:pt,cli:Xe,forceNewWindow:Xe["new-window"]||!yt&&Xe["unity-launch"],diffMode:Xe.diff,mergeMode:Xe.merge,noRecentEntry:wt,waitMarkerFileURI:ut,gotoLineMode:Xe.goto,initialStartup:!0,remoteAuthority:bt,profile:vt})}shouldBlockURI(Ee){return!!(Ee.authority===u.Schemas.file&&g.isWindows&&E.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,C.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,C.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,C.getPathLabel)(Ee,{os:g.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(Ee){if(!!Ee.path){if(Ee.authority===u.Schemas.file){const Pe=d.URI.file(Ee.fsPath);return(0,Ue.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(Ee.authority===u.Schemas.vscodeRemote){const Pe=Ee.path.indexOf(w.posix.sep,1);if(Pe!==-1){const Re=Ee.path.substring(1,Pe),Ie=Ee.path.substring(Pe),We=d.URI.from({scheme:u.Schemas.vscodeRemote,authority:Re,path:Ie,query:Ee.query,fragment:Ee.fragment});return(0,Ue.hasWorkspaceFileExtension)(Ie)?{workspaceUri:We}:/:[\d]+$/.test(Ie)?{fileUri:We}:{folderUri:We}}}}}afterWindowOpen(Ee,Pe){const Re=Ee.get(x.ITelemetryService),Ie=Ee.get(Ce.IUpdateService);this.lifecycleMainService.phase=3,this.handleSharedProcessErrors(Re,Pe),this.installMutex(),E.protocol.registerHttpProtocol(u.Schemas.vscodeRemoteResource,(We,ze)=>{ze({url:We.url.replace(/^vscode-remote-resource:/,"http:"),method:We.method})}),(Ie instanceof je.Win32UpdateService||Ie instanceof $e.LinuxUpdateService||Ie instanceof Oe.DarwinUpdateService)&&Ie.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement()}async installMutex(){const Ee=this.productService.win32MutexName;if(g.isWindows&&Ee)try{const Pe=await new Promise((Ie,We)=>{z(["windows-mutex"],Ie,We)}),Re=new Pe.Mutex(Ee);(0,v.once)(this.lifecycleMainService.onWillShutdown)(()=>Re.release())}catch(Pe){this.logService.error(Pe)}}handleSharedProcessErrors(Ee,Pe){let Re=!1;(0,v.once)(this.lifecycleMainService.onWillShutdown)(()=>Re=!0),this._register(Pe.onDidError(({type:Ie,details:We})=>{let ze;switch(Ie){case 1:ze="SharedProcess: detected unresponsive window";break;case 2:ze=`SharedProcess: renderer process gone (detail: ${We?.reason??"<unknown>"}, code: ${We?.exitCode??"<unknown>"})`;break;case 3:ze=`SharedProcess: failed to load (detail: ${We?.reason??"<unknown>"}, code: ${We?.exitCode??"<unknown>"})`;break}(0,P.onUnexpectedError)(new Error(ze)),Ee.publicLog2("sharedprocesserror",{type:Ie,reason:We?.reason,code:We?.exitCode,visible:Pe.isVisible(),shuttingdown:Re})}))}async resolveShellEnvironment(Ee,Pe,Re){try{return await(0,se.getResolvedShellEnv)(this.logService,Ee,Pe)}catch(Ie){const We=(0,D.toErrorMessage)(Ie);Re?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",We):this.logService.error(We)}return{}}async updateCrashReporterEnablement(){try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Re=JSON.parse((0,b.stripComments)(Pe)),We=(0,ye.getTelemetryLevel)(this.configurationService)>=1;if(Re["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${We},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,S.generateUuid)()}"`,"}"],Ze=Pe.substring(0,Pe.length-2).concat(`,
`,ze.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(Ze))}else{const ze=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${We},`);ze!==Pe&&await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(ze))}}catch(Ee){this.logService.error(Ee)}}};Pt=ve([ie(2,W.IInstantiationService),ie(3,J.ILogService),ie(4,oe.IEnvironmentMainService),ie(5,B.ILifecycleMainService),ie(6,a.IConfigurationService),ie(7,we.IStateMainService),ie(8,ne.IFileService),ie(9,De.IProductService),ie(10,St.IUserDataProfilesMainService)],Pt),e.CodeApplication=Pt}),define(ee[272],te([0,1,36,8,279,2]),function(z,e,E,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class D extends E.AbstractPolicyService{constructor(p){super(),this.productName=p,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(p){await this.throttler.queue(()=>new Promise((v,b)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,p,C=>{for(const I in C){const u=C[I];u===void 0?this.policies.delete(I):this.policies.set(I,u)}this._onDidChange.fire(Object.keys(C)),v()})}catch(C){b(C)}}))}}e.NativePolicyService=D}),define(ee[273],te([0,1,224,8,17,16,2,12,18,34,111,6,223,280]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let w=class extends D.Disposable{constructor(f,d,S){super(),this.environmentService=d,this.logService=S,this.configure(f.getValue()),this._register(f.onDidChangeConfiguration(()=>this.configure(f.getValue()),this))}configure(f){this.proxyUrl=f.http&&f.http.proxy,this.strictSSL=!!(f.http&&f.http.proxyStrictSSL),this.authorization=f.http&&f.http.proxyAuthorization}async request(f,d){this.logService.trace("RequestService#request (node) - begin",f.url);const{proxyUrl:S,strictSSL:m}=this;let h;try{h=await(0,b.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",r))}const l={...process.env,...h},n=f.agent?f.agent:await(0,I.getProxyAgent)(f.url||"",l,{proxyUrl:S,strictSSL:m});f.agent=n,f.strictSSL=m,this.authorization&&(f.headers={...f.headers||{},"Proxy-Authorization":this.authorization});try{const r=await this._request(f,d);return this.logService.trace("RequestService#request (node) - success",f.url),r}catch(r){throw this.logService.trace("RequestService#request (node) - error",f.url,r),r}}async getNodeRequest(f){return((0,E.parse)(f.url).protocol==="https:"?await new Promise((m,h)=>{z(["https"],m,h)}):await new Promise((m,h)=>{z(["http"],m,h)})).request}_request(f,d){return t.Promises.withAsyncBody(async(S,m)=>{const h=(0,E.parse)(f.url),l=f.getRawRequest?f.getRawRequest(f):await this.getNodeRequest(f),n={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,P.isBoolean)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(n.auth=f.user+":"+f.password);const r=l(n,i=>{const o=(0,P.isNumber)(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&o>0&&i.headers.location)this._request({...f,url:i.headers.location,followRedirects:o-1},d).then(S,m);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,u.createGunzip)())),S({res:i,stream:(0,k.streamToBufferReadableStream)(s)})}});r.on("error",m),f.timeout&&r.setTimeout(f.timeout),f.data&&typeof f.data=="string"&&r.write(f.data),r.end(),d.onCancellationRequested(()=>{r.abort(),m(new R.CancellationError)})})}async resolveProxy(f){}};w=ve([ie(0,p.IConfigurationService),ie(1,v.INativeEnvironmentService),ie(2,C.ILogService)],w),e.RequestService=w}),define(ee[274],te([0,1,13,273]),function(z,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(D){return E.net.request}class R extends t.RequestService{request(P,p){return super.request({...P||{},getRawRequest:k},p)}}e.RequestMainService=R}),define(ee[281],te([0,1,13,39,7,24,8,43,16,30,49,33,14,9,72,4,32,25,23,45,83,271,10,18,217,230,26,59,184,15,203,86,69,200,85,21,206,6,209,54,20,61,254,113,236,55,274,88,225,37,229,73,64,48,36,272,211,2,51,241,41,237]),function(z,e,E,t,k,R,D,P,p,v,b,C,I,u,w,g,f,d,S,m,h,l,n,r,i,o,s,c,a,y,M,T,U,Y,G,V,oe,ae,se,fe,K,H,F,A,O,_,ne,N,$,L,W,j,q,X,re,B,J,Z,ce,ge,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Te{main(){try{this.startup()}catch(we){console.error(we.message),E.app.exit(1)}}async startup(){(0,p.setUnexpectedErrorHandler)(Ce=>console.error(Ce));const[we,pe,Se,ke,x,ue,de,ye]=this.createServices();try{try{await this.initServices(Se,ye,ke,x,de)}catch(Ce){throw this.handleStartupDataDirError(Se,de.nameLong,Ce),Ce}await we.invokeFunction(async Ce=>{const Fe=Ce.get(ae.ILogService),Oe=Ce.get(V.ILifecycleMainService),$e=Ce.get(y.IFileService),Ne=Ce.get(ae.ILoggerService),je=await this.claimInstance(Fe,Se,Oe,we,de,!0);return S.Promises.writeFile(Se.mainLockfile,String(process.pid)).catch(Qe=>{Fe.warn(`Error writing main lockfile: ${Qe.stack}`)}),ue.logger=Ne.createLogger(k.URI.file((0,u.join)(Se.logsPath,"main.log")),{name:"main"}),(0,b.once)(Oe.onWillShutdown)(Qe=>{$e.dispose(),ke.dispose(),Qe.join(S.Promises.unlink(Se.mainLockfile).catch(()=>{}))}),we.createInstance(l.CodeApplication,je,pe).startup()})}catch(Ce){we.invokeFunction(this.quit,Ce)}}createServices(){const we=new G.ServiceCollection,pe=new Z.DisposableStore;process.once("exit",()=>pe.dispose());const Se={_serviceBrand:void 0,...fe.default};we.set(K.IProductService,Se);const ke=new s.EnvironmentMainService(this.resolveArgs(),Se),x=this.patchEnvironment(ke);we.set(s.IEnvironmentMainService,ke);const ue=new oe.BufferLogService,de=pe.add(new ae.MultiplexLogService([new ae.ConsoleMainLogger((0,ae.getLogLevel)(ke)),ue]));we.set(ae.ILogService,de);const ye=new M.FileService(de);we.set(y.IFileService,ye);const Ce=new T.DiskFileSystemProvider(de);ye.registerProvider(I.Schemas.file,Ce);const Fe=new ge.UriIdentityService(ye);we.set(ce.IUriIdentityService,Fe),we.set(ae.ILoggerService,new se.LoggerService(de));const Oe=new W.StateMainService(ke,de,ye);we.set(L.IStateMainService,Oe);const $e=new X.UserDataProfilesMainService(Oe,Fe,ke,ye,de);we.set(X.IUserDataProfilesMainService,$e);const Ne=g.isWindows&&Se.win32RegValueName?pe.add(new B.NativePolicyService(Se.win32RegValueName)):ke.policyFile?pe.add(new J.FilePolicyService(ke.policyFile,ye,de)):new re.NullPolicyService;we.set(re.IPolicyService,Ne);const je=new i.ConfigurationService($e.defaultProfile.settingsResource,ye,Ne,de);return we.set(r.IConfigurationService,je),we.set(V.ILifecycleMainService,new U.SyncDescriptor(V.LifecycleMainService,void 0,!1)),we.set(_.IRequestService,new U.SyncDescriptor(ne.RequestMainService,void 0,!0)),we.set(q.IThemeMainService,new U.SyncDescriptor(q.ThemeMainService)),we.set(N.ISignService,new U.SyncDescriptor($.SignService,void 0,!1)),we.set(A.ITunnelService,new U.SyncDescriptor(O.TunnelService)),we.set(H.IProtocolMainService,new F.ProtocolMainService(ke,$e,de)),[new Y.InstantiationService(we,!0),x,ke,je,Oe,ue,Se,$e]}patchEnvironment(we){const pe={VSCODE_IPC_HOOK:we.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Se=>{const ke=process.env[Se];typeof ke=="string"&&(pe[Se]=ke)}),Object.assign(process.env,pe),pe}async initServices(we,pe,Se,ke,x){await D.Promises.settled([Promise.all([we.extensionsPath,we.codeCachePath,we.logsPath,pe.defaultProfile.globalStorageHome.fsPath,we.workspaceStorageHome.fsPath,we.localHistoryHome.fsPath,we.backupHome].map(ue=>ue?S.Promises.mkdir(ue,{recursive:!0}):void 0)),ke.init(),Se.initialize()]),pe.setEnablement(x.quality!=="stable"||Se.getValue(De.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(we,pe,Se,ke,x,ue){let de;try{(0,w.mark)("code/willStartMainServer"),de=await(0,h.serve)(pe.mainIPCHandle),(0,w.mark)("code/didStartMainServer"),(0,b.once)(Se.onWillShutdown)(()=>de.dispose())}catch(ye){if(ye.code!=="EADDRINUSE")throw this.handleStartupDataDirError(pe,x.nameLong,ye),ye;let Ce;try{Ce=await(0,h.connect)(pe.mainIPCHandle,"main")}catch(Ne){if(!ue||g.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,n.localize)(0,null,x.nameShort),(0,n.localize)(1,null),x.nameLong),Ne;try{(0,t.unlinkSync)(pe.mainIPCHandle)}catch(je){throw we.warn("Could not delete obsolete instance handle",je),je}return this.claimInstance(we,pe,Se,ke,x,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw we.error(Ne),Ce.dispose(),new Error(Ne)}let Fe;!pe.args.wait&&!pe.args.status&&(Fe=setTimeout(()=>{this.showStartupWarningDialog((0,n.localize)(2,null,x.nameShort),(0,n.localize)(3,null),x.nameLong)},1e4));const Oe=m.ProxyChannel.toService(Ce.getChannel("launch"),{disableMarshalling:!0}),$e=m.ProxyChannel.toService(Ce.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return ke.invokeFunction(async()=>{const Ne=new o.DiagnosticsService(j.NullTelemetryService,x),je=await $e.getMainDiagnostics(),Qe=await $e.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ne.getDiagnostics(je,Qe);throw console.log(Be),new p.ExpectedError});throw g.isWindows&&await this.windowsAllowSetForegroundWindow(Oe,we),we.trace("Sending env to running instance..."),await Oe.start(pe.args,process.env),Ce.dispose(),Fe&&clearTimeout(Fe),new p.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw we.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new p.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),de}handleStartupDataDirError(we,pe,Se){if(Se.code==="EACCES"||Se.code==="EPERM"){const ke=(0,R.coalesce)([we.userDataPath,we.extensionsPath,h.XDG_RUNTIME_DIR]).map(x=>(0,C.getPathLabel)(k.URI.file(x),{os:g.OS,tildify:we}));this.showStartupWarningDialog((0,n.localize)(4,null),(0,n.localize)(5,null,(0,P.toErrorMessage)(Se),ke.join(`
`)),pe)}}showStartupWarningDialog(we,pe,Se){E.dialog.showMessageBoxSync({title:Se,type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,n.localize)(6,null))],message:we,detail:pe,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(we,pe){if(g.isWindows){const Se=await we.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",Se);try{(await new Promise((ke,x)=>{z(["windows-foreground-love"],ke,x)})).allowSetForegroundWindow(Se)}catch(ke){pe.error(ke)}}}quit(we,pe){const Se=we.get(ae.ILogService),ke=we.get(V.ILifecycleMainService);let x=0;pe&&(pe.isExpected?pe.message&&Se.trace(pe.message):(x=1,pe.stack?Se.error(pe.stack):Se.error(`Startup error: ${pe.toString()}`))),ke.kill(x)}resolveArgs(){const we=this.validatePaths((0,c.parseMainProcessArgv)(process.argv));if(we.wait&&!we.waitMarkerFilePath){const pe=(0,a.createWaitMarkerFileSync)(we.verbose);pe&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",pe),we.waitMarkerFilePath=pe)}return we}validatePaths(we){if(we["open-url"]&&(we._urls=we._,we._=[]),!we.remote){const pe=this.doValidatePaths(we._,we.goto);we._=pe}return we}doValidatePaths(we,pe){const Se=(0,f.cwd)(),ke=we.map(de=>{let ye=String(de),Ce;pe&&(Ce=(0,v.parseLineAndColumnAware)(ye),ye=Ce.path),ye&&(ye=this.preparePath(Se,ye));const Fe=(0,v.sanitizeFilePath)(ye,Se),Oe=(0,u.basename)(Fe);return Oe&&!(0,v.isValidBasename)(Oe)?null:pe&&Ce?(Ce.path=Fe,this.toPath(Ce)):Fe}),x=g.isWindows||g.isMacintosh,ue=(0,R.distinct)(ke,de=>de&&x?de.toLowerCase():de||"");return(0,R.coalesce)(ue)}preparePath(we,pe){return g.isWindows&&(pe=(0,d.rtrim)(pe,'"')),pe=(0,d.trim)((0,d.trim)(pe," "),"	"),g.isWindows&&(pe=(0,u.resolve)(we,pe),pe=(0,d.rtrim)(pe,".")),pe}toPath(we){const pe=[we.path];return typeof we.line=="number"&&pe.push(String(we.line)),typeof we.column=="number"&&pe.push(String(we.column)),pe.join(":")}}new Te().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e8eb39bac26ddc87f27ed69fa06c54cd230d18f9/core/vs/code/electron-main/main.js.map
