/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/event","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/errors","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/path","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/base/common/map","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/ternarySearchTree","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],ee=function(_){for(var e=[],C=0,D=_.length;C<D;C++)e[C]=Q[_[C]];return e};define(Q[49],ee([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function C(O){return(P,h,u)=>{let m=null,b=null;if(typeof u.value=="function"?(m="value",b=u.value):typeof u.get=="function"&&(m="get",b=u.get),!b)throw new Error("not supported");u[m]=O(b,h)}}function D(O,P,h){let u=null,m=null;if(typeof h.value=="function"?(u="value",m=h.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(u="get",m=h.get),!m)throw new Error("not supported");const b=`$memoize$${P}`;h[u]=function(...p){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,p)}),this[b]}}e.memoize=D;function I(O,P,h){return C((u,m)=>{const b=`$debounce$${m}`,p=`$debounce$result$${m}`;return function(...y){this[p]||(this[p]=h?h():void 0),clearTimeout(this[b]),P&&(this[p]=P(this[p],...y),y=[this[p]]),this[b]=setTimeout(()=>{u.apply(this,y),this[p]=h?h():void 0},O)}})}e.debounce=I;function k(O,P,h){return C((u,m)=>{const b=`$throttle$timer$${m}`,p=`$throttle$result$${m}`,y=`$throttle$lastRun$${m}`,v=`$throttle$pending$${m}`;return function(...E){if(this[p]||(this[p]=h?h():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),P&&(this[p]=P(this[p],...E)),this[v])return;const S=this[y]+O;S<=Date.now()?(this[y]=Date.now(),u.apply(this,[this[p]]),this[p]=h?h():void 0):(this[v]=!0,this[b]=setTimeout(()=>{this[v]=!1,this[y]=Date.now(),u.apply(this,[this[p]]),this[p]=h?h():void 0},S-Date.now()))}})}e.throttle=k}),define(Q[69],ee([0,1,11]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function D(h,u){if(!h)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=D;function I(h,u="Unreachable"){throw new Error(u)}e.assertNever=I;function k(h){if(!h)throw new C.BugIndicatingError("Assertion Failed")}e.assert=k;function O(h){if(!h()){debugger;h(),(0,C.onUnexpectedError)(new C.BugIndicatingError("Assertion Failed"))}}e.assertFn=O;function P(h,u){let m=0;for(;m<h.length-1;){const b=h[m],p=h[m+1];if(!u(b,p))return!1;m++}return!0}e.checkAdjacentItems=P}),define(Q[50],ee([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(C=e.ScanError||(e.ScanError={}));var D;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(i){i.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function O(i,n=!1){let t=0;const r=i.length;let o="",c=0,a=16,d=0;function R(Z){let ge=0,ce=0;for(;ge<Z;){const re=i.charCodeAt(t);if(re>=48&&re<=57)ce=ce*16+re-48;else if(re>=65&&re<=70)ce=ce*16+re-65+10;else if(re>=97&&re<=102)ce=ce*16+re-97+10;else break;t++,ge++}return ge<Z&&(ce=-1),ce}function M(Z){t=Z,o="",c=0,a=16,d=0}function q(){const Z=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&u(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&u(i.charCodeAt(t)))for(t++;t<i.length&&u(i.charCodeAt(t));)t++;else return d=3,i.substring(Z,t);let ge=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&u(i.charCodeAt(t))){for(t++;t<i.length&&u(i.charCodeAt(t));)t++;ge=t}else d=3;return i.substring(Z,ge)}function X(){let Z="",ge=t;for(;;){if(t>=r){Z+=i.substring(ge,t),d=2;break}const ce=i.charCodeAt(t);if(ce===34){Z+=i.substring(ge,t),t++;break}if(ce===92){if(Z+=i.substring(ge,t),t++,t>=r){d=2;break}switch(i.charCodeAt(t++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:{const z=R(4);z>=0?Z+=String.fromCharCode(z):d=4;break}default:d=5}ge=t;continue}if(ce>=0&&ce<=31)if(h(ce)){Z+=i.substring(ge,t),d=2;break}else d=6;t++}return Z}function J(){if(o="",d=0,c=t,t>=r)return c=r,a=17;let Z=i.charCodeAt(t);if(P(Z)){do t++,o+=String.fromCharCode(Z),Z=i.charCodeAt(t);while(P(Z));return a=15}if(h(Z))return t++,o+=String.fromCharCode(Z),Z===13&&i.charCodeAt(t)===10&&(t++,o+=`
`),a=14;switch(Z){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,o=X(),a=10;case 47:{const ge=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<r&&!h(i.charCodeAt(t));)t++;return o=i.substring(ge,t),a=12}if(i.charCodeAt(t+1)===42){t+=2;const ce=r-1;let re=!1;for(;t<ce;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,re=!0;break}t++}return re||(t++,d=1),o=i.substring(ge,t),a=13}return o+=String.fromCharCode(Z),t++,a=16}case 45:if(o+=String.fromCharCode(Z),t++,t===r||!u(i.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=q(),a=11;default:for(;t<r&&ie(Z);)t++,Z=i.charCodeAt(t);if(c!==t){switch(o=i.substring(c,t),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(Z),t++,a=16}}function ie(Z){if(P(Z)||h(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let Z;do Z=J();while(Z>=12&&Z<=15);return Z}return{setPosition:M,getPosition:()=>t,scan:n?oe:J,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>t-c,getTokenError:()=>d}}e.createScanner=O;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function h(i){return i===10||i===13||i===8232||i===8233}function u(i){return i>=48&&i<=57}var m;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(m||(m={}));function b(i,n){const t=[],r=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function d(R,M,q,X){c.value=R,c.offset=M,c.length=q,c.type=X,c.colonOffset=void 0,o=c}try{w(i,{onObjectBegin:(R,M)=>{if(n<=R)throw r;o=void 0,a=n>R,t.push("")},onObjectProperty:(R,M,q)=>{if(n<M||(d(R,M,q,"property"),t[t.length-1]=R,n<=M+q))throw r},onObjectEnd:(R,M)=>{if(n<=R)throw r;o=void 0,t.pop()},onArrayBegin:(R,M)=>{if(n<=R)throw r;o=void 0,t.push(0)},onArrayEnd:(R,M)=>{if(n<=R)throw r;o=void 0,t.pop()},onLiteralValue:(R,M,q)=>{if(n<M||(d(R,M,q,s(R)),n<=M+q))throw r},onSeparator:(R,M,q)=>{if(n<=M)throw r;if(R===":"&&o&&o.type==="property")o.colonOffset=M,a=!1,o=void 0;else if(R===","){const X=t[t.length-1];typeof X=="number"?t[t.length-1]=X+1:(a=!0,t[t.length-1]=""),o=void 0}}})}catch(R){if(R!==r)throw R}return{path:t,previousNode:o,isAtPropertyKey:a,matches:R=>{let M=0;for(let q=0;M<R.length&&q<t.length;q++)if(R[M]===t[q]||R[M]==="*")M++;else if(R[M]!=="**")return!1;return M===R.length}}}e.getLocation=b;function p(i,n=[],t=k.DEFAULT){let r=null,o=[];const c=[];function a(R){Array.isArray(o)?o.push(R):r!==null&&(o[r]=R)}return w(i,{onObjectBegin:()=>{const R={};a(R),c.push(o),o=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const R=[];a(R),c.push(o),o=R,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:a,onError:(R,M,q)=>{n.push({error:R,offset:M,length:q})}},t),o[0]}e.parse=p;function y(i,n=[],t=k.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(R){r.type==="property"&&(r.length=R-r.offset,r=r.parent)}function c(R){return r.children.push(R),R}w(i,{onObjectBegin:R=>{r=c({type:"object",offset:R,length:-1,parent:r,children:[]})},onObjectProperty:(R,M,q)=>{r=c({type:"property",offset:M,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:R,offset:M,length:q,parent:r})},onObjectEnd:(R,M)=>{r.length=R+M-r.offset,r=r.parent,o(R+M)},onArrayBegin:(R,M)=>{r=c({type:"array",offset:R,length:-1,parent:r,children:[]})},onArrayEnd:(R,M)=>{r.length=R+M-r.offset,r=r.parent,o(R+M)},onLiteralValue:(R,M,q)=>{c({type:s(R),offset:M,length:q,parent:r,value:R}),o(M+q)},onSeparator:(R,M,q)=>{r.type==="property"&&(R===":"?r.colonOffset=M:R===","&&o(M))},onError:(R,M,q)=>{n.push({error:R,offset:M,length:q})}},t);const d=r.children[0];return d&&delete d.parent,d}e.parseTree=y;function v(i,n){if(!i)return;let t=i;for(const r of n)if(typeof r=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const c of t.children)if(Array.isArray(c.children)&&c.children[0].value===r){t=c.children[1],o=!0;break}if(!o)return}else{const o=r;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}e.findNodeAtLocation=v;function E(i){if(!i.parent||!i.parent.children)return[];const n=E(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;n.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&n.push(t)}return n}e.getNodePath=E;function S(i){switch(i.type){case"array":return i.children.map(S);case"object":{const n=Object.create(null);for(const t of i.children){const r=t.children[1];r&&(n[t.children[0].value]=S(r))}return n}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=S;function l(i,n,t=!1){return n>=i.offset&&n<i.offset+i.length||t&&n===i.offset+i.length}e.contains=l;function g(i,n,t=!1){if(l(i,n,t)){const r=i.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const c=g(r[o],n,t);if(c)return c}return i}}e.findNodeAtOffset=g;function w(i,n,t=k.DEFAULT){const r=O(i,!1);function o(B){return B?()=>B(r.getTokenOffset(),r.getTokenLength()):()=>!0}function c(B){return B?N=>B(N,r.getTokenOffset(),r.getTokenLength()):()=>!0}const a=o(n.onObjectBegin),d=c(n.onObjectProperty),R=o(n.onObjectEnd),M=o(n.onArrayBegin),q=o(n.onArrayEnd),X=c(n.onLiteralValue),J=c(n.onSeparator),ie=o(n.onComment),oe=c(n.onError),Z=t&&t.disallowComments,ge=t&&t.allowTrailingComma;function ce(){for(;;){const B=r.scan();switch(r.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:Z||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(B){case 12:case 13:Z?re(10):ie();break;case 16:re(1);break;case 15:case 14:break;default:return B}}}function re(B,N=[],T=[]){if(oe(B),N.length+T.length>0){let L=r.getToken();for(;L!==17;){if(N.indexOf(L)!==-1){ce();break}else if(T.indexOf(L)!==-1)break;L=ce()}}}function z(B){const N=r.getTokenValue();return B?X(N):d(N),ce(),!0}function F(){switch(r.getToken()){case 11:{let B=0;try{B=JSON.parse(r.getTokenValue()),typeof B!="number"&&(re(2),B=0)}catch{re(2)}X(B);break}case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return ce(),!0}function A(){return r.getToken()!==10?(re(3,[],[2,5]),!1):(z(!1),r.getToken()===6?(J(":"),ce(),Y()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function W(){a(),ce();let B=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(B||re(4,[],[]),J(","),ce(),r.getToken()===2&&ge)break}else B&&re(6,[],[]);A()||re(4,[],[2,5]),B=!0}return R(),r.getToken()!==2?re(7,[2],[]):ce(),!0}function j(){M(),ce();let B=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(B||re(4,[],[]),J(","),ce(),r.getToken()===4&&ge)break}else B&&re(6,[],[]);Y()||re(4,[],[4,5]),B=!0}return q(),r.getToken()!==4?re(8,[4],[]):ce(),!0}function Y(){switch(r.getToken()){case 3:return j();case 1:return W();case 10:return z(!0);default:return F()}}return ce(),r.getToken()===17?t.allowEmptyContent?!0:(re(4,[],[]),!1):Y()?(r.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}e.visit=w;function f(i,n){const t=O(i),r=[];let o,c=0,a;do switch(a=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:c!==a&&r.push(i.substring(c,a)),n!==void 0&&r.push(t.getTokenValue().replace(/[^\r\n]/g,n)),c=t.getPosition();break}while(o!==17);return r.join("")}e.stripComments=f;function s(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),function(){function _(I){const k=[];typeof I=="number"&&k.push("code/timeOrigin",I);function O(h){k.push(h,Date.now())}function P(){const h=[];for(let u=0;u<k.length;u+=2)h.push({name:k[u],startTime:k[u+1]});return h}return{mark:O,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const O of performance.getEntriesByType("mark"))k.push({name:O.name,startTime:Math.round(I+O.startTime)});return k}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function C(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=C(D))}(),function(_,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var D in C)(typeof exports=="object"?exports:_)[D]=C[D]}}(typeof self<"u"?self:this,function(){return function(_){var e={};function C(D){if(e[D])return e[D].exports;var I=e[D]={i:D,l:!1,exports:{}};return _[D].call(I.exports,I,I.exports,C),I.l=!0,I.exports}return C.m=_,C.c=e,C.d=function(D,I,k){C.o(D,I)||Object.defineProperty(D,I,{enumerable:!0,get:k})},C.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},C.t=function(D,I){if(1&I&&(D=C(D)),8&I||4&I&&typeof D=="object"&&D&&D.__esModule)return D;var k=Object.create(null);if(C.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:D}),2&I&&typeof D!="string")for(var O in D)C.d(k,O,function(P){return D[P]}.bind(null,O));return k},C.n=function(D){var I=D&&D.__esModule?function(){return D.default}:function(){return D};return C.d(I,"a",I),I},C.o=function(D,I){return Object.prototype.hasOwnProperty.call(D,I)},C.p="",C(C.s=0)}([function(_,e,C){(function(D){var I;e=_.exports=T,I=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],h=e.src=[],u=0,m=u++;h[m]="0|[1-9]\\d*";var b=u++;h[b]="[0-9]+";var p=u++;h[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=u++;h[y]="("+h[m]+")\\.("+h[m]+")\\.("+h[m]+")";var v=u++;h[v]="("+h[b]+")\\.("+h[b]+")\\.("+h[b]+")";var E=u++;h[E]="(?:"+h[m]+"|"+h[p]+")";var S=u++;h[S]="(?:"+h[b]+"|"+h[p]+")";var l=u++;h[l]="(?:-("+h[E]+"(?:\\."+h[E]+")*))";var g=u++;h[g]="(?:-?("+h[S]+"(?:\\."+h[S]+")*))";var w=u++;h[w]="[0-9A-Za-z-]+";var f=u++;h[f]="(?:\\+("+h[w]+"(?:\\."+h[w]+")*))";var s=u++,i="v?"+h[y]+h[l]+"?"+h[f]+"?";h[s]="^"+i+"$";var n="[v=\\s]*"+h[v]+h[g]+"?"+h[f]+"?",t=u++;h[t]="^"+n+"$";var r=u++;h[r]="((?:<|>)?=?)";var o=u++;h[o]=h[b]+"|x|X|\\*";var c=u++;h[c]=h[m]+"|x|X|\\*";var a=u++;h[a]="[v=\\s]*("+h[c]+")(?:\\.("+h[c]+")(?:\\.("+h[c]+")(?:"+h[l]+")?"+h[f]+"?)?)?";var d=u++;h[d]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[g]+")?"+h[f]+"?)?)?";var R=u++;h[R]="^"+h[r]+"\\s*"+h[a]+"$";var M=u++;h[M]="^"+h[r]+"\\s*"+h[d]+"$";var q=u++;h[q]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var X=u++;h[X]="(?:~>?)";var J=u++;h[J]="(\\s*)"+h[X]+"\\s+",P[J]=new RegExp(h[J],"g");var ie=u++;h[ie]="^"+h[X]+h[a]+"$";var oe=u++;h[oe]="^"+h[X]+h[d]+"$";var Z=u++;h[Z]="(?:\\^)";var ge=u++;h[ge]="(\\s*)"+h[Z]+"\\s+",P[ge]=new RegExp(h[ge],"g");var ce=u++;h[ce]="^"+h[Z]+h[a]+"$";var re=u++;h[re]="^"+h[Z]+h[d]+"$";var z=u++;h[z]="^"+h[r]+"\\s*("+n+")$|^$";var F=u++;h[F]="^"+h[r]+"\\s*("+i+")$|^$";var A=u++;h[A]="(\\s*)"+h[r]+"\\s*("+n+"|"+h[a]+")",P[A]=new RegExp(h[A],"g");var W=u++;h[W]="^\\s*("+h[a]+")\\s+-\\s+("+h[a]+")\\s*$";var j=u++;h[j]="^\\s*("+h[d]+")\\s+-\\s+("+h[d]+")\\s*$";var Y=u++;h[Y]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)I(B,h[B]),P[B]||(P[B]=new RegExp(h[B]));function N(x,H){if(x instanceof T)return x;if(typeof x!="string"||x.length>k||!(H?P[t]:P[s]).test(x))return null;try{return new T(x,H)}catch{return null}}function T(x,H){if(x instanceof T){if(x.loose===H)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof T))return new T(x,H);I("SemVer",x,H),this.loose=H;var K=x.trim().match(H?P[t]:P[s]);if(!K)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var me=+fe;if(me>=0&&me<O)return me}return fe}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}e.parse=N,e.valid=function(x,H){var K=N(x,H);return K?K.version:null},e.clean=function(x,H){var K=N(x.trim().replace(/^[=v]+/,""),H);return K?K.version:null},e.SemVer=T,T.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},T.prototype.toString=function(){return this.version},T.prototype.compare=function(x){return I("SemVer.compare",this.version,this.loose,x),x instanceof T||(x=new T(x,this.loose)),this.compareMain(x)||this.comparePre(x)},T.prototype.compareMain=function(x){return x instanceof T||(x=new T(x,this.loose)),U(this.major,x.major)||U(this.minor,x.minor)||U(this.patch,x.patch)},T.prototype.comparePre=function(x){if(x instanceof T||(x=new T(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var H=0;do{var K=this.prerelease[H],fe=x.prerelease[H];if(I("prerelease compare",H,K,fe),K===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(K===void 0)return-1;if(K!==fe)return U(K,fe)}while(++H)},T.prototype.inc=function(x,H){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,H,K,fe){typeof K=="string"&&(fe=K,K=void 0);try{return new T(x,K).inc(H,fe).version}catch{return null}},e.diff=function(x,H){if(se(x,H))return null;var K=N(x),fe=N(H);if(K.prerelease.length||fe.prerelease.length){for(var me in K)if((me==="major"||me==="minor"||me==="patch")&&K[me]!==fe[me])return"pre"+me;return"prerelease"}for(var me in K)if((me==="major"||me==="minor"||me==="patch")&&K[me]!==fe[me])return me},e.compareIdentifiers=U;var L=/^[0-9]+$/;function U(x,H){var K=L.test(x),fe=L.test(H);return K&&fe&&(x=+x,H=+H),K&&!fe?-1:fe&&!K?1:x<H?-1:x>H?1:0}function V(x,H,K){return new T(x,K).compare(new T(H,K))}function $(x,H,K){return V(x,H,K)>0}function G(x,H,K){return V(x,H,K)<0}function se(x,H,K){return V(x,H,K)===0}function ue(x,H,K){return V(x,H,K)!==0}function pe(x,H,K){return V(x,H,K)>=0}function ve(x,H,K){return V(x,H,K)<=0}function le(x,H,K,fe){var me;switch(H){case"===":typeof x=="object"&&(x=x.version),typeof K=="object"&&(K=K.version),me=x===K;break;case"!==":typeof x=="object"&&(x=x.version),typeof K=="object"&&(K=K.version),me=x!==K;break;case"":case"=":case"==":me=se(x,K,fe);break;case"!=":me=ue(x,K,fe);break;case">":me=$(x,K,fe);break;case">=":me=pe(x,K,fe);break;case"<":me=G(x,K,fe);break;case"<=":me=ve(x,K,fe);break;default:throw new TypeError("Invalid operator: "+H)}return me}function ne(x,H){if(x instanceof ne){if(x.loose===H)return x;x=x.value}if(!(this instanceof ne))return new ne(x,H);I("comparator",x,H),this.loose=H,this.parse(x),this.semver===de?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(x,H){return U(H,x)},e.major=function(x,H){return new T(x,H).major},e.minor=function(x,H){return new T(x,H).minor},e.patch=function(x,H){return new T(x,H).patch},e.compare=V,e.compareLoose=function(x,H){return V(x,H,!0)},e.rcompare=function(x,H,K){return V(H,x,K)},e.sort=function(x,H){return x.sort(function(K,fe){return e.compare(K,fe,H)})},e.rsort=function(x,H){return x.sort(function(K,fe){return e.rcompare(K,fe,H)})},e.gt=$,e.lt=G,e.eq=se,e.neq=ue,e.gte=pe,e.lte=ve,e.cmp=le,e.Comparator=ne;var de={};function ae(x,H){if(x instanceof ae)return x.loose===H?x:new ae(x.raw,H);if(x instanceof ne)return new ae(x.value,H);if(!(this instanceof ae))return new ae(x,H);if(this.loose=H,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function Se(x){return!x||x.toLowerCase()==="x"||x==="*"}function Le(x,H,K,fe,me,De,we,Re,Ie,ke,Ne,Ce,Te){return((H=Se(K)?"":Se(fe)?">="+K+".0.0":Se(me)?">="+K+"."+fe+".0":">="+H)+" "+(Re=Se(Ie)?"":Se(ke)?"<"+(+Ie+1)+".0.0":Se(Ne)?"<"+Ie+"."+(+ke+1)+".0":Ce?"<="+Ie+"."+ke+"."+Ne+"-"+Ce:"<="+Re)).trim()}function Ae(x,H){for(var K=0;K<x.length;K++)if(!x[K].test(H))return!1;if(H.prerelease.length){for(K=0;K<x.length;K++)if(I(x[K].semver),x[K].semver!==de&&x[K].semver.prerelease.length>0){var fe=x[K].semver;if(fe.major===H.major&&fe.minor===H.minor&&fe.patch===H.patch)return!0}return!1}return!0}function Fe(x,H,K){try{H=new ae(H,K)}catch{return!1}return H.test(x)}function xe(x,H,K,fe){var me,De,we,Re,Ie;switch(x=new T(x,fe),H=new ae(H,fe),K){case">":me=$,De=ve,we=G,Re=">",Ie=">=";break;case"<":me=G,De=pe,we=$,Re="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(x,H,fe))return!1;for(var ke=0;ke<H.set.length;++ke){var Ne=H.set[ke],Ce=null,Te=null;if(Ne.forEach(function(Me){Me.semver===de&&(Me=new ne(">=0.0.0")),Ce=Ce||Me,Te=Te||Me,me(Me.semver,Ce.semver,fe)?Ce=Me:we(Me.semver,Te.semver,fe)&&(Te=Me)}),Ce.operator===Re||Ce.operator===Ie||(!Te.operator||Te.operator===Re)&&De(x,Te.semver)||Te.operator===Ie&&we(x,Te.semver))return!1}return!0}ne.prototype.parse=function(x){var H=this.loose?P[z]:P[F],K=x.match(H);if(!K)throw new TypeError("Invalid comparator: "+x);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new T(K[2],this.loose):this.semver=de},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(x){return I("Comparator.test",x,this.loose),this.semver===de||(typeof x=="string"&&(x=new T(x,this.loose)),le(x,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(x,H){if(!(x instanceof ne))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new ae(x.value,H),Fe(this.value,K,H);if(x.operator==="")return K=new ae(this.value,H),Fe(x.semver,K,H);var fe=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),De=this.semver.version===x.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Re=le(this.semver,"<",x.semver,H)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Ie=le(this.semver,">",x.semver,H)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return fe||me||De&&we||Re||Ie},e.Range=ae,ae.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},ae.prototype.toString=function(){return this.range},ae.prototype.parseRange=function(x){var H=this.loose;x=x.trim(),I("range",x,H);var K=H?P[j]:P[W];x=x.replace(K,Le),I("hyphen replace",x),x=x.replace(P[A],"$1$2$3"),I("comparator trim",x,P[A]),x=(x=(x=x.replace(P[J],"$1~")).replace(P[ge],"$1^")).split(/\s+/).join(" ");var fe=H?P[z]:P[F],me=x.split(" ").map(function(De){return function(we,Re){return I("comp",we),we=function(Ie,ke){return Ie.trim().split(/\s+/).map(function(Ne){return function(Ce,Te){I("caret",Ce,Te);var Me=Te?P[re]:P[ce];return Ce.replace(Me,function(Ue,ye,Ee,Pe,be){var Oe;return I("caret",Ce,Ue,ye,Ee,Pe,be),Se(ye)?Oe="":Se(Ee)?Oe=">="+ye+".0.0 <"+(+ye+1)+".0.0":Se(Pe)?Oe=ye==="0"?">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+".0 <"+(+ye+1)+".0.0":be?(I("replaceCaret pr",be),be.charAt(0)!=="-"&&(be="-"+be),Oe=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+be+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+be+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+be+" <"+(+ye+1)+".0.0"):(I("no pr"),Oe=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+" <"+(+ye+1)+".0.0"),I("caret return",Oe),Oe})}(Ne,ke)}).join(" ")}(we,Re),I("caret",we),we=function(Ie,ke){return Ie.trim().split(/\s+/).map(function(Ne){return function(Ce,Te){var Me=Te?P[oe]:P[ie];return Ce.replace(Me,function(Ue,ye,Ee,Pe,be){var Oe;return I("tilde",Ce,Ue,ye,Ee,Pe,be),Se(ye)?Oe="":Se(Ee)?Oe=">="+ye+".0.0 <"+(+ye+1)+".0.0":Se(Pe)?Oe=">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":be?(I("replaceTilde pr",be),be.charAt(0)!=="-"&&(be="-"+be),Oe=">="+ye+"."+Ee+"."+Pe+be+" <"+ye+"."+(+Ee+1)+".0"):Oe=">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0",I("tilde return",Oe),Oe})}(Ne,ke)}).join(" ")}(we,Re),I("tildes",we),we=function(Ie,ke){return I("replaceXRanges",Ie,ke),Ie.split(/\s+/).map(function(Ne){return function(Ce,Te){Ce=Ce.trim();var Me=Te?P[M]:P[R];return Ce.replace(Me,function(Ue,ye,Ee,Pe,be,Oe){I("xRange",Ce,Ue,ye,Ee,Pe,be,Oe);var _e=Se(Ee),Ve=_e||Se(Pe),ze=Ve||Se(be);return ye==="="&&ze&&(ye=""),_e?Ue=ye===">"||ye==="<"?"<0.0.0":"*":ye&&ze?(Ve&&(Pe=0),ze&&(be=0),ye===">"?(ye=">=",Ve?(Ee=+Ee+1,Pe=0,be=0):ze&&(Pe=+Pe+1,be=0)):ye==="<="&&(ye="<",Ve?Ee=+Ee+1:Pe=+Pe+1),Ue=ye+Ee+"."+Pe+"."+be):Ve?Ue=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ze&&(Ue=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),I("xRange return",Ue),Ue})}(Ne,ke)}).join(" ")}(we,Re),I("xrange",we),we=function(Ie,ke){return I("replaceStars",Ie,ke),Ie.trim().replace(P[Y],"")}(we,Re),I("stars",we),we}(De,H)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(De){return!!De.match(fe)})),me=me.map(function(De){return new ne(De,H)})},ae.prototype.intersects=function(x,H){if(!(x instanceof ae))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(fe){return x.set.some(function(me){return me.every(function(De){return fe.intersects(De,H)})})})})},e.toComparators=function(x,H){return new ae(x,H).set.map(function(K){return K.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},ae.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new T(x,this.loose));for(var H=0;H<this.set.length;H++)if(Ae(this.set[H],x))return!0;return!1},e.satisfies=Fe,e.maxSatisfying=function(x,H,K){var fe=null,me=null;try{var De=new ae(H,K)}catch{return null}return x.forEach(function(we){De.test(we)&&(fe&&me.compare(we)!==-1||(me=new T(fe=we,K)))}),fe},e.minSatisfying=function(x,H,K){var fe=null,me=null;try{var De=new ae(H,K)}catch{return null}return x.forEach(function(we){De.test(we)&&(fe&&me.compare(we)!==1||(me=new T(fe=we,K)))}),fe},e.validRange=function(x,H){try{return new ae(x,H).range||"*"}catch{return null}},e.ltr=function(x,H,K){return xe(x,H,"<",K)},e.gtr=function(x,H,K){return xe(x,H,">",K)},e.outside=xe,e.prerelease=function(x,H){var K=N(x,H);return K&&K.prerelease.length?K.prerelease:null},e.intersects=function(x,H,K){return x=new ae(x,K),H=new ae(H,K),x.intersects(H)},e.coerce=function(x){if(x instanceof T)return x;if(typeof x!="string")return null;var H=x.match(P[q]);return H==null?null:N((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,C(1))},function(_,e){var C,D,I=_.exports={};function k(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function P(S){if(C===setTimeout)return setTimeout(S,0);if((C===k||!C)&&setTimeout)return C=setTimeout,setTimeout(S,0);try{return C(S,0)}catch{try{return C.call(null,S,0)}catch{return C.call(this,S,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:k}catch{C=k}try{D=typeof clearTimeout=="function"?clearTimeout:O}catch{D=O}})();var h,u=[],m=!1,b=-1;function p(){m&&h&&(m=!1,h.length?u=h.concat(u):b=-1,u.length&&y())}function y(){if(!m){var S=P(p);m=!0;for(var l=u.length;l;){for(h=u,u=[];++b<l;)h&&h[b].run();b=-1,l=u.length}h=null,m=!1,function(g){if(D===clearTimeout)return clearTimeout(g);if((D===O||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(g);try{D(g)}catch{try{return D.call(null,g)}catch{return D.call(this,g)}}}(S)}}function v(S,l){this.fun=S,this.array=l}function E(){}I.nextTick=function(S){var l=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)l[g-1]=arguments[g];u.push(new v(S,l)),u.length!==1||m||P(y)},v.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=E,I.addListener=E,I.once=E,I.off=E,I.removeListener=E,I.removeAllListeners=E,I.emit=E,I.prependListener=E,I.prependOnceListener=E,I.listeners=function(S){return[]},I.binding=function(S){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(S){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Q[70],ee([0,1]),function(_,e){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class D{constructor(P,h,u){this.level=P,this.key=h,this.value=u,this.forward=[]}}const I=void 0;class k{constructor(P,h=2**16){this.comparator=P,this[C]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(h)|0),this._header=new D(this._maxLevel,I,I)}get size(){return this._size}clear(){this._header=new D(this._maxLevel,I,I)}has(P){return Boolean(k._search(this,P,this.comparator))}get(P){return k._search(this,P,this.comparator)?.value}set(P,h){return k._insert(this,P,h,this.comparator)&&(this._size+=1),this}delete(P){const h=k._delete(this,P,this.comparator);return h&&(this._size-=1),h}forEach(P,h){let u=this._header.forward[0];for(;u;)P.call(h,u.value,u.key,this),u=u.forward[0]}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",h=this._header.forward[0];for(;h;)P+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return P}static _search(P,h,u){let m=P._header;for(let b=P._level-1;b>=0;b--)for(;m.forward[b]&&u(m.forward[b].key,h)<0;)m=m.forward[b];if(m=m.forward[0],m&&u(m.key,h)===0)return m}static _insert(P,h,u,m){const b=[];let p=P._header;for(let y=P._level-1;y>=0;y--){for(;p.forward[y]&&m(p.forward[y].key,h)<0;)p=p.forward[y];b[y]=p}if(p=p.forward[0],p&&m(p.key,h)===0)return p.value=u,!1;{const y=k._randomLevel(P);if(y>P._level){for(let v=P._level;v<y;v++)b[v]=P._header;P._level=y}p=new D(y,h,u);for(let v=0;v<y;v++)p.forward[v]=b[v].forward[v],b[v].forward[v]=p;return!0}}static _randomLevel(P,h=.5){let u=1;for(;Math.random()<h&&u<P._maxLevel;)u+=1;return u}static _delete(P,h,u){const m=[];let b=P._header;for(let p=P._level-1;p>=0;p--){for(;b.forward[p]&&u(b.forward[p].key,h)<0;)b=b.forward[p];m[p]=b}if(b=b.forward[0],!b||u(b.key,h)!==0)return!1;for(let p=0;p<P._level&&m[p].forward[p]===b;p++)m[p].forward[p]=b.forward[p];for(;P._level>0&&P._header.forward[P._level-1]===I;)P._level-=1;return!0}}e.SkipList=k}),define(Q[43],ee([0,1,11,2]),function(_,e,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(f){const s=f;return s?typeof s.read=="function":!1}e.isReadable=I;function k(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=k;function O(f){const s=f;return s?k(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=O;function P(f,s){return new h(f,s)}e.newWriteableStream=P;class h{constructor(s,i){this.reducer=s,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s<"u"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(i=>i(s))}emitError(s){this.listeners.error.length===0?(0,C.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(i=>i(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,i){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(s,i){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const t=n.indexOf(i);t>=0&&n.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(f,s){const i=[];let n;for(;(n=f.read())!==null;)i.push(n);return s(i)}e.consumeReadable=u;function m(f,s,i){const n=[];let t;for(;(t=f.read())!==null&&n.length<i;)n.push(t);return t===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof t<"u"){const r=t;return t=void 0,r}return f.read()}}}e.peekReadable=m;function b(f,s){return new Promise((i,n)=>{const t=[];p(f,{onData:r=>{s&&t.push(r)},onError:r=>{s?n(r):i(void 0)},onEnd:()=>{i(s?s(t):void 0)}})})}e.consumeStream=b;function p(f,s){let i=!1;return f.on("error",n=>{i||s.onError(n)}),f.on("end",()=>{i||s.onEnd()}),f.on("data",n=>{i||s.onData(n)}),(0,D.toDisposable)(()=>i=!0)}e.listenStream=p;function y(f,s){return new Promise((i,n)=>{const t=new D.DisposableStore,r=[],o=d=>{if(r.push(d),r.length>s)return t.dispose(),f.pause(),i({stream:f,buffer:r,ended:!1})},c=d=>n(d),a=()=>i({stream:f,buffer:r,ended:!0});t.add((0,D.toDisposable)(()=>f.removeListener("error",c))),f.on("error",c),t.add((0,D.toDisposable)(()=>f.removeListener("end",a))),f.on("end",a),t.add((0,D.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=y;function v(f,s){const i=P(s);return i.end(f),i}e.toStream=v;function E(){const f=P(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=E;function S(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}e.toReadable=S;function l(f,s,i){const n=P(i);return p(f,{onData:t=>n.write(s.data(t)),onError:t=>n.error(s.error?s.error(t):t),onEnd:()=>n.end()}),n}e.transform=l;function g(f,s,i){let n=!1;return{read:()=>{const t=s.read();return n?t:(n=!0,t!==null?i([f,t]):f)}}}e.prefixedReadable=g;function w(f,s,i){let n=!1;const t=P(i);return p(s,{onData:r=>n?t.write(r):(n=!0,t.write(i([f,r]))),onError:r=>t.error(r),onEnd:()=>{n||(n=!0,t.write(f)),t.end()}}),t}e.prefixedStream=w}),define(Q[14],ee([0,1,43]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer<"u";let I,k;class O{static alloc(d){return D?new O(Buffer.allocUnsafe(d)):new O(new Uint8Array(d))}static wrap(d){return D&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new O(d)}static fromString(d,R){return!(R?.dontUseNodeBuffer||!1)&&D?new O(Buffer.from(d)):(I||(I=new TextEncoder),new O(I.encode(d)))}static fromByteArray(d){const R=O.alloc(d.length);for(let M=0,q=d.length;M<q;M++)R.buffer[M]=d[M];return R}static concat(d,R){if(typeof R>"u"){R=0;for(let X=0,J=d.length;X<J;X++)R+=d[X].byteLength}const M=O.alloc(R);let q=0;for(let X=0,J=d.length;X<J;X++){const ie=d[X];M.set(ie,q),q+=ie.byteLength}return M}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=O.alloc(this.byteLength);return d.set(this),d}toString(){return D?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(d,R){return new O(this.buffer.subarray(d,R))}set(d,R){if(d instanceof O)this.buffer.set(d.buffer,R);else if(d instanceof Uint8Array)this.buffer.set(d,R);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),R);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return u(this.buffer,d)}writeUInt32BE(d,R){m(this.buffer,d,R)}readUInt32LE(d){return b(this.buffer,d)}writeUInt32LE(d,R){p(this.buffer,d,R)}readUInt8(d){return y(this.buffer,d)}writeUInt8(d,R){v(this.buffer,d,R)}}e.VSBuffer=O;function P(a,d){return a[d+0]<<0>>>0|a[d+1]<<8>>>0}e.readUInt16LE=P;function h(a,d,R){a[R+0]=d&255,d=d>>>8,a[R+1]=d&255}e.writeUInt16LE=h;function u(a,d){return a[d]*2**24+a[d+1]*2**16+a[d+2]*2**8+a[d+3]}e.readUInt32BE=u;function m(a,d,R){a[R+3]=d,d=d>>>8,a[R+2]=d,d=d>>>8,a[R+1]=d,d=d>>>8,a[R]=d}e.writeUInt32BE=m;function b(a,d){return a[d+0]<<0>>>0|a[d+1]<<8>>>0|a[d+2]<<16>>>0|a[d+3]<<24>>>0}e.readUInt32LE=b;function p(a,d,R){a[R+0]=d&255,d=d>>>8,a[R+1]=d&255,d=d>>>8,a[R+2]=d&255,d=d>>>8,a[R+3]=d&255}e.writeUInt32LE=p;function y(a,d){return a[d]}e.readUInt8=y;function v(a,d,R){a[R]=d}e.writeUInt8=v;function E(a){return C.consumeReadable(a,d=>O.concat(d))}e.readableToBuffer=E;function S(a){return C.toReadable(a)}e.bufferToReadable=S;function l(a){return C.consumeStream(a,d=>O.concat(d))}e.streamToBuffer=l;async function g(a){return a.ended?O.concat(a.buffer):O.concat([...a.buffer,await l(a.stream)])}e.bufferedStreamToBuffer=g;function w(a){return C.toStream(a,d=>O.concat(d))}e.bufferToStream=w;function f(a){return C.transform(a,{data:d=>typeof d=="string"?O.fromString(d):O.wrap(d)},d=>O.concat(d))}e.streamToBufferReadableStream=f;function s(a){return C.newWriteableStream(d=>O.concat(d),a)}e.newWriteableBufferStream=s;function i(a,d){return C.prefixedReadable(a,d,R=>O.concat(R))}e.prefixedBufferReadable=i;function n(a,d){return C.prefixedStream(a,d,R=>O.concat(R))}e.prefixedBufferStream=n;function t(a){let d=0,R=0,M=0;const q=new Uint8Array(Math.floor(a.length/4*3)),X=ie=>{switch(R){case 3:q[M++]=d|ie,R=0;break;case 2:q[M++]=d|ie>>>2,d=ie<<6,R=3;break;case 1:q[M++]=d|ie>>>4,d=ie<<4,R=2;break;default:d=ie<<2,R=1}};for(let ie=0;ie<a.length;ie++){const oe=a.charCodeAt(ie);if(oe>=65&&oe<=90)X(oe-65);else if(oe>=97&&oe<=122)X(oe-97+26);else if(oe>=48&&oe<=57)X(oe-48+52);else if(oe===43||oe===45)X(62);else if(oe===47||oe===95)X(63);else{if(oe===61)break;throw new SyntaxError(`Unexpected base64 character ${a[ie]}`)}}const J=M;for(;R>0;)X(0);return O.wrap(q).slice(0,J)}e.decodeBase64=t;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:a},d=!0,R=!1){const M=R?o:r;let q="";const X=a.byteLength%3;let J=0;for(;J<a.byteLength-X;J+=3){const ie=a[J+0],oe=a[J+1],Z=a[J+2];q+=M[ie>>>2],q+=M[(ie<<4|oe>>>4)&63],q+=M[(oe<<2|Z>>>6)&63],q+=M[Z&63]}if(X===1){const ie=a[J+0];q+=M[ie>>>2],q+=M[ie<<4&63],d&&(q+="==")}else if(X===2){const ie=a[J+0],oe=a[J+1];q+=M[ie>>>2],q+=M[(ie<<4|oe>>>4)&63],q+=M[oe<<2&63],d&&(q+="=")}return q}e.encodeBase64=c}),define(Q[26],ee([0,1,8]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const g=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([w,f])=>{g[w]=f&&typeof f=="object"?D(f):f}),g}e.deepClone=D;function I(l){if(!l||typeof l!="object")return l;const g=[l];for(;g.length>0;){const w=g.shift();Object.freeze(w);for(const f in w)if(k.call(w,f)){const s=w[f];typeof s=="object"&&!Object.isFrozen(s)&&!(0,C.isTypedArray)(s)&&g.push(s)}}return l}e.deepFreeze=I;const k=Object.prototype.hasOwnProperty;function O(l,g){return P(l,g,new Set)}e.cloneAndChange=O;function P(l,g,w){if((0,C.isUndefinedOrNull)(l))return l;const f=g(l);if(typeof f<"u")return f;if(Array.isArray(l)){const s=[];for(const i of l)s.push(P(i,g,w));return s}if((0,C.isObject)(l)){if(w.has(l))throw new Error("Cannot clone recursive data-structure");w.add(l);const s={};for(const i in l)k.call(l,i)&&(s[i]=P(l[i],g,w));return w.delete(l),s}return l}function h(l,g,w=!0){return(0,C.isObject)(l)?((0,C.isObject)(g)&&Object.keys(g).forEach(f=>{f in l?w&&((0,C.isObject)(l[f])&&(0,C.isObject)(g[f])?h(l[f],g[f],w):l[f]=g[f]):l[f]=g[f]}),l):g}e.mixin=h;function u(l,g){if(l===g)return!0;if(l==null||g===null||g===void 0||typeof l!=typeof g||typeof l!="object"||Array.isArray(l)!==Array.isArray(g))return!1;let w,f;if(Array.isArray(l)){if(l.length!==g.length)return!1;for(w=0;w<l.length;w++)if(!u(l[w],g[w]))return!1}else{const s=[];for(f in l)s.push(f);s.sort();const i=[];for(f in g)i.push(f);if(i.sort(),!u(s,i))return!1;for(w=0;w<s.length;w++)if(!u(l[s[w]],g[s[w]]))return!1}return!0}e.equals=u;function m(l){const g=new Set;return JSON.stringify(l,(w,f)=>{if((0,C.isObject)(f)||Array.isArray(f)){if(g.has(f))return"[Circular]";g.add(f)}return f})}e.safeStringify=m;function b(l,g){const w=Object.create(null);return!l||!g||Object.keys(g).forEach(s=>{const i=l[s],n=g[s];u(i,n)||(w[s]=n)}),w}e.distinct=b;function p(l,g){const w=g.toLowerCase(),f=Object.keys(l).find(s=>s.toLowerCase()===w);return f?l[f]:l[g]}e.getCaseInsensitive=p;function y(l,g){const w=Object.create(null);for(const[f,s]of Object.entries(l))g(f,s)&&(w[f]=s);return w}e.filter=y;function v(l){let g=[],w=Object.getPrototypeOf(l);for(;Object.prototype!==w;)g=g.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return g}e.getAllPropertyNames=v;function E(l){const g=[];for(const w of v(l))typeof l[w]=="function"&&g.push(w);return g}e.getAllMethodNames=E;function S(l,g){const w=s=>function(){const i=Array.prototype.slice.call(arguments,0);return g(s,i)},f={};for(const s of l)f[s]=w(s);return f}e.createProxyObject=S}),define(Q[30],ee([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(I){return C.test(I)}e.isUUID=D,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(P){for(let h=0;h<P.length;h++)P[h]=Math.floor(Math.random()*256);return P};const k=new Uint8Array(16),O=[];for(let P=0;P<256;P++)O.push(P.toString(16).padStart(2,"0"));return function(){I(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let h=0,u="";return u+=O[k[h++]],u+=O[k[h++]],u+=O[k[h++]],u+=O[k[h++]],u+="-",u+=O[k[h++]],u+=O[k[h++]],u+="-",u+=O[k[h++]],u+=O[k[h++]],u+="-",u+=O[k[h++]],u+=O[k[h++]],u+="-",u+=O[k[h++]],u+=O[k[h++]],u+=O[k[h++]],u+=O[k[h++]],u+=O[k[h++]],u+=O[k[h++]],u}}()}),define(Q[71],ee([5,6]),function(_,e){return _.create("vs/base/common/date",e)}),define(Q[72],ee([0,1,71]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,I=D*60,k=I*24,O=k*7,P=k*30,h=k*365;function u(b,p,y){typeof b!="number"&&(b=b.getTime());const v=Math.round((new Date().getTime()-b)/1e3);if(v<-30)return(0,C.localize)(0,null,u(new Date().getTime()+v*1e3,!1));if(v<30)return(0,C.localize)(1,null);let E;return v<D?(E=v,p?E===1?y?(0,C.localize)(2,null,E):(0,C.localize)(3,null,E):y?(0,C.localize)(4,null,E):(0,C.localize)(5,null,E):E===1?y?(0,C.localize)(6,null,E):(0,C.localize)(7,null,E):y?(0,C.localize)(8,null,E):(0,C.localize)(9,null,E)):v<I?(E=Math.floor(v/D),p?E===1?y?(0,C.localize)(10,null,E):(0,C.localize)(11,null,E):y?(0,C.localize)(12,null,E):(0,C.localize)(13,null,E):E===1?y?(0,C.localize)(14,null,E):(0,C.localize)(15,null,E):y?(0,C.localize)(16,null,E):(0,C.localize)(17,null,E)):v<k?(E=Math.floor(v/I),p?E===1?y?(0,C.localize)(18,null,E):(0,C.localize)(19,null,E):y?(0,C.localize)(20,null,E):(0,C.localize)(21,null,E):E===1?y?(0,C.localize)(22,null,E):(0,C.localize)(23,null,E):y?(0,C.localize)(24,null,E):(0,C.localize)(25,null,E)):v<O?(E=Math.floor(v/k),p?E===1?(0,C.localize)(26,null,E):(0,C.localize)(27,null,E):E===1?(0,C.localize)(28,null,E):(0,C.localize)(29,null,E)):v<P?(E=Math.floor(v/O),p?E===1?y?(0,C.localize)(30,null,E):(0,C.localize)(31,null,E):y?(0,C.localize)(32,null,E):(0,C.localize)(33,null,E):E===1?y?(0,C.localize)(34,null,E):(0,C.localize)(35,null,E):y?(0,C.localize)(36,null,E):(0,C.localize)(37,null,E)):v<h?(E=Math.floor(v/P),p?E===1?y?(0,C.localize)(38,null,E):(0,C.localize)(39,null,E):y?(0,C.localize)(40,null,E):(0,C.localize)(41,null,E):E===1?y?(0,C.localize)(42,null,E):(0,C.localize)(43,null,E):y?(0,C.localize)(44,null,E):(0,C.localize)(45,null,E)):(E=Math.floor(v/h),p?E===1?y?(0,C.localize)(46,null,E):(0,C.localize)(47,null,E):y?(0,C.localize)(48,null,E):(0,C.localize)(49,null,E):E===1?y?(0,C.localize)(50,null,E):(0,C.localize)(51,null,E):y?(0,C.localize)(52,null,E):(0,C.localize)(53,null,E))}e.fromNow=u;function m(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=m}),define(Q[73],ee([5,6]),function(_,e){return _.create("vs/base/common/errorMessage",e)}),define(Q[31],ee([0,1,19,8,73]),function(_,e,C,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function k(b,p){return p&&(b.stack||b.stacktrace)?I.localize(0,null,P(b),O(b.stack)||O(b.stacktrace)):P(b)}function O(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?I.localize(1,null,b.message):b.message||I.localize(2,null)}function h(b=null,p=!1){if(!b)return I.localize(3,null);if(Array.isArray(b)){const y=C.coalesce(b),v=h(y[0],p);return y.length>1?I.localize(4,null,v,y.length):v}if(D.isString(b))return b;if(b.detail){const y=b.detail;if(y.error)return k(y.error,p);if(y.exception)return k(y.exception,p)}return b.stack?k(b,p):b.message?b.message:I.localize(5,null)}e.toErrorMessage=h;function u(b){const p=b;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=u;function m(b,p){let y;return typeof b=="string"?y=new Error(b):y=b,y.actions=p,y}e.createErrorWithActions=m}),define(Q[74],ee([5,6]),function(_,e){return _.create("vs/base/common/jsonErrorMessages",e)}),define(Q[75],ee([0,1,74]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function D(I){switch(I){case 1:return(0,C.localize)(0,null);case 2:return(0,C.localize)(1,null);case 3:return(0,C.localize)(2,null);case 4:return(0,C.localize)(3,null);case 5:return(0,C.localize)(4,null);case 6:return(0,C.localize)(5,null);case 7:return(0,C.localize)(6,null);case 8:return(0,C.localize)(7,null);case 9:return(0,C.localize)(8,null);default:return""}}e.getParseErrorMessage=D}),define(Q[51],ee([0,1,12]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var I;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(P,...h){const u=h.reduce((p,y)=>(p[y]=!0,p),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(p=>!u[p]).forEach(p=>{for(let y=0;y<m.length;y++)if(p.search(m[y])!==-1){delete P[p];break}})}e.sanitizeProcessEnvironment=k;function O(P){!P||(delete P.DEBUG,C.isMacintosh&&delete P.DYLD_LIBRARY_PATH,C.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=O}),define(Q[52],ee([0,1,4,2]),function(_,e,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const I=O=>({onDidChange:C.Event.None,value:O});e.staticObservableValue=I;class k extends D.Disposable{get value(){return this._value}set value(P){P!==this._value&&(this._value=P,this.changeEmitter.fire(P))}constructor(P){super(),this._value=P,this.changeEmitter=this._register(new C.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=k}),define(Q[53],ee([0,1,27]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function D(l){return I(l,0)}e.hash=D;function I(l,g){switch(typeof l){case"object":return l===null?k(349,g):Array.isArray(l)?h(l,g):u(l,g);case"string":return P(l,g);case"boolean":return O(l,g);case"number":return k(l,g);case"undefined":return k(937,g);default:return k(617,g)}}e.doHash=I;function k(l,g){return(g<<5)-g+l|0}e.numberHash=k;function O(l,g){return k(l?433:863,g)}function P(l,g){g=k(149417,g);for(let w=0,f=l.length;w<f;w++)g=k(l.charCodeAt(w),g);return g}e.stringHash=P;function h(l,g){return g=k(104579,g),l.reduce((w,f)=>I(f,w),g)}function u(l,g){return g=k(181387,g),Object.keys(l).sort().reduce((w,f)=>(w=P(f,w),I(l[f],w)),g)}class m{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=I(g,this._value),this._value}}e.Hasher=m;var b;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function p(l,g,w=32){const f=w-g,s=~((1<<f)-1);return(l<<g|(s&l)>>>f)>>>0}function y(l,g=0,w=l.byteLength,f=0){for(let s=0;s<w;s++)l[g+s]=f}function v(l,g,w="0"){for(;l.length<g;)l=w+l;return l}function E(l,g=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(w=>w.toString(16).padStart(2,"0")).join(""):v((l>>>0).toString(16),g/4)}e.toHexString=E;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const w=g.length;if(w===0)return;const f=this._buff;let s=this._buffLen,i=this._leftoverHighSurrogate,n,t;for(i!==0?(n=i,t=-1,i=0):(n=g.charCodeAt(0),t=0);;){let r=n;if(C.isHighSurrogate(n))if(t+1<w){const o=g.charCodeAt(t+1);C.isLowSurrogate(o)?(t++,r=C.computeCodePoint(n,o)):r=65533}else{i=n;break}else C.isLowSurrogate(n)&&(r=65533);if(s=this._push(f,s,r),t++,t<w)n=g.charCodeAt(t);else break}this._buffLen=s,this._leftoverHighSurrogate=i}_push(g,w,f){return f<128?g[w++]=f:f<2048?(g[w++]=192|(f&1984)>>>6,g[w++]=128|(f&63)>>>0):f<65536?(g[w++]=224|(f&61440)>>>12,g[w++]=128|(f&4032)>>>6,g[w++]=128|(f&63)>>>0):(g[w++]=240|(f&1835008)>>>18,g[w++]=128|(f&258048)>>>12,g[w++]=128|(f&4032)>>>6,g[w++]=128|(f&63)>>>0),w>=64&&(this._step(),w-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),w}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=S._bigBlock32,w=this._buffDV;for(let a=0;a<64;a+=4)g.setUint32(a,w.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,p(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let f=this._h0,s=this._h1,i=this._h2,n=this._h3,t=this._h4,r,o,c;for(let a=0;a<80;a++)a<20?(r=s&i|~s&n,o=1518500249):a<40?(r=s^i^n,o=1859775393):a<60?(r=s&i|s&n|i&n,o=2400959708):(r=s^i^n,o=3395469782),c=p(f,5)+r+t+o+g.getUint32(a*4,!1)&4294967295,t=n,n=i,i=p(s,30),s=f,f=c;this._h0=this._h0+f&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[54],ee([0,1,27]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(D||(D={})),function(I){const k="error",O="warning",P="warn",h="info",u="ignore";function m(p){return p?C.equalsIgnoreCase(k,p)?I.Error:C.equalsIgnoreCase(O,p)||C.equalsIgnoreCase(P,p)?I.Warning:C.equalsIgnoreCase(h,p)?I.Info:I.Ignore:I.Ignore}I.fromValue=m;function b(p){switch(p){case I.Error:return k;case I.Warning:return O;case I.Info:return h;default:return u}}I.toString=b}(D||(D={})),e.default=D}),define(Q[76],ee([0,1,10]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function D(u){const m=u;return m&&typeof m.type=="string"&&typeof m.severity=="string"}e.isRemoteConsoleLog=D;function I(u){const m=[];let b;try{const p=JSON.parse(u.arguments),y=p[p.length-1];y&&y.__$stack&&(p.pop(),b=y.__$stack),m.push(...p)}catch{m.push("Unable to log remote console arguments",u.arguments)}return{args:m,stack:b}}e.parse=I;function k(u){if(typeof u!="string")return k(I(u).stack);const m=u;if(m){const b=O(m),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(p&&p.length===4)return{uri:C.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=k;function O(u){if(!u)return u;const m=u.indexOf(`
`);return m===-1?u:u.substring(0,m)}function P(u,m){const{args:b,stack:p}=I(u),y=typeof b[0]=="string"&&b.length===1;let v=O(p);v&&(v=`(${v.trim()})`);let E=[];if(typeof b[0]=="string"?v&&y?E=[`%c[${m}] %c${b[0]} %c${v}`,h("blue"),h(""),h("grey")]:E=[`%c[${m}] %c${b[0]}`,h("blue"),h(""),...b.slice(1)]:E=[`%c[${m}]%`,h("blue"),...b],v&&!y&&E.push(v),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,E)}e.log=P;function h(u){return`color: ${u}`}}),define(Q[44],ee([0,1,14,27,10]),function(_,e,C,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(u){return JSON.stringify(u,P)}e.stringify=k;function O(u){let m=JSON.parse(u);return m=h(m),m}e.parse=O;function P(u,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:(0,D.regExpFlags)(m)}:m}function h(u,m=0){if(!u||m>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return I.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 15:return new Date(u.source)}if(u instanceof C.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let b=0;b<u.length;++b)u[b]=h(u[b],m+1);else for(const b in u)Object.hasOwnProperty.call(u,b)&&(u[b]=h(u[b],m+1))}return u}e.revive=h}),define(Q[77],ee([0,1,37,15,20]),function(_,e,C,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,O=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var h;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(h||(h={}));let u;switch(process.arch){case"ia32":case"x32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class b{constructor(s,i,n){this.exePath=s,this.displayName=i,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await I.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:f=!1}={}){return f?u===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:f=!1,findPreview:s=!1}={}){const i=p({useAlternateBitness:f});if(!i)return null;const n=D.join(i,"PowerShell");if(!await I.SymlinkSupport.existsDirectory(n))return null;let t=-1,r=null;for(const a of await I.Promises.readdir(n)){let d=-1;if(s){const M=a.indexOf("-");if(M<0)continue;const q=a.substring(0,M);if(!k.test(q)||a.substring(M+1)!=="preview")continue;d=parseInt(q,10)}else{if(!k.test(a))continue;d=parseInt(a,10)}if(d<=t)continue;const R=D.join(n,a,"pwsh.exe");!await I.SymlinkSupport.existsFile(R)||(r=R,t=d)}if(!r)return null;const o=i.includes("x86")?" (x86)":"",c=s?" Preview":"";return new b(r,`PowerShell${c}${o}`,!0)}async function v({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const s=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await I.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:i,pwshMsixName:n}=f?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const t of await I.Promises.readdir(s))if(i.test(t)){const r=D.join(s,t,"pwsh.exe");return new b(r,n)}return null}function E(){const f=D.join(C.homedir(),".dotnet","tools","pwsh.exe");return new b(f,".NET Core PowerShell Global Tool")}function S(){const f=D.join(process.env.windir,u===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(f,"Windows PowerShell",!0)}async function*l(){let f=await y();f&&(yield f),f=await y({useAlternateBitness:!0}),f&&(yield f),f=await v(),f&&(yield f),f=E(),f&&(yield f),f=await y({findPreview:!0}),f&&(yield f),f=await v({findPreview:!0}),f&&(yield f),f=await y({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=S(),f&&(yield f)}async function*g(){for await(const f of l())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=g;async function w(){for await(const f of g())return f;return null}e.getFirstAvailablePowerShellInstallation=w}),define(Q[55],ee([0,1,15,12,32,51,8,20]),function(_,e,C,D,I,k,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function h(b=I.env){return b.comspec||"cmd.exe"}e.getWindowsShell=h;function u(b){let p=[],y=!1;const v=function(E){if(y){p.push(E);return}(!b.send(E,l=>{if(l&&console.error(l),y=!1,p.length>0){const g=p.slice(0);p=[],g.forEach(w=>v(w))}})||D.isWindows)&&(y=!0)};return{send:v}}e.createQueuedSender=u;var m;(function(b){async function p(y,v,E){if(C.isAbsolute(y))return y;if(v===void 0&&(v=I.cwd()),C.dirname(y)!=="."||(E===void 0&&O.isString(I.env.PATH)&&(E=I.env.PATH.split(C.delimiter)),E===void 0||E.length===0))return C.join(v,y);async function l(g){if(await P.Promises.exists(g)){let w;try{w=await P.Promises.stat(g)}catch(f){f.message.startsWith("EACCES")&&(w=await P.Promises.lstat(g))}return w?!w.isDirectory():!1}return!1}for(const g of E){let w;if(C.isAbsolute(g)?w=C.join(g,y):w=C.join(v,g,y),await l(w))return w;let f=w+".com";if(await l(f)||(f=w+".exe",await l(f)))return f}return C.join(v,y)}b.findExecutable=p})(m=e.win32||(e.win32={}))}),define(Q[78],ee([0,1,37,12,77,55]),function(_,e,C,D,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function O(y,v){return y===1?D.isWindows?b():k.getWindowsShell(v):u(y,v)}e.getSystemShell=O;function P(y,v){return y===1?D.isWindows?p(v):k.getWindowsShell(v):u(y,v)}e.getSystemShellSync=P;let h=null;function u(y,v){if(D.isLinux&&y===2||D.isMacintosh&&y===3)return"/bin/bash";if(!h){let E;if(D.isWindows)E="/bin/bash";else{if(E=v.SHELL,!E)try{E=(0,C.userInfo)().shell}catch{}E||(E="sh"),E==="/bin/false"&&(E="/bin/bash")}h=E}return h}let m=null;async function b(){return m||(m=(await(0,I.getFirstAvailablePowerShellInstallation)()).exePath),m}function p(y){if(m)return m;const v=D.isWindows&&parseFloat((0,C.release)())>=10,E=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${y.windir}\\${E?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return v?S:k.getWindowsShell(y)}});var he=this&&this.__decorate||function(_,e,C,D){var I=arguments.length,k=I<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,C):D,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(_,e,C,D);else for(var P=_.length-1;P>=0;P--)(O=_[P])&&(k=(I<3?O(k):I>3?O(e,C,k):O(e,C))||k);return I>3&&k&&Object.defineProperty(e,C,k),k};define(Q[56],ee([0,1,19,3,14,22,49,11,4,2,44,27,8]),function(_,e,C,D,I,k,O,P,h,u,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var y;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(y||(y={}));function v(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(E||(E={}));function S(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(l||(l={}));class g{constructor(A){this.buffer=A,this.pos=0}read(A){const W=this.buffer.slice(this.pos,this.pos+A);return this.pos+=W.byteLength,W}}class w{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var f;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(f||(f={}));function s(F){const A=I.VSBuffer.alloc(4);return A.writeUInt32BE(F,0),A}function i(F){return F.read(4).readUInt32BE(0)}function n(F){const A=I.VSBuffer.alloc(1);return A.writeUInt8(F,0),A}const t={Undefined:n(f.Undefined),String:n(f.String),Buffer:n(f.Buffer),VSBuffer:n(f.VSBuffer),Array:n(f.Array),Object:n(f.Object)},r=typeof Buffer<"u";function o(F,A){if(typeof A>"u")F.write(t.Undefined);else if(typeof A=="string"){const W=I.VSBuffer.fromString(A);F.write(t.String),F.write(s(W.byteLength)),F.write(W)}else if(r&&Buffer.isBuffer(A)){const W=I.VSBuffer.wrap(A);F.write(t.Buffer),F.write(s(W.byteLength)),F.write(W)}else if(A instanceof I.VSBuffer)F.write(t.VSBuffer),F.write(s(A.byteLength)),F.write(A);else if(Array.isArray(A)){F.write(t.Array),F.write(s(A.length));for(const W of A)o(F,W)}else{const W=I.VSBuffer.fromString(JSON.stringify(A));F.write(t.Object),F.write(s(W.byteLength)),F.write(W)}}function c(F){switch(F.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return F.read(i(F)).toString();case f.Buffer:return F.read(i(F)).buffer;case f.VSBuffer:return F.read(i(F));case f.Array:{const W=i(F),j=[];for(let Y=0;Y<W;Y++)j.push(c(F));return j}case f.Object:return JSON.parse(F.read(i(F)).toString())}}class a{constructor(A,W,j=null,Y=1e3){this.protocol=A,this.ctx=W,this.logger=j,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(A,W){this.channels.set(A,W),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const W=this.send([A.type]);this.logger?.logOutgoing(W,0,1,S(A.type));return}case 201:case 202:case 204:case 203:{const W=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(W,A.id,1,S(A.type),A.data);return}}}send(A,W=void 0){const j=new w;return o(j,A),o(j,W),this.sendBuffer(j.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const W=new g(A),j=c(W),Y=c(W),B=j[0];switch(B){case 100:return this.logger?.logIncoming(A.byteLength,j[1],1,`${v(B)}: ${j[2]}.${j[3]}`,Y),this.onPromise({type:B,id:j[1],channelName:j[2],name:j[3],arg:Y});case 102:return this.logger?.logIncoming(A.byteLength,j[1],1,`${v(B)}: ${j[2]}.${j[3]}`,Y),this.onEventListen({type:B,id:j[1],channelName:j[2],name:j[3],arg:Y});case 101:return this.logger?.logIncoming(A.byteLength,j[1],1,`${v(B)}`),this.disposeActiveRequest({type:B,id:j[1]});case 103:return this.logger?.logIncoming(A.byteLength,j[1],1,`${v(B)}`),this.disposeActiveRequest({type:B,id:j[1]})}}onPromise(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const j=new k.CancellationTokenSource;let Y;try{Y=W.call(this.ctx,A.name,A.arg,j.token)}catch(T){Y=Promise.reject(T)}const B=A.id;Y.then(T=>{this.sendResponse({id:B,data:T,type:201}),this.activeRequests.delete(A.id)},T=>{T instanceof Error?this.sendResponse({id:B,data:{message:T.message,name:T.name,stack:T.stack?T.stack.split?T.stack.split(`
`):T.stack:void 0},type:202}):this.sendResponse({id:B,data:T,type:203}),this.activeRequests.delete(A.id)});const N=(0,u.toDisposable)(()=>j.cancel());this.activeRequests.set(A.id,N)}onEventListen(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const j=A.id,B=W.listen(this.ctx,A.name,A.arg)(N=>this.sendResponse({id:j,data:N,type:204}));this.activeRequests.set(A.id,B)}disposeActiveRequest(A){const W=this.activeRequests.get(A.id);W&&(W.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let W=this.pendingRequests.get(A.channelName);W||(W=[],this.pendingRequests.set(A.channelName,W));const j=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:A,timeoutTimer:j})}flushPendingRequests(A){const W=this.pendingRequests.get(A);if(W){for(const j of W)switch(clearTimeout(j.timeoutTimer),j.request.type){case 100:this.onPromise(j.request);break;case 102:this.onEventListen(j.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,u.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var d;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(A,W=null){this.protocol=A,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(j=>this.onBuffer(j)),this.logger=W}getChannel(A){const W=this;return{call(j,Y,B){return W.isDisposed?Promise.reject(new P.CancellationError):W.requestPromise(A,j,Y,B)},listen(j,Y){return W.isDisposed?h.Event.None:W.requestEvent(A,j,Y)}}}requestPromise(A,W,j,Y=k.CancellationToken.None){const B=this.lastRequestId++,T={id:B,type:100,channelName:A,name:W,arg:j};if(Y.isCancellationRequested)return Promise.reject(new P.CancellationError);let L;return new Promise((V,$)=>{if(Y.isCancellationRequested)return $(new P.CancellationError);const G=()=>{const ve=le=>{switch(le.type){case 201:this.handlers.delete(B),V(le.data);break;case 202:{this.handlers.delete(B);const ne=new Error(le.data.message);ne.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,ne.name=le.data.name,$(ne);break}case 203:this.handlers.delete(B),$(le.data);break}};this.handlers.set(B,ve),this.sendRequest(T)};let se=null;this.state===l.Idle?G():(se=(0,D.createCancelablePromise)(ve=>this.whenInitialized()),se.then(()=>{se=null,G()}));const ue=()=>{se?(se.cancel(),se=null):this.sendRequest({id:B,type:101}),$(new P.CancellationError)},pe=Y.onCancellationRequested(ue);L=(0,u.combinedDisposable)((0,u.toDisposable)(ue),pe),this.activeRequests.add(L)}).finally(()=>{this.activeRequests.delete(L)})}requestEvent(A,W,j){const Y=this.lastRequestId++,N={id:Y,type:102,channelName:A,name:W,arg:j};let T=null;const L=new h.Emitter({onWillAddFirstListener:()=>{T=(0,D.createCancelablePromise)(V=>this.whenInitialized()),T.then(()=>{T=null,this.activeRequests.add(L),this.sendRequest(N)})},onDidRemoveLastListener:()=>{T?(T.cancel(),T=null):(this.activeRequests.delete(L),this.sendRequest({id:Y,type:103}))}}),U=V=>L.fire(V.data);return this.handlers.set(Y,U),L.event}sendRequest(A){switch(A.type){case 100:case 102:{const W=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(W,A.id,0,`${v(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const W=this.send([A.type,A.id]);this.logger?.logOutgoing(W,A.id,0,v(A.type));return}}}send(A,W=void 0){const j=new w;return o(j,A),o(j,W),this.sendBuffer(j.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const W=new g(A),j=c(W),Y=c(W),B=j[0];switch(B){case 200:return this.logger?.logIncoming(A.byteLength,0,0,S(B)),this.onResponse({type:j[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,j[1],0,S(B),Y),this.onResponse({type:j[0],id:j[1],data:Y})}}onResponse(A){if(A.type===200){this.state=l.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,u.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}he([O.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class M{get connections(){const A=[];return this._connections.forEach(W=>A.push(W)),A}constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:W,onDidClientDisconnect:j})=>{h.Event.once(W.onMessage)(B=>{const N=new g(B),T=c(N),L=new a(W,T),U=new R(W);this.channels.forEach(($,G)=>L.registerChannel(G,$));const V={channelServer:L,channelClient:U,ctx:T};this._connections.add(V),this._onDidAddConnection.fire(V),j(()=>{L.dispose(),U.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}getChannel(A,W){const j=this;return{call(Y,B,N){let T;if((0,p.isFunction)(W)){const U=(0,C.getRandomElement)(j.connections.filter(W));T=U?Promise.resolve(U):h.Event.toPromise(h.Event.filter(j.onDidAddConnection,W))}else T=W.routeCall(j,Y,B);const L=T.then(U=>U.channelClient.getChannel(A));return X(L).call(Y,B,N)},listen(Y,B){if((0,p.isFunction)(W))return j.getMulticastEvent(A,W,Y,B);const N=W.routeEvent(j,Y,B).then(T=>T.channelClient.getChannel(A));return X(N).listen(Y,B)}}}getMulticastEvent(A,W,j,Y){const B=this;let N=new u.DisposableStore;const T=new h.Emitter({onWillAddFirstListener:()=>{N=new u.DisposableStore;const L=new h.EventMultiplexer,U=new Map,V=G=>{const ue=G.channelClient.getChannel(A).listen(j,Y),pe=L.add(ue);U.set(G,pe)},$=G=>{const se=U.get(G);!se||(se.dispose(),U.delete(G))};B.connections.filter(W).forEach(V),h.Event.filter(B.onDidAddConnection,W)(V,void 0,N),B.onDidRemoveConnection($,void 0,N),L.event(T.fire,T,N),N.add(L)},onDidRemoveLastListener:()=>{N.dispose()}});return T.event}registerChannel(A,W){this.channels.set(A,W),this._connections.forEach(j=>{j.channelServer.registerChannel(A,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=M;class q{constructor(A,W,j=null){const Y=new w;o(Y,W),A.send(Y.buffer),this.channelClient=new R(A,j),this.channelServer=new a(A,W,j)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,W){this.channelServer.registerChannel(A,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=q;function X(F){return{call(A,W,j){return F.then(Y=>Y.call(A,W,j))},listen(A,W){const j=new h.Relay;return F.then(Y=>j.input=Y.listen(A,W)),j.event}}}e.getDelayedChannel=X;function J(F){let A=!1;return{call(W,j,Y){return A?F.call(W,j,Y):(0,D.timeout)(0).then(()=>A=!0).then(()=>F.call(W,j,Y))},listen(W,j){if(A)return F.listen(W,j);const Y=new h.Relay;return(0,D.timeout)(0).then(()=>A=!0).then(()=>Y.input=F.listen(W,j)),Y.event}}}e.getNextTickChannel=J;class ie{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const W of A.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await h.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=ie;var oe;(function(F){function A(B,N){const T=B,L=N&&N.disableMarshalling,U=new Map;for(const V in T)j(V)&&U.set(V,h.Event.buffer(T[V],!0));return new class{listen(V,$,G){const se=U.get($);if(se)return se;if(Y($)){const ue=T[$];if(typeof ue=="function")return ue.call(T,G)}throw new Error(`Event not found: ${$}`)}call(V,$,G){const se=T[$];if(typeof se=="function"){if(!L&&Array.isArray(G))for(let ue=0;ue<G.length;ue++)G[ue]=(0,m.revive)(G[ue]);return se.apply(T,G)}throw new Error(`Method not found: ${$}`)}}}F.fromService=A;function W(B,N){const T=N&&N.disableMarshalling;return new Proxy({},{get(L,U){if(typeof U=="string")return N?.properties?.has(U)?N.properties.get(U):Y(U)?function(V){return B.listen(U,V)}:j(U)?B.listen(U):async function(...V){let $;N&&!(0,p.isUndefinedOrNull)(N.context)?$=[N.context,...V]:$=V;const G=await B.call(U,$);return T?G:(0,m.revive)(G)};throw new Error(`Property not found: ${String(U)}`)}})}F.toService=W;function j(B){return B[0]==="o"&&B[1]==="n"&&b.isUpperAsciiLetter(B.charCodeAt(2))}function Y(B){return/^onDynamic/.test(B)&&b.isUpperAsciiLetter(B.charCodeAt(9))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){const A=F.toString();if(A!=="[object Object]")return A}return F}function ce(F){return Array.isArray(F)?F.map(ge):ge(F)}function re(F,A,W,j,Y,B,N){N=ce(N);const T=Z[Y],L=T[j%T.length];let U=[`%c[${F}]%c[${String(A).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(j).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${L}`];/\($/.test(B)?(U=U.concat(N),U.push(")")):U.push(N),console.log.apply(console,U)}class z{constructor(A,W){this._outgoingPrefix=A,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,W,j,Y,B){this._totalOutgoing+=A,re(this._outgoingPrefix,this._totalOutgoing,A,W,j,Y,B)}logIncoming(A,W,j,Y,B){this._totalIncoming+=A,re(this._incomingPrefix,this._totalIncoming,A,W,j,Y,B)}}e.IPCLogger=z}),define(Q[79],ee([0,1,57,3,14,22,76,11,4,2,26,55,51,56]),function(_,e,C,D,I,k,O,P,h,u,m,b,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class v extends y.ChannelServer{constructor(l){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",g=>I.VSBuffer.wrap(Buffer.from(g,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=v;class E{constructor(l,g){this.modulePath=l,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new D.Delayer(w),this.child=null,this._client=null}getChannel(l){const g=this;return{call(w,f,s){return g.requestPromise(l,w,f,s)},listen(w,f){return g.requestEvent(l,w,f)}}}requestPromise(l,g,w,f=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(l),i=(0,D.createCancelablePromise)(r=>s.call(g,w,r)),n=f.onCancellationRequested(()=>i.cancel()),t=(0,u.toDisposable)(()=>i.cancel());return this.activeRequests.add(t),i.finally(()=>{n.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(l,g,w){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let f;const s=new h.Emitter({onWillAddFirstListener:()=>{f=this.getCachedChannel(l).listen(g,w)(s.fire,s),this.activeRequests.add(f)},onDidRemoveLastListener:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,m.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,p.removeDangerousEnvVariables)(g.env),this.child=(0,C.fork)(this.modulePath,l,g);const w=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,O.isRemoteConsoleLog)(o)){(0,O.log)(o,`IPC Library: ${this.options.serverName}`);return}w.fire(I.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,i=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),n=w.event,t={send:i,onMessage:n};this._client=new y.ChannelClient(t);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,c)=>{process.removeListener("exit",r),this.activeRequests.forEach(a=>(0,u.dispose)(a)),this.activeRequests.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:c})})}return this._client}getCachedChannel(l){let g=this.channels.get(l);return g||(g=this.client.getChannel(l),this.channels.set(l,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=E}),define(Q[80],ee([0,1,3,4,2,8]),function(_,e,C,D,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var O;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(O=e.StorageHint||(e.StorageHint={}));function P(b){const p=b;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var h;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(h=e.StorageState||(e.StorageState={}));class u extends I.Disposable{constructor(p,y=Object.create(null)){super(),this.database=p,this.options=y,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=h.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(u.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((y,v)=>this.accept(v,y)),p.deleted?.forEach(y=>this.accept(y,void 0))}accept(p,y){if(this.state===h.Closed)return;let v=!1;(0,k.isUndefinedOrNull)(y)?v=this.cache.delete(p):this.cache.get(p)!==y&&(this.cache.set(p,y),v=!0),v&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===h.None&&(this.state=h.Initialized,this.options.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,y){const v=this.cache.get(p);return(0,k.isUndefinedOrNull)(v)?y:v}getBoolean(p,y){const v=this.get(p);return(0,k.isUndefinedOrNull)(v)?y:v==="true"}getNumber(p,y){const v=this.get(p);return(0,k.isUndefinedOrNull)(v)?y:parseInt(v,10)}async set(p,y){if(this.state===h.Closed)return;if((0,k.isUndefinedOrNull)(y))return this.delete(p);const v=String(y);if(this.cache.get(p)!==v)return this.cache.set(p,v),this.pendingInserts.set(p,v),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async delete(p){if(!(this.state===h.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=h.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(p){if(!!this.hasPending)return this.doFlush(p)}async doFlush(p){return this.flushDelayer.trigger(()=>this.flushPending(),p)}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=u,u.DEFAULT_FLUSH_DELAY=100;class m{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert?.forEach((y,v)=>this.items.set(v,y)),p.delete?.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=m}),define(Q[81],ee([5,6]),function(_,e){return _.create("vs/base/node/zip",e)}),define(Q[82],ee([5,6]),function(_,e){return _.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[83],ee([5,6]),function(_,e){return _.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Q[84],ee([5,6]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[85],ee([5,6]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Q[86],ee([5,6]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Q[87],ee([5,6]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Q[88],ee([5,6]),function(_,e){return _.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Q[89],ee([5,6]),function(_,e){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Q[90],ee([5,6]),function(_,e){return _.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[91],ee([5,6]),function(_,e){return _.create("vs/platform/files/common/fileService",e)}),define(Q[92],ee([5,6]),function(_,e){return _.create("vs/platform/files/common/io",e)}),define(Q[93],ee([5,6]),function(_,e){return _.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[94],ee([5,6]),function(_,e){return _.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Q[95],ee([5,6]),function(_,e){return _.create("vs/platform/request/common/request",e)}),define(Q[96],ee([5,6]),function(_,e){return _.create("vs/platform/shell/node/shellEnv",e)}),define(Q[97],ee([5,6]),function(_,e){return _.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[98],ee([5,6]),function(_,e){return _.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Q[99],ee([5,6]),function(_,e){return _.create("vs/platform/workspace/common/workspace",e)}),define(Q[100],ee([0,1,72,49,16,15,32,17,10]),function(_,e,C,D,I,k,O,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class u{get appRoot(){return(0,k.dirname)(I.FileAccess.asFileUri("",_).fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const E=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",E)}return this.args.logsPath}get userDataSyncLogResource(){return h.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return h.URI.file((0,k.join)(this.logsPath,"editSessions.log"))}get remoteTunnelLogResource(){return h.URI.file((0,k.join)(this.logsPath,"remoteTunnel.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(h.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const E=O.env.VSCODE_PORTABLE;return E?h.URI.file((0,k.join)(E,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const E=this.args["builtin-extensions-dir"];return E?(0,k.resolve)(E):(0,k.normalize)((0,k.join)(I.FileAccess.asFileUri("",_).fsPath,"..","extensions"))}get extensionsDownloadLocation(){const E=this.args["extensions-download-dir"];return E?h.URI.file((0,k.resolve)(E)):h.URI.file((0,k.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const E=this.args["extensions-dir"];if(E)return(0,k.resolve)(E);const S=O.env.VSCODE_EXTENSIONS;if(S)return S;const l=O.env.VSCODE_PORTABLE;return l?(0,k.join)(l,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const E=this.args.extensionDevelopmentPath;if(Array.isArray(E))return E.map(S=>/^[^:/?#]+?:\/\//.test(S)?h.URI.parse(S):h.URI.file((0,k.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(E=>E==="ui"||E==="workspace"||E==="web"?E:"workspace")}get extensionTestsLocationURI(){const E=this.args.extensionTestsPath;if(E)return/^[^:/?#]+?:\/\//.test(E)?h.URI.parse(E):h.URI.file((0,k.normalize)(E))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const E=this.args["disable-extension"];if(E){if(typeof E=="string")return[E];if(Array.isArray(E)&&E.length>0)return E}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(E=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(E))}get extensionLogLevel(){const E=[];for(const S of this.args.log||[]){const l=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(S);l&&l[1]&&l[2]&&E.push([l[1],l[2]])}return E.length?E:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return h.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const E=O.env.VSCODE_PORTABLE;return E?h.URI.file((0,k.join)(E,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(E){this.args.continueOn=E}get args(){return this._args}constructor(E,S,l){this._args=E,this.paths=S,this.productService=l,this.editSessionId=this.args.editSessionId}}he([D.memoize],u.prototype,"appRoot",null),he([D.memoize],u.prototype,"userHome",null),he([D.memoize],u.prototype,"userDataPath",null),he([D.memoize],u.prototype,"appSettingsHome",null),he([D.memoize],u.prototype,"tmpDir",null),he([D.memoize],u.prototype,"cacheHome",null),he([D.memoize],u.prototype,"stateResource",null),he([D.memoize],u.prototype,"userRoamingDataHome",null),he([D.memoize],u.prototype,"userDataSyncHome",null),he([D.memoize],u.prototype,"userDataSyncLogResource",null),he([D.memoize],u.prototype,"editSessionsLogResource",null),he([D.memoize],u.prototype,"remoteTunnelLogResource",null),he([D.memoize],u.prototype,"sync",null),he([D.memoize],u.prototype,"machineSettingsResource",null),he([D.memoize],u.prototype,"workspaceStorageHome",null),he([D.memoize],u.prototype,"localHistoryHome",null),he([D.memoize],u.prototype,"keyboardLayoutResource",null),he([D.memoize],u.prototype,"argvResource",null),he([D.memoize],u.prototype,"isExtensionDevelopment",null),he([D.memoize],u.prototype,"untitledWorkspacesHome",null),he([D.memoize],u.prototype,"installSourcePath",null),he([D.memoize],u.prototype,"builtinExtensionsPath",null),he([D.memoize],u.prototype,"extensionsPath",null),he([D.memoize],u.prototype,"extensionDevelopmentLocationURI",null),he([D.memoize],u.prototype,"extensionDevelopmentKind",null),he([D.memoize],u.prototype,"extensionTestsLocationURI",null),he([D.memoize],u.prototype,"debugExtensionHost",null),he([D.memoize],u.prototype,"logLevel",null),he([D.memoize],u.prototype,"extensionLogLevel",null),he([D.memoize],u.prototype,"serviceMachineIdResource",null),he([D.memoize],u.prototype,"telemetryLogResource",null),he([D.memoize],u.prototype,"disableWorkspaceTrust",null),he([D.memoize],u.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=u;function m(v,E){return y(v["inspect-extensions"],v["inspect-brk-extensions"],5870,E,v.debugId,v.extensionEnvironment)}e.parseExtensionHostPort=m;function b(v,E){return y(v["inspect-search"],v["inspect-brk-search"],5876,E,v.extensionEnvironment)}e.parseSearchPort=b;function p(v,E){return y(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,E,v.extensionEnvironment)}e.parsePtyHostPort=p;function y(v,E,S,l,g,w){const s=Number(E||v)||(l?null:S),i=s?Boolean(!!E):!1;let n;if(w)try{n=JSON.parse(w)}catch{}return{port:s,break:i,debugId:g,env:n}}}),function(){"use strict";function _(e,C,D){function I(O,P){const h=k(O,P),u=[h];return e.isAbsolute(h)||u.unshift(D),e.resolve(...u)}function k(O,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,P);const m=O["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(b,"AppData","Roaming")}break;case"darwin":u=e.join(C.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,P)}return{getUserDataPath:I}}if(typeof define=="function")define(Q[101],ee([151,37,32]),function(e,C,D){return _(e,C,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),C=require("os");module.exports=_(e,C,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[102],ee([0,1,37,100,101]),function(_,e,C,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends D.AbstractNativeEnvironmentService{constructor(P,h){super(P,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,I.getUserDataPath)(P,h.nameShort)},h)}}e.NativeEnvironmentService=k}),define(Q[103],ee([0,1,8,86]),function(_,e,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function I(O,P,h){try{k(O,P,h)}catch(u){console.error(u?.message??u)}return O}e.localizeManifest=I;function k(O,P,h){const u=(m,b,p)=>{const y=m[b];if((0,C.isString)(y)){const v=y,E=v.length;if(E>1&&v[0]==="%"&&v[E-1]==="%"){const S=v.substr(1,E-2);let l=P[S];l===void 0&&h&&(l=h[S]);const g=typeof l=="string"?l:l?.message,w=h?.[S],f=typeof w=="string"?w:w?.message;if(!g){f||console.warn(`[${O.name}]: ${(0,D.localize)(0,null,S)}`);return}if(p&&(b==="title"||b==="category")&&f&&f!==g){const s={value:g,original:f};m[b]=s}else m[b]=g}}else if((0,C.isObject)(y))for(const v in y)y.hasOwnProperty(v)&&(v==="commands"?u(y,v,!0):u(y,v,p));else if(Array.isArray(y))for(let v=0;v<y.length;v++)u(y,v,p)};for(const m in O)O.hasOwnProperty(m)&&u(O,m)}}),define(Q[45],ee([0,1,17,54,90,38]),function(_,e,C,D,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function h(l){return l=l.trim(),l==="*"||O.test(l)}e.isValidVersionStr=h;function u(l){if(!h(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=l.match(O);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=u;function m(l){if(!l)return null;const g=l.majorBase,w=l.majorMustEqual,f=l.minorBase;let s=l.minorMustEqual;const i=l.patchBase;let n=l.patchMustEqual;l.hasCaret&&(g===0||(s=!1),n=!1);let t=0;if(l.preRelease){const r=P.exec(l.preRelease);if(r){const[,o,c,a]=r;t=Date.UTC(Number(o),Number(c)-1,Number(a))}}return{majorBase:g,majorMustEqual:w,minorBase:f,minorMustEqual:s,patchBase:i,patchMustEqual:n,isMinimum:l.hasGreaterEquals,notBefore:t}}e.normalizeVersion=m;function b(l,g,w){let f;typeof l=="string"?f=m(u(l)):f=l;let s;g instanceof Date?s=g.getTime():typeof g=="string"&&(s=new Date(g).getTime());let i;if(typeof w=="string"?i=m(u(w)):i=w,!f||!i)return!1;const n=f.majorBase,t=f.minorBase,r=f.patchBase;let o=i.majorBase,c=i.minorBase,a=i.patchBase;const d=i.notBefore;let R=i.majorMustEqual,M=i.minorMustEqual,q=i.patchMustEqual;return i.isMinimum?n>o?!0:n<o?!1:t>c?!0:t<c||s&&s<d?!1:r>=a:(n===1&&o===0&&(!R||!M||!q)&&(o=1,c=0,a=0,R=!0,M=!1,q=!1),n<o?!1:n>o?!R:t<c?!1:t>c?!M:r<a?!1:r>a?!q:!(s&&s<d))}e.isValidVersion=b;function p(l,g,w,f,s){const i=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return i.push([D.default.Error,I.localize(0,null)]),i;if(typeof f.name!="string")return i.push([D.default.Error,I.localize(1,null,"name")]),i;if(typeof f.version!="string")return i.push([D.default.Error,I.localize(2,null,"version")]),i;if(!f.engines)return i.push([D.default.Error,I.localize(3,null,"engines")]),i;if(typeof f.engines.vscode!="string")return i.push([D.default.Error,I.localize(4,null,"engines.vscode")]),i;if(typeof f.extensionDependencies<"u"&&!S(f.extensionDependencies))return i.push([D.default.Error,I.localize(5,null,"extensionDependencies")]),i;if(typeof f.activationEvents<"u"){if(!S(f.activationEvents))return i.push([D.default.Error,I.localize(6,null,"activationEvents")]),i;if(typeof f.main>"u"&&typeof f.browser>"u")return i.push([D.default.Error,I.localize(7,null,"activationEvents","main")]),i}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&i.push([D.default.Warning,I.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return i.push([D.default.Error,I.localize(9,null,"main")]),i;{const r=(0,C.joinPath)(w,f.main);(0,C.isEqualOrParent)(r,w)||i.push([D.default.Warning,I.localize(10,null,r.path,w.path)])}if(typeof f.activationEvents>"u")return i.push([D.default.Error,I.localize(11,null,"activationEvents","main")]),i}if(typeof f.browser<"u"){if(typeof f.browser!="string")return i.push([D.default.Error,I.localize(12,null,"browser")]),i;{const r=(0,C.joinPath)(w,f.browser);(0,C.isEqualOrParent)(r,w)||i.push([D.default.Warning,I.localize(13,null,r.path,w.path)])}if(typeof f.activationEvents>"u")return i.push([D.default.Error,I.localize(14,null,"activationEvents","browser")]),i}if(!k.valid(f.version))return i.push([D.default.Error,I.localize(15,null)]),i;const n=[];if(!y(l,g,f,s,n))for(const r of n)i.push([D.default.Error,r]);return i}e.validateExtensionManifest=p;function y(l,g,w,f,s){return f||typeof w.main>"u"&&typeof w.browser>"u"?!0:E(l,g,w.engines.vscode,s)}e.isValidExtensionVersion=y;function v(l,g,w){return l==="*"||E(g,w,l)}e.isEngineValid=v;function E(l,g,w,f=[]){const s=m(u(w));if(!s)return f.push(I.localize(16,null,w)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return f.push(I.localize(17,null,w)),!1}else if(!s.majorMustEqual)return f.push(I.localize(18,null,w)),!1;return b(l,g,s)?!0:(f.push(I.localize(19,null,l,w)),!1)}function S(l){if(!Array.isArray(l))return!1;for(let g=0,w=l.length;g<w;g++)if(typeof l[g]!="string")return!1;return!0}}),define(Q[104],ee([0,1,14,30]),function(_,e,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function I(k,O,P){let h=P&&P.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const m=(await O.readFile(k.serviceMachineIdResource)).value.toString();h=(0,D.isUUID)(m)?m:null}catch{h=null}if(!h){h=(0,D.generateUuid)();try{await O.writeFile(k.serviceMachineIdResource,C.VSBuffer.fromString(h))}catch{}}return P?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=I}),define(Q[46],ee([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class C{constructor(I,k=[],O=!1){this.ctor=I,this.staticArguments=k,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=C}),define(Q[105],ee([0,1,46]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const D=[];var I;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(I=e.InstantiationType||(e.InstantiationType={}));function k(P,h,u){h instanceof C.SyncDescriptor||(h=new C.SyncDescriptor(h,[],Boolean(u))),D.push([P,h])}e.registerSingleton=k;function O(){return D}e.getSingletonServiceDescriptors=O}),define(Q[106],ee([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class C{constructor(k,O){this.key=k,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.Node=C;class D{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(const O of this._nodes.values())O.outgoing.size===0&&k.push(O);return k}insertEdge(k,O){const P=this.lookupOrInsertNode(k),h=this.lookupOrInsertNode(O);P.outgoing.set(h.key,h),h.incoming.set(P.key,P)}removeNode(k){const O=this._hashFn(k);this._nodes.delete(O);for(const P of this._nodes.values())P.outgoing.delete(O),P.incoming.delete(O)}lookupOrInsertNode(k){const O=this._hashFn(k);let P=this._nodes.get(O);return P||(P=new C(O,k),this._nodes.set(O,P)),P}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){const k=[];for(const[O,P]of this._nodes)k.push(`${O}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,O]of this._nodes){const P=new Set([k]),h=this._findCycle(O,P);if(h)return h}}_findCycle(k,O){for(const[P,h]of k.outgoing){if(O.has(P))return[...O,P].join(" -> ");O.add(P);const u=this._findCycle(h,O);if(u)return u;O.delete(P)}}}e.Graph=D}),define(Q[21],ee([0,1,8,10,7]),function(_,e,C,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function k(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof D.URI)}e.isConfigurationOverrides=k;function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof D.URI)}e.isConfigurationUpdateOverrides=O;var P;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function h(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function u(l,g){const w=Object.create(null);for(const f in l)m(w,f,l[f],g);return w}e.toValuesTree=u;function m(l,g,w,f){const s=g.split("."),i=s.pop();let n=l;for(let t=0;t<s.length;t++){const r=s[t];let o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:f(`Ignoring ${g} as ${s.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[i]=w}catch{f(`Ignoring ${g} as ${s.join(".")} is ${JSON.stringify(n)}`)}else f(`Ignoring ${g} as ${s.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=m;function b(l,g){const w=g.split(".");p(l,w)}e.removeFromValueTree=b;function p(l,g){const w=g.shift();if(g.length===0){delete l[w];return}if(Object.keys(l).indexOf(w)!==-1){const f=l[w];typeof f=="object"&&!Array.isArray(f)&&(p(f,g),Object.keys(f).length===0&&delete l[w])}}function y(l,g,w){function f(n,t){let r=n;for(const o of t){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=g.split("."),i=f(l,s);return typeof i>"u"?w:i}e.getConfigurationValue=y;function v(l,g,w){Object.keys(g).forEach(f=>{f!=="__proto__"&&(f in l?C.isObject(l[f])&&C.isObject(g[f])?v(l[f],g[f],w):w&&(l[f]=g[f]):l[f]=g[f])})}e.merge=v;function E(l,g,w){const f=l.inspect(g),s=l.inspect(w);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof s.userValue<"u"||typeof s.workspaceValue<"u"||typeof s.workspaceFolderValue<"u"?s.value:f.defaultValue}e.getMigratedSettingValue=E;function S(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=S}),define(Q[58],ee([0,1,7]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,C.createDecorator)("downloadService")}),define(Q[18],ee([0,1,7]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,C.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,C.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[23],ee([0,1,84,7]),function(_,e,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.DEFAULT_PROFILE_EXTENSIONS_MIGRATION_KEY="DEFAULT_PROFILE_EXTENSIONS_MIGRATION";function I(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function k(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function O(l,g){switch(l){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=O;function P(l,g){return g==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function h(l,g,w){return P(g,w)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===w?!0:u(w).includes(l)}e.isTargetPlatformCompatible=h;function u(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=u;function m(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=m;var b;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var p;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var y;(function(l){l.Install="install",l.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var v;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var E;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(E=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class S extends Error{constructor(g,w){super(g),this.code=w,this.name=w}}e.ExtensionManagementError=S,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,C.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,C.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Q[59],ee([0,1,7]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,C.createDecorator)("IExtensionSignatureVerificationService");class D{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((k,O)=>_(["node-vsce-sign"],async P=>k(P),O))),this.moduleLoadingPromise}async verify(k,O){let P;try{P=await this.vsceSign()}catch{return!1}return P.verify(k,O)}}e.ExtensionSignatureVerificationService=D}),define(Q[60],ee([0,1,14,11,92,13]),function(_,e,C,D,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function O(m,b,p,y,v,E){let S;try{await P(m,b,p,y,v,E)}catch(l){S=l}finally{S&&v.errorTransformer&&(S=v.errorTransformer(S)),typeof S<"u"&&p.error(S),p.end()}}e.readFileIntoStream=O;async function P(m,b,p,y,v,E){h(E);const S=await m.open(b,{create:!1});try{h(E);let l=0,g=0,w=v&&typeof v.length=="number"?v.length:void 0,f=C.VSBuffer.alloc(Math.min(v.bufferSize,typeof w=="number"?w:v.bufferSize)),s=v&&typeof v.position=="number"?v.position:0,i=0;do g=await m.read(S,s,f.buffer,i,f.byteLength-i),s+=g,i+=g,l+=g,typeof w=="number"&&(w-=g),i===f.byteLength&&(await p.write(y(f)),f=C.VSBuffer.alloc(Math.min(v.bufferSize,typeof w=="number"?w:v.bufferSize)),i=0);while(g>0&&(typeof w!="number"||w>0)&&h(E)&&u(l,v));if(i>0){let n=i;typeof w=="number"&&(n=Math.min(i,w)),p.write(y(f.slice(0,n)))}}catch(l){throw(0,k.ensureFileSystemProviderError)(l)}finally{await m.close(S)}}function h(m){if(m.isCancellationRequested)throw(0,D.canceled)();return!0}function u(m,b){if(b?.limits){if(typeof b.limits.memory=="number"&&m>b.limits.memory)throw(0,k.createFileSystemProviderError)((0,I.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&m>b.limits.size)throw(0,k.createFileSystemProviderError)((0,I.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[107],ee([0,1,4,152,2,12,153]),function(_,e,C,D,I,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends I.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new C.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=C.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(u){const m=this.normalizeRequests(u),b=m.filter(y=>{const v=this.watchers.get(y.path);return v?!(0,D.patternsEquals)(v.request.excludes,y.excludes)||!(0,D.patternsEquals)(v.request.includes,y.includes):!0}),p=Array.from(this.watchers.values()).filter(({request:y})=>!m.find(v=>v.path===y.path&&(0,D.patternsEquals)(v.excludes,y.excludes)&&(0,D.patternsEquals)(v.includes,y.includes))).map(({request:y})=>y.path);b.length&&this.trace(`Request to start watching: ${b.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"})`).join(",")}`),p.length&&this.trace(`Request to stop watching: ${p.join(",")}`);for(const y of p)this.stopWatching(y);for(const y of b)this.startWatching(y)}startWatching(u){const m=new O.NodeJSFileWatcherLibrary(u,p=>this._onDidChangeFile.fire(p),p=>this._onDidLogMessage.fire(p),this.verboseLogging),b={request:u,instance:m};this.watchers.set(u.path,b)}async stop(){for(const[u]of this.watchers)this.stopWatching(u);this.watchers.clear()}stopWatching(u){const m=this.watchers.get(u);m&&(this.watchers.delete(u),m.instance.dispose())}normalizeRequests(u){const m=new Map;for(const b of u){const p=k.isLinux?b.path:b.path.toLowerCase();m.set(p,b)}return Array.from(m.values())}async setVerboseLogging(u){this.verboseLogging=u;for(const[,m]of this.watchers)m.instance.setVerboseLogging(u)}trace(u){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(u)})}toMessage(u,m){return m?`[File Watcher (node.js)] ${u} (path: ${m.request.path})`:`[File Watcher (node.js)] ${u}`}}e.NodeJSWatcher=P}),define(Q[108],ee([0,1,61,107]),function(_,e,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class I extends C.AbstractNonRecursiveWatcherClient{constructor(O,P,h){super(O,P,h),this.init()}createWatcher(){return new D.NodeJSWatcher}}e.NodeJSWatcherClient=I}),define(Q[109],ee([0,1,16,56,79,61]),function(_,e,C,D,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class O extends k.AbstractUniversalWatcherClient{constructor(h,u,m){super(h,u,m),this.init()}createWatcher(h){const u=h.add(new I.Client(C.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(u.onDidProcessExit(({code:m,signal:b})=>this.onError(`terminated by itself with code ${m}, signal: ${b}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(u.getChannel("watcher")))}}e.UniversalWatcherClient=O}),define(Q[62],ee([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class C{constructor(...I){this._entries=new Map;for(const[k,O]of I)this.set(k,O)}set(I,k){const O=this._entries.get(I);return this._entries.set(I,k),O}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=C}),define(Q[110],ee([0,1,3,11,2,46,106,7,62,154]),function(_,e,C,D,I,k,O,P,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const m=!1;class b extends Error{constructor(S){super("cyclic dependency between services"),this.message=S.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${S.toString()}`}}class p{constructor(S=new h.ServiceCollection,l=!1,g,w=m){this._services=S,this._strict=l,this._parent=g,this._enableTracing=w,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=w?g?._globalGraph??new O.Graph(f=>f):void 0}createChild(S){return new p(S,this._strict,this,this._enableTracing)}invokeFunction(S,...l){const g=v.traceInvocation(this._enableTracing,S);let w=!1;try{return S({get:s=>{if(w)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(s,g);if(!i)throw new Error(`[invokeFunction] unknown service '${s}'`);return i}},...l)}finally{w=!0,g.stop()}}createInstance(S,...l){let g,w;return S instanceof k.SyncDescriptor?(g=v.traceCreation(this._enableTracing,S.ctor),w=this._createInstance(S.ctor,S.staticArguments.concat(l),g)):(g=v.traceCreation(this._enableTracing,S),w=this._createInstance(S,l,g)),g.stop(),w}_createInstance(S,l=[],g){const w=P._util.getServiceDependencies(S).sort((i,n)=>i.index-n.index),f=[];for(const i of w){const n=this._getOrCreateServiceInstance(i.id,g);n||this._throwIfStrict(`[createInstance] ${S.name} depends on UNKNOWN service ${i.id}.`,!1),f.push(n)}const s=w.length>0?w[0].index:l.length;if(l.length!==s){console.trace(`[createInstance] First service dependency of ${S.name} at position ${s+1} conflicts with ${l.length} static arguments`);const i=s-l.length;i>0?l=l.concat(new Array(i)):l=l.slice(0,s)}return Reflect.construct(S,l.concat(f))}_setServiceInstance(S,l){if(this._services.get(S)instanceof k.SyncDescriptor)this._services.set(S,l);else if(this._parent)this._parent._setServiceInstance(S,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(S){const l=this._services.get(S);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(S):l}_getOrCreateServiceInstance(S,l){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(S));const g=this._getServiceInstanceOrDescriptor(S);return g instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(S,g,l.branch(S,!0)):(l.branch(S,!1),g)}_safeCreateAndCacheServiceInstance(S,l,g){if(this._activeInstantiations.has(S))throw new Error(`illegal state - RECURSIVELY instantiating service '${S}'`);this._activeInstantiations.add(S);try{return this._createAndCacheServiceInstance(S,l,g)}finally{this._activeInstantiations.delete(S)}}_createAndCacheServiceInstance(S,l,g){const w=new O.Graph(i=>i.id.toString());let f=0;const s=[{id:S,desc:l,_trace:g}];for(;s.length;){const i=s.pop();if(w.lookupOrInsertNode(i),f++>1e3)throw new b(w);for(const n of P._util.getServiceDependencies(i.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(n.id);if(t||this._throwIfStrict(`[createInstance] ${S} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(n.id)),t instanceof k.SyncDescriptor){const r={id:n.id,desc:t,_trace:i._trace.branch(n.id,!0)};w.insertEdge(i,r),s.push(r)}}}for(;;){const i=w.roots();if(i.length===0){if(!w.isEmpty())throw new b(w);break}for(const{data:n}of i){if(this._getServiceInstanceOrDescriptor(n.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this._setServiceInstance(n.id,r)}w.removeNode(n)}}return this._getServiceInstanceOrDescriptor(S)}_createServiceInstanceWithOwner(S,l,g=[],w,f){if(this._services.get(S)instanceof k.SyncDescriptor)return this._createServiceInstance(S,l,g,w,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(S,l,g,w,f);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(S,l,g=[],w,f){if(w){const s=new p(void 0,this._strict,this,this._enableTracing);s._globalGraphImplicitDependency=String(S);const i=new Map,n=new C.IdleValue(()=>{const t=s._createInstance(l,g,f);for(const[r,o]of i){const c=t[r];if(typeof c=="function")for(const a of o)c.apply(t,a)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,r){if(!n.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let a=i.get(r);return a||(a=new u.LinkedList,i.set(r,a)),(R,M,q)=>{const X=a.push([R,M,q]);return(0,I.toDisposable)(X)}}if(r in t)return t[r];const o=n.value;let c=o[r];return typeof c!="function"||(c=c.bind(o),t[r]=c),c},set(t,r,o){return n.value[r]=o,!0}})}else return this._createInstance(l,g,f)}_throwIfStrict(S,l){if(l&&console.warn(S),this._strict)throw new Error(S)}}e.InstantiationService=p;var y;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(y||(y={}));class v{static traceInvocation(S,l){return S?new v(1,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v._None}static traceCreation(S,l){return S?new v(0,l.name):v._None}constructor(S,l){this.type=S,this.name=l,this._start=Date.now(),this._dep=[]}branch(S,l){const g=new v(2,S.toString());return this._dep.push([S,l,g]),g}stop(){const S=Date.now()-this._start;v._totals+=S;let l=!1;function g(f,s){const i=[],n=new Array(f+1).join("	");for(const[t,r,o]of s._dep)if(r&&o){l=!0,i.push(`${n}CREATES -> ${t}`);const c=g(f+1,o);c&&i.push(c)}else i.push(`${n}uses -> ${t}`);return i.join(`
`)}const w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${S.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(S>2||l)&&v.all.add(w.join(`
`))}}e.Trace=v,v.all=new Set,v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0});var te=this&&this.__param||function(_,e){return function(C,D){e(C,D,_)}};define(Q[63],ee([0,1,22,2,12,94,23,7]),function(_,e,C,D,I,k,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let h=class extends D.Disposable{constructor(m){super(),this.extensionGalleryService=m}async getAvailableLanguages(){const m=new C.CancellationTokenSource;setTimeout(()=>m.cancel(),1e3);let b;try{b=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},m.token)}catch{return[]}const y=b.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some(E=>E.startsWith("lp-"))).map(v=>{const E=v.properties.localizedLanguages?.[0],S=this.getLocale(v);return{...this.createQuickPickItem(S,E,v),extensionId:v.identifier.id,galleryExtension:v}});return y.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),y}getLocale(m){return m.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(m,b,p){const y=b??m;let v;if(y!==m&&(v=`(${m})`),m.toLowerCase()===I.language.toLowerCase()&&(v??="",v+=(0,k.localize)(0,null)),p?.installCount){v??="";const E=p.installCount;let S;E>1e6?S=`${Math.floor(E/1e5)/10}M`:E>1e3?S=`${Math.floor(E/1e3)}K`:S=String(E),v+=` $(cloud-download) ${S}`}return{id:m,label:y,description:v}}};h=he([te(0,O.IExtensionGalleryService)],h),e.LanguagePackBaseService=h}),define(Q[9],ee([0,1,31,4,2,39,12,10,7]),function(_,e,C,D,I,k,O,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,h.createDecorator)("logService"),e.ILoggerService=(0,h.createDecorator)("loggerService");function u(){return new Date().toISOString()}var m;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;function b(c,a,d){switch(a){case m.Trace:c.trace(d);break;case m.Debug:c.debug(d);break;case m.Info:c.info(d);break;case m.Warning:c.warn(d);break;case m.Error:c.error(d);break;default:throw new Error("Invalid log level")}}e.log=b;function p(c){let a="";for(let d=0;d<c.length;d++){let R=c[d];if(typeof R=="object")try{R=JSON.stringify(R)}catch{}a+=(d>0?" ":"")+R}return a}e.format=p;class y extends I.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class v extends y{constructor(a){super(),this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...d){this.checkLogLevel(m.Trace)&&this.log(m.Trace,p([a,...d]))}debug(a,...d){this.checkLogLevel(m.Debug)&&this.log(m.Debug,p([a,...d]))}info(a,...d){this.checkLogLevel(m.Info)&&this.log(m.Info,p([a,...d]))}warn(a,...d){this.checkLogLevel(m.Warning)&&this.log(m.Warning,p([a,...d]))}error(a,...d){if(this.checkLogLevel(m.Error))if(a instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=a.stack,this.log(m.Error,p(R))}else this.log(m.Error,p([a,...d]))}flush(){}}e.AbstractMessageLogger=v;class E extends y{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.useColors=!O.isWindows}trace(a,...d){this.getLevel()<=m.Trace&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,a,...d):console.log(`[main ${u()}]`,a,...d))}debug(a,...d){this.getLevel()<=m.Debug&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,a,...d):console.log(`[main ${u()}]`,a,...d))}info(a,...d){this.getLevel()<=m.Info&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,a,...d):console.log(`[main ${u()}]`,a,...d))}warn(a,...d){this.getLevel()<=m.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,a,...d):console.warn(`[main ${u()}]`,a,...d))}error(a,...d){this.getLevel()<=m.Error&&(this.useColors?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,a,...d):console.error(`[main ${u()}]`,a,...d))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class S extends y{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...d){this.getLevel()<=m.Trace&&console.log("%cTRACE","color: #888",a,...d)}debug(a,...d){this.getLevel()<=m.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...d)}info(a,...d){this.getLevel()<=m.Info&&console.log("%c INFO","color: #33f",a,...d)}warn(a,...d){this.getLevel()<=m.Warning&&console.log("%c WARN","color: #993",a,...d)}error(a,...d){this.getLevel()<=m.Error&&console.log("%c  ERR","color: #f33",a,...d)}dispose(){}flush(){}}e.ConsoleLogger=S;class l extends y{constructor(a,d=e.DEFAULT_LOG_LEVEL){super(),this.adapter=a,this.setLevel(d)}trace(a,...d){this.getLevel()<=m.Trace&&this.adapter.log(m.Trace,[this.extractMessage(a),...d])}debug(a,...d){this.getLevel()<=m.Debug&&this.adapter.log(m.Debug,[this.extractMessage(a),...d])}info(a,...d){this.getLevel()<=m.Info&&this.adapter.log(m.Info,[this.extractMessage(a),...d])}warn(a,...d){this.getLevel()<=m.Warning&&this.adapter.log(m.Warning,[this.extractMessage(a),...d])}error(a,...d){this.getLevel()<=m.Error&&this.adapter.log(m.Error,[this.extractMessage(a),...d])}extractMessage(a){return typeof a=="string"?a:(0,C.toErrorMessage)(a,this.getLevel()<=m.Trace)}dispose(){}flush(){}}e.AdapterLogger=l;class g extends y{constructor(a){super(),this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const d of this.logServices)d.setLevel(a);super.setLevel(a)}trace(a,...d){for(const R of this.logServices)R.trace(a,...d)}debug(a,...d){for(const R of this.logServices)R.debug(a,...d)}info(a,...d){for(const R of this.logServices)R.info(a,...d)}warn(a,...d){for(const R of this.logServices)R.warn(a,...d)}error(a,...d){for(const R of this.logServices)R.error(a,...d)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=g;class w extends I.Disposable{constructor(a){super(),this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...d){this.logger.trace(a,...d)}debug(a,...d){this.logger.debug(a,...d)}info(a,...d){this.logger.info(a,...d)}warn(a,...d){this.logger.warn(a,...d)}error(a,...d){this.logger.error(a,...d)}flush(){this.logger.flush()}}e.LogService=w;class f extends I.Disposable{constructor(a,d){super(),this.logLevel=a,this.loggerItems=new k.ResourceMap,this._register(d(R=>this.setLevel(R)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:a})=>a)}getLogger(a){return this.loggerItems.get(a)?.logger}createLogger(a,d,R){let M=this.loggerItems.get(a)?.logger;return M||(R=d?.always?m.Trace:R,M=this.doCreateLogger(a,R??this.logLevel,d),this.loggerItems.set(a,{logger:M,logLevel:R})),M}setLevel(a,d){const R=P.URI.isUri(a)?a:void 0,M=R?d:a;if(R){const q=this.loggerItems.get(R);q&&q.logLevel!==M&&(q.logLevel=M,q.logger.setLevel(M))}else this.logLevel=M,this.loggerItems.forEach(({logLevel:q,logger:X})=>{q===void 0&&X.setLevel(this.logLevel)})}getLogLevel(a){return this.loggerItems.get(a)?.logLevel}dispose(){this.loggerItems.forEach(({logger:a})=>a.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=f;class s{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(a){}getLevel(){return m.Info}trace(a,...d){}debug(a,...d){}info(a,...d){}warn(a,...d){}error(a,...d){}critical(a,...d){}dispose(){}flush(){}}e.NullLogger=s;class i extends s{}e.NullLogService=i;class n extends f{constructor(){super(m.Info,D.Event.None)}doCreateLogger(a,d,R){return new s}}e.NullLoggerService=n;function t(c){if(c.verbose)return m.Trace;if(typeof c.logLevel=="string"){const a=o(c.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function r(c){switch(c){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.LogLevelToString=r;function o(c){switch(c){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.parseLogLevel=o}),define(Q[111],ee([0,1,19,3,11,4,2,15,61,9]),function(_,e,C,D,I,k,O,P,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class m extends O.Disposable{constructor(p,y){super(),this.logService=p,this.options=y,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new D.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}watch(p,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(p,y):this.watchNonRecursive(p,y)}watchUniversal(p,y){const v={path:this.toFilePath(p),excludes:y.excludes,includes:y.includes,recursive:y.recursive},E=(0,C.insert)(this.universalPathsToWatch,v);return this.refreshUniversalWatchers(),(0,O.toDisposable)(()=>{E(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(p=>(0,I.onUnexpectedError)(p))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,h.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===u.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)})));const p=this.options?.watcher?.recursive?.usePolling;if(p===!0)for(const y of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const y of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(y)&&p.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(p,y){const v={path:this.toFilePath(p),excludes:y.excludes,includes:y.includes,recursive:!1},E=(0,C.insert)(this.nonRecursivePathsToWatch,v);return this.refreshNonRecursiveWatchers(),(0,O.toDisposable)(()=>{E(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(p=>(0,I.onUnexpectedError)(p))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(p=>this._onDidChangeFile.fire((0,h.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===u.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logService[p.type](p.message)}toFilePath(p){return(0,P.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=m}),define(Q[112],ee([0,1,19,3,14,22,4,53,64,2,113,16,114,17,43,91,13,60,9]),function(_,e,C,D,I,k,O,P,h,u,m,b,p,y,v,E,S,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends u.Disposable{constructor(s){super(),this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new O.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new O.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new O.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(s,i){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${s}`);const n=new u.DisposableStore;return this.provider.set(s,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:i}),n.add(i.onDidChangeFile(t=>this._onDidFilesChange.fire(new S.FileChangesEvent(t,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&n.add(i.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),n.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:s}))),(0,u.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:i}),this.provider.delete(s),(0,u.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){i.push(n)}}),!this.provider.has(s)&&await D.Promises.settled(i)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,i){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&i)}listCapabilities(){return h.Iterable.map(this.provider,([s,i])=>({scheme:s,capabilities:i.capabilities}))}async withProvider(s){if(!(0,y.isAbsolutePath)(s))throw new S.FileOperationError((0,E.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const i=this.provider.get(s.scheme);if(!i){const n=new Error;throw n.name="ENOPRO",n.message=(0,E.localize)(1,null,s.toString()),n}return i}async withReadProvider(s){const i=await this.withProvider(s);if((0,S.hasOpenReadWriteCloseCapability)(i)||(0,S.hasReadWriteCapability)(i)||(0,S.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const i=await this.withProvider(s);if((0,S.hasOpenReadWriteCloseCapability)(i)||(0,S.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,i){try{return await this.doResolveFile(s,i)}catch(n){throw(0,S.toFileSystemProviderErrorCode)(n)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,E.localize)(2,null,this.resourceForError(s)),1):(0,S.ensureFileSystemProviderError)(n)}}async doResolveFile(s,i){const n=await this.withProvider(s),t=this.isPathCaseSensitive(n),r=i?.resolveTo,o=i?.resolveSingleChildDescendants,c=i?.resolveMetadata,a=await n.stat(s);let d;return this.toFileStat(n,s,a,void 0,!!c,(R,M)=>(d||(d=m.TernarySearchTree.forUris(()=>!t),d.set(s,!0),r&&d.fill(!0,r)),d.get(R.resource)||d.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&o?M===1:!1))}async toFileStat(s,i,n,t,r,o){const{providerExtUri:c}=this.getExtUri(s),a={resource:i,name:c.basename(i),isFile:(n.type&S.FileType.File)!==0,isDirectory:(n.type&S.FileType.Directory)!==0,isSymbolicLink:(n.type&S.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&S.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,S.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(a.isDirectory&&o(a,t)){try{const d=await s.readdir(i),R=await D.Promises.settled(d.map(async([M,q])=>{try{const X=c.joinPath(i,M),J=r?await s.stat(X):{type:q};return await this.toFileStat(s,X,J,d.length,r,o)}catch(X){return this.logService.trace(X),null}}));a.children=(0,C.coalesce)(R)}catch(d){this.logService.trace(d),a.children=[]}return a}return a}async resolveAll(s){return D.Promises.settled(s.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const i=await this.withProvider(s),n=await i.stat(s);return this.toFileStat(i,s,n,void 0,!0,()=>!1)}async exists(s){const i=await this.withProvider(s);try{return!!await i.stat(s)}catch{return!1}}async canCreateFile(s,i){try{await this.doValidateCreateFile(s,i)}catch(n){return n}return!0}async doValidateCreateFile(s,i){if(!i?.overwrite&&await this.exists(s))throw new S.FileOperationError((0,E.localize)(3,null,this.resourceForError(s)),3,i)}async createFile(s,i=I.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const t=await this.writeFile(s,i);return this._onDidRunOperation.fire(new S.FileOperationEvent(s,0,t)),t}async writeFile(s,i,n){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:r}=this.getExtUri(t);try{await this.validateWriteFile(t,s,n)||await this.mkdirp(t,r.dirname(s));let c;if((0,S.hasReadWriteCapability)(t)&&!(i instanceof I.VSBuffer))if((0,v.isReadableStream)(i)){const a=await(0,v.peekStream)(i,3);a.ended?c=I.VSBuffer.concat(a.buffer):c=a}else c=(0,v.peekReadable)(i,a=>I.VSBuffer.concat(a),3);else c=i;!(0,S.hasOpenReadWriteCloseCapability)(t)||(0,S.hasReadWriteCapability)(t)&&c instanceof I.VSBuffer?await this.doWriteUnbuffered(t,s,n,c):await this.doWriteBuffered(t,s,n,c instanceof I.VSBuffer?(0,I.bufferToReadable)(c):c),this._onDidRunOperation.fire(new S.FileOperationEvent(s,4))}catch(o){throw new S.FileOperationError((0,E.localize)(4,null,this.resourceForError(s),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,i,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,E.localize)(5,null,this.resourceForError(i)));let r;try{r=await s.stat(i)}catch{return}if((r.type&S.FileType.Directory)!==0)throw new S.FileOperationError((0,E.localize)(6,null,this.resourceForError(i)),0,n);if(this.throwIfFileIsReadonly(i,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==S.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,S.etag)({mtime:n.mtime,size:r.size}))throw new S.FileOperationError((0,E.localize)(7,null),3,n);return r}async readFile(s,i,n){const t=await this.withReadProvider(s);return i?.atomic?this.doReadFileAtomic(t,s,i,n):this.doReadFile(t,s,i,n)}async doReadFileAtomic(s,i,n,t){return new Promise((r,o)=>{this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(s,i,n,t);r(c)}catch(c){o(c)}})})}async doReadFile(s,i,n,t){const r=await this.doReadFileStream(s,i,{...n,preferUnbuffered:!0},t);return{...r,value:await(0,I.streamToBuffer)(r.value)}}async readFileStream(s,i,n){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,i,n)}async doReadFileStream(s,i,n,t){const r=new k.CancellationTokenSource(t),o=this.validateReadFile(i,n).then(a=>a,a=>{throw r.cancel(),a});let c;try{return typeof n?.etag=="string"&&n.etag!==S.ETAG_DISABLED&&await o,n?.atomic&&(0,S.hasFileAtomicReadCapability)(s)||!((0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasFileReadStreamCapability)(s))||(0,S.hasReadWriteCapability)(s)&&n?.preferUnbuffered?c=this.readFileUnbuffered(s,i,n):(0,S.hasFileReadStreamCapability)(s)?c=this.readFileStreamed(s,i,r.token,n):c=this.readFileBuffered(s,i,r.token,n),{...await o,value:c}}catch(a){c&&await(0,v.consumeStream)(c);const d=(0,E.localize)(8,null,this.resourceForError(i),(0,S.ensureFileSystemProviderError)(a).toString());throw a instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(d,a.stat,n):new S.FileOperationError(d,(0,S.toFileOperationResult)(a),n)}}readFileStreamed(s,i,n,t=Object.create(null)){const r=s.readFileStream(i,t,n);return(0,v.transform)(r,{data:o=>o instanceof I.VSBuffer?o:I.VSBuffer.wrap(o),error:o=>new S.FileOperationError((0,E.localize)(9,null,this.resourceForError(i),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),t)},o=>I.VSBuffer.concat(o))}readFileBuffered(s,i,n,t=Object.create(null)){const r=(0,I.newWriteableBufferStream)();return(0,l.readFileIntoStream)(s,i,r,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new S.FileOperationError((0,E.localize)(10,null,this.resourceForError(i),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),t)},n),r}readFileUnbuffered(s,i,n){const t=(0,v.newWriteableStream)(r=>I.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,S.hasFileAtomicReadCapability)(s)?r=await s.readFile(i,{atomic:!0}):r=await s.readFile(i),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.validateReadFileLimits(i,r.byteLength,n),t.end(I.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async validateReadFile(s,i){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new S.FileOperationError((0,E.localize)(11,null,this.resourceForError(s)),0,i);if(typeof i?.etag=="string"&&i.etag!==S.ETAG_DISABLED&&i.etag===n.etag)throw new S.NotModifiedSinceFileOperationError((0,E.localize)(12,null),n,i);return this.validateReadFileLimits(s,n.size,i),n}validateReadFileLimits(s,i,n){if(n?.limits){let t;if(typeof n.limits.memory=="number"&&i>n.limits.memory&&(t=9),typeof n.limits.size=="number"&&i>n.limits.size&&(t=7),typeof t=="number")throw new S.FileOperationError((0,E.localize)(13,null,this.resourceForError(s)),t)}}async canMove(s,i,n){return this.doCanMoveCopy(s,i,"move",n)}async canCopy(s,i,n){return this.doCanMoveCopy(s,i,"copy",n)}async doCanMoveCopy(s,i,n,t){if(s.toString()!==i.toString())try{const r=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(r,s,o,i,n,t)}catch(r){return r}return!0}async move(s,i,n){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(t,s,r,i,"move",!!n),c=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,o==="move"?2:3,c)),c}async copy(s,i,n){const t=await this.withReadProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(t,s,r,i,"copy",!!n),c=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,o==="copy"?3:2,c)),c}async doMoveCopy(s,i,n,t,r,o){if(i.toString()===t.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(s,i,n,t,r,o);if(c&&!a&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(t)),r==="copy"){if(s===n&&(0,S.hasFileFolderCopyCapability)(s))await s.copy(i,t,{overwrite:o});else{const d=await this.resolve(i);d.isDirectory?await this.doCopyFolder(s,d,n,t):await this.doCopyFile(s,i,n,t)}return r}else return s===n?(await s.rename(i,t,{overwrite:o}),r):(await this.doMoveCopy(s,i,n,t,"copy",o),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(s,i,n,t){if((0,S.hasOpenReadWriteCloseCapability)(s)&&(0,S.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,i,n,t);if((0,S.hasOpenReadWriteCloseCapability)(s)&&(0,S.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,i,n,t);if((0,S.hasReadWriteCapability)(s)&&(0,S.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,i,n,t);if((0,S.hasReadWriteCapability)(s)&&(0,S.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,i,n,t)}async doCopyFolder(s,i,n,t){await n.mkdir(t),Array.isArray(i.children)&&await D.Promises.settled(i.children.map(async r=>{const o=this.getExtUri(n).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.doCopyFolder(s,await this.resolve(r.resource),n,o):this.doCopyFile(s,r.resource,n,o)}))}async doValidateMoveCopy(s,i,n,t,r,o){let c=!1;if(s===n){const{providerExtUri:d,isPathCaseSensitive:R}=this.getExtUri(s);if(R||(c=d.isEqual(i,t)),c&&r==="copy")throw new Error((0,E.localize)(14,null,this.resourceForError(i),this.resourceForError(t)));if(!c&&d.isEqualOrParent(t,i))throw new Error((0,E.localize)(15,null,this.resourceForError(i),this.resourceForError(t)))}const a=await this.exists(t);if(a&&!c){if(!o)throw new S.FileOperationError((0,E.localize)(16,null,this.resourceForError(i),this.resourceForError(t)),4);if(s===n){const{providerExtUri:d}=this.getExtUri(s);if(d.isEqualOrParent(i,t))throw new Error((0,E.localize)(17,null,this.resourceForError(i),this.resourceForError(t)))}}return{exists:a,isSameResourceWithDifferentPathCase:c}}getExtUri(s){const i=this.isPathCaseSensitive(s);return{providerExtUri:i?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(i,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,0,n)),n}async mkdirp(s,i){const n=[],{providerExtUri:t}=this.getExtUri(s);for(;!t.isEqual(i,t.dirname(i));)try{if(((await s.stat(i)).type&S.FileType.Directory)===0)throw new Error((0,E.localize)(18,null,this.resourceForError(i)));break}catch(r){if((0,S.toFileSystemProviderErrorCode)(r)!==S.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(t.basename(i)),i=t.dirname(i)}for(let r=n.length-1;r>=0;r--){i=t.joinPath(i,n[r]);try{await s.mkdir(i)}catch(o){if((0,S.toFileSystemProviderErrorCode)(o)!==S.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,i){try{await this.doValidateDelete(s,i)}catch(n){return n}return!0}async doValidateDelete(s,i){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!i?.useTrash&&!(n.capabilities&4096))throw new Error((0,E.localize)(19,null,this.resourceForError(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.throwIfFileIsReadonly(s,r);else throw new S.FileOperationError((0,E.localize)(20,null,this.resourceForError(s)),1);if(!!!i?.recursive){const c=await this.resolve(s);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,E.localize)(21,null,this.resourceForError(s)))}return n}async del(s,i){const n=await this.doValidateDelete(s,i),t=!!i?.useTrash,r=!!i?.recursive;await n.delete(s,{recursive:r,useTrash:t}),this._onDidRunOperation.fire(new S.FileOperationEvent(s,1))}async cloneFile(s,i){const n=await this.withProvider(s),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(n===t&&this.getExtUri(n).providerExtUri.isEqual(s,i))return;if(n===t&&(0,S.hasFileCloneCapability)(n))return n.cloneFile(s,i);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i));const r=this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri);return n===t&&(0,S.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,i,{overwrite:!0})):r.queue(()=>this.doCopyFile(n,s,t,i))}watch(s,i={recursive:!1,excludes:[]}){const n=new u.DisposableStore;let t=!1,r=()=>{t=!0};return n.add((0,u.toDisposable)(()=>r())),(async()=>{try{const o=await this.doWatch(s,i);t?(0,u.dispose)(o):r=()=>(0,u.dispose)(o)}catch(o){this.logService.error(o)}})(),n}async doWatch(s,i){const n=await this.withProvider(s),t=(0,P.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(s),i]);let r=this.activeWatchers.get(t);return r||(r={count:0,disposable:n.watch(s,i)},this.activeWatchers.set(t,r)),r.count+=1,(0,u.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,u.dispose)(r.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,u.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,i,n,t){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(async()=>{const r=await s.open(i,{create:!0,unlock:n?.unlock??!1});try{(0,v.isReadableStream)(t)||(0,v.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(s,r,t):await this.doWriteReadableBufferedQueued(s,r,t)}catch(o){throw(0,S.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async doWriteStreamBufferedQueued(s,i,n){let t=0,r;if((0,v.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=I.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,i,o,o.byteLength,t,0),t+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,c)=>{(0,v.listenStream)(r,{onData:async a=>{r.pause();try{await this.doWriteBuffer(s,i,a,a.byteLength,t,0)}catch(d){return c(d)}t+=a.byteLength,setTimeout(()=>r.resume())},onError:a=>c(a),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,i,n){let t=0,r;for(;(r=n.read())!==null;)await this.doWriteBuffer(s,i,r,r.byteLength,t,0),t+=r.byteLength}async doWriteBuffer(s,i,n,t,r,o){let c=0;for(;c<t;)c+=await s.write(i,r+c,n.buffer,o+c,t-c)}async doWriteUnbuffered(s,i,n,t){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,i,n,t))}async doWriteUnbufferedQueued(s,i,n,t){let r;t instanceof I.VSBuffer?r=t:(0,v.isReadableStream)(t)?r=await(0,I.streamToBuffer)(t):(0,v.isReadableBufferedStream)(t)?r=await(0,I.bufferedStreamToBuffer)(t):r=(0,I.readableToBuffer)(t),await s.writeFile(i,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(s,i,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,i,n,t))}async doPipeBufferedQueued(s,i,n,t){let r,o;try{r=await s.open(i,{create:!1}),o=await n.open(t,{create:!0,unlock:!1});const c=I.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,d=0,R=0;do R=await s.read(r,a,c.buffer,d,c.byteLength-d),await this.doWriteBuffer(n,o,c,R,a,d),a+=R,d+=R,d===c.byteLength&&(d=0);while(R>0)}catch(c){throw(0,S.ensureFileSystemProviderError)(c)}finally{await D.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,i,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,i,n,t))}async doPipeUnbufferedQueued(s,i,n,t){return n.writeFile(t,await s.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,i,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,i,n,t))}async doPipeUnbufferedToBufferedQueued(s,i,n,t){const r=await n.open(t,{create:!0,unlock:!1});try{const o=await s.readFile(i);await this.doWriteBuffer(n,r,I.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,S.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async doPipeBufferedToUnbuffered(s,i,n,t){const r=await(0,I.streamToBuffer)(this.readFileBuffered(s,i,k.CancellationToken.None));await this.doWriteUnbuffered(n,t,void 0,r)}throwIfFileSystemIsReadonly(s,i){if(s.capabilities&2048)throw new S.FileOperationError((0,E.localize)(22,null,this.resourceForError(i)),6);return s}throwIfFileIsReadonly(s,i){if((i.permissions??0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,E.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===b.Schemas.file?s.fsPath:s.toString(!0)}};w=he([te(0,g.ILogService)],w),e.FileService=w}),define(Q[115],ee([0,1,116,155,3,39,14,4,156,2,15,12,17,43,20,93,13,60,111,31,109,108]),function(_,e,C,D,I,k,O,P,h,u,m,b,p,y,v,E,S,l,g,w,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(C)}catch(n){console.error(`Error enabling graceful-fs: ${(0,w.toErrorMessage)(n)}`)}})();class i extends g.AbstractDiskFileSystemProvider{constructor(t,r){super(t,r),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new k.ResourceMap(o=>p.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:r,symbolicLink:o}=await v.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(t){try{const r=await v.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async c=>{try{let a;c.isSymbolicLink()?a=(await this.stat((0,p.joinPath)(t,c.name))).type:a=this.toType(c),o.push([c.name,a])}catch(a){this.logService.trace(a)}})),o}catch(r){throw this.toFileSystemProviderError(r)}}toType(t,r){let o;return r?.dangling?o=S.FileType.Unknown:t.isFile()?o=S.FileType.File:t.isDirectory()?o=S.FileType.Directory:o=S.FileType.Unknown,r&&(o|=S.FileType.SymbolicLink),o}async createResourceLock(t){const r=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const c=new I.Barrier;return this.resourceLocks.set(t,c),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,u.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(t)===c&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),c.open()})}async readFile(t,r){let o;try{r?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),o=await this.createResourceLock(t));const c=this.toFilePath(t);return await v.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{o?.dispose()}}traceLock(t){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,r,o){const c=(0,y.newWriteableStream)(a=>O.VSBuffer.concat(a.map(d=>O.VSBuffer.wrap(d))).buffer);return(0,l.readFileIntoStream)(this,t,c,a=>a.buffer,{...r,bufferSize:256*1024},o),c}async writeFile(t,r,o){let c;try{const a=this.toFilePath(t);if(!o.create||!o.overwrite){if(await v.Promises.exists(a)){if(!o.overwrite)throw(0,S.createFileSystemProviderError)((0,E.localize)(0,null),S.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,S.createFileSystemProviderError)((0,E.localize)(1,null),S.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(c,0,r,0,r.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(t,a)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(t){i.canFlush=t}async open(t,r){const o=this.toFilePath(t);let c;(0,S.isFileOpenForWriteOptions)(r)&&(c=await this.createResourceLock(t));let a;try{if((0,S.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:R}=await v.SymlinkSupport.stat(o);R.mode&128||await v.Promises.chmod(o,R.mode|128)}catch(R){this.logService.trace(R)}let d;if((0,S.isFileOpenForWriteOptions)(r)){if(b.isWindows)try{await v.Promises.truncate(o,0),d="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}d||(d="w")}else d="r";a=await v.Promises.open(o,d)}catch(d){throw c?.dispose(),(0,S.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(t,d):this.toFileSystemProviderError(d)}if(this.mapHandleToPos.set(a,0),(0,S.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(a,t),c){const d=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.mapHandleToLock.set(a,c),d&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),d.dispose())}return a}async close(t){const r=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&i.canFlush)try{await v.Promises.fdatasync(t)}catch(o){i.configureFlushOnWrite(!1),this.logService.error(o)}return await v.Promises.close(t)}catch(o){throw this.toFileSystemProviderError(o)}finally{r&&(this.mapHandleToLock.get(t)===r&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),r.dispose())}}async read(t,r,o,c,a){const d=this.normalizePos(t,r);let R=null;try{R=(await v.Promises.read(t,o,c,a,d)).bytesRead}catch(M){throw this.toFileSystemProviderError(M)}finally{this.updatePos(t,d,R)}return R}normalizePos(t,r){return r===this.mapHandleToPos.get(t)?null:r}updatePos(t,r,o){const c=this.mapHandleToPos.get(t);typeof c=="number"&&(typeof r=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,c+o):this.mapHandleToPos.delete(t)))}async write(t,r,o,c,a){return(0,I.retry)(()=>this.doWrite(t,r,o,c,a),100,3)}async doWrite(t,r,o,c,a){const d=this.normalizePos(t,r);let R=null;try{R=(await v.Promises.write(t,o,c,a,d)).bytesWritten}catch(M){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),M)}finally{this.updatePos(t,d,R)}return R}async mkdir(t){try{await v.Promises.mkdir(this.toFilePath(t))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(t,r){try{const o=this.toFilePath(t);r.recursive?await v.Promises.rm(o,v.RimRafMode.MOVE):await v.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(t,r,o){const c=this.toFilePath(t),a=this.toFilePath(r);if(c!==a)try{await this.validateTargetDeleted(t,r,"move",o.overwrite),await v.Promises.move(c,a)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,E.localize)(2,null,(0,m.basename)(c),(0,m.basename)((0,m.dirname)(a)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(t,r,o){const c=this.toFilePath(t),a=this.toFilePath(r);if(c!==a)try{await this.validateTargetDeleted(t,r,"copy",o.overwrite),await v.Promises.copy(c,a,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,E.localize)(3,null,(0,m.basename)(c),(0,m.basename)((0,m.dirname)(a)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(t,r,o,c){const a=this.toFilePath(t),d=this.toFilePath(r);let R=!1;if(!!(this.capabilities&1024)||(R=(0,h.isEqual)(a,d,!0)),R&&o==="copy")throw(0,S.createFileSystemProviderError)((0,E.localize)(4,null),S.FileSystemProviderErrorCode.FileExists);if(!R&&await v.Promises.exists(d)){if(!c)throw(0,S.createFileSystemProviderError)((0,E.localize)(5,null),S.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(t,r){return this.doCloneFile(t,r,!1)}async doCloneFile(t,r,o){const c=this.toFilePath(t),a=this.toFilePath(r),d=!!(this.capabilities&1024);if((0,h.isEqual)(c,a,!d))return;const R=new u.DisposableStore;try{const[M,q]=await Promise.all([this.createResourceLock(t),this.createResourceLock(r)]);R.add(M),R.add(q),o&&await v.Promises.mkdir((0,m.dirname)(a),{recursive:!0}),await v.Promises.copyFile(c,a)}catch(M){if(M.code==="ENOENT"&&!o)return this.doCloneFile(t,r,!0);throw this.toFileSystemProviderError(M)}finally{R.dispose()}}createUniversalWatcher(t,r,o){return new f.UniversalWatcherClient(c=>t(c),c=>r(c),o)}createNonRecursiveWatcher(t,r,o){return new s.NodeJSWatcherClient(c=>t(c),c=>r(c),o)}toFileSystemProviderError(t){if(t instanceof S.FileSystemProviderError)return t;let r;switch(t.code){case"ENOENT":r=S.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=S.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=S.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=S.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=S.FileSystemProviderErrorCode.NoPermissions;break;default:r=S.FileSystemProviderErrorCode.Unknown}return(0,S.createFileSystemProviderError)(t,r)}async toFileSystemProviderWriteError(t,r){let o=this.toFileSystemProviderError(r);if(t&&o.code===S.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await v.SymlinkSupport.stat(this.toFilePath(t));c.mode&128||(o=(0,S.createFileSystemProviderError)(r,S.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return o}}e.DiskFileSystemProvider=i,i.TRACE_LOG_RESOURCE_LOCKS=!1,i.canFlush=!0}),define(Q[117],ee([0,1,13,9]),function(_,e,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var I;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(I||(I={}));async function k(u,m,b,p,y){try{const v=await new Promise((S,l)=>{_(["spdlog"],S,l)});v.setFlushOn(D.LogLevel.Trace);const E=await v.createAsyncRotatingLogger(u,m,b,p);return y?E.clearFormatters():E.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),E}catch(v){console.error(v)}return null}function O(u,m,b){switch(m){case D.LogLevel.Trace:u.trace(b);break;case D.LogLevel.Debug:u.debug(b);break;case D.LogLevel.Info:u.info(b);break;case D.LogLevel.Warning:u.warn(b);break;case D.LogLevel.Error:u.error(b);break;default:throw new Error("Invalid log level")}}function P(u,m){switch(m){case D.LogLevel.Trace:u.setLevel(I.Trace);break;case D.LogLevel.Debug:u.setLevel(I.Debug);break;case D.LogLevel.Info:u.setLevel(I.Info);break;case D.LogLevel.Warning:u.setLevel(I.Warning);break;case D.LogLevel.Error:u.setLevel(I.Error);break;case D.LogLevel.Off:u.setLevel(I.Off);break;default:throw new Error("Invalid log level")}}class h extends D.AbstractMessageLogger{constructor(m,b,p,y,v){super(),this.buffer=[],this.setLevel(v),this._loggerCreationPromise=this._createSpdLogLogger(m,b,p,y),this._register(this.onDidChangeLogLevel(E=>{this._logger&&P(this._logger,E)}))}async _createSpdLogLogger(m,b,p,y){const v=p?6:1,E=30/v*C.ByteSize.MB,S=await k(m,b,E,v,y);if(S){this._logger=S,P(this._logger,this.getLevel());for(const{level:l,message:g}of this.buffer)O(this._logger,l,g);this.buffer=[]}}log(m,b){this._logger?O(this._logger,m,b):this.getLevel()<=m&&this.buffer.push({level:m,message:b})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=h}),define(Q[36],ee([0,1,4,64,2,7]),function(_,e,C,D,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,k.createDecorator)("policy");class O extends I.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(u){const m=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...u,...this.policyDefinitions},m!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(u),D.Iterable.reduce(this.policies.entries(),(b,[p,y])=>({...b,[p]:y}),{})}getPolicyValue(u){return this.policies.get(u)}serialize(){return D.Iterable.reduce(Object.entries(this.policyDefinitions),(u,[m,b])=>({...u,[m]:{definition:b,value:this.policies.get(m)}}),{})}}e.AbstractPolicyService=O;class P{constructor(){this.onDidChange=C.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(Q[118],ee([0,1,3,4,64,8,13,9,36]),function(_,e,C,D,I,k,O,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function u(b,p){const y=[];for(const v of I.Iterable.concat(b.keys(),p.keys()))b.get(v)!==p.get(v)&&y.push(v);return y}let m=class extends h.AbstractPolicyService{constructor(p,y,v){super(),this.file=p,this.fileService=y,this.logService=v,this.throttledDelayer=this._register(new C.ThrottledDelayer(500));const E=D.Event.filter(y.onDidFilesChange,S=>S.affects(p));this._register(y.watch(p)),this._register(E(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(p){await this.refresh()}async read(){const p=new Map;try{const y=await this.fileService.readFile(this.file),v=JSON.parse(y.value.toString());if(!(0,k.isObject)(v))throw new Error("Policy file isn't a JSON object");for(const E of Object.keys(v))this.policyDefinitions[E]&&p.set(E,v[E])}catch(y){y.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",y)}return p}async refresh(){const p=await this.read(),y=u(this.policies,p);this.policies=p,y.length>0&&this._onDidChange.fire(y)}};m=he([te(1,O.IFileService),te(2,P.ILogService)],m),e.FilePolicyService=m}),define(Q[28],ee([0,1,7]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,C.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Q[33],ee([0,1,69,8]),function(_,e,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(O,P){C.ok(D.isString(O)),C.ok(D.isObject(P)),C.ok(!this.data.has(O),"There is already an extension with this id"),this.data.set(O,P)}knows(O){return this.data.has(O)}as(O){return this.data.get(O)||null}}e.Registry=new I}),define(Q[119],ee([0,1,4,33]),function(_,e,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class k{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,u){this.schemasById[I(h)]=u,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const O=new k;D.Registry.add(e.Extensions.JSONContribution,O)}),define(Q[40],ee([0,1,19,4,8,82,21,119,33]),function(_,e,C,D,I,k,O,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var u;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(u=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=h.Registry.as(P.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,n=!0){this.registerConfigurations([i],n)}registerConfigurations(i,n=!0){const t=this.doRegisterConfigurations(i,n);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(i){const n=this.doDeregisterConfigurations(i);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:i,remove:n}){const t=[];t.push(...this.doDeregisterConfigurations(n)),t.push(...this.doRegisterConfigurations(i,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,C.distinct)(t)})}registerDefaultConfigurations(i){const n=[],t=[];for(const{overrides:r,source:o}of i)for(const c in r)if(n.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const a=this.configurationDefaultsOverrides.get(c),d=a?.valuesSources??new Map;if(o)for(const X of Object.keys(r[c]))d.set(X,o);const R={...a?.value||{},...r[c]};this.configurationDefaultsOverrides.set(c,{source:o,value:R,valuesSources:d});const M=(0,O.getLanguageTagSettingPlainKey)(c),q={type:"object",default:R,description:k.localize(1,null,M),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:R,source:I.isString(o)?void 0:o,defaultValueSource:o};t.push(...E(c)),this.configurationProperties[c]=q,this.defaultLanguageConfigurationOverridesNode.properties[c]=q}else{this.configurationDefaultsOverrides.set(c,{value:r[c],source:o});const a=this.configurationProperties[c];a&&(this.updatePropertyDefaultValue(c,a),this.updateSchema(c,a))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const n=[];for(const{overrides:t,source:r}of i)for(const o in t){const c=this.configurationDefaultsOverrides.get(o),a=I.isString(r)?r:r?.id,d=I.isString(c?.source)?c?.source:c?.source?.id;if(a===d)if(n.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const R=this.configurationProperties[o];R&&(this.updatePropertyDefaultValue(o,R),this.updateSchema(o,R))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const n of i)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,n){const t=[];return i.forEach(r=>{t.push(...this.validateAndRegisterProperties(r,n,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),t}doDeregisterConfigurations(i){const n=[],t=r=>{if(r.properties)for(const o in r.properties){n.push(o);const c=this.configurationProperties[o];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o])}r.allOf?.forEach(o=>t(o))};for(const r of i){t(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}return n}validateAndRegisterProperties(i,n=!0,t,r,o=3){o=I.isUndefinedOrNull(i.scope)?o:i.scope;const c=[],a=i.properties;if(a)for(const R in a){const M=a[R];if(n&&w(R,M)){delete a[R];continue}if(M.source=t,M.defaultDefaultValue=a[R].default,this.updatePropertyDefaultValue(R,M),e.OVERRIDE_PROPERTY_REGEX.test(R)?M.scope=void 0:(M.scope=I.isUndefinedOrNull(M.scope)?o:M.scope,M.restricted=I.isUndefinedOrNull(M.restricted)?!!r?.includes(R):M.restricted),a[R].hasOwnProperty("included")&&!a[R].included){this.excludedConfigurationProperties[R]=a[R],delete a[R];continue}else this.configurationProperties[R]=a[R],a[R].policy?.name&&this.policyConfigurations.set(a[R].policy.name,R);!a[R].deprecationMessage&&a[R].markdownDeprecationMessage&&(a[R].deprecationMessage=a[R].markdownDeprecationMessage),c.push(R)}const d=i.allOf;if(d)for(const R of d)c.push(...this.validateAndRegisterProperties(R,n,t,r,o));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const n=t=>{const r=t.properties;if(r)for(const c in r)this.updateSchema(c,r[c]);t.allOf?.forEach(n)};n(i)}updateSchema(i,n){switch(e.allSettings.properties[i]=n,n.scope){case 1:e.applicationSettings.properties[i]=n;break;case 2:e.machineSettings.properties[i]=n;break;case 6:e.machineOverridableSettings.properties[i]=n;break;case 3:e.windowSettings.properties[i]=n;break;case 4:e.resourceSettings.properties[i]=n;break;case 5:e.resourceSettings.properties[i]=n,this.resourceLanguageSettingsSchema.properties[i]=n;break}}removeFromSchema(i,n){switch(delete e.allSettings.properties[i],n.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const n=`[${i}]`,t={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,t),e.allSettings.properties[n]=t,e.applicationSettings.properties[n]=t,e.machineSettings.properties[n]=t,e.machineOverridableSettings.properties[n]=t,e.windowSettings.properties[n]=t,e.resourceSettings.properties[n]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,n){const t=this.configurationDefaultsOverrides.get(i);let r=t?.value,o=t?.source;I.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),I.isUndefined(r)&&(r=l(n.type)),n.default=r,n.defaultValueSource=o}}const y="\\[([^\\]]+)\\]",v=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(s){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let n=v.exec(s);for(;n?.length;){const t=n[1].trim();t&&i.push(t),n=v.exec(s)}}return(0,C.distinct)(i)}e.overrideIdentifiersFromKey=E;function S(s){return s.reduce((i,n)=>`${i}[${n}]`,"")}e.keyFromOverrideIdentifiers=S;function l(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const g=new p;h.Registry.add(e.Extensions.Configuration,g);function w(s,i){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?k.localize(7,null,s):g.getConfigurationProperties()[s]!==void 0?k.localize(8,null,s):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?k.localize(9,null,s,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:k.localize(6,null)}e.validateProperty=w;function f(){const s=[],i=g.getConfigurationProperties();for(const n of Object.keys(i))s.push([n,i[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.getScopes=f}),define(Q[65],ee([0,1,19,4,50,2,39,26,8,10,21,40,33]),function(_,e,C,D,I,k,O,P,h,u,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class y{constructor(n={},t=[],r=[],o){this._contents=n,this._keys=t,this._overrides=r,this.raw=o,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(t=>{if(t instanceof y)return t;const r=new v("");return r.parseRaw(t),r.configurationModel});this._rawConfiguration=n.reduce((t,r)=>r===t?r:t.merge(r),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,m.getConfigurationValue)(this.contents,n):this.contents}inspect(n,t){const r=this.rawConfiguration.getValue(n),o=t?this.rawConfiguration.getOverrideValue(n,t):void 0,c=t?this.rawConfiguration.override(t).getValue(n):r;return{value:r,override:o,merged:c}}getOverrideValue(n,t){const r=this.getContentsForOverrideIdentifer(t);return r?n?(0,m.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const r of this.overrides)r.identifiers.includes(n)&&t.push(...r.keys);return C.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return C.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=P.deepClone(this.contents),r=P.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const a of n)if(c.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.mergeContents(t,a.contents);for(const d of a.overrides){const[R]=r.filter(M=>C.equals(M.identifiers,d.identifiers));R?(this.mergeContents(R.contents,d.contents),R.keys.push(...d.keys),R.keys=C.distinct(R.keys)):r.push(P.deepClone(d))}for(const d of a.keys)o.indexOf(d)===-1&&o.push(d)}return new y(t,o,r,c.every(a=>a instanceof y)?void 0:c)}freeze(){return this.frozen=!0,this}clone(){return new y(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const r={};for(const o of C.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[o];const a=t[o];a&&(typeof c=="object"&&typeof a=="object"?(c=P.deepClone(c),this.mergeContents(c,a)):c=a),r[o]=c}return new y(r,this.keys,this.overrides)}mergeContents(n,t){for(const r of Object.keys(t)){if(r in n&&h.isObject(n[r])&&h.isObject(t[r])){this.mergeContents(n[r],t[r]);continue}n[r]=P.deepClone(t[r])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?P.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,r=null;const o=c=>{c&&(r?this.mergeContents(r,c):r=P.deepClone(c))};for(const c of this.overrides)C.equals(c.identifiers,[n])?t=c.contents:c.identifiers.includes(n)&&o(c.contents);return o(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,m.addToValueTree)(this.contents,n,t,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,m.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let r=0;r<t;r++)n.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,n)}removeKey(n){const t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=y;class v{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!h.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:r,keys:o,overrides:c,restricted:a,hasExcludedProperties:d}=this.doParseRaw(n,t);this._configurationModel=new y(r,o,c,d?[n]:void 0),this._restrictedConfigurations=a||[]}doParseContent(n){let t={},r=null,o=[];const c=[],a=[];function d(M){Array.isArray(o)?o.push(M):r!==null&&(o[r]=M)}const R={onObjectBegin:()=>{const M={};d(M),c.push(o),o=M,r=null},onObjectProperty:M=>{r=M},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const M=[];d(M),c.push(o),o=M,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:d,onError:(M,q,X)=>{a.push({error:M,offset:q,length:X})}};if(n)try{I.visit(n,R),t=o[0]||{}}catch(M){console.error(`Error while parsing settings file ${this._name}: ${M}`),this._parseErrors=[M]}return t}doParseRaw(n,t){const r=p.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,r,!0,t);n=o.raw;const c=(0,m.toValuesTree)(n,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),a=Object.keys(n),d=this.toOverrides(n,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:c,keys:a,overrides:d,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(n,t,r,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:c};const a={},d=[];for(const R in n)if(b.OVERRIDE_PROPERTY_REGEX.test(R)&&r){const M=this.filter(n[R],t,!1,o);a[R]=M.raw,c=c||M.hasExcludedProperties,d.push(...M.restricted)}else{const M=t[R],q=M?typeof M.scope<"u"?M.scope:3:void 0;M?.restricted&&d.push(R),(q===void 0||o.scopes===void 0||o.scopes.includes(q))&&!(o.skipRestricted&&M?.restricted)?a[R]=n[R]:c=!0}return{raw:a,restricted:d,hasExcludedProperties:c}}toOverrides(n,t){const r=[];for(const o of Object.keys(n))if(b.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const a in n[o])c[a]=n[o][a];r.push({identifiers:(0,b.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,m.toValuesTree)(c,t)})}return r}}e.ConfigurationModelParser=v;class E extends k.Disposable{constructor(n,t,r,o){super(),this.userSettingsResource=n,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.any(D.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),D.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&r.isEqual(c.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class S{constructor(n,t,r,o,c,a,d,R,M,q,X,J,ie){this.key=n,this.overrides=t,this.value=r,this.overrideIdentifiers=o,this.defaultConfiguration=c,this.policyConfiguration=a,this.applicationConfiguration=d,this.userConfiguration=R,this.localUserConfiguration=M,this.remoteUserConfiguration=q,this.workspaceConfiguration=X,this.folderConfigurationModel=J,this.memoryInspectValue=ie}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class l{constructor(n,t,r,o,c=new y,a=new y,d=new O.ResourceMap,R=new y,M=new O.ResourceMap,q=!0){this._defaultConfiguration=n,this._policyConfiguration=t,this._applicationConfiguration=r,this._localUserConfiguration=o,this._remoteUserConfiguration=c,this._workspaceConfiguration=a,this._folderConfigurations=d,this._memoryConfiguration=R,this._memoryConfigurationByResource=M,this._freeze=q,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new O.ResourceMap,this._userConfiguration=null}getValue(n,t,r){return this.getConsolidatedConfigurationModel(n,t,r).getValue(n)}updateValue(n,t,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new y,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(n):o.setValue(n,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,r){const o=this.getConsolidatedConfigurationModel(n,t,r),c=C.distinct(o.overrides.map(R=>R.identifiers).flat()).filter(R=>o.getOverrideValue(n,R)!==void 0),a=this.getFolderConfigurationModelForResource(t.resource,r),d=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration;return new S(n,t,o.getValue(n),c.length?c:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),r?this._workspaceConfiguration.freeze():void 0,a?a.freeze():void 0,d.inspect(n,t.overrideIdentifier))}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const r=[];if(!t){const{added:o,updated:c,removed:a}=f(this._defaultConfiguration,n);t=[...o,...c,...a]}for(const o of t)for(const c of(0,b.overrideIdentifiersFromKey)(o)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(c),d=n.getKeysForOverrideIdentifier(c),R=[...d.filter(M=>a.indexOf(M)===-1),...a.filter(M=>d.indexOf(M)===-1),...a.filter(M=>!P.equals(this._defaultConfiguration.override(c).getValue(M),n.override(c).getValue(M)))];r.push([c,R])}return this.updateDefaultConfiguration(n),{keys:t,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:t,updated:r,removed:o}=f(this._policyConfiguration,n),c=[...t,...r,...o];return c.length&&this.updatePolicyConfiguration(n),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:t,updated:r,removed:o,overrides:c}=f(this.applicationConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateApplicationConfiguration(n),{keys:a,overrides:c}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:r,removed:o,overrides:c}=f(this.localUserConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateLocalUserConfiguration(n),{keys:a,overrides:c}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:r,removed:o,overrides:c}=f(this.remoteUserConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateRemoteUserConfiguration(n),{keys:a,overrides:c}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:r,removed:o,overrides:c}=f(this.workspaceConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateWorkspaceConfiguration(n),{keys:a,overrides:c}}compareAndUpdateFolderConfiguration(n,t){const r=this.folderConfigurations.get(n),{added:o,updated:c,removed:a,overrides:d}=f(r,t),R=[...o,...c,...a];return(R.length||!r)&&this.updateFolderConfiguration(n,t),{keys:R,overrides:d}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:c,overrides:a}=f(t,void 0);return{keys:[...r,...o,...c],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,t,r){let o=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:n},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const o=t.getFolder(n);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const c=this._memoryConfigurationByResource.get(n);c&&(r=r.merge(c))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(t=r.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=r}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const r=t.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:r,overrides:o,keys:c}=this._folderConfigurations.get(t);return n.push([t,{contents:r,overrides:o,keys:c}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.policy),o=this.parseConfigurationModel(n.application),c=this.parseConfigurationModel(n.user),a=this.parseConfigurationModel(n.workspace),d=n.folders.reduce((R,M)=>(R.set(u.URI.revive(M[0]),this.parseConfigurationModel(M[1])),R),new O.ResourceMap);return new l(t,r,o,c,new y,a,d,new y,new O.ResourceMap,!1)}static parseConfigurationModel(n){return new y(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=l;function g(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const n=new Set,t=new Map;for(const o of i)o.keys.forEach(c=>n.add(c)),o.overrides.forEach(([c,a])=>{const d=(0,O.getOrSet)(t,c,new Set);a.forEach(R=>d.add(R))});const r=[];return t.forEach((o,c)=>r.push([c,[...o.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=g;class w{constructor(n,t,r,o){this.change=n,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const c=new Set;n.keys.forEach(d=>c.add(d)),n.overrides.forEach(([,d])=>d.forEach(R=>c.add(R))),this.affectedKeys=[...c.values()];const a=new y;this.affectedKeys.forEach(d=>a.setValue(d,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=l.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!P.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let r=(0,m.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(n=n[o],!n)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=w;function f(i,n){const{added:t,removed:r,updated:o}=s(n?.rawConfiguration,i?.rawConfiguration),c=[],a=i?.getAllOverrideIdentifiers()||[],d=n?.getAllOverrideIdentifiers()||[];if(n){const R=d.filter(M=>!a.includes(M));for(const M of R)c.push([M,n.getKeysForOverrideIdentifier(M)])}if(i){const R=a.filter(M=>!d.includes(M));for(const M of R)c.push([M,i.getKeysForOverrideIdentifier(M)])}if(n&&i){for(const R of a)if(d.includes(R)){const M=s({contents:i.getOverrideValue(void 0,R)||{},keys:i.getKeysForOverrideIdentifier(R)},{contents:n.getOverrideValue(void 0,R)||{},keys:n.getKeysForOverrideIdentifier(R)});c.push([R,[...M.added,...M.removed,...M.updated]])}}return{added:t,removed:r,updated:o,overrides:c}}function s(i,n){const t=i?n?i.keys.filter(c=>n.keys.indexOf(c)===-1):[...i.keys]:[],r=n?i?n.keys.filter(c=>i.keys.indexOf(c)===-1):[...n.keys]:[],o=[];if(i&&n){for(const c of n.keys)if(i.keys.indexOf(c)!==-1){const a=(0,m.getConfigurationValue)(n.contents,c),d=(0,m.getConfigurationValue)(i.contents,c);P.equals(a,d)||o.push(c)}}return{added:t,removed:r,updated:o}}}),define(Q[120],ee([0,1,19,4,2,26,8,21,65,40,9,36,33]),function(_,e,C,D,I,k,O,P,h,u,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class y extends I.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new v(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(p.Registry.as(u.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:w})=>this.onDidUpdateConfiguration(g,w))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(g,w){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=y;class v extends h.ConfigurationModel{constructor(g={}){const w=p.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(w),s=Object.create(null),i=[];for(const n in w){const t=g[n],r=t!==void 0?t:w[n].default;(0,P.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))u.OVERRIDE_PROPERTY_REGEX.test(n)&&i.push({identifiers:(0,u.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,P.toValuesTree)(s[n],t=>console.error(`Conflict in default settings file: ${t}`))});super(s,f,i)}}e.DefaultConfigurationModel=v;class E{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new h.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=E;let S=class extends I.Disposable{get configurationModel(){return this._configurationModel}constructor(g,w,f){super(),this.defaultConfiguration=g,this.policyService=w,this.logService=f,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new h.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.registerPolicyDefinitions(g),!0))),this._configurationModel}async registerPolicyDefinitions(g){const w={},f=[],s=p.Registry.as(u.Extensions.Configuration).getConfigurationProperties();for(const i of g){const n=s[i];if(!n){f.push(i);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.logService.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}f.push(i),w[n.policy.name]={type:n.type}}}return(0,O.isEmptyObject)(w)||await this.policyService.registerPolicyDefinitions(w),f}onDidChangePolicies(g){const w=p.Registry.as(u.Extensions.Configuration).getPolicyConfigurations(),f=(0,C.coalesce)(g.map(s=>w.get(s)));this.update(f,!0)}update(g,w){const f=p.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),s=[],i=this._configurationModel.isEmpty();for(const n of g){const t=f[n]?.policy?.name;if(t){const r=this.policyService.getPolicyValue(t);(i?r!==void 0:!(0,k.equals)(this._configurationModel.getValue(n),r))&&s.push([n,r])}else this._configurationModel.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){const n=this._configurationModel;this._configurationModel=new h.ConfigurationModel;for(const t of n.keys)this._configurationModel.setValue(t,n.getValue(t));for(const[t,r]of s)r===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,r);w&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};S=he([te(1,b.IPolicyService),te(2,m.ILogService)],S),e.PolicyConfiguration=S}),define(Q[121],ee([0,1,3,4,2,17,21,65,120,36]),function(_,e,C,D,I,k,O,P,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class m extends I.Disposable{constructor(p,y,v,E){super(),this.settingsResource=p,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new h.DefaultConfiguration),this.policyConfiguration=v instanceof u.NullPolicyService?new h.NullPolicyConfiguration:this._register(new h.PolicyConfiguration(this.defaultConfiguration,v,E)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,y)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:S,properties:l})=>this.onDidDefaultConfigurationChange(S,l))),this._register(this.policyConfiguration.onDidChangeConfiguration(S=>this.onDidPolicyConfigurationChange(S))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[p,y,v]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(p,y,new P.ConfigurationModel,v)}getConfigurationData(){return this.configuration.toData()}getValue(p,y){const v=typeof p=="string"?p:void 0,E=(0,O.isConfigurationOverrides)(p)?p:(0,O.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(v,E,void 0)}updateValue(p,y,v,E){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const y=this.configuration.toData(),v=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(v,y,2)}onDidDefaultConfigurationChange(p,y){const v=this.configuration.toData(),E=this.configuration.compareAndUpdateDefaultConfiguration(p,y);this.trigger(E,v,7)}onDidPolicyConfigurationChange(p){const y=this.configuration.toData(),v=this.configuration.compareAndUpdatePolicyConfiguration(p);this.trigger(v,y,7)}trigger(p,y,v){const E=new P.ConfigurationChangeEvent(p,{data:y},this.configuration);E.source=v,E.sourceConfig=this.getTargetConfiguration(v),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(p){switch(p){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=m}),define(Q[122],ee([0,1,16]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function D(u){return u.scheme===C.Schemas.vscodeRemote?u.authority:void 0}e.getRemoteAuthority=D;function I(u){if(!u)return;const m=u.indexOf("+");return m<0?u:u.substr(0,m)}e.getRemoteName=I;function k(u){return`/${u.quality??"oss"}-${u.commit??"dev"}`}e.getRemoteServerRootPath=k;function O(u){const{host:m,port:b}=h(u);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:m,port:b}}e.parseAuthorityWithPort=O;function P(u,m){let{host:b,port:p}=h(u);return typeof p>"u"&&(p=m),{host:b,port:p}}e.parseAuthorityWithOptionalPort=P;function h(u){const m=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(m)return{host:m[1],port:parseInt(m[2],10)};const b=u.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const p=u.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:u,port:void 0}}}),define(Q[29],ee([0,1,27,7,122]),function(_,e,C,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=k;function O(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var h;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(h=e.TargetPlatform||(e.TargetPlatform={}));class u{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,S){if(typeof E>"u"||E===null)return typeof S>"u"||S===null;if(typeof S>"u"||S===null)return!1;if(typeof E=="string"||typeof S=="string"){const l=typeof E=="string"?E:E.value,g=typeof S=="string"?S:S.value;return C.equalsIgnoreCase(l,g)}return E._lower===S._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=u;function m(v){return b(v)}e.isApplicationScopedExtension=m;function b(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function p(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function y(v,E){if(E){const S=`onResolveRemoteAuthority:${(0,I.getRemoteName)(E)}`;return v.activationEvents?.indexOf(S)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[24],ee([0,1,27,23,29,12,10,11,32]),function(_,e,C,D,I,k,O,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function u(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,C.compareIgnoreCase)(n.id,t.id)===0}e.areSameExtensions=u;const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(t){const r=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new b(t.identifier,r,o)}static parse(t){const r=m.exec(t);return r&&r[1]&&r[2]?new b({id:r[1]},r[2],r[4]||void 0):null}constructor(t,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof b?u(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=b;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(n){const t=p.exec(n);return t&&t[1]?[E(t[1]),t[2]]:[E(n),void 0]}e.getIdAndVersion=y;function v(n,t){return`${n}.${t}`}e.getExtensionId=v;function E(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=E;function S(n,t){return E(v(n,t))}e.getGalleryExtensionId=S;function l(n,t){const r=[],o=c=>{for(const a of r)if(a.some(d=>u(t(d),t(c))))return a;return null};for(const c of n){const a=o(c);a?a.push(c):r.push([c])}return r}e.groupByExtension=l;function g(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function w(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function f(n,t){const r=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&r.every(a=>!u(a.identifier,{id:c}))){const a=n.filter(d=>u(d.identifier,{id:c}));a.length===1&&(r.push(a[0]),o.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=f;async function s(n,t){if(!k.isLinux)return!1;let r;try{r=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){t.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=s;async function i(n,t){const r=await s(n,t),o=(0,D.getTargetPlatform)(r?"alpine":k.platform,h.arch);return t.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=i}),define(Q[123],ee([0,1,22,11,16,17,38,10,85,23,24,29]),function(_,e,C,D,I,k,O,P,h,u,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const p=S=>(0,h.localize)(0,null,S),y=(0,h.localize)(1,null,"ms-dotnettools.csharp");function v(S,l){return l?`${S.publisher}.${S.name}@${S.version}`:`${S.publisher}.${S.name}`}let E=class{constructor(l,g){this.extensionManagementService=l,this.extensionGalleryService=g}get location(){}async listExtensions(l,g,w,f=console){let s=await this.extensionManagementService.getInstalled(1,w);const i=b.EXTENSION_CATEGORIES.map(t=>t.toLowerCase());if(g&&g!==""){if(i.indexOf(g.toLowerCase())<0){f.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}s=s.filter(t=>t.manifest.categories?t.manifest.categories.map(o=>o.toLowerCase()).indexOf(g.toLowerCase())>-1:!1)}else if(g===""){f.log("Possible Categories: "),i.forEach(t=>{f.log(t)});return}this.location&&f.log((0,h.localize)(2,null,this.location)),s=s.sort((t,r)=>t.identifier.id.localeCompare(r.identifier.id));let n;for(const t of s)n!==t.identifier.id&&(n=t.identifier.id,f.log(v(t.manifest,l)))}async installExtensions(l,g,w,f,s=console){const i=[],n=[];l.length&&s.log(this.location?(0,h.localize)(3,null,this.location):(0,h.localize)(4,null));const t=await this.extensionManagementService.getInstalled(1,w.profileLocation),r=(d,R)=>{const M=t.find(q=>(0,m.areSameExtensions)(q.identifier,{id:d}));if(M){if(!f&&(!R||R==="prerelease"&&M.preRelease))return s.log((0,h.localize)(5,null,d,M.manifest.version,d)),!1;if(R&&M.manifest.version===R)return s.log((0,h.localize)(6,null,`${d}@${R}`)),!1}return!0},o=(d,R,M)=>{a.push({id:d,version:R!=="prerelease"?R:void 0,installOptions:{...w,isBuiltin:M,installPreReleaseVersion:R==="prerelease"||w.installPreReleaseVersion}})},c=[],a=[];for(const d of l)if(d instanceof P.URI)c.push(d);else{const[R,M]=(0,m.getIdAndVersion)(d);r(R,M)&&o(R,M,!1)}for(const d of g){const[R,M]=(0,m.getIdAndVersion)(d);r(R,M)&&o(R,M,!0)}if(c.length&&await Promise.all(c.map(async d=>{try{const R=await this.installVSIX(d,{...w,isBuiltin:!1},f,s);R&&n.push(R)}catch(R){s.error(R.message||R.stack||R),i.push(d.toString())}})),a.length){const d=await this.getGalleryExtensions(a);await Promise.all(a.map(async R=>{const M=d.get(R.id.toLowerCase());if(M)try{const q=await this.installFromGallery(R,M,t,f,s);q&&n.push(q)}catch(q){s.error(q.message||q.stack||q),i.push(R.id)}else s.error(`${p(R.version?`${R.id}@${R.version}`:R.id)}
${y}`),i.push(R.id)}))}if(i.length)throw new Error((0,h.localize)(7,null,i.join(", ")))}async installVSIX(l,g,w,f){const s=await this.extensionManagementService.getManifest(l);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,w,g.profileLocation,f))try{return await this.extensionManagementService.install(l,g),f.log((0,h.localize)(8,null,(0,k.basename)(l))),s}catch(n){if((0,D.isCancellationError)(n))return f.log((0,h.localize)(9,null,(0,k.basename)(l))),null;throw n}return null}async getGalleryExtensions(l){const g=new Map,w=l.some(s=>s.installOptions.installPreReleaseVersion),f=await this.extensionGalleryService.getExtensions(l.map(s=>({...s,preRelease:w})),C.CancellationToken.None);for(const s of f)g.set(s.identifier.id.toLowerCase(),s);return g}async installFromGallery({id:l,version:g,installOptions:w},f,s,i,n){const t=await this.extensionGalleryService.getManifest(f,C.CancellationToken.None);if(t&&!this.validateExtensionKind(t,n))return null;const r=s.find(o=>(0,m.areSameExtensions)(o.identifier,f.identifier));if(r){if(f.version===r.manifest.version)return n.log((0,h.localize)(10,null,g?`${l}@${g}`:l)),null;n.log((0,h.localize)(11,null,l,f.version))}try{w.isBuiltin?n.log(g?(0,h.localize)(12,null,l,g):(0,h.localize)(13,null,l)):n.log(g?(0,h.localize)(14,null,l,g):(0,h.localize)(15,null,l));const o=await this.extensionManagementService.installFromGallery(f,{...w,installGivenVersion:!!g});return n.log((0,h.localize)(16,null,l,o.manifest.version)),t}catch(o){if((0,D.isCancellationError)(o))return n.log((0,h.localize)(17,null,l)),null;throw o}}validateExtensionKind(l,g){return!0}async validateVSIX(l,g,w,f){const s={id:(0,m.getGalleryExtensionId)(l.publisher,l.name)},n=(await this.extensionManagementService.getInstalled(1,w)).find(t=>(0,m.areSameExtensions)(s,t.identifier)&&(0,O.gt)(t.manifest.version,l.version));return n&&!g?(f.log((0,h.localize)(18,null,n.identifier.id,n.manifest.version,l.version)),!1):this.validateExtensionKind(l,f)}async uninstallExtensions(l,g,w,f=console){const s=async n=>{if(n instanceof P.URI){const t=await this.extensionManagementService.getManifest(n);return v(t)}return n},i=[];for(const n of l){const t=await s(n),o=(await this.extensionManagementService.getInstalled(void 0,w)).filter(c=>(0,m.areSameExtensions)(c.identifier,{id:t}));if(!o.length)throw new Error(`${this.notInstalled(t)}
${y}`);if(o.some(c=>c.type===0)){f.log((0,h.localize)(19,null,t));return}if(!g&&o.some(c=>c.isBuiltin)){f.log((0,h.localize)(20,null,t));return}f.log((0,h.localize)(21,null,t));for(const c of o)await this.extensionManagementService.uninstall(c,{profileLocation:w}),i.push(c);this.location?f.log((0,h.localize)(22,null,t,this.location)):f.log((0,h.localize)(23,null,t))}}async locateExtension(l,g=console){const w=await this.extensionManagementService.getInstalled();l.forEach(f=>{w.forEach(s=>{if(s.identifier.id===f&&s.location.scheme===I.Schemas.file){g.log(s.location.fsPath);return}})})}notInstalled(l){return this.location?(0,h.localize)(24,null,l,this.location):(0,h.localize)(25,null,l)}};E=he([te(0,u.IExtensionManagementService),te(1,u.IExtensionGalleryService)],E),e.ExtensionManagementCLI=E}),define(Q[41],ee([0,1,3,14,2,39,10,24,13,7,9]),function(_,e,C,D,I,k,O,P,h,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,u.createDecorator)("IExtensionsProfileScannerService");let b=class extends I.Disposable{constructor(y,v){super(),this.fileService=y,this.logService=v,this.resourcesAccessQueueMap=new k.ResourceMap}scanProfileExtensions(y){return this.withProfileExtensions(y)}addExtensionsToProfile(y,v){return this.withProfileExtensions(v,E=>(E=E.filter(S=>y.some(([l])=>!(0,P.areSameExtensions)(S.identifier,l.identifier))),E.push(...y.map(([S,l])=>({identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:l}))),E))}removeExtensionFromProfile(y,v){return this.withProfileExtensions(v,E=>E.filter(S=>!(0,P.areSameExtensions)(S.identifier,y)))}async withProfileExtensions(y,v){return this.getResourceAccessQueue(y).queue(async()=>{let E=[];try{const S=await this.fileService.readFile(y),l=JSON.parse(S.value.toString());for(const g of l){if(!g.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",g);continue}if(!g.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",g);continue}if(!g.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",g);continue}E.push({identifier:g.identifier,location:O.URI.revive(g.location),version:g.version,metadata:g.metadata})}}catch(S){S.fileOperationResult!==1&&this.logService.error(S)}if(v){E=v(E);const S=E.map(l=>({identifier:l.identifier,version:l.version,location:l.location.toJSON(),metadata:l.metadata}));await this.fileService.writeFile(y,D.VSBuffer.fromString(JSON.stringify(S)))}return E})}getResourceAccessQueue(y){let v=this.resourcesAccessQueueMap.get(y);return v||(v=new C.Queue,this.resourcesAccessQueueMap.set(y,v)),v}};b=he([te(0,h.IFileService),te(1,m.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(Q[124],ee([0,1,3,11,2,16,12,17,38,30,20,21,18,23,24,59,13,9]),function(_,e,C,D,I,k,O,P,h,u,m,b,p,y,v,E,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let g=class We extends I.Disposable{constructor(f,s,i,n,t,r){super(),this.fileService=s,this.extensionGalleryService=i,this.configurationService=n,this.extensionSignatureVerificationService=t,this.logService=r,this.extensionsDownloadDir=f.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(f,s){await this.cleanUpPromise;const i=(0,P.joinPath)(this.extensionsDownloadDir,this.getName(f));try{await this.downloadFile(f,i,t=>this.extensionGalleryService.download(f,t,s))}catch(t){throw new y.ExtensionManagementError(t.message,y.ExtensionManagementErrorCode.Download)}let n=!1;if(f.isSigned&&this.configurationService.getValue("extensions.verifySignature")===!0){const t=await this.downloadSignatureArchive(f);try{n=await this.extensionSignatureVerificationService.verify(i.fsPath,t.fsPath),this.logService.info(`Verified extension: ${f.identifier.id}`,n)}catch(r){throw await this.delete(t),await this.delete(i),new y.ExtensionManagementError(r.code,y.ExtensionManagementErrorCode.Signature)}}return{location:i,verified:n}}async downloadSignatureArchive(f){await this.cleanUpPromise;const s=(0,P.joinPath)(this.extensionsDownloadDir,`${this.getName(f)}${We.SignatureArchiveExtension}`);return await this.downloadFile(f,s,i=>this.extensionGalleryService.downloadSignatureArchive(f,i)),s}async downloadFile(f,s,i){if(await this.fileService.exists(s))return;if(s.scheme!==k.Schemas.file){await i(s);return}const n=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,u.generateUuid)()}`);await this.fileService.exists(n)||await i(n);try{await this.rename(n,s,Date.now()+2*60*1e3)}catch(t){try{await this.fileService.del(n)}catch{}if(t.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",f.identifier.id,s.path);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(t)}. Deleted the file from downloaded location`,n.path),t}}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,s,i){try{await m.Promises.rename(f.fsPath,s.fsPath)}catch(n){if(O.isWindows&&n&&n.code==="EPERM"&&Date.now()<i)return this.logService.info(`Failed renaming ${f} to ${s} with 'EPERM' error. Trying again...`),this.rename(f,s,i);throw n}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const s=[],i=[],n=[];for(const o of f.children)if(o.name.endsWith(We.SignatureArchiveExtension))n.push(o.resource);else{const c=v.ExtensionKey.parse(o.name);c&&i.push([c,o])}const t=(0,v.groupByExtension)(i,([o])=>o),r=[];for(const o of t)o.sort((c,a)=>h.rcompare(c[0].version,a[0].version)),s.push(...o.slice(1).map(c=>c[1].resource)),r.push(o[0][1]);r.sort((o,c)=>o.mtime-c.mtime),s.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(o=>o.resource)),s.push(...n),await C.Promises.settled(s.map(o=>(this.logService.trace("Deleting from cache",o.path),this.fileService.del(o))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?v.ExtensionKey.create(f).toString().toLowerCase():(0,u.generateUuid)()}};g.SignatureArchiveExtension=".sigzip",g=he([te(0,p.INativeEnvironmentService),te(1,S.IFileService),te(2,y.IExtensionGalleryService),te(3,b.IConfigurationService),te(4,E.IExtensionSignatureVerificationService),te(5,l.ILogService)],g),e.ExtensionsDownloader=g}),define(Q[125],ee([0,1,2,15,20,29]),function(_,e,C,D,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends C.Disposable{constructor(h,u){super(),this.environmentService=h,this.extensionsManifestCache=(0,D.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(u.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(u.onDidUninstallExtension(m=>this.onDidUnInstallExtension(m)))}onDidInstallExtensions(h){h.some(u=>!!u.local)&&this.invalidate()}onDidUnInstallExtension(h){h.error||this.invalidate()}invalidate(){I.Promises.rm(this.extensionsManifestCache,I.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=O}),define(Q[126],ee([0,1,4,2,24,29]),function(_,e,C,D,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class O extends D.Disposable{constructor(h,u,m,b,p,y,v){super(),this.extensionManagementService=h,this.userDataProfilesService=u,this.extensionsProfileScannerService=m,this.extensionsScannerService=b,this.uriIdentityService=p,this.fileService=y,this.logService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.profileExtensionsLocations=new Map,this.initialize().then(()=>this.registerListeners(),E=>v.error(E))}async initialize(){await this.extensionManagementService.migrateDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles,[]),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(h=>this.onDidChangeProfiles(h.added,h.removed))),this._register(this.extensionManagementService.onDidInstallExtensions(h=>this.onDidInstallExtensions(h))),this._register(this.extensionManagementService.onDidUninstallExtension(h=>this.onDidUninstallExtension(h))),this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(C.Event.filter(this.fileService.onDidFilesChange,h=>h.rawChanges.some(u=>this.doesChangeAffects(u,this.extensionsScannerService.userExtensionsLocation)))(()=>this.onDidChange()))}doesChangeAffects(h,u){return h.type!==1&&h.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(h.resource),u)?!1:this.uriIdentityService.extUri.isEqual(h.resource,this.uriIdentityService.extUri.joinPath(u,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(h.resource).startsWith(".")}async onDidChange(){const u=(await this.extensionManagementService.getAllUserInstalled()).filter(m=>m.installedTimestamp!==void 0||this.profileExtensionsLocations.has(this.getKey(m.identifier,m.manifest.version))?!1:(this.logService.info("Detected extension installed from another source",m.identifier.id),!0));u.length&&(await this.extensionsProfileScannerService.addExtensionsToProfile(u.map(m=>[m,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this._onDidChangeExtensionsByAnotherSource.fire({added:u.map(m=>({identifier:m.identifier,operation:1,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,local:m})),removed:[]}))}async onDidChangeProfiles(h,u){try{await Promise.all(u.map(m=>this.removeExtensionsFromProfile(m.extensionsResource)))}catch(m){this.logService.error(m)}try{h.length&&await Promise.all(h.map(m=>this.populateExtensionsFromProfile(m.extensionsResource)))}catch(m){this.logService.error(m)}}async uninstallExtensionsNotInProfiles(){const u=(await this.extensionManagementService.getAllUserInstalled()).filter(m=>!this.profileExtensionsLocations.has(this.getKey(m.identifier,m.manifest.version)));u.length&&await this.extensionManagementService.markAsUninstalled(...u)}async onDidInstallExtensions(h){for(const{local:u,profileLocation:m}of h)!u||!m||this.addExtensionWithKey(this.getKey(u.identifier,u.manifest.version),m)}async onDidUninstallExtension(h){!h.profileLocation||!h.version||this.removeExtensionWithKey(this.getKey(h.identifier,h.version),h.profileLocation)&&await this.uninstallExtensions([{identifier:h.identifier,version:h.version}])}async populateExtensionsFromProfile(h){const u=await this.extensionsProfileScannerService.scanProfileExtensions(h);for(const m of u)this.addExtensionWithKey(this.getKey(m.identifier,m.version),h)}async removeExtensionsFromProfile(h){const u=[];for(const m of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(m,h))continue;const b=this.fromKey(m);b&&u.push(b)}u.length&&await this.uninstallExtensions(u)}addExtensionWithKey(h,u){let m=this.profileExtensionsLocations.get(h);m||(m=[],this.profileExtensionsLocations.set(h,m)),m.push(u)}removeExtensionWithKey(h,u){const m=this.profileExtensionsLocations.get(h);if(m){const b=m.findIndex(p=>this.uriIdentityService.extUri.isEqual(p,u));b>-1&&m.splice(b,1)}return m?.length?!1:(this.profileExtensionsLocations.delete(h),!0)}async uninstallExtensions(h){const m=(await this.extensionManagementService.getAllUserInstalled()).filter(b=>h.some(p=>this.getKey(b.identifier,b.manifest.version)===this.getKey(p.identifier,p.version)));m.length&&await this.extensionManagementService.markAsUninstalled(...m)}getKey(h,u){return`${k.ExtensionIdentifier.toKey(h.id)}@${u}`}fromKey(h){const[u,m]=(0,I.getIdAndVersion)(h);return m?{identifier:{id:u},version:m}:void 0}}e.ExtensionsWatcher=O}),define(Q[127],ee([0,1,157,19,3,2,16,15,20,18,23,24,9,63,12,10]),function(_,e,C,D,I,k,O,P,h,u,m,b,p,y,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let S=class extends y.LanguagePackBaseService{constructor(f,s,i,n){super(i),this.extensionManagementService=f,this.logService=n,this.cache=this._register(new l(s,n)),this.extensionManagementService.registerParticipant({postInstall:async t=>this.postInstallExtension(t),postUninstall:async t=>this.postUninstallExtension(t)})}async getBuiltInExtensionTranslationsUri(f){const i=(await this.cache.getLanguagePacks())[v.Language.value()];if(!i){this.logService.warn(`No language pack found for ${v.Language.value()}`);return}const n=i.translations[f];return n?E.URI.file(n):void 0}async getInstalledLanguages(){const f=await this.cache.getLanguagePacks(),s=Object.keys(f).map(i=>{const n=f[i];return{...this.createQuickPickItem(i,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return s.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),s.sort((i,n)=>i.label.localeCompare(n.label)),s}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const s=await this.cache.getLanguagePacks();Object.keys(s).some(i=>s[i]&&s[i].extensions.some(n=>(0,b.areSameExtensions)(n.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,s]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),i=await this.cache.update(s);return!(0,D.equals)(Object.keys(f),Object.keys(i))}};S=he([te(0,m.IExtensionManagementService),te(1,u.INativeEnvironmentService),te(2,m.IExtensionGalleryService),te(3,p.ILogService)],S),e.NativeLanguagePackService=S;let l=class extends k.Disposable{constructor(f,s){super(),this.logService=s,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new I.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(s=>{Object.keys(s).forEach(i=>delete s[i]),this.createLanguagePacksFromExtensions(s,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...s){for(const i of s)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,i);Object.keys(f).forEach(i=>this.updateHash(f[i]))}createLanguagePacksFromExtension(f,s){const i=s.identifier,n=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const t of n)if(s.location.scheme===O.Schemas.file&&g(t)){let r=f[t.languageId];r||(r={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},f[t.languageId]=r);const o=r.extensions.filter(c=>(0,b.areSameExtensions)(c.extensionIdentifier,i))[0];o?o.version=s.manifest.version:r.extensions.push({extensionIdentifier:i,version:s.manifest.version});for(const c of t.translations)r.translations[c.id]=(0,P.join)(s.location.fsPath,c.path)}}updateHash(f){if(f){const s=(0,C.createHash)("md5");for(const i of f.extensions)s.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);f.hash=s.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let s=null;return h.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch{return{}}}).then(i=>(s=f(i),i)).then(i=>{for(const t of Object.keys(i))i[t]||delete i[t];this.languagePacks=i,this.initializedCache=!0;const n=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",n),h.Promises.writeFile(this.languagePacksFilePath,n)}).then(()=>s,i=>this.logService.error(i))})}};l=he([te(0,u.INativeEnvironmentService),te(1,p.ILogService)],l);function g(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const f of w.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}}),define(Q[47],ee([0,1,14,95,40,7,33]),function(_,e,C,D,I,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function P(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.isSuccess=P;function h(E){return E.res.statusCode===204}async function u(E){return h(E)?null:(await(0,C.streamToBuffer)(E.stream)).toString()}e.asText=u;async function m(E){if(!P(E))throw new Error("Server returned "+E.res.statusCode);return u(E)}e.asTextOrError=m;async function b(E){if(!P(E))throw new Error("Server returned "+E.res.statusCode);if(h(E))return null;const l=(await(0,C.streamToBuffer)(E.stream)).toString();try{return JSON.parse(l)}catch(g){throw g.message+=`:
`+l,g}}e.asJson=b;function p(E){v(E)}e.updateProxyConfigurationsScope=p;let y;function v(E){const S=O.Registry.as(I.Extensions.Configuration),l=y;y={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},S.updateConfigurations({add:[y],remove:l?[l]:[]})}v(2)}),define(Q[128],ee([0,1,22,16,13,47]),function(_,e,C,D,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let O=class{constructor(h,u){this.requestService=h,this.fileService=u}async download(h,u,m=C.CancellationToken.None){if(h.scheme===D.Schemas.file||h.scheme===D.Schemas.vscodeRemote){await this.fileService.copy(h,u);return}const b={type:"GET",url:h.toString(!0)},p=await this.requestService.request(b,m);if(p.res.statusCode===200)await this.fileService.writeFile(u,p.stream);else{const y=await(0,k.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${y}`)}}};O=he([te(0,k.IRequestService),te(1,I.IFileService)],O),e.DownloadService=O}),define(Q[129],ee([0,1,130,8]),function(_,e,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function I(O,P){return O.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:O.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function k(O,P,h={}){const u=(0,C.parse)(O),m=h.proxyUrl||I(u,P);if(!m)return null;const b=(0,C.parse)(m);if(!/^https?:$/.test(b.protocol||""))return null;const p={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,D.isBoolean)(h.strictSSL)?h.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((y,v)=>{_(["http-proxy-agent"],y,v)}))(p):new(await new Promise((y,v)=>{_(["https-proxy-agent"],y,v)}))(p)}e.getProxyAgent=k}),define(Q[131],ee([0,1,57,15,96,22,31,11,12,30,78,158,3]),function(_,e,C,D,I,k,O,P,h,u,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let v;async function E(l,g,w){return g["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(w)&&!g["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(w)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=p.Promises.withAsyncBody(async(f,s)=>{const i=new k.CancellationTokenSource,n=setTimeout(()=>{i.dispose(!0),s(new Error((0,I.localize)(0,null)))},y);try{f(await S(l,i.token))}catch(t){!(0,P.isCancellationError)(t)&&!i.token.isCancellationRequested?s(new Error((0,I.localize)(1,null,(0,O.toErrorMessage)(t)))):f({})}finally{clearTimeout(n),i.dispose()}})),v)}e.getResolvedShellEnv=E;async function S(l,g){const w=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",w);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",f);const s=(0,u.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",n);const t=await(0,m.getSystemShell)(h.OS,n);return l.trace("getUnixShellEnvironment#shell",t),new Promise((r,o)=>{if(g.isCancellationRequested)return o((0,P.canceled)());const c=(0,D.basename)(t);let a,d;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(a=`& '${process.execPath}' ${R} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,d=["-Login","-Command"]):(a=`'${process.execPath}' ${R} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,c==="tcsh"?d=["-ic"]:d=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),a);const M=(0,C.spawn)(t,[...d,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});g.onCancellationRequested(()=>(M.kill(),o((0,P.canceled)()))),M.on("error",J=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,O.toErrorMessage)(J)),o(J)});const q=[];M.stdout.on("data",J=>q.push(J));const X=[];M.stderr.on("data",J=>X.push(J)),M.on("close",(J,ie)=>{const oe=Buffer.concat(q).toString("utf8");l.trace("getUnixShellEnvironment#raw",oe);const Z=Buffer.concat(X).toString("utf8");if(Z.trim()&&l.trace("getUnixShellEnvironment#stderr",Z),J||ie)return o(new Error((0,I.localize)(2,null,J,ie)));const ge=i.exec(oe),ce=ge?ge[1]:"{}";try{const re=JSON.parse(ce);w?re.ELECTRON_RUN_AS_NODE=w:delete re.ELECTRON_RUN_AS_NODE,f?re.ELECTRON_NO_ATTACH_CONSOLE=f:delete re.ELECTRON_NO_ATTACH_CONSOLE,delete re.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",re),r(re)}catch(re){l.error("getUnixShellEnvironment#errorCaught",(0,O.toErrorMessage)(re)),o(re)}})})}}),define(Q[66],ee([0,1,7]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,C.createDecorator)("stateService")}),define(Q[132],ee([0,1,3,14,8,18,13,9]),function(_,e,C,D,I,k,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class h{constructor(b,p,y){this.storagePath=b,this.logService=p,this.fileService=y,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new C.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(b){b.fileOperationResult!==1&&this.logService.error(b)}}getItem(b,p){const y=this.storage[b];return(0,I.isUndefinedOrNull)(y)?p:y}setItem(b,p){this.setItems([{key:b,data:p}])}setItems(b){let p=!1;for(const{key:y,data:v}of b)this.storage[y]!==v&&((0,I.isUndefinedOrNull)(v)?(0,I.isUndefined)(this.storage[y])||(this.storage[y]=void 0,p=!0):(this.storage[y]=v,p=!0));p&&this.save()}removeItem(b){(0,I.isUndefined)(this.storage[b])||(this.storage[b]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const b=JSON.stringify(this.storage,null,4);if(b!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,D.VSBuffer.fromString(b)),this.lastSavedStorageContents=b}catch(p){this.logService.error(p)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=h;let u=class{constructor(b,p,y){this.fileStorage=new h(b.stateResource,p,y)}async init(){await this.fileStorage.init()}getItem(b,p){return this.fileStorage.getItem(b,p)}};u=he([te(0,k.IEnvironmentService),te(1,P.ILogService),te(2,O.IFileService)],u),e.StateService=u}),define(Q[67],ee([0,1,12,32,10,30]),function(_,e,C,D,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(u){if(C.platform===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}async function P(u,m,b,p,y,v,E,S,l,g){const w=Object.create(null);w["common.machineId"]=E,w.sessionID=(0,k.generateUuid)()+Date.now(),w.commitHash=y,w.version=v,w["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,C.PlatformToString)(C.platform),w["common.nodePlatform"]=D.platform,w["common.nodeArch"]=p,w["common.product"]=g||"desktop",S&&(w["common.msftInternal"]=S);let f=0;const s=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),C.isLinuxSnap&&(w["common.snap"]="true");const i=O(b);i&&(w["common.platformDetail"]=i);try{const n=await u.readFile(I.URI.file(l));w["common.source"]=n.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=P;function h(u){const m=D.env.USERDNSDOMAIN;if(!m)return!1;const b=m.toLowerCase();return u.some(p=>b===p)}e.verifyMicrosoftInternalDomain=h}),define(Q[34],ee([0,1,7]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,C.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(D=e.TelemetryLevel||(e.TelemetryLevel={}));var I;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(I=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Q[42],ee([0,1,26,52,8,21,67,34]),function(_,e,C,D,I,k,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class h{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,D.staticObservableValue)(0)}publicLog(r,o){return Promise.resolve(void 0)}publicLog2(r,o){return this.publicLog(r,o)}publicLogError(r,o){return Promise.resolve(void 0)}publicLogError2(r,o){return this.publicLogError(r,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=h,e.NullTelemetryService=new h;class u{async publicLog(r,o,c){}async publicLogError(r,o,c){}}e.NullEndpointTelemetryService=u,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(t,r){return r.onDidChangeConfiguration(o=>{o.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(o.source),configurationKeys:l(o.sourceConfig)})})}e.configurationTelemetry=m;function b(t,r){return!(r.disableTelemetry||!t.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=b;function p(t){const r=t.getValue(P.TELEMETRY_SETTING_ID),o=t.getValue("telemetry.enableCrashReporter");if(t.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function y(t){const r={},o={},c={};S(t,c);for(let a in c){a=a.length>150?a.substr(a.length-149):a;const d=c[a];typeof d=="number"?o[a]=d:typeof d=="boolean"?o[a]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${d.length}`),r[a]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(r[a]=d)}return{properties:r,measurements:o}}e.validateTelemetryData=y;const v=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function E(t){if(!t)return"none";for(const r of v)if(t.startsWith(`${r}+`))return r;return"other"}e.cleanRemoteAuthority=E;function S(t,r,o=0,c){if(!!t)for(const a of Object.getOwnPropertyNames(t)){const d=t[a],R=c?c+a:a;Array.isArray(d)?r[R]=(0,C.safeStringify)(d):d instanceof Date?r[R]=d.toISOString():(0,I.isObject)(d)?o<2?S(d,r,o+1,R+"."):r[R]=(0,C.safeStringify)(d):r[R]=d}}function l(t){if(!t)return[];const r=[];return g(r,"",t),r}function g(t,r,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(c=>g(t,r?`${r}.${c}`:c,o[c])):t.push(r)}function w(t,r){const o=t.msftInternalDomains||[],c=r.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(o)||c}e.isInternalTelemetry=w;function f(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.getPiiPathsFromEnvironment=f;function s(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let o=t;const c=[];for(const M of r)for(;;){const q=M.exec(t);if(!q)break;c.push([q.index,M.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let R=0;for(o="";;){const M=d.exec(t);if(!M)break;const q=c.some(([X,J])=>M.index<J&&X<d.lastIndex);!a.test(M[0])&&!q&&(o+=t.substring(R,M.index)+"<REDACTED: user-file-path>",R=d.lastIndex)}return R<t.length&&(o+=t.substr(R)),o}function i(t){if(!t)return t;const r=t.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of o)if(c.regex.test(r))return`<REDACTED: ${c.label}>`;return t}function n(t,r){return(0,C.cloneAndChange)(t,o=>{if(typeof o=="string"){let c=o;c=s(c,r);for(const a of r)c=c.replace(a,"");return c=i(c),c}})}e.cleanData=n}),define(Q[133],ee([0,1,104,42]),function(_,e,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function I(k,O,P,h,u,m,b){const p={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${O.nameShort})`};if((0,D.supportsTelemetry)(O,P)&&(0,D.getTelemetryLevel)(h)===3){const y=await(0,C.getServiceMachineId)(P,u,m),{sessionId:v}=await b.getTelemetryInfo();p["X-Market-User-Id"]=y,p["VSCode-SessionId"]=v}return p}e.resolveMarketplaceHeaders=I}),define(Q[134],ee([0,1,11,26,42]),function(_,e,C,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const k="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function O(h,u,m){const b=await new Promise((S,l)=>{_(["@microsoft/1ds-core-js"],S,l)}),p=await new Promise((S,l)=>{_(["@microsoft/1ds-post-js"],S,l)}),y=new b.AppInsightsCore,v=new p.PostChannel,E={instrumentationKey:h,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(m){E.extensionConfig={};const S={alwaysUseXhrOverride:!0,httpXHROverride:m};E.extensionConfig[v.identifier]=S}return y.initialize(E,[]),y.addTelemetryInitializer(S=>{u&&(S.ext=S.ext??{},S.ext.utc=S.ext.utc??{},S.ext.utc.flags=8462029)}),y}class P{constructor(u,m,b,p,y){this._isInternalTelemetry=u,this._eventPrefix=m,this._defaultData=b,this._xhrOverride=y,this.endPointUrl=k,this._defaultData||(this._defaultData={}),typeof p=="function"?this._aiCoreOrKey=p():this._aiCoreOrKey=p,this._asyncAiCore=null}_withAIClient(u){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){u(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=O(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(m=>{u(m)},m=>{(0,C.onUnexpectedError)(m),console.error(m)})}}log(u,m){if(!this._aiCoreOrKey)return;m=(0,D.mixin)(m,this._defaultData),m=(0,I.validateTelemetryData)(m);const b=this._eventPrefix+"/"+u;try{this._withAIClient(p=>{p.pluginVersionString=m?.properties.version??"Unknown",p.track({name:b,baseData:{name:b,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(u=>{this._withAIClient(m=>{m.unload(!0,()=>{this._aiCoreOrKey=void 0,u(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(Q[135],ee([0,1,2,26,52,12,27,97,21,40,136,28,33,34,42]),function(_,e,C,D,I,k,O,P,h,u,m,b,p,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(g,w,f){this._configurationService=w,this._productService=f,this._experimentProperties={},this.telemetryLevel=new I.MutableObservableValue(3),this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,w){this._experimentProperties[g]=w}_updateTelemetryLevel(){let g=(0,v.getTelemetryLevel)(this._configurationService);const w=this._productService.enabledTelemetryLevels;if(w){this._sendErrorTelemetry=this.sendErrorTelemetry?w.error:!1;const f=w.usage?3:w.error?2:0;g=Math.min(g,f)}this.telemetryLevel.value=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const g=await this._commonProperties,w=g.sessionID,f=g["common.machineId"],s=g["common.firstSessionDate"],i=g["common.msftInternal"];return{sessionId:w,machineId:f,firstSessionDate:s,msftInternal:i}}dispose(){this._disposables.dispose()}_log(g,w,f,s){return this.telemetryLevel.value<w?Promise.resolve(void 0):this._commonProperties.then(i=>{f=(0,D.mixin)(f,this._experimentProperties),f=(0,v.cleanData)(f,this._cleanupPatterns),f=(0,D.mixin)(f,i),this._appenders.forEach(n=>n.log(g,f))},i=>{console.error(i)})}publicLog(g,w,f){return this._log(g,3,w,f)}publicLog2(g,w,f){return this.publicLog(g,w,f)}publicLogError(g,w){return this._sendErrorTelemetry?this._log(g,2,w,!0):Promise.resolve(void 0)}publicLogError2(g,w){return this.publicLogError(g,w)}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=he([te(1,h.IConfigurationService),te(2,b.IProductService)],E),e.TelemetryService=E;function S(){const l=(0,P.localize)(0,null,m.default.nameLong),g=m.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=k.isWeb?"":(0,P.localize)(3,null),f=(0,P.localize)(4,null),s=(0,P.localize)(5,null),i=(0,P.localize)(6,null),n=(0,P.localize)(7,null),t=`
|       | ${f} | ${s} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,P.localize)(8,null);return`
${l} ${g} ${w}

&nbsp;

${n}
${t}

&nbsp;

${r}
`}p.Registry.as(u.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:S(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(u.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,P.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,P.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[137],ee([0,1,159,134]),function(_,e,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class I extends D.AbstractOneDataSystemAppender{constructor(O,P,h,u){const m={sendPOST:(b,p)=>{const y={method:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data)}};try{const v=C.request(b.urlString,y,E=>{E.on("data",function(S){p(E.statusCode??200,E.headers,S.toString())}),E.on("error",function(S){p(0,{})})});v.write(b.data),v.end()}catch{p(0,{})}}};super(O,P,h,u,m)}}e.OneDataSystemAppender=I}),define(Q[138],ee([0,1,15,20]),function(_,e,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function I(k,O){const P=Object.create(null),h=(m,b)=>{const p=JSON.parse(m);P[b]=p};if(O){const m=[],b=await D.Promises.readdir(O);for(const y of b)try{(await D.Promises.stat((0,C.join)(O,y))).isDirectory()&&m.push(y)}catch{}const p=[];for(const y of m)(await D.Promises.readdir((0,C.join)(O,y))).filter(E=>E==="telemetry.json").length===1&&p.push(y);for(const y of p){const v=(await D.Promises.readFile((0,C.join)(O,y,"telemetry.json"))).toString();h(v,y)}}let u=(await D.Promises.readFile((0,C.join)(k,"telemetry-core.json"))).toString();return h(u,"vscode-core"),u=(await D.Promises.readFile((0,C.join)(k,"telemetry-extensions.json"))).toString(),h(u,"vscode-extensions"),JSON.stringify(P,null,4)}e.buildTelemetryMessage=I}),define(Q[35],ee([0,1,7]),function(_,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,C.createDecorator)("IUriIdentityService")}),define(Q[139],ee([0,1,35,105,13,17,70,4,2]),function(_,e,C,D,I,k,O,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class u{constructor(p){this.uri=p,this.time=u._clock++}touch(){return this.time=u._clock++,this}}u._clock=0;let m=class{constructor(p){this._fileService=p,this._dispooables=new h.DisposableStore,this._limit=2**16;const y=new Map,v=E=>{let S=y.get(E.scheme);return S===void 0&&(S=p.hasProvider(E)&&!this._fileService.hasCapability(E,1024),y.set(E.scheme,S)),S};this._dispooables.add(P.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(E=>{y.delete(E.scheme)})),this.extUri=new k.ExtUri(v),this._canonicalUris=new O.SkipList((E,S)=>this.extUri.compare(E,S,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(p){this._fileService.hasProvider(p)&&(p=(0,k.normalizePath)(p));const y=this._canonicalUris.get(p);return y?y.touch().uri.with({fragment:p.fragment}):(this._canonicalUris.set(p,new u(p)),this._checkTrim(),p)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const p=[...this._canonicalUris.entries()].sort((v,E)=>v[1].touch<E[1].touch?1:v[1].touch>E[1].touch?-1:0);u._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let v=0;v<y;v++)this._canonicalUris.set(p[v][0],p[v][1].touch())}};m=he([te(0,I.IFileService)],m),e.UriIdentityService=m,(0,D.registerSingleton)(C.IUriIdentityService,m,1)}),define(Q[140],ee([0,1,99,15,113,17,10,7,16]),function(_,e,C,D,I,k,O,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function u(n){const t=n;return typeof t?.id=="string"&&O.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=u,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function m(n,t){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,D.basename)(n)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=n;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=m;function b(n){const t=n;return typeof t?.id=="string"&&O.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=b;function p(n){const t=n;if(t?.uri)return{id:t.id,uri:O.URI.revive(t.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=p;var y;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function v(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=v;function E(n){const t=n;return!!(t&&typeof t=="object"&&O.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=E;class S{constructor(t,r,o,c,a){this._id=t,this._transient=o,this._configuration=c,this._ignorePathCasing=a,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=S;class l{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,k.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function g(n){return new l({uri:n,index:0,name:(0,k.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,C.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(n,t){return k.extUriBiasedIgnorePathCase.isEqualOrParent(n,t.untitledWorkspacesHome)}e.isUntitledWorkspace=w;function f(n){let t;return O.URI.isUri(n)?t=n:t=n.configuration,t?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=f;function s(n,t){return!w(n,t)&&!f(n)}e.isSavedWorkspace=s;function i(n){return(typeof n=="string"?(0,D.extname)(n):(0,k.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(Q[25],ee([0,1,53,4,2,17,10,98,18,13,7,9,140,39,35,3,30,27]),function(_,e,C,D,I,k,O,P,h,u,m,b,p,y,v,E,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function g(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&O.URI.isUri(t.location)&&O.URI.isUri(t.globalStorageHome)&&O.URI.isUri(t.settingsResource)&&O.URI.isUri(t.keybindingsResource)&&O.URI.isUri(t.tasksResource)&&O.URI.isUri(t.snippetsHome)&&O.URI.isUri(t.extensionsResource))}e.isUserDataProfile=g,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,m.createDecorator)("IUserDataProfilesService");function w(n,t){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:O.URI.revive(n.location).with({scheme:t}),globalStorageHome:O.URI.revive(n.globalStorageHome).with({scheme:t}),settingsResource:O.URI.revive(n.settingsResource).with({scheme:t}),keybindingsResource:O.URI.revive(n.keybindingsResource).with({scheme:t}),tasksResource:O.URI.revive(n.tasksResource).with({scheme:t}),snippetsHome:O.URI.revive(n.snippetsHome).with({scheme:t}),extensionsResource:O.URI.revive(n.extensionsResource)?.with({scheme:t}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=w;function f(n,t,r,o){return{id:n,name:t,location:r,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,k.joinPath)(r,"globalStorage"),settingsResource:(0,k.joinPath)(r,"settings.json"),keybindingsResource:(0,k.joinPath)(r,"keybindings.json"),tasksResource:(0,k.joinPath)(r,"tasks.json"),snippetsHome:(0,k.joinPath)(r,"snippets"),extensionsResource:(0,k.joinPath)(r,"extensions.json"),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=f;let s=class extends I.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(t,r,o,c){super(),this.environmentService=t,this.fileService=r,this.uriIdentityService=o,this.logService=c,this.enabled=!1,this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new D.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new D.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new D.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new y.ResourceMap},this.profilesHome=(0,k.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(t){this.enabled!==t&&(this._profilesObject=void 0,this.enabled=t)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const t=this.enabled?this.getStoredProfiles().map(a=>f((0,k.basename)(a.location),a.name,a.location,{shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})):[];let r;const o=new y.ResourceMap,c=f((0,C.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.environmentService.userRoamingDataHome);if(t.unshift({...c,isDefault:!0}),t.length){const a=this.getStoredProfileAssociations();if(a.workspaces)for(const[d,R]of Object.entries(a.workspaces)){const M=O.URI.parse(d),q=O.URI.parse(R),X=t.find(J=>this.uriIdentityService.extUri.isEqual(J.location,q));X&&o.set(M,X)}if(a.emptyWindow){const d=O.URI.parse(a.emptyWindow);r=t.find(R=>this.uriIdentityService.extUri.isEqual(R.location,d))}}this._profilesObject={profiles:t,workspaces:o,emptyWindow:r}}return this._profilesObject}async createTransientProfile(t){const r="Temp",o=new RegExp(`${(0,l.escapeRegExpCharacters)(r)}\\s(\\d+)`);let c=0;for(const d of this.profiles){const R=o.exec(d.name),M=R?parseInt(R[1]):0;c=M>c?M:c}const a=`${r} ${c+1}`;return this.createProfile((0,C.hash)((0,S.generateUuid)()).toString(16),a,{transient:!0},t)}async createNamedProfile(t,r,o){return this.createProfile((0,C.hash)((0,S.generateUuid)()).toString(16),t,r,o)}async createProfile(t,r,o,c){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=await this.doCreateProfile(t,r,o);return c&&await this.setProfileForWorkspace(c,a),a}async doCreateProfile(t,r,o){let c=this.profileCreationPromises.get(r);return c||(c=(async()=>{try{const a=this.profiles.find(M=>M.name===r||M.id===t);if(a)return a;const d=f(t,r,(0,k.joinPath)(this.profilesHome,t),o);await this.fileService.createFolder(d.location);const R=[];return this._onWillCreateProfile.fire({profile:d,join(M){R.push(M)}}),await E.Promises.settled(R),this.updateProfiles([d],[],[]),d}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,c)),c}async updateProfile(t,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let o=this.profiles.find(c=>c.id===t.id);if(!o)throw new Error(`Profile '${t.name}' does not exist`);return o=f(o.id,r.name??o.name,o.location,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.updateProfiles([],[],[o]),o}async removeProfile(t){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(c=>c.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this._onWillRemoveProfile.fire({profile:r,join(c){o.push(c)}});try{await Promise.allSettled(o)}catch(c){this.logService.error(c)}r.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const c of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(c)?.id&&this.profilesObject.workspaces.delete(c);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(c){this.logService.error(c)}}getOrSetProfileForWorkspace(t,r=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let o=this.getProfileForWorkspace(t);return o||(o=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(t,o)),o}async setProfileForWorkspace(t,r){this.setProfileForWorkspaceSync(t,r)}setProfileForWorkspaceSync(t,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=this.profiles.find(c=>c.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(t,o)}unsetWorkspace(t,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(t,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const t=await this.fileService.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.uriIdentityService.extUri.isEqual(o.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const t=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.getWorkspace(t);return O.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(t){return(0,p.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,p.isWorkspaceIdentifier)(t)?t.configPath:"empty-window"}isProfileAssociatedToWorkspace(t){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,t.location)||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,t.location)||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location)))}updateProfiles(t,r,o){const c=[...this.profiles,...t],a=[];this.transientProfilesObject.profiles=[];for(let d of c)d.isDefault||r.some(R=>d.id===R.id)||(d=o.find(R=>d.id===R.id)??d,d.isTransient?this.transientProfilesObject.profiles.push(d):a.push({location:d.location,name:d.name,shortName:d.shortName,useDefaultFlags:d.useDefaultFlags}));this.saveStoredProfiles(a),this._profilesObject=void 0,this.triggerProfilesChanges(t,r,o)}triggerProfilesChanges(t,r,o){this._onDidChangeProfiles.fire({added:t,removed:r,updated:o,all:this.profiles})}updateWorkspaceAssociation(t,r,o){o=r?.isTransient?!0:o,o||this.updateWorkspaceAssociation(t,void 0,!0);const c=this.getWorkspace(t),a=o?this.transientProfilesObject:this.profilesObject;O.URI.isUri(c)?(a.workspaces.delete(c),r&&a.workspaces.set(c,r)):a.emptyWindow=r,o||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const t={};for(const[o,c]of this.profilesObject.workspaces.entries())t[o.toString()]=c.location.toString();const r=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:t,emptyWindow:r}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(t){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(t){throw new Error("not implemented")}};s.PROFILES_KEY="userDataProfiles",s.PROFILE_ASSOCIATIONS_KEY="profileAssociations",s=he([te(0,h.IEnvironmentService),te(1,u.IFileService),te(2,v.IUriIdentityService),te(3,b.ILogService)],s),e.UserDataProfilesService=s;class i extends s{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(t){this.storedProfiles=t}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(t){this.storedProfileAssociations=t}}e.InMemoryUserDataProfilesService=i}),define(Q[141],ee([0,1,19,3,22,11,4,2,12,10,83,23,24,29,9,28,34,25]),function(_,e,C,D,I,k,O,P,h,u,m,b,p,y,v,E,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends P.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(t,r,o,c,a){super(),this.galleryService=t,this.telemetryService=r,this.logService=o,this.productService=c,this.userDataProfilesService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new O.Emitter),this._onDidInstallExtensions=this._register(new O.Emitter),this._onUninstallExtension=this._register(new O.Emitter),this._onDidUninstallExtension=this._register(new O.Emitter),this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(({task:d})=>d.cancel()),this.uninstallingExtensions.forEach(d=>d.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,b.isTargetPlatformCompatible)(o,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.galleryService.isEnabled())throw new b.ExtensionManagementError(m.localize(0,null),b.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(t,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,r)}catch(o){throw s(this.telemetryService,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(t),error:o}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(o),f(o)}}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,r)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,r,o){const c={...o,installOnlyNewlyAddedFromExtensionPack:u.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:!o.profileLocation||(0,y.isApplicationScopedExtension)(t)?this.userDataProfilesService.defaultProfile.extensionsResource:o.profileLocation},a=J=>`${p.ExtensionKey.create(J).toString()}${c.profileLocation?`-${c.profileLocation.toString()}`:""}`;if(!u.URI.isUri(r)){const J=this.installingExtensions.get(a(r));if(J){this.logService.info("Extensions is already requested to install",r.identifier.id);const{local:ie}=await J.task.waitUntilTaskIsFinished();return ie}}const d=[],R=[],M=[],q=this.createInstallExtensionTask(t,r,c);u.URI.isUri(r)||this.installingExtensions.set(a(r),{task:q,waitingTasks:[]}),this._onInstallExtension.fire({identifier:q.identifier,source:r,profileLocation:c.profileLocation}),this.logService.info("Installing extension:",q.identifier.id),d.push({task:q,manifest:t});let X=!1;try{if(c.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",q.identifier.id);else try{const ie=await this.getAllDepsAndPackExtensions(q.identifier,t,!!c.installOnlyNewlyAddedFromExtensionPack,!!c.installPreReleaseVersion,c.profileLocation),oe=await this.getInstalled(void 0,c.profileLocation);for(const{gallery:Z,manifest:ge}of ie){X=X||!!ge.extensionDependencies?.some(z=>(0,p.areSameExtensions)({id:z},q.identifier));const ce=a(Z),re=this.installingExtensions.get(ce);if(re){if(this.canWaitForTask(q,re.task)){this.logService.info("Waiting for already requested installing extension",Z.identifier.id,q.identifier.id),re.waitingTasks.push(q);const z=re.task.identifier;R.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,F=>F.some(A=>(0,p.areSameExtensions)(A.identifier,z)))).then(F=>{if(!F.find(W=>(0,p.areSameExtensions)(W.identifier,z))?.local)throw new Error(`Extension ${z.id} is not installed`)}))}}else if(!oe.some(({identifier:z})=>(0,p.areSameExtensions)(z,Z.identifier))){const z=this.createInstallExtensionTask(ge,Z,{...c,donotIncludePackAndDependencies:!0});this.installingExtensions.set(ce,{task:z,waitingTasks:[q]}),this._onInstallExtension.fire({identifier:z.identifier,source:Z,profileLocation:c.profileLocation}),this.logService.info("Installing extension:",z.identifier.id,q.identifier.id),d.push({task:z,manifest:ge})}}}catch(ie){if(u.URI.isUri(q.source))(0,C.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",q.identifier.id,ie.message),(0,C.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",q.identifier.id,ie.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",q.identifier.id),ie}const J=d.reduce((ie,{task:oe,manifest:Z})=>(ie.set(oe.identifier.id.toLowerCase(),{task:oe,manifest:Z}),ie),new Map);for(;J.size;){let ie;const oe=[...J.values()].filter(({manifest:Z})=>!Z.extensionDependencies?.some(ge=>J.has(ge.toLowerCase())));oe.length?ie=J.size===1?oe:oe.filter(({task:Z})=>!(Z===q&&!X)):(this.logService.info("Found extensions with circular dependencies",oe.map(({task:Z})=>Z.identifier.id)),ie=[...J.values()]),await this.joinAllSettled(ie.map(async({task:Z})=>{const ge=new Date().getTime();try{const{local:ce}=await Z.run();if(await this.joinAllSettled(this.participants.map(re=>re.postInstall(ce,Z.source,c,I.CancellationToken.None))),!u.URI.isUri(Z.source)){const re=Z.operation===3,z=re?void 0:(new Date().getTime()-Z.source.lastUpdated)/1e3;if(s(this.telemetryService,re?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(Z.source),wasVerified:Z.wasVerified,duration:new Date().getTime()-ge,durationSinceUpdate:z}),h.isWeb&&Z.operation!==3)try{await this.galleryService.reportStatistic(ce.manifest.publisher,ce.manifest.name,ce.manifest.version,"install")}catch{}}M.push({local:ce,identifier:Z.identifier,operation:Z.operation,source:Z.source,context:c.context,profileLocation:c.profileLocation,applicationScoped:ce.isApplicationScoped})}catch(ce){throw u.URI.isUri(Z.source)||s(this.telemetryService,Z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(Z.source),wasVerified:Z.wasVerified,duration:new Date().getTime()-ge,error:ce}),this.logService.error("Error while installing the extension:",Z.identifier.id),ce}finally{J.delete(Z.identifier.id.toLowerCase())}}))}return R.length&&await this.joinAllSettled(R),M.forEach(({identifier:ie})=>this.logService.info("Extension installed successfully:",ie.id)),this._onDidInstallExtensions.fire(M),M.filter(({identifier:ie})=>(0,p.areSameExtensions)(ie,q.identifier))[0].local}catch(J){if(d.forEach(({task:ie})=>ie.cancel()),M.length)try{const ie=await Promise.allSettled(M.map(({local:oe})=>this.createUninstallExtensionTask(oe,{versionOnly:!0,profileLocation:c.profileLocation}).run()));for(let oe=0;oe<ie.length;oe++){const Z=ie[oe],{identifier:ge}=M[oe];Z.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ge.id):this.logService.warn("Rollback: Error while uninstalling extension",ge.id,(0,k.getErrorMessage)(Z.reason))}}catch(ie){this.logService.warn("Error while rolling back extensions",(0,k.getErrorMessage)(ie),M.map(({identifier:oe})=>oe.id))}throw this._onDidInstallExtensions.fire(d.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:c.context,profileLocation:c.profileLocation}))),J}finally{for(const[J,{task:ie,waitingTasks:oe}]of this.installingExtensions.entries()){const Z=oe.indexOf(q);Z!==-1&&oe.splice(Z,1),oe.length===0&&(ie===q||Z!==-1)&&this.installingExtensions.delete(J)}}}canWaitForTask(t,r){for(const[,{task:o,waitingTasks:c}]of this.installingExtensions.entries())if(o===t&&(c.includes(r)||c.some(a=>this.canWaitForTask(a,r)))||o===r&&c[0]&&!this.canWaitForTask(t,c[0]))return!1;return!0}async joinAllSettled(t){const r=[],o=[],c=await Promise.allSettled(t);for(const a of c)a.status==="fulfilled"?r.push(a.value):o.push(a.reason);if(o.length)throw w(o);return r}async getAllDepsAndPackExtensions(t,r,o,c,a){if(!this.galleryService.isEnabled())return[];const d=await this.getInstalled(void 0,a),R=[t],M=[],q=async(X,J)=>{const ie=J.extensionDependencies||[],oe=[...ie];if(J.extensionPack){const Z=o?d.find(ge=>(0,p.areSameExtensions)(ge.identifier,X)):void 0;for(const ge of J.extensionPack)Z&&Z.manifest.extensionPack&&Z.manifest.extensionPack.some(ce=>(0,p.areSameExtensions)({id:ce},{id:ge}))||oe.every(ce=>!(0,p.areSameExtensions)({id:ce},{id:ge}))&&oe.push(ge)}if(oe.length){const Z=[...R,...M.map(ce=>ce.gallery.identifier)],ge=oe.filter(ce=>Z.every(re=>!(0,p.areSameExtensions)(re,{id:ce})));if(ge.length){const ce=await this.galleryService.getExtensions(ge.map(re=>({id:re,preRelease:c})),I.CancellationToken.None);for(const re of ce){if(Z.find(A=>(0,p.areSameExtensions)(A,re.identifier)))continue;const z=ie.some(A=>(0,p.areSameExtensions)({id:A},re.identifier));let F;try{F=await this.checkAndGetCompatibleVersion(re,!1,c)}catch(A){if(A instanceof b.ExtensionManagementError&&A.code===b.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!z){this.logService.info("Skipping the packed extension as it cannot be installed",re.identifier.id);continue}else throw A}M.push({gallery:F.extension,manifest:F.manifest}),await q(F.extension.identifier,F.manifest)}}}};return await q(t,r),M}async checkAndGetCompatibleVersion(t,r,o){if((await this.getExtensionsControlManifest()).malicious.some(R=>(0,p.areSameExtensions)(t.identifier,R)))throw new b.ExtensionManagementError(m.localize(1,null,t.identifier.id),b.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const R=await this.getTargetPlatform();throw new b.ExtensionManagementError(m.localize(2,null,t.identifier.id,this.productService.nameLong,(0,b.TargetPlatformToString)(R)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(t,r,o);if(a){if(o&&!r&&t.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new b.ExtensionManagementError(m.localize(3,null,t.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],I.CancellationToken.None))[0]?new b.ExtensionManagementError(m.localize(4,null,t.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.ExtensionManagementError(m.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const d=await this.galleryService.getManifest(a,I.CancellationToken.None);if(d===null)throw new b.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(d.version!==a.version)throw new b.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:d}}async getCompatibleVersion(t,r,o){const c=await this.getTargetPlatform();let a=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(a=(await this.galleryService.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:c,compatible:!0},I.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(t,o,c)&&(a=t),a||(r?a=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:c,compatible:!0},I.CancellationToken.None))[0]||null:a=await this.galleryService.getCompatibleExtension(t,o,c)),a}async uninstallExtension(t,r){const o={...r,profileLocation:!r.profileLocation||t.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation},c=X=>`${X.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,a=this.uninstallingExtensions.get(c(t.identifier));if(a)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),a.waitUntilTaskIsFinished();const d=X=>{const J=this.createUninstallExtensionTask(X,o);return this.uninstallingExtensions.set(c(J.extension.identifier),J),o.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,o.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${X.identifier.id}@${X.manifest.version}`),this._onUninstallExtension.fire({identifier:X.identifier,profileLocation:o.profileLocation,applicationScoped:X.isApplicationScoped}),J},R=(X,J)=>{J?o.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,o.profileLocation.toString(),J.message):this.logService.error("Failed to uninstall extension:",`${X.identifier.id}@${X.manifest.version}`,J.message):o.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${X.identifier.id}@${X.manifest.version}`,o.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${X.identifier.id}@${X.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(X),error:J}),this._onDidUninstallExtension.fire({identifier:X.identifier,version:X.manifest.version,error:J?.code,profileLocation:o.profileLocation,applicationScoped:X.isApplicationScoped})},M=[],q=[];try{M.push(d(t));const X=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const J=this.getAllPackExtensionsToUninstall(t,X);for(const ie of J)this.uninstallingExtensions.has(c(ie.identifier))?this.logService.info("Extensions is already requested to uninstall",ie.identifier.id):M.push(d(ie))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(M.map(J=>J.extension),X,t),await this.joinAllSettled(M.map(async J=>{try{if(await J.run(),await this.joinAllSettled(this.participants.map(ie=>ie.postUninstall(J.extension,o,I.CancellationToken.None))),J.extension.identifier.uuid)try{await this.galleryService.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,"uninstall")}catch{}R(J.extension)}catch(ie){const oe=ie instanceof b.ExtensionManagementError?ie:new b.ExtensionManagementError((0,k.getErrorMessage)(ie),b.ExtensionManagementErrorCode.Internal);throw R(J.extension,oe),oe}finally{q.push(J)}}))}catch(X){const J=X instanceof b.ExtensionManagementError?X:new b.ExtensionManagementError((0,k.getErrorMessage)(X),b.ExtensionManagementErrorCode.Internal);for(const ie of M){try{ie.cancel()}catch{}q.includes(ie)||R(ie.extension,J)}throw J}finally{for(const X of M)this.uninstallingExtensions.delete(c(X.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",X.extension.identifier.id)}}checkForDependents(t,r,o){for(const c of t){const a=this.getDependents(c,r);if(a.length){const d=a.filter(R=>!t.some(M=>(0,p.areSameExtensions)(M.identifier,R.identifier)));if(d.length)throw new Error(this.getDependentsErrorMessage(c,d,o))}}}getDependentsErrorMessage(t,r,o){return o===t?r.length===1?m.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?m.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):m.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?m.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?m.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):m.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const c=t.manifest.extensionPack?t.manifest.extensionPack:[];if(c.length){const a=r.filter(R=>!R.isBuiltin&&c.some(M=>(0,p.areSameExtensions)({id:M},R.identifier))),d=[];for(const R of a)d.push(...this.getAllPackExtensionsToUninstall(R,r,o));return[...a,...d]}return[]}getDependents(t,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(c=>(0,p.areSameExtensions)({id:c},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};g=he([te(0,b.IExtensionGalleryService),te(1,S.ITelemetryService),te(2,v.ILogService),te(3,E.IProductService),te(4,l.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function w(n){const t=Array.isArray(n)?n:[n];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=w;function f(n){if(n instanceof b.ExtensionManagementError)return n;const t=new b.ExtensionManagementError(n.message,b.ExtensionManagementErrorCode.Internal);return t.stack=n.stack,t}function s(n,t,{extensionData:r,wasVerified:o,duration:c,error:a,durationSinceUpdate:d}){let R,M;a&&(a instanceof b.ExtensionManagementError?(R=a.code,a.code===b.ExtensionManagementErrorCode.Signature&&(M=a.message)):R=b.ExtensionManagementErrorCode.Internal),n.publicLog(t,{...r,wasVerified:o,success:!a,duration:c,errorcode:R,errorcodeDetail:M,durationSinceUpdate:d})}e.reportTelemetry=s;class i{constructor(){this.barrier=new D.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(t=>new Promise((r,o)=>{const c=t.onCancellationRequested(()=>{c.dispose(),o(new k.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=i}),define(Q[48],ee([0,1,19,3,26,14,11,50,75,2,16,15,12,17,38,54,8,10,87,18,24,29,45,13,7,9,28,4,44,41,25,35,103]),function(_,e,C,D,I,k,O,P,h,u,m,b,p,y,v,E,S,l,g,w,f,s,i,n,t,r,o,c,a,d,R,M,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var X;(function(re){function z(F,A){if(F===A)return!0;const W=Object.keys(F),j=new Set;for(const Y of Object.keys(A))j.add(Y);if(W.length!==j.size)return!1;for(const Y of W){if(F[Y]!==A[Y])return!1;j.delete(Y)}return j.size===0}re.equals=z})(X=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let J=class extends u.Disposable{constructor(z,F,A,W,j,Y,B,N,T,L,U){super(),this.systemExtensionsLocation=z,this.userExtensionsLocation=F,this.extensionsControlLocation=A,this.cacheLocation=W,this.userDataProfilesService=j,this.extensionsProfileScannerService=Y,this.fileService=B,this.logService=N,this.environmentService=T,this.productService=L,this.instantiationService=U,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,y.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Z,(0,y.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Z,(0,y.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(oe,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(z,F,A){const[W,j]=await Promise.all([this.scanSystemExtensions(z),this.scanUserExtensions(F)]),Y=A?await this.scanExtensionsUnderDevelopment(z,[...W,...j]):[];return this.dedupExtensions(W,j,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions(z){const F=[];F.push(this.scanDefaultSystemExtensions(!!z.useCache,z.language)),F.push(this.scanDevSystemExtensions(z.language,!!z.checkControlFile));const[A,W]=await Promise.all(F);return this.applyScanOptions([...A,...W],0,z,!1)}async scanUserExtensions(z){const F=z.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",F);const A=await this.createExtensionScannerInput(F,!!z.profileLocation,1,!z.includeUninstalled,z.language);let j=await(z.useCache&&!A.devMode&&A.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(A);return j=await this.applyScanOptions(j,1,z,!0),this.logService.trace("Scanned user extensions:",j.length),j}async scanExtensionsUnderDevelopment(z,F){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const A=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===m.Schemas.file).map(async W=>{const j=await this.createExtensionScannerInput(W,!1,1,!0,z.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(j)).map(B=>(B.type=F.find(N=>(0,f.areSameExtensions)(N.identifier,B.identifier))?.type??B.type,this.extensionsScanner.validate(B,j)))}))).flat();return this.applyScanOptions(A,"development",z,!0)}return[]}async scanExistingExtension(z,F,A){const W=await this.createExtensionScannerInput(z,!1,F,!0,A.language),j=await this.extensionsScanner.scanExtension(W);return!j||!A.includeInvalid&&!j.isValid?null:j}async scanOneOrMultipleExtensions(z,F,A){const W=await this.createExtensionScannerInput(z,!1,F,!0,A.language),j=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(j,F,A,!0)}async scanMetadata(z){const F=(0,y.joinPath)(z,"package.json"),A=(await this.fileService.readFile(F)).value.toString();return JSON.parse(A).__metadata}async updateMetadata(z,F){const A=(0,y.joinPath)(z,"package.json"),W=(await this.fileService.readFile(A)).value.toString(),j=JSON.parse(W);F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0,j.__metadata={...j.__metadata,...F},await this.fileService.writeFile((0,y.joinPath)(z,"package.json"),k.VSBuffer.fromString(JSON.stringify(j,null,"	")))}async applyScanOptions(z,F,A,W){return A.includeAllVersions||(z=this.dedupExtensions(F===0?z:void 0,F===1?z:void 0,F==="development"?z:void 0,await this.getTargetPlatform(),W)),A.includeInvalid||(z=z.filter(j=>j.isValid)),z.sort((j,Y)=>{const B=b.basename(j.location.fsPath),N=b.basename(Y.location.fsPath);return B<N?-1:B>N?1:0})}dedupExtensions(z,F,A,W,j){const Y=(N,T,L)=>{if(N.isValid&&!T.isValid)return!1;if(N.isValid===T.isValid){if(j&&v.gt(N.manifest.version,T.manifest.version))return this.logService.debug(`Skipping extension ${T.location.path} with lower version ${T.manifest.version} in favour of ${N.location.path} with version ${N.manifest.version}`),!1;if(v.eq(N.manifest.version,T.manifest.version)){if(N.type===0)return this.logService.debug(`Skipping extension ${T.location.path} in favour of system extension ${N.location.path} with same version`),!1;if(N.targetPlatform===W)return this.logService.debug(`Skipping extension ${T.location.path} from different target platform ${T.targetPlatform}`),!1}}return L?this.logService.warn(`Overwriting user extension ${N.location.path} with ${T.location.path}.`):this.logService.debug(`Overwriting user extension ${N.location.path} with ${T.location.path}.`),!0},B=new Map;return z?.forEach(N=>{const T=s.ExtensionIdentifier.toKey(N.identifier.id),L=B.get(T);(!L||Y(L,N,!1))&&B.set(T,N)}),F?.forEach(N=>{const T=s.ExtensionIdentifier.toKey(N.identifier.id),L=B.get(T);if(!L&&z&&N.type===0){this.logService.debug(`Skipping obsolete system extension ${N.location.path}.`);return}(!L||Y(L,N,!1))&&B.set(T,N)}),A?.forEach(N=>{const T=s.ExtensionIdentifier.toKey(N.identifier.id),L=B.get(T);(!L||Y(L,N,!0))&&B.set(T,N),B.set(T,N)}),[...B.values()]}async scanDefaultSystemExtensions(z,F){this.logService.trace("Started scanning system extensions");const A=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,F),j=await(z&&!A.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(A);return this.logService.trace("Scanned system extensions:",j.length),j}async scanDevSystemExtensions(z,F){const A=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!A?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=F?await this.getBuiltInExtensionControl():{},j=[],Y=l.URI.file(b.normalize(b.join(m.FileAccess.asFileUri("",_).fsPath,"..",".build","builtInExtensions")));for(const N of A){const T=W[N.name]||"marketplace";switch(T){case"disabled":break;case"marketplace":j.push((0,y.joinPath)(Y,N.name));break;default:j.push(l.URI.file(T));break}}const B=await Promise.all(j.map(async N=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(N,!1,0,!0,z))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,C.coalesce)(B)}async getBuiltInExtensionControl(){try{const z=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(z.value.toString())}catch{return{}}}async createExtensionScannerInput(z,F,A,W,j,Y=!0){const B=await this.getTranslations(j??p.language),N=await this.getMtime(z),T=F?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,L=T?await this.getMtime(T):void 0;return new ie(z,N,T,L,F,A,W,Y,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,j,B)}async getMtime(z){try{const F=await this.fileService.stat(z);if(typeof F.mtime=="number")return F.mtime}catch{}}};J=he([te(4,R.IUserDataProfilesService),te(5,d.IExtensionsProfileScannerService),te(6,n.IFileService),te(7,r.ILogService),te(8,w.IEnvironmentService),te(9,o.IProductService),te(10,t.IInstantiationService)],J),e.AbstractExtensionsScannerService=J;class ie{constructor(z,F,A,W,j,Y,B,N,T,L,U,V,$,G){this.location=z,this.mtime=F,this.applicationExtensionslocation=A,this.applicationExtensionslocationMtime=W,this.profile=j,this.type=Y,this.excludeObsolete=B,this.validate=N,this.productVersion=T,this.productDate=L,this.productCommit=U,this.devMode=V,this.language=$,this.translations=G}static createNlsConfiguration(z){return{language:z.language,pseudo:z.language==="pseudo",devMode:z.devMode,translations:z.translations}}static equals(z,F){return(0,y.isEqual)(z.location,F.location)&&z.mtime===F.mtime&&(0,y.isEqual)(z.applicationExtensionslocation,F.applicationExtensionslocation)&&z.applicationExtensionslocationMtime===F.applicationExtensionslocationMtime&&z.profile===F.profile&&z.type===F.type&&z.excludeObsolete===F.excludeObsolete&&z.validate===F.validate&&z.productVersion===F.productVersion&&z.productDate===F.productDate&&z.productCommit===F.productCommit&&z.devMode===F.devMode&&z.language===F.language&&X.equals(z.translations,F.translations)}}let oe=class extends u.Disposable{constructor(z,F,A,W,j){super(),this.obsoleteFile=z,this.extensionsProfileScannerService=F,this.uriIdentityService=A,this.fileService=W,this.logService=j}async scanExtensions(z){const F=z.profile?await this.scanExtensionsFromProfile(z):await this.scanExtensionsFromLocation(z);let A={};if(z.excludeObsolete&&z.type===1)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();A=JSON.parse(W)}catch{}return(0,S.isEmptyObject)(A)?F:F.filter(W=>!A[f.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation(z){const F=await this.fileService.resolve(z.location);if(!F.children?.length)return[];const A=await Promise.all(F.children.map(async W=>{if(!W.isDirectory||z.type===1&&(0,y.basename)(W.resource).indexOf(".")===0)return null;const j=new ie(W.resource,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(j)}));return(0,C.coalesce)(A).sort((W,j)=>W.location.path<j.location.path?-1:1)}async scanExtensionsFromProfile(z){let F=await this.scanExtensionsFromProfileResource(z.location,()=>!0,z);if(z.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(z.location,z.applicationExtensionslocation)){F=F.filter(W=>!W.metadata?.isApplicationScoped);const A=await this.scanExtensionsFromProfileResource(z.applicationExtensionslocation,W=>!!W.metadata?.isApplicationScoped,z);F.push(...A)}return F}async scanExtensionsFromProfileResource(z,F,A){const W=await this.extensionsProfileScannerService.scanProfileExtensions(z);if(!W.length)return[];const j=await Promise.all(W.map(async Y=>{if(F(Y)){const B=new ie(Y.location,A.mtime,A.applicationExtensionslocation,A.applicationExtensionslocationMtime,A.profile,A.type,A.excludeObsolete,A.validate,A.productVersion,A.productDate,A.productCommit,A.devMode,A.language,A.translations);return this.scanExtension(B,Y.metadata)}return null}));return(0,C.coalesce)(j)}async scanOneOrMultipleExtensions(z){try{if(await this.fileService.exists((0,y.joinPath)(z.location,"package.json"))){const F=await this.scanExtension(z);return F?[F]:[]}else return await this.scanExtensions(z)}catch(F){return this.logService.error(`Error scanning extensions at ${z.location.path}:`,(0,O.getErrorMessage)(F)),[]}}async scanExtension(z,F){try{let A=await this.scanExtensionManifest(z.location);if(A){A.publisher||(A.publisher=s.UNDEFINED_PUBLISHER),F=F??A.__metadata,delete A.__metadata;const W=(0,f.getGalleryExtensionId)(A.publisher,A.name),j=F?.id?{id:W,uuid:F.id}:{id:W},Y=F?.isSystem?0:z.type,B=Y===0||!!F?.isBuiltin;A=await this.translateManifest(z.location,A,ie.createNlsConfiguration(z));const N={type:Y,identifier:j,manifest:A,location:z.location,isBuiltin:B,targetPlatform:F?.targetPlatform??"undefined",metadata:F,isValid:!0,validations:[]};return z.validate?this.validate(N,z):N}}catch(A){z.type!==0&&this.logService.error(A)}return null}validate(z,F){let A=!0;const W=(0,i.validateExtensionManifest)(F.productVersion,F.productDate,F.location,z.manifest,z.isBuiltin);for(const[j,Y]of W)j===E.default.Error&&(A=!1,this.logService.error(this.formatMessage(F.location,Y)));return z.isValid=A,z.validations=W,z}async scanExtensionManifest(z){const F=(0,y.joinPath)(z,"package.json");let A;try{A=(await this.fileService.readFile(F)).value.toString()}catch(j){return(0,n.toFileOperationResult)(j)!==1&&this.logService.error(this.formatMessage(z,(0,g.localize)(0,null,F.path,j.message))),null}let W;try{W=JSON.parse(A)}catch{const Y=[];(0,P.parse)(A,Y);for(const B of Y)this.logService.error(this.formatMessage(z,(0,g.localize)(1,null,F.path,B.offset,B.length,(0,h.getParseErrorMessage)(B.error))));return null}return(0,P.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage(z,(0,g.localize)(2,null,F.path))),null):W}async translateManifest(z,F,A){const W=await this.getLocalizedMessages(z,F,A);if(W)try{const j=[],Y=await this.resolveOriginalMessageBundle(W.default,j);if(j.length>0)return j.forEach(N=>{this.logService.error(this.formatMessage(z,(0,g.localize)(3,null,W.default?.path,(0,h.getParseErrorMessage)(N.error))))}),F;if((0,P.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage(z,(0,g.localize)(4,null,W.default?.path))),F;const B=W.values||Object.create(null);return(0,q.localizeManifest)(F,B,Y)}catch{}return F}async getLocalizedMessages(z,F,A){const W=(0,y.joinPath)(z,"package.nls.json"),j=(T,L)=>{L.forEach(U=>{this.logService.error(this.formatMessage(z,(0,g.localize)(5,null,T?.path,(0,h.getParseErrorMessage)(U.error))))})},Y=T=>{this.logService.error(this.formatMessage(z,(0,g.localize)(6,null,T?.path)))},B=`${F.publisher}.${F.name}`,N=A.translations[B];if(N)try{const T=l.URI.file(N),L=(await this.fileService.readFile(T)).value.toString(),U=[],V=(0,P.parse)(L,U);return U.length>0?(j(T,U),{values:void 0,default:W}):(0,P.getNodeType)(V)!=="object"?(Y(T),{values:void 0,default:W}):{values:V.contents?V.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let L;try{L=await this.findMessageBundles(z,A)}catch{return}if(!L.localized)return{values:void 0,default:L.original};try{const U=(await this.fileService.readFile(L.localized)).value.toString(),V=[],$=(0,P.parse)(U,V);return V.length>0?(j(L.localized,V),{values:void 0,default:L.original}):(0,P.getNodeType)($)!=="object"?(Y(L.localized),{values:void 0,default:L.original}):{values:$,default:L.original}}catch{return{values:void 0,default:L.original}}}}async resolveOriginalMessageBundle(z,F){if(z)try{const A=(await this.fileService.readFile(z)).value.toString();return(0,P.parse)(A,F)}catch{}}findMessageBundles(z,F){return new Promise((A,W)=>{const j=Y=>{const B=(0,y.joinPath)(z,`package.nls.${Y}.json`);this.fileService.exists(B).then(N=>{N&&A({localized:B,original:(0,y.joinPath)(z,"package.nls.json")});const T=Y.lastIndexOf("-");T===-1?A({localized:(0,y.joinPath)(z,"package.nls.json"),original:null}):(Y=Y.substring(0,T),j(Y))})};if(F.devMode||F.pseudo||!F.language)return A({localized:(0,y.joinPath)(z,"package.nls.json"),original:null});j(F.language)})}formatMessage(z,F){return`[${z.path}]: ${F}`}};oe=he([te(1,d.IExtensionsProfileScannerService),te(2,M.IUriIdentityService),te(3,n.IFileService),te(4,r.ILogService)],oe);let Z=class extends oe{constructor(z,F,A,W,j,Y){super(F,A,W,j,Y),this.cacheFile=z,this.cacheValidatorThrottler=this._register(new D.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(z){const F=await this.readExtensionCache();if(this.input=z,F&&F.input&&ie.equals(F.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),F.result.map(W=>(W.location=l.URI.revive(W.location),W));const A=await super.scanExtensions(z);return await this.writeExtensionCache({input:z,result:A}),A}async readExtensionCache(){try{const z=await this.fileService.readFile(this.cacheFile),F=JSON.parse(z.value.toString());return{result:F.result,input:(0,a.revive)(F.input)}}catch(z){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,O.getErrorMessage)(z))}return null}async writeExtensionCache(z){try{await this.fileService.writeFile(this.cacheFile,k.VSBuffer.fromString(JSON.stringify(z)))}catch(F){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,O.getErrorMessage)(F))}}async validateCache(){if(!this.input)return;const z=await this.readExtensionCache();if(!z)return;const F=z.result,A=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!I.equals(A,F))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(W){this.logService.error(W)}}};Z=he([te(2,d.IExtensionsProfileScannerService),te(3,M.IUriIdentityService),te(4,n.IFileService),te(5,r.ILogService)],Z);function ge(re,z){const F=(0,f.getExtensionId)(re.manifest.publisher,re.manifest.name);return{id:F,identifier:new s.ExtensionIdentifier(F),isBuiltin:re.type===0,isUserBuiltin:re.type===1&&re.isBuiltin,isUnderDevelopment:z,extensionLocation:re.location,uuid:re.identifier.uuid,targetPlatform:re.targetPlatform,...re.manifest}}e.toExtensionDescription=ge;class ce extends J{constructor(z,F,A,W,j,Y,B,N,T,L,U){super(z,F,(0,y.joinPath)(A,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(W,s.MANIFEST_CACHE_FOLDER),j,Y,B,N,T,L,U),this.translationsPromise=(async()=>{if(p.translationsConfigFile)try{const V=await this.fileService.readFile(l.URI.file(p.translationsConfigFile));return JSON.parse(V.value.toString())}catch{}return Object.create(null)})()}getTranslations(z){return this.translationsPromise}}e.NativeExtensionsScannerService=ce}),define(Q[142],ee([0,1,57,3,31,4,2,16,15,20,9,25]),function(_,e,C,D,I,k,O,P,h,u,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends O.Disposable{constructor(v,E){super(),this.userDataProfilesService=v,this.logService=E,this.processesLimiter=new D.Limiter(5)}async postUninstall(v){const E=this.parseScript(v,"uninstall");return E&&(this.logService.info(v.identifier.id,v.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(E.script,"uninstall",E.args,!0,v).then(()=>this.logService.info(v.identifier.id,v.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(v.identifier.id,v.manifest.version,`Failed to run post uninstall script: ${S}`)))),u.Promises.rm(this.getExtensionStoragePath(v)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(v,E){const S=`vscode:${E}`;if(v.location.scheme===P.Schemas.file&&v.manifest&&v.manifest.scripts&&typeof v.manifest.scripts[S]=="string"){const l=v.manifest.scripts[S].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.logService.warn(v.identifier.id,v.manifest.version,`${S} should be a node script`),null):{script:(0,h.join)(v.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}runLifecycleHook(v,E,S,l,g){return new Promise((w,f)=>{const s=this.start(v,E,S,g);let i;const n=t=>{i&&(clearTimeout(i),i=null),t?f(t):w(void 0)};s.on("error",t=>{n((0,I.toErrorMessage)(t)||"Unknown")}),s.on("exit",(t,r)=>{n(t?`post-${E} process exited with code ${t}`:void 0)}),l&&(i=setTimeout(()=>{i=null,s.kill(),f("timed out")},5e3))})}start(v,E,S,l){const g={silent:!0,execArgv:void 0},w=(0,C.fork)(v,[`--type=extension-post-${E}`,...S],g);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const f=k.Event.fromNodeEventEmitter(w.stdout,"data"),s=k.Event.fromNodeEventEmitter(w.stderr,"data");f(t=>this.logService.info(l.identifier.id,l.manifest.version,`post-${E}`,t)),s(t=>this.logService.error(l.identifier.id,l.manifest.version,`post-${E}`,t));const i=k.Event.any(k.Event.map(f,t=>({data:`%c${t}`,format:[""]})),k.Event.map(s,t=>({data:`%c${t}`,format:["color: red"]})));return k.Event.debounce(i,(t,r)=>t?{data:t.data+r.data,format:[...t.format,...r.format]}:{data:r.data,format:r.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),w}getExtensionStoragePath(v){return(0,h.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,v.identifier.id.toLowerCase())}};p=he([te(0,b.IUserDataProfilesService),te(1,m.ILogService)],p),e.ExtensionsLifecycle=p}),define(Q[143],ee([0,1,10,18,41,48,13,7,9,28,25]),function(_,e,C,D,I,k,O,P,h,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends k.NativeExtensionsScannerService{constructor(y,v,E,S,l,g,w){super(C.URI.file(l.builtinExtensionsPath),C.URI.file(l.extensionsPath),l.userHome,C.URI.file(l.userDataPath),y,v,E,S,l,g,w)}};b=he([te(0,m.IUserDataProfilesService),te(1,I.IExtensionsProfileScannerService),te(2,O.IFileService),te(3,h.ILogService),te(4,D.INativeEnvironmentService),te(5,u.IProductService),te(6,P.IInstantiationService)],b),e.ExtensionsScannerService=b}),define(Q[144],ee([0,1,3,4,2,114,8,80,7,25]),function(_,e,C,D,I,k,O,P,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,h.createDecorator)("storageService");var m;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(m=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var p;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));function y(g){const w=g.get(e.TARGET_KEY);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}e.loadKeyTargets=y;class v extends I.Disposable{constructor(w={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super(),this.options=w,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new I.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,I.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(w,f){if(f===e.TARGET_KEY){switch(w){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:w})}else this._onDidChangeValue.fire({scope:w,key:f,target:this.getKeyTargets(w)[f]})}emitWillSaveState(w){this._onWillSaveState.fire({reason:w})}get(w,f,s){return this.getStorage(f)?.get(w,s)}getBoolean(w,f,s){return this.getStorage(f)?.getBoolean(w,s)}getNumber(w,f,s){return this.getStorage(f)?.getNumber(w,s)}store(w,f,s,i){if((0,O.isUndefinedOrNull)(f)){this.remove(w,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(w,s,i),this.getStorage(s)?.set(w,f)})}remove(w,f){this.withPausedEmitters(()=>{this.updateKeyTarget(w,f,void 0),this.getStorage(f)?.delete(w)})}withPausedEmitters(w){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{w()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(w,f){const s=[],i=this.getKeyTargets(w);for(const n of Object.keys(i))i[n]===f&&s.push(n);return s}updateKeyTarget(w,f,s){const i=this.getKeyTargets(f);typeof s=="number"?i[w]!==s&&(i[w]=s,this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[w]=="number"&&(delete i[w],this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(w){switch(w){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(w){const f=this.getStorage(w);return f?y(f):Object.create(null)}isNew(w){return this.getBoolean(e.IS_NEW_KEY,w)===!0}async flush(w=m.NONE){this._onWillSaveState.fire({reason:w});const f=this.getStorage(-1),s=this.getStorage(0),i=this.getStorage(1);switch(w){case m.NONE:await C.Promises.settled([f?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await C.Promises.settled([f?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const w=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,s=this.getStorage(1)?.items??new Map;return l(w,f,s,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(w,f){return this.emitWillSaveState(m.NONE),(0,u.isUserDataProfile)(w)?this.switchToProfile(w,f):this.switchToWorkspace(w,f)}canSwitchProfile(w,f){return!(w.id===f.id||E(f)&&E(w))}switchData(w,f,s,i){this.withPausedEmitters(()=>{if(i)for(const[n,t]of w)f.set(n,t);else{const n=new Set;for(const[t,r]of w)n.add(t),f.get(t)!==r&&this.emitDidChangeValue(s,t);for(const[t]of f.items)n.has(t)||this.emitDidChangeValue(s,t)}})}}e.AbstractStorageService=v,v.DEFAULT_FLUSH_INTERVAL=60*1e3;function E(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=E;class S extends v{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(w=>this.emitDidChangeValue(1,w))),this._register(this.profileStorage.onDidChangeStorage(w=>this.emitDidChangeValue(0,w))),this._register(this.applicationStorage.onDidChangeStorage(w=>this.emitDidChangeValue(-1,w)))}getStorage(w){switch(w){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(w){switch(w){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(w){return!1}}e.InMemoryStorageService=S;async function l(g,w,f,s,i,n){const t=X=>{try{return JSON.parse(X)}catch{return X}},r=new Map,o=new Map;g.forEach((X,J)=>{r.set(J,X),o.set(J,t(X))});const c=new Map,a=new Map;w.forEach((X,J)=>{c.set(J,X),a.set(J,t(X))});const d=new Map,R=new Map;f.forEach((X,J)=>{d.set(J,X),R.set(J,t(X))}),console.group(s!==i?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const M=[];if(r.forEach((X,J)=>{M.push({key:J,value:X})}),console.table(M),console.groupEnd(),console.log(o),s!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const X=[];c.forEach((J,ie)=>{X.push({key:ie,value:J})}),console.table(X),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${n})`);const q=[];d.forEach((X,J)=>{q.push({key:J,value:X})}),console.table(q),console.groupEnd(),console.log(R)}e.logStorage=l}),define(Q[145],ee([0,1,19,22,11,12,32,8,10,21,18,23,24,45,13,9,28,47,133,144,34]),function(_,e,C,D,I,k,O,P,h,u,m,b,p,y,v,E,S,l,g,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const s=k.isWeb?"web":(0,b.getTargetPlatform)(k.platform,O.arch);var i;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished",T[T.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...T){return String(T.reduce((L,U)=>L|U,0))}var t;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class d{constructor(L=a){this.state=L}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(L,U=this.state.pageSize){return new d({...this.state,pageNumber:L,pageSize:U})}withFilter(L,...U){const V=[...this.state.criteria,...U.length?U.map($=>({filterType:L,value:$})):[{filterType:L}]];return new d({...this.state,criteria:V})}withSortBy(L){return new d({...this.state,sortBy:L})}withSortOrder(L){return new d({...this.state,sortOrder:L})}withFlags(...L){return new d({...this.state,flags:L.reduce((U,V)=>U|V,0)})}withAssetTypes(...L){return new d({...this.state,assetTypes:L})}withSource(L){return new d({...this.state,source:L})}get raw(){const{criteria:L,pageNumber:U,pageSize:V,sortBy:$,sortOrder:G,flags:se,assetTypes:ue}=this.state;return{filters:[{criteria:L,pageNumber:U,pageSize:V,sortBy:$,sortOrder:G}],assetTypes:ue,flags:se}}get searchText(){const L=this.state.criteria.filter(U=>U.filterType===t.SearchText)[0];return L&&L.value?L.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(L=>String(L.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function R(T,L){const U=(T||[]).filter(V=>V.statisticName===L)[0];return U?U.value:0}function M(T){const L="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(V=>V.assetType.indexOf(L)===0).reduce((V,$)=>{const G=J(T,$.assetType);return G&&V.push([$.assetType.substring(L.length),G]),V},[])}function q(T){if(T.properties){const L=T.properties.filter($=>$.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=L.filter($=>U.test($.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return J(T,r.Repository)}function X(T){return{uri:`${T.fallbackAssetUri}/${r.VSIX}?redirect=true${T.targetPlatform?`&targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${r.VSIX}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}}function J(T,L){return T.files.filter(V=>V.assetType===L)[0]?{uri:`${T.assetUri}/${L}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${L}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}:null}function ie(T,L){const U=T.properties?T.properties.filter($=>$.key===L):[],V=U.length>0&&U[0].value;return V?V.split(",").map($=>(0,p.adoptToGalleryExtensionId)($)):[]}function oe(T){const L=T.properties?T.properties.filter(U=>U.key===o.Engine):[];return L.length>0&&L[0].value||""}function Z(T){const L=T.properties?T.properties.filter(U=>U.key===o.PreRelease):[];return L.length>0&&L[0].value==="true"}function ge(T){const L=T.properties?T.properties.filter(V=>V.key===o.LocalizedLanguages):[],U=L.length>0&&L[0].value||"";return U?U.split(","):[]}function ce(T){return T.properties?.find(L=>L.key===o.SponsorLink)?.value}function re(T){return T.indexOf("preview")!==-1}function z(T){return T.targetPlatform?(0,b.toTargetPlatform)(T.targetPlatform):"undefined"}function F(T){const L=(0,C.distinct)(T.versions.map(z)),U=!!T.tags?.includes(b.WEB_EXTENSION_TAG),V=L.indexOf("web");return U?V===-1&&L.push("web"):V!==-1&&L.splice(V,1),L}function A(T,L){const U=(0,b.getFallbackTargetPlarforms)(L);for(let V=0;V<T.length;V++){const $=T[V];if($.version===T[V-1]?.version){let G=V;const se=z($);if(se===L)for(;G>0&&T[G-1].version===$.version;)G--;else if(U.includes(se))for(;G>0&&T[G-1].version===$.version&&z(T[G-1])!==L;)G--;G!==V&&(T.splice(V,1),T.splice(G,0,$))}}return T}e.sortExtensionVersions=A;function W(T,L,U){T.telemetryData={index:L,querySource:U}}function j(T,L,U){const V=T.versions[0],$={manifest:J(L,r.Manifest),readme:J(L,r.Details),changelog:J(L,r.Changelog),license:J(L,r.License),repository:q(L),download:X(L),icon:J(L,r.Icon),signature:J(L,r.Signature),coreTranslations:M(L)};return{identifier:{id:(0,p.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:L.version,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,publisherDomain:T.publisher.domain?{link:T.publisher.domain,verified:!!T.publisher.isDomainVerified}:void 0,publisherSponsorLink:ce(V),description:T.shortDescription||"",installCount:R(T.statistics,"install"),rating:R(T.statistics,"averagerating"),ratingCount:R(T.statistics,"ratingcount"),categories:T.categories||[],tags:T.tags||[],releaseDate:Date.parse(T.releaseDate),lastUpdated:Date.parse(T.lastUpdated),allTargetPlatforms:U,assets:$,properties:{dependencies:ie(L,o.Dependency),extensionPack:ie(L,o.ExtensionPack),engine:oe(L),localizedLanguages:ge(L),targetPlatform:z(L),isPreReleaseVersion:Z(L)},hasPreReleaseVersion:Z(V),hasReleaseVersion:!0,preview:re(T.flags),isSigned:!!$.signature}}let Y=class{constructor(L,U,V,$,G,se,ue,pe){this.requestService=U,this.logService=V,this.environmentService=$,this.telemetryService=G,this.fileService=se,this.productService=ue,this.configurationService=pe;const ve=ue.extensionsGallery,le=ve?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=le?ve.servicePPEUrl:ve?.serviceUrl,this.extensionsGallerySearchUrl=le?void 0:ve?.searchUrl,this.extensionsControlUrl=ve?.controlUrl,this.commonHeadersPromise=(0,g.resolveMarketplaceHeaders)(ue.version,ue,this.environmentService,this.configurationService,this.fileService,L,this.telemetryService)}api(L=""){return`${this.extensionsGalleryUrl}${L}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(L,U,V){const $=D.CancellationToken.isCancellationToken(U)?{}:U,G=D.CancellationToken.isCancellationToken(U)?U:V,se=[],ue=[],pe=[],ve=[];let le=!0;for(const ae of L){ae.uuid?ue.push(ae.uuid):se.push(ae.id);const Se=!!(ae.version||ae.preRelease);pe.push({id:ae.id,uuid:ae.uuid,includePreRelease:Se}),ae.version&&ve.push({id:ae.id,uuid:ae.uuid,version:ae.version}),le=le&&!!ae.hasPreRelease&&!Se}if(!ue.length&&!se.length)return[];let ne=new d().withPage(1,L.length);ue.length&&(ne=ne.withFilter(t.ExtensionId,...ue)),se.length&&(ne=ne.withFilter(t.ExtensionName,...se)),($.queryAllVersions||le)&&(ne=ne.withFlags(ne.flags,i.IncludeVersions)),$.source&&(ne=ne.withSource($.source));const{extensions:de}=await this.queryGalleryExtensions(ne,{targetPlatform:$.targetPlatform??s,includePreRelease:pe,versions:ve,compatible:!!$.compatible},G);return $.source&&de.forEach((ae,Se)=>W(ae,Se,$.source)),de}async getCompatibleExtension(L,U,V){if((0,b.isNotWebExtensionInWebTargetPlatform)(L.allTargetPlatforms,V))return null;if(await this.isExtensionCompatible(L,U,V))return L;const $=new d().withFlags(i.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,L.identifier.uuid),{extensions:G}=await this.queryGalleryExtensions($,{targetPlatform:V,compatible:!0,includePreRelease:U},D.CancellationToken.None);return G[0]||null}async isExtensionCompatible(L,U,V){if(!(0,b.isTargetPlatformCompatible)(L.properties.targetPlatform,L.allTargetPlatforms,V)||!U&&L.properties.isPreReleaseVersion)return!1;let $=L.properties.engine;if(!$){const G=await this.getManifest(L,D.CancellationToken.None);if(!G)throw new Error("Manifest was not found");$=G.engines.vscode}return(0,y.isEngineValid)($,this.productService.version,this.productService.date)}async isValidVersion(L,U,V,$,G){if(!(0,b.isTargetPlatformCompatible)(z(L),$,G)||U!=="any"&&Z(L)!==(U==="prerelease"))return!1;if(V)try{const se=await this.getEngine(L);if(!(0,y.isEngineValid)(se,this.productService.version,this.productService.date))return!1}catch(se){return this.logService.error(`Error while getting the engine for the version ${L.version}.`,(0,I.getErrorMessage)(se)),!1}return!0}async query(L,U){let V=L.text||"";const $=L.pageSize??50;let G=new d().withPage(1,$);V?(V=V.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,ne,de)=>(G=G.withFilter(t.Category,de||ne),"")),V=V.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,ne,de)=>(G=G.withFilter(t.Tag,de||ne),"")),V=V.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(t.Featured),"")),V=V.trim(),V&&(V=V.length<200?V:V.substring(0,200),G=G.withFilter(t.SearchText,V)),G=G.withSortBy(0)):L.ids?G=G.withFilter(t.ExtensionId,...L.ids):L.names?G=G.withFilter(t.ExtensionName,...L.names):G=G.withSortBy(4),typeof L.sortBy=="number"&&(G=G.withSortBy(L.sortBy)),typeof L.sortOrder=="number"&&(G=G.withSortOrder(L.sortOrder)),L.source&&(G=G.withSource(L.source));const se=async(le,ne)=>{const{extensions:de,total:ae}=await this.queryGalleryExtensions(le,{targetPlatform:s,compatible:!1,includePreRelease:!!L.includePreRelease},ne);return de.forEach((Se,Le)=>W(Se,(le.pageNumber-1)*le.pageSize+Le,L.source)),{extensions:de,total:ae}},{extensions:ue,total:pe}=await se(G,U),ve=async(le,ne)=>{if(ne.isCancellationRequested)throw new I.CancellationError;const{extensions:de}=await se(G.withPage(le+1),ne);return de};return{firstPage:ue,total:pe,pageSize:G.pageSize,getPage:ve}}async queryGalleryExtensions(L,U,V){const $=L.flags;!!(L.flags&i.IncludeLatestVersionOnly)&&!!(L.flags&i.IncludeVersions)&&(L=L.withFlags(L.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(L.flags&i.IncludeLatestVersionOnly)&&!(L.flags&i.IncludeVersions)&&(L=L.withFlags(L.flags,i.IncludeLatestVersionOnly)),U.versions?.length&&(L=L.withFlags(L.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),L=L.withFlags(L.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:G,total:se}=await this.queryRawGalleryExtensions(L,V);if(!(L.flags&i.IncludeLatestVersionOnly)){const le=[];for(const ne of G){const de=await this.toGalleryExtensionWithCriteria(ne,U);de&&le.push(de)}return{extensions:le,total:se}}const pe=[],ve=new Map;for(let le=0;le<G.length;le++){const ne=G[le],de={id:(0,p.getGalleryExtensionId)(ne.publisher.publisherName,ne.extensionName),uuid:ne.extensionId},ae=(0,P.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Le=>(0,p.areSameExtensions)(Le,de))?.includePreRelease;if(U.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(F(ne),U.targetPlatform))continue;const Se=await this.toGalleryExtensionWithCriteria(ne,U);!Se||Se.properties.isPreReleaseVersion&&(!ae||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==U.targetPlatform&&Se.hasPreReleaseVersion?ve.set(ne.extensionId,le):pe.push([le,Se])}if(ve.size){const le=new Date().getTime(),ne=new d().withFlags($&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ve.size).withFilter(t.ExtensionId,...ve.keys()),{extensions:de}=await this.queryGalleryExtensions(ne,U,V);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-le,count:ve.size});for(const ae of de){const Se=ve.get(ae.identifier.uuid);pe.push([Se,ae])}}return{extensions:pe.sort((le,ne)=>le[0]-ne[0]).map(([,le])=>le),total:se}}async toGalleryExtensionWithCriteria(L,U){const V={id:(0,p.getGalleryExtensionId)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},$=U.versions?.find(pe=>(0,p.areSameExtensions)(pe,V))?.version,G=(0,P.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(pe=>(0,p.areSameExtensions)(pe,V))?.includePreRelease,se=F(L),ue=A(L.versions,U.targetPlatform);if(U.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(se,U.targetPlatform))return null;for(let pe=0;pe<ue.length;pe++){const ve=ue[pe];if(!($&&ve.version!==$)){if(await this.isValidVersion(ve,G?"any":"release",U.compatible,se,U.targetPlatform))return j(L,ve,se);if($&&ve.version===$)return null}}return $||U.compatible?null:j(L,L.versions[0],se)}async queryRawGalleryExtensions(L,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");L=L.withFlags(L.flags,i.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,n(i.Unpublished));const V=await this.commonHeadersPromise,$=JSON.stringify(L.raw),G={...V,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String($.length)},se=new Date().getTime();let ue,pe,ve=0;try{if(ue=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&L.criteria.some(ne=>ne.filterType===t.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:$,headers:G},U),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:ve};const le=await(0,l.asJson)(ue);if(le){const ne=le.results[0],de=ne.extensions,ae=ne.resultMetadata&&ne.resultMetadata.filter(Se=>Se.metadataType==="ResultCount")[0];return ve=ae&&ae.metadataItems.filter(Se=>Se.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ve}}return{galleryExtensions:[],total:ve}}catch(le){throw pe=le,le}finally{this.telemetryService.publicLog2("galleryService:query",{...L.telemetryData,requestBodySize:String($.length),duration:new Date().getTime()-se,success:!!ue&&(0,l.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:pe?(0,I.isCancellationError)(pe)?"canceled":(0,I.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(L,U,V,$){if(!this.isEnabled())return;const G=k.isWeb?this.api(`/itemName/${L}.${U}/version/${V}/statType/${$==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${L}/extensions/${U}/${V}/stats?statType=${$}`),se=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:G,headers:pe},D.CancellationToken.None)}catch{}}async download(L,U,V){this.logService.trace("ExtensionGalleryService#download",L.identifier.id);const $=(0,p.getGalleryExtensionTelemetryData)(L),G=new Date().getTime(),se=le=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...$,duration:le}),ue=V===2?"install":V===3?"update":"",pe=ue?{uri:`${L.assets.download.uri}${h.URI.parse(L.assets.download.uri).query?"&":"?"}${ue}=true`,fallbackUri:`${L.assets.download.fallbackUri}${h.URI.parse(L.assets.download.fallbackUri).query?"&":"?"}${ue}=true`}:L.assets.download,ve=await this.getAsset(pe);await this.fileService.writeFile(U,ve.stream),se(new Date().getTime()-G)}async downloadSignatureArchive(L,U){if(!L.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",L.identifier.id);const V=await this.getAsset(L.assets.signature);await this.fileService.writeFile(U,V.stream)}async getReadme(L,U){if(L.assets.readme){const V=await this.getAsset(L.assets.readme,{},U);return await(0,l.asTextOrError)(V)||""}return""}async getManifest(L,U){if(L.assets.manifest){const V=await this.getAsset(L.assets.manifest,{},U),$=await(0,l.asTextOrError)(V);return $?JSON.parse($):null}return null}async getManifestFromRawExtensionVersion(L,U){const V=J(L,r.Manifest);if(!V)throw new Error("Manifest was not found");const $={"Accept-Encoding":"gzip"},G=await this.getAsset(V,{headers:$});return await(0,l.asJson)(G)}async getCoreTranslation(L,U){const V=L.assets.coreTranslations.filter($=>$[0]===U.toUpperCase())[0];if(V){const $=await this.getAsset(V[1]),G=await(0,l.asTextOrError)($);return G?JSON.parse(G):null}return null}async getChangelog(L,U){if(L.assets.changelog){const V=await this.getAsset(L.assets.changelog,{},U);return await(0,l.asTextOrError)(V)||""}return""}async getAllCompatibleVersions(L,U,V){let $=new d().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);L.identifier.uuid?$=$.withFilter(t.ExtensionId,L.identifier.uuid):$=$.withFilter(t.ExtensionName,L.identifier.id);const{galleryExtensions:G}=await this.queryRawGalleryExtensions($,D.CancellationToken.None);if(!G.length)return[];const se=F(G[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(se,V))return[];const ue=[];await Promise.all(G[0].versions.map(async le=>{try{await this.isValidVersion(le,U?"any":"release",!0,se,V)&&ue.push(le)}catch{}}));const pe=[],ve=new Set;for(const le of A(ue,V))ve.has(le.version)||(ve.add(le.version),pe.push({version:le.version,date:le.lastUpdated,isPreReleaseVersion:Z(le)}));return pe}async getAsset(L,U={},V=D.CancellationToken.None){const $=await this.commonHeadersPromise,G={type:"GET"},se={...$,...U.headers||{}};U={...U,...G,headers:se};const ue=L.uri,pe=L.fallbackUri,ve={...U,url:ue};try{const le=await this.requestService.request(ve,V);if(le.res.statusCode===200)return le;const ne=await(0,l.asTextOrError)(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${ne}`)}catch(le){if((0,I.isCancellationError)(le))throw le;const ne=(0,I.getErrorMessage)(le);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ue,message:ne});const de={...U,url:pe};return this.requestService.request(de,V)}}async getEngine(L){let U=oe(L);if(!U){const V=await this.getManifestFromRawExtensionVersion(L,D.CancellationToken.None);if(!V)throw new Error("Manifest was not found");U=V.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const L=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(L.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,l.asJson)(L),V=[],$={};if(U){for(const G of U.malicious)V.push({id:G});if(U.migrateToPreRelease)for(const[G,se]of Object.entries(U.migrateToPreRelease))(!se.engine||(0,y.isEngineValid)(se.engine,this.productService.version,this.productService.date))&&($[G.toLowerCase()]={disallowInstall:!0,extension:{id:se.id,displayName:se.displayName,autoMigrate:{storage:!!se.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[G,se]of Object.entries(U.deprecated))se&&($[G.toLowerCase()]=(0,P.isBoolean)(se)?{}:se)}return{malicious:V,deprecated:$}}};Y=he([te(1,l.IRequestService),te(2,E.ILogService),te(3,m.IEnvironmentService),te(4,f.ITelemetryService),te(5,v.IFileService),te(6,S.IProductService),te(7,u.IConfigurationService)],Y);let B=class extends Y{constructor(L,U,V,$,G,se,ue,pe){super(L,U,V,$,G,se,ue,pe)}};B=he([te(0,w.IStorageService),te(1,l.IRequestService),te(2,E.ILogService),te(3,m.IEnvironmentService),te(4,f.ITelemetryService),te(5,v.IFileService),te(6,S.IProductService),te(7,u.IConfigurationService)],B),e.ExtensionGalleryService=B;let N=class extends Y{constructor(L,U,V,$,G,se,ue){super(void 0,L,U,V,$,G,se,ue)}};N=he([te(0,l.IRequestService),te(1,E.ILogService),te(2,m.IEnvironmentService),te(3,f.ITelemetryService),te(4,v.IFileService),te(5,S.IProductService),te(6,u.IConfigurationService)],N),e.ExtensionGalleryServiceWithNoStorageService=N}),define(Q[146],ee([0,1,44,18,13,9,66,35,25]),function(_,e,C,D,I,k,O,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let u=class je extends h.UserDataProfilesService{constructor(b,p,y,v,E){super(y,v,p,E),this.stateService=b}getStoredProfiles(){return(0,C.revive)(this.stateService.getItem(je.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,C.revive)(this.stateService.getItem(je.PROFILE_ASSOCIATIONS_KEY,{}))}};u=he([te(0,O.IStateService),te(1,P.IUriIdentityService),te(2,D.IEnvironmentService),te(3,I.IFileService),te(4,k.ILogService)],u),e.UserDataProfilesService=u}),define(Q[147],ee([0,1,36,3,160,2]),function(_,e,C,D,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class O extends C.AbstractPolicyService{constructor(h){super(),this.productName=h,this.throttler=new D.Throttler,this.watcher=this._register(new k.MutableDisposable)}async initializePolicies(h){await this.throttler.queue(()=>new Promise((u,m)=>{try{this.watcher.value=(0,I.createWatcher)(this.productName,h,b=>{for(const p in b){const y=b[p];y===void 0?this.policies.delete(p):this.policies.set(p,y)}this._onDidChange.fire(Object.keys(b)),u()})}catch(b){m(b)}}))}}e.NativePolicyService=O}),define(Q[68],ee([0,1,116,3,15,8,20,81,161,162]),function(_,e,C,D,I,k,O,P,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class m extends Error{constructor(i,n){let t=n.message;switch(i){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=i,this.cause=n}}e.ExtractError=m;function b(s){const i=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>i&n).reduce((n,t)=>n+t,i&61440)}function p(s){if(s instanceof m)return s;let i;return/end of central directory record signature not found/.test(s.message)&&(i="CorruptZip"),new m(i,s)}function y(s,i,n,t,r,o){const c=I.dirname(i),a=I.join(t,c);if(!a.startsWith(t))return Promise.reject(new Error(P.localize(0,null,i)));const d=I.join(t,i);let R;return o.onCancellationRequested(()=>{R?.destroy()}),Promise.resolve(O.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((M,q)=>{if(!o.isCancellationRequested)try{R=(0,C.createWriteStream)(d,{mode:n}),R.once("close",()=>M()),R.once("error",q),s.once("error",q),s.pipe(R)}catch(X){q(X)}}))}function v(s,i,n,t){let r=(0,D.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((c,a)=>{const d=new D.Sequencer,R=M=>{M.isCancellationRequested||(o++,s.readEntry())};s.once("error",a),s.once("close",()=>r.then(()=>{t.isCancellationRequested||s.entryCount===o?c():a(new m("Incomplete",new Error(P.localize(1,null,o,s.entryCount))))},a)),s.readEntry(),s.on("entry",M=>{if(t.isCancellationRequested)return;if(!n.sourcePathRegex.test(M.fileName)){R(t);return}const q=M.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(q)){const ie=I.join(i,q);r=(0,D.createCancelablePromise)(oe=>O.Promises.mkdir(ie,{recursive:!0}).then(()=>R(oe)).then(void 0,a));return}const X=S(s,M),J=b(M);r=(0,D.createCancelablePromise)(ie=>d.queue(()=>X.then(oe=>y(oe,q,J,i,n,ie).then(()=>R(ie)))).then(null,a))})})}function E(s,i=!1){return new Promise((n,t)=>{(0,h.open)(s,i?{lazyEntries:!0}:void 0,(r,o)=>{r?t(p(r)):n((0,k.assertIsDefined)(o))})})}function S(s,i){return new Promise((n,t)=>{s.openReadStream(i,(r,o)=>{r?t(p(r)):n((0,k.assertIsDefined)(o))})})}function l(s,i){return new Promise((n,t)=>{const r=new u.ZipFile;i.forEach(c=>{c.contents?r.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&r.addFile(c.localPath,c.path)}),r.end();const o=(0,C.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>n(s))})}e.zip=l;function g(s,i,n={},t){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=E(s,!0);return n.overwrite&&(o=o.then(c=>O.Promises.rm(i).then(()=>c))),o.then(c=>v(c,i,{sourcePathRegex:r},t))}e.extract=g;function w(s,i){return E(s).then(n=>new Promise((t,r)=>{n.on("entry",o=>{o.fileName===i&&S(n,o).then(c=>t(c),c=>r(c))}),n.once("close",()=>r(new Error(P.localize(2,null,i))))}))}function f(s,i){return w(s,i).then(n=>new Promise((t,r)=>{const o=[];n.once("error",r),n.on("data",c=>o.push(c)),n.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=f}),define(Q[148],ee([0,1,68,89]),function(_,e,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function I(k){return(0,C.buffer)(k,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.getManifest=I}),define(Q[149],ee([0,1,3,14,22,31,11,2,16,15,12,17,38,8,10,30,20,68,88,58,18,141,23,24,41,48,124,142,148,125,126,29,45,13,7,9,28,34,35,25]),function(_,e,C,D,I,k,O,P,h,u,m,b,p,y,v,E,S,l,g,w,f,s,i,n,t,r,o,c,a,d,R,M,q,X,J,ie,oe,Z,ge,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,J.refineServiceDecorator)(i.IExtensionManagementService);let re=class extends s.AbstractExtensionManagementService{constructor(N,T,L,U,V,$,G,se,ue,pe,ve,le){super(N,T,L,pe,le),this.extensionsScannerService=V,this.extensionsProfileScannerService=$,this.downloadService=G,this.fileService=ue,this.installGalleryExtensionsTasks=new Map;const ne=this._register(se.createInstance(c.ExtensionsLifecycle));this.extensionsScanner=this._register(se.createInstance(z,ae=>ne.postUninstall(ae))),this.manifestCache=this._register(new d.ExtensionsManifestCache(U,this)),this.extensionsDownloader=this._register(se.createInstance(o.ExtensionsDownloader));const de=this._register(new R.ExtensionsWatcher(this,le,$,V,ve,ue,L));this._register(de.onDidChangeExtensionsByAnotherSource(({added:ae,removed:Se})=>{ae.length&&this._onDidInstallExtensions.fire(ae),Se.forEach(Le=>this._onDidUninstallExtension.fire(Le))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,n.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(N){this.logService.trace("ExtensionManagementService#zip",N.identifier.id);const T=await this.collectFiles(N),L=await(0,l.zip)((0,b.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,E.generateUuid)()).fsPath,T);return v.URI.file(L)}async unzip(N){return this.logService.trace("ExtensionManagementService#unzip",N.toString()),(await this.install(N)).identifier}async getManifest(N){const{location:T,cleanup:L}=await this.downloadVsix(N),U=u.resolve(T.fsPath);try{return await(0,a.getManifest)(U)}finally{await L()}}getInstalled(N,T){return this.extensionsScanner.scanExtensions(N??null,T)}getAllUserInstalled(){return this.extensionsScanner.scanAllUserExtensions(!1)}async install(N,T={}){this.logService.trace("ExtensionManagementService#install",N.toString());const{location:L,cleanup:U}=await this.downloadVsix(N);try{const V=await(0,a.getManifest)(u.resolve(L.fsPath));if(V.engines&&V.engines.vscode&&!(0,q.isEngineValid)(V.engines.vscode,this.productService.version,this.productService.date))throw new Error(g.localize(0,null,(0,n.getGalleryExtensionId)(V.publisher,V.name),this.productService.version));return await this.installExtension(V,L,T)}finally{await U()}}getMetadata(N){return this.extensionsScannerService.scanMetadata(N.location)}async updateMetadata(N,T){this.logService.trace("ExtensionManagementService#updateMetadata",N.identifier.id);const L={...T};return T.isPreReleaseVersion&&(L.preRelease=!0),N=await this.extensionsScanner.updateMetadata(N,L),this.manifestCache.invalidate(),N}async updateExtensionScope(N,T){return this.logService.trace("ExtensionManagementService#updateExtensionScope",N.identifier.id),N=await this.extensionsScanner.updateMetadata(N,{isMachineScoped:T}),this.manifestCache.invalidate(),N}async reinstallFromGallery(N){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",N.identifier.id),!this.galleryService.isEnabled())throw new Error(g.localize(1,null));const T=await this.getTargetPlatform(),[L]=await this.galleryService.getExtensions([{...N.identifier,preRelease:N.preRelease}],{targetPlatform:T,compatible:!0},I.CancellationToken.None);if(!L)throw new Error(g.localize(2,null));await this.extensionsScanner.setUninstalled(N);try{await this.extensionsScanner.removeUninstalledExtension(N)}catch(U){throw new Error(g.localize(3,null,(0,k.toErrorMessage)(U)))}await this.installFromGallery(L)}markAsUninstalled(...N){return this.extensionsScanner.setUninstalled(...N)}removeUninstalledExtensions(){return this.extensionsScanner.cleanUp()}migrateDefaultProfileExtensions(){return this.extensionsScanner.migrateDefaultProfileExtensions()}async download(N,T){const{location:L}=await this.extensionsDownloader.download(N,T);return L}async downloadVsix(N){if(N.scheme===h.Schemas.file)return{location:N,async cleanup(){}};this.logService.trace("Downloading extension from",N.toString());const T=(0,b.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,E.generateUuid)());return await this.downloadService.download(N,T),this.logService.info("Downloaded extension to",T.toString()),{location:T,cleanup:async()=>{try{await this.fileService.del(T)}catch(U){this.logService.error(U)}}}}createInstallExtensionTask(N,T,L){let U;if(v.URI.isUri(T))U=new W(N,T,L,this.galleryService,this.extensionsScanner,this.logService);else{const V=n.ExtensionKey.create(T).toString();U=this.installGalleryExtensionsTasks.get(V),U||(this.installGalleryExtensionsTasks.set(V,U=new A(N,T,L,this.extensionsDownloader,this.extensionsScanner,this.logService)),U.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(V)))}return new j(U,L.profileLocation,this.extensionsProfileScannerService)}createUninstallExtensionTask(N,T){return new Y(N,T.profileLocation,this.extensionsProfileScannerService)}async collectFiles(N){const T=async U=>{let V=await S.Promises.readdir(U);V=V.map(se=>u.join(U,se));const $=await Promise.all(V.map(se=>S.Promises.stat(se)));let G=Promise.resolve([]);return $.forEach((se,ue)=>{const pe=V[ue];se.isFile()&&(G=G.then(ve=>[...ve,pe])),se.isDirectory()&&(G=G.then(ve=>T(pe).then(le=>[...ve,...le])))}),G};return(await T(N.location.fsPath)).map(U=>({path:`extension/${u.relative(N.location.fsPath,U)}`,localPath:U}))}};re=he([te(0,i.IExtensionGalleryService),te(1,Z.ITelemetryService),te(2,ie.ILogService),te(3,f.INativeEnvironmentService),te(4,r.IExtensionsScannerService),te(5,t.IExtensionsProfileScannerService),te(6,w.IDownloadService),te(7,J.IInstantiationService),te(8,X.IFileService),te(9,oe.IProductService),te(10,ge.IUriIdentityService),te(11,ce.IUserDataProfilesService)],re),e.ExtensionManagementService=re;let z=class extends P.Disposable{constructor(N,T,L,U,V,$){super(),this.beforeRemovingExtension=N,this.fileService=T,this.extensionsScannerService=L,this.userDataProfilesService=U,this.extensionsProfileScannerService=V,this.logService=$,this._migrateDefaultProfileExtensionsPromise=void 0,this.uninstalledPath=(0,b.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new C.Queue}async cleanUp(){await this.removeUninstalledExtensions()}async scanExtensions(N,T){await this.migrateDefaultProfileExtensions();const L={includeInvalid:!0,profileLocation:T};let U=[];return N===null||N===0?U.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},L,!1)):N===1&&U.push(...await this.extensionsScannerService.scanUserExtensions(L)),U=N!==null?U.filter(V=>V.type===N):U,Promise.all(U.map(V=>this.toLocalExtension(V)))}async scanAllUserExtensions(N){const T=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!N,includeInvalid:!0});return Promise.all(T.map(L=>this.toLocalExtension(L)))}async extractUserExtension(N,T,L,U){await this.migrateDefaultProfileExtensions();const V=N.toString(),$=u.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,E.generateUuid)()}`),G=u.join(this.extensionsScannerService.userExtensionsLocation.fsPath,V);try{await S.Promises.rm(G)}catch{throw new i.ExtensionManagementError(g.localize(4,null,G,N.id),i.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(N,T,$,U),await this.extensionsScannerService.updateMetadata(v.URI.file($),L);try{await this.rename(N,$,G,Date.now()+2*60*1e3),this.logService.info("Renamed to",G)}catch(se){try{await S.Promises.rm($)}catch{}if(se.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",N.id);else throw this.logService.info(`Rename failed because of ${(0,O.getErrorMessage)(se)}. Deleted from extracted location`,$),se}return this.scanLocalExtension(v.URI.file(G),1)}async updateMetadata(N,T){return await this.extensionsScannerService.updateMetadata(N.location,T),this.scanLocalExtension(N.location,N.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...N){const T=N.map(L=>n.ExtensionKey.create(L));await this.withUninstalledExtensions(L=>T.forEach(U=>{L[U.toString()]=!0,this.logService.info("Marked extension as uninstalled",U.toString())}))}async setInstalled(N){await this.withUninstalledExtensions(U=>delete U[N.toString()]);const L=(await this.scanAllUserExtensions(!0)).find(U=>n.ExtensionKey.create(U).equals(N))||null;return L?this.updateMetadata(L,{installedTimestamp:Date.now()}):null}async removeExtension(N,T){this.logService.trace(`Deleting ${T} extension from disk`,N.identifier.id,N.location.fsPath),await S.Promises.rm(N.location.fsPath),this.logService.info("Deleted from disk",N.identifier.id,N.location.fsPath)}async removeUninstalledExtension(N){await this.removeExtension(N,"uninstalled"),await this.withUninstalledExtensions(T=>delete T[n.ExtensionKey.create(N).toString()])}async withUninstalledExtensions(N){return this.uninstalledFileLimiter.queue(async()=>{let T;try{T=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(U){if(U.code!=="ENOENT")throw U}let L={};if(T)try{L=JSON.parse(T)}catch{}return N&&(N(L),Object.keys(L).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(L)):await S.Promises.rm(this.uninstalledPath)),L})}async extractAtLocation(N,T,L,U){this.logService.trace(`Started extracting the extension from ${T} to ${L}`);try{await S.Promises.rm(L)}catch(V){throw new i.ExtensionManagementError(this.joinErrors(V).message,i.ExtensionManagementErrorCode.Delete)}try{await(0,l.extract)(T,L,{sourcePath:"extension",overwrite:!0},U),this.logService.info(`Extracted extension to ${L}:`,N.id)}catch(V){try{await S.Promises.rm(L)}catch{}let $=i.ExtensionManagementErrorCode.Extract;throw V instanceof l.ExtractError&&(V.type==="CorruptZip"?$=i.ExtensionManagementErrorCode.CorruptZip:V.type==="Incomplete"&&($=i.ExtensionManagementErrorCode.IncompleteZip)),new i.ExtensionManagementError(V.message,$)}}async rename(N,T,L,U){try{await S.Promises.rename(T,L)}catch(V){if(m.isWindows&&V&&V.code==="EPERM"&&Date.now()<U)return this.logService.info(`Failed renaming ${T} to ${L} with 'EPERM' error. Trying again...`,N.id),this.rename(N,T,L,U);throw new i.ExtensionManagementError(V.message||g.localize(5,null,T,L),V.code||i.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(N,T){const L=await this.extensionsScannerService.scanExistingExtension(N,T,{includeInvalid:!0});if(L)return this.toLocalExtension(L);throw new Error(g.localize(6,null,N.path))}async toLocalExtension(N){const T=await this.fileService.resolve(N.location);let L,U;return T.children&&(L=T.children.find(({name:V})=>/^readme(\.txt|\.md|)$/i.test(V))?.resource,U=T.children.find(({name:V})=>/^changelog(\.txt|\.md|)$/i.test(V))?.resource),{identifier:N.identifier,type:N.type,isBuiltin:N.isBuiltin||!!N.metadata?.isBuiltin,location:N.location,manifest:N.manifest,targetPlatform:N.targetPlatform,validations:N.validations,isValid:N.isValid,readmeUrl:L,changelogUrl:U,publisherDisplayName:N.metadata?.publisherDisplayName||null,publisherId:N.metadata?.publisherId||null,isApplicationScoped:!!N.metadata?.isApplicationScoped,isMachineScoped:!!N.metadata?.isMachineScoped,isPreReleaseVersion:!!N.metadata?.isPreReleaseVersion,preRelease:!!N.metadata?.preRelease,installedTimestamp:N.metadata?.installedTimestamp,updated:!!N.metadata?.updated}}async removeUninstalledExtensions(){const N=await this.getUninstalledExtensions(),T=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),L=new Set;for(const $ of T)N[n.ExtensionKey.create($).toString()]||L.add($.identifier.id.toLowerCase());const U=(0,n.groupByExtension)(T,$=>$.identifier);await C.Promises.settled(U.map(async $=>{const G=$.sort((se,ue)=>p.rcompare(se.manifest.version,ue.manifest.version))[0];L.has(G.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(G))}));const V=T.filter($=>N[n.ExtensionKey.create($).toString()]);await C.Promises.settled(V.map($=>this.removeUninstalledExtension($)))}migrateDefaultProfileExtensions(){return this._migrateDefaultProfileExtensionsPromise||(this._migrateDefaultProfileExtensionsPromise=(async()=>{try{const N=(0,b.joinPath)(this.userDataProfilesService.defaultProfile.location,".migrated-default-profile");if(await this.fileService.exists(N))return;if(!await this.fileService.exists(this.userDataProfilesService.defaultProfile.extensionsResource)){this.logService.info("Started migrating default profile extensions from extensions installation folder to extensions manifest.");const T=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(T.map(L=>[L,L.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Completed migrating default profile extensions from extensions installation folder to extensions manifest.")}try{await this.fileService.createFile(N,D.VSBuffer.fromString(""))}catch(T){this.logService.warn("Failed to create migration marker file for default profile extensions migration.",(0,O.getErrorMessage)(T))}}catch(N){throw this.logService.error(N),N}})()),this._migrateDefaultProfileExtensionsPromise}joinErrors(N){const T=Array.isArray(N)?N:[N];return T.length===1?T[0]instanceof Error?T[0]:new Error(T[0]):T.reduce((L,U)=>new Error(`${L.message}${L.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}};z=he([te(1,X.IFileService),te(2,r.IExtensionsScannerService),te(3,ce.IUserDataProfilesService),te(4,t.IExtensionsProfileScannerService),te(5,ie.ILogService)],z),e.ExtensionsScanner=z;class F extends s.AbstractExtensionTask{get operation(){return(0,y.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(N,T,L,U,V){super(),this.identifier=N,this.source=T,this.options=L,this.extensionsScanner=U,this.logService=V,this.wasVerified=!1,this._operation=2}async installExtension(N,T){try{const L=await this.unsetUninstalledAndGetLocal(N.key);if(L)return this.extensionsScanner.updateMetadata(L,N.metadata)}catch{throw m.isMacintosh?new i.ExtensionManagementError(g.localize(7,null),i.ExtensionManagementErrorCode.Internal):new i.ExtensionManagementError(g.localize(8,null),i.ExtensionManagementErrorCode.Internal)}return this.extract(N,T)}async unsetUninstalledAndGetLocal(N){if(!await this.isUninstalled(N))return null;this.logService.trace("Removing the extension from uninstalled list:",N.id);const L=await this.extensionsScanner.setInstalled(N);return this.logService.info("Removed the extension from uninstalled list:",N.id),L}async isUninstalled(N){return!!(await this.extensionsScanner.getUninstalledExtensions())[N.toString()]}async extract({zipPath:N,key:T,metadata:L},U){const V=await this.extensionsScanner.extractUserExtension(T,N,L,U);return this.logService.info("Extracting completed.",T.id),V}}class A extends F{constructor(N,T,L,U,V,$){super(T.identifier,T,L,V,$),this.manifest=N,this.gallery=T,this.extensionsDownloader=U}async doRun(N){const L=(await this.extensionsScanner.scanExtensions(null,void 0)).find(G=>(0,n.areSameExtensions)(G.identifier,this.gallery.identifier));L&&(this._operation=3);const U={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,M.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||L?.isMachineScoped,isBuiltin:this.options.isBuiltin||L?.isBuiltin,isSystem:L?.type===0?!0:void 0,updated:!!L,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,y.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:L?.preRelease)};if(L?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(L,U),metadata:U};const{location:V,verified:$}=await this.extensionsDownloader.download(this.gallery,this._operation);try{this.wasVerified=!!$,this.validateManifest(V.fsPath);const G=await this.installExtension({zipPath:V.fsPath,key:n.ExtensionKey.create(this.gallery),metadata:U},N);return L&&!this.options.profileLocation&&(L.targetPlatform!==G.targetPlatform||p.neq(L.manifest.version,G.manifest.version))&&await this.extensionsScanner.setUninstalled(L),{local:G,metadata:U}}catch(G){try{await this.extensionsDownloader.delete(V)}catch(se){this.logService.warn("Error while deleting the downloaded file",V.toString(),(0,O.getErrorMessage)(se))}throw G}}async validateManifest(N){try{await(0,a.getManifest)(N)}catch(T){throw new i.ExtensionManagementError((0,s.joinErrors)(T).message,i.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=A;class W extends F{constructor(N,T,L,U,V,$){super({id:(0,n.getGalleryExtensionId)(N.publisher,N.name)},T,L,V,$),this.manifest=N,this.location=T,this.galleryService=U}async doRun(N){const T=new n.ExtensionKey(this.identifier,this.manifest.version),U=(await this.extensionsScanner.scanExtensions(1,void 0)).find(G=>(0,n.areSameExtensions)(this.identifier,G.identifier)),V=await this.getMetadata(this.identifier.id,this.manifest.version,N);if(V.isApplicationScoped=(0,M.isApplicationScopedExtension)(this.manifest),V.isMachineScoped=this.options.isMachineScoped||U?.isMachineScoped,V.isBuiltin=this.options.isBuiltin||U?.isBuiltin,V.installedTimestamp=Date.now(),U)if(this._operation=3,T.equals(new n.ExtensionKey(U.identifier,U.manifest.version)))try{await this.extensionsScanner.removeExtension(U,"existing")}catch{throw new Error(g.localize(9,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&p.gt(U.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(U);else{const G=await this.unsetUninstalledAndGetLocal(T);if(G)try{await this.extensionsScanner.removeExtension(G,"existing")}catch{throw new Error(g.localize(10,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:u.resolve(this.location.fsPath),key:T,metadata:V},N),metadata:V}}async getMetadata(N,T,L){try{let[U]=await this.galleryService.getExtensions([{id:N,version:T}],L);if(U||([U]=await this.galleryService.getExtensions([{id:N}],L)),U)return{id:U.identifier.uuid,publisherDisplayName:U.publisherDisplayName,publisherId:U.publisherId,isPreReleaseVersion:U.properties.isPreReleaseVersion,preRelease:U.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class j{constructor(N,T,L){this.task=N,this.profileLocation=T,this.extensionsProfileScannerService=L,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const N=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[N.local,N.metadata]],this.profileLocation),N}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class Y extends s.AbstractExtensionTask{constructor(N,T,L){super(),this.extension=N,this.profileLocation=T,this.extensionsProfileScannerService=L}async doRun(N){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(Q[150],ee([0,1,130,3,14,11,2,8,21,18,131,9,129,163]),function(_,e,C,D,I,k,O,P,h,u,m,b,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let v=class extends O.Disposable{constructor(S,l,g){super(),this.environmentService=l,this.logService=g,this.configure(S.getValue()),this._register(S.onDidChangeConfiguration(()=>this.configure(S.getValue()),this))}configure(S){this.proxyUrl=S.http&&S.http.proxy,this.strictSSL=!!(S.http&&S.http.proxyStrictSSL),this.authorization=S.http&&S.http.proxyAuthorization}async request(S,l){this.logService.trace("RequestService#request (node) - begin",S.url);const{proxyUrl:g,strictSSL:w}=this;let f;try{f=await(0,m.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...f},i=S.agent?S.agent:await(0,p.getProxyAgent)(S.url||"",s,{proxyUrl:g,strictSSL:w});S.agent=i,S.strictSSL=w,this.authorization&&(S.headers={...S.headers||{},"Proxy-Authorization":this.authorization});try{const n=await this._request(S,l);return this.logService.trace("RequestService#request (node) - success",S.url),n}catch(n){throw this.logService.trace("RequestService#request (node) - error",S.url,n),n}}async getNodeRequest(S){return((0,C.parse)(S.url).protocol==="https:"?await new Promise((w,f)=>{_(["https"],w,f)}):await new Promise((w,f)=>{_(["http"],w,f)})).request}_request(S,l){return D.Promises.withAsyncBody(async(g,w)=>{const f=(0,C.parse)(S.url),s=S.getRawRequest?S.getRawRequest(S):await this.getNodeRequest(S),i={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:S.type||"GET",headers:S.headers,agent:S.agent,rejectUnauthorized:(0,P.isBoolean)(S.strictSSL)?S.strictSSL:!0};S.user&&S.password&&(i.auth=S.user+":"+S.password);const n=s(i,t=>{const r=(0,P.isNumber)(S.followRedirects)?S.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&r>0&&t.headers.location)this._request({...S,url:t.headers.location,followRedirects:r-1},l).then(g,w);else{let o=t;t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,y.createGunzip)())),g({res:t,stream:(0,I.streamToBufferReadableStream)(o)})}});n.on("error",w),S.timeout&&n.setTimeout(S.timeout),S.data&&typeof S.data=="string"&&n.write(S.data),n.end(),l.onCancellationRequested(()=>{n.abort(),w(new k.CancellationError)})})}async resolveProxy(S){}};v=he([te(0,h.IConfigurationService),te(1,u.INativeEnvironmentService),te(2,b.ILogService)],v),e.RequestService=v}),define(Q[164],ee([0,1,37,3,14,31,11,2,16,15,12,32,10,20,21,121,58,128,18,102,145,23,59,123,41,48,149,143,13,112,115,46,110,62,63,127,9,117,118,36,147,136,28,47,150,66,132,67,34,135,42,137,138,35,139,25,146]),function(_,e,C,D,I,k,O,P,h,u,m,b,p,y,v,E,S,l,g,w,f,s,i,n,t,r,o,c,a,d,R,M,q,X,J,ie,oe,Z,ge,ce,re,z,F,A,W,j,Y,B,N,T,L,U,V,$,G,se,ue){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class pe extends P.Disposable{constructor(ne){super(),this.argv=ne,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[ne,de]=await this.initServices();return ne.invokeFunction(async ae=>{const Se=ae.get(oe.ILogService),Le=ae.get(a.IFileService),Ae=ae.get(g.INativeEnvironmentService),Fe=ae.get(se.IUserDataProfilesService);Se.info("CLI main",this.argv),this.registerErrorHandler(Se),await this.doRun(Ae,Le,Fe,ne),await Promise.all(de.map(xe=>{(0,D.raceTimeout)(xe.flush(),1e3)}))})}async initServices(){const ne=new X.ServiceCollection,de={_serviceBrand:void 0,...z.default};ne.set(F.IProductService,de);const ae=new w.NativeEnvironmentService(this.argv,de);ne.set(g.INativeEnvironmentService,ae),await Promise.all([ae.appSettingsHome.fsPath,ae.extensionsPath].map(Re=>Re?y.Promises.mkdir(Re,{recursive:!0}):void 0));const Se=(0,oe.getLogLevel)(ae),Le=[];Le.push(new Z.SpdLogLogger("cli",(0,u.join)(ae.logsPath,"cli.log"),!0,!1,Se)),Se===oe.LogLevel.Trace&&Le.push(new oe.ConsoleLogger(Se));const Ae=this._register(new oe.MultiplexLogService(Le));ne.set(oe.ILogService,Ae);const Fe=this._register(new d.FileService(Ae));ne.set(a.IFileService,Fe);const xe=this._register(new R.DiskFileSystemProvider(Ae));Fe.registerProvider(h.Schemas.file,xe);const x=new Y.StateService(ae,Ae,Fe);ne.set(j.IStateService,x);const H=new G.UriIdentityService(Fe);ne.set($.IUriIdentityService,H);const K=new ue.UserDataProfilesService(x,H,ae,Fe,Ae);ne.set(se.IUserDataProfilesService,K);const fe=m.isWindows&&de.win32RegValueName?this._register(new re.NativePolicyService(de.win32RegValueName)):ae.policyFile?this._register(new ge.FilePolicyService(ae.policyFile,Fe,Ae)):new ce.NullPolicyService;ne.set(ce.IPolicyService,fe);const me=this._register(new E.ConfigurationService(K.defaultProfile.settingsResource,Fe,fe,Ae));ne.set(v.IConfigurationService,me),await Promise.all([x.init(),me.initialize()]),K.setEnablement(de.quality!=="stable"||me.getValue(se.PROFILES_ENABLEMENT_CONFIG)),ne.set($.IUriIdentityService,new G.UriIdentityService(Fe)),ne.set(A.IRequestService,new M.SyncDescriptor(W.RequestService,void 0,!0)),ne.set(S.IDownloadService,new M.SyncDescriptor(l.DownloadService,void 0,!0)),ne.set(t.IExtensionsProfileScannerService,new M.SyncDescriptor(t.ExtensionsProfileScannerService,void 0,!0)),ne.set(r.IExtensionsScannerService,new M.SyncDescriptor(c.ExtensionsScannerService,void 0,!0)),ne.set(i.IExtensionSignatureVerificationService,new M.SyncDescriptor(i.ExtensionSignatureVerificationService,void 0,!0)),ne.set(o.INativeServerExtensionManagementService,new M.SyncDescriptor(o.ExtensionManagementService,void 0,!0)),ne.set(s.IExtensionGalleryService,new M.SyncDescriptor(f.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),ne.set(J.ILanguagePackService,new M.SyncDescriptor(ie.NativeLanguagePackService,void 0,!1));const De=[],we=(0,L.isInternalTelemetry)(de,me);if((0,L.supportsTelemetry)(de,ae)){de.aiConfig&&de.aiConfig.ariaKey&&De.push(new U.OneDataSystemAppender(we,"monacoworkbench",null,de.aiConfig.ariaKey));const{installSourcePath:Re}=ae,Ie={appenders:De,sendErrorTelemetry:!1,commonProperties:(async()=>{let ke;try{const Ne=await y.Promises.readFile(ae.stateResource.fsPath);ke=JSON.parse(Ne.toString())[N.machineIdKey]}catch(Ne){Ne.code!=="ENOENT"&&Ae.error(Ne)}return(0,B.resolveCommonProperties)(Fe,(0,C.release)(),(0,C.hostname)(),process.arch,de.commit,de.version,ke,we,Re)})(),piiPaths:(0,L.getPiiPathsFromEnvironment)(ae)};ne.set(N.ITelemetryService,new M.SyncDescriptor(T.TelemetryService,[Ie],!1))}else ne.set(N.ITelemetryService,L.NullTelemetryService);return[new q.InstantiationService(ne),De]}registerErrorHandler(ne){(0,O.setUnexpectedErrorHandler)(de=>{const ae=(0,k.toErrorMessage)(de,!0);!ae||ne.error(`[uncaught exception in CLI]: ${ae}`)}),process.on("uncaughtException",de=>(0,O.onUnexpectedError)(de)),process.on("unhandledRejection",de=>(0,O.onUnexpectedError)(de))}async doRun(ne,de,ae,Se){const Le=(ne.args.profile?ae.profiles.find(Ae=>Ae.name===ne.args.profile)??ae.defaultProfile:ae.defaultProfile).extensionsResource;if(this.argv["install-source"])return this.setInstallSource(ne,de,this.argv["install-source"]);if(this.argv["list-extensions"])return Se.createInstance(n.ExtensionManagementCLI).listExtensions(!!this.argv["show-versions"],this.argv.category,Le);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const Ae={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:Le};return Se.createInstance(n.ExtensionManagementCLI).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],Ae,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return Se.createInstance(n.ExtensionManagementCLI).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,Le);if(this.argv["locate-extension"])return Se.createInstance(n.ExtensionManagementCLI).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,V.buildTelemetryMessage)(ne.appRoot,ne.extensionsPath))}}asExtensionIdOrVSIX(ne){return ne.map(de=>/\.vsix$/i.test(de)?p.URI.file((0,u.isAbsolute)(de)?de:(0,u.join)((0,b.cwd)(),de)):de)}async setInstallSource(ne,de,ae){await de.writeFile(p.URI.file(ne.installSourcePath),I.VSBuffer.fromString(ae.slice(0,30)))}}async function ve(le){const ne=new pe(le);try{await ne.run()}finally{ne.dispose()}}e.main=ve})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e8eb39bac26ddc87f27ed69fa06c54cd230d18f9/core/vs/code/node/cliProcessMain.js.map
